/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/errors","vs/base/common/path","vs/platform/log/common/log","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/types","vs/base/common/network","vs/base/common/arrays","vs/base/common/buffer","vs/base/common/resources","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/base/common/process","os","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/map","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","child_process","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/codicons","vs/base/common/jsonFormatter","fs","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/files/common/watcher","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/parcel/parcelWatcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","string_decoder","util","minimist","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ie=function(Q){for(var e=[],L=0,i=Q.length;L<i;L++)e[L]=ne[Q[L]];return e};define(ne[98],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function L(i,k){if(!i)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=L}),define(ne[48],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function L(T){return T?T.replace(/\$\((.*?)\)/g,(D,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=L;class i{constructor(D,C,b){this.id=D,this.definition=C,this.description=b,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}e.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function k(T,D){const C=["codicon","codicon-"+T];return D&&C.push("codicon-modifier-"+D),C}e.getClassNamesArray=k;var _;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function C(E){if(E instanceof i)return["codicon","codicon-"+E.id];const f=D.exec(E.id);if(!f)return C(i.error);let[,p,h]=f;const S=["codicon","codicon-"+p];return h&&S.push("codicon-modifier-"+h.substr(1)),S}T.asClassNameArray=C;function b(E){return C(E).join(" ")}T.asClassName=b;function P(E){return"."+C(E).join(".")}T.asCSSSelector=P})(_=e.CSSIcon||(e.CSSIcon={}))}),define(ne[66],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const L=Object.prototype.hasOwnProperty;function i(P){const E=[];for(let f in P)L.call(P,f)&&E.push(P[f]);return E}e.values=i;function k(P,E){for(let f in P)if(L.call(P,f)&&E({key:f,value:P[f]},function(){delete P[f]})===!1)return}e.forEach=k;function _(P,E){const f=Object.create(null);for(const p of P){const h=E(p);let S=f[h];S||(S=f[h]=[]),S.push(p)}return f}e.groupBy=_;function T(P){const E=Object.create(null);return P&&P.forEach((f,p)=>{E[p]=f}),E}e.fromMap=T;function D(P,E){const f=[],p=[];for(let h of P)E.has(h)||f.push(h);for(let h of E)P.has(h)||p.push(h);return{removed:f,added:p}}e.diffSets=D;function C(P,E){const f=[],p=[];for(let[h,S]of P)E.has(h)||f.push(S);for(let[h,S]of E)P.has(h)||p.push(S);return{removed:f,added:p}}e.diffMaps=C;class b{constructor(){this.map=new Map}add(E,f){let p=this.map.get(E);p||(p=new Set,this.map.set(E,p)),p.add(f)}delete(E,f){const p=this.map.get(E);!p||(p.delete(f),p.size===0&&this.map.delete(E))}forEach(E,f){const p=this.map.get(E);!p||p.forEach(f)}}e.SetMap=b}),define(ne[53],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function L(T){return(D,C,b)=>{let P=null,E=null;if(typeof b.value=="function"?(P="value",E=b.value):typeof b.get=="function"&&(P="get",E=b.get),!E)throw new Error("not supported");b[P]=T(E,C)}}e.createDecorator=L;function i(T,D,C){let b=null,P=null;if(typeof C.value=="function"?(b="value",P=C.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(b="get",P=C.get),!P)throw new Error("not supported");const E=`$memoize$${D}`;C[b]=function(...f){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,f)}),this[E]}}e.memoize=i;function k(T,D,C){return L((b,P)=>{const E=`$debounce$${P}`,f=`$debounce$result$${P}`;return function(...p){this[f]||(this[f]=C?C():void 0),clearTimeout(this[E]),D&&(this[f]=D(this[f],...p),p=[this[f]]),this[E]=setTimeout(()=>{b.apply(this,p),this[f]=C?C():void 0},T)}})}e.debounce=k;function _(T,D,C){return L((b,P)=>{const E=`$throttle$timer$${P}`,f=`$throttle$result$${P}`,p=`$throttle$lastRun$${P}`,h=`$throttle$pending$${P}`;return function(...S){if(this[f]||(this[f]=C?C():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),D&&(this[f]=D(this[f],...S)),this[h])return;const v=this[p]+T;v<=Date.now()?(this[p]=Date.now(),b.apply(this,[this[f]]),this[f]=C?C():void 0):(this[h]=!0,this[E]=setTimeout(()=>{this[h]=!1,this[p]=Date.now(),b.apply(this,[this[f]]),this[f]=C?C():void 0},v-Date.now()))}})}e.throttle=_}),define(ne[8],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class L{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(a=>{a(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=L,e.errorHandler=new L;function i(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=i;function k(l){C(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=k;function _(l){C(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=_;function T(l){if(l instanceof Error){let{name:r,message:a}=l;const n=l.stacktrace||l.stack;return{$isError:!0,name:r,message:a,stack:n}}return l}e.transformErrorForSerialization=T;const D="Canceled";function C(l){return l instanceof Error&&l.name===D&&l.message===D}e.isPromiseCanceledError=C;class b extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=b;function P(){const l=new Error(D);return l.name=l.message,l}e.canceled=P;function E(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=E;function f(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=f;function p(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function h(l){const r=new Error(`${l} has been disposed`);return r.name="DISPOSED",r}e.disposed=h;function S(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=S;class v extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=v;class y extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=y;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function g(l){const r=l;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=g;function c(l,r=Object.create(null)){const a=new Error(l);return r.actions&&(a.actions=r.actions),a}e.createErrorWithActions=c}),define(ne[17],ie([0,1,8]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function i(F,j=0){return F[F.length-(1+j)]}e.tail=i;function k(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=k;function _(F,j,B=(z,V)=>z===V){if(F===j)return!0;if(!F||!j||F.length!==j.length)return!1;for(let z=0,V=F.length;z<V;z++)if(!B(F[z],j[z]))return!1;return!0}e.equals=_;function T(F,j,B){let z=0,V=F.length-1;for(;z<=V;){const te=(z+V)/2|0,se=B(F[te],j);if(se<0)z=te+1;else if(se>0)V=te-1;else return te}return-(z+1)}e.binarySearch=T;function D(F,j){let B=0,z=F.length;if(z===0)return 0;for(;B<z;){const V=Math.floor((B+z)/2);j(F[V])?z=V:B=V+1}return B}e.findFirstInSorted=D;function C(F,j,B){if(F=F|0,F>=j.length)throw new TypeError("invalid index");let z=j[Math.floor(j.length*Math.random())],V=[],te=[],se=[];for(let ce of j){const he=B(ce,z);he<0?V.push(ce):he>0?te.push(ce):se.push(ce)}return F<V.length?C(F,V,B):F<V.length+se.length?se[0]:C(F-(V.length+se.length),te,B)}e.quickSelect=C;function b(F,j){const B=[];let z;for(const V of F.slice(0).sort(j))!z||j(z[0],V)!==0?(z=[V],B.push(z)):z.push(V);return B}e.groupBy=b;function P(F,j,B){const z=[];function V(ce,he,me){if(he===0&&me.length===0)return;const ve=z[z.length-1];ve&&ve.start+ve.deleteCount===ce?(ve.deleteCount+=he,ve.toInsert.push(...me)):z.push({start:ce,deleteCount:he,toInsert:me})}let te=0,se=0;for(;;){if(te===F.length){V(te,0,j.slice(se));break}if(se===j.length){V(te,F.length-te,[]);break}const ce=F[te],he=j[se],me=B(ce,he);me===0?(te+=1,se+=1):me<0?(V(te,1,[]),te+=1):me>0&&(V(te,0,[he]),se+=1)}return z}e.sortedDiff=P;function E(F,j,B){const z=P(F,j,B),V=[],te=[];for(const se of z)V.push(...F.slice(se.start,se.start+se.deleteCount)),te.push(...se.toInsert);return{removed:V,added:te}}e.delta=E;function f(F,j,B){if(B===0)return[];const z=F.slice(0,B).sort(j);return h(F,j,z,B,F.length),z}e.top=f;function p(F,j,B,z,V){return B===0?Promise.resolve([]):new Promise((te,se)=>{(async()=>{const ce=F.length,he=F.slice(0,B).sort(j);for(let me=B,ve=Math.min(B+z,ce);me<ce;me=ve,ve=Math.min(ve+z,ce)){if(me>B&&await new Promise(ge=>setTimeout(ge)),V&&V.isCancellationRequested)throw(0,L.canceled)();h(F,j,he,me,ve)}return he})().then(te,se)})}e.topAsync=p;function h(F,j,B,z,V){for(const te=B.length;z<V;z++){const se=F[z];if(j(se,B[te-1])<0){B.pop();const ce=D(B,he=>j(se,he)<0);B.splice(ce,0,se)}}}function S(F){return F.filter(j=>!!j)}e.coalesce=S;function v(F){let j=0;for(let B=0;B<F.length;B++)F[B]&&(F[j]=F[B],j+=1);F.length=j}e.coalesceInPlace=v;function y(F,j,B){F.splice(B,0,F.splice(j,1)[0])}e.move=y;function w(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=w;function g(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=g;function c(F,j=B=>B){const B=new Set;return F.filter(z=>{const V=j(z);return B.has(V)?!1:(B.add(V),!0)})}e.distinct=c;function l(F){const j=Object.create(null);return B=>{const z=F(B);return j[z]?!1:(j[z]=!0,!0)}}e.uniqueFilter=l;function r(F,j){const B=a(F,j);if(B!==-1)return F[B]}e.findLast=r;function a(F,j){for(let B=F.length-1;B>=0;B--){const z=F[B];if(j(z))return B}return-1}e.lastIndex=a;function n(F,j){return F.length>0?F[0]:j}e.firstOrDefault=n;function t(F,j,B=(z,V)=>z===V){let z=0;for(let V=0,te=Math.min(F.length,j.length);V<te&&B(F[V],j[V]);V++)z++;return z}e.commonPrefixLength=t;function s(F){return[].concat(...F)}e.flatten=s;function o(F,j){let B=typeof j=="number"?F:0;typeof j=="number"?B=F:(B=0,j=F);const z=[];if(B<=j)for(let V=B;V<j;V++)z.push(V);else for(let V=B;V>j;V--)z.push(V);return z}e.range=o;function u(F,j,B){return F.reduce((z,V)=>(z[j(V)]=B?B(V):V,z),Object.create(null))}e.index=u;function d(F,j){return F.push(j),()=>m(F,j)}e.insert=d;function m(F,j){const B=F.indexOf(j);if(B>-1)return F.splice(B,1),j}e.remove=m;function I(F,j,B){const z=F.slice(0,j),V=F.slice(j);return z.concat(B,V)}e.arrayInsert=I;function A(F,j){let B;if(typeof j=="number"){let z=j;B=()=>{const V=Math.sin(z++)*179426549;return V-Math.floor(V)}}else B=Math.random;for(let z=F.length-1;z>0;z-=1){const V=Math.floor(B()*(z+1)),te=F[z];F[z]=F[V],F[V]=te}}e.shuffle=A;function O(F,j){const B=F.indexOf(j);B>-1&&(F.splice(B,1),F.unshift(j))}e.pushToStart=O;function N(F,j){const B=F.indexOf(j);B>-1&&(F.splice(B,1),F.push(j))}e.pushToEnd=N;function $(F,j){return Array.isArray(F)?F.map(j):j(F)}e.mapArrayOrNot=$;function R(F){return Array.isArray(F)?F:[F]}e.asArray=R;function M(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=M;function W(F,j){for(const B of F){const z=j(B);if(z!==void 0)return z}}e.mapFind=W;function U(F,j,B){const z=ee(F,j),V=F.length,te=B.length;F.length=V+te;for(let se=V-1;se>=z;se--)F[se+te]=F[se];for(let se=0;se<te;se++)F[se+z]=B[se]}e.insertInto=U;function x(F,j,B,z){const V=ee(F,j),te=F.splice(V,B);return U(F,V,z),te}e.splice=x;function ee(F,j){return j<0?Math.max(j+F.length,0):Math.min(j,F.length)}function G(F,j){return(B,z)=>j(F(B),F(z))}e.compareBy=G;const q=(F,j)=>F-j;e.numberComparator=q;function Y(F,j){if(F.length===0)return;let B=F[0];for(let z=1;z<F.length;z++){const V=F[z];j(V,B)>0&&(B=V)}return B}e.findMaxBy=Y;function H(F,j){if(F.length===0)return;let B=F[0];for(let z=1;z<F.length;z++){const V=F[z];j(V,B)>=0&&(B=V)}return B}e.findLastMaxBy=H;function Z(F,j){return Y(F,(B,z)=>-j(B,z))}e.findMinBy=Z;class K{constructor(j){this.items=j,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(j){let B=this.firstIdx;for(;B<this.items.length&&j(this.items[B]);)B++;const z=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,z}takeFromEndWhile(j){let B=this.lastIdx;for(;B>=0&&j(this.items[B]);)B--;const z=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,z}peek(){return this.items[this.firstIdx]}dequeue(){const j=this.items[this.firstIdx];return this.firstIdx++,j}takeCount(j){const B=this.items.slice(this.firstIdx,this.firstIdx+j);return this.firstIdx+=j,B}}e.ArrayQueue=K}),define(ne[67],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function L(i){const k=this;let _=!1,T;return function(){return _||(_=!0,T=i.apply(k,arguments)),T}}e.once=L}),define(ne[54],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var L;(function(i){function k(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}i.is=k;const _=Object.freeze([]);function T(){return _}i.empty=T;function*D(l){yield l}i.single=D;function C(l){return l||_}i.from=C;function b(l){return!l||l[Symbol.iterator]().next().done===!0}i.isEmpty=b;function P(l){return l[Symbol.iterator]().next().value}i.first=P;function E(l,r){for(const a of l)if(r(a))return!0;return!1}i.some=E;function f(l,r){for(const a of l)if(r(a))return a}i.find=f;function*p(l,r){for(const a of l)r(a)&&(yield a)}i.filter=p;function*h(l,r){let a=0;for(const n of l)yield r(n,a++)}i.map=h;function*S(...l){for(const r of l)for(const a of r)yield a}i.concat=S;function*v(l){for(const r of l)for(const a of r)yield a}i.concatNested=v;function y(l,r,a){let n=a;for(const t of l)n=r(n,t);return n}i.reduce=y;function*w(l,r,a=l.length){for(r<0&&(r+=l.length),a<0?a+=l.length:a>l.length&&(a=l.length);r<a;r++)yield l[r]}i.slice=w;function g(l,r=Number.POSITIVE_INFINITY){const a=[];if(r===0)return[a,l];const n=l[Symbol.iterator]();for(let t=0;t<r;t++){const s=n.next();if(s.done)return[a,i.empty()];a.push(s.value)}return[a,{[Symbol.iterator](){return n}}]}i.consume=g;function c(l,r,a=(n,t)=>n===t){const n=l[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const s=n.next(),o=t.next();if(s.done!==o.done)return!1;if(s.done)return!0;if(!a(s.value,o.value))return!1}}i.equals=c})(L=e.Iterable||(e.Iterable={}))}),define(ne[35],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(L=e.ScanError||(e.ScanError={}));var i;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var _;(function(r){r.DEFAULT={allowTrailingComma:!0}})(_=e.ParseOptions||(e.ParseOptions={}));function T(r,a=!1){let n=0,t=r.length,s="",o=0,u=16,d=0;function m(M){let W=0,U=0;for(;W<M;){const x=r.charCodeAt(n);if(x>=48&&x<=57)U=U*16+x-48;else if(x>=65&&x<=70)U=U*16+x-65+10;else if(x>=97&&x<=102)U=U*16+x-97+10;else break;n++,W++}return W<M&&(U=-1),U}function I(M){n=M,s="",o=0,u=16,d=0}function A(){const M=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&b(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&b(r.charCodeAt(n)))for(n++;n<r.length&&b(r.charCodeAt(n));)n++;else return d=3,r.substring(M,n);let W=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&b(r.charCodeAt(n))){for(n++;n<r.length&&b(r.charCodeAt(n));)n++;W=n}else d=3;return r.substring(M,W)}function O(){let M="",W=n;for(;;){if(n>=t){M+=r.substring(W,n),d=2;break}const U=r.charCodeAt(n);if(U===34){M+=r.substring(W,n),n++;break}if(U===92){if(M+=r.substring(W,n),n++,n>=t){d=2;break}switch(r.charCodeAt(n++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const ee=m(4);ee>=0?M+=String.fromCharCode(ee):d=4;break}default:d=5}W=n;continue}if(U>=0&&U<=31)if(C(U)){M+=r.substring(W,n),d=2;break}else d=6;n++}return M}function N(){if(s="",d=0,o=n,n>=t)return o=t,u=17;let M=r.charCodeAt(n);if(D(M)){do n++,s+=String.fromCharCode(M),M=r.charCodeAt(n);while(D(M));return u=15}if(C(M))return n++,s+=String.fromCharCode(M),M===13&&r.charCodeAt(n)===10&&(n++,s+=`
`),u=14;switch(M){case 123:return n++,u=1;case 125:return n++,u=2;case 91:return n++,u=3;case 93:return n++,u=4;case 58:return n++,u=6;case 44:return n++,u=5;case 34:return n++,s=O(),u=10;case 47:{const W=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<t&&!C(r.charCodeAt(n));)n++;return s=r.substring(W,n),u=12}if(r.charCodeAt(n+1)===42){n+=2;const U=t-1;let x=!1;for(;n<U;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,d=1),s=r.substring(W,n),u=13}return s+=String.fromCharCode(M),n++,u=16}case 45:if(s+=String.fromCharCode(M),n++,n===t||!b(r.charCodeAt(n)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=A(),u=11;default:for(;n<t&&$(M);)n++,M=r.charCodeAt(n);if(o!==n){switch(s=r.substring(o,n),s){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return s+=String.fromCharCode(M),n++,u=16}}function $(M){if(D(M)||C(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function R(){let M;do M=N();while(M>=12&&M<=15);return M}return{setPosition:I,getPosition:()=>n,scan:a?R:N,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>n-o,getTokenError:()=>d}}e.createScanner=T;function D(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function C(r){return r===10||r===13||r===8232||r===8233}function b(r){return r>=48&&r<=57}var P;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(P||(P={}));function E(r,a){const n=[],t=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function d(m,I,A,O){o.value=m,o.offset=I,o.length=A,o.type=O,o.colonOffset=void 0,s=o}try{g(r,{onObjectBegin:(m,I)=>{if(a<=m)throw t;s=void 0,u=a>m,n.push("")},onObjectProperty:(m,I,A)=>{if(a<I||(d(m,I,A,"property"),n[n.length-1]=m,a<=I+A))throw t},onObjectEnd:(m,I)=>{if(a<=m)throw t;s=void 0,n.pop()},onArrayBegin:(m,I)=>{if(a<=m)throw t;s=void 0,n.push(0)},onArrayEnd:(m,I)=>{if(a<=m)throw t;s=void 0,n.pop()},onLiteralValue:(m,I,A)=>{if(a<I||(d(m,I,A,l(m)),a<=I+A))throw t},onSeparator:(m,I,A)=>{if(a<=I)throw t;if(m===":"&&s&&s.type==="property")s.colonOffset=I,u=!1,s=void 0;else if(m===","){const O=n[n.length-1];typeof O=="number"?n[n.length-1]=O+1:(u=!0,n[n.length-1]=""),s=void 0}}})}catch(m){if(m!==t)throw m}return{path:n,previousNode:s,isAtPropertyKey:u,matches:m=>{let I=0;for(let A=0;I<m.length&&A<n.length;A++)if(m[I]===n[A]||m[I]==="*")I++;else if(m[I]!=="**")return!1;return I===m.length}}}e.getLocation=E;function f(r,a=[],n=_.DEFAULT){let t=null,s=[];const o=[];function u(m){Array.isArray(s)?s.push(m):t!==null&&(s[t]=m)}return g(r,{onObjectBegin:()=>{const m={};u(m),o.push(s),s=m,t=null},onObjectProperty:m=>{t=m},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const m=[];u(m),o.push(s),s=m,t=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:u,onError:(m,I,A)=>{a.push({error:m,offset:I,length:A})}},n),s[0]}e.parse=f;function p(r,a=[],n=_.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(m){t.type==="property"&&(t.length=m-t.offset,t=t.parent)}function o(m){return t.children.push(m),m}g(r,{onObjectBegin:m=>{t=o({type:"object",offset:m,length:-1,parent:t,children:[]})},onObjectProperty:(m,I,A)=>{t=o({type:"property",offset:I,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:m,offset:I,length:A,parent:t})},onObjectEnd:(m,I)=>{t.length=m+I-t.offset,t=t.parent,s(m+I)},onArrayBegin:(m,I)=>{t=o({type:"array",offset:m,length:-1,parent:t,children:[]})},onArrayEnd:(m,I)=>{t.length=m+I-t.offset,t=t.parent,s(m+I)},onLiteralValue:(m,I,A)=>{o({type:l(m),offset:I,length:A,parent:t,value:m}),s(I+A)},onSeparator:(m,I,A)=>{t.type==="property"&&(m===":"?t.colonOffset=I:m===","&&s(I))},onError:(m,I,A)=>{a.push({error:m,offset:I,length:A})}},n);const d=t.children[0];return d&&delete d.parent,d}e.parseTree=p;function h(r,a){if(!r)return;let n=r;for(let t of a)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const o of n.children)if(Array.isArray(o.children)&&o.children[0].value===t){n=o.children[1],s=!0;break}if(!s)return}else{const s=t;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=h;function S(r){if(!r.parent||!r.parent.children)return[];const a=S(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;a.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&a.push(n)}return a}e.getNodePath=S;function v(r){switch(r.type){case"array":return r.children.map(v);case"object":{const a=Object.create(null);for(let n of r.children){const t=n.children[1];t&&(a[n.children[0].value]=v(t))}return a}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=v;function y(r,a,n=!1){return a>=r.offset&&a<r.offset+r.length||n&&a===r.offset+r.length}e.contains=y;function w(r,a,n=!1){if(y(r,a,n)){const t=r.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=a;s++){const o=w(t[s],a,n);if(o)return o}return r}}e.findNodeAtOffset=w;function g(r,a,n=_.DEFAULT){const t=T(r,!1);function s(K){return K?()=>K(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(K){return K?F=>K(F,t.getTokenOffset(),t.getTokenLength()):()=>!0}const u=s(a.onObjectBegin),d=o(a.onObjectProperty),m=s(a.onObjectEnd),I=s(a.onArrayBegin),A=s(a.onArrayEnd),O=o(a.onLiteralValue),N=o(a.onSeparator),$=s(a.onComment),R=o(a.onError),M=n&&n.disallowComments,W=n&&n.allowTrailingComma;function U(){for(;;){const K=t.scan();switch(t.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:M||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(K){case 12:case 13:M?x(10):$();break;case 16:x(1);break;case 15:case 14:break;default:return K}}}function x(K,F=[],j=[]){if(R(K),F.length+j.length>0){let B=t.getToken();for(;B!==17;){if(F.indexOf(B)!==-1){U();break}else if(j.indexOf(B)!==-1)break;B=U()}}}function ee(K){const F=t.getTokenValue();return K?O(F):d(F),U(),!0}function G(){switch(t.getToken()){case 11:{let K=0;try{K=JSON.parse(t.getTokenValue()),typeof K!="number"&&(x(2),K=0)}catch{x(2)}O(K);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return U(),!0}function q(){return t.getToken()!==10?(x(3,[],[2,5]),!1):(ee(!1),t.getToken()===6?(N(":"),U(),Z()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function Y(){u(),U();let K=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(K||x(4,[],[]),N(","),U(),t.getToken()===2&&W)break}else K&&x(6,[],[]);q()||x(4,[],[2,5]),K=!0}return m(),t.getToken()!==2?x(7,[2],[]):U(),!0}function H(){I(),U();let K=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(K||x(4,[],[]),N(","),U(),t.getToken()===4&&W)break}else K&&x(6,[],[]);Z()||x(4,[],[4,5]),K=!0}return A(),t.getToken()!==4?x(8,[4],[]):U(),!0}function Z(){switch(t.getToken()){case 3:return H();case 1:return Y();case 10:return ee(!0);default:return G()}}return U(),t.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):Z()?(t.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.visit=g;function c(r,a){let n=T(r),t=[],s,o=0,u;do switch(u=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:o!==u&&t.push(r.substring(o,u)),a!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,a)),o=n.getPosition();break}while(s!==17);return t.join("")}e.stripComments=c;function l(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(ne[49],ie([0,1,35]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(b,P,E){let f,p,h,S,v;if(P){for(S=P.offset,v=S+P.length,h=S;h>0&&!C(b,h-1);)h--;let u=v;for(;u<b.length&&!C(b,u);)u++;p=b.substring(h,u),f=T(p,E)}else p=b,f=0,h=0,S=0,v=b.length;const y=D(E,b);let w=!1,g=0,c;E.insertSpaces?c=_(" ",E.tabSize||4):c="	";const l=(0,L.createScanner)(p,!1);let r=!1;function a(){return y+_(c,f+g)}function n(){let u=l.scan();for(w=!1;u===15||u===14;)w=w||u===14,u=l.scan();return r=u===16||l.getTokenError()!==0,u}const t=[];function s(u,d,m){!r&&d<v&&m>S&&b.substring(d,m)!==u&&t.push({offset:d,length:m-d,content:u})}let o=n();if(o!==17){const u=l.getTokenOffset()+h,d=_(c,f);s(d,h,u)}for(;o!==17;){let u=l.getTokenOffset()+l.getTokenLength()+h,d=n(),m="";for(;!w&&(d===12||d===13);){const A=l.getTokenOffset()+h;s(" ",u,A),u=l.getTokenOffset()+l.getTokenLength()+h,m=d===12?a():"",d=n()}if(d===2)o!==1&&(g--,m=a());else if(d===4)o!==3&&(g--,m=a());else{switch(o){case 3:case 1:g++,m=a();break;case 5:case 12:m=a();break;case 13:w?m=a():m=" ";break;case 6:m=" ";break;case 10:if(d===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?m=" ":d!==5&&d!==17&&(r=!0);break;case 16:r=!0;break}w&&(d===12||d===13)&&(m=a())}const I=l.getTokenOffset()+h;s(m,u,I),o=d}return t}e.format=i;function k(b,P){const E=JSON.stringify(b,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?E.replace(/\r\n|\r|\n/g,P.eol):E}e.toFormattedString=k;function _(b,P){let E="";for(let f=0;f<P;f++)E+=b;return E}function T(b,P){let E=0,f=0;const p=P.tabSize||4;for(;E<b.length;){const h=b.charAt(E);if(h===" ")f++;else if(h==="	")f+=p;else break;E++}return Math.floor(f/p)}function D(b,P){for(let E=0;E<P.length;E++){const f=P.charAt(E);if(f==="\r")return E+1<P.length&&P.charAt(E+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return b&&b.eol||`
`}e.getEOL=D;function C(b,P){return`\r
`.indexOf(b.charAt(P))!==-1}e.isEOL=C}),define(ne[68],ie([0,1,35,49]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(b,P,E){return _(b,P,void 0,E)}e.removeProperty=k;function _(b,P,E,f,p){const h=P.slice(),S=[],v=(0,L.parseTree)(b,S);let y,w;for(;h.length>0&&(w=h.pop(),y=(0,L.findNodeAtLocation)(v,h),y===void 0&&E!==void 0);)typeof w=="string"?E={[w]:E}:E=[E];if(y)if(y.type==="object"&&typeof w=="string"&&Array.isArray(y.children)){const g=(0,L.findNodeAtLocation)(y,[w]);if(g!==void 0)if(E===void 0){if(!g.parent)throw new Error("Malformed AST");const c=y.children.indexOf(g.parent);let l,r=g.parent.offset+g.parent.length;if(c>0){const a=y.children[c-1];l=a.offset+a.length}else l=y.offset+1,y.children.length>1&&(r=y.children[1].offset);return T(b,{offset:l,length:r-l,content:""},f)}else return T(b,{offset:g.offset,length:g.length,content:JSON.stringify(E)},f);else{if(E===void 0)return[];const c=`${JSON.stringify(w)}: ${JSON.stringify(E)}`,l=p?p(y.children.map(a=>a.children[0].value)):y.children.length;let r;if(l>0){const a=y.children[l-1];r={offset:a.offset+a.length,length:0,content:","+c}}else y.children.length===0?r={offset:y.offset+1,length:0,content:c}:r={offset:y.offset+1,length:0,content:c+","};return T(b,r,f)}}else if(y.type==="array"&&typeof w=="number"&&Array.isArray(y.children))if(E!==void 0){const g=`${JSON.stringify(E)}`;let c;if(y.children.length===0||w===0)c={offset:y.offset+1,length:0,content:y.children.length===0?g:g+","};else{const l=w===-1||w>y.children.length?y.children.length:w,r=y.children[l-1];c={offset:r.offset+r.length,length:0,content:","+g}}return T(b,c,f)}else{const g=w,c=y.children[g];let l;if(y.children.length===1)l={offset:y.offset+1,length:y.length-2,content:""};else if(y.children.length-1===g){const r=y.children[g-1],a=r.offset+r.length,n=y.offset+y.length;l={offset:a,length:n-2-a,content:""}}else l={offset:c.offset,length:y.children[g+1].offset-c.offset,content:""};return T(b,l,f)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${y.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return T(b,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(E)},f)}}e.setProperty=_;function T(b,P,E){let f=D(b,P),p=P.offset,h=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;p>0&&!(0,i.isEOL)(f,p-1);)p--;for(;h<f.length&&!(0,i.isEOL)(f,h);)h++}const S=(0,i.format)(f,{offset:p,length:h-p},E);for(let y=S.length-1;y>=0;y--){const w=S[y];f=D(f,w),p=Math.min(p,w.offset),h=Math.max(h,w.offset+w.length),h+=w.content.length-w.length}const v=b.length-(f.length-h)-p;return[{offset:p,length:v,content:f.substring(p,h)}]}e.withFormatting=T;function D(b,P){return b.substring(0,P.offset)+P.content+b.substring(P.offset+P.length)}e.applyEdit=D;function C(b,P){let E=P.slice(0).sort((p,h)=>{const S=p.offset-h.offset;return S===0?p.length-h.length:S}),f=b.length;for(let p=E.length-1;p>=0;p--){let h=E[p];if(h.offset+h.length<=f)b=D(b,h);else throw new Error("Overlapping edit");f=h.offset}return b}e.applyEdits=C}),define(ne[2],ie([0,1,67,54]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let _=null;function T(t){_=t}if(e.setDisposableTracker=T,k){const t="__is_disposable_tracked__";T(new class{trackDisposable(s){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[t]||console.log(o)},3e3)}setParent(s,o){if(s&&s!==w.None)try{s[t]=!0}catch{}}markAsDisposed(s){if(s&&s!==w.None)try{s[t]=!0}catch{}}markAsSingleton(s){}})}function D(t){return _?.trackDisposable(t),t}function C(t){_?.markAsDisposed(t)}function b(t,s){_?.setParent(t,s)}function P(t,s){if(!!_)for(const o of t)_.setParent(o,s)}function E(t){return _?.markAsSingleton(t),t}e.markAsSingleton=E;class f extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=f;function p(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=p;function h(t){if(i.Iterable.is(t)){let s=[];for(const o of t)if(o)try{o.dispose()}catch(u){s.push(u)}if(s.length===1)throw s[0];if(s.length>1)throw new f(s);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function S(...t){const s=v(()=>h(t));return P(t,s),s}e.combinedDisposable=S;function v(t){const s=D({dispose:(0,L.once)(()=>{C(s),t()})});return s}e.toDisposable=v;class y{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return b(s,this),this._isDisposed?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new y,D(this),b(this._store,this)}dispose(){C(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&b(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,C(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&b(s,null),s}}e.MutableDisposable=g;class c{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class l{constructor(){this.references=new Map}acquire(s,...o){let u=this.references.get(s);u||(u={counter:0,object:this.createReferencedObject(s,...o)},this.references.set(s,u));const{object:d}=u,m=(0,L.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(s,u.object),this.references.delete(s))});return u.counter++,{object:d,dispose:m}}}e.ReferenceCollection=l;class r{constructor(s){this.referenceCollection=s}async acquire(s,...o){const u=this.referenceCollection.acquire(s,...o);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(d){throw u.dispose(),d}}}e.AsyncReferenceCollection=r;class a{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=a;function n(t){const s=new y;try{t(s)}finally{s.dispose()}}e.disposeOnReturn=n}),define(ne[99],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class L{constructor(_){this.element=_,this.next=L.Undefined,this.prev=L.Undefined}}L.Undefined=new L(void 0);class i{constructor(){this._first=L.Undefined,this._last=L.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===L.Undefined}clear(){let _=this._first;for(;_!==L.Undefined;){const T=_.next;_.prev=L.Undefined,_.next=L.Undefined,_=T}this._first=L.Undefined,this._last=L.Undefined,this._size=0}unshift(_){return this._insert(_,!1)}push(_){return this._insert(_,!0)}_insert(_,T){const D=new L(_);if(this._first===L.Undefined)this._first=D,this._last=D;else if(T){const b=this._last;this._last=D,D.prev=b,b.next=D}else{const b=this._first;this._first=D,D.next=b,b.prev=D}this._size+=1;let C=!1;return()=>{C||(C=!0,this._remove(D))}}shift(){if(this._first!==L.Undefined){const _=this._first.element;return this._remove(this._first),_}}pop(){if(this._last!==L.Undefined){const _=this._last.element;return this._remove(this._last),_}}_remove(_){if(_.prev!==L.Undefined&&_.next!==L.Undefined){const T=_.prev;T.next=_.next,_.next.prev=T}else _.prev===L.Undefined&&_.next===L.Undefined?(this._first=L.Undefined,this._last=L.Undefined):_.next===L.Undefined?(this._last=this._last.prev,this._last.next=L.Undefined):_.prev===L.Undefined&&(this._first=this._first.next,this._first.prev=L.Undefined);this._size-=1}*[Symbol.iterator](){let _=this._first;for(;_!==L.Undefined;)yield _.element,_=_.next}}e.LinkedList=i}),function(){function Q(k){const _=[];typeof k=="number"&&_.push("code/timeOrigin",k);function T(C){_.push(C,Date.now())}function D(){const C=[];for(let b=0;b<_.length;b+=2)C.push({name:_[b],startTime:_[b+1]});return C}return{mark:T,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const _=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))_.push({name:T.name,startTime:Math.round(k+T.startTime)});return _}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function L(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=L(i))}(),define(ne[4],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const L="en";let i=!1,k=!1,_=!1,T=!1,D=!1,C=!1,b=!1,P=!1,E,f=L,p,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let S;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?S=e.globals.vscode.process:typeof process!="undefined"&&(S=process);const v=typeof S?.versions?.electron=="string",y=v&&S?.type==="renderer";if(e.isElectronSandboxed=y&&S?.sandboxed,typeof navigator=="object"&&!y)h=navigator.userAgent,i=h.indexOf("Windows")>=0,k=h.indexOf("Macintosh")>=0,P=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=h.indexOf("Linux")>=0,C=!0,E=navigator.language,f=E;else if(typeof S=="object"){i=S.platform==="win32",k=S.platform==="darwin",_=S.platform==="linux",T=_&&!!S.env.SNAP&&!!S.env.SNAP_REVISION,b=v,E=L,f=L;const s=S.env.VSCODE_NLS_CONFIG;if(s)try{const o=JSON.parse(s),u=o.availableLanguages["*"];E=o.locale,f=u||L,p=o._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var w;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function g(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=g;let c=0;k?c=1:i?c=3:_&&(c=2),e.isWindows=i,e.isMacintosh=k,e.isLinux=_,e.isLinuxSnap=T,e.isNative=D,e.isElectron=b,e.isWeb=C,e.isIOS=P,e.platform=c,e.userAgent=h,e.language=f;var l;(function(s){function o(){return e.language}s.value=o;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=u;function d(){return e.language==="en"}s.isDefault=d})(l=e.Language||(e.Language={})),e.locale=E,e.translationsConfigFile=p,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let d=0,m=s.length;d<m;d++){const I=s[d];if(I.id===u.data.vscodeScheduleAsyncWork){s.splice(d,1),I.callback();return}}});let o=0;return u=>{const d=++o;s.push({id:d,callback:u}),e.globals.postMessage({vscodeScheduleAsyncWork:d},"*")}}return s=>setTimeout(s)})();var r;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||P?2:i?1:3;let a=!0,n=!1;function t(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,a=new Uint16Array(s.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=t}),define(ne[31],ie([0,1,4]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.process!="undefined"){const k=L.globals.vscode.process;i={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return L.isWindows?"win32":L.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(ne[9],ie([0,1,31]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,k=97,_=90,T=122,D=46,C=47,b=92,P=58,E=63;class f extends Error{constructor(c,l,r){let a;typeof l=="string"&&l.indexOf("not ")===0?(a="must not be",l=l.replace(/^not /,"")):a="must be";const n=c.indexOf(".")!==-1?"property":"argument";let t=`The "${c}" ${n} ${a} of type ${l}`;t+=`. Received type ${typeof r}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function p(g,c){if(typeof g!="string")throw new f(c,"string",g)}function h(g){return g===C||g===b}function S(g){return g===C}function v(g){return g>=i&&g<=_||g>=k&&g<=T}function y(g,c,l,r){let a="",n=0,t=-1,s=0,o=0;for(let u=0;u<=g.length;++u){if(u<g.length)o=g.charCodeAt(u);else{if(r(o))break;o=C}if(r(o)){if(!(t===u-1||s===1))if(s===2){if(a.length<2||n!==2||a.charCodeAt(a.length-1)!==D||a.charCodeAt(a.length-2)!==D){if(a.length>2){const d=a.lastIndexOf(l);d===-1?(a="",n=0):(a=a.slice(0,d),n=a.length-1-a.lastIndexOf(l)),t=u,s=0;continue}else if(a.length!==0){a="",n=0,t=u,s=0;continue}}c&&(a+=a.length>0?`${l}..`:"..",n=2)}else a.length>0?a+=`${l}${g.slice(t+1,u)}`:a=g.slice(t+1,u),n=u-t-1;t=u,s=0}else o===D&&s!==-1?++s:s=-1}return a}function w(g,c){if(c===null||typeof c!="object")throw new f("pathObject","Object",c);const l=c.dir||c.root,r=c.base||`${c.name||""}${c.ext||""}`;return l?l===c.root?`${l}${r}`:`${l}${g}${r}`:r}e.win32={resolve(...g){let c="",l="",r=!1;for(let a=g.length-1;a>=-1;a--){let n;if(a>=0){if(n=g[a],p(n,"path"),n.length===0)continue}else c.length===0?n=L.cwd():(n=L.env[`=${c}`]||L.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==c.toLowerCase()&&n.charCodeAt(2)===b)&&(n=`${c}\\`));const t=n.length;let s=0,o="",u=!1;const d=n.charCodeAt(0);if(t===1)h(d)&&(s=1,u=!0);else if(h(d))if(u=!0,h(n.charCodeAt(1))){let m=2,I=m;for(;m<t&&!h(n.charCodeAt(m));)m++;if(m<t&&m!==I){const A=n.slice(I,m);for(I=m;m<t&&h(n.charCodeAt(m));)m++;if(m<t&&m!==I){for(I=m;m<t&&!h(n.charCodeAt(m));)m++;(m===t||m!==I)&&(o=`\\\\${A}\\${n.slice(I,m)}`,s=m)}}}else s=1;else v(d)&&n.charCodeAt(1)===P&&(o=n.slice(0,2),s=2,t>2&&h(n.charCodeAt(2))&&(u=!0,s=3));if(o.length>0)if(c.length>0){if(o.toLowerCase()!==c.toLowerCase())continue}else c=o;if(r){if(c.length>0)break}else if(l=`${n.slice(s)}\\${l}`,r=u,u&&c.length>0)break}return l=y(l,!r,"\\",h),r?`${c}\\${l}`:`${c}${l}`||"."},normalize(g){p(g,"path");const c=g.length;if(c===0)return".";let l=0,r,a=!1;const n=g.charCodeAt(0);if(c===1)return S(n)?"\\":g;if(h(n))if(a=!0,h(g.charCodeAt(1))){let s=2,o=s;for(;s<c&&!h(g.charCodeAt(s));)s++;if(s<c&&s!==o){const u=g.slice(o,s);for(o=s;s<c&&h(g.charCodeAt(s));)s++;if(s<c&&s!==o){for(o=s;s<c&&!h(g.charCodeAt(s));)s++;if(s===c)return`\\\\${u}\\${g.slice(o)}\\`;s!==o&&(r=`\\\\${u}\\${g.slice(o,s)}`,l=s)}}}else l=1;else v(n)&&g.charCodeAt(1)===P&&(r=g.slice(0,2),l=2,c>2&&h(g.charCodeAt(2))&&(a=!0,l=3));let t=l<c?y(g.slice(l),!a,"\\",h):"";return t.length===0&&!a&&(t="."),t.length>0&&h(g.charCodeAt(c-1))&&(t+="\\"),r===void 0?a?`\\${t}`:t:a?`${r}\\${t}`:`${r}${t}`},isAbsolute(g){p(g,"path");const c=g.length;if(c===0)return!1;const l=g.charCodeAt(0);return h(l)||c>2&&v(l)&&g.charCodeAt(1)===P&&h(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let c,l;for(let n=0;n<g.length;++n){const t=g[n];p(t,"path"),t.length>0&&(c===void 0?c=l=t:c+=`\\${t}`)}if(c===void 0)return".";let r=!0,a=0;if(typeof l=="string"&&h(l.charCodeAt(0))){++a;const n=l.length;n>1&&h(l.charCodeAt(1))&&(++a,n>2&&(h(l.charCodeAt(2))?++a:r=!1))}if(r){for(;a<c.length&&h(c.charCodeAt(a));)a++;a>=2&&(c=`\\${c.slice(a)}`)}return e.win32.normalize(c)},relative(g,c){if(p(g,"from"),p(c,"to"),g===c)return"";const l=e.win32.resolve(g),r=e.win32.resolve(c);if(l===r||(g=l.toLowerCase(),c=r.toLowerCase(),g===c))return"";let a=0;for(;a<g.length&&g.charCodeAt(a)===b;)a++;let n=g.length;for(;n-1>a&&g.charCodeAt(n-1)===b;)n--;const t=n-a;let s=0;for(;s<c.length&&c.charCodeAt(s)===b;)s++;let o=c.length;for(;o-1>s&&c.charCodeAt(o-1)===b;)o--;const u=o-s,d=t<u?t:u;let m=-1,I=0;for(;I<d;I++){const O=g.charCodeAt(a+I);if(O!==c.charCodeAt(s+I))break;O===b&&(m=I)}if(I!==d){if(m===-1)return r}else{if(u>d){if(c.charCodeAt(s+I)===b)return r.slice(s+I+1);if(I===2)return r.slice(s+I)}t>d&&(g.charCodeAt(a+I)===b?m=I:I===2&&(m=3)),m===-1&&(m=0)}let A="";for(I=a+m+1;I<=n;++I)(I===n||g.charCodeAt(I)===b)&&(A+=A.length===0?"..":"\\..");return s+=m,A.length>0?`${A}${r.slice(s,o)}`:(r.charCodeAt(s)===b&&++s,r.slice(s,o))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const c=e.win32.resolve(g);if(c.length<=2)return g;if(c.charCodeAt(0)===b){if(c.charCodeAt(1)===b){const l=c.charCodeAt(2);if(l!==E&&l!==D)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(v(c.charCodeAt(0))&&c.charCodeAt(1)===P&&c.charCodeAt(2)===b)return`\\\\?\\${c}`;return g},dirname(g){p(g,"path");const c=g.length;if(c===0)return".";let l=-1,r=0;const a=g.charCodeAt(0);if(c===1)return h(a)?g:".";if(h(a)){if(l=r=1,h(g.charCodeAt(1))){let s=2,o=s;for(;s<c&&!h(g.charCodeAt(s));)s++;if(s<c&&s!==o){for(o=s;s<c&&h(g.charCodeAt(s));)s++;if(s<c&&s!==o){for(o=s;s<c&&!h(g.charCodeAt(s));)s++;if(s===c)return g;s!==o&&(l=r=s+1)}}}}else v(a)&&g.charCodeAt(1)===P&&(l=c>2&&h(g.charCodeAt(2))?3:2,r=l);let n=-1,t=!0;for(let s=c-1;s>=r;--s)if(h(g.charCodeAt(s))){if(!t){n=s;break}}else t=!1;if(n===-1){if(l===-1)return".";n=l}return g.slice(0,n)},basename(g,c){c!==void 0&&p(c,"ext"),p(g,"path");let l=0,r=-1,a=!0,n;if(g.length>=2&&v(g.charCodeAt(0))&&g.charCodeAt(1)===P&&(l=2),c!==void 0&&c.length>0&&c.length<=g.length){if(c===g)return"";let t=c.length-1,s=-1;for(n=g.length-1;n>=l;--n){const o=g.charCodeAt(n);if(h(o)){if(!a){l=n+1;break}}else s===-1&&(a=!1,s=n+1),t>=0&&(o===c.charCodeAt(t)?--t==-1&&(r=n):(t=-1,r=s))}return l===r?r=s:r===-1&&(r=g.length),g.slice(l,r)}for(n=g.length-1;n>=l;--n)if(h(g.charCodeAt(n))){if(!a){l=n+1;break}}else r===-1&&(a=!1,r=n+1);return r===-1?"":g.slice(l,r)},extname(g){p(g,"path");let c=0,l=-1,r=0,a=-1,n=!0,t=0;g.length>=2&&g.charCodeAt(1)===P&&v(g.charCodeAt(0))&&(c=r=2);for(let s=g.length-1;s>=c;--s){const o=g.charCodeAt(s);if(h(o)){if(!n){r=s+1;break}continue}a===-1&&(n=!1,a=s+1),o===D?l===-1?l=s:t!==1&&(t=1):l!==-1&&(t=-1)}return l===-1||a===-1||t===0||t===1&&l===a-1&&l===r+1?"":g.slice(l,a)},format:w.bind(null,"\\"),parse(g){p(g,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return c;const l=g.length;let r=0,a=g.charCodeAt(0);if(l===1)return h(a)?(c.root=c.dir=g,c):(c.base=c.name=g,c);if(h(a)){if(r=1,h(g.charCodeAt(1))){let m=2,I=m;for(;m<l&&!h(g.charCodeAt(m));)m++;if(m<l&&m!==I){for(I=m;m<l&&h(g.charCodeAt(m));)m++;if(m<l&&m!==I){for(I=m;m<l&&!h(g.charCodeAt(m));)m++;m===l?r=m:m!==I&&(r=m+1)}}}}else if(v(a)&&g.charCodeAt(1)===P){if(l<=2)return c.root=c.dir=g,c;if(r=2,h(g.charCodeAt(2))){if(l===3)return c.root=c.dir=g,c;r=3}}r>0&&(c.root=g.slice(0,r));let n=-1,t=r,s=-1,o=!0,u=g.length-1,d=0;for(;u>=r;--u){if(a=g.charCodeAt(u),h(a)){if(!o){t=u+1;break}continue}s===-1&&(o=!1,s=u+1),a===D?n===-1?n=u:d!==1&&(d=1):n!==-1&&(d=-1)}return s!==-1&&(n===-1||d===0||d===1&&n===s-1&&n===t+1?c.base=c.name=g.slice(t,s):(c.name=g.slice(t,n),c.base=g.slice(t,s),c.ext=g.slice(n,s))),t>0&&t!==r?c.dir=g.slice(0,t-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let c="",l=!1;for(let r=g.length-1;r>=-1&&!l;r--){const a=r>=0?g[r]:L.cwd();p(a,"path"),a.length!==0&&(c=`${a}/${c}`,l=a.charCodeAt(0)===C)}return c=y(c,!l,"/",S),l?`/${c}`:c.length>0?c:"."},normalize(g){if(p(g,"path"),g.length===0)return".";const c=g.charCodeAt(0)===C,l=g.charCodeAt(g.length-1)===C;return g=y(g,!c,"/",S),g.length===0?c?"/":l?"./":".":(l&&(g+="/"),c?`/${g}`:g)},isAbsolute(g){return p(g,"path"),g.length>0&&g.charCodeAt(0)===C},join(...g){if(g.length===0)return".";let c;for(let l=0;l<g.length;++l){const r=g[l];p(r,"path"),r.length>0&&(c===void 0?c=r:c+=`/${r}`)}return c===void 0?".":e.posix.normalize(c)},relative(g,c){if(p(g,"from"),p(c,"to"),g===c||(g=e.posix.resolve(g),c=e.posix.resolve(c),g===c))return"";const l=1,r=g.length,a=r-l,n=1,t=c.length-n,s=a<t?a:t;let o=-1,u=0;for(;u<s;u++){const m=g.charCodeAt(l+u);if(m!==c.charCodeAt(n+u))break;m===C&&(o=u)}if(u===s)if(t>s){if(c.charCodeAt(n+u)===C)return c.slice(n+u+1);if(u===0)return c.slice(n+u)}else a>s&&(g.charCodeAt(l+u)===C?o=u:u===0&&(o=0));let d="";for(u=l+o+1;u<=r;++u)(u===r||g.charCodeAt(u)===C)&&(d+=d.length===0?"..":"/..");return`${d}${c.slice(n+o)}`},toNamespacedPath(g){return g},dirname(g){if(p(g,"path"),g.length===0)return".";const c=g.charCodeAt(0)===C;let l=-1,r=!0;for(let a=g.length-1;a>=1;--a)if(g.charCodeAt(a)===C){if(!r){l=a;break}}else r=!1;return l===-1?c?"/":".":c&&l===1?"//":g.slice(0,l)},basename(g,c){c!==void 0&&p(c,"ext"),p(g,"path");let l=0,r=-1,a=!0,n;if(c!==void 0&&c.length>0&&c.length<=g.length){if(c===g)return"";let t=c.length-1,s=-1;for(n=g.length-1;n>=0;--n){const o=g.charCodeAt(n);if(o===C){if(!a){l=n+1;break}}else s===-1&&(a=!1,s=n+1),t>=0&&(o===c.charCodeAt(t)?--t==-1&&(r=n):(t=-1,r=s))}return l===r?r=s:r===-1&&(r=g.length),g.slice(l,r)}for(n=g.length-1;n>=0;--n)if(g.charCodeAt(n)===C){if(!a){l=n+1;break}}else r===-1&&(a=!1,r=n+1);return r===-1?"":g.slice(l,r)},extname(g){p(g,"path");let c=-1,l=0,r=-1,a=!0,n=0;for(let t=g.length-1;t>=0;--t){const s=g.charCodeAt(t);if(s===C){if(!a){l=t+1;break}continue}r===-1&&(a=!1,r=t+1),s===D?c===-1?c=t:n!==1&&(n=1):c!==-1&&(n=-1)}return c===-1||r===-1||n===0||n===1&&c===r-1&&c===l+1?"":g.slice(c,r)},format:w.bind(null,"/"),parse(g){p(g,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return c;const l=g.charCodeAt(0)===C;let r;l?(c.root="/",r=1):r=0;let a=-1,n=0,t=-1,s=!0,o=g.length-1,u=0;for(;o>=r;--o){const d=g.charCodeAt(o);if(d===C){if(!s){n=o+1;break}continue}t===-1&&(s=!1,t=o+1),d===D?a===-1?a=o:u!==1&&(u=1):a!==-1&&(u=-1)}if(t!==-1){const d=n===0&&l?1:n;a===-1||u===0||u===1&&a===t-1&&a===n+1?c.base=c.name=g.slice(d,t):(c.name=g.slice(d,a),c.base=g.slice(d,t),c.ext=g.slice(a,t))}return n>0?c.dir=g.slice(0,n-1):l&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=L.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=L.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=L.platform==="win32"?e.win32.join:e.posix.join,e.resolve=L.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=L.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=L.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=L.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=L.platform==="win32"?e.win32.extname:e.posix.extname,e.format=L.platform==="win32"?e.win32.format:e.posix.format,e.parse=L.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=L.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=L.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=L.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[100],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(_){_[_.stdout=0]="stdout",_[_.stderr=1]="stderr"})(L=e.Source||(e.Source={}));var i;(function(_){_[_.Success=0]="Success",_[_.Unknown=1]="Unknown",_[_.AccessDenied=2]="AccessDenied",_[_.ProcessNotFound=3]="ProcessNotFound"})(i=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(_,...T){const D=T.reduce((P,E)=>(P[E]=!0,P),{}),C=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(_).filter(P=>!D[P]).forEach(P=>{for(let E=0;E<C.length;E++)if(P.search(C[E])!==-1){delete _[P];break}})}e.sanitizeProcessEnvironment=k}),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var i in L)(typeof exports=="object"?exports:Q)[i]=L[i]}}(typeof self!="undefined"?self:this,function(){return function(Q){var e={};function L(i){if(e[i])return e[i].exports;var k=e[i]={i,l:!1,exports:{}};return Q[i].call(k.exports,k,k.exports,L),k.l=!0,k.exports}return L.m=Q,L.c=e,L.d=function(i,k,_){L.o(i,k)||Object.defineProperty(i,k,{enumerable:!0,get:_})},L.r=function(i){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},L.t=function(i,k){if(1&k&&(i=L(i)),8&k||4&k&&typeof i=="object"&&i&&i.__esModule)return i;var _=Object.create(null);if(L.r(_),Object.defineProperty(_,"default",{enumerable:!0,value:i}),2&k&&typeof i!="string")for(var T in i)L.d(_,T,function(D){return i[D]}.bind(null,T));return _},L.n=function(i){var k=i&&i.__esModule?function(){return i.default}:function(){return i};return L.d(k,"a",k),k},L.o=function(i,k){return Object.prototype.hasOwnProperty.call(i,k)},L.p="",L(L.s=0)}([function(Q,e,L){(function(i){var k;e=Q.exports=j,k=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var re=Array.prototype.slice.call(arguments,0);re.unshift("SEMVER"),console.log.apply(console,re)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var _=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],C=e.src=[],b=0,P=b++;C[P]="0|[1-9]\\d*";var E=b++;C[E]="[0-9]+";var f=b++;C[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=b++;C[p]="("+C[P]+")\\.("+C[P]+")\\.("+C[P]+")";var h=b++;C[h]="("+C[E]+")\\.("+C[E]+")\\.("+C[E]+")";var S=b++;C[S]="(?:"+C[P]+"|"+C[f]+")";var v=b++;C[v]="(?:"+C[E]+"|"+C[f]+")";var y=b++;C[y]="(?:-("+C[S]+"(?:\\."+C[S]+")*))";var w=b++;C[w]="(?:-?("+C[v]+"(?:\\."+C[v]+")*))";var g=b++;C[g]="[0-9A-Za-z-]+";var c=b++;C[c]="(?:\\+("+C[g]+"(?:\\."+C[g]+")*))";var l=b++,r="v?"+C[p]+C[y]+"?"+C[c]+"?";C[l]="^"+r+"$";var a="[v=\\s]*"+C[h]+C[w]+"?"+C[c]+"?",n=b++;C[n]="^"+a+"$";var t=b++;C[t]="((?:<|>)?=?)";var s=b++;C[s]=C[E]+"|x|X|\\*";var o=b++;C[o]=C[P]+"|x|X|\\*";var u=b++;C[u]="[v=\\s]*("+C[o]+")(?:\\.("+C[o]+")(?:\\.("+C[o]+")(?:"+C[y]+")?"+C[c]+"?)?)?";var d=b++;C[d]="[v=\\s]*("+C[s]+")(?:\\.("+C[s]+")(?:\\.("+C[s]+")(?:"+C[w]+")?"+C[c]+"?)?)?";var m=b++;C[m]="^"+C[t]+"\\s*"+C[u]+"$";var I=b++;C[I]="^"+C[t]+"\\s*"+C[d]+"$";var A=b++;C[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=b++;C[O]="(?:~>?)";var N=b++;C[N]="(\\s*)"+C[O]+"\\s+",D[N]=new RegExp(C[N],"g");var $=b++;C[$]="^"+C[O]+C[u]+"$";var R=b++;C[R]="^"+C[O]+C[d]+"$";var M=b++;C[M]="(?:\\^)";var W=b++;C[W]="(\\s*)"+C[M]+"\\s+",D[W]=new RegExp(C[W],"g");var U=b++;C[U]="^"+C[M]+C[u]+"$";var x=b++;C[x]="^"+C[M]+C[d]+"$";var ee=b++;C[ee]="^"+C[t]+"\\s*("+a+")$|^$";var G=b++;C[G]="^"+C[t]+"\\s*("+r+")$|^$";var q=b++;C[q]="(\\s*)"+C[t]+"\\s*("+a+"|"+C[u]+")",D[q]=new RegExp(C[q],"g");var Y=b++;C[Y]="^\\s*("+C[u]+")\\s+-\\s+("+C[u]+")\\s*$";var H=b++;C[H]="^\\s*("+C[d]+")\\s+-\\s+("+C[d]+")\\s*$";var Z=b++;C[Z]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)k(K,C[K]),D[K]||(D[K]=new RegExp(C[K]));function F(re,ae){if(re instanceof j)return re;if(typeof re!="string"||re.length>_||!(ae?D[n]:D[l]).test(re))return null;try{return new j(re,ae)}catch{return null}}function j(re,ae){if(re instanceof j){if(re.loose===ae)return re;re=re.version}else if(typeof re!="string")throw new TypeError("Invalid Version: "+re);if(re.length>_)throw new TypeError("version is longer than "+_+" characters");if(!(this instanceof j))return new j(re,ae);k("SemVer",re,ae),this.loose=ae;var le=re.trim().match(ae?D[n]:D[l]);if(!le)throw new TypeError("Invalid Version: "+re);if(this.raw=re,this.major=+le[1],this.minor=+le[2],this.patch=+le[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");le[4]?this.prerelease=le[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ie=+be;if(Ie>=0&&Ie<T)return Ie}return be}):this.prerelease=[],this.build=le[5]?le[5].split("."):[],this.format()}e.parse=F,e.valid=function(re,ae){var le=F(re,ae);return le?le.version:null},e.clean=function(re,ae){var le=F(re.trim().replace(/^[=v]+/,""),ae);return le?le.version:null},e.SemVer=j,j.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},j.prototype.toString=function(){return this.version},j.prototype.compare=function(re){return k("SemVer.compare",this.version,this.loose,re),re instanceof j||(re=new j(re,this.loose)),this.compareMain(re)||this.comparePre(re)},j.prototype.compareMain=function(re){return re instanceof j||(re=new j(re,this.loose)),z(this.major,re.major)||z(this.minor,re.minor)||z(this.patch,re.patch)},j.prototype.comparePre=function(re){if(re instanceof j||(re=new j(re,this.loose)),this.prerelease.length&&!re.prerelease.length)return-1;if(!this.prerelease.length&&re.prerelease.length)return 1;if(!this.prerelease.length&&!re.prerelease.length)return 0;var ae=0;do{var le=this.prerelease[ae],be=re.prerelease[ae];if(k("prerelease compare",ae,le,be),le===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(le===void 0)return-1;if(le!==be)return z(le,be)}while(++ae)},j.prototype.inc=function(re,ae){switch(re){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var le=this.prerelease.length;--le>=0;)typeof this.prerelease[le]=="number"&&(this.prerelease[le]++,le=-2);le===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+re)}return this.format(),this.raw=this.version,this},e.inc=function(re,ae,le,be){typeof le=="string"&&(be=le,le=void 0);try{return new j(re,le).inc(ae,be).version}catch{return null}},e.diff=function(re,ae){if(ce(re,ae))return null;var le=F(re),be=F(ae);if(le.prerelease.length||be.prerelease.length){for(var Ie in le)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&le[Ie]!==be[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in le)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&le[Ie]!==be[Ie])return Ie},e.compareIdentifiers=z;var B=/^[0-9]+$/;function z(re,ae){var le=B.test(re),be=B.test(ae);return le&&be&&(re=+re,ae=+ae),le&&!be?-1:be&&!le?1:re<ae?-1:re>ae?1:0}function V(re,ae,le){return new j(re,le).compare(new j(ae,le))}function te(re,ae,le){return V(re,ae,le)>0}function se(re,ae,le){return V(re,ae,le)<0}function ce(re,ae,le){return V(re,ae,le)===0}function he(re,ae,le){return V(re,ae,le)!==0}function me(re,ae,le){return V(re,ae,le)>=0}function ve(re,ae,le){return V(re,ae,le)<=0}function ge(re,ae,le,be){var Ie;switch(ae){case"===":typeof re=="object"&&(re=re.version),typeof le=="object"&&(le=le.version),Ie=re===le;break;case"!==":typeof re=="object"&&(re=re.version),typeof le=="object"&&(le=le.version),Ie=re!==le;break;case"":case"=":case"==":Ie=ce(re,le,be);break;case"!=":Ie=he(re,le,be);break;case">":Ie=te(re,le,be);break;case">=":Ie=me(re,le,be);break;case"<":Ie=se(re,le,be);break;case"<=":Ie=ve(re,le,be);break;default:throw new TypeError("Invalid operator: "+ae)}return Ie}function we(re,ae){if(re instanceof we){if(re.loose===ae)return re;re=re.value}if(!(this instanceof we))return new we(re,ae);k("comparator",re,ae),this.loose=ae,this.parse(re),this.semver===De?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(re,ae){return z(ae,re)},e.major=function(re,ae){return new j(re,ae).major},e.minor=function(re,ae){return new j(re,ae).minor},e.patch=function(re,ae){return new j(re,ae).patch},e.compare=V,e.compareLoose=function(re,ae){return V(re,ae,!0)},e.rcompare=function(re,ae,le){return V(ae,re,le)},e.sort=function(re,ae){return re.sort(function(le,be){return e.compare(le,be,ae)})},e.rsort=function(re,ae){return re.sort(function(le,be){return e.rcompare(le,be,ae)})},e.gt=te,e.lt=se,e.eq=ce,e.neq=he,e.gte=me,e.lte=ve,e.cmp=ge,e.Comparator=we;var De={};function Ee(re,ae){if(re instanceof Ee)return re.loose===ae?re:new Ee(re.raw,ae);if(re instanceof we)return new Ee(re.value,ae);if(!(this instanceof Ee))return new Ee(re,ae);if(this.loose=ae,this.raw=re,this.set=re.split(/\s*\|\|\s*/).map(function(le){return this.parseRange(le.trim())},this).filter(function(le){return le.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+re);this.format()}function ke(re){return!re||re.toLowerCase()==="x"||re==="*"}function Le(re,ae,le,be,Ie,Me,Te,Ne,Ae,Ue,X,oe,ue){return((ae=ke(le)?"":ke(be)?">="+le+".0.0":ke(Ie)?">="+le+"."+be+".0":">="+ae)+" "+(Ne=ke(Ae)?"":ke(Ue)?"<"+(+Ae+1)+".0.0":ke(X)?"<"+Ae+"."+(+Ue+1)+".0":oe?"<="+Ae+"."+Ue+"."+X+"-"+oe:"<="+Ne)).trim()}function Fe(re,ae){for(var le=0;le<re.length;le++)if(!re[le].test(ae))return!1;if(ae.prerelease.length){for(le=0;le<re.length;le++)if(k(re[le].semver),re[le].semver!==De&&re[le].semver.prerelease.length>0){var be=re[le].semver;if(be.major===ae.major&&be.minor===ae.minor&&be.patch===ae.patch)return!0}return!1}return!0}function $e(re,ae,le){try{ae=new Ee(ae,le)}catch{return!1}return ae.test(re)}function ze(re,ae,le,be){var Ie,Me,Te,Ne,Ae;switch(re=new j(re,be),ae=new Ee(ae,be),le){case">":Ie=te,Me=ve,Te=se,Ne=">",Ae=">=";break;case"<":Ie=se,Me=me,Te=te,Ne="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(re,ae,be))return!1;for(var Ue=0;Ue<ae.set.length;++Ue){var X=ae.set[Ue],oe=null,ue=null;if(X.forEach(function(fe){fe.semver===De&&(fe=new we(">=0.0.0")),oe=oe||fe,ue=ue||fe,Ie(fe.semver,oe.semver,be)?oe=fe:Te(fe.semver,ue.semver,be)&&(ue=fe)}),oe.operator===Ne||oe.operator===Ae||(!ue.operator||ue.operator===Ne)&&Me(re,ue.semver)||ue.operator===Ae&&Te(re,ue.semver))return!1}return!0}we.prototype.parse=function(re){var ae=this.loose?D[ee]:D[G],le=re.match(ae);if(!le)throw new TypeError("Invalid comparator: "+re);this.operator=le[1],this.operator==="="&&(this.operator=""),le[2]?this.semver=new j(le[2],this.loose):this.semver=De},we.prototype.toString=function(){return this.value},we.prototype.test=function(re){return k("Comparator.test",re,this.loose),this.semver===De||(typeof re=="string"&&(re=new j(re,this.loose)),ge(re,this.operator,this.semver,this.loose))},we.prototype.intersects=function(re,ae){if(!(re instanceof we))throw new TypeError("a Comparator is required");var le;if(this.operator==="")return le=new Ee(re.value,ae),$e(this.value,le,ae);if(re.operator==="")return le=new Ee(this.value,ae),$e(re.semver,le,ae);var be=!(this.operator!==">="&&this.operator!==">"||re.operator!==">="&&re.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||re.operator!=="<="&&re.operator!=="<"),Me=this.semver.version===re.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||re.operator!==">="&&re.operator!=="<="),Ne=ge(this.semver,"<",re.semver,ae)&&(this.operator===">="||this.operator===">")&&(re.operator==="<="||re.operator==="<"),Ae=ge(this.semver,">",re.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(re.operator===">="||re.operator===">");return be||Ie||Me&&Te||Ne||Ae},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(re){return re.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(re){var ae=this.loose;re=re.trim(),k("range",re,ae);var le=ae?D[H]:D[Y];re=re.replace(le,Le),k("hyphen replace",re),re=re.replace(D[q],"$1$2$3"),k("comparator trim",re,D[q]),re=(re=(re=re.replace(D[N],"$1~")).replace(D[W],"$1^")).split(/\s+/).join(" ");var be=ae?D[ee]:D[G],Ie=re.split(" ").map(function(Me){return function(Te,Ne){return k("comp",Te),Te=function(Ae,Ue){return Ae.trim().split(/\s+/).map(function(X){return function(oe,ue){k("caret",oe,ue);var fe=ue?D[x]:D[U];return oe.replace(fe,function(ye,pe,Ce,Pe,Re){var _e;return k("caret",oe,ye,pe,Ce,Pe,Re),ke(pe)?_e="":ke(Ce)?_e=">="+pe+".0.0 <"+(+pe+1)+".0.0":ke(Pe)?_e=pe==="0"?">="+pe+"."+Ce+".0 <"+pe+"."+(+Ce+1)+".0":">="+pe+"."+Ce+".0 <"+(+pe+1)+".0.0":Re?(k("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),_e=pe==="0"?Ce==="0"?">="+pe+"."+Ce+"."+Pe+Re+" <"+pe+"."+Ce+"."+(+Pe+1):">="+pe+"."+Ce+"."+Pe+Re+" <"+pe+"."+(+Ce+1)+".0":">="+pe+"."+Ce+"."+Pe+Re+" <"+(+pe+1)+".0.0"):(k("no pr"),_e=pe==="0"?Ce==="0"?">="+pe+"."+Ce+"."+Pe+" <"+pe+"."+Ce+"."+(+Pe+1):">="+pe+"."+Ce+"."+Pe+" <"+pe+"."+(+Ce+1)+".0":">="+pe+"."+Ce+"."+Pe+" <"+(+pe+1)+".0.0"),k("caret return",_e),_e})}(X,Ue)}).join(" ")}(Te,Ne),k("caret",Te),Te=function(Ae,Ue){return Ae.trim().split(/\s+/).map(function(X){return function(oe,ue){var fe=ue?D[R]:D[$];return oe.replace(fe,function(ye,pe,Ce,Pe,Re){var _e;return k("tilde",oe,ye,pe,Ce,Pe,Re),ke(pe)?_e="":ke(Ce)?_e=">="+pe+".0.0 <"+(+pe+1)+".0.0":ke(Pe)?_e=">="+pe+"."+Ce+".0 <"+pe+"."+(+Ce+1)+".0":Re?(k("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),_e=">="+pe+"."+Ce+"."+Pe+Re+" <"+pe+"."+(+Ce+1)+".0"):_e=">="+pe+"."+Ce+"."+Pe+" <"+pe+"."+(+Ce+1)+".0",k("tilde return",_e),_e})}(X,Ue)}).join(" ")}(Te,Ne),k("tildes",Te),Te=function(Ae,Ue){return k("replaceXRanges",Ae,Ue),Ae.split(/\s+/).map(function(X){return function(oe,ue){oe=oe.trim();var fe=ue?D[I]:D[m];return oe.replace(fe,function(ye,pe,Ce,Pe,Re,_e){k("xRange",oe,ye,pe,Ce,Pe,Re,_e);var qe=ke(Ce),Je=qe||ke(Pe),Xe=Je||ke(Re);return pe==="="&&Xe&&(pe=""),qe?ye=pe===">"||pe==="<"?"<0.0.0":"*":pe&&Xe?(Je&&(Pe=0),Xe&&(Re=0),pe===">"?(pe=">=",Je?(Ce=+Ce+1,Pe=0,Re=0):Xe&&(Pe=+Pe+1,Re=0)):pe==="<="&&(pe="<",Je?Ce=+Ce+1:Pe=+Pe+1),ye=pe+Ce+"."+Pe+"."+Re):Je?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Xe&&(ye=">="+Ce+"."+Pe+".0 <"+Ce+"."+(+Pe+1)+".0"),k("xRange return",ye),ye})}(X,Ue)}).join(" ")}(Te,Ne),k("xrange",Te),Te=function(Ae,Ue){return k("replaceStars",Ae,Ue),Ae.trim().replace(D[Z],"")}(Te,Ne),k("stars",Te),Te}(Me,ae)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Me){return!!Me.match(be)})),Ie=Ie.map(function(Me){return new we(Me,ae)})},Ee.prototype.intersects=function(re,ae){if(!(re instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(le){return le.every(function(be){return re.set.some(function(Ie){return Ie.every(function(Me){return be.intersects(Me,ae)})})})})},e.toComparators=function(re,ae){return new Ee(re,ae).set.map(function(le){return le.map(function(be){return be.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(re){if(!re)return!1;typeof re=="string"&&(re=new j(re,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Fe(this.set[ae],re))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(re,ae,le){var be=null,Ie=null;try{var Me=new Ee(ae,le)}catch{return null}return re.forEach(function(Te){Me.test(Te)&&(be&&Ie.compare(Te)!==-1||(Ie=new j(be=Te,le)))}),be},e.minSatisfying=function(re,ae,le){var be=null,Ie=null;try{var Me=new Ee(ae,le)}catch{return null}return re.forEach(function(Te){Me.test(Te)&&(be&&Ie.compare(Te)!==1||(Ie=new j(be=Te,le)))}),be},e.validRange=function(re,ae){try{return new Ee(re,ae).range||"*"}catch{return null}},e.ltr=function(re,ae,le){return ze(re,ae,"<",le)},e.gtr=function(re,ae,le){return ze(re,ae,">",le)},e.outside=ze,e.prerelease=function(re,ae){var le=F(re,ae);return le&&le.prerelease.length?le.prerelease:null},e.intersects=function(re,ae,le){return re=new Ee(re,le),ae=new Ee(ae,le),re.intersects(ae)},e.coerce=function(re){if(re instanceof j)return re;if(typeof re!="string")return null;var ae=re.match(D[A]);return ae==null?null:F((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,L(1))},function(Q,e){var L,i,k=Q.exports={};function _(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function D(v){if(L===setTimeout)return setTimeout(v,0);if((L===_||!L)&&setTimeout)return L=setTimeout,setTimeout(v,0);try{return L(v,0)}catch{try{return L.call(null,v,0)}catch{return L.call(this,v,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:_}catch{L=_}try{i=typeof clearTimeout=="function"?clearTimeout:T}catch{i=T}})();var C,b=[],P=!1,E=-1;function f(){P&&C&&(P=!1,C.length?b=C.concat(b):E=-1,b.length&&p())}function p(){if(!P){var v=D(f);P=!0;for(var y=b.length;y;){for(C=b,b=[];++E<y;)C&&C[E].run();E=-1,y=b.length}C=null,P=!1,function(w){if(i===clearTimeout)return clearTimeout(w);if((i===T||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(w);try{i(w)}catch{try{return i.call(null,w)}catch{return i.call(this,w)}}}(v)}}function h(v,y){this.fun=v,this.array=y}function S(){}k.nextTick=function(v){var y=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)y[w-1]=arguments[w];b.push(new h(v,y)),b.length!==1||P||D(p)},h.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=S,k.addListener=S,k.once=S,k.off=S,k.removeListener=S,k.removeAllListeners=S,k.emit=S,k.prependListener=S,k.prependOnceListener=S,k.listeners=function(v){return[]},k.binding=function(v){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(v){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ne[101],ie([0,1]),function(Q,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class i{constructor(D,C,b){this.level=D,this.key=C,this.value=b,this.forward=[]}}const k=void 0;class _{constructor(D,C=2**16){this.comparator=D,this[L]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(C)|0),this._header=new i(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new i(this._maxLevel,k,k)}has(D){return Boolean(_._search(this,D,this.comparator))}get(D){return _._search(this,D,this.comparator)?.value}set(D,C){return _._insert(this,D,C,this.comparator)&&(this._size+=1),this}delete(D){const C=_._delete(this,D,this.comparator);return C&&(this._size-=1),C}forEach(D,C){let b=this._header.forward[0];for(;b;)D.call(C,b.value,b.key,this),b=b.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let D=this._header.forward[0];for(;D;)yield[D.key,D.value],D=D.forward[0]}*keys(){let D=this._header.forward[0];for(;D;)yield D.key,D=D.forward[0]}*values(){let D=this._header.forward[0];for(;D;)yield D.value,D=D.forward[0]}toString(){let D="[SkipList]:",C=this._header.forward[0];for(;C;)D+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return D}static _search(D,C,b){let P=D._header;for(let E=D._level-1;E>=0;E--)for(;P.forward[E]&&b(P.forward[E].key,C)<0;)P=P.forward[E];if(P=P.forward[0],P&&b(P.key,C)===0)return P}static _insert(D,C,b,P){let E=[],f=D._header;for(let p=D._level-1;p>=0;p--){for(;f.forward[p]&&P(f.forward[p].key,C)<0;)f=f.forward[p];E[p]=f}if(f=f.forward[0],f&&P(f.key,C)===0)return f.value=b,!1;{let p=_._randomLevel(D);if(p>D._level){for(let h=D._level;h<p;h++)E[h]=D._header;D._level=p}f=new i(p,C,b);for(let h=0;h<p;h++)f.forward[h]=E[h].forward[h],E[h].forward[h]=f;return!0}}static _randomLevel(D,C=.5){let b=1;for(;Math.random()<C&&b<D._maxLevel;)b+=1;return b}static _delete(D,C,b){let P=[],E=D._header;for(let f=D._level-1;f>=0;f--){for(;E.forward[f]&&b(E.forward[f].key,C)<0;)E=E.forward[f];P[f]=E}if(E=E.forward[0],!E||b(E.key,C)!==0)return!1;for(let f=0;f<D._level&&P[f].forward[f]===E;f++)P[f].forward[f]=E.forward[f];for(;D._level>0&&D._header.forward[D._level-1]===k;)D._level-=1;return!0}}e.SkipList=_}),define(ne[102],ie([0,1,4]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=L.globals.performance&&typeof L.globals.performance.now=="function";class k{constructor(T){this._highResolution=i&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new k(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?L.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ne[3],ie([0,1,8,67,2,99,102]),function(Q,e,L,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(c){c.None=()=>k.Disposable.None;function l(x){return(ee,G=null,q)=>{let Y=!1,H;return H=x(Z=>{if(!Y)return H?H.dispose():Y=!0,ee.call(G,Z)},null,q),Y&&H.dispose(),H}}c.once=l;function r(x,ee){return u((G,q=null,Y)=>x(H=>G.call(q,ee(H)),null,Y))}c.map=r;function a(x,ee){return u((G,q=null,Y)=>x(H=>{ee(H),G.call(q,H)},null,Y))}c.forEach=a;function n(x,ee){return u((G,q=null,Y)=>x(H=>ee(H)&&G.call(q,H),null,Y))}c.filter=n;function t(x){return x}c.signal=t;function s(...x){return(ee,G=null,q)=>(0,k.combinedDisposable)(...x.map(Y=>Y(H=>ee.call(G,H),null,q)))}c.any=s;function o(x,ee,G){let q=G;return r(x,Y=>(q=ee(q,Y),q))}c.reduce=o;function u(x){let ee;const G=new f({onFirstListenerAdd(){ee=x(G.fire,G)},onLastListenerRemove(){ee.dispose()}});return G.event}function d(x,ee,G,q=100,Y=!1){let H,Z,K=0;return x(F=>{K++,H=G(H,F),Y&&!Z&&(ee(H),H=void 0),clearTimeout(Z),Z=setTimeout(()=>{const j=H;H=void 0,Z=void 0,(!Y||K>1)&&ee(j),K=0},q)})}c.debouncedListener=d;function m(x,ee,G=100,q=!1,Y){let H,Z,K,F=0;const j=new f({leakWarningThreshold:Y,onFirstListenerAdd(){H=x(B=>{F++,Z=ee(Z,B),q&&!K&&(j.fire(Z),Z=void 0),clearTimeout(K),K=setTimeout(()=>{const z=Z;Z=void 0,K=void 0,(!q||F>1)&&j.fire(z),F=0},G)})},onLastListenerRemove(){H.dispose()}});return j.event}c.debounce=m;function I(x,ee=(G,q)=>G===q){let G=!0,q;return n(x,Y=>{const H=G||!ee(Y,q);return G=!1,q=Y,H})}c.latch=I;function A(x,ee){return[c.filter(x,ee),c.filter(x,G=>!ee(G))]}c.split=A;function O(x,ee=!1,G=[]){let q=G.slice(),Y=x(K=>{q?q.push(K):Z.fire(K)});const H=()=>{q&&q.forEach(K=>Z.fire(K)),q=null},Z=new f({onFirstListenerAdd(){Y||(Y=x(K=>Z.fire(K)))},onFirstListenerDidAdd(){q&&(ee?setTimeout(H):H())},onLastListenerRemove(){Y&&Y.dispose(),Y=null}});return Z.event}c.buffer=O;class N{constructor(ee){this.event=ee}map(ee){return new N(r(this.event,ee))}forEach(ee){return new N(a(this.event,ee))}filter(ee){return new N(n(this.event,ee))}reduce(ee,G){return new N(o(this.event,ee,G))}latch(){return new N(I(this.event))}debounce(ee,G=100,q=!1,Y){return new N(m(this.event,ee,G,q,Y))}on(ee,G,q){return this.event(ee,G,q)}once(ee,G,q){return l(this.event)(ee,G,q)}}function $(x){return new N(x)}c.chain=$;function R(x,ee,G=q=>q){const q=(...K)=>Z.fire(G(...K)),Y=()=>x.on(ee,q),H=()=>x.removeListener(ee,q),Z=new f({onFirstListenerAdd:Y,onLastListenerRemove:H});return Z.event}c.fromNodeEventEmitter=R;function M(x,ee,G=q=>q){const q=(...K)=>Z.fire(G(...K)),Y=()=>x.addEventListener(ee,q),H=()=>x.removeEventListener(ee,q),Z=new f({onFirstListenerAdd:Y,onLastListenerRemove:H});return Z.event}c.fromDOMEventEmitter=M;function W(x){return new Promise(ee=>l(x)(ee))}c.toPromise=W;function U(x,ee){return ee(void 0),x(G=>ee(G))}c.runAndSubscribe=U})(D=e.Event||(e.Event={}));class C{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${C._idPool++}`}start(l){this._stopWatch=new T.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}C._idPool=0;let b=-1;function P(c){const l=b;return b=c,{dispose(){b=l}}}e.setGlobalLeakWarningThreshold=P;class E{constructor(l,r=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let r=b;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||l<r)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(a)||0;if(this._stacks.set(a,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let t,s=0;for(const[o,u]of this._stacks)(!t||s<u)&&(t=o,s=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${s}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}class f{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=b>0?new E(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0}get event(){return this._event||(this._event=(l,r,a)=>{this._listeners||(this._listeners=new _.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(r?[l,r]:l);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,r);const s=this._leakageMon?.check(this._listeners.size),o=(0,k.toDisposable)(()=>{s&&s(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof k.DisposableStore?a.add(o):Array.isArray(a)&&a.push(o),o}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new _.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,a]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,a):r[0].call(r[1],a)}catch(n){(0,L.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=f;class p extends f{async fireAsync(l,r,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new _.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,l]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[n,t]=this._asyncDeliveryQueue.shift(),s=[],o={...t,token:r,waitUntil:u=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");a&&(u=a(u,typeof n=="function"?n:n[0])),s.push(u)}};try{typeof n=="function"?n.call(void 0,o):n[0].call(n[1],o)}catch(u){(0,L.onUnexpectedError)(u);continue}Object.freeze(s),await Promise.allSettled(s).then(u=>{for(const d of u)d.status==="rejected"&&(0,L.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=p;class h extends f{constructor(l){super(l);this._isPaused=0,this._eventQueue=new _.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=h;class S extends h{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=S;class v extends f{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=v;class y{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const r={event:l,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const a=()=>{this.hasListeners&&this.unhook(r);const n=this.events.indexOf(r);this.events.splice(n,1)};return(0,k.toDisposable)((0,i.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(r=>this.emitter.fire(r))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=y;class w{constructor(){this.buffers=[]}wrapEvent(l){return(r,a,n)=>l(t=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>r.call(a,t)):r.call(a,t)},void 0,n)}bufferEvents(l){const r=[];this.buffers.push(r);const a=l();return this.buffers.pop(),r.forEach(n=>n()),a}}e.EventBufferer=w;class g{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=k.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=g}),define(ne[27],ie([0,1,3]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(D,C){const b=setTimeout(D.bind(C),0);return{dispose(){clearTimeout(b)}}});var k;(function(D){function C(b){return b===D.None||b===D.Cancelled||b instanceof _?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}D.isCancellationToken=C,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:L.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(k=e.CancellationToken||(e.CancellationToken={}));class _{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new L.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(C){this._token=void 0,this._parentListener=void 0,this._parentListener=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new _),this._token}cancel(){this._token?this._token instanceof _&&this._token.cancel():this._token=k.Cancelled}dispose(C=!1){C&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof _&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=T}),define(ne[40],ie([0,1,8,2]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(g){const c=g;return c?[c.on,c.pause,c.resume,c.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=k;function _(g){const c=g;return c?k(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=_;function T(g,c){return new D(g,c)}e.newWriteableStream=T;class D{constructor(c,l){this.reducer=c,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(l=>l(c))}emitError(c){this.listeners.error.length===0?(0,L.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(l=>l(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,l){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(c,l){if(this.state.destroyed)return;let r;switch(c){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const a=r.indexOf(l);a>=0&&r.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(g,c){const l=[];let r;for(;(r=g.read())!==null;)l.push(r);return c(l)}e.consumeReadable=C;function b(g,c,l){const r=[];let a;for(;(a=g.read())!==null&&r.length<l;)r.push(a);return a===null&&r.length>0?c(r):{read:()=>{if(r.length>0)return r.shift();if(typeof a!="undefined"){const n=a;return a=void 0,n}return g.read()}}}e.peekReadable=b;function P(g,c){return new Promise((l,r)=>{const a=[];E(g,{onData:n=>{c&&a.push(n)},onError:n=>{c?r(n):l(void 0)},onEnd:()=>{l(c?c(a):void 0)}})})}e.consumeStream=P;function E(g,c){let l=!1;return g.on("error",r=>{l||c.onError(r)}),g.on("end",()=>{l||c.onEnd()}),g.on("data",r=>{l||c.onData(r)}),(0,i.toDisposable)(()=>l=!0)}e.listenStream=E;function f(g,c){return new Promise((l,r)=>{const a=new i.DisposableStore,n=[],t=u=>{if(n.push(u),n.length>c)return a.dispose(),g.pause(),l({stream:g,buffer:n,ended:!1})},s=u=>r(u),o=()=>l({stream:g,buffer:n,ended:!0});a.add((0,i.toDisposable)(()=>g.removeListener("error",s))),g.on("error",s),a.add((0,i.toDisposable)(()=>g.removeListener("end",o))),g.on("end",o),a.add((0,i.toDisposable)(()=>g.removeListener("data",t))),g.on("data",t)})}e.peekStream=f;function p(g,c){const l=T(c);return l.end(g),l}e.toStream=p;function h(){const g=T(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=h;function S(g){let c=!1;return{read:()=>c?null:(c=!0,g)}}e.toReadable=S;function v(g,c,l){const r=T(l);return E(g,{onData:a=>r.write(c.data(a)),onError:a=>r.error(c.error?c.error(a):a),onEnd:()=>r.end()}),r}e.transform=v;function y(g,c,l){let r=!1;return{read:()=>{const a=c.read();return r?a:(r=!0,a!==null?l([g,a]):g)}}}e.prefixedReadable=y;function w(g,c,l){let r=!1;const a=T(l);return E(c,{onData:n=>r?a.write(n):(r=!0,a.write(l([g,n]))),onError:n=>a.error(n),onEnd:()=>{r||(r=!0,a.write(g)),a.end()}}),a}e.prefixedStream=w}),define(ne[18],ie([0,1,40]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer!="undefined";let k,_;class T{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return i?new T(Buffer.allocUnsafe(t)):new T(new Uint8Array(t))}static wrap(t){return i&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new T(t)}static fromString(t,s){return!(s?.dontUseNodeBuffer||!1)&&i?new T(Buffer.from(t)):(k||(k=new TextEncoder),new T(k.encode(t)))}static fromByteArray(t){const s=T.alloc(t.length);for(let o=0,u=t.length;o<u;o++)s.buffer[o]=t[o];return s}static concat(t,s){if(typeof s=="undefined"){s=0;for(let d=0,m=t.length;d<m;d++)s+=t[d].byteLength}const o=T.alloc(s);let u=0;for(let d=0,m=t.length;d<m;d++){const I=t[d];o.set(I,u),u+=I.byteLength}return o}clone(){const t=T.alloc(this.byteLength);return t.set(this),t}toString(){return i?this.buffer.toString():(_||(_=new TextDecoder),_.decode(this.buffer))}slice(t,s){return new T(this.buffer.subarray(t,s))}set(t,s){if(t instanceof T)this.buffer.set(t.buffer,s);else if(t instanceof Uint8Array)this.buffer.set(t,s);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),s);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),s);else throw new Error("Unkown argument 'array'")}readUInt32BE(t){return b(this.buffer,t)}writeUInt32BE(t,s){P(this.buffer,t,s)}readUInt32LE(t){return E(this.buffer,t)}writeUInt32LE(t,s){f(this.buffer,t,s)}readUInt8(t){return p(this.buffer,t)}writeUInt8(t,s){h(this.buffer,t,s)}}e.VSBuffer=T;function D(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=D;function C(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255}e.writeUInt16LE=C;function b(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=b;function P(n,t,s){n[s+3]=t,t=t>>>8,n[s+2]=t,t=t>>>8,n[s+1]=t,t=t>>>8,n[s]=t}e.writeUInt32BE=P;function E(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=E;function f(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255,t=t>>>8,n[s+2]=t&255,t=t>>>8,n[s+3]=t&255}e.writeUInt32LE=f;function p(n,t){return n[t]}e.readUInt8=p;function h(n,t,s){n[s]=t}e.writeUInt8=h;function S(n){return L.consumeReadable(n,t=>T.concat(t))}e.readableToBuffer=S;function v(n){return L.toReadable(n)}e.bufferToReadable=v;function y(n){return L.consumeStream(n,t=>T.concat(t))}e.streamToBuffer=y;async function w(n){return n.ended?T.concat(n.buffer):T.concat([...n.buffer,await y(n.stream)])}e.bufferedStreamToBuffer=w;function g(n){return L.toStream(n,t=>T.concat(t))}e.bufferToStream=g;function c(n){return L.transform(n,{data:t=>typeof t=="string"?T.fromString(t):T.wrap(t)},t=>T.concat(t))}e.streamToBufferReadableStream=c;function l(n){return L.newWriteableStream(t=>T.concat(t),n)}e.newWriteableBufferStream=l;function r(n,t){return L.prefixedReadable(n,t,s=>T.concat(s))}e.prefixedBufferReadable=r;function a(n,t){return L.prefixedStream(n,t,s=>T.concat(s))}e.prefixedBufferStream=a}),define(ne[25],ie([0,1,4]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function i(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=i;const k=/{(\d+)}/g;function _(X,...oe){return oe.length===0?X:X.replace(k,function(ue,fe){const ye=parseInt(fe,10);return isNaN(ye)||ye<0||ye>=oe.length?ue:oe[ye]})}e.format=_;const T=/{([^}]+)}/g;function D(X,oe){return X.replace(T,(ue,fe)=>oe[fe]??ue)}e.format2=D;function C(X){return X.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=C;function b(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function P(X,oe){let ue=0;const fe=oe.charCodeAt(0);for(let ye=X.length-1;ye>=0;ye--)X.charCodeAt(ye)===fe&&ue++;return ue}e.count=P;function E(X,oe,ue="\u2026"){return X.length<=oe?X:`${X.substr(0,oe)}${ue}`}e.truncate=E;function f(X,oe=" "){const ue=p(X,oe);return h(ue,oe)}e.trim=f;function p(X,oe){if(!X||!oe)return X;const ue=oe.length;if(ue===0||X.length===0)return X;let fe=0;for(;X.indexOf(oe,fe)===fe;)fe=fe+ue;return X.substring(fe)}e.ltrim=p;function h(X,oe){if(!X||!oe)return X;const ue=oe.length,fe=X.length;if(ue===0||fe===0)return X;let ye=fe,pe=-1;for(;pe=X.lastIndexOf(oe,ye-1),!(pe===-1||pe+ue!==ye);){if(pe===0)return"";ye=pe}return X.substring(0,ye)}e.rtrim=h;function S(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=S;function v(X){return X.replace(/\*/g,"")}e.stripWildcards=v;function y(X,oe,ue={}){if(!X)throw new Error("Cannot create regex from empty string");oe||(X=b(X)),ue.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let fe="";return ue.global&&(fe+="g"),ue.matchCase||(fe+="i"),ue.multiline&&(fe+="m"),ue.unicode&&(fe+="u"),new RegExp(X,fe)}e.createRegExp=y;function w(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function g(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function c(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=c;function l(X){return X.split(/\r\n|\r|\n/)}e.splitLines=l;function r(X){for(let oe=0,ue=X.length;oe<ue;oe++){const fe=X.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.firstNonWhitespaceIndex=r;function a(X,oe=0,ue=X.length){for(let fe=oe;fe<ue;fe++){const ye=X.charCodeAt(fe);if(ye!==32&&ye!==9)return X.substring(oe,fe)}return X.substring(oe,ue)}e.getLeadingWhitespace=a;function n(X,oe=X.length-1){for(let ue=oe;ue>=0;ue--){const fe=X.charCodeAt(ue);if(fe!==32&&fe!==9)return ue}return-1}e.lastNonWhitespaceIndex=n;function t(X,oe){return X<oe?-1:X>oe?1:0}e.compare=t;function s(X,oe,ue=0,fe=X.length,ye=0,pe=oe.length){for(;ue<fe&&ye<pe;ue++,ye++){let Re=X.charCodeAt(ue),_e=oe.charCodeAt(ye);if(Re<_e)return-1;if(Re>_e)return 1}const Ce=fe-ue,Pe=pe-ye;return Ce<Pe?-1:Ce>Pe?1:0}e.compareSubstring=s;function o(X,oe){return u(X,oe,0,X.length,0,oe.length)}e.compareIgnoreCase=o;function u(X,oe,ue=0,fe=X.length,ye=0,pe=oe.length){for(;ue<fe&&ye<pe;ue++,ye++){let Re=X.charCodeAt(ue),_e=oe.charCodeAt(ye);if(Re===_e)continue;if(Re>=128||_e>=128)return s(X.toLowerCase(),oe.toLowerCase(),ue,fe,ye,pe);d(Re)&&(Re-=32),d(_e)&&(_e-=32);const qe=Re-_e;if(qe!==0)return qe}const Ce=fe-ue,Pe=pe-ye;return Ce<Pe?-1:Ce>Pe?1:0}e.compareSubstringIgnoreCase=u;function d(X){return X>=97&&X<=122}e.isLowerAsciiLetter=d;function m(X){return X>=65&&X<=90}e.isUpperAsciiLetter=m;function I(X,oe){return X.length===oe.length&&u(X,oe)===0}e.equalsIgnoreCase=I;function A(X,oe){const ue=oe.length;return oe.length>X.length?!1:u(X,oe,0,ue)===0}e.startsWithIgnoreCase=A;function O(X,oe){let ue,fe=Math.min(X.length,oe.length);for(ue=0;ue<fe;ue++)if(X.charCodeAt(ue)!==oe.charCodeAt(ue))return ue;return fe}e.commonPrefixLength=O;function N(X,oe){let ue,fe=Math.min(X.length,oe.length);const ye=X.length-1,pe=oe.length-1;for(ue=0;ue<fe;ue++)if(X.charCodeAt(ye-ue)!==oe.charCodeAt(pe-ue))return ue;return fe}e.commonSuffixLength=N;function $(X){return 55296<=X&&X<=56319}e.isHighSurrogate=$;function R(X){return 56320<=X&&X<=57343}e.isLowSurrogate=R;function M(X,oe){return(X-55296<<10)+(oe-56320)+65536}e.computeCodePoint=M;function W(X,oe,ue){const fe=X.charCodeAt(ue);if($(fe)&&ue+1<oe){const ye=X.charCodeAt(ue+1);if(R(ye))return M(fe,ye)}return fe}e.getNextCodePoint=W;function U(X,oe){const ue=X.charCodeAt(oe-1);if(R(ue)&&oe>1){const fe=X.charCodeAt(oe-2);if($(fe))return M(fe,ue)}return ue}function x(X,oe){const ue=ae.getInstance(),fe=oe,ye=X.length,pe=W(X,ye,oe);oe+=pe>=65536?2:1;let Ce=ue.getGraphemeBreakType(pe);for(;oe<ye;){const Pe=W(X,ye,oe),Re=ue.getGraphemeBreakType(Pe);if(ze(Ce,Re))break;oe+=Pe>=65536?2:1,Ce=Re}return oe-fe}e.nextCharLength=x;function ee(X,oe){const ue=ae.getInstance(),fe=oe,ye=U(X,oe);oe-=ye>=65536?2:1;let pe=ue.getGraphemeBreakType(ye);for(;oe>0;){const Ce=U(X,oe),Pe=ue.getGraphemeBreakType(Ce);if(ze(Pe,pe))break;oe-=Ce>=65536?2:1,pe=Pe}return fe-oe}e.prevCharLength=ee;function G(X,oe){const ue=ae.getInstance(),fe=X.length,ye=oe,pe=W(X,fe,oe),Ce=ue.getGraphemeBreakType(pe);oe+=pe>=65536?2:1;let Pe=Ce;for(;oe<fe;){const _e=W(X,fe,oe),qe=ue.getGraphemeBreakType(_e);if(ze(Pe,qe))break;oe+=_e>=65536?2:1,Pe=qe}const Re=oe;for(oe=ye,Pe=Ce;oe>0;){const _e=U(X,oe),qe=ue.getGraphemeBreakType(_e);if(ze(qe,Pe))break;oe-=_e>=65536?2:1,Pe=qe}return[oe,Re]}function q(X,oe){return oe>0&&R(X.charCodeAt(oe))?G(X,oe-1):G(X,oe)}e.getCharContainingOffset=q;const Y=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function H(X){return Y.test(X)}e.containsRTL=H;const Z=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function K(X){return Z.test(X)}e.containsEmoji=K;const F=/^[\t\n\r\x20-\x7E]*$/;function j(X){return F.test(X)}e.isBasicASCII=j,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function B(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=B;function z(X){for(let oe=0,ue=X.length;oe<ue;oe++)if(V(X.charCodeAt(oe)))return!0;return!1}e.containsFullWidthCharacter=z;function V(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=V;function te(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=te;function se(X,oe){if(X.length<oe)return X;const ue=/\b/g;let fe=0;for(;ue.test(X)&&!(X.length-ue.lastIndex<oe);)fe=ue.lastIndex,ue.lastIndex+=1;return X.substring(fe).replace(/^\s/,"")}e.lcut=se;const ce=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function ve(X){return X&&(X=X.replace(ce,""),X=X.replace(he,""),X=X.replace(me,"")),X}e.removeAnsiEscapeCodes=ve,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ge(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ge;function we(X){return ge(X)?X.substr(1):X}e.stripUTF8BOM=we;function De(X,oe){if(!X||!oe||X.length<oe.length)return!1;const ue=oe.length,fe=X.toLowerCase();let ye=0,pe=-1;for(;ye<ue;){const Ce=fe.indexOf(oe[ye],pe+1);if(Ce<0)return!1;pe=Ce,ye++}return!0}e.fuzzyContains=De;function Ee(X,oe=!1){return X?(oe&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=Ee;function ke(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=ke;function Le(X,oe=1){if(oe===0)return"";let ue=-1;do ue=X.indexOf(`
`,ue+1),oe--;while(oe>0&&ue>=0);return ue===-1?X:(X[ue-1]==="\r"&&ue--,X.substr(0,ue))}e.getNLines=Le;function Fe(X){const oe=90-65+1;return X=X%(2*oe),X<oe?String.fromCharCode(97+X):String.fromCharCode(65+X-oe)}e.singleLetterHash=Fe;function $e(X){return ae.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=$e;function ze(X,oe){return X===0?oe!==5&&oe!==7:X===2&&oe===3?!1:X===4||X===2||X===3||oe===4||oe===2||oe===3?!0:!(X===8&&(oe===8||oe===9||oe===11||oe===12)||(X===11||X===9)&&(oe===9||oe===10)||(X===12||X===10)&&oe===10||oe===5||oe===13||oe===7||X===1||X===13&&oe===14||X===6&&oe===6)}e.breakBetweenGraphemeBreakType=ze;var re;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=le()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const ue=this._data,fe=ue.length/3;let ye=1;for(;ye<=fe;)if(oe<ue[3*ye])ye=2*ye;else if(oe>ue[3*ye+1])ye=2*ye+1;else return ue[3*ye+2];return 0}}ae._INSTANCE=null;function le(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function be(X,oe){if(X===0)return 0;const ue=Ie(X,oe);if(ue!==void 0)return ue;const fe=U(oe,X);return X-=Me(fe),X}e.getLeftDeleteOffset=be;function Ie(X,oe){let ue=U(oe,X);for(X-=Me(ue);Te(ue)||ue===65039||ue===8419;){if(X===0)return;ue=U(oe,X),X-=Me(ue)}if(!!te(ue)){if(X>=0){const fe=U(oe,X);fe===8205&&(X-=Me(fe))}return X}}function Me(X){return X>=65536?2:1}function Te(X){return 127995<=X&&X<=127999}var Ne;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(Ne||(Ne={})),e.noBreakWhitespace="\xA0";class Ae{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!Ae.map){let fe=function(Ce){const Pe=new Map;for(let Re=0;Re<Ce.length;Re+=2)Pe.set(Ce[Re],Ce[Re+1]);return Pe};const oe=Ae.getData();let ue=L.locale;(!ue||!(ue in oe))&&(ue=L.language),(!ue||!(ue in oe))&&(ue="_default");const ye=fe(oe._common),pe=fe(oe[ue]);for(const[Ce,Pe]of pe)ye.set(Ce,Pe);Ae.map=ye}return Ae.map}static isAmbiguous(oe){return Ae.getConfusablesForCurrentLocale().has(oe)}static getPrimaryConfusable(oe){return Ae.getConfusablesForCurrentLocale().get(oe)}static getPrimaryConfusableCodePoints(){return new Set(Ae.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=Ae;class Ue{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ue.getRawData())),this._data}static isInvisibleCharacter(oe){return Ue.getData().has(oe)}static get codePoints(){return Ue.getData()}}e.InvisibleCharacters=Ue,Ue._data=void 0}),define(ne[103],ie([0,1,25]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(y){return k(y,0)}e.hash=i;function k(y,w){switch(typeof y){case"object":return y===null?_(349,w):Array.isArray(y)?C(y,w):b(y,w);case"string":return D(y,w);case"boolean":return T(y,w);case"number":return _(y,w);case"undefined":return _(937,w);default:return _(617,w)}}e.doHash=k;function _(y,w){return(w<<5)-w+y|0}e.numberHash=_;function T(y,w){return _(y?433:863,w)}function D(y,w){w=_(149417,w);for(let g=0,c=y.length;g<c;g++)w=_(y.charCodeAt(g),w);return w}e.stringHash=D;function C(y,w){return w=_(104579,w),y.reduce((g,c)=>k(c,g),w)}function b(y,w){return w=_(181387,w),Object.keys(y).sort().reduce((g,c)=>(g=D(c,g),k(y[c],g)),w)}class P{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=k(w,this._value),this._value}}e.Hasher=P;var E;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function f(y,w,g=32){const c=g-w,l=~((1<<c)-1);return(y<<w|(l&y)>>>c)>>>0}function p(y,w=0,g=y.byteLength,c=0){for(let l=0;l<g;l++)y[w+l]=c}function h(y,w,g="0"){for(;y.length<w;)y=g+y;return y}function S(y,w=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(g=>g.toString(16).padStart(2,"0")).join(""):h((y>>>0).toString(16),w/4)}e.toHexString=S;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const g=w.length;if(g===0)return;const c=this._buff;let l=this._buffLen,r=this._leftoverHighSurrogate,a,n;for(r!==0?(a=r,n=-1,r=0):(a=w.charCodeAt(0),n=0);;){let t=a;if(L.isHighSurrogate(a))if(n+1<g){const s=w.charCodeAt(n+1);L.isLowSurrogate(s)?(n++,t=L.computeCodePoint(a,s)):t=65533}else{r=a;break}else L.isLowSurrogate(a)&&(t=65533);if(l=this._push(c,l,t),n++,n<g)a=w.charCodeAt(n);else break}this._buffLen=l,this._leftoverHighSurrogate=r}_push(w,g,c){return c<128?w[g++]=c:c<2048?(w[g++]=192|(c&1984)>>>6,w[g++]=128|(c&63)>>>0):c<65536?(w[g++]=224|(c&61440)>>>12,w[g++]=128|(c&4032)>>>6,w[g++]=128|(c&63)>>>0):(w[g++]=240|(c&1835008)>>>18,w[g++]=128|(c&258048)>>>12,w[g++]=128|(c&4032)>>>6,w[g++]=128|(c&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=v._bigBlock32,g=this._buffDV;for(let u=0;u<64;u+=4)w.setUint32(u,g.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)w.setUint32(u,f(w.getUint32(u-12,!1)^w.getUint32(u-32,!1)^w.getUint32(u-56,!1)^w.getUint32(u-64,!1),1),!1);let c=this._h0,l=this._h1,r=this._h2,a=this._h3,n=this._h4,t,s,o;for(let u=0;u<80;u++)u<20?(t=l&r|~l&a,s=1518500249):u<40?(t=l^r^a,s=1859775393):u<60?(t=l&r|l&a|r&a,s=2400959708):(t=l^r^a,s=3395469782),o=f(c,5)+t+n+s+w.getUint32(u*4,!1)&4294967295,n=a,a=r,r=f(l,30),l=c,c=o;this._h0=this._h0+c&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var Ct=this&&this.__classPrivateFieldSet||function(Q,e,L,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(Q,L):k?k.value=L:e.set(Q,L),L},Ve=this&&this.__classPrivateFieldGet||function(Q,e,L,i){if(L==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!i:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return L==="m"?i:L==="a"?i.call(Q):i?i.value:e.get(Q)};define(ne[39],ie([0,1,17,25]),function(Q,e,L,i){"use strict";var k,_,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(n,t,s){let o=n.get(t);return o===void 0&&(o=s,n.set(t,o)),o}e.getOrSet=D;function C(n){const t=[];return n.forEach((s,o)=>{t.push(`${o} => ${s}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=C;function b(n){const t=[];return n.forEach(s=>{t.push(s)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=b;class P{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const s=t.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=P;class E{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class f{constructor(t=!0,s=!0){this._splitOnBackslash=t,this._caseSensitive=s}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let s=t.length-1;s>=0;s--,this._valueLen--){const o=this._value.charCodeAt(s);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var p;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(p||(p={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,i.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(v||(v={}));class y{constructor(t){this._iter=t}static forUris(t=()=>!1){return new y(new h(t))}static forPaths(){return new y(new f)}static forStrings(){return new y(new P)}static forConfigKeys(){return new y(new E)}clear(){this._root=void 0}fill(t,s){if(s){const o=s.slice(0);(0,L.shuffle)(o);for(let u of o)this.set(u,t)}else{const o=t.slice(0);(0,L.shuffle)(o);for(let u of o)this.set(u[0],u[1])}}set(t,s){const o=this._iter.reset(t);let u;this._root||(this._root=new S,this._root.segment=o.value());const d=[];for(u=this._root;;){const I=o.cmp(u.segment);if(I>0)u.left||(u.left=new S,u.left.segment=o.value()),d.push([-1,u]),u=u.left;else if(I<0)u.right||(u.right=new S,u.right.segment=o.value()),d.push([1,u]),u=u.right;else if(o.hasNext())o.next(),u.mid||(u.mid=new S,u.mid.segment=o.value()),d.push([0,u]),u=u.mid;else break}const m=u.value;u.value=s,u.key=t;for(let I=d.length-1;I>=0;I--){const A=d[I][1];A.updateHeight();const O=A.balanceFactor();if(O<-1||O>1){const N=d[I][0],$=d[I+1][0];if(N===1&&$===1)d[I][1]=A.rotateLeft();else if(N===-1&&$===-1)d[I][1]=A.rotateRight();else if(N===1&&$===-1)A.right=d[I+1][1]=d[I+1][1].rotateRight(),d[I][1]=A.rotateLeft();else if(N===-1&&$===1)A.left=d[I+1][1]=d[I+1][1].rotateLeft(),d[I][1]=A.rotateRight();else throw new Error;if(I>0)switch(d[I-1][0]){case-1:d[I-1][1].left=d[I][1];break;case 1:d[I-1][1].right=d[I][1];break;case 0:d[I-1][1].mid=d[I][1];break}else this._root=d[0][1]}}return m}get(t){return this._getNode(t)?.value}_getNode(t){const s=this._iter.reset(t);let o=this._root;for(;o;){const u=s.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(t){const s=this._getNode(t);return!(s?.value===void 0&&s?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,s){const o=this._iter.reset(t),u=[];let d=this._root;for(;d;){const m=o.cmp(d.segment);if(m>0)u.push([-1,d]),d=d.left;else if(m<0)u.push([1,d]),d=d.right;else if(o.hasNext())o.next(),u.push([0,d]),d=d.mid;else break}if(!!d){if(s?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const m=this._min(d.right),{key:I,value:A,segment:O}=m;this._delete(m.key,!1),d.key=I,d.value=A,d.segment=O}else{const m=d.left??d.right;if(u.length>0){const[I,A]=u[u.length-1];switch(I){case-1:A.left=m;break;case 0:A.mid=m;break;case 1:A.right=m;break}}else this._root=m}for(let m=u.length-1;m>=0;m--){const I=u[m][1];I.updateHeight();const A=I.balanceFactor();if(A>1?(I.right.balanceFactor()>=0||(I.right=I.right.rotateRight()),u[m][1]=I.rotateLeft()):A<-1&&(I.left.balanceFactor()<=0||(I.left=I.left.rotateLeft()),u[m][1]=I.rotateRight()),m>0)switch(u[m-1][0]){case-1:u[m-1][1].left=u[m][1];break;case 1:u[m-1][1].right=u[m][1];break;case 0:u[m-1][1].mid=u[m][1];break}else this._root=u[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const s=this._iter.reset(t);let o=this._root,u;for(;o;){const d=s.cmp(o.segment);if(d>0)o=o.left;else if(d<0)o=o.right;else if(s.hasNext())s.next(),u=o.value||u,o=o.mid;else break}return o&&o.value||u}findSuperstr(t){const s=this._iter.reset(t);let o=this._root;for(;o;){const u=s.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(t){for(const[s,o]of this)t(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=s=>{if(!s)return!0;const o=s.balanceFactor();return o<-1||o>1?!1:t(s.left)&&t(s.right)};return t(this._root)}}e.TernarySearchTree=y;class w{constructor(t,s){this.uri=t,this.value=s}}class g{constructor(t,s){this[k]="ResourceMap",t instanceof g?(this.map=new Map(t.map),this.toKey=s??g.defaultToKey):(this.map=new Map,this.toKey=t??g.defaultToKey)}set(t,s){return this.map.set(this.toKey(t),new w(t,s)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,s){typeof s!="undefined"&&(t=t.bind(s));for(let[o,u]of this.map)t(u.value,u.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=g,g.defaultToKey=n=>n.toString();var c;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class l{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,s=0){const o=this._map.get(t);if(!!o)return s!==0&&this.touch(o,s),o.value}set(t,s,o=0){let u=this._map.get(t);if(u)u.value=s,o!==0&&this.touch(u,o);else{switch(u={key:t,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(t,u),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this._map.get(t);if(!!s)return this._map.delete(t),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,s){const o=this._state;let u=this._head;for(;u;){if(s?t.bind(s)(u.value,u.key,this):t(u.value,u.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const t=this,s=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const d={value:o.key,done:!1};return o=o.next,d}else return{value:void 0,done:!0}}};return u}values(){const t=this,s=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const d={value:o.value,done:!1};return o=o.next,d}else return{value:void 0,done:!0}}};return u}entries(){const t=this,s=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const d={value:[o.key,o.value],done:!1};return o=o.next,d}else return{value:void 0,done:!0}}};return u}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>t;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const s=t.next,o=t.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}t.next=void 0,t.previous=void 0,this._state++}touch(t,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this._head)return;const o=t.next,u=t.previous;t===this._tail?(u.next=void 0,this._tail=u):(o.previous=u,u.next=o),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(s===2){if(t===this._tail)return;const o=t.next,u=t.previous;t===this._head?(o.previous=void 0,this._head=o):(o.previous=u,u.next=o),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((s,o)=>{t.push([o,s])}),t}fromJSON(t){this.clear();for(const[s,o]of t)this.set(s,o)}}e.LinkedMap=l;class r extends l{constructor(t,s=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class a{constructor(t){T.set(this,void 0),Ct(this,T,t,"f")}get size(){return Ve(this,T,"f").size}forEach(t,s){Ve(this,T,"f").forEach(t,s)}get(t){return Ve(this,T,"f").get(t)}has(t){return Ve(this,T,"f").has(t)}entries(){return Ve(this,T,"f").entries()}keys(){return Ve(this,T,"f").keys()}values(){return Ve(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return Ve(this,T,"f").entries()}}e.ReadonlyMapView=a}),define(ne[69],ie([0,1,39]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new L.LRUCache(1e4);function k(b){return C(b,"NFC",i)}e.normalizeNFC=k;const _=new L.LRUCache(1e4);function T(b){return C(b,"NFD",_)}e.normalizeNFD=T;const D=/[^\u0000-\u0080]/;function C(b,P,E){if(!b)return b;const f=E.get(b);if(f)return f;let p;return D.test(b)?p=b.normalize(P):p=b,E.set(b,p),p}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(P){return T(P).replace(b,"")}}()}),define(ne[15],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function L(d){return Array.isArray(d)}e.isArray=L;function i(d){return typeof d=="string"}e.isString=i;function k(d){return Array.isArray(d)&&d.every(m=>i(m))}e.isStringArray=k;function _(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=_;function T(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=T;function D(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=D;function C(d){return d===!0||d===!1}e.isBoolean=C;function b(d){return typeof d=="undefined"}e.isUndefined=b;function P(d){return!E(d)}e.isDefined=P;function E(d){return b(d)||d===null}e.isUndefinedOrNull=E;function f(d,m){if(!d)throw new Error(m?`Unexpected type, expected '${m}'`:"Unexpected type")}e.assertType=f;function p(d){if(E(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=p;function h(...d){const m=[];for(let I=0;I<d.length;I++){const A=d[I];if(E(A))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);m.push(A)}return m}e.assertAllDefined=h;const S=Object.prototype.hasOwnProperty;function v(d){if(!_(d))return!1;for(let m in d)if(S.call(d,m))return!1;return!0}e.isEmptyObject=v;function y(d){return typeof d=="function"}e.isFunction=y;function w(...d){return d.length>0&&d.every(y)}e.areFunctions=w;function g(d,m){const I=Math.min(d.length,m.length);for(let A=0;A<I;A++)c(d[A],m[A])}e.validateConstraints=g;function c(d,m){if(i(m)){if(typeof d!==m)throw new Error(`argument does not match constraint: typeof ${m}`)}else if(y(m)){try{if(d instanceof m)return}catch{}if(!E(d)&&d.constructor===m||m.length===1&&m.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function l(d){let m=[],I=Object.getPrototypeOf(d);for(;Object.prototype!==I;)m=m.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return m}e.getAllPropertyNames=l;function r(d){const m=[];for(const I of l(d))typeof d[I]=="function"&&m.push(I);return m}e.getAllMethodNames=r;function a(d,m){const I=O=>function(){const N=Array.prototype.slice.call(arguments,0);return m(O,N)};let A={};for(const O of d)A[O]=I(O);return A}e.createProxyObject=a;function n(d){return d===null?void 0:d}e.withNullAsUndefined=n;function t(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=t;function s(d){return class{constructor(){return new Proxy({},{get(m,I){if(m[I])return m[I];throw new Error(`Not Implemented: ${d}->${String(I)}`)}})}}}e.NotImplementedProxy=s;function o(d,m="Unreachable"){throw new Error(m)}e.assertNever=o;function u(d){return!!d&&typeof d.then=="function"&&typeof d.catch=="function"}e.isPromise=u}),define(ne[41],ie([0,1,9,4,25,15]),function(Q,e,L,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(s){return s===47||s===92}e.isPathSeparator=T;function D(s){return s.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=D;function C(s){return s.indexOf("/")===-1&&(s=D(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=C;function b(s,o=L.posix.sep){if(!s)return"";const u=s.length,d=s.charCodeAt(0);if(T(d)){if(T(s.charCodeAt(1))&&!T(s.charCodeAt(2))){let I=3;const A=I;for(;I<u&&!T(s.charCodeAt(I));I++);if(A!==I&&!T(s.charCodeAt(I+1))){for(I+=1;I<u;I++)if(T(s.charCodeAt(I)))return s.slice(0,I+1).replace(/[\\/]/g,o)}}return o}else if(y(d)&&s.charCodeAt(1)===58)return T(s.charCodeAt(2))?s.slice(0,2)+o:s.slice(0,2);let m=s.indexOf("://");if(m!==-1){for(m+=3;m<u;m++)if(T(s.charCodeAt(m)))return s.slice(0,m+1)}return""}e.getRoot=b;function P(s){if(!i.isWindows||!s||s.length<5)return!1;let o=s.charCodeAt(0);if(o!==92||(o=s.charCodeAt(1),o!==92))return!1;let u=2;const d=u;for(;u<s.length&&(o=s.charCodeAt(u),o!==92);u++);return!(d===u||(o=s.charCodeAt(u+1),isNaN(o)||o===92))}e.isUNC=P;const E=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(s,o=i.isWindows){const u=o?E:f;return!(!s||s.length===0||/^\s+$/.test(s)||(u.lastIndex=0,u.test(s))||o&&p.test(s)||s==="."||s===".."||o&&s[s.length-1]==="."||o&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=h;function S(s,o,u){const d=s===o;return!u||d?d:!s||!o?!1:(0,k.equalsIgnoreCase)(s,o)}e.isEqual=S;function v(s,o,u,d=L.sep){if(s===o)return!0;if(!s||!o||o.length>s.length)return!1;if(u){if(!(0,k.startsWithIgnoreCase)(s,o))return!1;if(o.length===s.length)return!0;let I=o.length;return o.charAt(o.length-1)===d&&I--,s.charAt(I)===d}return o.charAt(o.length-1)!==d&&(o+=d),s.indexOf(o)===0}e.isEqualOrParent=v;function y(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=y;function w(s,o){return i.isWindows&&s.endsWith(":")&&(s+=L.sep),(0,L.isAbsolute)(s)||(s=(0,L.join)(o,s)),s=(0,L.normalize)(s),i.isWindows?(s=(0,k.rtrim)(s,L.sep),s.endsWith(":")&&(s+=L.sep)):(s=(0,k.rtrim)(s,L.sep),s||(s=L.sep)),s}e.sanitizeFilePath=w;function g(s){const o=(0,L.normalize)(s);return i.isWindows?s.length>3?!1:c(o)&&(s.length===2||o.charCodeAt(2)===92):o===L.posix.sep}e.isRootOrDriveLetter=g;function c(s,o){return(o!==void 0?o:i.isWindows)?y(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function l(s){return c(s)?s[0]:void 0}e.getDriveLetter=l;function r(s,o,u){return o.length>s.length?-1:s===o?0:(u&&(s=s.toLowerCase(),o=o.toLowerCase()),s.indexOf(o))}e.indexOfPath=r;function a(s){const o=s.split(":");let u,d,m;if(o.forEach(I=>{const A=Number(I);(0,_.isNumber)(A)?d===void 0?d=A:m===void 0&&(m=A):u=u?[u,I].join(":"):I}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:d!==void 0?d:void 0,column:m!==void 0?m:d!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(s,o,u=8){let d="";for(let I=0;I<u;I++)d+=n.charAt(Math.floor(Math.random()*n.length));let m;return o?m=`${o}-${d}`:m=d,s?(0,L.join)(s,m):m}e.randomPath=t}),define(ne[28],ie([0,1,15]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(S){if(!S||typeof S!="object"||S instanceof RegExp)return S;const v=Array.isArray(S)?[]:{};return Object.keys(S).forEach(y=>{S[y]&&typeof S[y]=="object"?v[y]=i(S[y]):v[y]=S[y]}),v}e.deepClone=i;function k(S){if(!S||typeof S!="object")return S;const v=[S];for(;v.length>0;){const y=v.shift();Object.freeze(y);for(const w in y)if(_.call(y,w)){const g=y[w];typeof g=="object"&&!Object.isFrozen(g)&&v.push(g)}}return S}e.deepFreeze=k;const _=Object.prototype.hasOwnProperty;function T(S,v){return D(S,v,new Set)}e.cloneAndChange=T;function D(S,v,y){if((0,L.isUndefinedOrNull)(S))return S;const w=v(S);if(typeof w!="undefined")return w;if((0,L.isArray)(S)){const g=[];for(const c of S)g.push(D(c,v,y));return g}if((0,L.isObject)(S)){if(y.has(S))throw new Error("Cannot clone recursive data-structure");y.add(S);const g={};for(let c in S)_.call(S,c)&&(g[c]=D(S[c],v,y));return y.delete(S),g}return S}function C(S,v,y=!0){return(0,L.isObject)(S)?((0,L.isObject)(v)&&Object.keys(v).forEach(w=>{w in S?y&&((0,L.isObject)(S[w])&&(0,L.isObject)(v[w])?C(S[w],v[w],y):S[w]=v[w]):S[w]=v[w]}),S):v}e.mixin=C;function b(S,v){if(S===v)return!0;if(S==null||v===null||v===void 0||typeof S!=typeof v||typeof S!="object"||Array.isArray(S)!==Array.isArray(v))return!1;let y,w;if(Array.isArray(S)){if(S.length!==v.length)return!1;for(y=0;y<S.length;y++)if(!b(S[y],v[y]))return!1}else{const g=[];for(w in S)g.push(w);g.sort();const c=[];for(w in v)c.push(w);if(c.sort(),!b(g,c))return!1;for(y=0;y<g.length;y++)if(!b(S[g[y]],v[g[y]]))return!1}return!0}e.equals=b;function P(S){const v=new Set;return JSON.stringify(S,(y,w)=>{if((0,L.isObject)(w)||Array.isArray(w)){if(v.has(w))return"[Circular]";v.add(w)}return w})}e.safeStringify=P;function E(S,v,y){const w=v(S);return typeof w=="undefined"?y:w}e.getOrDefault=E;function f(S,v){const y=Object.create(null);return!S||!v||Object.keys(v).forEach(g=>{const c=S[g],l=v[g];b(c,l)||(y[g]=l)}),y}e.distinct=f;function p(S,v){const y=v.toLowerCase(),w=Object.keys(S).find(g=>g.toLowerCase()===y);return w?S[w]:S[v]}e.getCaseInsensitive=p;function h(S,v){const y=Object.create(null);for(const[w,g]of Object.entries(S))v(w,g)&&(y[w]=g);return y}e.filter=h}),define(ne[7],ie([0,1,9,4]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,_=/^\//,T=/^\/\//;function D(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!k.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!_.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(n,t){return!n&&!t?"file":n}function b(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==E&&(t=E+t):t=E;break}return t}const P="",E="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(t,s,o,u,d,m=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=C(t,m),this.authority=s||P,this.path=b(this.scheme,o||P),this.query=u||P,this.fragment=d||P,D(this,m))}static isUri(t){return t instanceof p?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return g(this,!1)}with(t){if(!t)return this;let{scheme:s,authority:o,path:u,query:d,fragment:m}=t;return s===void 0?s=this.scheme:s===null&&(s=P),o===void 0?o=this.authority:o===null&&(o=P),u===void 0?u=this.path:u===null&&(u=P),d===void 0?d=this.query:d===null&&(d=P),m===void 0?m=this.fragment:m===null&&(m=P),s===this.scheme&&o===this.authority&&u===this.path&&d===this.query&&m===this.fragment?this:new S(s,o,u,d,m)}static parse(t,s=!1){const o=f.exec(t);return o?new S(o[2]||P,a(o[4]||P),a(o[5]||P),a(o[7]||P),a(o[9]||P),s):new S(P,P,P,P,P)}static file(t){let s=P;if(i.isWindows&&(t=t.replace(/\\/g,E)),t[0]===E&&t[1]===E){const o=t.indexOf(E,2);o===-1?(s=t.substring(2),t=E):(s=t.substring(2,o),t=t.substring(o)||E)}return new S("file",s,t,P,P)}static from(t){const s=new S(t.scheme,t.authority,t.path,t.query,t.fragment);return D(s,!0),s}static joinPath(t,...s){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return i.isWindows&&t.scheme==="file"?o=p.file(L.win32.join(g(t,!0),...s)).path:o=L.posix.join(t.path,...s),t.with({path:o})}toString(t=!1){return c(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof p)return t;{const s=new S(t);return s._formatted=t.external,s._fsPath=t._sep===h?t.fsPath:null,s}}else return t}}e.URI=p;const h=i.isWindows?1:void 0;class S extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(t=!1){return t?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function y(n,t){let s,o=-1;for(let u=0;u<n.length;u++){const d=n.charCodeAt(u);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||t&&d===47)o!==-1&&(s+=encodeURIComponent(n.substring(o,u)),o=-1),s!==void 0&&(s+=n.charAt(u));else{s===void 0&&(s=n.substr(0,u));const m=v[d];m!==void 0?(o!==-1&&(s+=encodeURIComponent(n.substring(o,u)),o=-1),s+=m):o===-1&&(o=u)}}return o!==-1&&(s+=encodeURIComponent(n.substring(o))),s!==void 0?s:n}function w(n){let t;for(let s=0;s<n.length;s++){const o=n.charCodeAt(s);o===35||o===63?(t===void 0&&(t=n.substr(0,s)),t+=v[o]):t!==void 0&&(t+=n[s])}return t!==void 0?t:n}function g(n,t){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,i.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=g;function c(n,t){const s=t?w:y;let o="",{scheme:u,authority:d,path:m,query:I,fragment:A}=n;if(u&&(o+=u,o+=":"),(d||u==="file")&&(o+=E,o+=E),d){let O=d.indexOf("@");if(O!==-1){const N=d.substr(0,O);d=d.substr(O+1),O=N.indexOf(":"),O===-1?o+=s(N,!1):(o+=s(N.substr(0,O),!1),o+=":",o+=s(N.substr(O+1),!1)),o+="@"}d=d.toLowerCase(),O=d.indexOf(":"),O===-1?o+=s(d,!1):(o+=s(d.substr(0,O),!1),o+=d.substr(O))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const O=m.charCodeAt(1);O>=65&&O<=90&&(m=`/${String.fromCharCode(O+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const O=m.charCodeAt(0);O>=65&&O<=90&&(m=`${String.fromCharCode(O+32)}:${m.substr(2)}`)}o+=s(m,!0)}return I&&(o+="?",o+=s(I,!1)),A&&(o+="#",o+=t?A:y(A,!1)),o}function l(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+l(n.substr(3)):n}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(n){return n.match(r)?n.replace(r,t=>l(t)):n}}),define(ne[104],ie([0,1,7]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function i(b){const P=b;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=i;function k(b){const P=[];let E;try{const f=JSON.parse(b.arguments),p=f[f.length-1];p&&p.__$stack&&(f.pop(),E=p.__$stack),P.push(...f)}catch{P.push("Unable to log remote console arguments",b.arguments)}return{args:P,stack:E}}e.parse=k;function _(b){if(typeof b!="string")return _(k(b).stack);const P=b;if(P){const E=T(P),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(f&&f.length===4)return{uri:L.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.getFirstFrame=_;function T(b){if(!b)return b;const P=b.indexOf(`
`);return P===-1?b:b.substring(0,P)}function D(b,P){const{args:E,stack:f}=k(b),p=typeof E[0]=="string"&&E.length===1;let h=T(f);h&&(h=`(${h.trim()})`);let S=[];if(typeof E[0]=="string"?h&&p?S=[`%c[${P}] %c${E[0]} %c${h}`,C("blue"),C(""),C("grey")]:S=[`%c[${P}] %c${E[0]}`,C("blue"),C(""),...E.slice(1)]:S=[`%c[${P}]%`,C("blue"),...E],h&&!p&&S.push(h),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,S)}e.log=D;function C(b){return`color: ${b}`}}),define(ne[105],ie([0,1,18,25,7]),function(Q,e,L,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function _(P){return JSON.stringify(P,C)}e.stringify=_;function T(P){let E=JSON.parse(P);return E=b(E),E}e.parse=T;var D;(function(P){P[P.Uri=1]="Uri",P[P.Regexp=2]="Regexp",P[P.ScmResource=3]="ScmResource",P[P.ScmResourceGroup=4]="ScmResourceGroup",P[P.ScmProvider=5]="ScmProvider",P[P.CommentController=6]="CommentController",P[P.CommentThread=7]="CommentThread",P[P.CommentThreadReply=8]="CommentThreadReply",P[P.CommentNode=9]="CommentNode",P[P.CommentThreadNode=10]="CommentThreadNode",P[P.TimelineActionContext=11]="TimelineActionContext",P[P.NotebookCellActionContext=12]="NotebookCellActionContext",P[P.TestItemContext=13]="TestItemContext"})(D=e.MarshalledId||(e.MarshalledId={}));function C(P,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,i.regExpFlags)(E)}:E}function b(P,E=0){if(!P||E>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return k.URI.revive(P);case 2:return new RegExp(P.source,P.flags)}if(P instanceof L.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let f=0;f<P.length;++f)P[f]=b(P[f],E+1);else for(const f in P)Object.hasOwnProperty.call(P,f)&&(P[f]=b(P[f],E+1))}return P}e.revive=b}),define(ne[16],ie([0,1,4,7]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp",D.vsls="vsls"})(k=e.Schemas||(e.Schemas={}));class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,b,P){this._hosts[C]=b,this._ports[C]=P}setConnectionToken(C,b){this._connectionTokens[C]=b}rewrite(C){if(this._delegate)return this._delegate(C);const b=C.authority;let P=this._hosts[b];P&&P.indexOf(":")!==-1&&(P=`[${P}]`);const E=this._ports[b],f=this._connectionTokens[b];let p=`path=${encodeURIComponent(C.path)}`;return typeof f=="string"&&(p+=`&tkn=${encodeURIComponent(f)}`),i.URI.from({scheme:L.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${P}:${E}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new _;class T{asBrowserUri(C,b){const P=this.toUri(C,b);return P.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===k.file&&(L.isNative||typeof L.globals.importScripts=="function"&&L.globals.origin===`${k.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?P.with({scheme:k.vscodeFileResource,authority:P.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(C,b){const P=this.toUri(C,b);return P.scheme===k.vscodeFileResource?P.with({scheme:k.file,authority:P.authority!==T.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(C,b){return i.URI.isUri(C)?C:i.URI.parse(b.toUrl(C))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(ne[19],ie([0,1,41,16,9,4,25,7]),function(Q,e,L,i,k,_,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(p){return(0,D.uriToFsPath)(p,!0)}e.originalFSPath=C;class b{constructor(h){this._ignorePathCasing=h}compare(h,S,v=!1){return h===S?0:(0,T.compare)(this.getComparisonKey(h,v),this.getComparisonKey(S,v))}isEqual(h,S,v=!1){return h===S?!0:!h||!S?!1:this.getComparisonKey(h,v)===this.getComparisonKey(S,v)}getComparisonKey(h,S=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,S,v=!1){if(h.scheme===S.scheme){if(h.scheme===i.Schemas.file)return L.isEqualOrParent(C(h),C(S),this._ignorePathCasing(h))&&h.query===S.query&&(v||h.fragment===S.fragment);if((0,e.isEqualAuthority)(h.authority,S.authority))return L.isEqualOrParent(h.path,S.path,this._ignorePathCasing(h),"/")&&h.query===S.query&&(v||h.fragment===S.fragment)}return!1}joinPath(h,...S){return D.URI.joinPath(h,...S)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return k.posix.basename(h.path)}extname(h){return k.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let S;return h.scheme===i.Schemas.file?S=D.URI.file(k.dirname(C(h))).path:(S=k.posix.dirname(h.path),h.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),S="/")),h.with({path:S})}normalizePath(h){if(!h.path.length)return h;let S;return h.scheme===i.Schemas.file?S=D.URI.file(k.normalize(C(h))).path:S=k.posix.normalize(h.path),h.with({path:S})}relativePath(h,S){if(h.scheme!==S.scheme||!(0,e.isEqualAuthority)(h.authority,S.authority))return;if(h.scheme===i.Schemas.file){const w=k.relative(C(h),C(S));return _.isWindows?L.toSlashes(w):w}let v=h.path||"/",y=S.path||"/";if(this._ignorePathCasing(h)){let w=0;for(const g=Math.min(v.length,y.length);w<g&&!(v.charCodeAt(w)!==y.charCodeAt(w)&&v.charAt(w).toLowerCase()!==y.charAt(w).toLowerCase());w++);v=y.substr(0,w)+v.substr(w)}return k.posix.relative(v,y)}resolvePath(h,S){if(h.scheme===i.Schemas.file){const v=D.URI.file(k.resolve(C(h),S));return h.with({authority:v.authority,path:v.path})}return S=L.toPosixPath(S),h.with({path:k.posix.resolve(h.path,S)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,S){return h===S||h!==void 0&&S!==void 0&&(0,T.equalsIgnoreCase)(h,S)}hasTrailingPathSeparator(h,S=k.sep){if(h.scheme===i.Schemas.file){const v=C(h);return v.length>L.getRoot(v).length&&v[v.length-1]===S}else{const v=h.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,S=k.sep){return(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,S=k.sep){let v=!1;if(h.scheme===i.Schemas.file){const y=C(h);v=y!==void 0&&y.length===L.getRoot(y).length&&y[y.length-1]===S}else{S="/";const y=h.path;v=y.length===1&&y.charCodeAt(y.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path+"/"}):h}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(p=>p.scheme===i.Schemas.file?!_.isLinux:!0),e.extUriIgnorePathCase=new b(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(p,h){const S=[];for(let v=0;v<p.length;v++){const y=h(p[v]);p.some((w,g)=>g===v?!1:(0,e.isEqualOrParent)(y,h(w)))||S.push(p[v])}return S}e.distinctParents=P;var E;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function h(S){const v=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(g=>{const[c,l]=g.split(":");c&&l&&v.set(c,l)});const w=S.path.substring(0,S.path.indexOf(";"));return w&&v.set(p.META_DATA_MIME,w),v}p.parseMetaData=h})(E=e.DataUri||(e.DataUri={}));function f(p,h,S){if(h){let v=p.path;return v&&v[0]!==k.posix.sep&&(v=k.posix.sep+v),p.with({scheme:S,authority:h,path:v})}return p.with({scheme:S})}e.toLocalResource=f}),define(ne[5],ie([0,1,27,8,3,2,19,4]),function(Q,e,L,i,k,_,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(K){return!!K&&typeof K.then=="function"}e.isThenable=C;function b(K){const F=new L.CancellationTokenSource,j=K(F.token),B=new Promise((z,V)=>{const te=F.token.onCancellationRequested(()=>{te.dispose(),F.dispose(),V((0,i.canceled)())});Promise.resolve(j).then(se=>{te.dispose(),F.dispose(),z(se)},se=>{te.dispose(),F.dispose(),V(se)})});return new class{cancel(){F.cancel()}then(z,V){return B.then(z,V)}catch(z){return this.then(void 0,z)}finally(z){return B.finally(z)}}}e.createCancelablePromise=b;function P(K,F,j){return Promise.race([K,new Promise(B=>F.onCancellationRequested(()=>B(j)))])}e.raceCancellation=P;async function E(K){let F=-1;const j=K.map((z,V)=>z.then(te=>(F=V,te))),B=await Promise.race(j);return K.forEach((z,V)=>{V!==F&&z.cancel()}),B}e.raceCancellablePromises=E;function f(K,F,j){let B;const z=setTimeout(()=>{B?.(void 0),j?.()},F);return Promise.race([K.finally(()=>clearTimeout(z)),new Promise(V=>B=V)])}e.raceTimeout=f;function p(K){return new Promise((F,j)=>{const B=K();C(B)?B.then(F,j):F(B)})}e.asPromise=p;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const j=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(j,j).then(B)})}return new Promise((j,B)=>{this.queuedPromise.then(j,B)})}return this.activePromise=F(),new Promise((j,B)=>{this.activePromise.then(z=>{this.activePromise=null,j(z)},z=>{this.activePromise=null,B(z)})})}}e.Throttler=h;class S{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=S;class v{constructor(){this.promiseMap=new Map}queue(F,j){const z=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(j).finally(()=>{this.promiseMap.get(F)===z&&this.promiseMap.delete(F)});return this.promiseMap.set(F,z),z}}e.SequencerByKey=v;const y=(K,F)=>{let j=!0;const B=setTimeout(()=>{j=!1,F()},K);return{isTriggered:()=>j,dispose:()=>{clearTimeout(B),j=!1}}},w=K=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,K())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class g{constructor(F){this.defaultDelay=F,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,j=this.defaultDelay){this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((z,V)=>{this.doResolve=z,this.doReject=V}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const z=this.task;return this.task=null,z()}}));const B=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=j===e.MicrotaskDelay?w(B):y(j,B),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,i.canceled)()),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=g;class c{constructor(F){this.delayer=new g(F),this.throttler=new h}trigger(F,j){return this.delayer.trigger(()=>this.throttler.queue(F),j)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class l{constructor(){this._isOpen=!1,this._promise=new Promise((F,j)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class r extends l{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function a(K,F){return F?new Promise((j,B)=>{const z=setTimeout(()=>{V.dispose(),j()},K),V=F.onCancellationRequested(()=>{clearTimeout(z),V.dispose(),B((0,i.canceled)())})}):b(j=>a(K,j))}e.timeout=a;function n(K,F=0){const j=setTimeout(K,F);return(0,_.toDisposable)(()=>clearTimeout(j))}e.disposableTimeout=n;function t(K){const F=[];let j=0;const B=K.length;function z(){return j<B?K[j++]():null}function V(te){te!=null&&F.push(te);const se=z();return se?se.then(V):Promise.resolve(F)}return Promise.resolve(null).then(V)}e.sequence=t;function s(K,F=B=>!!B,j=null){let B=0;const z=K.length,V=()=>{if(B>=z)return Promise.resolve(j);const te=K[B++];return Promise.resolve(te()).then(ce=>F(ce)?Promise.resolve(ce):V())};return V()}e.first=s;function o(K,F=B=>!!B,j=null){if(K.length===0)return Promise.resolve(j);let B=K.length;const z=()=>{B=-1;for(const V of K)V.cancel?.()};return new Promise((V,te)=>{for(const se of K)se.then(ce=>{--B>=0&&F(ce)?(z(),V(ce)):B===0&&V(j)}).catch(ce=>{--B>=0&&(z(),te(ce))})})}e.firstParallel=o;class u{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((j,B)=>{this.outstandingPromises.push({factory:F,c:j,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const j=F.factory();j.then(F.c,F.e),j.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=u;class d extends u{constructor(){super(1)}}e.Queue=d;class m{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const F=new ee;return this.drainers.add(F),F.p}isDrained(){for(const[,F]of this.queues)if(F.size>0)return!1;return!0}queueFor(F,j=T.extUri){const B=j.getComparisonKey(F);let z=this.queues.get(B);return z||(z=new d,k.Event.once(z.onFinished)(()=>{z?.dispose(),this.queues.delete(B),this.onDidQueueFinish()}),this.queues.set(B,z)),z}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const F of this.drainers)F.complete();this.drainers.clear()}dispose(){for(const[,F]of this.queues)F.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=m;class I{constructor(F,j){this._token=-1,typeof F=="function"&&typeof j=="number"&&this.setIfNotSet(F,j)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,j){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},j)}setIfNotSet(F,j){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},j))}}e.TimeoutTimer=I;class A{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,j){this.cancel(),this._token=setInterval(()=>{F()},j)}}e.IntervalTimer=A;class O{constructor(F,j){this.timeoutToken=-1,this.runner=F,this.timeout=j,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=O;class N{constructor(F,j){j%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.runner=F,this.timeout=j,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(F=this.timeout){F%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(F/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=N;class $ extends O{constructor(F,j){super(F,j);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=$;class R extends _.Disposable{constructor(F,j,B,z){super();this.maxWorkChunkSize=F,this.maxPendingWork=j,this.throttleDelay=B,this.handler=z,this.pendingWork=[],this.throttler=this._register(new _.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.maxPendingWork)return!1}else if(this.pending+F.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new O(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=R,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=K=>{(0,D.setTimeout0)(()=>{if(F)return;const j=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,j-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.runWhenIdle=(K,F)=>{const j=requestIdleCallback(K,typeof F=="number"?{timeout:F}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(j))}}}}();class M{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(j){this._error=j}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=M;async function W(K,F,j){let B;for(let z=0;z<j;z++)try{return await K()}catch(V){B=V,await a(F)}throw B}e.retry=W;class U{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,j,B){return this._pending={taskId:F,cancel:()=>B?.(),promise:j},j.then(()=>this.donePending(F),()=>this.donePending(F)),j}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let j,B;const z=new Promise((V,te)=>{j=V,B=te});this._next={run:F,promise:z,promiseResolve:j,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=U;class x{constructor(F,j=()=>Date.now()){this.interval=F,this.nowFn=j,this.lastIncrementTime=0,this.value=0}increment(){const F=this.nowFn();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class ee{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,j)=>{this.completeCallback=F,this.errorCallback=j})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(j=>{this.completeCallback(F),this.resolved=!0,j()})}error(F){return new Promise(j=>{this.errorCallback(F),this.rejected=!0,j()})}cancel(){new Promise(F=>{this.errorCallback((0,i.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=ee;var G;(function(K){async function F(B){let z;const V=await Promise.all(B.map(te=>te.then(se=>se,se=>{z||(z=se)})));if(typeof z!="undefined")throw z;return V}K.settled=F;function j(B){return new Promise(async(z,V)=>{try{await B(z,V)}catch(te){V(te)}})}K.withAsyncBody=j})(G=e.Promises||(e.Promises={}));var q;(function(K){K[K.Initial=0]="Initial",K[K.DoneOK=1]="DoneOK",K[K.DoneError=2]="DoneError"})(q||(q={}));class Y{constructor(F){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const j={emitOne:B=>this.emitOne(B),emitMany:B=>this.emitMany(B),reject:B=>this.reject(B)};try{await Promise.resolve(F(j)),this.resolve()}catch(B){this.reject(B)}finally{j.emitOne=void 0,j.emitMany=void 0,j.reject=void 0}})}static fromArray(F){return new Y(j=>{j.emitMany(F)})}static fromPromise(F){return new Y(async j=>{j.emitMany(await F)})}static fromPromises(F){return new Y(async j=>{await Promise.all(F.map(async B=>j.emitOne(await B)))})}static merge(F){return new Y(async j=>{await Promise.all(F.map(async B=>{for await(const z of B)j.emitOne(z)}))})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(F<this._results.length)return{done:!1,value:this._results[F++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(F,j){return new Y(async B=>{for await(const z of F)B.emitOne(j(z))})}map(F){return Y.map(this,F)}static filter(F,j){return new Y(async B=>{for await(const z of F)j(z)&&B.emitOne(z)})}filter(F){return Y.filter(this,F)}static coalesce(F){return Y.filter(F,j=>!!j)}coalesce(){return Y.coalesce(this)}static async toPromise(F){const j=[];for await(const B of F)j.push(B);return j}toPromise(){return Y.toPromise(this)}emitOne(F){this._state===0&&(this._results.push(F),this._onStateChanged.fire())}emitMany(F){this._state===0&&(this._results=this._results.concat(F),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(F){this._state===0&&(this._state=2,this._error=F,this._onStateChanged.fire())}}e.AsyncIterableObject=Y,Y.EMPTY=Y.fromArray([]);class H extends Y{constructor(F,j){super(j);this._source=F}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=H;function Z(K){const F=new L.CancellationTokenSource,j=K(F.token);return new H(F,async B=>{const z=F.token.onCancellationRequested(()=>{z.dispose(),F.dispose(),B.reject((0,i.canceled)())});try{for await(const V of j){if(F.token.isCancellationRequested)return;B.emitOne(V)}z.dispose(),F.dispose()}catch(V){z.dispose(),F.dispose(),B.reject(V)}})}e.createCancelableAsyncIterable=Z}),define(ne[106],ie([0,1,5,41,39,9,25]),function(Q,e,L,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const C="**",b="/",P="[/\\\\]",E="[^/\\\\]",f=/\//g;function p(q){switch(q){case 0:return"";case 1:return`${E}*?`;default:return`(?:${P}|${E}+${P}|${P}${E}+)*?`}}function h(q,Y){if(!q)return[];const H=[];let Z=!1,K=!1,F="";for(const j of q){switch(j){case Y:if(!Z&&!K){H.push(F),F="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":K=!0;break;case"]":K=!1;break}F+=j}return F&&H.push(F),H}e.splitGlobAware=h;function S(q){if(!q)return"";let Y="";const H=h(q,b);if(H.every(Z=>Z===C))Y=".*";else{let Z=!1;H.forEach((K,F)=>{if(K===C){Z||(Y+=p(2),Z=!0);return}let j=!1,B="",z=!1,V="";for(const te of K){if(te!=="}"&&j){B+=te;continue}if(z&&(te!=="]"||!V)){let se;te==="-"?se=te:(te==="^"||te==="!")&&!V?se="^":te===b?se="":se=T.escapeRegExpCharacters(te),V+=se;continue}switch(te){case"{":j=!0;continue;case"[":z=!0;continue;case"}":{Y+=`(?:${h(B,",").map(he=>S(he)).join("|")})`,j=!1,B="";break}case"]":Y+="["+V+"]",z=!1,V="";break;case"?":Y+=E;continue;case"*":Y+=p(1);continue;default:Y+=T.escapeRegExpCharacters(te)}}F<H.length-1&&(H[F+1]!==C||F+2<H.length)&&(Y+=P),Z=!1})}return Y}const v=/^\*\*\/\*\.[\w\.-]+$/,y=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,g=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new k.LRUCache(1e4),a=function(){return!1},n=function(){return null};function t(q,Y){if(!q)return n;let H;typeof q!="string"?H=q.pattern:H=q,H=H.trim();const Z=`${H}_${!!Y.trimForExclusions}`;let K=r.get(Z);if(K)return s(K,q);let F;if(v.test(H)){const j=H.substr(4);K=function(B,z){return typeof B=="string"&&B.endsWith(j)?H:null}}else(F=y.exec(o(H,Y)))?K=u(F[1],H):(Y.trimForExclusions?g:w).test(H)?K=d(H,Y):(F=c.exec(o(H,Y)))?K=m(F[1].substr(1),H,!0):(F=l.exec(o(H,Y)))?K=m(F[1],H,!1):K=I(H);return r.set(Z,K),s(K,q)}function s(q,Y){return typeof Y=="string"?q:function(H,Z){return i.isEqualOrParent(H,Y.base)?q(_.relative(Y.base,H),Z):null}}function o(q,Y){return Y.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function u(q,Y){const H=`/${q}`,Z=`\\${q}`,K=function(j,B){return typeof j!="string"?null:B?B===q?Y:null:j===q||j.endsWith(H)||j.endsWith(Z)?Y:null},F=[q];return K.basenames=F,K.patterns=[Y],K.allBasenames=F,K}function d(q,Y){const H=G(q.slice(1,-1).split(",").map(B=>t(B,Y)).filter(B=>B!==n),q),Z=H.length;if(!Z)return n;if(Z===1)return H[0];const K=function(B,z){for(let V=0,te=H.length;V<te;V++)if(H[V](B,z))return q;return null},F=H.find(B=>!!B.allBasenames);F&&(K.allBasenames=F.allBasenames);const j=H.reduce((B,z)=>z.allPaths?B.concat(z.allPaths):B,[]);return j.length&&(K.allPaths=j),K}function m(q,Y,H){const Z=_.sep===_.posix.sep,K=Z?q:q.replace(f,_.sep),F=_.sep+K,j=_.posix.sep+q,B=H?function(z,V){return typeof z=="string"&&(z===K||z.endsWith(F)||!Z&&(z===q||z.endsWith(j)))?Y:null}:function(z,V){return typeof z=="string"&&(z===K||!Z&&z===q)?Y:null};return B.allPaths=[(H?"*/":"./")+q],B}function I(q){try{const Y=new RegExp(`^${S(q)}$`);return function(H){return Y.lastIndex=0,typeof H=="string"&&Y.test(H)?q:null}}catch{return n}}function A(q,Y,H){return!q||typeof Y!="string"?!1:O(q)(Y,void 0,H)}e.match=A;function O(q,Y={}){if(!q)return a;if(typeof q=="string"||M(q)){const H=t(q,Y);if(H===n)return a;const Z=function(K,F){return!!H(K,F)};return H.allBasenames&&(Z.allBasenames=H.allBasenames),H.allPaths&&(Z.allPaths=H.allPaths),Z}return x(q,Y)}e.parse=O;function N(q){if(!q)return;let Y;return H=>(Y||(Y=(q()||Promise.resolve([])).then(Z=>Z?R(Z):{})),Y.then(Z=>!!Z[H]))}e.hasSiblingPromiseFn=N;function $(q){if(!q)return;let Y;return H=>{if(!Y){const Z=q();Y=Z?R(Z):{}}return!!Y[H]}}e.hasSiblingFn=$;function R(q){const Y={};for(const H of q)Y[H]=!0;return Y}function M(q){const Y=q;return Y&&typeof Y.base=="string"&&typeof Y.pattern=="string"}e.isRelativePattern=M;function W(q){return q.allBasenames||[]}e.getBasenameTerms=W;function U(q){return q.allPaths||[]}e.getPathTerms=U;function x(q,Y){const H=G(Object.getOwnPropertyNames(q).map(B=>ee(B,q[B],Y)).filter(B=>B!==n)),Z=H.length;if(!Z)return n;if(!H.some(B=>!!B.requiresSiblings)){if(Z===1)return H[0];const B=function(te,se){for(let ce=0,he=H.length;ce<he;ce++){const me=H[ce](te,se);if(me)return me}return null},z=H.find(te=>!!te.allBasenames);z&&(B.allBasenames=z.allBasenames);const V=H.reduce((te,se)=>se.allPaths?te.concat(se.allPaths):te,[]);return V.length&&(B.allPaths=V),B}const K=function(B,z,V){let te;for(let se=0,ce=H.length;se<ce;se++){const he=H[se];he.requiresSiblings&&V&&(z||(z=_.basename(B)),te||(te=z.substr(0,z.length-_.extname(B).length)));const me=he(B,z,te,V);if(me)return me}return null},F=H.find(B=>!!B.allBasenames);F&&(K.allBasenames=F.allBasenames);const j=H.reduce((B,z)=>z.allPaths?B.concat(z.allPaths):B,[]);return j.length&&(K.allPaths=j),K}function ee(q,Y,H){if(Y===!1)return n;const Z=t(q,H);if(Z===n)return n;if(typeof Y=="boolean")return Z;if(Y){const K=Y.when;if(typeof K=="string"){const F=(j,B,z,V)=>{if(!V||!Z(j,B))return null;const te=K.replace("$(basename)",z),se=V(te);return(0,L.isThenable)(se)?se.then(ce=>ce?q:null):se?q:null};return F.requiresSiblings=!0,F}}return Z}function G(q,Y){const H=q.filter(B=>!!B.basenames);if(H.length<2)return q;const Z=H.reduce((B,z)=>{const V=z.basenames;return V?B.concat(V):B},[]);let K;if(Y){K=[];for(let B=0,z=Z.length;B<z;B++)K.push(Y)}else K=H.reduce((B,z)=>{const V=z.patterns;return V?B.concat(V):B},[]);const F=function(B,z){if(typeof B!="string")return null;if(!z){let te;for(te=B.length;te>0;te--){const se=B.charCodeAt(te-1);if(se===47||se===92)break}z=B.substr(te)}const V=Z.indexOf(z);return V!==-1?K[V]:null};F.basenames=Z,F.patterns=K,F.allBasenames=Z;const j=q.filter(B=>!B.basenames);return j.push(F),j}}),define(ne[107],ie([0,1,106,16,9,19,25]),function(Q,e,L,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var D;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(D=e.Mimes||(e.Mimes={}));let C=[],b=[],P=[];function E(t,s=!1){const o=f(t);C.push(o),o.userConfigured?P.push(o):b.push(o),s&&!o.userConfigured&&C.forEach(u=>{u.mime===o.mime||u.userConfigured||(o.extension&&u.extension===o.extension&&console.warn(`Overwriting extension <<${o.extension}>> to now point to mime <<${o.mime}>>`),o.filename&&u.filename===o.filename&&console.warn(`Overwriting filename <<${o.filename}>> to now point to mime <<${o.mime}>>`),o.filepattern&&u.filepattern===o.filepattern&&console.warn(`Overwriting filepattern <<${o.filepattern}>> to now point to mime <<${o.mime}>>`),o.firstline&&u.firstline===o.firstline&&console.warn(`Overwriting firstline <<${o.firstline}>> to now point to mime <<${o.mime}>>`))})}e.registerTextMime=E;function f(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,L.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(k.posix.sep)>=0:!1}}function p(t){t?(C=C.filter(s=>!s.userConfigured),P=[]):(C=[],b=[],P=[])}e.clearTextMimes=p;function h(t,s){let o;if(t)switch(t.scheme){case i.Schemas.file:o=t.fsPath;break;case i.Schemas.data:{o=_.DataUri.parseMetaData(t).get(_.DataUri.META_DATA_LABEL);break}default:o=t.path}if(!o)return[D.unknown];o=o.toLowerCase();const u=(0,k.basename)(o),d=S(o,u,P);if(d)return[d,D.text];const m=S(o,u,b);if(m)return[m,D.text];if(s){const I=v(s);if(I)return[I,D.text]}return[D.unknown]}e.guessMimeTypes=h;function S(t,s,o){let u=null,d=null,m=null;for(let I=o.length-1;I>=0;I--){const A=o[I];if(s===A.filenameLowercase){u=A;break}if(A.filepattern&&(!d||A.filepattern.length>d.filepattern.length)){const O=A.filepatternOnPath?t:s;A.filepatternLowercase?.(O)&&(d=A)}A.extension&&(!m||A.extension.length>m.extension.length)&&s.endsWith(A.extensionLowercase)&&(m=A)}return u?u.mime:d?d.mime:m?m.mime:null}function v(t){if((0,T.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let s=C.length-1;s>=0;s--){const o=C[s];if(!o.firstline)continue;const u=t.match(o.firstline);if(u&&u.length>0)return o.mime}return null}function y(t){return t?typeof t=="string"?t===D.binary||t===D.text||t===D.unknown:t.length===1&&y(t[0]):!0}e.isUnspecific=y;const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},g={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function c(t){const s=(0,k.extname)(t),o=w[s.toLowerCase()];return o!==void 0?o:l(t)}e.getMediaOrTextMime=c;function l(t){const s=(0,k.extname)(t);return g[s.toLowerCase()]}e.getMediaMime=l;function r(t){for(const s in g)if(g[s]===t)return s}e.getExtensionForMimeType=r;const a=/^(.+)\/(.+?)(;.+)?$/;function n(t,s){const o=a.exec(t);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:s?void 0:t}e.normalizeMimeType=n}),define(ne[108],ie([0,1,7]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(P){return P.toJSON()}class k{constructor(E){this._uriTransformer=E}transformIncoming(E){const f=this._uriTransformer.transformIncoming(E);return f===E?E:i(L.URI.from(f))}transformOutgoing(E){const f=this._uriTransformer.transformOutgoing(E);return f===E?E:i(L.URI.from(f))}transformOutgoingURI(E){const f=this._uriTransformer.transformOutgoing(E);return f===E?E:L.URI.from(f)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function _(P,E,f){if(!P||f>200)return null;if(typeof P=="object"){if(P instanceof L.URI)return E.transformOutgoing(P);for(let p in P)if(Object.hasOwnProperty.call(P,p)){const h=_(P[p],E,f+1);h!==null&&(P[p]=h)}}return null}function T(P,E){const f=_(P,E,0);return f===null?P:f}e.transformOutgoingURIs=T;function D(P,E,f,p){if(!P||p>200)return null;if(typeof P=="object"){if(P.$mid===1)return f?L.URI.revive(E.transformIncoming(P)):E.transformIncoming(P);for(let h in P)if(Object.hasOwnProperty.call(P,h)){const S=D(P[h],E,f,p+1);S!==null&&(P[h]=S)}}return null}function C(P,E){const f=D(P,E,!1,0);return f===null?P:f}e.transformIncomingURIs=C;function b(P,E){const f=D(P,E,!0,0);return f===null?P:f}e.transformAndReviveIncomingURIs=b}),define(ne[30],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(C){return L.test(C)}e.isUUID=i;const k=new Uint8Array(16),_=[];for(let C=0;C<256;C++)_.push(C.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(C){for(let b=0;b<C.length;b++)C[b]=Math.floor(Math.random()*256);return C};function D(){T(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let C=0,b="";return b+=_[k[C++]],b+=_[k[C++]],b+=_[k[C++]],b+=_[k[C++]],b+="-",b+=_[k[C++]],b+=_[k[C++]],b+="-",b+=_[k[C++]],b+=_[k[C++]],b+="-",b+=_[k[C++]],b+=_[k[C++]],b+="-",b+=_[k[C++]],b+=_[k[C++]],b+=_[k[C++]],b+=_[k[C++]],b+=_[k[C++]],b+=_[k[C++]],b}e.generateUuid=D}),define(ne[109],ie([0,1,244]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class i{constructor(_="utf8"){this.stringDecoder=new L.StringDecoder(_),this.remaining=null}write(_){const T=[],D=this.remaining?this.remaining+this.stringDecoder.write(_):this.stringDecoder.write(_);if(D.length<1)return T;let C=0,b,P=C;for(;P<D.length;)if(b=D.charCodeAt(P),b===13||b===10){if(T.push(D.substring(C,P)),P++,P<D.length){const E=b;b=D.charCodeAt(P),(E===13&&b===10||E===10&&b===13)&&P++}C=P}else P++;return this.remaining=C<D.length?D.substr(C):null,T}end(){return this.remaining}}e.LineDecoder=i}),define(ne[110],ie([0,1,32]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const i=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(T){const D=T.replace(/\-/g,":").toLowerCase();return!i.has(D)}function _(){const T=(0,L.networkInterfaces)();for(let D in T){const C=T[D];if(C){for(const{mac:b}of C)if(k(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=_}),define(ne[111],ie([0,1,32,8,39,30,110]),function(Q,e,L,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,E=0;const f=(0,L.networkInterfaces)();for(let p in f){const h=f[p];if(h)for(const{mac:S,internal:v}of h)v||(E+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(P+=1))}this._value=E>0?P/E:0}return this._value}};let D;async function C(){return D||(D=(async()=>await b()||_.generateUuid())()),D}e.getMachineId=C;async function b(){try{const P=await new Promise((f,p)=>{Q(["crypto"],f,p)}),E=(0,T.getMac)();return P.createHash("sha256").update(E,"utf8").digest("hex")}catch(P){i.onUnexpectedError(P);return}}}),define(ne[20],ie([0,1,50,32,245,5,41,69,9,4,19,7]),function(Q,e,L,i,k,_,T,D,C,b,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function p(M,W=f.UNLINK){if((0,T.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return W===f.UNLINK?S(M):h(M)}async function h(M){try{const W=(0,T.randomPath)((0,i.tmpdir)());try{await e.Promises.rename(M,W)}catch{return S(M)}S(W).catch(U=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function S(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function v(M){if((0,T.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");L.rmdirSync(M,{recursive:!0})}e.rimrafSync=v;async function y(M,W){return c(await(W?w(M):(0,k.promisify)(L.readdir)(M)))}async function w(M){try{return await(0,k.promisify)(L.readdir)(M,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const W=[],U=await y(M);for(const x of U){let ee=!1,G=!1,q=!1;try{const Y=await e.Promises.lstat((0,C.join)(M,x));ee=Y.isFile(),G=Y.isDirectory(),q=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}W.push({name:x,isFile:()=>ee,isDirectory:()=>G,isSymbolicLink:()=>q})}return W}function g(M){return c(L.readdirSync(M))}e.readdirSync=g;function c(M){return M.map(W=>typeof W=="string"?b.isMacintosh?(0,D.normalizeNFC)(W):W:(W.name=b.isMacintosh?(0,D.normalizeNFC)(W.name):W.name,W))}async function l(M){const W=await y(M),U=[];for(const x of W)await a.existsDirectory((0,C.join)(M,x))&&U.push(x);return U}function r(M,W=1e3){return new Promise(U=>{let x=!1;const ee=setInterval(()=>{x||(x=!0,L.access(M,G=>{x=!1,G&&(clearInterval(ee),U(void 0))}))},W)})}e.whenDeleted=r;var a;(function(M){async function W(ee){let G;try{if(G=await e.Promises.lstat(ee),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(ee),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(b.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ee)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw Y}throw q}}M.stat=W;async function U(ee){try{const{stat:G,symbolicLink:q}=await M.stat(ee);return G.isFile()&&q?.dangling!==!0}catch{}return!1}M.existsFile=U;async function x(ee){try{const{stat:G,symbolicLink:q}=await M.stat(ee);return G.isDirectory()&&q?.dangling!==!0}catch{}return!1}M.existsDirectory=x})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new _.ResourceQueue;function t(M,W,U){return n.queueFor(E.URI.file(M),P.extUriBiasedIgnorePathCase).queue(()=>{const x=d(U);return new Promise((ee,G)=>o(M,W,x,q=>q?G(q):ee()))})}let s=!0;function o(M,W,U,x){if(!s)return L.writeFile(M,W,{mode:U.mode,flag:U.flag},x);L.open(M,U.flag,U.mode,(ee,G)=>{if(ee)return x(ee);L.writeFile(G,W,q=>{if(q)return L.close(G,()=>x(q));L.fdatasync(G,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),s=!1),L.close(G,H=>x(H))))})})}function u(M,W,U){const x=d(U);if(!s)return L.writeFileSync(M,W,{mode:x.mode,flag:x.flag});const ee=L.openSync(M,x.flag,x.mode);try{L.writeFileSync(ee,W);try{L.fdatasyncSync(ee)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),s=!1}}finally{L.closeSync(ee)}}e.writeFileSync=u;function d(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function m(M,W){if(M===W)return;async function U(x){try{const ee=await e.Promises.lstat(x);if(ee.isDirectory()||ee.isSymbolicLink())return;await e.Promises.utimes(x,ee.atime,new Date)}catch{}}try{await e.Promises.rename(M,W),await U(W)}catch(x){if(M.toLowerCase()!==W.toLowerCase()&&x.code==="EXDEV"||M.endsWith("."))await I(M,W,{preserveSymlinks:!1}),await p(M,f.MOVE),await U(W);else throw x}}async function I(M,W,U){return O(M,W,{root:{source:M,target:W},options:U,handledSourcePaths:new Set})}const A=511;async function O(M,W,U){if(U.handledSourcePaths.has(M))return;U.handledSourcePaths.add(M);const{stat:x,symbolicLink:ee}=await a.stat(M);if(ee){if(U.options.preserveSymlinks)try{return await R(M,W,U)}catch(G){console.warn("[node.js fs] copy of symlink failed: ",G)}if(ee.dangling)return}return x.isDirectory()?N(M,W,x.mode&A,U):$(M,W,x.mode&A)}async function N(M,W,U,x){await e.Promises.mkdir(W,{recursive:!0,mode:U});const ee=await y(M);for(const G of ee)await O((0,C.join)(M,G),(0,C.join)(W,G),x)}async function $(M,W,U){await e.Promises.copyFile(M,W),await e.Promises.chmod(W,U)}async function R(M,W,U){let x=await e.Promises.readlink(M);(0,T.isEqualOrParent)(x,U.root.source,!b.isLinux)&&(x=(0,C.join)(U.root.target,x.substr(U.root.source.length+1))),await e.Promises.symlink(x,W)}e.Promises=new class{get access(){return(0,k.promisify)(L.access)}get stat(){return(0,k.promisify)(L.stat)}get lstat(){return(0,k.promisify)(L.lstat)}get utimes(){return(0,k.promisify)(L.utimes)}get read(){return(0,k.promisify)(L.read)}get readFile(){return(0,k.promisify)(L.readFile)}get write(){return(0,k.promisify)(L.write)}get appendFile(){return(0,k.promisify)(L.appendFile)}get fdatasync(){return(0,k.promisify)(L.fdatasync)}get truncate(){return(0,k.promisify)(L.truncate)}get rename(){return(0,k.promisify)(L.rename)}get copyFile(){return(0,k.promisify)(L.copyFile)}get open(){return(0,k.promisify)(L.open)}get close(){return(0,k.promisify)(L.close)}get symlink(){return(0,k.promisify)(L.symlink)}get readlink(){return(0,k.promisify)(L.readlink)}get chmod(){return(0,k.promisify)(L.chmod)}get mkdir(){return(0,k.promisify)(L.mkdir)}get unlink(){return(0,k.promisify)(L.unlink)}get rmdir(){return(0,k.promisify)(L.rmdir)}get realpath(){return(0,k.promisify)(L.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return y}get readDirsInDir(){return l}get writeFile(){return t}get rm(){return p}get move(){return m}get copy(){return I}}}),define(ne[112],ie([0,1,50,9,25,20]),function(Q,e,L,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function T(P){const E=(0,i.dirname)(P);if(P===E)return P;const f=((0,i.basename)(P)||P).toLowerCase();try{const h=(0,_.readdirSync)(E).filter(S=>S.toLowerCase()===f);if(h.length===1){const S=T(E);if(S)return(0,i.join)(S,h[0])}else if(h.length>1){const S=h.indexOf(f);if(S>=0){const v=T(E);if(v)return(0,i.join)(v,h[S])}}}catch{}return null}e.realcaseSync=T;async function D(P){try{return await _.Promises.realpath(P)}catch{const f=b(P);return await _.Promises.access(f,L.constants.R_OK),f}}e.realpath=D;function C(P){try{return L.realpathSync(P)}catch{const f=b(P);return L.accessSync(f,L.constants.R_OK),f}}e.realpathSync=C;function b(P){return(0,k.rtrim)((0,i.normalize)(P),i.sep)}}),define(ne[113],ie([0,1,55]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function i(D,C,b,P=1){let E=!1;return new Promise(f=>{const p=setTimeout(()=>{if(!E)return E=!0,f(0)},b);k(D,C,P,h=>{if(!E)return E=!0,clearTimeout(p),f(h)})})}e.findFreePort=i;function k(D,C,b,P){if(C===0)return P(0);const E=new L.Socket;E.once("connect",()=>(T(E),k(D+b,C-1,b,P))),E.once("data",()=>{}),E.once("error",f=>(T(E),f.code!=="ECONNREFUSED"?k(D+b,C-1,b,P):P(D))),E.connect(D,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function _(D,C,b){let P=!1,E,f=1;const p=L.createServer({pauseOnConnect:!0});function h(S,v){P||(P=!0,p.removeAllListeners(),p.close(),E&&clearTimeout(E),v(S))}return new Promise(S=>{E=setTimeout(()=>{h(0,S)},b),p.on("listening",()=>{h(D,S)}),p.on("error",v=>{v&&(v.code==="EADDRINUSE"||v.code==="EACCES")&&f<C?(D++,f++,p.listen(D,"127.0.0.1")):h(0,S)}),p.on("close",()=>{h(0,S)}),p.listen(D,"127.0.0.1")})}e.findFreePortFaster=_;function T(D){try{D.removeAllListeners("connect"),D.removeAllListeners("error"),D.end(),D.destroy(),D.unref()}catch(C){console.error(C)}}}),define(ne[70],ie([0,1,32,9,20]),function(Q,e,L,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const _=/^\d+$/,T=/^Microsoft.PowerShell_.*/,D=/^Microsoft.PowerShellPreview_.*/;var C;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(C||(C={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class E{constructor(l,r,a){this.exePath=l,this.displayName=r,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:c=!1}={}){return c?b===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:c=!1,findPreview:l=!1}={}){const r=f({useAlternateBitness:c});if(!r)return null;const a=i.join(r,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(a))return null;let n=-1,t=null;for(const u of await k.Promises.readdir(a)){let d=-1;if(l){const I=u.indexOf("-");if(I<0)continue;const A=u.substring(0,I);if(!_.test(A)||u.substring(I+1)!=="preview")continue;d=parseInt(A,10)}else{if(!_.test(u))continue;d=parseInt(u,10)}if(d<=n)continue;const m=i.join(a,u,"pwsh.exe");!await k.SymlinkSupport.existsFile(m)||(t=m,n=d)}if(!t)return null;const s=r.includes("x86")?" (x86)":"",o=l?" Preview":"";return new E(t,`PowerShell${o}${s}`,!0)}async function h({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const l=i.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:r,pwshMsixName:a}=c?{pwshMsixDirRegex:D,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const n of await k.Promises.readdir(l))if(r.test(n)){const t=i.join(l,n,"pwsh.exe");return new E(t,a)}return null}function S(){const c=i.join(L.homedir(),".dotnet","tools","pwsh.exe");return new E(c,".NET Core PowerShell Global Tool")}function v(){const c=i.join(process.env.windir,b===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(c,"Windows PowerShell",!0)}async function*y(){let c=await p();c&&(yield c),c=await p({useAlternateBitness:!0}),c&&(yield c),c=await h(),c&&(yield c),c=S(),c&&(yield c),c=await p({findPreview:!0}),c&&(yield c),c=await h({findPreview:!0}),c&&(yield c),c=await p({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=v(),c&&(yield c)}async function*w(){for await(const c of y())await c.exists()&&(yield c)}e.enumeratePowerShellInstallations=w;async function g(){for await(const c of w())return c;return null}e.getFirstAvailablePowerShellInstallation=g}),define(ne[114],ie([0,1,45,16]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(T){return new Promise((D,C)=>{let b;const P=new Map;function E(p,h,S,v,y){const w=P.get(h);if(p===T||w){const g={name:f(S),cmd:S,pid:p,ppid:h,load:v,mem:y};P.set(p,g),p===T&&(b=g),w&&(w.children||(w.children=[]),w.children.push(g),w.children.length>1&&(w.children=w.children.sort((c,l)=>c.pid-l.pid)))}}function f(p){const h=/--vscode-window-kind=shared-process/,S=/--vscode-window-kind=issue-reporter/,v=/--vscode-window-kind=process-explorer/,y=/--utility-sub-type=network/,w=/--crashes-directory/,g=/\\pipe\\winpty-control/,c=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(w.exec(p))return"electron-crash-reporter";if(g.exec(p))return"winpty-process";if(c.exec(p))return"console-window-host (Windows internal process)";let r=l.exec(p);if(r&&r.length===2)return r[1]==="renderer"?h.exec(p)?"shared-process":S.exec(p)?"issue-reporter":v.exec(p)?"process-explorer":"window":r[1]==="utility"&&y.exec(p)?"utility-network-service":r[1];const a=/[a-zA-Z-]+\.js/g;let n="";do r=a.exec(p),r&&(n+=r+" ");while(r);return n&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${n}`:p}if(process.platform==="win32"){const p=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,S)=>{Q(["windows-process-tree"],h,S)}).then(h=>{h.getProcessList(T,S=>{h.getProcessCpuUsage(S,v=>{const y=new Map;v.forEach(w=>{const g=p(w.commandLine||"");y.set(w.pid,{name:f(g),cmd:g,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),b=y.get(T),b?(y.forEach(w=>{const g=y.get(w.ppid);g&&(g.children||(g.children=[]),g.children.push(w))}),y.forEach(w=>{w.children&&(w.children=w.children.sort((g,c)=>g.pid-c.pid))}),D(b)):C(new Error(`Root process ${T} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let p=function(){let h=[b];const S=[];for(;h.length;){const y=h.shift();y&&(S.push(y.pid),y.children&&(h=h.concat(y.children)))}let v=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Q).fsPath);v+=" "+S.join(" "),(0,L.exec)(v,{},(y,w,g)=>{if(y||g)C(y||new Error(g.toString()));else{const c=w.toString().split(`
`);for(let l=0;l<S.length;l++){const r=P.get(S[l]);r.load=parseFloat(c[l])}if(!b){C(new Error(`Root process ${T} not found`));return}D(b)}})};(0,L.exec)("which ps",{},(h,S,v)=>{if(h||v)if(process.platform!=="linux")C(h||new Error(v.toString()));else{const y=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/ps.sh",Q).fsPath);(0,L.exec)(y,{},(w,g,c)=>{w||c?C(w||new Error(c.toString())):(_(g,E),p())})}else{const y=S.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,L.exec)(`${y} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,c,l)=>{g||l&&!l.includes("screen size is bogus")?C(g||new Error(l.toString())):(_(c,E),process.platform==="linux"?p():b?D(b):C(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=k;function _(T,D){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=T.toString().split(`
`);for(const P of b){const E=C.exec(P.trim());E&&E.length===6&&D(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(ne[115],ie([0,1,50,27,41,2,69,9,4,20]),function(Q,e,L,i,k,_,T,D,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function P(h,S,v){return f({path:h,isDirectory:!1},S,v)}e.watchFile=P;function E(h,S,v){return f({path:h,isDirectory:!0},S,v)}e.watchFolder=E,e.CHANGE_BUFFER_DELAY=100;function f(h,S,v){if(C.isMacintosh&&(0,k.isEqualOrParent)(h.path,"/Volumes/"))return v(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),_.Disposable.None;const y=(0,D.basename)(h.path),w=new Map;let g=!1,c=[(0,_.toDisposable)(()=>{w.forEach(l=>(0,_.dispose)(l)),w.clear()})];try{const l=(0,L.watch)(h.path);c.push((0,_.toDisposable)(()=>{l.removeAllListeners(),l.close()}));const r=new Set;h.isDirectory&&b.Promises.readdir(h.path).then(a=>a.forEach(n=>r.add(n))),l.on("error",(a,n)=>{g||v(`Failed to watch ${h.path} for changes using fs.watch() (${a}, ${n})`)}),l.on("change",(a,n)=>{if(g)return;let t="";if(n&&(t=n.toString(),C.isMacintosh&&(t=(0,T.normalizeNFC)(t))),!t||a!=="change"&&a!=="rename")return;const s=h.isDirectory?(0,D.join)(h.path,t):h.path;if(h.isDirectory)if(a==="rename"){const o=w.get(s);o&&(0,_.dispose)(o);const u=setTimeout(async()=>{w.delete(s);const d=await b.Promises.exists(s);if(g)return;let m;d?r.has(t)?m="changed":(m="added",r.add(t)):(r.delete(t),m="deleted"),S(m,s)},e.CHANGE_BUFFER_DELAY);w.set(s,(0,_.toDisposable)(()=>clearTimeout(u)))}else{let o;r.has(t)?o="changed":(o="added",r.add(t)),S(o,s)}else if(a==="rename"||t!==y){const o=setTimeout(async()=>{const u=await b.Promises.exists(s);g||(u?(S("changed",s),c=[f(h,S,v)]):S("deleted",s))},e.CHANGE_BUFFER_DELAY);(0,_.dispose)(c),c=[(0,_.toDisposable)(()=>clearTimeout(o))]}else S("changed",s)})}catch(l){b.Promises.exists(h.path).then(r=>{r&&!g&&v(`Failed to watch ${h.path} for changes using fs.watch() (${l.toString()})`)})}return(0,_.toDisposable)(()=>{g=!0,c=(0,_.dispose)(c)})}async function p(h,S,v,y=512){const w=await b.Promises.open(h,"r"),g=Buffer.allocUnsafe(y),c=new i.CancellationTokenSource(v);let l,r=!1;const a=P(h,async n=>{if(n==="changed"){if(r)return;r=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:t}=await b.Promises.read(w,g,0,y,null);if(!t||c.token.isCancellationRequested)break;S(g.slice(0,t))}}catch(t){l=new Error(t),c.dispose(!0)}finally{r=!1}}},n=>{l=new Error(n),c.dispose(!0)});return new Promise((n,t)=>{c.token.onCancellationRequested(async()=>{a.dispose(),await b.Promises.close(w),l?t(l):n()})})}e.watchFileContents=p});var de=this&&this.__decorate||function(Q,e,L,i){var k=arguments.length,_=k<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,L):i,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(Q,e,L,i);else for(var D=Q.length-1;D>=0;D--)(T=Q[D])&&(_=(k<3?T(_):k>3?T(e,L,_):T(e,L))||_);return k>3&&_&&Object.defineProperty(e,L,_),_};define(ne[36],ie([0,1,17,5,18,27,53,8,3,2,105,25,15]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function h(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function v(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var y;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(y||(y={}));class w{constructor(q){this.buffer=q,this.pos=0}read(q){const Y=this.buffer.slice(this.pos,this.pos+q);return this.pos+=Y.byteLength,Y}}class g{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}var c;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object"})(c||(c={}));function l(G){const q=k.VSBuffer.alloc(4);return q.writeUInt32BE(G,0),q}function r(G){return G.read(4).readUInt32BE(0)}function a(G){const q=k.VSBuffer.alloc(1);return q.writeUInt8(G,0),q}const n={Undefined:a(c.Undefined),String:a(c.String),Buffer:a(c.Buffer),VSBuffer:a(c.VSBuffer),Array:a(c.Array),Object:a(c.Object)},t=typeof Buffer!="undefined";function s(G,q){if(typeof q=="undefined")G.write(n.Undefined);else if(typeof q=="string"){const Y=k.VSBuffer.fromString(q);G.write(n.String),G.write(l(Y.byteLength)),G.write(Y)}else if(t&&Buffer.isBuffer(q)){const Y=k.VSBuffer.wrap(q);G.write(n.Buffer),G.write(l(Y.byteLength)),G.write(Y)}else if(q instanceof k.VSBuffer)G.write(n.VSBuffer),G.write(l(q.byteLength)),G.write(q);else if(Array.isArray(q)){G.write(n.Array),G.write(l(q.length));for(const Y of q)s(G,Y)}else{const Y=k.VSBuffer.fromString(JSON.stringify(q));G.write(n.Object),G.write(l(Y.byteLength)),G.write(Y)}}function o(G){switch(G.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return G.read(r(G)).toString();case c.Buffer:return G.read(r(G)).buffer;case c.VSBuffer:return G.read(r(G));case c.Array:{const Y=r(G),H=[];for(let Z=0;Z<Y;Z++)H.push(o(G));return H}case c.Object:return JSON.parse(G.read(r(G)).toString())}}class u{constructor(q,Y,H=null,Z=1e3){this.protocol=q,this.ctx=Y,this.logger=H,this.timeoutDelay=Z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(q,Y){this.channels.set(q,Y),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const Y=this.send([q.type]);this.logger&&this.logger.logOutgoing(Y,0,1,v(q.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([q.type,q.id],q.data);this.logger&&this.logger.logOutgoing(Y,q.id,1,v(q.type),q.data);return}}}send(q,Y=void 0){const H=new g;return s(H,q),s(H,Y),this.sendBuffer(H.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const Y=new w(q),H=o(Y),Z=o(Y),K=H[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${h(K)}: ${H[2]}.${H[3]}`,Z),this.onPromise({type:K,id:H[1],channelName:H[2],name:H[3],arg:Z});case 102:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${h(K)}: ${H[2]}.${H[3]}`,Z),this.onEventListen({type:K,id:H[1],channelName:H[2],name:H[3],arg:Z});case 101:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${h(K)}`),this.disposeActiveRequest({type:K,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${h(K)}`),this.disposeActiveRequest({type:K,id:H[1]})}}onPromise(q){const Y=this.channels.get(q.channelName);if(!Y){this.collectPendingRequest(q);return}const H=new _.CancellationTokenSource;let Z;try{Z=Y.call(this.ctx,q.name,q.arg,H.token)}catch(j){Z=Promise.reject(j)}const K=q.id;Z.then(j=>{this.sendResponse({id:K,data:j,type:201}),this.activeRequests.delete(q.id)},j=>{j instanceof Error?this.sendResponse({id:K,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split?j.stack.split(`
`):j.stack:void 0},type:202}):this.sendResponse({id:K,data:j,type:203}),this.activeRequests.delete(q.id)});const F=(0,b.toDisposable)(()=>H.cancel());this.activeRequests.set(q.id,F)}onEventListen(q){const Y=this.channels.get(q.channelName);if(!Y){this.collectPendingRequest(q);return}const H=q.id,K=Y.listen(this.ctx,q.name,q.arg)(F=>this.sendResponse({id:H,data:F,type:204}));this.activeRequests.set(q.id,K)}disposeActiveRequest(q){const Y=this.activeRequests.get(q.id);Y&&(Y.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let Y=this.pendingRequests.get(q.channelName);Y||(Y=[],this.pendingRequests.set(q.channelName,Y));const H=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:q,timeoutTimer:H})}flushPendingRequests(q){const Y=this.pendingRequests.get(q);if(Y){for(const H of Y)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(q=>q.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var d;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class m{constructor(q,Y=null){this.protocol=q,this.isDisposed=!1,this.state=y.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new C.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=Y}getChannel(q){const Y=this;return{call(H,Z,K){return Y.isDisposed?Promise.reject(D.canceled()):Y.requestPromise(q,H,Z,K)},listen(H,Z){return Y.isDisposed?Promise.reject(D.canceled()):Y.requestEvent(q,H,Z)}}}requestPromise(q,Y,H,Z=_.CancellationToken.None){const K=this.lastRequestId++,j={id:K,type:100,channelName:q,name:Y,arg:H};if(Z.isCancellationRequested)return Promise.reject(D.canceled());let B;return new Promise((V,te)=>{if(Z.isCancellationRequested)return te(D.canceled());const se=()=>{const ve=ge=>{switch(ge.type){case 201:this.handlers.delete(K),V(ge.data);break;case 202:{this.handlers.delete(K);const we=new Error(ge.data.message);we.stack=ge.data.stack,we.name=ge.data.name,te(we);break}case 203:this.handlers.delete(K),te(ge.data);break}};this.handlers.set(K,ve),this.sendRequest(j)};let ce=null;this.state===y.Idle?se():(ce=(0,i.createCancelablePromise)(ve=>this.whenInitialized()),ce.then(()=>{ce=null,se()}));const he=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:K,type:101}),te(D.canceled())},me=Z.onCancellationRequested(he);B=(0,b.combinedDisposable)((0,b.toDisposable)(he),me),this.activeRequests.add(B)}).finally(()=>{this.activeRequests.delete(B)})}requestEvent(q,Y,H){const Z=this.lastRequestId++,F={id:Z,type:102,channelName:q,name:Y,arg:H};let j=null;const B=new C.Emitter({onFirstListenerAdd:()=>{j=(0,i.createCancelablePromise)(V=>this.whenInitialized()),j.then(()=>{j=null,this.activeRequests.add(B),this.sendRequest(F)})},onLastListenerRemove:()=>{j?(j.cancel(),j=null):(this.activeRequests.delete(B),this.sendRequest({id:Z,type:103}))}}),z=V=>B.fire(V.data);return this.handlers.set(Z,z),B.event}sendRequest(q){switch(q.type){case 100:case 102:{const Y=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger&&this.logger.logOutgoing(Y,q.id,0,`${h(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const Y=this.send([q.type,q.id]);this.logger&&this.logger.logOutgoing(Y,q.id,0,h(q.type));return}}}send(q,Y=void 0){const H=new g;return s(H,q),s(H,Y),this.sendBuffer(H.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const Y=new w(q),H=o(Y),Z=o(Y),K=H[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(q.byteLength,0,0,v(K)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],0,v(K),Z),this.onResponse({type:H[0],id:H[1],data:Z})}}onResponse(q){if(q.type===200){this.state=y.Idle,this._onDidInitialize.fire();return}const Y=this.handlers.get(q.id);Y&&Y(q)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===y.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(q=>q.dispose()),this.activeRequests.clear()}}de([T.memoize],m.prototype,"onDidInitializePromise",null),e.ChannelClient=m;class I{constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new C.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new C.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,q(({protocol:Y,onDidClientDisconnect:H})=>{C.Event.once(Y.onMessage)(K=>{const F=new w(K),j=o(F),B=new u(Y,j),z=new m(Y);this.channels.forEach((te,se)=>B.registerChannel(se,te));const V={channelServer:B,channelClient:z,ctx:j};this._connections.add(V),this._onDidAddConnection.fire(V),H(()=>{B.dispose(),z.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const q=[];return this._connections.forEach(Y=>q.push(Y)),q}getChannel(q,Y){const H=this;return{call(Z,K,F){let j;if((0,f.isFunction)(Y)){let z=(0,L.getRandomElement)(H.connections.filter(Y));j=z?Promise.resolve(z):C.Event.toPromise(C.Event.filter(H.onDidAddConnection,Y))}else j=Y.routeCall(H,Z,K);const B=j.then(z=>z.channelClient.getChannel(q));return O(B).call(Z,K,F)},listen(Z,K){if((0,f.isFunction)(Y))return H.getMulticastEvent(q,Y,Z,K);const F=Y.routeEvent(H,Z,K).then(j=>j.channelClient.getChannel(q));return O(F).listen(Z,K)}}}getMulticastEvent(q,Y,H,Z){const K=this;let F=new b.DisposableStore;const j=new C.Emitter({onFirstListenerAdd:()=>{F=new b.DisposableStore;const B=new C.EventMultiplexer,z=new Map,V=se=>{const he=se.channelClient.getChannel(q).listen(H,Z),me=B.add(he);z.set(se,me)},te=se=>{const ce=z.get(se);!ce||(ce.dispose(),z.delete(se))};K.connections.filter(Y).forEach(V),C.Event.filter(K.onDidAddConnection,Y)(V,void 0,F),K.onDidRemoveConnection(te,void 0,F),B.event(j.fire,j,F),F.add(B)},onLastListenerRemove:()=>{F.dispose()}});return j.event}registerChannel(q,Y){this.channels.set(q,Y),this._connections.forEach(H=>{H.channelServer.registerChannel(q,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=I;class A{constructor(q,Y,H=null){const Z=new g;s(Z,Y),q.send(Z.buffer),this.channelClient=new m(q,H),this.channelServer=new u(q,Y,H)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,Y){this.channelServer.registerChannel(q,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=A;function O(G){return{call(q,Y,H){return G.then(Z=>Z.call(q,Y,H))},listen(q,Y){const H=new C.Relay;return G.then(Z=>H.input=Z.listen(q,Y)),H.event}}}e.getDelayedChannel=O;function N(G){let q=!1;return{call(Y,H,Z){return q?G.call(Y,H,Z):(0,i.timeout)(0).then(()=>q=!0).then(()=>G.call(Y,H,Z))},listen(Y,H){if(q)return G.listen(Y,H);const Z=new C.Relay;return(0,i.timeout)(0).then(()=>q=!0).then(()=>Z.input=G.listen(Y,H)),Z.event}}}e.getNextTickChannel=N;class ${constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const Y of q.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await C.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=$;var R;(function(G){function q(K,F){const j=K,B=F&&F.disableMarshalling,z=new Map;for(const V in j)H(V)&&z.set(V,C.Event.buffer(j[V],!0));return new class{listen(V,te,se){const ce=z.get(te);if(ce)return ce;if(Z(te)){const he=j[te];if(typeof he=="function")return he.call(j,se)}throw new Error(`Event not found: ${te}`)}call(V,te,se){const ce=j[te];if(typeof ce=="function"){if(!B&&Array.isArray(se))for(let he=0;he<se.length;he++)se[he]=(0,P.revive)(se[he]);return ce.apply(j,se)}throw new Error(`Method not found: ${te}`)}}}G.fromService=q;function Y(K,F){const j=F&&F.disableMarshalling;return new Proxy({},{get(B,z){if(typeof z=="string")return F?.properties?.has(z)?F.properties.get(z):Z(z)?function(V){return K.listen(z,V)}:H(z)?K.listen(z):async function(...V){let te;F&&!(0,f.isUndefinedOrNull)(F.context)?te=[F.context,...V]:te=V;const se=await K.call(z,te);return j?se:(0,P.revive)(se)};throw new Error(`Property not found: ${String(z)}`)}})}G.toService=Y;function H(K){return K[0]==="o"&&K[1]==="n"&&E.isUpperAsciiLetter(K.charCodeAt(2))}function Z(K){return/^onDynamic/.test(K)&&E.isUpperAsciiLetter(K.charCodeAt(9))}})(R=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){let q=G.toString();if(q!=="[object Object]")return q}return G}function U(G){return Array.isArray(G)?G.map(W):W(G)}function x(G,q,Y,H,Z,K,F){F=U(F);const j=M[Z],B=j[H%j.length];let z=[`%c[${G}]%c[${String(q).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(K)?(z=z.concat(F),z.push(")")):z.push(F),console.log.apply(console,z)}e.logWithColors=x;class ee{constructor(q,Y){this._outgoingPrefix=q,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,Y,H,Z,K){this._totalOutgoing+=q,x(this._outgoingPrefix,this._totalOutgoing,q,Y,H,Z,K)}logIncoming(q,Y,H,Z,K){this._totalIncoming+=q,x(this._incomingPrefix,this._totalIncoming,q,Y,H,Z,K)}}e.IPCLogger=ee}),define(ne[116],ie([0,1,18,3,36]),function(Q,e,L,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class _{constructor(C){this.port=C,this.onMessage=i.Event.fromDOMEventEmitter(this.port,"message",b=>L.VSBuffer.wrap(b.data)),C.start()}send(C){this.port.postMessage(C.buffer)}disconnect(){this.port.close()}}e.Protocol=_;class T extends k.IPCClient{constructor(C,b){const P=new _(C);super(P,b);this.protocol=P}dispose(){this.protocol.disconnect()}}e.Client=T}),define(ne[71],ie([0,1,18,3,2,36]),function(Q,e,L,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var D;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let o=0;function u(m,I){if(!s.has(m)){const A=String(++o);s.set(m,A)}return s.get(m)}function d(m,I,A,O){if(!t.enableDiagnostics)return;const N=u(m,I);if(O instanceof L.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const $=L.VSBuffer.alloc(O.byteLength);$.set(O),t.records.push({timestamp:Date.now(),id:N,label:I,type:A,buff:$})}else t.records.push({timestamp:Date.now(),id:N,label:I,type:A,data:O})}t.traceSocketEvent=d})(D=e.SocketDiagnostics||(e.SocketDiagnostics={}));var C;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function P(){return b||(b=L.VSBuffer.alloc(0)),b}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,o){if(s===0)return P();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const I=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=s),I}if(this._chunks[0].byteLength>s){const I=this._chunks[0].slice(0,s);return o&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),I}let u=L.VSBuffer.alloc(s),d=0,m=0;for(;s>0;){const I=this._chunks[m];if(I.byteLength>s){const A=I.slice(0,s);u.set(A,d),d+=s,o&&(this._chunks[m]=I.slice(s),this._totalLength-=s),s-=s}else u.set(I,d),d+=I.byteLength,o?(this._chunks.shift(),this._totalLength-=I.byteLength):m++,s-=I.byteLength}return u}}e.ChunkStream=E;var f;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(f||(f={}));function p(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var h;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class S{constructor(s,o,u,d){this.type=s,this.id=o,this.ack=u,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends k.Disposable{constructor(s){super();this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:p(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const u=this._state.messageType,d=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new S(u,d,m,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class y{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=L.VSBuffer.alloc(13);o.writeUInt8(s.type,0),o.writeUInt32BE(s.id,1),o.writeUInt32BE(s.ack,5),o.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:p(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(o,s.data)}_bufferAdd(s,o){const u=this._totalLength===0;return this._data.push(s,o),this._totalLength+=s.byteLength+o.byteLength,u}_bufferTake(){const s=L.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,o){this._bufferAdd(s,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class w extends k.Disposable{constructor(s){super();this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new y(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new S(1,0,0,s))}}e.Protocol=w;class g extends _.IPCClient{constructor(s,o,u=null){super(s,o,u);this.protocol=s}static fromSocket(s,o){return new g(new w(s),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=g;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class l{constructor(s){this.data=s,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],o=0,u=this._first;for(;u;)s[o++]=u.data,u=u.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const o=new l(s);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class a{constructor(){this.lastRuns=[];const s=Date.now();for(let o=0;o<a._HISTORY_LENGTH;o++)this.lastRuns[o]=s-1e3*o;setInterval(()=>{for(let o=a._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const s=Date.now(),o=(1+a._HISTORY_LENGTH)*1e3;let u=0;for(let d=0;d<a._HISTORY_LENGTH;d++)s-this.lastRuns[d]<=o&&u++;return 1-u/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class n{constructor(s,o=null,u=a.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new S(5,0,0,P());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new S(7,0,0,P());this._socketWriter.write(s)}sendResume(){const s=new S(8,0,0,P());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,o){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new S(3,0,this._incomingAckId,P());this._socketWriter.write(s);const o=this._outgoingUnackMsg.toArray();for(let u=0,d=o.length;u<d;u++)this._socketWriter.write(o[u]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new S(6,0,0,P())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let u=0,d=o.length;u<d;u++)this._socketWriter.write(o[u]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new S(1,o,this._incomingAckId,s);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(s){const o=new S(2,0,0,s);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),o=Date.now()-s.writtenTime,u=Date.now()-this._socketReader.lastReadTime,d=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&u>=2e4&&d>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const m=Math.max(2e4-o,2e4-u,2e4-d,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},m)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new S(3,0,this._incomingAckId,P());this._socketWriter.write(s)}}e.PersistentProtocol=n}),define(ne[117],ie([0,1,72,3,36,116]),function(Q,e,L,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends k.IPCServer{static getOnDidClientConnect(){const C=i.Event.fromNodeEventEmitter(L.ipcRenderer,"vscode:createMessageChannel",(b,P)=>P);return i.Event.map(C,b=>{const{port1:P,port2:E}=new MessageChannel,p={protocol:new _.Protocol(P),onDidClientDisconnect:i.Event.fromDOMEventEmitter(P,"close")};return L.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[E]),p})}constructor(){super(T.getOnDidClientConnect())}}e.Server=T}),define(ne[118],ie([0,1,18,8]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function k(D,C){D.proxyAuthorization&&(D.headers={...D.headers||{},"Proxy-Authorization":D.proxyAuthorization});const b=new XMLHttpRequest;return new Promise((P,E)=>{b.open(D.type||"GET",D.url||"",!0,D.user,D.password),_(b,D),b.responseType="arraybuffer",b.onerror=f=>E(new Error(b.statusText&&"XHR failed: "+b.statusText||"XHR failed")),b.onload=f=>{P({res:{statusCode:b.status,headers:T(b)},stream:(0,L.bufferToStream)(L.VSBuffer.wrap(new Uint8Array(b.response)))})},b.ontimeout=f=>E(new Error(`XHR timeout: ${D.timeout}ms`)),D.timeout&&(b.timeout=D.timeout),b.send(D.data),C.onCancellationRequested(()=>{b.abort(),E((0,i.canceled)())})})}e.request=k;function _(D,C){if(C.headers){e:for(let b in C.headers){switch(b){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}D.setRequestHeader(b,C.headers[b])}}}function T(D){const C=Object.create(null);for(const b of D.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(b){const P=b.indexOf(":");C[b.substr(0,P).trim().toLowerCase()]=b.substr(P+1).trim()}return C}}),define(ne[73],ie([0,1,5,3,2,15]),function(Q,e,L,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));function D(E){const f=E;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=D;var C;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(C||(C={}));class b extends k.Disposable{constructor(f,p=Object.create(null)){super();this.database=f,this.options=p,this._onDidChangeStorage=this._register(new i.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=C.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((p,h)=>this.accept(h,p)),f.deleted?.forEach(p=>this.accept(p,void 0))}accept(f,p){if(this.state===C.Closed)return;let h=!1;(0,_.isUndefinedOrNull)(p)?h=this.cache.delete(f):this.cache.get(f)!==p&&(this.cache.set(f,p),h=!0),h&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===C.None&&(this.state=C.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,p){const h=this.cache.get(f);return(0,_.isUndefinedOrNull)(h)?p:h}getBoolean(f,p){const h=this.get(f);return(0,_.isUndefinedOrNull)(h)?p:h==="true"}getNumber(f,p){const h=this.get(f);return(0,_.isUndefinedOrNull)(h)?p:parseInt(h,10)}async set(f,p){if(this.state===C.Closed)return;if((0,_.isUndefinedOrNull)(p))return this.delete(f);const h=String(p);if(this.cache.get(f)!==h)return this.cache.set(f,h),this.pendingInserts.set(f,h),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async delete(f){if(!(this.state===C.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=C.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(!!this.hasPending)return this.doFlush(f)}async doFlush(f){return this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class P{constructor(){this.onDidChangeItemsExternal=i.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((p,h)=>this.items.set(h,p)),f.delete&&f.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=P}),define(ne[119],ie([11,12]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(ne[56],ie([0,1,119]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,k=i*60,_=k*24,T=_*7,D=_*30,C=_*365;function b(E,f){typeof E!="number"&&(E=E.getTime());const p=Math.round((new Date().getTime()-E)/1e3);if(p<-30)return(0,L.localize)(0,null,b(new Date().getTime()+p*1e3,!1));if(p<30)return(0,L.localize)(1,null);let h;return p<i?(h=p,f?h===1?(0,L.localize)(2,null,h):(0,L.localize)(3,null,h):h===1?(0,L.localize)(4,null,h):(0,L.localize)(5,null,h)):p<k?(h=Math.floor(p/i),f?h===1?(0,L.localize)(6,null,h):(0,L.localize)(7,null,h):h===1?(0,L.localize)(8,null,h):(0,L.localize)(9,null,h)):p<_?(h=Math.floor(p/k),f?h===1?(0,L.localize)(10,null,h):(0,L.localize)(11,null,h):h===1?(0,L.localize)(12,null,h):(0,L.localize)(13,null,h)):p<T?(h=Math.floor(p/_),f?h===1?(0,L.localize)(14,null,h):(0,L.localize)(15,null,h):h===1?(0,L.localize)(16,null,h):(0,L.localize)(17,null,h)):p<D?(h=Math.floor(p/T),f?h===1?(0,L.localize)(18,null,h):(0,L.localize)(19,null,h):h===1?(0,L.localize)(20,null,h):(0,L.localize)(21,null,h)):p<C?(h=Math.floor(p/D),f?h===1?(0,L.localize)(22,null,h):(0,L.localize)(23,null,h):h===1?(0,L.localize)(24,null,h):(0,L.localize)(25,null,h)):(h=Math.floor(p/C),f?h===1?(0,L.localize)(26,null,h):(0,L.localize)(27,null,h):h===1?(0,L.localize)(28,null,h):(0,L.localize)(29,null,h))}e.fromNow=b;function P(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(ne[120],ie([11,12]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(ne[37],ie([0,1,17,15,120]),function(Q,e,L,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function _(b,P){return P&&(b.stack||b.stacktrace)?k.localize(0,null,D(b),T(b.stack)||T(b.stacktrace)):D(b)}function T(b){return Array.isArray(b)?b.join(`
`):b}function D(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?k.localize(1,null,b.message):b.message||k.localize(2,null)}function C(b=null,P=!1){if(!b)return k.localize(3,null);if(Array.isArray(b)){const E=L.coalesce(b),f=C(E[0],P);return E.length>1?k.localize(4,null,f,E.length):f}if(i.isString(b))return b;if(b.detail){const E=b.detail;if(E.error)return _(E.error,P);if(E.exception)return _(E.exception,P)}return b.stack?_(b,P):b.message?b.message:k.localize(5,null)}e.toErrorMessage=C}),define(ne[121],ie([11,12]),function(Q,e){return Q.create("vs/base/node/processes",e)}),define(ne[74],ie([0,1,45,41,16,28,9,4,31,100,15,109,20,121]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return b.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return b.TerminateResponseCode}});function h(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function S(r,a){if(D.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};a&&(n.cwd=a);const t=L.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],n);return new Promise(s=>{t.once("error",o=>{s({success:!1,error:o})}),t.once("exit",(o,u)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?h(n.status):1})}else if(D.isLinux||D.isMacintosh)try{const n=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Q).fsPath;return new Promise(t=>{L.execFile(n,[r.pid.toString()],{encoding:"utf8",shell:!0},(s,o,u)=>{t(s?{success:!1,error:s}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function v(r){!r||(delete r.DEBUG,D.isMacintosh&&delete r.DYLD_LIBRARY_PATH,D.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=v;function y(r=C.env){return r.comspec||"cmd.exe"}e.getWindowsShell=y;class w{constructor(a,n,t,s){if(n!==void 0&&t!==void 0&&s!==void 0)this.cmd=a,this.args=n,this.shell=t,this.options=s;else{const o=a;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(C.env).forEach(u=>{o[u]=C.env[u]}),Object.keys(this.options.env).forEach(u=>{o[u]=this.options.env[u]}),this.options.env=o}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const n=a.lastIndexOf(T.sep);return n!==-1&&(a=a.substring(n+1)),w.WellKnowCommands[a]?a:"other"}start(a){return D.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(C.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(n=>{let t,s;const o=new Promise((u,d)=>{t=u,s=d});if(n){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=L.exec(u,this.options,(d,m,I)=>{this.childProcess=null;const A=d;A&&A.killed?s({killed:this.terminateRequested,stdout:m.toString(),stderr:I.toString()}):this.handleExec(t,a,d,m,I)})}else{let u=null;const d=m=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(m,t,a,s);const I={terminated:this.terminateRequested};P.isNumber(m)&&(I.cmdCode=m),t(I)};if(this.shell&&D.isWindows){const m=_.deepClone(this.options);m.windowsVerbatimArguments=!0,m.detached=!1;let I=!1,A=!1;const O=[];let N=this.ensureQuotes(this.cmd);O.push(N.value),I=N.quoted,this.args&&this.args.forEach(R=>{N=this.ensureQuotes(R),O.push(N.value),A=A&&N.quoted});const $=["/s","/c"];I?A?$.push('"'+O.join(" ")+'"'):O.length>1?$.push('"'+O[0]+'" '+O.slice(1).join(" ")):$.push('"'+O[0]+'"'):$.push(O.join(" ")),u=L.spawn(y(),$,m)}else this.cmd&&(u=L.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(P.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",m=>{this.childProcess=null,s({terminated:this.terminateRequested,error:m})}),u.pid&&(this.childProcess.on("close",d),this.handleSpawn(u,t,a,s,!0)))}return o})}handleClose(a,n,t,s){}ensureQuotes(a){return w.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,S(a,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!D.isWindows)return a(!1);const n=L.spawn(y(),["/s","/c"]);n.on("error",t=>a(!0)),n.on("exit",t=>a(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class g extends w{constructor(a,n,t,s){super(a,n,t,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,n,t,s,o){[s,o].forEach((u,d)=>{const m=new E.LineDecoder;m.write(u).forEach(O=>{n({line:O,source:d===0?0:1})});const A=m.end();A&&n({line:A,source:d===0?0:1})}),a({terminated:this.terminateRequested,error:t})}handleSpawn(a,n,t,s,o){const u=new E.LineDecoder,d=new E.LineDecoder;a.stdout.on("data",m=>{u.write(m).forEach(A=>t({line:A,source:0}))}),a.stderr.on("data",m=>{d.write(m).forEach(A=>t({line:A,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=d}handleClose(a,n,t,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&t({line:o,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&t({line:u,source:1})}}e.LineProcess=g;function c(r){let a=[],n=!1;const t=function(s){if(n){a.push(s);return}(!r.send(s,u=>{if(u&&console.error(u),n=!1,a.length>0){const d=a.slice(0);a=[],d.forEach(m=>t(m))}})||D.isWindows)&&(n=!0)};return{send:t}}e.createQueuedSender=c;var l;(function(r){async function a(n,t,s){if(T.isAbsolute(n))return n;if(t===void 0&&(t=C.cwd()),T.dirname(n)!=="."||(s===void 0&&P.isString(C.env.PATH)&&(s=C.env.PATH.split(T.delimiter)),s===void 0||s.length===0))return T.join(t,n);async function u(d){if(await f.Promises.exists(d)){let m;try{m=await f.Promises.stat(d)}catch(I){I.message.startsWith("EACCES")&&(m=await f.Promises.lstat(d))}return m?!m.isDirectory():!1}return!1}for(let d of s){let m;if(T.isAbsolute(d)?m=T.join(d,n):m=T.join(t,d,n),await u(m))return m;let I=m+".com";if(await u(I)||(I=m+".exe",await u(I)))return I}return T.join(t,n)}r.findExecutable=a})(l=e.win32||(e.win32={}))}),define(ne[122],ie([0,1,32,4,70,74]),function(Q,e,L,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function T(p,h){return p===1?i.isWindows?E():_.getWindowsShell(h):b(p,h)}e.getSystemShell=T;function D(p,h){return p===1?i.isWindows?f(h):_.getWindowsShell(h):b(p,h)}e.getSystemShellSync=D;let C=null;function b(p,h){if(i.isLinux&&p===2||i.isMacintosh&&p===3)return"/bin/bash";if(!C){let S;if(i.isWindows)S="/bin/bash";else{if(S=h.SHELL,!S)try{S=(0,L.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}C=S}return C}let P=null;async function E(){return P||(P=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),P}function f(p){if(P)return P;const h=i.isWindows&&parseFloat((0,L.release)())>=10,S=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${p.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?v:_.getWindowsShell(p)}}),define(ne[57],ie([0,1,45,5,18,27,104,8,3,2,28,74,36]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends f.ChannelServer{constructor(v){super({send:y=>{try{process.send&&process.send(y.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",y=>k.VSBuffer.wrap(Buffer.from(y,"base64")))},v);process.once("disconnect",()=>this.dispose())}}e.Server=p;class h{constructor(v,y){this.modulePath=v,this.options=y,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new C.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=y&&y.timeout?y.timeout:6e4;this.disposeDelayer=new i.Delayer(w),this.child=null,this._client=null}getChannel(v){const y=this;return{call(w,g,c){return y.requestPromise(v,w,g,c)},listen(w,g){return y.requestEvent(v,w,g)}}}requestPromise(v,y,w,g=_.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(D.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(v),l=(0,i.createCancelablePromise)(n=>c.call(y,w,n)),r=g.onCancellationRequested(()=>l.cancel()),a=(0,b.toDisposable)(()=>l.cancel());return this.activeRequests.add(a),l.finally(()=>{r.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(v,y,w){if(!this.disposeDelayer)return C.Event.None;this.disposeDelayer.cancel();let g;const c=new C.Emitter({onFirstListenerAdd:()=>{g=this.getCachedChannel(v).listen(y,w)(c.fire,c),this.activeRequests.add(g)},onLastListenerRemove:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],y=Object.create(null);y.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(y.env={...y.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(y.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),y.execArgv===void 0&&(y.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,E.removeDangerousEnvVariables)(y.env),this.child=(0,L.fork)(this.modulePath,v,y);const w=new C.Emitter;C.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,T.isRemoteConsoleLog)(t)){(0,T.log)(t,`IPC Library: ${this.options.serverName}`);return}w.fire(k.VSBuffer.wrap(Buffer.from(t,"base64")))});const c=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,l=t=>this.child&&this.child.connected&&c.send(t.buffer.toString("base64")),r=w.event,a={send:l,onMessage:r};this._client=new f.ChannelClient(a);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,s)=>{process.removeListener("exit",n),this.activeRequests.forEach(o=>(0,b.dispose)(o)),this.activeRequests.clear(),t!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:s})})}return this._client}getCachedChannel(v){let y=this.channels.get(v);return y||(y=this.client.getChannel(v),this.channels.set(v,y)),y}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(ne[123],ie([11,12]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(ne[124],ie([11,12]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[125],ie([11,12]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(ne[126],ie([11,12]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(ne[127],ie([11,12]),function(Q,e){return Q.create("vs/platform/environment/node/shellEnv",e)}),define(ne[128],ie([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[129],ie([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[130],ie([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[131],ie([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[132],ie([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[133],ie([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(ne[134],ie([11,12]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[135],ie([11,12]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(ne[136],ie([11,12]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(ne[137],ie([11,12]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(ne[138],ie([11,12]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[139],ie([11,12]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(ne[140],ie([11,12]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[141],ie([11,12]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[142],ie([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[143],ie([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[144],ie([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[145],ie([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[146],ie([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[147],ie([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[148],ie([0,1,4]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var i;(function(T){T.Team="team",T.Internal="internal",T.Insiders="insider",T.Public="public"})(i=e.TargetPopulation||(e.TargetPopulation={}));var k;(function(T){T.Market="X-MSEdge-Market",T.CorpNet="X-FD-Corpnet",T.ApplicationVersion="X-VSCode-AppVersion",T.Build="X-VSCode-Build",T.ClientId="X-MSEdge-ClientId",T.ExtensionName="X-VSCode-ExtensionName",T.Language="X-VSCode-Language",T.TargetPopulation="X-VSCode-TargetPopulation"})(k=e.Filters||(e.Filters={}));class _{constructor(D,C,b,P){this.version=D,this.appName=C,this.machineId=b,this.targetPopulation=P}getFilterValue(D){switch(D){case k.ApplicationVersion:return this.version;case k.Build:return this.appName;case k.ClientId:return this.machineId;case k.Language:return L.language;case k.ExtensionName:return"vscode-core";case k.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let D=new Map,C=Object.values(k);for(let b of C)D.set(b,this.getFilterValue(b));return D}}e.AssignmentFilterProvider=_}),define(ne[75],ie([0,1,56,53,16,9,31,19,7]),function(Q,e,L,i,k,_,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(S,v,y){this._args=S,this.paths=v,this.productService=y}get appRoot(){return(0,_.dirname)(k.FileAccess.asFileUri("",Q).fsPath)}get userHome(){return C.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return C.URI.file((0,_.join)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.paths.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,D.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,D.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,_.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return C.URI.file((0,_.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,D.joinPath)(C.URI.file((0,_.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return C.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return C.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=T.env.VSCODE_PORTABLE;return S?C.URI.file((0,_.join)(S,"argv.json")):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,D.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,_.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,_.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,_.resolve)(S):(0,_.normalize)((0,_.join)(k.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,_.resolve)(S):(0,_.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,_.resolve)(S);const v=T.env.VSCODE_EXTENSIONS;if(v)return v;const y=T.env.VSCODE_PORTABLE;return y?(0,_.join)(y,"extensions"):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(v=>/^[^:/?#]+?:\/\//.test(v)?C.URI.parse(v):C.URI.file((0,_.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?C.URI.parse(S):C.URI.file((0,_.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,D.joinPath)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return C.URI.file((0,_.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([i.memoize],b.prototype,"appRoot",null),de([i.memoize],b.prototype,"userHome",null),de([i.memoize],b.prototype,"userDataPath",null),de([i.memoize],b.prototype,"appSettingsHome",null),de([i.memoize],b.prototype,"tmpDir",null),de([i.memoize],b.prototype,"cacheHome",null),de([i.memoize],b.prototype,"userRoamingDataHome",null),de([i.memoize],b.prototype,"settingsResource",null),de([i.memoize],b.prototype,"userDataSyncHome",null),de([i.memoize],b.prototype,"userDataSyncLogResource",null),de([i.memoize],b.prototype,"sync",null),de([i.memoize],b.prototype,"machineSettingsResource",null),de([i.memoize],b.prototype,"globalStorageHome",null),de([i.memoize],b.prototype,"workspaceStorageHome",null),de([i.memoize],b.prototype,"keybindingsResource",null),de([i.memoize],b.prototype,"keyboardLayoutResource",null),de([i.memoize],b.prototype,"argvResource",null),de([i.memoize],b.prototype,"snippetsHome",null),de([i.memoize],b.prototype,"isExtensionDevelopment",null),de([i.memoize],b.prototype,"untitledWorkspacesHome",null),de([i.memoize],b.prototype,"installSourcePath",null),de([i.memoize],b.prototype,"builtinExtensionsPath",null),de([i.memoize],b.prototype,"extensionsPath",null),de([i.memoize],b.prototype,"extensionDevelopmentLocationURI",null),de([i.memoize],b.prototype,"extensionDevelopmentKind",null),de([i.memoize],b.prototype,"extensionTestsLocationURI",null),de([i.memoize],b.prototype,"debugExtensionHost",null),de([i.memoize],b.prototype,"serviceMachineIdResource",null),de([i.memoize],b.prototype,"telemetryLogResource",null),de([i.memoize],b.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=b;function P(h,S){return p(h["inspect-extensions"],h["inspect-brk-extensions"],5870,S,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=P;function E(h,S){return p(h["inspect-search"],h["inspect-brk-search"],5876,S,h.extensionEnvironment)}e.parseSearchPort=E;function f(h,S){return p(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,S,h.extensionEnvironment)}e.parsePtyHostPort=f;function p(h,S,v,y,w,g){const l=Number(S||h)||(y?null:v),r=l?Boolean(!!S):!1;let a;if(g)try{a=JSON.parse(g)}catch{}return{port:l,break:r,debugId:w,env:a}}}),define(ne[149],ie([0,1,246,4,125]),function(Q,e,L,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const _={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,k.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(14,null)},category:{type:"string",cat:"e",description:(0,k.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,k.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,k.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,k.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,k.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,k.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function D(h,S,v=T){const y={},w=[],g=[];for(let a in S){const n=S[a];n.alias&&(y[a]=n.alias),n.type==="string"||n.type==="string[]"?(w.push(a),n.deprecates&&w.push(n.deprecates)):n.type==="boolean"&&(g.push(a),n.deprecates&&g.push(n.deprecates))}const c=L(h,{string:w,boolean:g,alias:y}),l={},r=c;l._=c._.map(a=>String(a)).filter(a=>a.length>0),delete r._;for(let a in S){const n=S[a];n.alias&&delete r[n.alias];let t=r[a];n.deprecates&&r.hasOwnProperty(n.deprecates)&&(t||(t=r[n.deprecates],t&&v.onDeprecatedOption(n.deprecates,a)),delete r[n.deprecates]),typeof t!="undefined"&&(n.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):n.type==="string"&&Array.isArray(t)&&(t=t.pop(),v.onMultipleValues(a,t)),l[a]=t),delete r[a]}for(let a in r)v.onUnknownOption(a);return l}e.parseArgs=D;function C(h,S){let v="";return S.args&&(Array.isArray(S.args)?v=` <${S.args.join("> <")}>`:v=` <${S.args}>`),S.alias?`-${S.alias} --${h}${v}`:`--${h}${v}`}function b(h,S){let v=0,y=[];for(const l in h){const r=h[l],a=C(l,r);v=Math.max(v,a.length),y.push([a,r.description])}let w=v+2+1;if(S-w<25)return y.reduce((l,r)=>l.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let g=S-w-1,c=[];for(const l of y){let r=l[0],a=E(l[1],g),n=P(w-r.length-2);c.push("  "+r+n+a[0]);for(let t=1;t<a.length;t++)c.push(P(w)+a[t])}return c}e.formatOptions=b;function P(h){return" ".repeat(h)}function E(h,S){let v=[];for(;h.length;){let y=h.length<S?h.length:h.lastIndexOf(" ",S),w=h.slice(0,y).trim();h=h.slice(y),v.push(w)}return v}function f(h,S,v,y,w){const g=process.stdout.isTTY&&process.stdout.columns||80,c=w?.noInputFiles!==!0?`[${(0,k.localize)(33,null)}...]`:"",l=[`${h} ${v}`];l.push(""),l.push(`${(0,k.localize)(34,null)}: ${S} [${(0,k.localize)(35,null)}]${c}`),l.push(""),w?.noPipe!==!0&&(i.isWindows?l.push((0,k.localize)(36,null,S)):l.push((0,k.localize)(37,null,S)),l.push(""));const r={};for(const a in y){const n=y[a];if(n.description&&n.cat){let t=r[n.cat];t||(r[n.cat]=t={}),t[a]=n}}for(let a in r){const n=a;let t=r[n];t&&(l.push(_[n]),l.push(...b(t,g)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=f;function p(h,S){return`${h||(0,k.localize)(38,null)}
${S||(0,k.localize)(39,null)}
${process.arch}`}e.buildVersionMessage=p}),function(){"use strict";function Q(e,L,i,k){function _(D){const C=T(D),b=[C];return e.isAbsolute(C)||b.unshift(k),e.resolve(...b)}function T(D){const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,i);const P=D["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(E,"AppData","Roaming")}break;case"darwin":b=e.join(L.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,i)}return{getUserDataPath:_}}if(typeof define=="function")define(ne[150],ie([0,151,32,16,19,31]),function(e,L,i,k,_,T){const D=_.dirname(k.FileAccess.asFileUri("",e)),C=e.__$__nodeRequire(_.joinPath(D,"package.json").fsPath);return Q(L,i,C.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),L=require("path"),i=require("os");module.exports=Q(L,i,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[152],ie([0,1,32,75,150]),function(Q,e,L,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class _ extends i.AbstractNativeEnvironmentService{constructor(D,C){super(D,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,k.getUserDataPath)(D)},C)}}e.NativeEnvironmentService=_}),define(ne[153],ie([0,1,7]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const i=/^([^@:]+@)?([^:]+):/,k=/^([^@:]+@)?([^:]+):(.+)$/,_=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,D=/^\s*url\s*=\s*(.+\S)\s*$/mg,C=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(v){const y=v.match(T);return y?y[1]:null}function P(v){if(v.indexOf("://")===-1){const y=v.match(i);return y?b(y[2]):null}try{const y=L.URI.parse(v);if(y.authority)return b(y.authority)}catch{}return null}function E(v,y){const w=new Set;let g;for(;g=D.exec(v);){const l=P(g[1]);l&&w.add(l)}const c=new Set(y);return Array.from(w).map(l=>c.has(l)?l:l.replace(C,"a"))}e.getDomainsOfRemotes=E;function f(v){const y=v.match(_);return y?y[2]:null}function p(v,y,w){return v&&y?(w&&y.endsWith(".git")&&(y=y.substr(0,y.length-4)),y.indexOf("/")===0?`${v}${y}`:`${v}/${y}`):null}function h(v,y){if(v.indexOf("://")===-1){const w=v.match(k);if(w)return p(w[2],w[3],y)}try{const w=L.URI.parse(v);if(w.authority)return p(f(w.authority),w.path,y)}catch{}return null}function S(v,y=!1){const w=[];let g;for(;g=D.exec(v);){const c=h(g[1],y);c&&w.push(c)}return w}e.getRemotes=S}),define(ne[154],ie([0,1,28]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const i=/^%([\w\d.-]+)%$/i;function k(_,T){const D=C=>{if(typeof C!="string")return;const b=i.exec(C);if(!b)return;const P=T[b[1]]??C;return typeof P=="string"?P:typeof P.message=="string"?P.message:C};return(0,L.cloneAndChange)(_,D)}e.localizeManifest=k}),define(ne[155],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class L{constructor(_){this.channel=_}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(_,T,D,C){return this.channel.call("promptImportantExtensionsInstallNotification",[_,T,D,C])}promptWorkspaceRecommendations(_){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=L;class i{constructor(_){this.service=_}listen(_,T){throw new Error(`Event not found: ${T}`)}call(_,T,D){switch(T){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(D[0],D[1],D[2],D[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=i}),define(ne[76],ie([0,1,134]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const i=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function _(f){return f=f.trim(),f==="*"||i.test(f)}e.isValidVersionStr=_;function T(f){if(!_(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=f.match(i);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=T;function D(f){if(!f)return null;let p=f.majorBase,h=f.majorMustEqual,S=f.minorBase,v=f.minorMustEqual,y=f.patchBase,w=f.patchMustEqual;f.hasCaret&&(p===0||(v=!1),w=!1);let g=0;if(f.preRelease){const c=k.exec(f.preRelease);if(c){const[,l,r,a]=c;g=Date.UTC(Number(l),Number(r)-1,Number(a))}}return{majorBase:p,majorMustEqual:h,minorBase:S,minorMustEqual:v,patchBase:y,patchMustEqual:w,isMinimum:f.hasGreaterEquals,notBefore:g}}e.normalizeVersion=D;function C(f,p,h){let S;typeof f=="string"?S=D(T(f)):S=f;let v;p instanceof Date?v=p.getTime():typeof p=="string"&&(v=new Date(p).getTime());let y;if(typeof h=="string"?y=D(T(h)):y=h,!S||!y)return!1;let w=S.majorBase,g=S.minorBase,c=S.patchBase,l=y.majorBase,r=y.minorBase,a=y.patchBase,n=y.notBefore,t=y.majorMustEqual,s=y.minorMustEqual,o=y.patchMustEqual;return y.isMinimum?w>l?!0:w<l?!1:g>r?!0:g<r||v&&v<n?!1:c>=a:(w===1&&l===0&&(!t||!s||!o)&&(l=1,r=0,a=0,t=!0,s=!1,o=!1),w<l?!1:w>l?!t:g<r?!1:g>r?!s:c<a?!1:c>a?!o:!(v&&v<n))}e.isValidVersion=C;function b(f,p,h,S){return h.isBuiltin||typeof h.main=="undefined"?!0:E(f,p,h.engines.vscode,S)}e.isValidExtensionVersion=b;function P(f,p,h){return f==="*"||E(p,h,f)}e.isEngineValid=P;function E(f,p,h,S=[]){let v=D(T(h));if(!v)return S.push(L.localize(0,null,h)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return S.push(L.localize(1,null,h)),!1}else if(!v.majorMustEqual)return S.push(L.localize(2,null,h)),!1;return C(f,p,v)?!0:(S.push(L.localize(3,null,f,h)),!1)}}),define(ne[51],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(k,_=[],T=!1){this.ctor=k,this.staticArguments=_,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=L}),define(ne[77],ie([0,1,51]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const i=[];function k(T,D,C){D instanceof L.SyncDescriptor||(D=new L.SyncDescriptor(D,[],C)),i.push([T,D])}e.registerSingleton=k;function _(){return i}e.getSingletonServiceDescriptors=_}),define(ne[156],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(_){this.incoming=new Map,this.outgoing=new Map,this.data=_}}e.Node=L;class i{constructor(_){this._hashFn=_,this._nodes=new Map}roots(){const _=[];for(let T of this._nodes.values())T.outgoing.size===0&&_.push(T);return _}insertEdge(_,T){const D=this.lookupOrInsertNode(_),C=this.lookupOrInsertNode(T);D.outgoing.set(this._hashFn(T),C),C.incoming.set(this._hashFn(_),D)}removeNode(_){const T=this._hashFn(_);this._nodes.delete(T);for(let D of this._nodes.values())D.outgoing.delete(T),D.incoming.delete(T)}lookupOrInsertNode(_){const T=this._hashFn(_);let D=this._nodes.get(T);return D||(D=new L(_),this._nodes.set(T,D)),D}lookup(_){return this._nodes.get(this._hashFn(_))}isEmpty(){return this._nodes.size===0}toString(){let _=[];for(let[T,D]of this._nodes)_.push(`${T}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return _.join(`
`)}findCycleSlow(){for(let[_,T]of this._nodes){const D=new Set([_]),C=this._findCycle(T,D);if(C)return C}}_findCycle(_,T){for(let[D,C]of _.outgoing){if(T.has(D))return[...T,D].join(" -> ");T.add(D);const b=this._findCycle(C,T);if(b)return b;T.delete(D)}}}e.Graph=i}),define(ne[6],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var L;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function D(C){return C[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=D})(L=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function i(T,D,C,b){D[L.DI_TARGET]===D?D[L.DI_DEPENDENCIES].push({id:T,index:C,optional:b}):(D[L.DI_DEPENDENCIES]=[{id:T,index:C,optional:b}],D[L.DI_TARGET]=D)}function k(T){if(L.serviceIds.has(T))return L.serviceIds.get(T);const D=function(C,b,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(D,C,P,!1)};return D.toString=()=>T,L.serviceIds.set(T,D),D}e.createDecorator=k;function _(T){return T}e.refineServiceDecorator=_}),define(ne[157],ie([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,L.createDecorator)("checksumService")}),define(ne[21],ie([0,1,15,7,6]),function(Q,e,L,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function _(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof i.URI)}e.isConfigurationOverrides=_;function T(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||L.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=T;var D;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(D=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function b(v,y){const w=Object.create(null);for(let g in v)P(w,g,v[g],y);return w}e.toValuesTree=b;function P(v,y,w,g){const c=y.split("."),l=c.pop();let r=v;for(let a=0;a<c.length;a++){let n=c[a],t=r[n];switch(typeof t){case"undefined":t=r[n]=Object.create(null);break;case"object":break;default:g(`Ignoring ${y} as ${c.slice(0,a+1).join(".")} is ${JSON.stringify(t)}`);return}r=t}if(typeof r=="object"&&r!==null)try{r[l]=w}catch{g(`Ignoring ${y} as ${c.join(".")} is ${JSON.stringify(r)}`)}else g(`Ignoring ${y} as ${c.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=P;function E(v,y){const w=y.split(".");f(v,w)}e.removeFromValueTree=E;function f(v,y){const w=y.shift();if(y.length===0){delete v[w];return}if(Object.keys(v).indexOf(w)!==-1){const g=v[w];typeof g=="object"&&!Array.isArray(g)&&(f(g,y),Object.keys(g).length===0&&delete v[w])}}function p(v,y,w){function g(r,a){let n=r;for(const t of a){if(typeof n!="object"||n===null)return;n=n[t]}return n}const c=y.split("."),l=g(v,c);return typeof l=="undefined"?w:l}e.getConfigurationValue=p;function h(v,y,w){Object.keys(y).forEach(g=>{g!=="__proto__"&&(g in v?L.isObject(v[g])&&L.isObject(y[g])?h(v[g],y[g],w):w&&(v[g]=y[g]):v[g]=y[g])})}e.merge=h;function S(v,y,w){const g=v.inspect(y),c=v.inspect(w);return typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:g.defaultValue}e.getMigratedSettingValue=S}),define(ne[158],ie([0,1,4,25,6]),function(Q,e,L,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let _=L.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",L.isMacintosh),T.set("isLinux",L.isLinux),T.set("isWindows",L.isWindows),T.set("isWeb",L.isWeb),T.set("isMacNative",L.isMacintosh&&!L.isWeb),T.set("isEdge",_.indexOf("Edg/")>=0),T.set("isFirefox",_.indexOf("Firefox")>=0),T.set("isChrome",_.indexOf("Chrome")>=0),T.set("isSafari",_.indexOf("Safari")>=0);const D=Object.prototype.hasOwnProperty;var C;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return f.INSTANCE}static true(){return p.INSTANCE}static has(R){return h.create(R)}static equals(R,M){return S.create(R,M)}static notEquals(R,M){return w.create(R,M)}static regex(R,M){return t.create(R,M)}static in(R,M){return v.create(R,M)}static not(R){return g.create(R)}static and(...R){return u.create(R,null)}static or(...R){return d.create(R,null,!0)}static greater(R,M){return l.create(R,M)}static greaterEquals(R,M){return r.create(R,M)}static smaller(R,M){return a.create(R,M)}static smallerEquals(R,M){return n.create(R,M)}static deserialize(R,M=!1){if(!!R)return this._deserializeOrExpression(R,M)}static _deserializeOrExpression(R,M){let W=R.split("||");return d.create(W.map(U=>this._deserializeAndExpression(U,M)),null,!0)}static _deserializeAndExpression(R,M){let W=R.split("&&");return u.create(W.map(U=>this._deserializeOne(U,M)),null)}static _deserializeOne(R,M){if(R=R.trim(),R.indexOf("!=")>=0){let W=R.split("!=");return w.create(W[0].trim(),this._deserializeValue(W[1],M))}if(R.indexOf("==")>=0){let W=R.split("==");return S.create(W[0].trim(),this._deserializeValue(W[1],M))}if(R.indexOf("=~")>=0){let W=R.split("=~");return t.create(W[0].trim(),this._deserializeRegexValue(W[1],M))}if(R.indexOf(" in ")>=0){let W=R.split(" in ");return v.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(R)){const W=R.split(">=");return r.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(R)){const W=R.split(">");return l.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(R)){const W=R.split("<=");return n.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(R)){const W=R.split("<");return a.create(W[0].trim(),W[1].trim())}return/^\!\s*/.test(R)?g.create(R.substr(1).trim()):h.create(R)}static _deserializeValue(R,M){if(R=R.trim(),R==="true")return!0;if(R==="false")return!1;let W=/^'([^']*)'$/.exec(R);return W?W[1].trim():R}static _deserializeRegexValue(R,M){if((0,i.isFalsyOrWhitespace)(R)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let W=R.indexOf("/"),U=R.lastIndexOf("/");if(W===U||W<0){if(M)throw new Error(`bad regexp-value '${R}', missing /-enclosure`);return console.warn(`bad regexp-value '${R}', missing /-enclosure`),null}let x=R.slice(W+1,U),ee=R[U+1]==="i"?"i":"";try{return new RegExp(x,ee)}catch(G){if(M)throw new Error(`bad regexp-value '${R}', parse error: ${G}`);return console.warn(`bad regexp-value '${R}', parse error: ${G}`),null}}}e.ContextKeyExpr=b;function P($,R){const M=$?$.substituteConstants():void 0,W=R?R.substituteConstants():void 0;return!M&&!W?!0:!M||!W?!1:M.equals(W)}e.expressionsAreEqualWithConstantSubstitution=P;function E($,R){return $.cmp(R)}class f{constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=f,f.INSTANCE=new f;class p{constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return f.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class h{constructor(R,M){this.key=R,this.negated=M,this.type=2}static create(R,M=null){const W=T.get(R);return typeof W=="boolean"?W?p.INSTANCE:f.INSTANCE:new h(R,M)}cmp(R){return R.type!==this.type?this.type-R.type:I(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=T.get(this.key);return typeof R=="boolean"?R?p.INSTANCE:f.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class S{constructor(R,M,W){this.key=R,this.value=M,this.negated=W,this.type=4}static create(R,M,W=null){if(typeof M=="boolean")return M?h.create(R,W):g.create(R,W);const U=T.get(R);return typeof U=="boolean"?M===(U?"true":"false")?p.INSTANCE:f.INSTANCE:new S(R,M,W)}cmp(R){return R.type!==this.type?this.type-R.type:A(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=T.get(this.key);if(typeof R=="boolean"){const M=R?"true":"false";return this.value===M?p.INSTANCE:f.INSTANCE}return this}evaluate(R){return R.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(R){return R.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=S;class v{constructor(R,M){this.key=R,this.valueKey=M,this.type=10,this.negated=null}static create(R,M){return new v(R,M)}cmp(R){return R.type!==this.type?this.type-R.type:A(this.key,this.valueKey,R.key,R.valueKey)}equals(R){return R.type===this.type?this.key===R.key&&this.valueKey===R.valueKey:!1}substituteConstants(){return this}evaluate(R){const M=R.getValue(this.valueKey),W=R.getValue(this.key);return Array.isArray(M)?M.indexOf(W)>=0:typeof W=="string"&&typeof M=="object"&&M!==null?D.call(M,W):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(R){return R.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=y.create(this)),this.negated}}e.ContextKeyInExpr=v;class y{constructor(R){this._actual=R,this.type=11}static create(R){return new y(R)}cmp(R){return R.type!==this.type?this.type-R.type:this._actual.cmp(R._actual)}equals(R){return R.type===this.type?this._actual.equals(R._actual):!1}substituteConstants(){return this}evaluate(R){return!this._actual.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(R){return new y(this._actual.map(R))}negate(){return this._actual}}e.ContextKeyNotInExpr=y;class w{constructor(R,M,W){this.key=R,this.value=M,this.negated=W,this.type=5}static create(R,M,W=null){if(typeof M=="boolean")return M?g.create(R,W):h.create(R,W);const U=T.get(R);return typeof U=="boolean"?M===(U?"true":"false")?f.INSTANCE:p.INSTANCE:new w(R,M,W)}cmp(R){return R.type!==this.type?this.type-R.type:A(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=T.get(this.key);if(typeof R=="boolean"){const M=R?"true":"false";return this.value===M?f.INSTANCE:p.INSTANCE}return this}evaluate(R){return R.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(R){return R.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class g{constructor(R,M){this.key=R,this.negated=M,this.type=3}static create(R,M=null){const W=T.get(R);return typeof W=="boolean"?W?f.INSTANCE:p.INSTANCE:new g(R,M)}cmp(R){return R.type!==this.type?this.type-R.type:I(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=T.get(this.key);return typeof R=="boolean"?R?f.INSTANCE:p.INSTANCE:this}evaluate(R){return!R.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(R){return R.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function c($,R){if(typeof $=="string"){const M=parseFloat($);isNaN(M)||($=M)}return typeof $=="string"||typeof $=="number"?R($):f.INSTANCE}class l{constructor(R,M,W){this.key=R,this.value=M,this.negated=W,this.type=12}static create(R,M,W=null){return c(M,U=>new l(R,U,W))}cmp(R){return R.type!==this.type?this.type-R.type:A(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class r{constructor(R,M,W){this.key=R,this.value=M,this.negated=W,this.type=13}static create(R,M,W=null){return c(M,U=>new r(R,U,W))}cmp(R){return R.type!==this.type?this.type-R.type:A(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class a{constructor(R,M,W){this.key=R,this.value=M,this.negated=W,this.type=14}static create(R,M,W=null){return c(M,U=>new a(R,U,W))}cmp(R){return R.type!==this.type?this.type-R.type:A(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class n{constructor(R,M,W){this.key=R,this.value=M,this.negated=W,this.type=15}static create(R,M,W=null){return c(M,U=>new n(R,U,W))}cmp(R){return R.type!==this.type?this.type-R.type:A(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(R,M){this.key=R,this.regexp=M,this.type=7,this.negated=null}static create(R,M){return new t(R,M)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.key<R.key)return-1;if(this.key>R.key)return 1;const M=this.regexp?this.regexp.source:"",W=R.regexp?R.regexp.source:"";return M<W?-1:M>W?1:0}equals(R){if(R.type===this.type){const M=this.regexp?this.regexp.source:"",W=R.regexp?R.regexp.source:"";return this.key===R.key&&M===W}return!1}substituteConstants(){return this}evaluate(R){let M=R.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const R=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${R}`}keys(){return[this.key]}map(R){return R.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class s{constructor(R){this._actual=R,this.type=8}static create(R){return new s(R)}cmp(R){return R.type!==this.type?this.type-R.type:this._actual.cmp(R._actual)}equals(R){return R.type===this.type?this._actual.equals(R._actual):!1}substituteConstants(){return this}evaluate(R){return!this._actual.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(R){return new s(this._actual.map(R))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function o($){let R=null;for(let M=0,W=$.length;M<W;M++){const U=$[M].substituteConstants();if($[M]!==U&&R===null){R=[];for(let x=0;x<M;x++)R[x]=$[x]}R!==null&&(R[M]=U)}return R===null?$:R}class u{constructor(R,M){this.expr=R,this.negated=M,this.type=6}static create(R,M){return u._normalizeArr(R,M)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let M=0,W=this.expr.length;M<W;M++){const U=E(this.expr[M],R.expr[M]);if(U!==0)return U}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let M=0,W=this.expr.length;M<W;M++)if(!this.expr[M].equals(R.expr[M]))return!1;return!0}return!1}substituteConstants(){const R=o(this.expr);return R===this.expr?this:u.create(R,this.negated)}evaluate(R){for(let M=0,W=this.expr.length;M<W;M++)if(!this.expr[M].evaluate(R))return!1;return!0}static _normalizeArr(R,M){const W=[];let U=!1;for(const x of R)if(!!x){if(x.type===1){U=!0;continue}if(x.type===0)return f.INSTANCE;if(x.type===6){W.push(...x.expr);continue}W.push(x)}if(W.length===0&&U)return p.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(E);for(let x=1;x<W.length;x++)W[x-1].equals(W[x])&&(W.splice(x,1),x--);if(W.length===1)return W[0];for(;W.length>1;){const x=W[W.length-1];if(x.type!==9)break;W.pop();const ee=W.pop(),G=W.length===0,q=d.create(x.expr.map(Y=>u.create([Y,ee],null)),null,G);q&&(W.push(q),W.sort(E))}return W.length===1?W[0]:new u(W,M)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(let M of this.expr)R.push(...M.keys());return R}map(R){return new u(this.expr.map(M=>M.map(R)),null)}negate(){if(!this.negated){const R=[];for(let M of this.expr)R.push(M.negate());this.negated=d.create(R,this,!0)}return this.negated}}class d{constructor(R,M){this.expr=R,this.negated=M,this.type=9}static create(R,M,W){return d._normalizeArr(R,M,W)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let M=0,W=this.expr.length;M<W;M++){const U=E(this.expr[M],R.expr[M]);if(U!==0)return U}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let M=0,W=this.expr.length;M<W;M++)if(!this.expr[M].equals(R.expr[M]))return!1;return!0}return!1}substituteConstants(){const R=o(this.expr);return R===this.expr?this:d.create(R,this.negated,!1)}evaluate(R){for(let M=0,W=this.expr.length;M<W;M++)if(this.expr[M].evaluate(R))return!0;return!1}static _normalizeArr(R,M,W){let U=[],x=!1;if(R){for(let ee=0,G=R.length;ee<G;ee++){const q=R[ee];if(!!q){if(q.type===0){x=!0;continue}if(q.type===1)return p.INSTANCE;if(q.type===9){U=U.concat(q.expr);continue}U.push(q)}}if(U.length===0&&x)return f.INSTANCE;U.sort(E)}if(U.length!==0){if(U.length===1)return U[0];for(let ee=1;ee<U.length;ee++)U[ee-1].equals(U[ee])&&(U.splice(ee,1),ee--);if(U.length===1)return U[0];if(W){for(let ee=0;ee<U.length;ee++)for(let G=ee+1;G<U.length;G++)O(U[ee],U[G])&&(U.splice(G,1),G--);if(U.length===1)return U[0]}return new d(U,M)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(let M of this.expr)R.push(...M.keys());return R}map(R){return new d(this.expr.map(M=>M.map(R)),null)}negate(){if(!this.negated){let R=[];for(let M of this.expr)R.push(M.negate());for(;R.length>1;){const M=R.shift(),W=R.shift(),U=[];for(const ee of N(M))for(const G of N(W))U.push(u.create([ee,G],null));const x=R.length===0;R.unshift(d.create(U,null,x))}this.negated=R[0]}return this.negated}}class m extends h{constructor(R,M,W){super(R,null);this._defaultValue=M,typeof W=="object"?m._info.push({...W,key:R}):W!==!0&&m._info.push({key:R,description:W,type:M!=null?typeof M:void 0})}static all(){return m._info.values()}bindTo(R){return R.createKey(this.key,this._defaultValue)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return S.create(this.key,R)}notEqualsTo(R){return w.create(this.key,R)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function I($,R){return $<R?-1:$>R?1:0}function A($,R,M,W){return $<M?-1:$>M?1:R<W?-1:R>W?1:0}function O($,R){if(R.type===6&&$.type!==9&&$.type!==6){for(const U of R.expr)if($.equals(U))return!0}const M=$.negate(),W=N(M).concat(N(R));W.sort(E);for(let U=0;U<W.length;U++){const ee=W[U].negate();for(let G=U+1;G<W.length;G++){const q=W[G];if(ee.equals(q))return!0}}return!1}e.implies=O;function N($){return $.type===9?$.expr:[$]}}),define(ne[78],ie([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,L.createDecorator)(e.ID);function i(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=i}),define(ne[79],ie([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(ne[13],ie([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[29],ie([0,1,16,129,6]),function(Q,e,L,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var _;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(_=e.TargetPlatform||(e.TargetPlatform={}));function T(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function D(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=D;function C(g,c){switch(g){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function b(g,c){return c==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function P(g,c,l){return b(c,l)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===l?!0:E(l).includes(g)}e.isTargetPlatformCompatible=P;function E(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function f(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=f;var p;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var h;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var S;(function(g){g.Install="install",g.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var v;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var y;(function(g){g.Unsupported="Unsupported",g.UnsupportedPreRelease="UnsupportedPreRelease",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatiblePreRelease="IncompatiblePreRelease",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal"})(y=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(c,l){super(c);this.code=l,this.name=l}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",Q).toString(!0),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")});var J=this&&this.__param||function(Q,e){return function(L,i){e(L,i,Q)}};define(ne[159],ie([0,1,2,29]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let k=class extends L.Disposable{constructor(T){super();T.removeDeprecatedExtensions(),T.migrateUnsupportedExtensions()}};k=de([J(0,i.IExtensionManagementService)],k),e.ExtensionsCleaner=k}),define(ne[160],ie([0,1,3,2,28,7,108,29]),function(Q,e,L,i,k,_,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function C(S,v){return _.URI.revive(v?v.transformIncoming(S):S)}function b(S,v){return v?v.transformOutgoingURI(S):S}function P(S,v){v=v||T.DefaultURITransformer;const y=S.manifest;return{...(0,T.transformAndReviveIncomingURIs)({...S,manifest:void 0},v),manifest:y}}function E(S,v){return v?(0,k.cloneAndChange)(S,y=>y instanceof _.URI?v.transformOutgoingURI(y):void 0):S}class f{constructor(v,y){this.service=v,this.getUriTransformer=y,this.onInstallExtension=L.Event.buffer(v.onInstallExtension,!0),this.onDidInstallExtensions=L.Event.buffer(v.onDidInstallExtensions,!0),this.onUninstallExtension=L.Event.buffer(v.onUninstallExtension,!0),this.onDidUninstallExtension=L.Event.buffer(v.onDidUninstallExtension,!0)}listen(v,y){const w=this.getUriTransformer(v);switch(y){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return L.Event.map(this.onDidInstallExtensions,g=>g.map(c=>({...c,local:c.local?E(c.local,w):c.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(v,y,w){const g=this.getUriTransformer(v);switch(y){case"zip":return this.service.zip(P(w[0],g)).then(c=>b(c,g));case"unzip":return this.service.unzip(C(w[0],g));case"install":return this.service.install(C(w[0],g),w[1]);case"getManifest":return this.service.getManifest(C(w[0],g));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(P(w[0],g),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(P(w[0],g));case"getInstalled":return this.service.getInstalled(w[0]).then(c=>c.map(l=>E(l,g)));case"updateMetadata":return this.service.updateMetadata(P(w[0],g),w[1]).then(c=>E(c,g));case"updateExtensionScope":return this.service.updateExtensionScope(P(w[0],g),w[1]).then(c=>E(c,g));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class p extends i.Disposable{constructor(v){super();this.channel=v,this._onInstallExtension=this._register(new L.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new L.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new L.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new L.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(y=>this._onInstallExtension.fire({identifier:y.identifier,source:this.isUriComponents(y.source)?_.URI.revive(y.source):y.source}))),this._register(this.channel.listen("onDidInstallExtensions")(y=>this._onDidInstallExtensions.fire(y.map(w=>({...w,local:w.local?P(w.local,null):w.local,source:this.isUriComponents(w.source)?_.URI.revive(w.source):w.source}))))),this._register(this.channel.listen("onUninstallExtension")(y=>this._onUninstallExtension.fire(y))),this._register(this.channel.listen("onDidUninstallExtension")(y=>this._onDidUninstallExtension.fire(y)))}isUriComponents(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(v){const y=await this.getTargetPlatform();return v.allTargetPlatforms.some(w=>(0,D.isTargetPlatformCompatible)(w,v.allTargetPlatforms,y))}zip(v){return Promise.resolve(this.channel.call("zip",[v]).then(y=>_.URI.revive(y)))}unzip(v){return Promise.resolve(this.channel.call("unzip",[v]))}install(v,y){return Promise.resolve(this.channel.call("install",[v,y])).then(w=>P(w,null))}getManifest(v){return Promise.resolve(this.channel.call("getManifest",[v]))}installFromGallery(v,y){return Promise.resolve(this.channel.call("installFromGallery",[v,y])).then(w=>P(w,null))}uninstall(v,y){return Promise.resolve(this.channel.call("uninstall",[v,y]))}reinstallFromGallery(v){return Promise.resolve(this.channel.call("reinstallFromGallery",[v]))}getInstalled(v=null){return Promise.resolve(this.channel.call("getInstalled",[v])).then(y=>y.map(w=>P(w,null)))}updateMetadata(v,y){return Promise.resolve(this.channel.call("updateMetadata",[v,y])).then(w=>P(w,null))}updateExtensionScope(v,y){return Promise.resolve(this.channel.call("updateExtensionScope",[v,y])).then(w=>P(w,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class h{constructor(v){this.service=v}listen(v,y){throw new Error("Invalid listen")}call(v,y,w){switch(y){case"getConfigBasedTips":return this.service.getConfigBasedTips(_.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(ne[80],ie([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var i;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(i=e.RecommendationSource||(e.RecommendationSource={}));function k(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=k;var _;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(_=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,L.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[14],ie([0,1,39,9,25,15,7,136,6]),function(Q,e,L,i,k,_,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function b(U){return U.create===!0}e.isFileOpenForWriteOptions=b;var P;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(P=e.FileType||(e.FileType={}));var E;(function(U){U[U.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var f;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=p;function h(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=h;function S(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=S;function v(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=v;function y(U){return p(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=y;var w;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(x,ee){super(x);this.code=ee}}e.FileSystemProviderError=g;function c(U,x){const ee=new g(U.toString(),x);return r(ee,x),ee}e.createFileSystemProviderError=c;function l(U){return U||c((0,D.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=l;function r(U,x){return U.name=x?`${x} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=r;function a(U){if(!U)return w.Unknown;if(U instanceof g)return U.code;const x=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!x)return w.Unknown;switch(x[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=a;function n(U){if(U instanceof m)return U.fileOperationResult;switch(a(U)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var t;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class s{constructor(x,ee,G){this.resource=x,this.operation=ee,this.target=G}isOperation(x){return this.operation===x}}e.FileOperationEvent=s;var o;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class u{constructor(x,ee){this.added=void 0,this.updated=void 0,this.deleted=void 0;const G=new Map;for(const q of x){const Y=G.get(q.type);Y?Y.push([q.resource,q]):G.set(q.type,[[q.resource,q]])}for(const[q,Y]of G)switch(q){case 1:this.added=L.TernarySearchTree.forUris(()=>ee),this.added.fill(Y);break;case 0:this.updated=L.TernarySearchTree.forUris(()=>ee),this.updated.fill(Y);break;case 2:this.deleted=L.TernarySearchTree.forUris(()=>ee),this.deleted.fill(Y);break}}contains(x,...ee){return this.doContains(x,{includeChildren:!1},...ee)}affects(x,...ee){return this.doContains(x,{includeChildren:!0},...ee)}doContains(x,ee,...G){if(!x)return!1;const q=G.length>0;return!!((!q||G.includes(1))&&(this.added?.get(x)||ee.includeChildren&&this.added?.findSuperstr(x))||(!q||G.includes(0))&&(this.updated?.get(x)||ee.includeChildren&&this.updated?.findSuperstr(x))||(!q||G.includes(2))&&(this.deleted?.findSubstr(x)||ee.includeChildren&&this.deleted?.findSuperstr(x)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=u;function d(U,x,ee){return!U||!x||U===x||x.length>U.length?!1:(x.charAt(x.length-1)!==i.sep&&(x+=i.sep),ee?(0,k.startsWithIgnoreCase)(U,x):U.indexOf(x)===0)}e.isParent=d;class m extends Error{constructor(x,ee,G){super(x);this.fileOperationResult=ee,this.options=G}}e.FileOperationError=m;class I extends m{constructor(x,ee,G){super(x,2,G);this.stat=ee}}e.NotModifiedSinceFileOperationError=I;var A;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=N;async function $(U,x){if(!x.hasProvider(T.URI.from({scheme:U.scheme})))return new Promise(ee=>{const G=x.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===U.scheme&&q.added&&(G.dispose(),ee())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class R{static formatSize(x){return(0,_.isNumber)(x)||(x=0),x<R.KB?(0,D.localize)(1,null,x.toFixed(0)):x<R.MB?(0,D.localize)(2,null,(x/R.KB).toFixed(2)):x<R.GB?(0,D.localize)(3,null,(x/R.MB).toFixed(2)):x<R.TB?(0,D.localize)(4,null,(x/R.GB).toFixed(2)):(0,D.localize)(5,null,(x/R.TB).toFixed(2))}}e.ByteSize=R,R.KB=1024,R.MB=R.KB*R.KB,R.GB=R.MB*R.KB,R.TB=R.GB*R.KB;var M;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(M=e.Arch||(e.Arch={}));function W(U){return{maxFileSize:U===0?300*R.MB:16*R.GB,maxHeapSize:U===0?700*R.MB:2*700*R.MB}}e.getPlatformLimits=W}),define(ne[161],ie([0,1,81,40,14]),function(Q,e,L,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let _=class{constructor(D){this.fileService=D}async checksum(D){const C=(await this.fileService.readFileStream(D)).value;return new Promise((b,P)=>{const E=(0,L.createHash)("md5");(0,i.listenStream)(C,{onData:f=>E.update(f.buffer),onError:f=>P(f),onEnd:()=>b(E.digest("base64").replace(/=+$/,""))})})}};_=de([J(0,k.IFileService)],_),e.ChecksumService=_}),define(ne[162],ie([0,1,247,126,149,14]),function(Q,e,L,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function T(f,p){const h={onUnknownOption:v=>{console.warn((0,i.localize)(0,null,v))},onMultipleValues:(v,y)=>{console.warn((0,i.localize)(1,null,v,y))},onDeprecatedOption:(v,y)=>{console.warn((0,i.localize)(2,null,v,y))}},S=(0,k.parseArgs)(f,k.OPTIONS,p?h:void 0);return S.goto&&S._.forEach(v=>L(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,i.localize)(3,null))),S["max-memory"]&&L(parseInt(S["max-memory"])>=_.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${_.MIN_MAX_MEMORY_SIZE_MB} MB.`),S}function D(f){const p=f.findIndex(h=>!/^-/.test(h));if(p>-1)return[...f.slice(0,p),...f.slice(p+1)]}function C(f){let[,...p]=f;process.env.VSCODE_DEV&&(p=D(p)||[]);const h=!E(process.env);return T(p,h)}e.parseMainProcessArgv=C;function b(f){const[,,...p]=f;return T(p,!0)}e.parseCLIProcessArgv=b;function P(f,...p){const h=f.indexOf("--");return h===-1?f.push(...p):f.splice(h,0,...p),f}e.addArg=P;function E(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),define(ne[163],ie([0,1,45,9,127,27,37,8,4,30,122,162,5]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const p=1e4;let h;async function S(y,w,g){return w["force-disable-user-env"]?(y.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):C.isWindows?(y.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(g)&&!w["force-user-env"]?(y.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(g)?y.trace("resolveShellEnv(): running (--force-user-env)"):y.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=f.Promises.withAsyncBody(async(c,l)=>{const r=new _.CancellationTokenSource,a=setTimeout(()=>{r.dispose(!0),l(new Error((0,k.localize)(0,null)))},p);try{c(await v(y,r.token))}catch(n){!(0,D.isPromiseCanceledError)(n)&&!r.token.isCancellationRequested?l(new Error((0,k.localize)(1,null,(0,T.toErrorMessage)(n)))):c({})}finally{clearTimeout(a),r.dispose()}})),h)}e.getResolvedShellEnv=S;async function v(y,w){const g=process.env.ELECTRON_RUN_AS_NODE;y.trace("getUnixShellEnvironment#runAsNode",g);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;y.trace("getUnixShellEnvironment#noAttach",c);const l=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(l+"(.*)"+l),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};y.trace("getUnixShellEnvironment#env",a);const n=await(0,P.getSystemShell)(C.OS,a);return y.trace("getUnixShellEnvironment#shell",n),new Promise((t,s)=>{if(w.isCancellationRequested)return s((0,D.canceled)());const o=(0,i.basename)(n);let u,d;const m=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' ${m} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,d=["-Login","-Command"]):(u=`'${process.execPath}' ${m} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,o==="tcsh"?d=["-ic"]:d=["-ilc"]),y.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),u);const I=(0,L.spawn)(n,[...d,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});w.onCancellationRequested(()=>(I.kill(),s((0,D.canceled)()))),I.on("error",N=>{y.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(N)),s(N)});const A=[];I.stdout.on("data",N=>A.push(N));const O=[];I.stderr.on("data",N=>O.push(N)),I.on("close",(N,$)=>{const R=Buffer.concat(A).toString("utf8");y.trace("getUnixShellEnvironment#raw",R);const M=Buffer.concat(O).toString("utf8");if(M.trim()&&y.trace("getUnixShellEnvironment#stderr",M),N||$)return s(new Error((0,k.localize)(2,null,N,$)));const W=r.exec(R),U=W?W[1]:"{}";try{const x=JSON.parse(U);g?x.ELECTRON_RUN_AS_NODE=g:delete x.ELECTRON_RUN_AS_NODE,c?x.ELECTRON_NO_ATTACH_CONSOLE=c:delete x.ELECTRON_NO_ATTACH_CONSOLE,delete x.XDG_RUNTIME_DIR,y.trace("getUnixShellEnvironment#result",x),t(x)}catch(x){y.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(x)),s(x)}})})}}),define(ne[164],ie([0,1,18,37,8,3,2,40,7,30,14]),function(Q,e,L,i,k,_,T,D,C,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends T.Disposable{constructor(p,h){super();this.channel=p,this.extraCapabilities=h,this.onDidChangeCapabilities=_.Event.None,this._onDidChange=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,b.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(p){return this.channel.call("stat",[p])}readdir(p){return this.channel.call("readdir",[p])}async readFile(p,h){const{buffer:S}=await this.channel.call("readFile",[p,h]);return S}readFileStream(p,h,S){const v=(0,D.newWriteableStream)(w=>L.VSBuffer.concat(w.map(g=>L.VSBuffer.wrap(g))).buffer),y=this.channel.listen("readFileStream",[p,h])(w=>{if(w instanceof L.VSBuffer)v.write(w.buffer);else{if(w==="end")v.end();else{let g=w;g instanceof Error||(g=(0,P.createFileSystemProviderError)((0,i.toErrorMessage)(g),P.FileSystemProviderErrorCode.Unknown)),v.error(g),v.end()}y.dispose()}});return S.onCancellationRequested(()=>{v.error((0,k.canceled)()),v.end(),y.dispose()}),v}writeFile(p,h,S){return this.channel.call("writeFile",[p,L.VSBuffer.wrap(h),S])}open(p,h){return this.channel.call("open",[p,h])}close(p){return this.channel.call("close",[p])}async read(p,h,S,v,y){const[w,g]=await this.channel.call("read",[p,h,y]);return S.set(w.buffer.slice(0,g),v),g}write(p,h,S,v,y){return this.channel.call("write",[p,h,L.VSBuffer.wrap(S),v,y])}mkdir(p){return this.channel.call("mkdir",[p])}delete(p,h){return this.channel.call("delete",[p,h])}rename(p,h,S){return this.channel.call("rename",[p,h,S])}copy(p,h,S){return this.channel.call("copy",[p,h,S])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(p=>{if(Array.isArray(p)){const h=p;this._onDidChange.fire(h.map(S=>({resource:C.URI.revive(S.resource),type:S.type})))}else{const h=p;this._onDidWatchError.fire(h)}}))}watch(p,h){const S=(0,b.generateUuid)();return this.channel.call("watch",[this.sessionId,S,p,h]),(0,T.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,S]))}}e.DiskFileSystemProviderClient=E}),define(ne[82],ie([0,1,18,8,137,14]),function(Q,e,L,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(P,E,f,p,h,S){let v;try{await D(P,E,f,p,h,S)}catch(y){v=y}finally{v&&h.errorTransformer&&(v=h.errorTransformer(v)),typeof v!="undefined"&&f.error(v),f.end()}}e.readFileIntoStream=T;async function D(P,E,f,p,h,S){C(S);const v=await P.open(E,{create:!1});try{C(S);let y=0,w=0,g=h&&typeof h.length=="number"?h.length:void 0,c=L.VSBuffer.alloc(Math.min(h.bufferSize,typeof g=="number"?g:h.bufferSize)),l=h&&typeof h.position=="number"?h.position:0,r=0;do w=await P.read(v,l,c.buffer,r,c.byteLength-r),l+=w,r+=w,y+=w,typeof g=="number"&&(g-=w),r===c.byteLength&&(await f.write(p(c)),c=L.VSBuffer.alloc(Math.min(h.bufferSize,typeof g=="number"?g:h.bufferSize)),r=0);while(w>0&&(typeof g!="number"||g>0)&&C(S)&&b(y,h));if(r>0){let a=r;typeof g=="number"&&(a=Math.min(r,g)),f.write(p(c.slice(0,a)))}}catch(y){throw(0,_.ensureFileSystemProviderError)(y)}finally{await P.close(v)}}function C(P){if(P.isCancellationRequested)throw(0,i.canceled)();return!0}function b(P,E){if(E?.limits){if(typeof E.limits.memory=="number"&&P>E.limits.memory)throw(0,_.createFileSystemProviderError)((0,k.localize)(0,null),_.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&P>E.limits.size)throw(0,_.createFileSystemProviderError)((0,k.localize)(1,null),_.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[58],ie([0,1,2,4,7,14]),function(Q,e,L,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractRecursiveWatcherClient=void 0;class T extends L.Disposable{constructor(E,f,p){super();this.onFileChanges=E,this.onLogMessage=f,this.verboseLogging=p,this.watcherDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const E=new L.DisposableStore;this.watcherDisposables.value=E,this.watcher=this.createWatcher(E),this.watcher.setVerboseLogging(this.verboseLogging),E.add(this.watcher.onDidChangeFile(f=>this.onFileChanges(f))),E.add(this.watcher.onDidLogMessage(f=>this.onLogMessage(f))),E.add(this.watcher.onDidError(f=>this.onError(f)))}onError(E){this.restartCounter<T.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${E}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${E}`)}restart(E){this.restartCounter++,this.init(),this.watch(E)}async watch(E){this.requests=E,await this.watcher?.watch(E)}async setVerboseLogging(E){this.verboseLogging=E,await this.watcher?.setVerboseLogging(E)}error(E){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${E}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractRecursiveWatcherClient=T,T.MAX_RESTARTS=5;function D(P){return P.map(E=>({type:E.type,resource:k.URI.file(E.path)}))}e.toFileChanges=D;function C(P){const E=new b;for(const f of P)E.processEvent(f);return E.coalesce()}e.coalesceEvents=C;class b{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(E){return i.isLinux?E.path:E.path.toLowerCase()}processEvent(E){const f=this.mapPathToChange.get(this.toKey(E));let p=!1;if(f){const h=f.type,S=E.type;f.path!==E.path&&E.type===2?p=!0:h===1&&S===2?(this.mapPathToChange.delete(this.toKey(E)),this.coalesced.delete(f)):h===2&&S===1?f.type=0:h===1&&S===0||(f.type=S)}else p=!0;p&&(this.coalesced.add(E),this.mapPathToChange.set(this.toKey(E),E))}coalesce(){const E=[],f=[];return Array.from(this.coalesced).filter(p=>p.type!==2?(E.push(p),!1):!0).sort((p,h)=>p.path.length-h.path.length).filter(p=>f.some(h=>(0,_.isParent)(p.path,h,!i.isLinux))?!1:(f.push(p.path),!0)).concat(E)}}}),define(ne[165],ie([0,1,5,2,9,112,20,115,58]),function(Q,e,L,i,k,_,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcher=void 0;class b extends i.Disposable{constructor(E,f,p,h){super();this.path=E,this.onDidFilesChange=f,this.onLogMessage=p,this.verboseLogging=h,this.fileChangesDelayer=this._register(new L.ThrottledDelayer(D.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(E){this.verboseLogging=E}async startWatching(){try{const{stat:E,symbolicLink:f}=await T.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(f)try{p=await(0,_.realpath)(p)}catch(h){if(this.onError(h),f.dangling)return}E.isDirectory()?this._register((0,D.watchFolder)(p,(h,S)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,k.join)(this.path,(0,k.basename)(S))})},h=>this.onError(h))):this._register((0,D.watchFile)(p,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(E){E.code!=="ENOENT"&&this.onError(E)}}onFileChange(E){this.fileChangesBuffer.push(E),this.verboseLogging&&this.onVerbose(`${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`),this.fileChangesDelayer.trigger(async()=>{const f=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,C.coalesceEvents)(f);if(this.verboseLogging)for(const h of p)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);p.length>0&&this.onDidFilesChange(p)})}onError(E){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${E}`})}onVerbose(E){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${E}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.NodeJSFileWatcher=b}),define(ne[166],ie([0,1,16,36,57,58]),function(Q,e,L,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParcelWatcherClient=void 0;class T extends _.AbstractRecursiveWatcherClient{constructor(C,b,P){super(C,b,P);this.init()}createWatcher(C){const b=C.add(new k.Client(L.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=parcelWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/parcelWatcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(b.onDidProcessExit(({code:P,signal:E})=>this.onError(`terminated by itself with code ${P}, signal: ${E}`))),i.ProxyChannel.toService((0,i.getNextTickChannel)(b.getChannel("watcher")))}}e.ParcelWatcherClient=T}),define(ne[83],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(...k){this._entries=new Map;for(let[_,T]of k)this.set(_,T)}set(k,_){const T=this._entries.get(k);return this._entries.set(k,_),T}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=L}),define(ne[167],ie([0,1,5,8,51,156,6,83]),function(Q,e,L,i,k,_,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class b extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class P{constructor(h=new D.ServiceCollection,S=!1,v){this._activeInstantiations=new Set,this._services=h,this._strict=S,this._parent=v,this._services.set(T.IInstantiationService,this)}createChild(h){return new P(h,this._strict,this)}invokeFunction(h,...S){let v=f.traceInvocation(h),y=!1;try{return h({get:g=>{if(y)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(g,v);if(!c)throw new Error(`[invokeFunction] unknown service '${g}'`);return c}},...S)}finally{y=!0,v.stop()}}createInstance(h,...S){let v,y;return h instanceof k.SyncDescriptor?(v=f.traceCreation(h.ctor),y=this._createInstance(h.ctor,h.staticArguments.concat(S),v)):(v=f.traceCreation(h),y=this._createInstance(h,S,v)),v.stop(),y}_createInstance(h,S=[],v){let y=T._util.getServiceDependencies(h).sort((c,l)=>c.index-l.index),w=[];for(const c of y){let l=this._getOrCreateServiceInstance(c.id,v);if(!l&&this._strict&&!c.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${c.id}.`);w.push(l)}let g=y.length>0?y[0].index:S.length;if(S.length!==g){console.warn(`[createInstance] First service dependency of ${h.name} at position ${g+1} conflicts with ${S.length} static arguments`);let c=g-S.length;c>0?S=S.concat(new Array(c)):S=S.slice(0,g)}return new h(...[...S,...w])}_setServiceInstance(h,S){if(this._services.get(h)instanceof k.SyncDescriptor)this._services.set(h,S);else if(this._parent)this._parent._setServiceInstance(h,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let S=this._services.get(h);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):S}_getOrCreateServiceInstance(h,S){let v=this._getServiceInstanceOrDescriptor(h);return v instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,v,S.branch(h,!0)):(S.branch(h,!1),v)}_safeCreateAndCacheServiceInstance(h,S,v){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,S,v)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,S,v){const y=new _.Graph(c=>c.id.toString());let w=0;const g=[{id:h,desc:S,_trace:v}];for(;g.length;){const c=g.pop();if(y.lookupOrInsertNode(c),w++>1e3)throw new b(y);for(let l of T._util.getServiceDependencies(c.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(l.id);if(!r&&!l.optional&&console.warn(`[createInstance] ${h} depends on ${l.id} which is NOT registered.`),r instanceof k.SyncDescriptor){const a={id:l.id,desc:r,_trace:c._trace.branch(l.id,!0)};y.insertEdge(c,a),g.push(a)}}}for(;;){const c=y.roots();if(c.length===0){if(!y.isEmpty())throw new b(y);break}for(const{data:l}of c){if(this._getServiceInstanceOrDescriptor(l.id)instanceof k.SyncDescriptor){const a=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,a)}y.removeNode(l)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,S,v=[],y,w){if(this._services.get(h)instanceof k.SyncDescriptor)return this._createServiceInstance(S,v,y,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,S,v,y,w);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(h,S=[],v,y){if(v){const w=new L.IdleValue(()=>this._createInstance(h,S,y));return new Proxy(Object.create(null),{get(g,c){if(c in g)return g[c];let l=w.value,r=l[c];return typeof r!="function"||(r=r.bind(l),g[c]=r),r},set(g,c,l){return w.value[c]=l,!0}})}else return this._createInstance(h,S,y)}}e.InstantiationService=P;var E;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(E||(E={}));class f{constructor(h,S){this.type=h,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return C?new f(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(h){return C?new f(0,h.name):f._None}branch(h,S){let v=new f(2,h.toString());return this._dep.push([h,S,v]),v}stop(){let h=Date.now()-this._start;f._totals+=h;let S=!1;function v(w,g){let c=[],l=new Array(w+1).join("	");for(const[r,a,n]of g._dep)if(a&&n){S=!0,c.push(`${l}CREATES -> ${r}`);let t=v(w+1,n);t&&c.push(t)}else c.push(`${l}uses -> ${r}`);return c.join(`
`)}let y=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(h>2||S)&&console.log(y.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(ne[168],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class L{constructor(k,_){this.server=k,this.router=_}getChannel(k){return this.server.getChannel(k,this.router)}registerChannel(k,_){this.server.registerChannel(k,_)}}e.MessagePortMainProcessService=L}),define(ne[169],ie([0,1,36,51,77,6]),function(Q,e,L,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(p,h,S){const v=S.getChannel(p);return D(h)?new h.channelClientCtor(v):L.ProxyChannel.toService(v,h?.proxyOptions)}}function D(f){return!!f?.channelClientCtor}e.IMainProcessService=(0,_.createDecorator)("mainProcessService");let C=class extends T{constructor(p,h,S){super(p,h,S)}};C=de([J(2,e.IMainProcessService)],C);function b(f,p,h){(0,k.registerSingleton)(f,new i.SyncDescriptor(C,[p,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,_.createDecorator)("sharedProcessService");let P=class extends T{constructor(p,h,S){super(p,h,S)}};P=de([J(2,e.ISharedProcessService)],P);function E(f,p,h){(0,k.registerSingleton)(f,new i.SyncDescriptor(P,[p,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=E}),define(ne[59],ie([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,L.createDecorator)("localizationsService");function i(k){if(typeof k.languageId!="string"||!Array.isArray(k.translations)||k.translations.length===0)return!1;for(const _ of k.translations)if(typeof _.id!="string"||typeof _.path!="string")return!1;return!(k.languageName&&typeof k.languageName!="string"||k.localizedLanguageName&&typeof k.localizedLanguageName!="string")}e.isValidLocalization=i}),define(ne[170],ie([0,1,2,59]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let k=class extends L.Disposable{constructor(T){super();this.localizationsService=T,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};k=de([J(0,i.ILocalizationsService)],k),e.LocalizationsUpdater=k}),define(ne[10],ie([0,1,37,3,2,4,6]),function(Q,e,L,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function D(){return new Date().toISOString()}var C;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function b(a,n,t){switch(n){case C.Trace:a.trace(t);break;case C.Debug:a.debug(t);break;case C.Info:a.info(t);break;case C.Warning:a.warn(t);break;case C.Error:a.error(t);break;case C.Critical:a.critical(t);break;default:throw new Error("Invalid log level")}}e.log=b;function P(a){let n="";for(let t=0;t<a.length;t++){let s=a[t];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}n+=(t>0?" ":"")+s}return n}e.format=P;class E extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new i.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class f extends E{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...t){this.checkLogLevel(C.Trace)&&this.log(C.Trace,P([n,...t]))}debug(n,...t){this.checkLogLevel(C.Debug)&&this.log(C.Debug,P([n,...t]))}info(n,...t){this.checkLogLevel(C.Info)&&this.log(C.Info,P([n,...t]))}warn(n,...t){this.checkLogLevel(C.Warning)&&this.log(C.Warning,P([n,...t]))}error(n,...t){if(this.checkLogLevel(C.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(C.Error,P(s))}else this.log(C.Error,P([n,...t]))}critical(n,...t){this.checkLogLevel(C.Critical)&&this.log(C.Critical,P([n,...t]))}flush(){}}e.AbstractMessageLogger=f;class p extends E{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!_.isWindows}trace(n,...t){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,n,...t):console.log(`[main ${D()}]`,n,...t))}debug(n,...t){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,n,...t):console.log(`[main ${D()}]`,n,...t))}info(n,...t){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,n,...t):console.log(`[main ${D()}]`,n,...t))}warn(n,...t){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,n,...t):console.warn(`[main ${D()}]`,n,...t))}error(n,...t){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,n,...t):console.error(`[main ${D()}]`,n,...t))}critical(n,...t){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,n,...t):console.error(`[main ${D()}]`,n,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class h extends E{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...t){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",n,...t)}debug(n,...t){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...t)}info(n,...t){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",n,...t)}warn(n,...t){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",n,...t)}error(n,...t){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",n,...t)}critical(n,...t){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class S extends E{constructor(n,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(t)}trace(n,...t){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(n),...t])}debug(n,...t){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(n),...t])}info(n,...t){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(n),...t])}warn(n,...t){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(n),...t])}error(n,...t){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(n),...t])}critical(n,...t){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(n),...t])}extractMessage(n){return typeof n=="string"?n:(0,L.toErrorMessage)(n,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class v extends E{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const t of this.logServices)t.setLevel(n);super.setLevel(n)}trace(n,...t){for(const s of this.logServices)s.trace(n,...t)}debug(n,...t){for(const s of this.logServices)s.debug(n,...t)}info(n,...t){for(const s of this.logServices)s.info(n,...t)}warn(n,...t){for(const s of this.logServices)s.warn(n,...t)}error(n,...t){for(const s of this.logServices)s.error(n,...t)}critical(n,...t){for(const s of this.logServices)s.critical(n,...t)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=v;class y extends k.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...t){this.logger.trace(n,...t)}debug(n,...t){this.logger.debug(n,...t)}info(n,...t){this.logger.info(n,...t)}warn(n,...t){this.logger.warn(n,...t)}error(n,...t){this.logger.error(n,...t)}critical(n,...t){this.logger.critical(n,...t)}flush(){this.logger.flush()}}e.LogService=y;class w extends k.Disposable{constructor(n,t){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,t){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,t?.always?C.Trace:this.logLevel,t),this.loggers.set(n.toString(),s),t?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class g{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(n){}getLevel(){return C.Info}trace(n,...t){}debug(n,...t){}info(n,...t){}warn(n,...t){}error(n,...t){}critical(n,...t){}dispose(){}flush(){}}e.NullLogService=g;function c(a){if(a.verbose)return C.Trace;if(typeof a.logLevel=="string"){const n=l(a.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function l(a){switch(a){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=l;function r(a){switch(a){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=r}),define(ne[171],ie([0,1,5,8,2,9,20,13,10]),function(Q,e,L,i,k,_,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends k.Disposable{constructor(E,f){super();this.environmentService=E,this.logService=f,this._register(new L.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,_.basename)(this.environmentService.logsPath),f=(0,_.dirname)(this.environmentService.logsPath),S=(await T.Promises.readdir(f)).filter(y=>/^\d{8}T\d{6}$/.test(y)).sort().filter(y=>y!==E),v=S.slice(0,Math.max(0,S.length-9));v.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${v.join(", ")}'`),await Promise.all(v.map(y=>T.Promises.rm((0,_.join)(f,y)))))}catch(E){(0,i.onUnexpectedError)(E)}}};b=de([J(0,D.IEnvironmentService),J(1,C.ILogService)],b),e.LogsDataCleaner=b}),define(ne[172],ie([0,1,5,8,2,9,20,13,10]),function(Q,e,L,i,k,_,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let b=class gt extends k.Disposable{constructor(E,f,p){super();this.backupWorkspacesPath=E,this.environmentService=f,this.logService=p,this._register(new L.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const E=await T.Promises.readFile(this.backupWorkspacesPath,"utf8"),p=JSON.parse(E).emptyWorkspaceInfos.map(S=>S.backupFolder),h=await T.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async S=>{S.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||S===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||p.indexOf(S)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${S}.`),await T.Promises.rm((0,_.join)(this.environmentService.workspaceStorageHome.fsPath,S)))}))}catch(E){(0,i.onUnexpectedError)(E)}}};b.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,b.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",b=de([J(1,D.INativeEnvironmentService),J(2,C.ILogService)],b),e.StorageDataCleaner=b}),define(ne[173],ie([0,1,45,5,37,3,2,16,9,20,13,10]),function(Q,e,L,i,k,_,T,D,C,b,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let f=class extends T.Disposable{constructor(h,S){super();this.environmentService=h,this.logService=S,this.processesLimiter=new i.Limiter(5)}async postUninstall(h){const S=this.parseScript(h,"uninstall");return S&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${v}`)))),b.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(h,S){const v=`vscode:${S}`;if(h.location.scheme===D.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[v]=="string"){const y=h.manifest.scripts[v].split(" ");return y.length<2||y[0]!=="node"||!y[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${v} should be a node script`),null):{script:(0,C.join)(h.location.fsPath,y[1]),args:y.slice(2)||[]}}return null}runLifecycleHook(h,S,v,y,w){return new Promise((g,c)=>{const l=this.start(h,S,v,w);let r;const a=n=>{r&&(clearTimeout(r),r=null),n?c(n):g(void 0)};l.on("error",n=>{a((0,k.toErrorMessage)(n)||"Unknown")}),l.on("exit",(n,t)=>{a(n?`post-${S} process exited with code ${n}`:void 0)}),y&&(r=setTimeout(()=>{r=null,l.kill(),c("timed out")},5e3))})}start(h,S,v,y){const w={silent:!0,execArgv:void 0},g=(0,L.fork)(h,[`--type=extension-post-${S}`,...v],w);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const c=_.Event.fromNodeEventEmitter(g.stdout,"data"),l=_.Event.fromNodeEventEmitter(g.stderr,"data");c(n=>this.logService.info(y.identifier.id,y.manifest.version,`post-${S}`,n)),l(n=>this.logService.error(y.identifier.id,y.manifest.version,`post-${S}`,n));const r=_.Event.any(_.Event.map(c,n=>({data:`%c${n}`,format:[""]})),_.Event.map(l,n=>({data:`%c${n}`,format:["color: red"]})));return _.Event.debounce(r,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100)(n=>{console.group(y.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),g}getExtensionStoragePath(h){return(0,C.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};f=de([J(0,P.IEnvironmentService),J(1,E.ILogService)],f),e.ExtensionsLifecycle=f}),define(ne[174],ie([0,1,17,5,8,3,2,9,58,10]),function(Q,e,L,i,k,_,T,D,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends T.Disposable{constructor(f){super();this.logService=f,this._onDidChangeFile=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new i.ThrottledDelayer(0))}watch(f,p){return p.recursive?this.watchRecursive(f,p):this.watchNonRecursive(f)}watchRecursive(f,p){const h={path:this.toFilePath(f),excludes:p.excludes},S=(0,L.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,T.toDisposable)(()=>{S(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(f=>(0,k.onUnexpectedError)(f))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(f=>this._onDidChangeFile.fire((0,C.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(f,p){return f.watch(p)}watchNonRecursive(f){const p=this.createNonRecursiveWatcher(this.toFilePath(f),S=>this._onDidChangeFile.fire((0,C.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===b.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{p.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)});return(0,T.combinedDisposable)(p,h)}onWatcherLogMessage(f){f.type==="error"&&this._onDidWatchError.fire(f.message),this.logService[f.type](f.message)}toFilePath(f){return(0,D.normalize)(f.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(ne[175],ie([0,1,17,5,18,27,3,54,2,39,16,176,19,40,135,14,82,10]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h,S,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class Ye extends C.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this._onDidChangeFilesRaw=this._register(new T.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new i.ThrottledWorker(Ye.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ye.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ye.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new S.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new i.ThrottledWorker(Ye.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ye.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ye.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new S.FileChangesEvent(l,!0)))),this.watchedResources=b.TernarySearchTree.forUris(l=>{const r=this.getProvider(l.scheme);return r?!this.isPathCaseSensitive(r):!1}),this.writeQueue=this._register(new i.ResourceQueue)}registerProvider(c,l){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${c}`),this.provider.set(c,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:l});const r=new C.DisposableStore;return r.add(l.onDidChangeFile(a=>this.onDidChangeFile(a,this.isPathCaseSensitive(l)))),r.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:c}))),typeof l.onDidWatchError=="function"&&r.add(l.onDidWatchError(a=>this._onDidWatchError.fire(new Error(a)))),(0,C.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:l}),this.provider.delete(c),(0,C.dispose)(r)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(r){l.push(r)}}),!this.provider.has(c)&&await i.Promises.settled(l)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,l){const r=this.provider.get(c.scheme);return!!(r&&r.capabilities&l)}listCapabilities(){return D.Iterable.map(this.provider,([c,l])=>({scheme:c,capabilities:l.capabilities}))}async withProvider(c){if(!(0,f.isAbsolutePath)(c))throw new S.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const l=this.provider.get(c.scheme);if(!l){const r=new Error;throw r.name="ENOPRO",r.message=(0,h.localize)(1,null,c.toString()),r}return l}async withReadProvider(c){const l=await this.withProvider(c);if((0,S.hasOpenReadWriteCloseCapability)(l)||(0,S.hasReadWriteCapability)(l)||(0,S.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const l=await this.withProvider(c);if((0,S.hasOpenReadWriteCloseCapability)(l)||(0,S.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,l){try{return await this.doResolveFile(c,l)}catch(r){throw(0,S.toFileSystemProviderErrorCode)(r)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,S.ensureFileSystemProviderError)(r)}}async doResolveFile(c,l){const r=await this.withProvider(c),a=this.isPathCaseSensitive(r),n=l?.resolveTo,t=l?.resolveSingleChildDescendants,s=l?.resolveMetadata,o=await r.stat(c);let u;return this.toFileStat(r,c,o,void 0,!!s,(d,m)=>(u||(u=b.TernarySearchTree.forUris(()=>!a),u.set(c,!0),n&&u.fill(!0,n)),u.get(d.resource)||u.findSuperstr(d.resource.with({query:null,fragment:null}))?!0:d.isDirectory&&t?m===1:!1))}async toFileStat(c,l,r,a,n,t){const{providerExtUri:s}=this.getExtUri(c),o={resource:l,name:s.basename(l),isFile:(r.type&S.FileType.File)!=0,isDirectory:(r.type&S.FileType.Directory)!=0,isSymbolicLink:(r.type&S.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&S.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,S.etag)({mtime:r.mtime,size:r.size})};if(o.isDirectory&&t(o,a)){try{const u=await c.readdir(l),d=await i.Promises.settled(u.map(async([m,I])=>{try{const A=s.joinPath(l,m),O=n?await c.stat(A):{type:I};return await this.toFileStat(c,A,O,u.length,n,t)}catch(A){return this.logService.trace(A),null}}));o.children=(0,L.coalesce)(d)}catch(u){this.logService.trace(u),o.children=[]}return o}return o}async resolveAll(c){return i.Promises.settled(c.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async exists(c){const l=await this.withProvider(c);try{return!!await l.stat(c)}catch{return!1}}async canCreateFile(c,l){try{await this.doValidateCreateFile(c,l)}catch(r){return r}return!0}async doValidateCreateFile(c,l){if(!l?.overwrite&&await this.exists(c))throw new S.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,l)}async createFile(c,l=k.VSBuffer.fromString(""),r){await this.doValidateCreateFile(c,r);const a=await this.writeFile(c,l);return this._onDidRunOperation.fire(new S.FileOperationEvent(c,0,a)),a}async writeFile(c,l,r){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:n}=this.getExtUri(a);try{await this.validateWriteFile(a,c,r)||await this.mkdirp(a,n.dirname(c));let s;if((0,S.hasReadWriteCapability)(a)&&!(l instanceof k.VSBuffer))if((0,p.isReadableStream)(l)){const o=await(0,p.peekStream)(l,3);o.ended?s=k.VSBuffer.concat(o.buffer):s=o}else s=(0,p.peekReadable)(l,o=>k.VSBuffer.concat(o),3);else s=l;!(0,S.hasOpenReadWriteCloseCapability)(a)||(0,S.hasReadWriteCapability)(a)&&s instanceof k.VSBuffer?await this.doWriteUnbuffered(a,c,r,s):await this.doWriteBuffered(a,c,r,s instanceof k.VSBuffer?(0,k.bufferToReadable)(s):s)}catch(t){throw new S.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,S.ensureFileSystemProviderError)(t).toString()),(0,S.toFileOperationResult)(t),r)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,l,r){if(!!r?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(l)));let n;try{n=await c.stat(l)}catch{return}if((n.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,h.localize)(6,null,this.resourceForError(l)),0,r);if(this.throwIfFileIsReadonly(l,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==S.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,S.etag)({mtime:r.mtime,size:n.size}))throw new S.FileOperationError((0,h.localize)(7,null),3,r);return n}async readFile(c,l,r){const a=await this.withReadProvider(c);return l?.atomic?this.doReadFileAtomic(a,c,l,r):this.doReadFile(a,c,l,r)}async doReadFileAtomic(c,l,r,a){return new Promise((n,t)=>{this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(c,l,r,a);n(s)}catch(s){t(s)}})})}async doReadFile(c,l,r,a){const n=await this.doReadFileStream(c,l,{...r,preferUnbuffered:!0},a);return{...n,value:await(0,k.streamToBuffer)(n.value)}}async readFileStream(c,l,r){const a=await this.withReadProvider(c);return this.doReadFileStream(a,c,l,r)}async doReadFileStream(c,l,r,a){const n=new _.CancellationTokenSource(a),t=this.validateReadFile(l,r).then(o=>o,o=>{throw n.cancel(),o});let s;try{return typeof r?.etag=="string"&&r.etag!==S.ETAG_DISABLED&&await t,r?.atomic&&(0,S.hasFileAtomicReadCapability)(c)||!((0,S.hasOpenReadWriteCloseCapability)(c)||(0,S.hasFileReadStreamCapability)(c))||(0,S.hasReadWriteCapability)(c)&&r?.preferUnbuffered?s=this.readFileUnbuffered(c,l,r):(0,S.hasFileReadStreamCapability)(c)?s=this.readFileStreamed(c,l,n.token,r):s=this.readFileBuffered(c,l,n.token,r),{...await t,value:s}}catch(o){s&&await(0,p.consumeStream)(s);const u=(0,h.localize)(8,null,this.resourceForError(l),(0,S.ensureFileSystemProviderError)(o).toString());throw o instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(u,o.stat,r):new S.FileOperationError(u,(0,S.toFileOperationResult)(o),r)}}readFileStreamed(c,l,r,a=Object.create(null)){const n=c.readFileStream(l,a,r);return(0,p.transform)(n,{data:t=>t instanceof k.VSBuffer?t:k.VSBuffer.wrap(t),error:t=>new S.FileOperationError((0,h.localize)(9,null,this.resourceForError(l),(0,S.ensureFileSystemProviderError)(t).toString()),(0,S.toFileOperationResult)(t),a)},t=>k.VSBuffer.concat(t))}readFileBuffered(c,l,r,a=Object.create(null)){const n=(0,k.newWriteableBufferStream)();return(0,v.readFileIntoStream)(c,l,n,t=>t,{...a,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new S.FileOperationError((0,h.localize)(10,null,this.resourceForError(l),(0,S.ensureFileSystemProviderError)(t).toString()),(0,S.toFileOperationResult)(t),a)},r),n}readFileUnbuffered(c,l,r){const a=(0,p.newWriteableStream)(n=>k.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,S.hasFileAtomicReadCapability)(c)?n=await c.readFile(l,{atomic:!0}):n=await c.readFile(l),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(l,n.byteLength,r),a.end(k.VSBuffer.wrap(n))}catch(n){a.error(n),a.end()}})(),a}async validateReadFile(c,l){const r=await this.resolve(c,{resolveMetadata:!0});if(r.isDirectory)throw new S.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,l);if(typeof l?.etag=="string"&&l.etag!==S.ETAG_DISABLED&&l.etag===r.etag)throw new S.NotModifiedSinceFileOperationError((0,h.localize)(12,null),r,l);return this.validateReadFileLimits(c,r.size,l),r}validateReadFileLimits(c,l,r){if(r?.limits){let a;if(typeof r.limits.memory=="number"&&l>r.limits.memory&&(a=9),typeof r.limits.size=="number"&&l>r.limits.size&&(a=7),typeof a=="number")throw new S.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),a)}}async canMove(c,l,r){return this.doCanMoveCopy(c,l,"move",r)}async canCopy(c,l,r){return this.doCanMoveCopy(c,l,"copy",r)}async doCanMoveCopy(c,l,r,a){if(c.toString()!==l.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(n,c,t,l,r,a)}catch(n){return n}return!0}async move(c,l,r){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=await this.doMoveCopy(a,c,n,l,"move",!!r),s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,t==="move"?2:3,s)),s}async copy(c,l,r){const a=await this.withReadProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=await this.doMoveCopy(a,c,n,l,"copy",!!r),s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,t==="copy"?3:2,s)),s}async doMoveCopy(c,l,r,a,n,t){if(l.toString()===a.toString())return n;const{exists:s,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(c,l,r,a,n,t);if(s&&!o&&t&&await this.del(a,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(a)),n==="copy"){if(c===r&&(0,S.hasFileFolderCopyCapability)(c))await c.copy(l,a,{overwrite:t});else{const u=await this.resolve(l);u.isDirectory?await this.doCopyFolder(c,u,r,a):await this.doCopyFile(c,l,r,a)}return n}else return c===r?(await c.rename(l,a,{overwrite:t}),n):(await this.doMoveCopy(c,l,r,a,"copy",t),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(c,l,r,a){if((0,S.hasOpenReadWriteCloseCapability)(c)&&(0,S.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(c,l,r,a);if((0,S.hasOpenReadWriteCloseCapability)(c)&&(0,S.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(c,l,r,a);if((0,S.hasReadWriteCapability)(c)&&(0,S.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(c,l,r,a);if((0,S.hasReadWriteCapability)(c)&&(0,S.hasReadWriteCapability)(r))return this.doPipeUnbuffered(c,l,r,a)}async doCopyFolder(c,l,r,a){await r.mkdir(a),Array.isArray(l.children)&&await i.Promises.settled(l.children.map(async n=>{const t=this.getExtUri(r).providerExtUri.joinPath(a,n.name);return n.isDirectory?this.doCopyFolder(c,await this.resolve(n.resource),r,t):this.doCopyFile(c,n.resource,r,t)}))}async doValidateMoveCopy(c,l,r,a,n,t){let s=!1;if(c===r){const{providerExtUri:u,isPathCaseSensitive:d}=this.getExtUri(c);if(d||(s=u.isEqual(l,a)),s&&n==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(l),this.resourceForError(a)));if(!s&&u.isEqualOrParent(a,l))throw new Error((0,h.localize)(15,null,this.resourceForError(l),this.resourceForError(a)))}const o=await this.exists(a);if(o&&!s){if(!t)throw new S.FileOperationError((0,h.localize)(16,null,this.resourceForError(l),this.resourceForError(a)),4);if(c===r){const{providerExtUri:u}=this.getExtUri(c);if(u.isEqualOrParent(l,a))throw new Error((0,h.localize)(17,null,this.resourceForError(l),this.resourceForError(a)))}}return{exists:o,isSameResourceWithDifferentPathCase:s}}getExtUri(c){const l=this.isPathCaseSensitive(c);return{providerExtUri:l?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(l,c);const r=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,0,r)),r}async mkdirp(c,l){const r=[],{providerExtUri:a}=this.getExtUri(c);for(;!a.isEqual(l,a.dirname(l));)try{if(((await c.stat(l)).type&S.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(l)));break}catch(n){if((0,S.toFileSystemProviderErrorCode)(n)!==S.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(a.basename(l)),l=a.dirname(l)}for(let n=r.length-1;n>=0;n--){l=a.joinPath(l,r[n]);try{await c.mkdir(l)}catch(t){if((0,S.toFileSystemProviderErrorCode)(t)!==S.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(c,l){try{await this.doValidateDelete(c,l)}catch(r){return r}return!0}async doValidateDelete(c,l){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!l?.useTrash&&!(r.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let n;try{n=await r.stat(c)}catch{}if(n)this.throwIfFileIsReadonly(c,n);else throw new S.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!l?.recursive){const s=await this.resolve(c);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return r}async del(c,l){const r=await this.doValidateDelete(c,l),a=!!l?.useTrash,n=!!l?.recursive;await r.delete(c,{recursive:n,useTrash:a}),this._onDidRunOperation.fire(new S.FileOperationEvent(c,1))}onDidChangeFile(c,l){this._onDidChangeFilesRaw.fire({changes:c});let r,a;{for(const n of c)this.watchedResources.has(n.resource)?(r||(r=[]),r.push(n)):(a||(a=[]),a.push(n));r&&this._onDidFilesChange.fire(new S.FileChangesEvent(r,!l))}if(a){const n=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(a)&&Ye.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(c,l={recursive:!1,excludes:[]}){const r=new C.DisposableStore;let a=!1,n=()=>{a=!0};return r.add((0,C.toDisposable)(()=>n())),this.doWatch(c,l).then(t=>{a?(0,C.dispose)(t):n=()=>(0,C.dispose)(t)},t=>this.logService.error(t)),l.recursive||(this.watchedResources.set(c,(this.watchedResources.get(c)??0)+1),r.add((0,C.toDisposable)(()=>{const t=this.watchedResources.get(c);typeof t=="number"&&(t<=1?this.watchedResources.delete(c):this.watchedResources.set(c,t-1))}))),r}async doWatch(c,l){const r=await this.withProvider(c),a=this.toWatchKey(r,c,l);let n=this.activeWatchers.get(a);return n||(n={count:0,disposable:r.watch(c,l)},this.activeWatchers.set(a,n)),n.count+=1,(0,C.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,C.dispose)(n.disposable),this.activeWatchers.delete(a)))})}toWatchKey(c,l,r){const{providerExtUri:a}=this.getExtUri(c);return[a.getComparisonKey(l),String(r.recursive),r.excludes.join()].join()}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,C.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,l,r,a){return this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(async()=>{const n=await c.open(l,{create:!0,unlock:r?.unlock??!1});try{(0,p.isReadableStream)(a)||(0,p.isReadableBufferedStream)(a)?await this.doWriteStreamBufferedQueued(c,n,a):await this.doWriteReadableBufferedQueued(c,n,a)}catch(t){throw(0,S.ensureFileSystemProviderError)(t)}finally{await c.close(n)}})}async doWriteStreamBufferedQueued(c,l,r){let a=0,n;if((0,p.isReadableBufferedStream)(r)){if(r.buffer.length>0){const t=k.VSBuffer.concat(r.buffer);await this.doWriteBuffer(c,l,t,t.byteLength,a,0),a+=t.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((t,s)=>{(0,p.listenStream)(n,{onData:async o=>{n.pause();try{await this.doWriteBuffer(c,l,o,o.byteLength,a,0)}catch(u){return s(u)}a+=o.byteLength,setTimeout(()=>n.resume())},onError:o=>s(o),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(c,l,r){let a=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(c,l,n,n.byteLength,a,0),a+=n.byteLength}async doWriteBuffer(c,l,r,a,n,t){let s=0;for(;s<a;)s+=await c.write(l,n+s,r.buffer,t+s,a-s)}async doWriteUnbuffered(c,l,r,a){return this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,l,r,a))}async doWriteUnbufferedQueued(c,l,r,a){let n;a instanceof k.VSBuffer?n=a:(0,p.isReadableStream)(a)?n=await(0,k.streamToBuffer)(a):(0,p.isReadableBufferedStream)(a)?n=await(0,k.bufferedStreamToBuffer)(a):n=(0,k.readableToBuffer)(a),await c.writeFile(l,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(c,l,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,l,r,a))}async doPipeBufferedQueued(c,l,r,a){let n,t;try{n=await c.open(l,{create:!1}),t=await r.open(a,{create:!0,unlock:!1});const s=k.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,u=0,d=0;do d=await c.read(n,o,s.buffer,u,s.byteLength-u),await this.doWriteBuffer(r,t,s,d,o,u),o+=d,u+=d,u===s.byteLength&&(u=0);while(d>0)}catch(s){throw(0,S.ensureFileSystemProviderError)(s)}finally{await i.Promises.settled([typeof n=="number"?c.close(n):Promise.resolve(),typeof t=="number"?r.close(t):Promise.resolve()])}}async doPipeUnbuffered(c,l,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,l,r,a))}async doPipeUnbufferedQueued(c,l,r,a){return r.writeFile(a,await c.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,l,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,l,r,a))}async doPipeUnbufferedToBufferedQueued(c,l,r,a){const n=await r.open(a,{create:!0,unlock:!1});try{const t=await c.readFile(l);await this.doWriteBuffer(r,n,k.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,S.ensureFileSystemProviderError)(t)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(c,l,r,a){const n=await(0,k.streamToBuffer)(this.readFileBuffered(c,l,_.CancellationToken.None));await this.doWriteUnbuffered(r,a,void 0,n)}throwIfFileSystemIsReadonly(c,l){if(c.capabilities&2048)throw new S.FileOperationError((0,h.localize)(22,null,this.resourceForError(l)),6);return c}throwIfFileIsReadonly(c,l){if((l.permissions??0)&S.FilePermission.Readonly)throw new S.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===P.Schemas.file?c.fsPath:c.toString(!0)}};w.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},w=de([J(0,y.ILogService)],w),e.FileService=w}),define(ne[177],ie([0,1,50,248,5,39,18,3,41,2,9,4,19,40,20,138,14,82,165,166,174,37]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h,S,v,y,w,g,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,i.gracefulify)(L)}catch(a){console.error(`Error enabling graceful-fs: ${(0,l.toErrorMessage)(a)}`)}})();class r extends c.AbstractDiskFileSystemProvider{constructor(n,t){super(n);this.options=t,this.onDidChangeCapabilities=D.Event.None,this.resourceLocks=new _.ResourceMap(s=>f.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:t,symbolicLink:s}=await h.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(t,s),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.toFileSystemProviderError(t)}}async readdir(n){try{const t=await h.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),s=[];return await Promise.all(t.map(async o=>{try{let u;o.isSymbolicLink()?u=(await this.stat((0,f.joinPath)(n,o.name))).type:u=this.toType(o),s.push([o.name,u])}catch(u){this.logService.trace(u)}})),s}catch(t){throw this.toFileSystemProviderError(t)}}toType(n,t){let s;return t?.dangling?s=v.FileType.Unknown:n.isFile()?s=v.FileType.File:n.isDirectory()?s=v.FileType.Directory:s=v.FileType.Unknown,t&&(s|=v.FileType.SymbolicLink),s}async createResourceLock(n){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(n)})`);let t;for(;t=this.resourceLocks.get(n);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(n)})`),await t.wait();const s=new k.Barrier;return this.resourceLocks.set(n,s),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(n)})`),(0,b.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(n)})`),this.resourceLocks.delete(n),s.open()})}async readFile(n,t){let s;try{t?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),s=await this.createResourceLock(n));const o=this.toFilePath(n);return await h.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{s?.dispose()}}readFileStream(n,t,s){const o=(0,p.newWriteableStream)(u=>T.VSBuffer.concat(u.map(d=>T.VSBuffer.wrap(d))).buffer);return(0,y.readFileIntoStream)(this,n,o,u=>u.buffer,{...t,bufferSize:256*1024},s),o}async writeFile(n,t,s){let o;try{const u=this.toFilePath(n);if(!s.create||!s.overwrite){if(await h.Promises.exists(u)){if(!s.overwrite)throw(0,v.createFileSystemProviderError)((0,S.localize)(0,null),v.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,v.createFileSystemProviderError)((0,S.localize)(1,null),v.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(n,{create:!0,unlock:s.unlock}),await this.write(o,0,t,0,t.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(n,u)}finally{typeof o=="number"&&await this.close(o)}}async open(n,t){let s;(0,v.isFileOpenForWriteOptions)(t)&&(s=await this.createResourceLock(n));let o;try{const u=this.toFilePath(n);if((0,v.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:m}=await h.SymlinkSupport.stat(u);m.mode&128||await h.Promises.chmod(u,m.mode|128)}catch(m){this.logService.trace(m)}let d;if((0,v.isFileOpenForWriteOptions)(t)){if(E.isWindows)try{await h.Promises.truncate(u,0),d="r+"}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}d||(d="w")}else d="r";o=await h.Promises.open(u,d)}catch(u){throw s?.dispose(),(0,v.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(n,u):this.toFileSystemProviderError(u)}return this.mapHandleToPos.set(o,0),(0,v.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(o,n),s&&this.mapHandleToLock.set(o,s),o}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await h.Promises.fdatasync(n)}catch(t){this.canFlush=!1,this.logService.error(t)}return await h.Promises.close(n)}catch(t){throw this.toFileSystemProviderError(t)}finally{const t=this.mapHandleToLock.get(n);t&&(this.mapHandleToLock.delete(n),t.dispose())}}async read(n,t,s,o,u){const d=this.normalizePos(n,t);let m=null;try{const I=await h.Promises.read(n,s,o,u,d);return typeof I=="number"?m=I:m=I.bytesRead,m}catch(I){throw this.toFileSystemProviderError(I)}finally{this.updatePos(n,d,m)}}normalizePos(n,t){return t===this.mapHandleToPos.get(n)?null:t}updatePos(n,t,s){const o=this.mapHandleToPos.get(n);typeof o=="number"&&(typeof t=="number"||(typeof s=="number"?this.mapHandleToPos.set(n,o+s):this.mapHandleToPos.delete(n)))}async write(n,t,s,o,u){return(0,k.retry)(()=>this.doWrite(n,t,s,o,u),100,3)}async doWrite(n,t,s,o,u){const d=this.normalizePos(n,t);let m=null;try{const I=await h.Promises.write(n,s,o,u,d);return typeof I=="number"?m=I:m=I.bytesWritten,m}catch(I){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),I)}finally{this.updatePos(n,d,m)}}async mkdir(n){try{await h.Promises.mkdir(this.toFilePath(n))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(n,t){try{const s=this.toFilePath(n);t.recursive?await h.Promises.rm(s,h.RimRafMode.MOVE):await h.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(n,t,s){const o=this.toFilePath(n),u=this.toFilePath(t);if(o!==u)try{await this.validateTargetDeleted(n,t,"move",s.overwrite),await h.Promises.move(o,u)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,S.localize)(2,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(u)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(n,t,s){const o=this.toFilePath(n),u=this.toFilePath(t);if(o!==u)try{await this.validateTargetDeleted(n,t,"copy",s.overwrite),await h.Promises.copy(o,u,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,S.localize)(3,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(u)),d.toString()))),this.toFileSystemProviderError(d)}}async validateTargetDeleted(n,t,s,o){const u=this.toFilePath(n),d=this.toFilePath(t);let m=!1;if(!!(this.capabilities&1024)||(m=(0,C.isEqual)(u,d,!0)),m&&s==="copy")throw(0,v.createFileSystemProviderError)((0,S.localize)(4,null),v.FileSystemProviderErrorCode.FileExists);if(!m&&await h.Promises.exists(d)){if(!o)throw(0,v.createFileSystemProviderError)((0,S.localize)(5,null),v.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(n,t,s){return new g.ParcelWatcherClient(o=>n(o),o=>t(o),s)}doWatch(n,t){const s=this.options?.watcher?.usePolling;if(s===!0)for(const o of t)o.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(s))for(const o of t)s.includes(o.path)&&(o.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(n,t)}createNonRecursiveWatcher(n,t,s,o){return new w.NodeJSFileWatcher(n,u=>t(u),u=>s(u),o)}toFileSystemProviderError(n){if(n instanceof v.FileSystemProviderError)return n;let t;switch(n.code){case"ENOENT":t=v.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=v.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=v.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=v.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=v.FileSystemProviderErrorCode.NoPermissions;break;default:t=v.FileSystemProviderErrorCode.Unknown}return(0,v.createFileSystemProviderError)(n,t)}async toFileSystemProviderWriteError(n,t){let s=this.toFileSystemProviderError(t);if(n&&s.code===v.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await h.SymlinkSupport.stat(this.toFilePath(n));o.mode&128||(s=(0,v.createFileSystemProviderError)(t,v.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return s}}e.DiskFileSystemProvider=r}),define(ne[84],ie([0,1,3,7,10]),function(Q,e,L,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class _{constructor(f){this.service=f,this.onDidChangeLogLevel=L.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(f,p,h){switch(p){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=_;class T{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){T.setLevel(this.channel,f)}static setLevel(f,p){return f.call("setLevel",p)}}e.LogLevelChannelClient=T;class D{constructor(f){this.loggerService=f,this.loggers=new Map}listen(f,p){throw new Error(`Event not found: ${p}`)}async call(f,p,h){switch(p){case"createLogger":this.createLogger(i.URI.revive(h[0]),h[1]);return;case"log":return this.log(i.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${p}`)}createLogger(f,p){this.loggers.set(f.toString(),this.loggerService.createLogger(f,p))}consoleLog(f,p){let h=console.log;switch(f){case k.LogLevel.Error:h=console.error;break;case k.LogLevel.Warning:h=console.warn;break;case k.LogLevel.Info:h=console.info;break}h.call(console,...p)}log(f,p){const h=this.loggers.get(f.toString());if(!h)throw new Error("Create the logger before logging");for(const[S,v]of p)(0,k.log)(h,S,v)}}e.LoggerChannel=D;class C extends k.AbstractLoggerService{constructor(f,p,h){super(f,p);this.channel=h}createConsoleMainLogger(){return new k.AdapterLogger({log:(f,p)=>{this.channel.call("consoleLog",[f,p])}})}doCreateLogger(f,p,h){return new b(this.channel,f,p,h)}}e.LoggerChannelClient=C;class b extends k.AbstractMessageLogger{constructor(f,p,h,S){super(S?.always);this.channel=f,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[p,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,p){const h=[[f,p]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(f){this.channel.call("log",[this.file,f])}}class P extends k.LogService{constructor(f,p){super(p);this.parent=f,this._register(f.onDidChangeLogLevel(h=>p.setLevel(h)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=P}),define(ne[60],ie([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,L.createDecorator)("nativeHostService")}),define(ne[85],ie([0,1,16,4,31,19]),function(Q,e,L,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof i.globals.vscode!="undefined"&&typeof i.globals.vscode.context!="undefined"){const D=i.globals.vscode.context.configuration();if(D)T=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Q?.__$__nodeRequire=="function"){const D=(0,_.dirname)(L.FileAccess.asFileUri("",Q));T=Q.__$__nodeRequire((0,_.joinPath)(D,"product.json").fsPath);const C=Q.__$__nodeRequire((0,_.joinPath)(D,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:C.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T}),define(ne[26],ie([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService")}),define(ne[178],ie([0,1,5,8,2,9,20,10,26]),function(Q,e,L,i,k,_,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends k.Disposable{constructor(E,f,p){super();this.productService=f,this.logService=p,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpCodeCaches(E)},30*1e3)).schedule()}async cleanUpCodeCaches(E){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),p=(0,_.dirname)(E),h=(0,_.basename)(E),S=await T.Promises.readdir(p);await Promise.all(S.map(async v=>{if(v===h)return;const y=(0,_.join)(p,v),w=await T.Promises.stat(y);if(w.isDirectory()&&f-w.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${v}.`),T.Promises.rm(y)}))}catch(f){(0,i.onUnexpectedError)(f)}}};b=de([J(1,C.IProductService),J(2,D.ILogService)],b),e.CodeCacheCleaner=b}),define(ne[179],ie([0,1,5,8,2,9,20,13,10,26]),function(Q,e,L,i,k,_,T,D,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends k.Disposable{constructor(f,p,h){super();this.environmentService=f,this.logService=p,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),p=JSON.parse(await T.Promises.readFile((0,_.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let w of Object.keys(p)){const g=p[w];f[`${g.hash}.${w}`]=!0}const h=(0,_.join)(this.environmentService.userDataPath,"clp");if(!await T.Promises.exists(h))return;const v=await T.Promises.readdir(h);for(const w of v){if(f[w]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${w}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${w}`),await T.Promises.rm((0,_.join)(h,w))}const y=Date.now();for(const w of Object.keys(f)){const g=(0,_.join)(h,w),c=await T.Promises.readdir(g);for(const l of c){if(l==="tcf.json")continue;const r=(0,_.join)(g,l),a=await T.Promises.stat(r);a.isDirectory()&&y-a.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,_.join)(w,l)}`),await T.Promises.rm(r))}}}catch(f){(0,i.onUnexpectedError)(f)}}};P=de([J(0,D.INativeEnvironmentService),J(1,C.ILogService),J(2,b.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(ne[38],ie([0,1,98,15]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(T,D){L.ok(i.isString(T)),L.ok(i.isObject(D)),L.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,D)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new k}),define(ne[86],ie([0,1,3,38]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class _{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,b){this.schemasById[k(C)]=b,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new _;i.Registry.add(e.Extensions.JSONContribution,T)}),define(ne[42],ie([0,1,17,3,15,124,86,38]),function(Q,e,L,i,k,_,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=D.Registry.as(T.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new i.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new i.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,r=!0){this.registerConfigurations([l],r)}registerConfigurations(l,r=!0){const a=this.doRegisterConfigurations(l,r);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}deregisterConfigurations(l){const r=this.doDeregisterConfigurations(l);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:l,remove:r}){const a=[];a.push(...this.doDeregisterConfigurations(r)),a.push(...this.doRegisterConfigurations(l,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,L.distinct)(a)})}registerDefaultConfigurations(l){const r=[],a=[];for(const{overrides:n,source:t}of l)for(const s in n)if(r.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const o={...this.configurationDefaultsOverrides.get(s)?.value||{},...n[s]};this.configurationDefaultsOverrides.set(s,{source:t,value:o});const u={type:"object",default:o,description:_.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:k.isString(t)?void 0:t};a.push(...h(s)),this.configurationProperties[s]=u,this.defaultLanguageConfigurationOverridesNode.properties[s]=u}else{this.configurationDefaultsOverrides.set(s,{value:n[s],source:t});const o=this.configurationProperties[s];o&&(this.updatePropertyDefaultValue(s,o),this.updateSchema(s,o))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(l){const r=[];for(const{overrides:a,source:n}of l)for(const t in a){const s=this.configurationDefaultsOverrides.get(t),o=k.isString(n)?n:n?.id,u=k.isString(s?.source)?s?.source:s?.source?.id;if(o===u)if(r.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const d=this.configurationProperties[t];d&&(this.updatePropertyDefaultValue(t,d),this.updateSchema(t,d))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const r of l)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,r){const a=[];return l.forEach(n=>{a.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),a}doDeregisterConfigurations(l){const r=[],a=n=>{if(n.properties)for(const t in n.properties)r.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,n.properties[t]);n.allOf&&n.allOf.forEach(t=>a(t))};for(const n of l){a(n);const t=this.configurationContributors.indexOf(n);t!==-1&&this.configurationContributors.splice(t,1)}return r}validateAndRegisterProperties(l,r=!0,a,n,t=3){t=k.isUndefinedOrNull(l.scope)?t:l.scope;let s=[],o=l.properties;if(o)for(let d in o){if(r&&w(d)){delete o[d];continue}const m=o[d];if(m.source=a,m.defaultDefaultValue=o[d].default,this.updatePropertyDefaultValue(d,m),e.OVERRIDE_PROPERTY_REGEX.test(d)?m.scope=void 0:(m.scope=k.isUndefinedOrNull(m.scope)?t:m.scope,m.restricted=k.isUndefinedOrNull(m.restricted)?!!n?.includes(d):m.restricted),o[d].hasOwnProperty("included")&&!o[d].included){this.excludedConfigurationProperties[d]=o[d],delete o[d];continue}else this.configurationProperties[d]=o[d];!o[d].deprecationMessage&&o[d].markdownDeprecationMessage&&(o[d].deprecationMessage=o[d].markdownDeprecationMessage),s.push(d)}let u=l.allOf;if(u)for(let d of u)s.push(...this.validateAndRegisterProperties(d,r,a,n,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const r=a=>{let n=a.properties;if(n)for(const s in n)this.updateSchema(s,n[s]);let t=a.allOf;t&&t.forEach(r)};r(l)}updateSchema(l,r){switch(e.allSettings.properties[l]=r,r.scope){case 1:e.applicationSettings.properties[l]=r;break;case 2:e.machineSettings.properties[l]=r;break;case 6:e.machineOverridableSettings.properties[l]=r;break;case 3:e.windowSettings.properties[l]=r;break;case 4:e.resourceSettings.properties[l]=r;break;case 5:e.resourceSettings.properties[l]=r,this.resourceLanguageSettingsSchema.properties[l]=r;break}}removeFromSchema(l,r){switch(delete e.allSettings.properties[l],r.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const r=`[${l}]`,a={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,a),e.allSettings.properties[r]=a,e.applicationSettings.properties[r]=a,e.machineSettings.properties[r]=a,e.machineOverridableSettings.properties[r]=a,e.windowSettings.properties[r]=a,e.resourceSettings.properties[r]=a}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:_.localize(4,null),errorMessage:_.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,r){const a=this.configurationDefaultsOverrides.get(l);let n=a?.value,t=a?.source;k.isUndefined(n)&&(n=r.defaultDefaultValue,t=void 0),k.isUndefined(n)&&(n=v(r.type)),r.default=n,r.defaultValueSource=t}}const f="\\[([^\\]]+)\\]",p=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(c){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let r=p.exec(c);for(;r?.length;){const a=r[1].trim();a&&l.push(a),r=p.exec(c)}}return(0,L.distinct)(l)}e.overrideIdentifiersFromKey=h;function S(c){return c.reduce((l,r)=>`${l}[${r}]`,"")}e.keyFromOverrideIdentifiers=S;function v(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const y=new E;D.Registry.add(e.Extensions.Configuration,y);function w(c){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?_.localize(7,null,c):y.getConfigurationProperties()[c]!==void 0?_.localize(8,null,c):null:_.localize(6,null)}e.validateProperty=w;function g(){const c=[],l=y.getConfigurationProperties();for(const r of Object.keys(l))c.push([r,l[r].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=g}),define(ne[87],ie([0,1,17,3,35,2,39,28,15,7,21,42,38]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(n={},t=[],s=[]){this._contents=n,this._keys=t,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,P.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const s=this.getContentsForOverrideIdentifer(t);return s?n?(0,P.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const s of this.overrides)s.identifiers.includes(n)&&t.push(...s.keys);return L.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return L.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=D.deepClone(this.contents),s=D.deepClone(this.overrides),o=[...this.keys];for(const u of n){this.mergeContents(t,u.contents);for(const d of u.overrides){const[m]=s.filter(I=>L.equals(I.identifiers,d.identifiers));m?(this.mergeContents(m.contents,d.contents),m.keys.push(...d.keys),m.keys=L.distinct(m.keys)):s.push(D.deepClone(d))}for(const d of u.keys)o.indexOf(d)===-1&&o.push(d)}return new p(t,o,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let s={};for(const o of L.distinct([...Object.keys(this.contents),...Object.keys(t)])){let u=this.contents[o],d=t[o];d&&(typeof u=="object"&&typeof d=="object"?(u=D.deepClone(u),this.mergeContents(u,d)):u=d),s[o]=u}return new p(s,this.keys,this.overrides)}mergeContents(n,t){for(const s of Object.keys(t)){if(s in n&&C.isObject(n[s])&&C.isObject(t[s])){this.mergeContents(n[s],t[s]);continue}n[s]=D.deepClone(t[s])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?D.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,s=null;const o=u=>{u&&(s?this.mergeContents(s,u):s=D.deepClone(u))};for(const u of this.overrides)L.equals(u.identifiers,[n])?t=u.contents:u.identifiers.includes(n)&&o(u.contents);return o(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,P.addToValueTree)(this.contents,n,t,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,P.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let s=0;s<t;s++)n.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=p;class h extends p{constructor(n={}){const t=f.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(t),o=Object.create(null),u=[];for(const d in t){const m=n[d],I=m!==void 0?m:t[d].default;(0,P.addToValueTree)(o,d,I,A=>console.error(`Conflict in default settings: ${A}`))}for(const d of Object.keys(o))E.OVERRIDE_PROPERTY_REGEX.test(d)&&u.push({identifiers:(0,E.overrideIdentifiersFromKey)(d),keys:Object.keys(o[d]),contents:(0,P.toValuesTree)(o[d],m=>console.error(`Conflict in default settings file: ${m}`))});super(o,s,u)}}e.DefaultConfigurationModel=h;class S{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!C.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:s,keys:o,overrides:u,restricted:d}=this.doParseRaw(n,t);this._configurationModel=new p(s,o,u),this._restrictedConfigurations=d||[]}doParseContent(n){let t={},s=null,o=[],u=[],d=[];function m(A){Array.isArray(o)?o.push(A):s!==null&&(o[s]=A)}let I={onObjectBegin:()=>{let A={};m(A),u.push(o),o=A,s=null},onObjectProperty:A=>{s=A},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{let A=[];m(A),u.push(o),o=A,s=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:m,onError:(A,O,N)=>{d.push({error:A,offset:O,length:N})}};if(n)try{k.visit(n,I),t=o[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return t}doParseRaw(n,t){const s=f.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=this.filter(n,s,!0,t);n=o.raw;const u=(0,P.toValuesTree)(n,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),d=Object.keys(n),m=this.toOverrides(n,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:u,keys:d,overrides:m,restricted:o.restricted}}filter(n,t,s,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[]};const u={},d=[];for(let m in n)if(E.OVERRIDE_PROPERTY_REGEX.test(m)&&s){const I=this.filter(n[m],t,!1,o);u[m]=I.raw,d.push(...I.restricted)}else{const I=t[m],A=I?typeof I.scope!="undefined"?I.scope:3:void 0;I?.restricted&&d.push(m),(A===void 0||o.scopes===void 0||o.scopes.includes(A))&&(o.skipRestricted&&I?.restricted||(u[m]=n[m]))}return{raw:u,restricted:d}}toOverrides(n,t){const s=[];for(const o of Object.keys(n))if(E.OVERRIDE_PROPERTY_REGEX.test(o)){const u={};for(const d in n[o])u[d]=n[o][d];s.push({identifiers:(0,E.overrideIdentifiersFromKey)(o),keys:Object.keys(u),contents:(0,P.toValuesTree)(u,t)})}return s}}e.ConfigurationModelParser=S;class v extends _.Disposable{constructor(n,t,s,o){super();this.userSettingsResource=n,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new S(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(i.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class y{constructor(n,t,s=new p,o=new p,u=new T.ResourceMap,d=new p,m=new T.ResourceMap,I=!0){this._defaultConfiguration=n,this._localUserConfiguration=t,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=u,this._memoryConfiguration=d,this._memoryConfigurationByResource=m,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(n,t,s){return this.getConsolidateConfigurationModel(t,s).getValue(n)}updateValue(n,t,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new p,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(n):o.setValue(n,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,s){const o=this.getConsolidateConfigurationModel(t,s),u=this.getFolderConfigurationModelForResource(t.resource,s),d=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,m=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),I=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),A=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),O=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),N=s?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,$=u?t.overrideIdentifier?u.freeze().override(t.overrideIdentifier).getValue(n):u.freeze().getValue(n):void 0,R=t.overrideIdentifier?d.override(t.overrideIdentifier).getValue(n):d.getValue(n),M=o.getValue(n),W=L.distinct(L.flatten(o.overrides.map(U=>U.identifiers))).filter(U=>o.getOverrideValue(n,U)!==void 0);return{defaultValue:m,userValue:I,userLocalValue:A,userRemoteValue:O,workspaceValue:N,workspaceFolderValue:$,memoryValue:R,value:M,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:$!==void 0?{value:u?.freeze().getValue(n),override:t.overrideIdentifier?u?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:R!==void 0?{value:d.getValue(n),override:t.overrideIdentifier?d.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const s=[];if(!t){const{added:o,updated:u,removed:d}=l(this._defaultConfiguration,n);t=[...o,...u,...d]}for(const o of t)for(const u of(0,E.overrideIdentifiersFromKey)(o)){const d=this._defaultConfiguration.getKeysForOverrideIdentifier(u),m=n.getKeysForOverrideIdentifier(u),I=[...m.filter(A=>d.indexOf(A)===-1),...d.filter(A=>m.indexOf(A)===-1),...d.filter(A=>!D.equals(this._defaultConfiguration.override(u).getValue(A),n.override(u).getValue(A)))];s.push([u,I])}return this.updateDefaultConfiguration(n),{keys:t,overrides:s}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:s,removed:o,overrides:u}=l(this.localUserConfiguration,n),d=[...t,...s,...o];return d.length&&this.updateLocalUserConfiguration(n),{keys:d,overrides:u}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:s,removed:o,overrides:u}=l(this.remoteUserConfiguration,n);let d=[...t,...s,...o];return d.length&&this.updateRemoteUserConfiguration(n),{keys:d,overrides:u}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:s,removed:o,overrides:u}=l(this.workspaceConfiguration,n);let d=[...t,...s,...o];return d.length&&this.updateWorkspaceConfiguration(n),{keys:d,overrides:u}}compareAndUpdateFolderConfiguration(n,t){const s=this.folderConfigurations.get(n),{added:o,updated:u,removed:d,overrides:m}=l(s,t);let I=[...o,...u,...d];return(I.length||!s)&&this.updateFolderConfiguration(n,t),{keys:I,overrides:m}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:o,removed:u,overrides:d}=l(t,void 0);return{keys:[...s,...o,...u],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,t){let s=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier?s.override(n.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:n},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const o=t.getFolder(n);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const u=this._memoryConfigurationByResource.get(n);u&&(s=s.merge(u))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(n);o?(t=s.merge(o),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=s}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const s=t.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:s,overrides:o,keys:u}=this._folderConfigurations.get(t);return n.push([t,{contents:s,overrides:o,keys:u}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.user),o=this.parseConfigurationModel(n.workspace),u=n.folders.reduce((d,m)=>(d.set(b.URI.revive(m[0]),this.parseConfigurationModel(m[1])),d),new T.ResourceMap);return new y(t,s,new p,o,u,new p,new T.ResourceMap,!1)}static parseConfigurationModel(n){return new p(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=y;function w(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,t=new Map;for(const o of a)o.keys.forEach(u=>n.add(u)),o.overrides.forEach(([u,d])=>{const m=(0,T.getOrSet)(t,u,new Set);d.forEach(I=>m.add(I))});const s=[];return t.forEach((o,u)=>s.push([u,[...o.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=w;class g{constructor(n,t,s,o){this.change=n,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const u=new Set;n.keys.forEach(m=>u.add(m)),n.overrides.forEach(([,m])=>m.forEach(I=>u.add(I))),this.affectedKeys=[...u.values()];const d=new p;this.affectedKeys.forEach(m=>d.setValue(m,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!D.equals(s,o)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let s=(0,P.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(n=n[o],!n)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=g;class c extends g{constructor(n,t,s,o){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=c;function l(a,n){const{added:t,removed:s,updated:o}=r(n,a),u=[],d=a?.getAllOverrideIdentifiers()||[],m=n?.getAllOverrideIdentifiers()||[];if(n){const I=m.filter(A=>!d.includes(A));for(const A of I)u.push([A,n.getKeysForOverrideIdentifier(A)])}if(a){const I=d.filter(A=>!m.includes(A));for(const A of I)u.push([A,a.getKeysForOverrideIdentifier(A)])}if(n&&a){for(const I of d)if(m.includes(I)){const A=r({contents:a.getOverrideValue(void 0,I)||{},keys:a.getKeysForOverrideIdentifier(I)},{contents:n.getOverrideValue(void 0,I)||{},keys:n.getKeysForOverrideIdentifier(I)});u.push([I,[...A.added,...A.removed,...A.updated]])}}return{added:t,removed:s,updated:o,overrides:u}}function r(a,n){const t=a?n?a.keys.filter(u=>n.keys.indexOf(u)===-1):[...a.keys]:[],s=n?a?n.keys.filter(u=>a.keys.indexOf(u)===-1):[...n.keys]:[],o=[];if(a&&n){for(const u of n.keys)if(a.keys.indexOf(u)!==-1){const d=(0,P.getConfigurationValue)(n.contents,u),m=(0,P.getConfigurationValue)(a.contents,u);D.equals(d,m)||o.push(u)}}return{added:t,removed:s,updated:o}}}),define(ne[180],ie([0,1,5,3,2,19,21,87,42,38]),function(Q,e,L,i,k,_,T,D,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends k.Disposable{constructor(f,p){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new i.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new D.UserSettings(this.settingsResource,void 0,_.extUriBiasedIgnorePathCase,p)),this.configuration=new D.Configuration(new D.DefaultConfigurationModel,new D.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(b.Registry.as(C.Extensions.Configuration).onDidUpdateConfiguration(({properties:h})=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new D.Configuration(new D.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,p){const h=typeof f=="string"?f:void 0,S=(0,T.isConfigurationOverrides)(f)?f:(0,T.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(h,S,void 0)}updateValue(f,p,h,S){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(h,p,1)}onDidDefaultConfigurationChange(f){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new D.DefaultConfigurationModel,f);this.trigger(h,p,6)}trigger(f,p,h){const S=new D.ConfigurationChangeEvent(f,{data:p},this.configuration);S.source=h,S.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(ne[181],ie([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var i;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(i=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(T,D=i.Unknown,C){super(T);this._message=T,this._code=D,this._detail=C,this.isHandled=D===i.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(T){return T instanceof k&&T._code===i.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof k&&T._code===i.NoResolverFound}static isHandled(T){return T instanceof k&&T.isHandled}}e.RemoteAuthorityResolverError=k}),define(ne[182],ie([0,1,5,18,27,8,3,2,30,71,181]),function(Q,e,L,i,k,_,T,D,C,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var f;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function p(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(H){const Z=new k.CancellationTokenSource;return setTimeout(()=>Z.cancel(),H),Z.token}function S(H,Z){if(H.isCancellationRequested||Z.isCancellationRequested)return k.CancellationToken.Cancelled;const K=new k.CancellationTokenSource;return H.onCancellationRequested(()=>K.cancel()),Z.onCancellationRequested(()=>K.cancel()),K.token}class v{constructor(Z){this._state="pending",this._disposables=new D.DisposableStore,this.promise=new Promise((K,F)=>{this._resolvePromise=K,this._rejectPromise=F}),Z.isCancellationRequested?this._timeout():this._disposables.add(Z.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(Z){this._state==="pending"?this._disposables.add(Z):Z.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Z=new Error("Time limit reached");return Z.code="ETIMEDOUT",Z.syscall="connect",Z}resolve(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Z))}reject(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Z))}}function y(H,Z){const K=new v(Z);return K.registerDisposable(H.onControlMessage(F=>{const j=JSON.parse(F.toString()),B=x(j);B?K.reject(B):K.resolve(j)})),K.promise}function w(H,Z,K,F,j,B,z){const V=new v(z);return Z.connect(K,F,j,B,(te,se)=>{V.didTimeout?(te&&H.error(te),se?.dispose()):te||!se?V.reject(te):V.resolve(se)}),V.promise}function g(H,Z){const K=new v(Z);return H.then(F=>{K.didTimeout||K.resolve(F)},F=>{K.didTimeout||K.reject(F)}),K.promise}async function c(H,Z,K,F){const j=q(H,Z);H.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let B;try{B=await w(H.logService,H.socketFactory,H.host,H.port,`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,`renderer-${p(Z)}-${H.reconnectionToken}`,F)}catch(ce){throw H.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),H.logService.error(ce),ce}H.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let z,V;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(B,null),z=H.reconnectionProtocol,V=!1):(z=new b.PersistentProtocol(B,null),V=!0),H.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const te=await g(H.signService.createNewMessage((0,C.generateUuid)()),F),se={type:"auth",auth:H.connectionToken||"00000000000000000000",data:te.data};z.sendControl(i.VSBuffer.fromString(JSON.stringify(se)));try{const ce=await y(z,S(F,h(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const ge=new Error("Unexpected handshake message");throw ge.code="VSCODE_CONNECTION_ERROR",ge}if(H.logService.trace(`${j} 4/6. received SignRequest control message.`),!await g(H.signService.validate(te,ce.signedData),F)){const ge=new Error("Refused to connect to unsupported server");throw ge.code="VSCODE_CONNECTION_ERROR",ge}const me=await g(H.signService.sign(ce.data),F),ve={type:"connectionType",commit:H.commit,signedData:me,desiredConnectionType:Z};return K&&(ve.args=K),H.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),z.sendControl(i.VSBuffer.fromString(JSON.stringify(ve))),{protocol:z,ownsProtocol:V}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(H.logService.error(`${j} the handshake timed out. Error:`),H.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${j} received error control message when negotiating connection. Error:`),H.logService.error(ce)),V&&U(z),ce}}async function l(H,Z,K,F){const j=Date.now(),B=q(H,Z),{protocol:z,ownsProtocol:V}=await c(H,Z,K,F),te=new v(F);return te.registerDisposable(z.onControlMessage(se=>{const ce=JSON.parse(se.toString()),he=x(ce);he?(H.logService.error(`${B} received error control message when negotiating connection. Error:`),H.logService.error(he),V&&U(z),te.reject(he)):(H.reconnectionProtocol&&H.reconnectionProtocol.endAcceptReconnection(),H.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${Y(j)}!`),te.resolve({protocol:z,firstMessage:ce}))})),te.promise}async function r(H,Z){const{protocol:K}=await l(H,1,void 0,Z);return{protocol:K}}async function a(H,Z,K){const{protocol:F,firstMessage:j}=await l(H,2,Z,K),B=j&&j.debugPort;return{protocol:F,debugPort:B}}async function n(H,Z,K){const F=Date.now(),j=q(H,3),{protocol:B}=await c(H,3,Z,K);return H.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${Y(F)}!`),B}async function t(H,Z,K){const{host:F,port:j,connectionToken:B}=await H.addressProvider.getAddress();return{commit:H.commit,host:F,port:j,connectionToken:B,reconnectionToken:Z,reconnectionProtocol:K,socketFactory:H.socketFactory,signService:H.signService,logService:H.logService}}async function s(H,Z,K){try{const F=(0,C.generateUuid)(),j=await t(H,F,null),{protocol:B}=await r(j,k.CancellationToken.None);return new M(H,Z,K,F,B)}catch(F){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(F),R.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(F)),F}}e.connectRemoteAgentManagement=s;async function o(H,Z){try{const K=(0,C.generateUuid)(),F=await t(H,K,null),{protocol:j,debugPort:B}=await a(F,Z,k.CancellationToken.None);return new W(H,Z,K,j,B)}catch(K){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(K),R.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(K)),K}}e.connectRemoteAgentExtensionHost=o;async function u(H,Z,K){const F=await t(H,(0,C.generateUuid)(),null);return await n(F,{host:Z,port:K},k.CancellationToken.None)}e.connectRemoteAgentTunnel=u;function d(H){return(0,L.createCancelablePromise)(Z=>new Promise((K,F)=>{const j=setTimeout(K,H*1e3);Z.onCancellationRequested(()=>{clearTimeout(j),K()})}))}var m;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(m=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class I{constructor(Z,K){this.reconnectionToken=Z,this.millisSinceLastIncomingData=K,this.type=0}}e.ConnectionLostEvent=I;class A{constructor(Z,K,F,j){this.reconnectionToken=Z,this.millisSinceLastIncomingData=K,this.durationSeconds=F,this.cancellableTimer=j,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=A;class O{constructor(Z,K,F){this.reconnectionToken=Z,this.millisSinceLastIncomingData=K,this.attempt=F,this.type=2}}e.ReconnectionRunningEvent=O;class N{constructor(Z,K,F){this.reconnectionToken=Z,this.millisSinceLastIncomingData=K,this.attempt=F,this.type=4}}e.ConnectionGainEvent=N;class ${constructor(Z,K,F,j){this.reconnectionToken=Z,this.millisSinceLastIncomingData=K,this.attempt=F,this.handled=j,this.type=3}}e.ReconnectionPermanentFailureEvent=$;class R extends D.Disposable{constructor(Z,K,F,j){super();this._connectionType=Z,this._onDidStateChange=this._register(new T.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=K,this.reconnectionToken=F,this.protocol=j,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(j.onSocketClose(B=>{const z=G(this._connectionType,this.reconnectionToken,!0);B?B.type===0?(this._options.logService.info(`${z} received socket close event (hadError: ${B.hadError}).`),B.error&&this._options.logService.error(B.error)):(this._options.logService.info(`${z} received socket close event (wasClean: ${B.wasClean}, code: ${B.code}, reason: ${B.reason}).`),B.event&&this._options.logService.error(B.event)):this._options.logService.info(`${z} received socket close event.`),this._beginReconnecting()})),this._register(j.onSocketTimeout(()=>{const B=G(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${B} received socket timeout event.`),this._beginReconnecting()})),R._instances.push(this),R._permanentFailure&&this._gotoPermanentFailure(R._permanentFailureMillisSinceLastIncomingData,R._permanentFailureAttempt,R._permanentFailureHandled)}static triggerPermanentFailure(Z,K,F){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Z,this._permanentFailureAttempt=K,this._permanentFailureHandled=F,this._instances.forEach(j=>j._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Z=>Z._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Z=>Z._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(R._permanentFailure)return;const Z=G(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Z} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new I(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const K=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const j=F<K.length?K[F]:K[K.length-1];try{if(j>0){const z=d(j);this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,z)),this._options.logService.info(`${Z} waiting for ${j} seconds before reconnecting...`);try{await z}catch{}}if(R._permanentFailure){this._options.logService.error(`${Z} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this._options.logService.info(`${Z} resolving connection...`);const B=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Z} connecting to ${B.host}:${B.port}...`),await this._reconnect(B,h(E)),this._options.logService.info(`${Z} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(B),R.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this._options.logService.error(`${Z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(B),R.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(P.RemoteAuthorityResolverError.isTemporarilyNotAvailable(B)){this._options.logService.info(`${Z} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this._options.logService.info(`${Z} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((0,_.isPromiseCanceledError)(B)){this._options.logService.info(`${Z} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if(B instanceof P.RemoteAuthorityResolverError){this._options.logService.error(`${Z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(B),R.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,P.RemoteAuthorityResolverError.isHandled(B));break}this._options.logService.error(`${Z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(B),R.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!R._permanentFailure)}_gotoPermanentFailure(Z,K,F){this._onDidStateChange.fire(new $(this.reconnectionToken,Z,K,F)),U(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=R,R._permanentFailure=!1,R._permanentFailureMillisSinceLastIncomingData=0,R._permanentFailureAttempt=0,R._permanentFailureHandled=!1,R._instances=[];class M extends R{constructor(Z,K,F,j,B){super(1,Z,j,B);this.client=this._register(new b.Client(B,{remoteAuthority:K,clientId:F},Z.ipcLogger))}async _reconnect(Z,K){await r(Z,K)}}e.ManagementPersistentConnection=M;class W extends R{constructor(Z,K,F,j,B){super(2,Z,F,j);this._startArguments=K,this.debugPort=B}async _reconnect(Z,K){await a(Z,this._startArguments,K)}}e.ExtensionHostPersistentConnection=W;function U(H){try{H.acceptDisconnect();const Z=H.getSocket();H.dispose(),Z.dispose()}catch(Z){(0,_.onUnexpectedError)(Z)}}function x(H){if(H&&H.type==="error"){const Z=new Error(`Connection error: ${H.reason}`);return Z.code="VSCODE_CONNECTION_ERROR",Z}return null}function ee(H,Z){for(;H.length<Z;)H+=" ";return H}function G(H,Z,K){return`[remote-connection][${ee(p(H),13)}][${Z.substr(0,5)}\u2026][${K?"reconnect":"initial"}]`}function q(H,Z){return`${G(Z,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.host}:${H.port}]`}function Y(H){return`${Date.now()-H} ms`}}),define(ne[183],ie([0,1,16]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function i(b){return b.scheme===L.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=i;function k(b){if(!b)return;const P=b.indexOf("+");return P<0?b:b.substr(0,P)}e.getRemoteName=k;function _(b){return b.scheme!==L.Schemas.file&&b.scheme!==L.Schemas.vscodeRemote}e.isVirtualResource=_;function T(b){if(b.folders.length)return b.folders.every(P=>_(P.uri))?b.folders[0].uri:void 0;if(b.configuration&&_(b.configuration))return b.configuration}e.getVirtualWorkspaceLocation=T;function D(b){return T(b)?.scheme}e.getVirtualWorkspaceScheme=D;function C(b){return T(b)!==void 0}e.isVirtualWorkspace=C}),define(ne[88],ie([0,1,25,6,183]),function(Q,e,L,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function _(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=_;function T(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));class C{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,h){if(typeof p=="undefined"||p===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof p=="string"||typeof h=="string"){let S=typeof p=="string"?p:p.value,v=typeof h=="string"?h:h.value;return L.equalsIgnoreCase(S,v)}return p._lower===h._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=C;function b(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function P(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=P;function E(f,p){if(p){const h=`onResolveRemoteAuthority:${(0,k.getRemoteName)(p)}`;return f.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[33],ie([0,1,25,88]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(h,S){return h.uuid&&S.uuid?h.uuid===S.uuid:h.id===S.id?!0:(0,L.compareIgnoreCase)(h.id,S.id)===0}e.areSameExtensions=k;class _{constructor(S,v){this.version=v,this.id=S.id,this.uuid=S.uuid}key(){return`${this.id}-${this.version}`}equals(S){return S instanceof _?k(this,S)&&this.version===S.version:!1}}e.ExtensionIdentifierWithVersion=_;function T(h,S){return`${h}.${S}`}e.getExtensionId=T;function D(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function C(h,S){return D(T(h,S))}e.getGalleryExtensionId=C;function b(h,S){const v=[],y=w=>{for(const g of v)if(g.some(c=>k(S(c),S(w))))return g;return null};for(const w of h){const g=y(w);g?g.push(w):v.push([w])}return v}e.groupByExtension=b;function P(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=P;function E(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new i.ExtensionIdentifier("pprice.better-merge");function f(h){const S=new Set;if(h.malicious)for(const v of h.malicious)S.add(v.id);return S}e.getMaliciousExtensionsSet=f;function p(h,S){const v=[],y=S.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const w=y.shift();if(w&&v.every(g=>!k(g.identifier,{id:w}))){const g=h.filter(c=>k(c.identifier,{id:w}));g.length===1&&(v.push(g[0]),y.push(...g[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=p}),define(ne[184],ie([0,1,5,8,2,4,19,61,7,30,20,13,29,33,14,10]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let y=class extends k.Disposable{constructor(g,c,l,r){super();this.fileService=c,this.extensionGalleryService=l,this.logService=r,this.extensionsDownloadDir=C.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,c){await this.cleanUpPromise;const l=this.getName(g),r=(0,T.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(r)){const a=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(a)||await this.extensionGalleryService.download(g,a,c);try{await this.rename(a,r,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(a)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,a.path),n}}return r}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,c,l){try{await P.Promises.rename(g.fsPath,c.fsPath)}catch(r){if(_.isWindows&&r&&r.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${g} to ${c} with 'EPERM' error. Trying again...`),this.rename(g,c,l);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const c=[],l=[];for(const n of g.children){const t=this.parse(n.name);t&&l.push([t,n])}const r=(0,p.groupByExtension)(l,([n])=>n),a=[];for(const n of r)n.sort((t,s)=>D.rcompare(t[0].version,s[0].version)),c.push(...n.slice(1).map(t=>t[1].resource)),a.push(n[0][1]);a.sort((n,t)=>n.mtime-t.mtime),c.push(...a.slice(0,Math.max(0,a.length-this.cache)).map(n=>n.resource)),await L.Promises.settled(c.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?`${new p.ExtensionIdentifierWithVersion(g.identifier,g.version).key().toLowerCase()}${g.properties.targetPlatform!=="undefined"?`-${g.properties.targetPlatform}`:""}`:(0,b.generateUuid)()}parse(g){const c=v.exec(g);return c&&c[1]&&c[2]?new p.ExtensionIdentifierWithVersion({id:c[1]},c[2]):null}};y=de([J(0,E.INativeEnvironmentService),J(1,h.IFileService),J(2,f.IExtensionGalleryService),J(3,S.ILogService)],y),e.ExtensionsDownloader=y}),define(ne[185],ie([0,1,2,9,20,88]),function(Q,e,L,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends L.Disposable{constructor(C,b){super();this.environmentService=C,this.extensionsManifestCache=(0,i.join)(this.environmentService.userDataPath,_.MANIFEST_CACHE_FOLDER,_.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(P=>this.onDidInstallExtensions(P))),this._register(b.onDidUninstallExtension(P=>this.onDidUnInstallExtension(P)))}onDidInstallExtensions(C){C.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(C){C.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(ne[186],ie([0,1,81,17,5,2,16,9,20,13,29,33,59,10]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends _.Disposable{constructor(y,w,g){super();this.extensionManagementService=y,this.logService=g,this.cache=this._register(new S(w,g)),this.extensionManagementService.registerParticipant({postInstall:async c=>this.postInstallExtension(c),postUninstall:async c=>this.postUninstallExtension(c)})}async getLanguageIds(){const y=await this.cache.getLanguagePacks(),w=["en",...Object.keys(y)];return(0,i.distinct)(w)}async postInstallExtension(y){y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",y.identifier.id),await this.update())}async postUninstallExtension(y){const w=await this.cache.getLanguagePacks();Object.keys(w).some(g=>w[g]&&w[g].extensions.some(c=>(0,E.areSameExtensions)(c.extensionIdentifier,y.identifier)))&&(this.logService.info("Removing language packs from the extension",y.identifier.id),await this.update())}async update(){const[y,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),g=await this.cache.update(w);return!(0,i.equals)(Object.keys(y),Object.keys(g))}};h=de([J(0,P.IExtensionManagementService),J(1,b.INativeEnvironmentService),J(2,p.ILogService)],h),e.LocalizationsService=h;let S=class extends _.Disposable{constructor(y,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,D.join)(y.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new k.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(y){return this.withLanguagePacks(w=>{Object.keys(w).forEach(g=>delete w[g]),this.createLanguagePacksFromExtensions(w,...y)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(y,...w){for(const g of w)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(y,g);Object.keys(y).forEach(g=>this.updateHash(y[g]))}createLanguagePacksFromExtension(y,w){const g=w.identifier,c=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const l of c)if(w.location.scheme===T.Schemas.file&&(0,f.isValidLocalization)(l)){let r=y[l.languageId];r||(r={hash:"",extensions:[],translations:{}},y[l.languageId]=r);let a=r.extensions.filter(n=>(0,E.areSameExtensions)(n.extensionIdentifier,g))[0];a?a.version=w.manifest.version:r.extensions.push({extensionIdentifier:g,version:w.manifest.version});for(const n of l.translations)r.translations[n.id]=(0,D.join)(w.location.fsPath,n.path)}}updateHash(y){if(y){const w=(0,L.createHash)("md5");for(const g of y.extensions)w.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);y.hash=w.digest("hex")}}withLanguagePacks(y=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return C.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(w=y(g),g)).then(g=>{for(const l of Object.keys(g))g[l]||delete g[l];this.languagePacks=g,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),C.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>w,g=>this.logService.error(g))})}};S=de([J(0,b.INativeEnvironmentService),J(1,p.ILogService)],S)}),define(ne[187],ie([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,L.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[62],ie([0,1,3,4,6,10]),function(Q,e,L,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var T;(function(h){h.Http="http",h.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var D;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(D=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const S=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!S)return{address:S[1],port:+S[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=E;function f(h,S){return S?S!==1&&h<1024:!i.isWindows&&h<1024}e.isPortPrivileged=f;let p=class{constructor(S){this.logService=S,this._onTunnelOpened=new L.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new L.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new L.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(S,v){return this._tunnelProvider=S,S?(this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const S=[],v=Array.from(this._tunnels.values());for(let y of v){const w=Array.from(y.values());for(let g of w){const c=await g.value;c&&S.push(c)}}return S}async dispose(){for(const S of this._tunnels.values()){for(const{value:v}of S.values())await v.then(y=>y?.dispose());S.clear()}this._tunnels.clear()}openTunnel(S,v,y,w,g=!1,c=D.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${y} on local port ${w}.`),!S)return;v||(v="localhost");const r=this.retainOrCreateTunnel(S,v,y,w,g,c,l);return r?r.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,y);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(a);return(a.tunnelRemoteHost!==v||a.tunnelRemotePort!==y)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(S){return{tunnelRemotePort:S.tunnelRemotePort,tunnelRemoteHost:S.tunnelRemoteHost,tunnelLocalPort:S.tunnelLocalPort,localAddress:S.localAddress,privacy:S.privacy,protocol:S.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${S.tunnelRemoteHost}:${S.tunnelRemotePort} `);const v=this._tunnels.get(S.tunnelRemoteHost);if(v){const y=v.get(S.tunnelRemotePort);y&&(y.refcount--,await this.tryDisposeTunnel(S.tunnelRemoteHost,S.tunnelRemotePort,y))}}}}async tryDisposeTunnel(S,v,y){if(y.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${S}:${v}.`);const w=y.value.then(async g=>{g&&(await g.dispose(!0),this._onTunnelClosed.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this._tunnels.has(S)&&this._tunnels.get(S).delete(v),w}}async closeTunnel(S,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${S}:${v} `);const y=this._tunnels.get(S);if(y&&y.has(v)){const w=y.get(v);w.refcount=0,await this.tryDisposeTunnel(S,v,w)}}addTunnelToMap(S,v,y){this._tunnels.has(S)||this._tunnels.set(S,new Map),this._tunnels.get(S).set(v,{refcount:1,value:y})}async removeEmptyTunnelFromMap(S,v){const y=this._tunnels.get(S);y&&(await y.get(v)||y.delete(v),y.size===0&&this._tunnels.delete(S))}getTunnelFromMap(S,v){let y=[S];P(S)?(y.push(...e.LOCALHOST_ADDRESSES),y.push(...e.ALL_INTERFACES_ADDRESSES)):E(S)&&y.push(...e.ALL_INTERFACES_ADDRESSES);const w=y.map(g=>this._tunnels.get(g));for(const g of w){const c=g?.get(v);if(c)return c}}canTunnel(S){return!!b(S)}createWithProvider(S,v,y,w,g,c,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${y} on local port ${w}.`);const a={elevationRequired:g?f(w===void 0?y:w):!1},n={remoteAddress:{host:v,port:y},localAddressPort:w,privacy:c,public:c!==D.Private,protocol:l},t=S.forwardPort(n,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(v,y,t),t}};p=de([J(0,_.ILogService)],p),e.AbstractTunnelService=p}),define(ne[188],ie([0,1,10,62,2,8,5]),function(Q,e,L,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class D extends k.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new T.DeferredPromise),this._addressPromise.p)}setAddress(P){this._address=P,this._addressPromise&&(this._addressPromise.complete(P),this._addressPromise=null)}setTunnel(P){this._register(P)}}let C=class bt extends k.Disposable{constructor(P,E){super();this._tunnelService=P,this._logService=E,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++bt._lastId)}}async startTunnel(P,E,f,p,h,S){const v=new D,y=await Promise.resolve(this._tunnelService.openTunnel(P,v,f,p,h,S));if(!y)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${p} (remote).`),v.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(E))throw this._disposedTunnels.delete(E),v.dispose(),await y.dispose(),(0,_.canceled)();return v.setTunnel(y),this._tunnels.set(E,v),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${y.localAddress} (local) to ${f}:${p} (remote).`),{tunnelLocalPort:y.tunnelLocalPort,localAddress:y.localAddress}}async setAddress(P,E){const f=this._tunnels.get(P);!f||f.setAddress(E)}async destroyTunnel(P){const E=this._tunnels.get(P);if(E){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this._tunnels.delete(P),await E.dispose();return}this._disposedTunnels.add(P)}};C._lastId=0,C=de([J(0,i.ISharedTunnelsService),J(1,L.ILogService)],C),e.SharedProcessTunnelService=C}),define(ne[189],ie([0,1,118,21,10]),function(Q,e,L,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let _=class{constructor(D,C){this.configurationService=D,this.logService=C}request(D,C){return this.logService.trace("RequestService#request",D.url),D.proxyAuthorization||(D.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,L.request)(D,C)}async resolveProxy(D){}};_=de([J(0,i.IConfigurationService),J(1,k.ILogService)],_),e.RequestService=_}),define(ne[43],ie([0,1,18,139,42,6,38]),function(Q,e,L,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,_.createDecorator)("requestService");function D(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=D;function C(h){return h.res.statusCode===204}async function b(h){if(!D(h))throw new Error("Server returned "+h.res.statusCode);return C(h)?null:(await(0,L.streamToBuffer)(h.stream)).toString()}e.asText=b;async function P(h){if(!D(h))throw new Error("Server returned "+h.res.statusCode);if(C(h))return null;const v=(await(0,L.streamToBuffer)(h.stream)).toString();try{return JSON.parse(v)}catch(y){throw y.message+=`:
`+v,y}}e.asJson=P;function E(h){p(h)}e.updateProxyConfigurationsScope=E;let f;function p(h){const S=T.Registry.as(k.Extensions.Configuration),v=f;f={id:"http",order:15,title:(0,i.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,i.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,i.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,i.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,i.localize)(4,null),(0,i.localize)(5,null),(0,i.localize)(6,null),(0,i.localize)(7,null)],default:"override",description:(0,i.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,i.localize)(9,null),restricted:!0}}},S.updateConfigurations({add:[f],remove:v?[v]:[]})}p(2)}),define(ne[190],ie([0,1,27,16,14,43]),function(Q,e,L,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(C,b){this.requestService=C,this.fileService=b}async download(C,b,P=L.CancellationToken.None){if(C.scheme===i.Schemas.file||C.scheme===i.Schemas.vscodeRemote){await this.fileService.copy(C,b);return}const E={type:"GET",url:C.toString()},f=await this.requestService.request(E,P);if(f.res.statusCode===200)await this.fileService.writeFile(b,f.stream);else{const p=await(0,_.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${p}`)}}};T=de([J(0,_.IRequestService),J(1,k.IFileService)],T),e.DownloadService=T}),define(ne[191],ie([0,1,17,27,66,2,19,153,14,10,26,43]),function(Q,e,L,i,k,_,T,D,C,b,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let f=class extends _.Disposable{constructor(h,S,v,y){super();this.fileService=h,this.productService=S,this.requestService=v,this.logService=y,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,k.forEach)(this.productService.configBasedExtensionTips,({value:w})=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const S=[];for(const[v,y]of this.allConfigBasedTips)if(!(y.configScheme&&y.configScheme!==h.scheme))try{const w=await this.fileService.readFile((0,T.joinPath)(h,v)),g=new Map;(0,k.forEach)(y.recommendations,({key:l,value:r})=>{if((0,L.isNonEmptyArray)(r.remotes))for(const a of r.remotes)g.set(a,{extensionId:l,extensionName:r.name,configName:y.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack});else S.push({extensionId:l,extensionName:r.name,configName:y.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack})});const c=(0,D.getDomainsOfRemotes)(w.value.toString(),[...g.keys()]);for(const l of c){const r=g.get(l);r&&S.push(r)}}catch{}return S}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},i.CancellationToken.None);if(h.res.statusCode!==200)return[];const S=await(0,E.asJson)(h);return S?S.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};f=de([J(0,C.IFileService),J(1,P.IProductService),J(2,E.IRequestService),J(3,b.ILogService)],f),e.ExtensionTipsService=f}),define(ne[46],ie([0,1,18,30]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(_,T,D){let C=D&&D.get("storage.serviceMachineId",0)||null;if(C)return C;try{const P=(await T.readFile(_.serviceMachineIdResource)).value.toString();C=(0,i.isUUID)(P)?P:null}catch{C=null}if(!C){C=(0,i.generateUuid)();try{await T.writeFile(_.serviceMachineIdResource,L.VSBuffer.fromString(C))}catch{}}return D&&D.store("storage.serviceMachineId",C,0,1),C}e.getServiceMachineId=k}),define(ne[89],ie([0,1,103,6]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function k(_){return(0,L.hash)({moduleId:_.process.moduleId,windowId:_.reply.windowId})}e.hash=k,e.ISharedProcessWorkerService=(0,i.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[192],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var L;(function(i){i.Spawn="vscode:shared-process->shared-process-worker=spawn",i.Terminate="vscode:shared-process->shared-process-worker=terminate",i.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",i.Ready="vscode:shared-process-worker->shared-process=ready",i.Ack="vscode:shared-process-worker->shared-process=ack",i.Trace="vscode:shared-process-worker->shared-process=trace",i.Info="vscode:shared-process-worker->shared-process=info",i.Warn="vscode:shared-process-worker->shared-process=warn",i.Error="vscode:shared-process-worker->shared-process=error"})(L=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[193],ie([0,1,72,151,5,27,3,2,16,4,30,13,10,26,89,192]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let v=class{constructor(g,c,l){this.logService=g,this.productService=c,this.environmentService=l,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(g){const c=`window: ${g.reply.windowId}, moduleId: ${g.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${c})`);const l=(0,h.hash)(g);this.processeDisposables.has(l)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${c})`),this.doDisposeWorker(g));const r=new _.CancellationTokenSource;let a,n,t;this.processeDisposables.set(l,d=>{r.dispose(!0),a?.terminate(g,_.CancellationToken.None),n?.close(),t?.close(),this.processeDisposables.delete(l);const m=this.processResolvers.get(l);m&&(this.processResolvers.delete(l),m({reason:d}))}),a=await this.getOrCreateWebWorker(g);const s=new Promise(d=>{this.processResolvers.set(l,d)});if(r.token.isCancellationRequested)return s;const{port1:o,port2:u}=new MessageChannel;return n=o,t=u,await a.spawn(g,t,r.token),r.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${c})`),L.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",g,[n])),s}getOrCreateWebWorker(g){let c=this.workers.get(g.process.moduleId);if(!c){this.logService.trace(`SharedProcess: creating new web worker (${g.process.moduleId})`);const l=new y(g.process.type,this.logService,this.productService,this.environmentService);c=l.init(),l.onDidProcessSelfTerminate(({configuration:r,reason:a})=>{this.doDisposeWorker(r,a)}),this.workers.set(g.process.moduleId,c)}return c}async disposeWorker(g){return this.doDisposeWorker(g)}doDisposeWorker(g,c){const l=this.processeDisposables.get((0,h.hash)(g));l&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${g.reply.windowId}, moduleId: ${g.process.moduleId})`),l(c))}};v=de([J(0,f.ILogService),J(1,p.IProductService),J(2,E.INativeEnvironmentService)],v),e.SharedProcessWorkerService=v;class y extends D.Disposable{constructor(g,c,l,r){super();this.type=g,this.logService=c,this.productService=l,this.environmentService=r,this._onDidProcessSelfTerminate=this._register(new T.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const g=new k.DeferredPromise,c=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return c.onerror=l=>{this.logService.error(`SharedProcess: worker error (${this.type})`,l.message)},c.onmessageerror=l=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,l)},c.onmessage=l=>{const{id:r,message:a,configuration:n,nonce:t}=l.data;switch(r){case S.SharedProcessWorkerMessages.Ready:g.complete(c);break;case S.SharedProcessWorkerMessages.Ack:if(t){const s=this.mapMessageNonceToPendingMessageResolve.get(t);s&&(this.mapMessageNonceToPendingMessageResolve.delete(t),s())}break;case S.SharedProcessWorkerMessages.SelfTerminated:n&&a&&this._onDidProcessSelfTerminate.fire({configuration:n,reason:JSON.parse(a)});break;case S.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,a);break;case S.SharedProcessWorkerMessages.Info:a&&this.logService.info(a);break;case S.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,a);break;case S.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,a);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,l)}},c.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),g.p}async send(g,c,l){const r=await this.workerReady;if(!c.isCancellationRequested)return new Promise(a=>{const n=(0,P.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(n,a);const t={...g,nonce:n};l?r.postMessage(t,[l]):r.postMessage(t),c.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(n)&&a()})})}spawn(g,c,l){const r={id:S.SharedProcessWorkerMessages.Spawn,configuration:g,environment:this.getSharedProcessWorkerEnvironment()};return this.send(r,l,c)}getSharedProcessWorkerEnvironment(){const g={bootstrapPath:C.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,env:Object.create(null)};if(b.isLinux){const c={companyName:this.productService.crashReporter?.companyName||"Microsoft",productName:this.productService.crashReporter?.productName||this.productService.nameShort,submitURL:"",uploadToServer:!1},l=this.environmentService.args["crash-reporter-id"],r=this.productService.appCenter;if(!this.environmentService.args["crash-reporter-directory"]&&r&&l&&(0,P.isUUID)(l)){const t=r["linux-x64"];c.submitURL=t.concat("&uid=",l,"&iid=",l,"&sid=",l),c.uploadToServer=!0}const n=this.environmentService.args["crash-reporter-directory"]||this.environmentService.userDataPath;g.env.BREAKPAD_DUMP_LOCATION=(0,i.join)(n,this.type),g.env.VSCODE_CRASH_REPORTER_START_OPTIONS=JSON.stringify(c)}return g}terminate(g,c){const l={id:S.SharedProcessWorkerMessages.Terminate,configuration:g};return this.send(l,c)}}}),define(ne[194],ie([0,1,53,16,152]),function(Q,e,L,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class _ extends k.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:i.Schemas.userData})}}de([L.memoize],_.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=_}),define(ne[90],ie([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,L.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[195],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L{constructor(){this.validators=new Map}vsda(){return new Promise((k,_)=>Q(["vsda"],k,_))}async createNewMessage(k){try{const _=await this.vsda(),T=new _.validator;if(T){const D=String(L._nextId++);return this.validators.set(D,T),{id:D,data:T.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,_){if(!k.id)return!0;const T=this.validators.get(k.id);if(!T)return!1;this.validators.delete(k.id);try{return T.validate(_)==="ok"}catch{return!1}}async sign(k){try{const _=await this.vsda(),T=new _.signer;if(T)return T.sign(k)}catch{}return k}}e.SignService=L,L._nextId=1}),define(ne[23],ie([0,1,5,3,2,176,15,73,6]),function(Q,e,L,i,k,_,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const b="__$__targetStorageMarker";e.IStorageService=(0,C.createDecorator)("storageService");var P;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var f;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class p extends k.Disposable{constructor(y={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=y,this._onDidChangeValue=this._register(new i.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new i.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new i.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,_.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,_.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(y,w){w===b?(y===0?this._globalKeyTargets=void 0:y===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:y})):this._onDidChangeValue.fire({scope:y,key:w,target:this.getKeyTargets(y)[w]})}emitWillSaveState(y){this._onWillSaveState.fire({reason:y})}get(y,w,g){return this.getStorage(w)?.get(y,g)}getBoolean(y,w,g){return this.getStorage(w)?.getBoolean(y,g)}getNumber(y,w,g){return this.getStorage(w)?.getNumber(y,g)}store(y,w,g,c){if((0,T.isUndefinedOrNull)(w)){this.remove(y,g);return}this.withPausedEmitters(()=>{this.updateKeyTarget(y,g,c),this.getStorage(g)?.set(y,w)})}remove(y,w){this.withPausedEmitters(()=>{this.updateKeyTarget(y,w,void 0),this.getStorage(w)?.delete(y)})}withPausedEmitters(y){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{y()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(y,w){const g=[],c=this.getKeyTargets(y);for(const l of Object.keys(c))c[l]===w&&g.push(l);return g}updateKeyTarget(y,w,g){const c=this.getKeyTargets(w);typeof g=="number"?c[y]!==g&&(c[y]=g,this.getStorage(w)?.set(b,JSON.stringify(c))):typeof c[y]=="number"&&(delete c[y],this.getStorage(w)?.set(b,JSON.stringify(c)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(y){return y===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(y){const w=this.get(b,y);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}isNew(y){return this.getBoolean(e.IS_NEW_KEY,y)===!0}async flush(y=P.NONE){this._onWillSaveState.fire({reason:y});const w=this.getStorage(0),g=this.getStorage(1);switch(y){case P.NONE:await L.Promises.settled([w?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([w?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve()]);break}}async logStorage(){const y=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return S(y,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class h extends p{constructor(){super();this.globalStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(y=>this.emitDidChangeValue(1,y))),this._register(this.globalStorage.onDidChangeStorage(y=>this.emitDidChangeValue(0,y)))}getStorage(y){return y===0?this.globalStorage:this.workspaceStorage}getLogDetails(y){return y===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(y){}}e.InMemoryStorageService=h;async function S(v,y,w,g){const c=o=>{try{return JSON.parse(o)}catch{return o}},l=new Map,r=new Map;v.forEach((o,u)=>{l.set(u,o),r.set(u,c(o))});const a=new Map,n=new Map;y.forEach((o,u)=>{a.set(u,o),n.set(u,c(o))}),console.group(`Storage: Global (path: ${w})`);let t=[];l.forEach((o,u)=>{t.push({key:u,value:o})}),console.table(t),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${g})`);let s=[];a.forEach((o,u)=>{s.push({key:u,value:o})}),console.table(s),console.groupEnd(),console.log(n)}e.logStorage=S}),define(ne[196],ie([0,1,3,2,15,29,33,23]),function(Q,e,L,i,k,_,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let C=class extends i.Disposable{constructor(E,f){super();this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new b(E)),this._register(this.storageManger.onDidChange(p=>this._onDidChangeEnablement.fire({extensions:p,source:"storage"}))),this._register(f.onDidInstallExtensions(p=>p.forEach(({local:h,operation:S})=>{h&&S===4&&this._removeFromDisabledExtensions(h.identifier)})))}async enableExtension(E,f){return this._removeFromDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:f}),!0):!1}async disableExtension(E,f){return this._addToDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:f}),!0):!1}getDisabledExtensions(){return this._getExtensions(_.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(E){let f=this.getDisabledExtensions();return f.every(p=>!(0,T.areSameExtensions)(p,E))?(f.push(E),this._setDisabledExtensions(f),!0):!1}_removeFromDisabledExtensions(E){let f=this.getDisabledExtensions();for(let p=0;p<f.length;p++){const h=f[p];if((0,T.areSameExtensions)(h,E))return f.splice(p,1),this._setDisabledExtensions(f),!0}return!1}_setDisabledExtensions(E){this._setExtensions(_.DISABLED_EXTENSIONS_STORAGE_PATH,E)}_getExtensions(E){return this.storageManger.get(E,0)}_setExtensions(E,f){this.storageManger.set(E,f,0)}};C=de([J(0,D.IStorageService),J(1,_.IExtensionManagementService)],C),e.GlobalExtensionEnablementService=C;class b extends i.Disposable{constructor(E){super();this.storageService=E,this.storage=Object.create(null),this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this._register(E.onDidChangeValue(f=>this.onDidStorageChange(f)))}get(E,f){let p;return f===0?((0,k.isUndefinedOrNull)(this.storage[E])&&(this.storage[E]=this._get(E,f)),p=this.storage[E]):p=this._get(E,f),JSON.parse(p)}set(E,f,p){let h=JSON.stringify(f.map(({id:v,uuid:y})=>({id:v,uuid:y})));this._get(E,p)!==h&&(p===0&&(f.length?this.storage[E]=h:delete this.storage[E]),this._set(E,f.length?h:void 0,p))}onDidStorageChange(E){if(E.scope===0&&!(0,k.isUndefinedOrNull)(this.storage[E.key])&&this._get(E.key,E.scope)!==this.storage[E.key]){const p=this.get(E.key,E.scope);delete this.storage[E.key];const h=this.get(E.key,E.scope),S=p.filter(y=>!h.some(w=>(0,T.areSameExtensions)(y,w))),v=h.filter(y=>!p.some(w=>(0,T.areSameExtensions)(w,y)));(S.length||v.length)&&this._onDidChange.fire([...S,...v])}}_get(E,f){return this.storageService.get(E,f,"[]")}_set(E,f,p){f?this.storageService.store(E,f,p,1):this.storageService.remove(E,p)}}e.StorageManager=b}),define(ne[197],ie([0,1,3,2]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class k extends i.Disposable{constructor(b,P){super();this.channel=b,this.workspace=P}async getItems(){const b={workspace:this.workspace},P=await this.channel.call("getItems",b);return new Map(P)}updateItems(b){const P={workspace:this.workspace};return b.insert&&(P.insert=Array.from(b.insert.entries())),b.delete&&(P.delete=Array.from(b.delete.values())),this.channel.call("updateItems",P)}}class _ extends k{constructor(b){super(b,void 0);this._onDidChangeItemsExternal=this._register(new L.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(b=>this.onDidChangeGlobalStorage(b)))}onDidChangeGlobalStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}async close(){this.dispose()}}class T extends k{constructor(b,P){super(b,P);this.onDidChangeItemsExternal=L.Event.None}async close(){const b={workspace:this.workspace};return this.channel.call("close",b)}}class D extends i.Disposable{constructor(b,P){super();this.channel=b,this.workspace=P,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new _(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new T(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=D}),define(ne[198],ie([0,1,5,2,19,73,23,197]),function(Q,e,L,i,k,_,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class C extends T.AbstractStorageService{constructor(P,E,f){super();this.mainProcessService=E,this.environmentService=f,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new i.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(P)}createGlobalStorage(){const P=new D.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),E=new _.Storage(P.globalStorage);return this._register(E.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),E}createWorkspaceStorage(P){const E=new D.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),P);if(E.workspaceStorage){const f=new _.Storage(E.workspaceStorage);return this.workspaceStorageDisposable.value=f.onDidChangeStorage(p=>this.emitDidChangeValue(1,p)),this.workspaceStorageId=P?.id,f}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await L.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,k.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(T.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(P){const E=this.workspaceStorage,f=E?.items??new Map;E&&(await E.close(),E.dispose()),this.workspaceStorage=this.createWorkspaceStorage(P),await this.workspaceStorage.init();for(const[p,h]of f)this.workspaceStorage.set(p,h)}}e.NativeStorageService=C}),define(ne[199],ie([0,1,4,31,7,30]),function(Q,e,L,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(b){if(L.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function D(b,P,E,f,p,h,S,v,y,w){const g=Object.create(null);g["common.machineId"]=S,g.sessionID=(0,_.generateUuid)()+Date.now(),g.commitHash=p,g.version=h,g["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,L.PlatformToString)(L.platform),g["common.nodePlatform"]=i.platform,g["common.nodeArch"]=f,g["common.product"]=w||"desktop";const c=C(v||[]);c&&(g["common.msftInternal"]=c);let l=0;const r=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),L.isLinuxSnap&&(g["common.snap"]="true");const a=T(E);a&&(g["common.platformDetail"]=a);try{const n=await b.readFile(k.URI.file(y));g["common.source"]=n.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=D;function C(b){const P=i.env.USERDNSDOMAIN;if(!P)return!1;const E=P.toLowerCase();return b.some(f=>E===f)}e.verifyMicrosoftInternalDomain=C}),define(ne[22],ie([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var i;(function(_){_[_.NONE=0]="NONE",_[_.CRASH=1]="CRASH",_[_.ERROR=2]="ERROR",_[_.USAGE=3]="USAGE"})(i=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(_){_.OFF="off",_.CRASH="crash",_.ERROR="error",_.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[200],ie([0,1,32,54,5,35,16,9,4,7,111,20,114,78,14,26,22]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function y(r,a){const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let t;const s=L.homedir().toLowerCase();switch(process.platform){case"win32":t=[{tag:"gdrive",matcher:O=>/^[a-z]:\\(my drive|shared drives)\\/.test(O)||O.startsWith(s+"\\my drive\\")},{tag:"dropbox",matcher:O=>O.startsWith(s+"\\dropbox")},{tag:"onedrive",matcher:O=>O.startsWith(s+"\\onedrive")},{tag:"box",matcher:O=>O.startsWith(s+"\\box\\")},{tag:"nextcloud",matcher:O=>O.startsWith(s+"\\nextcloud\\")},{tag:"owncloud",matcher:O=>O.startsWith(s+"\\owncloud\\")}];break;case"darwin":t=[{tag:"gdrive",matcher:O=>O.startsWith("/volumes/googledrive/")||O.startsWith(s+"/my drive/")},{tag:"dropbox",matcher:O=>O.startsWith(s+"/dropbox")},{tag:"onedrive",matcher:O=>O.startsWith(s+"/onedrive")||O.startsWith(s+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:O=>O.startsWith(s+"/library/mobile documents/")},{tag:"box",matcher:O=>O.startsWith(s+"/box/")},{tag:"nextcloud",matcher:O=>O.startsWith(s+"/nextcloud/")},{tag:"owncloud",matcher:O=>O.startsWith(s+"/owncloud/")}];break}const o=new Map,u=new Map,d=2e4;function m(O,N,$,R){for(const W of t){const U=O.toLowerCase();W.matcher(U)&&u.set(W.tag,1)}const M=N.substring(O.length+1);return k.Promises.withAsyncBody(async W=>{let U;try{U=await E.Promises.readdir(N,{withFileTypes:!0})}catch{W();return}if(R.count>=d){R.count+=U.length,R.maxReached=!0,W();return}let x=U.length;if(x===0){W();return}let ee=U;R.count+U.length>d&&(R.maxReached=!0,x=d-R.count,ee=U.slice(0,x)),R.count+=U.length;for(const G of ee)if(G.isDirectory()){if($.includes(G.name)||await m(O,(0,D.join)(N,G.name),$,R),--x==0){W();return}}else{const q=G.name.lastIndexOf(".");if(q>=0){const Y=G.name.substring(q+1);Y&&o.set(Y,(o.get(Y)??0)+1)}for(const Y of n)Y.relativePathPattern?.test(M)!==!1&&Y.filePattern.test(G.name)&&u.set(Y.tag,(u.get(Y.tag)??0)+1);if(--x==0){W();return}}})}const I={count:0,maxReached:!1};await m(r,r,a,I);const A=await c(r);return{configFiles:w(u),fileTypes:w(o),fileCount:I.count,maxFilesReached:I.maxReached,launchConfigFiles:A}}e.collectWorkspaceStats=y;function w(r){return[...i.Iterable.map(r.entries(),([a,n])=>({name:a,count:n}))].sort((a,n)=>n.count-a.count)}function g(){const r={os:`${L.type()} ${L.arch()} ${L.release()}`,memory:`${(L.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},a=L.cpus();return a&&a.length>0&&(r.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),r}e.getMachineInfo=g;async function c(r){try{const a=new Map,n=(0,D.join)(r,".vscode","launch.json"),t=await E.Promises.readFile(n),s=[],o=(0,_.parse)(t.toString(),s);if(s.length)return console.log(`Unable to parse ${n}`),[];if((0,_.getNodeType)(o)==="object"&&o.configurations)for(const u of o.configurations){const d=u.type;d&&(a.has(d)?a.set(d,a.get(d)+1):a.set(d,1))}return w(a)}catch{return[]}}e.collectLaunchConfigs=c;let l=class{constructor(a,n){this.telemetryService=a,this.productService=n}formatMachineInfo(a){const n=[];return n.push(`OS Version:       ${a.os}`),n.push(`CPUs:             ${a.cpus}`),n.push(`Memory (System):  ${a.memory}`),n.push(`VM:               ${a.vmHint}`),n.join(`
`)}formatEnvironment(a){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${L.type()} ${L.arch()} ${L.release()}`);const t=L.cpus();return t&&t.length>0&&n.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),n.push(`Memory (System):  ${(L.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),C.isWindows||n.push(`Load (avg):       ${L.loadavg().map(s=>Math.round(s)).join(", ")}`),n.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${a.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(a,n){return Promise.all([(0,f.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async t=>{let[s,o]=t,u=this.formatProcessList(a,s);return n.forEach(d=>{if((0,p.isRemoteDiagnosticError)(d))u+=`
${d.errorMessage}`,o+=`
${d.errorMessage}`;else if(u+=`

Remote: ${d.hostName}`,d.processes&&(u+=`
${this.formatProcessList(a,d.processes)}`),d.workspaceMetadata){o+=`
|  Remote: ${d.hostName}`;for(const m of Object.keys(d.workspaceMetadata)){const I=d.workspaceMetadata[m];let A=`${I.fileCount} files`;I.maxFilesReached&&(A=`more than ${A}`),o+=`|    Folder (${m}): ${A}`,o+=this.formatWorkspaceStats(I)}}}),{processInfo:u,workspaceInfo:o}})}async getSystemInfo(a,n){const{memory:t,vmHint:s,os:o,cpus:u}=g(),d={os:o,memory:t,cpus:u,vmHint:s,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:n};return C.isWindows||(d.load=`${L.loadavg().map(m=>Math.round(m)).join(", ")}`),C.isLinux&&(d.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(d)}async getDiagnostics(a,n){const t=[];return(0,f.listProcesses)(a.mainPID).then(async s=>(t.push(""),t.push(this.formatEnvironment(a)),t.push(""),t.push(this.formatProcessList(a,s)),a.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(a))),n.forEach(o=>{if((0,p.isRemoteDiagnosticError)(o))t.push(`
${o.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${o.hostName}`),t.push(this.formatMachineInfo(o.machineInfo)),o.processes&&t.push(this.formatProcessList(a,o.processes)),o.workspaceMetadata)for(const u of Object.keys(o.workspaceMetadata)){const d=o.workspaceMetadata[u];let m=`${d.fileCount} files`;d.maxFilesReached&&(m=`more than ${m}`),t.push(`Folder (${u}): ${m}`),t.push(this.formatWorkspaceStats(d))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(a){const n=[],t=60;let s=0;const o=(I,A)=>{const O=` ${I}(${A})`;s+O.length>t?(n.push(u),u="|                 ",s=u.length):s+=O.length,u+=O};let u="|      File types:";const d=10;let m=a.fileTypes.length>d?d:a.fileTypes.length;for(let I=0;I<m;I++){const A=a.fileTypes[I];o(A.name,A.count)}if(n.push(u),a.configFiles.length>=0&&(u="|      Conf files:",s=0,a.configFiles.forEach(I=>{o(I.name,I.count)}),n.push(u)),a.launchConfigFiles.length>0){let I="|      Launch Configs:";a.launchConfigFiles.forEach(A=>{I+=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`}),n.push(I)}return n.join(`
`)}expandGPUFeatures(a){const n=Math.max(...Object.keys(a).map(t=>t.length));return Object.keys(a).map(t=>`${t}:  ${" ".repeat(n-t.length)}  ${a[t]}`).join(`
                  `)}formatWorkspaceMetadata(a){const n=[],t=[];return a.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(n.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const u=b.URI.revive(o);if(u.scheme===T.Schemas.file){const d=u.fsPath;t.push(y(d,["node_modules",".git"]).then(m=>{let I=`${m.fileCount} files`;m.maxFilesReached&&(I=`more than ${I}`),n.push(`|    Folder (${(0,D.basename)(d)}): ${I}`),n.push(this.formatWorkspaceStats(m))}).catch(m=>{n.push(`|      Error: Unable to collect workspace stats for folder ${d} (${m.toString()})`)}))}else n.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(s=>n.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(a,n){const t=new Map;a.windows.forEach(o=>t.set(o.pid,o.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(a.mainPID,t,s,n,0),s.join(`
`)}formatProcessItem(a,n,t,s,o){const u=o===0;let d;u?d=s.pid===a?`${this.productService.applicationName} main`:"remote agent":(d=`${"  ".repeat(o)} ${s.name}`,s.name==="window"&&(d=`${d} (${n.get(s.pid)})`));const m=process.platform==="win32"?s.mem:L.totalmem()*(s.mem/100);t.push(`${s.load.toFixed(0).padStart(5," ")}	${(m/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${d}`),Array.isArray(s.children)&&s.children.forEach(I=>this.formatProcessItem(a,n,t,I,o+1))}async reportWorkspaceStats(a){for(const{uri:n}of a.folders){const t=b.URI.revive(n);if(t.scheme!==T.Schemas.file)continue;const s=t.fsPath;try{const o=await y(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),o.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:u.name,count:u.count})}),o.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:u.name,count:u.count})}),o.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};l=de([J(0,v.ITelemetryService),J(1,S.IProductService)],l),e.DiagnosticsService=l}),define(ne[201],ie([0,1,17,5,27,8,3,2,4,15,7,128,29,33,10,26,22]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let y=class extends D.Disposable{constructor(a,n,t,s){super();this.galleryService=a,this.telemetryService=n,this.logService=t,this.productService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,D.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const n=await this.getTargetPlatform();return a.allTargetPlatforms.some(t=>(0,f.isTargetPlatformCompatible)(t,a.allTargetPlatforms,n))}async installFromGallery(a,n={}){try{if(!this.galleryService.isEnabled())throw new f.ExtensionManagementError(E.localize(0,null),f.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(a,!n.installGivenVersion,!!n.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,n)}catch(t){throw c(this.telemetryService,"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(a),void 0,t),this.logService.error("Failed to install extension.",a.identifier.id),this.logService.error(t),g(t)}}async migrateUnsupportedExtensions(){try{const a=await this.getExtensionsControlManifest();if(!a.unsupportedPreReleaseExtensions)return;const n=await this.getInstalled(1);for(const[t,s]of Object.entries(a.unsupportedPreReleaseExtensions)){const o=n.find(m=>(0,p.areSameExtensions)(m.identifier,{id:t}));if(!o)continue;const u=await this.galleryService.getCompatibleExtension({id:s.id},!0,await this.getTargetPlatform());if(!u){this.logService.info(`Skipping migrating '${o.identifier.id}' extension because, the comaptible target '${s.id}' extension is not found`);continue}const d=await this.galleryService.getManifest(u,k.CancellationToken.None);if(!d){this.logService.info(`Skipping migrating '${o.identifier.id}' extension because, the manifest for '${s.id}' extension is not found`);continue}try{this.logService.info(`Migrating '${o.identifier.id}' extension to '${s.id}' extension...`),await Promise.allSettled([this.uninstall(o),this.installExtension(d,u,{installPreReleaseVersion:!0,isMachineScoped:o.isMachineScoped,operation:4})]),this.logService.info(`Migrated '${o.identifier.id}' extension to '${s.id}' extension.`)}catch(m){this.logService.error(m)}}}catch(a){this.logService.error(a)}}async uninstall(a,n={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,n)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(1,null));const n=await this.findGalleryExtension(a);if(!n)throw new Error(E.localize(2,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsControlManifest(){const a=new Date().getTime();return(!this.extensionsControlManifest||a-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=a),this.extensionsControlManifest}registerParticipant(a){this.participants.push(a)}async installExtension(a,n,t){if(!P.URI.isUri(n)){let m=this.installingExtensions.get(new p.ExtensionIdentifierWithVersion(n.identifier,n.version).key());if(m)return this.logService.info("Extensions is already requested to install",n.identifier.id),m.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const s=[],o=[],u=this.createInstallExtensionTask(a,n,t);P.URI.isUri(n)||this.installingExtensions.set(new p.ExtensionIdentifierWithVersion(u.identifier,a.version).key(),u),this._onInstallExtension.fire({identifier:u.identifier,source:n}),this.logService.info("Installing extension:",u.identifier.id),s.push({task:u,manifest:a});let d=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",u.identifier.id);else try{const I=await this.getAllDepsAndPackExtensionsToInstall(u.identifier,a,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:A,manifest:O}of I)if(d=d||!!O.extensionDependencies?.some(N=>(0,p.areSameExtensions)({id:N},u.identifier)),this.installingExtensions.has(new p.ExtensionIdentifierWithVersion(A.identifier,A.version).key()))this.logService.info("Extension is already requested to install",A.identifier.id);else{const N=this.createInstallExtensionTask(O,A,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new p.ExtensionIdentifierWithVersion(N.identifier,O.version).key(),N),this._onInstallExtension.fire({identifier:N.identifier,source:A}),this.logService.info("Installing extension:",N.identifier.id),s.push({task:N,manifest:O})}}catch(I){if(P.URI.isUri(u.source))(0,L.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",u.identifier.id,I.message),(0,L.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",u.identifier.id,I.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",u.identifier.id),I}const m=s.reduce((I,{task:A,manifest:O})=>(I.set(A.identifier.id.toLowerCase(),{task:A,manifest:O}),I),new Map);for(;m.size;){let I;const A=[...m.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(N=>m.has(N.toLowerCase())));A.length?I=m.size===1?A:A.filter(({task:O})=>!(O===u&&!d)):(this.logService.info("Found extensions with circular dependencies",A.map(({task:O})=>O.identifier.id)),I=[...m.values()]),await this.joinAllSettled(I.map(async({task:O})=>{const N=new Date().getTime(),$=(0,b.isUndefined)(t.operation)?O.operation:t.operation;try{const R=await O.run();if(await this.joinAllSettled(this.participants.map(M=>M.postInstall(R,O.source,t,k.CancellationToken.None))),!P.URI.isUri(O.source)&&(c(this.telemetryService,$===3?"extensionGallery:update":"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-N,void 0),C.isWeb&&$!==3))try{await this.galleryService.reportStatistic(R.manifest.publisher,R.manifest.name,R.manifest.version,"install")}catch{}o.push({local:R,identifier:O.identifier,operation:$,source:O.source})}catch(R){throw P.URI.isUri(O.source)||c(this.telemetryService,$===3?"extensionGallery:update":"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-N,R),this.logService.error("Error while installing the extension:",O.identifier.id),R}finally{m.delete(O.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:I})=>this.logService.info("Extension installed successfully:",I.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:I})=>(0,p.areSameExtensions)(I,u.identifier))[0].local}catch(m){if(s.forEach(({task:I})=>I.cancel()),o.length)try{const I=await Promise.allSettled(o.map(({local:A})=>this.createUninstallExtensionTask(A,{versionOnly:!0}).run()));for(let A=0;A<I.length;A++){const O=I[A],{identifier:N}=o[A];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,_.getErrorMessage)(O.reason))}}catch(I){this.logService.warn("Error while rolling back extensions",(0,_.getErrorMessage)(I),o.map(({identifier:A})=>A.id))}throw this._onDidInstallExtensions.fire(s.map(({task:I})=>({identifier:I.identifier,operation:2,source:I.source}))),m}finally{for(const{task:m,manifest:I}of s)if(!P.URI.isUri(m.source)){const A=new p.ExtensionIdentifierWithVersion(m.identifier,I.version).key();this.installingExtensions.delete(A)||this.logService.warn("Installation task is not found in the cache",A)}}}async joinAllSettled(a){const n=[],t=[],s=await Promise.allSettled(a);for(const o of s)o.status==="fulfilled"?n.push(o.value):t.push(o.reason);if(t.length)throw w(t);return n}async getAllDepsAndPackExtensionsToInstall(a,n,t,s){if(!this.galleryService.isEnabled())return[];let o=await this.getInstalled();const u=[a,...o.map(I=>I.identifier)],d=[],m=async(I,A)=>{const O=A.extensionDependencies||[],N=[...O];if(A.extensionPack){const $=t?o.find(R=>(0,p.areSameExtensions)(R.identifier,I)):void 0;for(const R of A.extensionPack)$&&$.manifest.extensionPack&&$.manifest.extensionPack.some(M=>(0,p.areSameExtensions)({id:M},{id:R}))||N.every(M=>!(0,p.areSameExtensions)({id:M},{id:R}))&&N.push(R)}if(N.length){const $=[...u,...d.map(M=>M.gallery.identifier)],R=N.filter(M=>$.every(W=>!(0,p.areSameExtensions)(W,{id:M})));if(R.length){const M=await this.galleryService.query({names:R,pageSize:N.length},k.CancellationToken.None);for(const W of M.firstPage){if($.find(ee=>(0,p.areSameExtensions)(ee,W.identifier)))continue;const U=O.some(ee=>(0,p.areSameExtensions)({id:ee},W.identifier));let x;try{x=await this.checkAndGetCompatibleVersion(W,!0,s)}catch(ee){if(ee instanceof f.ExtensionManagementError&&ee.code===f.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!U){this.logService.info("Skipping the packed extension as it cannot be installed",W.identifier.id);continue}else throw ee}d.push({gallery:x.extension,manifest:x.manifest}),await m(x.extension.identifier,A)}}}};return await m(a,n),o=await this.getInstalled(),d.filter(I=>!o.some(A=>(0,p.areSameExtensions)(A.identifier,I.gallery.identifier)))}async checkAndGetCompatibleVersion(a,n,t){const s=await this.getExtensionsControlManifest();if((0,p.getMaliciousExtensionsSet)(s).has(a.identifier.id))throw new f.ExtensionManagementError(E.localize(3,null,a.identifier.id),f.ExtensionManagementErrorCode.Malicious);if(!!s.unsupportedPreReleaseExtensions&&!!s.unsupportedPreReleaseExtensions[a.identifier.id])throw new f.ExtensionManagementError(E.localize(4,null,a.identifier.id,s.unsupportedPreReleaseExtensions[a.identifier.id].displayName),f.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(a)){const d=await this.getTargetPlatform();throw new f.ExtensionManagementError(E.localize(5,null,a.identifier.id,this.productService.nameLong,(0,f.TargetPlatformToString)(d)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.getCompatibleVersion(a,n,t);if(o){if(t&&a.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new f.ExtensionManagementError(E.localize(6,null,a.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new f.ExtensionManagementError(E.localize(7,null,a.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",o.identifier.id);const u=await this.galleryService.getManifest(o,k.CancellationToken.None);if(u===null)throw new f.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(u.version!==o.version)throw new f.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:u}}async getCompatibleVersion(a,n,t){const s=await this.getTargetPlatform();let o=null;return n&&a.hasPreReleaseVersion&&a.properties.isPreReleaseVersion!==t&&(o=await this.galleryService.getCompatibleExtension(a.identifier,t,s)),!o&&await this.galleryService.isExtensionCompatible(a,t,s)&&(o=a),!o&&n&&(o=await this.galleryService.getCompatibleExtension(a,t,s)),o}async unininstallExtension(a,n){const t=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),t.waitUntilTaskIsFinished();const s=(m,I)=>{const A=this.createUninstallExtensionTask(m,I);return this.uninstallingExtensions.set(A.extension.identifier.id.toLowerCase(),A),this.logService.info("Uninstalling extension:",m.identifier.id),this._onUninstallExtension.fire(m.identifier),A},o=(m,I)=>{I?this.logService.error("Failed to uninstall extension:",m.identifier.id,I.message):this.logService.info("Successfully uninstalled extension:",m.identifier.id),c(this.telemetryService,"extensionGallery:uninstall",(0,p.getLocalExtensionTelemetryData)(m),void 0,I),this._onDidUninstallExtension.fire({identifier:m.identifier,error:I?.code})},u=[],d=[];try{u.push(s(a,{}));const m=await this.getInstalled(1);if(n.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const I=this.getAllPackExtensionsToUninstall(a,m);for(const A of I)this.uninstallingExtensions.has(A.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",A.identifier.id):u.push(s(A,{}))}n.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(u.map(I=>I.extension),m,a),await this.joinAllSettled(u.map(async I=>{try{if(await I.run(),await this.joinAllSettled(this.participants.map(A=>A.postUninstall(I.extension,n,k.CancellationToken.None))),I.extension.identifier.uuid)try{await this.galleryService.reportStatistic(I.extension.manifest.publisher,I.extension.manifest.name,I.extension.manifest.version,"uninstall")}catch{}o(I.extension)}catch(A){const O=A instanceof f.ExtensionManagementError?A:new f.ExtensionManagementError((0,_.getErrorMessage)(A),f.ExtensionManagementErrorCode.Internal);throw o(I.extension,O),O}finally{d.push(I)}}))}catch(m){const I=m instanceof f.ExtensionManagementError?m:new f.ExtensionManagementError((0,_.getErrorMessage)(m),f.ExtensionManagementErrorCode.Internal);for(const A of u){try{A.cancel()}catch{}d.includes(A)||o(A.extension,I)}throw I}finally{for(const m of u)this.uninstallingExtensions.delete(m.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",m.extension.identifier.id)}}checkForDependents(a,n,t){for(const s of a){const o=this.getDependents(s,n);if(o.length){const u=o.filter(d=>!a.some(m=>(0,p.areSameExtensions)(m.identifier,d.identifier)));if(u.length)throw new Error(this.getDependentsErrorMessage(s,u,t))}}}getDependentsErrorMessage(a,n,t){return t===a?n.length===1?E.localize(8,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?E.localize(9,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):E.localize(10,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?E.localize(11,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?E.localize(12,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):E.localize(13,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(a,n,t=[]){if(t.indexOf(a)!==-1)return[];t.push(a);const s=a.manifest.extensionPack?a.manifest.extensionPack:[];if(s.length){const o=n.filter(d=>!d.isBuiltin&&s.some(m=>(0,p.areSameExtensions)({id:m},d.identifier))),u=[];for(const d of o)u.push(...this.getAllPackExtensionsToUninstall(d,n,t));return[...o,...u]}return[]}getDependents(a,n){return n.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(s=>(0,p.areSameExtensions)({id:s},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const n=await this.findGalleryExtensionById(a.identifier.uuid);return n||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},k.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},k.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",a),a}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};y=de([J(0,f.IExtensionGalleryService),J(1,v.ITelemetryService),J(2,h.ILogService),J(3,S.IProductService)],y),e.AbstractExtensionManagementService=y;function w(r){const a=Array.isArray(r)?r:[r];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((n,t)=>new Error(`${n.message}${n.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=w;function g(r){if(r instanceof f.ExtensionManagementError)return r;const a=new f.ExtensionManagementError(r.message,f.ExtensionManagementErrorCode.Internal);return a.stack=r.stack,a}function c(r,a,n,t,s){const o=s?s instanceof f.ExtensionManagementError?s.code:f.ExtensionManagementErrorCode.Internal:void 0;r.publicLogError(a,{...n,success:!s,duration:t,errorcode:o})}e.reportTelemetry=c;class l{constructor(){this.barrier=new i.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,i.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,i.createCancelablePromise)(a=>new Promise((n,t)=>{const s=a.onCancellationRequested(()=>{s.dispose(),t((0,_.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=l}),define(ne[202],ie([0,1,17,5,66,3,9,4,31,7,130,13,29,191,80,14,10,60,26,43,23,22]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h,S,v,y,w,g,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",a="extensionTips/lastPromptedMediumImpExeTime";let n=class extends p.ExtensionTipsService{constructor(s,o,u,d,m,I,A,O,N,$){super(A,O,N,$);this.environmentService=s,this.telemetryService=o,this.extensionManagementService=u,this.storageService=d,this.nativeHostService=m,this.extensionRecommendationNotificationService=I,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,k.forEach)(O.exeBasedExtensionTips,({key:R,value:M})=>{const W=[],U=[],x=[];(0,k.forEach)(M.recommendations,({key:ee,value:G})=>{G.important?M.important?W.push({extensionId:ee,extensionName:G.name,isExtensionPack:!!G.isExtensionPack}):U.push({extensionId:ee,extensionName:G.name,isExtensionPack:!!G.isExtensionPack}):x.push({extensionId:ee,extensionName:G.name,isExtensionPack:!!G.isExtensionPack})}),W.length&&this.highImportanceExecutableTips.set(R,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:W}),U.length&&this.mediumImportanceExecutableTips.set(R,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:U}),x.length&&this.allOtherExecutableTips.set(R,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:x})}),(0,i.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,u)}groupImportantTipsByExe(s,o){const u=new Map;s.forEach(O=>u.set(O.extensionId.toLowerCase(),O));const{installed:d,uninstalled:m}=this.groupByInstalled([...u.keys()],o);for(const O of d){const N=u.get(O);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:N.exeName})}for(const O of m){const N=u.get(O);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:N.exeName})}const I=this.getPromptedExecutableTips(),A=new Map;for(const O of m){const N=u.get(O);if(N&&(!I[N.exeName]||!I[N.exeName].includes(N.extensionId))){let $=A.get(N.exeName);$||($=[],A.set(N.exeName,$)),$.push(N)}}return A}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const d=_.Event.once(_.Event.latch(_.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const d=this._register((0,i.disposableTimeout)(()=>{d.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),o=Date.now()-s,u=7*24*60*60*1e3;if(o<u){const I=this._register((0,i.disposableTimeout)(()=>{I.dispose(),this.promptMediumImportanceExeBasedTip()},u-o));return}const[d,m]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(m).then(I=>{switch(I){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(m[0].exeName,m);const A=this._register((0,i.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},u));break}case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const A=_.Event.once(_.Event.latch(_.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(A(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const A=this._register((0,i.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}promptExeRecommendations(s){const o=s.map(({extensionId:d})=>d.toLowerCase()),u=(0,P.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,u,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(a,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(a,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,0,"{}"))}addToRecommendedExecutables(s,o){const u=this.getPromptedExecutableTips();u[s]=o.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(r,JSON.stringify(u),0,0)}groupByInstalled(s,o){const u=[],d=[],m=o.reduce((I,A)=>(I.add(A.identifier.id.toLowerCase()),I),new Set);return s.forEach(I=>{m.has(I.toLowerCase())?u.push(I):d.push(I)}),{installed:u,uninstalled:d}}async getValidExecutableBasedExtensionTips(s){const o=[],u=new Map;for(const d of s.keys()){const m=s.get(d);if(!m||!(0,L.isNonEmptyArray)(m.recommendations))continue;const I=[];D.isWindows?m.windowsPath&&I.push(m.windowsPath.replace("%USERPROFILE%",C.env.USERPROFILE).replace("%ProgramFiles(x86)%",C.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",C.env.ProgramFiles).replace("%APPDATA%",C.env.APPDATA).replace("%WINDIR%",C.env.WINDIR)):(I.push((0,T.join)("/usr/local/bin",d)),I.push((0,T.join)("/usr/bin",d)),I.push((0,T.join)(this.environmentService.userHome.fsPath,d)));for(const A of I){let O=u.get(A);if(O===void 0&&(O=await this.fileService.exists(b.URI.file(A)),u.set(A,O)),O)for(const{extensionId:N,extensionName:$,isExtensionPack:R}of m.recommendations)o.push({extensionId:N,extensionName:$,isExtensionPack:R,exeName:d,exeFriendlyName:m.exeFriendlyName,windowsPath:m.windowsPath})}}return o}};n=de([J(0,E.INativeEnvironmentService),J(1,l.ITelemetryService),J(2,f.IExtensionManagementService),J(3,c.IStorageService),J(4,y.INativeHostService),J(5,h.IExtensionRecommendationNotificationService),J(6,S.IFileService),J(7,w.IProductService),J(8,g.IRequestService),J(9,v.ILogService)],n),e.ExtensionTipsService=n}),define(ne[91],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class L{constructor(_){this.appenders=_}listen(_,T){throw new Error(`Event not found: ${T}`)}call(_,T,{eventName:D,data:C}){return this.appenders.forEach(b=>b.log(D,C)),Promise.resolve(null)}}e.TelemetryAppenderChannel=L;class i{constructor(_){this.channel=_}log(_,T){return this.channel.call("log",{eventName:_,data:T}).then(void 0,D=>`Failed to log telemetry: ${console.warn(D)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=i}),define(ne[44],ie([0,1,28,15,21,22]),function(Q,e,L,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class T{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(y,w){return Promise.resolve(void 0)}publicLog2(y,w){return this.publicLog(y,w)}publicLogError(y,w){return Promise.resolve(void 0)}publicLogError2(y,w){return this.publicLogError(y,w)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=T,e.NullTelemetryService=new T;class D{async publicLog(y,w,g){}async publicLogError(y,w,g){}}e.NullEndpointTelemetryService=D,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(v,y){return y.onDidChangeConfiguration(w=>{w.source!==6&&v.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(w.source),configurationKeys:h(w.sourceConfig)})})}e.configurationTelemetry=C;function b(v,y){return!(y.disableTelemetry||!v.enableTelemetry)}e.supportsTelemetry=b;function P(v){const y=v.getValue(_.TELEMETRY_SETTING_ID),w=v.getValue("telemetry.enableCrashReporter");if(v.getValue(_.TELEMETRY_OLD_SETTING_ID)===!1||w===!1)return 0;switch(y??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=P;function E(v){const y=Object.create(null),w=Object.create(null),g=Object.create(null);p(v,g);for(let c in g){c=c.length>150?c.substr(c.length-149):c;const l=g[c];typeof l=="number"?w[c]=l:typeof l=="boolean"?w[c]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${l.length}`),y[c]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(y[c]=l)}return{properties:y,measurements:w}}e.validateTelemetryData=E;function f(v){if(!v)return"none";let y="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(g=>{v.indexOf(`${g}+`)===0&&(y=g)}),y}e.cleanRemoteAuthority=f;function p(v,y,w=0,g){if(!!v)for(let c of Object.getOwnPropertyNames(v)){const l=v[c],r=g?g+c:c;Array.isArray(l)?y[r]=(0,L.safeStringify)(l):l instanceof Date?y[r]=l.toISOString():(0,i.isObject)(l)?w<2?p(l,y,w+1,r+"."):y[r]=(0,L.safeStringify)(l):y[r]=l}}function h(v){if(!v)return[];const y=[];return S(y,"",v),y}function S(v,y,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(g=>S(v,y?`${y}.${g}`:g,w[g])):v.push(y)}}),define(ne[203],ie([0,1,44,148]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class k{constructor(){}setSharedProperty(C,b){}postEvent(C,b){}}class _{constructor(C,b,P,E,f){this.getMachineId=C,this.configurationService=b,this.productService=P,this.telemetry=E,this.keyValueStorage=f,this.networkInitialized=!1,P.tasConfig&&this.experimentsEnabled&&(0,L.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const p=this.configurationService.getValue("experiments.overrideDelay"),h=typeof p=="number"?p:0;this.overrideInitDelay=new Promise(S=>setTimeout(S,h))}get experimentsEnabled(){return!0}async getTreatment(C){await this.overrideInitDelay;const b=this.configurationService.getValue("experiments.override."+C);if(b!==void 0)return b;if(!this.tasClient||!this.experimentsEnabled)return;let P;const E=await this.tasClient;return this.networkInitialized?P=E.getTreatmentVariable("vscode",C):P=await E.getTreatmentVariableAsync("vscode",C,!0),P=E.getTreatmentVariable("vscode",C),P}async setupTASClient(){const C=this.productService.quality==="stable"?i.TargetPopulation.Public:i.TargetPopulation.Insiders,b=await this.getMachineId(),P=new i.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,b,C),E=this.productService.tasConfig,f=new(await new Promise((p,h)=>{Q(["tas-client-umd"],p,h)})).ExperimentationService({filterProviders:[P],telemetry:this.telemetry,storageKey:i.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:E.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:E.assignmentContextTelemetryPropertyName,telemetryEventName:E.telemetryEventName,endpoint:E.endpoint,refetchInterval:i.ASSIGNMENT_REFETCH_INTERVAL});return await f.initializePromise,f.initialFetch.then(()=>this.networkInitialized=!0),f}}e.BaseAssignmentService=_;class T extends _{constructor(C,b,P){super(()=>Promise.resolve(C),b,P,new k)}}e.AssignmentService=T}),define(ne[204],ie([0,1,17,27,8,28,4,31,15,7,21,13,29,33,76,14,10,26,43,46,23,22,44]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h,S,v,y,w,g,c,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const a=T.isWeb?"web":(0,f.getTargetPlatform)(T.platform,D.arch);var n;(function(z){z[z.None=0]="None",z[z.IncludeVersions=1]="IncludeVersions",z[z.IncludeFiles=2]="IncludeFiles",z[z.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",z[z.IncludeSharedAccounts=8]="IncludeSharedAccounts",z[z.IncludeVersionProperties=16]="IncludeVersionProperties",z[z.ExcludeNonValidated=32]="ExcludeNonValidated",z[z.IncludeInstallationTargets=64]="IncludeInstallationTargets",z[z.IncludeAssetUri=128]="IncludeAssetUri",z[z.IncludeStatistics=256]="IncludeStatistics",z[z.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",z[z.Unpublished=4096]="Unpublished"})(n||(n={}));function t(...z){return String(z.reduce((V,te)=>V|te,0))}var s;(function(z){z[z.Tag=1]="Tag",z[z.ExtensionId=4]="ExtensionId",z[z.Category=5]="Category",z[z.ExtensionName=7]="ExtensionName",z[z.Target=8]="Target",z[z.Featured=9]="Featured",z[z.SearchText=10]="SearchText",z[z.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},u={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},m={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class I{constructor(V=m){this.state=V}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(V,te=this.state.pageSize){return new I({...this.state,pageNumber:V,pageSize:te})}withFilter(V,...te){const se=[...this.state.criteria,...te.length?te.map(ce=>({filterType:V,value:ce})):[{filterType:V}]];return new I({...this.state,criteria:se})}withSortBy(V){return new I({...this.state,sortBy:V})}withSortOrder(V){return new I({...this.state,sortOrder:V})}withFlags(...V){return new I({...this.state,flags:V.reduce((te,se)=>te|se,0)})}withAssetTypes(...V){return new I({...this.state,assetTypes:V})}get raw(){const{criteria:V,pageNumber:te,pageSize:se,sortBy:ce,sortOrder:he,flags:me,assetTypes:ve}=this.state;return{filters:[{criteria:V,pageNumber:te,pageSize:se,sortBy:ce,sortOrder:he}],assetTypes:ve,flags:me}}get searchText(){const V=this.state.criteria.filter(te=>te.filterType===s.SearchText)[0];return V&&V.value?V.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(V=>String(V.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(z,V){const te=(z||[]).filter(se=>se.statisticName===V)[0];return te?te.value:0}function O(z){const V="Microsoft.VisualStudio.Code.Translation.";return z.files.filter(se=>se.assetType.indexOf(V)===0).reduce((se,ce)=>{const he=M(z,ce.assetType);return he&&se.push([ce.assetType.substring(V.length),he]),se},[])}function N(z){if(z.properties){const V=z.properties.filter(ce=>ce.key===o.Repository),te=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),se=V.filter(ce=>te.test(ce.value))[0];return se?{uri:se.value,fallbackUri:se.value}:null}return M(z,o.Repository)}function $(z){return{uri:`${z.fallbackAssetUri}/${o.VSIX}?redirect=true${z.targetPlatform?`&targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${o.VSIX}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}}function R(z){const V=M(z,o.Icon);if(V)return V;const te=f.DefaultIconPath;return{uri:te,fallbackUri:te}}function M(z,V){return z.files.filter(se=>se.assetType===V)[0]?{uri:`${z.assetUri}/${V}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${V}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}:null}function W(z,V){const te=z.properties?z.properties.filter(ce=>ce.key===V):[],se=te.length>0&&te[0].value;return se?se.split(",").map(ce=>(0,p.adoptToGalleryExtensionId)(ce)):[]}function U(z){const V=z.properties?z.properties.filter(te=>te.key===u.Engine):[];return V.length>0&&V[0].value||""}function x(z){const V=z.properties?z.properties.filter(te=>te.key===u.PreRelease):[];return V.length>0&&V[0].value==="true"}function ee(z){const V=z.properties?z.properties.filter(se=>se.key===u.LocalizedLanguages):[],te=V.length>0&&V[0].value||"";return te?te.split(","):[]}function G(z){return z.indexOf("preview")!==-1}function q(z){return z.targetPlatform?(0,f.toTargetPlatform)(z.targetPlatform):"undefined"}function Y(z){const V=(0,L.distinct)(z.versions.map(q)),te=!!z.tags?.includes(f.WEB_EXTENSION_TAG),se=V.indexOf("web");return te?se===-1&&V.push("web"):se!==-1&&V.splice(se,1),V}function H(z,V){const te=(0,f.getFallbackTargetPlarforms)(V);for(let se=0;se<z.length;se++){const ce=z[se];if(ce.version===z[se-1]?.version){let he=se;const me=q(ce);if(me===V)for(;he>0&&z[he-1].version===ce.version;)he--;else if(te.includes(me))for(;he>0&&z[he-1].version===ce.version&&q(z[he-1])!==V;)he--;he!==se&&(z.splice(se,1),z.splice(he,0,ce))}}return z}e.sortExtensionVersions=H;function Z(z,V,te,se,ce){const he=z.versions[0],me={manifest:M(V,o.Manifest),readme:M(V,o.Details),changelog:M(V,o.Changelog),license:M(V,o.License),repository:N(V),download:$(V),icon:R(V),coreTranslations:O(V)};return{identifier:{id:(0,p.getGalleryExtensionId)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},name:z.extensionName,version:V.version,displayName:z.displayName,publisherId:z.publisher.publisherId,publisher:z.publisher.publisherName,publisherDisplayName:z.publisher.displayName,publisherDomain:z.publisher.domain?{link:z.publisher.domain,verified:!!z.publisher.isDomainVerified}:void 0,description:z.shortDescription||"",installCount:A(z.statistics,"install"),rating:A(z.statistics,"averagerating"),ratingCount:A(z.statistics,"ratingcount"),categories:z.categories||[],tags:z.tags||[],releaseDate:Date.parse(z.releaseDate),lastUpdated:Date.parse(z.lastUpdated),allTargetPlatforms:te,assets:me,properties:{dependencies:W(V,u.Dependency),extensionPack:W(V,u.ExtensionPack),engine:U(V),localizedLanguages:ee(V),targetPlatform:q(V),isPreReleaseVersion:x(V)},hasPreReleaseVersion:x(he),hasReleaseVersion:se,preview:G(z.flags),telemetryData:ce}}let K=class{constructor(V,te,se,ce,he,me,ve,ge){this.requestService=te,this.logService=se,this.environmentService=ce,this.telemetryService=he,this.fileService=me,this.productService=ve,this.configurationService=ge;const we=ve.extensionsGallery;this.extensionsGalleryUrl=we&&we.serviceUrl,this.extensionsControlUrl=we&&we.controlUrl,this.commonHeadersPromise=B(ve.version,ve,this.environmentService,this.configurationService,this.fileService,V)}api(V=""){return`${this.extensionsGalleryUrl}${V}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(V,te,se){const ce=(0,C.isBoolean)(te)?te:!1,he=(0,C.isBoolean)(te)?se:te;let me=new I().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,V.length).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionName,...V.map(({id:we})=>we.toLowerCase()));V.every(we=>!we.version)&&(me=me.withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties,n.IncludeLatestVersionOnly));const{galleryExtensions:ve}=await this.queryGallery(me,a,i.CancellationToken.None),ge=ve.map(we=>{const De=(0,p.getGalleryExtensionId)(we.publisher.publisherName,we.extensionName);return{rawGalleryExtension:we,version:V.find(Ee=>(0,p.areSameExtensions)(Ee,{id:De}))?.version,preRelease:ce}});return this.converToGalleryExtensions(ge,a,()=>{},he)}async getExtensions2(V){const te=[],se=[];for(const ve of V)ve.uuid?se.push(ve.uuid):te.push(ve.id.toLowerCase());let ce=new I().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties,n.IncludeLatestVersionOnly).withPage(1,V.length).withFilter(s.Target,"Microsoft.VisualStudio.Code");se.length&&(ce=ce.withFilter(s.ExtensionId,...se)),te.length&&(ce=ce.withFilter(s.ExtensionId,...te));const{galleryExtensions:he}=await this.queryGallery(ce,a,i.CancellationToken.None),me=he.map(ve=>{const ge=(0,p.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName),we=V.find(De=>(0,p.areSameExtensions)(De,{id:ge,uuid:ve.extensionId}));return{rawGalleryExtension:ve,preRelease:!!we?.preRelease}});return this.converToGalleryExtensions(me,a,()=>{},i.CancellationToken.None)}async getCompatibleExtension(V,te,se){const ce=(0,f.isIExtensionIdentifier)(V)?null:V;if(ce){if((0,f.isNotWebExtensionInWebTargetPlatform)(ce.allTargetPlatforms,se))return null;if(await this.isExtensionCompatible(ce,te,se))return ce}const{id:he,uuid:me}=ce?ce.identifier:V;let ve=new I().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");me?ve=ve.withFilter(s.ExtensionId,me):ve=ve.withFilter(s.ExtensionName,he);const{galleryExtensions:ge}=await this.queryGallery(ve,se,i.CancellationToken.None),[we]=ge;if(!we||!we.versions.length)return null;const De=Y(we);if((0,f.isNotWebExtensionInWebTargetPlatform)(De,se))return null;for(let Ee of we.versions){if(!U(Ee)){const ke=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:u.Engine,value:ke}]}}if(await this.isRawExtensionVersionCompatible(Ee,te,De,se)){const ke=we.versions.some(Le=>!x(Le));return Z(we,Ee,De,ke)}}return null}async isExtensionCompatible(V,te,se){if(!(0,f.isTargetPlatformCompatible)(V.properties.targetPlatform,V.allTargetPlatforms,se)||!te&&V.properties.isPreReleaseVersion)return!1;let ce=V.properties.engine;if(!ce){const he=await this.getManifest(V,i.CancellationToken.None);if(!he)throw new Error("Manifest was not found");ce=he.engines.vscode}return(0,h.isEngineValid)(ce,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(V,te,se,ce){if(!(0,f.isTargetPlatformCompatible)(q(V),se,ce)||!te&&x(V))return!1;const he=await this.getEngine(V);return(0,h.isEngineValid)(he,this.productService.version,this.productService.date)}async query(V,te){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let se=V.text||"";const ce=(0,_.getOrDefault)(V,Ee=>Ee.pageSize,50);let he=new I().withFlags(n.IncludeLatestVersionOnly,n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,ce).withFilter(s.Target,"Microsoft.VisualStudio.Code");se?(se=se.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,ke,Le)=>(he=he.withFilter(s.Category,Le||ke),"")),se=se.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,ke,Le)=>(he=he.withFilter(s.Tag,Le||ke),"")),se=se.replace(/\bfeatured(\s+|\b|$)/g,()=>(he=he.withFilter(s.Featured),"")),se=se.trim(),se&&(se=se.length<200?se:se.substring(0,200),he=he.withFilter(s.SearchText,se)),he=he.withSortBy(0)):V.ids?he=he.withFilter(s.ExtensionId,...V.ids):V.names?he=he.withFilter(s.ExtensionName,...V.names):he=he.withSortBy(4),typeof V.sortBy=="number"&&(he=he.withSortBy(V.sortBy)),typeof V.sortOrder=="number"&&(he=he.withSortOrder(V.sortOrder));const{galleryExtensions:me,total:ve}=await this.queryGallery(he,a,te),ge=Ee=>({index:(he.pageNumber-1)*he.pageSize+Ee,querySource:V.source}),we=await this.converToGalleryExtensions(me.map(Ee=>({rawGalleryExtension:Ee,preRelease:!!V.includePreRelease})),a,ge,te),De=async(Ee,ke)=>{if(ke.isCancellationRequested)throw(0,k.canceled)();const Le=he.withPage(Ee+1),{galleryExtensions:Fe}=await this.queryGallery(Le,a,ke);return await this.converToGalleryExtensions(Fe.map($e=>({rawGalleryExtension:$e,preRelease:!!V.includePreRelease})),a,ge,te)};return{firstPage:we,total:ve,pageSize:he.pageSize,getPage:De}}async converToGalleryExtensions(V,te,se,ce){const he=(ge,we,De,Ee)=>{const ke=Y(ge);let Le=ge.versions[0];return Le=ge.versions.find(Fe=>Fe.version===Le.version&&(0,f.isTargetPlatformCompatible)(q(Fe),ke,te))||Le,x(Le)&&!Ee&&(Le=ge.versions.find(Fe=>Fe.version!==Le.version&&!x(Fe))||Le),Z(ge,Le,ke,De,se(we))},me=[],ve=new Map;for(let ge=0;ge<V.length;ge++){const{rawGalleryExtension:we,version:De,preRelease:Ee}=V[ge],ke=we.versions.some(Le=>!x(Le));if(De){const Le=we.versions.find(Fe=>Fe.version===De);Le&&me.push([ge,Z(we,Le,Y(we),ke)])}else{const Le=he(we,ge,ke,Ee);Le.properties.isPreReleaseVersion?ve.set(Le.identifier.uuid,{index:ge,preRelease:Ee}):me.push([ge,Le])}}if(ve.size){const ge=new Date().getTime(),we=new I().withFlags(n.IncludeVersions,n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,ve.size).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionId,...ve.keys()),{galleryExtensions:De}=await this.queryGallery(we,te,ce);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-ge,count:ve.size}),De.length!==ve.size)throw new Error("Not all extensions with latest versions are returned");for(const Ee of De){const ke=Ee.versions.some(ze=>!x(ze)),{index:Le,preRelease:Fe}=ve.get(Ee.extensionId),$e=he(Ee,Le,ke,Fe);me.push([Le,$e])}}return me.sort((ge,we)=>ge[0]-we[0]).map(([,ge])=>ge)}async queryGallery(V,te,se){if(!this.isEnabled())throw new Error("No extension gallery service configured.");V=V.withFlags(V.flags,n.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,t(n.Unpublished));const ce=await this.commonHeadersPromise,he=JSON.stringify(V.raw),me={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(he.length)},ve=new Date().getTime();let ge,we,De=0;try{if(ge=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:he,headers:me},se),ge.res.statusCode&&ge.res.statusCode>=400&&ge.res.statusCode<500)return{galleryExtensions:[],total:De};const Ee=await(0,w.asJson)(ge);if(Ee){const ke=Ee.results[0],Le=ke.extensions;Le.forEach($e=>H($e.versions,te));const Fe=ke.resultMetadata&&ke.resultMetadata.filter($e=>$e.metadataType==="ResultCount")[0];return De=Fe&&Fe.metadataItems.filter($e=>$e.name==="TotalCount")[0].count||0,{galleryExtensions:Le,total:De}}return{galleryExtensions:[],total:De}}catch(Ee){throw we=Ee,Ee}finally{this.telemetryService.publicLog2("galleryService:query",{...V.telemetryData,requestBodySize:String(he.length),duration:new Date().getTime()-ve,success:!!ge&&(0,w.isSuccess)(ge),responseBodySize:ge?.res.headers["Content-Length"],statusCode:ge?String(ge.res.statusCode):void 0,errorCode:we?(0,k.isPromiseCanceledError)(we)?"canceled":(0,k.getErrorMessage)(we).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(De)})}}async reportStatistic(V,te,se,ce){if(!this.isEnabled())return;const he=T.isWeb?this.api(`/itemName/${V}.${te}/version/${se}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${V}/extensions/${te}/${se}/stats?statType=${ce}`),me=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.commonHeadersPromise,Accept:me};try{await this.requestService.request({type:"POST",url:he,headers:ge},i.CancellationToken.None)}catch{}}async download(V,te,se){this.logService.trace("ExtensionGalleryService#download",V.identifier.id);const ce=(0,p.getGalleryExtensionTelemetryData)(V),he=new Date().getTime(),me=De=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:De}),ve=se===2?"install":se===3?"update":"",ge=ve?{uri:`${V.assets.download.uri}${b.URI.parse(V.assets.download.uri).query?"&":"?"}${ve}=true`,fallbackUri:`${V.assets.download.fallbackUri}${b.URI.parse(V.assets.download.fallbackUri).query?"&":"?"}${ve}=true`}:V.assets.download,we=await this.getAsset(ge);await this.fileService.writeFile(te,we.stream),me(new Date().getTime()-he)}async getReadme(V,te){if(V.assets.readme){const se=await this.getAsset(V.assets.readme,{},te);return await(0,w.asText)(se)||""}return""}async getManifest(V,te){if(V.assets.manifest){const se=await this.getAsset(V.assets.manifest,{},te),ce=await(0,w.asText)(se);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(V,te){const se=M(V,o.Manifest);if(!se)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},he=await this.getAsset(se,{headers:ce});return await(0,w.asJson)(he)}async getCoreTranslation(V,te){const se=V.assets.coreTranslations.filter(ce=>ce[0]===te.toUpperCase())[0];if(se){const ce=await this.getAsset(se[1]),he=await(0,w.asText)(ce);return he?JSON.parse(he):null}return null}async getChangelog(V,te){if(V.assets.changelog){const se=await this.getAsset(V.assets.changelog,{},te);return await(0,w.asText)(se)||""}return""}async getAllCompatibleVersions(V,te,se){let ce=new I().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");V.identifier.uuid?ce=ce.withFilter(s.ExtensionId,V.identifier.uuid):ce=ce.withFilter(s.ExtensionName,V.identifier.id);const{galleryExtensions:he}=await this.queryGallery(ce,se,i.CancellationToken.None);if(!he.length)return[];const me=Y(he[0]);if((0,f.isNotWebExtensionInWebTargetPlatform)(me,se))return[];const ve=[];for(const ge of he[0].versions)try{ve[ve.length-1]?.version!==ge.version&&await this.isRawExtensionVersionCompatible(ge,te,me,se)&&ve.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:x(ge)})}catch{}return ve}async getAsset(V,te={},se=i.CancellationToken.None){const ce=await this.commonHeadersPromise,he={type:"GET"},me={...ce,...te.headers||{}};te={...te,...he,headers:me};const ve=V.uri,ge=V.fallbackUri,we={...te,url:ve};try{const De=await this.requestService.request(we,se);if(De.res.statusCode===200)return De;const Ee=await(0,w.asText)(De);throw new Error(`Expected 200, got back ${De.res.statusCode} instead.

${Ee}`)}catch(De){if((0,k.isPromiseCanceledError)(De))throw De;const Ee=(0,k.getErrorMessage)(De);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ve,message:Ee});const ke={...te,url:ge};return this.requestService.request(ke,se)}}async getEngine(V){let te=U(V);if(!te){const se=await this.getManifestFromRawExtensionVersion(V,i.CancellationToken.None);if(!se)throw new Error("Manifest was not found");te=se.engines.vscode}return te}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const V=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},i.CancellationToken.None);if(V.res.statusCode!==200)throw new Error("Could not get extensions report.");const te=await(0,w.asJson)(V),se=[],ce={};if(te){for(const he of te.malicious)se.push({id:he});if(te.unsupported)for(const he of Object.keys(te.unsupported)){const me=te.unsupported[he];(0,C.isBoolean)(me)||(ce[he.toLowerCase()]=me.preReleaseExtension)}}return{malicious:se,unsupportedPreReleaseExtensions:ce}}};K=de([J(1,w.IRequestService),J(2,v.ILogService),J(3,E.IEnvironmentService),J(4,l.ITelemetryService),J(5,S.IFileService),J(6,y.IProductService),J(7,P.IConfigurationService)],K);let F=class extends K{constructor(V,te,se,ce,he,me,ve,ge){super(V,te,se,ce,he,me,ve,ge)}};F=de([J(0,c.IStorageService),J(1,w.IRequestService),J(2,v.ILogService),J(3,E.IEnvironmentService),J(4,l.ITelemetryService),J(5,S.IFileService),J(6,y.IProductService),J(7,P.IConfigurationService)],F),e.ExtensionGalleryService=F;let j=class extends K{constructor(V,te,se,ce,he,me,ve){super(void 0,V,te,se,ce,he,me,ve)}};j=de([J(0,w.IRequestService),J(1,v.ILogService),J(2,E.IEnvironmentService),J(3,l.ITelemetryService),J(4,S.IFileService),J(5,y.IProductService),J(6,P.IConfigurationService)],j),e.ExtensionGalleryServiceWithNoStorageService=j;async function B(z,V,te,se,ce,he){const me={"X-Market-Client-Id":`VSCode ${z}`,"User-Agent":`VSCode ${z} (${V.nameShort})`},ve=await(0,g.getServiceMachineId)(te,ce,he);return(0,r.supportsTelemetry)(V,te)&&(0,r.getTelemetryLevel)(se)===3&&(me["X-Market-User-Id"]=ve),me}e.resolveMarketplaceHeaders=B}),define(ne[92],ie([0,1,2,13,10,44]),function(Q,e,L,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends L.Disposable{constructor(C,b,P=""){super();this.prefix=P;const E=C.getLogger(b.telemetryLogResource);E?this.logger=this._register(E):(this.logger=this._register(C.createLogger(b.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(C,b){this.logger.trace(`${this.prefix}telemetry/${C}`,(0,_.validateTelemetryData)(b))}};T=de([J(0,k.ILoggerService),J(1,i.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(ne[93],ie([0,1,2,28,4,25,140,21,42,85,38,22,44]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(v,y){this._configurationService=y,this._experimentProperties={},this._disposables=new L.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,_.escapeRegExpCharacters)(w),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(w=>{const g=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!g})})}setExperimentProperty(v,y){this._experimentProperties[v]=y}_updateTelemetryLevel(){this._telemetryLevel=(0,f.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const v=await this._commonProperties;let y=v.sessionID,w=v["common.machineId"],g=v["common.firstSessionDate"],c=v["common.msftInternal"];return{sessionId:y,machineId:w,firstSessionDate:g,msftInternal:c}}dispose(){this._disposables.dispose()}_log(v,y,w,g){return this.telemetryLevel<y?Promise.resolve(void 0):this._commonProperties.then(c=>{w=(0,i.mixin)(w,c),w=(0,i.mixin)(w,this._experimentProperties),w=(0,i.cloneAndChange)(w,l=>{if(typeof l=="string")return this._cleanupInfo(l,g)}),this._appenders.forEach(l=>l.log(v,w))},c=>{console.error(c)})}publicLog(v,y,w){return this._log(v,3,y,w)}publicLog2(v,y,w){return this.publicLog(v,y,w)}publicLogError(v,y){return this.sendErrorTelemetry?this._log(v,2,y,!0):Promise.resolve(void 0)}publicLogError2(v,y){return this.publicLogError(v,y)}_anonymizeFilePaths(v){let y=v;const w=[];for(let r of this._cleanupPatterns)for(;;){const a=r.exec(v);if(!a)break;w.push([a.index,r.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(y="";;){const r=c.exec(v);if(!r)break;!g.test(r[0])&&w.every(([a,n])=>r.index<a||r.index>=n)&&(y+=v.substring(l,r.index)+"<REDACTED: user-file-path>",l=c.lastIndex)}return l<v.length&&(y+=v.substr(l)),y}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const y=v.toLowerCase(),w=/@[a-zA-Z0-9-.]+/;return/(key|token|sig|signature|password|passwd|pwd)[="':\s]/.test(y)?"<REDACTED: secret>":w.test(y)?"<REDACTED: email>":v}_cleanupInfo(v,y){let w=v;y&&(w=this._anonymizeFilePaths(w));for(let g of this._cleanupPatterns)w=w.replace(g,"");return w=this._removePropertiesWithPossibleUserInfo(w),w}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=de([J(1,D.IConfigurationService)],p),e.TelemetryService=p;function h(){const S=(0,T.localize)(0,null,b.default.nameLong),v=b.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),y=k.isWeb?"":(0,T.localize)(3,null),w=(0,T.localize)(4,null),g=(0,T.localize)(5,null),c=(0,T.localize)(6,null),l=(0,T.localize)(7,null),r=`
|       | ${w} | ${g} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,T.localize)(8,null);return`
${S} ${v} ${y}

&nbsp;

${l}
${r}

&nbsp;

${a}
`}P.Registry.as(C.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),P.Registry.as(C.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,T.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,T.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[205],ie([0,1,8,28,44]),function(Q,e,L,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function _(D,C){const b=await new Promise((E,f)=>{Q(["applicationinsights"],E,f)});let P;return b.defaultClient?(P=new b.TelemetryClient(D),P.channel.setUseDiskRetryCaching(!0)):(b.setup(D).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),P=b.defaultClient),D.indexOf("AIF-")===0&&(P.config.endpointUrl=C?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),P}class T{constructor(C,b,P,E,f){this._eventPrefix=C,this._defaultData=b,this.testCollector=E,this.mirrored=f,this._defaultData||(this._defaultData=Object.create(null)),typeof P=="function"?this._aiClient=P():this._aiClient=P,this._asyncAIClient=null}_withAIClient(C){if(!!this._aiClient){if(typeof this._aiClient!="string"){C(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=_(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(b=>{C(b)},b=>{(0,L.onUnexpectedError)(b),console.error(b)})}}log(C,b){!this._aiClient||(b=(0,i.mixin)(b,this._defaultData),b=(0,k.validateTelemetryData)(b),this.testCollector&&(b.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(P=>P.trackEvent({name:this._eventPrefix+"/"+C,properties:b.properties,measurements:b.measurements})))}flush(){return this._aiClient?new Promise(C=>{this._withAIClient(b=>{b.flush({callback:()=>{this._aiClient=void 0,C(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=T}),define(ne[206],ie([0,1,16,57,21,13,10,22,91,92,93]),function(Q,e,L,i,k,_,T,D,C,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let E=class{constructor(p,h,S,v){this.configurationService=p,this.telemetryService=h,this.loggerService=S,this.environmentService=v,this.customTelemetryServices=new Map}async getCustomTelemetryService(p){if(!this.customTelemetryServices.has(p.id)){const{machineId:h,sessionId:S}=await this.telemetryService.getTelemetryInfo(),v=Object.create(null);v["common.vscodemachineid"]=h,v["common.vscodesessionid"]=S;const y=[p.id,JSON.stringify(v),p.aiKey],g=new i.Client(L.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:y,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),c=[new C.TelemetryAppenderClient(g),new b.TelemetryLogAppender(this.loggerService,this.environmentService,`[${p.id}] `)];this.customTelemetryServices.set(p.id,new P.TelemetryService({appenders:c,sendErrorTelemetry:p.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(p.id)}async publicLog(p,h,S){await(await this.getCustomTelemetryService(p)).publicLog(h,S)}async publicLogError(p,h,S){await(await this.getCustomTelemetryService(p)).publicLogError(h,S)}};E=de([J(0,k.IConfigurationService),J(1,D.ITelemetryService),J(2,T.ILoggerService),J(3,_.IEnvironmentService)],E),e.CustomEndpointTelemetryService=E}),define(ne[207],ie([0,1,5,27,3,2,10]),function(Q,e,L,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let D=class extends _.Disposable{constructor(b,P){super();this._logService=P,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new k.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((P,E)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,P),this._onCreateRequest.fire({requestId:f,...b});const p=new i.CancellationTokenSource;(0,L.timeout)(this._timeout,p.token).then(()=>E(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,_.toDisposable)(()=>p.cancel())])})}acceptReply(b,P){const E=this._pendingRequests.get(b);E?(this._pendingRequests.delete(b),(0,_.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),E(P)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};D=de([J(1,T.ILogService)],D),e.RequestStore=D}),define(ne[94],ie([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var i;(function(v){v.Shell="terminal.integrated.shell.",v.ShellArgs="terminal.integrated.shellArgs.",v.DefaultProfile="terminal.integrated.defaultProfile.",v.Profiles="terminal.integrated.profiles."})(i=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var k;(function(v){v.ShellLinux="terminal.integrated.shell.linux",v.ShellMacOs="terminal.integrated.shell.osx",v.ShellWindows="terminal.integrated.shell.windows",v.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",v.AutomationShellLinux="terminal.integrated.automationShell.linux",v.AutomationShellMacOs="terminal.integrated.automationShell.osx",v.AutomationShellWindows="terminal.integrated.automationShell.windows",v.AutomationProfileLinux="terminal.integrated.automationProfile.linux",v.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",v.AutomationProfileWindows="terminal.integrated.automationProfile.windows",v.ShellArgsLinux="terminal.integrated.shellArgs.linux",v.ShellArgsMacOs="terminal.integrated.shellArgs.osx",v.ShellArgsWindows="terminal.integrated.shellArgs.windows",v.ProfilesWindows="terminal.integrated.profiles.windows",v.ProfilesMacOs="terminal.integrated.profiles.osx",v.ProfilesLinux="terminal.integrated.profiles.linux",v.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",v.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",v.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",v.UseWslProfiles="terminal.integrated.useWslProfiles",v.TabsEnabled="terminal.integrated.tabs.enabled",v.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",v.TabsHideCondition="terminal.integrated.tabs.hideCondition",v.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",v.TabsShowActions="terminal.integrated.tabs.showActions",v.TabsLocation="terminal.integrated.tabs.location",v.TabsFocusMode="terminal.integrated.tabs.focusMode",v.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",v.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",v.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",v.CopyOnSelection="terminal.integrated.copyOnSelection",v.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",v.FontFamily="terminal.integrated.fontFamily",v.FontSize="terminal.integrated.fontSize",v.LetterSpacing="terminal.integrated.letterSpacing",v.LineHeight="terminal.integrated.lineHeight",v.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",v.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",v.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",v.BellDuration="terminal.integrated.bellDuration",v.FontWeight="terminal.integrated.fontWeight",v.FontWeightBold="terminal.integrated.fontWeightBold",v.CursorBlinking="terminal.integrated.cursorBlinking",v.CursorStyle="terminal.integrated.cursorStyle",v.CursorWidth="terminal.integrated.cursorWidth",v.Scrollback="terminal.integrated.scrollback",v.DetectLocale="terminal.integrated.detectLocale",v.DefaultLocation="terminal.integrated.defaultLocation",v.GpuAcceleration="terminal.integrated.gpuAcceleration",v.TerminalTitleSeparator="terminal.integrated.tabs.separator",v.TerminalTitle="terminal.integrated.tabs.title",v.TerminalDescription="terminal.integrated.tabs.description",v.RightClickBehavior="terminal.integrated.rightClickBehavior",v.Cwd="terminal.integrated.cwd",v.ConfirmOnExit="terminal.integrated.confirmOnExit",v.ConfirmOnKill="terminal.integrated.confirmOnKill",v.EnableBell="terminal.integrated.enableBell",v.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",v.AllowChords="terminal.integrated.allowChords",v.AllowMnemonics="terminal.integrated.allowMnemonics",v.EnvMacOs="terminal.integrated.env.osx",v.EnvLinux="terminal.integrated.env.linux",v.EnvWindows="terminal.integrated.env.windows",v.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",v.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",v.ShowExitAlert="terminal.integrated.showExitAlert",v.SplitCwd="terminal.integrated.splitCwd",v.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",v.WordSeparators="terminal.integrated.wordSeparators",v.EnableFileLinks="terminal.integrated.enableFileLinks",v.UnicodeVersion="terminal.integrated.unicodeVersion",v.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",v.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",v.LocalEchoEnabled="terminal.integrated.localEchoEnabled",v.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",v.LocalEchoStyle="terminal.integrated.localEchoStyle",v.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",v.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",v.CustomGlyphs="terminal.integrated.customGlyphs",v.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",v.InheritEnv="terminal.integrated.inheritEnv",v.ShowLinkHover="terminal.integrated.showLinkHover",v.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",v.AutoReplies="terminal.integrated.autoReplies"})(k=e.TerminalSettingId||(e.TerminalSettingId={}));var _;(function(v){v.CommandPrompt="cmd",v.PowerShell="pwsh",v.Wsl="wsl",v.GitBash="gitbash"})(_=e.WindowsShellType||(e.WindowsShellType={}));var T;(function(v){v[v.Api=0]="Api",v[v.Process=1]="Process",v[v.Sequence=2]="Sequence",v[v.Config=3]="Config"})(T=e.TitleEventSource||(e.TitleEventSource={}));var D;(function(v){v.LocalPty="localPty",v.PtyHost="ptyHost",v.Log="log",v.Heartbeat="heartbeat"})(D=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,L.createDecorator)("ptyService");var C;(function(v){v.Cwd="cwd",v.InitialCwd="initialCwd",v.FixedDimensions="fixedDimensions",v.Title="title",v.ShellType="shellType",v.HasChildProcesses="hasChildProcesses",v.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",v.OverrideDimensions="overrideDimensions"})(C=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(v){v[v.BeatInterval=5e3]="BeatInterval",v[v.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",v[v.SecondWaitMultiplier=1]="SecondWaitMultiplier",v[v.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var P;(function(v){v[v.Panel=1]="Panel",v[v.Editor=2]="Editor"})(P=e.TerminalLocation||(e.TerminalLocation={}));var E;(function(v){v.TerminalView="view",v.Editor="editor"})(E=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(v){v.CwdDetection="cwdDetection"})(f=e.ProcessCapability||(e.ProcessCapability={}));var p;(function(v){v[v.GraceTime=6e4]="GraceTime",v[v.ShortGraceTime=6e3]="ShortGraceTime"})(p=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(v){v[v.HighWatermarkChars=1e5]="HighWatermarkChars",v[v.LowWatermarkChars=5e3]="LowWatermarkChars",v[v.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var S;(function(v){v.GitBash="Git Bash",v.Pwsh="PowerShell"})(S=e.ProfileSource||(e.ProfileSource={}))}),define(ne[208],ie([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,L.createDecorator)("localPtyService")}),define(ne[209],ie([0,1,32,28,9,4,31,15,20]),function(Q,e,L,i,k,_,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(L.release());let f=0;return E&&E.length===4&&(f=parseInt(E[3])),f}e.getWindowsBuildNumber=b;async function P(E,f,p,h=T.env,S=C.Promises.exists){if(k.isAbsolute(E))return await S(E)?E:void 0;if(f===void 0&&(f=T.cwd()),k.dirname(E)!=="."){const g=k.join(f,E);return await S(g)?g:void 0}const y=(0,i.getCaseInsensitive)(h,"PATH");if(p===void 0&&(0,D.isString)(y)&&(p=y.split(k.delimiter)),p===void 0||p.length===0){const g=k.join(f,E);return await S(g)?g:void 0}for(let g of p){let c;if(k.isAbsolute(g)?c=k.join(g,E):c=k.join(f,g,E),await S(c))return c;if(_.isWindows){let l=c+".com";if(await S(l)||(l=c+".exe",await S(l)))return l}}const w=k.join(f,E);return await S(w)?w:void 0}e.findExecutable=P}),define(ne[210],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var L;(function(i){i.DARK="dark",i.LIGHT="light",i.HIGH_CONTRAST="hc"})(L=e.ColorScheme||(e.ColorScheme={}))}),define(ne[95],ie([0,1,48,3,2,6,38,210]),function(Q,e,L,i,k,_,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var C;(function(v){function y(w){return w&&typeof w=="object"&&typeof w.id=="string"}v.isThemeColor=y})(C=e.ThemeColor||(e.ThemeColor={}));function b(v){return{id:v}}e.themeColorFromId=b;var P;(function(v){function y(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||C.isThemeColor(t.color))}v.isThemeIcon=y;const w=new RegExp(`^\\$\\((${L.CSSIcon.iconNameExpression}(?:${L.CSSIcon.iconModifierExpression})?)\\)$`);function g(t){const s=w.exec(t);if(!s)return;let[,o]=s;return{id:o}}v.fromString=g;function c(t){return{id:t}}v.fromId=c;function l(t,s){let o=t.id;const u=o.lastIndexOf("~");return u!==-1&&(o=o.substring(0,u)),s&&(o=`${o}~${s}`),{id:o}}v.modify=l;function r(t){const s=t.id.lastIndexOf("~");if(s!==-1)return t.id.substring(s+1)}v.getModifier=r;function a(t,s){return t.id===s.id&&t.color?.id===s.color?.id}v.isEqual=a;function n(t,s){return{id:t.id,color:s?b(s):void 0}}v.asThemeIcon=n,v.asClassNameArray=L.CSSIcon.asClassNameArray,v.asClassName=L.CSSIcon.asClassName,v.asCSSSelector=L.CSSIcon.asCSSSelector})(P=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=L.Codicon.file,e.FolderThemeIcon=L.Codicon.folder;function E(v){switch(v){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(y){return this.themingParticipants.push(y),this.onThemingParticipantAddedEmitter.fire(y),(0,k.toDisposable)(()=>{const w=this.themingParticipants.indexOf(y);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new f;T.Registry.add(e.Extensions.ThemingContribution,p);function h(v){return p.onColorThemeChange(v)}e.registerThemingParticipant=h;class S extends k.Disposable{constructor(y){super();this.themeService=y,this.theme=y.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(y){this.theme=y,this.updateStyles()}updateStyles(){}getColor(y,w){let g=this.theme.getColor(y);return g&&w&&(g=w(g,this.theme)),g?g.toString():null}}e.Themable=S}),define(ne[211],ie([0,1,48,7,95]),function(Q,e,L,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function _(E,f){const p=E.map(h=>({name:h.profileName,description:T(h)}));return f&&p.push(...f.map(h=>({name:h.title,description:D(h)}))),{values:p.map(h=>h.name),markdownDescriptions:p.map(h=>h.description)}}e.createProfileSchemaEnums=_;function T(E){let f=`$(${k.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:L.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?f+=`
- args: "${E.args}"`:f+=`
- args: [${E.args.length===0?"":`'${E.args.join("','")}'`}]`),E.overrideName!==void 0&&(f+=`
- overrideName: ${E.overrideName}`),E.color&&(f+=`
- color: ${E.color}`),E.env&&(f+=`
- env: ${JSON.stringify(E.env)}`),f}function D(E){return`$(${k.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:L.Codicon.terminal.id}) ${E.title}
- extensionIdenfifier: ${E.extensionIdentifier}`}function C(E,f){if(!E&&!f)return!0;if(typeof E=="string"&&typeof f=="string")return E===f;if(Array.isArray(E)&&Array.isArray(f)){if(E.length!==f.length)return!1;for(let p=0;p<E.length;p++)if(E[p]!==f[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=C;function b(E,f){if(!E&&!f)return!0;if(!E||!f)return!1;if(k.ThemeIcon.isThemeIcon(E)&&k.ThemeIcon.isThemeIcon(f))return E.id===f.id&&E.color===f.color;if(typeof E=="object"&&E&&"light"in E&&"dark"in E&&typeof f=="object"&&f&&"light"in f&&"dark"in f){const p=E,h=f;if((i.URI.isUri(p.light)||P(p.light))&&(i.URI.isUri(p.dark)||P(p.dark))&&(i.URI.isUri(h.light)||P(h.light))&&(i.URI.isUri(h.dark)||P(h.dark)))return p.light.path===h.light.path&&p.dark.path===h.dark.path}if(i.URI.isUri(E)&&i.URI.isUri(f)||P(E)||P(f)){const p=E,h=f;return p.path===h.path&&p.scheme===h.scheme}return!1}e.terminalIconsEqual=b;function P(E){return E?typeof E.path=="string"&&typeof E.scheme=="string":!1}e.isUriComponents=P}),define(ne[212],ie([0,1,48,141,42,38,211]),function(Q,e,L,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const D={args:{description:(0,i.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,i.localize)(1,null),type:"boolean"},icon:{description:(0,i.localize)(2,null),type:"string",enum:Array.from(L.Codicon.getAll(),c=>c.id),markdownEnumDescriptions:Array.from(L.Codicon.getAll(),c=>`$(${c.id})`)},color:{description:(0,i.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,i.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},C={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(5,null),type:["string","array"],items:{type:"string"}},...D}},b={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(6,null),type:["string"],items:{type:"string"}},...D}},P=(0,i.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),E=(0,i.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),f=(0,i.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),p=(0,i.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,i.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),S=(0,i.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),v={id:"terminal",order:100,title:(0,i.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,i.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,i.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,i.localize)(26,null)}},{type:"string",markdownDescription:(0,i.localize)(27,null)}],default:[],markdownDeprecationMessage:f},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,i.localize)(29,null),enum:["PowerShell","Git Bash"]},...D}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(30,null),type:"string"},id:{description:(0,i.localize)(31,null),type:"string"},title:{description:(0,i.localize)(32,null),type:"string"},...D}},{type:"null"},C]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(34,null),type:"string"},id:{description:(0,i.localize)(35,null),type:"string"},title:{description:(0,i.localize)(36,null),type:"string"},...D}},{type:"null"},C]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(38,null),type:"string"},id:{description:(0,i.localize)(39,null),type:"string"},title:{description:(0,i.localize)(40,null),type:"string"},...D}},{type:"null"},C]}},["terminal.integrated.useWslProfiles"]:{description:(0,i.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,i.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,i.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,i.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,i.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function y(){_.Registry.as(k.Extensions.Configuration).registerConfiguration(v),g()}e.registerTerminalPlatformConfiguration=y;let w;function g(c,l){const r=_.Registry.as(k.Extensions.Configuration);let a;c&&(a=(0,T.createProfileSchemaEnums)(c?.profiles,l));const n=w;w={id:"terminal",order:100,title:(0,i.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:c?.os===3?a?.values:void 0,markdownEnumDescriptions:c?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:c?.os===2?a?.values:void 0,markdownEnumDescriptions:c?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:c?.os===1?a?.values:void 0,markdownEnumDescriptions:c?.os===1?a?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[w],remove:n?[n]:[]})}e.registerTerminalDefaultProfileConfiguration=g}),define(ne[213],ie([0,1,45,48,9,4,20,70,209,95]),function(Q,e,L,i,k,_,T,D,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let P,E=!0;function f(a,n,t,s,o=process.env,u,d,m,I){return u=u||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},_.isWindows?p(t,u,o,d,s.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:s.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:s.getValue("terminal.integrated.defaultProfile.windows"),I,m):c(u,d,t,a&&typeof a=="object"?{...a}:s.getValue(_.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:s.getValue(_.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),I,m,o)}e.detectAvailableProfiles=f;async function p(a,n,t,s,o,u,d,m,I){const A=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${A?"Sysnative":"System32"}`;let N=!1;(0,C.getWindowsBuildNumber)()>=16299&&(N=!0),await v(m);const $=new Map;a&&($.set("PowerShell",{source:"PowerShell",icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),$.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),$.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:i.Codicon.terminalCmd,isAutoDetected:!0})),l(u,$);const R=await h($.entries(),d,n,t,s,I);if(a||!a&&o)try{const M=await w(`${O}\\${N?"wsl":"bash"}.exe`,d);for(const W of M)(!u||!(W.profileName in u))&&R.push(W)}catch{E&&(s?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return R}async function h(a,n,t,s=process.env,o,u){const d=[];for(const[m,I]of a){if(I===null)continue;let A,O,N;if("source"in I){const M=P?.get(I.source);if(!M)continue;A=M.paths,O=I.args||M.args,I.icon?N=S(I.icon):M.icon&&(N=M.icon)}else A=Array.isArray(I.path)?I.path:[I.path],O=_.isWindows||Array.isArray(I.args)?I.args:void 0,N=S(I.icon);const $=await u?.(A)||A.slice(),R=await r(m,n,$,t,s,O,I.env,I.overrideName,I.isAutoDetected,o);R?(R.isAutoDetected=I.isAutoDetected,R.icon=N,R.color=I.color,d.push(R)):o?.trace("profile not validated",m,A)}return d}function S(a){return typeof a=="string"?{id:a}:a}async function v(a){P&&!a||(P=new Map,P.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),P.set("PowerShell",{profileName:"PowerShell",paths:a||await y(),icon:b.ThemeIcon.asThemeIcon(i.Codicon.terminalPowershell)}))}async function y(){const a=[];for await(const n of(0,D.enumeratePowerShellInstallations)())a.push(n.exePath);return a}async function w(a,n){const t=[],s=await new Promise((d,m)=>{L.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(I,A)=>{if(I)return m("Problem occurred when getting wsl distros");d(A)})});if(!s)return[];const o=new RegExp(/[\r?\n]/),u=s.split(o).filter(d=>d.trim().length>0&&d!=="");for(const d of u){if(d===""||d.startsWith("docker-desktop"))continue;const m=`${d} (WSL)`,I={profileName:m,path:a,args:["-d",`${d}`],isDefault:m===n,icon:g(d),isAutoDetected:!1};t.push(I)}return t}function g(a){return a.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(i.Codicon.terminalUbuntu):a.includes("Debian")?b.ThemeIcon.asThemeIcon(i.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(i.Codicon.terminalLinux)}async function c(a,n,t,s,o,u,d,m){const I=new Map;if(t){const A=(await a.readFile("/etc/shells")).toString(),O=u||A.split(`
`).filter($=>$.trim().indexOf("#")!==0&&$.trim().length>0),N=new Map;for(const $ of O){let R=(0,k.basename)($),M=N.get(R)||0;M++,M>1&&(R=`${R} (${M})`),N.set(R,M),I.set(R,{path:$,isAutoDetected:!0})}}return l(s,I),await h(I.entries(),o,a,m,n,d)}function l(a,n){if(!!a)for(const[t,s]of Object.entries(a))s===null||!("path"in s)&&!("source"in s)?n.delete(t):(s.icon=s.icon||n.get(t)?.icon,n.set(t,s))}async function r(a,n,t,s,o,u,d,m,I,A){if(t.length===0)return Promise.resolve(void 0);const O=t.shift();if(O==="")return r(a,n,t,s,o,u,d,m,I);const N={profileName:a,path:O,args:u,env:d,overrideName:m,isAutoDetected:I,isDefault:a===n};if((0,k.basename)(O)===O){const R=o.PATH?o.PATH.split(k.delimiter):void 0;return await(0,C.findExecutable)(O,void 0,R,void 0,s.existsFile)?N:r(a,n,t,s,o,u)}return await s.existsFile((0,k.normalize)(O))?N:r(a,n,t,s,o,u,d,m,I)}}),define(ne[214],ie([0,1,3,2,16,4,36,57,21,13,75,163,10,84,22,207,94,212,213]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h,S,v,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(r){r[r.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let c=0,l=class extends i.Disposable{constructor(a,n,t,s,o){super();this._reconnectConstants=a,this._configurationService=n,this._environmentService=t,this._logService=s,this._telemetryService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new L.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new L.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new L.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new L.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new L.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new L.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new L.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new L.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new L.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new L.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new L.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new L.Emitter),this.onProcessExit=this._onProcessExit.event,(0,y.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,i.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new S.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async u=>{u.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(_.isWindows)return process.env;try{return await(0,E.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(a){return this._logService.error("ptyHost was unable to resolve shell environment",a),{}}}_startPtyHost(){const a={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},n=(0,P.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);n&&(n.break&&n.port?a.debugBrk=n.port:!n.break&&n.port&&(a.debug=n.port));const t=new D.Client(k.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,a);this._onPtyHostStart.fire(),T.ProxyChannel.toService(t.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(d=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(d.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}, giving up`))}));const o=t.getChannel(v.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const u=T.ProxyChannel.toService(t.getChannel(v.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(d=>this._onProcessData.fire(d))),this._register(u.onProcessReady(d=>this._onProcessReady.fire(d))),this._register(u.onProcessExit(d=>this._onProcessExit.fire(d))),this._register(u.onDidChangeProperty(d=>this._onDidChangeProperty.fire(d))),this._register(u.onProcessReplay(d=>this._onProcessReplay.fire(d))),this._register(u.onProcessOrphanQuestion(d=>this._onProcessOrphanQuestion.fire(d))),this._register(u.onDidRequestDetach(d=>this._onDidRequestDetach.fire(d))),[t,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,n,t,s,o,u,d,m,I,A,O){const N=setTimeout(()=>this._handleUnresponsiveCreateProcess(),v.HeartbeatConstants.CreateProcessTimeout),$=await this._proxy.createProcess(a,n,t,s,o,u,d,m,I,A,O);return clearTimeout(N),c=Math.max(c,$),$}updateTitle(a,n,t){return this._proxy.updateTitle(a,n,t)}updateIcon(a,n,t){return this._proxy.updateIcon(a,n,t)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,n){return this._proxy.shutdown(a,n)}input(a,n){return this._proxy.input(a,n)}processBinary(a,n){return this._proxy.processBinary(a,n)}resize(a,n,t){return this._proxy.resize(a,n,t)}acknowledgeDataEvent(a,n){return this._proxy.acknowledgeDataEvent(a,n)}setUnicodeVersion(a,n){return this._proxy.setUnicodeVersion(a,n)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}installAutoReply(a,n){return this._proxy.installAutoReply(a,n)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(a){return this._proxy.uninstallAutoReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,n,t,s=!1){const o=await this._shellEnv;return(0,w.detectAvailableProfiles)(n,t,s,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,n){return this._proxy.requestDetachInstance(a,n)}async acceptDetachInstanceReply(a,n){return this._proxy.acceptDetachInstanceReply(a,n)}async serializeTerminalState(a){return this._proxy.serializeTerminalState(a)}async reviveTerminalProcesses(a,n){return this._proxy.reviveTerminalProcesses(a,n)}async refreshProperty(a,n){return this._proxy.refreshProperty(a,n)}async updateProperty(a,n,t){return this._proxy.updateProperty(a,n,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,n){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:n})}async acceptPtyHostResolvedVariables(a,n){this._resolveVariablesRequestStore.acceptReply(a,n)}};l=de([J(1,C.IConfigurationService),J(2,b.IEnvironmentService),J(3,f.ILogService),J(4,h.ITelemetryService)],l),e.PtyHostService=l}),define(ne[34],ie([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(ne[215],ie([0,1,3,2,7,13,33,14,10,34]),function(Q,e,L,i,k,_,T,D,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let P=class extends i.Disposable{constructor(f,p,h,S,v){super();this.extensionsManagementService=f,this.logService=S,this.uriIdentityService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(w=>this.onInstallExtension(w))),this._register(f.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(f.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const y=k.URI.file(h.extensionsPath);this._register(p.watch(y)),this._register(L.Event.filter(p.onDidChangeFilesRaw,w=>w.changes.some(g=>this.doesChangeAffects(g,y)))(()=>this.onDidChange()))}doesChangeAffects(f,p){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(f.resource),p)?this.uriIdentityService.extUri.isEqual(f.resource,this.uriIdentityService.extUri.joinPath(p,".obsolete"))?!0:!(f.type!==1&&f.type!==2||this.uriIdentityService.extUri.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const p of f)this.removeInstallingExtension(p.identifier),p.local&&this.addInstalledExtension(p.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(p=>!(0,T.areSameExtensions)(p,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(p=>!(0,T.areSameExtensions)(p,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),p=f.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,T.areSameExtensions)(v,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),h=this.installedExtensions.filter(S=>this.installingExtensions.some(v=>(0,T.areSameExtensions)(v,S))?!1:f.every(v=>!(0,T.areSameExtensions)(v.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=f.map(S=>S.identifier),(p.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:p,removed:h})}}};P=de([J(1,D.IFileService),J(2,_.INativeEnvironmentService),J(3,C.ILogService),J(4,b.IUriIdentityService)],P),e.ExtensionsWatcher=P}),define(ne[216],ie([0,1,34,77,14,19,101,3,2]),function(Q,e,L,i,k,_,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class b{constructor(f){this.uri=f,this.time=b._clock++}touch(){return this.time=b._clock++,this}}b._clock=0;let P=class{constructor(f){this._fileService=f,this._dispooables=new C.DisposableStore,this._limit=2**16;const p=new Map,h=S=>{let v=p.get(S.scheme);return v===void 0&&(v=f.hasProvider(S)&&!this._fileService.hasCapability(S,1024),p.set(S.scheme,v)),v};this._dispooables.add(D.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(S=>{p.delete(S.scheme)})),this.extUri=new _.ExtUri(h),this._canonicalUris=new T.SkipList((S,v)=>this.extUri.compare(S,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(f){this._fileService.hasProvider(f)&&(f=(0,_.normalizePath)(f));let p=this._canonicalUris.get(f);return p?p.touch().uri.with({fragment:f.fragment}):(this._canonicalUris.set(f,new b(f)),this._checkTrim(),f)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const f=[...this._canonicalUris.entries()].sort((h,S)=>h[1].touch<S[1].touch?1:h[1].touch>S[1].touch?-1:0);b._clock=0,this._canonicalUris.clear();const p=this._limit*.5;for(let h=0;h<p;h++)this._canonicalUris.set(f[h][0],f[h][1].touch())}};P=de([J(0,k.IFileService)],P),e.UriIdentityService=P,(0,i.registerSingleton)(L.IUriIdentityService,P,!0)}),define(ne[217],ie([0,1,3,2,40,39,18]),function(Q,e,L,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class D extends i.Disposable{constructor(b,P,E,f){super();this.fileSystemScheme=b,this.fileSystemProvider=P,this.userDataScheme=E,this.logService=f,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=_.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(p=>this.handleFileChanges(p)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(b,P){this.watchResources.set(b,b);const E=this.fileSystemProvider.watch(this.toFileSystemResource(b),P);return(0,i.toDisposable)(()=>{this.watchResources.delete(b),E.dispose()})}stat(b){return this.fileSystemProvider.stat(this.toFileSystemResource(b))}mkdir(b){return this.fileSystemProvider.mkdir(this.toFileSystemResource(b))}rename(b,P,E){return this.fileSystemProvider.rename(this.toFileSystemResource(b),this.toFileSystemResource(P),E)}readFile(b){return this.fileSystemProvider.readFile(this.toFileSystemResource(b),{atomic:!0})}readFileStream(b,P,E){const f=(0,k.newWriteableStream)(p=>T.VSBuffer.concat(p.map(h=>T.VSBuffer.wrap(h))).buffer);return(async()=>{try{const p=await this.readFile(b);f.end(p)}catch(p){f.error(p),f.end()}})(),f}readdir(b){return this.fileSystemProvider.readdir(this.toFileSystemResource(b))}writeFile(b,P,E){return this.fileSystemProvider.writeFile(this.toFileSystemResource(b),P,E)}delete(b,P){return this.fileSystemProvider.delete(this.toFileSystemResource(b),P)}handleFileChanges(b){const P=[];for(const E of b){const f=this.toUserDataResource(E.resource);this.watchResources.findSubstr(f)&&P.push({resource:f,type:E.type})}P.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(P))}toFileSystemResource(b){return b.with({scheme:this.fileSystemScheme})}toUserDataResource(b){return b.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=D}),define(ne[52],ie([0,1,68]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function i(T,D,C,b){const P=(0,L.setProperty)(T,D,C,b)[0];return P&&(T=T.substring(0,P.offset)+P.content+T.substring(P.offset+P.length)),T}e.edit=i;function k(T,D,C){let b=C;for(;b>=0;){if(T.charAt(b)===D.charAt(D.length-1)&&D.length===1)return b+1;if(b--,D.length===2&&b>=0&&T.charAt(b)===D.charAt(0))return b+2}return 0}e.getLineStartOffset=k;function _(T,D,C){let b=C;for(;b>=0;)if(T.charAt(b)===D.charAt(D.length-1)&&D.length===1||(b++,D.length===2&&b>=0&&T.charAt(b)===D.charAt(1)))return b;return T.length-1}e.getLineEndOffset=_}),define(ne[218],ie([0,1,28,61,15]),function(Q,e,L,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function _(f,p,h,S,v){const y=[],w=[],g=[];if(!p){const O=f.filter(({identifier:N})=>v.every($=>$.toLowerCase()!==N.id.toLowerCase()));return{local:{added:y,removed:w,updated:g},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}f=f.map(P),p=p.map(P),h=h?h.map(P):null;const c=new Map,l=O=>{O.uuid&&c.set(O.id.toLowerCase(),O.uuid)};f.forEach(({identifier:O})=>l(O)),p.forEach(({identifier:O})=>l(O)),h&&h.forEach(({identifier:O})=>l(O));const r=O=>{const N=O.identifier.uuid||c.get(O.identifier.id.toLowerCase());return N?`uuid:${N}`:`id:${O.identifier.id.toLowerCase()}`},a=(O,N)=>(O.set(r(N),N),O),n=f.reduce(a,new Map),t=p.reduce(a,new Map),s=p.reduce((O,N)=>{const $=r(N);N=(0,L.deepClone)(N);const R=n.get($);return R&&(R.installed&&(N.installed=!0),N.version||(N.version=R.version)),a(O,N)},new Map),o=h?h.reduce(a,new Map):null,u=S.reduce(a,new Map),d=v.reduce((O,N)=>{const $=c.get(N.toLowerCase());return O.add($?`uuid:${$}`:`id:${N.toLowerCase()}`)},new Set),m=T(n,t,d);if(m.added.size>0||m.removed.size>0||m.updated.size>0){const O=T(o,n,d),N=T(o,t,d),$=(R,M)=>{const W=n.get(R);if(W){const U=t.get(R),x=M?U:W;return{...x,version:(U.version&&i.gt(U.version,W.version),W.version),state:D(W,U,o?.get(R)),preRelease:(0,k.isUndefined)(x.preRelease)?W.preRelease:x.preRelease}}};for(const R of N.removed.values()){const M=n.get(R);M&&w.push(M.identifier)}for(const R of N.added.values())if(O.added.has(R)){if(m.updated.has(R)){const M=$(R,!0);M&&(g.push(E(M,R)),s.set(R,M))}}else{const M=t.get(R);M.installed&&y.push(E(M,R))}for(const R of N.updated.values()){const M=$(R,!0);M&&(g.push(E(M,R)),s.set(R,M))}for(const R of O.added.values())N.added.has(R)||s.set(R,n.get(R));for(const R of O.updated.values())if(!N.removed.has(R)&&!N.updated.has(R)){const M=$(R,!1);M&&(s.get(R)?.installed&&(M.installed=!0),s.set(R,M))}for(const R of O.removed.values())!u.has(R)&&!N.updated.has(R)&&o?.get(R)?.installed&&s.delete(R)}const I=[],A=T(t,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(A.added.size>0||A.updated.size>0||A.removed.size>0)&&s.forEach((O,N)=>I.push(E(O,N))),{local:{added:y,removed:w,updated:g},remote:I.length?{added:[...A.added].map(O=>s.get(O)),updated:[...A.updated].map(O=>s.get(O)),removed:[...A.removed].map(O=>t.get(O)),all:I}:null}}e.merge=_;function T(f,p,h,{checkInstalledProperty:S,checkVersionProperty:v}={checkInstalledProperty:!1,checkVersionProperty:!1}){const y=f?[...f.keys()].filter(r=>!h.has(r)):[],w=[...p.keys()].filter(r=>!h.has(r)),g=w.filter(r=>y.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),c=y.filter(r=>w.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),l=new Set;for(const r of y){if(c.has(r))continue;const a=f.get(r),n=p.get(r);(!n||a.disabled!==n.disabled||a.preRelease!==n.preRelease||!b(a.state,n.state)||v&&a.version!==n.version||S&&a.installed!==n.installed)&&l.add(r)}return{added:g,removed:c,updated:l}}function D(f,p,h){const S=f.state,v=p.state,y=h?.state;if(!p.version||S&&i.gt(f.version,p.version))return S;if(v&&i.gt(p.version,f.version)||!S)return v;if(!v)return S;const w=(0,L.deepClone)(S),g=y?C(y,v):{added:Object.keys(v).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set},c=y?C(y,S):{added:Object.keys(S).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set};for(const l of[...g.added.values(),...g.updated.values()])w[l]=v[l];for(const l of g.removed.values())c.updated.has(l)||delete w[l];return w}function C(f,p){const h=Object.keys(f),S=Object.keys(p),v=S.filter(g=>h.indexOf(g)===-1).reduce((g,c)=>(g.add(c),g),new Set),y=h.filter(g=>S.indexOf(g)===-1).reduce((g,c)=>(g.add(c),g),new Set),w=new Set;for(const g of h){if(y.has(g))continue;const c=f[g],l=p[g];(0,L.equals)(c,l)||w.add(g)}return{added:v,removed:y,updated:w}}function b(f={},p={}){const{added:h,removed:S,updated:v}=C(f,p);return h.size===0&&S.size===0&&v.size===0}function P(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function E(f,p){const h={identifier:{id:f.identifier.id,uuid:p.startsWith("uuid:")?p.substring("uuid:".length):void 0},preRelease:!!f.preRelease};return f.version&&(h.version=f.version),f.disabled&&(h.disabled=!0),f.installed&&(h.installed=!0),f.state&&(h.state=f.state),h}}),define(ne[96],ie([0,1,17,3,2,33,6,26,23]),function(Q,e,L,i,k,_,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,T.createDecorator)("IExtensionsStorageSyncService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let P=class it extends k.Disposable{constructor(f,p){super();this.storageService=f,this.productService=p,this._onDidChangeExtensionsStorage=this._register(new i.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(f){return`extensionKeys/${(0,_.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static fromKey(f){const p=b.exec(f);if(p&&p[1])return{id:p[1],version:p[2]}}initialize(){const f=this.storageService.keys(0,1);for(const p of f){const h=it.fromKey(p);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(f){if(f.scope!==0)return;if(this.extensionsWithKeysForSync.has(f.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const p=it.fromKey(f.key);if(p){this.extensionsWithKeysForSync.add(p.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(f,p){this.storageService.store(it.toKey(f),JSON.stringify(p),0,1)}getKeysForSync(f){const p=this.productService.extensionSyncedKeys?.[f.id.toLowerCase()],h=this.storageService.get(it.toKey(f),0),S=h?JSON.parse(h):void 0;return S&&p?(0,L.distinct)([...S,...p]):S||p}};P=de([J(0,C.IStorageService),J(1,D.IProductService)],P),e.ExtensionsStorageSyncService=P}),define(ne[97],ie([0,1,17,21,6]),function(Q,e,L,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,k.createDecorator)("IIgnoredExtensionsManagementService");let _=class{constructor(D){this.configurationService=D}hasToNeverSyncExtension(D){return this.getConfiguredIgnoredExtensions().includes(D.toLowerCase())}hasToAlwaysSyncExtension(D){return this.getConfiguredIgnoredExtensions().includes(`-${D.toLowerCase()}`)}updateIgnoredExtensions(D,C){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return b=b.filter(P=>P!==D&&P!==`-${D}`),C&&b.push(D.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}updateSynchronizedExtensions(D,C){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return b=b.filter(P=>P!==D&&P!==`-${D}`),C&&b.push(`-${D.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}getIgnoredExtensions(D){const C=D.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),b=this.getConfiguredIgnoredExtensions().map(f=>f.toLowerCase()),P=[],E=[];if(Array.isArray(b))for(const f of b)f.startsWith("-")?E.push(f.substring(1)):P.push(f);return(0,L.distinct)([...C,...P].filter(f=>E.indexOf(f)===-1))}getConfiguredIgnoredExtensions(){let D=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return D!==void 0||(D=this.configurationService.inspect("sync.ignoredExtensions").userValue,D!==void 0)?D:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};_=de([J(0,i.IConfigurationService)],_),e.IgnoredExtensionsManagementService=_}),define(ne[219],ie([0,1,17,35,28,158,52]),function(Q,e,L,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function D(c){return(0,i.parse)(c)||[]}e.parseKeybindings=D;async function C(c,l,r,a,n){const t=D(c),s=D(l),o=r?D(r):null,u=[...t,...s,...o||[]].map(U=>U.key),d=await n.resolveUserBindings(u);let m=P(t,s,o,d);if(!m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!m.hasLocalForwarded&&m.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const I=f(t),A=f(s),O=o?f(o):null,N=h(I,A,d),$=O?h(O,I,d):{added:[...I.keys()].reduce((U,x)=>(U.add(x),U),new Set),removed:new Set,updated:new Set},R=O?h(O,A,d):{added:[...A.keys()].reduce((U,x)=>(U.add(x),U),new Set),removed:new Set,updated:new Set},M=b(N,$,R);let W=c;for(const U of M.removed.values())M.conflicts.has(U)||(W=w(W,U,a));for(const U of M.added.values()){if(M.conflicts.has(U))continue;const x=A.get(U);if(x.some(ee=>ee.command!==`-${U}`&&m.conflicts.has(d[ee.key]))){M.conflicts.add(U);continue}W=y(W,x,a)}for(const U of M.updated.values()){if(M.conflicts.has(U))continue;const x=A.get(U);if(x.some(ee=>ee.command!==`-${U}`&&m.conflicts.has(d[ee.key]))){M.conflicts.add(U);continue}W=g(W,U,x,a)}return{mergeContent:W,hasChanges:!0,hasConflicts:M.conflicts.size>0}}e.merge=C;function b(c,l,r){const a=new Set,n=new Set,t=new Set,s=new Set;for(const o of l.removed.values())r.updated.has(o)&&s.add(o);for(const o of r.removed.values())s.has(o)||(l.updated.has(o)?s.add(o):n.add(o));for(const o of l.added.values())s.has(o)||r.added.has(o)&&c.updated.has(o)&&s.add(o);for(const o of r.added.values())s.has(o)||(l.added.has(o)?c.updated.has(o)&&s.add(o):a.add(o));for(const o of l.updated.values())s.has(o)||r.updated.has(o)&&c.updated.has(o)&&s.add(o);for(const o of r.updated.values())s.has(o)||(l.updated.has(o)?c.updated.has(o)&&s.add(o):t.add(o));return{added:a,removed:n,updated:t,conflicts:s}}function P(c,l,r,a){const n=new Set,t=E(c,a),s=E(l,a),o=r?E(r,a):null,u=p(t,s);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const d=o?p(o,t):{added:[...t.keys()].reduce(($,R)=>($.add(R),$),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const m=o?p(o,s):{added:[...s.keys()].reduce(($,R)=>($.add(R),$),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:I,removed:A,updated:O,conflicts:N}=b(u,d,m);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:I,removed:A,updated:O,conflicts:N}}function E(c,l){const r=new Map;for(const a of c){const n=l[a.key];let t=r.get(n);t||(t=[],r.set(n,t)),t.push(a)}return r}function f(c){const l=new Map;for(const r of c){const a=r.command[0]==="-"?r.command.substring(1):r.command;let n=l.get(a);n||(n=[],l.set(a,n)),n.push(r)}return l}function p(c,l){const r=[...c.keys()],a=[...l.keys()],n=a.filter(o=>r.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),t=r.filter(o=>a.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),s=new Set;for(const o of r){if(t.has(o))continue;const u=c.get(o).map(m=>({...m,key:o})),d=l.get(o).map(m=>({...m,key:o}));(0,L.equals)(u,d,(m,I)=>v(m,I))||s.add(o)}return{added:n,removed:t,updated:s}}function h(c,l,r){const a=[...c.keys()],n=[...l.keys()],t=n.filter(u=>a.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),s=a.filter(u=>n.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),o=new Set;for(const u of a){if(s.has(u))continue;const d=c.get(u).map(I=>({...I,key:r[I.key]})),m=l.get(u).map(I=>({...I,key:r[I.key]}));S(d,m)||o.add(u)}return{added:t,removed:s,updated:o}}function S(c,l){return!(!(0,L.equals)(c.filter(({command:r})=>r[0]!=="-"),l.filter(({command:r})=>r[0]!=="-"),(r,a)=>v(r,a))||!(0,L.equals)(c.filter(({command:r})=>r[0]==="-"),l.filter(({command:r})=>r[0]==="-"),(r,a)=>v(r,a)))}function v(c,l){if(c.command!==l.command||c.key!==l.key)return!1;const r=_.ContextKeyExpr.deserialize(c.when),a=_.ContextKeyExpr.deserialize(l.when);return!(r&&!a||!r&&a||r&&a&&!r.equals(a)||!k.equals(c.args,l.args))}function y(c,l,r){for(const a of l)c=T.edit(c,[-1],a,r);return c}function w(c,l,r){const a=D(c);for(let n=a.length-1;n>=0;n--)(a[n].command===l||a[n].command===`-${l}`)&&(c=T.edit(c,[n],void 0,r));return c}function g(c,l,r,a){const n=D(c),t=n.findIndex(s=>s.command===l||s.command===`-${l}`);for(let s=n.length-1;s>=0;s--)(n[s].command===l||n[s].command===`-${l}`)&&(c=T.edit(c,[s],void 0,a));for(let s=r.length-1;s>=0;s--)c=T.edit(c,[t],r[s],a);return c}}),define(ne[220],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function L(_,T,D){const C={},b={},P=new Set;if(!T)return{local:{added:C,updated:b,removed:[...P.values()]},remote:{added:_,updated:{},removed:[]},conflicts:[]};const E=i(_,T);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:C,updated:b,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=i(D,_),p=i(D,T),h={},S={},v=new Set,y=new Set;for(const w of f.removed.values())p.updated.has(w)?C[w]=T[w]:v.add(w);for(const w of p.removed.values())y.has(w)||(f.updated.has(w)?y.add(w):P.add(w));for(const w of f.updated.values())y.has(w)||(p.updated.has(w)?E.updated.has(w)&&y.add(w):S[w]=_[w]);for(const w of p.updated.values())y.has(w)||(f.updated.has(w)?E.updated.has(w)&&y.add(w):_[w]!==void 0&&(b[w]=T[w]));for(const w of f.added.values())y.has(w)||(p.added.has(w)?E.updated.has(w)&&y.add(w):h[w]=_[w]);for(const w of p.added.values())y.has(w)||(f.added.has(w)?E.updated.has(w)&&y.add(w):C[w]=T[w]);return{local:{added:C,removed:[...P.values()],updated:b},remote:{added:h,removed:[...v.values()],updated:S},conflicts:[...y.values()]}}e.merge=L;function i(_,T){const D=_?Object.keys(_):[],C=T?Object.keys(T):[],b=C.filter(f=>D.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),P=D.filter(f=>C.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),E=new Set;for(const f of D){if(P.has(f))continue;const p=_[f],h=T[f];p!==h&&E.add(f)}return{added:b,removed:P,updated:E}}function k(_,T){const{added:D,removed:C,updated:b}=i(_,T);return D.size===0&&C.size===0&&b.size===0}e.areSame=k}),define(ne[24],ie([0,1,17,19,15,146,42,29,6,86,38]),function(Q,e,L,i,k,_,T,D,C,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function E(){const o=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(u=>!!o[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=E;function f(){const o=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(o).filter(I=>!!o[I].ignoreSync),d=Object.keys(o).filter(I=>o[I].scope===2||o[I].scope===6),m=E();return(0,L.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...d,...m])}e.getDefaultIgnoredSettings=f,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function p(){const o="vscode://schemas/ignoredSettings",u=P.Registry.as(T.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,_.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,_.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,_.localize)(2,null),items:[{type:"string",pattern:D.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,_.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,_.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const d=P.Registry.as(b.Extensions.JSONContribution),m=()=>{const I=E(),A=f().filter(R=>R!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(T.allSettings.properties).filter(R=>A.indexOf(R)===-1),N=A.filter(R=>I.indexOf(R)===-1),$={items:{type:"string",enum:[...O,...N.map(R=>`-${R}`)]}};d.registerSchema(o,$)};return u.onDidUpdateConfiguration(()=>m())}e.registerConfiguration=p;function h(o){return o&&(0,k.isObject)(o)&&(0,k.isString)(o.id)&&(0,k.isArray)(o.scopes)}e.isAuthenticationProvider=h;var S;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Extensions="extensions",o.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function v(o,u,d){return d.joinPath(u.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=v,e.IUserDataSyncStoreManagementService=(0,C.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,C.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,C.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function y(o){const u={};return u[e.HEADER_EXECUTION_ID]=o,u}e.createSyncHeaders=y;var w;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(w=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class g extends Error{constructor(u,d,m,I){super(u);this.code=d,this.resource=m,this.operationId=I,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=g;class c extends g{constructor(u,d,m,I,A){super(u,m,void 0,A);this.url=d,this.serverCode=I}}e.UserDataSyncStoreError=c;class l extends g{constructor(u,d){super(u,d)}}e.UserDataAutoSyncError=l,function(o){function u(d){if(d instanceof o)return d;const m=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(d.name);if(m&&m[1]){const I=m[2]==="unknown"?void 0:m[2],A=m[3]==="unknown"?void 0:m[3];return new o(d.message,m[1],I,A)}return new o(d.message,"Unknown")}o.toUserDataSyncError=u}(g=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var a;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(a=e.Change||(e.Change={}));var n;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(o){return`sync.enable.${o}`}e.getEnablementKey=t,e.IUserDataSyncEnablementService=(0,C.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,C.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,C.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,C.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,C.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function s(o,u){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(d=>(0,i.isEqualOrParent)(o,(0,i.joinPath)(u.userDataSyncHome,d,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=s}),define(ne[47],ie([0,1,17,5,18,27,3,35,2,25,15,7,142,21,13,14,10,46,23,22,34,24]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h,S,v,y,w,g,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&(Object.keys(o).length===2||Object.keys(o).length===3&&o.machineId!==void 0&&typeof o.machineId=="string"))}e.isSyncData=r;let a=class extends C.Disposable{constructor(u,d,m,I,A,O,N,$,R,M,W){super();this.resource=u,this.fileService=d,this.environmentService=m,this.userDataSyncStoreService=A,this.userDataSyncBackupStoreService=O,this.userDataSyncEnablementService=N,this.telemetryService=$,this.logService=R,this.configurationService=M,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new i.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,b.uppercaseFirstLetter)(this.resource),this.extUri=W.extUri,this.syncFolder=this.extUri.joinPath(m.userDataSyncHome,u),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(u,m,this.extUri),this.currentMachineIdPromise=(0,y.getServiceMachineId)(m,d,I)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const u=await this.syncPreviewPromise;this.syncPreviewPromise=null;const d=await this.performSync(u.remoteUserData,u.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(d)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const u=await this.getLastSyncUserData();(u?await this.hasRemoteChanged(u):!0)&&this._onDidChangeLocal.fire()}}setStatus(u){if(this._status!==u){const d=this._status;u==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),d==="hasConflicts"&&u==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=u,this._onDidChangStatus.fire(u)}}async sync(u,d={}){await this._sync(u,!0,this.getUserDataSyncConfiguration(),d)}async preview(u,d,m={}){return this._sync(u,!1,d,m)}async apply(u,d={}){try{this.syncHeaders={...d};const m=await this.doApply(u);return this.setStatus(m),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(u,d,m,I){try{if(this.syncHeaders={...I},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let A="idle";try{const O=await this.getLastSyncUserData(),N=await this.getLatestRemoteUserData(u,O);return A=await this.performSync(N,O,d,m),A==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):A==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(A)}}finally{this.syncHeaders={}}}async replace(u){const d=await this.resolveContent(u);if(!d)return!1;const m=this.parseSyncData(d);if(!m)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const I=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(null,I),O=await this.isRemoteDataFromCurrentMachine(A),N=await this.generateSyncPreview({ref:A.ref,syncData:m},I,O,this.getUserDataSyncConfiguration(),_.CancellationToken.None),$=[];for(const R of N){const M=await this.getAcceptResult(R,R.remoteResource,void 0,_.CancellationToken.None),{remoteChange:W}=await this.getAcceptResult(R,R.previewResource,R.remoteContent,_.CancellationToken.None);$.push([R,{...M,remoteChange:W!==0?W:2}])}await this.applyResult(A,I,$,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(u){const d=await this.currentMachineIdPromise;return!!u.syncData?.machineId&&u.syncData.machineId===d}async getLatestRemoteUserData(u,d){if(d){const m=u&&u.latest?u.latest[this.resource]:void 0;if(d.ref===m||m===void 0&&d.syncData===null)return d}return this.getRemoteUserData(d)}async performSync(u,d,m,I){if(u.syncData&&u.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,f.localize)(0,null,this.resource,this.version,u.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(u,d,m,I)}catch(A){if(A instanceof l.UserDataSyncError)switch(A.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(u,d,m,I);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),u=await this.getRemoteUserData(null),d=await this.getLastSyncUserData(),this.performSync(u,d,m,I)}throw A}}async doSync(u,d,m,I){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,i.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(u,d,m,I,O)));const A=await this.syncPreviewPromise;return this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":m?await this.doApply(!1):"syncing"}catch(A){throw this.syncPreviewPromise=null,A}}async merge(u){return await this.updateSyncResourcePreview(u,async d=>{const m=await this.getMergeResult(d,_.CancellationToken.None);await this.fileService.writeFile(d.previewResource,k.VSBuffer.fromString(m?.content||""));const I=m&&!m.hasConflicts?await this.getAcceptResult(d,d.previewResource,void 0,_.CancellationToken.None):void 0;return d.acceptResult=I,d.mergeState=m.hasConflicts?"conflict":I?"accepted":"preview",d.localChange=I?I.localChange:m.localChange,d.remoteChange=I?I.remoteChange:m.remoteChange,d}),this.syncPreviewPromise}async accept(u,d){return await this.updateSyncResourcePreview(u,async m=>{const I=await this.getAcceptResult(m,u,d,_.CancellationToken.None);return m.acceptResult=I,m.mergeState="accepted",m.localChange=I.localChange,m.remoteChange=I.remoteChange,m}),this.syncPreviewPromise}async discard(u){return await this.updateSyncResourcePreview(u,async d=>{const m=await this.getMergeResult(d,_.CancellationToken.None);return await this.fileService.writeFile(d.previewResource,k.VSBuffer.fromString(m.content||"")),d.acceptResult=void 0,d.mergeState="preview",d.localChange=m.localChange,d.remoteChange=m.remoteChange,d}),this.syncPreviewPromise}async updateSyncResourcePreview(u,d){if(!this.syncPreviewPromise)return;let m=await this.syncPreviewPromise;const I=m.resourcePreviews.findIndex(({localResource:A,remoteResource:O,previewResource:N})=>this.extUri.isEqual(A,u)||this.extUri.isEqual(O,u)||this.extUri.isEqual(N,u));I!==-1&&(this.syncPreviewPromise=(0,i.createCancelablePromise)(async A=>{const O=[...m.resourcePreviews];return O[I]=await d(O[I]),{...m,resourcePreviews:O}}),m=await this.syncPreviewPromise,this.updateConflicts(m.resourcePreviews),m.resourcePreviews.some(({mergeState:A})=>A==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(u){if(!this.syncPreviewPromise)return"idle";const d=await this.syncPreviewPromise;return d.resourcePreviews.some(({mergeState:m})=>m==="conflict")?"hasConflicts":d.resourcePreviews.some(({mergeState:m})=>m!=="accepted")?"syncing":(await this.applyResult(d.remoteUserData,d.lastSyncUserData,d.resourcePreviews.map(m=>[m,m.acceptResult]),u),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(u){const d=u.filter(({mergeState:m})=>m==="conflict");(0,L.equals)(this._conflicts,d,(m,I)=>this.extUri.isEqual(m.previewResource,I.previewResource))||(this._conflicts=d,this._onDidChangeConflicts.fire(d))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:d,ref:m})=>({created:d,uri:this.toRemoteBackupResource(m)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:d,ref:m})=>({created:d,uri:this.toLocalBackupResource(m)}))}toRemoteBackupResource(u){return E.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${u}`})}toLocalBackupResource(u){return E.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${u}`})}async getMachineId({uri:u}){const d=this.extUri.basename(u);if(this.extUri.isEqual(u,this.toRemoteBackupResource(d))){const{content:m}=await this.getUserData(d);if(m)return this.parseSyncData(m)?.machineId}}async resolveContent(u){const d=this.extUri.basename(u);if(this.extUri.isEqual(u,this.toRemoteBackupResource(d))){const{content:m}=await this.getUserData(d);return m}return this.extUri.isEqual(u,this.toLocalBackupResource(d))?this.userDataSyncBackupStoreService.resolveContent(this.resource,d):null}async resolvePreviewContent(u){const d=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(d)for(const m of d.resourcePreviews){if(this.extUri.isEqual(m.acceptedResource,u))return m.acceptResult?m.acceptResult.content:null;if(this.extUri.isEqual(m.remoteResource,u))return m.remoteContent;if(this.extUri.isEqual(m.localResource,u))return m.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(u,d,m,I,A){const O=await this.isRemoteDataFromCurrentMachine(u),N=await this.generateSyncPreview(u,d,O,I,A),$=[];for(const R of N){const M=R.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(R.localChange===0&&R.remoteChange===0)$.push({...R,acceptedResource:M,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const W=m?await this.getMergeResult(R,A):void 0;if(A.isCancellationRequested)break;await this.fileService.writeFile(R.previewResource,k.VSBuffer.fromString(W?.content||""));const U=W&&!W.hasConflicts?await this.getAcceptResult(R,R.previewResource,void 0,A):void 0;$.push({...R,acceptResult:U,mergeState:W?.hasConflicts?"conflict":U?"accepted":"preview",localChange:U?U.localChange:W?W.localChange:R.localChange,remoteChange:U?U.remoteChange:W?W.remoteChange:R.remoteChange})}}return{remoteUserData:u,lastSyncUserData:d,resourcePreviews:$,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const u=await this.fileService.readFile(this.lastSyncResource),d=JSON.parse(u.value.toString()),m=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=d.version&&m&&d.version!==m,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${d.version} is not compatible with current sync state version ${m}.`),await this.resetLocal(),null;const I=d;if(I.content===null)return{ref:d.ref,syncData:null};const A=JSON.parse(I.content);if(r(A))return{...d,syncData:A,content:void 0}}catch(u){u instanceof S.FileOperationError&&u.fileOperationResult===1||this.logService.error(u)}return null}async updateLastSyncUserData(u,d={}){if(d.ref||d.content||d.version)throw new Error("Cannot have core properties as additional");const m=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),I={ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null,version:m,...d};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(I)))}async getRemoteUserData(u){const{ref:d,content:m}=await this.getUserData(u);let I=null;return m!==null&&(I=this.parseSyncData(m)),{ref:d,syncData:I}}parseSyncData(u){try{const d=JSON.parse(u);if(r(d))return d}catch(d){this.logService.error(d)}throw new l.UserDataSyncError((0,f.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(u){if((0,P.isString)(u)){const d=await this.userDataSyncStoreService.resolveContent(this.resource,u);return{ref:u,content:d}}else{const d=u?{ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,d,this.syncHeaders)}}async updateRemoteUserData(u,d){const m=await this.currentMachineIdPromise,I={version:this.version,machineId:m,content:u};return d=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(I),d,this.syncHeaders),{ref:d,syncData:I}}async backupLocal(u){const d={version:this.version,content:u};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(d))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};a=de([J(1,S.IFileService),J(2,h.IEnvironmentService),J(3,w.IStorageService),J(4,l.IUserDataSyncStoreService),J(5,l.IUserDataSyncBackupStoreService),J(6,l.IUserDataSyncEnablementService),J(7,g.ITelemetryService),J(8,l.IUserDataSyncLogService),J(9,p.IConfigurationService),J(10,c.IUriIdentityService)],a),e.AbstractSynchroniser=a;let n=class extends a{constructor(u,d,m,I,A,O,N,$,R,M,W,U){super(d,m,I,A,O,N,$,R,M,W,U);this.file=u,this._register(this.fileService.watch(this.extUri.dirname(u))),this._register(this.fileService.onDidFilesChange(x=>this.onFileChanges(x)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(u,d,m){try{d?await this.fileService.writeFile(this.file,k.VSBuffer.fromString(u),m?void 0:d):await this.fileService.createFile(this.file,k.VSBuffer.fromString(u),{overwrite:m})}catch(I){throw I instanceof S.FileOperationError&&I.fileOperationResult===1||I instanceof S.FileOperationError&&I.fileOperationResult===3?new l.UserDataSyncError(I.message,"LocalPreconditionFailed"):I}}onFileChanges(u){!u.contains(this.file)||this.triggerLocalChange()}};n=de([J(2,S.IFileService),J(3,h.IEnvironmentService),J(4,w.IStorageService),J(5,l.IUserDataSyncStoreService),J(6,l.IUserDataSyncBackupStoreService),J(7,l.IUserDataSyncEnablementService),J(8,g.ITelemetryService),J(9,l.IUserDataSyncLogService),J(10,p.IConfigurationService),J(11,c.IUriIdentityService)],n),e.AbstractFileSynchroniser=n;let t=class extends n{constructor(u,d,m,I,A,O,N,$,R,M,W,U,x){super(u,d,m,I,A,O,N,$,R,M,U,x);this.userDataSyncUtilService=W,this._formattingOptions=void 0}hasErrors(u){const d=[];return(0,D.parse)(u,d,{allowEmptyContent:!0,allowTrailingComma:!0}),d.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=de([J(2,S.IFileService),J(3,h.IEnvironmentService),J(4,w.IStorageService),J(5,l.IUserDataSyncStoreService),J(6,l.IUserDataSyncBackupStoreService),J(7,l.IUserDataSyncEnablementService),J(8,g.ITelemetryService),J(9,l.IUserDataSyncLogService),J(10,l.IUserDataSyncUtilService),J(11,p.IConfigurationService),J(12,c.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let s=class{constructor(u,d,m,I,A){this.resource=u,this.environmentService=d,this.logService=m,this.fileService=I,this.extUri=A.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,d,this.extUri)}async initialize({ref:u,content:d}){if(!d){this.logService.info("Remote content does not exist.",this.resource);return}const m=this.parseSyncData(d);if(!!m)try{await this.doInitialize({ref:u,syncData:m})}catch(I){this.logService.error(I)}}parseSyncData(u){try{const d=JSON.parse(u);if(r(d))return d}catch(d){this.logService.error(d)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(u,d={}){const m={ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null,...d};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(m)))}};s=de([J(1,h.IEnvironmentService),J(2,v.ILogService),J(3,S.IFileService),J(4,c.IUriIdentityService)],s),e.AbstractInitializer=s}),define(ne[221],ie([0,1,5,27,8,3,49,25,7,21,13,29,33,14,10,23,22,34,47,218,96,97,24]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h,S,v,y,w,g,c,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function a(u,d){const m=JSON.parse(u.content);if(u.version===1||u.version===2){const I=(await d.getInstalled(0)).filter(A=>A.isBuiltin);for(const A of m)u.version===1&&(A.enabled===!1&&(A.disabled=!0),delete A.enabled),u.version===2&&I.every(O=>!(0,f.areSameExtensions)(O.identifier,A.identifier))&&(A.installed=!0)}return m}function n(u,d,m){const I=m.get((0,f.getExtensionId)(u,d),0)||"{}";return JSON.parse(I)}e.getExtensionStorageState=n;function t(u,d,m,I){I.store((0,f.getExtensionId)(u,d),JSON.stringify(m),0,1)}e.storeExtensionStorageState=t;let s=class mt extends w.AbstractSynchroniser{constructor(d,m,I,A,O,N,$,R,M,W,U,x,ee,G,q){super("extensions",m,d,I,A,O,x,ee,M,U,q);this.storageService=I,this.extensionManagementService=N,this.extensionEnablementService=$,this.ignoredExtensionsManagementService=R,this.extensionGalleryService=W,this.extensionsStorageSyncService=G,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(_.Event.debounce(_.Event.any(_.Event.filter(this.extensionManagementService.onDidInstallExtensions,Y=>Y.some(({local:H})=>!!H)),_.Event.filter(this.extensionManagementService.onDidUninstallExtension,Y=>!Y.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}async generateSyncPreview(d,m){const I=d.syncData?await a(d.syncData,this.extensionManagementService):null,A=m?.skippedExtensions||[],O=m?.syncData?await a(m.syncData,this.extensionManagementService):null,N=await this.extensionManagementService.getInstalled(void 0,!0),$=this.getLocalExtensions(N),R=this.ignoredExtensionsManagementService.getIgnoredExtensions(N);I?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:M,remote:W}=(0,g.merge)($,I,O,A,R),U={local:M,remote:W,content:this.getPreviewContent($,M.added,M.updated,M.removed),localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:W!==null?2:0};return[{skippedExtensions:A,localResource:this.localResource,localContent:this.stringify($,!1),localExtensions:$,remoteResource:this.remoteResource,remoteContent:I?this.stringify(I,!1):null,previewResource:this.previewResource,previewResult:U,localChange:U.localChange,remoteChange:U.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(d){const m=d.syncData?await a(d.syncData,this.extensionManagementService):null,I=await this.extensionManagementService.getInstalled(void 0,!0),A=this.getLocalExtensions(I),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(I),{remote:N}=(0,g.merge)(A,m,m,d.skippedExtensions||[],O);return N!==null}getPreviewContent(d,m,I,A){const O=[...m,...I],N=new Set,$=R=>{N.add(R.id.toLowerCase()),R.uuid&&N.add(R.uuid)};O.forEach(({identifier:R})=>$(R)),A.forEach($);for(const R of d)N.has(R.identifier.id.toLowerCase())||R.identifier.uuid&&N.has(R.identifier.uuid)||O.push(R);return this.stringify(O,!1)}async getMergeResult(d,m){return{...d.previewResult,hasConflicts:!1}}async getAcceptResult(d,m,I,A){if(this.extUri.isEqual(m,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(m,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(m,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${m.toString()}`)}async acceptLocal(d){const m=await this.extensionManagementService.getInstalled(),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(m),A=(0,g.merge)(d.localExtensions,null,null,d.skippedExtensions,I),{local:O,remote:N}=A;return{content:d.localContent,local:O,remote:N,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:N!==null?2:0}}async acceptRemote(d){const m=await this.extensionManagementService.getInstalled(),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(m),A=d.remoteContent?JSON.parse(d.remoteContent):null;if(A!==null){const O=(0,g.merge)(d.localExtensions,A,d.localExtensions,[],I),{local:N,remote:$}=O;return{content:d.remoteContent,local:N,remote:$,localChange:N.added.length>0||N.removed.length>0||N.updated.length>0?2:0,remoteChange:$!==null?2:0}}else return{content:d.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(d,m,I,A){let{skippedExtensions:O,localExtensions:N}=I[0][0],{local:$,remote:R,localChange:M,remoteChange:W}=I[0][1];if(M===0&&W===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),M!==0&&(await this.backupLocal(JSON.stringify(N)),O=await this.updateLocalExtensions($.added,$.removed,$.updated,O)),R){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const U=JSON.stringify(R.all);d=await this.updateRemoteUserData(U,A?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${R.added.length?` Added: ${JSON.stringify(R.added.map(x=>x.identifier.id))}.`:""}${R.updated.length?` Updated: ${JSON.stringify(R.updated.map(x=>x.identifier.id))}.`:""}${R.removed.length?` Removed: ${JSON.stringify(R.removed.map(x=>x.identifier.id))}.`:""}`)}m?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(d,{skippedExtensions:O}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${O.length?` Skipped: ${JSON.stringify(O.map(U=>U.identifier.id))}.`:""}`))}async getAssociatedResources({uri:d}){return[{resource:this.extUri.joinPath(d,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(d){if(this.extUri.isEqual(d,mt.EXTENSIONS_DATA_URI)){const I=await this.extensionManagementService.getInstalled(),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(I),O=this.getLocalExtensions(I).filter(N=>!A.some($=>(0,f.areSameExtensions)({id:$},N.identifier)));return this.stringify(O,!0)}if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d)){const I=await this.resolvePreviewContent(d);return I&&this.stringify(JSON.parse(I),!0)}let m=await super.resolveContent(d);if(m)return m;if(m=await super.resolveContent(this.extUri.dirname(d)),m){const I=this.parseSyncData(m);if(I)switch(this.extUri.basename(d)){case"extensions.json":return this.stringify(this.parseExtensions(I),!0)}}return null}stringify(d,m){return d.sort((I,A)=>!I.identifier.uuid&&A.identifier.uuid?-1:I.identifier.uuid&&!A.identifier.uuid?1:(0,D.compare)(I.identifier.id,A.identifier.id)),m?(0,T.toFormattedString)(d,{}):JSON.stringify(d)}async hasLocalData(){try{const d=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(d).some(I=>I.installed||I.disabled))return!0}catch{}return!1}async updateLocalExtensions(d,m,I,A){const O=[],N=[],$=await this.extensionManagementService.getInstalled();if(m.length){const M=$.filter(({identifier:W,isBuiltin:U})=>!U&&m.some(x=>(0,f.areSameExtensions)(W,x)));await L.Promises.settled(M.map(async W=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,W.identifier.id),await this.extensionManagementService.uninstall(W,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,W.identifier.id),O.push(W.identifier)}))}(d.length||I.length)&&await L.Promises.settled([...d,...I].map(async M=>{const W=$.find(x=>(0,f.areSameExtensions)(x.identifier,M.identifier));if(W&&W.isBuiltin){M.state&&W.manifest.version===M.version&&this.updateExtensionState(M.state,W.manifest.publisher,W.manifest.name,W.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(ee=>(0,f.areSameExtensions)(ee,M.identifier))!==!!M.disabled&&(M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id))),O.push(M.identifier);return}const U=(await this.extensionGalleryService.getExtensions([M.identifier],!!M.preRelease,i.CancellationToken.None))[0];if(M.state&&(W?W.manifest.version===M.version:!!U)){const x=W?W.manifest.publisher:U.publisher,ee=W?W.manifest.name:U.name;this.updateExtensionState(M.state,x,ee,W?.manifest.version)}if(U)try{this.extensionEnablementService.getDisabledExtensions().some(ee=>(0,f.areSameExtensions)(ee,M.identifier))!==!!M.disabled&&(M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id,U.version),await this.extensionEnablementService.disableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id,U.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id,U.version),await this.extensionEnablementService.enableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id,U.version))),(!W||W.preRelease!==M.preRelease)&&(await this.extensionManagementService.canInstall(U)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,M.identifier.id,U.version),await this.extensionManagementService.installFromGallery(U,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:M.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,M.identifier.id,U.version),O.push(U.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),N.push(M)))}catch(x){N.push(M),x instanceof E.ExtensionManagementError&&[E.ExtensionManagementErrorCode.Incompatible,E.ExtensionManagementErrorCode.IncompatiblePreRelease,E.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(x.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,U.displayName||U.identifier.id):(this.logService.error(x),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,U.displayName||U.identifier.id))}else N.push(M),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,M.identifier.id)}));const R=[];for(const M of A)O.some(W=>(0,f.areSameExtensions)(W,M.identifier))||R.push(M);for(const M of N)R.some(W=>(0,f.areSameExtensions)(W.identifier,M.identifier))||R.push(M);return R}updateExtensionState(d,m,I,A){const O=n(m,I,this.storageService),N=A?this.extensionsStorageSyncService.getKeysForSync({id:(0,f.getGalleryExtensionId)(m,I),version:A}):void 0;N?N.forEach($=>{O[$]=d[$]}):Object.keys(d).forEach($=>O[$]=d[$]),t(m,I,O,this.storageService)}parseExtensions(d){return JSON.parse(d.content)}getLocalExtensions(d){const m=this.extensionEnablementService.getDisabledExtensions();return d.map(({identifier:I,isBuiltin:A,manifest:O,preRelease:N})=>{const $={identifier:I,preRelease:N,version:O.version};m.some(R=>(0,f.areSameExtensions)(R,I))&&($.disabled=!0),A||($.installed=!0);try{const R=this.extensionsStorageSyncService.getKeysForSync({id:I.id,version:O.version});if(R){const M=n(O.publisher,O.name,this.storageService);$.state=Object.keys(M).reduce((W,U)=>(R.includes(U)&&(W[U]=M[U]),W),{})}}catch(R){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,k.getErrorMessage)(R))}return $})}};s.EXTENSIONS_DATA_URI=C.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),s=de([J(0,P.IEnvironmentService),J(1,p.IFileService),J(2,S.IStorageService),J(3,r.IUserDataSyncStoreService),J(4,r.IUserDataSyncBackupStoreService),J(5,E.IExtensionManagementService),J(6,E.IGlobalExtensionEnablementService),J(7,l.IIgnoredExtensionsManagementService),J(8,r.IUserDataSyncLogService),J(9,E.IExtensionGalleryService),J(10,b.IConfigurationService),J(11,r.IUserDataSyncEnablementService),J(12,v.ITelemetryService),J(13,c.IExtensionsStorageSyncService),J(14,y.IUriIdentityService)],s),e.ExtensionsSynchroniser=s;let o=class extends w.AbstractInitializer{constructor(d,m,I,A,O,N){super("extensions",A,O,I,N);this.extensionManagementService=d,this.ignoredExtensionsManagementService=m}async parseExtensions(d){return d.syncData?await a(d.syncData,this.extensionManagementService):null}generatePreview(d,m){const I=[],A=[],O=[];for(const N of d){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(N.identifier.id))continue;const $=m.find(R=>(0,f.areSameExtensions)(R.identifier,N.identifier));$?(I.push($),N.disabled&&O.push(N.identifier)):N.installed&&(A.push(N.identifier),N.disabled&&O.push(N.identifier))}return{installedExtensions:I,newExtensions:A,disabledExtensions:O,remoteExtensions:d}}};o=de([J(0,E.IExtensionManagementService),J(1,l.IIgnoredExtensionsManagementService),J(2,p.IFileService),J(3,P.IEnvironmentService),J(4,h.ILogService),J(5,y.IUriIdentityService)],o),e.AbstractExtensionsInitializer=o}),define(ne[222],ie([0,1,28,24]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(D,C,b,P,E){if(!C)return{remote:Object.keys(D).length>0?D:null,local:{added:{},removed:[],updated:{}}};const f=_(D,C);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const p=b?_(b,C):{added:Object.keys(C).reduce((w,g)=>(w.add(g),w),new Set),removed:new Set,updated:new Set},h=b?_(b,D):{added:Object.keys(D).reduce((w,g)=>(w.add(g),w),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},v=L.deepClone(C),y=!b;for(const w of h.added.values())w!==i.SYNC_SERVICE_URL_TYPE&&y&&p.added.has(w)||(v[w]=D[w]);for(const w of h.updated.values())v[w]=D[w];for(const w of h.removed.values())P.unregistered.includes(w)||delete v[w];for(const w of p.added.values()){const g=C[w];if(P.machine.includes(w)){E.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(b&&h.added.has(w))continue;const c=D[w];c&&c.value===g.value||w===i.SYNC_SERVICE_URL_TYPE&&y&&h.added.has(w)||(c?S.updated[w]=g:S.added[w]=g)}for(const w of p.updated.values()){const g=C[w];if(P.machine.includes(w)){E.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(w)||h.removed.has(w))continue;const c=D[w];c&&c.value===g.value||(S.updated[w]=g)}for(const w of p.removed.values()){if(P.machine.includes(w)){E.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}h.updated.has(w)||h.removed.has(w)||S.removed.push(w)}return{local:S,remote:T(v,C)?null:v}}e.merge=k;function _(D,C){const b=Object.keys(D),P=Object.keys(C),E=P.filter(h=>b.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),f=b.filter(h=>P.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),p=new Set;for(const h of b){if(f.has(h))continue;const S=D[h],v=C[h];L.equals(S,v)||p.add(h)}return{added:E,removed:f,updated:p}}function T(D,C){const{added:b,removed:P,updated:E}=_(D,C);return b.size===0&&P.size===0&&E.size===0}}),define(ne[223],ie([0,1,18,8,3,35,49,4,7,30,21,13,14,10,46,23,22,34,47,52,222,24]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h,S,v,y,w,g,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",a=["locale"];function n(d,m){const I=d.storage?Object.keys(d.storage).sort():[],A={};return I.forEach(O=>A[O]=d.storage[O]),d.storage=A,m?(0,T.toFormattedString)(d,{}):JSON.stringify(d)}const t=1;let s=class vt extends w.AbstractSynchroniser{constructor(m,I,A,O,N,$,R,M,W,U){super("globalState",m,N,W,I,A,$,R,O,M,U);this.storageService=W,this.version=t,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(m.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(k.Event.any(k.Event.filter(m.onDidFilesChange,x=>x.contains(this.environmentService.argvResource)),k.Event.filter(W.onDidChangeValue,x=>x.scope===0&&x.target!==void 0?x.target===0:W.keys(0,0).includes(x.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(m,I,A){const O=m.syncData?JSON.parse(m.syncData.content):null;I=I===null&&A?m:I;const N=I&&I.syncData?JSON.parse(I.syncData.content):null,$=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const R=this.getStorageKeys(N),{local:M,remote:W}=(0,c.merge)($.storage,O?O.storage:null,N?N.storage:null,R,this.logService),U={content:null,local:M,remote:W,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:W!==null?2:0};return[{localResource:this.localResource,localContent:n($,!1),localUserData:$,remoteResource:this.remoteResource,remoteContent:O?n(O,!1):null,previewResource:this.previewResource,previewResult:U,localChange:U.localChange,remoteChange:U.remoteChange,acceptedResource:this.acceptedResource,storageKeys:R}]}async hasRemoteChanged(m){const I=m.syncData?JSON.parse(m.syncData.content):null;if(I===null)return!0;const A=await this.getLocalGlobalState(),O=this.getStorageKeys(I),{remote:N}=(0,c.merge)(A.storage,I.storage,I.storage,O,this.logService);return N!==null}async getMergeResult(m,I){return{...m.previewResult,hasConflicts:!1}}async getAcceptResult(m,I,A,O){if(this.extUri.isEqual(I,this.localResource))return this.acceptLocal(m);if(this.extUri.isEqual(I,this.remoteResource))return this.acceptRemote(m);if(this.extUri.isEqual(I,this.previewResource))return m.previewResult;throw new Error(`Invalid Resource: ${I.toString()}`)}async acceptLocal(m){return{content:m.localContent,local:{added:{},removed:[],updated:{}},remote:m.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(m){if(m.remoteContent!==null){const I=JSON.parse(m.remoteContent),{local:A,remote:O}=(0,c.merge)(m.localUserData.storage,I.storage,null,m.storageKeys,this.logService);return{content:m.remoteContent,local:A,remote:O,localChange:Object.keys(A.added).length>0||Object.keys(A.updated).length>0||A.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:m.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(m,I,A,O){let{localUserData:N}=A[0][0],{local:$,remote:R,localChange:M,remoteChange:W}=A[0][1];if(M===0&&W===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),M!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(N)),await this.writeLocalGlobalState($),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),W!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const U=JSON.stringify({storage:R});m=await this.updateRemoteUserData(U,O?null:m.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}I?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:m}){return[{resource:this.extUri.joinPath(m,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(m){if(this.extUri.isEqual(m,vt.GLOBAL_STATE_DATA_URI)){const A=await this.getLocalGlobalState();return n(A,!0)}if(this.extUri.isEqual(this.remoteResource,m)||this.extUri.isEqual(this.localResource,m)||this.extUri.isEqual(this.acceptedResource,m)){const A=await this.resolvePreviewContent(m);return A&&n(JSON.parse(A),!0)}let I=await super.resolveContent(m);if(I)return I;if(I=await super.resolveContent(this.extUri.dirname(m)),I){const A=this.parseSyncData(I);if(A)switch(this.extUri.basename(m)){case"globalState.json":return n(JSON.parse(A.content),!0)}}return null}async hasLocalData(){try{const{storage:m}=await this.getLocalGlobalState();if(Object.keys(m).length>1||m[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const m={},I=await this.getLocalArgvContent(),A=(0,_.parse)(I);for(const O of a)A[O]!==void 0&&(m[`${r}${O}`]={version:1,value:A[O]});for(const O of this.storageService.keys(0,0)){const N=this.storageService.get(O,0);N&&(m[O]={version:1,value:N})}return{storage:m}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const m=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),m.value.toString()}catch(m){this.logService.debug((0,i.getErrorMessage)(m))}return"{}"}async writeLocalGlobalState({added:m,removed:I,updated:A}){const O={},N={},$=(M,W)=>{for(const U of M){if(U.startsWith(r)){O[U.substring(r.length)]=W?W[U].value:void 0;continue}if(W){const x=W[U];x.value!==String(this.storageService.get(U,0))&&(N[U]=x.value)}else this.storageService.get(U,0)!==void 0&&(N[U]=void 0)}};if($(Object.keys(m),m),$(Object.keys(A),A),$(I),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(N).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const M of Object.keys(N))this.storageService.store(M,N[M],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(N))}}async updateArgv(m){const I=await this.getLocalArgvContent();let A=I;for(const O of Object.keys(m))A=(0,g.edit)(A,[O],m[O],{});I!==A&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(A)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(m){const I=this.storageService.keys(0,0),A=this.storageService.keys(0,1),O=[...I,...A],N=m?.storage?Object.keys(m.storage).filter($=>!$.startsWith(r)&&!O.includes($)&&this.storageService.get($,0)!==void 0):[];if(!D.isWeb){const $=[...l.ALL_SYNC_RESOURCES.map(R=>(0,l.getEnablementKey)(R)),l.SYNC_SERVICE_URL_TYPE];N.push(...$),A.push(...$)}return{user:I,machine:A,unregistered:N}}};s.GLOBAL_STATE_DATA_URI=C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),s=de([J(0,f.IFileService),J(1,l.IUserDataSyncStoreService),J(2,l.IUserDataSyncBackupStoreService),J(3,l.IUserDataSyncLogService),J(4,E.IEnvironmentService),J(5,l.IUserDataSyncEnablementService),J(6,v.ITelemetryService),J(7,P.IConfigurationService),J(8,S.IStorageService),J(9,y.IUriIdentityService)],s),e.GlobalStateSynchroniser=s;let o=class extends w.AbstractInitializer{constructor(m,I,A,O,N){super("globalState",A,O,I,N);this.storageService=m}async doInitialize(m){const I=m.syncData?JSON.parse(m.syncData.content):null;if(!I){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const A={},O={};for(const N of Object.keys(I.storage))N.startsWith(r)?A[N.substring(r.length)]=I.storage[N].value:this.storageService.get(N,0)===void 0&&(O[N]=I.storage[N].value);if(Object.keys(A).length){let N="{}";try{N=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const $ of Object.keys(A))N=(0,g.edit)(N,[$],A[$],{});await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(N))}if(Object.keys(O).length)for(const N of Object.keys(O))this.storageService.store(N,O[N],0,0)}};o=de([J(0,S.IStorageService),J(1,f.IFileService),J(2,E.IEnvironmentService),J(3,l.IUserDataSyncLogService),J(4,y.IUriIdentityService)],o),e.GlobalStateInitializer=o;let u=class{constructor(m,I,A,O,N){this.userDataSyncStoreClient=m,this.storageService=I,this.environmentService=A,this.fileService=O,this.logService=N}getSyncStoreType(m){return this.parseGlobalState(m)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(m){const I=(0,l.createSyncHeaders)((0,b.generateUuid)());try{return await this.doSync(m,I)}catch(A){if(A instanceof l.UserDataSyncError)switch(A.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(m,I)}throw A}}async doSync(m,I){const A=await this.userDataSyncStoreClient.read("globalState",null,I),O=this.parseGlobalState(A)||{storage:{}};O.storage[l.SYNC_SERVICE_URL_TYPE]={value:m,version:t};const N=await(0,h.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),$={version:t,machineId:N,content:n(O,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify($),A.ref,I)}parseGlobalState({content:m}){if(!m)return null;const I=JSON.parse(m);if((0,w.isSyncData)(I))return I?JSON.parse(I.content):null;throw new Error("Invalid remote data")}};u=de([J(1,S.IStorageService),J(2,E.IEnvironmentService),J(3,f.IFileService),J(4,p.ILogService)],u),e.UserDataSyncStoreTypeSynchronizer=u}),define(ne[224],ie([0,1,17,18,3,35,4,15,143,21,13,14,23,22,34,47,219,24]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h,S,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(l,r,a){try{const n=JSON.parse(l);if(!r)return(0,D.isUndefined)(n.all)?null:n.all;switch(T.OS){case 2:return(0,D.isUndefined)(n.mac)?null:n.mac;case 3:return(0,D.isUndefined)(n.linux)?null:n.linux;case 1:return(0,D.isUndefined)(n.windows)?null:n.windows}}catch(n){return a.error(n),null}}e.getKeybindingsContentFromSyncContent=w;let g=class extends S.AbstractJsonFileSynchroniser{constructor(r,a,n,t,s,o,u,d,m,I,A){super(u.keybindingsResource,"keybindings",o,u,d,r,a,s,I,n,m,t,A);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.filter(t.onDidChangeConfiguration,O=>O.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,a,n,t){const s=r.syncData?w(r.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;a=a===null&&n?r:a;const o=a?this.getKeybindingsContentFromLastSyncUserData(a):null,u=await this.getLocalFileContent(),d=await this.getFormattingOptions();let m=null,I=!1,A=!1,O=!1;if(s){let $=u?u.value.toString():"[]";if($=$||"[]",this.hasErrors($))throw new y.UserDataSyncError((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==$||o!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const R=await(0,v.merge)($,s,o,d,this.userDataSyncUtilService);R.hasChanges&&(m=R.mergeContent,O=R.hasConflicts,I=O||R.mergeContent!==$,A=O||R.mergeContent!==s)}}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),m=u.value.toString(),A=!0);const N={content:m,localChange:I?u?2:1:0,remoteChange:A?2:0,hasConflicts:O};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const a=this.getKeybindingsContentFromLastSyncUserData(r);if(a===null)return!0;const n=await this.getLocalFileContent(),t=n?n.value.toString():"",s=await this.getFormattingOptions(),o=await(0,v.merge)(t||"[]",a,a,s,this.userDataSyncUtilService);return o.hasConflicts||o.mergeContent!==a}async getMergeResult(r,a){return r.previewResult}async getAcceptResult(r,a,n,t){if(this.extUri.isEqual(a,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return n===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(r,a,n,t){const{fileContent:s}=n[0][0];let{content:o,localChange:u,remoteChange:d}=n[0][1];if(u===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o)))throw new y.UserDataSyncError((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(o||"[]",s,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),d!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const m=this.toSyncContent(o||"[]",r.syncData?.content);r=await this.updateRemoteUserData(m,t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}a?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const a=(0,_.parse)(r.value.toString());if((0,L.isNonEmptyArray)(a))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:a}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let a=await super.resolveContent(r);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(r)),a){const n=this.parseSyncData(a);if(n)switch(this.extUri.basename(r)){case"keybindings.json":return w(n.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:w(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,a){let n={};try{n=JSON.parse(a||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=r,T.OS){case 2:n.mac=r;break;case 3:n.linux=r;break;case 1:n.windows=r;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};g=de([J(0,y.IUserDataSyncStoreService),J(1,y.IUserDataSyncBackupStoreService),J(2,y.IUserDataSyncLogService),J(3,b.IConfigurationService),J(4,y.IUserDataSyncEnablementService),J(5,E.IFileService),J(6,P.IEnvironmentService),J(7,f.IStorageService),J(8,y.IUserDataSyncUtilService),J(9,p.ITelemetryService),J(10,h.IUriIdentityService)],g),e.KeybindingsSynchroniser=g;let c=class extends S.AbstractInitializer{constructor(r,a,n,t){super("keybindings",a,n,r,t)}async doInitialize(r){const a=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!a){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,i.VSBuffer.fromString(a)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),a=(0,_.parse)(r.value.toString());return!(0,L.isNonEmptyArray)(a)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return w(r,!0,this.logService)}catch(a){return this.logService.error(a),null}}};c=de([J(0,E.IFileService),J(1,P.IEnvironmentService),J(2,y.IUserDataSyncLogService),J(3,h.IUriIdentityService)],c),e.KeybindingsInitializer=c}),define(ne[225],ie([0,1,17,35,68,49,28,52,24]),function(Q,e,L,i,k,_,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function b(o,u,d){let m=[];d?m=E(d):m=P(u);const I=[],A=[...(0,C.getDisallowedIgnoredSettings)()];if(Array.isArray(m))for(const O of m)O.startsWith("-")?A.push(O.substring(1)):I.push(O);return(0,L.distinct)([...o,...I].filter(O=>A.indexOf(O)===-1))}e.getIgnoredSettings=b;function P(o){let u=o.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=o.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:o.getValue("settingsSync.ignoredSettings")||[]}function E(o){const u=(0,i.parse)(o);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function f(o,u,d,m){if(d.length){const I=s(u),A=(0,i.parse)(u),O=(0,i.parse)(o),N=[];for(const $ of d){const R=A[$],M=O[$];R===void 0?o=D.edit(o,[$],void 0,m):M!==void 0?o=D.edit(o,[$],R,m):N.push(l($,I))}N.sort(($,R)=>$.startOffset-R.startOffset),N.forEach($=>o=y($.setting.key,u,o,m))}return o}e.updateIgnoredSettings=f;function p(o,u,d,m,I,A){const O=f(o,u,m,A),N=d!==O,$=d!==u;if(!N&&!$)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(N&&!$)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if($&&!N)return{conflictsSettings:[],localContent:f(u,o,m,A),remoteContent:null,hasConflicts:!1};if(d===null&&S(o)){const z=h(o,u,m)?null:f(u,o,m,A);return{conflictsSettings:[],localContent:z,remoteContent:null,hasConflicts:!1}}let R=o,M=u;const W=(0,i.parse)(o),U=(0,i.parse)(u),x=d?(0,i.parse)(d):null,ee=m.reduce((z,V)=>(z.add(V),z),new Set),G=v(W,U,ee),q=v(x,W,ee),Y=v(x,U,ee),H=new Map,Z=new Set,K=z=>{Z.add(z);const V=I.filter(({key:te})=>te===z)[0];V?(R=D.edit(R,[z],V.value,A),M=D.edit(M,[z],V.value,A)):H.set(z,{key:z,localValue:W[z],remoteValue:U[z]})};for(const z of q.removed.values())Y.updated.has(z)?K(z):M=D.edit(M,[z],void 0,A);for(const z of Y.removed.values())Z.has(z)||(q.updated.has(z)?K(z):R=D.edit(R,[z],void 0,A));for(const z of q.updated.values())Z.has(z)||(Y.updated.has(z)?G.updated.has(z)&&K(z):M=D.edit(M,[z],W[z],A));for(const z of Y.updated.values())Z.has(z)||(q.updated.has(z)?G.updated.has(z)&&K(z):R=D.edit(R,[z],U[z],A));for(const z of q.added.values())Z.has(z)||(Y.added.has(z)?G.updated.has(z)&&K(z):M=y(z,R,M,A));for(const z of Y.added.values())Z.has(z)||(q.added.has(z)?G.updated.has(z)&&K(z):R=y(z,M,R,A));const F=H.size>0||!h(R,M,m),j=F||!h(R,o,[]),B=F||!h(M,u,[]);return{localContent:j?R:null,remoteContent:B?M:null,conflictsSettings:[...H.values()],hasConflicts:F}}e.merge=p;function h(o,u,d){if(o===u)return!0;const m=(0,i.parse)(o),I=(0,i.parse)(u),A=d.reduce(($,R)=>($.add(R),$),new Set),O=s(o).filter($=>!($.setting&&A.has($.setting.key))),N=s(u).filter($=>!($.setting&&A.has($.setting.key)));if(O.length!==N.length)return!1;for(let $=0;$<O.length;$++){const R=O[$],M=N[$];if(R.setting&&M.setting){if(R.setting.key!==M.setting.key||!T.equals(m[R.setting.key],I[R.setting.key]))return!1}else if(!R.setting&&!M.setting){if(R.value!==M.value)return!1}else return!1}return!0}e.areSame=h;function S(o){return o?s(o).length===0:!0}e.isEmpty=S;function v(o,u,d){const m=o?Object.keys(o).filter($=>!d.has($)):[],I=Object.keys(u).filter($=>!d.has($)),A=I.filter($=>m.indexOf($)===-1).reduce(($,R)=>($.add(R),$),new Set),O=m.filter($=>I.indexOf($)===-1).reduce(($,R)=>($.add(R),$),new Set),N=new Set;if(o)for(const $ of m){if(O.has($))continue;const R=o[$],M=u[$];T.equals(R,M)||N.add($)}return{added:A,removed:O,updated:N}}function y(o,u,d,m){const I=(0,i.parse)(u),A=s(u),O=s(d),N=w(o,A,O);return g(d,o,I[o],N,O,m)}e.addSetting=y;function w(o,u,d){const m=u.findIndex(A=>A.setting?.key===o),I=u[m-1];if(I){if(I.setting){const O=l(I.setting.key,d);if(O)return{index:d.indexOf(O),insertAfter:!0}}else{const O=r(m,u);if(O){const N=l(O.setting.key,d);if(N){const $=a(d.indexOf(N),d),R=n(u,O,u[m]);if($){const M=n(d,N,$),W=t(R,M);return W?{index:d.indexOf(W),insertAfter:!0}:{index:d.indexOf($),insertAfter:!1}}else{const M=n(d,N,d[d.length-1]),W=t(R,M);return W?{index:d.indexOf(W),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const A=u[m+1];if(A)if(A.setting){const O=l(A.setting.key,d);if(O)return{index:d.indexOf(O),insertAfter:!1}}else{const O=a(m,u);if(O){const N=l(O.setting.key,d);if(N){const $=r(d.indexOf(N),d),R=n(u,u[m],O);if($){const M=n(d,$,N),W=t(R.reverse(),M.reverse());return W?{index:d.indexOf(W),insertAfter:!1}:{index:d.indexOf($),insertAfter:!0}}else{const M=n(d,d[0],N),W=t(R.reverse(),M.reverse());return W?{index:d.indexOf(W),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function g(o,u,d,m,I,A){let O;return m.index===-1?O=(0,k.setProperty)(o,[u],d,A):O=c(o,u,d,m,I,A).map(N=>(0,k.withFormatting)(o,N,A)[0]),(0,k.applyEdits)(o,O)}function c(o,u,d,m,I,A){const O=`${JSON.stringify(u)}: ${JSON.stringify(d)}`,N=(0,_.getEOL)(A,o),$=I[m.index];if(m.insertAfter){const R=[];if($.setting)R.push({offset:$.endOffset,length:0,content:","+O});else{const M=a(m.index,I),W=r(m.index,I),U=W?.setting?.commaOffset;W&&U===void 0&&R.push({offset:W.endOffset,length:0,content:","});const x=U!==void 0&&U>$.endOffset;R.push({offset:x?U+1:$.endOffset,length:0,content:M?N+O+",":N+O})}return R}else{if($.setting)return[{offset:$.startOffset,length:0,content:O+","}];const R=(I[m.index-1]&&!I[m.index-1].setting?N:"")+O+(a(m.index,I)?",":"")+N;return[{offset:$.startOffset,length:0,content:R}]}}function l(o,u){return u.filter(d=>d.setting?.key===o)[0]}function r(o,u){for(let d=o-1;d>=0;d--)if(u[d].setting)return u[d]}function a(o,u){for(let d=o+1;d<u.length;d++)if(u[d].setting)return u[d]}function n(o,u,d){const m=o.indexOf(u),I=o.indexOf(d);return o.filter((A,O)=>m<O&&O<I)}function t(o,u){if(o.length&&u.length){let d=0;for(;d<u.length&&d<o.length;d++)if(o[d].value!==u[d].value)return u[d-1];return u[d-1]}}function s(o){const u=[];let d=-1,m,I;const A={onObjectBegin:O=>{d++},onObjectProperty:(O,N,$)=>{d===0&&(m=N,I=O)},onObjectEnd:(O,N)=>{d--,d===0&&u.push({startOffset:m,endOffset:O+N,value:o.substring(m,O+N),setting:{key:I,commaOffset:void 0}})},onArrayBegin:(O,N)=>{d++},onArrayEnd:(O,N)=>{d--,d===0&&u.push({startOffset:m,endOffset:O+N,value:o.substring(m,O+N),setting:{key:I,commaOffset:void 0}})},onLiteralValue:(O,N,$)=>{d===0&&u.push({startOffset:m,endOffset:N+$,value:o.substring(m,N+$),setting:{key:I,commaOffset:void 0}})},onSeparator:(O,N,$)=>{if(d===0&&O===","){let R=u.length-1;for(;R>=0&&!u[R].setting;R--);const M=u[R];M&&u.splice(R,1,{startOffset:M.startOffset,endOffset:M.endOffset,value:M.value,setting:{key:M.setting.key,commaOffset:N}})}},onComment:(O,N)=>{d===0&&u.push({startOffset:O,endOffset:O+N,value:o.substring(O,O+N)})}};return(0,i.visit)(o,A),u}}),define(ne[226],ie([0,1,18,3,144,21,87,13,29,14,23,22,34,47,52,225,24]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function y(l){return l&&l.settings&&typeof l.settings=="string"&&Object.keys(l).length===1}function w(l){const r=JSON.parse(l);return y(r)?r:{settings:l}}e.parseSettingsSyncContent=w;let g=class extends p.AbstractJsonFileSynchroniser{constructor(r,a,n,t,s,o,u,d,m,I,A,O){super(a.settingsResource,"settings",r,a,n,t,s,m,I,o,u,d,O);this.extensionManagementService=A,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const a=await this.getLastSyncUserData(),n=await this.getLatestRemoteUserData(r,a),t=this.getSettingsSyncContent(n),s=new T.ConfigurationModelParser(v.USER_DATA_SYNC_CONFIGURATION_SCOPE);return t?.settings&&s.parse(t.settings),s.configurationModel.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,a,n){const t=await this.getLocalFileContent(),s=await this.getFormattingOptions(),o=this.getSettingsSyncContent(r);a=a===null&&n?r:a;const u=a?this.getSettingsSyncContent(a):null,d=await this.getIgnoredSettings();let m=null,I=!1,A=!1,O=!1;if(o){let $=t?t.value.toString().trim():"{}";$=$||"{}",this.validateContent($),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const R=(0,S.merge)($,o.settings,u?u.settings:null,d,[],s);m=R.localContent||R.remoteContent,I=R.localContent!==null,A=R.remoteContent!==null,O=R.hasConflicts}else t&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),m=t.value.toString(),A=!0);const N={content:m,localChange:I?2:0,remoteChange:A?2:0,hasConflicts:O};return[{fileContent:t,localResource:this.localResource,localContent:t?t.value.toString():null,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const a=this.getSettingsSyncContent(r);if(a===null)return!0;const n=await this.getLocalFileContent(),t=n?n.value.toString().trim():"",s=await this.getIgnoredSettings(),o=await this.getFormattingOptions();return(0,S.merge)(t||"{}",a.settings,a.settings,s,[],o).remoteContent!==null}async getMergeResult(r,a){const n=await this.getFormattingOptions(),t=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,S.updateIgnoredSettings)(r.previewResult.content,"{}",t,n):null}}async getAcceptResult(r,a,n,t){const s=await this.getFormattingOptions(),o=await this.getIgnoredSettings();if(this.extUri.isEqual(a,this.localResource))return{content:r.fileContent?(0,S.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",o,s):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:r.remoteContent!==null?(0,S.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",o,s):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return n===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:n!==null?(0,S.updateIgnoredSettings)(n,r.fileContent?r.fileContent.value.toString():"{}",o,s):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(r,a,n,t){const{fileContent:s}=n[0][0];let{content:o,localChange:u,remoteChange:d}=n[0][1];if(u===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.validateContent(o),u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),s&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(s.value.toString()))),await this.updateLocalFileContent(o,s,t),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),d!==0){const m=await this.getFormattingOptions(),I=this.getSettingsSyncContent(r),A=await this.getIgnoredSettings(o);o=(0,S.updateIgnoredSettings)(o,I?I.settings:"{}",A,m),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(o)),t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}a?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const a=await this.getFormattingOptions(),n=(0,h.edit)(r.value.toString(),[v.CONFIGURATION_SYNC_STORE_KEY],void 0,a);return!(0,S.isEmpty)(n)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:a}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let a=await super.resolveContent(r);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(r)),a){const n=this.parseSyncData(a);if(n){const t=this.parseSettingsSyncContent(n.content);if(t)switch(this.extUri.basename(r)){case"settings.json":return t.settings}}}return null}async resolvePreviewContent(r){let a=await super.resolvePreviewContent(r);if(a){const n=await this.getFormattingOptions(),t=await this.getIgnoredSettings();a=(0,S.updateIgnoredSettings)(a,"{}",t,n)}return a}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return w(r)}catch(a){this.logService.error(a)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=i.Event.any(i.Event.filter(this.extensionManagementService.onDidInstallExtensions,t=>t.some(({local:s})=>!!s)),i.Event.filter(this.extensionManagementService.onDidUninstallExtension,t=>!t.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const a=await this._defaultIgnoredSettings;return(0,S.getIgnoredSettings)(a,this.configurationService,r)}validateContent(r){if(this.hasErrors(r))throw new v.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}};g=de([J(0,b.IFileService),J(1,D.IEnvironmentService),J(2,P.IStorageService),J(3,v.IUserDataSyncStoreService),J(4,v.IUserDataSyncBackupStoreService),J(5,v.IUserDataSyncLogService),J(6,v.IUserDataSyncUtilService),J(7,_.IConfigurationService),J(8,v.IUserDataSyncEnablementService),J(9,E.ITelemetryService),J(10,C.IExtensionManagementService),J(11,f.IUriIdentityService)],g),e.SettingsSynchroniser=g;let c=class extends p.AbstractInitializer{constructor(r,a,n,t){super("settings",a,n,r,t)}async doInitialize(r){const a=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!a){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,L.VSBuffer.fromString(a.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource);return(0,S.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return w(r)}catch(a){this.logService.error(a)}return null}};c=de([J(0,b.IFileService),J(1,D.IEnvironmentService),J(2,v.IUserDataSyncLogService),J(3,f.IUriIdentityService)],c),e.SettingsInitializer=c}),define(ne[227],ie([0,1,18,3,28,21,13,14,23,22,34,47,220,24]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let h=class extends E.AbstractSynchroniser{constructor(y,w,g,c,l,r,a,n,t,s){super("snippets",w,y,g,c,l,n,t,r,a,s);this.version=1,this.snippetsFolder=y.snippetsHome,this._register(this.fileService.watch(y.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(i.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(y,w,g){const c=await this.getSnippetsFileContents(),l=this.toSnippetsContents(c),r=y.syncData?this.parseSnippets(y.syncData):null;w=w===null&&g?y:w;const a=w&&w.syncData?this.parseSnippets(w.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,f.merge)(l,r,a);return this.getResourcePreviews(n,c,r||{})}async hasRemoteChanged(y){const w=y.syncData?this.parseSnippets(y.syncData):null;if(w===null)return!0;const g=await this.getSnippetsFileContents(),c=this.toSnippetsContents(g),l=(0,f.merge)(c,w,w);return Object.keys(l.remote.added).length>0||Object.keys(l.remote.updated).length>0||l.remote.removed.length>0||l.conflicts.length>0}async getMergeResult(y,w){return y.previewResult}async getAcceptResult(y,w,g,c){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:y.fileContent?y.fileContent.value.toString():null,localChange:0,remoteChange:y.fileContent?y.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:y.remoteContent,localChange:y.remoteContent!==null?y.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return g===void 0?{content:y.previewResult.content,localChange:y.previewResult.localChange,remoteChange:y.previewResult.remoteChange}:{content:g,localChange:g===null?y.fileContent!==null?3:0:2,remoteChange:g===null?y.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(y,w,g,c){const l=g.map(([r,a])=>({...r,acceptResult:a}));l.every(({localChange:r,remoteChange:a})=>r===0&&a===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,c)),l.some(({remoteChange:r})=>r!==0)&&(y=await this.updateRemoteSnippets(l,y,c)),w?.ref!==y.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(y),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of l)try{await this.fileService.del(r)}catch{}}getResourcePreviews(y,w,g){const c=new Map;for(const l of Object.keys(y.local.added)){const r={content:y.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};c.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(y.local.updated)){const r={content:y.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of y.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(y.remote.added)){const r={content:y.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(y.remote.updated)){const r={content:y.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of y.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of y.conflicts){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!0,localChange:w[l]?2:1,remoteChange:g[l]?2:1};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(w))if(!c.has(l)){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...c.values()]}async getAssociatedResources({uri:y}){let w=await super.resolveContent(y);if(w){const g=this.parseSyncData(w);if(g){const c=this.parseSnippets(g),l=[];for(const r of Object.keys(c)){const a=this.extUri.joinPath(y,r),n=this.extUri.joinPath(this.snippetsFolder,r),t=await this.fileService.exists(n);l.push({resource:a,comparableResource:t?n:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(y){if(this.extUri.isEqualOrParent(y,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(y,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(y,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(y);let w=await super.resolveContent(y);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(y)),w){const g=this.parseSyncData(w);if(g)return this.parseSnippets(g)[this.extUri.basename(y)]||null}return null}async hasLocalData(){try{const y=await this.getSnippetsFileContents();if(Object.keys(y).length)return!0}catch{}return!1}async updateLocalBackup(y){const w={};for(const g of y)g.fileContent&&(w[this.extUri.basename(g.localResource)]=g.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(y,w){for(const{fileContent:g,acceptResult:c,localResource:l,remoteResource:r,localChange:a}of y)if(a!==0){const n=r?this.extUri.basename(r):this.extUri.basename(l),t=this.extUri.joinPath(this.snippetsFolder,n);a===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):a===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,L.VSBuffer.fromString(c.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,L.VSBuffer.fromString(c.content),w?void 0:g),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(y,w,g){const c=w.syncData?this.parseSnippets(w.syncData):{},l=(0,k.deepClone)(c);for(const{acceptResult:r,localResource:a,remoteResource:n,remoteChange:t}of y)if(t!==0){const s=a?this.extUri.basename(a):this.extUri.basename(n);t===3?delete l[s]:l[s]=r.content}return(0,f.areSame)(c,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(l),g?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(y){return JSON.parse(y.content)}toSnippetsContents(y){const w={};for(const g of Object.keys(y))w[g]=y[g].value.toString();return w}async getSnippetsFileContents(){const y={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(g){if(g instanceof D.FileOperationError&&g.fileOperationResult===1)return y;throw g}for(const g of w.children||[]){const c=g.resource,l=this.extUri.extname(c);if(l===".json"||l===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,c),a=await this.fileService.readFile(c);y[r]=a}}return y}};h=de([J(0,T.IEnvironmentService),J(1,D.IFileService),J(2,C.IStorageService),J(3,p.IUserDataSyncStoreService),J(4,p.IUserDataSyncBackupStoreService),J(5,p.IUserDataSyncLogService),J(6,_.IConfigurationService),J(7,p.IUserDataSyncEnablementService),J(8,b.ITelemetryService),J(9,P.IUriIdentityService)],h),e.SnippetsSynchroniser=h;let S=class extends E.AbstractInitializer{constructor(y,w,g,c){super("snippets",w,g,y,c)}async doInitialize(y){const w=y.syncData?JSON.parse(y.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const c of Object.keys(w)){const l=w[c];if(l){const r=this.extUri.joinPath(this.environmentService.snippetsHome,c);await this.fileService.createFile(r,L.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(y)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(y){return y.fileOperationResult===1}}};S=de([J(0,D.IFileService),J(1,T.IEnvironmentService),J(2,p.IUserDataSyncLogService),J(3,P.IUriIdentityService)],S),e.SnippetsInitializer=S}),define(ne[63],ie([0,1,3,2,6,24]),function(Q,e,L,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,k.createDecorator)("IUserDataSyncAccountService");let T=class extends i.Disposable{constructor(C,b){super();this.userDataSyncStoreService=C,this.logService=b,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(C.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(C.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(C){(C&&this._account?C.token!==this._account.token||C.authenticationProviderId!==this._account.authenticationProviderId:C!==this._account)&&(this._account=C,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(C))}};T=de([J(0,_.IUserDataSyncStoreService),J(1,_.IUserDataSyncLogService)],T),e.UserDataSyncAccountService=T}),define(ne[228],ie([0,1,5,18,56,2,19,21,13,14,24]),function(Q,e,L,i,k,_,T,D,C,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let E=class extends _.Disposable{constructor(p,h,S,v){super();this.environmentService=p,this.fileService=h,this.configurationService=S,this.logService=v,P.ALL_SYNC_RESOURCES.forEach(y=>this.cleanUpBackup(y))}async getAllRefs(p){const h=(0,T.joinPath)(this.environmentService.userDataSyncHome,p),S=await this.fileService.resolve(h);return S.children?S.children.filter(y=>y.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(y.name)).sort().reverse().map(y=>({ref:y.name,created:this.getCreationTime(y)})):[]}async resolveContent(p,h){if(!h){const S=await this.getAllRefs(p);S.length&&(h=S[S.length-1].ref)}if(h){const S=(0,T.joinPath)(this.environmentService.userDataSyncHome,p,h);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(p,h){const S=(0,T.joinPath)(this.environmentService.userDataSyncHome,p),v=(0,T.joinPath)(S,`${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(v,i.VSBuffer.fromString(h))}catch(y){this.logService.error(y)}try{this.cleanUpBackup(p)}catch{}}async cleanUpBackup(p){const h=(0,T.joinPath)(this.environmentService.userDataSyncHome,p);try{try{if(!await this.fileService.exists(h))return}catch{return}const S=await this.fileService.resolve(h);if(S.children){const v=S.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),y=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let w=v.filter(c=>Date.now()-this.getCreationTime(c)>y);const g=v.length-w.length;g<10&&(w=w.slice(10-g)),await L.Promises.settled(w.map(async c=>{this.logService.info("Deleting from backup",c.resource.path),await this.fileService.del(c.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(p){return p.ctime||new Date(parseInt(p.name.substring(0,4)),parseInt(p.name.substring(4,6))-1,parseInt(p.name.substring(6,8)),parseInt(p.name.substring(9,11)),parseInt(p.name.substring(11,13)),parseInt(p.name.substring(13,15))).getTime()}};E=de([J(0,C.IEnvironmentService),J(1,b.IFileService),J(2,D.IConfigurationService),J(3,P.IUserDataSyncLogService)],E),e.UserDataSyncBackupStoreService=E}),define(ne[229],ie([0,1,3,2,4,13,23,22,24]),function(Q,e,L,i,k,_,T,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const b="sync.enable";let P=class extends i.Disposable{constructor(f,p,h,S){super();this.storageService=f,this.telemetryService=p,this.environmentService=h,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new L.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(f.onDidChangeValue(v=>this.onDidStorageChange(v)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(b,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(f){f&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(b,{enabled:f}),this.storageService.store(b,f,0,1))}isResourceEnabled(f){return this.storageService.getBoolean((0,C.getEnablementKey)(f),0,!0)}setResourceEnablement(f,p){if(this.isResourceEnabled(f)!==p){const h=(0,C.getEnablementKey)(f);this.telemetryService.publicLog2(h,{enabled:p}),this.storeResourceEnablement(h,p)}}getResourceSyncStateVersion(f){}storeResourceEnablement(f,p){this.storageService.store(f,p,0,k.isWeb?0:1)}onDidStorageChange(f){if(f.scope!==0)return;if(b===f.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const p=C.ALL_SYNC_RESOURCES.filter(h=>(0,C.getEnablementKey)(h)===f.key)[0];if(p){this._onDidChangeResourceEnablement.fire([p,this.isResourceEnabled(p)]);return}}};P=de([J(0,T.IStorageService),J(1,D.ITelemetryService),J(2,_.IEnvironmentService),J(3,C.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(ne[230],ie([0,1,2,7]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class k{constructor(f){this.service=f}listen(f,p){switch(p){case"onError":return this.service.onError}throw new Error(`Event not found: ${p}`)}call(f,p,h){switch(p){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=k;class _{constructor(f){this.service=f}listen(f,p){throw new Error(`Event not found: ${p}`)}call(f,p,h){switch(p){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(i.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=_;class T{constructor(f){this.channel=f}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(f){return this.channel.call("resolveUserKeybindings",[f])}async resolveFormattingOptions(f){return this.channel.call("resolveFormattingOptions",[f])}}e.UserDataSyncUtilServiceClient=T;class D{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${p}`)}async call(f,p,h){switch(p){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=D;class C{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(f,p,h){switch(p){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=C;class b{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(f,p,h){switch(p){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class P extends L.Disposable{constructor(f){super();this.channel=f,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:i.URI.revive(f.url),type:f.type,defaultUrl:i.URI.revive(f.defaultUrl),insidersUrl:i.URI.revive(f.insidersUrl),stableUrl:i.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(ne[231],ie([0,1,13,10]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let k=class extends i.AbstractLogger{constructor(T,D){super();this.logger=this._register(T.createLogger(D.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...D){this.logger.trace(T,...D)}debug(T,...D){this.logger.debug(T,...D)}info(T,...D){this.logger.info(T,...D)}warn(T,...D){this.logger.warn(T,...D)}error(T,...D){this.logger.error(T,...D)}critical(T,...D){this.logger.critical(T,...D)}flush(){this.logger.flush()}};k=de([J(0,i.ILoggerService),J(1,L.IEnvironmentService)],k),e.UserDataSyncLogService=k}),define(ne[64],ie([0,1,3,2,4,25,147,13,14,6,26,46,23,24]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let S=class et extends i.Disposable{constructor(y,w,g,c,l,r){super();this.storageService=g,this.userDataSyncStoreService=c,this.logService=l,this.productService=r,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,E.getServiceMachineId)(y,w,g)}async getMachines(y){const w=await this.currentMachineIdPromise;return(await this.readMachinesData(y)).machines.map(c=>({...c,isCurrent:c.id===w}))}async addCurrentMachine(y){const w=await this.currentMachineIdPromise,g=await this.readMachinesData(y);g.machines.some(({id:c})=>c===w)||(g.machines.push({id:w,name:this.computeCurrentMachineName(g.machines)}),await this.writeMachinesData(g))}async removeCurrentMachine(y){const w=await this.currentMachineIdPromise,g=await this.readMachinesData(y),c=g.machines.filter(({id:l})=>l!==w);c.length!==g.machines.length&&(g.machines=c,await this.writeMachinesData(g))}async renameMachine(y,w,g){const c=await this.currentMachineIdPromise,l=await this.readMachinesData(g),r=l.machines.find(({id:a})=>a===y);r&&(r.name=w,await this.writeMachinesData(l),l.machines.some(({id:a})=>a===c)&&this.storageService.store(h,w,0,1))}async setEnablement(y,w){const g=await this.readMachinesData(),c=g.machines.find(({id:l})=>l===y);c&&(c.disabled=w?void 0:!0,await this.writeMachinesData(g))}computeCurrentMachineName(y){const w=this.storageService.get(h,0);if(w)return w;const g=`${this.productService.nameLong} (${(0,k.PlatformToString)(k.isWeb?0:k.platform)})`,c=new RegExp(`${(0,_.escapeRegExpCharacters)(g)}\\s#(\\d+)`);let l=0;for(const r of y){const a=c.exec(r.name),n=a?parseInt(a[1]):0;l=n>l?n:l}return`${g} #${l+1}`}async readMachinesData(y){this.userData=await this.readUserData(y);const w=this.parse(this.userData);if(w.version!==et.VERSION)throw new Error((0,T.localize)(0,null,this.productService.nameLong));return w}async writeMachinesData(y){const w=JSON.stringify(y),g=await this.userDataSyncStoreService.write(et.RESOURCE,w,this.userData?.ref||null);this.userData={ref:g,content:w},this._onDidChange.fire()}async readUserData(y){if(this.userData){const w=y&&y.latest?y.latest[et.RESOURCE]:void 0;if(this.userData.ref===w)return this.userData;if(w===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(et.RESOURCE,this.userData)}parse(y){if(y.content!==null)try{return JSON.parse(y.content)}catch(w){this.logService.error(w)}return{version:et.VERSION,machines:[]}}};S.VERSION=1,S.RESOURCE="machines",S=de([J(0,D.IEnvironmentService),J(1,C.IFileService),J(2,f.IStorageService),J(3,p.IUserDataSyncStoreService),J(4,p.IUserDataSyncLogService),J(5,P.IProductService)],S),e.UserDataSyncMachinesService=S}),define(ne[232],ie([0,1,5,56,37,8,3,2,4,19,7,145,26,23,22,24,63,64]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h,S,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const w="sync.disableMachineEventually",g="sync.sessionId",c="sync.storeUrl",l="sync.productQuality";let r=class extends D.Disposable{constructor(t,s,o,u,d,m,I,A,O,N){super();this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=o,this.userDataSyncEnablementService=u,this.userDataSyncService=d,this.logService=m,this.userDataSyncAccountService=I,this.telemetryService=A,this.userDataSyncMachinesService=O,this.storageService=N,this.autoSync=this._register(new D.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new L.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=t.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(I.onDidChangeAccount(()=>this.updateAutoSync())),this._register(o.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(T.Event.debounce(d.onDidChangeLocal,($,R)=>$?[...$,R]:[R],1e3)($=>this.triggerSync($,!1,!1))),this._register(T.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const t=this.storageService.get(c,0);return t?P.URI.parse(t):void 0}set syncUrl(t){t?this.storageService.store(c,t.toString(),0,1):this.storageService.remove(c,0)}get productQuality(){return this.storageService.get(l,0)}set productQuality(t){t?this.storageService.store(l,t,0,1):this.storageService.remove(l,0)}updateAutoSync(){const{enabled:t,message:s}=this.isAutoSyncEnabled();t?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(o=>this.onDidFinishSync(o))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,i.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(t,s,o){try{this.userDataSyncAccountService.account&&!o&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(g,0),t?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(u){if(s)this.logService.error(u),this.updateEnablement(!1);else throw u}}updateEnablement(t){this.userDataSyncEnablementService.isEnabled()!==t&&(this.userDataSyncEnablementService.setEnablement(t),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(t){if(!t){this.successiveFailures=0;return}const s=S.UserDataSyncError.toUserDataSyncError(t);s instanceof S.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"||s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?C.isWeb&&s.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(w,!0,0,1),await(0,L.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(w,0,!1)}stopDisableMachineEventually(){this.storageService.remove(w,0)}async triggerSync(t,s,o){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...t),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",o)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=de([J(0,f.IProductService),J(1,S.IUserDataSyncStoreManagementService),J(2,S.IUserDataSyncStoreService),J(3,S.IUserDataSyncEnablementService),J(4,S.IUserDataSyncService),J(5,S.IUserDataSyncLogService),J(6,v.IUserDataSyncAccountService),J(7,h.ITelemetryService),J(8,y.IUserDataSyncMachinesService),J(9,p.IStorageService)],r),e.UserDataAutoSyncService=r;class a extends D.Disposable{constructor(t,s,o,u,d,m,I,A){super();this.lastSyncUrl=t,this.interval=s,this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=u,this.userDataSyncService=d,this.userDataSyncMachinesService=m,this.logService=I,this.storageService=A,this.intervalHandler=this._register(new D.MutableDisposable),this._onDidStartSync=this._register(new T.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new T.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,D.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,L.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(t,s){const o=(0,L.createCancelablePromise)(async u=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(d){if((0,_.isPromiseCanceledError)(d))return}return this.doSync(t,s,u)});return this.syncPromise=o,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const t=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!t&&(!(0,b.isEqual)(s.defaultUrl,t.defaultUrl)||!(0,b.isEqual)(s.insidersUrl,t.insidersUrl)||!(0,b.isEqual)(s.stableUrl,t.stableUrl))}async doSync(t,s,o){this.logService.info(`Auto Sync: Triggered by ${t}`),this._onDidStartSync.fire();let u;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),o.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const d=this.storageService.get(g,0);if(d&&this.manifest&&d!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const m=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(o.isCancellationRequested)return;const I=m.find(A=>A.isCurrent);if(I?.disabled)throw new S.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(A){throw new S.UserDataAutoSyncError((0,k.toErrorMessage)(A),A instanceof S.UserDataSyncError?A.code:"Unknown")}if(this.manifest&&this.manifest.session!==d&&this.storageService.store(g,this.manifest.session,0,1),o.isCancellationRequested)return;I||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(d){this.logService.error(d),u=d}this._onDidFinishSync.fire(u)}register(t){return super._register(t)}}a.INTERVAL_SYNCING="Interval"}),define(ne[233],ie([0,1,17,5,37,3,2,19,15,30,21,29,6,23,22,221,223,224,226,227,24]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h,S,v,y,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const l="sync.lastSyncTime";let r=class extends T.Disposable{constructor(o,u,d,m,I,A,O,N){super();this.userDataSyncStoreService=o,this.userDataSyncStoreManagementService=u,this.instantiationService=d,this.configurationService=m,this.logService=I,this.telemetryService=A,this.storageService=O,this.userDataSyncEnablementService=N,this._status="uninitialized",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new _.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new _.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new _.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new _.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new T.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(l,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(o,u){this.checkEnablement();const d=(0,b.generateUuid)();try{const N=(0,c.createSyncHeaders)(d);u&&(N["Cache-Control"]="no-cache"),o=await this.userDataSyncStoreService.manifest(o,N)}catch(N){const $=c.UserDataSyncError.toUserDataSyncError(N);throw this.reportUserDataSyncError($,d),$}let m=!1;const I=this,A=this.getEnabledSynchronizers();let O;return{manifest:o,async run(){if(m)throw new Error("Can run a task only once");return O=(0,i.createCancelablePromise)(N=>I.sync(A,o,d,N)),O.finally(()=>O=void 0)},async stop(){if(O&&O.cancel(),I.status!=="idle")return I.stop(A)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new c.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const o=(0,b.generateUuid)(),u=(0,c.createSyncHeaders)(o);let d;try{d=await this.userDataSyncStoreService.manifest(null,u)}catch(I){const A=c.UserDataSyncError.toUserDataSyncError(I);throw this.reportUserDataSyncError(A,o),A}await this.resetLocal();const m=this.getEnabledSynchronizers();return new a(o,d,u,m,()=>this.resetLocal(),this.configurationService,this.logService)}async sync(o,u,d,m){if(m.isCancellationRequested||!o.length)return;const I=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const A=(0,c.createSyncHeaders)(d);for(const O of o){if(m.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(O.resource))return;try{await O.sync(u,A)}catch(N){let $=!1;if(N instanceof c.UserDataSyncError)switch(N.code){case"TooLarge":N=new c.UserDataSyncError(N.message,N.code,O.resource),$=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":$=!0;break}const R=c.UserDataSyncError.toUserDataSyncError(N);if(this.reportUserDataSyncError(R,d),$)throw R;this.logService.error(N),this.logService.error(`${O.resource}: ${(0,k.toErrorMessage)(N)}`),this._syncErrors.push([O.resource,R])}}this.logService.info(`Sync done. Took ${new Date().getTime()-I}ms`),this.updateLastSyncTime()}catch(A){const O=c.UserDataSyncError.toUserDataSyncError(A);throw this.reportUserDataSyncError(O,d),O}finally{this.updateStatus(o),this._onSyncErrors.fire(this._syncErrors)}}async stop(o){if(this.status!=="idle")for(const u of o)try{u.status!=="idle"&&await u.stop()}catch(d){this.logService.error(d)}}async replace(o){this.checkEnablement(),await this.performSynchronizerAction(async u=>{if(await u.replace(o))return!0})}async accept(o,u,d,m){this.checkEnablement(),await this.performSynchronizerAction(async I=>{if(I.resource===o)return await I.accept(u,d),m&&await I.apply(!1,(0,c.createSyncHeaders)((0,b.generateUuid)())),!0})}async resolveContent(o){return this.performSynchronizerAction(async u=>{const d=await u.resolveContent(o);if(d)return d})}async getRemoteSyncResourceHandles(o){return await this.performSynchronizerAction(async d=>{if(d.resource===o)return d.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(o){return await this.performSynchronizerAction(async d=>{if(d.resource===o)return d.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(o,u){return await this.performSynchronizerAction(async m=>{if(m.resource===o)return m.getAssociatedResources(u)})||[]}async getMachineId(o,u){return await this.performSynchronizerAction(async m=>{if(m.resource===o)return await m.getMachineId(u)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async u=>{if(u.resource!=="globalState"&&await u.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async u=>{if(await u.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(o){this.logService.error(o)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(l,0),this.synchronizers.value){for(const o of this.synchronizers.value.enabled)try{await o.resetLocal()}catch(u){this.logService.error(`${o.resource}: ${(0,k.toErrorMessage)(u)}`),this.logService.error(u)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(o){const u=new T.DisposableStore;try{const d=this.synchronizers.value||u.add(this.instantiationService.createInstance(n,()=>{},()=>{},()=>{})),m=[...d.enabled,...d.disabled.map(I=>u.add(d.createSynchronizer(I)))];for(const I of m){const A=await o(I);if(!(0,C.isUndefined)(A))return A}return null}finally{u.dispose()}}setStatus(o){const u=this._status;this._status!==o&&(this._status=o,this._onDidChangeStatus.fire(o),u==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(o){this.updateConflicts(o);const u=this.computeStatus(o);this.setStatus(u)}updateConflicts(o){const u=this.computeConflicts(o);(0,L.equals)(this._conflicts,u,([d,m],[I,A])=>d===d&&(0,L.equals)(m,A,(O,N)=>(0,D.isEqual)(O.previewResource,N.previewResource)))||(this._conflicts=this.computeConflicts(o),this._onDidChangeConflicts.fire(u))}computeConflicts(o){return o.filter(u=>u.status==="hasConflicts").map(u=>[u.resource,u.conflicts.map(t)])}computeStatus(o){return this.userDataSyncStoreManagementService.userDataSyncStore?o.some(u=>u.status==="hasConflicts")?"hasConflicts":o.some(u=>u.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(l,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(o,u){this.telemetryService.publicLog2("sync/error",{code:o.code,serverCode:o instanceof c.UserDataSyncStoreError?String(o.serverCode):void 0,url:o instanceof c.UserDataSyncStoreError?o.url:void 0,resource:o.resource,executionId:u,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(n,o=>this.updateStatus(o),o=>this.updateConflicts(o),o=>this._onDidChangeLocal.fire(o))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=de([J(0,c.IUserDataSyncStoreService),J(1,c.IUserDataSyncStoreManagementService),J(2,f.IInstantiationService),J(3,P.IConfigurationService),J(4,c.IUserDataSyncLogService),J(5,h.ITelemetryService),J(6,p.IStorageService),J(7,c.IUserDataSyncEnablementService)],r),e.UserDataSyncService=r;class a extends T.Disposable{constructor(o,u,d,m,I,A,O){super();this.id=o,this.manifest=u,this.syncHeaders=d,this.synchronisers=m,this.onStop=I,this.configurationService=A,this.logService=O,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new _.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(o=>o.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(o=>o.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,i.createCancelablePromise)(o=>this.getPreviews(o))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(o){throw this.logService.error(o),o}}async accept(o,u){try{return await this.performAction(o,d=>d.accept(o,u))}catch(d){throw this.logService.error(d),d}}async merge(o){try{return o?await this.performAction(o,u=>u.merge(o)):await this.mergeAll()}catch(u){throw this.logService.error(u),u}}async discard(o){try{return await this.performAction(o,u=>u.discard(o))}catch(u){throw this.logService.error(u),u}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const o=[];for(const[,u]of this.previews)for(const d of u.resourcePreviews)d.mergeState==="conflict"&&o.push(d.previewResource);for(const u of o)await this.discard(u);return this.previews}catch(o){throw this.logService.error(o),o}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const o=[];for(const[u,d]of this.previews){this.synchronizingResources.push([u,d.resourcePreviews.map(A=>A.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const m=this.synchronisers.find(A=>A.resource===u);for(const A of d.resourcePreviews)(A.localChange!==0||A.remoteChange!==0)&&A.mergeState==="preview"&&await m.merge(A.previewResource);const I=await m.apply(!1,this.syncHeaders);I&&o.push(this.toSyncResourcePreview(m.resource,I)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(A=>A[0]===u),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}catch(o){throw this.logService.error(o),o}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,u]of this.previews){this.synchronizingResources.push([o,u.resourcePreviews.map(m=>m.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const d=this.synchronisers.find(m=>m.resource===o);for(const m of u.resourcePreviews)await d.accept(m.remoteResource);await d.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(m=>m[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,u]of this.previews){this.synchronizingResources.push([o,u.resourcePreviews.map(m=>m.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const d=this.synchronisers.find(m=>m.resource===o);for(const m of u.resourcePreviews)await d.accept(m.localResource);await d.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(m=>m[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async stop(){await this.onStop(),this.reset()}async performAction(o,u){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const d=this.previews.findIndex(([,M])=>M.resourcePreviews.some(({localResource:W,previewResource:U,remoteResource:x})=>(0,D.isEqual)(o,W)||(0,D.isEqual)(o,U)||(0,D.isEqual)(o,x)));if(d===-1)return this.previews;const[m,I]=this.previews[d],A=I.resourcePreviews.find(({localResource:M,remoteResource:W,previewResource:U})=>(0,D.isEqual)(M,o)||(0,D.isEqual)(W,o)||(0,D.isEqual)(U,o));if(!A)return this.previews;let O=this.synchronizingResources.find(M=>M[0]===m);O||(O=[m,[]],this.synchronizingResources.push(O)),O[1].some(M=>(0,D.isEqual)(M,A.localResource))||(O[1].push(A.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const N=this.synchronisers.find(M=>M.resource===this.previews[d][0]),$=await u(N);$?this.previews.splice(d,1,this.toSyncResourcePreview(N.resource,$)):this.previews.splice(d,1);const R=this.synchronizingResources.findIndex(M=>M[0]===m);return this.synchronizingResources[R][1].splice(O[1].findIndex(M=>(0,D.isEqual)(M,A.localResource)),1),O[1].length||(this.synchronizingResources.splice(R,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const o=[];for(const[u,d]of this.previews){this.synchronizingResources.push([u,d.resourcePreviews.map(A=>A.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const m=this.synchronisers.find(A=>A.resource===u);let I=d;for(const A of d.resourcePreviews)(A.localChange!==0||A.remoteChange!==0)&&A.mergeState==="preview"&&(I=await m.merge(A.previewResource));I&&o.push(this.toSyncResourcePreview(m.resource,I)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(A=>A[0]===u),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}async getPreviews(o){const u=[],d=await this.getUserDataSyncConfiguration();for(const m of this.synchronisers){if(o.isCancellationRequested)return[];const I=await m.preview(this.manifest,d,this.syncHeaders);I&&u.push(this.toSyncResourcePreview(m.resource,I))}return u}async getUserDataSyncConfiguration(){const o=this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE),u=await this.synchronisers.find(d=>d instanceof w.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...o,...u}}toSyncResourcePreview(o,u){return[o,{isLastSyncFromCurrentMachine:u.isLastSyncFromCurrentMachine,resourcePreviews:u.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let n=class extends T.Disposable{constructor(o,u,d,m,I,A,O){super();this.onDidChangeStatus=o,this.onDidChangeConflicts=u,this.onDidChangeLocal=d,this.userDataSyncEnablementService=m,this.instantiationService=I,this.extensionGalleryService=A,this.logService=O,this._enabled=[],this._register(m.onDidChangeResourceEnablement(([N,$])=>this.onDidChangeResourceEnablement(N,$))),this._register((0,T.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,N])=>N.dispose())));for(const N of c.ALL_SYNC_RESOURCES)m.isResourceEnabled(N)&&this.registerSynchronizer(N)}get enabled(){return this._enabled.sort((o,u)=>o[1]-u[1]).map(([o])=>o)}get disabled(){return c.ALL_SYNC_RESOURCES.filter(o=>!this.userDataSyncEnablementService.isResourceEnabled(o))}onDidChangeResourceEnablement(o,u){u?this.registerSynchronizer(o):this.deRegisterSynchronizer(o)}registerSynchronizer(o){if(this._enabled.some(([I])=>I.resource===o))return;if(o==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const u=new T.DisposableStore,d=u.add(this.createSynchronizer(o));u.add(d.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),u.add(d.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),u.add(d.onDidChangeLocal(()=>this.onDidChangeLocal(o)));const m=this.getOrder(o);this._enabled.push([d,m,u])}deRegisterSynchronizer(o){const u=this._enabled.findIndex(([d])=>d.resource===o);if(u!==-1){const d=this._enabled.splice(u,1);for(const[m,,I]of d){if(m.status!=="idle"){const A=m.conflicts.length>0;m.stop(),A&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}I.dispose()}}}createSynchronizer(o){switch(o){case"settings":return this.instantiationService.createInstance(w.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(y.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(g.SnippetsSynchroniser);case"globalState":return this.instantiationService.createInstance(v.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(S.ExtensionsSynchroniser)}}getOrder(o){switch(o){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"globalState":return 3;case"extensions":return 4}}};n=de([J(3,c.IUserDataSyncEnablementService),J(4,f.IInstantiationService),J(5,E.IExtensionGalleryService),J(6,c.IUserDataSyncLogService)],n);function t(s){return{localResource:s.localResource,previewResource:s.previewResource,remoteResource:s.remoteResource,acceptedResource:s.acceptedResource,localChange:s.localChange,remoteChange:s.remoteChange,mergeState:s.mergeState}}}),define(ne[234],ie([0,1,3,2,15,7,24]),function(Q,e,L,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class D{constructor(E,f){this.service=E,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new L.Emitter}listen(E,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(E,f,p){try{return await this._call(E,f,p)}catch(h){throw this.logService.error(h),h}}async _call(E,f,p){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(_.URI.revive(p[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(p[0],_.URI.revive(p[1]),p[2],p[3]);case"resolveContent":return this.service.resolveContent(_.URI.revive(p[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(p[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(p[0]);case"getAssociatedResources":return this.service.getAssociatedResources(p[0],{created:p[1].created,uri:_.URI.revive(p[1].uri)});case"getMachineId":return this.service.getMachineId(p[0],{created:p[1].created,uri:_.URI.revive(p[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const h=f.substring("manualSync/".length),S=p[0],v=this.getManualSyncTask(S);switch(p=p.slice(1),h){case"preview":return v.preview();case"accept":return v.accept(_.URI.revive(p[0]),p[1]);case"merge":return v.merge(_.URI.revive(p[0]));case"discard":return v.discard(_.URI.revive(p[0]));case"discardConflicts":return v.discardConflicts();case"apply":return v.apply();case"pull":return v.pull();case"push":return v.push();case"stop":return v.stop();case"_getStatus":return v.status;case"dispose":return this.disposeManualSyncTask(v)}}throw new Error("Invalid call")}getManualSyncTask(E){const f=this.manualSyncTasks.get(this.createKey(E));if(!f)throw new Error(`Manual sync taks not found: ${E}`);return f.manualSyncTask}async createManualSyncTask(){const E=new i.DisposableStore,f=E.add(await this.service.createManualSyncTask());return E.add(f.onSynchronizeResources(p=>this.onManualSynchronizeResources.fire({manualSyncTaskId:f.id,data:p}))),this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:E}),{id:f.id,manifest:f.manifest,status:f.status}}disposeManualSyncTask(E){E.dispose();const f=this.createKey(E.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=D;class C extends i.Disposable{constructor(E){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,p,h){return E.call(f,p,h).then(null,S=>{throw T.UserDataSyncError.toUserDataSyncError(S)})},listen(f,p){return E.listen(f,p)}},this.channel.call("_getInitialData").then(([f,p,h])=>{this.updateStatus(f),this.updateConflicts(p),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(S=>this.updateStatus(S))),this._register(this.channel.listen("onDidChangeLastSyncTime")(S=>this.updateLastSyncTime(S)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(([p,h])=>[p,T.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:f,status:p}=await this.channel.call("createManualSyncTask"),h=this,S=new b(E,f,p,{async call(v,y,w){return h.channel.call(`manualSync/${v}`,[E,...(0,k.isArray)(y)?y:[y]],w)},listen(v,y){return L.Event.map(L.Event.filter(h.channel.listen(`manualSync/${v}`,y),w=>!S.isDiposed()&&w.manualSyncTaskId===E),w=>w.data)}});return S}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,f,p,h){return this.channel.call("accept",[E,f,p,h])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:p,uri:h})=>({created:p,uri:_.URI.revive(h)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:p,uri:h})=>({created:p,uri:_.URI.revive(h)}))}async getAssociatedResources(E,f){return(await this.channel.call("getAssociatedResources",[E,f])).map(({resource:h,comparableResource:S})=>({resource:_.URI.revive(h),comparableResource:_.URI.revive(S)}))}async getMachineId(E,f){return this.channel.call("getMachineId",[E,f])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([f,p])=>[f,p.map(h=>({...h,localResource:_.URI.revive(h.localResource),remoteResource:_.URI.revive(h.remoteResource),previewResource:_.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=C;class b extends i.Disposable{constructor(E,f,p,h){super();this.id=E,this.manifest=f,this._disposed=!1,this._status=p;const S=this;this.channel={async call(v,y,w){try{const g=await h.call(v,y,w);return S.isDiposed()||(S._status=await h.call("_getStatus")),g}catch(g){throw T.UserDataSyncError.toUserDataSyncError(g)}},listen(v,y){return h.listen(v,y)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,f){const p=await this.channel.call("accept",[E,f]);return this.deserializePreviews(p)}async merge(E){const f=await this.channel.call("merge",[E]);return this.deserializePreviews(f)}async discard(E){const f=await this.channel.call("discard",[E]);return this.deserializePreviews(f)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([f,p])=>[f,{isLastSyncFromCurrentMachine:p.isLastSyncFromCurrentMachine,resourcePreviews:p.resourcePreviews.map(h=>({...h,localResource:_.URI.revive(h.localResource),remoteResource:_.URI.revive(h.remoteResource),previewResource:_.URI.revive(h.previewResource),acceptedResource:_.URI.revive(h.acceptedResource)}))}])}}}),define(ne[235],ie([0,1,5,27,8,3,2,107,4,19,15,7,30,21,13,14,26,43,46,23,24]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h,S,v,y,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",r="sync.donot-make-requests-until",a="sync.user-session-id",n="sync.machine-session-id",t=100,s=1e3*60*5;let o=class extends T.Disposable{constructor(O,N,$){super();this.productService=O,this.configurationService=N,this.storageService=$,this._onDidChangeUserDataSyncStore=this._register(new _.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(_.Event.filter($.onDidChangeValue,R=>R.key===c.SYNC_SERVICE_URL_TYPE&&R.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(c.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(c.SYNC_SERVICE_URL_TYPE,O,0,C.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[c.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(c.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,N){O=C.isWeb&&O?.web?{...O,...O.web}:O;const $={...O||{},...N||{}};if($&&(0,P.isString)($.url)&&(0,P.isObject)($.authenticationProviders)&&Object.keys($.authenticationProviders).every(R=>(0,P.isArray)($.authenticationProviders[R].scopes))){const R=$,M=!!R.canSwitch&&!N?.url,W=R.url===R.insidersUrl?"insiders":"stable",U=(M?this.userDataSyncStoreType:void 0)||W,x=N?.url||(U==="insiders"?R.insidersUrl:U==="stable"?R.stableUrl:R.url);return{url:E.URI.parse(x),type:U,defaultType:W,defaultUrl:E.URI.parse(R.url),stableUrl:E.URI.parse(R.stableUrl),insidersUrl:E.URI.parse(R.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(R.authenticationProviders).reduce((ee,G)=>(ee.push({id:G,scopes:R.authenticationProviders[G].scopes}),ee),[])}}}};o=de([J(0,v.IProductService),J(1,p.IConfigurationService),J(2,g.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let u=class extends o{constructor(O,N,$){super(O,N,$);const R=this.storageService.get(l,0);R&&(this.previousConfigurationSyncStore=JSON.parse(R));const M=this.productService[c.CONFIGURATION_SYNC_STORE_KEY];M?this.storageService.store(l,JSON.stringify(M),0,1):this.storageService.remove(l,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=de([J(0,v.IProductService),J(1,p.IConfigurationService),J(2,g.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let d=class extends T.Disposable{constructor(O,N,$,R,M,W,U){super();this.requestService=$,this.logService=R,this.storageService=U,this._onTokenFailed=this._register(new _.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new _.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new _.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,w.getServiceMachineId)(M,W,U).then(x=>{const ee={"X-Client-Name":`${N.applicationName}${C.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(ee["X-Client-Commit"]=N.commit),ee}),this.session=new I(t,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,T.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,N){this.authToken={token:O,type:N}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,b.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(r,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,L.createCancelablePromise)(N=>(0,L.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O),$={},R=await this.request(N.toString(),{type:"GET",headers:$},[],i.CancellationToken.None);return(await(0,y.asJson)(R)||[]).map(({url:W,created:U})=>({ref:(0,b.relativePath)(N,N.with({path:W})),created:U*1e3}))}async resolveContent(O,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O,N).toString(),R={};R["Cache-Control"]="no-cache";const M=await this.request($,{type:"GET",headers:R},[],i.CancellationToken.None);return await(0,y.asText)(M)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),$={};await this.request(N,{type:"DELETE",headers:$},[],i.CancellationToken.None)}async read(O,N,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const R=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();$={...$},$["Cache-Control"]="no-cache",N&&($["If-None-Match"]=N.ref);const M=await this.request(R,{type:"GET",headers:$},[304],i.CancellationToken.None);let W=null;if(M.res.statusCode===304&&(W=N),W===null){const U=M.res.headers.etag;if(!U)throw new c.UserDataSyncStoreError("Server did not return the ref",R,"NoRef",M.res.statusCode,M.res.headers[c.HEADER_OPERATION_ID]);const x=await(0,y.asText)(M);if(!x&&M.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",R,"EmptyResponse",M.res.statusCode,M.res.headers[c.HEADER_OPERATION_ID]);W={ref:U,content:x}}return W}async write(O,N,$,R={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();R={...R},R["Content-Type"]=D.Mimes.text,$&&(R["If-Match"]=$);const W=await this.request(M,{type:"POST",data:N,headers:R},[],i.CancellationToken.None),U=W.res.headers.etag;if(!U)throw new c.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",W.res.statusCode,W.res.headers[c.HEADER_OPERATION_ID]);return U}async manifest(O,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,b.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",O&&(N["If-None-Match"]=O.ref);const R=await this.request($,{type:"GET",headers:N},[304],i.CancellationToken.None);let M=null;if(R.res.statusCode===304&&(M=O),!M){const U=R.res.headers.etag;if(!U)throw new c.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",R.res.statusCode,R.res.headers[c.HEADER_OPERATION_ID]);const x=await(0,y.asText)(R);if(!x&&R.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",$,"EmptyResponse",R.res.statusCode,R.res.headers[c.HEADER_OPERATION_ID]);x&&(M={...JSON.parse(x),ref:U})}const W=this.storageService.get(a,0);return W&&M&&W!==M.session&&this.clearSession(),M===null&&W&&this.clearSession(),M&&this.storageService.store(a,M.session,0,1),M}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":D.Mimes.text};await this.request(O,{type:"DELETE",headers:N},[],i.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(a,0),this.storageService.remove(n,0)}async request(O,N,$,R){if(!this.authToken)throw new c.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const M=await this.commonHeadersPromise;N.headers={...N.headers||{},...M,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:O,type:N.type,headers:{...N.headers,authorization:void 0}});let W;try{W=await this.session.request(O,N,R)}catch(G){if(!(G instanceof c.UserDataSyncStoreError)){let q="RequestFailed";const Y=(0,k.getErrorMessage)(G).toLowerCase();Y.includes("xhr timeout")?q="RequestTimeout":Y.includes("protocol")&&Y.includes("not supported")?q="RequestProtocolNotSupported":Y.includes("request path contains unescaped characters")?q="RequestPathNotEscaped":Y.includes("headers must be an object")?q="RequestHeadersNotObject":(0,k.isPromiseCanceledError)(G)&&(q="RequestCanceled"),G=new c.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,q,void 0,void 0)}throw this.logService.info("Request failed",O),G}const U=W.res.headers[c.HEADER_OPERATION_ID],x={url:O,status:W.res.statusCode,"execution-id":N.headers[c.HEADER_EXECUTION_ID],"operation-id":U},ee=(0,y.isSuccess)(W)||W.res.statusCode&&$.indexOf(W.res.statusCode)!==-1;if(ee?this.logService.trace("Request succeeded",x):this.logService.info("Request failed",x),W.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new c.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",W.res.statusCode,U);if(this._onTokenSucceed.fire(),W.res.statusCode===409)throw new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",W.res.statusCode,U);if(W.res.statusCode===410)throw new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",W.res.statusCode,U);if(W.res.statusCode===412)throw new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",W.res.statusCode,U);if(W.res.statusCode===413)throw new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",W.res.statusCode,U);if(W.res.statusCode===426)throw new c.UserDataSyncStoreError(`${N.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",W.res.statusCode,U);if(W.res.statusCode===429){const G=W.res.headers["retry-after"];throw G?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(G)*1e3)),new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",W.res.statusCode,U)):new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",W.res.statusCode,U)}if(!ee)throw new c.UserDataSyncStoreError("Server returned "+W.res.statusCode,O,"Unknown",W.res.statusCode,U);return W}addSessionHeaders(O){let N=this.storageService.get(n,0);N===void 0&&(N=(0,f.generateUuid)(),this.storageService.store(n,N,0,1)),O["X-Machine-Session-Id"]=N;const $=this.storageService.get(a,0);$!==void 0&&(O["X-User-Session-Id"]=$)}};d=de([J(1,v.IProductService),J(2,y.IRequestService),J(3,c.IUserDataSyncLogService),J(4,h.IEnvironmentService),J(5,S.IFileService),J(6,g.IStorageService)],d),e.UserDataSyncStoreClient=d;let m=class extends d{constructor(O,N,$,R,M,W,U){super(O.userDataSyncStore?.url,N,$,R,M,W,U);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};m=de([J(0,c.IUserDataSyncStoreManagementService),J(1,v.IProductService),J(2,y.IRequestService),J(3,c.IUserDataSyncLogService),J(4,h.IEnvironmentService),J(5,S.IFileService),J(6,g.IStorageService)],m),e.UserDataSyncStoreService=m;class I{constructor(O,N,$,R){this.limit=O,this.interval=N,this.requestService=$,this.logService=R,this.requests=[],this.startTime=void 0}request(O,N,$){if(this.isExpired()&&this.reset(),N.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new c.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(N,$)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=I}),define(ne[236],ie([0,1,3,60,26,23,22,232,24,63,64]),function(Q,e,L,i,k,_,T,D,C,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends D.UserDataAutoSyncService{constructor(p,h,S,v,y,w,g,c,l,r,a){super(p,h,S,v,y,g,c,l,r,a);this._register(L.Event.debounce(L.Event.any(L.Event.map(w.onDidFocusWindow,()=>"windowFocus"),L.Event.map(w.onDidOpenWindow,()=>"windowOpen")),(n,t)=>n?[...n,t]:[t],1e3)(n=>this.triggerSync(n,!0,!1)))}};E=de([J(0,k.IProductService),J(1,C.IUserDataSyncStoreManagementService),J(2,C.IUserDataSyncStoreService),J(3,C.IUserDataSyncEnablementService),J(4,C.IUserDataSyncService),J(5,i.INativeHostService),J(6,C.IUserDataSyncLogService),J(7,b.IUserDataSyncAccountService),J(8,T.ITelemetryService),J(9,P.IUserDataSyncMachinesService),J(10,_.IStorageService)],E),e.UserDataAutoSyncService=E}),define(ne[237],ie([0,1,5,3,2]),function(Q,e,L,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class _ extends k.Disposable{constructor({onDidOpenWindow:D,onDidFocusWindow:C,getActiveWindowId:b}){super();this.disposables=this._register(new k.DisposableStore),i.Event.latch(i.Event.any(D,C))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,L.createCancelablePromise)(()=>b()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(D){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=D}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=_}),define(ne[65],ie([0,1,50,5,9,15,20,123,249,250]),function(Q,e,L,i,k,_,T,D,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class P extends Error{constructor(r,a){let n=a.message;switch(r){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=r,this.cause=a}}e.ExtractError=P;function E(l){const r=l.externalFileAttributes>>16||33188;return[448,56,7].map(a=>r&a).reduce((a,n)=>a+n,r&61440)}function f(l){if(l instanceof P)return l;let r;return/end of central directory record signature not found/.test(l.message)&&(r="CorruptZip"),new P(r,l)}function p(l,r,a,n,t,s){const o=k.dirname(r),u=k.join(n,o);if(!u.startsWith(n))return Promise.reject(new Error(D.localize(0,null,r)));const d=k.join(n,r);let m;return s.onCancellationRequested(()=>{m&&m.destroy()}),Promise.resolve(T.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((I,A)=>{if(!s.isCancellationRequested)try{m=(0,L.createWriteStream)(d,{mode:a}),m.once("close",()=>I()),m.once("error",A),l.once("error",A),l.pipe(m)}catch(O){A(O)}}))}function h(l,r,a,n){let t=(0,i.createCancelablePromise)(()=>Promise.resolve()),s=0;return n.onCancellationRequested(()=>{t.cancel(),l.close()}),new Promise((o,u)=>{const d=new i.Sequencer,m=I=>{I.isCancellationRequested||(s++,l.readEntry())};l.once("error",u),l.once("close",()=>t.then(()=>{n.isCancellationRequested||l.entryCount===s?o():u(new P("Incomplete",new Error(D.localize(1,null,s,l.entryCount))))},u)),l.readEntry(),l.on("entry",I=>{if(n.isCancellationRequested)return;if(!a.sourcePathRegex.test(I.fileName)){m(n);return}const A=I.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(A)){const $=k.join(r,A);t=(0,i.createCancelablePromise)(R=>T.Promises.mkdir($,{recursive:!0}).then(()=>m(R)).then(void 0,u));return}const O=v(l,I),N=E(I);t=(0,i.createCancelablePromise)($=>d.queue(()=>O.then(R=>p(R,A,N,r,a,$).then(()=>m($)))).then(null,u))})})}function S(l,r=!1){return new Promise((a,n)=>{(0,C.open)(l,r?{lazyEntries:!0}:void 0,(t,s)=>{t?n(f(t)):a((0,_.assertIsDefined)(s))})})}function v(l,r){return new Promise((a,n)=>{l.openReadStream(r,(t,s)=>{t?n(f(t)):a((0,_.assertIsDefined)(s))})})}function y(l,r){return new Promise((a,n)=>{const t=new b.ZipFile;r.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const s=(0,L.createWriteStream)(l);t.outputStream.pipe(s),t.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>a(l))})}e.zip=y;function w(l,r,a={},n){const t=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let s=S(l,!0);return a.overwrite&&(s=s.then(o=>T.Promises.rm(r).then(()=>o))),s.then(o=>h(o,r,{sourcePathRegex:t},n))}e.extract=w;function g(l,r){return S(l).then(a=>new Promise((n,t)=>{a.on("entry",s=>{s.fileName===r&&v(a,s).then(o=>n(o),o=>t(o))}),a.once("close",()=>t(new Error(D.localize(2,null,r))))}))}function c(l,r){return g(l,r).then(a=>new Promise((n,t)=>{const s=[];a.once("error",t),a.on("data",o=>s.push(o)),a.on("end",()=>n(Buffer.concat(s)))}))}e.buffer=c}),define(ne[238],ie([0,1,65,132]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(_){return(0,L.buffer)(_,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,i.localize)(0,null))}})}e.getManifest=k}),define(ne[239],ie([0,1,17,5,8,2,16,9,4,19,61,7,30,20,65,133,13,29,33,154,14,10,26]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h,S,v,y,w,g,c,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let a=class extends _.Disposable{constructor(t,s,o,u,d){super();this.beforeRemovingExtension=t,this.fileService=s,this.logService=o,this.environmentService=u,this.productService=d,this._devSystemExtensionsPath=null,this.systemExtensionsPath=u.builtinExtensionsPath,this.extensionsPath=u.extensionsPath,this.uninstalledPath=D.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new i.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const s=[];(t===null||t===0)&&s.push(this.scanSystemExtensions().then(null,o=>Promise.reject(new y.ExtensionManagementError(this.joinErrors(o).message,y.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&s.push(this.scanUserExtensions(!0).then(null,o=>Promise.reject(new y.ExtensionManagementError(this.joinErrors(o).message,y.ExtensionManagementErrorCode.Internal))));try{const o=await Promise.all(s);return(0,L.flatten)(o)}catch(o){throw this.joinErrors(o)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[s,o]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return o=o.filter(u=>!s[new w.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).key()]),t&&(o=(0,w.groupByExtension)(o,d=>d.identifier).map(d=>d.sort((m,I)=>P.rcompare(m.manifest.version,I.manifest.version))[0])),this.logService.trace("Scanned user extensions:",o.length),o}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,s,o,u){const d=t.key(),m=D.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),I=D.join(this.extensionsPath,d);try{await p.Promises.rm(I)}catch{try{await p.Promises.rm(I)}catch{}throw new y.ExtensionManagementError((0,S.localize)(0,null,I,t.id),y.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,s,m,u);let A=await this.scanExtension(E.URI.file(m),1);if(!A)throw new Error((0,S.localize)(1,null,m));await this.storeMetadata(A,{...o,installedTimestamp:Date.now()});try{await this.rename(t,m,I,Date.now()+2*60*1e3),this.logService.info("Renamed to",I)}catch(O){try{await p.Promises.rm(m)}catch{}if(O.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(O)}. Deleted from extracted location`,m),O}try{A=await this.scanExtension(E.URI.file(I),1)}catch{}if(A)return A;throw new Error((0,S.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,s){return this.setMetadata(t,s),await this.storeMetadata(t,{...s,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const o=D.join(t.location.fsPath,"package.json"),u=await p.Promises.readFile(o,"utf8"),{manifest:d}=await this.parseManifest(u);return d.__metadata=s,await p.Promises.writeFile(o,JSON.stringify(d,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const s=t.map(o=>new w.ExtensionIdentifierWithVersion(o.identifier,o.manifest.version));await this.withUninstalledExtensions(o=>{s.forEach(u=>o[u.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(u=>delete u[t.key()]);const o=(await this.scanExtensions(1)).find(u=>new w.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).equals(t))||null;return o?(await this.storeMetadata(o,{installedTimestamp:Date.now()}),this.scanExtension(o.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await p.Promises.readFile(this.uninstalledPath,"utf8")}catch(u){if(u.code!=="ENOENT")throw u}let o={};if(s)try{o=JSON.parse(s)}catch{}return t&&(t(o),Object.keys(o).length?await p.Promises.writeFile(this.uninstalledPath,JSON.stringify(o)):await p.Promises.rm(this.uninstalledPath)),o})}async removeExtension(t,s){this.logService.trace(`Deleting ${s} extension from disk`,t.identifier.id,t.location.fsPath),await p.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new w.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,s,o,u){this.logService.trace(`Started extracting the extension from ${s} to ${o}`);try{await p.Promises.rm(o)}catch(d){throw new y.ExtensionManagementError(this.joinErrors(d).message,y.ExtensionManagementErrorCode.Delete)}try{await(0,h.extract)(s,o,{sourcePath:"extension",overwrite:!0},u),this.logService.info(`Extracted extension to ${o}:`,t.id)}catch(d){try{await p.Promises.rm(o)}catch{}let m=y.ExtensionManagementErrorCode.Extract;throw d instanceof h.ExtractError&&(d.type==="CorruptZip"?m=y.ExtensionManagementErrorCode.CorruptZip:d.type==="Incomplete"&&(m=y.ExtensionManagementErrorCode.IncompleteZip)),new y.ExtensionManagementError(d.message,m)}}async rename(t,s,o,u){try{await p.Promises.rename(s,o)}catch(d){if(C.isWindows&&d&&d.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${s} to ${o} with 'EPERM' error. Trying again...`,t.id),this.rename(t,s,o,u);throw new y.ExtensionManagementError(d.message||(0,S.localize)(3,null,s,o),d.code||y.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const s=this.scanDevSystemExtensions(),[o,u]=await Promise.all([t,s]);return[...o,...u]}async scanExtensionsInDir(t,s){const o=new i.Limiter(10),u=await this.fileService.resolve(E.URI.file(t));return u.children?(await Promise.all(u.children.filter(m=>m.isDirectory).map(m=>o.queue(async()=>s===1&&(0,b.basename)(m.resource).indexOf(".")===0?null:this.scanExtension(m.resource,s))))).filter(m=>m&&m.identifier):[]}async scanExtension(t,s){try{const o=await this.fileService.resolve(t);if(o.children){const{manifest:u,metadata:d}=await this.readManifest(t.fsPath),m=o.children.find(({name:N})=>/^readme(\.txt|\.md|)$/i.test(N))?.resource,I=o.children.find(({name:N})=>/^changelog(\.txt|\.md|)$/i.test(N))?.resource,A={id:(0,w.getGalleryExtensionId)(u.publisher,u.name)},O={type:s,identifier:A,manifest:u,location:t,readmeUrl:m,changelogUrl:I,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return this.setMetadata(O,d),O}}catch(o){s!==0&&this.logService.trace(o)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(o=>t.some(u=>(0,w.areSameExtensions)(o.identifier,{id:u})))}else return[]}setMetadata(t,s){t.publisherDisplayName=s?.publisherDisplayName||null,t.publisherId=s?.publisherId||null,t.identifier.uuid=s?.id,t.isMachineScoped=!!s?.isMachineScoped,t.isPreReleaseVersion=!!s?.isPreReleaseVersion,t.preRelease=!!s?.preRelease,t.isBuiltin=t.type===0||!!s?.isBuiltin,t.installedTimestamp=s?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),o=new Set;for(const m of s)t[new w.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).key()]||o.add(m.identifier.id.toLowerCase());const u=(0,w.groupByExtension)(s,m=>m.identifier);await i.Promises.settled(u.map(async m=>{const I=m.sort((A,O)=>P.rcompare(A.manifest.version,O.manifest.version))[0];o.has(I.identifier.id.toLowerCase())||await this.beforeRemovingExtension(I)}));const d=s.filter(m=>t[new w.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).key()]);await i.Promises.settled(d.map(m=>this.removeUninstalledExtension(m)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),s=[],o=(0,w.groupByExtension)(t,u=>u.identifier);s.push(...(0,L.flatten)(o.map(u=>u.sort((d,m)=>P.rcompare(d.manifest.version,m.manifest.version)).slice(1)))),await i.Promises.settled(s.map(u=>this.removeExtension(u,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const s=Array.isArray(t)?t:[t];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,u)=>new Error(`${o.message}${o.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=D.normalize(D.join(T.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const s=[p.Promises.readFile(D.join(t,"package.json"),"utf8").then(m=>this.parseManifest(m)),p.Promises.readFile(D.join(t,"package.nls.json"),"utf8").then(void 0,m=>m.code!=="ENOENT"?Promise.reject(m):"{}").then(m=>JSON.parse(m))],[{manifest:o,metadata:u},d]=await Promise.all(s);return{manifest:(0,g.localizeManifest)(o,d),metadata:u}}parseManifest(t){return new Promise((s,o)=>{try{const u=JSON.parse(t),d=u.__metadata||null;s({manifest:u,metadata:d})}catch{o(new Error((0,S.localize)(4,null)))}})}};a=de([J(1,c.IFileService),J(2,l.ILogService),J(3,v.INativeEnvironmentService),J(4,r.IProductService)],a),e.ExtensionsScanner=a}),define(ne[240],ie([0,1,37,8,16,9,4,31,19,61,7,30,20,65,131,79,13,201,29,33,184,173,238,185,239,215,76,14,6,10,26,22,34]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h,S,v,y,w,g,c,l,r,a,n,t,s,o,u,d,m,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let O=class extends y.AbstractExtensionManagementService{constructor(U,x,ee,G,q,Y,H,Z,K){super(U,x,ee,Z);this.environmentService=G,this.downloadService=q,this.fileService=H;const F=this._register(Y.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(Y.createInstance(n.ExtensionsScanner,B=>F.postUninstall(B))),this.manifestCache=this._register(new a.ExtensionsManifestCache(G,this)),this.extensionsDownloader=this._register(Y.createInstance(c.ExtensionsDownloader));const j=this._register(new t.ExtensionsWatcher(this,H,G,ee,K));this._register(j.onDidChangeExtensionsByAnotherSource(({added:B,removed:z})=>{B.length&&this._onDidInstallExtensions.fire(B.map(V=>({identifier:V.identifier,operation:1,local:V}))),z.forEach(V=>this._onDidUninstallExtension.fire({identifier:V}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const U=await this.isAlpineLinux(),x=(0,w.getTargetPlatform)(U?"alpine":T.platform,D.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",x),x})()),this._targetPlatformPromise}async isAlpineLinux(){if(!T.isLinux)return!1;let U;try{U=(await this.fileService.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{U=(await this.fileService.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(ee){this.logService.debug("Error while getting the os-release file.",(0,i.getErrorMessage)(ee))}}return!!U&&(U.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const x=await this.collectFiles(U),ee=await(0,p.zip)((0,C.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)()).fsPath,x);return P.URI.file(ee)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const x=await this.downloadVsix(U),ee=_.resolve(x.fsPath);return(0,r.getManifest)(ee)}getInstalled(U=null){return this.extensionsScanner.scanExtensions(U)}async install(U,x={}){this.logService.trace("ExtensionManagementService#install",U.toString());const ee=await this.downloadVsix(U),G=await(0,r.getManifest)(_.resolve(ee.fsPath));if(G.engines&&G.engines.vscode&&!(0,s.isEngineValid)(G.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,g.getGalleryExtensionId)(G.publisher,G.name),this.productService.version));return this.installExtension(G,ee,x)}async updateMetadata(U,x){this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id);const ee={...U.manifest.__metadata||{},...x};return x.isPreReleaseVersion&&(ee.preRelease=!0),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,ee),this.manifestCache.invalidate(),U}async updateExtensionScope(U,x){return this.logService.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},isMachineScoped:x}),this.manifestCache.invalidate(),U}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(U){if(U.scheme===k.Schemas.file)return U;const x=(0,C.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)());return await this.downloadService.download(U,x),x}createInstallExtensionTask(U,x,ee){return P.URI.isUri(x)?new R(U,x,ee,this.galleryService,this.extensionsScanner,this.logService):new $(x,ee,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(U,x){return new M(U,x,this.extensionsScanner)}async collectFiles(U){const x=async G=>{let q=await f.Promises.readdir(G);q=q.map(Z=>_.join(G,Z));const Y=await Promise.all(q.map(Z=>f.Promises.stat(Z)));let H=Promise.resolve([]);return Y.forEach((Z,K)=>{const F=q[K];Z.isFile()&&(H=H.then(j=>[...j,F])),Z.isDirectory()&&(H=H.then(j=>x(F).then(B=>[...j,...B])))}),H};return(await x(U.location.fsPath)).map(G=>({path:`extension/${_.relative(U.location.fsPath,G)}`,localPath:G}))}};O=de([J(0,w.IExtensionGalleryService),J(1,I.ITelemetryService),J(2,d.ILogService),J(3,v.INativeEnvironmentService),J(4,S.IDownloadService),J(5,u.IInstantiationService),J(6,o.IFileService),J(7,m.IProductService),J(8,A.IUriIdentityService)],O),e.ExtensionManagementService=O;class N extends y.AbstractExtensionTask{constructor(U,x,ee,G){super();this.identifier=U,this.source=x,this.extensionsScanner=ee,this.logService=G,this._operation=2}get operation(){return this._operation}async installExtension(U,x){try{const ee=await this.unsetUninstalledAndGetLocal(U.identifierWithVersion);if(ee)return U.metadata?this.extensionsScanner.saveMetadataForLocalExtension(ee,{...ee.manifest.__metadata||{},...U.metadata}):ee}catch{throw T.isMacintosh?new w.ExtensionManagementError(h.localize(1,null),w.ExtensionManagementErrorCode.Internal):new w.ExtensionManagementError(h.localize(2,null),w.ExtensionManagementErrorCode.Internal)}return this.extract(U,x)}async unsetUninstalledAndGetLocal(U){if(!await this.isUninstalled(U))return null;this.logService.trace("Removing the extension from uninstalled list:",U.id);const ee=await this.extensionsScanner.setInstalled(U);return this.logService.info("Removed the extension from uninstalled list:",U.id),ee}async isUninstalled(U){return!!(await this.extensionsScanner.getUninstalledExtensions())[U.key()]}async extract({zipPath:U,identifierWithVersion:x,metadata:ee},G){let q=await this.extensionsScanner.extractUserExtension(x,U,ee,G);return this.logService.info("Extracting completed.",x.id),q}}class $ extends N{constructor(U,x,ee,G,q){super(U.identifier,U,G,q);this.gallery=U,this.options=x,this.extensionsDownloader=ee}async doRun(U){const ee=(await this.extensionsScanner.scanExtensions(null)).find(q=>(0,g.areSameExtensions)(q.identifier,this.gallery.identifier));ee&&(this._operation=3);const G=await this.downloadInstallableExtension(this.gallery,this._operation);G.metadata.isMachineScoped=this.options.isMachineScoped||ee?.isMachineScoped,G.metadata.isBuiltin=this.options.isBuiltin||ee?.isBuiltin,G.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,G.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:ee?.preRelease;try{const q=await this.installExtension(G,U);return ee&&b.neq(ee.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(ee),q}catch(q){throw await this.deleteDownloadedVSIX(G.zipPath),q}}async deleteDownloadedVSIX(U){try{await this.extensionsDownloader.delete(P.URI.file(U))}catch(x){this.logService.warn("Error while deleting the downloaded vsix",U.toString(),(0,i.getErrorMessage)(x))}}async downloadInstallableExtension(U,x){const ee={id:U.identifier.uuid,publisherId:U.publisherId,publisherDisplayName:U.publisherDisplayName};let G;try{this.logService.trace("Started downloading extension:",U.identifier.id),G=(await this.extensionsDownloader.downloadExtension(U,x)).fsPath,this.logService.info("Downloaded extension:",U.identifier.id,G)}catch(q){throw new w.ExtensionManagementError((0,y.joinErrors)(q).message,w.ExtensionManagementErrorCode.Download)}try{const q=await(0,r.getManifest)(G);return{zipPath:G,identifierWithVersion:new g.ExtensionIdentifierWithVersion(U.identifier,q.version),metadata:ee}}catch(q){throw await this.deleteDownloadedVSIX(G),new w.ExtensionManagementError((0,y.joinErrors)(q).message,w.ExtensionManagementErrorCode.Invalid)}}}class R extends N{constructor(U,x,ee,G,q,Y){super({id:(0,g.getGalleryExtensionId)(U.publisher,U.name)},x,q,Y);this.manifest=U,this.location=x,this.options=ee,this.galleryService=G}async doRun(U){const x=new g.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),G=(await this.extensionsScanner.scanExtensions(1)).find(Y=>(0,g.areSameExtensions)(this.identifier,Y.identifier)),q=await this.getMetadata(this.identifier.id,this.manifest.version,U);if(q.isMachineScoped=this.options.isMachineScoped||G?.isMachineScoped,q.isBuiltin=this.options.isBuiltin||G?.isBuiltin,G)if(this._operation=3,x.equals(new g.ExtensionIdentifierWithVersion(G.identifier,G.manifest.version)))try{await this.extensionsScanner.removeExtension(G,"existing")}catch{throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else b.gt(G.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(G);else{const Y=await this.unsetUninstalledAndGetLocal(x);if(Y)try{await this.extensionsScanner.removeExtension(Y,"existing")}catch{throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:_.resolve(this.location.fsPath),identifierWithVersion:x,metadata:q},U)}async getMetadata(U,x,ee){try{let[G]=await this.galleryService.getExtensions([{id:U,version:x}],ee);if(G||([G]=await this.galleryService.getExtensions([{id:U}],ee)),G)return{id:G.identifier.uuid,publisherDisplayName:G.publisherDisplayName,publisherId:G.publisherId,isPreReleaseVersion:G.properties.isPreReleaseVersion,preRelease:G.properties.isPreReleaseVersion}}catch{}return{}}}class M extends y.AbstractExtensionTask{constructor(U,x,ee){super();this.extension=U,this.options=x,this.extensionsScanner=ee}async doRun(U){const x=[],ee=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const G=new g.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);x.push(...ee.filter(q=>G.equals(new g.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version))))}else x.push(...ee.filter(G=>(0,g.areSameExtensions)(G.identifier,this.extension.identifier)));if(!x.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...x),this.options.remove)for(const G of x)try{U.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(G)}catch(q){throw new Error(h.localize(6,null,(0,L.toErrorMessage)(q)))}}}}),define(ne[241],ie([0,1,81,55,32,18,8,3,2,9,4,30,36,71,251]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class S{constructor(I,A=""){this.debugLabel=A,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,T.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(I,A){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,A)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(I){const A=O=>{this.traceSocketEvent("read",O),I(_.VSBuffer.wrap(O))};return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(I){const A=O=>{this.traceSocketEvent("close",{hadError:O}),I({type:0,hadError:O,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(I){const A=()=>{this.traceSocketEvent("nodeEndReceived"),I()};return this.socket.on("end",A),{dispose:()=>this.socket.off("end",A)}}write(I){if(!this.socket.destroyed)try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,T.onUnexpectedError)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,T.onUnexpectedError)(A)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,A)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=S;var v;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var y;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(y||(y={}));class w extends C.Disposable{constructor(I,A,O,N){super();this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:A,inflateBytesLength:O?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new g(this,A,O,N,this._onData,($,R)=>this._write($,R))),this._register(this._flowManager.onError($=>{console.error($),(0,T.onUnexpectedError)($),this._onClose.fire({type:0,hadError:!0,error:$})})),this._incomingData=new p.ChunkStream,this._register(this.socket.onData($=>this._acceptChunk($))),this._register(this.socket.onClose($=>this._onClose.fire($)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(I,A){this.socket.traceSocketEvent(I,A)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){this._flowManager.writeMessage(I)}_write(I,A){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let O=2;I.byteLength<126?O+=0:I.byteLength<2**16?O+=2:O+=8;const N=_.VSBuffer.alloc(O);if(A?N.writeUInt8(194,0):N.writeUInt8(130,0),I.byteLength<126)N.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){N.writeUInt8(126,1);let $=1;N.writeUInt8(I.byteLength>>>8&255,++$),N.writeUInt8(I.byteLength>>>0&255,++$)}else{N.writeUInt8(127,1);let $=1;N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(I.byteLength>>>24&255,++$),N.writeUInt8(I.byteLength>>>16&255,++$),N.writeUInt8(I.byteLength>>>8&255,++$),N.writeUInt8(I.byteLength>>>0&255,++$)}this.socket.write(_.VSBuffer.concat([N,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const A=this._incomingData.peek(this._state.readLen),O=A.readUInt8(0),N=(O&128)>>>7,$=(O&64)>>>6,R=A.readUInt8(1),M=(R&128)>>>7,W=R&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(W===126?2:0)+(W===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean($)),this._state.firstFrameOfMessage=Boolean(N),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const A=this._incomingData.read(this._state.readLen),O=A.readUInt8(1),N=(O&128)>>>7;let $=O&127,R=1;$===126?$=A.readUInt8(++R)*2**8+A.readUInt8(++R):$===127&&($=A.readUInt8(++R)*0+A.readUInt8(++R)*0+A.readUInt8(++R)*0+A.readUInt8(++R)*0+A.readUInt8(++R)*2**24+A.readUInt8(++R)*2**16+A.readUInt8(++R)*2**8+A.readUInt8(++R));let M=0;N&&(M=A.readUInt8(++R)*2**24+A.readUInt8(++R)*2**16+A.readUInt8(++R)*2**8+A.readUInt8(++R)),this._state.state=3,this._state.readLen=$,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const A=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",A),r(A,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",A),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(A,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class g extends C.Disposable{constructor(I,A,O,N,$,R){super();this._tracer=I,this._onData=$,this._writeFn=R,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,A?(this._zlibInflateStream=this._register(new c(this._tracer,N,O,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:_.VSBuffer.alloc(0)}writeMessage(I){this._writeQueue.push(I),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const I=this._writeQueue.shift();if(this._zlibDeflateStream){const A=await this._deflateMessage(this._zlibDeflateStream,I);this._writeFn(A,!0)}else this._writeFn(I,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(I,A){return new Promise((O,N)=>{I.write(A),I.flush($=>O($))})}acceptFrame(I,A,O){this._readQueue.push({data:I,isCompressed:A,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const I=this._readQueue.shift();if(this._zlibInflateStream&&I.isCompressed){const A=await this._inflateFrame(this._zlibInflateStream,I.data,I.isLastFrameOfMessage);this._onData.fire(A)}else this._onData.fire(I.data)}this._isProcessingReadQueue=!1}}_inflateFrame(I,A,O){return new Promise((N,$)=>{I.write(A),O&&I.write(_.VSBuffer.fromByteArray([0,0,255,255])),I.flush(R=>N(R))})}}class c extends C.Disposable{constructor(I,A,O,N){super();this._tracer=I,this._recordInflateBytes=A,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=h.createInflateRaw(N),this._zlibInflate.on("error",$=>{this._tracer.traceSocketEvent("zlibInflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibInflate.on("data",$=>{this._tracer.traceSocketEvent("zlibInflateData",$),this._pendingInflateData.push(_.VSBuffer.wrap($))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?_.VSBuffer.concat(this._recordedInflateBytes):_.VSBuffer.alloc(0)}write(I){this._recordInflateBytes&&this._recordedInflateBytes.push(I.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",I),this._zlibInflate.write(I.buffer)}flush(I){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const A=_.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,I(A)})}}class l extends C.Disposable{constructor(I,A){super();this._tracer=I,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(_.VSBuffer.wrap(O))})}write(I){this._tracer.traceSocketEvent("zlibDeflateWrite",I.buffer),this._zlibDeflate.write(I.buffer)}flush(I){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let A=_.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,A=A.slice(0,A.byteLength-4),I(A)})}}function r(m,I){if(I===0)return;let A=m.byteLength>>>2;for(let W=0;W<A;W++){const U=m.readUInt32BE(W*4);m.writeUInt32BE(U^I,W*4)}let O=A*4,N=m.byteLength-O;const $=I>>>24&255,R=I>>>16&255,M=I>>>8&255;N>=1&&m.writeUInt8(m.readUInt8(O)^$,O),N>=2&&m.writeUInt8(m.readUInt8(O+1)^R,O+1),N>=3&&m.writeUInt8(m.readUInt8(O+2)^M,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function n(){const m=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let I;return e.XDG_RUNTIME_DIR?I=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):I=(0,b.join)((0,k.tmpdir)(),`vscode-ipc-${m}.sock`),s(I),I}e.createRandomIPCHandle=n;function t(m,I,A){const O=(0,L.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${A}-${I}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${A}-${I}.sock`):N=(0,b.join)(m,`${A}-${I}.sock`),s(N),N}e.createStaticIPCHandle=t;function s(m){const I=a[P.platform];typeof I=="number"&&m.length>=I&&console.warn(`WARNING: IPC handle "${m}" is longer than ${I} chars, try a shorter --user-data-dir`)}class o extends f.IPCServer{constructor(I){super(o.toClientConnectionEvent(I));this.server=I}static toClientConnectionEvent(I){const A=D.Event.fromNodeEventEmitter(I,"connection");return D.Event.map(A,O=>({protocol:new p.Protocol(new S(O,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function u(m){return new Promise((I,A)=>{const O=(0,i.createServer)();O.on("error",A),O.listen(m,()=>{O.removeListener("error",A),I(new o(O))})})}e.serve=u;function d(m,I){return new Promise((A,O)=>{const N=(0,i.createConnection)(m,()=>{N.removeListener("error",O),A(p.Client.fromSocket(new S(N,`ipc-client${I}`),I))});N.once("error",O)})}e.connect=d}),define(ne[242],ie([0,1,55,241]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,_,T,D,C){const b=E=>C(E,void 0),P=L.createConnection({host:k,port:_},()=>{P.removeListener("error",b);const E=Buffer.alloc(16);for(let S=0;S<16;S++)E[S]=Math.round(Math.random()*256);const f=E.toString("base64"),p=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${_}/?${T}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];P.write(p.join(`\r
`)+`\r
\r
`);const h=S=>{S.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",h),C(void 0,new i.NodeSocket(P,D)))};P.on("data",h)});P.setNoDelay(!0),P.once("error",b)}}}),define(ne[243],ie([0,1,55,113,242,5,2,21,10,26,182,62,90]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(w,g,c,l,r){let a;for(let n=3;n&&(a&&a.dispose(),a=await new h(w,g,c,l,r).waitForReady(),!(r&&i.BROWSER_RESTRICTED_PORTS[r]||!i.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));n--);return a}class h extends T.Disposable{constructor(g,c,l,r,a){super();this.defaultTunnelHost=c,this.suggestedLocalPort=a,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=g,this._server=L.createServer(),this._barrier=new _.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=n=>this._onConnection(n),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(c=>{c()})}async waitForReady(){let g=await(0,i.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),c=null;return this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address(),c||(g=0,this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(g){g.pause();const c=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,P.connectRemoteAgentTunnel)(this._options,c,this.tunnelRemotePort),r=l.getSocket().socket,a=l.readEntireBuffer();l.dispose(),a.byteLength>0&&g.write(a.buffer),g.on("end",()=>{this._socketsDispose.delete(g.localAddress),r.end()}),g.on("close",()=>r.end()),g.on("error",()=>{this._socketsDispose.delete(g.localAddress),r.destroy()}),r.on("end",()=>g.end()),r.on("close",()=>g.end()),r.on("error",()=>{g.destroy()}),g.pipe(r),r.pipe(g),this._socketsDispose.set(g.localAddress,()=>{g.end(),r.end()})}}let S=class extends E.AbstractTunnelService{constructor(g,c,l,r,a){super(c);this.socketFactory=g,this.signService=l,this.productService=r,this.configurationService=a}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(g,c,l,r,a,n,t){const s=this.getTunnelFromMap(c,l);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,c,l,r,a,n,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${l} on local port ${r}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:g,signService:this.signService,logService:this.logService,ipcLogger:null},u=p(o,this.defaultTunnelHost,c,l,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(c,l,u),u}}};S=de([J(1,C.ILogService),J(2,f.ISignService),J(3,b.IProductService),J(4,D.IConfigurationService)],S),e.BaseTunnelService=S;let v=class extends S{constructor(g,c,l,r){super(k.nodeSocketFactory,g,c,l,r)}};v=de([J(0,C.ILogService),J(1,f.ISignService),J(2,b.IProductService),J(3,D.IConfigurationService)],v),e.TunnelService=v;let y=class extends T.Disposable{constructor(g,c,l,r){super();this.logService=g,this.productService=c,this.signService=l,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(g,c,l,r,a,n,t,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${r} on local port ${a}.`),!this._tunnelServices.has(g)){const o=new v(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(g,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(g))})}return this._tunnelServices.get(g).openTunnel(c,l,r,a,n,t,s)}};y=de([J(0,C.ILogService),J(1,b.IProductService),J(2,f.ISignService),J(3,D.IConfigurationService)],y),e.SharedTunnelsService=y}),define(ne[252],ie([0,1,72,32,37,8,2,16,19,7,36,117,178,159,179,170,171,172,157,161,21,180,78,200,79,190,13,194,196,204,29,160,202,240,80,155,14,175,177,51,6,167,83,168,169,59,186,10,84,60,85,26,189,43,23,198,199,22,91,92,93,44,205,206,94,208,214,96,97,24,63,228,230,231,64,229,233,234,235,236,237,90,195,62,243,187,188,89,193,203,34,216,4,217,164]),function(Q,e,L,i,k,_,T,D,C,b,P,E,f,p,h,S,v,y,w,g,c,l,r,a,n,t,s,o,u,d,m,I,A,O,N,$,R,M,W,U,x,ee,G,q,Y,H,Z,K,F,j,B,z,V,te,se,ce,he,me,ve,ge,we,De,Ee,ke,Le,Fe,$e,ze,re,ae,le,be,Ie,Me,Te,Ne,Ae,Ue,X,oe,ue,fe,ye,pe,Ce,Pe,Re,_e,qe,Je,Xe,It,Pt,Dt,pt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Rt extends T.Disposable{constructor(Se){super();this.configuration=Se,this.server=this._register(new E.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const Se=()=>this.dispose();process.once("exit",Se),L.ipcRenderer.once("vscode:electron-main->shared-process=exit",Se);const Oe="vscode:electron-main->shared-process=disposeWorker",je=(He,We)=>this.onDisposeWorker(We);L.ipcRenderer.on(Oe,je),this._register((0,T.toDisposable)(()=>L.ipcRenderer.removeListener(Oe,je)))}onDisposeWorker(Se){this.sharedProcessWorkerService?.disposeWorker(Se)}async open(){const Se=await this.initServices();(0,ae.registerConfiguration)(),Se.invokeFunction(Oe=>{const je=Oe.get(K.ILogService);je.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(je)}),this._register((0,T.combinedDisposable)(Se.createInstance(f.CodeCacheCleaner,this.configuration.codeCachePath),Se.createInstance(h.LanguagePackCachedDataCleaner),Se.createInstance(y.StorageDataCleaner,this.configuration.backupWorkspacesPath),Se.createInstance(v.LogsDataCleaner),Se.createInstance(S.LocalizationsUpdater),Se.createInstance(p.ExtensionsCleaner)))}async initServices(){const Se=new G.ServiceCollection,Oe={_serviceBrand:void 0,...B.default};Se.set(z.IProductService,Oe);const je=new P.StaticRouter(Be=>Be==="main"),He=new q.MessagePortMainProcessService(this.server,je);Se.set(Y.IMainProcessService,He);const We=new o.SharedProcessEnvironmentService(this.configuration.args,Oe);Se.set(s.INativeEnvironmentService,We);const rt=new F.LogLevelChannelClient(this.server.getChannel("logLevel",je)),Qe=new F.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,He.getChannel("logger"));Se.set(K.ILoggerService,Qe);const at=this._register(new K.MultiplexLogService([this._register(new K.ConsoleLogger(this.configuration.logLevel)),this._register(Qe.createLogger((0,C.joinPath)(b.URI.file(We.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new F.FollowerLogService(rt,at));Se.set(K.ILogService,Ge),this.sharedProcessWorkerService=new qe.SharedProcessWorkerService(Ge,Oe,We),Se.set(_e.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ke=this._register(new M.FileService(Ge));Se.set(R.IFileService,Ke);const ct=this._register(new W.DiskFileSystemProvider(Ge));Ke.registerProvider(D.Schemas.file,ct);const lt=this._register(new Dt.FileUserDataProvider(D.Schemas.file,this._register(new pt.DiskFileSystemProviderClient(He.getChannel(pt.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Pt.isLinux})),D.Schemas.userData,Ge));Ke.registerProvider(D.Schemas.userData,lt);const xe=this._register(new l.ConfigurationService(We.settingsResource,Ke));Se.set(c.IConfigurationService,xe);const tt=new ce.NativeStorageService(void 0,He,We);Se.set(se.IStorageService,tt),this._register((0,T.toDisposable)(()=>tt.flush())),await Promise.all([xe.initialize(),tt.initialize()]),Se.set(Xe.IUriIdentityService,new It.UriIdentityService(Ke)),Se.set(te.IRequestService,new U.SyncDescriptor(V.RequestService)),Se.set(w.IChecksumService,new U.SyncDescriptor(g.ChecksumService));const st=P.ProxyChannel.toService(He.getChannel("nativeHost"),{context:this.configuration.windowId});Se.set(j.INativeHostService,st),Se.set(n.IDownloadService,new U.SyncDescriptor(t.DownloadService));const ut=this._register(new ue.ActiveWindowManager(st)),ht=new P.StaticRouter(Be=>ut.getActiveClientId().then(dt=>Be===dt));Se.set(N.IExtensionRecommendationNotificationService,new $.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ht)));const Tt=new Je.AssignmentService(this.configuration.machineId,xe,Oe);let nt;const Ze=[];if((0,De.supportsTelemetry)(Oe,We)){const Be=new ge.TelemetryLogAppender(Qe,We);Ze.push(Be);const{appRoot:dt,extensionsPath:_t,installSourcePath:At}=We;if(Oe.aiConfig&&Oe.aiConfig.asimovKey){const ot=await Tt.getTreatment("telemetryMigration")??!1,ft=Oe.quality!=="stable";if(ft&&ot){const Et=new Ee.AppInsightsAppender("monacoworkbench",null,Oe.aiConfig.asimovKey,ot,!0);this._register((0,T.toDisposable)(()=>Et.flush())),Ze.push(Et)}const wt=new Ee.AppInsightsAppender("monacoworkbench",null,Oe.aiConfig.asimovKey,ft?!1:ot,ot&&ft);this._register((0,T.toDisposable)(()=>wt.flush())),Ze.push(wt)}nt=new we.TelemetryService({appenders:Ze,commonProperties:(0,he.resolveCommonProperties)(Ke,(0,i.release)(),(0,i.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,Oe.msftInternalDomains,At),sendErrorTelemetry:!0,piiPaths:[dt,_t]},xe)}else{nt=De.NullTelemetryService;const Be=De.NullAppender;Ze.push(Be)}this.server.registerChannel("telemetryAppender",new ve.TelemetryAppenderChannel(Ze)),Se.set(me.ITelemetryService,nt);const Lt=new ke.CustomEndpointTelemetryService(xe,nt,Qe,We);Se.set(me.ICustomEndpointTelemetryService,Lt),Se.set(m.IExtensionManagementService,new U.SyncDescriptor(O.ExtensionManagementService)),Se.set(m.IExtensionGalleryService,new U.SyncDescriptor(d.ExtensionGalleryService)),Se.set(m.IExtensionTipsService,new U.SyncDescriptor(A.ExtensionTipsService)),Se.set(H.ILocalizationsService,new U.SyncDescriptor(Z.LocalizationsService)),Se.set(r.IDiagnosticsService,new U.SyncDescriptor(a.DiagnosticsService)),Se.set(le.IUserDataSyncAccountService,new U.SyncDescriptor(le.UserDataSyncAccountService)),Se.set(ae.IUserDataSyncLogService,new U.SyncDescriptor(Me.UserDataSyncLogService)),Se.set(ae.IUserDataSyncUtilService,new Ie.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Be=>Be.ctx!=="main"))),Se.set(m.IGlobalExtensionEnablementService,new U.SyncDescriptor(u.GlobalExtensionEnablementService)),Se.set(re.IIgnoredExtensionsManagementService,new U.SyncDescriptor(re.IgnoredExtensionsManagementService)),Se.set(ze.IExtensionsStorageSyncService,new U.SyncDescriptor(ze.ExtensionsStorageSyncService)),Se.set(ae.IUserDataSyncStoreManagementService,new U.SyncDescriptor(X.UserDataSyncStoreManagementService)),Se.set(ae.IUserDataSyncStoreService,new U.SyncDescriptor(X.UserDataSyncStoreService)),Se.set(Te.IUserDataSyncMachinesService,new U.SyncDescriptor(Te.UserDataSyncMachinesService)),Se.set(ae.IUserDataSyncBackupStoreService,new U.SyncDescriptor(be.UserDataSyncBackupStoreService)),Se.set(ae.IUserDataSyncEnablementService,new U.SyncDescriptor(Ne.UserDataSyncEnablementService)),Se.set(ae.IUserDataSyncService,new U.SyncDescriptor(Ae.UserDataSyncService));const yt=new $e.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:xe.getValue("terminal.integrated.persistentSessionScrollback")??100},xe,We,Ge,nt);return await yt.initialize(),Se.set(Fe.ILocalPtyService,this._register(yt)),Se.set(fe.ISignService,new U.SyncDescriptor(ye.SignService)),Se.set(pe.ISharedTunnelsService,new U.SyncDescriptor(Ce.SharedTunnelsService)),Se.set(Pe.ISharedProcessTunnelService,new U.SyncDescriptor(Re.SharedProcessTunnelService)),new ee.InstantiationService(Se)}initChannels(Se){const Oe=new I.ExtensionManagementChannel(Se.get(m.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const je=P.ProxyChannel.fromService(Se.get(H.ILocalizationsService));this.server.registerChannel("localizations",je);const He=P.ProxyChannel.fromService(Se.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",He);const We=new I.ExtensionTipsChannel(Se.get(m.IExtensionTipsService));this.server.registerChannel("extensionTipsService",We);const rt=P.ProxyChannel.fromService(Se.get(w.IChecksumService));this.server.registerChannel("checksum",rt);const Qe=new Ie.UserDataSyncMachinesServiceChannel(Se.get(Te.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Qe);const at=P.ProxyChannel.fromService(Se.get(me.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",at);const Ge=new Ie.UserDataSyncAccountServiceChannel(Se.get(le.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ge);const Ke=new Ie.UserDataSyncStoreManagementServiceChannel(Se.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ke);const ct=new Ue.UserDataSyncChannel(Se.get(ae.IUserDataSyncService),Se.get(K.ILogService));this.server.registerChannel("userDataSync",ct);const lt=this._register(Se.get(x.IInstantiationService).createInstance(oe.UserDataAutoSyncService)),xe=new Ie.UserDataAutoSyncChannel(lt);this.server.registerChannel("userDataAutoSync",xe);const tt=Se.get(Fe.ILocalPtyService),st=P.ProxyChannel.fromService(tt);this.server.registerChannel(Le.TerminalIpcChannels.LocalPty,st);const ut=P.ProxyChannel.fromService(Se.get(Pe.ISharedProcessTunnelService));this.server.registerChannel(Pe.ipcSharedProcessTunnelChannelName,ut);const ht=P.ProxyChannel.fromService(Se.get(_e.ISharedProcessWorkerService));this.server.registerChannel(_e.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(Se){window.addEventListener("unhandledrejection",Oe=>{(0,_.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,_.setUnexpectedErrorHandler)(Oe=>{const je=(0,k.toErrorMessage)(Oe,!0);!je||Se.error(`[uncaught exception in sharedProcess]: ${je}`)})}}async function kt(St){const Se=new Rt(St);L.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await Se.open(),L.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=kt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/807bf598bea406dcb272a9fced54697986e87768/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
