/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/extensions/common/extensions","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","fs","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],be=function(Y){for(var e=[],m=0,i=Y.length;m<i;m++)e[m]=we[Y[m]];return e};define(we[56],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(i,y){if(!i)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=m}),define(we[73],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function m(P){return P?P.replace(/\$\((.*?)\)/g,(k,_)=>` ${_} `).trim():""}e.getCodiconAriaLabel=m;class i{constructor(k,_,I){this.id=k,this.definition=_,this.description=I,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}e.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function y(P,k){const _=["codicon","codicon-"+P];return k&&_.push("codicon-modifier-"+k),_}e.getClassNamesArray=y;var C;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function _(T){if(T instanceof i)return["codicon","codicon-"+T.id];const l=k.exec(T.id);if(!l)return _(i.error);let[,E,h]=l;const p=["codicon","codicon-"+E];return h&&p.push("codicon-modifier-"+h.substr(1)),p}P.asClassNameArray=_;function I(T){return _(T).join(" ")}P.asClassName=I;function L(T){return"."+_(T).join(".")}P.asCSSSelector=L})(C=e.CSSIcon||(e.CSSIcon={}))}),define(we[74],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function i(L){const T=[];for(let l in L)m.call(L,l)&&T.push(L[l]);return T}e.values=i;function y(L,T){for(let l in L)if(m.call(L,l)&&T({key:l,value:L[l]},function(){delete L[l]})===!1)return}e.forEach=y;function C(L,T){const l=Object.create(null);for(const E of L){const h=T(E);let p=l[h];p||(p=l[h]=[]),p.push(E)}return l}e.groupBy=C;function P(L){const T=Object.create(null);return L&&L.forEach((l,E)=>{T[E]=l}),T}e.fromMap=P;function k(L,T){const l=[],E=[];for(let h of L)T.has(h)||l.push(h);for(let h of T)L.has(h)||E.push(h);return{removed:l,added:E}}e.diffSets=k;function _(L,T){const l=[],E=[];for(let[h,p]of L)T.has(h)||l.push(p);for(let[h,p]of T)L.has(h)||E.push(p);return{removed:l,added:E}}e.diffMaps=_;class I{constructor(){this.map=new Map}add(T,l){let E=this.map.get(T);E||(E=new Set,this.map.set(T,E)),E.add(l)}delete(T,l){const E=this.map.get(T);!E||(E.delete(l),E.size===0&&this.map.delete(T))}forEach(T,l){const E=this.map.get(T);!E||E.forEach(l)}}e.SetMap=I}),define(we[57],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(P){return(k,_,I)=>{let L=null,T=null;if(typeof I.value=="function"?(L="value",T=I.value):typeof I.get=="function"&&(L="get",T=I.get),!T)throw new Error("not supported");I[L]=P(T,_)}}e.createDecorator=m;function i(P,k,_){let I=null,L=null;if(typeof _.value=="function"?(I="value",L=_.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(I="get",L=_.get),!L)throw new Error("not supported");const T=`$memoize$${k}`;_[I]=function(...l){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,l)}),this[T]}}e.memoize=i;function y(P,k,_){return m((I,L)=>{const T=`$debounce$${L}`,l=`$debounce$result$${L}`;return function(...E){this[l]||(this[l]=_?_():void 0),clearTimeout(this[T]),k&&(this[l]=k(this[l],...E),E=[this[l]]),this[T]=setTimeout(()=>{I.apply(this,E),this[l]=_?_():void 0},P)}})}e.debounce=y;function C(P,k,_){return m((I,L)=>{const T=`$throttle$timer$${L}`,l=`$throttle$result$${L}`,E=`$throttle$lastRun$${L}`,h=`$throttle$pending$${L}`;return function(...p){if(this[l]||(this[l]=_?_():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),k&&(this[l]=k(this[l],...p)),this[h])return;const v=this[E]+P;v<=Date.now()?(this[E]=Date.now(),I.apply(this,[this[l]]),this[l]=_?_():void 0):(this[h]=!0,this[T]=setTimeout(()=>{this[h]=!1,this[E]=Date.now(),I.apply(this,[this[l]]),this[l]=_?_():void 0},v-Date.now()))}})}e.throttle=C}),define(we[15],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(c){setTimeout(()=>{throw c.stack?new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.listeners.push(c),()=>{this._removeListener(c)}}emit(c){this.listeners.forEach(S=>{S(c)})}_removeListener(c){this.listeners.splice(this.listeners.indexOf(c),1)}setUnexpectedErrorHandler(c){this.unexpectedErrorHandler=c}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(c){this.unexpectedErrorHandler(c),this.emit(c)}onUnexpectedExternalError(c){this.unexpectedErrorHandler(c)}}e.ErrorHandler=m,e.errorHandler=new m;function i(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=i;function y(g){_(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=y;function C(g){_(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=C;function P(g){if(g instanceof Error){let{name:c,message:S}=g;const r=g.stacktrace||g.stack;return{$isError:!0,name:c,message:S,stack:r}}return g}e.transformErrorForSerialization=P;const k="Canceled";function _(g){return g instanceof Error&&g.name===k&&g.message===k}e.isPromiseCanceledError=_;class I extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=I;function L(){const g=new Error(k);return g.name=g.message,g}e.canceled=L;function T(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=T;function l(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=l;function E(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function h(g){const c=new Error(`${g} has been disposed`);return c.name="DISPOSED",c}e.disposed=h;function p(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=p;class v extends Error{constructor(c){super("NotImplemented");c&&(this.message=c)}}e.NotImplementedError=v;class A extends Error{constructor(c){super("NotSupported");c&&(this.message=c)}}e.NotSupportedError=A;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function s(g){const c=g;return c instanceof Error&&Array.isArray(c.actions)}e.isErrorWithActions=s;function o(g,c=Object.create(null)){const S=new Error(g);return c.actions&&(S.actions=c.actions),S}e.createErrorWithActions=o}),define(we[16],be([0,1,15]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function i(j,ie=0){return j[j.length-(1+ie)]}e.tail=i;function y(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=y;function C(j,ie,ce=(ge,ke)=>ge===ke){if(j===ie)return!0;if(!j||!ie||j.length!==ie.length)return!1;for(let ge=0,ke=j.length;ge<ke;ge++)if(!ce(j[ge],ie[ge]))return!1;return!0}e.equals=C;function P(j,ie,ce){let ge=0,ke=j.length-1;for(;ge<=ke;){const Le=(ge+ke)/2|0,Oe=ce(j[Le],ie);if(Oe<0)ge=Le+1;else if(Oe>0)ke=Le-1;else return Le}return-(ge+1)}e.binarySearch=P;function k(j,ie){let ce=0,ge=j.length;if(ge===0)return 0;for(;ce<ge;){const ke=Math.floor((ce+ge)/2);ie(j[ke])?ge=ke:ce=ke+1}return ce}e.findFirstInSorted=k;function _(j,ie,ce){if(j=j|0,j>=ie.length)throw new TypeError("invalid index");let ge=ie[Math.floor(ie.length*Math.random())],ke=[],Le=[],Oe=[];for(let q of ie){const J=ce(q,ge);J<0?ke.push(q):J>0?Le.push(q):Oe.push(q)}return j<ke.length?_(j,ke,ce):j<ke.length+Oe.length?Oe[0]:_(j-(ke.length+Oe.length),Le,ce)}e.quickSelect=_;function I(j,ie){const ce=[];let ge;for(const ke of j.slice(0).sort(ie))!ge||ie(ge[0],ke)!==0?(ge=[ke],ce.push(ge)):ge.push(ke);return ce}e.groupBy=I;function L(j,ie,ce){const ge=[];function ke(q,J,re){if(J===0&&re.length===0)return;const he=ge[ge.length-1];he&&he.start+he.deleteCount===q?(he.deleteCount+=J,he.toInsert.push(...re)):ge.push({start:q,deleteCount:J,toInsert:re})}let Le=0,Oe=0;for(;;){if(Le===j.length){ke(Le,0,ie.slice(Oe));break}if(Oe===ie.length){ke(Le,j.length-Le,[]);break}const q=j[Le],J=ie[Oe],re=ce(q,J);re===0?(Le+=1,Oe+=1):re<0?(ke(Le,1,[]),Le+=1):re>0&&(ke(Le,0,[J]),Oe+=1)}return ge}e.sortedDiff=L;function T(j,ie,ce){const ge=L(j,ie,ce),ke=[],Le=[];for(const Oe of ge)ke.push(...j.slice(Oe.start,Oe.start+Oe.deleteCount)),Le.push(...Oe.toInsert);return{removed:ke,added:Le}}e.delta=T;function l(j,ie,ce){if(ce===0)return[];const ge=j.slice(0,ce).sort(ie);return h(j,ie,ge,ce,j.length),ge}e.top=l;function E(j,ie,ce,ge,ke){return ce===0?Promise.resolve([]):new Promise((Le,Oe)=>{(async()=>{const q=j.length,J=j.slice(0,ce).sort(ie);for(let re=ce,he=Math.min(ce+ge,q);re<q;re=he,he=Math.min(he+ge,q)){if(re>ce&&await new Promise(ee=>setTimeout(ee)),ke&&ke.isCancellationRequested)throw(0,m.canceled)();h(j,ie,J,re,he)}return J})().then(Le,Oe)})}e.topAsync=E;function h(j,ie,ce,ge,ke){for(const Le=ce.length;ge<ke;ge++){const Oe=j[ge];if(ie(Oe,ce[Le-1])<0){ce.pop();const q=k(ce,J=>ie(Oe,J)<0);ce.splice(q,0,Oe)}}}function p(j){return j.filter(ie=>!!ie)}e.coalesce=p;function v(j){let ie=0;for(let ce=0;ce<j.length;ce++)j[ce]&&(j[ie]=j[ce],ie+=1);j.length=ie}e.coalesceInPlace=v;function A(j,ie,ce){j.splice(ce,0,j.splice(ie,1)[0])}e.move=A;function w(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=w;function s(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=s;function o(j,ie=ce=>ce){const ce=new Set;return j.filter(ge=>{const ke=ie(ge);return ce.has(ke)?!1:(ce.add(ke),!0)})}e.distinct=o;function g(j){const ie=Object.create(null);return ce=>{const ge=j(ce);return ie[ge]?!1:(ie[ge]=!0,!0)}}e.uniqueFilter=g;function c(j,ie){const ce=S(j,ie);if(ce!==-1)return j[ce]}e.findLast=c;function S(j,ie){for(let ce=j.length-1;ce>=0;ce--){const ge=j[ce];if(ie(ge))return ce}return-1}e.lastIndex=S;function r(j,ie){return j.length>0?j[0]:ie}e.firstOrDefault=r;function t(j,ie,ce=(ge,ke)=>ge===ke){let ge=0;for(let ke=0,Le=Math.min(j.length,ie.length);ke<Le&&ce(j[ke],ie[ke]);ke++)ge++;return ge}e.commonPrefixLength=t;function n(j){return[].concat(...j)}e.flatten=n;function u(j,ie){let ce=typeof ie=="number"?j:0;typeof ie=="number"?ce=j:(ce=0,ie=j);const ge=[];if(ce<=ie)for(let ke=ce;ke<ie;ke++)ge.push(ke);else for(let ke=ce;ke>ie;ke--)ge.push(ke);return ge}e.range=u;function a(j,ie,ce){return j.reduce((ge,ke)=>(ge[ie(ke)]=ce?ce(ke):ke,ge),Object.create(null))}e.index=a;function f(j,ie){return j.push(ie),()=>b(j,ie)}e.insert=f;function b(j,ie){const ce=j.indexOf(ie);if(ce>-1)return j.splice(ce,1),ie}e.remove=b;function d(j,ie,ce){const ge=j.slice(0,ie),ke=j.slice(ie);return ge.concat(ce,ke)}e.arrayInsert=d;function D(j,ie){let ce;if(typeof ie=="number"){let ge=ie;ce=()=>{const ke=Math.sin(ge++)*179426549;return ke-Math.floor(ke)}}else ce=Math.random;for(let ge=j.length-1;ge>0;ge-=1){const ke=Math.floor(ce()*(ge+1)),Le=j[ge];j[ge]=j[ke],j[ke]=Le}}e.shuffle=D;function R(j,ie){const ce=j.indexOf(ie);ce>-1&&(j.splice(ce,1),j.unshift(ie))}e.pushToStart=R;function N(j,ie){const ce=j.indexOf(ie);ce>-1&&(j.splice(ce,1),j.push(ie))}e.pushToEnd=N;function B(j,ie){return Array.isArray(j)?j.map(ie):ie(j)}e.mapArrayOrNot=B;function F(j){return Array.isArray(j)?j:[j]}e.asArray=F;function O(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=O;function z(j,ie){for(const ce of j){const ge=ie(ce);if(ge!==void 0)return ge}}e.mapFind=z;function W(j,ie,ce){const ge=x(j,ie),ke=j.length,Le=ce.length;j.length=ke+Le;for(let Oe=ke-1;Oe>=ge;Oe--)j[Oe+Le]=j[Oe];for(let Oe=0;Oe<Le;Oe++)j[Oe+ge]=ce[Oe]}e.insertInto=W;function M(j,ie,ce,ge){const ke=x(j,ie),Le=j.splice(ke,ce);return W(j,ke,ge),Le}e.splice=M;function x(j,ie){return ie<0?Math.max(ie+j.length,0):Math.min(ie,j.length)}function V(j,ie){return(ce,ge)=>ie(j(ce),j(ge))}e.compareBy=V;const U=(j,ie)=>j-ie;e.numberComparator=U;function H(j,ie){if(j.length===0)return;let ce=j[0];for(let ge=1;ge<j.length;ge++){const ke=j[ge];ie(ke,ce)>0&&(ce=ke)}return ce}e.findMaxBy=H;function X(j,ie){if(j.length===0)return;let ce=j[0];for(let ge=1;ge<j.length;ge++){const ke=j[ge];ie(ke,ce)>=0&&(ce=ke)}return ce}e.findLastMaxBy=X;function se(j,ie){return H(j,(ce,ge)=>-ie(ce,ge))}e.findMinBy=se;class K{constructor(ie){this.items=ie,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ie){let ce=this.firstIdx;for(;ce<this.items.length&&ie(this.items[ce]);)ce++;const ge=ce===this.firstIdx?null:this.items.slice(this.firstIdx,ce);return this.firstIdx=ce,ge}takeFromEndWhile(ie){let ce=this.lastIdx;for(;ce>=0&&ie(this.items[ce]);)ce--;const ge=ce===this.lastIdx?null:this.items.slice(ce+1,this.lastIdx+1);return this.lastIdx=ce,ge}peek(){return this.items[this.firstIdx]}dequeue(){const ie=this.items[this.firstIdx];return this.firstIdx++,ie}takeCount(ie){const ce=this.items.slice(this.firstIdx,this.firstIdx+ie);return this.firstIdx+=ie,ce}}e.ArrayQueue=K}),define(we[75],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(i){const y=this;let C=!1,P;return function(){return C||(C=!0,P=i.apply(y,arguments)),P}}e.once=m}),define(we[76],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(y){this._prefix=y,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(we[77],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(i){function y(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}i.is=y;const C=Object.freeze([]);function P(){return C}i.empty=P;function*k(g){yield g}i.single=k;function _(g){return g||C}i.from=_;function I(g){return!g||g[Symbol.iterator]().next().done===!0}i.isEmpty=I;function L(g){return g[Symbol.iterator]().next().value}i.first=L;function T(g,c){for(const S of g)if(c(S))return!0;return!1}i.some=T;function l(g,c){for(const S of g)if(c(S))return S}i.find=l;function*E(g,c){for(const S of g)c(S)&&(yield S)}i.filter=E;function*h(g,c){let S=0;for(const r of g)yield c(r,S++)}i.map=h;function*p(...g){for(const c of g)for(const S of c)yield S}i.concat=p;function*v(g){for(const c of g)for(const S of c)yield S}i.concatNested=v;function A(g,c,S){let r=S;for(const t of g)r=c(r,t);return r}i.reduce=A;function*w(g,c,S=g.length){for(c<0&&(c+=g.length),S<0?S+=g.length:S>g.length&&(S=g.length);c<S;c++)yield g[c]}i.slice=w;function s(g,c=Number.POSITIVE_INFINITY){const S=[];if(c===0)return[S,g];const r=g[Symbol.iterator]();for(let t=0;t<c;t++){const n=r.next();if(n.done)return[S,i.empty()];S.push(n.value)}return[S,{[Symbol.iterator](){return r}}]}i.consume=s;function o(g,c,S=(r,t)=>r===t){const r=g[Symbol.iterator](),t=c[Symbol.iterator]();for(;;){const n=r.next(),u=t.next();if(n.done!==u.done)return!1;if(n.done)return!0;if(!S(n.value,u.value))return!1}}i.equals=o})(m=e.Iterable||(e.Iterable={}))}),define(we[58],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(c){c[c.None=0]="None",c[c.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=2]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",c[c.InvalidUnicode=4]="InvalidUnicode",c[c.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",c[c.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var i;(function(c){c[c.OpenBraceToken=1]="OpenBraceToken",c[c.CloseBraceToken=2]="CloseBraceToken",c[c.OpenBracketToken=3]="OpenBracketToken",c[c.CloseBracketToken=4]="CloseBracketToken",c[c.CommaToken=5]="CommaToken",c[c.ColonToken=6]="ColonToken",c[c.NullKeyword=7]="NullKeyword",c[c.TrueKeyword=8]="TrueKeyword",c[c.FalseKeyword=9]="FalseKeyword",c[c.StringLiteral=10]="StringLiteral",c[c.NumericLiteral=11]="NumericLiteral",c[c.LineCommentTrivia=12]="LineCommentTrivia",c[c.BlockCommentTrivia=13]="BlockCommentTrivia",c[c.LineBreakTrivia=14]="LineBreakTrivia",c[c.Trivia=15]="Trivia",c[c.Unknown=16]="Unknown",c[c.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(c){c[c.InvalidSymbol=1]="InvalidSymbol",c[c.InvalidNumberFormat=2]="InvalidNumberFormat",c[c.PropertyNameExpected=3]="PropertyNameExpected",c[c.ValueExpected=4]="ValueExpected",c[c.ColonExpected=5]="ColonExpected",c[c.CommaExpected=6]="CommaExpected",c[c.CloseBraceExpected=7]="CloseBraceExpected",c[c.CloseBracketExpected=8]="CloseBracketExpected",c[c.EndOfFileExpected=9]="EndOfFileExpected",c[c.InvalidCommentToken=10]="InvalidCommentToken",c[c.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=12]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",c[c.InvalidUnicode=14]="InvalidUnicode",c[c.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",c[c.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(c){c.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function P(c,S=!1){let r=0,t=c.length,n="",u=0,a=16,f=0;function b(O){let z=0,W=0;for(;z<O;){const M=c.charCodeAt(r);if(M>=48&&M<=57)W=W*16+M-48;else if(M>=65&&M<=70)W=W*16+M-65+10;else if(M>=97&&M<=102)W=W*16+M-97+10;else break;r++,z++}return z<O&&(W=-1),W}function d(O){r=O,n="",u=0,a=16,f=0}function D(){const O=r;if(c.charCodeAt(r)===48)r++;else for(r++;r<c.length&&I(c.charCodeAt(r));)r++;if(r<c.length&&c.charCodeAt(r)===46)if(r++,r<c.length&&I(c.charCodeAt(r)))for(r++;r<c.length&&I(c.charCodeAt(r));)r++;else return f=3,c.substring(O,r);let z=r;if(r<c.length&&(c.charCodeAt(r)===69||c.charCodeAt(r)===101))if(r++,(r<c.length&&c.charCodeAt(r)===43||c.charCodeAt(r)===45)&&r++,r<c.length&&I(c.charCodeAt(r))){for(r++;r<c.length&&I(c.charCodeAt(r));)r++;z=r}else f=3;return c.substring(O,z)}function R(){let O="",z=r;for(;;){if(r>=t){O+=c.substring(z,r),f=2;break}const W=c.charCodeAt(r);if(W===34){O+=c.substring(z,r),r++;break}if(W===92){if(O+=c.substring(z,r),r++,r>=t){f=2;break}switch(c.charCodeAt(r++)){case 34:O+='"';break;case 92:O+="\\";break;case 47:O+="/";break;case 98:O+="\b";break;case 102:O+="\f";break;case 110:O+=`
`;break;case 114:O+="\r";break;case 116:O+="	";break;case 117:{const x=b(4);x>=0?O+=String.fromCharCode(x):f=4;break}default:f=5}z=r;continue}if(W>=0&&W<=31)if(_(W)){O+=c.substring(z,r),f=2;break}else f=6;r++}return O}function N(){if(n="",f=0,u=r,r>=t)return u=t,a=17;let O=c.charCodeAt(r);if(k(O)){do r++,n+=String.fromCharCode(O),O=c.charCodeAt(r);while(k(O));return a=15}if(_(O))return r++,n+=String.fromCharCode(O),O===13&&c.charCodeAt(r)===10&&(r++,n+=`
`),a=14;switch(O){case 123:return r++,a=1;case 125:return r++,a=2;case 91:return r++,a=3;case 93:return r++,a=4;case 58:return r++,a=6;case 44:return r++,a=5;case 34:return r++,n=R(),a=10;case 47:{const z=r-1;if(c.charCodeAt(r+1)===47){for(r+=2;r<t&&!_(c.charCodeAt(r));)r++;return n=c.substring(z,r),a=12}if(c.charCodeAt(r+1)===42){r+=2;const W=t-1;let M=!1;for(;r<W;){if(c.charCodeAt(r)===42&&c.charCodeAt(r+1)===47){r+=2,M=!0;break}r++}return M||(r++,f=1),n=c.substring(z,r),a=13}return n+=String.fromCharCode(O),r++,a=16}case 45:if(n+=String.fromCharCode(O),r++,r===t||!I(c.charCodeAt(r)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=D(),a=11;default:for(;r<t&&B(O);)r++,O=c.charCodeAt(r);if(u!==r){switch(n=c.substring(u,r),n){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return n+=String.fromCharCode(O),r++,a=16}}function B(O){if(k(O)||_(O))return!1;switch(O){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let O;do O=N();while(O>=12&&O<=15);return O}return{setPosition:d,getPosition:()=>r,scan:S?F:N,getToken:()=>a,getTokenValue:()=>n,getTokenOffset:()=>u,getTokenLength:()=>r-u,getTokenError:()=>f}}e.createScanner=P;function k(c){return c===32||c===9||c===11||c===12||c===160||c===5760||c>=8192&&c<=8203||c===8239||c===8287||c===12288||c===65279}function _(c){return c===10||c===13||c===8232||c===8233}function I(c){return c>=48&&c<=57}var L;(function(c){c[c.nullCharacter=0]="nullCharacter",c[c.maxAsciiCharacter=127]="maxAsciiCharacter",c[c.lineFeed=10]="lineFeed",c[c.carriageReturn=13]="carriageReturn",c[c.lineSeparator=8232]="lineSeparator",c[c.paragraphSeparator=8233]="paragraphSeparator",c[c.nextLine=133]="nextLine",c[c.space=32]="space",c[c.nonBreakingSpace=160]="nonBreakingSpace",c[c.enQuad=8192]="enQuad",c[c.emQuad=8193]="emQuad",c[c.enSpace=8194]="enSpace",c[c.emSpace=8195]="emSpace",c[c.threePerEmSpace=8196]="threePerEmSpace",c[c.fourPerEmSpace=8197]="fourPerEmSpace",c[c.sixPerEmSpace=8198]="sixPerEmSpace",c[c.figureSpace=8199]="figureSpace",c[c.punctuationSpace=8200]="punctuationSpace",c[c.thinSpace=8201]="thinSpace",c[c.hairSpace=8202]="hairSpace",c[c.zeroWidthSpace=8203]="zeroWidthSpace",c[c.narrowNoBreakSpace=8239]="narrowNoBreakSpace",c[c.ideographicSpace=12288]="ideographicSpace",c[c.mathematicalSpace=8287]="mathematicalSpace",c[c.ogham=5760]="ogham",c[c._=95]="_",c[c.$=36]="$",c[c._0=48]="_0",c[c._1=49]="_1",c[c._2=50]="_2",c[c._3=51]="_3",c[c._4=52]="_4",c[c._5=53]="_5",c[c._6=54]="_6",c[c._7=55]="_7",c[c._8=56]="_8",c[c._9=57]="_9",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.ampersand=38]="ampersand",c[c.asterisk=42]="asterisk",c[c.at=64]="at",c[c.backslash=92]="backslash",c[c.bar=124]="bar",c[c.caret=94]="caret",c[c.closeBrace=125]="closeBrace",c[c.closeBracket=93]="closeBracket",c[c.closeParen=41]="closeParen",c[c.colon=58]="colon",c[c.comma=44]="comma",c[c.dot=46]="dot",c[c.doubleQuote=34]="doubleQuote",c[c.equals=61]="equals",c[c.exclamation=33]="exclamation",c[c.greaterThan=62]="greaterThan",c[c.lessThan=60]="lessThan",c[c.minus=45]="minus",c[c.openBrace=123]="openBrace",c[c.openBracket=91]="openBracket",c[c.openParen=40]="openParen",c[c.percent=37]="percent",c[c.plus=43]="plus",c[c.question=63]="question",c[c.semicolon=59]="semicolon",c[c.singleQuote=39]="singleQuote",c[c.slash=47]="slash",c[c.tilde=126]="tilde",c[c.backspace=8]="backspace",c[c.formFeed=12]="formFeed",c[c.byteOrderMark=65279]="byteOrderMark",c[c.tab=9]="tab",c[c.verticalTab=11]="verticalTab"})(L||(L={}));function T(c,S){const r=[],t=new Object;let n;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function f(b,d,D,R){u.value=b,u.offset=d,u.length=D,u.type=R,u.colonOffset=void 0,n=u}try{s(c,{onObjectBegin:(b,d)=>{if(S<=b)throw t;n=void 0,a=S>b,r.push("")},onObjectProperty:(b,d,D)=>{if(S<d||(f(b,d,D,"property"),r[r.length-1]=b,S<=d+D))throw t},onObjectEnd:(b,d)=>{if(S<=b)throw t;n=void 0,r.pop()},onArrayBegin:(b,d)=>{if(S<=b)throw t;n=void 0,r.push(0)},onArrayEnd:(b,d)=>{if(S<=b)throw t;n=void 0,r.pop()},onLiteralValue:(b,d,D)=>{if(S<d||(f(b,d,D,g(b)),S<=d+D))throw t},onSeparator:(b,d,D)=>{if(S<=d)throw t;if(b===":"&&n&&n.type==="property")n.colonOffset=d,a=!1,n=void 0;else if(b===","){const R=r[r.length-1];typeof R=="number"?r[r.length-1]=R+1:(a=!0,r[r.length-1]=""),n=void 0}}})}catch(b){if(b!==t)throw b}return{path:r,previousNode:n,isAtPropertyKey:a,matches:b=>{let d=0;for(let D=0;d<b.length&&D<r.length;D++)if(b[d]===r[D]||b[d]==="*")d++;else if(b[d]!=="**")return!1;return d===b.length}}}e.getLocation=T;function l(c,S=[],r=C.DEFAULT){let t=null,n=[];const u=[];function a(b){Array.isArray(n)?n.push(b):t!==null&&(n[t]=b)}return s(c,{onObjectBegin:()=>{const b={};a(b),u.push(n),n=b,t=null},onObjectProperty:b=>{t=b},onObjectEnd:()=>{n=u.pop()},onArrayBegin:()=>{const b=[];a(b),u.push(n),n=b,t=null},onArrayEnd:()=>{n=u.pop()},onLiteralValue:a,onError:(b,d,D)=>{S.push({error:b,offset:d,length:D})}},r),n[0]}e.parse=l;function E(c,S=[],r=C.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(b){t.type==="property"&&(t.length=b-t.offset,t=t.parent)}function u(b){return t.children.push(b),b}s(c,{onObjectBegin:b=>{t=u({type:"object",offset:b,length:-1,parent:t,children:[]})},onObjectProperty:(b,d,D)=>{t=u({type:"property",offset:d,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:b,offset:d,length:D,parent:t})},onObjectEnd:(b,d)=>{t.length=b+d-t.offset,t=t.parent,n(b+d)},onArrayBegin:(b,d)=>{t=u({type:"array",offset:b,length:-1,parent:t,children:[]})},onArrayEnd:(b,d)=>{t.length=b+d-t.offset,t=t.parent,n(b+d)},onLiteralValue:(b,d,D)=>{u({type:g(b),offset:d,length:D,parent:t,value:b}),n(d+D)},onSeparator:(b,d,D)=>{t.type==="property"&&(b===":"?t.colonOffset=d:b===","&&n(d))},onError:(b,d,D)=>{S.push({error:b,offset:d,length:D})}},r);const f=t.children[0];return f&&delete f.parent,f}e.parseTree=E;function h(c,S){if(!c)return;let r=c;for(let t of S)if(typeof t=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const u of r.children)if(Array.isArray(u.children)&&u.children[0].value===t){r=u.children[1],n=!0;break}if(!n)return}else{const n=t;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.findNodeAtLocation=h;function p(c){if(!c.parent||!c.parent.children)return[];const S=p(c.parent);if(c.parent.type==="property"){const r=c.parent.children[0].value;S.push(r)}else if(c.parent.type==="array"){const r=c.parent.children.indexOf(c);r!==-1&&S.push(r)}return S}e.getNodePath=p;function v(c){switch(c.type){case"array":return c.children.map(v);case"object":{const S=Object.create(null);for(let r of c.children){const t=r.children[1];t&&(S[r.children[0].value]=v(t))}return S}case"null":case"string":case"number":case"boolean":return c.value;default:return}}e.getNodeValue=v;function A(c,S,r=!1){return S>=c.offset&&S<c.offset+c.length||r&&S===c.offset+c.length}e.contains=A;function w(c,S,r=!1){if(A(c,S,r)){const t=c.children;if(Array.isArray(t))for(let n=0;n<t.length&&t[n].offset<=S;n++){const u=w(t[n],S,r);if(u)return u}return c}}e.findNodeAtOffset=w;function s(c,S,r=C.DEFAULT){const t=P(c,!1);function n(K){return K?()=>K(t.getTokenOffset(),t.getTokenLength()):()=>!0}function u(K){return K?j=>K(j,t.getTokenOffset(),t.getTokenLength()):()=>!0}const a=n(S.onObjectBegin),f=u(S.onObjectProperty),b=n(S.onObjectEnd),d=n(S.onArrayBegin),D=n(S.onArrayEnd),R=u(S.onLiteralValue),N=u(S.onSeparator),B=n(S.onComment),F=u(S.onError),O=r&&r.disallowComments,z=r&&r.allowTrailingComma;function W(){for(;;){const K=t.scan();switch(t.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:O||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(K){case 12:case 13:O?M(10):B();break;case 16:M(1);break;case 15:case 14:break;default:return K}}}function M(K,j=[],ie=[]){if(F(K),j.length+ie.length>0){let ce=t.getToken();for(;ce!==17;){if(j.indexOf(ce)!==-1){W();break}else if(ie.indexOf(ce)!==-1)break;ce=W()}}}function x(K){const j=t.getTokenValue();return K?R(j):f(j),W(),!0}function V(){switch(t.getToken()){case 11:{let K=0;try{K=JSON.parse(t.getTokenValue()),typeof K!="number"&&(M(2),K=0)}catch{M(2)}R(K);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return W(),!0}function U(){return t.getToken()!==10?(M(3,[],[2,5]),!1):(x(!1),t.getToken()===6?(N(":"),W(),se()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function H(){a(),W();let K=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(K||M(4,[],[]),N(","),W(),t.getToken()===2&&z)break}else K&&M(6,[],[]);U()||M(4,[],[2,5]),K=!0}return b(),t.getToken()!==2?M(7,[2],[]):W(),!0}function X(){d(),W();let K=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(K||M(4,[],[]),N(","),W(),t.getToken()===4&&z)break}else K&&M(6,[],[]);se()||M(4,[],[4,5]),K=!0}return D(),t.getToken()!==4?M(8,[4],[]):W(),!0}function se(){switch(t.getToken()){case 3:return X();case 1:return H();case 10:return x(!0);default:return V()}}return W(),t.getToken()===17?r.allowEmptyContent?!0:(M(4,[],[]),!1):se()?(t.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=s;function o(c,S){let r=P(c),t=[],n,u=0,a;do switch(a=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:u!==a&&t.push(c.substring(u,a)),S!==void 0&&t.push(r.getTokenValue().replace(/[^\r\n]/g,S)),u=r.getPosition();break}while(n!==17);return t.join("")}e.stripComments=o;function g(c){switch(typeof c){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(c){if(Array.isArray(c))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(we[138],be([0,1,58]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(I,L,T){let l,E,h,p,v;if(L){for(p=L.offset,v=p+L.length,h=p;h>0&&!_(I,h-1);)h--;let a=v;for(;a<I.length&&!_(I,a);)a++;E=I.substring(h,a),l=P(E,T)}else E=I,l=0,h=0,p=0,v=I.length;const A=k(T,I);let w=!1,s=0,o;T.insertSpaces?o=C(" ",T.tabSize||4):o="	";const g=(0,m.createScanner)(E,!1);let c=!1;function S(){return A+C(o,l+s)}function r(){let a=g.scan();for(w=!1;a===15||a===14;)w=w||a===14,a=g.scan();return c=a===16||g.getTokenError()!==0,a}const t=[];function n(a,f,b){!c&&f<v&&b>p&&I.substring(f,b)!==a&&t.push({offset:f,length:b-f,content:a})}let u=r();if(u!==17){const a=g.getTokenOffset()+h,f=C(o,l);n(f,h,a)}for(;u!==17;){let a=g.getTokenOffset()+g.getTokenLength()+h,f=r(),b="";for(;!w&&(f===12||f===13);){const D=g.getTokenOffset()+h;n(" ",a,D),a=g.getTokenOffset()+g.getTokenLength()+h,b=f===12?S():"",f=r()}if(f===2)u!==1&&(s--,b=S());else if(f===4)u!==3&&(s--,b=S());else{switch(u){case 3:case 1:s++,b=S();break;case 5:case 12:b=S();break;case 13:w?b=S():b=" ";break;case 6:b=" ";break;case 10:if(f===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?b=" ":f!==5&&f!==17&&(c=!0);break;case 16:c=!0;break}w&&(f===12||f===13)&&(b=S())}const d=g.getTokenOffset()+h;n(b,a,d),u=f}return t}e.format=i;function y(I,L){const T=JSON.stringify(I,void 0,L.insertSpaces?L.tabSize||4:"	");return L.eol!==void 0?T.replace(/\r\n|\r|\n/g,L.eol):T}e.toFormattedString=y;function C(I,L){let T="";for(let l=0;l<L;l++)T+=I;return T}function P(I,L){let T=0,l=0;const E=L.tabSize||4;for(;T<I.length;){const h=I.charAt(T);if(h===" ")l++;else if(h==="	")l+=E;else break;T++}return Math.floor(l/E)}function k(I,L){for(let T=0;T<L.length;T++){const l=L.charAt(T);if(l==="\r")return T+1<L.length&&L.charAt(T+1)===`
`?`\r
`:"\r";if(l===`
`)return`
`}return I&&I.eol||`
`}e.getEOL=k;function _(I,L){return`\r
`.indexOf(I.charAt(L))!==-1}e.isEOL=_}),define(we[139],be([0,1,58,138]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function y(I,L,T){return C(I,L,void 0,T)}e.removeProperty=y;function C(I,L,T,l,E){const h=L.slice(),p=[],v=(0,m.parseTree)(I,p);let A,w;for(;h.length>0&&(w=h.pop(),A=(0,m.findNodeAtLocation)(v,h),A===void 0&&T!==void 0);)typeof w=="string"?T={[w]:T}:T=[T];if(A)if(A.type==="object"&&typeof w=="string"&&Array.isArray(A.children)){const s=(0,m.findNodeAtLocation)(A,[w]);if(s!==void 0)if(T===void 0){if(!s.parent)throw new Error("Malformed AST");const o=A.children.indexOf(s.parent);let g,c=s.parent.offset+s.parent.length;if(o>0){const S=A.children[o-1];g=S.offset+S.length}else g=A.offset+1,A.children.length>1&&(c=A.children[1].offset);return P(I,{offset:g,length:c-g,content:""},l)}else return P(I,{offset:s.offset,length:s.length,content:JSON.stringify(T)},l);else{if(T===void 0)return[];const o=`${JSON.stringify(w)}: ${JSON.stringify(T)}`,g=E?E(A.children.map(S=>S.children[0].value)):A.children.length;let c;if(g>0){const S=A.children[g-1];c={offset:S.offset+S.length,length:0,content:","+o}}else A.children.length===0?c={offset:A.offset+1,length:0,content:o}:c={offset:A.offset+1,length:0,content:o+","};return P(I,c,l)}}else if(A.type==="array"&&typeof w=="number"&&Array.isArray(A.children))if(T!==void 0){const s=`${JSON.stringify(T)}`;let o;if(A.children.length===0||w===0)o={offset:A.offset+1,length:0,content:A.children.length===0?s:s+","};else{const g=w===-1||w>A.children.length?A.children.length:w,c=A.children[g-1];o={offset:c.offset+c.length,length:0,content:","+s}}return P(I,o,l)}else{const s=w,o=A.children[s];let g;if(A.children.length===1)g={offset:A.offset+1,length:A.length-2,content:""};else if(A.children.length-1===s){const c=A.children[s-1],S=c.offset+c.length,r=A.offset+A.length;g={offset:S,length:r-2-S,content:""}}else g={offset:o.offset,length:A.children[s+1].offset-o.offset,content:""};return P(I,g,l)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${A.type}`);else{if(T===void 0)throw new Error("Can not delete in empty document");return P(I,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(T)},l)}}e.setProperty=C;function P(I,L,T){let l=k(I,L),E=L.offset,h=L.offset+L.content.length;if(L.length===0||L.content.length===0){for(;E>0&&!(0,i.isEOL)(l,E-1);)E--;for(;h<l.length&&!(0,i.isEOL)(l,h);)h++}const p=(0,i.format)(l,{offset:E,length:h-E},T);for(let A=p.length-1;A>=0;A--){const w=p[A];l=k(l,w),E=Math.min(E,w.offset),h=Math.max(h,w.offset+w.length),h+=w.content.length-w.length}const v=I.length-(l.length-h)-E;return[{offset:E,length:v,content:l.substring(E,h)}]}e.withFormatting=P;function k(I,L){return I.substring(0,L.offset)+L.content+I.substring(L.offset+L.length)}e.applyEdit=k;function _(I,L){let T=L.slice(0).sort((E,h)=>{const p=E.offset-h.offset;return p===0?E.length-h.length:p}),l=I.length;for(let E=T.length-1;E>=0;E--){let h=T[E];if(h.offset+h.length<=l)I=k(I,h);else throw new Error("Overlapping edit");l=h.offset}return I}e.applyEdits=_}),define(we[140],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(y){this.executor=y,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(y){this._error=y}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(y){return new m(()=>y(this.getValue()))}}e.Lazy=m}),define(we[6],be([0,1,75,77]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const y=!1;let C=null;function P(t){C=t}if(e.setDisposableTracker=P,y){const t="__is_disposable_tracked__";P(new class{trackDisposable(n){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[t]||console.log(u)},3e3)}setParent(n,u){if(n&&n!==w.None)try{n[t]=!0}catch{}}markAsDisposed(n){if(n&&n!==w.None)try{n[t]=!0}catch{}}markAsSingleton(n){}})}function k(t){return C?.trackDisposable(t),t}function _(t){C?.markAsDisposed(t)}function I(t,n){C?.setParent(t,n)}function L(t,n){if(!!C)for(const u of t)C.setParent(u,n)}function T(t){return C?.markAsSingleton(t),t}e.markAsSingleton=T;class l extends Error{constructor(n){super(`Encountered errors while disposing of store. Errors: [${n.join(", ")}]`);this.errors=n}}e.MultiDisposeError=l;function E(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=E;function h(t){if(i.Iterable.is(t)){let n=[];for(const u of t)if(u)try{u.dispose()}catch(a){n.push(a)}if(n.length===1)throw n[0];if(n.length>1)throw new l(n);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function p(...t){const n=v(()=>h(t));return L(t,n),n}e.combinedDisposable=p;function v(t){const n=k({dispose:(0,m.once)(()=>{_(n),t()})});return n}e.toDisposable=v;class A{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(_(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return I(n,this),this._isDisposed?A.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=A,A.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new A,k(this),I(this._store,this)}dispose(){_(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class s{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&I(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,_(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&I(n,null),n}}e.MutableDisposable=s;class o{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class g{constructor(){this.references=new Map}acquire(n,...u){let a=this.references.get(n);a||(a={counter:0,object:this.createReferencedObject(n,...u)},this.references.set(n,a));const{object:f}=a,b=(0,m.once)(()=>{--a.counter==0&&(this.destroyReferencedObject(n,a.object),this.references.delete(n))});return a.counter++,{object:f,dispose:b}}}e.ReferenceCollection=g;class c{constructor(n){this.referenceCollection=n}async acquire(n,...u){const a=this.referenceCollection.acquire(n,...u);try{return{object:await a.object,dispose:()=>a.dispose()}}catch(f){throw a.dispose(),f}}}e.AsyncReferenceCollection=c;class S{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=S;function r(t){const n=new A;try{t(n)}finally{n.dispose()}}e.disposeOnReturn=r}),define(we[93],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(C){this.element=C,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class i{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let C=this._first;for(;C!==m.Undefined;){const P=C.next;C.prev=m.Undefined,C.next=m.Undefined,C=P}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,P){const k=new m(C);if(this._first===m.Undefined)this._first=k,this._last=k;else if(P){const I=this._last;this._last=k,k.prev=I,I.next=k}else{const I=this._first;this._first=k,k.next=I,I.prev=k}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(k))}}shift(){if(this._first!==m.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==m.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==m.Undefined&&C.next!==m.Undefined){const P=C.prev;P.next=C.next,C.next.prev=P}else C.prev===m.Undefined&&C.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):C.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):C.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==m.Undefined;)yield C.element,C=C.next}}e.LinkedList=i}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Ae,Pe){for(var ye=0;ye<Pe.length;ye++){var de=Pe[ye];de.enumerable=de.enumerable||!1,de.configurable=!0,"value"in de&&(de.writable=!0),Object.defineProperty(Ae,de.key,de)}}function e(Ae,Pe,ye){return Pe&&Y(Ae.prototype,Pe),ye&&Y(Ae,ye),Ae}function m(Ae,Pe){if(!!Ae){if(typeof Ae=="string")return i(Ae,Pe);var ye=Object.prototype.toString.call(Ae).slice(8,-1);if(ye==="Object"&&Ae.constructor&&(ye=Ae.constructor.name),ye==="Map"||ye==="Set")return Array.from(Ae);if(ye==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ye))return i(Ae,Pe)}}function i(Ae,Pe){(Pe==null||Pe>Ae.length)&&(Pe=Ae.length);for(var ye=0,de=new Array(Pe);ye<Pe;ye++)de[ye]=Ae[ye];return de}function y(Ae,Pe){var ye=typeof Symbol!="undefined"&&Ae[Symbol.iterator]||Ae["@@iterator"];if(ye)return(ye=ye.call(Ae)).next.bind(ye);if(Array.isArray(Ae)||(ye=m(Ae))||Pe&&Ae&&typeof Ae.length=="number"){ye&&(Ae=ye);var de=0;return function(){return de>=Ae.length?{done:!0}:{done:!1,value:Ae[de++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var C={exports:{}};function P(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Ae){C.exports.defaults=Ae}C.exports={defaults:P(),getDefaults:P,changeDefaults:k};var _=/[&<>"']/,I=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(Pe){return l[Pe]};function h(Ae,Pe){if(Pe){if(_.test(Ae))return Ae.replace(I,E)}else if(L.test(Ae))return Ae.replace(T,E);return Ae}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(Ae){return Ae.replace(p,function(Pe,ye){return ye=ye.toLowerCase(),ye==="colon"?":":ye.charAt(0)==="#"?ye.charAt(1)==="x"?String.fromCharCode(parseInt(ye.substring(2),16)):String.fromCharCode(+ye.substring(1)):""})}var A=/(^|[^\[])\^/g;function w(Ae,Pe){Ae=Ae.source||Ae,Pe=Pe||"";var ye={replace:function(fe,Ee){return Ee=Ee.source||Ee,Ee=Ee.replace(A,"$1"),Ae=Ae.replace(fe,Ee),ye},getRegex:function(){return new RegExp(Ae,Pe)}};return ye}var s=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(Ae,Pe,ye){if(Ae){var de;try{de=decodeURIComponent(v(ye)).replace(s,"").toLowerCase()}catch{return null}if(de.indexOf("javascript:")===0||de.indexOf("vbscript:")===0||de.indexOf("data:")===0)return null}Pe&&!o.test(ye)&&(ye=n(Pe,ye));try{ye=encodeURI(ye).replace(/%25/g,"%")}catch{return null}return ye}var c={},S=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(Ae,Pe){c[" "+Ae]||(S.test(Ae)?c[" "+Ae]=Ae+"/":c[" "+Ae]=b(Ae,"/",!0)),Ae=c[" "+Ae];var ye=Ae.indexOf(":")===-1;return Pe.substring(0,2)==="//"?ye?Pe:Ae.replace(r,"$1")+Pe:Pe.charAt(0)==="/"?ye?Pe:Ae.replace(t,"$1")+Pe:Ae+Pe}var u={exec:function(){}};function a(Ae){for(var Pe=1,ye,de;Pe<arguments.length;Pe++){ye=arguments[Pe];for(de in ye)Object.prototype.hasOwnProperty.call(ye,de)&&(Ae[de]=ye[de])}return Ae}function f(Ae,Pe){var ye=Ae.replace(/\|/g,function(Ee,Ce,Ne){for(var Ke=!1,He=Ce;--He>=0&&Ne[He]==="\\";)Ke=!Ke;return Ke?"|":" |"}),de=ye.split(/ \|/),fe=0;if(de[0].trim()||de.shift(),de[de.length-1].trim()||de.pop(),de.length>Pe)de.splice(Pe);else for(;de.length<Pe;)de.push("");for(;fe<de.length;fe++)de[fe]=de[fe].trim().replace(/\\\|/g,"|");return de}function b(Ae,Pe,ye){var de=Ae.length;if(de===0)return"";for(var fe=0;fe<de;){var Ee=Ae.charAt(de-fe-1);if(Ee===Pe&&!ye)fe++;else if(Ee!==Pe&&ye)fe++;else break}return Ae.substr(0,de-fe)}function d(Ae,Pe){if(Ae.indexOf(Pe[1])===-1)return-1;for(var ye=Ae.length,de=0,fe=0;fe<ye;fe++)if(Ae[fe]==="\\")fe++;else if(Ae[fe]===Pe[0])de++;else if(Ae[fe]===Pe[1]&&(de--,de<0))return fe;return-1}function D(Ae){Ae&&Ae.sanitize&&!Ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Ae,Pe){if(Pe<1)return"";for(var ye="";Pe>1;)Pe&1&&(ye+=Ae),Pe>>=1,Ae+=Ae;return ye+Ae}var N={escape:h,unescape:v,edit:w,cleanUrl:g,resolveUrl:n,noopTest:u,merge:a,splitCells:f,rtrim:b,findClosingBracket:d,checkSanitizeDeprecation:D,repeatString:R},B=C.exports.defaults,F=N.rtrim,O=N.splitCells,z=N.escape,W=N.findClosingBracket;function M(Ae,Pe,ye,de){var fe=Pe.href,Ee=Pe.title?z(Pe.title):null,Ce=Ae[1].replace(/\\([\[\]])/g,"$1");if(Ae[0].charAt(0)!=="!"){de.state.inLink=!0;var Ne={type:"link",raw:ye,href:fe,title:Ee,text:Ce,tokens:de.inlineTokens(Ce,[])};return de.state.inLink=!1,Ne}else return{type:"image",raw:ye,href:fe,title:Ee,text:z(Ce)}}function x(Ae,Pe){var ye=Ae.match(/^(\s+)(?:```)/);if(ye===null)return Pe;var de=ye[1];return Pe.split(`
`).map(function(fe){var Ee=fe.match(/^\s+/);if(Ee===null)return fe;var Ce=Ee[0];return Ce.length>=de.length?fe.slice(de.length):fe}).join(`
`)}var V=function(){function Ae(ye){this.options=ye||B}var Pe=Ae.prototype;return Pe.space=function(de){var fe=this.rules.block.newline.exec(de);if(fe)return fe[0].length>1?{type:"space",raw:fe[0]}:{raw:`
`}},Pe.code=function(de){var fe=this.rules.block.code.exec(de);if(fe){var Ee=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?Ee:F(Ee,`
`)}}},Pe.fences=function(de){var fe=this.rules.block.fences.exec(de);if(fe){var Ee=fe[0],Ce=x(Ee,fe[3]||"");return{type:"code",raw:Ee,lang:fe[2]?fe[2].trim():fe[2],text:Ce}}},Pe.heading=function(de){var fe=this.rules.block.heading.exec(de);if(fe){var Ee=fe[2].trim();if(/#$/.test(Ee)){var Ce=F(Ee,"#");(this.options.pedantic||!Ce||/ $/.test(Ce))&&(Ee=Ce.trim())}var Ne={type:"heading",raw:fe[0],depth:fe[1].length,text:Ee,tokens:[]};return this.lexer.inline(Ne.text,Ne.tokens),Ne}},Pe.hr=function(de){var fe=this.rules.block.hr.exec(de);if(fe)return{type:"hr",raw:fe[0]}},Pe.blockquote=function(de){var fe=this.rules.block.blockquote.exec(de);if(fe){var Ee=fe[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:fe[0],tokens:this.lexer.blockTokens(Ee,[]),text:Ee}}},Pe.list=function(de){var fe=this.rules.block.list.exec(de);if(fe){var Ee,Ce,Ne,Ke,He,Qe,st,at,me,De,ue=fe[1].trim(),Q=ue.length>1,Ie={type:"list",raw:"",ordered:Q,start:Q?+ue.slice(0,-1):"",loose:!1,items:[]};ue=Q?"\\d{1,9}\\"+ue.slice(-1):"\\"+ue,this.options.pedantic&&(ue=Q?ue:"[*+-]");for(var Fe=new RegExp("^( {0,3}"+ue+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");de&&!(this.rules.block.hr.test(de)||!(fe=Fe.exec(de)));){me=fe[2].split(`
`),this.options.pedantic?(Ke=2,De=me[0].trimLeft()):(Ke=fe[2].search(/[^ ]/),Ke=fe[1].length+(Ke>4?1:Ke),De=me[0].slice(Ke-fe[1].length)),Qe=!1,Ee=fe[0],!me[0]&&/^ *$/.test(me[1])&&(Ee=fe[1]+me.slice(0,2).join(`
`)+`
`,Ie.loose=!0,me=[]);var Ze=new RegExp("^ {0,"+Math.min(3,Ke-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(He=1;He<me.length;He++){if(at=me[He],this.options.pedantic&&(at=at.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ze.test(at)){Ee=fe[1]+me.slice(0,He).join(`
`)+`
`;break}if(!Qe){at.trim()||(Qe=!0),at.search(/[^ ]/)>=Ke?De+=`
`+at.slice(Ke):De+=`
`+at;continue}if(at.search(/[^ ]/)>=Ke||!at.trim()){De+=`
`+at.slice(Ke);continue}else{Ee=fe[1]+me.slice(0,He).join(`
`)+`
`;break}}Ie.loose||(st?Ie.loose=!0:/\n *\n *$/.test(Ee)&&(st=!0)),this.options.gfm&&(Ce=/^\[[ xX]\] /.exec(De),Ce&&(Ne=Ce[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),Ie.items.push({type:"list_item",raw:Ee,task:!!Ce,checked:Ne,loose:!1,text:De}),Ie.raw+=Ee,de=de.slice(Ee.length)}Ie.items[Ie.items.length-1].raw=Ee.trimRight(),Ie.items[Ie.items.length-1].text=De.trimRight(),Ie.raw=Ie.raw.trimRight();var qe=Ie.items.length;for(He=0;He<qe;He++)this.lexer.state.top=!1,Ie.items[He].tokens=this.lexer.blockTokens(Ie.items[He].text,[]),Ie.items[He].tokens.some(function(dt){return dt.type==="space"})&&(Ie.loose=!0,Ie.items[He].loose=!0);return Ie}},Pe.html=function(de){var fe=this.rules.block.html.exec(de);if(fe){var Ee={type:"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:fe[0]};return this.options.sanitize&&(Ee.type="paragraph",Ee.text=this.options.sanitizer?this.options.sanitizer(fe[0]):z(fe[0]),Ee.tokens=[],this.lexer.inline(Ee.text,Ee.tokens)),Ee}},Pe.def=function(de){var fe=this.rules.block.def.exec(de);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var Ee=fe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Ee,raw:fe[0],href:fe[2],title:fe[3]}}},Pe.table=function(de){var fe=this.rules.block.table.exec(de);if(fe){var Ee={type:"table",header:O(fe[1]).map(function(st){return{text:st}}),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:fe[3]?fe[3].replace(/\n$/,"").split(`
`):[]};if(Ee.header.length===Ee.align.length){Ee.raw=fe[0];var Ce=Ee.align.length,Ne,Ke,He,Qe;for(Ne=0;Ne<Ce;Ne++)/^ *-+: *$/.test(Ee.align[Ne])?Ee.align[Ne]="right":/^ *:-+: *$/.test(Ee.align[Ne])?Ee.align[Ne]="center":/^ *:-+ *$/.test(Ee.align[Ne])?Ee.align[Ne]="left":Ee.align[Ne]=null;for(Ce=Ee.rows.length,Ne=0;Ne<Ce;Ne++)Ee.rows[Ne]=O(Ee.rows[Ne],Ee.header.length).map(function(st){return{text:st}});for(Ce=Ee.header.length,Ke=0;Ke<Ce;Ke++)Ee.header[Ke].tokens=[],this.lexer.inlineTokens(Ee.header[Ke].text,Ee.header[Ke].tokens);for(Ce=Ee.rows.length,Ke=0;Ke<Ce;Ke++)for(Qe=Ee.rows[Ke],He=0;He<Qe.length;He++)Qe[He].tokens=[],this.lexer.inlineTokens(Qe[He].text,Qe[He].tokens);return Ee}}},Pe.lheading=function(de){var fe=this.rules.block.lheading.exec(de);if(fe){var Ee={type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1],tokens:[]};return this.lexer.inline(Ee.text,Ee.tokens),Ee}},Pe.paragraph=function(de){var fe=this.rules.block.paragraph.exec(de);if(fe){var Ee={type:"paragraph",raw:fe[0],text:fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1],tokens:[]};return this.lexer.inline(Ee.text,Ee.tokens),Ee}},Pe.text=function(de){var fe=this.rules.block.text.exec(de);if(fe){var Ee={type:"text",raw:fe[0],text:fe[0],tokens:[]};return this.lexer.inline(Ee.text,Ee.tokens),Ee}},Pe.escape=function(de){var fe=this.rules.inline.escape.exec(de);if(fe)return{type:"escape",raw:fe[0],text:z(fe[1])}},Pe.tag=function(de){var fe=this.rules.inline.tag.exec(de);if(fe)return!this.lexer.state.inLink&&/^<a /i.test(fe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(fe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):z(fe[0]):fe[0]}},Pe.link=function(de){var fe=this.rules.inline.link.exec(de);if(fe){var Ee=fe[2].trim();if(!this.options.pedantic&&/^</.test(Ee)){if(!/>$/.test(Ee))return;var Ce=F(Ee.slice(0,-1),"\\");if((Ee.length-Ce.length)%2==0)return}else{var Ne=W(fe[2],"()");if(Ne>-1){var Ke=fe[0].indexOf("!")===0?5:4,He=Ke+fe[1].length+Ne;fe[2]=fe[2].substring(0,Ne),fe[0]=fe[0].substring(0,He).trim(),fe[3]=""}}var Qe=fe[2],st="";if(this.options.pedantic){var at=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Qe);at&&(Qe=at[1],st=at[3])}else st=fe[3]?fe[3].slice(1,-1):"";return Qe=Qe.trim(),/^</.test(Qe)&&(this.options.pedantic&&!/>$/.test(Ee)?Qe=Qe.slice(1):Qe=Qe.slice(1,-1)),M(fe,{href:Qe&&Qe.replace(this.rules.inline._escapes,"$1"),title:st&&st.replace(this.rules.inline._escapes,"$1")},fe[0],this.lexer)}},Pe.reflink=function(de,fe){var Ee;if((Ee=this.rules.inline.reflink.exec(de))||(Ee=this.rules.inline.nolink.exec(de))){var Ce=(Ee[2]||Ee[1]).replace(/\s+/g," ");if(Ce=fe[Ce.toLowerCase()],!Ce||!Ce.href){var Ne=Ee[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return M(Ee,Ce,Ee[0],this.lexer)}},Pe.emStrong=function(de,fe,Ee){Ee===void 0&&(Ee="");var Ce=this.rules.inline.emStrong.lDelim.exec(de);if(!!Ce&&!(Ce[3]&&Ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=Ce[1]||Ce[2]||"";if(!Ne||Ne&&(Ee===""||this.rules.inline.punctuation.exec(Ee))){var Ke=Ce[0].length-1,He,Qe,st=Ke,at=0,me=Ce[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,fe=fe.slice(-1*de.length+Ke);(Ce=me.exec(fe))!=null;)if(He=Ce[1]||Ce[2]||Ce[3]||Ce[4]||Ce[5]||Ce[6],!!He){if(Qe=He.length,Ce[3]||Ce[4]){st+=Qe;continue}else if((Ce[5]||Ce[6])&&Ke%3&&!((Ke+Qe)%3)){at+=Qe;continue}if(st-=Qe,!(st>0)){if(Qe=Math.min(Qe,Qe+st+at),Math.min(Ke,Qe)%2){var De=de.slice(1,Ke+Ce.index+Qe);return{type:"em",raw:de.slice(0,Ke+Ce.index+Qe+1),text:De,tokens:this.lexer.inlineTokens(De,[])}}var ue=de.slice(2,Ke+Ce.index+Qe-1);return{type:"strong",raw:de.slice(0,Ke+Ce.index+Qe+1),text:ue,tokens:this.lexer.inlineTokens(ue,[])}}}}}},Pe.codespan=function(de){var fe=this.rules.inline.code.exec(de);if(fe){var Ee=fe[2].replace(/\n/g," "),Ce=/[^ ]/.test(Ee),Ne=/^ /.test(Ee)&&/ $/.test(Ee);return Ce&&Ne&&(Ee=Ee.substring(1,Ee.length-1)),Ee=z(Ee,!0),{type:"codespan",raw:fe[0],text:Ee}}},Pe.br=function(de){var fe=this.rules.inline.br.exec(de);if(fe)return{type:"br",raw:fe[0]}},Pe.del=function(de){var fe=this.rules.inline.del.exec(de);if(fe)return{type:"del",raw:fe[0],text:fe[2],tokens:this.lexer.inlineTokens(fe[2],[])}},Pe.autolink=function(de,fe){var Ee=this.rules.inline.autolink.exec(de);if(Ee){var Ce,Ne;return Ee[2]==="@"?(Ce=z(this.options.mangle?fe(Ee[1]):Ee[1]),Ne="mailto:"+Ce):(Ce=z(Ee[1]),Ne=Ce),{type:"link",raw:Ee[0],text:Ce,href:Ne,tokens:[{type:"text",raw:Ce,text:Ce}]}}},Pe.url=function(de,fe){var Ee;if(Ee=this.rules.inline.url.exec(de)){var Ce,Ne;if(Ee[2]==="@")Ce=z(this.options.mangle?fe(Ee[0]):Ee[0]),Ne="mailto:"+Ce;else{var Ke;do Ke=Ee[0],Ee[0]=this.rules.inline._backpedal.exec(Ee[0])[0];while(Ke!==Ee[0]);Ce=z(Ee[0]),Ee[1]==="www."?Ne="http://"+Ce:Ne=Ce}return{type:"link",raw:Ee[0],text:Ce,href:Ne,tokens:[{type:"text",raw:Ce,text:Ce}]}}},Pe.inlineText=function(de,fe){var Ee=this.rules.inline.text.exec(de);if(Ee){var Ce;return this.lexer.state.inRawBlock?Ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Ee[0]):z(Ee[0]):Ee[0]:Ce=z(this.options.smartypants?fe(Ee[0]):Ee[0]),{type:"text",raw:Ee[0],text:Ce}}},Ae}(),U=N.noopTest,H=N.edit,X=N.merge,se={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:U,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};se._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,se._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,se.def=H(se.def).replace("label",se._label).replace("title",se._title).getRegex(),se.bullet=/(?:[*+-]|\d{1,9}[.)])/,se.listItemStart=H(/^( *)(bull) */).replace("bull",se.bullet).getRegex(),se.list=H(se.list).replace(/bull/g,se.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+se.def.source+")").getRegex(),se._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",se._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,se.html=H(se.html,"i").replace("comment",se._comment).replace("tag",se._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),se.paragraph=H(se._paragraph).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.blockquote=H(se.blockquote).replace("paragraph",se.paragraph).getRegex(),se.normal=X({},se),se.gfm=X({},se.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),se.gfm.table=H(se.gfm.table).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.pedantic=X({},se.normal,{html:H(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",se._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:U,paragraph:H(se.normal._paragraph).replace("hr",se.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",se.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var K={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:U,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:U,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};K._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",K.punctuation=H(K.punctuation).replace(/punctuation/g,K._punctuation).getRegex(),K.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,K.escapedEmSt=/\\\*|\\_/g,K._comment=H(se._comment).replace("(?:-->|$)","-->").getRegex(),K.emStrong.lDelim=H(K.emStrong.lDelim).replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimAst=H(K.emStrong.rDelimAst,"g").replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimUnd=H(K.emStrong.rDelimUnd,"g").replace(/punct/g,K._punctuation).getRegex(),K._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,K._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,K._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,K.autolink=H(K.autolink).replace("scheme",K._scheme).replace("email",K._email).getRegex(),K._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,K.tag=H(K.tag).replace("comment",K._comment).replace("attribute",K._attribute).getRegex(),K._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,K._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,K._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,K.link=H(K.link).replace("label",K._label).replace("href",K._href).replace("title",K._title).getRegex(),K.reflink=H(K.reflink).replace("label",K._label).getRegex(),K.reflinkSearch=H(K.reflinkSearch,"g").replace("reflink",K.reflink).replace("nolink",K.nolink).getRegex(),K.normal=X({},K),K.pedantic=X({},K.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:H(/^!?\[(label)\]\((.*?)\)/).replace("label",K._label).getRegex(),reflink:H(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",K._label).getRegex()}),K.gfm=X({},K.normal,{escape:H(K.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),K.gfm.url=H(K.gfm.url,"i").replace("email",K.gfm._extended_email).getRegex(),K.breaks=X({},K.gfm,{br:H(K.br).replace("{2,}","*").getRegex(),text:H(K.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var j={block:se,inline:K},ie=V,ce=C.exports.defaults,ge=j.block,ke=j.inline,Le=N.repeatString;function Oe(Ae){return Ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(Ae){var Pe="",ye,de,fe=Ae.length;for(ye=0;ye<fe;ye++)de=Ae.charCodeAt(ye),Math.random()>.5&&(de="x"+de.toString(16)),Pe+="&#"+de+";";return Pe}var J=function(){function Ae(ye){this.tokens=[],this.tokens.links=Object.create(null),this.options=ye||ce,this.options.tokenizer=this.options.tokenizer||new ie,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var de={block:ge.normal,inline:ke.normal};this.options.pedantic?(de.block=ge.pedantic,de.inline=ke.pedantic):this.options.gfm&&(de.block=ge.gfm,this.options.breaks?de.inline=ke.breaks:de.inline=ke.gfm),this.tokenizer.rules=de}Ae.lex=function(de,fe){var Ee=new Ae(fe);return Ee.lex(de)},Ae.lexInline=function(de,fe){var Ee=new Ae(fe);return Ee.inlineTokens(de)};var Pe=Ae.prototype;return Pe.lex=function(de){de=de.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(de,this.tokens);for(var fe;fe=this.inlineQueue.shift();)this.inlineTokens(fe.src,fe.tokens);return this.tokens},Pe.blockTokens=function(de,fe){var Ee=this;fe===void 0&&(fe=[]),this.options.pedantic&&(de=de.replace(/^ +$/gm,""));for(var Ce,Ne,Ke,He;de;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(st){return(Ce=st.call({lexer:Ee},de,fe))?(de=de.substring(Ce.raw.length),fe.push(Ce),!0):!1}))){if(Ce=this.tokenizer.space(de)){de=de.substring(Ce.raw.length),Ce.type&&fe.push(Ce);continue}if(Ce=this.tokenizer.code(de)){de=de.substring(Ce.raw.length),Ne=fe[fe.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+Ce.raw,Ne.text+=`
`+Ce.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):fe.push(Ce);continue}if(Ce=this.tokenizer.fences(de)){de=de.substring(Ce.raw.length),fe.push(Ce);continue}if(Ce=this.tokenizer.heading(de)){de=de.substring(Ce.raw.length),fe.push(Ce);continue}if(Ce=this.tokenizer.hr(de)){de=de.substring(Ce.raw.length),fe.push(Ce);continue}if(Ce=this.tokenizer.blockquote(de)){de=de.substring(Ce.raw.length),fe.push(Ce);continue}if(Ce=this.tokenizer.list(de)){de=de.substring(Ce.raw.length),fe.push(Ce);continue}if(Ce=this.tokenizer.html(de)){de=de.substring(Ce.raw.length),fe.push(Ce);continue}if(Ce=this.tokenizer.def(de)){de=de.substring(Ce.raw.length),Ne=fe[fe.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+Ce.raw,Ne.text+=`
`+Ce.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[Ce.tag]||(this.tokens.links[Ce.tag]={href:Ce.href,title:Ce.title});continue}if(Ce=this.tokenizer.table(de)){de=de.substring(Ce.raw.length),fe.push(Ce);continue}if(Ce=this.tokenizer.lheading(de)){de=de.substring(Ce.raw.length),fe.push(Ce);continue}if(Ke=de,this.options.extensions&&this.options.extensions.startBlock&&function(){var st=1/0,at=de.slice(1),me=void 0;Ee.options.extensions.startBlock.forEach(function(De){me=De.call({lexer:this},at),typeof me=="number"&&me>=0&&(st=Math.min(st,me))}),st<1/0&&st>=0&&(Ke=de.substring(0,st+1))}(),this.state.top&&(Ce=this.tokenizer.paragraph(Ke))){Ne=fe[fe.length-1],He&&Ne.type==="paragraph"?(Ne.raw+=`
`+Ce.raw,Ne.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):fe.push(Ce),He=Ke.length!==de.length,de=de.substring(Ce.raw.length);continue}if(Ce=this.tokenizer.text(de)){de=de.substring(Ce.raw.length),Ne=fe[fe.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+Ce.raw,Ne.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):fe.push(Ce);continue}if(de){var Qe="Infinite loop on byte: "+de.charCodeAt(0);if(this.options.silent){console.error(Qe);break}else throw new Error(Qe)}}return this.state.top=!0,fe},Pe.inline=function(de,fe){this.inlineQueue.push({src:de,tokens:fe})},Pe.inlineTokens=function(de,fe){var Ee=this;fe===void 0&&(fe=[]);var Ce,Ne,Ke,He=de,Qe,st,at;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;(Qe=this.tokenizer.rules.inline.reflinkSearch.exec(He))!=null;)me.includes(Qe[0].slice(Qe[0].lastIndexOf("[")+1,-1))&&(He=He.slice(0,Qe.index)+"["+Le("a",Qe[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Qe=this.tokenizer.rules.inline.blockSkip.exec(He))!=null;)He=He.slice(0,Qe.index)+"["+Le("a",Qe[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Qe=this.tokenizer.rules.inline.escapedEmSt.exec(He))!=null;)He=He.slice(0,Qe.index)+"++"+He.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;de;)if(st||(at=""),st=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ue){return(Ce=ue.call({lexer:Ee},de,fe))?(de=de.substring(Ce.raw.length),fe.push(Ce),!0):!1}))){if(Ce=this.tokenizer.escape(de)){de=de.substring(Ce.raw.length),fe.push(Ce);continue}if(Ce=this.tokenizer.tag(de)){de=de.substring(Ce.raw.length),Ne=fe[fe.length-1],Ne&&Ce.type==="text"&&Ne.type==="text"?(Ne.raw+=Ce.raw,Ne.text+=Ce.text):fe.push(Ce);continue}if(Ce=this.tokenizer.link(de)){de=de.substring(Ce.raw.length),fe.push(Ce);continue}if(Ce=this.tokenizer.reflink(de,this.tokens.links)){de=de.substring(Ce.raw.length),Ne=fe[fe.length-1],Ne&&Ce.type==="text"&&Ne.type==="text"?(Ne.raw+=Ce.raw,Ne.text+=Ce.text):fe.push(Ce);continue}if(Ce=this.tokenizer.emStrong(de,He,at)){de=de.substring(Ce.raw.length),fe.push(Ce);continue}if(Ce=this.tokenizer.codespan(de)){de=de.substring(Ce.raw.length),fe.push(Ce);continue}if(Ce=this.tokenizer.br(de)){de=de.substring(Ce.raw.length),fe.push(Ce);continue}if(Ce=this.tokenizer.del(de)){de=de.substring(Ce.raw.length),fe.push(Ce);continue}if(Ce=this.tokenizer.autolink(de,q)){de=de.substring(Ce.raw.length),fe.push(Ce);continue}if(!this.state.inLink&&(Ce=this.tokenizer.url(de,q))){de=de.substring(Ce.raw.length),fe.push(Ce);continue}if(Ke=de,this.options.extensions&&this.options.extensions.startInline&&function(){var ue=1/0,Q=de.slice(1),Ie=void 0;Ee.options.extensions.startInline.forEach(function(Fe){Ie=Fe.call({lexer:this},Q),typeof Ie=="number"&&Ie>=0&&(ue=Math.min(ue,Ie))}),ue<1/0&&ue>=0&&(Ke=de.substring(0,ue+1))}(),Ce=this.tokenizer.inlineText(Ke,Oe)){de=de.substring(Ce.raw.length),Ce.raw.slice(-1)!=="_"&&(at=Ce.raw.slice(-1)),st=!0,Ne=fe[fe.length-1],Ne&&Ne.type==="text"?(Ne.raw+=Ce.raw,Ne.text+=Ce.text):fe.push(Ce);continue}if(de){var De="Infinite loop on byte: "+de.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return fe},e(Ae,null,[{key:"rules",get:function(){return{block:ge,inline:ke}}}]),Ae}(),re=C.exports.defaults,he=N.cleanUrl,ee=N.escape,ae=function(){function Ae(ye){this.options=ye||re}var Pe=Ae.prototype;return Pe.code=function(de,fe,Ee){var Ce=(fe||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(de,Ce);Ne!=null&&Ne!==de&&(Ee=!0,de=Ne)}return de=de.replace(/\n$/,"")+`
`,Ce?'<pre><code class="'+this.options.langPrefix+ee(Ce,!0)+'">'+(Ee?de:ee(de,!0))+`</code></pre>
`:"<pre><code>"+(Ee?de:ee(de,!0))+`</code></pre>
`},Pe.blockquote=function(de){return`<blockquote>
`+de+`</blockquote>
`},Pe.html=function(de){return de},Pe.heading=function(de,fe,Ee,Ce){return this.options.headerIds?"<h"+fe+' id="'+this.options.headerPrefix+Ce.slug(Ee)+'">'+de+"</h"+fe+`>
`:"<h"+fe+">"+de+"</h"+fe+`>
`},Pe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Pe.list=function(de,fe,Ee){var Ce=fe?"ol":"ul",Ne=fe&&Ee!==1?' start="'+Ee+'"':"";return"<"+Ce+Ne+`>
`+de+"</"+Ce+`>
`},Pe.listitem=function(de){return"<li>"+de+`</li>
`},Pe.checkbox=function(de){return"<input "+(de?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Pe.paragraph=function(de){return"<p>"+de+`</p>
`},Pe.table=function(de,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+de+`</thead>
`+fe+`</table>
`},Pe.tablerow=function(de){return`<tr>
`+de+`</tr>
`},Pe.tablecell=function(de,fe){var Ee=fe.header?"th":"td",Ce=fe.align?"<"+Ee+' align="'+fe.align+'">':"<"+Ee+">";return Ce+de+"</"+Ee+`>
`},Pe.strong=function(de){return"<strong>"+de+"</strong>"},Pe.em=function(de){return"<em>"+de+"</em>"},Pe.codespan=function(de){return"<code>"+de+"</code>"},Pe.br=function(){return this.options.xhtml?"<br/>":"<br>"},Pe.del=function(de){return"<del>"+de+"</del>"},Pe.link=function(de,fe,Ee){if(de=he(this.options.sanitize,this.options.baseUrl,de),de===null)return Ee;var Ce='<a href="'+ee(de)+'"';return fe&&(Ce+=' title="'+fe+'"'),Ce+=">"+Ee+"</a>",Ce},Pe.image=function(de,fe,Ee){if(de=he(this.options.sanitize,this.options.baseUrl,de),de===null)return Ee;var Ce='<img src="'+de+'" alt="'+Ee+'"';return fe&&(Ce+=' title="'+fe+'"'),Ce+=this.options.xhtml?"/>":">",Ce},Pe.text=function(de){return de},Ae}(),Se=function(){function Ae(){}var Pe=Ae.prototype;return Pe.strong=function(de){return de},Pe.em=function(de){return de},Pe.codespan=function(de){return de},Pe.del=function(de){return de},Pe.html=function(de){return de},Pe.text=function(de){return de},Pe.link=function(de,fe,Ee){return""+Ee},Pe.image=function(de,fe,Ee){return""+Ee},Pe.br=function(){return""},Ae}(),Ue=function(){function Ae(){this.seen={}}var Pe=Ae.prototype;return Pe.serialize=function(de){return de.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Pe.getNextSafeSlug=function(de,fe){var Ee=de,Ce=0;if(this.seen.hasOwnProperty(Ee)){Ce=this.seen[de];do Ce++,Ee=de+"-"+Ce;while(this.seen.hasOwnProperty(Ee))}return fe||(this.seen[de]=Ce,this.seen[Ee]=0),Ee},Pe.slug=function(de,fe){fe===void 0&&(fe={});var Ee=this.serialize(de);return this.getNextSafeSlug(Ee,fe.dryrun)},Ae}(),Ve=ae,Ge=Se,Je=Ue,tt=C.exports.defaults,ot=N.unescape,et=function(){function Ae(ye){this.options=ye||tt,this.options.renderer=this.options.renderer||new Ve,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ge,this.slugger=new Je}Ae.parse=function(de,fe){var Ee=new Ae(fe);return Ee.parse(de)},Ae.parseInline=function(de,fe){var Ee=new Ae(fe);return Ee.parseInline(de)};var Pe=Ae.prototype;return Pe.parse=function(de,fe){fe===void 0&&(fe=!0);var Ee="",Ce,Ne,Ke,He,Qe,st,at,me,De,ue,Q,Ie,Fe,Ze,qe,dt,wt,yt,bt,ft=de.length;for(Ce=0;Ce<ft;Ce++){if(ue=de[Ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ue.type]&&(bt=this.options.extensions.renderers[ue.type].call({parser:this},ue),bt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ue.type))){Ee+=bt||"";continue}switch(ue.type){case"space":continue;case"hr":{Ee+=this.renderer.hr();continue}case"heading":{Ee+=this.renderer.heading(this.parseInline(ue.tokens),ue.depth,ot(this.parseInline(ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{Ee+=this.renderer.code(ue.text,ue.lang,ue.escaped);continue}case"table":{for(me="",at="",He=ue.header.length,Ne=0;Ne<He;Ne++)at+=this.renderer.tablecell(this.parseInline(ue.header[Ne].tokens),{header:!0,align:ue.align[Ne]});for(me+=this.renderer.tablerow(at),De="",He=ue.rows.length,Ne=0;Ne<He;Ne++){for(st=ue.rows[Ne],at="",Qe=st.length,Ke=0;Ke<Qe;Ke++)at+=this.renderer.tablecell(this.parseInline(st[Ke].tokens),{header:!1,align:ue.align[Ke]});De+=this.renderer.tablerow(at)}Ee+=this.renderer.table(me,De);continue}case"blockquote":{De=this.parse(ue.tokens),Ee+=this.renderer.blockquote(De);continue}case"list":{for(Q=ue.ordered,Ie=ue.start,Fe=ue.loose,He=ue.items.length,De="",Ne=0;Ne<He;Ne++)qe=ue.items[Ne],dt=qe.checked,wt=qe.task,Ze="",qe.task&&(yt=this.renderer.checkbox(dt),Fe?qe.tokens.length>0&&qe.tokens[0].type==="paragraph"?(qe.tokens[0].text=yt+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=yt+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:yt}):Ze+=yt),Ze+=this.parse(qe.tokens,Fe),De+=this.renderer.listitem(Ze,wt,dt);Ee+=this.renderer.list(De,Q,Ie);continue}case"html":{Ee+=this.renderer.html(ue.text);continue}case"paragraph":{Ee+=this.renderer.paragraph(this.parseInline(ue.tokens));continue}case"text":{for(De=ue.tokens?this.parseInline(ue.tokens):ue.text;Ce+1<ft&&de[Ce+1].type==="text";)ue=de[++Ce],De+=`
`+(ue.tokens?this.parseInline(ue.tokens):ue.text);Ee+=fe?this.renderer.paragraph(De):De;continue}default:{var vt='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(vt);return}else throw new Error(vt)}}}return Ee},Pe.parseInline=function(de,fe){fe=fe||this.renderer;var Ee="",Ce,Ne,Ke,He=de.length;for(Ce=0;Ce<He;Ce++){if(Ne=de[Ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(Ke=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),Ke!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){Ee+=Ke||"";continue}switch(Ne.type){case"escape":{Ee+=fe.text(Ne.text);break}case"html":{Ee+=fe.html(Ne.text);break}case"link":{Ee+=fe.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,fe));break}case"image":{Ee+=fe.image(Ne.href,Ne.title,Ne.text);break}case"strong":{Ee+=fe.strong(this.parseInline(Ne.tokens,fe));break}case"em":{Ee+=fe.em(this.parseInline(Ne.tokens,fe));break}case"codespan":{Ee+=fe.codespan(Ne.text);break}case"br":{Ee+=fe.br();break}case"del":{Ee+=fe.del(this.parseInline(Ne.tokens,fe));break}case"text":{Ee+=fe.text(Ne.text);break}default:{var Qe='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Qe);return}else throw new Error(Qe)}}}return Ee},Ae}(),it=J,ct=et,pt=V,Pt=ae,We=Se,Rt=Ue,Z=N.merge,ne=N.checkSanitizeDeprecation,ve=N.escape,te=C.exports.getDefaults,_e=C.exports.changeDefaults,Me=C.exports.defaults;function Be(Ae,Pe,ye){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");if(typeof Pe=="function"&&(ye=Pe,Pe=null),Pe=Z({},Be.defaults,Pe||{}),ne(Pe),ye){var de=Pe.highlight,fe;try{fe=it.lex(Ae,Pe)}catch(Ke){return ye(Ke)}var Ee=function(He){var Qe;if(!He)try{Pe.walkTokens&&Be.walkTokens(fe,Pe.walkTokens),Qe=ct.parse(fe,Pe)}catch(st){He=st}return Pe.highlight=de,He?ye(He):ye(null,Qe)};if(!de||de.length<3||(delete Pe.highlight,!fe.length))return Ee();var Ce=0;Be.walkTokens(fe,function(Ke){Ke.type==="code"&&(Ce++,setTimeout(function(){de(Ke.text,Ke.lang,function(He,Qe){if(He)return Ee(He);Qe!=null&&Qe!==Ke.text&&(Ke.text=Qe,Ke.escaped=!0),Ce--,Ce===0&&Ee()})},0))}),Ce===0&&Ee();return}try{var Ne=it.lex(Ae,Pe);return Pe.walkTokens&&Be.walkTokens(Ne,Pe.walkTokens),ct.parse(Ne,Pe)}catch(Ke){if(Ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Pe.silent)return"<p>An error occurred:</p><pre>"+ve(Ke.message+"",!0)+"</pre>";throw Ke}}Be.options=Be.setOptions=function(Ae){return Z(Be.defaults,Ae),_e(Be.defaults),Be},Be.getDefaults=te,Be.defaults=Me,Be.use=function(){for(var Ae=this,Pe=arguments.length,ye=new Array(Pe),de=0;de<Pe;de++)ye[de]=arguments[de];var fe=Z.apply(void 0,[{}].concat(ye)),Ee=Be.defaults.extensions||{renderers:{},childTokens:{}},Ce;ye.forEach(function(Ne){if(Ne.extensions&&(Ce=!0,Ne.extensions.forEach(function(He){if(!He.name)throw new Error("extension name required");if(He.renderer){var Qe=Ee.renderers?Ee.renderers[He.name]:null;Qe?Ee.renderers[He.name]=function(){for(var st=arguments.length,at=new Array(st),me=0;me<st;me++)at[me]=arguments[me];var De=He.renderer.apply(this,at);return De===!1&&(De=Qe.apply(this,at)),De}:Ee.renderers[He.name]=He.renderer}if(He.tokenizer){if(!He.level||He.level!=="block"&&He.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Ee[He.level]?Ee[He.level].unshift(He.tokenizer):Ee[He.level]=[He.tokenizer],He.start&&(He.level==="block"?Ee.startBlock?Ee.startBlock.push(He.start):Ee.startBlock=[He.start]:He.level==="inline"&&(Ee.startInline?Ee.startInline.push(He.start):Ee.startInline=[He.start]))}He.childTokens&&(Ee.childTokens[He.name]=He.childTokens)})),Ne.renderer&&function(){var He=Be.defaults.renderer||new Pt,Qe=function(me){var De=He[me];He[me]=function(){for(var ue=arguments.length,Q=new Array(ue),Ie=0;Ie<ue;Ie++)Q[Ie]=arguments[Ie];var Fe=Ne.renderer[me].apply(He,Q);return Fe===!1&&(Fe=De.apply(He,Q)),Fe}};for(var st in Ne.renderer)Qe(st);fe.renderer=He}(),Ne.tokenizer&&function(){var He=Be.defaults.tokenizer||new pt,Qe=function(me){var De=He[me];He[me]=function(){for(var ue=arguments.length,Q=new Array(ue),Ie=0;Ie<ue;Ie++)Q[Ie]=arguments[Ie];var Fe=Ne.tokenizer[me].apply(He,Q);return Fe===!1&&(Fe=De.apply(He,Q)),Fe}};for(var st in Ne.tokenizer)Qe(st);fe.tokenizer=He}(),Ne.walkTokens){var Ke=Be.defaults.walkTokens;fe.walkTokens=function(He){Ne.walkTokens.call(Ae,He),Ke&&Ke(He)}}Ce&&(fe.extensions=Ee),Be.setOptions(fe)})},Be.walkTokens=function(Ae,Pe){for(var ye=function(){var Ce=fe.value;switch(Pe(Ce),Ce.type){case"table":{for(var Ne=y(Ce.header),Ke;!(Ke=Ne()).done;){var He=Ke.value;Be.walkTokens(He.tokens,Pe)}for(var Qe=y(Ce.rows),st;!(st=Qe()).done;)for(var at=st.value,me=y(at),De;!(De=me()).done;){var ue=De.value;Be.walkTokens(ue.tokens,Pe)}break}case"list":{Be.walkTokens(Ce.items,Pe);break}default:Be.defaults.extensions&&Be.defaults.extensions.childTokens&&Be.defaults.extensions.childTokens[Ce.type]?Be.defaults.extensions.childTokens[Ce.type].forEach(function(Q){Be.walkTokens(Ce[Q],Pe)}):Ce.tokens&&Be.walkTokens(Ce.tokens,Pe)}},de=y(Ae),fe;!(fe=de()).done;)ye()},Be.parseInline=function(Ae,Pe){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");Pe=Z({},Be.defaults,Pe||{}),ne(Pe);try{var ye=it.lexInline(Ae,Pe);return Pe.walkTokens&&Be.walkTokens(ye,Pe.walkTokens),ct.parseInline(ye,Pe)}catch(de){if(de.message+=`
Please report this to https://github.com/markedjs/marked.`,Pe.silent)return"<p>An error occurred:</p><pre>"+ve(de.message+"",!0)+"</pre>";throw de}},Be.Parser=ct,Be.parser=ct.parse,Be.Renderer=Pt,Be.TextRenderer=We,Be.Lexer=it,Be.lexer=it.lex,Be.Tokenizer=pt,Be.Slugger=Rt,Be.parse=Be;var Xe=Be;return Xe}),define(we[78],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(P,k,_){return Math.min(Math.max(P,k),_)}e.clamp=m;function i(P,k){return(k+P%k)%k}e.rot=i;class y{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=y;class C{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function Y(y){const C=[];typeof y=="number"&&C.push("code/timeOrigin",y);function P(_){C.push(_,Date.now())}function k(){const _=[];for(let I=0;I<C.length;I+=2)_.push({name:C[I],startTime:C[I+1]});return _}return{mark:P,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const P of performance.getEntriesByType("mark"))C.push({name:P.name,startTime:Math.round(y+P.startTime)});return C}};if(typeof process=="object"){const y=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function m(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=m(i))}(),define(we[12],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const m="en";let i=!1,y=!1,C=!1,P=!1,k=!1,_=!1,I=!1,L=!1,T,l=m,E,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?p=e.globals.vscode.process:typeof process!="undefined"&&(p=process);const v=typeof p?.versions?.electron=="string",A=v&&p?.type==="renderer";if(e.isElectronSandboxed=A&&p?.sandboxed,typeof navigator=="object"&&!A)h=navigator.userAgent,i=h.indexOf("Windows")>=0,y=h.indexOf("Macintosh")>=0,L=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=h.indexOf("Linux")>=0,_=!0,T=navigator.language,l=T;else if(typeof p=="object"){i=p.platform==="win32",y=p.platform==="darwin",C=p.platform==="linux",P=C&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,I=v,T=m,l=m;const n=p.env.VSCODE_NLS_CONFIG;if(n)try{const u=JSON.parse(n),a=u.availableLanguages["*"];T=u.locale,l=a||m,E=u._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var w;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function s(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=s;let o=0;y?o=1:i?o=3:C&&(o=2),e.isWindows=i,e.isMacintosh=y,e.isLinux=C,e.isLinuxSnap=P,e.isNative=k,e.isElectron=I,e.isWeb=_,e.isIOS=L,e.platform=o,e.userAgent=h,e.language=l;var g;(function(n){function u(){return e.language}n.value=u;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=a;function f(){return e.language==="en"}n.isDefault=f})(g=e.Language||(e.Language={})),e.locale=T,e.translationsConfigFile=E,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let n=[];e.globals.addEventListener("message",a=>{if(a.data&&a.data.vscodeScheduleAsyncWork)for(let f=0,b=n.length;f<b;f++){const d=n[f];if(d.id===a.data.vscodeScheduleAsyncWork){n.splice(f,1),d.callback();return}}});let u=0;return a=>{const f=++u;n.push({id:f,callback:a}),e.globals.postMessage({vscodeScheduleAsyncWork:f},"*")}}return n=>setTimeout(n)})();var c;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||L?2:i?1:3;let S=!0,r=!1;function t(){if(!r){r=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,S=new Uint16Array(n.buffer)[0]===(2<<8)+1}return S}e.isLittleEndian=t}),define(we[40],be([0,1,12]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const y=m.globals.vscode.process;i={get platform(){return y.platform},get arch(){return y.arch},get env(){return y.env},cwd(){return y.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(we[9],be([0,1,40]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,y=97,C=90,P=122,k=46,_=47,I=92,L=58,T=63;class l extends Error{constructor(o,g,c){let S;typeof g=="string"&&g.indexOf("not ")===0?(S="must not be",g=g.replace(/^not /,"")):S="must be";const r=o.indexOf(".")!==-1?"property":"argument";let t=`The "${o}" ${r} ${S} of type ${g}`;t+=`. Received type ${typeof c}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function E(s,o){if(typeof s!="string")throw new l(o,"string",s)}function h(s){return s===_||s===I}function p(s){return s===_}function v(s){return s>=i&&s<=C||s>=y&&s<=P}function A(s,o,g,c){let S="",r=0,t=-1,n=0,u=0;for(let a=0;a<=s.length;++a){if(a<s.length)u=s.charCodeAt(a);else{if(c(u))break;u=_}if(c(u)){if(!(t===a-1||n===1))if(n===2){if(S.length<2||r!==2||S.charCodeAt(S.length-1)!==k||S.charCodeAt(S.length-2)!==k){if(S.length>2){const f=S.lastIndexOf(g);f===-1?(S="",r=0):(S=S.slice(0,f),r=S.length-1-S.lastIndexOf(g)),t=a,n=0;continue}else if(S.length!==0){S="",r=0,t=a,n=0;continue}}o&&(S+=S.length>0?`${g}..`:"..",r=2)}else S.length>0?S+=`${g}${s.slice(t+1,a)}`:S=s.slice(t+1,a),r=a-t-1;t=a,n=0}else u===k&&n!==-1?++n:n=-1}return S}function w(s,o){if(o===null||typeof o!="object")throw new l("pathObject","Object",o);const g=o.dir||o.root,c=o.base||`${o.name||""}${o.ext||""}`;return g?g===o.root?`${g}${c}`:`${g}${s}${c}`:c}e.win32={resolve(...s){let o="",g="",c=!1;for(let S=s.length-1;S>=-1;S--){let r;if(S>=0){if(r=s[S],E(r,"path"),r.length===0)continue}else o.length===0?r=m.cwd():(r=m.env[`=${o}`]||m.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===I)&&(r=`${o}\\`));const t=r.length;let n=0,u="",a=!1;const f=r.charCodeAt(0);if(t===1)h(f)&&(n=1,a=!0);else if(h(f))if(a=!0,h(r.charCodeAt(1))){let b=2,d=b;for(;b<t&&!h(r.charCodeAt(b));)b++;if(b<t&&b!==d){const D=r.slice(d,b);for(d=b;b<t&&h(r.charCodeAt(b));)b++;if(b<t&&b!==d){for(d=b;b<t&&!h(r.charCodeAt(b));)b++;(b===t||b!==d)&&(u=`\\\\${D}\\${r.slice(d,b)}`,n=b)}}}else n=1;else v(f)&&r.charCodeAt(1)===L&&(u=r.slice(0,2),n=2,t>2&&h(r.charCodeAt(2))&&(a=!0,n=3));if(u.length>0)if(o.length>0){if(u.toLowerCase()!==o.toLowerCase())continue}else o=u;if(c){if(o.length>0)break}else if(g=`${r.slice(n)}\\${g}`,c=a,a&&o.length>0)break}return g=A(g,!c,"\\",h),c?`${o}\\${g}`:`${o}${g}`||"."},normalize(s){E(s,"path");const o=s.length;if(o===0)return".";let g=0,c,S=!1;const r=s.charCodeAt(0);if(o===1)return p(r)?"\\":s;if(h(r))if(S=!0,h(s.charCodeAt(1))){let n=2,u=n;for(;n<o&&!h(s.charCodeAt(n));)n++;if(n<o&&n!==u){const a=s.slice(u,n);for(u=n;n<o&&h(s.charCodeAt(n));)n++;if(n<o&&n!==u){for(u=n;n<o&&!h(s.charCodeAt(n));)n++;if(n===o)return`\\\\${a}\\${s.slice(u)}\\`;n!==u&&(c=`\\\\${a}\\${s.slice(u,n)}`,g=n)}}}else g=1;else v(r)&&s.charCodeAt(1)===L&&(c=s.slice(0,2),g=2,o>2&&h(s.charCodeAt(2))&&(S=!0,g=3));let t=g<o?A(s.slice(g),!S,"\\",h):"";return t.length===0&&!S&&(t="."),t.length>0&&h(s.charCodeAt(o-1))&&(t+="\\"),c===void 0?S?`\\${t}`:t:S?`${c}\\${t}`:`${c}${t}`},isAbsolute(s){E(s,"path");const o=s.length;if(o===0)return!1;const g=s.charCodeAt(0);return h(g)||o>2&&v(g)&&s.charCodeAt(1)===L&&h(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let o,g;for(let r=0;r<s.length;++r){const t=s[r];E(t,"path"),t.length>0&&(o===void 0?o=g=t:o+=`\\${t}`)}if(o===void 0)return".";let c=!0,S=0;if(typeof g=="string"&&h(g.charCodeAt(0))){++S;const r=g.length;r>1&&h(g.charCodeAt(1))&&(++S,r>2&&(h(g.charCodeAt(2))?++S:c=!1))}if(c){for(;S<o.length&&h(o.charCodeAt(S));)S++;S>=2&&(o=`\\${o.slice(S)}`)}return e.win32.normalize(o)},relative(s,o){if(E(s,"from"),E(o,"to"),s===o)return"";const g=e.win32.resolve(s),c=e.win32.resolve(o);if(g===c||(s=g.toLowerCase(),o=c.toLowerCase(),s===o))return"";let S=0;for(;S<s.length&&s.charCodeAt(S)===I;)S++;let r=s.length;for(;r-1>S&&s.charCodeAt(r-1)===I;)r--;const t=r-S;let n=0;for(;n<o.length&&o.charCodeAt(n)===I;)n++;let u=o.length;for(;u-1>n&&o.charCodeAt(u-1)===I;)u--;const a=u-n,f=t<a?t:a;let b=-1,d=0;for(;d<f;d++){const R=s.charCodeAt(S+d);if(R!==o.charCodeAt(n+d))break;R===I&&(b=d)}if(d!==f){if(b===-1)return c}else{if(a>f){if(o.charCodeAt(n+d)===I)return c.slice(n+d+1);if(d===2)return c.slice(n+d)}t>f&&(s.charCodeAt(S+d)===I?b=d:d===2&&(b=3)),b===-1&&(b=0)}let D="";for(d=S+b+1;d<=r;++d)(d===r||s.charCodeAt(d)===I)&&(D+=D.length===0?"..":"\\..");return n+=b,D.length>0?`${D}${c.slice(n,u)}`:(c.charCodeAt(n)===I&&++n,c.slice(n,u))},toNamespacedPath(s){if(typeof s!="string")return s;if(s.length===0)return"";const o=e.win32.resolve(s);if(o.length<=2)return s;if(o.charCodeAt(0)===I){if(o.charCodeAt(1)===I){const g=o.charCodeAt(2);if(g!==T&&g!==k)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(v(o.charCodeAt(0))&&o.charCodeAt(1)===L&&o.charCodeAt(2)===I)return`\\\\?\\${o}`;return s},dirname(s){E(s,"path");const o=s.length;if(o===0)return".";let g=-1,c=0;const S=s.charCodeAt(0);if(o===1)return h(S)?s:".";if(h(S)){if(g=c=1,h(s.charCodeAt(1))){let n=2,u=n;for(;n<o&&!h(s.charCodeAt(n));)n++;if(n<o&&n!==u){for(u=n;n<o&&h(s.charCodeAt(n));)n++;if(n<o&&n!==u){for(u=n;n<o&&!h(s.charCodeAt(n));)n++;if(n===o)return s;n!==u&&(g=c=n+1)}}}}else v(S)&&s.charCodeAt(1)===L&&(g=o>2&&h(s.charCodeAt(2))?3:2,c=g);let r=-1,t=!0;for(let n=o-1;n>=c;--n)if(h(s.charCodeAt(n))){if(!t){r=n;break}}else t=!1;if(r===-1){if(g===-1)return".";r=g}return s.slice(0,r)},basename(s,o){o!==void 0&&E(o,"ext"),E(s,"path");let g=0,c=-1,S=!0,r;if(s.length>=2&&v(s.charCodeAt(0))&&s.charCodeAt(1)===L&&(g=2),o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let t=o.length-1,n=-1;for(r=s.length-1;r>=g;--r){const u=s.charCodeAt(r);if(h(u)){if(!S){g=r+1;break}}else n===-1&&(S=!1,n=r+1),t>=0&&(u===o.charCodeAt(t)?--t==-1&&(c=r):(t=-1,c=n))}return g===c?c=n:c===-1&&(c=s.length),s.slice(g,c)}for(r=s.length-1;r>=g;--r)if(h(s.charCodeAt(r))){if(!S){g=r+1;break}}else c===-1&&(S=!1,c=r+1);return c===-1?"":s.slice(g,c)},extname(s){E(s,"path");let o=0,g=-1,c=0,S=-1,r=!0,t=0;s.length>=2&&s.charCodeAt(1)===L&&v(s.charCodeAt(0))&&(o=c=2);for(let n=s.length-1;n>=o;--n){const u=s.charCodeAt(n);if(h(u)){if(!r){c=n+1;break}continue}S===-1&&(r=!1,S=n+1),u===k?g===-1?g=n:t!==1&&(t=1):g!==-1&&(t=-1)}return g===-1||S===-1||t===0||t===1&&g===S-1&&g===c+1?"":s.slice(g,S)},format:w.bind(null,"\\"),parse(s){E(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const g=s.length;let c=0,S=s.charCodeAt(0);if(g===1)return h(S)?(o.root=o.dir=s,o):(o.base=o.name=s,o);if(h(S)){if(c=1,h(s.charCodeAt(1))){let b=2,d=b;for(;b<g&&!h(s.charCodeAt(b));)b++;if(b<g&&b!==d){for(d=b;b<g&&h(s.charCodeAt(b));)b++;if(b<g&&b!==d){for(d=b;b<g&&!h(s.charCodeAt(b));)b++;b===g?c=b:b!==d&&(c=b+1)}}}}else if(v(S)&&s.charCodeAt(1)===L){if(g<=2)return o.root=o.dir=s,o;if(c=2,h(s.charCodeAt(2))){if(g===3)return o.root=o.dir=s,o;c=3}}c>0&&(o.root=s.slice(0,c));let r=-1,t=c,n=-1,u=!0,a=s.length-1,f=0;for(;a>=c;--a){if(S=s.charCodeAt(a),h(S)){if(!u){t=a+1;break}continue}n===-1&&(u=!1,n=a+1),S===k?r===-1?r=a:f!==1&&(f=1):r!==-1&&(f=-1)}return n!==-1&&(r===-1||f===0||f===1&&r===n-1&&r===t+1?o.base=o.name=s.slice(t,n):(o.name=s.slice(t,r),o.base=s.slice(t,n),o.ext=s.slice(r,n))),t>0&&t!==c?o.dir=s.slice(0,t-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...s){let o="",g=!1;for(let c=s.length-1;c>=-1&&!g;c--){const S=c>=0?s[c]:m.cwd();E(S,"path"),S.length!==0&&(o=`${S}/${o}`,g=S.charCodeAt(0)===_)}return o=A(o,!g,"/",p),g?`/${o}`:o.length>0?o:"."},normalize(s){if(E(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===_,g=s.charCodeAt(s.length-1)===_;return s=A(s,!o,"/",p),s.length===0?o?"/":g?"./":".":(g&&(s+="/"),o?`/${s}`:s)},isAbsolute(s){return E(s,"path"),s.length>0&&s.charCodeAt(0)===_},join(...s){if(s.length===0)return".";let o;for(let g=0;g<s.length;++g){const c=s[g];E(c,"path"),c.length>0&&(o===void 0?o=c:o+=`/${c}`)}return o===void 0?".":e.posix.normalize(o)},relative(s,o){if(E(s,"from"),E(o,"to"),s===o||(s=e.posix.resolve(s),o=e.posix.resolve(o),s===o))return"";const g=1,c=s.length,S=c-g,r=1,t=o.length-r,n=S<t?S:t;let u=-1,a=0;for(;a<n;a++){const b=s.charCodeAt(g+a);if(b!==o.charCodeAt(r+a))break;b===_&&(u=a)}if(a===n)if(t>n){if(o.charCodeAt(r+a)===_)return o.slice(r+a+1);if(a===0)return o.slice(r+a)}else S>n&&(s.charCodeAt(g+a)===_?u=a:a===0&&(u=0));let f="";for(a=g+u+1;a<=c;++a)(a===c||s.charCodeAt(a)===_)&&(f+=f.length===0?"..":"/..");return`${f}${o.slice(r+u)}`},toNamespacedPath(s){return s},dirname(s){if(E(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===_;let g=-1,c=!0;for(let S=s.length-1;S>=1;--S)if(s.charCodeAt(S)===_){if(!c){g=S;break}}else c=!1;return g===-1?o?"/":".":o&&g===1?"//":s.slice(0,g)},basename(s,o){o!==void 0&&E(o,"ext"),E(s,"path");let g=0,c=-1,S=!0,r;if(o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let t=o.length-1,n=-1;for(r=s.length-1;r>=0;--r){const u=s.charCodeAt(r);if(u===_){if(!S){g=r+1;break}}else n===-1&&(S=!1,n=r+1),t>=0&&(u===o.charCodeAt(t)?--t==-1&&(c=r):(t=-1,c=n))}return g===c?c=n:c===-1&&(c=s.length),s.slice(g,c)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===_){if(!S){g=r+1;break}}else c===-1&&(S=!1,c=r+1);return c===-1?"":s.slice(g,c)},extname(s){E(s,"path");let o=-1,g=0,c=-1,S=!0,r=0;for(let t=s.length-1;t>=0;--t){const n=s.charCodeAt(t);if(n===_){if(!S){g=t+1;break}continue}c===-1&&(S=!1,c=t+1),n===k?o===-1?o=t:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||c===-1||r===0||r===1&&o===c-1&&o===g+1?"":s.slice(o,c)},format:w.bind(null,"/"),parse(s){E(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const g=s.charCodeAt(0)===_;let c;g?(o.root="/",c=1):c=0;let S=-1,r=0,t=-1,n=!0,u=s.length-1,a=0;for(;u>=c;--u){const f=s.charCodeAt(u);if(f===_){if(!n){r=u+1;break}continue}t===-1&&(n=!1,t=u+1),f===k?S===-1?S=u:a!==1&&(a=1):S!==-1&&(a=-1)}if(t!==-1){const f=r===0&&g?1:r;S===-1||a===0||a===1&&S===t-1&&S===r+1?o.base=o.name=s.slice(f,t):(o.name=s.slice(f,S),o.base=s.slice(f,t),o.ext=s.slice(S,t))}return r>0?o.dir=s.slice(0,r-1):g&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[94],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var i;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(i=e.TerminateResponseCode||(e.TerminateResponseCode={}));function y(C,...P){const k=P.reduce((L,T)=>(L[T]=!0,L),{}),_=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(L=>!k[L]).forEach(L=>{for(let T=0;T<_.length;T++)if(L.search(_[T])!==-1){delete C[L];break}})}e.sanitizeProcessEnvironment=y}),define(we[46],be([0,1,12]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=m.globals.performance&&typeof m.globals.performance.now=="function";class y{constructor(P){this._highResolution=i&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new y(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=y}),define(we[3],be([0,1,15,75,6,93,46]),function(Y,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(o){o.None=()=>y.Disposable.None;function g(M){return(x,V=null,U)=>{let H=!1,X;return X=M(se=>{if(!H)return X?X.dispose():H=!0,x.call(V,se)},null,U),H&&X.dispose(),X}}o.once=g;function c(M,x){return a((V,U=null,H)=>M(X=>V.call(U,x(X)),null,H))}o.map=c;function S(M,x){return a((V,U=null,H)=>M(X=>{x(X),V.call(U,X)},null,H))}o.forEach=S;function r(M,x){return a((V,U=null,H)=>M(X=>x(X)&&V.call(U,X),null,H))}o.filter=r;function t(M){return M}o.signal=t;function n(...M){return(x,V=null,U)=>(0,y.combinedDisposable)(...M.map(H=>H(X=>x.call(V,X),null,U)))}o.any=n;function u(M,x,V){let U=V;return c(M,H=>(U=x(U,H),U))}o.reduce=u;function a(M){let x;const V=new l({onFirstListenerAdd(){x=M(V.fire,V)},onLastListenerRemove(){x.dispose()}});return V.event}function f(M,x,V,U=100,H=!1){let X,se,K=0;return M(j=>{K++,X=V(X,j),H&&!se&&(x(X),X=void 0),clearTimeout(se),se=setTimeout(()=>{const ie=X;X=void 0,se=void 0,(!H||K>1)&&x(ie),K=0},U)})}o.debouncedListener=f;function b(M,x,V=100,U=!1,H){let X,se,K,j=0;const ie=new l({leakWarningThreshold:H,onFirstListenerAdd(){X=M(ce=>{j++,se=x(se,ce),U&&!K&&(ie.fire(se),se=void 0),clearTimeout(K),K=setTimeout(()=>{const ge=se;se=void 0,K=void 0,(!U||j>1)&&ie.fire(ge),j=0},V)})},onLastListenerRemove(){X.dispose()}});return ie.event}o.debounce=b;function d(M,x=(V,U)=>V===U){let V=!0,U;return r(M,H=>{const X=V||!x(H,U);return V=!1,U=H,X})}o.latch=d;function D(M,x){return[o.filter(M,x),o.filter(M,V=>!x(V))]}o.split=D;function R(M,x=!1,V=[]){let U=V.slice(),H=M(K=>{U?U.push(K):se.fire(K)});const X=()=>{U&&U.forEach(K=>se.fire(K)),U=null},se=new l({onFirstListenerAdd(){H||(H=M(K=>se.fire(K)))},onFirstListenerDidAdd(){U&&(x?setTimeout(X):X())},onLastListenerRemove(){H&&H.dispose(),H=null}});return se.event}o.buffer=R;class N{constructor(x){this.event=x}map(x){return new N(c(this.event,x))}forEach(x){return new N(S(this.event,x))}filter(x){return new N(r(this.event,x))}reduce(x,V){return new N(u(this.event,x,V))}latch(){return new N(d(this.event))}debounce(x,V=100,U=!1,H){return new N(b(this.event,x,V,U,H))}on(x,V,U){return this.event(x,V,U)}once(x,V,U){return g(this.event)(x,V,U)}}function B(M){return new N(M)}o.chain=B;function F(M,x,V=U=>U){const U=(...K)=>se.fire(V(...K)),H=()=>M.on(x,U),X=()=>M.removeListener(x,U),se=new l({onFirstListenerAdd:H,onLastListenerRemove:X});return se.event}o.fromNodeEventEmitter=F;function O(M,x,V=U=>U){const U=(...K)=>se.fire(V(...K)),H=()=>M.addEventListener(x,U),X=()=>M.removeEventListener(x,U),se=new l({onFirstListenerAdd:H,onLastListenerRemove:X});return se.event}o.fromDOMEventEmitter=O;function z(M){return new Promise(x=>g(M)(x))}o.toPromise=z;function W(M,x){return x(void 0),M(V=>x(V))}o.runAndSubscribe=W})(k=e.Event||(e.Event={}));class _{constructor(g){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${g}_${_._idPool++}`}start(g){this._stopWatch=new P.StopWatch(!0),this._listenerCount=g}stop(){if(this._stopWatch){const g=this._stopWatch.elapsed();this._elapsedOverall+=g,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${g.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let I=-1;function L(o){const g=I;return I=o,{dispose(){I=g}}}e.setGlobalLeakWarningThreshold=L;class T{constructor(g,c=Math.random().toString(18).slice(2,5)){this.customThreshold=g,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(g){let c=I;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),c<=0||g<c)return;this._stacks||(this._stacks=new Map);const S=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(S)||0;if(this._stacks.set(S,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let t,n=0;for(const[u,a]of this._stacks)(!t||n<a)&&(t=u,n=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(S)||0;this._stacks.set(S,t-1)}}}class l{constructor(g){this._disposed=!1,this._options=g,this._leakageMon=I>0?new T(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(g,c,S)=>{this._listeners||(this._listeners=new C.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(c?[g,c]:g);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,g,c);const n=this._leakageMon?.check(this._listeners.size),u=(0,y.toDisposable)(()=>{n&&n(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return S instanceof y.DisposableStore?S.add(u):Array.isArray(S)&&S.push(u),u}),this._event}fire(g){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let c of this._listeners)this._deliveryQueue.push([c,g]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[c,S]=this._deliveryQueue.shift();try{typeof c=="function"?c.call(void 0,S):c[0].call(c[1],S)}catch(r){(0,m.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=l;class E extends l{async fireAsync(g,c,S){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,g]);for(;this._asyncDeliveryQueue.size>0&&!c.isCancellationRequested;){const[r,t]=this._asyncDeliveryQueue.shift(),n=[],u={...t,token:c,waitUntil:a=>{if(Object.isFrozen(n))throw new Error("waitUntil can NOT be called asynchronous");S&&(a=S(a,typeof r=="function"?r:r[0])),n.push(a)}};try{typeof r=="function"?r.call(void 0,u):r[0].call(r[1],u)}catch(a){(0,m.onUnexpectedError)(a);continue}Object.freeze(n),await Promise.allSettled(n).then(a=>{for(const f of a)f.status==="rejected"&&(0,m.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=E;class h extends l{constructor(g){super(g);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=g?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const g=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(g))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(g){this._listeners&&(this._isPaused!==0?this._eventQueue.push(g):super.fire(g))}}e.PauseableEmitter=h;class p extends h{constructor(g){super(g);this._delay=g.delay??100}fire(g){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(g)}}e.DebounceEmitter=p;class v extends l{constructor(g){super(g);this._queuedEvents=[],this._mergeFn=g?.merge}fire(g){this._queuedEvents.push(g),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(c=>super.fire(c)),this._queuedEvents=[]})}}e.MicrotaskEmitter=v;class A{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(g){const c={event:g,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const S=()=>{this.hasListeners&&this.unhook(c);const r=this.events.indexOf(c);this.events.splice(r,1)};return(0,y.toDisposable)((0,i.once)(S))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(g=>this.hook(g))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(g=>this.unhook(g))}hook(g){g.listener=g.event(c=>this.emitter.fire(c))}unhook(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=A;class w{constructor(){this.buffers=[]}wrapEvent(g){return(c,S,r)=>g(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>c.call(S,t)):c.call(S,t)},void 0,r)}bufferEvents(g){const c=[];this.buffers.push(c);const S=g();return this.buffers.pop(),c.forEach(r=>r()),S}}e.EventBufferer=w;class s{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=y.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(g){this.inputEvent=g,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=g(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(we[21],be([0,1,3]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(k,_){const I=setTimeout(k.bind(_),0);return{dispose(){clearTimeout(I)}}});var y;(function(k){function _(I){return I===k.None||I===k.Cancelled||I instanceof C?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}k.isCancellationToken=_,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(y=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=y.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=y.None}}e.CancellationTokenSource=P}),define(we[95],be([0,1,15,6]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function y(s){const o=s;return o?[o.on,o.pause,o.resume,o.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=y;function C(s){const o=s;return o?y(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=C;function P(s,o){return new k(s,o)}e.newWriteableStream=P;class k{constructor(o,g){this.reducer=o,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(g=>this.pendingWritePromises.push(g))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(g=>g(o))}emitError(o){this.listeners.error.length===0?(0,m.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(g=>g(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,g){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(o,g){if(this.state.destroyed)return;let c;switch(o){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const S=c.indexOf(g);S>=0&&c.splice(S,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(s,o){const g=[];let c;for(;(c=s.read())!==null;)g.push(c);return o(g)}e.consumeReadable=_;function I(s,o,g){const c=[];let S;for(;(S=s.read())!==null&&c.length<g;)c.push(S);return S===null&&c.length>0?o(c):{read:()=>{if(c.length>0)return c.shift();if(typeof S!="undefined"){const r=S;return S=void 0,r}return s.read()}}}e.peekReadable=I;function L(s,o){return new Promise((g,c)=>{const S=[];T(s,{onData:r=>{o&&S.push(r)},onError:r=>{o?c(r):g(void 0)},onEnd:()=>{g(o?o(S):void 0)}})})}e.consumeStream=L;function T(s,o){let g=!1;return s.on("error",c=>{g||o.onError(c)}),s.on("end",()=>{g||o.onEnd()}),s.on("data",c=>{g||o.onData(c)}),(0,i.toDisposable)(()=>g=!0)}e.listenStream=T;function l(s,o){return new Promise((g,c)=>{const S=new i.DisposableStore,r=[],t=a=>{if(r.push(a),r.length>o)return S.dispose(),s.pause(),g({stream:s,buffer:r,ended:!1})},n=a=>c(a),u=()=>g({stream:s,buffer:r,ended:!0});S.add((0,i.toDisposable)(()=>s.removeListener("error",n))),s.on("error",n),S.add((0,i.toDisposable)(()=>s.removeListener("end",u))),s.on("end",u),S.add((0,i.toDisposable)(()=>s.removeListener("data",t))),s.on("data",t)})}e.peekStream=l;function E(s,o){const g=P(o);return g.end(s),g}e.toStream=E;function h(){const s=P(()=>{throw new Error("not supported")});return s.end(),s}e.emptyStream=h;function p(s){let o=!1;return{read:()=>o?null:(o=!0,s)}}e.toReadable=p;function v(s,o,g){const c=P(g);return T(s,{onData:S=>c.write(o.data(S)),onError:S=>c.error(o.error?o.error(S):S),onEnd:()=>c.end()}),c}e.transform=v;function A(s,o,g){let c=!1;return{read:()=>{const S=o.read();return c?S:(c=!0,S!==null?g([s,S]):s)}}}e.prefixedReadable=A;function w(s,o,g){let c=!1;const S=P(g);return T(o,{onData:r=>c?S.write(r):(c=!0,S.write(g([s,r]))),onError:r=>S.error(r),onEnd:()=>{c||(c=!0,S.write(s)),S.end()}}),S}e.prefixedStream=w}),define(we[22],be([0,1,95]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer!="undefined";let y,C;class P{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return i?new P(Buffer.allocUnsafe(t)):new P(new Uint8Array(t))}static wrap(t){return i&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new P(t)}static fromString(t,n){return!(n?.dontUseNodeBuffer||!1)&&i?new P(Buffer.from(t)):(y||(y=new TextEncoder),new P(y.encode(t)))}static fromByteArray(t){const n=P.alloc(t.length);for(let u=0,a=t.length;u<a;u++)n.buffer[u]=t[u];return n}static concat(t,n){if(typeof n=="undefined"){n=0;for(let f=0,b=t.length;f<b;f++)n+=t[f].byteLength}const u=P.alloc(n);let a=0;for(let f=0,b=t.length;f<b;f++){const d=t[f];u.set(d,a),a+=d.byteLength}return u}clone(){const t=P.alloc(this.byteLength);return t.set(this),t}toString(){return i?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(t,n){return new P(this.buffer.subarray(t,n))}set(t,n){if(t instanceof P)this.buffer.set(t.buffer,n);else if(t instanceof Uint8Array)this.buffer.set(t,n);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),n);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),n);else throw new Error("Unkown argument 'array'")}readUInt32BE(t){return I(this.buffer,t)}writeUInt32BE(t,n){L(this.buffer,t,n)}readUInt32LE(t){return T(this.buffer,t)}writeUInt32LE(t,n){l(this.buffer,t,n)}readUInt8(t){return E(this.buffer,t)}writeUInt8(t,n){h(this.buffer,t,n)}}e.VSBuffer=P;function k(r,t){return r[t+0]<<0>>>0|r[t+1]<<8>>>0}e.readUInt16LE=k;function _(r,t,n){r[n+0]=t&255,t=t>>>8,r[n+1]=t&255}e.writeUInt16LE=_;function I(r,t){return r[t]*2**24+r[t+1]*2**16+r[t+2]*2**8+r[t+3]}e.readUInt32BE=I;function L(r,t,n){r[n+3]=t,t=t>>>8,r[n+2]=t,t=t>>>8,r[n+1]=t,t=t>>>8,r[n]=t}e.writeUInt32BE=L;function T(r,t){return r[t+0]<<0>>>0|r[t+1]<<8>>>0|r[t+2]<<16>>>0|r[t+3]<<24>>>0}e.readUInt32LE=T;function l(r,t,n){r[n+0]=t&255,t=t>>>8,r[n+1]=t&255,t=t>>>8,r[n+2]=t&255,t=t>>>8,r[n+3]=t&255}e.writeUInt32LE=l;function E(r,t){return r[t]}e.readUInt8=E;function h(r,t,n){r[n]=t}e.writeUInt8=h;function p(r){return m.consumeReadable(r,t=>P.concat(t))}e.readableToBuffer=p;function v(r){return m.toReadable(r)}e.bufferToReadable=v;function A(r){return m.consumeStream(r,t=>P.concat(t))}e.streamToBuffer=A;async function w(r){return r.ended?P.concat(r.buffer):P.concat([...r.buffer,await A(r.stream)])}e.bufferedStreamToBuffer=w;function s(r){return m.toStream(r,t=>P.concat(t))}e.bufferToStream=s;function o(r){return m.transform(r,{data:t=>typeof t=="string"?P.fromString(t):P.wrap(t)},t=>P.concat(t))}e.streamToBufferReadableStream=o;function g(r){return m.newWriteableStream(t=>P.concat(t),r)}e.newWriteableBufferStream=g;function c(r,t){return m.prefixedReadable(r,t,n=>P.concat(n))}e.prefixedBufferReadable=c;function S(r,t){return m.prefixedStream(r,t,n=>P.concat(n))}e.prefixedBufferStream=S}),define(we[8],be([0,1,12]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function i(te){return!te||typeof te!="string"?!0:te.trim().length===0}e.isFalsyOrWhitespace=i;const y=/{(\d+)}/g;function C(te,..._e){return _e.length===0?te:te.replace(y,function(Me,Be){const Xe=parseInt(Be,10);return isNaN(Xe)||Xe<0||Xe>=_e.length?Me:_e[Xe]})}e.format=C;const P=/{([^}]+)}/g;function k(te,_e){return te.replace(P,(Me,Be)=>_e[Be]??Me)}e.format2=k;function _(te){return te.replace(/[<>&]/g,function(_e){switch(_e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return _e}})}e.escape=_;function I(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function L(te,_e){let Me=0;const Be=_e.charCodeAt(0);for(let Xe=te.length-1;Xe>=0;Xe--)te.charCodeAt(Xe)===Be&&Me++;return Me}e.count=L;function T(te,_e,Me="\u2026"){return te.length<=_e?te:`${te.substr(0,_e)}${Me}`}e.truncate=T;function l(te,_e=" "){const Me=E(te,_e);return h(Me,_e)}e.trim=l;function E(te,_e){if(!te||!_e)return te;const Me=_e.length;if(Me===0||te.length===0)return te;let Be=0;for(;te.indexOf(_e,Be)===Be;)Be=Be+Me;return te.substring(Be)}e.ltrim=E;function h(te,_e){if(!te||!_e)return te;const Me=_e.length,Be=te.length;if(Me===0||Be===0)return te;let Xe=Be,Ae=-1;for(;Ae=te.lastIndexOf(_e,Xe-1),!(Ae===-1||Ae+Me!==Xe);){if(Ae===0)return"";Xe=Ae}return te.substring(0,Xe)}e.rtrim=h;function p(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function v(te){return te.replace(/\*/g,"")}e.stripWildcards=v;function A(te,_e,Me={}){if(!te)throw new Error("Cannot create regex from empty string");_e||(te=I(te)),Me.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let Be="";return Me.global&&(Be+="g"),Me.matchCase||(Be+="i"),Me.multiline&&(Be+="m"),Me.unicode&&(Be+="u"),new RegExp(te,Be)}e.createRegExp=A;function w(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function s(te){return!!te.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=s;function o(te){return(te.global?"g":"")+(te.ignoreCase?"i":"")+(te.multiline?"m":"")+(te.unicode?"u":"")}e.regExpFlags=o;function g(te){return te.split(/\r\n|\r|\n/)}e.splitLines=g;function c(te){for(let _e=0,Me=te.length;_e<Me;_e++){const Be=te.charCodeAt(_e);if(Be!==32&&Be!==9)return _e}return-1}e.firstNonWhitespaceIndex=c;function S(te,_e=0,Me=te.length){for(let Be=_e;Be<Me;Be++){const Xe=te.charCodeAt(Be);if(Xe!==32&&Xe!==9)return te.substring(_e,Be)}return te.substring(_e,Me)}e.getLeadingWhitespace=S;function r(te,_e=te.length-1){for(let Me=_e;Me>=0;Me--){const Be=te.charCodeAt(Me);if(Be!==32&&Be!==9)return Me}return-1}e.lastNonWhitespaceIndex=r;function t(te,_e){return te<_e?-1:te>_e?1:0}e.compare=t;function n(te,_e,Me=0,Be=te.length,Xe=0,Ae=_e.length){for(;Me<Be&&Xe<Ae;Me++,Xe++){let de=te.charCodeAt(Me),fe=_e.charCodeAt(Xe);if(de<fe)return-1;if(de>fe)return 1}const Pe=Be-Me,ye=Ae-Xe;return Pe<ye?-1:Pe>ye?1:0}e.compareSubstring=n;function u(te,_e){return a(te,_e,0,te.length,0,_e.length)}e.compareIgnoreCase=u;function a(te,_e,Me=0,Be=te.length,Xe=0,Ae=_e.length){for(;Me<Be&&Xe<Ae;Me++,Xe++){let de=te.charCodeAt(Me),fe=_e.charCodeAt(Xe);if(de===fe)continue;if(de>=128||fe>=128)return n(te.toLowerCase(),_e.toLowerCase(),Me,Be,Xe,Ae);f(de)&&(de-=32),f(fe)&&(fe-=32);const Ee=de-fe;if(Ee!==0)return Ee}const Pe=Be-Me,ye=Ae-Xe;return Pe<ye?-1:Pe>ye?1:0}e.compareSubstringIgnoreCase=a;function f(te){return te>=97&&te<=122}e.isLowerAsciiLetter=f;function b(te){return te>=65&&te<=90}e.isUpperAsciiLetter=b;function d(te,_e){return te.length===_e.length&&a(te,_e)===0}e.equalsIgnoreCase=d;function D(te,_e){const Me=_e.length;return _e.length>te.length?!1:a(te,_e,0,Me)===0}e.startsWithIgnoreCase=D;function R(te,_e){let Me,Be=Math.min(te.length,_e.length);for(Me=0;Me<Be;Me++)if(te.charCodeAt(Me)!==_e.charCodeAt(Me))return Me;return Be}e.commonPrefixLength=R;function N(te,_e){let Me,Be=Math.min(te.length,_e.length);const Xe=te.length-1,Ae=_e.length-1;for(Me=0;Me<Be;Me++)if(te.charCodeAt(Xe-Me)!==_e.charCodeAt(Ae-Me))return Me;return Be}e.commonSuffixLength=N;function B(te){return 55296<=te&&te<=56319}e.isHighSurrogate=B;function F(te){return 56320<=te&&te<=57343}e.isLowSurrogate=F;function O(te,_e){return(te-55296<<10)+(_e-56320)+65536}e.computeCodePoint=O;function z(te,_e,Me){const Be=te.charCodeAt(Me);if(B(Be)&&Me+1<_e){const Xe=te.charCodeAt(Me+1);if(F(Xe))return O(Be,Xe)}return Be}e.getNextCodePoint=z;function W(te,_e){const Me=te.charCodeAt(_e-1);if(F(Me)&&_e>1){const Be=te.charCodeAt(_e-2);if(B(Be))return O(Be,Me)}return Me}function M(te,_e){const Me=it.getInstance(),Be=_e,Xe=te.length,Ae=z(te,Xe,_e);_e+=Ae>=65536?2:1;let Pe=Me.getGraphemeBreakType(Ae);for(;_e<Xe;){const ye=z(te,Xe,_e),de=Me.getGraphemeBreakType(ye);if(ot(Pe,de))break;_e+=ye>=65536?2:1,Pe=de}return _e-Be}e.nextCharLength=M;function x(te,_e){const Me=it.getInstance(),Be=_e,Xe=W(te,_e);_e-=Xe>=65536?2:1;let Ae=Me.getGraphemeBreakType(Xe);for(;_e>0;){const Pe=W(te,_e),ye=Me.getGraphemeBreakType(Pe);if(ot(ye,Ae))break;_e-=Pe>=65536?2:1,Ae=ye}return Be-_e}e.prevCharLength=x;function V(te,_e){const Me=it.getInstance(),Be=te.length,Xe=_e,Ae=z(te,Be,_e),Pe=Me.getGraphemeBreakType(Ae);_e+=Ae>=65536?2:1;let ye=Pe;for(;_e<Be;){const fe=z(te,Be,_e),Ee=Me.getGraphemeBreakType(fe);if(ot(ye,Ee))break;_e+=fe>=65536?2:1,ye=Ee}const de=_e;for(_e=Xe,ye=Pe;_e>0;){const fe=W(te,_e),Ee=Me.getGraphemeBreakType(fe);if(ot(Ee,ye))break;_e-=fe>=65536?2:1,ye=Ee}return[_e,de]}function U(te,_e){return _e>0&&F(te.charCodeAt(_e))?V(te,_e-1):V(te,_e)}e.getCharContainingOffset=U;const H=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function X(te){return H.test(te)}e.containsRTL=X;const se=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function K(te){return se.test(te)}e.containsEmoji=K;const j=/^[\t\n\r\x20-\x7E]*$/;function ie(te){return j.test(te)}e.isBasicASCII=ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ce(te){return e.UNUSUAL_LINE_TERMINATORS.test(te)}e.containsUnusualLineTerminators=ce;function ge(te){for(let _e=0,Me=te.length;_e<Me;_e++)if(ke(te.charCodeAt(_e)))return!0;return!1}e.containsFullWidthCharacter=ge;function ke(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}e.isFullWidthCharacter=ke;function Le(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}e.isEmojiImprecise=Le;function Oe(te,_e){if(te.length<_e)return te;const Me=/\b/g;let Be=0;for(;Me.test(te)&&!(te.length-Me.lastIndex<_e);)Be=Me.lastIndex,Me.lastIndex+=1;return te.substring(Be).replace(/^\s/,"")}e.lcut=Oe;const q=/\x1B\x5B[12]?K/g,J=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function he(te){return te&&(te=te.replace(q,""),te=te.replace(J,""),te=te.replace(re,"")),te}e.removeAnsiEscapeCodes=he,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ee(te){return!!(te&&te.length>0&&te.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ee;function ae(te){return ee(te)?te.substr(1):te}e.stripUTF8BOM=ae;function Se(te,_e){if(!te||!_e||te.length<_e.length)return!1;const Me=_e.length,Be=te.toLowerCase();let Xe=0,Ae=-1;for(;Xe<Me;){const Pe=Be.indexOf(_e[Xe],Ae+1);if(Pe<0)return!1;Ae=Pe,Xe++}return!0}e.fuzzyContains=Se;function Ue(te,_e=!1){return te?(_e&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}e.containsUppercaseCharacter=Ue;function Ve(te){return te.charAt(0).toUpperCase()+te.slice(1)}e.uppercaseFirstLetter=Ve;function Ge(te,_e=1){if(_e===0)return"";let Me=-1;do Me=te.indexOf(`
`,Me+1),_e--;while(_e>0&&Me>=0);return Me===-1?te:(te[Me-1]==="\r"&&Me--,te.substr(0,Me))}e.getNLines=Ge;function Je(te){const _e=90-65+1;return te=te%(2*_e),te<_e?String.fromCharCode(97+te):String.fromCharCode(65+te-_e)}e.singleLetterHash=Je;function tt(te){return it.getInstance().getGraphemeBreakType(te)}e.getGraphemeBreakType=tt;function ot(te,_e){return te===0?_e!==5&&_e!==7:te===2&&_e===3?!1:te===4||te===2||te===3||_e===4||_e===2||_e===3?!0:!(te===8&&(_e===8||_e===9||_e===11||_e===12)||(te===11||te===9)&&(_e===9||_e===10)||(te===12||te===10)&&_e===10||_e===5||_e===13||_e===7||te===1||te===13&&_e===14||te===6&&_e===6)}e.breakBetweenGraphemeBreakType=ot;var et;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class it{constructor(){this._data=ct()}static getInstance(){return it._INSTANCE||(it._INSTANCE=new it),it._INSTANCE}getGraphemeBreakType(_e){if(_e<32)return _e===10?3:_e===13?2:4;if(_e<127)return 0;const Me=this._data,Be=Me.length/3;let Xe=1;for(;Xe<=Be;)if(_e<Me[3*Xe])Xe=2*Xe;else if(_e>Me[3*Xe+1])Xe=2*Xe+1;else return Me[3*Xe+2];return 0}}it._INSTANCE=null;function ct(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function pt(te,_e){if(te===0)return 0;const Me=Pt(te,_e);if(Me!==void 0)return Me;const Be=W(_e,te);return te-=We(Be),te}e.getLeftDeleteOffset=pt;function Pt(te,_e){let Me=W(_e,te);for(te-=We(Me);Rt(Me)||Me===65039||Me===8419;){if(te===0)return;Me=W(_e,te),te-=We(Me)}if(!!Le(Me)){if(te>=0){const Be=W(_e,te);Be===8205&&(te-=We(Be))}return te}}function We(te){return te>=65536?2:1}function Rt(te){return 127995<=te&&te<=127999}var Z;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(Z||(Z={})),e.noBreakWhitespace="\xA0";class ne{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!ne.map){let Be=function(Pe){const ye=new Map;for(let de=0;de<Pe.length;de+=2)ye.set(Pe[de],Pe[de+1]);return ye};const _e=ne.getData();let Me=m.locale;(!Me||!(Me in _e))&&(Me=m.language),(!Me||!(Me in _e))&&(Me="_default");const Xe=Be(_e._common),Ae=Be(_e[Me]);for(const[Pe,ye]of Ae)Xe.set(Pe,ye);ne.map=Xe}return ne.map}static isAmbiguous(_e){return ne.getConfusablesForCurrentLocale().has(_e)}static getPrimaryConfusable(_e){return ne.getConfusablesForCurrentLocale().get(_e)}static getPrimaryConfusableCodePoints(){return new Set(ne.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=ne;class ve{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ve.getRawData())),this._data}static isInvisibleCharacter(_e){return ve.getData().has(_e)}static get codePoints(){return ve.getData()}}e.InvisibleCharacters=ve,ve._data=void 0}),define(we[47],be([0,1,8]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(A){return y(A,0)}e.hash=i;function y(A,w){switch(typeof A){case"object":return A===null?C(349,w):Array.isArray(A)?_(A,w):I(A,w);case"string":return k(A,w);case"boolean":return P(A,w);case"number":return C(A,w);case"undefined":return C(937,w);default:return C(617,w)}}e.doHash=y;function C(A,w){return(w<<5)-w+A|0}e.numberHash=C;function P(A,w){return C(A?433:863,w)}function k(A,w){w=C(149417,w);for(let s=0,o=A.length;s<o;s++)w=C(A.charCodeAt(s),w);return w}e.stringHash=k;function _(A,w){return w=C(104579,w),A.reduce((s,o)=>y(o,s),w)}function I(A,w){return w=C(181387,w),Object.keys(A).sort().reduce((s,o)=>(s=k(o,s),y(A[o],s)),w)}class L{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=y(w,this._value),this._value}}e.Hasher=L;var T;(function(A){A[A.BLOCK_SIZE=64]="BLOCK_SIZE",A[A.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function l(A,w,s=32){const o=s-w,g=~((1<<o)-1);return(A<<w|(g&A)>>>o)>>>0}function E(A,w=0,s=A.byteLength,o=0){for(let g=0;g<s;g++)A[w+g]=o}function h(A,w,s="0"){for(;A.length<w;)A=s+A;return A}function p(A,w=32){return A instanceof ArrayBuffer?Array.from(new Uint8Array(A)).map(s=>s.toString(16).padStart(2,"0")).join(""):h((A>>>0).toString(16),w/4)}e.toHexString=p;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const s=w.length;if(s===0)return;const o=this._buff;let g=this._buffLen,c=this._leftoverHighSurrogate,S,r;for(c!==0?(S=c,r=-1,c=0):(S=w.charCodeAt(0),r=0);;){let t=S;if(m.isHighSurrogate(S))if(r+1<s){const n=w.charCodeAt(r+1);m.isLowSurrogate(n)?(r++,t=m.computeCodePoint(S,n)):t=65533}else{c=S;break}else m.isLowSurrogate(S)&&(t=65533);if(g=this._push(o,g,t),r++,r<s)S=w.charCodeAt(r);else break}this._buffLen=g,this._leftoverHighSurrogate=c}_push(w,s,o){return o<128?w[s++]=o:o<2048?(w[s++]=192|(o&1984)>>>6,w[s++]=128|(o&63)>>>0):o<65536?(w[s++]=224|(o&61440)>>>12,w[s++]=128|(o&4032)>>>6,w[s++]=128|(o&63)>>>0):(w[s++]=240|(o&1835008)>>>18,w[s++]=128|(o&258048)>>>12,w[s++]=128|(o&4032)>>>6,w[s++]=128|(o&63)>>>0),s>=64&&(this._step(),s-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),s}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,E(this._buff,this._buffLen),this._buffLen>56&&(this._step(),E(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=v._bigBlock32,s=this._buffDV;for(let a=0;a<64;a+=4)w.setUint32(a,s.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)w.setUint32(a,l(w.getUint32(a-12,!1)^w.getUint32(a-32,!1)^w.getUint32(a-56,!1)^w.getUint32(a-64,!1),1),!1);let o=this._h0,g=this._h1,c=this._h2,S=this._h3,r=this._h4,t,n,u;for(let a=0;a<80;a++)a<20?(t=g&c|~g&S,n=1518500249):a<40?(t=g^c^S,n=1859775393):a<60?(t=g&c|g&S|c&S,n=2400959708):(t=g^c^S,n=3395469782),u=l(o,5)+t+r+n+w.getUint32(a*4,!1)&4294967295,r=S,S=c,c=l(g,30),g=o,o=u;this._h0=this._h0+o&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+c&4294967295,this._h3=this._h3+S&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},xe=this&&this.__classPrivateFieldGet||function(Y,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(Y):i?i.value:e.get(Y)};define(we[24],be([0,1,16,8]),function(Y,e,m,i){"use strict";var y,C,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(r,t,n){let u=r.get(t);return u===void 0&&(u=n,r.set(t,u)),u}e.getOrSet=k;function _(r){const t=[];return r.forEach((n,u)=>{t.push(`${u} => ${n}`)}),`Map(${r.size}) {${t.join(", ")}}`}e.mapToString=_;function I(r){const t=[];return r.forEach(n=>{t.push(n)}),`Set(${r.size}) {${t.join(", ")}}`}e.setToString=I;class L{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const n=t.charCodeAt(0),u=this._value.charCodeAt(this._pos);return n-u}value(){return this._value[this._pos]}}e.StringIterator=L;class T{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class l{constructor(t=!0,n=!0){this._splitOnBackslash=t,this._caseSensitive=n}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let n=t.length-1;n>=0;n--,this._valueLen--){const u=this._value.charCodeAt(n);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var E;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(E||(E={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,i.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(v||(v={}));class A{constructor(t){this._iter=t}static forUris(t=()=>!1){return new A(new h(t))}static forPaths(){return new A(new l)}static forStrings(){return new A(new L)}static forConfigKeys(){return new A(new T)}clear(){this._root=void 0}fill(t,n){if(n){const u=n.slice(0);(0,m.shuffle)(u);for(let a of u)this.set(a,t)}else{const u=t.slice(0);(0,m.shuffle)(u);for(let a of u)this.set(a[0],a[1])}}set(t,n){const u=this._iter.reset(t);let a;this._root||(this._root=new p,this._root.segment=u.value());const f=[];for(a=this._root;;){const d=u.cmp(a.segment);if(d>0)a.left||(a.left=new p,a.left.segment=u.value()),f.push([-1,a]),a=a.left;else if(d<0)a.right||(a.right=new p,a.right.segment=u.value()),f.push([1,a]),a=a.right;else if(u.hasNext())u.next(),a.mid||(a.mid=new p,a.mid.segment=u.value()),f.push([0,a]),a=a.mid;else break}const b=a.value;a.value=n,a.key=t;for(let d=f.length-1;d>=0;d--){const D=f[d][1];D.updateHeight();const R=D.balanceFactor();if(R<-1||R>1){const N=f[d][0],B=f[d+1][0];if(N===1&&B===1)f[d][1]=D.rotateLeft();else if(N===-1&&B===-1)f[d][1]=D.rotateRight();else if(N===1&&B===-1)D.right=f[d+1][1]=f[d+1][1].rotateRight(),f[d][1]=D.rotateLeft();else if(N===-1&&B===1)D.left=f[d+1][1]=f[d+1][1].rotateLeft(),f[d][1]=D.rotateRight();else throw new Error;if(d>0)switch(f[d-1][0]){case-1:f[d-1][1].left=f[d][1];break;case 1:f[d-1][1].right=f[d][1];break;case 0:f[d-1][1].mid=f[d][1];break}else this._root=f[0][1]}}return b}get(t){return this._getNode(t)?.value}_getNode(t){const n=this._iter.reset(t);let u=this._root;for(;u;){const a=n.cmp(u.segment);if(a>0)u=u.left;else if(a<0)u=u.right;else if(n.hasNext())n.next(),u=u.mid;else break}return u}has(t){const n=this._getNode(t);return!(n?.value===void 0&&n?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,n){const u=this._iter.reset(t),a=[];let f=this._root;for(;f;){const b=u.cmp(f.segment);if(b>0)a.push([-1,f]),f=f.left;else if(b<0)a.push([1,f]),f=f.right;else if(u.hasNext())u.next(),a.push([0,f]),f=f.mid;else break}if(!!f){if(n?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const b=this._min(f.right),{key:d,value:D,segment:R}=b;this._delete(b.key,!1),f.key=d,f.value=D,f.segment=R}else{const b=f.left??f.right;if(a.length>0){const[d,D]=a[a.length-1];switch(d){case-1:D.left=b;break;case 0:D.mid=b;break;case 1:D.right=b;break}}else this._root=b}for(let b=a.length-1;b>=0;b--){const d=a[b][1];d.updateHeight();const D=d.balanceFactor();if(D>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),a[b][1]=d.rotateLeft()):D<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),a[b][1]=d.rotateRight()),b>0)switch(a[b-1][0]){case-1:a[b-1][1].left=a[b][1];break;case 1:a[b-1][1].right=a[b][1];break;case 0:a[b-1][1].mid=a[b][1];break}else this._root=a[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const n=this._iter.reset(t);let u=this._root,a;for(;u;){const f=n.cmp(u.segment);if(f>0)u=u.left;else if(f<0)u=u.right;else if(n.hasNext())n.next(),a=u.value||a,u=u.mid;else break}return u&&u.value||a}findSuperstr(t){const n=this._iter.reset(t);let u=this._root;for(;u;){const a=n.cmp(u.segment);if(a>0)u=u.left;else if(a<0)u=u.right;else if(n.hasNext())n.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(t){for(const[n,u]of this)t(u,n)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=n=>{if(!n)return!0;const u=n.balanceFactor();return u<-1||u>1?!1:t(n.left)&&t(n.right)};return t(this._root)}}e.TernarySearchTree=A;class w{constructor(t,n){this.uri=t,this.value=n}}class s{constructor(t,n){this[y]="ResourceMap",t instanceof s?(this.map=new Map(t.map),this.toKey=n??s.defaultToKey):(this.map=new Map,this.toKey=t??s.defaultToKey)}set(t,n){return this.map.set(this.toKey(t),new w(t,n)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,n){typeof n!="undefined"&&(t=t.bind(n));for(let[u,a]of this.map)t(a.value,a.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=s,s.defaultToKey=r=>r.toString();var o;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class g{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,n=0){const u=this._map.get(t);if(!!u)return n!==0&&this.touch(u,n),u.value}set(t,n,u=0){let a=this._map.get(t);if(a)a.value=n,u!==0&&this.touch(a,u);else{switch(a={key:t,value:n,next:void 0,previous:void 0},u){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(t,a),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const n=this._map.get(t);if(!!n)return this._map.delete(t),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,n){const u=this._state;let a=this._head;for(;a;){if(n?t.bind(n)(a.value,a.key,this):t(a.value,a.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const t=this,n=this._state;let u=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:u.key,done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return a}values(){const t=this,n=this._state;let u=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:u.value,done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return a}entries(){const t=this,n=this._state;let u=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:[u.key,u.value],done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return a}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let n=this._head,u=this.size;for(;n&&u>t;)this._map.delete(n.key),n=n.next,u--;this._head=n,this._size=u,n&&(n.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const n=t.next,u=t.previous;if(!n||!u)throw new Error("Invalid list");n.previous=u,u.next=n}t.next=void 0,t.previous=void 0,this._state++}touch(t,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(t===this._head)return;const u=t.next,a=t.previous;t===this._tail?(a.next=void 0,this._tail=a):(u.previous=a,a.next=u),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(n===2){if(t===this._tail)return;const u=t.next,a=t.previous;t===this._head?(u.previous=void 0,this._head=u):(u.previous=a,a.next=u),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((n,u)=>{t.push([u,n])}),t}fromJSON(t){this.clear();for(const[n,u]of t)this.set(n,u)}}e.LinkedMap=g;class c extends g{constructor(t,n=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,n=2){return super.get(t,n)}peek(t){return super.get(t,0)}set(t,n){return super.set(t,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class S{constructor(t){P.set(this,void 0),nt(this,P,t,"f")}get size(){return xe(this,P,"f").size}forEach(t,n){xe(this,P,"f").forEach(t,n)}get(t){return xe(this,P,"f").get(t)}has(t){return xe(this,P,"f").has(t)}entries(){return xe(this,P,"f").entries()}keys(){return xe(this,P,"f").keys()}values(){return xe(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return xe(this,P,"f").entries()}}e.ReadonlyMapView=S}),define(we[96],be([0,1,24,8]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...ee){return function(ae,Se){for(let Ue=0,Ve=ee.length;Ue<Ve;Ue++){const Ge=ee[Ue](ae,Se);if(Ge)return Ge}return null}}e.or=y,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(ee,ae,Se){if(!Se||Se.length<ae.length)return null;let Ue;return ee?Ue=i.startsWithIgnoreCase(Se,ae):Ue=Se.indexOf(ae)===0,Ue?ae.length>0?[{start:0,end:ae.length}]:[]:null}function P(ee,ae){const Se=ae.toLowerCase().indexOf(ee.toLowerCase());return Se===-1?null:[{start:Se,end:Se+ee.length}]}e.matchesContiguousSubString=P;function k(ee,ae){return _(ee.toLowerCase(),ae.toLowerCase(),0,0)}e.matchesSubString=k;function _(ee,ae,Se,Ue){if(Se===ee.length)return[];if(Ue===ae.length)return null;if(ee[Se]===ae[Ue]){let Ve=null;return(Ve=_(ee,ae,Se+1,Ue+1))?A({start:Ue,end:Ue+1},Ve):null}return _(ee,ae,Se,Ue+1)}function I(ee){return 97<=ee&&ee<=122}function L(ee){return 65<=ee&&ee<=90}e.isUpper=L;function T(ee){return 48<=ee&&ee<=57}function l(ee){return ee===32||ee===9||ee===10||ee===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>E.add(ee.charCodeAt(0)));function h(ee){return l(ee)||E.has(ee)}function p(ee,ae){return ee===ae||h(ee)&&h(ae)}function v(ee){return I(ee)||L(ee)||T(ee)}function A(ee,ae){return ae.length===0?ae=[ee]:ee.end===ae[0].start?ae[0].start=ee.start:ae.unshift(ee),ae}function w(ee,ae){for(let Se=ae;Se<ee.length;Se++){const Ue=ee.charCodeAt(Se);if(L(Ue)||T(Ue)||Se>0&&!v(ee.charCodeAt(Se-1)))return Se}return ee.length}function s(ee,ae,Se,Ue){if(Se===ee.length)return[];if(Ue===ae.length)return null;if(ee[Se]!==ae[Ue].toLowerCase())return null;{let Ve=null,Ge=Ue+1;for(Ve=s(ee,ae,Se+1,Ue+1);!Ve&&(Ge=w(ae,Ge))<ae.length;)Ve=s(ee,ae,Se+1,Ge),Ge++;return Ve===null?null:A({start:Ue,end:Ue+1},Ve)}}function o(ee){let ae=0,Se=0,Ue=0,Ve=0,Ge=0;for(let it=0;it<ee.length;it++)Ge=ee.charCodeAt(it),L(Ge)&&ae++,I(Ge)&&Se++,v(Ge)&&Ue++,T(Ge)&&Ve++;const Je=ae/ee.length,tt=Se/ee.length,ot=Ue/ee.length,et=Ve/ee.length;return{upperPercent:Je,lowerPercent:tt,alphaPercent:ot,numericPercent:et}}function g(ee){const{upperPercent:ae,lowerPercent:Se}=ee;return Se===0&&ae>.6}function c(ee){const{upperPercent:ae,lowerPercent:Se,alphaPercent:Ue,numericPercent:Ve}=ee;return Se>.2&&ae<.8&&Ue>.6&&Ve<.2}function S(ee){let ae=0,Se=0,Ue=0,Ve=0;for(let Ge=0;Ge<ee.length;Ge++)Ue=ee.charCodeAt(Ge),L(Ue)&&ae++,I(Ue)&&Se++,l(Ue)&&Ve++;return(ae===0||Se===0)&&Ve===0?ee.length<=30:ae<=5}function r(ee,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!S(ee)||ae.length>60)return null;const Se=o(ae);if(!c(Se)){if(!g(Se))return null;ae=ae.toLowerCase()}let Ue=null,Ve=0;for(ee=ee.toLowerCase();Ve<ae.length&&(Ue=s(ee,ae,0,Ve))===null;)Ve=w(ae,Ve+1);return Ue}e.matchesCamelCase=r;function t(ee,ae,Se=!1){if(!ae||ae.length===0)return null;let Ue=null,Ve=0;for(ee=ee.toLowerCase(),ae=ae.toLowerCase();Ve<ae.length&&(Ue=n(ee,ae,0,Ve,Se))===null;)Ve=u(ae,Ve+1);return Ue}e.matchesWords=t;function n(ee,ae,Se,Ue,Ve){if(Se===ee.length)return[];if(Ue===ae.length)return null;if(p(ee.charCodeAt(Se),ae.charCodeAt(Ue))){let Ge=null,Je=Ue+1;if(Ge=n(ee,ae,Se+1,Ue+1,Ve),!Ve)for(;!Ge&&(Je=u(ae,Je))<ae.length;)Ge=n(ee,ae,Se+1,Je,Ve),Je++;return Ge===null?null:A({start:Ue,end:Ue+1},Ge)}else return null}function u(ee,ae){for(let Se=ae;Se<ee.length;Se++)if(h(ee.charCodeAt(Se))||Se>0&&h(ee.charCodeAt(Se-1)))return Se;return ee.length}const a=y(e.matchesPrefix,r,P),f=y(e.matchesPrefix,r,k),b=new m.LRUCache(1e4);function d(ee,ae,Se=!1){if(typeof ee!="string"||typeof ae!="string")return null;let Ue=b.get(ee);Ue||(Ue=new RegExp(i.convertSimple2RegExpPattern(ee),"i"),b.set(ee,Ue));const Ve=Ue.exec(ae);return Ve?[{start:Ve.index,end:Ve.index+Ve[0].length}]:Se?f(ee,ae):a(ee,ae)}e.matchesFuzzy=d;function D(ee,ae){const Se=ke(ee,ee.toLowerCase(),0,ae,ae.toLowerCase(),0,!0);return Se?N(Se):null}e.matchesFuzzy2=D;function R(ee,ae,Se,Ue,Ve,Ge){const Je=Math.min(13,ee.length);for(;Se<Je;Se++){const tt=ke(ee,ae,Se,Ue,Ve,Ge,!1);if(tt)return tt}return[0,Ge]}e.anyScore=R;function N(ee){if(typeof ee=="undefined")return[];const ae=[],Se=ee[1];for(let Ue=ee.length-1;Ue>1;Ue--){const Ve=ee[Ue]+Se,Ge=ae[ae.length-1];Ge&&Ge.end===Ve?Ge.end=Ve+1:ae.push({start:Ve,end:Ve+1})}return ae}e.createMatches=N;const B=128;function F(){const ee=[],ae=[];for(let Se=0;Se<=B;Se++)ae[Se]=0;for(let Se=0;Se<=B;Se++)ee.push(ae.slice(0));return ee}function O(ee){const ae=[];for(let Se=0;Se<=ee;Se++)ae[Se]=0;return ae}const z=O(2*B),W=O(2*B),M=F(),x=F(),V=F(),U=!1;function H(ee,ae,Se,Ue,Ve){function Ge(tt,ot,et=" "){for(;tt.length<ot;)tt=et+tt;return tt}let Je=` |   |${Ue.split("").map(tt=>Ge(tt,3)).join("|")}
`;for(let tt=0;tt<=Se;tt++)tt===0?Je+=" |":Je+=`${ae[tt-1]}|`,Je+=ee[tt].slice(0,Ve+1).map(ot=>Ge(ot.toString(),3)).join("|")+`
`;return Je}function X(ee,ae,Se,Ue){ee=ee.substr(ae),Se=Se.substr(Ue),console.log(H(x,ee,ee.length,Se,Se.length)),console.log(H(V,ee,ee.length,Se,Se.length)),console.log(H(M,ee,ee.length,Se,Se.length))}function se(ee,ae){if(ae<0||ae>=ee.length)return!1;const Se=ee.codePointAt(ae);switch(Se){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(Se)}}function K(ee,ae){if(ae<0||ae>=ee.length)return!1;switch(ee.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function j(ee,ae,Se){return ae[ee]!==Se[ee]}function ie(ee,ae,Se,Ue,Ve,Ge,Je=!1){for(;ae<Se&&Ve<Ge;)ee[ae]===Ue[Ve]&&(Je&&(z[ae]=Ve),ae+=1),Ve+=1;return ae===Se}e.isPatternInWord=ie;var ce;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(ce||(ce={}));var ge;(function(ee){ee.Default=[-100,0];function ae(Se){return!Se||Se.length===2&&Se[0]===-100&&Se[1]===0}ee.isDefault=ae})(ge=e.FuzzyScore||(e.FuzzyScore={}));function ke(ee,ae,Se,Ue,Ve,Ge,Je){const tt=ee.length>B?B:ee.length,ot=Ue.length>B?B:Ue.length;if(Se>=tt||Ge>=ot||tt-Se>ot-Ge||!ie(ae,Se,tt,Ve,Ge,ot,!0))return;Le(tt,ot,Se,Ge,ae,Ve);let et=1,it=1,ct=Se,pt=Ge;const Pt=[!1];for(et=1,ct=Se;ct<tt;et++,ct++){const ve=z[ct],te=W[ct],_e=ct+1<tt?W[ct+1]:ot;for(it=ve-Ge+1,pt=ve;pt<_e;it++,pt++){let Me=Number.MIN_SAFE_INTEGER,Be=!1;pt<=te&&(Me=Oe(ee,ae,ct,Se,Ue,Ve,pt,ot,Ge,M[et-1][it-1]===0,Pt));let Xe=0;Me!==Number.MAX_SAFE_INTEGER&&(Be=!0,Xe=Me+x[et-1][it-1]);const Ae=pt>ve,Pe=Ae?x[et][it-1]+(M[et][it-1]>0?-5:0):0,ye=pt>ve+1&&M[et][it-1]>0,de=ye?x[et][it-2]+(M[et][it-2]>0?-5:0):0;if(ye&&(!Ae||de>=Pe)&&(!Be||de>=Xe))x[et][it]=de,V[et][it]=3,M[et][it]=0;else if(Ae&&(!Be||Pe>=Xe))x[et][it]=Pe,V[et][it]=2,M[et][it]=0;else if(Be)x[et][it]=Xe,V[et][it]=1,M[et][it]=M[et-1][it-1]+1;else throw new Error("not possible")}}if(U&&X(ee,Se,Ue,Ge),!Pt[0]&&!Je)return;et--,it--;const We=[x[et][it],Ge];let Rt=0,Z=0;for(;et>=1;){let ve=it;do{const te=V[et][ve];if(te===3)ve=ve-2;else if(te===2)ve=ve-1;else break}while(ve>=1);Rt>1&&ae[Se+et-1]===Ve[Ge+it-1]&&!j(ve+Ge-1,Ue,Ve)&&Rt+1>M[et][ve]&&(ve=it),ve===it?Rt++:Rt=1,Z||(Z=ve),et--,it=ve-1,We.push(it)}ot===tt&&(We[0]+=2);const ne=Z-tt;return We[0]-=ne,We}e.fuzzyScore=ke;function Le(ee,ae,Se,Ue,Ve,Ge){let Je=ee-1,tt=ae-1;for(;Je>=Se&&tt>=Ue;)Ve[Je]===Ge[tt]&&(W[Je]=tt,Je--),tt--}function Oe(ee,ae,Se,Ue,Ve,Ge,Je,tt,ot,et,it){if(ae[Se]!==Ge[Je])return Number.MIN_SAFE_INTEGER;let ct=1,pt=!1;return Je===Se-Ue?ct=ee[Se]===Ve[Je]?7:5:j(Je,Ve,Ge)&&(Je===0||!j(Je-1,Ve,Ge))?(ct=ee[Se]===Ve[Je]?7:5,pt=!0):se(Ge,Je)&&(Je===0||!se(Ge,Je-1))?ct=5:(se(Ge,Je-1)||K(Ge,Je-1))&&(ct=5,pt=!0),ct>1&&Se===Ue&&(it[0]=!0),pt||(pt=j(Je,Ve,Ge)||se(Ge,Je-1)||K(Ge,Je-1)),Se===Ue?Je>ot&&(ct-=pt?3:5):et?ct+=pt?2:0:ct+=pt?0:1,Je+1===tt&&(ct-=pt?3:5),ct}function q(ee,ae,Se,Ue,Ve,Ge,Je){return re(ee,ae,Se,Ue,Ve,Ge,!0,Je)}e.fuzzyScoreGracefulAggressive=q;function J(ee,ae,Se,Ue,Ve,Ge,Je){return re(ee,ae,Se,Ue,Ve,Ge,!1,Je)}e.fuzzyScoreGraceful=J;function re(ee,ae,Se,Ue,Ve,Ge,Je,tt){let ot=ke(ee,ae,Se,Ue,Ve,Ge,tt);if(ot&&!Je)return ot;if(ee.length>=3){const et=Math.min(7,ee.length-1);for(let it=Se+1;it<et;it++){const ct=he(ee,it);if(ct){const pt=ke(ct,ct.toLowerCase(),Se,Ue,Ve,Ge,tt);pt&&(pt[0]-=3,(!ot||pt[0]>ot[0])&&(ot=pt))}}}return ot}function he(ee,ae){if(ae+1>=ee.length)return;const Se=ee[ae],Ue=ee[ae+1];if(Se!==Ue)return ee.slice(0,ae)+Ue+Se+ee.slice(ae+2)}}),define(we[141],be([0,1,73,96,8]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(m.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${C.source}`,"g");function _(v){return v.replace(k,(A,w)=>w?A:`\\${A}`)}e.escapeIcons=_;const I=new RegExp(`\\\\${C.source}`,"g");function L(v){return v.replace(I,A=>`\\${A}`)}e.markdownEscapeEscapedIcons=L;const T=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function l(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(T,(A,w,s,o)=>s?A:w||o||"")}e.stripIcons=l;function E(v){const A=v.indexOf(e.iconStartMarker);return A===-1?{text:v}:h(v,A)}e.parseLabelWithIcons=E;function h(v,A){const w=[];let s="";function o(a){if(a){s+=a;for(const f of a)w.push(S)}}let g=-1,c="",S=0,r,t,n=A;const u=v.length;for(o(v.substr(0,A));n<u;)r=v[n],t=v[n+1],r===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(g=n,o(c),c=e.iconStartMarker,n++):r===")"&&g!==-1?(S+=n-g+1,g=-1,c=""):g!==-1?P.test(r)?c+=r:(o(c),g=-1,c=""):o(r),n++;return o(c),{text:s,iconOffsets:w}}function p(v,A,w=!1){const{text:s,iconOffsets:o}=A;if(!o||o.length===0)return(0,i.matchesFuzzy)(v,s,w);const g=(0,y.ltrim)(s," "),c=s.length-g.length,S=(0,i.matchesFuzzy)(v,g,w);if(S)for(const r of S){const t=o[r.start+c]+c;r.start+=t,r.end+=t}return S}e.matchesFuzzyIconAware=p}),define(we[97],be([0,1,15,141]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var y;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(y=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(E="",h=!1){if(this.value=E,typeof this.value!="string")throw(0,m.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(E,h=0){return this.value+=I(this.supportThemeIcons?(0,i.escapeIcons)(E):E).replace(/([ \t]+)/g,(p,v)=>"&nbsp;".repeat(v.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(E){return this.value+=E,this}appendCodeblock(E,h){return this.value+="\n```",this.value+=E,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}}e.MarkdownString=C;function P(l){return k(l)?!l.value:Array.isArray(l)?l.every(P):!0}e.isEmptyMarkdownString=P;function k(l){return l instanceof C?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function _(l,E){return l===E?!0:!l||!E?!1:l.value===E.value&&l.isTrusted===E.isTrusted&&l.supportThemeIcons===E.supportThemeIcons}e.markdownStringEqual=_;function I(l){return l.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function L(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=L;function T(l){const E=[],h=l.split("|").map(v=>v.trim());l=h[0];const p=h[1];if(p){const v=/height=(\d+)/.exec(p),A=/width=(\d+)/.exec(p),w=v?v[1]:"",s=A?A[1]:"",o=isFinite(parseInt(s)),g=isFinite(parseInt(w));o&&E.push(`width="${s}"`),g&&E.push(`height="${w}"`)}return{href:l,dimensions:E}}e.parseHrefAndDimensions=T}),define(we[79],be([0,1,24]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new m.LRUCache(1e4);function y(I){return _(I,"NFC",i)}e.normalizeNFC=y;const C=new m.LRUCache(1e4);function P(I){return _(I,"NFD",C)}e.normalizeNFD=P;const k=/[^\u0000-\u0080]/;function _(I,L,T){if(!I)return I;const l=T.get(I);if(l)return l;let E;return k.test(I)?E=I.normalize(L):E=I,T.set(I,E),E}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(L){return P(L).replace(I,"")}}()}),define(we[48],be([0,1,8]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(i||(i={})),function(y){const C="error",P="warning",k="warn",_="info",I="ignore";function L(l){return l?m.equalsIgnoreCase(C,l)?y.Error:m.equalsIgnoreCase(P,l)||m.equalsIgnoreCase(k,l)?y.Warning:m.equalsIgnoreCase(_,l)?y.Info:y.Ignore:y.Ignore}y.fromValue=L;function T(l){switch(l){case y.Error:return C;case y.Warning:return P;case y.Info:return _;default:return I}}y.toString=T}(i||(i={})),e.default=i}),define(we[13],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(f){return Array.isArray(f)}e.isArray=m;function i(f){return typeof f=="string"}e.isString=i;function y(f){return Array.isArray(f)&&f.every(b=>i(b))}e.isStringArray=y;function C(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=C;function P(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=P;function k(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=k;function _(f){return f===!0||f===!1}e.isBoolean=_;function I(f){return typeof f=="undefined"}e.isUndefined=I;function L(f){return!T(f)}e.isDefined=L;function T(f){return I(f)||f===null}e.isUndefinedOrNull=T;function l(f,b){if(!f)throw new Error(b?`Unexpected type, expected '${b}'`:"Unexpected type")}e.assertType=l;function E(f){if(T(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=E;function h(...f){const b=[];for(let d=0;d<f.length;d++){const D=f[d];if(T(D))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);b.push(D)}return b}e.assertAllDefined=h;const p=Object.prototype.hasOwnProperty;function v(f){if(!C(f))return!1;for(let b in f)if(p.call(f,b))return!1;return!0}e.isEmptyObject=v;function A(f){return typeof f=="function"}e.isFunction=A;function w(...f){return f.length>0&&f.every(A)}e.areFunctions=w;function s(f,b){const d=Math.min(f.length,b.length);for(let D=0;D<d;D++)o(f[D],b[D])}e.validateConstraints=s;function o(f,b){if(i(b)){if(typeof f!==b)throw new Error(`argument does not match constraint: typeof ${b}`)}else if(A(b)){try{if(f instanceof b)return}catch{}if(!T(f)&&f.constructor===b||b.length===1&&b.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function g(f){let b=[],d=Object.getPrototypeOf(f);for(;Object.prototype!==d;)b=b.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return b}e.getAllPropertyNames=g;function c(f){const b=[];for(const d of g(f))typeof f[d]=="function"&&b.push(d);return b}e.getAllMethodNames=c;function S(f,b){const d=R=>function(){const N=Array.prototype.slice.call(arguments,0);return b(R,N)};let D={};for(const R of f)D[R]=d(R);return D}e.createProxyObject=S;function r(f){return f===null?void 0:f}e.withNullAsUndefined=r;function t(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=t;function n(f){return class{constructor(){return new Proxy({},{get(b,d){if(b[d])return b[d];throw new Error(`Not Implemented: ${f}->${String(d)}`)}})}}}e.NotImplementedProxy=n;function u(f,b="Unreachable"){throw new Error(b)}e.assertNever=u;function a(f){return!!f&&typeof f.then=="function"&&typeof f.catch=="function"}e.isPromise=a}),define(we[30],be([0,1,9,12,8,13]),function(Y,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(n){return n===47||n===92}e.isPathSeparator=P;function k(n){return n.replace(/[\\/]/g,m.posix.sep)}e.toSlashes=k;function _(n){return n.indexOf("/")===-1&&(n=k(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=_;function I(n,u=m.posix.sep){if(!n)return"";const a=n.length,f=n.charCodeAt(0);if(P(f)){if(P(n.charCodeAt(1))&&!P(n.charCodeAt(2))){let d=3;const D=d;for(;d<a&&!P(n.charCodeAt(d));d++);if(D!==d&&!P(n.charCodeAt(d+1))){for(d+=1;d<a;d++)if(P(n.charCodeAt(d)))return n.slice(0,d+1).replace(/[\\/]/g,u)}}return u}else if(A(f)&&n.charCodeAt(1)===58)return P(n.charCodeAt(2))?n.slice(0,2)+u:n.slice(0,2);let b=n.indexOf("://");if(b!==-1){for(b+=3;b<a;b++)if(P(n.charCodeAt(b)))return n.slice(0,b+1)}return""}e.getRoot=I;function L(n){if(!i.isWindows||!n||n.length<5)return!1;let u=n.charCodeAt(0);if(u!==92||(u=n.charCodeAt(1),u!==92))return!1;let a=2;const f=a;for(;a<n.length&&(u=n.charCodeAt(a),u!==92);a++);return!(f===a||(u=n.charCodeAt(a+1),isNaN(u)||u===92))}e.isUNC=L;const T=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(n,u=i.isWindows){const a=u?T:l;return!(!n||n.length===0||/^\s+$/.test(n)||(a.lastIndex=0,a.test(n))||u&&E.test(n)||n==="."||n===".."||u&&n[n.length-1]==="."||u&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=h;function p(n,u,a){const f=n===u;return!a||f?f:!n||!u?!1:(0,y.equalsIgnoreCase)(n,u)}e.isEqual=p;function v(n,u,a,f=m.sep){if(n===u)return!0;if(!n||!u||u.length>n.length)return!1;if(a){if(!(0,y.startsWithIgnoreCase)(n,u))return!1;if(u.length===n.length)return!0;let d=u.length;return u.charAt(u.length-1)===f&&d--,n.charAt(d)===f}return u.charAt(u.length-1)!==f&&(u+=f),n.indexOf(u)===0}e.isEqualOrParent=v;function A(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=A;function w(n,u){return i.isWindows&&n.endsWith(":")&&(n+=m.sep),(0,m.isAbsolute)(n)||(n=(0,m.join)(u,n)),n=(0,m.normalize)(n),i.isWindows?(n=(0,y.rtrim)(n,m.sep),n.endsWith(":")&&(n+=m.sep)):(n=(0,y.rtrim)(n,m.sep),n||(n=m.sep)),n}e.sanitizeFilePath=w;function s(n){const u=(0,m.normalize)(n);return i.isWindows?n.length>3?!1:o(u)&&(n.length===2||u.charCodeAt(2)===92):u===m.posix.sep}e.isRootOrDriveLetter=s;function o(n,u){return(u!==void 0?u:i.isWindows)?A(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function g(n){return o(n)?n[0]:void 0}e.getDriveLetter=g;function c(n,u,a){return u.length>n.length?-1:n===u?0:(a&&(n=n.toLowerCase(),u=u.toLowerCase()),n.indexOf(u))}e.indexOfPath=c;function S(n){const u=n.split(":");let a,f,b;if(u.forEach(d=>{const D=Number(d);(0,C.isNumber)(D)?f===void 0?f=D:b===void 0&&(b=D):a=a?[a,d].join(":"):d}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:f!==void 0?f:void 0,column:b!==void 0?b:f!==void 0?1:void 0}}e.parseLineAndColumnAware=S;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(n,u,a=8){let f="";for(let d=0;d<a;d++)f+=r.charAt(Math.floor(Math.random()*r.length));let b;return u?b=`${u}-${f}`:b=f,n?(0,m.join)(n,b):b}e.randomPath=t}),define(we[25],be([0,1,13]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const v=Array.isArray(p)?[]:{};return Object.keys(p).forEach(A=>{p[A]&&typeof p[A]=="object"?v[A]=i(p[A]):v[A]=p[A]}),v}e.deepClone=i;function y(p){if(!p||typeof p!="object")return p;const v=[p];for(;v.length>0;){const A=v.shift();Object.freeze(A);for(const w in A)if(C.call(A,w)){const s=A[w];typeof s=="object"&&!Object.isFrozen(s)&&v.push(s)}}return p}e.deepFreeze=y;const C=Object.prototype.hasOwnProperty;function P(p,v){return k(p,v,new Set)}e.cloneAndChange=P;function k(p,v,A){if((0,m.isUndefinedOrNull)(p))return p;const w=v(p);if(typeof w!="undefined")return w;if((0,m.isArray)(p)){const s=[];for(const o of p)s.push(k(o,v,A));return s}if((0,m.isObject)(p)){if(A.has(p))throw new Error("Cannot clone recursive data-structure");A.add(p);const s={};for(let o in p)C.call(p,o)&&(s[o]=k(p[o],v,A));return A.delete(p),s}return p}function _(p,v,A=!0){return(0,m.isObject)(p)?((0,m.isObject)(v)&&Object.keys(v).forEach(w=>{w in p?A&&((0,m.isObject)(p[w])&&(0,m.isObject)(v[w])?_(p[w],v[w],A):p[w]=v[w]):p[w]=v[w]}),p):v}e.mixin=_;function I(p,v){if(p===v)return!0;if(p==null||v===null||v===void 0||typeof p!=typeof v||typeof p!="object"||Array.isArray(p)!==Array.isArray(v))return!1;let A,w;if(Array.isArray(p)){if(p.length!==v.length)return!1;for(A=0;A<p.length;A++)if(!I(p[A],v[A]))return!1}else{const s=[];for(w in p)s.push(w);s.sort();const o=[];for(w in v)o.push(w);if(o.sort(),!I(s,o))return!1;for(A=0;A<s.length;A++)if(!I(p[s[A]],v[s[A]]))return!1}return!0}e.equals=I;function L(p){const v=new Set;return JSON.stringify(p,(A,w)=>{if((0,m.isObject)(w)||Array.isArray(w)){if(v.has(w))return"[Circular]";v.add(w)}return w})}e.safeStringify=L;function T(p,v,A){const w=v(p);return typeof w=="undefined"?A:w}e.getOrDefault=T;function l(p,v){const A=Object.create(null);return!p||!v||Object.keys(v).forEach(s=>{const o=p[s],g=v[s];I(o,g)||(A[s]=g)}),A}e.distinct=l;function E(p,v){const A=v.toLowerCase(),w=Object.keys(p).find(s=>s.toLowerCase()===A);return w?p[w]:p[v]}e.getCaseInsensitive=E;function h(p,v){const A=Object.create(null);for(const[w,s]of Object.entries(p))v(w,s)&&(A[w]=s);return A}e.filter=h}),define(we[98],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function i(C){return C<0?0:C>255?255:C|0}e.toUint8=i;function y(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=y}),define(we[2],be([0,1,9,12]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const y=/^\w[\w\d+.-]*$/,C=/^\//,P=/^\/\//;function k(r,t){if(!r.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!y.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!C.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(r,t){return!r&&!t?"file":r}function I(r,t){switch(r){case"https":case"http":case"file":t?t[0]!==T&&(t=T+t):t=T;break}return t}const L="",T="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{constructor(t,n,u,a,f,b=!1){typeof t=="object"?(this.scheme=t.scheme||L,this.authority=t.authority||L,this.path=t.path||L,this.query=t.query||L,this.fragment=t.fragment||L):(this.scheme=_(t,b),this.authority=n||L,this.path=I(this.scheme,u||L),this.query=a||L,this.fragment=f||L,k(this,b))}static isUri(t){return t instanceof E?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return s(this,!1)}with(t){if(!t)return this;let{scheme:n,authority:u,path:a,query:f,fragment:b}=t;return n===void 0?n=this.scheme:n===null&&(n=L),u===void 0?u=this.authority:u===null&&(u=L),a===void 0?a=this.path:a===null&&(a=L),f===void 0?f=this.query:f===null&&(f=L),b===void 0?b=this.fragment:b===null&&(b=L),n===this.scheme&&u===this.authority&&a===this.path&&f===this.query&&b===this.fragment?this:new p(n,u,a,f,b)}static parse(t,n=!1){const u=l.exec(t);return u?new p(u[2]||L,S(u[4]||L),S(u[5]||L),S(u[7]||L),S(u[9]||L),n):new p(L,L,L,L,L)}static file(t){let n=L;if(i.isWindows&&(t=t.replace(/\\/g,T)),t[0]===T&&t[1]===T){const u=t.indexOf(T,2);u===-1?(n=t.substring(2),t=T):(n=t.substring(2,u),t=t.substring(u)||T)}return new p("file",n,t,L,L)}static from(t){const n=new p(t.scheme,t.authority,t.path,t.query,t.fragment);return k(n,!0),n}static joinPath(t,...n){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return i.isWindows&&t.scheme==="file"?u=E.file(m.win32.join(s(t,!0),...n)).path:u=m.posix.join(t.path,...n),t.with({path:u})}toString(t=!1){return o(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof E)return t;{const n=new p(t);return n._formatted=t.external,n._fsPath=t._sep===h?t.fsPath:null,n}}else return t}}e.URI=E;const h=i.isWindows?1:void 0;class p extends E{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(t=!1){return t?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function A(r,t){let n,u=-1;for(let a=0;a<r.length;a++){const f=r.charCodeAt(a);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||t&&f===47)u!==-1&&(n+=encodeURIComponent(r.substring(u,a)),u=-1),n!==void 0&&(n+=r.charAt(a));else{n===void 0&&(n=r.substr(0,a));const b=v[f];b!==void 0?(u!==-1&&(n+=encodeURIComponent(r.substring(u,a)),u=-1),n+=b):u===-1&&(u=a)}}return u!==-1&&(n+=encodeURIComponent(r.substring(u))),n!==void 0?n:r}function w(r){let t;for(let n=0;n<r.length;n++){const u=r.charCodeAt(n);u===35||u===63?(t===void 0&&(t=r.substr(0,n)),t+=v[u]):t!==void 0&&(t+=r[n])}return t!==void 0?t:r}function s(r,t){let n;return r.authority&&r.path.length>1&&r.scheme==="file"?n=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?t?n=r.path.substr(1):n=r.path[1].toLowerCase()+r.path.substr(2):n=r.path,i.isWindows&&(n=n.replace(/\//g,"\\")),n}e.uriToFsPath=s;function o(r,t){const n=t?w:A;let u="",{scheme:a,authority:f,path:b,query:d,fragment:D}=r;if(a&&(u+=a,u+=":"),(f||a==="file")&&(u+=T,u+=T),f){let R=f.indexOf("@");if(R!==-1){const N=f.substr(0,R);f=f.substr(R+1),R=N.indexOf(":"),R===-1?u+=n(N,!1):(u+=n(N.substr(0,R),!1),u+=":",u+=n(N.substr(R+1),!1)),u+="@"}f=f.toLowerCase(),R=f.indexOf(":"),R===-1?u+=n(f,!1):(u+=n(f.substr(0,R),!1),u+=f.substr(R))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const R=b.charCodeAt(1);R>=65&&R<=90&&(b=`/${String.fromCharCode(R+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const R=b.charCodeAt(0);R>=65&&R<=90&&(b=`${String.fromCharCode(R+32)}:${b.substr(2)}`)}u+=n(b,!0)}return d&&(u+="?",u+=n(d,!1)),D&&(u+="#",u+=t?D:A(D,!1)),u}function g(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+g(r.substr(3)):r}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function S(r){return r.match(c)?r.replace(c,t=>g(t)):r}}),define(we[59],be([0,1,22,8,2]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(L){return JSON.stringify(L,_)}e.stringify=C;function P(L){let T=JSON.parse(L);return T=I(T),T}e.parse=P;var k;(function(L){L[L.Uri=1]="Uri",L[L.Regexp=2]="Regexp",L[L.ScmResource=3]="ScmResource",L[L.ScmResourceGroup=4]="ScmResourceGroup",L[L.ScmProvider=5]="ScmProvider",L[L.CommentController=6]="CommentController",L[L.CommentThread=7]="CommentThread",L[L.CommentThreadReply=8]="CommentThreadReply",L[L.CommentNode=9]="CommentNode",L[L.CommentThreadNode=10]="CommentThreadNode",L[L.TimelineActionContext=11]="TimelineActionContext",L[L.NotebookCellActionContext=12]="NotebookCellActionContext",L[L.TestItemContext=13]="TestItemContext"})(k=e.MarshalledId||(e.MarshalledId={}));function _(L,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,i.regExpFlags)(T)}:T}function I(L,T=0){if(!L||T>200)return L;if(typeof L=="object"){switch(L.$mid){case 1:return y.URI.revive(L);case 2:return new RegExp(L.source,L.flags)}if(L instanceof m.VSBuffer||L instanceof Uint8Array)return L;if(Array.isArray(L))for(let l=0;l<L.length;++l)L[l]=I(L[l],T+1);else for(const l in L)Object.hasOwnProperty.call(L,l)&&(L[l]=I(L[l],T+1))}return L}e.revive=I}),define(we[10],be([0,1,12,2]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var y;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(y=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,I,L){this._hosts[_]=I,this._ports[_]=L}setConnectionToken(_,I){this._connectionTokens[_]=I}rewrite(_){if(this._delegate)return this._delegate(_);const I=_.authority;let L=this._hosts[I];L&&L.indexOf(":")!==-1&&(L=`[${L}]`);const T=this._ports[I],l=this._connectionTokens[I];let E=`path=${encodeURIComponent(_.path)}`;return typeof l=="string"&&(E+=`&tkn=${encodeURIComponent(l)}`),i.URI.from({scheme:m.isWeb?this._preferredWebSchema:y.vscodeRemoteResource,authority:`${L}:${T}`,path:"/vscode-remote-resource",query:E})}}e.RemoteAuthorities=new C;class P{asBrowserUri(_,I){const L=this.toUri(_,I);return L.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===y.file&&(m.isNative||typeof m.globals.importScripts=="function"&&m.globals.origin===`${y.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?L.with({scheme:y.vscodeFileResource,authority:L.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):L}asFileUri(_,I){const L=this.toUri(_,I);return L.scheme===y.vscodeFileResource?L.with({scheme:y.file,authority:L.authority!==P.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(_,I){return i.URI.isUri(_)?_:i.URI.parse(I.toUrl(_))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P}),define(we[23],be([0,1,30,10,9,12,8,2]),function(Y,e,m,i,y,C,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(E){return(0,k.uriToFsPath)(E,!0)}e.originalFSPath=_;class I{constructor(h){this._ignorePathCasing=h}compare(h,p,v=!1){return h===p?0:(0,P.compare)(this.getComparisonKey(h,v),this.getComparisonKey(p,v))}isEqual(h,p,v=!1){return h===p?!0:!h||!p?!1:this.getComparisonKey(h,v)===this.getComparisonKey(p,v)}getComparisonKey(h,p=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,p,v=!1){if(h.scheme===p.scheme){if(h.scheme===i.Schemas.file)return m.isEqualOrParent(_(h),_(p),this._ignorePathCasing(h))&&h.query===p.query&&(v||h.fragment===p.fragment);if((0,e.isEqualAuthority)(h.authority,p.authority))return m.isEqualOrParent(h.path,p.path,this._ignorePathCasing(h),"/")&&h.query===p.query&&(v||h.fragment===p.fragment)}return!1}joinPath(h,...p){return k.URI.joinPath(h,...p)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return y.posix.basename(h.path)}extname(h){return y.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let p;return h.scheme===i.Schemas.file?p=k.URI.file(y.dirname(_(h))).path:(p=y.posix.dirname(h.path),h.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),p="/")),h.with({path:p})}normalizePath(h){if(!h.path.length)return h;let p;return h.scheme===i.Schemas.file?p=k.URI.file(y.normalize(_(h))).path:p=y.posix.normalize(h.path),h.with({path:p})}relativePath(h,p){if(h.scheme!==p.scheme||!(0,e.isEqualAuthority)(h.authority,p.authority))return;if(h.scheme===i.Schemas.file){const w=y.relative(_(h),_(p));return C.isWindows?m.toSlashes(w):w}let v=h.path||"/",A=p.path||"/";if(this._ignorePathCasing(h)){let w=0;for(const s=Math.min(v.length,A.length);w<s&&!(v.charCodeAt(w)!==A.charCodeAt(w)&&v.charAt(w).toLowerCase()!==A.charAt(w).toLowerCase());w++);v=A.substr(0,w)+v.substr(w)}return y.posix.relative(v,A)}resolvePath(h,p){if(h.scheme===i.Schemas.file){const v=k.URI.file(y.resolve(_(h),p));return h.with({authority:v.authority,path:v.path})}return p=m.toPosixPath(p),h.with({path:y.posix.resolve(h.path,p)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,p){return h===p||h!==void 0&&p!==void 0&&(0,P.equalsIgnoreCase)(h,p)}hasTrailingPathSeparator(h,p=y.sep){if(h.scheme===i.Schemas.file){const v=_(h);return v.length>m.getRoot(v).length&&v[v.length-1]===p}else{const v=h.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,p=y.sep){return(0,e.hasTrailingPathSeparator)(h,p)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,p=y.sep){let v=!1;if(h.scheme===i.Schemas.file){const A=_(h);v=A!==void 0&&A.length===m.getRoot(A).length&&A[A.length-1]===p}else{p="/";const A=h.path;v=A.length===1&&A.charCodeAt(A.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(h,p)?h.with({path:h.path+"/"}):h}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(E=>E.scheme===i.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new I(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(E,h){const p=[];for(let v=0;v<E.length;v++){const A=h(E[v]);E.some((w,s)=>s===v?!1:(0,e.isEqualOrParent)(A,h(w)))||p.push(E[v])}return p}e.distinctParents=L;var T;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function h(p){const v=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(s=>{const[o,g]=s.split(":");o&&g&&v.set(o,g)});const w=p.path.substring(0,p.path.indexOf(";"));return w&&v.set(E.META_DATA_MIME,w),v}E.parseMetaData=h})(T=e.DataUri||(e.DataUri={}));function l(E,h,p){if(h){let v=E.path;return v&&v[0]!==y.posix.sep&&(v=y.posix.sep+v),E.with({scheme:p,authority:h,path:v})}return E.with({scheme:p})}e.toLocalResource=l}),define(we[18],be([0,1,21,15,3,6,23,12]),function(Y,e,m,i,y,C,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function _(K){return!!K&&typeof K.then=="function"}e.isThenable=_;function I(K){const j=new m.CancellationTokenSource,ie=K(j.token),ce=new Promise((ge,ke)=>{const Le=j.token.onCancellationRequested(()=>{Le.dispose(),j.dispose(),ke((0,i.canceled)())});Promise.resolve(ie).then(Oe=>{Le.dispose(),j.dispose(),ge(Oe)},Oe=>{Le.dispose(),j.dispose(),ke(Oe)})});return new class{cancel(){j.cancel()}then(ge,ke){return ce.then(ge,ke)}catch(ge){return this.then(void 0,ge)}finally(ge){return ce.finally(ge)}}}e.createCancelablePromise=I;function L(K,j,ie){return Promise.race([K,new Promise(ce=>j.onCancellationRequested(()=>ce(ie)))])}e.raceCancellation=L;async function T(K){let j=-1;const ie=K.map((ge,ke)=>ge.then(Le=>(j=ke,Le))),ce=await Promise.race(ie);return K.forEach((ge,ke)=>{ke!==j&&ge.cancel()}),ce}e.raceCancellablePromises=T;function l(K,j,ie){let ce;const ge=setTimeout(()=>{ce?.(void 0),ie?.()},j);return Promise.race([K.finally(()=>clearTimeout(ge)),new Promise(ke=>ce=ke)])}e.raceTimeout=l;function E(K){return new Promise((j,ie)=>{const ce=K();_(ce)?ce.then(j,ie):j(ce)})}e.asPromise=E;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(j){if(this.activePromise){if(this.queuedPromiseFactory=j,!this.queuedPromise){const ie=()=>{this.queuedPromise=null;const ce=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ce};this.queuedPromise=new Promise(ce=>{this.activePromise.then(ie,ie).then(ce)})}return new Promise((ie,ce)=>{this.queuedPromise.then(ie,ce)})}return this.activePromise=j(),new Promise((ie,ce)=>{this.activePromise.then(ge=>{this.activePromise=null,ie(ge)},ge=>{this.activePromise=null,ce(ge)})})}}e.Throttler=h;class p{constructor(){this.current=Promise.resolve(null)}queue(j){return this.current=this.current.then(()=>j(),()=>j())}}e.Sequencer=p;class v{constructor(){this.promiseMap=new Map}queue(j,ie){const ge=(this.promiseMap.get(j)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.promiseMap.get(j)===ge&&this.promiseMap.delete(j)});return this.promiseMap.set(j,ge),ge}}e.SequencerByKey=v;const A=(K,j)=>{let ie=!0;const ce=setTimeout(()=>{ie=!1,j()},K);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(ce),ie=!1}}},w=K=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,K())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class s{constructor(j){this.defaultDelay=j,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(j,ie=this.defaultDelay){this.task=j,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ge,ke)=>{this.doResolve=ge,this.doReject=ke}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ge=this.task;return this.task=null,ge()}}));const ce=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ie===e.MicrotaskDelay?w(ce):A(ie,ce),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,i.canceled)()),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=s;class o{constructor(j){this.delayer=new s(j),this.throttler=new h}trigger(j,ie){return this.delayer.trigger(()=>this.throttler.queue(j),ie)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=o;class g{constructor(){this._isOpen=!1,this._promise=new Promise((j,ie)=>{this._completePromise=j})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=g;class c extends g{constructor(j){super();this._timeout=setTimeout(()=>this.open(),j)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function S(K,j){return j?new Promise((ie,ce)=>{const ge=setTimeout(()=>{ke.dispose(),ie()},K),ke=j.onCancellationRequested(()=>{clearTimeout(ge),ke.dispose(),ce((0,i.canceled)())})}):I(ie=>S(K,ie))}e.timeout=S;function r(K,j=0){const ie=setTimeout(K,j);return(0,C.toDisposable)(()=>clearTimeout(ie))}e.disposableTimeout=r;function t(K){const j=[];let ie=0;const ce=K.length;function ge(){return ie<ce?K[ie++]():null}function ke(Le){Le!=null&&j.push(Le);const Oe=ge();return Oe?Oe.then(ke):Promise.resolve(j)}return Promise.resolve(null).then(ke)}e.sequence=t;function n(K,j=ce=>!!ce,ie=null){let ce=0;const ge=K.length,ke=()=>{if(ce>=ge)return Promise.resolve(ie);const Le=K[ce++];return Promise.resolve(Le()).then(q=>j(q)?Promise.resolve(q):ke())};return ke()}e.first=n;function u(K,j=ce=>!!ce,ie=null){if(K.length===0)return Promise.resolve(ie);let ce=K.length;const ge=()=>{ce=-1;for(const ke of K)ke.cancel?.()};return new Promise((ke,Le)=>{for(const Oe of K)Oe.then(q=>{--ce>=0&&j(q)?(ge(),ke(q)):ce===0&&ke(ie)}).catch(q=>{--ce>=0&&(ge(),Le(q))})})}e.firstParallel=u;class a{constructor(j){this._size=0,this.maxDegreeOfParalellism=j,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new y.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(j){return this._size++,new Promise((ie,ce)=>{this.outstandingPromises.push({factory:j,c:ie,e:ce}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const j=this.outstandingPromises.shift();this.runningPromises++;const ie=j.factory();ie.then(j.c,j.e),ie.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=a;class f extends a{constructor(){super(1)}}e.Queue=f;class b{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const j=new x;return this.drainers.add(j),j.p}isDrained(){for(const[,j]of this.queues)if(j.size>0)return!1;return!0}queueFor(j,ie=P.extUri){const ce=ie.getComparisonKey(j);let ge=this.queues.get(ce);return ge||(ge=new f,y.Event.once(ge.onFinished)(()=>{ge?.dispose(),this.queues.delete(ce),this.onDidQueueFinish()}),this.queues.set(ce,ge)),ge}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const j of this.drainers)j.complete();this.drainers.clear()}dispose(){for(const[,j]of this.queues)j.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=b;class d{constructor(j,ie){this._token=-1,typeof j=="function"&&typeof ie=="number"&&this.setIfNotSet(j,ie)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(j,ie){this.cancel(),this._token=setTimeout(()=>{this._token=-1,j()},ie)}setIfNotSet(j,ie){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,j()},ie))}}e.TimeoutTimer=d;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(j,ie){this.cancel(),this._token=setInterval(()=>{j()},ie)}}e.IntervalTimer=D;class R{constructor(j,ie){this.timeoutToken=-1,this.runner=j,this.timeout=ie,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(j=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,j)}get delay(){return this.timeout}set delay(j){this.timeout=j}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class N{constructor(j,ie){ie%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.runner=j,this.timeout=ie,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(j=this.timeout){j%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(j/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=N;class B extends R{constructor(j,ie){super(j,ie);this.units=[]}work(j){this.units.push(j),this.isScheduled()||this.schedule()}doRun(){const j=this.units;this.units=[],this.runner&&this.runner(j)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=B;class F extends C.Disposable{constructor(j,ie,ce,ge){super();this.maxWorkChunkSize=j,this.maxPendingWork=ie,this.throttleDelay=ce,this.handler=ge,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(j){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+j.length>this.maxPendingWork)return!1}else if(this.pending+j.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...j),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=K=>{(0,k.setTimeout0)(()=>{if(j)return;const ie=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e.runWhenIdle=(K,j)=>{const ie=requestIdleCallback(K,typeof j=="number"?{timeout:j}:void 0);let ce=!1;return{dispose(){ce||(ce=!0,cancelIdleCallback(ie))}}}}();class O{constructor(j){this._didRun=!1,this._executor=()=>{try{this._value=j()}catch(ie){this._error=ie}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function z(K,j,ie){let ce;for(let ge=0;ge<ie;ge++)try{return await K()}catch(ke){ce=ke,await S(j)}throw ce}e.retry=z;class W{hasPending(j){return this._pending?typeof j=="number"?this._pending.taskId===j:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(j,ie,ce){return this._pending={taskId:j,cancel:()=>ce?.(),promise:ie},ie.then(()=>this.donePending(j),()=>this.donePending(j)),ie}donePending(j){this._pending&&j===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const j=this._next;this._next=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}setNext(j){if(this._next)this._next.run=j;else{let ie,ce;const ge=new Promise((ke,Le)=>{ie=ke,ce=Le});this._next={run:j,promise:ge,promiseResolve:ie,promiseReject:ce}}return this._next.promise}}e.TaskSequentializer=W;class M{constructor(j,ie=()=>Date.now()){this.interval=j,this.nowFn=ie,this.lastIncrementTime=0,this.value=0}increment(){const j=this.nowFn();return j-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=j,this.value=0),this.value++,this.value}}e.IntervalCounter=M;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((j,ie)=>{this.completeCallback=j,this.errorCallback=ie})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(j){return new Promise(ie=>{this.completeCallback(j),this.resolved=!0,ie()})}error(j){return new Promise(ie=>{this.errorCallback(j),this.rejected=!0,ie()})}cancel(){new Promise(j=>{this.errorCallback((0,i.canceled)()),this.rejected=!0,j()})}}e.DeferredPromise=x;var V;(function(K){async function j(ce){let ge;const ke=await Promise.all(ce.map(Le=>Le.then(Oe=>Oe,Oe=>{ge||(ge=Oe)})));if(typeof ge!="undefined")throw ge;return ke}K.settled=j;function ie(ce){return new Promise(async(ge,ke)=>{try{await ce(ge,ke)}catch(Le){ke(Le)}})}K.withAsyncBody=ie})(V=e.Promises||(e.Promises={}));var U;(function(K){K[K.Initial=0]="Initial",K[K.DoneOK=1]="DoneOK",K[K.DoneError=2]="DoneError"})(U||(U={}));class H{constructor(j){this._state=0,this._results=[],this._error=null,this._onStateChanged=new y.Emitter,queueMicrotask(async()=>{const ie={emitOne:ce=>this.emitOne(ce),emitMany:ce=>this.emitMany(ce),reject:ce=>this.reject(ce)};try{await Promise.resolve(j(ie)),this.resolve()}catch(ce){this.reject(ce)}finally{ie.emitOne=void 0,ie.emitMany=void 0,ie.reject=void 0}})}static fromArray(j){return new H(ie=>{ie.emitMany(j)})}static fromPromise(j){return new H(async ie=>{ie.emitMany(await j)})}static fromPromises(j){return new H(async ie=>{await Promise.all(j.map(async ce=>ie.emitOne(await ce)))})}static merge(j){return new H(async ie=>{await Promise.all(j.map(async ce=>{for await(const ge of ce)ie.emitOne(ge)}))})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(j<this._results.length)return{done:!1,value:this._results[j++]};if(this._state===1)return{done:!0,value:void 0};await y.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(j,ie){return new H(async ce=>{for await(const ge of j)ce.emitOne(ie(ge))})}map(j){return H.map(this,j)}static filter(j,ie){return new H(async ce=>{for await(const ge of j)ie(ge)&&ce.emitOne(ge)})}filter(j){return H.filter(this,j)}static coalesce(j){return H.filter(j,ie=>!!ie)}coalesce(){return H.coalesce(this)}static async toPromise(j){const ie=[];for await(const ce of j)ie.push(ce);return ie}toPromise(){return H.toPromise(this)}emitOne(j){this._state===0&&(this._results.push(j),this._onStateChanged.fire())}emitMany(j){this._state===0&&(this._results=this._results.concat(j),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(j){this._state===0&&(this._state=2,this._error=j,this._onStateChanged.fire())}}e.AsyncIterableObject=H,H.EMPTY=H.fromArray([]);class X extends H{constructor(j,ie){super(ie);this._source=j}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=X;function se(K){const j=new m.CancellationTokenSource,ie=K(j.token);return new X(j,async ce=>{const ge=j.token.onCancellationRequested(()=>{ge.dispose(),j.dispose(),ce.reject((0,i.canceled)())});try{for await(const ke of ie){if(j.token.isCancellationRequested)return;ce.emitOne(ke)}ge.dispose(),j.dispose()}catch(ke){ge.dispose(),j.dispose(),ce.reject(ke)}})}e.createCancelableAsyncIterable=se}),define(we[99],be([0,1,18,9]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new m.IdleValue(()=>{const b=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:b,collatorIsNumeric:b.resolvedOptions().numeric}}),C=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(b,d,D=!1){const R=b||"",N=d||"",B=y.value.collator.compare(R,N);return y.value.collatorIsNumeric&&B===0&&R!==N?R<N?-1:1:B}e.compareFileNames=k;function _(b,d){const D=C.value.collator;return b=b||"",d=d||"",g(D,b,d)}e.compareFileNamesDefault=_;function I(b,d){const D=C.value.collator;return b=b||"",d=d||"",t(b,d)||g(D,b,d)}e.compareFileNamesUpper=I;function L(b,d){const D=C.value.collator;return b=b||"",d=d||"",r(b,d)||g(D,b,d)}e.compareFileNamesLower=L;function T(b,d){return b=b||"",d=d||"",b===d?0:b<d?-1:1}e.compareFileNamesUnicode=T;function l(b,d,D=!1){D||(b=b&&b.toLowerCase(),d=d&&d.toLowerCase());const[R,N]=s(b),[B,F]=s(d);return R!==B?R<B?-1:1:N===F?0:N<F?-1:1}e.noIntlCompareFileNames=l;function E(b,d){const[D,R]=s(b),[N,B]=s(d);let F=y.value.collator.compare(R,B);if(F===0){if(y.value.collatorIsNumeric&&R!==B)return R<B?-1:1;if(F=y.value.collator.compare(D,N),y.value.collatorIsNumeric&&F===0&&D!==N)return D<N?-1:1}return F}e.compareFileExtensions=E;function h(b,d){b=b||"",d=d||"";const D=o(b),R=o(d),N=C.value.collator,B=P.value.collator;return g(B,D,R)||g(N,b,d)}e.compareFileExtensionsDefault=h;function p(b,d){b=b||"",d=d||"";const D=o(b),R=o(d),N=C.value.collator,B=P.value.collator;return g(B,D,R)||t(b,d)||g(N,b,d)}e.compareFileExtensionsUpper=p;function v(b,d){b=b||"",d=d||"";const D=o(b),R=o(d),N=C.value.collator,B=P.value.collator;return g(B,D,R)||r(b,d)||g(N,b,d)}e.compareFileExtensionsLower=v;function A(b,d){b=b||"",d=d||"";const D=o(b).toLowerCase(),R=o(d).toLowerCase();return D!==R?D<R?-1:1:b!==d?b<d?-1:1:0}e.compareFileExtensionsUnicode=A;const w=/^(.*?)(\.([^.]*))?$/;function s(b,d=!1){const D=b?w.exec(b):[];let R=[D&&D[1]||"",D&&D[3]||""];return d&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function o(b){const d=b?w.exec(b):[];return d&&d[1]&&d[1].charAt(0)!=="."&&d[3]||""}function g(b,d,D){let R=b.compare(d,D);return R!==0?R:d.length!==D.length?d.length<D.length?-1:1:0}function c(b){const d=b.charAt(0);return d.toLocaleUpperCase()!==d}function S(b){const d=b.charAt(0);return d.toLocaleLowerCase()!==d}function r(b,d){return c(b)&&S(d)?-1:S(b)&&c(d)?1:0}function t(b,d){return S(b)&&c(d)?-1:c(b)&&S(d)?1:0}function n(b,d,D=!1){return D||(b=b&&b.toLowerCase(),d=d&&d.toLowerCase()),b===d?0:b<d?-1:1}function u(b,d,D=!1){const R=b.split(i.sep),N=d.split(i.sep),B=R.length-1,F=N.length-1;let O,z;for(let W=0;;W++){if(O=B===W,z=F===W,O&&z)return k(R[W],N[W],D);if(O)return-1;if(z)return 1;const M=n(R[W],N[W],D);if(M!==0)return M}}e.comparePaths=u;function a(b,d,D){const R=b.toLowerCase(),N=d.toLowerCase(),B=f(b,d,D);if(B)return B;const F=R.endsWith(D),O=N.endsWith(D);if(F!==O)return F?-1:1;const z=k(R,N);return z!==0?z:R.localeCompare(N)}e.compareAnything=a;function f(b,d,D){const R=b.toLowerCase(),N=d.toLowerCase(),B=R.startsWith(D),F=N.startsWith(D);if(B!==F)return B?-1:1;if(B&&F){if(R.length<N.length)return-1;if(R.length>N.length)return 1}return 0}e.compareByPrefix=f}),define(we[100],be([0,1,99,96,47,9,12,8]),function(Y,e,m,i,y,C,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const _=0,I=[_,[]];function L(M,x,V,U){if(!M||!x)return I;const H=M.length,X=x.length;if(H<X)return I;const se=M.toLowerCase();return T(x,V,X,M,se,H,U)}e.scoreFuzzy=L;function T(M,x,V,U,H,X,se){const K=[],j=[];for(let ke=0;ke<V;ke++){const Le=ke*X,Oe=Le-X,q=ke>0,J=M[ke],re=x[ke];for(let he=0;he<X;he++){const ee=he>0,ae=Le+he,Se=ae-1,Ue=Oe+he-1,Ve=ee?K[Se]:0,Ge=q&&ee?K[Ue]:0,Je=q&&ee?j[Ue]:0;let tt;!Ge&&q?tt=0:tt=l(J,re,U,H,he,Je),tt&&Ge+tt>=Ve&&(se||q||H.startsWith(x,he))?(j[ae]=Je+1,K[ae]=Ge+tt):(j[ae]=_,K[ae]=Ve)}}const ie=[];let ce=V-1,ge=X-1;for(;ce>=0&&ge>=0;){const ke=ce*X+ge;j[ke]===_||(ie.push(ge),ce--),ge--}return[K[V*X-1],ie.reverse()]}function l(M,x,V,U,H,X){let se=0;if(!E(x,U[H]))return se;if(se+=1,X>0&&(se+=X*5),M===V[H]&&(se+=1),H===0)se+=8;else{const K=h(V.charCodeAt(H-1));K?se+=K:(0,i.isUpper)(V.charCodeAt(H))&&X===0&&(se+=2)}return se}function E(M,x){return M===x?!0:M==="/"||M==="\\"?x==="/"||x==="\\":!1}function h(M){switch(M){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function v(M,x,V=0,U=0){const H=x;return H.values&&H.values.length>1?A(M,H.values,V,U):w(M,x,V,U)}e.scoreFuzzy2=v;function A(M,x,V,U){let H=0;const X=[];for(const se of x){const[K,j]=w(M,se,V,U);if(typeof K!="number")return p;H+=K,X.push(...j)}return[H,f(X)]}function w(M,x,V,U){const H=(0,i.fuzzyScore)(x.original,x.originalLowercase,V,M,M.toLowerCase(),U,!0);return H?[H[0],(0,i.createMatches)(H)]:p}const s=Object.freeze({score:0}),o=1<<18,g=1<<17,c=1<<16;function S(M,x,V,U){const H=U.values?U.values:[U];return(0,y.hash)({[U.normalized]:{values:H.map(se=>({value:se.normalized,expectContiguousMatch:se.expectContiguousMatch})),label:M,description:x,allowNonContiguousMatches:V}})}function r(M,x,V,U,H){if(!M||!x.normalized)return s;const X=U.getItemLabel(M);if(!X)return s;const se=U.getItemDescription(M),K=S(X,se,V,x),j=H[K];if(j)return j;const ie=t(X,se,U.getItemPath(M),x,V);return H[K]=ie,ie}e.scoreItemFuzzy=r;function t(M,x,V,U,H){const X=!V||!U.containsPathSeparator;return V&&(P.isLinux?U.pathNormalized===V:(0,k.equalsIgnoreCase)(U.pathNormalized,V))?{score:o,labelMatch:[{start:0,end:M.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:U.values&&U.values.length>1?n(M,x,V,U.values,X,H):u(M,x,V,U,X,H)}function n(M,x,V,U,H,X){let se=0;const K=[],j=[];for(const ie of U){const{score:ce,labelMatch:ge,descriptionMatch:ke}=u(M,x,V,ie,H,X);if(ce===_)return s;se+=ce,ge&&K.push(...ge),ke&&j.push(...ke)}return{score:se,labelMatch:f(K),descriptionMatch:f(j)}}function u(M,x,V,U,H,X){if(H||!x){const[se,K]=L(M,U.normalized,U.normalizedLowercase,X&&!U.expectContiguousMatch);if(se){const j=(0,i.matchesPrefix)(U.normalized,M);let ie;return j?(ie=g,ie+=Math.round(U.normalized.length/M.length*100)):ie=c,{score:ie+se,labelMatch:j||a(K)}}}if(x){let se=x;V&&(se=`${x}${C.sep}`);const K=se.length,j=`${se}${M}`,[ie,ce]=L(j,U.normalized,U.normalizedLowercase,X&&!U.expectContiguousMatch);if(ie){const ge=a(ce),ke=[],Le=[];return ge.forEach(Oe=>{Oe.start<K&&Oe.end>K?(ke.push({start:0,end:Oe.end-K}),Le.push({start:Oe.start,end:K})):Oe.start>=K?ke.push({start:Oe.start-K,end:Oe.end-K}):Le.push(Oe)}),{score:ie,labelMatch:ke,descriptionMatch:Le}}}return s}function a(M){const x=[];if(!M)return x;let V;for(const U of M)V&&V.end===U?V.end+=1:(V={start:U,end:U+1},x.push(V));return x}function f(M){const x=M.sort((H,X)=>H.start-X.start),V=[];let U;for(const H of x)!U||!b(U,H)?(U=H,V.push(H)):(U.start=Math.min(U.start,H.start),U.end=Math.max(U.end,H.end));return V}function b(M,x){return!(M.end<x.start||x.end<M.start)}function d(M,x,V,U,H,X){const se=r(M,V,U,H,X),K=r(x,V,U,H,X),j=se.score,ie=K.score;if((j===o||ie===o)&&j!==ie)return j===o?-1:1;if(j>c||ie>c){if(j!==ie)return j>ie?-1:1;if(j<g&&ie<g){const J=R(se.labelMatch,K.labelMatch);if(J!==0)return J}const Oe=H.getItemLabel(M)||"",q=H.getItemLabel(x)||"";if(Oe.length!==q.length)return Oe.length-q.length}if(j!==ie)return j>ie?-1:1;const ce=Array.isArray(se.labelMatch)&&se.labelMatch.length>0,ge=Array.isArray(K.labelMatch)&&K.labelMatch.length>0;if(ce&&!ge)return-1;if(ge&&!ce)return 1;const ke=D(M,se,H),Le=D(x,K,H);return ke&&Le&&ke!==Le?Le>ke?-1:1:N(M,x,V,H)}e.compareItemsByFuzzyScore=d;function D(M,x,V){let U=-1,H=-1;if(x.descriptionMatch&&x.descriptionMatch.length?U=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(U=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(H=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const X=V.getItemDescription(M);X&&(H+=X.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(H=x.descriptionMatch[x.descriptionMatch.length-1].end);return H-U}function R(M,x){if(!M&&!x||(!M||!M.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!M||!M.length)return 1;const V=M[0].start,H=M[M.length-1].end-V,X=x[0].start,K=x[x.length-1].end-X;return H===K?0:K<H?1:-1}function N(M,x,V,U){const H=U.getItemLabel(M)||"",X=U.getItemLabel(x)||"",se=U.getItemDescription(M),K=U.getItemDescription(x),j=H.length+(se?se.length:0),ie=X.length+(K?K.length:0);if(j!==ie)return j-ie;const ce=U.getItemPath(M),ge=U.getItemPath(x);return ce&&ge&&ce.length!==ge.length?ce.length-ge.length:H!==X?(0,m.compareAnything)(H,X,V.normalized):se&&K&&se!==K?(0,m.compareAnything)(se,K,V.normalized):ce&&ge&&ce!==ge?(0,m.compareAnything)(ce,ge,V.normalized):0}function B(M){return M.startsWith('"')&&M.endsWith('"')}const F=" ";function O(M){typeof M!="string"&&(M="");const x=M.toLowerCase(),{pathNormalized:V,normalized:U,normalizedLowercase:H}=z(M),X=V.indexOf(C.sep)>=0,se=B(M);let K;const j=M.split(F);if(j.length>1)for(const ie of j){const ce=B(ie),{pathNormalized:ge,normalized:ke,normalizedLowercase:Le}=z(ie);ke&&(K||(K=[]),K.push({original:ie,originalLowercase:ie.toLowerCase(),pathNormalized:ge,normalized:ke,normalizedLowercase:Le,expectContiguousMatch:ce}))}return{original:M,originalLowercase:x,pathNormalized:V,normalized:U,normalizedLowercase:H,values:K,containsPathSeparator:X,expectContiguousMatch:se}}e.prepareQuery=O;function z(M){let x;P.isWindows?x=M.replace(/\//g,C.sep):x=M.replace(/\\/g,C.sep);const V=(0,k.stripWildcards)(x).replace(/\s|"/g,"");return{pathNormalized:x,normalized:V,normalizedLowercase:V.toLowerCase()}}function W(M){return Array.isArray(M)?O(M.map(x=>x.original).join(F)):O(M.original)}e.pieceToQuery=W}),define(we[31],be([0,1,18,30,24,9,8]),function(Y,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const _="**",I="/",L="[/\\\\]",T="[^/\\\\]",l=/\//g;function E(U){switch(U){case 0:return"";case 1:return`${T}*?`;default:return`(?:${L}|${T}+${L}|${L}${T}+)*?`}}function h(U,H){if(!U)return[];const X=[];let se=!1,K=!1,j="";for(const ie of U){switch(ie){case H:if(!se&&!K){X.push(j),j="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":K=!0;break;case"]":K=!1;break}j+=ie}return j&&X.push(j),X}e.splitGlobAware=h;function p(U){if(!U)return"";let H="";const X=h(U,I);if(X.every(se=>se===_))H=".*";else{let se=!1;X.forEach((K,j)=>{if(K===_){se||(H+=E(2),se=!0);return}let ie=!1,ce="",ge=!1,ke="";for(const Le of K){if(Le!=="}"&&ie){ce+=Le;continue}if(ge&&(Le!=="]"||!ke)){let Oe;Le==="-"?Oe=Le:(Le==="^"||Le==="!")&&!ke?Oe="^":Le===I?Oe="":Oe=P.escapeRegExpCharacters(Le),ke+=Oe;continue}switch(Le){case"{":ie=!0;continue;case"[":ge=!0;continue;case"}":{H+=`(?:${h(ce,",").map(J=>p(J)).join("|")})`,ie=!1,ce="";break}case"]":H+="["+ke+"]",ge=!1,ke="";break;case"?":H+=T;continue;case"*":H+=E(1);continue;default:H+=P.escapeRegExpCharacters(Le)}}j<X.length-1&&(X[j+1]!==_||j+2<X.length)&&(H+=L),se=!1})}return H}const v=/^\*\*\/\*\.[\w\.-]+$/,A=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,s=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new y.LRUCache(1e4),S=function(){return!1},r=function(){return null};function t(U,H){if(!U)return r;let X;typeof U!="string"?X=U.pattern:X=U,X=X.trim();const se=`${X}_${!!H.trimForExclusions}`;let K=c.get(se);if(K)return n(K,U);let j;if(v.test(X)){const ie=X.substr(4);K=function(ce,ge){return typeof ce=="string"&&ce.endsWith(ie)?X:null}}else(j=A.exec(u(X,H)))?K=a(j[1],X):(H.trimForExclusions?s:w).test(X)?K=f(X,H):(j=o.exec(u(X,H)))?K=b(j[1].substr(1),X,!0):(j=g.exec(u(X,H)))?K=b(j[1],X,!1):K=d(X);return c.set(se,K),n(K,U)}function n(U,H){return typeof H=="string"?U:function(X,se){return i.isEqualOrParent(X,H.base)?U(C.relative(H.base,X),se):null}}function u(U,H){return H.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function a(U,H){const X=`/${U}`,se=`\\${U}`,K=function(ie,ce){return typeof ie!="string"?null:ce?ce===U?H:null:ie===U||ie.endsWith(X)||ie.endsWith(se)?H:null},j=[U];return K.basenames=j,K.patterns=[H],K.allBasenames=j,K}function f(U,H){const X=V(U.slice(1,-1).split(",").map(ce=>t(ce,H)).filter(ce=>ce!==r),U),se=X.length;if(!se)return r;if(se===1)return X[0];const K=function(ce,ge){for(let ke=0,Le=X.length;ke<Le;ke++)if(X[ke](ce,ge))return U;return null},j=X.find(ce=>!!ce.allBasenames);j&&(K.allBasenames=j.allBasenames);const ie=X.reduce((ce,ge)=>ge.allPaths?ce.concat(ge.allPaths):ce,[]);return ie.length&&(K.allPaths=ie),K}function b(U,H,X){const se=C.sep===C.posix.sep,K=se?U:U.replace(l,C.sep),j=C.sep+K,ie=C.posix.sep+U,ce=X?function(ge,ke){return typeof ge=="string"&&(ge===K||ge.endsWith(j)||!se&&(ge===U||ge.endsWith(ie)))?H:null}:function(ge,ke){return typeof ge=="string"&&(ge===K||!se&&ge===U)?H:null};return ce.allPaths=[(X?"*/":"./")+U],ce}function d(U){try{const H=new RegExp(`^${p(U)}$`);return function(X){return H.lastIndex=0,typeof X=="string"&&H.test(X)?U:null}}catch{return r}}function D(U,H,X){return!U||typeof H!="string"?!1:R(U)(H,void 0,X)}e.match=D;function R(U,H={}){if(!U)return S;if(typeof U=="string"||O(U)){const X=t(U,H);if(X===r)return S;const se=function(K,j){return!!X(K,j)};return X.allBasenames&&(se.allBasenames=X.allBasenames),X.allPaths&&(se.allPaths=X.allPaths),se}return M(U,H)}e.parse=R;function N(U){if(!U)return;let H;return X=>(H||(H=(U()||Promise.resolve([])).then(se=>se?F(se):{})),H.then(se=>!!se[X]))}e.hasSiblingPromiseFn=N;function B(U){if(!U)return;let H;return X=>{if(!H){const se=U();H=se?F(se):{}}return!!H[X]}}e.hasSiblingFn=B;function F(U){const H={};for(const X of U)H[X]=!0;return H}function O(U){const H=U;return H&&typeof H.base=="string"&&typeof H.pattern=="string"}e.isRelativePattern=O;function z(U){return U.allBasenames||[]}e.getBasenameTerms=z;function W(U){return U.allPaths||[]}e.getPathTerms=W;function M(U,H){const X=V(Object.getOwnPropertyNames(U).map(ce=>x(ce,U[ce],H)).filter(ce=>ce!==r)),se=X.length;if(!se)return r;if(!X.some(ce=>!!ce.requiresSiblings)){if(se===1)return X[0];const ce=function(Le,Oe){for(let q=0,J=X.length;q<J;q++){const re=X[q](Le,Oe);if(re)return re}return null},ge=X.find(Le=>!!Le.allBasenames);ge&&(ce.allBasenames=ge.allBasenames);const ke=X.reduce((Le,Oe)=>Oe.allPaths?Le.concat(Oe.allPaths):Le,[]);return ke.length&&(ce.allPaths=ke),ce}const K=function(ce,ge,ke){let Le;for(let Oe=0,q=X.length;Oe<q;Oe++){const J=X[Oe];J.requiresSiblings&&ke&&(ge||(ge=C.basename(ce)),Le||(Le=ge.substr(0,ge.length-C.extname(ce).length)));const re=J(ce,ge,Le,ke);if(re)return re}return null},j=X.find(ce=>!!ce.allBasenames);j&&(K.allBasenames=j.allBasenames);const ie=X.reduce((ce,ge)=>ge.allPaths?ce.concat(ge.allPaths):ce,[]);return ie.length&&(K.allPaths=ie),K}function x(U,H,X){if(H===!1)return r;const se=t(U,X);if(se===r)return r;if(typeof H=="boolean")return se;if(H){const K=H.when;if(typeof K=="string"){const j=(ie,ce,ge,ke)=>{if(!ke||!se(ie,ce))return null;const Le=K.replace("$(basename)",ge),Oe=ke(Le);return(0,m.isThenable)(Oe)?Oe.then(q=>q?U:null):Oe?U:null};return j.requiresSiblings=!0,j}}return se}function V(U,H){const X=U.filter(ce=>!!ce.basenames);if(X.length<2)return U;const se=X.reduce((ce,ge)=>{const ke=ge.basenames;return ke?ce.concat(ke):ce},[]);let K;if(H){K=[];for(let ce=0,ge=se.length;ce<ge;ce++)K.push(H)}else K=X.reduce((ce,ge)=>{const ke=ge.patterns;return ke?ce.concat(ke):ce},[]);const j=function(ce,ge){if(typeof ce!="string")return null;if(!ge){let Le;for(Le=ce.length;Le>0;Le--){const Oe=ce.charCodeAt(Le-1);if(Oe===47||Oe===92)break}ge=ce.substr(Le)}const ke=se.indexOf(ge);return ke!==-1?K[ke]:null};j.basenames=se,j.patterns=K,j.allBasenames=se;const ie=U.filter(ce=>!ce.basenames);return ie.push(j),ie}}),define(we[80],be([0,1,30,10,9,12,23,8,2]),function(Y,e,m,i,y,C,P,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function I(t,n,u){if(typeof t=="string"&&(t=_.URI.file(t)),u){const f=u.getWorkspaceFolder(t);if(f){const b=u.getWorkspace().folders.length>1;let d;if((0,P.isEqual)(f.uri,t)?d="":d=(0,P.relativePath)(f.uri,t),b){const D=f.name?f.name:(0,P.basename)(f.uri);d=d?D+" \u2022 "+d:D}return d}}if(t.scheme!==i.Schemas.file&&t.scheme!==i.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,m.hasDriveLetter)(t.fsPath))return(0,y.normalize)(T(t.fsPath));let a=(0,y.normalize)(t.fsPath);return!C.isWindows&&n?.userHome&&(a=E(a,n.userHome.fsPath)),a}e.getPathLabel=I;function L(t){if(!t)return;typeof t=="string"&&(t=_.URI.file(t));const n=(0,P.basename)(t)||(t.scheme===i.Schemas.file?t.fsPath:t.path);return C.isWindows&&(0,m.isRootOrDriveLetter)(n)?T(n):n}e.getBaseLabel=L;function T(t,n){return(0,m.hasDriveLetter)(t,n)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=T;let l=Object.create(null);function E(t,n){if(C.isWindows||!t||!n)return t;let u=l.original===n?l.normalized:void 0;return u||(u=`${(0,k.rtrim)(n,y.posix.sep)}${y.posix.sep}`,l={original:n,normalized:u}),(C.isLinux?t.startsWith(u):(0,k.startsWithIgnoreCase)(t,u))&&(t=`~/${t.substr(u.length)}`),t}e.tildify=E;function h(t,n){return t.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=h;const p="\u2026",v="\\\\",A="~";function w(t,n=y.sep){const u=new Array(t.length);let a=!1;for(let f=0;f<t.length;f++){let b=t[f];if(b===""){u[f]=`.${n}`;continue}if(!b){u[f]=b;continue}a=!0;let d="";b.indexOf(v)===0?(d=b.substr(0,b.indexOf(v)+v.length),b=b.substr(b.indexOf(v)+v.length)):b.indexOf(n)===0?(d=b.substr(0,b.indexOf(n)+n.length),b=b.substr(b.indexOf(n)+n.length)):b.indexOf(A)===0&&(d=b.substr(0,b.indexOf(A)+A.length),b=b.substr(b.indexOf(A)+A.length));const D=b.split(n);for(let R=1;a&&R<=D.length;R++)for(let N=D.length-R;a&&N>=0;N--){a=!1;let B=D.slice(N,N+R).join(n);for(let F=0;!a&&F<t.length;F++)if(F!==f&&t[F]&&t[F].indexOf(B)>-1){const O=N+R===D.length,z=N>0&&t[F].indexOf(n)>-1?n+B:B,W=t[F].endsWith(z);a=!O||W}if(!a){let F="";(D[0].endsWith(":")||d!=="")&&(N===1&&(N=0,R++,B=D[0]+n+B),N>0&&(F=D[0]+n),F=d+F),N>0&&(F=F+p+n),F=F+B,N+R<D.length&&(F=F+n+p),u[f]=F}}a&&(u[f]=b)}return u}e.shorten=w;var s;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function o(t,n=Object.create(null)){const u=[];let a=!1,f="";for(const b of t)if(b==="$"||a&&b==="{")f&&u.push({value:f,type:s.TEXT}),f="",a=!0;else if(b==="}"&&a){const d=n[f];if(typeof d=="string")d.length&&u.push({value:d,type:s.VARIABLE});else if(d){const D=u[u.length-1];(!D||D.type!==s.SEPARATOR)&&u.push({value:d.label,type:s.SEPARATOR})}f="",a=!1}else f+=b;return f&&!a&&u.push({value:f,type:s.TEXT}),u.filter((b,d)=>{if(b.type===s.SEPARATOR){const D=u[d-1],R=u[d+1];return[D,R].every(N=>N&&(N.type===s.VARIABLE||N.type===s.TEXT)&&N.value.length>0)}return!0}).map(b=>b.value).join("")}e.template=o;function g(t,n){return C.isMacintosh||n?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):t.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function c(t,n){return C.isMacintosh||n?t.replace(/\(&&\w\)|&&/g,""):C.isWindows?t.replace(/&&|&/g,u=>u==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=c;function S(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=S;function r(t){const n=t.indexOf("/")!==-1?y.posix:y.win32,u=n.basename(t),a=n.dirname(t);return u.length?{name:u,parentPath:a}:{name:a,parentPath:""}}e.splitName=r}),define(we[101],be([0,1,31,10,9,23,8]),function(Y,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var k;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(k=e.Mimes||(e.Mimes={}));let _=[],I=[],L=[];function T(t,n=!1){const u=l(t);_.push(u),u.userConfigured?L.push(u):I.push(u),n&&!u.userConfigured&&_.forEach(a=>{a.mime===u.mime||a.userConfigured||(u.extension&&a.extension===u.extension&&console.warn(`Overwriting extension <<${u.extension}>> to now point to mime <<${u.mime}>>`),u.filename&&a.filename===u.filename&&console.warn(`Overwriting filename <<${u.filename}>> to now point to mime <<${u.mime}>>`),u.filepattern&&a.filepattern===u.filepattern&&console.warn(`Overwriting filepattern <<${u.filepattern}>> to now point to mime <<${u.mime}>>`),u.firstline&&a.firstline===u.firstline&&console.warn(`Overwriting firstline <<${u.firstline}>> to now point to mime <<${u.mime}>>`))})}e.registerTextMime=T;function l(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,m.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(y.posix.sep)>=0:!1}}function E(t){t?(_=_.filter(n=>!n.userConfigured),L=[]):(_=[],I=[],L=[])}e.clearTextMimes=E;function h(t,n){let u;if(t)switch(t.scheme){case i.Schemas.file:u=t.fsPath;break;case i.Schemas.data:{u=C.DataUri.parseMetaData(t).get(C.DataUri.META_DATA_LABEL);break}default:u=t.path}if(!u)return[k.unknown];u=u.toLowerCase();const a=(0,y.basename)(u),f=p(u,a,L);if(f)return[f,k.text];const b=p(u,a,I);if(b)return[b,k.text];if(n){const d=v(n);if(d)return[d,k.text]}return[k.unknown]}e.guessMimeTypes=h;function p(t,n,u){let a=null,f=null,b=null;for(let d=u.length-1;d>=0;d--){const D=u[d];if(n===D.filenameLowercase){a=D;break}if(D.filepattern&&(!f||D.filepattern.length>f.filepattern.length)){const R=D.filepatternOnPath?t:n;D.filepatternLowercase?.(R)&&(f=D)}D.extension&&(!b||D.extension.length>b.extension.length)&&n.endsWith(D.extensionLowercase)&&(b=D)}return a?a.mime:f?f.mime:b?b.mime:null}function v(t){if((0,P.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let n=_.length-1;n>=0;n--){const u=_[n];if(!u.firstline)continue;const a=t.match(u.firstline);if(a&&a.length>0)return u.mime}return null}function A(t){return t?typeof t=="string"?t===k.binary||t===k.text||t===k.unknown:t.length===1&&A(t[0]):!0}e.isUnspecific=A;const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},s={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function o(t){const n=(0,y.extname)(t),u=w[n.toLowerCase()];return u!==void 0?u:g(t)}e.getMediaOrTextMime=o;function g(t){const n=(0,y.extname)(t);return s[n.toLowerCase()]}e.getMediaMime=g;function c(t){for(const n in s)if(s[n]===t)return n}e.getExtensionForMimeType=c;const S=/^(.+)\/(.+?)(;.+)?$/;function r(t,n){const u=S.exec(t);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:n?void 0:t}e.normalizeMimeType=r}),define(we[102],be([0,1,2]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(L){return L.toJSON()}class y{constructor(T){this._uriTransformer=T}transformIncoming(T){const l=this._uriTransformer.transformIncoming(T);return l===T?T:i(m.URI.from(l))}transformOutgoing(T){const l=this._uriTransformer.transformOutgoing(T);return l===T?T:i(m.URI.from(l))}transformOutgoingURI(T){const l=this._uriTransformer.transformOutgoing(T);return l===T?T:m.URI.from(l)}transformOutgoingScheme(T){return this._uriTransformer.transformOutgoingScheme(T)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function C(L,T,l){if(!L||l>200)return null;if(typeof L=="object"){if(L instanceof m.URI)return T.transformOutgoing(L);for(let E in L)if(Object.hasOwnProperty.call(L,E)){const h=C(L[E],T,l+1);h!==null&&(L[E]=h)}}return null}function P(L,T){const l=C(L,T,0);return l===null?L:l}e.transformOutgoingURIs=P;function k(L,T,l,E){if(!L||E>200)return null;if(typeof L=="object"){if(L.$mid===1)return l?m.URI.revive(T.transformIncoming(L)):T.transformIncoming(L);for(let h in L)if(Object.hasOwnProperty.call(L,h)){const p=k(L[h],T,l,E+1);p!==null&&(L[h]=p)}}return null}function _(L,T){const l=k(L,T,!1,0);return l===null?L:l}e.transformIncomingURIs=_;function I(L,T){const l=k(L,T,!0,0);return l===null?L:l}e.transformAndReviveIncomingURIs=I}),define(we[33],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(_){return m.test(_)}e.isUUID=i;const y=new Uint8Array(16),C=[];for(let _=0;_<256;_++)C.push(_.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(_){for(let I=0;I<_.length;I++)_[I]=Math.floor(Math.random()*256);return _};function k(){P(y),y[6]=y[6]&15|64,y[8]=y[8]&63|128;let _=0,I="";return I+=C[y[_++]],I+=C[y[_++]],I+=C[y[_++]],I+=C[y[_++]],I+="-",I+=C[y[_++]],I+=C[y[_++]],I+="-",I+=C[y[_++]],I+=C[y[_++]],I+="-",I+=C[y[_++]],I+=C[y[_++]],I+="-",I+=C[y[_++]],I+=C[y[_++]],I+=C[y[_++]],I+=C[y[_++]],I+=C[y[_++]],I+=C[y[_++]],I}e.generateUuid=k}),define(we[142],be([0,1,103]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class i{constructor(C="utf8"){this.stringDecoder=new m.StringDecoder(C),this.remaining=null}write(C){const P=[],k=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(k.length<1)return P;let _=0,I,L=_;for(;L<k.length;)if(I=k.charCodeAt(L),I===13||I===10){if(P.push(k.substring(_,L)),L++,L<k.length){const T=I;I=k.charCodeAt(L),(T===13&&I===10||T===10&&I===13)&&L++}_=L}else L++;return this.remaining=_<k.length?k.substr(_):null,P}end(){return this.remaining}}e.LineDecoder=i}),define(we[28],be([0,1,60,81,289,18,30,79,9,12,23,2]),function(Y,e,m,i,y,C,P,k,_,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var l;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(l=e.RimRafMode||(e.RimRafMode={}));async function E(O,z=l.UNLINK){if((0,P.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return z===l.UNLINK?p(O):h(O)}async function h(O){try{const z=(0,P.randomPath)((0,i.tmpdir)());try{await e.Promises.rename(O,z)}catch{return p(O)}p(z).catch(W=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function p(O){return e.Promises.rmdir(O,{recursive:!0,maxRetries:3})}function v(O){if((0,P.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(O,{recursive:!0})}e.rimrafSync=v;async function A(O,z){return o(await(z?w(O):(0,y.promisify)(m.readdir)(O)))}async function w(O){try{return await(0,y.promisify)(m.readdir)(O,{withFileTypes:!0})}catch(M){console.warn("[node.js fs] readdir with filetypes failed with error: ",M)}const z=[],W=await A(O);for(const M of W){let x=!1,V=!1,U=!1;try{const H=await e.Promises.lstat((0,_.join)(O,M));x=H.isFile(),V=H.isDirectory(),U=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}z.push({name:M,isFile:()=>x,isDirectory:()=>V,isSymbolicLink:()=>U})}return z}function s(O){return o(m.readdirSync(O))}e.readdirSync=s;function o(O){return O.map(z=>typeof z=="string"?I.isMacintosh?(0,k.normalizeNFC)(z):z:(z.name=I.isMacintosh?(0,k.normalizeNFC)(z.name):z.name,z))}async function g(O){const z=await A(O),W=[];for(const M of z)await S.existsDirectory((0,_.join)(O,M))&&W.push(M);return W}function c(O,z=1e3){return new Promise(W=>{let M=!1;const x=setInterval(()=>{M||(M=!0,m.access(O,V=>{M=!1,V&&(clearInterval(x),W(void 0))}))},z)})}e.whenDeleted=c;var S;(function(O){async function z(x){let V;try{if(V=await e.Promises.lstat(x),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(I.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw H}throw U}}O.stat=z;async function W(x){try{const{stat:V,symbolicLink:U}=await O.stat(x);return V.isFile()&&U?.dangling!==!0}catch{}return!1}O.existsFile=W;async function M(x){try{const{stat:V,symbolicLink:U}=await O.stat(x);return V.isDirectory()&&U?.dangling!==!0}catch{}return!1}O.existsDirectory=M})(S=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new C.ResourceQueue;function t(O,z,W){return r.queueFor(T.URI.file(O),L.extUriBiasedIgnorePathCase).queue(()=>{const M=f(W);return new Promise((x,V)=>u(O,z,M,U=>U?V(U):x()))})}let n=!0;function u(O,z,W,M){if(!n)return m.writeFile(O,z,{mode:W.mode,flag:W.flag},M);m.open(O,W.flag,W.mode,(x,V)=>{if(x)return M(x);m.writeFile(V,z,U=>{if(U)return m.close(V,()=>M(U));m.fdatasync(V,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),n=!1),m.close(V,X=>M(X))))})})}function a(O,z,W){const M=f(W);if(!n)return m.writeFileSync(O,z,{mode:M.mode,flag:M.flag});const x=m.openSync(O,M.flag,M.mode);try{m.writeFileSync(x,z);try{m.fdatasyncSync(x)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),n=!1}}finally{m.closeSync(x)}}e.writeFileSync=a;function f(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function b(O,z){if(O===z)return;async function W(M){try{const x=await e.Promises.lstat(M);if(x.isDirectory()||x.isSymbolicLink())return;await e.Promises.utimes(M,x.atime,new Date)}catch{}}try{await e.Promises.rename(O,z),await W(z)}catch(M){if(O.toLowerCase()!==z.toLowerCase()&&M.code==="EXDEV"||O.endsWith("."))await d(O,z,{preserveSymlinks:!1}),await E(O,l.MOVE),await W(z);else throw M}}async function d(O,z,W){return R(O,z,{root:{source:O,target:z},options:W,handledSourcePaths:new Set})}const D=511;async function R(O,z,W){if(W.handledSourcePaths.has(O))return;W.handledSourcePaths.add(O);const{stat:M,symbolicLink:x}=await S.stat(O);if(x){if(W.options.preserveSymlinks)try{return await F(O,z,W)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(x.dangling)return}return M.isDirectory()?N(O,z,M.mode&D,W):B(O,z,M.mode&D)}async function N(O,z,W,M){await e.Promises.mkdir(z,{recursive:!0,mode:W});const x=await A(O);for(const V of x)await R((0,_.join)(O,V),(0,_.join)(z,V),M)}async function B(O,z,W){await e.Promises.copyFile(O,z),await e.Promises.chmod(z,W)}async function F(O,z,W){let M=await e.Promises.readlink(O);(0,P.isEqualOrParent)(M,W.root.source,!I.isLinux)&&(M=(0,_.join)(W.root.target,M.substr(W.root.source.length+1))),await e.Promises.symlink(M,z)}e.Promises=new class{get access(){return(0,y.promisify)(m.access)}get stat(){return(0,y.promisify)(m.stat)}get lstat(){return(0,y.promisify)(m.lstat)}get utimes(){return(0,y.promisify)(m.utimes)}get read(){return(0,y.promisify)(m.read)}get readFile(){return(0,y.promisify)(m.readFile)}get write(){return(0,y.promisify)(m.write)}get appendFile(){return(0,y.promisify)(m.appendFile)}get fdatasync(){return(0,y.promisify)(m.fdatasync)}get truncate(){return(0,y.promisify)(m.truncate)}get rename(){return(0,y.promisify)(m.rename)}get copyFile(){return(0,y.promisify)(m.copyFile)}get open(){return(0,y.promisify)(m.open)}get close(){return(0,y.promisify)(m.close)}get symlink(){return(0,y.promisify)(m.symlink)}get readlink(){return(0,y.promisify)(m.readlink)}get chmod(){return(0,y.promisify)(m.chmod)}get mkdir(){return(0,y.promisify)(m.mkdir)}get unlink(){return(0,y.promisify)(m.unlink)}get rmdir(){return(0,y.promisify)(m.rmdir)}get realpath(){return(0,y.promisify)(m.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return A}get readDirsInDir(){return g}get writeFile(){return t}get rm(){return E}get move(){return b}get copy(){return d}}}),define(we[104],be([0,1,60,9,8,28]),function(Y,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function P(L){const T=(0,i.dirname)(L);if(L===T)return L;const l=((0,i.basename)(L)||L).toLowerCase();try{const h=(0,C.readdirSync)(T).filter(p=>p.toLowerCase()===l);if(h.length===1){const p=P(T);if(p)return(0,i.join)(p,h[0])}else if(h.length>1){const p=h.indexOf(l);if(p>=0){const v=P(T);if(v)return(0,i.join)(v,h[p])}}}catch{}return null}e.realcaseSync=P;async function k(L){try{return await C.Promises.realpath(L)}catch{const l=I(L);return await C.Promises.access(l,m.constants.R_OK),l}}e.realpath=k;function _(L){try{return m.realpathSync(L)}catch{const l=I(L);return m.accessSync(l,m.constants.R_OK),l}}e.realpathSync=_;function I(L){return(0,y.rtrim)((0,i.normalize)(L),i.sep)}});var je=this&&this.__decorate||function(Y,e,m,i){var y=arguments.length,C=y<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,m):i,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(Y,e,m,i);else for(var k=Y.length-1;k>=0;k--)(P=Y[k])&&(C=(y<3?P(C):y>3?P(e,m,C):P(e,m))||C);return y>3&&C&&Object.defineProperty(e,m,C),C};define(we[105],be([0,1,16,18,22,21,57,15,3,6,59,8,13]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function h(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function v(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var A;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(A||(A={}));class w{constructor(U){this.buffer=U,this.pos=0}read(U){const H=this.buffer.slice(this.pos,this.pos+U);return this.pos+=H.byteLength,H}}class s{constructor(){this.buffers=[]}get buffer(){return y.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object"})(o||(o={}));function g(V){const U=y.VSBuffer.alloc(4);return U.writeUInt32BE(V,0),U}function c(V){return V.read(4).readUInt32BE(0)}function S(V){const U=y.VSBuffer.alloc(1);return U.writeUInt8(V,0),U}const r={Undefined:S(o.Undefined),String:S(o.String),Buffer:S(o.Buffer),VSBuffer:S(o.VSBuffer),Array:S(o.Array),Object:S(o.Object)},t=typeof Buffer!="undefined";function n(V,U){if(typeof U=="undefined")V.write(r.Undefined);else if(typeof U=="string"){const H=y.VSBuffer.fromString(U);V.write(r.String),V.write(g(H.byteLength)),V.write(H)}else if(t&&Buffer.isBuffer(U)){const H=y.VSBuffer.wrap(U);V.write(r.Buffer),V.write(g(H.byteLength)),V.write(H)}else if(U instanceof y.VSBuffer)V.write(r.VSBuffer),V.write(g(U.byteLength)),V.write(U);else if(Array.isArray(U)){V.write(r.Array),V.write(g(U.length));for(const H of U)n(V,H)}else{const H=y.VSBuffer.fromString(JSON.stringify(U));V.write(r.Object),V.write(g(H.byteLength)),V.write(H)}}function u(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(c(V)).toString();case o.Buffer:return V.read(c(V)).buffer;case o.VSBuffer:return V.read(c(V));case o.Array:{const H=c(V),X=[];for(let se=0;se<H;se++)X.push(u(V));return X}case o.Object:return JSON.parse(V.read(c(V)).toString())}}class a{constructor(U,H,X=null,se=1e3){this.protocol=U,this.ctx=H,this.logger=X,this.timeoutDelay=se,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(U,H){this.channels.set(U,H),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const H=this.send([U.type]);this.logger&&this.logger.logOutgoing(H,0,1,v(U.type));return}case 201:case 202:case 204:case 203:{const H=this.send([U.type,U.id],U.data);this.logger&&this.logger.logOutgoing(H,U.id,1,v(U.type),U.data);return}}}send(U,H=void 0){const X=new s;return n(X,U),n(X,H),this.sendBuffer(X.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch{return 0}}onRawMessage(U){const H=new w(U),X=u(H),se=u(H),K=X[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(U.byteLength,X[1],1,`${h(K)}: ${X[2]}.${X[3]}`,se),this.onPromise({type:K,id:X[1],channelName:X[2],name:X[3],arg:se});case 102:return this.logger&&this.logger.logIncoming(U.byteLength,X[1],1,`${h(K)}: ${X[2]}.${X[3]}`,se),this.onEventListen({type:K,id:X[1],channelName:X[2],name:X[3],arg:se});case 101:return this.logger&&this.logger.logIncoming(U.byteLength,X[1],1,`${h(K)}`),this.disposeActiveRequest({type:K,id:X[1]});case 103:return this.logger&&this.logger.logIncoming(U.byteLength,X[1],1,`${h(K)}`),this.disposeActiveRequest({type:K,id:X[1]})}}onPromise(U){const H=this.channels.get(U.channelName);if(!H){this.collectPendingRequest(U);return}const X=new C.CancellationTokenSource;let se;try{se=H.call(this.ctx,U.name,U.arg,X.token)}catch(ie){se=Promise.reject(ie)}const K=U.id;se.then(ie=>{this.sendResponse({id:K,data:ie,type:201}),this.activeRequests.delete(U.id)},ie=>{ie instanceof Error?this.sendResponse({id:K,data:{message:ie.message,name:ie.name,stack:ie.stack?ie.stack.split?ie.stack.split(`
`):ie.stack:void 0},type:202}):this.sendResponse({id:K,data:ie,type:203}),this.activeRequests.delete(U.id)});const j=(0,I.toDisposable)(()=>X.cancel());this.activeRequests.set(U.id,j)}onEventListen(U){const H=this.channels.get(U.channelName);if(!H){this.collectPendingRequest(U);return}const X=U.id,K=H.listen(this.ctx,U.name,U.arg)(j=>this.sendResponse({id:X,data:j,type:204}));this.activeRequests.set(U.id,K)}disposeActiveRequest(U){const H=this.activeRequests.get(U.id);H&&(H.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let H=this.pendingRequests.get(U.channelName);H||(H=[],this.pendingRequests.set(U.channelName,H));const X=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);H.push({request:U,timeoutTimer:X})}flushPendingRequests(U){const H=this.pendingRequests.get(U);if(H){for(const X of H)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.onPromise(X.request);break;case 102:this.onEventListen(X.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelServer=a;var f;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class b{constructor(U,H=null){this.protocol=U,this.isDisposed=!1,this.state=A.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(X=>this.onBuffer(X)),this.logger=H}getChannel(U){const H=this;return{call(X,se,K){return H.isDisposed?Promise.reject(k.canceled()):H.requestPromise(U,X,se,K)},listen(X,se){return H.isDisposed?Promise.reject(k.canceled()):H.requestEvent(U,X,se)}}}requestPromise(U,H,X,se=C.CancellationToken.None){const K=this.lastRequestId++,ie={id:K,type:100,channelName:U,name:H,arg:X};if(se.isCancellationRequested)return Promise.reject(k.canceled());let ce;return new Promise((ke,Le)=>{if(se.isCancellationRequested)return Le(k.canceled());const Oe=()=>{const he=ee=>{switch(ee.type){case 201:this.handlers.delete(K),ke(ee.data);break;case 202:{this.handlers.delete(K);const ae=new Error(ee.data.message);ae.stack=ee.data.stack,ae.name=ee.data.name,Le(ae);break}case 203:this.handlers.delete(K),Le(ee.data);break}};this.handlers.set(K,he),this.sendRequest(ie)};let q=null;this.state===A.Idle?Oe():(q=(0,i.createCancelablePromise)(he=>this.whenInitialized()),q.then(()=>{q=null,Oe()}));const J=()=>{q?(q.cancel(),q=null):this.sendRequest({id:K,type:101}),Le(k.canceled())},re=se.onCancellationRequested(J);ce=(0,I.combinedDisposable)((0,I.toDisposable)(J),re),this.activeRequests.add(ce)}).finally(()=>{this.activeRequests.delete(ce)})}requestEvent(U,H,X){const se=this.lastRequestId++,j={id:se,type:102,channelName:U,name:H,arg:X};let ie=null;const ce=new _.Emitter({onFirstListenerAdd:()=>{ie=(0,i.createCancelablePromise)(ke=>this.whenInitialized()),ie.then(()=>{ie=null,this.activeRequests.add(ce),this.sendRequest(j)})},onLastListenerRemove:()=>{ie?(ie.cancel(),ie=null):(this.activeRequests.delete(ce),this.sendRequest({id:se,type:103}))}}),ge=ke=>ce.fire(ke.data);return this.handlers.set(se,ge),ce.event}sendRequest(U){switch(U.type){case 100:case 102:{const H=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger&&this.logger.logOutgoing(H,U.id,0,`${h(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const H=this.send([U.type,U.id]);this.logger&&this.logger.logOutgoing(H,U.id,0,h(U.type));return}}}send(U,H=void 0){const X=new s;return n(X,U),n(X,H),this.sendBuffer(X.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch{return 0}}onBuffer(U){const H=new w(U),X=u(H),se=u(H),K=X[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(U.byteLength,0,0,v(K)),this.onResponse({type:X[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(U.byteLength,X[1],0,v(K),se),this.onResponse({type:X[0],id:X[1],data:se})}}onResponse(U){if(U.type===200){this.state=A.Idle,this._onDidInitialize.fire();return}const H=this.handlers.get(U.id);H&&H(U)}get onDidInitializePromise(){return _.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===A.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}je([P.memoize],b.prototype,"onDidInitializePromise",null),e.ChannelClient=b;class d{constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:H,onDidClientDisconnect:X})=>{_.Event.once(H.onMessage)(K=>{const j=new w(K),ie=u(j),ce=new a(H,ie),ge=new b(H);this.channels.forEach((Le,Oe)=>ce.registerChannel(Oe,Le));const ke={channelServer:ce,channelClient:ge,ctx:ie};this._connections.add(ke),this._onDidAddConnection.fire(ke),X(()=>{ce.dispose(),ge.dispose(),this._connections.delete(ke),this._onDidRemoveConnection.fire(ke)})})})}get connections(){const U=[];return this._connections.forEach(H=>U.push(H)),U}getChannel(U,H){const X=this;return{call(se,K,j){let ie;if((0,l.isFunction)(H)){let ge=(0,m.getRandomElement)(X.connections.filter(H));ie=ge?Promise.resolve(ge):_.Event.toPromise(_.Event.filter(X.onDidAddConnection,H))}else ie=H.routeCall(X,se,K);const ce=ie.then(ge=>ge.channelClient.getChannel(U));return R(ce).call(se,K,j)},listen(se,K){if((0,l.isFunction)(H))return X.getMulticastEvent(U,H,se,K);const j=H.routeEvent(X,se,K).then(ie=>ie.channelClient.getChannel(U));return R(j).listen(se,K)}}}getMulticastEvent(U,H,X,se){const K=this;let j=new I.DisposableStore;const ie=new _.Emitter({onFirstListenerAdd:()=>{j=new I.DisposableStore;const ce=new _.EventMultiplexer,ge=new Map,ke=Oe=>{const J=Oe.channelClient.getChannel(U).listen(X,se),re=ce.add(J);ge.set(Oe,re)},Le=Oe=>{const q=ge.get(Oe);!q||(q.dispose(),ge.delete(Oe))};K.connections.filter(H).forEach(ke),_.Event.filter(K.onDidAddConnection,H)(ke,void 0,j),K.onDidRemoveConnection(Le,void 0,j),ce.event(ie.fire,ie,j),j.add(ce)},onLastListenerRemove:()=>{j.dispose()}});return ie.event}registerChannel(U,H){this.channels.set(U,H),this._connections.forEach(X=>{X.channelServer.registerChannel(U,H)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=d;class D{constructor(U,H,X=null){const se=new s;n(se,H),U.send(se.buffer),this.channelClient=new b(U,X),this.channelServer=new a(U,H,X)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,H){this.channelServer.registerChannel(U,H)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=D;function R(V){return{call(U,H,X){return V.then(se=>se.call(U,H,X))},listen(U,H){const X=new _.Relay;return V.then(se=>X.input=se.listen(U,H)),X.event}}}e.getDelayedChannel=R;function N(V){let U=!1;return{call(H,X,se){return U?V.call(H,X,se):(0,i.timeout)(0).then(()=>U=!0).then(()=>V.call(H,X,se))},listen(H,X){if(U)return V.listen(H,X);const se=new _.Relay;return(0,i.timeout)(0).then(()=>U=!0).then(()=>se.input=V.listen(H,X)),se.event}}}e.getNextTickChannel=N;class B{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const H of U.connections)if(await Promise.resolve(this.fn(H.ctx)))return Promise.resolve(H);return await _.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=B;var F;(function(V){function U(K,j){const ie=K,ce=j&&j.disableMarshalling,ge=new Map;for(const ke in ie)X(ke)&&ge.set(ke,_.Event.buffer(ie[ke],!0));return new class{listen(ke,Le,Oe){const q=ge.get(Le);if(q)return q;if(se(Le)){const J=ie[Le];if(typeof J=="function")return J.call(ie,Oe)}throw new Error(`Event not found: ${Le}`)}call(ke,Le,Oe){const q=ie[Le];if(typeof q=="function"){if(!ce&&Array.isArray(Oe))for(let J=0;J<Oe.length;J++)Oe[J]=(0,L.revive)(Oe[J]);return q.apply(ie,Oe)}throw new Error(`Method not found: ${Le}`)}}}V.fromService=U;function H(K,j){const ie=j&&j.disableMarshalling;return new Proxy({},{get(ce,ge){if(typeof ge=="string")return j?.properties?.has(ge)?j.properties.get(ge):se(ge)?function(ke){return K.listen(ge,ke)}:X(ge)?K.listen(ge):async function(...ke){let Le;j&&!(0,l.isUndefinedOrNull)(j.context)?Le=[j.context,...ke]:Le=ke;const Oe=await K.call(ge,Le);return ie?Oe:(0,L.revive)(Oe)};throw new Error(`Property not found: ${String(ge)}`)}})}V.toService=H;function X(K){return K[0]==="o"&&K[1]==="n"&&T.isUpperAsciiLetter(K.charCodeAt(2))}function se(K){return/^onDynamic/.test(K)&&T.isUpperAsciiLetter(K.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){let U=V.toString();if(U!=="[object Object]")return U}return V}function W(V){return Array.isArray(V)?V.map(z):z(V)}function M(V,U,H,X,se,K,j){j=W(j);const ie=O[se],ce=ie[X%ie.length];let ge=[`%c[${V}]%c[${String(U).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${ce}`];/\($/.test(K)?(ge=ge.concat(j),ge.push(")")):ge.push(j),console.log.apply(console,ge)}e.logWithColors=M;class x{constructor(U,H){this._outgoingPrefix=U,this._incomingPrefix=H,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,H,X,se,K){this._totalOutgoing+=U,M(this._outgoingPrefix,this._totalOutgoing,U,H,X,se,K)}logIncoming(U,H,X,se,K){this._totalIncoming+=U,M(this._incomingPrefix,this._totalIncoming,U,H,X,se,K)}}e.IPCLogger=x}),define(we[106],be([0,1,22,3,6,105]),function(Y,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(t){t.enableDiagnostics=!1,t.records=[];const n=new WeakMap;let u=0;function a(b,d){if(!n.has(b)){const D=String(++u);n.set(b,D)}return n.get(b)}function f(b,d,D,R){if(!t.enableDiagnostics)return;const N=a(b,d);if(R instanceof m.VSBuffer||R instanceof Uint8Array||R instanceof ArrayBuffer||ArrayBuffer.isView(R)){const B=m.VSBuffer.alloc(R.byteLength);B.set(R),t.records.push({timestamp:Date.now(),id:N,label:d,type:D,buff:B})}else t.records.push({timestamp:Date.now(),id:N,label:d,type:D,data:R})}t.traceSocketEvent=f})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var _;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(_=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function L(){return I||(I=m.VSBuffer.alloc(0)),I}class T{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,u){if(n===0)return L();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const d=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=n),d}if(this._chunks[0].byteLength>n){const d=this._chunks[0].slice(0,n);return u&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),d}let a=m.VSBuffer.alloc(n),f=0,b=0;for(;n>0;){const d=this._chunks[b];if(d.byteLength>n){const D=d.slice(0,n);a.set(D,f),f+=n,u&&(this._chunks[b]=d.slice(n),this._totalLength-=n),n-=n}else a.set(d,f),f+=d.byteLength,u?(this._chunks.shift(),this._totalLength-=d.byteLength):b++,n-=d.byteLength}return a}}e.ChunkStream=T;var l;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(l||(l={}));function E(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var h;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(n,u,a,f){this.type=n,this.id=u,this.ack=a,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends y.Disposable{constructor(n){super();this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new T,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:E(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,f=this._state.id,b=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",u),this._onMessage.fire(new p(a,f,b,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class A{constructor(n){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=m.VSBuffer.alloc(13);u.writeUInt8(n.type,0),u.writeUInt32BE(n.id,1),u.writeUInt32BE(n.ack,5),u.writeUInt32BE(n.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:E(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",n.data),this._writeSoon(u,n.data)}_bufferAdd(n,u){const a=this._totalLength===0;return this._data.push(n,u),this._totalLength+=n.byteLength+u.byteLength,a}_bufferTake(){const n=m.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,u){this._bufferAdd(n,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const n=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this._socket.write(n)}}class w extends y.Disposable{constructor(n){super();this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new A(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new p(1,0,0,n))}}e.Protocol=w;class s extends C.IPCClient{constructor(n,u,a=null){super(n,u,a);this.protocol=n}static fromSocket(n,u){return new s(new w(n),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=s;class o{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=o;class g{constructor(n){this.data=n,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],u=0,a=this._first;for(;a;)n[u++]=a.data,a=a.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const u=new g(n);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class S{constructor(){this.lastRuns=[];const n=Date.now();for(let u=0;u<S._HISTORY_LENGTH;u++)this.lastRuns[u]=n-1e3*u;setInterval(()=>{for(let u=S._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return S._INSTANCE||(S._INSTANCE=new S),S._INSTANCE}load(){const n=Date.now(),u=(1+S._HISTORY_LENGTH)*1e3;let a=0;for(let f=0;f<S._HISTORY_LENGTH;f++)n-this.lastRuns[f]<=u&&a++;return 1-a/S._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}S._HISTORY_LENGTH=10,S._INSTANCE=null;class r{constructor(n,u=null,a=S.getInstance()){this._onControlMessage=new o,this.onControlMessage=this._onControlMessage.event,this._onMessage=new o,this.onMessage=this._onMessage.event,this._onDidDispose=new o,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new o,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new o,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=n,this._socketWriter=new A(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),u&&this._socketReader.acceptChunk(u)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,y.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new p(5,0,0,L());this._socketWriter.write(n),this._socketWriter.flush()}sendPause(){const n=new p(7,0,0,L());this._socketWriter.write(n)}sendResume(){const n=new p(8,0,0,L());this._socketWriter.write(n)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,u){this._isReconnecting=!0,this._socketDisposables=(0,y.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=n,this._socketWriter=new A(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const n=new p(3,0,this._incomingAckId,L());this._socketWriter.write(n);const u=this._outgoingUnackMsg.toArray();for(let a=0,f=u.length;a<f;a++)this._socketWriter.write(u[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new p(6,0,0,L())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data);break}case 2:{this._onControlMessage.fire(n.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const u=this._outgoingUnackMsg.toArray();for(let a=0,f=u.length;a<f;a++)this._socketWriter.write(u[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new p(1,u,this._incomingAckId,n);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(n){const u=new p(2,0,0,n);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),u=Date.now()-n.writtenTime,a=Date.now()-this._socketReader.lastReadTime,f=Date.now()-this._lastSocketTimeoutTime;if(u>=2e4&&a>=2e4&&f>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const b=Math.max(2e4-u,2e4-a,2e4-f,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},b)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new p(3,0,this._incomingAckId,L());this._socketWriter.write(n)}}e.PersistentProtocol=r}),define(we[107],be([0,1,98]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class i{constructor(k){let _=(0,m.toUint8)(k);this._defaultValue=_,this._asciiMap=i._createAsciiMap(_),this._map=new Map}static _createAsciiMap(k){let _=new Uint8Array(256);for(let I=0;I<256;I++)_[I]=k;return _}set(k,_){let I=(0,m.toUint8)(_);k>=0&&k<256?this._asciiMap[k]=I:this._map.set(k,I)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=i;var y;(function(P){P[P.False=0]="False",P[P.True=1]="True"})(y||(y={}));class C{constructor(){this._actual=new i(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=C}),define(we[143],be([0,1,107]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var i;(function(P){P[P.Regular=0]="Regular",P[P.Whitespace=1]="Whitespace",P[P.WordSeparator=2]="WordSeparator"})(i=e.WordCharacterClass||(e.WordCharacterClass={}));class y extends m.CharacterClassifier{constructor(k){super(0);for(let _=0,I=k.length;_<I;_++)this.set(k.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=y;function C(P){let k={};return _=>(k.hasOwnProperty(_)||(k[_]=P(_)),k[_])}e.getMapForWordSeparators=C(P=>new y(P))}),define(we[49],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(y,C){this.lineNumber=y,this.column=C}with(y=this.lineNumber,C=this.column){return y===this.lineNumber&&C===this.column?this:new m(y,C)}delta(y=0,C=0){return this.with(this.lineNumber+y,this.column+C)}equals(y){return m.equals(this,y)}static equals(y,C){return!y&&!C?!0:!!y&&!!C&&y.lineNumber===C.lineNumber&&y.column===C.column}isBefore(y){return m.isBefore(this,y)}static isBefore(y,C){return y.lineNumber<C.lineNumber?!0:C.lineNumber<y.lineNumber?!1:y.column<C.column}isBeforeOrEqual(y){return m.isBeforeOrEqual(this,y)}static isBeforeOrEqual(y,C){return y.lineNumber<C.lineNumber?!0:C.lineNumber<y.lineNumber?!1:y.column<=C.column}static compare(y,C){let P=y.lineNumber|0,k=C.lineNumber|0;if(P===k){let _=y.column|0,I=C.column|0;return _-I}return P-k}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(y){return new m(y.lineNumber,y.column)}static isIPosition(y){return y&&typeof y.lineNumber=="number"&&typeof y.column=="number"}}e.Position=m}),define(we[41],be([0,1,49]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class i{constructor(C,P,k,_){C>k||C===k&&P>_?(this.startLineNumber=k,this.startColumn=_,this.endLineNumber=C,this.endColumn=P):(this.startLineNumber=C,this.startColumn=P,this.endLineNumber=k,this.endColumn=_)}isEmpty(){return i.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return i.containsPosition(this,C)}static containsPosition(C,P){return!(P.lineNumber<C.startLineNumber||P.lineNumber>C.endLineNumber||P.lineNumber===C.startLineNumber&&P.column<C.startColumn||P.lineNumber===C.endLineNumber&&P.column>C.endColumn)}static strictContainsPosition(C,P){return!(P.lineNumber<C.startLineNumber||P.lineNumber>C.endLineNumber||P.lineNumber===C.startLineNumber&&P.column<=C.startColumn||P.lineNumber===C.endLineNumber&&P.column>=C.endColumn)}containsRange(C){return i.containsRange(this,C)}static containsRange(C,P){return!(P.startLineNumber<C.startLineNumber||P.endLineNumber<C.startLineNumber||P.startLineNumber>C.endLineNumber||P.endLineNumber>C.endLineNumber||P.startLineNumber===C.startLineNumber&&P.startColumn<C.startColumn||P.endLineNumber===C.endLineNumber&&P.endColumn>C.endColumn)}strictContainsRange(C){return i.strictContainsRange(this,C)}static strictContainsRange(C,P){return!(P.startLineNumber<C.startLineNumber||P.endLineNumber<C.startLineNumber||P.startLineNumber>C.endLineNumber||P.endLineNumber>C.endLineNumber||P.startLineNumber===C.startLineNumber&&P.startColumn<=C.startColumn||P.endLineNumber===C.endLineNumber&&P.endColumn>=C.endColumn)}plusRange(C){return i.plusRange(this,C)}static plusRange(C,P){let k,_,I,L;return P.startLineNumber<C.startLineNumber?(k=P.startLineNumber,_=P.startColumn):P.startLineNumber===C.startLineNumber?(k=P.startLineNumber,_=Math.min(P.startColumn,C.startColumn)):(k=C.startLineNumber,_=C.startColumn),P.endLineNumber>C.endLineNumber?(I=P.endLineNumber,L=P.endColumn):P.endLineNumber===C.endLineNumber?(I=P.endLineNumber,L=Math.max(P.endColumn,C.endColumn)):(I=C.endLineNumber,L=C.endColumn),new i(k,_,I,L)}intersectRanges(C){return i.intersectRanges(this,C)}static intersectRanges(C,P){let k=C.startLineNumber,_=C.startColumn,I=C.endLineNumber,L=C.endColumn,T=P.startLineNumber,l=P.startColumn,E=P.endLineNumber,h=P.endColumn;return k<T?(k=T,_=l):k===T&&(_=Math.max(_,l)),I>E?(I=E,L=h):I===E&&(L=Math.min(L,h)),k>I||k===I&&_>L?null:new i(k,_,I,L)}equalsRange(C){return i.equalsRange(this,C)}static equalsRange(C,P){return!!C&&!!P&&C.startLineNumber===P.startLineNumber&&C.startColumn===P.startColumn&&C.endLineNumber===P.endLineNumber&&C.endColumn===P.endColumn}getEndPosition(){return i.getEndPosition(this)}static getEndPosition(C){return new m.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return i.getStartPosition(this)}static getStartPosition(C){return new m.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,P){return new i(this.startLineNumber,this.startColumn,C,P)}setStartPosition(C,P){return new i(C,P,this.endLineNumber,this.endColumn)}collapseToStart(){return i.collapseToStart(this)}static collapseToStart(C){return new i(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,P=C){return new i(C.lineNumber,C.column,P.lineNumber,P.column)}static lift(C){return C?new i(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,P){return!(C.endLineNumber<P.startLineNumber||C.endLineNumber===P.startLineNumber&&C.endColumn<P.startColumn||P.endLineNumber<C.startLineNumber||P.endLineNumber===C.startLineNumber&&P.endColumn<C.startColumn)}static areIntersecting(C,P){return!(C.endLineNumber<P.startLineNumber||C.endLineNumber===P.startLineNumber&&C.endColumn<=P.startColumn||P.endLineNumber<C.startLineNumber||P.endLineNumber===C.startLineNumber&&P.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,P){if(C&&P){const I=C.startLineNumber|0,L=P.startLineNumber|0;if(I===L){const T=C.startColumn|0,l=P.startColumn|0;if(T===l){const E=C.endLineNumber|0,h=P.endLineNumber|0;if(E===h){const p=C.endColumn|0,v=P.endColumn|0;return p-v}return E-h}return T-l}return I-L}return(C?1:0)-(P?1:0)}static compareRangesUsingEnds(C,P){return C.endLineNumber===P.endLineNumber?C.endColumn===P.endColumn?C.startLineNumber===P.startLineNumber?C.startColumn-P.startColumn:C.startLineNumber-P.startLineNumber:C.endColumn-P.endColumn:C.endLineNumber-P.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=i}),define(we[144],be([0,1,49,41]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var y;(function(P){P[P.LTR=0]="LTR",P[P.RTL=1]="RTL"})(y=e.SelectionDirection||(e.SelectionDirection={}));class C extends i.Range{constructor(k,_,I,L){super(k,_,I,L);this.selectionStartLineNumber=k,this.selectionStartColumn=_,this.positionLineNumber=I,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return C.selectionsEqual(this,k)}static selectionsEqual(k,_){return k.selectionStartLineNumber===_.selectionStartLineNumber&&k.selectionStartColumn===_.selectionStartColumn&&k.positionLineNumber===_.positionLineNumber&&k.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,_){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,k,_):new C(k,_,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new m.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,_){return this.getDirection()===0?new C(k,_,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,k,_)}static fromPositions(k,_=k){return new C(k.lineNumber,k.column,_.lineNumber,_.column)}static fromRange(k,_){return _===0?new C(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new C(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new C(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,_){if(k&&!_||!k&&_)return!1;if(!k&&!_)return!0;if(k.length!==_.length)return!1;for(let I=0,L=k.length;I<L;I++)if(!this.selectionsEqual(k[I],_[I]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,_,I,L,T){return T===0?new C(k,_,I,L):new C(I,L,k,_)}}e.Selection=C}),define(we[108],be([0,1,25]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var i;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(i=e.OverviewRulerLane||(e.OverviewRulerLane={}));var y;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(y=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class _{constructor(v){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,v.tabSize|0),this.indentSize=v.tabSize|0,this.insertSpaces=Boolean(v.insertSpaces),this.defaultEOL=v.defaultEOL|0,this.trimAutoWhitespace=Boolean(v.trimAutoWhitespace),this.bracketPairColorizationOptions=v.bracketPairColorizationOptions}equals(v){return this.tabSize===v.tabSize&&this.indentSize===v.indentSize&&this.insertSpaces===v.insertSpaces&&this.defaultEOL===v.defaultEOL&&this.trimAutoWhitespace===v.trimAutoWhitespace&&(0,m.equals)(this.bracketPairColorizationOptions,v.bracketPairColorizationOptions)}createChangeEvent(v){return{tabSize:this.tabSize!==v.tabSize,indentSize:this.indentSize!==v.indentSize,insertSpaces:this.insertSpaces!==v.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==v.trimAutoWhitespace}}}e.TextModelResolvedOptions=_;class I{constructor(v,A){this._findMatchBrand=void 0,this.range=v,this.matches=A}}e.FindMatch=I;var L;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(L=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var T;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None"})(T=e.PositionAffinity||(e.PositionAffinity={}));var l;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(l=e.ModelConstants||(e.ModelConstants={}));class E{constructor(v,A,w,s,o,g){this.identifier=v,this.range=A,this.text=w,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=o,this._isTracked=g}}e.ValidAnnotatedEditOperation=E;class h{constructor(v,A,w){this.reverseEdits=v,this.changes=A,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=h}),define(we[145],be([0,1,8,143,49,41,108]),function(Y,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class _{constructor(s,o,g,c){this.searchString=s,this.isRegex=o,this.matchCase=g,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let s;this.isRegex?s=I(this.searchString):s=this.searchString.indexOf(`
`)>=0;let o=null;try{o=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:s,global:!0,unicode:!0})}catch{return null}if(!o)return null;let g=!this.isRegex&&!s;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new L(o,this.wordSeparators?(0,i.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=_;function I(w){if(!w||w.length===0)return!1;for(let s=0,o=w.length;s<o;s++)if(w.charCodeAt(s)===92){if(s++,s>=o)break;const c=w.charCodeAt(s);if(c===110||c===114||c===87)return!0}return!1}e.isMultilineRegexSource=I;class L{constructor(s,o,g){this.regex=s,this.wordSeparators=o,this.simpleSearch=g}}e.SearchData=L;function T(w,s,o){if(!o)return new P.FindMatch(w,null);let g=[];for(let c=0,S=s.length;c<S;c++)g[c]=s[c];return new P.FindMatch(w,g)}e.createFindMatch=T;class l{constructor(s){let o=[],g=0;for(let c=0,S=s.length;c<S;c++)s.charCodeAt(c)===10&&(o[g++]=c);this._lineFeedsOffsets=o}findLineFeedCountBeforeOffset(s){const o=this._lineFeedsOffsets;let g=0,c=o.length-1;if(c===-1||s<=o[0])return 0;for(;g<c;){const S=g+((c-g)/2>>0);o[S]>=s?c=S-1:o[S+1]>=s?(g=S,c=S):g=S+1}return g+1}}class E{static findMatches(s,o,g,c,S){const r=o.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(s,g,new A(r.wordSeparators,r.regex),c,S):this._doFindMatchesLineByLine(s,g,r,c,S):[]}static _getMultilineMatchRange(s,o,g,c,S,r){let t,n=0;c?(n=c.findLineFeedCountBeforeOffset(S),t=o+S+n):t=o+S;let u;if(c){let d=c.findLineFeedCountBeforeOffset(S+r.length)-n;u=t+r.length+d}else u=t+r.length;const a=s.getPositionAt(t),f=s.getPositionAt(u);return new C.Range(a.lineNumber,a.column,f.lineNumber,f.column)}static _doFindMatchesMultiline(s,o,g,c,S){const r=s.getOffsetAt(o.getStartPosition()),t=s.getValueInRange(o,1),n=s.getEOL()===`\r
`?new l(t):null,u=[];let a=0,f;for(g.reset(0);f=g.next(t);)if(u[a++]=T(this._getMultilineMatchRange(s,r,t,n,f.index,f[0]),f,c),a>=S)return u;return u}static _doFindMatchesLineByLine(s,o,g,c,S){const r=[];let t=0;if(o.startLineNumber===o.endLineNumber){const u=s.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return t=this._findMatchesInLine(g,u,o.startLineNumber,o.startColumn-1,t,r,c,S),r}const n=s.getLineContent(o.startLineNumber).substring(o.startColumn-1);t=this._findMatchesInLine(g,n,o.startLineNumber,o.startColumn-1,t,r,c,S);for(let u=o.startLineNumber+1;u<o.endLineNumber&&t<S;u++)t=this._findMatchesInLine(g,s.getLineContent(u),u,0,t,r,c,S);if(t<S){const u=s.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);t=this._findMatchesInLine(g,u,o.endLineNumber,0,t,r,c,S)}return r}static _findMatchesInLine(s,o,g,c,S,r,t,n){const u=s.wordSeparators;if(!t&&s.simpleSearch){const b=s.simpleSearch,d=b.length,D=o.length;let R=-d;for(;(R=o.indexOf(b,R+d))!==-1;)if((!u||v(u,o,D,R,d))&&(r[S++]=new P.FindMatch(new C.Range(g,R+1+c,g,R+1+d+c),null),S>=n))return S;return S}const a=new A(s.wordSeparators,s.regex);let f;a.reset(0);do if(f=a.next(o),f&&(r[S++]=T(new C.Range(g,f.index+1+c,g,f.index+1+f[0].length+c),f,t),S>=n))return S;while(f);return S}static findNextMatch(s,o,g,c){const S=o.parseSearchRequest();if(!S)return null;const r=new A(S.wordSeparators,S.regex);return S.regex.multiline?this._doFindNextMatchMultiline(s,g,r,c):this._doFindNextMatchLineByLine(s,g,r,c)}static _doFindNextMatchMultiline(s,o,g,c){const S=new y.Position(o.lineNumber,1),r=s.getOffsetAt(S),t=s.getLineCount(),n=s.getValueInRange(new C.Range(S.lineNumber,S.column,t,s.getLineMaxColumn(t)),1),u=s.getEOL()===`\r
`?new l(n):null;g.reset(o.column-1);let a=g.next(n);return a?T(this._getMultilineMatchRange(s,r,n,u,a.index,a[0]),a,c):o.lineNumber!==1||o.column!==1?this._doFindNextMatchMultiline(s,new y.Position(1,1),g,c):null}static _doFindNextMatchLineByLine(s,o,g,c){const S=s.getLineCount(),r=o.lineNumber,t=s.getLineContent(r),n=this._findFirstMatchInLine(g,t,r,o.column,c);if(n)return n;for(let u=1;u<=S;u++){const a=(r+u-1)%S,f=s.getLineContent(a+1),b=this._findFirstMatchInLine(g,f,a+1,1,c);if(b)return b}return null}static _findFirstMatchInLine(s,o,g,c,S){s.reset(c-1);const r=s.next(o);return r?T(new C.Range(g,r.index+1,g,r.index+1+r[0].length),r,S):null}static findPreviousMatch(s,o,g,c){const S=o.parseSearchRequest();if(!S)return null;const r=new A(S.wordSeparators,S.regex);return S.regex.multiline?this._doFindPreviousMatchMultiline(s,g,r,c):this._doFindPreviousMatchLineByLine(s,g,r,c)}static _doFindPreviousMatchMultiline(s,o,g,c){const S=this._doFindMatchesMultiline(s,new C.Range(1,1,o.lineNumber,o.column),g,c,10*k);if(S.length>0)return S[S.length-1];const r=s.getLineCount();return o.lineNumber!==r||o.column!==s.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(s,new y.Position(r,s.getLineMaxColumn(r)),g,c):null}static _doFindPreviousMatchLineByLine(s,o,g,c){const S=s.getLineCount(),r=o.lineNumber,t=s.getLineContent(r).substring(0,o.column-1),n=this._findLastMatchInLine(g,t,r,c);if(n)return n;for(let u=1;u<=S;u++){const a=(S+r-u-1)%S,f=s.getLineContent(a+1),b=this._findLastMatchInLine(g,f,a+1,c);if(b)return b}return null}static _findLastMatchInLine(s,o,g,c){let S=null,r;for(s.reset(0);r=s.next(o);)S=T(new C.Range(g,r.index+1,g,r.index+1+r[0].length),r,c);return S}}e.TextModelSearch=E;function h(w,s,o,g,c){if(g===0)return!0;const S=s.charCodeAt(g-1);if(w.get(S)!==0||S===13||S===10)return!0;if(c>0){const r=s.charCodeAt(g);if(w.get(r)!==0)return!0}return!1}function p(w,s,o,g,c){if(g+c===o)return!0;const S=s.charCodeAt(g+c);if(w.get(S)!==0||S===13||S===10)return!0;if(c>0){const r=s.charCodeAt(g+c-1);if(w.get(r)!==0)return!0}return!1}function v(w,s,o,g,c){return h(w,s,o,g,c)&&p(w,s,o,g,c)}e.isValidMatch=v;class A{constructor(s,o){this._wordSeparators=s,this._searchRegex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(s){this._searchRegex.lastIndex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(s){const o=s.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===o||(g=this._searchRegex.exec(s),!g))return null;const c=g.index,S=g[0].length;if(c===this._prevMatchStartIndex&&S===this._prevMatchLength){if(S===0){m.getNextCodePoint(s,o,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=c,this._prevMatchLength=S,!this._wordSeparators||v(this._wordSeparators,s,o,c,S))return g}while(g);return null}}e.Searcher=A}),define(we[109],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(k=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const I of e.USUAL_WORD_SEPARATORS)k.indexOf(I)>=0||(_+="\\"+I);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=m();function i(k){let _=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)_=k;else{let I="g";k.ignoreCase&&(I+="i"),k.multiline&&(I+="m"),k.unicode&&(I+="u"),_=new RegExp(k.source,I)}return _.lastIndex=0,_}e.ensureValidWordDefinition=i;const y={maxLen:1e3,windowSize:15,timeBudget:150};function C(k,_,I,L,T=y){if(I.length>T.maxLen){let v=k-T.maxLen/2;return v<0?v=0:L+=v,I=I.substring(v,k+T.maxLen/2),C(k,_,I,L,T)}const l=Date.now(),E=k-1-L;let h=-1,p=null;for(let v=1;!(Date.now()-l>=T.timeBudget);v++){const A=E-T.windowSize*v;_.lastIndex=Math.max(0,A);const w=P(_,I,E,h);if(!w&&p||(p=w,A<=0))break;h=A}if(p){let v={word:p[0],startColumn:L+1+p.index,endColumn:L+1+p.index+p[0].length};return _.lastIndex=0,v}return null}e.getWordAtText=C;function P(k,_,I,L){let T;for(;T=k.exec(_);){const l=T.index||0;if(l<=I&&k.lastIndex>=I)return T;if(L>0&&l>L)return null}return null}}),define(we[146],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class i{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(k.notIn))for(let _=0,I=k.notIn.length;_<I;_++)switch(k.notIn[_]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(k){switch(k){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(k,_){if(k.getTokenCount()===0)return!0;const I=k.findTokenIndexAtOffset(_-2),L=k.getStandardTokenType(I);return this.isOK(L)}_findNeutralCharacterInRange(k,_){for(let I=k;I<=_;I++){const L=String.fromCharCode(I);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=i;class y{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of k)C(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),C(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),C(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),C(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&C(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=y;function C(P,k,_){P.has(k)?P.get(k).push(_):P.set(k,[_])}}),define(we[82],be([0,1,31,9]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(C,P,k,_){if(Array.isArray(C)){let I=0;for(const L of C){const T=y(L,P,k,_);if(T===10)return T;T>I&&(I=T)}return I}else{if(typeof C=="string")return _?C==="*"?5:C===k?10:0:0;if(C){const{language:I,pattern:L,scheme:T,hasAccessToAllModels:l}=C;if(!_&&!l)return 0;let E=0;if(T)if(T===P.scheme)E=10;else if(T==="*")E=5;else return 0;if(I)if(I===k)E=10;else if(I==="*")E=Math.max(E,5);else return 0;if(L){let h;if(typeof L=="string"?h=L:h={...L,base:(0,i.normalize)(L.base)},h===P.fsPath||(0,m.match)(h,P.fsPath))E=10;else return 0}return E}else return 0}}e.score=y}),define(we[147],be([0,1,107]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var i;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(i=e.State||(e.State={}));class y{constructor(h,p,v){const A=new Uint8Array(h*p);for(let w=0,s=h*p;w<s;w++)A[w]=v;this._data=A,this.rows=h,this.cols=p}get(h,p){return this._data[h*this.cols+p]}set(h,p,v){this._data[h*this.cols+p]=v}}e.Uint8Matrix=y;class C{constructor(h){let p=0,v=0;for(let w=0,s=h.length;w<s;w++){let[o,g,c]=h[w];g>p&&(p=g),o>v&&(v=o),c>v&&(v=c)}p++,v++;let A=new y(v,p,0);for(let w=0,s=h.length;w<s;w++){let[o,g,c]=h[w];A.set(o,g,c)}this._states=A,this._maxCharCode=p}nextState(h,p){return p<0||p>=this._maxCharCode?0:this._states.get(h,p)}}e.StateMachine=C;let P=null;function k(){return P===null&&(P=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),P}var _;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let I=null;function L(){if(I===null){I=new m.CharacterClassifier(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<E.length;p++)I.set(E.charCodeAt(p),1);const h=".,;";for(let p=0;p<h.length;p++)I.set(h.charCodeAt(p),2)}return I}class T{static _createLink(h,p,v,A,w){let s=w-1;do{const o=p.charCodeAt(s);if(h.get(o)!==2)break;s--}while(s>A);if(A>0){const o=p.charCodeAt(A-1),g=p.charCodeAt(s);(o===40&&g===41||o===91&&g===93||o===123&&g===125)&&s--}return{range:{startLineNumber:v,startColumn:A+1,endLineNumber:v,endColumn:s+2},url:p.substring(A,s+1)}}static computeLinks(h,p=k()){const v=L();let A=[];for(let w=1,s=h.getLineCount();w<=s;w++){const o=h.getLineContent(w),g=o.length;let c=0,S=0,r=0,t=1,n=!1,u=!1,a=!1,f=!1;for(;c<g;){let b=!1;const d=o.charCodeAt(c);if(t===13){let D;switch(d){case 40:n=!0,D=0;break;case 41:D=n?0:1;break;case 91:a=!0,u=!0,D=0;break;case 93:a=!1,D=u?0:1;break;case 123:f=!0,D=0;break;case 125:D=f?0:1;break;case 39:D=r===34||r===96?0:1;break;case 34:D=r===39||r===96?0:1;break;case 96:D=r===39||r===34?0:1;break;case 42:D=r===42?1:0;break;case 124:D=r===124?1:0;break;case 32:D=a?0:1;break;default:D=v.get(d)}D===1&&(A.push(T._createLink(v,o,w,S,c)),b=!0)}else if(t===12){let D;d===91?(u=!0,D=0):D=v.get(d),D===1?b=!0:t=13}else t=p.nextState(t,d),t===0&&(b=!0);b&&(t=1,n=!1,u=!1,f=!1,S=c+1,r=d),c++}t===13&&A.push(T._createLink(v,o,w,S,g))}return A}}e.LinkComputer=T;function l(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:T.computeLinks(E)}e.computeLinks=l}),define(we[148],be([0,1,3,6]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class y{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(P){this._onDidChange.fire({changedLanguages:P,changedColorMap:!1})}register(P,k){return this._map.set(P,k),this.fire([P]),(0,i.toDisposable)(()=>{this._map.get(P)===k&&(this._map.delete(P),this.fire([P]))})}registerPromise(P,k){let _=null,I=!1;return this._promises.set(P,k.then(L=>{this._promises.delete(P),!(I||!L)&&(_=this.register(P,L))})),(0,i.toDisposable)(()=>{I=!0,_&&_.dispose()})}getPromise(P){const k=this.get(P);if(k)return Promise.resolve(k);const _=this._promises.get(P);return _?_.then(I=>this.get(P)):null}get(P){return this._map.get(P)||null}setColorMap(P){this._colorMap=P,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=y}),define(we[110],be([0,1,22,12]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(T){T[T.Full=1]="Full",T[T.Delta=2]="Delta"})(y||(y={}));function C(T){for(let l=0,E=T.length;l<E;l+=4){const h=T[l+0],p=T[l+1],v=T[l+2],A=T[l+3];T[l+0]=A,T[l+1]=v,T[l+2]=p,T[l+3]=h}}function P(T){const l=new Uint8Array(T.buffer,T.byteOffset,T.length*4);return i.isLittleEndian()||C(l),m.VSBuffer.wrap(l)}function k(T){const l=T.buffer;if(i.isLittleEndian()||C(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const E=new Uint8Array(l.byteLength);return E.set(l),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function _(T){const l=new Uint32Array(I(T));let E=0;if(l[E++]=T.id,T.type==="full")l[E++]=1,l[E++]=T.data.length,l.set(T.data,E),E+=T.data.length;else{l[E++]=2,l[E++]=T.deltas.length;for(const h of T.deltas)l[E++]=h.start,l[E++]=h.deleteCount,h.data?(l[E++]=h.data.length,l.set(h.data,E),E+=h.data.length):l[E++]=0}return P(l)}e.encodeSemanticTokensDto=_;function I(T){let l=0;if(l+=1+1,T.type==="full")l+=1+T.data.length;else{l+=1,l+=(1+1+1)*T.deltas.length;for(const E of T.deltas)E.data&&(l+=E.data.length)}return l}function L(T){const l=k(T);let E=0;const h=l[E++];if(l[E++]===1){const w=l[E++],s=l.subarray(E,E+w);return E+=w,{id:h,type:"full",data:s}}const v=l[E++];let A=[];for(let w=0;w<v;w++){const s=l[E++],o=l[E++],g=l[E++];let c;g>0&&(c=l.subarray(E,E+g),E+=g),A[w]={start:s,deleteCount:o,data:c}}return{id:h,type:"delta",deltas:A}}e.decodeSemanticTokensDto=L}),define(we[111],be([0,1,16,98]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class y{constructor(_){this.values=_,this.prefixSum=new Uint32Array(_.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(_,I){_=(0,i.toUint32)(_);const L=this.values,T=this.prefixSum,l=I.length;return l===0?!1:(this.values=new Uint32Array(L.length+l),this.values.set(L.subarray(0,_),0),this.values.set(L.subarray(_),_+l),this.values.set(I,_),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(_,I){return _=(0,i.toUint32)(_),I=(0,i.toUint32)(I),this.values[_]===I?!1:(this.values[_]=I,_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),!0)}removeValues(_,I){_=(0,i.toUint32)(_),I=(0,i.toUint32)(I);const L=this.values,T=this.prefixSum;if(_>=L.length)return!1;let l=L.length-_;return I>=l&&(I=l),I===0?!1:(this.values=new Uint32Array(L.length-I),this.values.set(L.subarray(0,_),0),this.values.set(L.subarray(_+I),_),this.prefixSum=new Uint32Array(this.values.length),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(_){return _<0?0:(_=(0,i.toUint32)(_),this._getPrefixSum(_))}_getPrefixSum(_){if(_<=this.prefixSumValidIndex[0])return this.prefixSum[_];let I=this.prefixSumValidIndex[0]+1;I===0&&(this.prefixSum[0]=this.values[0],I++),_>=this.values.length&&(_=this.values.length-1);for(let L=I;L<=_;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],_),this.prefixSum[_]}getIndexOf(_){_=Math.floor(_),this.getTotalSum();let I=0,L=this.values.length-1,T=0,l=0,E=0;for(;I<=L;)if(T=I+(L-I)/2|0,l=this.prefixSum[T],E=l-this.values[T],_<E)L=T-1;else if(_>=l)I=T+1;else break;return new P(T,_-E)}}e.PrefixSumComputer=y;class C{constructor(_){this._values=_,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(_){return this._ensureValid(),_===0?0:this._prefixSum[_-1]}getIndexOf(_){this._ensureValid();const I=this._indexBySum[_],L=I>0?this._prefixSum[I-1]:0;return new P(I,_-L)}removeValues(_,I){this._values.splice(_,I),this._invalidate(_)}insertValues(_,I){this._values=(0,m.arrayInsert)(this._values,_,I),this._invalidate(_)}_invalidate(_){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,_-1)}_ensureValid(){if(!this._isValid){for(let _=this._validEndIndex+1,I=this._values.length;_<I;_++){const L=this._values[_],T=_>0?this._prefixSum[_-1]:0;this._prefixSum[_]=T+L;for(let l=0;l<L;l++)this._indexBySum[T+l]=_}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(_,I){this._values[_]!==I&&(this._values[_]=I,this._invalidate(_))}}e.ConstantTimePrefixSumComputer=C;class P{constructor(_,I){this.index=_,this.remainder=I,this._prefixSumIndexOfResultBrand=void 0,this.index=_,this.remainder=I}}e.PrefixSumIndexOfResult=P}),define(we[149],be([0,1,8,49,111]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(k,_,I,L){this._uri=k,this._lines=_,this._eol=I,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const _=k.changes;for(const I of _)this._acceptDeleteRange(I.range),this._acceptInsertText(new i.Position(I.range.startLineNumber,I.range.startColumn),I.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,_=this._lines.length,I=new Uint32Array(_);for(let L=0;L<_;L++)I[L]=this._lines[L].length+k;this._lineStarts=new y.PrefixSumComputer(I)}}_setLineText(k,_){this._lines[k]=_,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,_){if(_.length===0)return;let I=(0,m.splitLines)(_);if(I.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+I[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}I[I.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+I[0]);let L=new Uint32Array(I.length-1);for(let T=1;T<I.length;T++)this._lines.splice(k.lineNumber+T-1,0,I[T]),L[T-1]=I[T].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,L)}}e.MirrorTextModel=C}),define(we[150],be([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(we[151],be([0,1,150]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,y=i*60,C=y*24,P=C*7,k=C*30,_=C*365;function I(T,l){typeof T!="number"&&(T=T.getTime());const E=Math.round((new Date().getTime()-T)/1e3);if(E<-30)return(0,m.localize)(0,null,I(new Date().getTime()+E*1e3,!1));if(E<30)return(0,m.localize)(1,null);let h;return E<i?(h=E,l?h===1?(0,m.localize)(2,null,h):(0,m.localize)(3,null,h):h===1?(0,m.localize)(4,null,h):(0,m.localize)(5,null,h)):E<y?(h=Math.floor(E/i),l?h===1?(0,m.localize)(6,null,h):(0,m.localize)(7,null,h):h===1?(0,m.localize)(8,null,h):(0,m.localize)(9,null,h)):E<C?(h=Math.floor(E/y),l?h===1?(0,m.localize)(10,null,h):(0,m.localize)(11,null,h):h===1?(0,m.localize)(12,null,h):(0,m.localize)(13,null,h)):E<P?(h=Math.floor(E/C),l?h===1?(0,m.localize)(14,null,h):(0,m.localize)(15,null,h):h===1?(0,m.localize)(16,null,h):(0,m.localize)(17,null,h)):E<k?(h=Math.floor(E/P),l?h===1?(0,m.localize)(18,null,h):(0,m.localize)(19,null,h):h===1?(0,m.localize)(20,null,h):(0,m.localize)(21,null,h)):E<_?(h=Math.floor(E/k),l?h===1?(0,m.localize)(22,null,h):(0,m.localize)(23,null,h):h===1?(0,m.localize)(24,null,h):(0,m.localize)(25,null,h)):(h=Math.floor(E/_),l?h===1?(0,m.localize)(26,null,h):(0,m.localize)(27,null,h):h===1?(0,m.localize)(28,null,h):(0,m.localize)(29,null,h))}e.fromNow=I;function L(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(we[152],be([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(we[50],be([0,1,16,13,152]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(I,L){return L&&(I.stack||I.stacktrace)?y.localize(0,null,k(I),P(I.stack)||P(I.stacktrace)):k(I)}function P(I){return Array.isArray(I)?I.join(`
`):I}function k(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?y.localize(1,null,I.message):I.message||y.localize(2,null)}function _(I=null,L=!1){if(!I)return y.localize(3,null);if(Array.isArray(I)){const T=m.coalesce(I),l=_(T[0],L);return T.length>1?y.localize(4,null,l,T.length):l}if(i.isString(I))return I;if(I.detail){const T=I.detail;if(T.error)return C(T.error,L);if(T.exception)return C(T.exception,L)}return I.stack?C(I,L):I.message?I.message:y.localize(5,null)}e.toErrorMessage=_}),define(we[153],be([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(we[112],be([0,1,37,30,10,25,9,12,40,94,13,142,28,153]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function h(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function p(c,S){if(k.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};S&&(r.cwd=S);const t=m.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],r);return new Promise(n=>{t.once("error",u=>{n({success:!1,error:u})}),t.once("exit",(u,a)=>{n(u===0?{success:!0}:{success:!1,code:u!==null?u:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?h(r.status):1})}else if(k.isLinux||k.isMacintosh)try{const r=y.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(t=>{m.execFile(r,[c.pid.toString()],{encoding:"utf8",shell:!0},(n,u,a)=>{t(n?{success:!1,error:n}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function v(c){!c||(delete c.DEBUG,k.isMacintosh&&delete c.DYLD_LIBRARY_PATH,k.isLinux&&delete c.LD_PRELOAD)}e.removeDangerousEnvVariables=v;function A(c=_.env){return c.comspec||"cmd.exe"}e.getWindowsShell=A;class w{constructor(S,r,t,n){if(r!==void 0&&t!==void 0&&n!==void 0)this.cmd=S,this.args=r,this.shell=t,this.options=n;else{const u=S;this.cmd=u.command,this.shell=u.isShellCommand,this.args=u.args.slice(0),this.options=u.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const u=Object.create(null);Object.keys(_.env).forEach(a=>{u[a]=_.env[a]}),Object.keys(this.options.env).forEach(a=>{u[a]=this.options.env[a]}),this.options.env=u}}getSanitizedCommand(){let S=this.cmd.toLowerCase();const r=S.lastIndexOf(P.sep);return r!==-1&&(S=S.substring(r+1)),w.WellKnowCommands[S]?S:"other"}start(S){return k.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(_.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(r=>{let t,n;const u=new Promise((a,f)=>{t=a,n=f});if(r){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=m.exec(a,this.options,(f,b,d)=>{this.childProcess=null;const D=f;D&&D.killed?n({killed:this.terminateRequested,stdout:b.toString(),stderr:d.toString()}):this.handleExec(t,S,f,b,d)})}else{let a=null;const f=b=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(b,t,S,n);const d={terminated:this.terminateRequested};L.isNumber(b)&&(d.cmdCode=b),t(d)};if(this.shell&&k.isWindows){const b=C.deepClone(this.options);b.windowsVerbatimArguments=!0,b.detached=!1;let d=!1,D=!1;const R=[];let N=this.ensureQuotes(this.cmd);R.push(N.value),d=N.quoted,this.args&&this.args.forEach(F=>{N=this.ensureQuotes(F),R.push(N.value),D=D&&N.quoted});const B=["/s","/c"];d?D?B.push('"'+R.join(" ")+'"'):R.length>1?B.push('"'+R[0]+'" '+R.slice(1).join(" ")):B.push('"'+R[0]+'"'):B.push(R.join(" ")),a=m.spawn(A(),B,b)}else this.cmd&&(a=m.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(L.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",b=>{this.childProcess=null,n({terminated:this.terminateRequested,error:b})}),a.pid&&(this.childProcess.on("close",f),this.handleSpawn(a,t,S,n,!0)))}return u})}handleClose(S,r,t,n){}ensureQuotes(S){return w.regexp.test(S)?{value:'"'+S+'"',quoted:!0}:{value:S,quoted:S.length>0&&S[0]==='"'&&S[S.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(S=>S.pid,S=>-1):new Promise(S=>{this.pidResolve=S})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(S=>(this.terminateRequested=!0,p(S,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),S=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(S=>{if(!this.shell||!k.isWindows)return S(!1);const r=m.spawn(A(),["/s","/c"]);r.on("error",t=>S(!0)),r.on("exit",t=>S(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class s extends w{constructor(S,r,t,n){super(S,r,t,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(S,r,t,n,u){[n,u].forEach((a,f)=>{const b=new T.LineDecoder;b.write(a).forEach(R=>{r({line:R,source:f===0?0:1})});const D=b.end();D&&r({line:D,source:f===0?0:1})}),S({terminated:this.terminateRequested,error:t})}handleSpawn(S,r,t,n,u){const a=new T.LineDecoder,f=new T.LineDecoder;S.stdout.on("data",b=>{a.write(b).forEach(D=>t({line:D,source:0}))}),S.stderr.on("data",b=>{f.write(b).forEach(D=>t({line:D,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=f}handleClose(S,r,t,n){const u=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;u&&t({line:u,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&t({line:a,source:1})}}e.LineProcess=s;function o(c){let S=[],r=!1;const t=function(n){if(r){S.push(n);return}(!c.send(n,a=>{if(a&&console.error(a),r=!1,S.length>0){const f=S.slice(0);S=[],f.forEach(b=>t(b))}})||k.isWindows)&&(r=!0)};return{send:t}}e.createQueuedSender=o;var g;(function(c){async function S(r,t,n){if(P.isAbsolute(r))return r;if(t===void 0&&(t=_.cwd()),P.dirname(r)!=="."||(n===void 0&&L.isString(_.env.PATH)&&(n=_.env.PATH.split(P.delimiter)),n===void 0||n.length===0))return P.join(t,r);async function a(f){if(await l.Promises.exists(f)){let b;try{b=await l.Promises.stat(f)}catch(d){d.message.startsWith("EACCES")&&(b=await l.Promises.lstat(f))}return b?!b.isDirectory():!1}return!1}for(let f of n){let b;if(P.isAbsolute(f)?b=P.join(f,r):b=P.join(t,f,r),await a(b))return b;let d=b+".com";if(await a(d)||(d=b+".exe",await a(d)))return d}return P.join(t,r)}c.findExecutable=S})(g=e.win32||(e.win32={}))}),define(we[154],be([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(we[113],be([0,1,154,12,109,16,25]),function(Y,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(k=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class _{constructor(ne){this._values=ne}hasChanged(ne){return this._values[ne]}}e.ConfigurationChangedEvent=_;class I{constructor(){this._values=[]}_read(ne){return this._values[ne]}get(ne){return this._values[ne]}_write(ne,ve){this._values[ne]=ve}}e.ValidatedEditorOptions=I;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class T{constructor(ne,ve,te,_e){this.id=ne,this.name=ve,this.defaultValue=te,this.schema=_e}applyUpdate(ne,ve){return E(ne,ve)}compute(ne,ve,te){return te}}class l{constructor(ne,ve){this.newValue=ne,this.didChange=ve}}e.ApplyUpdateResult=l;function E(Z,ne){if(typeof Z!="object"||typeof ne!="object"||!Z||!ne)return new l(ne,Z!==ne);if(Array.isArray(Z)||Array.isArray(ne)){const te=Array.isArray(Z)&&Array.isArray(ne)&&C.equals(Z,ne);return new l(ne,te)}let ve=!1;for(let te in ne)if(ne.hasOwnProperty(te)){const _e=E(Z[te],ne[te]);_e.didChange&&(Z[te]=_e.newValue,ve=!0)}return new l(Z,ve)}class h{constructor(ne){this.schema=void 0,this.id=ne,this.name="_never_",this.defaultValue=void 0}applyUpdate(ne,ve){return E(ne,ve)}validate(ne){return this.defaultValue}}class p{constructor(ne,ve,te,_e){this.id=ne,this.name=ve,this.defaultValue=te,this.schema=_e}applyUpdate(ne,ve){return E(ne,ve)}validate(ne){return typeof ne=="undefined"?this.defaultValue:ne}compute(ne,ve,te){return te}}function v(Z,ne){return typeof Z=="undefined"?ne:Z==="false"?!1:Boolean(Z)}e.boolean=v;class A extends p{constructor(ne,ve,te,_e=void 0){typeof _e!="undefined"&&(_e.type="boolean",_e.default=te);super(ne,ve,te,_e)}validate(ne){return v(ne,this.defaultValue)}}function w(Z,ne,ve,te){if(typeof Z=="undefined")return ne;let _e=parseInt(Z,10);return isNaN(_e)?ne:(_e=Math.max(ve,_e),_e=Math.min(te,_e),_e|0)}e.clampedInt=w;class s extends p{constructor(ne,ve,te,_e,Me,Be=void 0){typeof Be!="undefined"&&(Be.type="integer",Be.default=te,Be.minimum=_e,Be.maximum=Me);super(ne,ve,te,Be);this.minimum=_e,this.maximum=Me}static clampedInt(ne,ve,te,_e){return w(ne,ve,te,_e)}validate(ne){return s.clampedInt(ne,this.defaultValue,this.minimum,this.maximum)}}class o extends p{constructor(ne,ve,te,_e,Me){typeof Me!="undefined"&&(Me.type="number",Me.default=te);super(ne,ve,te,Me);this.validationFn=_e}static clamp(ne,ve,te){return ne<ve?ve:ne>te?te:ne}static float(ne,ve){if(typeof ne=="number")return ne;if(typeof ne=="undefined")return ve;const te=parseFloat(ne);return isNaN(te)?ve:te}validate(ne){return this.validationFn(o.float(ne,this.defaultValue))}}class g extends p{static string(ne,ve){return typeof ne!="string"?ve:ne}constructor(ne,ve,te,_e=void 0){typeof _e!="undefined"&&(_e.type="string",_e.default=te);super(ne,ve,te,_e)}validate(ne){return g.string(ne,this.defaultValue)}}function c(Z,ne,ve){return typeof Z!="string"||ve.indexOf(Z)===-1?ne:Z}e.stringSet=c;class S extends p{constructor(ne,ve,te,_e,Me=void 0){typeof Me!="undefined"&&(Me.type="string",Me.enum=_e,Me.default=te);super(ne,ve,te,Me);this._allowedValues=_e}validate(ne){return c(ne,this.defaultValue,this._allowedValues)}}class r extends T{constructor(ne,ve,te,_e,Me,Be,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="string",Xe.enum=Me,Xe.default=_e);super(ne,ve,te,Xe);this._allowedValues=Me,this._convert=Be}validate(ne){return typeof ne!="string"?this.defaultValue:this._allowedValues.indexOf(ne)===-1?this.defaultValue:this._convert(ne)}}function t(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(ne){switch(ne){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ne,ve,te){return te===0?ne.accessibilitySupport:te}}class u extends T{constructor(){const ne={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ne,{"editor.comments.insertSpace":{type:"boolean",default:ne.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ne.ignoreEmptyLines,description:m.localize(5,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{insertSpace:v(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:v(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var a;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(a=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function f(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var b;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(b=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function d(Z){switch(Z){case b.Line:return"line";case b.Block:return"block";case b.Underline:return"underline";case b.LineThin:return"line-thin";case b.BlockOutline:return"block-outline";case b.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=d;function D(Z){switch(Z){case"line":return b.Line;case"block":return b.Block;case"underline":return b.Underline;case"line-thin":return b.LineThin;case"block-outline":return b.BlockOutline;case"underline-thin":return b.UnderlineThin}}class R extends h{constructor(){super(127)}compute(ne,ve,te){const _e=["monaco-editor"];return ve.get(33)&&_e.push(ve.get(33)),ne.extraEditorClassName&&_e.push(ne.extraEditorClassName),ve.get(65)==="default"?_e.push("mouse-default"):ve.get(65)==="copy"&&_e.push("mouse-copy"),ve.get(99)&&_e.push("showUnused"),ve.get(125)&&_e.push("showDeprecated"),_e.join(" ")}}class N extends A{constructor(){super(32,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(ne,ve,te){return te&&ne.emptySelectionClipboard}}class B extends T{constructor(){const ne={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ne,{"editor.find.cursorMoveOnType":{type:"boolean",default:ne.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ne.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ne.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ne.globalFindClipboard,description:m.localize(16,null),included:i.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ne.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:ne.loop,description:m.localize(18,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{cursorMoveOnType:v(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ne.seedSearchStringFromSelection=="boolean"?ne.seedSearchStringFromSelection?"always":"never":c(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ne.autoFindInSelection=="boolean"?ne.autoFindInSelection?"always":"never":c(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:v(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:v(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:v(ve.loop,this.defaultValue.loop)}}}class F extends T{constructor(){super(44,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(ne){return typeof ne=="undefined"?this.defaultValue:typeof ne=="string"?ne==="false"?F.OFF:ne==="true"?F.ON:ne:Boolean(ne)?F.ON:F.OFF}}e.EditorFontLigatures=F,F.OFF='"liga" off, "calt" off',F.ON='"liga" on, "calt" on';class O extends h{constructor(){super(43)}compute(ne,ve,te){return ne.fontInfo}}class z extends p{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(22,null)})}validate(ne){let ve=o.float(ne,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(ve,6,100)}compute(ne,ve,te){return ne.fontInfo.fontSize}}class W extends T{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:m.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(24,null)})}validate(ne){return ne==="normal"||ne==="bold"?ne:String(s.clampedInt(ne,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}W.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],W.MINIMUM_VALUE=1,W.MAXIMUM_VALUE=1e3;class M extends T{constructor(){const ne={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:ne.multiple,enumDescriptions:[m.localize(25,null),m.localize(26,null),m.localize(27,null)]},te=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",ne,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(29,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(30,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:m.localize(31,null),...ve},"editor.gotoLocation.multipleImplementations":{description:m.localize(32,null),...ve},"editor.gotoLocation.multipleReferences":{description:m.localize(33,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ne.alternativeDefinitionCommand,enum:te,description:m.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ne.alternativeTypeDefinitionCommand,enum:te,description:m.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ne.alternativeDeclarationCommand,enum:te,description:m.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ne.alternativeImplementationCommand,enum:te,description:m.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ne.alternativeReferenceCommand,enum:te,description:m.localize(38,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{multiple:c(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??c(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??c(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??c(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??c(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??c(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends T{constructor(){const ne={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",ne,{"editor.hover.enabled":{type:"boolean",default:ne.enabled,description:m.localize(39,null)},"editor.hover.delay":{type:"number",default:ne.delay,description:m.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ne.sticky,description:m.localize(41,null)},"editor.hover.above":{type:"boolean",default:ne.above,description:m.localize(42,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{enabled:v(ve.enabled,this.defaultValue.enabled),delay:s.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:v(ve.sticky,this.defaultValue.sticky),above:v(ve.above,this.defaultValue.above)}}}var V;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(V=e.RenderMinimap||(e.RenderMinimap={}));class U extends h{constructor(){super(130)}compute(ne,ve,te){return U.computeLayout(ve,{memory:ne.memory,outerWidth:ne.outerWidth,outerHeight:ne.outerHeight,isDominatedByLongLines:ne.isDominatedByLongLines,lineHeight:ne.fontInfo.lineHeight,viewLineCount:ne.viewLineCount,lineNumbersDigitCount:ne.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ne.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ne.fontInfo.maxDigitWidth,pixelRatio:ne.pixelRatio})}static computeContainedMinimapLineCount(ne){const ve=ne.height/ne.lineHeight,te=ne.scrollBeyondLastLine?ve-1:0,_e=(ne.viewLineCount+te)/(ne.pixelRatio*ne.height),Me=Math.floor(ne.viewLineCount/_e);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:te,desiredRatio:_e,minimapLineCount:Me}}static _computeMinimapLayout(ne,ve){const te=ne.outerWidth,_e=ne.outerHeight,Me=ne.pixelRatio;if(!ne.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Me*_e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:_e};const Be=ve.stableMinimapLayoutInput,Xe=Be&&ne.outerHeight===Be.outerHeight&&ne.lineHeight===Be.lineHeight&&ne.typicalHalfwidthCharacterWidth===Be.typicalHalfwidthCharacterWidth&&ne.pixelRatio===Be.pixelRatio&&ne.scrollBeyondLastLine===Be.scrollBeyondLastLine&&ne.minimap.enabled===Be.minimap.enabled&&ne.minimap.side===Be.minimap.side&&ne.minimap.size===Be.minimap.size&&ne.minimap.showSlider===Be.minimap.showSlider&&ne.minimap.renderCharacters===Be.minimap.renderCharacters&&ne.minimap.maxColumn===Be.minimap.maxColumn&&ne.minimap.scale===Be.minimap.scale&&ne.verticalScrollbarWidth===Be.verticalScrollbarWidth&&ne.isViewportWrapping===Be.isViewportWrapping,Ae=ne.lineHeight,Pe=ne.typicalHalfwidthCharacterWidth,ye=ne.scrollBeyondLastLine,de=ne.minimap.renderCharacters;let fe=Me>=2?Math.round(ne.minimap.scale*2):ne.minimap.scale;const Ee=ne.minimap.maxColumn,Ce=ne.minimap.size,Ne=ne.minimap.side,Ke=ne.verticalScrollbarWidth,He=ne.viewLineCount,Qe=ne.remainingWidth,st=ne.isViewportWrapping,at=de?2:3;let me=Math.floor(Me*_e);const De=me/Me;let ue=!1,Q=!1,Ie=at*fe,Fe=fe/Me,Ze=1;if(Ce==="fill"||Ce==="fit"){const{typicalViewportLineCount:vt,extraLinesBeyondLastLine:_t,desiredRatio:Ot,minimapLineCount:It}=U.computeContainedMinimapLineCount({viewLineCount:He,scrollBeyondLastLine:ye,height:_e,lineHeight:Ae,pixelRatio:Me});if(He/It>1)ue=!0,Q=!0,fe=1,Ie=1,Fe=fe/Me;else{let Lt=!1,St=fe+1;if(Ce==="fit"){const Mt=Math.ceil((He+_t)*Ie);st&&Xe&&Qe<=ve.stableFitRemainingWidth?(Lt=!0,St=ve.stableFitMaxMinimapScale):Lt=Mt>me}if(Ce==="fill"||Lt){ue=!0;const Mt=fe;Ie=Math.min(Ae*Me,Math.max(1,Math.floor(1/Ot))),st&&Xe&&Qe<=ve.stableFitRemainingWidth&&(St=ve.stableFitMaxMinimapScale),fe=Math.min(St,Math.max(1,Math.floor(Ie/at))),fe>Mt&&(Ze=Math.min(2,fe/Mt)),Fe=fe/Me/Ze,me=Math.ceil(Math.max(vt,He+_t)*Ie),st?(ve.stableMinimapLayoutInput=ne,ve.stableFitRemainingWidth=Qe,ve.stableFitMaxMinimapScale=fe):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const qe=Math.floor(Ee*Fe),dt=Math.min(qe,Math.max(0,Math.floor((Qe-Ke-2)*Fe/(Pe+Fe)))+e.MINIMAP_GUTTER_WIDTH);let wt=Math.floor(Me*dt);const yt=wt/Me;wt=Math.floor(wt*Ze);const bt=de?1:2,ft=Ne==="left"?0:te-dt-Ke;return{renderMinimap:bt,minimapLeft:ft,minimapWidth:dt,minimapHeightIsEditorHeight:ue,minimapIsSampling:Q,minimapScale:fe,minimapLineHeight:Ie,minimapCanvasInnerWidth:wt,minimapCanvasInnerHeight:me,minimapCanvasOuterWidth:yt,minimapCanvasOuterHeight:De}}static computeLayout(ne,ve){const te=ve.outerWidth|0,_e=ve.outerHeight|0,Me=ve.lineHeight|0,Be=ve.lineNumbersDigitCount|0,Xe=ve.typicalHalfwidthCharacterWidth,Ae=ve.maxDigitWidth,Pe=ve.pixelRatio,ye=ve.viewLineCount,de=ne.get(122),fe=de==="inherit"?ne.get(121):de,Ee=fe==="inherit"?ne.get(117):fe,Ce=ne.get(120),Ne=ne.get(2),Ke=ve.isDominatedByLongLines,He=ne.get(49),Qe=ne.get(59).renderType!==0,st=ne.get(60),at=ne.get(93),me=ne.get(64),De=ne.get(91),ue=De.verticalScrollbarSize,Q=De.verticalHasArrows,Ie=De.arrowSize,Fe=De.horizontalScrollbarSize,Ze=ne.get(57),qe=ne.get(37);let dt;if(typeof Ze=="string"&&/^\d+(\.\d+)?ch$/.test(Ze)){const Wt=parseFloat(Ze.substr(0,Ze.length-2));dt=s.clampedInt(Wt*Xe,0,0,1e3)}else dt=s.clampedInt(Ze,0,0,1e3);qe&&(dt+=16);let wt=0;if(Qe){const Wt=Math.max(Be,st);wt=Math.round(Wt*Ae)}let yt=0;He&&(yt=Me);let bt=0,ft=bt+yt,vt=ft+wt,_t=vt+dt;const Ot=te-yt-wt-dt;let It=!1,Tt=!1,Lt=-1;Ne!==2&&(fe==="inherit"&&Ke?(It=!0,Tt=!0):Ee==="on"||Ee==="bounded"?Tt=!0:Ee==="wordWrapColumn"&&(Lt=Ce));const St=U._computeMinimapLayout({outerWidth:te,outerHeight:_e,lineHeight:Me,typicalHalfwidthCharacterWidth:Xe,pixelRatio:Pe,scrollBeyondLastLine:at,minimap:me,verticalScrollbarWidth:ue,viewLineCount:ye,remainingWidth:Ot,isViewportWrapping:Tt},ve.memory||new L);St.renderMinimap!==0&&St.minimapLeft===0&&(bt+=St.minimapWidth,ft+=St.minimapWidth,vt+=St.minimapWidth,_t+=St.minimapWidth);const Mt=Ot-St.minimapWidth,Nt=Math.max(1,Math.floor((Mt-ue-2)/Xe)),Et=Q?Ie:0;return Tt&&(Lt=Math.max(1,Nt),Ee==="bounded"&&(Lt=Math.min(Lt,Ce))),{width:te,height:_e,glyphMarginLeft:bt,glyphMarginWidth:yt,lineNumbersLeft:ft,lineNumbersWidth:wt,decorationsLeft:vt,decorationsWidth:dt,contentLeft:_t,contentWidth:Mt,minimap:St,viewportColumn:Nt,isWordWrapMinified:It,isViewportWrapping:Tt,wrappingColumn:Lt,verticalScrollbarWidth:ue,horizontalScrollbarHeight:Fe,overviewRuler:{top:Et,width:ue,height:_e-2*Et,right:0}}}}e.EditorLayoutInfoComputer=U;class H extends T{constructor(){const ne={enabled:!0};super(56,"lightbulb",ne,{"editor.lightbulb.enabled":{type:"boolean",default:ne.enabled,description:m.localize(43,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:v(ne.enabled,this.defaultValue.enabled)}}}class X extends T{constructor(){const ne={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",ne,{"editor.inlayHints.enabled":{type:"boolean",default:ne.enabled,description:m.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ne.fontSize,markdownDescription:m.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ne.fontFamily,markdownDescription:m.localize(46,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{enabled:v(ve.enabled,this.defaultValue.enabled),fontSize:s.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class se extends o{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ne=>o.clamp(ne,0,150),{markdownDescription:m.localize(47,null)})}compute(ne,ve,te){return ne.fontInfo.lineHeight}}class K extends T{constructor(){const ne={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",ne,{"editor.minimap.enabled":{type:"boolean",default:ne.enabled,description:m.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(49,null),m.localize(50,null),m.localize(51,null)],default:ne.size,description:m.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ne.side,description:m.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ne.showSlider,description:m.localize(54,null)},"editor.minimap.scale":{type:"number",default:ne.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ne.renderCharacters,description:m.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ne.maxColumn,description:m.localize(57,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{enabled:v(ve.enabled,this.defaultValue.enabled),size:c(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:c(ve.side,this.defaultValue.side,["right","left"]),showSlider:c(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:v(ve.renderCharacters,this.defaultValue.renderCharacters),scale:s.clampedInt(ve.scale,1,1,3),maxColumn:s.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function j(Z){return Z==="ctrlCmd"?i.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ie extends T{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(59,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{top:s.clampedInt(ve.top,0,0,1e3),bottom:s.clampedInt(ve.bottom,0,0,1e3)}}}class ce extends T{constructor(){const ne={enabled:!0,cycle:!1};super(75,"parameterHints",ne,{"editor.parameterHints.enabled":{type:"boolean",default:ne.enabled,description:m.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ne.cycle,description:m.localize(61,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{enabled:v(ve.enabled,this.defaultValue.enabled),cycle:v(ve.cycle,this.defaultValue.cycle)}}}class ge extends h{constructor(){super(128)}compute(ne,ve,te){return ne.pixelRatio}}class ke extends T{constructor(){const ne={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",ne,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ne.strings,description:m.localize(62,null)},comments:{type:"boolean",default:ne.comments,description:m.localize(63,null)},other:{type:"boolean",default:ne.other,description:m.localize(64,null)}}}],default:ne,description:m.localize(65,null)});this.defaultValue=ne}validate(ne){if(typeof ne=="boolean")return ne;if(ne&&typeof ne=="object"){const ve=ne,te={other:v(ve.other,this.defaultValue.other),comments:v(ve.comments,this.defaultValue.comments),strings:v(ve.strings,this.defaultValue.strings)};return te.other&&te.comments&&te.strings?!0:!te.other&&!te.comments&&!te.strings?!1:te}return this.defaultValue}}var Le;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(Le=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Oe extends T{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(66,null),m.localize(67,null),m.localize(68,null),m.localize(69,null)],default:"on",description:m.localize(70,null)})}validate(ne){let ve=this.defaultValue.renderType,te=this.defaultValue.renderFn;return typeof ne!="undefined"&&(typeof ne=="function"?(ve=4,te=ne):ne==="interval"?ve=3:ne==="relative"?ve=2:ne==="on"?ve=1:ve=0),{renderType:ve,renderFn:te}}}function q(Z){const ne=Z.get(86);return ne==="editable"?Z.get(80):ne!=="on"}e.filterValidationDecorations=q;class J extends T{constructor(){const ne=[],ve={type:"number",description:m.localize(71,null)};super(90,"rulers",ne,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:m.localize(72,null),format:"color-hex"}}}]},default:ne,description:m.localize(73,null)})}validate(ne){if(Array.isArray(ne)){let ve=[];for(let te of ne)if(typeof te=="number")ve.push({column:s.clampedInt(te,0,0,1e4),color:null});else if(te&&typeof te=="object"){const _e=te;ve.push({column:s.clampedInt(_e.column,0,0,1e4),color:_e.color})}return ve.sort((te,_e)=>te.column-_e.column),ve}return this.defaultValue}}function re(Z,ne){if(typeof Z!="string")return ne;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class he extends T{constructor(){const ne={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",ne,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(74,null),m.localize(75,null),m.localize(76,null)],default:"auto",description:m.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(78,null),m.localize(79,null),m.localize(80,null)],default:"auto",description:m.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ne.verticalScrollbarSize,description:m.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ne.horizontalScrollbarSize,description:m.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ne.scrollByPage,description:m.localize(84,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne,te=s.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),_e=s.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:s.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:re(ve.vertical,this.defaultValue.vertical),horizontal:re(ve.horizontal,this.defaultValue.horizontal),useShadows:v(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:v(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:v(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:v(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:v(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:te,horizontalSliderSize:s.clampedInt(ve.horizontalSliderSize,te,0,1e3),verticalScrollbarSize:_e,verticalSliderSize:s.clampedInt(ve.verticalSliderSize,_e,0,1e3),scrollByPage:v(ve.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings"};class ee extends T{constructor(){const ne={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{}};super(112,"unicodeHighlight",ne,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ne.nonBasicASCII,description:m.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ne.invisibleCharacters,description:m.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ne.ambiguousCharacters,description:m.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ne.includeComments,description:m.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ne.includeStrings,description:m.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ne.allowedCharacters,description:m.localize(90,null),additionalProperties:{type:"boolean"}}})}applyUpdate(ne,ve){let te=!1;ve.allowedCharacters&&(P.equals(ne.allowedCharacters,ve.allowedCharacters)||(ne={...ne,allowedCharacters:ve.allowedCharacters},te=!0));const _e=super.applyUpdate(ne,ve);return te?new l(_e.newValue,!0):_e}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{nonBasicASCII:Ve(ve.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:v(ve.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:v(ve.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ve(ve.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ve(ve.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateAllowedCharacters(ne.allowedCharacters,this.defaultValue.allowedCharacters)}}validateAllowedCharacters(ne,ve){if(typeof ne!="object"||!ne)return ve;const te={};for(const[_e,Me]of Object.entries(ne))Me===!0&&(te[_e]=!0);return te}}class ae extends T{constructor(){const ne={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",ne,{"editor.inlineSuggest.enabled":{type:"boolean",default:ne.enabled,description:m.localize(91,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{enabled:v(ve.enabled,this.defaultValue.enabled),mode:c(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Se extends T{constructor(){const ne={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ne,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ne.enabled,description:m.localize(92,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:v(ne.enabled,this.defaultValue.enabled)}}}class Ue extends T{constructor(){const ne={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ne,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(93,null),m.localize(94,null),m.localize(95,null)],default:ne.bracketPairs,description:m.localize(96,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(97,null),m.localize(98,null),m.localize(99,null)],default:ne.bracketPairsHorizontal,description:m.localize(100,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ne.highlightActiveBracketPair,description:m.localize(101,null)},"editor.guides.indentation":{type:"boolean",default:ne.indentation,description:m.localize(102,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ne.highlightActiveIndentation,description:m.localize(103,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{bracketPairs:Ve(ve.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ve(ve.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:v(ve.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:v(ve.indentation,this.defaultValue.indentation),highlightActiveIndentation:v(ve.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function Ve(Z,ne,ve){const te=ve.indexOf(Z);return te===-1?ne:ve[te]}class Ge extends T{constructor(){const ne={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",ne,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(104,null),m.localize(105,null)],default:ne.insertMode,description:m.localize(106,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ne.filterGraceful,description:m.localize(107,null)},"editor.suggest.localityBonus":{type:"boolean",default:ne.localityBonus,description:m.localize(108,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ne.shareSuggestSelections,markdownDescription:m.localize(109,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ne.snippetsPreventQuickSuggestions,description:m.localize(110,null)},"editor.suggest.showIcons":{type:"boolean",default:ne.showIcons,description:m.localize(111,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ne.showStatusBar,description:m.localize(112,null)},"editor.suggest.preview":{type:"boolean",default:ne.preview,description:m.localize(113,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ne.showInlineDetails,description:m.localize(114,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(115,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(116,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(117,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(119,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(120,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(121,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(122,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(123,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(124,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(125,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(126,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(127,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(128,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(129,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(130,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(131,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(132,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(133,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(134,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(135,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(136,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(137,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(138,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(139,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(140,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(141,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(142,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(143,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(144,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(145,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{insertMode:c(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:v(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:v(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:v(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:v(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:v(ve.showIcons,this.defaultValue.showIcons),showStatusBar:v(ve.showStatusBar,this.defaultValue.showStatusBar),preview:v(ve.preview,this.defaultValue.preview),previewMode:c(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:v(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:v(ve.showMethods,this.defaultValue.showMethods),showFunctions:v(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:v(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:v(ve.showDeprecated,this.defaultValue.showDeprecated),showFields:v(ve.showFields,this.defaultValue.showFields),showVariables:v(ve.showVariables,this.defaultValue.showVariables),showClasses:v(ve.showClasses,this.defaultValue.showClasses),showStructs:v(ve.showStructs,this.defaultValue.showStructs),showInterfaces:v(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:v(ve.showModules,this.defaultValue.showModules),showProperties:v(ve.showProperties,this.defaultValue.showProperties),showEvents:v(ve.showEvents,this.defaultValue.showEvents),showOperators:v(ve.showOperators,this.defaultValue.showOperators),showUnits:v(ve.showUnits,this.defaultValue.showUnits),showValues:v(ve.showValues,this.defaultValue.showValues),showConstants:v(ve.showConstants,this.defaultValue.showConstants),showEnums:v(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:v(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:v(ve.showKeywords,this.defaultValue.showKeywords),showWords:v(ve.showWords,this.defaultValue.showWords),showColors:v(ve.showColors,this.defaultValue.showColors),showFiles:v(ve.showFiles,this.defaultValue.showFiles),showReferences:v(ve.showReferences,this.defaultValue.showReferences),showFolders:v(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:v(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:v(ve.showSnippets,this.defaultValue.showSnippets),showUsers:v(ve.showUsers,this.defaultValue.showUsers),showIssues:v(ve.showIssues,this.defaultValue.showIssues)}}}class Je extends T{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(146,null),default:!0,type:"boolean"}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:v(ne.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class tt extends h{constructor(){super(129)}compute(ne,ve,te){return ve.get(80)?!0:ne.tabFocusMode}}var ot;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(ot=e.WrappingIndent||(e.WrappingIndent={}));function et(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class it extends h{constructor(){super(131)}compute(ne,ve,te){const _e=ve.get(130);return{isDominatedByLongLines:ne.isDominatedByLongLines,isWordWrapMinified:_e.isWordWrapMinified,isViewportWrapping:_e.isViewportWrapping,wrappingColumn:_e.wrappingColumn}}}const ct="Consolas, 'Courier New', monospace",pt="Menlo, Monaco, 'Courier New', monospace",Pt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:i.isMacintosh?pt:i.isLinux?Pt:ct,fontWeight:"normal",fontSize:i.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function We(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var Rt;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.autoClosingBrackets=5]="autoClosingBrackets",Z[Z.autoClosingDelete=6]="autoClosingDelete",Z[Z.autoClosingOvertype=7]="autoClosingOvertype",Z[Z.autoClosingQuotes=8]="autoClosingQuotes",Z[Z.autoIndent=9]="autoIndent",Z[Z.automaticLayout=10]="automaticLayout",Z[Z.autoSurround=11]="autoSurround",Z[Z.bracketPairColorization=12]="bracketPairColorization",Z[Z.guides=13]="guides",Z[Z.codeLens=14]="codeLens",Z[Z.codeLensFontFamily=15]="codeLensFontFamily",Z[Z.codeLensFontSize=16]="codeLensFontSize",Z[Z.colorDecorators=17]="colorDecorators",Z[Z.columnSelection=18]="columnSelection",Z[Z.comments=19]="comments",Z[Z.contextmenu=20]="contextmenu",Z[Z.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=22]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=24]="cursorStyle",Z[Z.cursorSurroundingLines=25]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=27]="cursorWidth",Z[Z.disableLayerHinting=28]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",Z[Z.domReadOnly=30]="domReadOnly",Z[Z.dragAndDrop=31]="dragAndDrop",Z[Z.emptySelectionClipboard=32]="emptySelectionClipboard",Z[Z.extraEditorClassName=33]="extraEditorClassName",Z[Z.fastScrollSensitivity=34]="fastScrollSensitivity",Z[Z.find=35]="find",Z[Z.fixedOverflowWidgets=36]="fixedOverflowWidgets",Z[Z.folding=37]="folding",Z[Z.foldingStrategy=38]="foldingStrategy",Z[Z.foldingHighlight=39]="foldingHighlight",Z[Z.foldingImportsByDefault=40]="foldingImportsByDefault",Z[Z.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=42]="fontFamily",Z[Z.fontInfo=43]="fontInfo",Z[Z.fontLigatures=44]="fontLigatures",Z[Z.fontSize=45]="fontSize",Z[Z.fontWeight=46]="fontWeight",Z[Z.formatOnPaste=47]="formatOnPaste",Z[Z.formatOnType=48]="formatOnType",Z[Z.glyphMargin=49]="glyphMargin",Z[Z.gotoLocation=50]="gotoLocation",Z[Z.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",Z[Z.hover=52]="hover",Z[Z.inDiffEditor=53]="inDiffEditor",Z[Z.inlineSuggest=54]="inlineSuggest",Z[Z.letterSpacing=55]="letterSpacing",Z[Z.lightbulb=56]="lightbulb",Z[Z.lineDecorationsWidth=57]="lineDecorationsWidth",Z[Z.lineHeight=58]="lineHeight",Z[Z.lineNumbers=59]="lineNumbers",Z[Z.lineNumbersMinChars=60]="lineNumbersMinChars",Z[Z.linkedEditing=61]="linkedEditing",Z[Z.links=62]="links",Z[Z.matchBrackets=63]="matchBrackets",Z[Z.minimap=64]="minimap",Z[Z.mouseStyle=65]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=67]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=69]="multiCursorModifier",Z[Z.multiCursorPaste=70]="multiCursorPaste",Z[Z.occurrencesHighlight=71]="occurrencesHighlight",Z[Z.overviewRulerBorder=72]="overviewRulerBorder",Z[Z.overviewRulerLanes=73]="overviewRulerLanes",Z[Z.padding=74]="padding",Z[Z.parameterHints=75]="parameterHints",Z[Z.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=78]="quickSuggestions",Z[Z.quickSuggestionsDelay=79]="quickSuggestionsDelay",Z[Z.readOnly=80]="readOnly",Z[Z.renameOnType=81]="renameOnType",Z[Z.renderControlCharacters=82]="renderControlCharacters",Z[Z.renderFinalNewline=83]="renderFinalNewline",Z[Z.renderLineHighlight=84]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=86]="renderValidationDecorations",Z[Z.renderWhitespace=87]="renderWhitespace",Z[Z.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",Z[Z.roundedSelection=89]="roundedSelection",Z[Z.rulers=90]="rulers",Z[Z.scrollbar=91]="scrollbar",Z[Z.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=93]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=94]="scrollPredominantAxis",Z[Z.selectionClipboard=95]="selectionClipboard",Z[Z.selectionHighlight=96]="selectionHighlight",Z[Z.selectOnLineNumbers=97]="selectOnLineNumbers",Z[Z.showFoldingControls=98]="showFoldingControls",Z[Z.showUnused=99]="showUnused",Z[Z.snippetSuggestions=100]="snippetSuggestions",Z[Z.smartSelect=101]="smartSelect",Z[Z.smoothScrolling=102]="smoothScrolling",Z[Z.stickyTabStops=103]="stickyTabStops",Z[Z.stopRenderingLineAfter=104]="stopRenderingLineAfter",Z[Z.suggest=105]="suggest",Z[Z.suggestFontSize=106]="suggestFontSize",Z[Z.suggestLineHeight=107]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",Z[Z.suggestSelection=109]="suggestSelection",Z[Z.tabCompletion=110]="tabCompletion",Z[Z.tabIndex=111]="tabIndex",Z[Z.unicodeHighlighting=112]="unicodeHighlighting",Z[Z.unusualLineTerminators=113]="unusualLineTerminators",Z[Z.useShadowDOM=114]="useShadowDOM",Z[Z.useTabStops=115]="useTabStops",Z[Z.wordSeparators=116]="wordSeparators",Z[Z.wordWrap=117]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=120]="wordWrapColumn",Z[Z.wordWrapOverride1=121]="wordWrapOverride1",Z[Z.wordWrapOverride2=122]="wordWrapOverride2",Z[Z.wrappingIndent=123]="wrappingIndent",Z[Z.wrappingStrategy=124]="wrappingStrategy",Z[Z.showDeprecated=125]="showDeprecated",Z[Z.inlayHints=126]="inlayHints",Z[Z.editorClassName=127]="editorClassName",Z[Z.pixelRatio=128]="pixelRatio",Z[Z.tabFocusMode=129]="tabFocusMode",Z[Z.layoutInfo=130]="layoutInfo",Z[Z.wrappingInfo=131]="wrappingInfo"})(Rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:We(new A(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(147,null)})),acceptSuggestionOnEnter:We(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(148,null),""],markdownDescription:m.localize(149,null)})),accessibilitySupport:We(new n),accessibilityPageSize:We(new s(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(150,null)})),ariaLabel:We(new g(4,"ariaLabel",m.localize(151,null))),autoClosingBrackets:We(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(152,null),m.localize(153,null),""],description:m.localize(154,null)})),autoClosingDelete:We(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(155,null),""],description:m.localize(156,null)})),autoClosingOvertype:We(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(157,null),""],description:m.localize(158,null)})),autoClosingQuotes:We(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(159,null),m.localize(160,null),""],description:m.localize(161,null)})),autoIndent:We(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],t,{enumDescriptions:[m.localize(162,null),m.localize(163,null),m.localize(164,null),m.localize(165,null),m.localize(166,null)],description:m.localize(167,null)})),automaticLayout:We(new A(10,"automaticLayout",!1)),autoSurround:We(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(168,null),m.localize(169,null),m.localize(170,null),""],description:m.localize(171,null)})),bracketPairColorization:We(new Se),bracketPairGuides:We(new Ue),stickyTabStops:We(new A(103,"stickyTabStops",!1,{description:m.localize(172,null)})),codeLens:We(new A(14,"codeLens",!0,{description:m.localize(173,null)})),codeLensFontFamily:We(new g(15,"codeLensFontFamily","",{description:m.localize(174,null)})),codeLensFontSize:We(new s(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(175,null)})),colorDecorators:We(new A(17,"colorDecorators",!0,{description:m.localize(176,null)})),columnSelection:We(new A(18,"columnSelection",!1,{description:m.localize(177,null)})),comments:We(new u),contextmenu:We(new A(20,"contextmenu",!0)),copyWithSyntaxHighlighting:We(new A(21,"copyWithSyntaxHighlighting",!0,{description:m.localize(178,null)})),cursorBlinking:We(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:m.localize(179,null)})),cursorSmoothCaretAnimation:We(new A(23,"cursorSmoothCaretAnimation",!1,{description:m.localize(180,null)})),cursorStyle:We(new r(24,"cursorStyle",b.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],D,{description:m.localize(181,null)})),cursorSurroundingLines:We(new s(25,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(182,null)})),cursorSurroundingLinesStyle:We(new S(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(183,null),m.localize(184,null)],description:m.localize(185,null)})),cursorWidth:We(new s(27,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(186,null)})),disableLayerHinting:We(new A(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:We(new A(29,"disableMonospaceOptimizations",!1)),domReadOnly:We(new A(30,"domReadOnly",!1)),dragAndDrop:We(new A(31,"dragAndDrop",!0,{description:m.localize(187,null)})),emptySelectionClipboard:We(new N),extraEditorClassName:We(new g(33,"extraEditorClassName","")),fastScrollSensitivity:We(new o(34,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:m.localize(188,null)})),find:We(new B),fixedOverflowWidgets:We(new A(36,"fixedOverflowWidgets",!1)),folding:We(new A(37,"folding",!0,{description:m.localize(189,null)})),foldingStrategy:We(new S(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(190,null),m.localize(191,null)],description:m.localize(192,null)})),foldingHighlight:We(new A(39,"foldingHighlight",!0,{description:m.localize(193,null)})),foldingImportsByDefault:We(new A(40,"foldingImportsByDefault",!1,{description:m.localize(194,null)})),unfoldOnClickAfterEndOfLine:We(new A(41,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(195,null)})),fontFamily:We(new g(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(196,null)})),fontInfo:We(new O),fontLigatures2:We(new F),fontSize:We(new z),fontWeight:We(new W),formatOnPaste:We(new A(47,"formatOnPaste",!1,{description:m.localize(197,null)})),formatOnType:We(new A(48,"formatOnType",!1,{description:m.localize(198,null)})),glyphMargin:We(new A(49,"glyphMargin",!0,{description:m.localize(199,null)})),gotoLocation:We(new M),hideCursorInOverviewRuler:We(new A(51,"hideCursorInOverviewRuler",!1,{description:m.localize(200,null)})),hover:We(new x),inDiffEditor:We(new A(53,"inDiffEditor",!1)),letterSpacing:We(new o(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>o.clamp(Z,-5,20),{description:m.localize(201,null)})),lightbulb:We(new H),lineDecorationsWidth:We(new p(57,"lineDecorationsWidth",10)),lineHeight:We(new se),lineNumbers:We(new Oe),lineNumbersMinChars:We(new s(60,"lineNumbersMinChars",5,1,300)),linkedEditing:We(new A(61,"linkedEditing",!1,{description:m.localize(202,null)})),links:We(new A(62,"links",!0,{description:m.localize(203,null)})),matchBrackets:We(new S(63,"matchBrackets","always",["always","near","never"],{description:m.localize(204,null)})),minimap:We(new K),mouseStyle:We(new S(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:We(new o(66,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:m.localize(205,null)})),mouseWheelZoom:We(new A(67,"mouseWheelZoom",!1,{markdownDescription:m.localize(206,null)})),multiCursorMergeOverlapping:We(new A(68,"multiCursorMergeOverlapping",!0,{description:m.localize(207,null)})),multiCursorModifier:We(new r(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],j,{markdownEnumDescriptions:[m.localize(208,null),m.localize(209,null)],markdownDescription:m.localize(210,null)})),multiCursorPaste:We(new S(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(211,null),m.localize(212,null)],markdownDescription:m.localize(213,null)})),occurrencesHighlight:We(new A(71,"occurrencesHighlight",!0,{description:m.localize(214,null)})),overviewRulerBorder:We(new A(72,"overviewRulerBorder",!0,{description:m.localize(215,null)})),overviewRulerLanes:We(new s(73,"overviewRulerLanes",3,0,3)),padding:We(new ie),parameterHints:We(new ce),peekWidgetDefaultFocus:We(new S(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(216,null),m.localize(217,null)],description:m.localize(218,null)})),definitionLinkOpensInPeek:We(new A(77,"definitionLinkOpensInPeek",!1,{description:m.localize(219,null)})),quickSuggestions:We(new ke),quickSuggestionsDelay:We(new s(79,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(220,null)})),readOnly:We(new A(80,"readOnly",!1)),renameOnType:We(new A(81,"renameOnType",!1,{description:m.localize(221,null),markdownDeprecationMessage:m.localize(222,null)})),renderControlCharacters:We(new A(82,"renderControlCharacters",!0,{description:m.localize(223,null),restricted:!0})),renderFinalNewline:We(new A(83,"renderFinalNewline",!0,{description:m.localize(224,null)})),renderLineHighlight:We(new S(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(225,null)],description:m.localize(226,null)})),renderLineHighlightOnlyWhenFocus:We(new A(85,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(227,null)})),renderValidationDecorations:We(new S(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:We(new S(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(228,null),m.localize(229,null),m.localize(230,null),""],description:m.localize(231,null)})),revealHorizontalRightPadding:We(new s(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:We(new A(89,"roundedSelection",!0,{description:m.localize(232,null)})),rulers:We(new J),scrollbar:We(new he),scrollBeyondLastColumn:We(new s(92,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(233,null)})),scrollBeyondLastLine:We(new A(93,"scrollBeyondLastLine",!0,{description:m.localize(234,null)})),scrollPredominantAxis:We(new A(94,"scrollPredominantAxis",!0,{description:m.localize(235,null)})),selectionClipboard:We(new A(95,"selectionClipboard",!0,{description:m.localize(236,null),included:i.isLinux})),selectionHighlight:We(new A(96,"selectionHighlight",!0,{description:m.localize(237,null)})),selectOnLineNumbers:We(new A(97,"selectOnLineNumbers",!0)),showFoldingControls:We(new S(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(238,null),m.localize(239,null)],description:m.localize(240,null)})),showUnused:We(new A(99,"showUnused",!0,{description:m.localize(241,null)})),showDeprecated:We(new A(125,"showDeprecated",!0,{description:m.localize(242,null)})),inlayHints:We(new X),snippetSuggestions:We(new S(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(243,null),m.localize(244,null),m.localize(245,null),m.localize(246,null)],description:m.localize(247,null)})),smartSelect:We(new Je),smoothScrolling:We(new A(102,"smoothScrolling",!1,{description:m.localize(248,null)})),stopRenderingLineAfter:We(new s(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:We(new Ge),inlineSuggest:We(new ae),suggestFontSize:We(new s(106,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(249,null)})),suggestLineHeight:We(new s(107,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(250,null)})),suggestOnTriggerCharacters:We(new A(108,"suggestOnTriggerCharacters",!0,{description:m.localize(251,null)})),suggestSelection:We(new S(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(252,null),m.localize(253,null),m.localize(254,null)],description:m.localize(255,null)})),tabCompletion:We(new S(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(256,null),m.localize(257,null),m.localize(258,null)],description:m.localize(259,null)})),tabIndex:We(new s(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:We(new ee),unusualLineTerminators:We(new S(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(260,null),m.localize(261,null),m.localize(262,null)],description:m.localize(263,null)})),useShadowDOM:We(new A(114,"useShadowDOM",!0)),useTabStops:We(new A(115,"useTabStops",!0,{description:m.localize(264,null)})),wordSeparators:We(new g(116,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:m.localize(265,null)})),wordWrap:We(new S(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(266,null),m.localize(267,null),m.localize(268,null),m.localize(269,null)],description:m.localize(270,null)})),wordWrapBreakAfterCharacters:We(new g(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:We(new g(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:We(new s(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(271,null)})),wordWrapOverride1:We(new S(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:We(new S(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:We(new r(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],et,{enumDescriptions:[m.localize(272,null),m.localize(273,null),m.localize(274,null),m.localize(275,null)],description:m.localize(276,null)})),wrappingStrategy:We(new S(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(277,null),m.localize(278,null)],description:m.localize(279,null)})),editorClassName:We(new R),pixelRatio:We(new ge),tabFocusMode:We(new tt),layoutInfo:We(new U),wrappingInfo:We(new it)}}),define(we[155],be([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[156],be([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(we[157],be([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[158],be([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(we[159],be([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(we[160],be([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(we[161],be([19,20]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(we[162],be([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[163],be([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[164],be([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(we[165],be([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[166],be([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[167],be([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[168],be([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[169],be([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(we[170],be([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(we[171],be([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(we[172],be([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[173],be([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(we[174],be([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[175],be([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[176],be([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[177],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var m;(function(P){P[P.ACTIVATE=1]="ACTIVATE",P[P.RESTORE=2]="RESTORE",P[P.PRESERVE=3]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var i;(function(P){P[P.PICK=0]="PICK",P[P.DISABLED=1]="DISABLED",P[P.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(i=e.EditorResolution||(e.EditorResolution={}));var y;(function(P){P[P.API=0]="API",P[P.USER=1]="USER"})(y=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(P){P[P.Center=0]="Center",P[P.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",P[P.NearTop=2]="NearTop",P[P.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[178],be([0,1,157]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const i=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function C(l){return l=l.trim(),l==="*"||i.test(l)}e.isValidVersionStr=C;function P(l){if(!C(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=l.match(i);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=P;function k(l){if(!l)return null;let E=l.majorBase,h=l.majorMustEqual,p=l.minorBase,v=l.minorMustEqual,A=l.patchBase,w=l.patchMustEqual;l.hasCaret&&(E===0||(v=!1),w=!1);let s=0;if(l.preRelease){const o=y.exec(l.preRelease);if(o){const[,g,c,S]=o;s=Date.UTC(Number(g),Number(c)-1,Number(S))}}return{majorBase:E,majorMustEqual:h,minorBase:p,minorMustEqual:v,patchBase:A,patchMustEqual:w,isMinimum:l.hasGreaterEquals,notBefore:s}}e.normalizeVersion=k;function _(l,E,h){let p;typeof l=="string"?p=k(P(l)):p=l;let v;E instanceof Date?v=E.getTime():typeof E=="string"&&(v=new Date(E).getTime());let A;if(typeof h=="string"?A=k(P(h)):A=h,!p||!A)return!1;let w=p.majorBase,s=p.minorBase,o=p.patchBase,g=A.majorBase,c=A.minorBase,S=A.patchBase,r=A.notBefore,t=A.majorMustEqual,n=A.minorMustEqual,u=A.patchMustEqual;return A.isMinimum?w>g?!0:w<g?!1:s>c?!0:s<c||v&&v<r?!1:o>=S:(w===1&&g===0&&(!t||!n||!u)&&(g=1,c=0,S=0,t=!0,n=!1,u=!1),w<g?!1:w>g?!t:s<c?!1:s>c?!n:o<S?!1:o>S?!u:!(v&&v<r))}e.isValidVersion=_;function I(l,E,h,p){return h.isBuiltin||typeof h.main=="undefined"?!0:T(l,E,h.engines.vscode,p)}e.isValidExtensionVersion=I;function L(l,E,h){return l==="*"||T(E,h,l)}e.isEngineValid=L;function T(l,E,h,p=[]){let v=k(P(h));if(!v)return p.push(m.localize(0,null,h)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return p.push(m.localize(1,null,h)),!1}else if(!v.majorMustEqual)return p.push(m.localize(2,null,h)),!1;return _(l,E,v)?!0:(p.push(m.localize(3,null,l,h)),!1)}}),define(we[114],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(y,C=[],P=!1){this.ctor=y,this.staticArguments=C,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=m}),define(we[83],be([0,1,114]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const i=[];function y(P,k,_){k instanceof m.SyncDescriptor||(k=new m.SyncDescriptor(k,[],_)),i.push([P,k])}e.registerSingleton=y;function C(){return i}e.getSingletonServiceDescriptors=C}),define(we[179],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=m;class i{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let P of this._nodes.values())P.outgoing.size===0&&C.push(P);return C}insertEdge(C,P){const k=this.lookupOrInsertNode(C),_=this.lookupOrInsertNode(P);k.outgoing.set(this._hashFn(P),_),_.incoming.set(this._hashFn(C),k)}removeNode(C){const P=this._hashFn(C);this._nodes.delete(P);for(let k of this._nodes.values())k.outgoing.delete(P),k.incoming.delete(P)}lookupOrInsertNode(C){const P=this._hashFn(C);let k=this._nodes.get(P);return k||(k=new m(C),this._nodes.set(P,k)),k}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[P,k]of this._nodes)C.push(`${P}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,P]of this._nodes){const k=new Set([C]),_=this._findCycle(P,k);if(_)return _}}_findCycle(C,P){for(let[k,_]of C.outgoing){if(P.has(k))return[...P,k].join(" -> ");P.add(k);const I=this._findCycle(_,P);if(I)return I;P.delete(k)}}}e.Graph=i}),define(we[4],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function k(_){return _[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=k})(m=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function i(P,k,_,I){k[m.DI_TARGET]===k?k[m.DI_DEPENDENCIES].push({id:P,index:_,optional:I}):(k[m.DI_DEPENDENCIES]=[{id:P,index:_,optional:I}],k[m.DI_TARGET]=k)}function y(P){if(m.serviceIds.has(P))return m.serviceIds.get(P);const k=function(_,I,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(k,_,L,!1)};return k.toString=()=>P,m.serviceIds.set(P,k),k}e.createDecorator=y;function C(P){return P}e.refineServiceDecorator=C}),define(we[180],be([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,m.createDecorator)("modelService");function i(y){return!y.isTooLargeForSyncing()&&!y.isForSimpleWidget}e.shouldSynchronizeModel=i}),define(we[181],be([0,1,3,47,6,24,78,82,180]),function(Y,e,m,i,y,C,P,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function I(p){return typeof p=="string"?!1:Array.isArray(p)?p.every(I):!!p.exclusive}class L{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(v,A){let w={selector:v,provider:A,_score:-1,_time:this._clock++};return this._entries.push(w),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,y.toDisposable)(()=>{if(w){let s=this._entries.indexOf(w);s>=0&&(this._entries.splice(s,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),w=void 0)}})}has(v){return this.all(v).length>0}all(v){if(!v)return[];this._updateScores(v);const A=[];for(let w of this._entries)w._score>0&&A.push(w.provider);return A}ordered(v){const A=[];return this._orderedForEach(v,w=>A.push(w.provider)),A}orderedGroups(v){const A=[];let w,s;return this._orderedForEach(v,o=>{w&&s===o._score?w.push(o.provider):(s=o._score,w=[o.provider],A.push(w))}),A}_orderedForEach(v,A){if(!!v){this._updateScores(v);for(const w of this._entries)w._score>0&&A(w)}}_updateScores(v){let A={uri:v.uri.toString(),language:v.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===A.language&&this._lastCandidate.uri===A.uri)){this._lastCandidate=A;for(let w of this._entries)if(w._score=(0,k.score)(w.selector,v.uri,v.getLanguageId(),(0,_.shouldSynchronizeModel)(v)),I(w.selector)&&w._score>0){for(let s of this._entries)s._score=0;w._score=1e3;break}this._entries.sort(L._compareByScoreAndTime)}}static _compareByScoreAndTime(v,A){return v._score<A._score?1:v._score>A._score?-1:v._time<A._time?1:v._time>A._time?-1:0}}e.LanguageFeatureRegistry=L;const T=new WeakMap;let l=0;function E(p){let v=T.get(p);return v===void 0&&(v=++l,T.set(p,v)),v}class h{constructor(v,A,w=Number.MAX_SAFE_INTEGER){this._registry=v,this.min=A,this.max=w,this._cache=new C.LRUCache(50,.7)}_key(v){return v.id+this._registry.all(v).reduce((A,w)=>(0,i.doHash)(E(w),A),0)}_clamp(v){return v===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(v*1.3)))}get(v){const A=this._key(v),w=this._cache.get(A);return this._clamp(w?.value)}update(v,A){const w=this._key(v);let s=this._cache.get(w);return s||(s=new P.MovingAverage,this._cache.set(w,s)),s.update(A),this.get(v)}}e.LanguageFeatureRequestDelays=h}),define(we[84],be([0,1,2,41,181,148,73]),function(Y,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(d){d[d.Null=0]="Null",d[d.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var _;(function(d){d[d.NotSet=-1]="NotSet",d[d.None=0]="None",d[d.Italic=1]="Italic",d[d.Bold=2]="Bold",d[d.Underline=4]="Underline",d[d.Strikethrough=8]="Strikethrough"})(_=e.FontStyle||(e.FontStyle={}));var I;(function(d){d[d.None=0]="None",d[d.DefaultForeground=1]="DefaultForeground",d[d.DefaultBackground=2]="DefaultBackground"})(I=e.ColorId||(e.ColorId={}));var L;(function(d){d[d.Other=0]="Other",d[d.Comment=1]="Comment",d[d.String=2]="String",d[d.RegEx=3]="RegEx"})(L=e.StandardTokenType||(e.StandardTokenType={}));var T;(function(d){d[d.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",d[d.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",d[d.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",d[d.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",d[d.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",d[d.ITALIC_MASK=1024]="ITALIC_MASK",d[d.BOLD_MASK=2048]="BOLD_MASK",d[d.UNDERLINE_MASK=4096]="UNDERLINE_MASK",d[d.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",d[d.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",d[d.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",d[d.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",d[d.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",d[d.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",d[d.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",d[d.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",d[d.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",d[d.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",d[d.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(T=e.MetadataConsts||(e.MetadataConsts={}));class l{static getLanguageId(D){return(D&255)>>>0}static getTokenType(D){return(D&768)>>>8}static getFontStyle(D){return(D&15360)>>>10}static getForeground(D){return(D&8372224)>>>14}static getBackground(D){return(D&4286578688)>>>23}static getClassNameFromMetadata(D){let R=this.getForeground(D),N="mtk"+R,B=this.getFontStyle(D);return B&1&&(N+=" mtki"),B&2&&(N+=" mtkb"),B&4&&(N+=" mtku"),N}static getInlineStyleFromMetadata(D,R){const N=this.getForeground(D),B=this.getFontStyle(D);let F=`color: ${R[N]};`;return B&1&&(F+="font-style: italic;"),B&2&&(F+="font-weight: bold;"),B&4&&(F+="text-decoration: underline;"),F}}e.TokenMetadata=l;var E;(function(d){d[d.Method=0]="Method",d[d.Function=1]="Function",d[d.Constructor=2]="Constructor",d[d.Field=3]="Field",d[d.Variable=4]="Variable",d[d.Class=5]="Class",d[d.Struct=6]="Struct",d[d.Interface=7]="Interface",d[d.Module=8]="Module",d[d.Property=9]="Property",d[d.Event=10]="Event",d[d.Operator=11]="Operator",d[d.Unit=12]="Unit",d[d.Value=13]="Value",d[d.Constant=14]="Constant",d[d.Enum=15]="Enum",d[d.EnumMember=16]="EnumMember",d[d.Keyword=17]="Keyword",d[d.Text=18]="Text",d[d.Color=19]="Color",d[d.File=20]="File",d[d.Reference=21]="Reference",d[d.Customcolor=22]="Customcolor",d[d.Folder=23]="Folder",d[d.TypeParameter=24]="TypeParameter",d[d.User=25]="User",d[d.Issue=26]="Issue",d[d.Snippet=27]="Snippet"})(E=e.CompletionItemKind||(e.CompletionItemKind={}));var h;(function(d){const D=new Map;D.set(0,P.Codicon.symbolMethod),D.set(1,P.Codicon.symbolFunction),D.set(2,P.Codicon.symbolConstructor),D.set(3,P.Codicon.symbolField),D.set(4,P.Codicon.symbolVariable),D.set(5,P.Codicon.symbolClass),D.set(6,P.Codicon.symbolStruct),D.set(7,P.Codicon.symbolInterface),D.set(8,P.Codicon.symbolModule),D.set(9,P.Codicon.symbolProperty),D.set(10,P.Codicon.symbolEvent),D.set(11,P.Codicon.symbolOperator),D.set(12,P.Codicon.symbolUnit),D.set(13,P.Codicon.symbolValue),D.set(15,P.Codicon.symbolEnum),D.set(14,P.Codicon.symbolConstant),D.set(15,P.Codicon.symbolEnum),D.set(16,P.Codicon.symbolEnumMember),D.set(17,P.Codicon.symbolKeyword),D.set(27,P.Codicon.symbolSnippet),D.set(18,P.Codicon.symbolText),D.set(19,P.Codicon.symbolColor),D.set(20,P.Codicon.symbolFile),D.set(21,P.Codicon.symbolReference),D.set(22,P.Codicon.symbolCustomColor),D.set(23,P.Codicon.symbolFolder),D.set(24,P.Codicon.symbolTypeParameter),D.set(25,P.Codicon.account),D.set(26,P.Codicon.issues);function R(F){let O=D.get(F);return O||(console.info("No codicon found for CompletionItemKind "+F),O=P.Codicon.symbolProperty),O}d.toIcon=R;const N=new Map;N.set("method",0),N.set("function",1),N.set("constructor",2),N.set("field",3),N.set("variable",4),N.set("class",5),N.set("struct",6),N.set("interface",7),N.set("module",8),N.set("property",9),N.set("event",10),N.set("operator",11),N.set("unit",12),N.set("value",13),N.set("constant",14),N.set("enum",15),N.set("enum-member",16),N.set("enumMember",16),N.set("keyword",17),N.set("snippet",27),N.set("text",18),N.set("color",19),N.set("file",20),N.set("reference",21),N.set("customcolor",22),N.set("folder",23),N.set("type-parameter",24),N.set("typeParameter",24),N.set("account",25),N.set("issue",26);function B(F,O){let z=N.get(F);return typeof z=="undefined"&&!O&&(z=9),z}d.fromString=B})(h=e.CompletionItemKinds||(e.CompletionItemKinds={}));var p;(function(d){d[d.Deprecated=1]="Deprecated"})(p=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(d){d[d.KeepWhitespace=1]="KeepWhitespace",d[d.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var A;(function(d){d[d.Invoke=0]="Invoke",d[d.TriggerCharacter=1]="TriggerCharacter",d[d.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(A=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(d){d[d.Automatic=0]="Automatic",d[d.Explicit=1]="Explicit"})(w=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var s;(function(d){d[d.Invoke=1]="Invoke",d[d.Auto=2]="Auto"})(s=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(d){d[d.Invoke=1]="Invoke",d[d.TriggerCharacter=2]="TriggerCharacter",d[d.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(d){d[d.Text=0]="Text",d[d.Read=1]="Read",d[d.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function c(d){return d&&m.URI.isUri(d.uri)&&i.Range.isIRange(d.range)&&(i.Range.isIRange(d.originSelectionRange)||i.Range.isIRange(d.targetSelectionRange))}e.isLocationLink=c;var S;(function(d){d[d.File=0]="File",d[d.Module=1]="Module",d[d.Namespace=2]="Namespace",d[d.Package=3]="Package",d[d.Class=4]="Class",d[d.Method=5]="Method",d[d.Property=6]="Property",d[d.Field=7]="Field",d[d.Constructor=8]="Constructor",d[d.Enum=9]="Enum",d[d.Interface=10]="Interface",d[d.Function=11]="Function",d[d.Variable=12]="Variable",d[d.Constant=13]="Constant",d[d.String=14]="String",d[d.Number=15]="Number",d[d.Boolean=16]="Boolean",d[d.Array=17]="Array",d[d.Object=18]="Object",d[d.Key=19]="Key",d[d.Null=20]="Null",d[d.EnumMember=21]="EnumMember",d[d.Struct=22]="Struct",d[d.Event=23]="Event",d[d.Operator=24]="Operator",d[d.TypeParameter=25]="TypeParameter"})(S=e.SymbolKind||(e.SymbolKind={}));var r;(function(d){d[d.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var t;(function(d){const D=new Map;D.set(0,P.Codicon.symbolFile),D.set(1,P.Codicon.symbolModule),D.set(2,P.Codicon.symbolNamespace),D.set(3,P.Codicon.symbolPackage),D.set(4,P.Codicon.symbolClass),D.set(5,P.Codicon.symbolMethod),D.set(6,P.Codicon.symbolProperty),D.set(7,P.Codicon.symbolField),D.set(8,P.Codicon.symbolConstructor),D.set(9,P.Codicon.symbolEnum),D.set(10,P.Codicon.symbolInterface),D.set(11,P.Codicon.symbolFunction),D.set(12,P.Codicon.symbolVariable),D.set(13,P.Codicon.symbolConstant),D.set(14,P.Codicon.symbolString),D.set(15,P.Codicon.symbolNumber),D.set(16,P.Codicon.symbolBoolean),D.set(17,P.Codicon.symbolArray),D.set(18,P.Codicon.symbolObject),D.set(19,P.Codicon.symbolKey),D.set(20,P.Codicon.symbolNull),D.set(21,P.Codicon.symbolEnumMember),D.set(22,P.Codicon.symbolStruct),D.set(23,P.Codicon.symbolEvent),D.set(24,P.Codicon.symbolOperator),D.set(25,P.Codicon.symbolTypeParameter);function R(N){let B=D.get(N);return B||(console.info("No codicon found for SymbolKind "+N),B=P.Codicon.symbolProperty),B}d.toIcon=R})(t=e.SymbolKinds||(e.SymbolKinds={}));class n{constructor(D){this.value=D}}e.FoldingRangeKind=n,n.Comment=new n("comment"),n.Imports=new n("imports"),n.Region=new n("region");var u;(function(d){d[d.Collapsed=0]="Collapsed",d[d.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var a;(function(d){d[d.Editing=0]="Editing",d[d.Preview=1]="Preview"})(a=e.CommentMode||(e.CommentMode={}));var f;(function(d){d[d.Other=0]="Other",d[d.Type=1]="Type",d[d.Parameter=2]="Parameter"})(f=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new y.LanguageFeatureRegistry,e.RenameProviderRegistry=new y.LanguageFeatureRegistry,e.CompletionProviderRegistry=new y.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new y.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new y.LanguageFeatureRegistry,e.HoverProviderRegistry=new y.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new y.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new y.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new y.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new y.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new y.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new y.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new y.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new y.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new y.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.LinkProviderRegistry=new y.LanguageFeatureRegistry,e.ColorProviderRegistry=new y.LanguageFeatureRegistry,e.SelectionRangeRegistry=new y.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new y.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistryImpl;var b;(function(d){d[d.None=0]="None",d[d.Option=1]="Option",d[d.Default=2]="Default",d[d.Preferred=3]="Preferred"})(b=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[115],be([0,1,13,2,4]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function C(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof i.URI)}e.isConfigurationOverrides=C;function P(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||m.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=P;var k;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function _(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=_;function I(v,A){const w=Object.create(null);for(let s in v)L(w,s,v[s],A);return w}e.toValuesTree=I;function L(v,A,w,s){const o=A.split("."),g=o.pop();let c=v;for(let S=0;S<o.length;S++){let r=o[S],t=c[r];switch(typeof t){case"undefined":t=c[r]=Object.create(null);break;case"object":break;default:s(`Ignoring ${A} as ${o.slice(0,S+1).join(".")} is ${JSON.stringify(t)}`);return}c=t}if(typeof c=="object"&&c!==null)try{c[g]=w}catch{s(`Ignoring ${A} as ${o.join(".")} is ${JSON.stringify(c)}`)}else s(`Ignoring ${A} as ${o.join(".")} is ${JSON.stringify(c)}`)}e.addToValueTree=L;function T(v,A){const w=A.split(".");l(v,w)}e.removeFromValueTree=T;function l(v,A){const w=A.shift();if(A.length===0){delete v[w];return}if(Object.keys(v).indexOf(w)!==-1){const s=v[w];typeof s=="object"&&!Array.isArray(s)&&(l(s,A),Object.keys(s).length===0&&delete v[w])}}function E(v,A,w){function s(c,S){let r=c;for(const t of S){if(typeof r!="object"||r===null)return;r=r[t]}return r}const o=A.split("."),g=s(v,o);return typeof g=="undefined"?w:g}e.getConfigurationValue=E;function h(v,A,w){Object.keys(A).forEach(s=>{s!=="__proto__"&&(s in v?m.isObject(v[s])&&m.isObject(A[s])?h(v[s],A[s],w):w&&(v[s]=A[s]):v[s]=A[s])})}e.merge=h;function p(v,A,w){const s=v.inspect(A),o=v.inspect(w);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:s.defaultValue}e.getMigratedSettingValue=p}),define(we[61],be([0,1,12,8,4]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=m.userAgent||"";const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",m.isMacintosh),P.set("isLinux",m.isLinux),P.set("isWindows",m.isWindows),P.set("isWeb",m.isWeb),P.set("isMacNative",m.isMacintosh&&!m.isWeb),P.set("isEdge",C.indexOf("Edg/")>=0),P.set("isFirefox",C.indexOf("Firefox")>=0),P.set("isChrome",C.indexOf("Chrome")>=0),P.set("isSafari",C.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var _;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return l.INSTANCE}static true(){return E.INSTANCE}static has(F){return h.create(F)}static equals(F,O){return p.create(F,O)}static notEquals(F,O){return w.create(F,O)}static regex(F,O){return t.create(F,O)}static in(F,O){return v.create(F,O)}static not(F){return s.create(F)}static and(...F){return a.create(F,null)}static or(...F){return f.create(F,null,!0)}static greater(F,O){return g.create(F,O)}static greaterEquals(F,O){return c.create(F,O)}static smaller(F,O){return S.create(F,O)}static smallerEquals(F,O){return r.create(F,O)}static deserialize(F,O=!1){if(!!F)return this._deserializeOrExpression(F,O)}static _deserializeOrExpression(F,O){let z=F.split("||");return f.create(z.map(W=>this._deserializeAndExpression(W,O)),null,!0)}static _deserializeAndExpression(F,O){let z=F.split("&&");return a.create(z.map(W=>this._deserializeOne(W,O)),null)}static _deserializeOne(F,O){if(F=F.trim(),F.indexOf("!=")>=0){let z=F.split("!=");return w.create(z[0].trim(),this._deserializeValue(z[1],O))}if(F.indexOf("==")>=0){let z=F.split("==");return p.create(z[0].trim(),this._deserializeValue(z[1],O))}if(F.indexOf("=~")>=0){let z=F.split("=~");return t.create(z[0].trim(),this._deserializeRegexValue(z[1],O))}if(F.indexOf(" in ")>=0){let z=F.split(" in ");return v.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const z=F.split(">=");return c.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const z=F.split(">");return g.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const z=F.split("<=");return r.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const z=F.split("<");return S.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(F)?s.create(F.substr(1).trim()):h.create(F)}static _deserializeValue(F,O){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;let z=/^'([^']*)'$/.exec(F);return z?z[1].trim():F}static _deserializeRegexValue(F,O){if((0,i.isFalsyOrWhitespace)(F)){if(O)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=F.indexOf("/"),W=F.lastIndexOf("/");if(z===W||z<0){if(O)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}let M=F.slice(z+1,W),x=F[W+1]==="i"?"i":"";try{return new RegExp(M,x)}catch(V){if(O)throw new Error(`bad regexp-value '${F}', parse error: ${V}`);return console.warn(`bad regexp-value '${F}', parse error: ${V}`),null}}}e.ContextKeyExpr=I;function L(B,F){const O=B?B.substituteConstants():void 0,z=F?F.substituteConstants():void 0;return!O&&!z?!0:!O||!z?!1:O.equals(z)}e.expressionsAreEqualWithConstantSubstitution=L;function T(B,F){return B.cmp(F)}class l{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=l,l.INSTANCE=new l;class E{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return l.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class h{constructor(F,O){this.key=F,this.negated=O,this.type=2}static create(F,O=null){const z=P.get(F);return typeof z=="boolean"?z?E.INSTANCE:l.INSTANCE:new h(F,O)}cmp(F){return F.type!==this.type?this.type-F.type:d(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=P.get(this.key);return typeof F=="boolean"?F?E.INSTANCE:l.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=s.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class p{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=4}static create(F,O,z=null){if(typeof O=="boolean")return O?h.create(F,z):s.create(F,z);const W=P.get(F);return typeof W=="boolean"?O===(W?"true":"false")?E.INSTANCE:l.INSTANCE:new p(F,O,z)}cmp(F){return F.type!==this.type?this.type-F.type:D(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=P.get(this.key);if(typeof F=="boolean"){const O=F?"true":"false";return this.value===O?E.INSTANCE:l.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=p;class v{constructor(F,O){this.key=F,this.valueKey=O,this.type=10,this.negated=null}static create(F,O){return new v(F,O)}cmp(F){return F.type!==this.type?this.type-F.type:D(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const O=F.getValue(this.valueKey),z=F.getValue(this.key);return Array.isArray(O)?O.indexOf(z)>=0:typeof z=="string"&&typeof O=="object"&&O!==null?k.call(O,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=A.create(this)),this.negated}}e.ContextKeyInExpr=v;class A{constructor(F){this._actual=F,this.type=11}static create(F){return new A(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new A(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotInExpr=A;class w{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=5}static create(F,O,z=null){if(typeof O=="boolean")return O?s.create(F,z):h.create(F,z);const W=P.get(F);return typeof W=="boolean"?O===(W?"true":"false")?l.INSTANCE:E.INSTANCE:new w(F,O,z)}cmp(F){return F.type!==this.type?this.type-F.type:D(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=P.get(this.key);if(typeof F=="boolean"){const O=F?"true":"false";return this.value===O?l.INSTANCE:E.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class s{constructor(F,O){this.key=F,this.negated=O,this.type=3}static create(F,O=null){const z=P.get(F);return typeof z=="boolean"?z?l.INSTANCE:E.INSTANCE:new s(F,O)}cmp(F){return F.type!==this.type?this.type-F.type:d(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=P.get(this.key);return typeof F=="boolean"?F?l.INSTANCE:E.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=s;function o(B,F){if(typeof B=="string"){const O=parseFloat(B);isNaN(O)||(B=O)}return typeof B=="string"||typeof B=="number"?F(B):l.INSTANCE}class g{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=12}static create(F,O,z=null){return o(O,W=>new g(F,W,z))}cmp(F){return F.type!==this.type?this.type-F.type:D(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=g;class c{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=13}static create(F,O,z=null){return o(O,W=>new c(F,W,z))}cmp(F){return F.type!==this.type?this.type-F.type:D(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=c;class S{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=14}static create(F,O,z=null){return o(O,W=>new S(F,W,z))}cmp(F){return F.type!==this.type?this.type-F.type:D(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=S;class r{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=15}static create(F,O,z=null){return o(O,W=>new r(F,W,z))}cmp(F){return F.type!==this.type?this.type-F.type:D(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class t{constructor(F,O){this.key=F,this.regexp=O,this.type=7,this.negated=null}static create(F,O){return new t(F,O)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const O=this.regexp?this.regexp.source:"",z=F.regexp?F.regexp.source:"";return O<z?-1:O>z?1:0}equals(F){if(F.type===this.type){const O=this.regexp?this.regexp.source:"",z=F.regexp?F.regexp.source:"";return this.key===F.key&&O===z}return!1}substituteConstants(){return this}evaluate(F){let O=F.getValue(this.key);return this.regexp?this.regexp.test(O):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class n{constructor(F){this._actual=F,this.type=8}static create(F){return new n(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new n(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function u(B){let F=null;for(let O=0,z=B.length;O<z;O++){const W=B[O].substituteConstants();if(B[O]!==W&&F===null){F=[];for(let M=0;M<O;M++)F[M]=B[M]}F!==null&&(F[O]=W)}return F===null?B:F}class a{constructor(F,O){this.expr=F,this.negated=O,this.type=6}static create(F,O){return a._normalizeArr(F,O)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let O=0,z=this.expr.length;O<z;O++){const W=T(this.expr[O],F.expr[O]);if(W!==0)return W}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].equals(F.expr[O]))return!1;return!0}return!1}substituteConstants(){const F=u(this.expr);return F===this.expr?this:a.create(F,this.negated)}evaluate(F){for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].evaluate(F))return!1;return!0}static _normalizeArr(F,O){const z=[];let W=!1;for(const M of F)if(!!M){if(M.type===1){W=!0;continue}if(M.type===0)return l.INSTANCE;if(M.type===6){z.push(...M.expr);continue}z.push(M)}if(z.length===0&&W)return E.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(T);for(let M=1;M<z.length;M++)z[M-1].equals(z[M])&&(z.splice(M,1),M--);if(z.length===1)return z[0];for(;z.length>1;){const M=z[z.length-1];if(M.type!==9)break;z.pop();const x=z.pop(),V=z.length===0,U=f.create(M.expr.map(H=>a.create([H,x],null)),null,V);U&&(z.push(U),z.sort(T))}return z.length===1?z[0]:new a(z,O)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(let O of this.expr)F.push(...O.keys());return F}map(F){return new a(this.expr.map(O=>O.map(F)),null)}negate(){if(!this.negated){const F=[];for(let O of this.expr)F.push(O.negate());this.negated=f.create(F,this,!0)}return this.negated}}class f{constructor(F,O){this.expr=F,this.negated=O,this.type=9}static create(F,O,z){return f._normalizeArr(F,O,z)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let O=0,z=this.expr.length;O<z;O++){const W=T(this.expr[O],F.expr[O]);if(W!==0)return W}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].equals(F.expr[O]))return!1;return!0}return!1}substituteConstants(){const F=u(this.expr);return F===this.expr?this:f.create(F,this.negated,!1)}evaluate(F){for(let O=0,z=this.expr.length;O<z;O++)if(this.expr[O].evaluate(F))return!0;return!1}static _normalizeArr(F,O,z){let W=[],M=!1;if(F){for(let x=0,V=F.length;x<V;x++){const U=F[x];if(!!U){if(U.type===0){M=!0;continue}if(U.type===1)return E.INSTANCE;if(U.type===9){W=W.concat(U.expr);continue}W.push(U)}}if(W.length===0&&M)return l.INSTANCE;W.sort(T)}if(W.length!==0){if(W.length===1)return W[0];for(let x=1;x<W.length;x++)W[x-1].equals(W[x])&&(W.splice(x,1),x--);if(W.length===1)return W[0];if(z){for(let x=0;x<W.length;x++)for(let V=x+1;V<W.length;V++)R(W[x],W[V])&&(W.splice(V,1),V--);if(W.length===1)return W[0]}return new f(W,O)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(let O of this.expr)F.push(...O.keys());return F}map(F){return new f(this.expr.map(O=>O.map(F)),null)}negate(){if(!this.negated){let F=[];for(let O of this.expr)F.push(O.negate());for(;F.length>1;){const O=F.shift(),z=F.shift(),W=[];for(const x of N(O))for(const V of N(z))W.push(a.create([x,V],null));const M=F.length===0;F.unshift(f.create(W,null,M))}this.negated=F[0]}return this.negated}}class b extends h{constructor(F,O,z){super(F,null);this._defaultValue=O,typeof z=="object"?b._info.push({...z,key:F}):z!==!0&&b._info.push({key:F,description:z,type:O!=null?typeof O:void 0})}static all(){return b._info.values()}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return p.create(this.key,F)}notEqualsTo(F){return w.create(this.key,F)}}e.RawContextKey=b,b._info=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(B,F){return B<F?-1:B>F?1:0}function D(B,F,O,z){return B<O?-1:B>O?1:F<z?-1:F>z?1:0}function R(B,F){if(F.type===6&&B.type!==9&&B.type!==6){for(const W of F.expr)if(B.equals(W))return!0}const O=B.negate(),z=N(O).concat(N(F));z.sort(T);for(let W=0;W<z.length;W++){const x=z[W].negate();for(let V=W+1;V<z.length;V++){const U=z[V];if(x.equals(U))return!0}}return!1}e.implies=R;function N(B){return B.type===9?B.expr:[B]}}),define(we[182],be([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(we[183],be([0,1,10,156,4]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(s){s.WIN32_X64="win32-x64",s.WIN32_IA32="win32-ia32",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function P(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function k(s){switch(s){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function _(s,o){switch(s){case 3:return o==="x64"?"win32-x64":o==="ia32"?"win32-ia32":o==="arm64"?"win32-arm64":"unknown";case 2:return o==="x64"?"linux-x64":o==="arm64"?"linux-arm64":o==="arm"?"linux-armhf":"unknown";case"alpine":return o==="x64"?"alpine-x64":o==="arm64"?"alpine-arm64":"unknown";case 1:return o==="x64"?"darwin-x64":o==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function I(s,o){return o==="web"&&!s.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function L(s,o,g){return I(o,g)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===g?!0:T(g).includes(s)}e.isTargetPlatformCompatible=L;function T(s){switch(s){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=T;function l(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=l;var E;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var h;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var p;(function(s){s.Install="install",s.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var v;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,y.createDecorator)("extensionGalleryService");var A;(function(s){s.Unsupported="Unsupported",s.UnsupportedPreRelease="UnsupportedPreRelease",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatiblePreRelease="IncompatiblePreRelease",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Internal="Internal"})(A=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(o,g){super(o);this.code=g,this.name=g}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,y.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,y.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,y.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=m.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,y.createDecorator)("IExtensionManagementCLIService")}),define(we[184],be([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(we[185],be([0,1,37,10,9,12,94,28,112,158,184]),function(Y,e,m,i,y,C,P,k,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const T=I.localize(0,null);class l{async getDefaultTerminalForPlatforms(){return{windows:E.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class E extends l{openTerminal(o,g){return this.spawnTerminal(m,o,_.getWindowsShell(),g)}spawnTerminal(o,g,c,S){const r=g.windowsExec||E.getDefaultTerminalWindows();S&&S[1]===":"&&(S=S[0].toUpperCase()+S.substr(1));const t=y.basename(r).toLowerCase();if(t==="cmder"||t==="cmder.exe")return o.spawn(r,S?[S]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),(t==="wt"||t==="wt.exe")&&n.push("-d ."),new Promise((u,a)=>{const f=v(process),b=o.spawn(c,n,{cwd:S,env:f});b.on("error",a),b.on("exit",()=>u())})}runInTerminal(o,g,c,S,r){const t="windowsExec"in r&&r.windowsExec?r.windowsExec:E.getDefaultTerminalWindows();return new Promise((n,u)=>{const a=`"${g} - ${T}"`,f=`""${c.join('" "')}" & pause"`,b=["/c","start",a,"/wait",t,"/c",f],d=Object.assign({},v(process),S);Object.keys(d).filter(N=>d[N]===null).forEach(N=>delete d[N]);const D={cwd:g,env:d,windowsVerbatimArguments:!0};m.spawn(E.CMD,b,D).on("error",N=>{u(A(N))}),n(void 0)})}static getDefaultTerminalWindows(){if(!E._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");E._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return E._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=E,E.CMD="cmd.exe";class h extends l{openTerminal(o,g){return this.spawnTerminal(m,o,g)}runInTerminal(o,g,c,S,r){const t=r.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((n,u)=>{if(t===L.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const a=t===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",b=[i.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${a}.scpt`,Y).fsPath,"-t",o||T,"-w",g];for(let R of c)b.push("-a"),b.push(R);if(S){const R=Object.assign({},v(process),S);for(let N in R){const B=R[N];B===null?(b.push("-u"),b.push(N)):(b.push("-e"),b.push(`${N}=${B}`))}}let d="";const D=m.spawn(h.OSASCRIPT,b);D.on("error",R=>{u(A(R))}),D.stderr.on("data",R=>{d+=R.toString()}),D.on("exit",R=>{if(R===0)n(void 0);else if(d){const N=d.split(`
`,1);u(new Error(N[0]))}else u(new Error(I.localize(1,null,a,R)))})}else u(new Error(I.localize(2,null,t)))})}spawnTerminal(o,g,c){const S=g.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,t)=>{const n=["-a",S];c&&n.push(c);const u=v(process),a=o.spawn("/usr/bin/open",n,{cwd:c,env:u});a.on("error",t),a.on("exit",()=>r())})}}e.MacExternalTerminalService=h,h.OSASCRIPT="/usr/bin/osascript";class p extends l{openTerminal(o,g){return this.spawnTerminal(m,o,g)}runInTerminal(o,g,c,S,r){const t=r.linuxExec?Promise.resolve(r.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((n,u)=>{let a=[];t.then(f=>{f.indexOf("gnome-terminal")>=0?a.push("-x"):a.push("-e"),a.push("bash"),a.push("-c");const b=`${w(c)}; echo; read -p "${p.WAIT_MESSAGE}" -n1;`;a.push(`''${b}''`);const d=Object.assign({},v(process),S);Object.keys(d).filter(B=>d[B]===null).forEach(B=>delete d[B]);const D={cwd:g,env:d};let R="";const N=m.spawn(f,a,D);N.on("error",B=>{u(A(B))}),N.stderr.on("data",B=>{R+=B.toString()}),N.on("exit",B=>{if(B===0)n(void 0);else if(R){const F=R.split(`
`,1);u(new Error(F[0]))}else u(new Error(I.localize(4,null,f,B)))})})})}static async getDefaultTerminalLinuxReady(){if(!p._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)p._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const o=await k.Promises.exists("/etc/debian_version");p._DEFAULT_TERMINAL_LINUX_READY=new Promise(g=>{o?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return p._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,g,c){const S=g.linuxExec?Promise.resolve(g.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((r,t)=>{S.then(n=>{const u=v(process),a=o.spawn(n,[],{cwd:c,env:u});a.on("error",t),a.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=p,p.WAIT_MESSAGE=I.localize(3,null);function v(s){const o={...s.env};return(0,P.sanitizeProcessEnvironment)(o),o}function A(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(I.localize(5,null,s.path)):s}function w(s){let o="";for(let g of s)g.indexOf(" ")>=0?o+='"'+g+'"':o+=g,o+=" ";return o}}),define(we[42],be([0,1,24,9,8,13,2,159,4]),function(Y,e,m,i,y,C,P,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function I(W){return W.create===!0}e.isFileOpenForWriteOptions=I;var L;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var T;(function(W){W[W.Readonly=1]="Readonly"})(T=e.FilePermission||(e.FilePermission={}));var l;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=E;function h(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=h;function p(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function v(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=v;function A(W){return E(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=A;var w;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class s extends Error{constructor(M,x){super(M);this.code=x}}e.FileSystemProviderError=s;function o(W,M){const x=new s(W.toString(),M);return c(x,M),x}e.createFileSystemProviderError=o;function g(W){return W||o((0,k.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=g;function c(W,M){return W.name=M?`${M} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=c;function S(W){if(!W)return w.Unknown;if(W instanceof s)return W.code;const M=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!M)return w.Unknown;switch(M[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=S;function r(W){if(W instanceof b)return W.fileOperationResult;switch(S(W)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var t;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class n{constructor(M,x,V){this.resource=M,this.operation=x,this.target=V}isOperation(M){return this.operation===M}}e.FileOperationEvent=n;var u;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class a{constructor(M,x){this.added=void 0,this.updated=void 0,this.deleted=void 0;const V=new Map;for(const U of M){const H=V.get(U.type);H?H.push([U.resource,U]):V.set(U.type,[[U.resource,U]])}for(const[U,H]of V)switch(U){case 1:this.added=m.TernarySearchTree.forUris(()=>x),this.added.fill(H);break;case 0:this.updated=m.TernarySearchTree.forUris(()=>x),this.updated.fill(H);break;case 2:this.deleted=m.TernarySearchTree.forUris(()=>x),this.deleted.fill(H);break}}contains(M,...x){return this.doContains(M,{includeChildren:!1},...x)}affects(M,...x){return this.doContains(M,{includeChildren:!0},...x)}doContains(M,x,...V){if(!M)return!1;const U=V.length>0;return!!((!U||V.includes(1))&&(this.added?.get(M)||x.includeChildren&&this.added?.findSuperstr(M))||(!U||V.includes(0))&&(this.updated?.get(M)||x.includeChildren&&this.updated?.findSuperstr(M))||(!U||V.includes(2))&&(this.deleted?.findSubstr(M)||x.includeChildren&&this.deleted?.findSuperstr(M)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=a;function f(W,M,x){return!W||!M||W===M||M.length>W.length?!1:(M.charAt(M.length-1)!==i.sep&&(M+=i.sep),x?(0,y.startsWithIgnoreCase)(W,M):W.indexOf(M)===0)}e.isParent=f;class b extends Error{constructor(M,x,V){super(M);this.fileOperationResult=x,this.options=V}}e.FileOperationError=b;class d extends b{constructor(M,x,V){super(M,2,V);this.stat=x}}e.NotModifiedSinceFileOperationError=d;var D;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(D=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=N;async function B(W,M){if(!M.hasProvider(P.URI.from({scheme:W.scheme})))return new Promise(x=>{const V=M.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===W.scheme&&U.added&&(V.dispose(),x())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(M){return(0,C.isNumber)(M)||(M=0),M<F.KB?(0,k.localize)(1,null,M.toFixed(0)):M<F.MB?(0,k.localize)(2,null,(M/F.KB).toFixed(2)):M<F.GB?(0,k.localize)(3,null,(M/F.MB).toFixed(2)):M<F.TB?(0,k.localize)(4,null,(M/F.GB).toFixed(2)):(0,k.localize)(5,null,(M/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var O;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(O=e.Arch||(e.Arch={}));function z(W){return{maxFileSize:W===0?300*F.MB:16*F.GB,maxHeapSize:W===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=z}),define(we[85],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...y){this._entries=new Map;for(let[C,P]of y)this.set(C,P)}set(y,C){const P=this._entries.get(y);return this._entries.set(y,C),P}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}e.ServiceCollection=m}),define(we[186],be([0,1,18,15,114,179,4,85]),function(Y,e,m,i,y,C,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class I extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class L{constructor(h=new k.ServiceCollection,p=!1,v){this._activeInstantiations=new Set,this._services=h,this._strict=p,this._parent=v,this._services.set(P.IInstantiationService,this)}createChild(h){return new L(h,this._strict,this)}invokeFunction(h,...p){let v=l.traceInvocation(h),A=!1;try{return h({get:s=>{if(A)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(s,v);if(!o)throw new Error(`[invokeFunction] unknown service '${s}'`);return o}},...p)}finally{A=!0,v.stop()}}createInstance(h,...p){let v,A;return h instanceof y.SyncDescriptor?(v=l.traceCreation(h.ctor),A=this._createInstance(h.ctor,h.staticArguments.concat(p),v)):(v=l.traceCreation(h),A=this._createInstance(h,p,v)),v.stop(),A}_createInstance(h,p=[],v){let A=P._util.getServiceDependencies(h).sort((o,g)=>o.index-g.index),w=[];for(const o of A){let g=this._getOrCreateServiceInstance(o.id,v);if(!g&&this._strict&&!o.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${o.id}.`);w.push(g)}let s=A.length>0?A[0].index:p.length;if(p.length!==s){console.warn(`[createInstance] First service dependency of ${h.name} at position ${s+1} conflicts with ${p.length} static arguments`);let o=s-p.length;o>0?p=p.concat(new Array(o)):p=p.slice(0,s)}return new h(...[...p,...w])}_setServiceInstance(h,p){if(this._services.get(h)instanceof y.SyncDescriptor)this._services.set(h,p);else if(this._parent)this._parent._setServiceInstance(h,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let p=this._services.get(h);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):p}_getOrCreateServiceInstance(h,p){let v=this._getServiceInstanceOrDescriptor(h);return v instanceof y.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,v,p.branch(h,!0)):(p.branch(h,!1),v)}_safeCreateAndCacheServiceInstance(h,p,v){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,p,v)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,p,v){const A=new C.Graph(o=>o.id.toString());let w=0;const s=[{id:h,desc:p,_trace:v}];for(;s.length;){const o=s.pop();if(A.lookupOrInsertNode(o),w++>1e3)throw new I(A);for(let g of P._util.getServiceDependencies(o.desc.ctor)){let c=this._getServiceInstanceOrDescriptor(g.id);if(!c&&!g.optional&&console.warn(`[createInstance] ${h} depends on ${g.id} which is NOT registered.`),c instanceof y.SyncDescriptor){const S={id:g.id,desc:c,_trace:o._trace.branch(g.id,!0)};A.insertEdge(o,S),s.push(S)}}}for(;;){const o=A.roots();if(o.length===0){if(!A.isEmpty())throw new I(A);break}for(const{data:g}of o){if(this._getServiceInstanceOrDescriptor(g.id)instanceof y.SyncDescriptor){const S=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,S)}A.removeNode(g)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,p,v=[],A,w){if(this._services.get(h)instanceof y.SyncDescriptor)return this._createServiceInstance(p,v,A,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,p,v,A,w);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(h,p=[],v,A){if(v){const w=new m.IdleValue(()=>this._createInstance(h,p,A));return new Proxy(Object.create(null),{get(s,o){if(o in s)return s[o];let g=w.value,c=g[o];return typeof c!="function"||(c=c.bind(g),s[o]=c),c},set(s,o,g){return w.value[o]=g,!0}})}else return this._createInstance(h,p,A)}}e.InstantiationService=L;var T;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(T||(T={}));class l{constructor(h,p){this.type=h,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return _?new l(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(h){return _?new l(0,h.name):l._None}branch(h,p){let v=new l(2,h.toString());return this._dep.push([h,p,v]),v}stop(){let h=Date.now()-this._start;l._totals+=h;let p=!1;function v(w,s){let o=[],g=new Array(w+1).join("	");for(const[c,S,r]of s._dep)if(S&&r){p=!0,o.push(`${g}CREATES -> ${c}`);let t=v(w+1,r);t&&o.push(t)}else o.push(`${g}uses -> ${c}`);return o.join(`
`)}let A=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(h>2||p)&&console.log(A.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(we[11],be([0,1,50,3,6,12,4]),function(Y,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function k(){return new Date().toISOString()}var _;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;function I(S,r,t){switch(r){case _.Trace:S.trace(t);break;case _.Debug:S.debug(t);break;case _.Info:S.info(t);break;case _.Warning:S.warn(t);break;case _.Error:S.error(t);break;case _.Critical:S.critical(t);break;default:throw new Error("Invalid log level")}}e.log=I;function L(S){let r="";for(let t=0;t<S.length;t++){let n=S[t];if(typeof n=="object")try{n=JSON.stringify(n)}catch{}r+=(t>0?" ":"")+n}return r}e.format=L;class T extends y.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new i.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class l extends T{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...t){this.checkLogLevel(_.Trace)&&this.log(_.Trace,L([r,...t]))}debug(r,...t){this.checkLogLevel(_.Debug)&&this.log(_.Debug,L([r,...t]))}info(r,...t){this.checkLogLevel(_.Info)&&this.log(_.Info,L([r,...t]))}warn(r,...t){this.checkLogLevel(_.Warning)&&this.log(_.Warning,L([r,...t]))}error(r,...t){if(this.checkLogLevel(_.Error))if(r instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=r.stack,this.log(_.Error,L(n))}else this.log(_.Error,L([r,...t]))}critical(r,...t){this.checkLogLevel(_.Critical)&&this.log(_.Critical,L([r,...t]))}flush(){}}e.AbstractMessageLogger=l;class E extends T{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!C.isWindows}trace(r,...t){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,r,...t):console.log(`[main ${k()}]`,r,...t))}debug(r,...t){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,r,...t):console.log(`[main ${k()}]`,r,...t))}info(r,...t){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,r,...t):console.log(`[main ${k()}]`,r,...t))}warn(r,...t){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,r,...t):console.warn(`[main ${k()}]`,r,...t))}error(r,...t){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,r,...t):console.error(`[main ${k()}]`,r,...t))}critical(r,...t){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,r,...t):console.error(`[main ${k()}]`,r,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class h extends T{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...t){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",r,...t)}debug(r,...t){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...t)}info(r,...t){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",r,...t)}warn(r,...t){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",r,...t)}error(r,...t){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",r,...t)}critical(r,...t){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class p extends T{constructor(r,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(t)}trace(r,...t){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(r),...t])}debug(r,...t){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(r),...t])}info(r,...t){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(r),...t])}warn(r,...t){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(r),...t])}error(r,...t){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(r),...t])}critical(r,...t){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(r),...t])}extractMessage(r){return typeof r=="string"?r:(0,m.toErrorMessage)(r,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class v extends T{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const t of this.logServices)t.setLevel(r);super.setLevel(r)}trace(r,...t){for(const n of this.logServices)n.trace(r,...t)}debug(r,...t){for(const n of this.logServices)n.debug(r,...t)}info(r,...t){for(const n of this.logServices)n.info(r,...t)}warn(r,...t){for(const n of this.logServices)n.warn(r,...t)}error(r,...t){for(const n of this.logServices)n.error(r,...t)}critical(r,...t){for(const n of this.logServices)n.critical(r,...t)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=v;class A extends y.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...t){this.logger.trace(r,...t)}debug(r,...t){this.logger.debug(r,...t)}info(r,...t){this.logger.info(r,...t)}warn(r,...t){this.logger.warn(r,...t)}error(r,...t){this.logger.error(r,...t)}critical(r,...t){this.logger.critical(r,...t)}flush(){this.logger.flush()}}e.LogService=A;class w extends y.Disposable{constructor(r,t){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(n))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,t){let n=this.loggers.get(r.toString());return n||(n=this.doCreateLogger(r,t?.always?_.Trace:this.logLevel,t),this.loggers.set(r.toString(),n),t?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class s{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(r){}getLevel(){return _.Info}trace(r,...t){}debug(r,...t){}info(r,...t){}warn(r,...t){}error(r,...t){}critical(r,...t){}dispose(){}flush(){}}e.NullLogService=s;function o(S){if(S.verbose)return _.Trace;if(typeof S.logLevel=="string"){const r=g(S.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function g(S){switch(S){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=g;function c(S){switch(S){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=c}),define(we[187],be([0,1,42,11]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function y(k,_,I,L,T){try{const l=await new Promise((h,p)=>{Y(["spdlog"],h,p)});l.setFlushOn(i.LogLevel.Trace);const E=await l.createAsyncRotatingLogger(k,_,I,L);return T&&E.clearFormatters(),E}catch(l){console.error(l)}return null}function C(k,_,I){switch(_){case i.LogLevel.Trace:k.trace(I);break;case i.LogLevel.Debug:k.debug(I);break;case i.LogLevel.Info:k.info(I);break;case i.LogLevel.Warning:k.warn(I);break;case i.LogLevel.Error:k.error(I);break;case i.LogLevel.Critical:k.critical(I);break;default:throw new Error("Invalid log level")}}class P extends i.AbstractMessageLogger{constructor(_,I,L,T,l){super();this.buffer=[],this.setLevel(l),this._loggerCreationPromise=this._createSpdLogLogger(_,I,L,T),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}async _createSpdLogLogger(_,I,L,T){const l=L?6:1,E=30/l*m.ByteSize.MB,h=await y(_,I,E,l,T);if(h){this._logger=h,this._logger.setLevel(this.getLevel());for(const{level:p,message:v}of this.buffer)C(this._logger,p,v);this.buffer=[]}}log(_,I){this._logger?C(this._logger,_,I):this.getLevel()<=_&&this.buffer.push({level:_,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(we[116],be([0,1,48,160,4]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var P;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(P=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function I(h,p){return p-h}_.compare=I;const L=Object.create(null);L[_.Error]=(0,i.localize)(0,null),L[_.Warning]=(0,i.localize)(1,null),L[_.Info]=(0,i.localize)(2,null);function T(h){return L[h]||""}_.toString=T;function l(h){switch(h){case m.default.Error:return _.Error;case m.default.Warning:return _.Warning;case m.default.Info:return _.Info;case m.default.Ignore:return _.Hint}}_.fromSeverity=l;function E(h){switch(h){case _.Error:return m.default.Error;case _.Warning:return m.default.Warning;case _.Info:return m.default.Info;case _.Hint:return m.default.Ignore}}_.toSeverity=E}(P=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(_){const I="";function L(l){return T(l,!0)}_.makeKey=L;function T(l,E){let h=[I];return l.source?h.push(l.source.replace("\xA6","\\\xA6")):h.push(I),l.code?typeof l.code=="string"?h.push(l.code.replace("\xA6","\\\xA6")):h.push(l.code.value.replace("\xA6","\\\xA6")):h.push(I),l.severity!==void 0&&l.severity!==null?h.push(P.toString(l.severity)):h.push(I),l.message&&E?h.push(l.message.replace("\xA6","\\\xA6")):h.push(I),l.startLineNumber!==void 0&&l.startLineNumber!==null?h.push(l.startLineNumber.toString()):h.push(I),l.startColumn!==void 0&&l.startColumn!==null?h.push(l.startColumn.toString()):h.push(I),l.endLineNumber!==void 0&&l.endLineNumber!==null?h.push(l.endLineNumber.toString()):h.push(I),l.endColumn!==void 0&&l.endColumn!==null?h.push(l.endColumn.toString()):h.push(I),h.push(I),h.join("\xA6")}_.makeKeyOptionalMessage=T})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(we[188],be([0,1,3,48,4]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=i.default,e.INotificationService=(0,y.createDecorator)("notificationService");var C;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var P;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(P=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new _,this.onDidClose=m.Event.None,this.onDidChangeVisibility=m.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=k;class _{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=_}),define(we[189],be([0,1,6,8,2,4]),function(Y,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(_){return{resolved:_,dispose(){}}}});function P(_,I){return y.URI.isUri(_)?(0,i.equalsIgnoreCase)(_.scheme,I):(0,i.startsWithIgnoreCase)(_,I+":")}e.matchesScheme=P;function k(_,...I){return I.some(L=>P(_,L))}e.matchesSomeScheme=k}),define(we[190],be([0,1,10,12,40,23]),function(Y,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof i.globals.vscode!="undefined"&&typeof i.globals.vscode.context!="undefined"){const k=i.globals.vscode.context.configuration();if(k)P=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const k=(0,C.dirname)(m.FileAccess.asFileUri("",Y));P=Y.__$__nodeRequire((0,C.joinPath)(k,"product.json").fsPath);const _=Y.__$__nodeRequire((0,C.joinPath)(k,"package.json").fsPath);y.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`}),Object.assign(P,{version:_.version})}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=P});var ze=this&&this.__param||function(Y,e){return function(m,i){e(m,i,Y)}};define(we[117],be([0,1,18,21,6,4]),function(Y,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var P;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(P=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(T){this.callback=T}get value(){return this._value}report(T){this._value=T,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let _=class extends y.Disposable{constructor(T,l){super();this.deferred=new m.DeferredPromise,l.withProgress(T,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,y.toDisposable)(()=>this.deferred.complete()))}report(T){this.reporter?this.reporter.report(T):this.lastStep=T}};_=je([ze(1,e.IProgressService)],_),e.UnmanagedProgress=_;class I extends y.Disposable{constructor(T){super();this.progressIndicator=T,this.currentOperationId=0,this.currentOperationDisposables=this._register(new y.DisposableStore)}start(T){this.stop();const l=++this.currentOperationId,E=new i.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},T),this.currentOperationDisposables.add((0,y.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,y.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,y.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:E.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(T){this.currentOperationId===T&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(we[51],be([0,1,56,13]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.data=new Map}add(P,k){m.ok(i.isString(P)),m.ok(i.isObject(k)),m.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,k)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new y}),define(we[191],be([0,1,3,51]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class C{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,I){this.schemasById[y(_)]=I,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new C;i.Registry.add(e.Extensions.JSONContribution,P)}),define(we[118],be([0,1,16,3,13,155,191,51]),function(Y,e,m,i,y,C,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var _;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(_=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const L=k.Registry.as(P.Extensions.JSONContribution);class T{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new i.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new i.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(g,c=!0){this.registerConfigurations([g],c)}registerConfigurations(g,c=!0){const S=this.doRegisterConfigurations(g,c);L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:S})}deregisterConfigurations(g){const c=this.doDeregisterConfigurations(g);L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}updateConfigurations({add:g,remove:c}){const S=[];S.push(...this.doDeregisterConfigurations(c)),S.push(...this.doRegisterConfigurations(g,!1)),L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,m.distinct)(S)})}registerDefaultConfigurations(g){const c=[],S=[];for(const{overrides:r,source:t}of g)for(const n in r)if(c.push(n),e.OVERRIDE_PROPERTY_REGEX.test(n)){const u={...this.configurationDefaultsOverrides.get(n)?.value||{},...r[n]};this.configurationDefaultsOverrides.set(n,{source:t,value:u});const a={type:"object",default:u,description:C.localize(1,null,n),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:u,source:y.isString(t)?void 0:t};S.push(...h(n)),this.configurationProperties[n]=a,this.defaultLanguageConfigurationOverridesNode.properties[n]=a}else{this.configurationDefaultsOverrides.set(n,{value:r[n],source:t});const u=this.configurationProperties[n];u&&(this.updatePropertyDefaultValue(n,u),this.updateSchema(n,u))}this.registerOverrideIdentifiers(S),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}deregisterDefaultConfigurations(g){const c=[];for(const{overrides:S,source:r}of g)for(const t in S){const n=this.configurationDefaultsOverrides.get(t),u=y.isString(r)?r:r?.id,a=y.isString(n?.source)?n?.source:n?.source?.id;if(u===a)if(c.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const f=this.configurationProperties[t];f&&(this.updatePropertyDefaultValue(t,f),this.updateSchema(t,f))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){for(const c of g)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(g,c){const S=[];return g.forEach(r=>{S.push(...this.validateAndRegisterProperties(r,c,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),S}doDeregisterConfigurations(g){const c=[],S=r=>{if(r.properties)for(const t in r.properties)c.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,r.properties[t]);r.allOf&&r.allOf.forEach(t=>S(t))};for(const r of g){S(r);const t=this.configurationContributors.indexOf(r);t!==-1&&this.configurationContributors.splice(t,1)}return c}validateAndRegisterProperties(g,c=!0,S,r,t=3){t=y.isUndefinedOrNull(g.scope)?t:g.scope;let n=[],u=g.properties;if(u)for(let f in u){if(c&&w(f)){delete u[f];continue}const b=u[f];if(b.source=S,b.defaultDefaultValue=u[f].default,this.updatePropertyDefaultValue(f,b),e.OVERRIDE_PROPERTY_REGEX.test(f)?b.scope=void 0:(b.scope=y.isUndefinedOrNull(b.scope)?t:b.scope,b.restricted=y.isUndefinedOrNull(b.restricted)?!!r?.includes(f):b.restricted),u[f].hasOwnProperty("included")&&!u[f].included){this.excludedConfigurationProperties[f]=u[f],delete u[f];continue}else this.configurationProperties[f]=u[f];!u[f].deprecationMessage&&u[f].markdownDeprecationMessage&&(u[f].deprecationMessage=u[f].markdownDeprecationMessage),n.push(f)}let a=g.allOf;if(a)for(let f of a)n.push(...this.validateAndRegisterProperties(f,c,S,r,t));return n}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(g){const c=S=>{let r=S.properties;if(r)for(const n in r)this.updateSchema(n,r[n]);let t=S.allOf;t&&t.forEach(c)};c(g)}updateSchema(g,c){switch(e.allSettings.properties[g]=c,c.scope){case 1:e.applicationSettings.properties[g]=c;break;case 2:e.machineSettings.properties[g]=c;break;case 6:e.machineOverridableSettings.properties[g]=c;break;case 3:e.windowSettings.properties[g]=c;break;case 4:e.resourceSettings.properties[g]=c;break;case 5:e.resourceSettings.properties[g]=c,this.resourceLanguageSettingsSchema.properties[g]=c;break}}removeFromSchema(g,c){switch(delete e.allSettings.properties[g],c.scope){case 1:delete e.applicationSettings.properties[g];break;case 2:delete e.machineSettings.properties[g];break;case 6:delete e.machineOverridableSettings.properties[g];break;case 3:delete e.windowSettings.properties[g];break;case 4:case 5:delete e.resourceSettings.properties[g],delete this.resourceLanguageSettingsSchema.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const c=`[${g}]`,S={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,S),e.allSettings.properties[c]=S,e.applicationSettings.properties[c]=S,e.machineSettings.properties[c]=S,e.machineOverridableSettings.properties[c]=S,e.windowSettings.properties[c]=S,e.resourceSettings.properties[c]=S}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const g={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,c){const S=this.configurationDefaultsOverrides.get(g);let r=S?.value,t=S?.source;y.isUndefined(r)&&(r=c.defaultDefaultValue,t=void 0),y.isUndefined(r)&&(r=v(c.type)),c.default=r,c.defaultValueSource=t}}const l="\\[([^\\]]+)\\]",E=new RegExp(l,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${l})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(o){const g=[];if(e.OVERRIDE_PROPERTY_REGEX.test(o)){let c=E.exec(o);for(;c?.length;){const S=c[1].trim();S&&g.push(S),c=E.exec(o)}}return(0,m.distinct)(g)}e.overrideIdentifiersFromKey=h;function p(o){return o.reduce((g,c)=>`${g}[${c}]`,"")}e.keyFromOverrideIdentifiers=p;function v(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const A=new T;k.Registry.add(e.Extensions.Configuration,A);function w(o){return o.trim()?e.OVERRIDE_PROPERTY_REGEX.test(o)?C.localize(7,null,o):A.getConfigurationProperties()[o]!==void 0?C.localize(8,null,o):null:C.localize(6,null)}e.validateProperty=w;function s(){const o=[],g=A.getConfigurationProperties();for(const c of Object.keys(g))o.push([c,g[c].scope]);return o.push(["launch",4]),o.push(["task",4]),o}e.getScopes=s}),define(we[192],be([0,1,16,3,58,6,24,25,13,2,115,118,51]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class E{constructor(r={},t=[],n=[]){this._contents=r,this._keys=t,this._overrides=n,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,L.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,t){const n=this.getContentsForOverrideIdentifer(t);return n?r?(0,L.getConfigurationValue)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const t=[];for(const n of this.overrides)n.identifiers.includes(r)&&t.push(...n.keys);return m.distinct(t)}getAllOverrideIdentifiers(){const r=[];for(const t of this.overrides)r.push(...t.identifiers);return m.distinct(r)}override(r){let t=this.overrideConfigurations.get(r);return t||(t=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,t)),t}merge(...r){const t=k.deepClone(this.contents),n=k.deepClone(this.overrides),u=[...this.keys];for(const a of r){this.mergeContents(t,a.contents);for(const f of a.overrides){const[b]=n.filter(d=>m.equals(d.identifiers,f.identifiers));b?(this.mergeContents(b.contents,f.contents),b.keys.push(...f.keys),b.keys=m.distinct(b.keys)):n.push(k.deepClone(f))}for(const f of a.keys)u.indexOf(f)===-1&&u.push(f)}return new E(t,u,n)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const t=this.getContentsForOverrideIdentifer(r);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let n={};for(const u of m.distinct([...Object.keys(this.contents),...Object.keys(t)])){let a=this.contents[u],f=t[u];f&&(typeof a=="object"&&typeof f=="object"?(a=k.deepClone(a),this.mergeContents(a,f)):a=f),n[u]=a}return new E(n,this.keys,this.overrides)}mergeContents(r,t){for(const n of Object.keys(t)){if(n in r&&_.isObject(r[n])&&_.isObject(t[n])){this.mergeContents(r[n],t[n]);continue}r[n]=k.deepClone(t[n])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?k.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let t=null,n=null;const u=a=>{a&&(n?this.mergeContents(n,a):n=k.deepClone(a))};for(const a of this.overrides)m.equals(a.identifiers,[r])?t=a.contents:a.identifiers.includes(r)&&u(a.contents);return u(t),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,t){this.addKey(r),(0,L.addToValueTree)(this.contents,r,t,n=>{throw new Error(n)})}removeValue(r){this.removeKey(r)&&(0,L.removeFromValueTree)(this.contents,r)}addKey(r){let t=this.keys.length;for(let n=0;n<t;n++)r.indexOf(this.keys[n])===0&&(t=n);this.keys.splice(t,1,r)}removeKey(r){let t=this.keys.indexOf(r);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=E;class h extends E{constructor(r={}){const t=l.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),n=Object.keys(t),u=Object.create(null),a=[];for(const f in t){const b=r[f],d=b!==void 0?b:t[f].default;(0,L.addToValueTree)(u,f,d,D=>console.error(`Conflict in default settings: ${D}`))}for(const f of Object.keys(u))T.OVERRIDE_PROPERTY_REGEX.test(f)&&a.push({identifiers:(0,T.overrideIdentifiersFromKey)(f),keys:Object.keys(u[f]),contents:(0,L.toValuesTree)(u[f],b=>console.error(`Conflict in default settings file: ${b}`))});super(u,n,a)}}e.DefaultConfigurationModel=h;class p{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,t){if(!_.isUndefinedOrNull(r)){const n=this.doParseContent(r);this.parseRaw(n,t)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,t){this._raw=r;const{contents:n,keys:u,overrides:a,restricted:f}=this.doParseRaw(r,t);this._configurationModel=new E(n,u,a),this._restrictedConfigurations=f||[]}doParseContent(r){let t={},n=null,u=[],a=[],f=[];function b(D){Array.isArray(u)?u.push(D):n!==null&&(u[n]=D)}let d={onObjectBegin:()=>{let D={};b(D),a.push(u),u=D,n=null},onObjectProperty:D=>{n=D},onObjectEnd:()=>{u=a.pop()},onArrayBegin:()=>{let D=[];b(D),a.push(u),u=D,n=null},onArrayEnd:()=>{u=a.pop()},onLiteralValue:b,onError:(D,R,N)=>{f.push({error:D,offset:R,length:N})}};if(r)try{y.visit(r,d),t=u[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return t}doParseRaw(r,t){const n=l.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),u=this.filter(r,n,!0,t);r=u.raw;const a=(0,L.toValuesTree)(r,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),f=Object.keys(r),b=this.toOverrides(r,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:a,keys:f,overrides:b,restricted:u.restricted}}filter(r,t,n,u){if(!u?.scopes&&!u?.skipRestricted)return{raw:r,restricted:[]};const a={},f=[];for(let b in r)if(T.OVERRIDE_PROPERTY_REGEX.test(b)&&n){const d=this.filter(r[b],t,!1,u);a[b]=d.raw,f.push(...d.restricted)}else{const d=t[b],D=d?typeof d.scope!="undefined"?d.scope:3:void 0;d?.restricted&&f.push(b),(D===void 0||u.scopes===void 0||u.scopes.includes(D))&&(u.skipRestricted&&d?.restricted||(a[b]=r[b]))}return{raw:a,restricted:f}}toOverrides(r,t){const n=[];for(const u of Object.keys(r))if(T.OVERRIDE_PROPERTY_REGEX.test(u)){const a={};for(const f in r[u])a[f]=r[u][f];n.push({identifiers:(0,T.overrideIdentifiersFromKey)(u),keys:Object.keys(a),contents:(0,L.toValuesTree)(a,t)})}return n}}e.ConfigurationModelParser=p;class v extends C.Disposable{constructor(r,t,n,u){super();this.userSettingsResource=r,this.scopes=t,this.fileService=u,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(i.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class A{constructor(r,t,n=new E,u=new E,a=new P.ResourceMap,f=new E,b=new P.ResourceMap,d=!0){this._defaultConfiguration=r,this._localUserConfiguration=t,this._remoteUserConfiguration=n,this._workspaceConfiguration=u,this._folderConfigurations=a,this._memoryConfiguration=f,this._memoryConfigurationByResource=b,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(r,t,n){return this.getConsolidateConfigurationModel(t,n).getValue(r)}updateValue(r,t,n={}){let u;n.resource?(u=this._memoryConfigurationByResource.get(n.resource),u||(u=new E,this._memoryConfigurationByResource.set(n.resource,u))):u=this._memoryConfiguration,t===void 0?u.removeValue(r):u.setValue(r,t),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,t,n){const u=this.getConsolidateConfigurationModel(t,n),a=this.getFolderConfigurationModelForResource(t.resource,n),f=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,b=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),d=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),D=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),R=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),N=n?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,B=a?t.overrideIdentifier?a.freeze().override(t.overrideIdentifier).getValue(r):a.freeze().getValue(r):void 0,F=t.overrideIdentifier?f.override(t.overrideIdentifier).getValue(r):f.getValue(r),O=u.getValue(r),z=m.distinct(m.flatten(u.overrides.map(W=>W.identifiers))).filter(W=>u.getOverrideValue(r,W)!==void 0);return{defaultValue:b,userValue:d,userLocalValue:D,userRemoteValue:R,workspaceValue:N,workspaceFolderValue:B,memoryValue:F,value:O,default:b!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,userLocal:D!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,userRemote:R!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,workspaceFolder:B!==void 0?{value:a?.freeze().getValue(r),override:t.overrideIdentifier?a?.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:f.getValue(r),override:t.overrideIdentifier?f.getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(r){const t=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,t){this._folderConfigurations.set(r,t),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,t){const n=[];if(!t){const{added:u,updated:a,removed:f}=g(this._defaultConfiguration,r);t=[...u,...a,...f]}for(const u of t)for(const a of(0,T.overrideIdentifiersFromKey)(u)){const f=this._defaultConfiguration.getKeysForOverrideIdentifier(a),b=r.getKeysForOverrideIdentifier(a),d=[...b.filter(D=>f.indexOf(D)===-1),...f.filter(D=>b.indexOf(D)===-1),...f.filter(D=>!k.equals(this._defaultConfiguration.override(a).getValue(D),r.override(a).getValue(D)))];n.push([a,d])}return this.updateDefaultConfiguration(r),{keys:t,overrides:n}}compareAndUpdateLocalUserConfiguration(r){const{added:t,updated:n,removed:u,overrides:a}=g(this.localUserConfiguration,r),f=[...t,...n,...u];return f.length&&this.updateLocalUserConfiguration(r),{keys:f,overrides:a}}compareAndUpdateRemoteUserConfiguration(r){const{added:t,updated:n,removed:u,overrides:a}=g(this.remoteUserConfiguration,r);let f=[...t,...n,...u];return f.length&&this.updateRemoteUserConfiguration(r),{keys:f,overrides:a}}compareAndUpdateWorkspaceConfiguration(r){const{added:t,updated:n,removed:u,overrides:a}=g(this.workspaceConfiguration,r);let f=[...t,...n,...u];return f.length&&this.updateWorkspaceConfiguration(r),{keys:f,overrides:a}}compareAndUpdateFolderConfiguration(r,t){const n=this.folderConfigurations.get(r),{added:u,updated:a,removed:f,overrides:b}=g(n,t);let d=[...u,...a,...f];return(d.length||!n)&&this.updateFolderConfiguration(r,t),{keys:d,overrides:b}}compareAndDeleteFolderConfiguration(r){const t=this.folderConfigurations.get(r);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:u,removed:a,overrides:f}=g(t,void 0);return{keys:[...n,...u,...a],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,t){let n=this.getConsolidatedConfigurationModelForResource(r,t);return r.overrideIdentifier?n.override(r.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:r},t){let n=this.getWorkspaceConsolidatedConfiguration();if(t&&r){const u=t.getFolder(r);u&&(n=this.getFolderConsolidatedConfiguration(u.uri)||n);const a=this._memoryConfigurationByResource.get(r);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let t=this._foldersConsolidatedConfigurations.get(r);if(!t){const n=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(r);u?(t=n.merge(u),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(r,t)):t=n}return t}getFolderConfigurationModelForResource(r,t){if(t&&r){const n=t.getFolder(r);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,t)=>{const{contents:n,overrides:u,keys:a}=this._folderConfigurations.get(t);return r.push([t,{contents:n,overrides:u,keys:a}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>r.add(t)),this.userConfiguration.freeze().keys.forEach(t=>r.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>r.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(n=>r.add(n))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(u=>t.add(u))),[...t.values()]}static parse(r){const t=this.parseConfigurationModel(r.defaults),n=this.parseConfigurationModel(r.user),u=this.parseConfigurationModel(r.workspace),a=r.folders.reduce((f,b)=>(f.set(I.URI.revive(b[0]),this.parseConfigurationModel(b[1])),f),new P.ResourceMap);return new A(t,n,new E,u,a,new E,new P.ResourceMap,!1)}static parseConfigurationModel(r){return new E(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=A;function w(...S){if(S.length===0)return{keys:[],overrides:[]};if(S.length===1)return S[0];const r=new Set,t=new Map;for(const u of S)u.keys.forEach(a=>r.add(a)),u.overrides.forEach(([a,f])=>{const b=(0,P.getOrSet)(t,a,new Set);f.forEach(d=>b.add(d))});const n=[];return t.forEach((u,a)=>n.push([a,[...u.values()]])),{keys:[...r.values()],overrides:n}}e.mergeChanges=w;class s{constructor(r,t,n,u){this.change=r,this.previous=t,this.currentConfiguraiton=n,this.currentWorkspace=u,this._previousConfiguration=void 0;const a=new Set;r.keys.forEach(b=>a.add(b)),r.overrides.forEach(([,b])=>b.forEach(d=>a.add(d))),this.affectedKeys=[...a.values()];const f=new E;this.affectedKeys.forEach(b=>f.setValue(b,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=A.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(t){const n=this.previousConfiguration?this.previousConfiguration.getValue(r,t,this.previous?.workspace):void 0,u=this.currentConfiguraiton.getValue(r,t,this.currentWorkspace);return!k.equals(n,u)}return!0}return!1}doesAffectedKeysTreeContains(r,t){let n=(0,L.toValuesTree)({[t]:!0},()=>{}),u;for(;typeof n=="object"&&(u=Object.keys(n)[0]);){if(r=r[u],!r)return!1;n=n[u]}return!0}}e.ConfigurationChangeEvent=s;class o extends s{constructor(r,t,n,u){super({keys:r.allKeys(),overrides:[]},void 0,r,t);this.source=n,this.sourceConfig=u}}e.AllKeysConfigurationChangeEvent=o;function g(S,r){const{added:t,removed:n,updated:u}=c(r,S),a=[],f=S?.getAllOverrideIdentifiers()||[],b=r?.getAllOverrideIdentifiers()||[];if(r){const d=b.filter(D=>!f.includes(D));for(const D of d)a.push([D,r.getKeysForOverrideIdentifier(D)])}if(S){const d=f.filter(D=>!b.includes(D));for(const D of d)a.push([D,S.getKeysForOverrideIdentifier(D)])}if(r&&S){for(const d of f)if(b.includes(d)){const D=c({contents:S.getOverrideValue(void 0,d)||{},keys:S.getKeysForOverrideIdentifier(d)},{contents:r.getOverrideValue(void 0,d)||{},keys:r.getKeysForOverrideIdentifier(d)});a.push([d,[...D.added,...D.removed,...D.updated]])}}return{added:t,removed:n,updated:u,overrides:a}}function c(S,r){const t=S?r?S.keys.filter(a=>r.keys.indexOf(a)===-1):[...S.keys]:[],n=r?S?r.keys.filter(a=>S.keys.indexOf(a)===-1):[...r.keys]:[],u=[];if(S&&r){for(const a of r.keys)if(S.keys.indexOf(a)!==-1){const f=(0,L.getConfigurationValue)(r.contents,a),b=(0,L.getConfigurationValue)(S.contents,a);k.equals(f,b)||u.push(a)}}return{added:t,removed:n,updated:u}}}),define(we[119],be([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var i;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(i=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class y extends Error{constructor(P,k=i.Unknown,_){super(P);this._message=P,this._code=k,this._detail=_,this.isHandled=k===i.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,y.prototype)}static isTemporarilyNotAvailable(P){return P instanceof y&&P._code===i.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof y&&P._code===i.NoResolverFound}static isHandled(P){return P instanceof y&&P.isHandled}}e.RemoteAuthorityResolverError=y}),define(we[62],be([0,1,10]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function i(I){return I.scheme===m.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=i;function y(I){if(!I)return;const L=I.indexOf("+");return L<0?I:I.substr(0,L)}e.getRemoteName=y;function C(I){return I.scheme!==m.Schemas.file&&I.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=C;function P(I){if(I.folders.length)return I.folders.every(L=>C(L.uri))?I.folders[0].uri:void 0;if(I.configuration&&C(I.configuration))return I.configuration}e.getVirtualWorkspaceLocation=P;function k(I){return P(I)?.scheme}e.getVirtualWorkspaceScheme=k;function _(I){return P(I)!==void 0}e.isVirtualWorkspace=_}),define(we[27],be([0,1,8,4,62]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.getWorkspaceSupportTypeMessage=C;function P(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class _{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,h){if(typeof E=="undefined"||E===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof E=="string"||typeof h=="string"){let p=typeof E=="string"?E:E.value,v=typeof h=="string"?h:h.value;return m.equalsIgnoreCase(p,v)}return E._lower===h._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=_;function I(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function L(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=L;function T(l,E){if(E){const h=`onResolveRemoteAuthority:${(0,y.getRemoteName)(E)}`;return l.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=T,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[193],be([0,1,8,27]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function y(h,p){return h.uuid&&p.uuid?h.uuid===p.uuid:h.id===p.id?!0:(0,m.compareIgnoreCase)(h.id,p.id)===0}e.areSameExtensions=y;class C{constructor(p,v){this.version=v,this.id=p.id,this.uuid=p.uuid}key(){return`${this.id}-${this.version}`}equals(p){return p instanceof C?y(this,p)&&this.version===p.version:!1}}e.ExtensionIdentifierWithVersion=C;function P(h,p){return`${h}.${p}`}e.getExtensionId=P;function k(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function _(h,p){return k(P(h,p))}e.getGalleryExtensionId=_;function I(h,p){const v=[],A=w=>{for(const s of v)if(s.some(o=>y(p(o),p(w))))return s;return null};for(const w of h){const s=A(w);s?s.push(w):v.push([w])}return v}e.groupByExtension=I;function L(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=L;function T(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=T,e.BetterMergeId=new i.ExtensionIdentifier("pprice.better-merge");function l(h){const p=new Set;if(h.malicious)for(const v of h.malicious)p.add(v.id);return p}e.getMaliciousExtensionsSet=l;function E(h,p){const v=[],A=p.manifest.extensionDependencies?.slice(0)??[];for(;A.length;){const w=A.shift();if(w&&v.every(s=>!y(s.identifier,{id:w}))){const s=h.filter(o=>y(o.identifier,{id:w}));s.length===1&&(v.push(s[0]),A.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=E}),define(we[120],be([0,1,3,12,4,11]),function(Y,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var P;(function(h){h.Http="http",h.Https="https"})(P=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var _;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(_=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function T(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=T;function l(h,p){return p?p!==1&&h<1024:!i.isWindows&&h<1024}e.isPortPrivileged=l;let E=class{constructor(p){this.logService=p,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p,v){return this._tunnelProvider=p,p?(this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const p=[],v=Array.from(this._tunnels.values());for(let A of v){const w=Array.from(A.values());for(let s of w){const o=await s.value;o&&p.push(o)}}return p}async dispose(){for(const p of this._tunnels.values()){for(const{value:v}of p.values())await v.then(A=>A?.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,v,A,w,s=!1,o=k.Private,g){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${A} on local port ${w}.`),!p)return;v||(v="localhost");const c=this.retainOrCreateTunnel(p,v,A,w,s,o,g);return c?c.then(S=>{if(!S){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,A);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(S);return(S.tunnelRemoteHost!==v||S.tunnelRemotePort!==A)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,privacy:p.privacy,protocol:p.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const v=this._tunnels.get(p.tunnelRemoteHost);if(v){const A=v.get(p.tunnelRemotePort);A&&(A.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,A))}}}}async tryDisposeTunnel(p,v,A){if(A.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${v}.`);const w=A.value.then(async s=>{s&&(await s.dispose(!0),this._onTunnelClosed.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(v),w}}async closeTunnel(p,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${v} `);const A=this._tunnels.get(p);if(A&&A.has(v)){const w=A.get(v);w.refcount=0,await this.tryDisposeTunnel(p,v,w)}}addTunnelToMap(p,v,A){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(v,{refcount:1,value:A})}async removeEmptyTunnelFromMap(p,v){const A=this._tunnels.get(p);A&&(await A.get(v)||A.delete(v),A.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,v){let A=[p];L(p)?(A.push(...e.LOCALHOST_ADDRESSES),A.push(...e.ALL_INTERFACES_ADDRESSES)):T(p)&&A.push(...e.ALL_INTERFACES_ADDRESSES);const w=A.map(s=>this._tunnels.get(s));for(const s of w){const o=s?.get(v);if(o)return o}}canTunnel(p){return!!I(p)}createWithProvider(p,v,A,w,s,o,g){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${A} on local port ${w}.`);const S={elevationRequired:s?l(w===void 0?A:w):!1},r={remoteAddress:{host:v,port:A},localAddressPort:w,privacy:o,public:o!==k.Private,protocol:g},t=p.forwardPort(r,S);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(v,A,t),t}};E=je([ze(0,C.ILogService)],E),e.AbstractTunnelService=E}),define(we[194],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{constructor(){this.validators=new Map}vsda(){return new Promise((y,C)=>Y(["vsda"],y,C))}async createNewMessage(y){try{const C=await this.vsda(),P=new C.validator;if(P){const k=String(m._nextId++);return this.validators.set(k,P),{id:k,data:P.createNewMessage(y)}}}catch{}return{id:"",data:y}}async validate(y,C){if(!y.id)return!0;const P=this.validators.get(y.id);if(!P)return!1;this.validators.delete(y.id);try{return P.validate(C)==="ok"}catch{return!1}}async sign(y){try{const C=await this.vsda(),P=new C.signer;if(P)return P.sign(y)}catch{}return y}}e.SignService=m,m._nextId=1}),define(we[195],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(y){this._callback=y,this._terminalBufferMap=new Map}dispose(){for(const y of this._terminalBufferMap.values())y.dispose()}startBuffering(y,C,P=5){let k;return k=C(_=>{const I=typeof _=="string"?_:_.data;let L=this._terminalBufferMap.get(y);if(L){L.data.push(I);return}const T=setTimeout(()=>this.flushBuffer(y),P);L={data:[I],timeoutId:T,dispose:()=>{clearTimeout(T),this.flushBuffer(y),k.dispose()}},this._terminalBufferMap.set(y,L)}),k}stopBuffering(y){const C=this._terminalBufferMap.get(y);C&&C.dispose()}flushBuffer(y){const C=this._terminalBufferMap.get(y);C&&(this._terminalBufferMap.delete(y),this._callback(y,C.data.join("")))}}e.TerminalDataBufferer=m}),define(we[196],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(i){i.DARK="dark",i.LIGHT="light",i.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(we[86],be([0,1,73,3,6,4,51,196]),function(Y,e,m,i,y,C,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var _;(function(v){function A(w){return w&&typeof w=="object"&&typeof w.id=="string"}v.isThemeColor=A})(_=e.ThemeColor||(e.ThemeColor={}));function I(v){return{id:v}}e.themeColorFromId=I;var L;(function(v){function A(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||_.isThemeColor(t.color))}v.isThemeIcon=A;const w=new RegExp(`^\\$\\((${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?)\\)$`);function s(t){const n=w.exec(t);if(!n)return;let[,u]=n;return{id:u}}v.fromString=s;function o(t){return{id:t}}v.fromId=o;function g(t,n){let u=t.id;const a=u.lastIndexOf("~");return a!==-1&&(u=u.substring(0,a)),n&&(u=`${u}~${n}`),{id:u}}v.modify=g;function c(t){const n=t.id.lastIndexOf("~");if(n!==-1)return t.id.substring(n+1)}v.getModifier=c;function S(t,n){return t.id===n.id&&t.color?.id===n.color?.id}v.isEqual=S;function r(t,n){return{id:t.id,color:n?I(n):void 0}}v.asThemeIcon=r,v.asClassNameArray=m.CSSIcon.asClassNameArray,v.asClassName=m.CSSIcon.asClassName,v.asCSSSelector=m.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=m.Codicon.file,e.FolderThemeIcon=m.Codicon.folder;function T(v){switch(v){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=T,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(A){return this.themingParticipants.push(A),this.onThemingParticipantAddedEmitter.fire(A),(0,y.toDisposable)(()=>{const w=this.themingParticipants.indexOf(A);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let E=new l;P.Registry.add(e.Extensions.ThemingContribution,E);function h(v){return E.onColorThemeChange(v)}e.registerThemingParticipant=h;class p extends y.Disposable{constructor(A){super();this.themeService=A,this.theme=A.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(A){this.theme=A,this.updateStyles()}updateStyles(){}getColor(A,w){let s=this.theme.getColor(A);return s&&w&&(s=w(s,this.theme)),s?s.toString():null}}e.Themable=p}),define(we[43],be([0,1,24,23,2,4]),function(Y,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var P;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function k(l){const E=l;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&Array.isArray(E.folders))}e.isWorkspace=k;function _(l){const E=l;return!!(E&&typeof E=="object"&&y.URI.isUri(E.uri)&&typeof E.name=="string"&&typeof E.toResource=="function")}e.isWorkspaceFolder=_;class I{constructor(E,h,p,v,A){this._id=E,this._transient=p,this._configuration=v,this._ignorePathCasing=A,this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=h}update(E){this._id=E.id,this._configuration=E.configuration,this._transient=E.transient,this._ignorePathCasing=E._ignorePathCasing,this.folders=E.folders}get folders(){return this._folders}set folders(E){this._folders=E,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(E){this._configuration=E}getFolder(E){return E&&this._foldersMap.findSubstr(E.with({scheme:E.scheme,authority:E.authority,path:E.path}))||null}updateFoldersMap(){this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing);for(const E of this.folders)this._foldersMap.set(E.uri,E)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=I;class L{constructor(E,h){this.raw=h,this.uri=E.uri,this.index=E.index,this.name=E.name}toResource(E){return(0,i.joinPath)(this.uri,E)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=L;function T(l){return new L({uri:l,index:0,name:(0,i.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=T}),define(we[197],be([0,1,30,58,139,80,10,9,12,23,2,161,4,62,43]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const p=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(M){return(typeof M=="string"?(0,k.extname)(M):(0,I.extname)(M))===p}e.hasWorkspaceFileExtension=v,e.IWorkspacesService=(0,l.createDecorator)("workspacesService");function A(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=A;function w(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=w;function s(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=s;function o(M){return M&&M.hasOwnProperty("folderUri")}e.isFolderBackupInfo=o;function g(M){return M&&M.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=g;function c(M){const x=M;return typeof x?.id=="string"&&L.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=c;function S(M){if(M.configuration)return{id:M.id,configPath:M.configuration};if(M.folders.length===1)return{id:M.id,uri:M.folders[0].uri}}e.toWorkspaceIdentifier=S;function r(M){const x=M;return typeof x?.id=="string"&&L.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=r;function t(M){const x=M;if(x?.uri)return{id:x.id,uri:L.URI.revive(x.uri)};const V=M;if(V?.configPath)return{id:V.id,configPath:L.URI.revive(V.configPath)};if(M?.id)return{id:M.id}}e.reviveIdentifier=t;function n(M,x){return I.extUriBiasedIgnorePathCase.isEqualOrParent(M,x.untitledWorkspacesHome)}e.isUntitledWorkspace=n;function u(M){return a(M)||f(M)}e.isStoredWorkspaceFolder=u;function a(M){const x=M;return typeof x?.path=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=a;function f(M){const x=M;return typeof x?.uri=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=f;function b(M,x,V,U,H=!_.isWindows,X){if(M.scheme!==U.scheme)return{name:V,uri:M.toString(!0)};let se=x?void 0:X.relativePath(U,M);if(se!==void 0)se.length===0?se=".":_.isWindows&&M.scheme===P.Schemas.file&&!H&&(se=se.replace(/\//g,"\\"));else if(M.scheme===P.Schemas.file)se=M.fsPath,_.isWindows&&(se=(0,C.normalizeDriveLetter)(se),H&&(se=(0,m.toSlashes)(se)));else{if(!X.isEqualAuthority(M.authority,U.authority))return{name:V,uri:M.toString(!0)};se=M.path}return{name:V,path:se}}e.getStoredWorkspaceFolder=b;function d(M,x,V){let U=[],H=new Set;const X=V.dirname(x);for(let se of M){let K;if(a(se))se.path&&(K=V.resolvePath(X,se.path));else if(f(se))try{K=L.URI.parse(se.uri),K.path[0]!=="/"&&(K=K.with({path:"/"+K.path}))}catch(j){console.warn(j)}if(K){let j=V.getComparisonKey(K);if(!H.has(j)){H.add(j);const ie=se.name||V.basenameOrAuthority(K);U.push(new h.WorkspaceFolder({uri:K,name:ie,index:U.length},se))}}}return U}e.toWorkspaceFolders=d;function D(M,x,V,U,H){let X=R(x,M);const se=H.dirname(x),K=H.dirname(U),j=[],ie=N(X.folders);for(const Le of X.folders){const Oe=a(Le)?H.resolvePath(se,Le.path):L.URI.parse(Le.uri);let q;V?q=!1:q=!a(Le)||(0,k.isAbsolute)(Le.path),j.push(b(Oe,q,Le.name,K,ie,H))}const ce={insertSpaces:!1,tabSize:4,eol:_.isLinux||_.isMacintosh?`
`:`\r
`},ge=y.setProperty(M,["folders"],j,ce);let ke=y.applyEdits(M,ge);return(0,I.isEqualAuthority)(X.remoteAuthority,(0,E.getRemoteAuthority)(U))&&(ke=y.applyEdits(ke,y.removeProperty(ke,["remoteAuthority"],ce))),ke}e.rewriteWorkspaceFileForNewLocation=D;function R(M,x){let V=i.parse(x);if(V&&Array.isArray(V.folders))V.folders=V.folders.filter(U=>u(U));else throw new Error(`${M} looks like an invalid workspace file.`);return V}function N(M){return _.isWindows?M.some(x=>a(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=N;function B(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function F(M){return typeof M.folderUri=="string"}function O(M){return typeof M.fileUri=="string"}function z(M,x){const V={workspaces:[],files:[]};if(M){const U=function(X,se){for(let K=0;K<X.length;K++)try{se(X[K],K)}catch(j){x.warn(`Error restoring recent entry ${JSON.stringify(X[K])}: ${j.toString()}. Skip entry.`)}},H=M;if(Array.isArray(H.entries))U(H.entries,X=>{const se=X.label,K=X.remoteAuthority;B(X)?V.workspaces.push({label:se,remoteAuthority:K,workspace:{id:X.workspace.id,configPath:L.URI.parse(X.workspace.configPath)}}):F(X)?V.workspaces.push({label:se,remoteAuthority:K,folderUri:L.URI.parse(X.folderUri)}):O(X)&&V.files.push({label:se,remoteAuthority:K,fileUri:L.URI.parse(X.fileUri)})});else{const X=M;Array.isArray(X.workspaces3)&&U(X.workspaces3,(se,K)=>{const j=Array.isArray(X.workspaceLabels)&&X.workspaceLabels[K]||void 0;typeof se=="object"&&typeof se.id=="string"&&typeof se.configURIPath=="string"?V.workspaces.push({label:j,workspace:{id:se.id,configPath:L.URI.parse(se.configURIPath)}}):typeof se=="string"&&V.workspaces.push({label:j,folderUri:L.URI.parse(se)})}),Array.isArray(X.files2)&&U(X.files2,(se,K)=>{const j=Array.isArray(X.fileLabels)&&X.fileLabels[K]||void 0;typeof se=="string"&&V.files.push({label:j,fileUri:L.URI.parse(se)})})}}return V}e.restoreRecentlyOpened=z;function W(M){const x={entries:[]};for(const V of M.workspaces)w(V)?x.entries.push({folderUri:V.folderUri.toString(),label:V.label,remoteAuthority:V.remoteAuthority}):x.entries.push({workspace:{id:V.workspace.id,configPath:V.workspace.configPath.toString()},label:V.label,remoteAuthority:V.remoteAuthority});for(const V of M.files)x.entries.push({fileUri:V.fileUri.toString(),label:V.label,remoteAuthority:V.remoteAuthority});return x}e.toStoreData=W}),define(we[87],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(y){this.id=y,this._data=new Map,this._idPool=1}add(y){const C=this._idPool++;return this._data.set(C,y),this.logDebugInfo(),C}get(y,C){return this._data.has(y)?this._data.get(y)[C]:void 0}delete(y){this._data.delete(y),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(we[44],be([0,1,10,23,4]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map,this.extUri=new i.ExtUri(k=>{const _=this._providerInfo.get(k.scheme);return!(_===void 0||_&1024)})}$acceptProviderInfos(k,_){_===null?this._providerInfo.delete(k.scheme):this._providerInfo.set(k.scheme,_)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(we[26],be([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(we[198],be([0,1,18]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class i{constructor(P,k,_){this._deferredPromises=new Map,this._id=P,this._shared=k,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of I.values())L.complete()}catch(L){for(const T of I.values())T.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this._init}get(P,k){let _=this._value[P];return typeof _=="undefined"&&(_=k),_}update(P,k){this._value[P]=k;let _=this._deferredPromises.get(P);if(_!==void 0)return _.p;const I=new m.DeferredPromise;return this._deferredPromises.set(P,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=i;class y extends i{constructor(P,k){super(P.identifier.value,!0,k);this._extension=P}setKeysForSync(P){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},P)}}e.ExtensionGlobalMemento=y}),define(we[199],be([0,1,3,2,11]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(k,_){this._logService=k,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,_,I){this._notebooksAndEditors.getNotebookDocument(i.URI.revive(k)).acceptModelChanged(_.value,I)}$acceptDirtyStateChanged(k,_){this._notebooksAndEditors.getNotebookDocument(i.URI.revive(k)).acceptDirty(_)}$acceptModelSaved(k){const _=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(k));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(k,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,_);const I=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(k));I.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:I.apiNotebook})}};C=je([ze(0,y.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(we[14],be([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class i{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=i});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},xe=this&&this.__classPrivateFieldGet||function(Y,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(Y):i?i.value:e.get(Y)};define(we[200],be([0,1,27,3]),function(Y,e,m,i){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(k,_){y.set(this,void 0),this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(k.identifier),nt(this,y,_,"f"),xe(this,y,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(k){return xe(this,y,"f").get(this._id,k)}store(k,_){return xe(this,y,"f").store(this._id,k,_)}delete(k){return xe(this,y,"f").delete(this._id,k)}}e.ExtensionSecrets=C,y=new WeakMap}),define(we[121],be([0,1,4,3]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class y{constructor(){this._onDidChangeTelemetryEnabled=new i.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(P){this._enabled=P}$onDidChangeTelemetryEnabled(P){this._enabled=P,this._onDidChangeTelemetryEnabled.fire(P)}}e.ExtHostTelemetry=y,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(we[63],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var m;(function(w){w[w.Upsert=0]="Upsert",w[w.RemoveChild=1]="RemoveChild",w[w.Invalidated=2]="Invalidated",w[w.SetProp=3]="SetProp",w[w.Bulk=4]="Bulk"})(m=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const i=new WeakMap,y=(w,s)=>{const o={controllerId:s};return i.set(w,o),o};e.createPrivateApiFor=y;const C=w=>i.get(w);e.getPrivateApiFor=C;const P=(w,s,o,g)=>{let c=o;return{enumerable:!0,configurable:!1,get(){return c},set(S){if(!g(c,S)){const r=c;c=S,w.listener?.({op:3,key:s,value:S,previous:r})}}}},k=(w,s)=>w===s,_={range:(w,s)=>w===s?!0:!w||!s?!1:w.isEqual(s),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(w,s)=>!(w.length!==s.length||w.some(o=>!s.find(g=>o.id===g.id)))},I=Object.keys(_),L=(w,s)=>({range:P(w,"range",void 0,_.range),label:P(w,"label",s,_.label),description:P(w,"description",void 0,_.description),canResolveChildren:P(w,"canResolveChildren",!1,_.canResolveChildren),busy:P(w,"busy",!1,_.busy),error:P(w,"error",void 0,_.error),tags:P(w,"tags",[],_.tags)}),T=(w,s)=>{const o=new Map;for(const g of I)_[g](w[g],s[g])||o.set(g,s[g]);return o};e.diffTestItems=T;class l extends Error{constructor(s){super(`Attempted to insert a duplicate test item ID ${s}`)}}e.DuplicateTestItemError=l;class E extends Error{constructor(s){super(`TestItem with ID "${s}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=E;class h extends Error{constructor(s,o,g){super(`TestItem with ID "${s}" is from controller "${o}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=h;const p=w=>{const s=(0,e.getPrivateApiFor)(w);let o=new Map;return{get size(){return o.size},forEach(g,c){for(const S of o.values())g.call(c,S,this)},replace(g){const c=new Map,S=new Set(o.keys()),r={op:4,ops:[]};for(const t of g){if(!(t instanceof v))throw new E(t.id);const n=(0,e.getPrivateApiFor)(t).controllerId;if(n!==s.controllerId)throw new h(t.id,n,s.controllerId);if(c.has(t.id))throw new l(t.id);c.set(t.id,t),S.delete(t.id),r.ops.push({op:0,item:t})}for(const t of S.keys())r.ops.push({op:1,id:t});s.listener?.(r),o=c},add(g){if(!(g instanceof v))throw new E(g.id);o.set(g.id,g),s.listener?.({op:0,item:g})},delete(g){o.delete(g)&&s.listener?.({op:1,id:g})},get(g){return o.get(g)},toJSON(){return Array.from(o.values())},[Symbol.iterator](){return o.values()}}};class v{constructor(s,o,g,c){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const S=(0,e.createPrivateApiFor)(this,s);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:c,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return S.parent instanceof A?void 0:S.parent}},children:{value:p(this),enumerable:!0,writable:!1},...L(S,g)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=v;class A extends v{constructor(s,o){super(s,s,o,void 0)}}e.TestItemRootImpl=A}),define(we[52],be([0,1,4,120,3,14]),function(Y,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var P;(function(_){function I(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public,privacy:T.privacy??(T.public?i.TunnelPrivacyId.Public:i.TunnelPrivacyId.Private),protocol:T.protocol}}_.fromApiTunnel=I;function L(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.privacy!==i.TunnelPrivacyId.ConstantPrivate&&T.privacy!==i.TunnelPrivacyId.ConstantPrivate,privacy:T.privacy,protocol:T.protocol}}_.fromServiceTunnel=L})(P=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let k=class{constructor(I){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,L){}async getTunnels(){return[]}async setTunnelExtensionFunctions(I){return{dispose:()=>{}}}registerPortsAttributesProvider(I,L){return{dispose:()=>{}}}async $providePortAttributes(I,L,T,l,E){return[]}async $forwardPort(I,L){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=je([ze(0,C.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},xe=this&&this.__classPrivateFieldGet||function(Y,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(Y):i?i.value:e.get(Y)};define(we[7],be([0,1,16,15,97,24,101,8,13,2,33,42,119]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l){"use strict";var E,h,p,v,A,w,s,o,g,c,S,r,t,n,u,a,f,b,d,D;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R(G){function $(){return Reflect.construct(G,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(G,"name")),Object.setPrototypeOf($,G),Object.setPrototypeOf($.prototype,G.prototype),$}let N=A=class{constructor($){E.set(this,void 0),nt(this,E,$,"f")}static from(...$){let le=$;return new A(function(){if(le){for(const Te of le)Te&&typeof Te.dispose=="function"&&Te.dispose();le=void 0}})}dispose(){typeof xe(this,E,"f")=="function"&&(xe(this,E,"f").call(this),nt(this,E,void 0,"f"))}};E=new WeakMap,N=A=je([R],N),e.Disposable=N;let B=w=class{constructor($,le){if($<0)throw(0,i.illegalArgument)("line must be non-negative");if(le<0)throw(0,i.illegalArgument)("character must be non-negative");this._line=$,this._character=le}static Min(...$){if($.length===0)throw new TypeError;let le=$[0];for(let Te=1;Te<$.length;Te++){const Ye=$[Te];Ye.isBefore(le)&&(le=Ye)}return le}static Max(...$){if($.length===0)throw new TypeError;let le=$[0];for(let Te=1;Te<$.length;Te++){const Ye=$[Te];Ye.isAfter(le)&&(le=Ye)}return le}static isPosition($){if(!$)return!1;if($ instanceof w)return!0;let{line:le,character:Te}=$;return typeof le=="number"&&typeof Te=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,le=0){if($===null||le===null)throw(0,i.illegalArgument)();let Te;return typeof $=="undefined"?Te=0:typeof $=="number"?Te=$:(Te=typeof $.lineDelta=="number"?$.lineDelta:0,le=typeof $.characterDelta=="number"?$.characterDelta:0),Te===0&&le===0?this:new w(this.line+Te,this.character+le)}with($,le=this.character){if($===null||le===null)throw(0,i.illegalArgument)();let Te;return typeof $=="undefined"?Te=this.line:typeof $=="number"?Te=$:(Te=typeof $.line=="number"?$.line:this.line,le=typeof $.character=="number"?$.character:this.character),Te===this.line&&le===this.character?this:new w(Te,le)}toJSON(){return{line:this.line,character:this.character}}};B=w=je([R],B),e.Position=B;let F=s=class{constructor($,le,Te,Ye){let rt,lt;if(typeof $=="number"&&typeof le=="number"&&typeof Te=="number"&&typeof Ye=="number"?(rt=new B($,le),lt=new B(Te,Ye)):$ instanceof B&&le instanceof B&&(rt=$,lt=le),!rt||!lt)throw new Error("Invalid arguments");rt.isBefore(lt)?(this._start=rt,this._end=lt):(this._start=lt,this._end=rt)}static isRange($){return $ instanceof s?!0:$?B.isPosition($.start)&&B.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof s?this.contains($._start)&&this.contains($._end):$ instanceof B?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const le=B.Max($.start,this._start),Te=B.Min($.end,this._end);if(!le.isAfter(Te))return new s(le,Te)}union($){if(this.contains($))return this;if($.contains(this))return $;const le=B.Min($.start,this._start),Te=B.Max($.end,this.end);return new s(le,Te)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,le=this.end){if($===null||le===null)throw(0,i.illegalArgument)();let Te;return $?B.isPosition($)?Te=$:(Te=$.start||this.start,le=$.end||this.end):Te=this.start,Te.isEqual(this._start)&&le.isEqual(this.end)?this:new s(Te,le)}toJSON(){return[this.start,this.end]}};F=s=je([R],F),e.Range=F;let O=o=class extends F{constructor($,le,Te,Ye){let rt,lt;if(typeof $=="number"&&typeof le=="number"&&typeof Te=="number"&&typeof Ye=="number"?(rt=new B($,le),lt=new B(Te,Ye)):$ instanceof B&&le instanceof B&&(rt=$,lt=le),!rt||!lt)throw new Error("Invalid arguments");super(rt,lt);this._anchor=rt,this._active=lt}static isSelection($){return $ instanceof o?!0:$?F.isRange($)&&B.isPosition($.anchor)&&B.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};O=o=je([R],O),e.Selection=O;class z{constructor($,le,Te){if(typeof $!="string"||$.length===0)throw(0,i.illegalArgument)("host");if(typeof le!="number"||le===0||Math.round(le)!==le)throw(0,i.illegalArgument)("port");if(typeof Te!="undefined"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z\-]+$/.test(Te)))throw(0,i.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(le),this.connectionToken=Te}}e.ResolvedAuthority=z;class W extends Error{constructor($,le=l.RemoteAuthorityResolverErrorCode.Unknown,Te){super($);this._message=$,this._code=le,this._detail=Te,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,W.prototype)}static NotAvailable($,le){return new W($,l.RemoteAuthorityResolverErrorCode.NotAvailable,le)}static TemporarilyNotAvailable($){return new W($,l.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=W;var M;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(M=e.EndOfLine||(e.EndOfLine={}));var x;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let V=g=class{constructor($,le){this._range=$,this._newText=le}static isTextEdit($){return $ instanceof g?!0:$?F.isRange($)&&typeof $.newText=="string":!1}static replace($,le){return new g($,le)}static insert($,le){return g.replace(new F($,$),le)}static delete($){return g.replace($,"")}static setEndOfLine($){const le=new g(new F(new B(0,0),new B(0,0)),"");return le.newEol=$,le}get range(){return this._range}set range($){if($&&!F.isRange($))throw(0,i.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,i.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,i.illegalArgument)("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};V=g=je([R],V),e.TextEdit=V;var U;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace"})(U=e.FileEditType||(e.FileEditType={}));let H=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,le,Te,Ye){this._edits.push({_type:1,from:$,to:le,options:Te,metadata:Ye})}createFile($,le,Te){this._edits.push({_type:1,from:void 0,to:$,options:le,metadata:Te})}deleteFile($,le,Te){this._edits.push({_type:1,from:$,to:void 0,options:le,metadata:Te})}replaceNotebookMetadata($,le,Te){this._edits.push({_type:3,metadata:Te,uri:$,edit:{editType:5,metadata:le},notebookMetadata:le})}replaceNotebookCells($,le,Te,Ye,rt){let lt,ht,kt=[],Ft;if($e.isNotebookRange(le)&&Bt.isNotebookCellDataArray(Te)&&!Bt.isNotebookCellDataArray(Ye)?(lt=le.start,ht=le.end,kt=Te,Ft=Ye):typeof le=="number"&&typeof Te=="number"&&Bt.isNotebookCellDataArray(Ye)&&(lt=le,ht=Te,kt=Ye,Ft=rt),lt===void 0||ht===void 0)throw new Error("Invalid arguments");(lt!==ht||kt.length>0)&&this._edits.push({_type:5,uri:$,index:lt,count:ht-lt,cells:kt,metadata:Ft})}replaceNotebookCellMetadata($,le,Te,Ye){this._edits.push({_type:3,metadata:Ye,uri:$,edit:{editType:8,index:le,metadata:Te}})}replace($,le,Te,Ye){this._edits.push({_type:2,uri:$,edit:new V(le,Te),metadata:Ye})}insert($,le,Te,Ye){this.replace($,new F(le,le),Te,Ye)}delete($,le,Te){this.replace($,le,"",Te)}has($){return this._edits.some(le=>le._type===2&&le.uri.toString()===$.toString())}set($,le){if(le)for(const Te of le)Te&&this._edits.push({_type:2,uri:$,edit:Te});else{for(let Te=0;Te<this._edits.length;Te++){const Ye=this._edits[Te];Ye._type===2&&Ye.uri.toString()===$.toString()&&(this._edits[Te]=void 0)}(0,m.coalesceInPlace)(this._edits)}}get($){const le=[];for(let Te of this._edits)Te._type===2&&Te.uri.toString()===$.toString()&&le.push(Te.edit);return le}entries(){const $=new C.ResourceMap;for(let le of this._edits)if(le._type===2){let Te=$.get(le.uri);Te||(Te=[le.uri,[]],$.set(le.uri,Te)),Te[1].push(le.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};H=je([R],H),e.WorkspaceEdit=H;let X=c=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof c?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=c._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,le=this._tabstop++){if(typeof $=="function"){const Te=new c;Te._tabstop=this._tabstop,$(Te),this._tabstop=Te._tabstop,$=Te.value}else $=c._escape($);return this.value+="${",this.value+=le,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,le=this._tabstop++){const Te=$.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=le,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable($,le){if(typeof le=="function"){const Te=new c;Te._tabstop=this._tabstop,le(Te),this._tabstop=Te._tabstop,le=Te.value}else typeof le=="string"&&(le=le.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,le&&(this.value+=":",this.value+=le),this.value+="}",this}};X=c=je([R],X),e.SnippetString=X;var se;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var K;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(K=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let j=S=class{constructor($,le){if(this.uri=$,le)if(le instanceof F)this.range=le;else if(le instanceof B)this.range=new F(le,le);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof S?!0:$?F.isRange($.range)&&I.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};j=S=je([R],j),e.Location=j;let ie=class{constructor($,le){this.location=$,this.message=le}static is($){return $?typeof $.message=="string"&&$.location&&F.isRange($.location.range)&&I.URI.isUri($.location.uri):!1}static isEqual($,le){return $===le?!0:!$||!le?!1:$.message===le.message&&$.location.range.isEqual(le.location.range)&&$.location.uri.toString()===le.location.uri.toString()}};ie=je([R],ie),e.DiagnosticRelatedInformation=ie;let ce=class{constructor($,le,Te=K.Error){if(!F.isRange($))throw new TypeError("range must be set");if(!le)throw new TypeError("message must be set");this.range=$,this.message=le,this.severity=Te}toJSON(){return{severity:K[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,le){return $===le?!0:!$||!le?!1:$.message===le.message&&$.severity===le.severity&&$.code===le.code&&$.severity===le.severity&&$.source===le.source&&$.range.isEqual(le.range)&&(0,m.equals)($.tags,le.tags)&&(0,m.equals)($.relatedInformation,le.relatedInformation,ie.isEqual)}};ce=je([R],ce),e.Diagnostic=ce;let ge=class{constructor($,le){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=le}};ge=je([R],ge),e.Hover=ge;var ke;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(ke=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Le=class{constructor($,le=ke.Text){this.range=$,this.kind=le}toJSON(){return{range:this.range,kind:ke[this.kind]}}};Le=je([R],Le),e.DocumentHighlight=Le;var Oe;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(Oe=e.SymbolKind||(e.SymbolKind={}));var q;(function(G){G[G.Deprecated=1]="Deprecated"})(q=e.SymbolTag||(e.SymbolTag={}));let J=r=class{constructor($,le,Te,Ye,rt){this.name=$,this.kind=le,this.containerName=rt,typeof Te=="string"&&(this.containerName=Te),Ye instanceof j?this.location=Ye:Te instanceof F&&(this.location=new j(Ye,Te)),r.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Oe[this.kind],location:this.location,containerName:this.containerName}}};J=r=je([R],J),e.SymbolInformation=J;let re=t=class{constructor($,le,Te,Ye,rt){this.name=$,this.detail=le,this.kind=Te,this.range=Ye,this.selectionRange=rt,this.children=[],t.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(t.validate)}};re=t=je([R],re),e.DocumentSymbol=re;var he;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(he=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ee=class{constructor($,le){this.title=$,this.kind=le}};ee=je([R],ee),e.CodeAction=ee;let ae=n=class{constructor($){this.value=$}append($){return new n(this.value?this.value+n.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+n.sep)}};ae.sep=".",ae=n=je([R],ae),e.CodeActionKind=ae,ae.Empty=new ae(""),ae.QuickFix=ae.Empty.append("quickfix"),ae.Refactor=ae.Empty.append("refactor"),ae.RefactorExtract=ae.Refactor.append("extract"),ae.RefactorInline=ae.Refactor.append("inline"),ae.RefactorRewrite=ae.Refactor.append("rewrite"),ae.Source=ae.Empty.append("source"),ae.SourceOrganizeImports=ae.Source.append("organizeImports"),ae.SourceFixAll=ae.Source.append("fixAll");let Se=class{constructor($,le){if(this.range=$,this.parent=le,le&&!le.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Se=je([R],Se),e.SelectionRange=Se;class Ue{constructor($,le,Te,Ye,rt,lt){this.kind=$,this.name=le,this.detail=Te,this.uri=Ye,this.range=rt,this.selectionRange=lt}}e.CallHierarchyItem=Ue;class Ve{constructor($,le){this.fromRanges=le,this.from=$}}e.CallHierarchyIncomingCall=Ve;class Ge{constructor($,le){this.fromRanges=le,this.to=$}}e.CallHierarchyOutgoingCall=Ge;var Je;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(Je=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let tt=class{constructor($,le){this.range=$,this.command=le}get isResolved(){return!!this.command}};tt=je([R],tt),e.CodeLens=tt;let ot=u=class{constructor($,le=!1){h.set(this,void 0),nt(this,h,new y.MarkdownString($,{supportThemeIcons:le}),"f")}static isMarkdownString($){return $ instanceof u?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return xe(this,h,"f").value}set value($){xe(this,h,"f").value=$}get isTrusted(){return xe(this,h,"f").isTrusted}set isTrusted($){xe(this,h,"f").isTrusted=$}get supportThemeIcons(){return xe(this,h,"f").supportThemeIcons}set supportThemeIcons($){xe(this,h,"f").supportThemeIcons=$}get supportHtml(){return xe(this,h,"f").supportHtml}set supportHtml($){xe(this,h,"f").supportHtml=$}appendText($){return xe(this,h,"f").appendText($),this}appendMarkdown($){return xe(this,h,"f").appendMarkdown($),this}appendCodeblock($,le){return xe(this,h,"f").appendCodeblock(le??"",$),this}};h=new WeakMap,ot=u=je([R],ot),e.MarkdownString=ot;let et=class{constructor($,le){this.label=$,this.documentation=le}};et=je([R],et),e.ParameterInformation=et;let it=class{constructor($,le){this.label=$,this.documentation=le,this.parameters=[]}};it=je([R],it),e.SignatureInformation=it;let ct=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ct=je([R],ct),e.SignatureHelp=ct;var pt;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(pt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Pt;(function(G){G[G.Other=0]="Other",G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(Pt=e.InlayHintKind||(e.InlayHintKind={}));let We=class{constructor($,le,Te){this.text=$,this.position=le,this.kind=Te}};We=je([R],We),e.InlayHint=We;var Rt;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Rt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Z;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Z=e.CompletionItemKind||(e.CompletionItemKind={}));var ne;(function(G){G[G.Deprecated=1]="Deprecated"})(ne=e.CompletionItemTag||(e.CompletionItemTag={}));let ve=class{constructor($,le){this.label=$,this.kind=le}toJSON(){return{label:this.label,kind:this.kind&&Z[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ve=je([R],ve),e.CompletionItem=ve;let te=class{constructor($=[],le=!1){this.items=$,this.isIncomplete=le}};te=je([R],te),e.CompletionList=te;let _e=class{constructor($,le,Te){this.text=$,this.range=le,this.command=Te}};_e=je([R],_e),e.InlineSuggestion=_e;let Me=class{constructor($){this.items=$}};Me=je([R],Me),e.InlineSuggestions=Me;var Be;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(Be=e.ViewColumn||(e.ViewColumn={}));var Xe;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Xe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ae;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var de;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(de=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var fe;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(fe=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ee;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(Ee=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(G){function $(le){switch(le){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=$}(de=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ce=class{constructor($,le){if(le&&!I.URI.isUri(le))throw(0,i.illegalArgument)("target");if(!F.isRange($)||$.isEmpty)throw(0,i.illegalArgument)("range");this.range=$,this.target=le}};Ce=je([R],Ce),e.DocumentLink=Ce;let Ne=class{constructor($,le,Te,Ye){this.red=$,this.green=le,this.blue=Te,this.alpha=Ye}};Ne=je([R],Ne),e.Color=Ne;let Ke=class{constructor($,le){if(le&&!(le instanceof Ne))throw(0,i.illegalArgument)("color");if(!F.isRange($)||$.isEmpty)throw(0,i.illegalArgument)("range");this.range=$,this.color=le}};Ke=je([R],Ke),e.ColorInformation=Ke;let He=class{constructor($){if(!$||typeof $!="string")throw(0,i.illegalArgument)("label");this.label=$}};He=je([R],He),e.ColorPresentation=He;var Qe;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Qe=e.ColorFormat||(e.ColorFormat={}));var st;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(st=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class at{constructor($,le,Te){if(this.startIndex=$,this.length=le,this.tooltip=Te,typeof $!="number"||$<0)throw(0,i.illegalArgument)("startIndex");if(typeof le!="number"||le<1)throw(0,i.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,i.illegalArgument)("tooltip")}}e.TerminalLink=at;var me;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(me=e.TerminalLocation||(e.TerminalLocation={}));class De{constructor($){this.options=$,typeof $!="object"&&(0,i.illegalArgument)("options")}}e.TerminalProfile=De;var ue;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(ue=e.TaskRevealKind||(e.TaskRevealKind={}));var Q;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(Q=e.TaskPanelKind||(e.TaskPanelKind={}));let Ie=a=class{constructor($,le){if(this.label=le,typeof $!="string"||typeof le!="string")throw(0,i.illegalArgument)("name");this._id=$}static from($){switch($){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};Ie.Clean=new a("clean","Clean"),Ie.Build=new a("build","Build"),Ie.Rebuild=new a("rebuild","Rebuild"),Ie.Test=new a("test","Test"),Ie=a=je([R],Ie),e.TaskGroup=Ie;function Fe(G){let $="";for(let le=0;le<G.length;le++)$+=G[le].replace(/,/g,",,")+",";return $}let Ze=class{constructor($,le,Te){if(typeof $!="string")throw(0,i.illegalArgument)("process");this._args=[],this._process=$,le!==void 0&&(Array.isArray(le)?(this._args=le,this._options=Te):this._options=le)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,i.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let le of this._args)$.push(le);return Fe($)}};Ze=je([R],Ze),e.ProcessExecution=Ze;let qe=class{constructor($,le,Te){if(this._args=[],Array.isArray(le)){if(!$)throw(0,i.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,i.illegalArgument)("command");this._command=$,this._args=le,this._options=Te}else{if(typeof $!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=$,this._options=le}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,i.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let le of this._args)$.push(typeof le=="string"?le:le.value);return Fe($)}};qe=je([R],qe),e.ShellExecution=qe;var dt;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(dt=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class yt{constructor($){this._callback=$}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=yt;let bt=f=class{constructor($,le,Te,Ye,rt,lt){this.__deprecated=!1,this._definition=this.definition=$;let ht;typeof le=="string"?(this._name=this.name=le,this._source=this.source=Te,this.execution=Ye,ht=rt,this.__deprecated=!0):le===wt.Global||le===wt.Workspace?(this.target=le,this._name=this.name=Te,this._source=this.source=Ye,this.execution=rt,ht=lt):(this.target=le,this._name=this.name=Te,this._source=this.source=Ye,this.execution=rt,ht=lt),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ze?this._definition={type:f.ProcessType,id:this._execution.computeId()}:this._execution instanceof qe?this._definition={type:f.ShellType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:f.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:f.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,i.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,i.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const le=this._definition.type;(f.EmptyType===le||f.ProcessType===le||f.ShellType===le||f.ExtensionCallbackType===le)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,i.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=f=je([R],bt),e.Task=bt;var ft;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(ft=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor($,le=_t.None){this.collapsibleState=le,I.URI.isUri($)?this.resourceUri=$:this.label=$}};vt=je([R],vt),e.TreeItem=vt;var _t;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ot=class{constructor($){this._value=$}async asString(){return JSON.stringify(this._value)}};Ot=je([R],Ot),e.TreeDataTransferItem=Ot;let It=class{constructor(){this._items=new Map}get($){return this._items.get($)}set($,le){this._items.set($,le)}forEach($){this._items.forEach($)}};It=je([R],It),e.TreeDataTransfer=It;let Tt=class{constructor($,le){this.id=$,this.color=le}};Tt=je([R],Tt),e.ThemeIcon=Tt,Tt.File=new Tt("file"),Tt.Folder=new Tt("folder");let Lt=class{constructor($){this.id=$}};Lt=je([R],Lt),e.ThemeColor=Lt;var St;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(St=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Mt=class{constructor($,le){if(typeof $!="string"&&(!$||!I.URI.isUri($)&&!I.URI.isUri($.uri)))throw(0,i.illegalArgument)("base");if(typeof le!="string")throw(0,i.illegalArgument)("pattern");typeof $=="string"?(this.baseFolder=I.URI.file($),this.base=$):I.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=le}};Mt=je([R],Mt),e.RelativePattern=Mt;let Nt=class{constructor($,le,Te,Ye){this.enabled=typeof $=="boolean"?$:!0,typeof le=="string"&&(this.condition=le),typeof Te=="string"&&(this.hitCondition=Te),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this._id||(this._id=(0,L.generateUuid)()),this._id}};Nt=je([R],Nt),e.Breakpoint=Nt;let Et=class extends Nt{constructor($,le,Te,Ye,rt){super(le,Te,Ye,rt);if($===null)throw(0,i.illegalArgument)("location");this.location=$}};Et=je([R],Et),e.SourceBreakpoint=Et;let Wt=class extends Nt{constructor($,le,Te,Ye,rt){super(le,Te,Ye,rt);this.functionName=$}};Wt=je([R],Wt),e.FunctionBreakpoint=Wt;let jt=class extends Nt{constructor($,le,Te,Ye,rt,lt,ht){super(Ye,rt,lt,ht);if(!le)throw(0,i.illegalArgument)("dataId");this.label=$,this.dataId=le,this.canPersist=Te}};jt=je([R],jt),e.DataBreakpoint=jt;let si=class{constructor($,le,Te){this.command=$,this.args=le||[],this.options=Te}};si=je([R],si),e.DebugAdapterExecutable=si;let oi=class{constructor($,le){this.port=$,this.host=le}};oi=je([R],oi),e.DebugAdapterServer=oi;let At=class{constructor($){this.path=$}};At=je([R],At),e.DebugAdapterNamedPipeServer=At;let Xt=class{constructor($){this.implementation=$}};Xt=je([R],Xt),e.DebugAdapterInlineImplementation=Xt;let ai=class{constructor($,le){this.range=$,this.expression=le}};ai=je([R],ai),e.EvaluatableExpression=ai;var Yt;(function(G){G[G.Automatic=0]="Automatic",G[G.Explicit=1]="Explicit"})(Yt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Vt=class{constructor($,le){this.range=$,this.text=le}};Vt=je([R],Vt),e.InlineValueText=Vt;let gt=class{constructor($,le,Te=!0){this.range=$,this.variableName=le,this.caseSensitiveLookup=Te}};gt=je([R],gt),e.InlineValueVariableLookup=gt;let ci=class{constructor($,le){this.range=$,this.expression=le}};ci=je([R],ci),e.InlineValueEvaluatableExpression=ci;let Ut=class{constructor($,le){this.frameId=$,this.stoppedLocation=le}};Ut=je([R],Ut),e.InlineValueContext=Ut;var qt;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(qt=e.FileChangeType||(e.FileChangeType={}));let Jt=b=class extends Error{constructor($,le=T.FileSystemProviderErrorCode.Unknown,Te){super(I.URI.isUri($)?$.toString(!0):$);this.code=Te?.name??"Unknown",(0,T.markAsFileSystemProviderError)(this,le),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}static FileExists($){return new b($,T.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound($){return new b($,T.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory($){return new b($,T.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory($){return new b($,T.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions($){return new b($,T.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable($){return new b($,T.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}};Jt=b=je([R],Jt),e.FileSystemError=Jt;let li=class{constructor($,le,Te){this.start=$,this.end=le,this.kind=Te}};li=je([R],li),e.FoldingRange=li;var fi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class Zt{constructor($,le=[]){this.tokenTypes=$,this.tokenModifiers=le}}e.SemanticTokensLegend=Zt;function Si(G){return typeof G=="undefined"||(0,_.isStringArray)(G)}class Gt{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let le=0,Te=$.tokenTypes.length;le<Te;le++)this._tokenTypeStrToInt.set($.tokenTypes[le],le);for(let le=0,Te=$.tokenModifiers.length;le<Te;le++)this._tokenModifierStrToInt.set($.tokenModifiers[le],le)}}push($,le,Te,Ye,rt){if(typeof $=="number"&&typeof le=="number"&&typeof Te=="number"&&typeof Ye=="number"&&(typeof rt=="number"||typeof rt=="undefined"))return typeof rt=="undefined"&&(rt=0),this._pushEncoded($,le,Te,Ye,rt);if(F.isRange($)&&typeof le=="string"&&Si(Te))return this._push($,le,Te);throw(0,i.illegalArgument)()}_push($,le,Te){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(le))throw new Error("`tokenType` is not in the provided legend");const Ye=$.start.line,rt=$.start.character,lt=$.end.character-$.start.character,ht=this._tokenTypeStrToInt.get(le);let kt=0;if(Te)for(const Ft of Te){if(!this._tokenModifierStrToInt.has(Ft))throw new Error("`tokenModifier` is not in the provided legend");const xt=this._tokenModifierStrToInt.get(Ft);kt|=1<<xt>>>0}this._pushEncoded(Ye,rt,lt,ht,kt)}_pushEncoded($,le,Te,Ye,rt){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&le<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const kt=this._data.length/5|0;let Ft=0,xt=0;for(let $t=0;$t<kt;$t++){let Ht=this._data[5*$t],di=this._data[5*$t+1];Ht===0?(Ht=Ft,di+=xt):Ht+=Ft,this._data[5*$t]=Ht,this._data[5*$t+1]=di,Ft=Ht,xt=di}}let lt=$,ht=le;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Te,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=rt,this._prevLine=$,this._prevChar=le}static _sortAndDeltaEncode($){let le=[];const Te=$.length/5|0;for(let ht=0;ht<Te;ht++)le[ht]=ht;le.sort((ht,kt)=>{const Ft=$[5*ht],xt=$[5*kt];if(Ft===xt){const $t=$[5*ht+1],Ht=$[5*kt+1];return $t-Ht}return Ft-xt});const Ye=new Uint32Array($.length);let rt=0,lt=0;for(let ht=0;ht<Te;ht++){const kt=5*le[ht],Ft=$[kt+0],xt=$[kt+1],$t=$[kt+2],Ht=$[kt+3],di=$[kt+4],$i=Ft-rt,Xi=$i===0?xt-lt:xt,hi=5*ht;Ye[hi+0]=$i,Ye[hi+1]=Xi,Ye[hi+2]=$t,Ye[hi+3]=Ht,Ye[hi+4]=di,rt=Ft,lt=xt}return Ye}build($){return this._dataIsSortedAndDeltaEncoded?new Kt(new Uint32Array(this._data),$):new Kt(Gt._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=Gt;class Kt{constructor($,le){this.resultId=le,this.data=$}}e.SemanticTokens=Kt;class _i{constructor($,le,Te){this.start=$,this.deleteCount=le,this.data=Te}}e.SemanticTokensEdit=_i;class Ci{constructor($,le){this.resultId=le,this.edits=$}}e.SemanticTokensEdits=Ci;var Qt;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Qt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yi;(function(G){G[G.Initial=1]="Initial",G[G.Dynamic=2]="Dynamic"})(yi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new Tt("arrow-left")},ei=je([R],ei),e.QuickInputButtons=ei;var Di;(function(G){G[G.Default=1]="Default",G[G.Separator=2]="Separator"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor($,le,Te){this.badge=$,this.tooltip=le,this.color=Te}static validate($){if($.badge){let le=(0,k.nextCharLength)($.badge,0);if(le<$.badge.length&&(le+=(0,k.nextCharLength)($.badge,le)),$.badge.length>le)throw new Error("The 'badge'-property must be undefined or a short character")}if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ti=class{constructor($){this.kind=$}};ti=je([R],ti),e.ColorTheme=ti;var gi;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class $e{constructor($,le){if($<0)throw(0,i.illegalArgument)("start must be positive");if(le<0)throw(0,i.illegalArgument)("end must be positive");$<=le?(this._start=$,this._end=le):(this._start=le,this._end=$)}static isNotebookRange($){return $ instanceof $e?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let le=this._start,Te=this._end;return $.start!==void 0&&(le=$.start),$.end!==void 0&&(Te=$.end),le===this._start&&Te===this._end?this:new $e(le,Te)}}e.NotebookRange=$e;class Bt{constructor($,le,Te,Ye,rt,lt,ht){this.kind=$,this.value=le,this.languageId=Te,this.mime=Ye,this.outputs=rt??[],this.metadata=lt,this.executionSummary=ht,Bt.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(le=>Bt.isNotebookCellData(le))}static isNotebookCellData($){return!0}}e.NotebookCellData=Bt;class pi{constructor($){this.cells=$}}e.NotebookData=pi;class mt{constructor($,le){this.data=$,this.mime=le;const Te=(0,P.normalizeMimeType)(le,!0);if(!Te)throw new Error(`INVALID mime type: ${le}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}static isNotebookCellOutputItem($){return $ instanceof mt?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const le={name:$.name,message:$.message,stack:$.stack};return mt.json(le,"application/vnd.code.notebook.error")}static stdout($){return mt.text($,"application/vnd.code.notebook.stdout")}static stderr($){return mt.text($,"application/vnd.code.notebook.stderr")}static bytes($,le="application/octet-stream"){return new mt($,le)}static text($,le=P.Mimes.text){const Te=xe(mt,p,"f",v).encode(String($));return new mt(Te,le)}static json($,le="application/json"){const Te=JSON.stringify($,void 0,"	");return mt.text(Te,le)}}e.NotebookCellOutputItem=mt,p=mt,v={value:new TextEncoder};class ii{constructor($,le,Te){this.items=ii.ensureUniqueMimeTypes($,!0),typeof le=="string"?(this.id=le,this.metadata=Te):(this.id=(0,L.generateUuid)(),this.metadata=le??Te)}static isNotebookCellOutput($){return $ instanceof ii?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&(0,_.isArray)($.items)}static ensureUniqueMimeTypes($,le=!1){const Te=new Set,Ye=new Set;for(let rt=0;rt<$.length;rt++){const lt=$[rt],ht=(0,P.normalizeMimeType)(lt.mime);if(!Te.has(ht)){Te.add(ht);continue}Ye.add(rt),le&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ye.size===0?$:$.filter((rt,lt)=>!Ye.has(lt))}}e.NotebookCellOutput=ii;var Ii;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var wi;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(wi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor($,le){this.text=$,this.alignment=le}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor($,le=[]){this.uri=$,this.provides=(0,m.asArray)(le)}}e.NotebookRendererScript=Ri;let ni=class{constructor($,le){this.label=$,this.timestamp=le}};ni=je([R],ni),e.TimelineItem=ni;var Li;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(Li=e.ExtensionMode||(e.ExtensionMode={}));var Fi;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(Fi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Mi;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(Mi=e.StandardTokenType||(e.StandardTokenType={}));class Oi{constructor($,le){this.ranges=$,this.wordPattern=le}}e.LinkedEditingRanges=Oi;class Ni{constructor($,le){this._port=$,this._autoForwardAction=le}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var oe;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(oe=e.TestResultState||(e.TestResultState={}));var pe;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(pe=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Re=class{constructor($=void 0,le=void 0,Te=void 0){this.include=$,this.exclude=le,this.profile=Te}};Re=je([R],Re),e.TestRunRequest=Re;let ut=d=class{constructor($){this.message=$}static diff($,le,Te){const Ye=new d($);return Ye.expectedOutput=le,Ye.actualOutput=Te,Ye}};ut=d=je([R],ut),e.TestMessage=ut;let Ct=class{constructor($){this.id=$}};Ct=je([R],Ct),e.TestTag=Ct;let Dt=class{constructor($,le){this.covered=$,this.total=le}};Dt=je([R],Dt),e.CoveredCount=Dt;let Ui=D=class{constructor($,le,Te,Ye){this.uri=$,this.statementCoverage=le,this.branchCoverage=Te,this.functionCoverage=Ye}static fromDetails($,le){const Te=new Dt(0,0),Ye=new Dt(0,0),rt=new Dt(0,0);for(const ht of le)if("branches"in ht){Te.total+=1,Te.covered+=ht.executionCount>0?1:0;for(const kt of ht.branches)Ye.total+=1,Ye.covered+=kt.executionCount>0?1:0}else rt.total+=1,rt.covered+=ht.executionCount>0?1:0;const lt=new D($,Te,Ye.total>0?Ye:void 0,rt.total>0?rt:void 0);return lt.detailedCoverage=le,lt}};Ui=D=je([R],Ui),e.FileCoverage=Ui;let Bi=class{constructor($,le,Te=[]){this.executionCount=$,this.location=le,this.branches=Te}};Bi=je([R],Bi),e.StatementCoverage=Bi;let xi=class{constructor($,le){this.executionCount=$,this.location=le}};xi=je([R],xi),e.BranchCoverage=xi;let Wi=class{constructor($,le){this.executionCount=$,this.location=le}};Wi=je([R],Wi),e.FunctionCoverage=Wi;var qi;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Gi;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(Gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ki;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ki=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor($,le,Te,Ye,rt,lt){this.kind=$,this.name=le,this.detail=Te,this.uri=Ye,this.range=rt,this.selectionRange=lt}}e.TypeHierarchyItem=Qi}),define(we[122],be([0,1,56,10,8,149,109,7,16]),function(Y,e,m,i,y,C,P,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const I=new Map;function L(h,p){p?I.set(h,p):I.delete(h)}e.setWordDefinitionFor=L;function T(h){return I.get(h)}e.getWordDefinitionFor=T;class l extends C.MirrorTextModel{constructor(p,v,A,w,s,o,g,c){super(v,A,w,s);this._proxy=p,this._languageId=o,this._isDirty=g,this._notebook=c,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(p){return(0,_.equals)(this._lines,p)}get document(){if(!this._document){const p=this;this._document={get uri(){return p._uri},get fileName(){return p._uri.fsPath},get isUntitled(){return p._uri.scheme===i.Schemas.untitled},get languageId(){return p._languageId},get version(){return p._versionId},get isClosed(){return p._isDisposed},get isDirty(){return p._isDirty},get notebook(){return p._notebook},save(){return p._save()},getText(v){return v?p._getTextInRange(v):p.getText()},get eol(){return p._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return p._lines.length},lineAt(v){return p._lineAt(v)},offsetAt(v){return p._offsetAt(v)},positionAt(v){return p._positionAt(v)},validateRange(v){return p._validateRange(v)},validatePosition(v){return p._validatePosition(v)},getWordRangeAtPosition(v,A){return p._getWordRangeAtPosition(v,A)}}}return Object.freeze(this._document)}_acceptLanguageId(p){(0,m.ok)(!this._isDisposed),this._languageId=p}_acceptIsDirty(p){(0,m.ok)(!this._isDisposed),this._isDirty=p}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(p){const v=this._validateRange(p);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const A=this._eol,w=v.start.line,s=v.end.line,o=[];o.push(this._lines[w].substring(v.start.character));for(let g=w+1;g<s;g++)o.push(this._lines[g]);return o.push(this._lines[s].substring(0,v.end.character)),o.join(A)}_lineAt(p){let v;if(p instanceof k.Position?v=p.line:typeof p=="number"&&(v=p),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new E(v,this._lines[v],v===this._lines.length-1)}_offsetAt(p){return p=this._validatePosition(p),this._ensureLineStarts(),this._lineStarts.getPrefixSum(p.line-1)+p.character}_positionAt(p){p=Math.floor(p),p=Math.max(0,p),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(p),A=this._lines[v.index].length;return new k.Position(v.index,Math.min(v.remainder,A))}_validateRange(p){if(!(p instanceof k.Range))throw new Error("Invalid argument");const v=this._validatePosition(p.start),A=this._validatePosition(p.end);return v===p.start&&A===p.end?p:new k.Range(v.line,v.character,A.line,A.character)}_validatePosition(p){if(!(p instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return p.with(0,0);let{line:v,character:A}=p,w=!1;if(v<0)v=0,A=0,w=!0;else if(v>=this._lines.length)v=this._lines.length-1,A=this._lines[v].length,w=!0;else{const s=this._lines[v].length;A<0?(A=0,w=!0):A>s&&(A=s,w=!0)}return w?new k.Position(v,A):p}_getWordRangeAtPosition(p,v){const A=this._validatePosition(p);if(!v)v=T(this._languageId);else if((0,y.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const w=(0,P.getWordAtText)(A.character+1,(0,P.ensureValidWordDefinition)(v),this._lines[A.line],0);if(w)return new k.Range(A.line,w.startColumn-1,A.line,w.endColumn-1)}}e.ExtHostDocumentData=l;class E{constructor(p,v,A){this._line=p,this._text=v,this._isLastLine=A}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=E}),define(we[201],be([0,1,7,3,111,6,82,24,2,33]),function(Y,e,m,i,y,C,P,k,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class L{constructor(l,E,h,p){this._notebook=h,this._selector=p,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,I.generateUuid)()}),this._init(),this._disposables.add(E.onDidChangeDocument(A=>{const w=this._cellUris.get(A.document.uri);w!==void 0&&(this._cellLengths.setValue(w,this._cells[w].document.getText().length+1),this._cellLines.setValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=A=>{A===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(A=>v(A.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const l=[],E=[];for(const h of this._notebook.getCells())h.kind===m.NotebookCellKind.Code&&(!this._selector||(0,P.score)(this._selector,h.document.uri,h.document.languageId,!0))&&(this._cellUris.set(h.document.uri,this._cells.length),this._cells.push(h),l.push(h.document.getText().length+1),E.push(h.document.lineCount));this._cellLengths=new y.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new y.PrefixSumComputer(new Uint32Array(E))}get version(){return this._versionId}getText(l){if(!l){let w="";for(const s of this._cells)w+=s.document.getText()+`
`;return w=w.slice(0,-1),w}if(l.isEmpty)return"";const E=this.locationAt(l.start),h=this.locationAt(l.end),p=this._cellUris.get(E.uri),v=this._cellUris.get(h.uri);if(p===void 0||v===void 0)return"";if(p===v)return this._cells[p].document.getText(new m.Range(E.range.start,h.range.end));const A=[this._cells[p].document.getText(new m.Range(E.range.start,new m.Position(this._cells[p].document.lineCount,0)))];for(let w=p+1;w<v;w++)A.push(this._cells[w].document.getText());return A.push(this._cells[v].document.getText(new m.Range(new m.Position(0,0),h.range.end))),A.join(`
`)}offsetAt(l){const E=this._cellLines.getIndexOf(l.line),h=this._cellLengths.getPrefixSum(E.index-1),p=this._cells[E.index].document.offsetAt(l.with(E.remainder));return h+p}positionAt(l){if(typeof l=="number"){const h=this._cellLengths.getIndexOf(l),p=this._cellLines.getPrefixSum(h.index-1);return this._cells[h.index].document.positionAt(h.remainder).translate(p)}const E=this._cellUris.get(l.uri);if(E!==void 0){const h=this._cellLines.getPrefixSum(E-1);return new m.Position(h+l.range.start.line,l.range.start.character)}return new m.Position(0,0)}locationAt(l){m.Range.isRange(l)||(l=new m.Range(l,l));const E=this._cellLines.getIndexOf(l.start.line);let h=E;l.isEmpty||(h=this._cellLines.getIndexOf(l.end.line));const p=new m.Position(E.remainder,l.start.character),v=new m.Position(h.remainder,l.end.character),A=new m.Range(p,v),w=this._cells[E.index];return new m.Location(w.document.uri,w.document.validateRange(A))}contains(l){return this._cellUris.has(l)}validateRange(l){const E=this.validatePosition(l.start),h=this.validatePosition(l.end);return l.with(E,h)}validatePosition(l){const E=this._cellLines.getIndexOf(l.line),h=new m.Position(E.remainder,l.character),p=this._cells[E.index].document.validatePosition(h),v=this._cellLines.getPrefixSum(E.index-1);return new m.Position(v+p.line,p.character)}}e.ExtHostNotebookConcatDocument=L}),define(we[202],be([0,1,7,14,3]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(k){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new y.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let _=k==="light"?m.ColorThemeKind.Light:k==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=je([ze(0,i.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(we[64],be([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class i{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.URITransformerService=i}),define(we[203],be([0,1,22]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class i{constructor(){this.buffers=[]}add(_){let I=this.buffers.indexOf(_);return I<0&&(I=this.buffers.length,this.buffers.push(_)),I}}function y(k,_){if(_.serializeBuffersForPostMessage){const I=new i,L=(E,h)=>{if(h instanceof ArrayBuffer){const p=I.add(h);return{$$vscode_array_buffer_reference$$:!0,index:p}}else if(ArrayBuffer.isView(h)){const p=C(h);if(p){const v=I.add(h.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:p,byteLength:h.byteLength,byteOffset:h.byteOffset}}}}return h},T=JSON.stringify(k,L),l=I.buffers.map(E=>{const h=new Uint8Array(E);return m.VSBuffer.wrap(h)});return{message:T,buffers:l}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=y;function C(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function P(k,_){const I=_.map(l=>{const E=new ArrayBuffer(l.byteLength);return new Uint8Array(E).set(l.buffer),E}),L=_.length?(l,E)=>{if(typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const h=E,{index:p}=h,v=I[p];if(h.view)switch(h.view.type){case 1:return new Int8Array(v,h.view.byteOffset,h.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,h.view.byteOffset,h.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,h.view.byteOffset,h.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,h.view.byteOffset,h.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,h.view.byteOffset,h.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,h.view.byteOffset,h.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,h.view.byteOffset,h.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,h.view.byteOffset,h.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,h.view.byteOffset,h.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,h.view.byteOffset,h.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,h.view.byteOffset,h.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return E}:void 0;return{message:JSON.parse(k,L),arrayBuffers:I}}e.deserializeWebviewMessage=P}),define(we[204],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var m;(function(i){function y(P){const k=new Map;return P.types.forEach((_,I)=>{k.set(_,{asString:async()=>P.items[I].asString})}),k}i.toITreeDataTransfer=y;async function C(P){const k={types:[],items:[]},_=Array.from(P.entries());for(const I of _)k.types.push(I[0]),k.items.push({asString:await I[1].asString()});return k}i.toTreeDataTransferDTO=C})(m=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(we[88],be([0,1,10,2]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function y(k,_){return k.scheme===m.Schemas.http||k.scheme===m.Schemas.https?k:(_&&_.authority&&_.isRemote&&k.scheme===m.Schemas.file&&(k=i.URI.from({scheme:m.Schemas.vscodeRemote,authority:_.authority,path:k.path})),i.URI.from({scheme:m.Schemas.https,authority:`${k.scheme}+${C(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=y;function C(k){return k.replace(/./g,_=>{const I=_.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?_:"-"+I.toString(16).padStart(4,"0")})}function P(k){return k.replace(/-([0-9a-f]{4})/g,(_,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=P}),define(we[205],be([0,1,3,6,88]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(k,_,I){this._proxy=k,this._editors=_,this._initData=I,this._handlePool=0,this._disposables=new i.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const L=_.getVisibleTextEditors();for(const T of this._insets.values())L.indexOf(T.editor)<0&&T.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,_,I,L,T){let l;for(const s of this._editors.getVisibleTextEditors(!0))if(s.value===k){l=s;break}if(!l)throw new Error("not a visible editor");const E=this,h=this._handlePool++,p=new m.Emitter,v=new m.Emitter,A=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(s){return(0,y.asWebviewUri)(s,E._initData.remote)}get cspSource(){return y.webviewGenericCspSource}set options(s){this._options=s,E._proxy.$setOptions(h,s)}get options(){return this._options}set html(s){this._html=s,E._proxy.$setHtml(h,s)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(s){return E._proxy.$postMessage(h,s)}},w=new class{constructor(){this.editor=k,this.line=_,this.height=I,this.webview=A,this.onDidDispose=v.event}dispose(){E._insets.has(h)&&(E._insets.delete(h),E._proxy.$disposeEditorInset(h),v.fire(),v.dispose(),p.dispose())}};return this._proxy.$createEditorInset(h,l.id,l.value.document.uri,_+1,I,L||{},T.identifier,T.extensionLocation),this._insets.set(h,{editor:k,inset:w,onDidReceiveMessage:p}),w}$onDidDispose(k){const _=this._insets.get(k);_&&_.inset.dispose()}$onDidReceiveMessage(k,_){const I=this._insets.get(k);I&&I.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=C}),define(we[206],be([0,1,171,13,2,6,4,61,51,42,16,10]),function(Y,e,m,i,y,C,P,k,_,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,m.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,m.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,m.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,m.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,m.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new k.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,m.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,m.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,m.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,m.localize)(10,null)),e.SideBySideEditorActiveContext=new k.RawContextKey("sideBySideEditorActive",!1,(0,m.localize)(11,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,m.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,m.localize)(13,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,m.localize)(14,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,m.localize)(15,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,m.localize)(16,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,m.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,m.localize)(18,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,m.localize)(19,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,m.localize)(20,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,m.localize)(21,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,m.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function l(F,O,z){for(const W of z.visibleEditorPanes)if(W.group.id===O&&F.matches(W.input))return W.getViewState()}e.findViewStateForEditor=l;function E(F){if(g(F))return!1;const O=F;return y.URI.isUri(O?.resource)}e.isResourceEditorInput=E;function h(F){if(g(F))return!1;const O=F;return O?.original!==void 0&&O.modified!==void 0}e.isResourceDiffEditorInput=h;function p(F){if(g(F)||h(F))return!1;const O=F;return O?.primary!==void 0&&O.secondary!==void 0}e.isResourceSideBySideEditorInput=p;function v(F){if(g(F))return!1;const O=F;return O?O.resource===void 0||O.resource.scheme===T.Schemas.untitled||O.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=v;var A;(function(F){F[F.SHORT=0]="SHORT",F[F.MEDIUM=1]="MEDIUM",F[F.LONG=2]="LONG"})(A=e.Verbosity||(e.Verbosity={}));var w;(function(F){F[F.EXPLICIT=1]="EXPLICIT",F[F.AUTO=2]="AUTO",F[F.FOCUS_CHANGE=3]="FOCUS_CHANGE",F[F.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(w=e.SaveReason||(e.SaveReason={}));var s;(function(F){F[F.None=0]="None",F[F.Readonly=2]="Readonly",F[F.Untitled=4]="Untitled",F[F.Singleton=8]="Singleton",F[F.RequiresTrust=16]="RequiresTrust",F[F.CanSplitInGroup=32]="CanSplitInGroup",F[F.ForceDescription=64]="ForceDescription"})(s=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends C.Disposable{}e.AbstractEditorInput=o;function g(F){return F instanceof o}e.isEditorInput=g;function c(F){const O=F;return y.URI.isUri(O?.preferredResource)}function S(F){const O=F;return g(O?.primary)&&g(O?.secondary)}e.isSideBySideEditorInput=S;function r(F){const O=F;return g(O?.modified)&&g(O?.original)}e.isDiffEditorInput=r;function t(F){return g(F?.editor)}e.isEditorInputWithOptions=t;function n(F){const O=F;return t(F)&&O?.group!==void 0}e.isEditorInputWithOptionsAndGroup=n;function u(F){const O=F;return typeof O?.groupId=="number"&&g(O.editor)}e.isEditorIdentifier=u;var a;(function(F){F[F.UNKNOWN=0]="UNKNOWN",F[F.REPLACE=1]="REPLACE",F[F.MOVE=2]="MOVE",F[F.UNPIN=3]="UNPIN"})(a=e.EditorCloseContext||(e.EditorCloseContext={}));var f;(function(F){F[F.GROUP_ACTIVE=0]="GROUP_ACTIVE",F[F.GROUP_INDEX=1]="GROUP_INDEX",F[F.GROUP_LOCKED=2]="GROUP_LOCKED",F[F.EDITOR_OPEN=3]="EDITOR_OPEN",F[F.EDITOR_CLOSE=4]="EDITOR_CLOSE",F[F.EDITOR_MOVE=5]="EDITOR_MOVE",F[F.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",F[F.EDITOR_LABEL=7]="EDITOR_LABEL",F[F.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",F[F.EDITOR_PIN=9]="EDITOR_PIN",F[F.EDITOR_STICKY=10]="EDITOR_STICKY",F[F.EDITOR_DIRTY=11]="EDITOR_DIRTY",F[F.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(f=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var b;(function(F){F[F.PRIMARY=1]="PRIMARY",F[F.SECONDARY=2]="SECONDARY",F[F.BOTH=3]="BOTH",F[F.ANY=4]="ANY"})(b=e.SideBySideEditor||(e.SideBySideEditor={}));class d{getOriginalUri(O,z){if(!O)return;if(z?.supportSideBySide){const{primary:M,secondary:x}=this.getSideEditors(O);if(M&&x){if(z?.supportSideBySide===b.BOTH)return{primary:this.getOriginalUri(M,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(x,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===b.ANY)return this.getOriginalUri(M,{filterByScheme:z.filterByScheme})??this.getOriginalUri(x,{filterByScheme:z.filterByScheme});O=z.supportSideBySide===b.PRIMARY?M:x}}if(h(O)||p(O))return;const W=c(O)?O.preferredResource:O.resource;return!W||!z||!z.filterByScheme?W:this.filterUri(W,z.filterByScheme)}getSideEditors(O){return S(O)||p(O)?{primary:O.primary,secondary:O.secondary}:r(O)||h(O)?{primary:O.modified,secondary:O.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(O,z){if(!O)return;if(z?.supportSideBySide){const{primary:M,secondary:x}=this.getSideEditors(O);if(M&&x){if(z?.supportSideBySide===b.BOTH)return{primary:this.getCanonicalUri(M,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(x,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===b.ANY)return this.getCanonicalUri(M,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(x,{filterByScheme:z.filterByScheme});O=z.supportSideBySide===b.PRIMARY?M:x}}if(h(O)||p(O))return;const W=O.resource;return!W||!z||!z.filterByScheme?W:this.filterUri(W,z.filterByScheme)}filterUri(O,z){if(Array.isArray(z)){if(z.some(W=>O.scheme===W))return O}else if(z===O.scheme)return O}}e.EditorResourceAccessor=new d;var D;(function(F){F[F.LEFT=0]="LEFT",F[F.RIGHT=1]="RIGHT"})(D=e.CloseDirection||(e.CloseDirection={}));class R{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(O){const z=this.instantiationService=O.get(P.IInstantiationService);for(const[W,M]of this.editorSerializerConstructors)this.createEditorSerializer(W,M,z);this.editorSerializerConstructors.clear()}createEditorSerializer(O,z,W){const M=W.createInstance(z);this.editorSerializerInstances.set(O,M)}registerFileEditorFactory(O){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=O}getFileEditorFactory(){return(0,i.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(O,z){if(this.editorSerializerConstructors.has(O)||this.editorSerializerInstances.has(O))throw new Error(`A editor serializer with type ID '${O}' was already registered.`);return this.instantiationService?this.createEditorSerializer(O,z,this.instantiationService):this.editorSerializerConstructors.set(O,z),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(O),this.editorSerializerInstances.delete(O)})}getEditorSerializer(O){return this.editorSerializerInstances.get(typeof O=="string"?O:O.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new R);async function N(F,O){if(!F||!F.length)return[];const z=await Promise.all(F.map(async W=>{const M=y.URI.revive(W.fileUri);if(!M||!await O.canHandleResource(M))return;let V=W.exists,U=W.type;if(typeof V!="boolean"||typeof U!="number")try{U=(await O.resolve(M)).isDirectory?I.FileType.Directory:I.FileType.Unknown,V=!0}catch{V=!1}if(!V&&W.openOnlyIfExists||U===I.FileType.Directory)return;const H={selection:V?W.selection:void 0,pinned:!0,override:W.editorOverrideId};let X;return V?X={resource:M,options:H}:X={resource:M,options:H,forceUntitled:!0},X}));return(0,L.coalesce)(z)}e.pathsToEditors=N;var B;(function(F){F[F.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",F[F.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(we[123],be([0,1,3,18,172]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,_,I,L){const T={command:k};if(_&&Object.keys(_).length>0&&(T.arguments=_),this.internalSend("request",T),typeof L=="number"){const l=setTimeout(()=>{clearTimeout(l);const E=this.pendingRequests.get(T.seq);if(E){this.pendingRequests.delete(T.seq);const h={type:"response",seq:0,request_seq:T.seq,success:!1,command:k,message:(0,y.localize)(0,null,L,k)};E(h)}},L)}return I&&this.pendingRequests.set(T.seq,I),T.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,_){return k.type!=="event"||_.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,i.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":{const _=k,I=this.pendingRequests.get(_.request_seq);I&&(this.pendingRequests.delete(_.request_seq),I(_));break}}}}internalSend(k,_){_.type=k,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((_,I)=>k.set(I,_)),await(0,i.timeout)(500),k.forEach((_,I)=>{_({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(we[207],be([0,1,8,2,9,25,10]),function(Y,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function _(r,t,n){return r.replace(k,function(u,a){return t&&a.length>0&&a[0]!=="_"?u:n&&n.hasOwnProperty(a)?n[a]:u})}e.formatPII=_;function I(r){const t={};for(const n of Object.keys(r))n.startsWith("!")||(t[n]=r[n]);return t}e.filterExceptionsFromTelemetry=I;function L(r){return r.configuration.request==="attach"&&!T(r)&&(!r.parentSession||L(r.parentSession))}e.isSessionAttach=L;function T(r){let t=r.configuration.type;if(!!t)return t==="vslsShare"&&(t=r.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(t,"extensionhost")||(0,m.equalsIgnoreCase)(t,"pwa-extensionhost")?r:r.parentSession?T(r.parentSession):void 0}e.getExtensionHostDebugSession=T;function l(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=l;function E(r,t,n){let u,a=0,f=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,b=null;for(;b=f.exec(r);){let d=b.index+1,D=d+b[0].length;if(d<=t&&D>=n){u=b[0],a=d;break}}if(u){let d=/\w+/g,D=null;for(;(D=d.exec(u))&&!(D.index+1+a+D[0].length>=n););D&&(u=u.substring(0,d.lastIndex))}return u?{start:a,end:a+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=E;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function p(r){return!!(r&&r.match(h))}e.isUri=p;function v(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(p(r.path))return i.URI.parse(r.path);if((0,y.isAbsolute)(r.path))return i.URI.file(r.path)}return r.path}function A(r){if(typeof r.path=="object"){const t=i.URI.revive(r.path);if(t)return t.scheme===P.Schemas.file?t.fsPath:t.toString()}return r.path}function w(r,t){const n=t?v:A,u=(0,C.deepClone)(r);return o(u,(a,f)=>{a&&f&&(f.path=n(f))}),u}e.convertToDAPaths=w;function s(r,t){const n=t?v:A,u=(0,C.deepClone)(r);return o(u,(a,f)=>{!a&&f&&(f.path=n(f))}),u}e.convertToVSCPaths=s;function o(r,t){switch(r.type){case"event":{const n=r;switch(n.event){case"output":t(!1,n.body.source);break;case"loadedSource":t(!1,n.body.source);break;case"breakpoint":t(!1,n.body.breakpoint.source);break;default:break}break}case"request":{const n=r;switch(n.command){case"setBreakpoints":t(!0,n.arguments.source);break;case"breakpointLocations":t(!0,n.arguments.source);break;case"source":t(!0,n.arguments.source);break;case"gotoTargets":t(!0,n.arguments.source);break;case"launchVSCode":n.arguments.args.forEach(u=>t(!1,u));break;default:break}break}case"response":{const n=r;if(n.success&&n.body)switch(n.command){case"stackTrace":n.body.stackFrames.forEach(u=>t(!1,u.source));break;case"loadedSources":n.body.sources.forEach(u=>t(!1,u));break;case"scopes":n.body.scopes.forEach(u=>t(!1,u.source));break;case"setFunctionBreakpoints":n.body.breakpoints.forEach(u=>t(!1,u.source));break;case"setBreakpoints":n.body.breakpoints.forEach(u=>t(!1,u.source));break;default:break}break}}}function g(r){return r.filter(t=>!t.presentation?.hidden).sort((t,n)=>t.presentation?n.presentation?t.presentation.group?n.presentation.group?t.presentation.group!==n.presentation.group?t.presentation.group.localeCompare(n.presentation.group):c(t.presentation.order,n.presentation.order):-1:n.presentation.group?1:c(t.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=g;function c(r,t){return typeof r!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:r-t}async function S(r,t){const n=r.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorMode});if(n!=="none"&&(await t.saveAll(),n==="allEditorsInActiveGroup")){const u=t.activeEditorPane;u&&await t.save({editor:u.input,groupId:u.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=S}),define(we[208],be([0,1,28,37,173,124,9,8,25,12,183,123]),function(Y,e,m,i,y,C,P,k,_,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class l extends T.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(w,s){this.outputStream=s,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,w.on("data",o=>this.handleData(o))}sendMessage(w){if(this.outputStream){const s=JSON.stringify(w);this.outputStream.write(`Content-Length: ${Buffer.byteLength(s,"utf8")}${l.TWO_CRLF}${s}`,"utf8")}}handleData(w){for(this.rawData=Buffer.concat([this.rawData,w]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const s=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,s.length>0)try{this.acceptMessage(JSON.parse(s))}catch(o){this._onError.fire(new Error((o.message||o)+`
`+s))}continue}}else{const s=this.rawData.indexOf(l.TWO_CRLF);if(s!==-1){const g=this.rawData.toString("utf8",0,s).split(l.HEADER_LINESEPARATOR);for(const c of g){const S=c.split(l.HEADER_FIELDSEPARATOR);S[0]==="Content-Length"&&(this.contentLength=Number(S[1]))}this.rawData=this.rawData.slice(s+l.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=l,l.TWO_CRLF=`\r
\r
`,l.HEADER_LINESEPARATOR=/\r?\n/,l.HEADER_FIELDSEPARATOR=/: */;class E extends l{startSession(){return new Promise((w,s)=>{let o=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),w(),o=!0}),this.socket.on("close",()=>{o?this._onError.fire(new Error("connection closed")):s(new Error("connection closed"))}),this.socket.on("error",g=>{o?this._onError.fire(g):s(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=E;class h extends E{constructor(w){super();this.adapterServer=w}createConnection(w){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",w)}}e.SocketDebugAdapter=h;class p extends E{constructor(w){super();this.adapterServer=w}createConnection(w){return C.createConnection(this.adapterServer.path,w)}}e.NamedPipeDebugAdapter=p;class v extends l{constructor(w,s,o){super();this.adapterExecutable=w,this.debugType=s,this.outputService=o}async startSession(){const w=this.adapterExecutable.command,s=this.adapterExecutable.args,o=this.adapterExecutable.options||{};try{if(w)if(P.isAbsolute(w)){if(!await m.Promises.exists(w))throw new Error(y.localize(0,null,w))}else w.indexOf("/")<0&&w.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.debugType));let g=process.env;if(o.env&&Object.keys(o.env).length>0&&(g=_.mixin(_.deepClone(process.env),o.env)),w==="node")if(Array.isArray(s)&&s.length>0){const S=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:g,execArgv:S?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};o.cwd&&(r.cwd=o.cwd);const t=i.fork(s[0],s.slice(1),r);if(!t.pid)throw new Error(y.localize(2,null,s[0]));this.serverProcess=t}else throw new Error(y.localize(3,null));else{const S={env:g};o.cwd&&(S.cwd=o.cwd),this.serverProcess=i.spawn(w,s,S)}this.serverProcess.on("error",S=>{this._onError.fire(S)}),this.serverProcess.on("exit",(S,r)=>{this._onExit.fire(S)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",S=>{this._onError.fire(S)}),this.serverProcess.stdin.on("error",S=>{this._onError.fire(S)});const c=this.outputService;if(c){const S=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const t=c.getChannel(L.ExtensionsChannelId);t&&t.append(S(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),I.isWindows?new Promise((w,s)=>{const o=i.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,c,S){if(g)return s(g)});o.on("exit",w),o.on("error",s)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(w,s){if(!w)return;const o=Object.create(null);w.runtime&&(w.runtime.indexOf("./")===0?o.runtime=P.join(s,w.runtime):o.runtime=w.runtime),w.runtimeArgs&&(o.runtimeArgs=w.runtimeArgs),w.program&&(P.isAbsolute(w.program)?o.program=w.program:o.program=P.join(s,w.program)),w.args&&(o.args=w.args);const g=w;return g.win&&(o.win=v.extract(g.win,s)),g.winx86&&(o.winx86=v.extract(g.winx86,s)),g.windows&&(o.windows=v.extract(g.windows,s)),g.osx&&(o.osx=v.extract(g.osx,s)),g.linux&&(o.linux=v.extract(g.linux,s)),o}static platformAdapterExecutable(w,s){let o=Object.create(null);s=s.toLowerCase();for(const n of w)if(n.contributes){const u=n.contributes.debuggers;u&&u.length>0&&u.filter(a=>typeof a.type=="string"&&k.equalsIgnoreCase(a.type,s)).forEach(a=>{const f=v.extract(a,n.extensionLocation.fsPath);o=_.mixin(o,f,n.isBuiltin)})}let g;I.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=o.winx86||o.win||o.windows:I.isWindows?g=o.win||o.windows:I.isMacintosh?g=o.osx:I.isLinux&&(g=o.linux),g=g||o;let c=g.program||o.program;const S=g.args||o.args;let r=g.runtime||o.runtime;const t=g.runtimeArgs||o.runtimeArgs;if(r)return{type:"executable",command:r,args:(t||[]).concat(typeof c=="string"?[c]:[]).concat(S||[])};if(c)return{type:"executable",command:c,args:S||[]}}}e.ExecutableDebugAdapter=v}),define(we[209],be([0,1,37,12,30,185]),function(Y,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function P(l,E){return new Promise((h,p)=>{let v="";const A=m.spawn(l,E);A.pid&&A.stdout.on("data",w=>{v+=w.toString()}),A.on("error",w=>{p(w)}),A.on("close",w=>{h(v)})})}let k;function _(l,E){if(!k)if(i.isWindows)k=new C.WindowsExternalTerminalService;else if(i.isMacintosh)k=new C.MacExternalTerminalService;else if(i.isLinux)k=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const h=E.getConfiguration("terminal");return k.runInTerminal(l.title,l.cwd,l.args,l.env||{},h.external||{})}e.runInExternalTerminal=_;async function I(l){if(l)if(i.isWindows){const E=await new Promise((h,p)=>{Y(["windows-process-tree"],h,p)});return new Promise(h=>{E.getProcessTree(l,p=>{h(p.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(l)]).then(E=>{const h=E.trim();return!(h.length===0||h.indexOf(" tmux")>=0)},E=>!0);return Promise.resolve(!0)}e.hasChildProcesses=I;var L;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(L||(L={}));function T(l,E,h,p){l=l.trim().toLowerCase();let v;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?v=1:l.indexOf("cmd.exe")>=0?v=0:l.indexOf("bash")>=0?v=2:i.isWindows?v=0:v=2;let A,w=" ";switch(v){case 1:if(A=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),h){const s=(0,y.getDriveLetter)(h);s&&(w+=`${s}:; `),w+=`cd ${A(h)}; `}if(p)for(let s in p){const o=p[s];o===null?w+=`Remove-Item env:${s}; `:w+=`\${env:${s}}='${o}'; `}if(E.length>0){const s=A(E.shift());w+=s[0]==="'"?`& ${s} `:`${s} `;for(let o of E)w+=`${A(o)} `}break;case 0:if(A=s=>(s=s.replace(/\"/g,'""'),s.indexOf(" ")>=0||s.indexOf('"')>=0||s.length===0?`"${s}"`:s),h){const s=(0,y.getDriveLetter)(h);s&&(w+=`${s}: && `),w+=`cd ${A(h)} && `}if(p){w+='cmd /C "';for(let s in p){let o=p[s];o===null?w+=`set "${s}=" && `:(o=o.replace(/[\^\&\|\<\>]/g,g=>`^${g}`),w+=`set "${s}=${o}" && `)}}for(let s of E)w+=`${A(s)} `;p&&(w+='"');break;case 2:{A=o=>(o=o.replace(/(["'\\\$])/g,"\\$1"),o.indexOf(" ")>=0||o.indexOf(";")>=0||o.length===0?`"${o}"`:o);const s=o=>/[^\w@%\/+=,.:^-]/.test(o)?`'${o.replace(/'/g,"'\\''")}'`:o;if(h&&(w+=`cd ${A(h)} ; `),p){w+="/usr/bin/env";for(let o in p){const g=p[o];g===null?w+=` -u ${s(o)}`:w+=` ${s(`${o}=${g}`)}`}w+=" "}for(let o of E)w+=`${A(o)} `;break}}return w}e.prepareCommand=T}),define(we[125],be([0,1,31,77,101,10,9,12,61]),function(Y,e,m,i,y,C,P,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var I;(function(d){d[d.Markup=1]="Markup",d[d.Code=2]="Code"})(I=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",y.Mimes.latex,y.Mimes.markdown,"image/png","image/jpeg",y.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[y.Mimes.latex,y.Mimes.markdown,"application/json",y.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var L;(function(d){d[d.Running=1]="Running",d[d.Idle=2]="Idle"})(L=e.NotebookRunState||(e.NotebookRunState={}));var T;(function(d){d[d.Pending=2]="Pending",d[d.Executing=3]="Executing"})(T=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var l;(function(d){d[d.WithHardKernelDependency=0]="WithHardKernelDependency",d[d.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",d[d.Pure=2]="Pure",d[d.Never=3]="Never"})(l=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var E;(function(d){d.Always="always",d.Never="never",d.Optional="optional"})(E=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(d){d[d.ModelChange=1]="ModelChange",d[d.Move=2]="Move",d[d.ChangeLanguage=5]="ChangeLanguage",d[d.Initialize=6]="Initialize",d[d.ChangeCellMetadata=7]="ChangeCellMetadata",d[d.Output=8]="Output",d[d.OutputItem=9]="OutputItem",d[d.ChangeCellContent=10]="ChangeCellContent",d[d.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",d[d.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",d[d.ChangeCellMime=13]="ChangeCellMime",d[d.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var p;(function(d){d[d.Handle=0]="Handle",d[d.Index=1]="Index"})(p=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(d){d[d.Replace=1]="Replace",d[d.Output=2]="Output",d[d.Metadata=3]="Metadata",d[d.CellLanguage=4]="CellLanguage",d[d.DocumentMetadata=5]="DocumentMetadata",d[d.Move=6]="Move",d[d.OutputItems=7]="OutputItems",d[d.PartialMetadata=8]="PartialMetadata",d[d.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var A;(function(d){d.scheme=C.Schemas.vscodeNotebookCell;const D=/^ch(\d{7,})/;function R(W,M){return W.with({scheme:d.scheme,fragment:`ch${M.toString().padStart(7,"0")}${W.scheme!==C.Schemas.file?W.scheme:""}`})}d.generate=R;function N(W){if(W.scheme!==d.scheme)return;const M=D.exec(W.fragment);return M?{handle:Number(M[1]),notebook:W.with({scheme:W.fragment.substr(M[0].length)||C.Schemas.file,fragment:null})}:void 0}d.parse=N;function B(W,M,x){return W.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`ch${M.toString().padStart(7,"0")},${x??""},${W.scheme!==C.Schemas.file?W.scheme:""}`})}d.generateCellOutputUri=B;function F(W){if(W.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const M=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(W.fragment);if(!M)return;const x=Number(M[1]),V=M[2]&&M[2]!==""?M[2]:void 0,U=M[3];return{handle:x,outputId:V,notebook:W.with({scheme:U||C.Schemas.file,fragment:null})}}d.parseCellOutputUri=F;function O(W,M,x){return W.with({scheme:x,fragment:`ch${M.toString().padStart(7,"0")}${W.scheme!==C.Schemas.file?W.scheme:""}`})}d.generateCellUri=O;function z(W,M){if(W.scheme!==M)return;const x=D.exec(W.fragment);return x?{handle:Number(x[1]),notebook:W.with({scheme:W.fragment.substr(x[0].length)||C.Schemas.file,fragment:null})}:void 0}d.parseCellUri=z})(A=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function s(d){return w.get(d)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=s;function o(d){return w.get(d)?.supportedByCore??!1}e.mimeTypeSupportedByCore=o;function g(d){return w.get(d)?.mergeable??!1}e.mimeTypeIsMergeable=g;const c=d=>k.isWindows?d.replace(/\//g,"\\"):d;class S{constructor(D=[],R=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=R,this.order=[...new Set(D)].map(N=>({pattern:N,matches:m.parse(c(N))}))}sort(D){const R=new Map(i.Iterable.map(D,B=>[B,c(B)]));let N=[];for(const{matches:B}of this.order)for(const[F,O]of R)if(B(O)){N.push(F),R.delete(F);break}return R.size&&(N=N.concat([...R.keys()].sort((B,F)=>this.defaultOrder.indexOf(B)-this.defaultOrder.indexOf(F)))),N}prioritize(D,R){const N=this.findIndex(D);if(N===-1){this.order.unshift({pattern:D,matches:m.parse(c(D))});return}const B=new Set(R.map(O=>this.findIndex(O,N)));B.delete(-1);const F=Array.from(B).sort();this.order.splice(N+1,0,...F.map(O=>this.order[O]));for(let O=F.length-1;O>=0;O--)this.order.splice(F[O],1)}toArray(){return this.order.map(D=>D.pattern)}findIndex(D,R=this.order.length){const N=c(D);for(let B=0;B<R;B++)if(this.order[B].matches(N))return B;return-1}}e.MimeTypeDisplayOrder=S;function r(d,D,R,N=(B,F)=>B===F){const B=[];function F(W,M,x){if(M===0&&x.length===0)return;const V=B[B.length-1];V&&V.start+V.deleteCount===W?(V.deleteCount+=M,V.toInsert.push(...x)):B.push({start:W,deleteCount:M,toInsert:x})}let O=0,z=0;for(;;){if(O===d.length){F(O,0,D.slice(z));break}if(z===D.length){F(O,d.length-O,[]);break}const W=d[O],M=D[z];if(N(W,M)){O+=1,z+=1;continue}R(M)?(F(O,1,[]),O+=1):(F(O,0,[M]),z+=1)}return B}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new _.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(d){d.default="default",d.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function n(d){const D=d;return!!((typeof D.include=="string"||m.isRelativePattern(D.include))&&(typeof D.exclude=="string"||m.isRelativePattern(D.exclude)))}e.isDocumentExcludePattern=n;function u(d,D,R){if(Array.isArray(d.viewType)&&d.viewType.indexOf(D)>=0||d.viewType===D)return!0;if(d.filenamePattern){let N=n(d.filenamePattern)?d.filenamePattern.include:d.filenamePattern,B=n(d.filenamePattern)?d.filenamePattern.exclude:void 0;if(m.match(N,(0,P.basename)(R.fsPath).toLowerCase()))return!(B&&m.match(B,(0,P.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=u;class a{constructor(D){this.textModel=D}getElements(){const D=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)D[R]=this.textModel.cells[R].getHashValue();return D}}e.CellSequence=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var f;(function(d){d[d.Left=1]="Left",d[d.Right=2]="Right"})(f=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class b{static create(D){return`${b._prefix}${D}`}static parse(D){if(D.startsWith(b._prefix))return D.substr(b._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=b,b._prefix="notebook/"}),define(we[210],be([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var i;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState",y[y.Complete=4]="Complete"})(i=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,m.createDecorator)("INotebookExecutionService")}),define(we[211],be([0,1,4,61]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new i.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new i.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new i.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,m.createDecorator)(e.OUTPUT_SERVICE_ID);var y;(function(C){C[C.Append=1]="Append",C[C.Replace=2]="Replace",C[C.Clear=3]="Clear"})(y=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(we[212],be([0,1,175,4,61]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new y.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new y.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new y.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=(0,i.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[213],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=m;function i(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=i}),define(we[126],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var m;(function(T){T[T.Unset=0]="Unset",T[T.Queued=1]="Queued",T[T.Running=2]="Running",T[T.Passed=3]="Passed",T[T.Failed=4]="Failed",T[T.Skipped=5]="Skipped",T[T.Errored=6]="Errored"})(m=e.TestResultState||(e.TestResultState={}));var i;(function(T){T[T.Run=2]="Run",T[T.Debug=4]="Debug",T[T.Coverage=8]="Coverage",T[T.HasNonDefaultProfile=16]="HasNonDefaultProfile",T[T.HasConfigurable=32]="HasConfigurable"})(i=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var y;(function(T){T[T.Error=0]="Error",T[T.Info=1]="Info"})(y=e.TestMessageType||(e.TestMessageType={}));var C;(function(T){T[T.NotExpandable=0]="NotExpandable",T[T.Expandable=1]="Expandable",T[T.BusyExpanding=2]="BusyExpanding",T[T.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const P=(T,l)=>{l.expand!==void 0&&(T.expand=l.expand),l.item!==void 0&&(T.item=T.item?Object.assign(T.item,l.item):l.item)};e.applyTestItemUpdate=P;var k;(function(T){T[T.Function=0]="Function",T[T.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var _;(function(T){T[T.Add=0]="Add",T[T.Update=1]="Update",T[T.Remove=2]="Remove",T[T.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",T[T.Retire=4]="Retire",T[T.AddTag=5]="AddTag",T[T.RemoveTag=6]="RemoveTag"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));class I{add(l){}update(l){}remove(l,E){}complete(){}}e.IncrementalChangeCollector=I;class L{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(l){const E=this.createChangeCollector();for(const h of l)switch(h[0]){case 0:{const p=h[1];if(p.parent){if(this.items.has(p.parent)){const v=this.items.get(p.parent);v.children.add(p.item.extId);const A=this.createItem(p,v);this.items.set(p.item.extId,A),E.add(A)}}else{const v=this.createItem(p);this.roots.add(v),this.items.set(p.item.extId,v),E.add(v)}p.expand===2&&this.busyControllerCount++;break}case 1:{const p=h[1],v=this.items.get(p.extId);if(!v)break;p.expand!==void 0&&(v.expand===2&&this.busyControllerCount--,p.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(v,p),E.update(v);break}case 2:{const p=this.items.get(h[1]);if(!p)break;p.parent?this.items.get(p.parent).children.delete(p.item.extId):this.roots.delete(p);const v=[[h[1]]];for(;v.length;)for(const A of v.pop()){const w=this.items.get(A);w&&(v.push(w.children),this.items.delete(A),E.remove(w,w!==p),w.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(h[1]);break;case 3:this.updatePendingRoots(h[1]);break;case 5:this._tags.set(h[1].id,h[1]);break;case 6:this._tags.delete(h[1]);break}E.complete()}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return new I}}e.AbstractIncrementalTestCollection=L}),define(we[89],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var m;(function(C){C.Delimiter="\0"})(m=e.TestIdPathParts||(e.TestIdPathParts={}));var i;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(i=e.TestPosition||(e.TestPosition={}));class y{constructor(P,k=P.length){if(this.path=P,this.viewEnd=k,P.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(P,k,_=P.parent){if(P.id===k)return new y([k]);let I=[P.id];for(let L=_;L&&L.id!==k;L=L.parent)I.push(L.id);return I.push(k),new y(I.reverse())}static isRoot(P){return!P.includes("\0")}static fromString(P){return new y(P.split("\0"))}static join(P,k){return new y([...P.path,k])}static joinToString(P,k){return P.toString()+"\0"+k}static compare(P,k){return P===k?0:k.startsWith(P+"\0")?2:P.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new y(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let P=1;P<=this.viewEnd;P++)yield new y(this.path,P)}compare(P){if(typeof P=="string")return y.compare(this.toString(),P);for(let k=0;k<P.viewEnd&&k<this.viewEnd;k++)if(P.path[k]!==this.path[k])return 1;return P.viewEnd>this.viewEnd?2:P.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let P=1;P<this.viewEnd;P++)this.stringifed+="\0",this.stringifed+=this.path[P]}return this.stringifed}}e.TestId=y}),define(we[214],be([0,1,9,40,13,25,12,80,176]),function(Y,e,m,i,y,C,P,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(T,l,E){this._contributedVariables=new Map,this._context=T,this._labelService=l,E&&(this._envVariablesPromise=E.then(h=>this.prepareEnv(h)))}prepareEnv(T){if(P.isWindows){const l=Object.create(null);return Object.keys(T).forEach(E=>{l[E.toLowerCase()]=T[E]}),l}return T}resolveWithEnvironment(T,l,E){return this.recursiveResolve(this.prepareEnv(T),l?l.uri:void 0,E)}async resolveAsync(T,l){return this.recursiveResolve(await this._envVariablesPromise,T?T.uri:void 0,l)}async resolveAnyBase(T,l,E,h){const p=C.deepClone(l);return P.isWindows&&p.windows?Object.keys(p.windows).forEach(v=>p[v]=p.windows[v]):P.isMacintosh&&p.osx?Object.keys(p.osx).forEach(v=>p[v]=p.osx[v]):P.isLinux&&p.linux&&Object.keys(p.linux).forEach(v=>p[v]=p.linux[v]),delete p.windows,delete p.osx,delete p.linux,this.recursiveResolve(await this._envVariablesPromise,T?T.uri:void 0,p,E,h)}async resolveAnyAsync(T,l,E){return this.resolveAnyBase(T,l,E)}async resolveAnyMap(T,l,E){const h=new Map;return{newConfig:await this.resolveAnyBase(T,l,E,h),resolvedVariables:h}}resolveWithInteractionReplace(T,l,E,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,l,E,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,l){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,l)}recursiveResolve(T,l,E,h,p){if(y.isString(E))return this.resolveString(T,l,E,h,p);if(y.isArray(E))return E.map(v=>this.recursiveResolve(T,l,v,h,p));if(y.isObject(E)){let v=Object.create(null);return Object.keys(E).forEach(A=>{const w=this.resolveString(T,l,A,h,p);v[w]=this.recursiveResolve(T,l,E[A],h,p)}),v}return E}resolveString(T,l,E,h,p){return E.replace(I.VARIABLE_REGEXP,(A,w)=>{if(w.includes(I.VARIABLE_LHS))return A;let s=this.evaluateSingleVariable(T,A,w,l,h);return p&&p.set(w,s),s!==A&&y.isString(s)&&s.match(I.VARIABLE_REGEXP)&&(s=this.resolveString(T,l,s,h,p)),s})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}evaluateSingleVariable(T,l,E,h,p){let v;const A=E.split(":");A.length>1&&(E=A[0],v=A[1]);const w=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error((0,_.localize)(0,null,l))},s=()=>{const g=w();if(this._context.getWorkspaceFolderPathForFile){const c=this._context.getWorkspaceFolderPathForFile();if(c)return c}throw new Error((0,_.localize)(1,null,l,m.basename(g)))},o=()=>{if(v){const g=this._context.getFolderUri(v);if(g)return g;throw new Error((0,_.localize)(2,null,l,v))}if(h)return h;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,l)):new Error((0,_.localize)(4,null,l))};switch(E){case"env":if(v){if(T){const g=T[P.isWindows?v.toLowerCase():v];if(y.isString(g))return g}return""}throw new Error((0,_.localize)(5,null,l));case"config":if(v){const g=this._context.getConfigurationValue(h,v);if(y.isUndefinedOrNull(g))throw new Error((0,_.localize)(6,null,l,v));if(y.isObject(g))throw new Error((0,_.localize)(7,null,l,v));return g}throw new Error((0,_.localize)(8,null,l));case"command":return this.resolveFromMap(l,v,p,"command");case"input":return this.resolveFromMap(l,v,p,"input");default:switch(E){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(o()));case"cwd":return h||v?(0,k.normalizeDriveLetter)(this.fsPath(o())):i.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(o()));case"lineNumber":{const g=this._context.getLineNumber();if(g)return g;throw new Error((0,_.localize)(9,null,l))}case"selectedText":{const g=this._context.getSelectedText();if(g)return g;throw new Error((0,_.localize)(10,null,l))}case"file":return w();case"fileWorkspaceFolder":return s();case"relativeFile":return h||v?m.relative(this.fsPath(o()),w()):w();case"relativeFileDirname":{const g=m.dirname(w());if(h||v){const c=m.relative(this.fsPath(o()),g);return c.length===0?".":c}return g}case"fileDirname":return m.dirname(w());case"fileExtname":return m.extname(w());case"fileBasename":return m.basename(w());case"fileBasenameNoExtension":{const g=m.basename(w());return g.slice(0,g.length-m.extname(g).length)}case"fileDirnameBasename":return m.basename(m.dirname(w()));case"execPath":{const g=this._context.getExecPath();return g||l}case"execInstallFolder":{const g=this._context.getAppRoot();return g||l}case"pathSeparator":return m.sep;default:try{const g=v?`${E}:${v}`:E;return this.resolveFromMap(l,g,p,void 0)}catch{return l}}}}resolveFromMap(T,l,E,h){if(l&&E){const p=h===void 0?E[l]:E[h+":"+l];if(typeof p=="string")return p;throw new Error((0,_.localize)(11,null,T))}return T}}e.AbstractVariableResolverService=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[127],be([0,1,4,206]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var y;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var C;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var k;(function(h){h[h.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function I(h){const p=h;return(0,i.isEditorInput)(p?.editor)&&(0,i.isEditorInput)(p?.replacement)}e.isEditorReplacement=I;var L;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var T;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function l(h){const p=h;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=l;function E(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(we[215],be([0,1,4,127]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(C){const P=C;return typeof C=="number"||(0,i.isEditorGroup)(P)}e.isPreferredGroup=y}),define(we[17],be([0,1,16,22,97,290,59,25,13,2,41,84,177,116,63,125,89,215,7]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(me){function De(Q){const{selectionStartLineNumber:Ie,selectionStartColumn:Fe,positionLineNumber:Ze,positionColumn:qe}=Q,dt=new w.Position(Ie-1,Fe-1),wt=new w.Position(Ze-1,qe-1);return new w.Selection(dt,wt)}me.to=De;function ue(Q){const{anchor:Ie,active:Fe}=Q;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Fe.line+1,positionColumn:Fe.character+1}}me.from=ue})(s=e.Selection||(e.Selection={}));var o;(function(me){function De(Q){if(!Q)return;const{start:Ie,end:Fe}=Q;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Fe.line+1,endColumn:Fe.character+1}}me.from=De;function ue(Q){if(!Q)return;const{startLineNumber:Ie,startColumn:Fe,endLineNumber:Ze,endColumn:qe}=Q;return new w.Range(Ie-1,Fe-1,Ze-1,qe-1)}me.to=ue})(o=e.Range||(e.Range={}));var g;(function(me){function De(ue){switch(ue){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 3:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}me.to=De})(g=e.TokenType||(e.TokenType={}));var c;(function(me){function De(Q){return new w.Position(Q.lineNumber-1,Q.column-1)}me.to=De;function ue(Q){return{lineNumber:Q.line+1,column:Q.character+1}}me.from=ue})(c=e.Position||(e.Position={}));var S;(function(me){function De(Ie,Fe){return(0,m.coalesce)((0,m.asArray)(Ie).map(Ze=>ue(Ze,Fe)))}me.from=De;function ue(Ie,Fe){if(typeof Ie=="string")return{$serialized:!0,language:Ie};if(Ie)return{$serialized:!0,language:Ie.language,scheme:Q(Ie.scheme,Fe),pattern:typeof Ie.pattern=="undefined"?void 0:Z.from(Ie.pattern),exclusive:Ie.exclusive}}function Q(Ie,Fe){return Fe&&typeof Ie=="string"?Fe.transformOutgoingScheme(Ie):Ie}})(S=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(me){function De(Q){switch(Q){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}me.from=De;function ue(Q){switch(Q){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}me.to=ue})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(me){function De(Q){let Ie;return Q.code&&((0,_.isString)(Q.code)||(0,_.isNumber)(Q.code)?Ie=String(Q.code):Ie={value:String(Q.code.value),target:Q.code.target}),{...o.from(Q.range),message:Q.message,source:Q.source,code:Ie,severity:u.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(n.from),tags:Array.isArray(Q.tags)?(0,m.coalesce)(Q.tags.map(r.from)):void 0}}me.from=De;function ue(Q){const Ie=new w.Diagnostic(o.to(Q),Q.message,u.to(Q.severity));return Ie.source=Q.source,Ie.code=(0,_.isString)(Q.code)?Q.code:Q.code?.value,Ie.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(n.to),Ie.tags=Q.tags&&(0,m.coalesce)(Q.tags.map(r.to)),Ie}me.to=ue})(t=e.Diagnostic||(e.Diagnostic={}));var n;(function(me){function De(Q){return{...o.from(Q.location.range),message:Q.message,resource:Q.location.uri}}me.from=De;function ue(Q){return new w.DiagnosticRelatedInformation(new w.Location(Q.resource,o.to(Q)),Q.message)}me.to=ue})(n=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var u;(function(me){function De(Q){switch(Q){case w.DiagnosticSeverity.Error:return E.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return E.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return E.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return E.MarkerSeverity.Hint}return E.MarkerSeverity.Error}me.from=De;function ue(Q){switch(Q){case E.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case E.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case E.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case E.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}me.to=ue})(u=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var a;(function(me){function De(Q){return typeof Q=="number"&&Q>=w.ViewColumn.One?Q-1:Q===w.ViewColumn.Beside?A.SIDE_GROUP:A.ACTIVE_GROUP}me.from=De;function ue(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}me.to=ue})(a=e.ViewColumn||(e.ViewColumn={}));function f(me){return typeof me.range!="undefined"}function b(me){return me.length===0?!0:!!f(me[0])}e.isDecorationOptionsArr=b;var d;(function(me){function De(qe){return qe.map(me.from)}me.fromMany=De;function ue(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function Q(qe){let dt;if(ue(qe)){const{language:ft,value:vt}=qe;dt={value:"```"+ft+`
`+vt+"\n```\n"}}else w.MarkdownString.isMarkdownString(qe)?dt={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml}:typeof qe=="string"?dt={value:qe}:dt={value:""};const wt=Object.create(null);dt.uris=wt;const yt=ft=>{try{let vt=I.URI.parse(ft,!0);vt=vt.with({query:Ie(vt.query,wt)}),wt[ft]=vt}catch{}return""},bt=new C.Renderer;return bt.link=yt,bt.image=ft=>yt(y.parseHrefAndDimensions(ft).href),C(dt.value,{renderer:bt}),dt}me.from=Q;function Ie(qe,dt){if(!qe)return qe;let wt;try{wt=(0,P.parse)(qe)}catch{}if(!wt)return qe;let yt=!1;return wt=(0,k.cloneAndChange)(wt,bt=>{if(I.URI.isUri(bt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[ft]=bt,yt=!0,ft}else return}),yt?JSON.stringify(wt):qe}function Fe(qe){const dt=new w.MarkdownString(qe.value,qe.supportThemeIcons);return dt.isTrusted=qe.isTrusted,dt.supportHtml=qe.supportHtml,dt}me.to=Fe;function Ze(qe){if(!!qe)return typeof qe=="string"?qe:me.from(qe)}me.fromStrict=Ze})(d=e.MarkdownString||(e.MarkdownString={}));function D(me){return b(me)?me.map(De=>({range:o.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?d.fromMany(De.hoverMessage):De.hoverMessage?d.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):me.map(De=>({range:o.from(De)}))}e.fromRangeOrRangeWithMessage=D;function R(me){return typeof me=="undefined"?me:typeof me=="string"?I.URI.file(me):me}e.pathOrURIToURI=R;var N;(function(me){function De(ue){return typeof ue=="undefined"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?R(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}me.from=De})(N=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(me){function De(ue){return typeof ue=="undefined"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?R(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?N.from(ue.before):void 0,after:ue.after?N.from(ue.after):void 0}}me.from=De})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(me){function De(ue){if(typeof ue=="undefined")return ue;switch(ue){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}me.from=De})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(me){function De(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?F.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?B.from(ue.light):void 0,dark:ue.dark?B.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?R(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?N.from(ue.before):void 0,after:ue.after?N.from(ue.after):void 0}}me.from=De})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(me){function De(Q){return{text:Q.newText,eol:Q.newEol&&ct.from(Q.newEol),range:o.from(Q.range)}}me.from=De;function ue(Q){const Ie=new w.TextEdit(o.to(Q.range),Q.text);return Ie.newEol=typeof Q.eol=="undefined"?void 0:ct.to(Q.eol),Ie}me.to=ue})(z=e.TextEdit||(e.TextEdit={}));var W;(function(me){function De(Q,Ie,Fe){const Ze={edits:[]};if(Q instanceof w.WorkspaceEdit)for(let qe of Q._allEntries())if(qe._type===1)Ze.edits.push({_type:1,oldUri:qe.from,newUri:qe.to,options:qe.options,metadata:qe.metadata});else if(qe._type===2){const dt=Ie?.getDocument(qe.uri);Ze.edits.push({_type:2,resource:qe.uri,edit:z.from(qe.edit),modelVersionId:dt?.version,metadata:qe.metadata})}else qe._type===3?Ze.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,edit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Fe?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version}):qe._type===5&&Ze.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,notebookVersionId:Fe?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Be.from)}});return Ze}me.from=De;function ue(Q){const Ie=new w.WorkspaceEdit;for(const Fe of Q.edits)Fe.edit?Ie.replace(I.URI.revive(Fe.resource),o.to(Fe.edit.range),Fe.edit.text):Ie.renameFile(I.URI.revive(Fe.oldUri),I.URI.revive(Fe.newUri),Fe.options);return Ie}me.to=ue})(W=e.WorkspaceEdit||(e.WorkspaceEdit={}));var M;(function(me){const De=Object.create(null);De[w.SymbolKind.File]=0,De[w.SymbolKind.Module]=1,De[w.SymbolKind.Namespace]=2,De[w.SymbolKind.Package]=3,De[w.SymbolKind.Class]=4,De[w.SymbolKind.Method]=5,De[w.SymbolKind.Property]=6,De[w.SymbolKind.Field]=7,De[w.SymbolKind.Constructor]=8,De[w.SymbolKind.Enum]=9,De[w.SymbolKind.Interface]=10,De[w.SymbolKind.Function]=11,De[w.SymbolKind.Variable]=12,De[w.SymbolKind.Constant]=13,De[w.SymbolKind.String]=14,De[w.SymbolKind.Number]=15,De[w.SymbolKind.Boolean]=16,De[w.SymbolKind.Array]=17,De[w.SymbolKind.Object]=18,De[w.SymbolKind.Key]=19,De[w.SymbolKind.Null]=20,De[w.SymbolKind.EnumMember]=21,De[w.SymbolKind.Struct]=22,De[w.SymbolKind.Event]=23,De[w.SymbolKind.Operator]=24,De[w.SymbolKind.TypeParameter]=25;function ue(Ie){return typeof De[Ie]=="number"?De[Ie]:6}me.from=ue;function Q(Ie){for(const Fe in De)if(De[Fe]===Ie)return Number(Fe);return w.SymbolKind.Property}me.to=Q})(M=e.SymbolKind||(e.SymbolKind={}));var x;(function(me){function De(Q){switch(Q){case w.SymbolTag.Deprecated:return 1}}me.from=De;function ue(Q){switch(Q){case 1:return w.SymbolTag.Deprecated}}me.to=ue})(x=e.SymbolTag||(e.SymbolTag={}));var V;(function(me){function De(Q){return{name:Q.name,kind:M.from(Q.kind),tags:Q.tags&&Q.tags.map(x.from),containerName:Q.containerName,location:K.from(Q.location)}}me.from=De;function ue(Q){const Ie=new w.SymbolInformation(Q.name,M.to(Q.kind),Q.containerName,K.to(Q.location));return Ie.tags=Q.tags&&Q.tags.map(x.to),Ie}me.to=ue})(V=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var U;(function(me){function De(Q){const Ie={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:o.from(Q.range),selectionRange:o.from(Q.selectionRange),kind:M.from(Q.kind),tags:Q.tags?.map(x.from)??[]};return Q.children&&(Ie.children=Q.children.map(De)),Ie}me.from=De;function ue(Q){const Ie=new w.DocumentSymbol(Q.name,Q.detail,M.to(Q.kind),o.to(Q.range),o.to(Q.selectionRange));return(0,m.isNonEmptyArray)(Q.tags)&&(Ie.tags=Q.tags.map(x.to)),Q.children&&(Ie.children=Q.children.map(ue)),Ie}me.to=ue})(U=e.DocumentSymbol||(e.DocumentSymbol={}));var H;(function(me){function De(Q){const Ie=new w.CallHierarchyItem(M.to(Q.kind),Q.name,Q.detail||"",I.URI.revive(Q.uri),o.to(Q.range),o.to(Q.selectionRange));return Ie._sessionId=Q._sessionId,Ie._itemId=Q._itemId,Ie}me.to=De;function ue(Q,Ie,Fe){if(Ie=Ie??Q._sessionId,Fe=Fe??Q._itemId,Ie===void 0||Fe===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Fe,name:Q.name,detail:Q.detail,kind:M.from(Q.kind),uri:Q.uri,range:o.from(Q.range),selectionRange:o.from(Q.selectionRange),tags:Q.tags?.map(x.from)}}me.from=ue})(H=e.CallHierarchyItem||(e.CallHierarchyItem={}));var X;(function(me){function De(ue){return new w.CallHierarchyIncomingCall(H.to(ue.from),ue.fromRanges.map(Q=>o.to(Q)))}me.to=De})(X=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var se;(function(me){function De(ue){return new w.CallHierarchyOutgoingCall(H.to(ue.to),ue.fromRanges.map(Q=>o.to(Q)))}me.to=De})(se=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var K;(function(me){function De(Q){return{range:Q.range&&o.from(Q.range),uri:Q.uri}}me.from=De;function ue(Q){return new w.Location(I.URI.revive(Q.uri),o.to(Q.range))}me.to=ue})(K=e.location||(e.location={}));var j;(function(me){function De(Q){const Ie=Q,Fe=Q;return{originSelectionRange:Ie.originSelectionRange?o.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Fe.uri,range:o.from(Ie.targetRange?Ie.targetRange:Fe.range),targetSelectionRange:Ie.targetSelectionRange?o.from(Ie.targetSelectionRange):void 0}}me.from=De;function ue(Q){return{targetUri:I.URI.revive(Q.uri),targetRange:o.to(Q.range),targetSelectionRange:Q.targetSelectionRange?o.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?o.to(Q.originSelectionRange):void 0}}me.to=ue})(j=e.DefinitionLink||(e.DefinitionLink={}));var ie;(function(me){function De(Q){return{range:o.from(Q.range),contents:d.fromMany(Q.contents)}}me.from=De;function ue(Q){return new w.Hover(Q.contents.map(d.to),o.to(Q.range))}me.to=ue})(ie=e.Hover||(e.Hover={}));var ce;(function(me){function De(Q){return{range:o.from(Q.range),expression:Q.expression}}me.from=De;function ue(Q){return new w.EvaluatableExpression(o.to(Q.range),Q.expression)}me.to=ue})(ce=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ge;(function(me){function De(Q){if(Q instanceof w.InlineValueText)return{type:"text",range:o.from(Q.range),text:Q.text};if(Q instanceof w.InlineValueVariableLookup)return{type:"variable",range:o.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}me.from=De;function ue(Q){switch(Q.type){case"text":return{range:o.to(Q.range),text:Q.text};case"variable":return{range:o.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:o.to(Q.range),expression:Q.expression}}}me.to=ue})(ge=e.InlineValue||(e.InlineValue={}));var ke;(function(me){function De(Q){return{frameId:Q.frameId,stoppedLocation:o.from(Q.stoppedLocation)}}me.from=De;function ue(Q){return new w.InlineValueContext(Q.frameId,o.to(Q.stoppedLocation))}me.to=ue})(ke=e.InlineValueContext||(e.InlineValueContext={}));var Le;(function(me){function De(Q){return{range:o.from(Q.range),kind:Q.kind}}me.from=De;function ue(Q){return new w.DocumentHighlight(o.to(Q.range),Q.kind)}me.to=ue})(Le=e.DocumentHighlight||(e.DocumentHighlight={}));var Oe;(function(me){function De(ue){switch(ue){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}me.to=De})(Oe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var q;(function(me){function De(ue){return{triggerKind:Oe.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}me.to=De})(q=e.CompletionContext||(e.CompletionContext={}));var J;(function(me){function De(Q){switch(Q){case w.CompletionItemTag.Deprecated:return 1}}me.from=De;function ue(Q){switch(Q){case 1:return w.CompletionItemTag.Deprecated}}me.to=ue})(J=e.CompletionItemTag||(e.CompletionItemTag={}));var re;(function(me){const De=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function ue(Fe){return De.get(Fe)??9}me.from=ue;const Q=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function Ie(Fe){return Q.get(Fe)??w.CompletionItemKind.Property}me.to=Ie})(re=e.CompletionItemKind||(e.CompletionItemKind={}));var he;(function(me){function De(ue,Q){const Ie=new w.CompletionItem(ue.label);return Ie.insertText=ue.insertText,Ie.kind=re.to(ue.kind),Ie.tags=ue.tags?.map(J.to),Ie.detail=ue.detail,Ie.documentation=y.isMarkdownString(ue.documentation)?d.to(ue.documentation):ue.documentation,Ie.sortText=ue.sortText,Ie.filterText=ue.filterText,Ie.preselect=ue.preselect,Ie.commitCharacters=ue.commitCharacters,L.Range.isIRange(ue.range)?Ie.range=o.to(ue.range):typeof ue.range=="object"&&(Ie.range={inserting:o.to(ue.range.insert),replacing:o.to(ue.range.replace)}),Ie.keepWhitespace=typeof ue.insertTextRules=="undefined"?!1:Boolean(ue.insertTextRules&1),typeof ue.insertTextRules!="undefined"&&ue.insertTextRules&4?Ie.insertText=new w.SnippetString(ue.insertText):(Ie.insertText=ue.insertText,Ie.textEdit=Ie.range instanceof w.Range?new w.TextEdit(Ie.range,Ie.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Ie.additionalTextEdits=ue.additionalTextEdits.map(Fe=>z.to(Fe))),Ie.command=Q&&ue.command?Q.fromInternal(ue.command):void 0,Ie}me.to=De})(he=e.CompletionItem||(e.CompletionItem={}));var ee;(function(me){function De(Q){return{label:Q.label,documentation:Q.documentation?d.fromStrict(Q.documentation):void 0}}me.from=De;function ue(Q){return{label:Q.label,documentation:y.isMarkdownString(Q.documentation)?d.to(Q.documentation):Q.documentation}}me.to=ue})(ee=e.ParameterInformation||(e.ParameterInformation={}));var ae;(function(me){function De(Q){return{label:Q.label,documentation:Q.documentation?d.fromStrict(Q.documentation):void 0,parameters:Array.isArray(Q.parameters)?Q.parameters.map(ee.from):[],activeParameter:Q.activeParameter}}me.from=De;function ue(Q){return{label:Q.label,documentation:y.isMarkdownString(Q.documentation)?d.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(ee.to):[],activeParameter:Q.activeParameter}}me.to=ue})(ae=e.SignatureInformation||(e.SignatureInformation={}));var Se;(function(me){function De(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(ae.from):[]}}me.from=De;function ue(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(ae.to):[]}}me.to=ue})(Se=e.SignatureHelp||(e.SignatureHelp={}));var Ue;(function(me){function De(Q){return{text:Q.text,position:c.from(Q.position),kind:Ve.from(Q.kind??w.InlayHintKind.Other),whitespaceBefore:Q.whitespaceBefore,whitespaceAfter:Q.whitespaceAfter}}me.from=De;function ue(Q){const Ie=new w.InlayHint(Q.text,c.to(Q.position),Ve.to(Q.kind));return Ie.whitespaceAfter=Q.whitespaceAfter,Ie.whitespaceBefore=Q.whitespaceBefore,Ie}me.to=ue})(Ue=e.InlayHint||(e.InlayHint={}));var Ve;(function(me){function De(Q){return Q}me.from=De;function ue(Q){return Q}me.to=ue})(Ve=e.InlayHintKind||(e.InlayHintKind={}));var Ge;(function(me){function De(Q){return{range:o.from(Q.range),url:Q.target,tooltip:Q.tooltip}}me.from=De;function ue(Q){let Ie;if(Q.url)try{Ie=typeof Q.url=="string"?I.URI.parse(Q.url,!0):I.URI.revive(Q.url)}catch{}return new w.DocumentLink(o.to(Q.range),Ie)}me.to=ue})(Ge=e.DocumentLink||(e.DocumentLink={}));var Je;(function(me){function De(Q){const Ie=new w.ColorPresentation(Q.label);return Q.textEdit&&(Ie.textEdit=z.to(Q.textEdit)),Q.additionalTextEdits&&(Ie.additionalTextEdits=Q.additionalTextEdits.map(Fe=>z.to(Fe))),Ie}me.to=De;function ue(Q){return{label:Q.label,textEdit:Q.textEdit?z.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Ie=>z.from(Ie)):void 0}}me.from=ue})(Je=e.ColorPresentation||(e.ColorPresentation={}));var tt;(function(me){function De(Q){return new w.Color(Q[0],Q[1],Q[2],Q[3])}me.to=De;function ue(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}me.from=ue})(tt=e.Color||(e.Color={}));var ot;(function(me){function De(Q){return{range:o.from(Q.range)}}me.from=De;function ue(Q){return new w.SelectionRange(o.to(Q.range))}me.to=ue})(ot=e.SelectionRange||(e.SelectionRange={}));var et;(function(me){function De(ue){switch(ue){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}me.to=De})(et=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var it;(function(me){function De(Q){switch(Q){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}me.from=De;function ue(Q){switch(Q){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}me.to=ue})(it=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ct;(function(me){function De(Q){if(Q===w.EndOfLine.CRLF)return 1;if(Q===w.EndOfLine.LF)return 0}me.from=De;function ue(Q){if(Q===1)return w.EndOfLine.CRLF;if(Q===0)return w.EndOfLine.LF}me.to=ue})(ct=e.EndOfLine||(e.EndOfLine={}));var pt;(function(me){function De(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}me.from=De})(pt=e.ProgressLocation||(e.ProgressLocation={}));var Pt;(function(me){function De(ue){const Q={start:ue.start+1,end:ue.end+1};return ue.kind&&(Q.kind=We.from(ue.kind)),Q}me.from=De})(Pt=e.FoldingRange||(e.FoldingRange={}));var We;(function(me){function De(ue){if(ue)switch(ue){case w.FoldingRangeKind.Comment:return T.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return T.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return T.FoldingRangeKind.Region}}me.from=De})(We=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Rt;(function(me){function De(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?o.from(ue.selection):void 0,override:typeof ue.override=="boolean"?l.EditorResolution.DISABLED:void 0}}me.from=De})(Rt=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Z;(function(me){function De(Q){return Q instanceof w.RelativePattern||typeof Q=="string"?Q:ue(Q)?new w.RelativePattern(Q.base,Q.pattern):Q}me.from=De;function ue(Q){const Ie=Q;return Ie&&typeof Ie.base=="string"&&typeof Ie.pattern=="string"}})(Z=e.GlobPattern||(e.GlobPattern={}));var ne;(function(me){function De(ue){if(ue){if(Array.isArray(ue))return ue.map(De);if(typeof ue=="string")return ue;{const Q=ue;return{language:Q.language,scheme:Q.scheme,pattern:typeof Q.pattern=="undefined"?void 0:Z.from(Q.pattern),exclusive:Q.exclusive}}}else return}me.from=De})(ne=e.LanguageSelector||(e.LanguageSelector={}));var ve;(function(me){function De(Q){return{start:Q.start,end:Q.end}}me.from=De;function ue(Q){return new w.NotebookRange(Q.start,Q.end)}me.to=ue})(ve=e.NotebookRange||(e.NotebookRange={}));var te;(function(me){function De(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}me.to=De;function ue(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}me.from=ue})(te=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var _e;(function(me){function De(Q){switch(Q){case w.NotebookCellKind.Markup:return p.CellKind.Markup;case w.NotebookCellKind.Code:default:return p.CellKind.Code}}me.from=De;function ue(Q){switch(Q){case p.CellKind.Markup:return w.NotebookCellKind.Markup;case p.CellKind.Code:default:return w.NotebookCellKind.Code}}me.to=ue})(_e=e.NotebookCellKind||(e.NotebookCellKind={}));var Me;(function(me){function De(Q){const Ie={metadata:Q.metadata??Object.create(null),cells:[]};for(let Fe of Q.cells)w.NotebookCellData.validate(Fe),Ie.cells.push(Be.from(Fe));return Ie}me.from=De;function ue(Q){const Ie=new w.NotebookData(Q.cells.map(Be.to));return(0,_.isEmptyObject)(Q.metadata)||(Ie.metadata=Q.metadata),Ie}me.to=ue})(Me=e.NotebookData||(e.NotebookData={}));var Be;(function(me){function De(Q){return{cellKind:_e.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:te.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(Ae.from):[]}}me.from=De;function ue(Q){return new w.NotebookCellData(_e.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(Ae.to):void 0,Q.metadata,Q.internalMetadata?te.to(Q.internalMetadata):void 0)}me.to=ue})(Be=e.NotebookCellData||(e.NotebookCellData={}));var Xe;(function(me){function De(Q){return{mime:Q.mime,valueBytes:i.VSBuffer.wrap(Q.data)}}me.from=De;function ue(Q){return new w.NotebookCellOutputItem(Q.valueBytes.buffer,Q.mime)}me.to=ue})(Xe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ae;(function(me){function De(Q){return{outputId:Q.id,items:Q.items.map(Xe.from),metadata:Q.metadata}}me.from=De;function ue(Q){const Ie=Q.items.map(Xe.to);return new w.NotebookCellOutput(Ie,Q.outputId,Q.metadata)}me.to=ue})(Ae=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Pe;(function(me){function De(Fe){if(Fe!=null){if(Fe instanceof w.RelativePattern||typeof Fe=="string")return Fe;if(Ie(Fe))return new w.RelativePattern(Fe.base,Fe.pattern);if(Q(Fe))return{include:Z.from(Fe.include)||void 0,exclude:Z.from(Fe.exclude)||void 0}}}me.from=De;function ue(Fe){return typeof Fe=="string"?Fe:Ie(Fe)?{base:Fe.base,pattern:Fe.pattern}:{include:Fe.include,exclude:Fe.exclude}}me.to=ue;function Q(Fe){const Ze=Fe,qe=Z.from(Ze.include);if(!(qe&&qe instanceof w.RelativePattern||typeof qe=="string"))return!1;const dt=Z.from(Ze.exclude);return!!(dt&&dt instanceof w.RelativePattern||typeof dt=="string")}function Ie(Fe){const Ze=Fe;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(Pe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ye;(function(me){function De(ue){return{backgroundColor:ue.backgroundColor,borderColor:ue.borderColor,top:ue.top?N.from(ue.top):void 0}}me.from=De})(ye=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var de;(function(me){function De(ue,Q,Ie){const Fe=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Fe,Ie),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}me.from=De})(de=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var fe;(function(me){function De(ue){return{transientOutputs:ue?.transientOutputs??!1,transientCellMetadata:ue?.transientCellMetadata??{},transientDocumentMetadata:ue?.transientDocumentMetadata??{}}}me.from=De})(fe=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ee;(function(me){function De(Q){return{uri:Q.uri,provides:Q.provides}}me.from=De;function ue(Q){return new w.NotebookRendererScript(I.URI.revive(Q.uri),Q.provides)}me.to=ue})(Ee=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Ce;(function(me){function De(Q){return{message:d.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,location:Q.location?K.from(Q.location):void 0}}me.from=De;function ue(Q){const Ie=new w.TestMessage(typeof Q.message=="string"?Q.message:d.to(Q.message));return Ie.actualOutput=Q.actual,Ie.expectedOutput=Q.expected,Ie.location=Q.location?K.to(Q.location):void 0,Ie}me.to=ue})(Ce=e.TestMessage||(e.TestMessage={}));var Ne;(function(me){let De;(function(ue){ue.Delimiter="\0"})(De||(De={})),me.namespace=(ue,Q)=>ue+"\0"+Q,me.denamespace=ue=>{const Q=ue.indexOf("\0");return{ctrlId:ue.slice(0,Q),tagId:ue.slice(Q+1)}}})(Ne=e.TestTag||(e.TestTag={}));var Ke;(function(me){function De(Fe){const Ze=(0,h.getPrivateApiFor)(Fe).controllerId;return{extId:v.TestId.fromExtHostTestItem(Fe,Ze).toString(),label:Fe.label,uri:Fe.uri,tags:Fe.tags.map(qe=>Ne.namespace(Ze,qe.id)),range:o.from(Fe.range)||null,description:Fe.description||null,error:Fe.error&&d.fromStrict(Fe.error)||null}}me.from=De;function ue(Fe){return{parent:void 0,error:void 0,id:v.TestId.fromString(Fe.extId).localId,label:Fe.label,uri:I.URI.revive(Fe.uri),tags:(Fe.tags||[]).map(Ze=>{const{tagId:qe}=Ne.denamespace(Ze);return new w.TestTag(qe)}),range:o.to(Fe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Fe.description||void 0}}me.toPlain=ue;function Q(Fe){const Ze=v.TestId.fromString(Fe.extId),qe=new h.TestItemImpl(Ze.controllerId,Ze.localId,Fe.label,I.URI.revive(Fe.uri));return qe.range=o.to(Fe.range||void 0),qe.description=Fe.description||void 0,qe}function Ie(Fe){let Ze;for(const qe of Fe.tests){const dt=Q(qe.item);(0,h.getPrivateApiFor)(dt).parent=Ze,Ze=dt}return Ze}me.toItemFromContext=Ie})(Ke=e.TestItem||(e.TestItem={})),function(me){function De(Q){return{id:Q.id}}me.from=De;function ue(Q){return new w.TestTag(Q.id)}me.to=ue}(Ne=e.TestTag||(e.TestTag={}));var He;(function(me){const De=(Q,Ie)=>{const Fe={...Ke.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(Ze=>({state:Ze.state,duration:Ze.duration,messages:Ze.messages.filter(qe=>qe.type===0).map(Ce.to)})),children:Q.children.map(Ze=>Ie.get(Ze)).filter(_.isDefined).map(Ze=>De(Ze,Ie))};for(const Ze of Fe.children)Ze.parent=Fe;return Fe};function ue(Q){const Ie=[],Fe=new Map;for(const Ze of Q.items)Fe.set(Ze.item.extId,Ze),Q.request.targets.some(qe=>qe.controllerId===Ze.controllerId&&qe.testIds.includes(Ze.item.extId))&&Ie.push(Ze);return{completedAt:Q.completedAt,results:Ie.map(Ze=>De(Ze,Fe))}}me.to=ue})(He=e.TestResults||(e.TestResults={}));var Qe;(function(me){function De(Fe){return{covered:Fe.covered,total:Fe.covered}}function ue(Fe){return"line"in Fe?c.from(Fe):o.from(Fe)}function Q(Fe){return"branches"in Fe?{count:Fe.executionCount,location:ue(Fe.location),type:1,branches:Fe.branches.length?Fe.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ue(Ze.location)})):void 0}:{type:0,count:Fe.executionCount,location:ue(Fe.location)}}me.fromDetailed=Q;function Ie(Fe){return{uri:Fe.uri,statement:De(Fe.statementCoverage),branch:Fe.branchCoverage&&De(Fe.branchCoverage),function:Fe.functionCoverage&&De(Fe.functionCoverage),details:Fe.detailedCoverage?.map(Q)}}me.fromFile=Ie})(Qe=e.TestCoverage||(e.TestCoverage={}));var st;(function(me){function De(ue){switch(ue){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}me.to=De})(st=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var at;(function(me){function De(Q){const Ie=new w.TypeHierarchyItem(M.to(Q.kind),Q.name,Q.detail||"",I.URI.revive(Q.uri),o.to(Q.range),o.to(Q.selectionRange));return Ie._sessionId=Q._sessionId,Ie._itemId=Q._itemId,Ie}me.to=De;function ue(Q,Ie,Fe){if(Ie=Ie??Q._sessionId,Fe=Fe??Q._itemId,Ie===void 0||Fe===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Fe,kind:M.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:o.from(Q.range),selectionRange:o.from(Q.selectionRange),tags:Q.tags?.map(x.from)}}me.from=ue})(at=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(we[216],be([0,1,2,15,7,17,93]),function(Y,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(I,L,T,l={timeout:1500,errors:3}){this._logService=I,this._documents=L,this._mainThreadBulkEdits=T,this._thresholds=l,this._callbacks=new P.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(L,T,l)=>{const h={dispose:this._callbacks.push([L,T,I])};return Array.isArray(l)&&l.push(h),h}}async $participateInSave(I,L){const T=m.URI.revive(I);let l=!1;const E=setTimeout(()=>l=!0,this._thresholds.timeout),h=[];try{for(let p of[...this._callbacks]){if(l)break;const v=this._documents.getDocument(T),A=await this._deliverEventAsyncAndBlameBadListeners(p,{document:v,reason:C.TextDocumentSaveReason.to(L)});h.push(A)}}finally{clearTimeout(E)}return h}_deliverEventAsyncAndBlameBadListeners([I,L,T],l){const E=this._badListeners.get(I);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(T,I,L,l).then(()=>!0,h=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' threw ERROR`),this._logService.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const p=this._badListeners.get(I);this._badListeners.set(I,p?p+1:1),typeof p=="number"&&p>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,L,T,l){const E=[],h=Date.now(),{document:p,reason:v}=l,{version:A}=p,w=Object.freeze({document:p,reason:v,waitUntil(s){if(Object.isFrozen(E))throw(0,i.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(s))}});try{L.apply(T,[w])}catch(s){return Promise.reject(s)}return Object.freeze(E),new Promise((s,o)=>{const g=setTimeout(()=>o(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(c=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(g),s(c)}).catch(c=>{clearTimeout(g),o(c)})}).then(s=>{const o={edits:[]};for(const g of s)if(Array.isArray(g)&&g.every(c=>c instanceof y.TextEdit))for(const{newText:c,newEol:S,range:r}of g)o.edits.push({_type:2,resource:p.uri,edit:{range:r&&C.Range.from(r),text:c,eol:S&&C.EndOfLine.from(S)}});if(o.edits.length!==0)return A===p.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(we[217],be([0,1,3,31,2,17,7]),function(Y,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(L,T,l,E,h){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,l&&(this._config+=1),E&&(this._config+=2),h&&(this._config+=4);const p=(0,i.parse)(T),v=L(A=>{if(!l)for(let w of A.created){const s=y.URI.revive(w);p(s.fsPath)&&this._onDidCreate.fire(s)}if(!E)for(let w of A.changed){const s=y.URI.revive(w);p(s.fsPath)&&this._onDidChange.fire(s)}if(!h)for(let w of A.deleted){const s=y.URI.revive(w);p(s.fsPath)&&this._onDidDelete.fire(s)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class _{constructor(L,T,l){this._logService=T,this._extHostDocumentsAndEditors=l,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(L,T,l,E){return new k(this._onFileSystemEvent.event,L,T,l,E)}$onFileEvent(L){this._onFileSystemEvent.fire(L)}$onDidRunFileOperation(L,T){switch(L){case 2:this._onDidRenameFile.fire(Object.freeze({files:T.map(l=>({oldUri:y.URI.revive(l.source),newUri:y.URI.revive(l.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:T.map(l=>y.URI.revive(l.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:T.map(l=>y.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(L){return this._createWillExecuteEvent(L,this._onWillRenameFile)}getOnWillCreateFileEvent(L){return this._createWillExecuteEvent(L,this._onWillCreateFile)}getOnWillDeleteFileEvent(L){return this._createWillExecuteEvent(L,this._onWillDeleteFile)}_createWillExecuteEvent(L,T){return(l,E,h)=>{const p=function(A){l.call(E,A)};return p.extension=L,T.event(p,void 0,h)}}async $onWillRunFileOperation(L,T,l,E){switch(L){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:T.map(h=>({oldUri:y.URI.revive(h.source),newUri:y.URI.revive(h.target)}))},l,E);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:T.map(h=>y.URI.revive(h.target))},l,E);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:T.map(h=>y.URI.revive(h.target))},l,E)}}async _fireWillEvent(L,T,l,E){const h=new Set,p=[];if(await L.fireAsync(T,E,async(A,w)=>{const s=Date.now(),o=await Promise.resolve(A);o instanceof P.WorkspaceEdit&&(p.push(o),h.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-s>l&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),E.isCancellationRequested||p.length===0)return;const v={edits:[]};for(let A of p){let{edits:w}=C.WorkspaceEdit.from(A,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(w)}return{edit:v,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=_}),define(we[218],be([0,1,10,25,2,17,7,125]),function(Y,e,m,i,y,C,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(l,E,h,p){this.start=l,this.deletedCount=E,this.deletedItems=h,this.items=p}static asApiEvents(l){return l.map(E=>({start:E.start,deletedCount:E.deletedCount,deletedItems:E.deletedItems,items:E.items.map(h=>h.apiCell)}))}}class I{constructor(l,E,h){this.notebook=l,this._extHostDocument=E,this._cellData=h,this.handle=h.handle,this.uri=y.URI.revive(h.uri),this.cellKind=h.cellKind,this._outputs=h.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=h.internalMetadata??{},this._metadata=Object.freeze(h.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(h.internalMetadata??{}))}static asModelAddData(l,E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,E=this._extHostDocument.getDocument(this.uri);if(!E)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:E.document,get mime(){return l._mime},set mime(h){l._mime=h},get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(C.NotebookCellOutput.to)}setOutputItems(l,E,h){const p=h.map(C.NotebookCellOutputItem.to),v=this._outputs.find(A=>A.id===l);v&&(E||(v.items.length=0),v.items.push(...p))}setMetadata(l){this._metadata=Object.freeze(l)}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(l))}setMime(l){}}e.ExtHostCell=I;class L{constructor(l,E,h,p,v,A){this._proxy=l,this._textDocumentsAndEditors=E,this._textDocuments=h,this._emitter=p,this.uri=v,this.handle=L._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=A.viewType,this._metadata=Object.freeze(A.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,A.cells]],!0),this._versionId=A.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===m.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(E){return E=l._validateIndex(E),l._cells[E].apiCell},getCells(E){return(E?l._getCells(E):l._cells).map(p=>p.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata=Object.freeze({...this._metadata,...l.metadata}))}acceptDirty(l){this._isDirty=l}acceptModelChanged(l,E){this._versionId=l.versionId,this._isDirty=E;for(const h of l.rawEvents)h.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1):h.kind===k.NotebookCellsChangeType.Move?this._moveCell(h.index,h.newIdx):h.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(h.index,h.outputs):h.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems):h.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(h.index,h.language):h.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(h.index,h.metadata):h.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(h.index,h.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let E=l.start|0,h=l.end|0;return E<0&&(E=0),h>this._cells.length&&(h=this._cells.length),l.with({start:E,end:h})}_getCells(l){l=this._validateRange(l);const E=[];for(let h=l.start;h<l.end;h++)E.push(this._cells[h]);return E}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,E){if(this._disposed)return;const h=[],p=[],v=[];l.reverse().forEach(A=>{const s=A[2].map(c=>{const S=new I(this,this._textDocumentsAndEditors,c);return E||p.push(I.asModelAddData(this.apiNotebook,c)),S}),o=new _(A[0],A[1],[],s),g=this._cells.splice(A[0],A[1],...s);for(const c of g)v.push(c.uri),o.deletedItems.push(c.apiCell);h.push(o)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:v}),E||this._emitter.emitModelChange((0,i.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(h)}))}_moveCell(l,E){const h=this._cells.splice(l,1);this._cells.splice(E,0,...h);const p=[new _(l,1,h.map(v=>v.apiCell),[]),new _(E,0,[],h)];this._emitter.emitModelChange((0,i.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(p)}))}_setCellOutputs(l,E){const h=this._cells[l];h.setOutputs(E),this._emitter.emitCellOutputsChange((0,i.deepFreeze)({document:this.apiNotebook,cells:[h.apiCell]}))}_setCellOutputItems(l,E,h,p){const v=this._cells[l];v.setOutputItems(E,h,p),this._emitter.emitCellOutputsChange((0,i.deepFreeze)({document:this.apiNotebook,cells:[v.apiCell]}))}_changeCellLanguage(l,E){const h=this._cells[l];h.apiCell.document.languageId!==E&&this._textDocuments.$acceptModelModeChanged(h.uri,E)}_changeCellMime(l,E){const h=this._cells[l];h.apiCell.mime=E}_changeCellMetadata(l,E){const h=this._cells[l],p=h.apiCell.metadata;h.setMetadata(E);const v=h.apiCell.metadata;(0,i.equals)(p,v)||this._emitter.emitCellMetadataChange((0,i.deepFreeze)({document:this.apiNotebook,cell:h.apiCell}))}_changeCellInternalMetadata(l,E){const h=this._cells[l],p=h.internalMetadata;if(h.setInternalMetadata(E),p.runState!==E.runState){const v=E.runState??P.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,i.deepFreeze)({document:this.apiNotebook,cell:h.apiCell,state:v}))}}getCellFromApiCell(l){return this._cells.find(E=>E.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(E=>E.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=L,L._handlePool=0}),define(we[128],be([0,1,7,17,15]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,I){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:I})}replaceCells(_,I,L){this._throwIfFinalized(),!(_===I&&L.length===0)&&this._collectedEdits.push({editType:1,index:_,count:I-_,cells:L.map(i.NotebookCellData.from)})}}class P{constructor(_,I,L,T,l,E){this.id=_,this._proxy=I,this.notebookData=L,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=T,this._viewColumn=E}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(I){if(!Array.isArray(I)||!I.every(m.NotebookRange.isNotebookRange))throw(0,y.illegalArgument)("selections");_._selections=I,_._trySetSelections(I)},get visibleRanges(){return _._visibleRanges},revealRange(I,L){_._proxy.$tryRevealRange(_.id,i.NotebookRange.from(I),L??m.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(I){const L=new C(this.document.version);return I(L),_._applyEdit(L.finalize())},setDecorations(I,L){return _.setDecorations(I,L)}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(i.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const I=[];let L=-1;for(let T=0;T<_.cellEdits.length;T++){if(L<0){I.push(_.cellEdits[T]),L++;continue}const E=I[L],h=_.cellEdits[T];if(E.editType===1&&h.editType===1&&E.index===h.index){E.cells.push(..._.cellEdits[T].cells),E.count+=_.cellEdits[T].count;continue}I.push(_.cellEdits[T]),L++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,I)}setDecorations(_,I){if(!(I.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return I.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,i.NotebookRange.from(I),_.key)}}e.ExtHostNotebookEditor=P,P.apiEditorsToExtHost=new WeakMap}),define(we[219],be([0,1,17,117,164,21,57,15]),function(Y,e,m,i,y,C,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class _{constructor(l){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=l}async withProgress(l,E,h){const p=this._handles++,{title:v,location:A,cancellable:w}=E,s={label:(0,y.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this._proxy.$startProgress(p,{location:m.ProgressLocation.from(A),title:v,source:s,cancellable:w},l).catch(k.onUnexpectedExternalError),this._withProgress(p,h,!!w)}_withProgress(l,E,h){let p;h&&(p=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(l,p));const v=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),p&&p.dispose()};let A;try{A=E(new L(this._proxy,l),h&&p?p.token:C.CancellationToken.None)}catch(w){throw v(l),w}return A.then(w=>v(l),w=>v(l)),A}$acceptProgressCanceled(l){const E=this._mapHandleToCancellationSource.get(l);E&&(E.cancel(),this._mapHandleToCancellationSource.delete(l))}}e.ExtHostProgress=_;function I(T,l){return T.message=l.message,typeof l.increment=="number"&&(typeof T.increment=="number"?T.increment+=l.increment:T.increment=l.increment),T}class L extends i.Progress{constructor(l,E){super(h=>this.throttledReport(h));this._proxy=l,this._handle=E}throttledReport(l){this._proxy.$progressReport(this._handle,l)}}je([(0,P.throttle)(100,(T,l)=>I(T,l),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(we[129],be([0,1,56,15,76,17,7]),function(Y,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(l,E,h){const p=k._Keys.nextId();l.$registerTextEditorDecorationType(E.identifier,p,C.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:p,dispose(){l.$removeTextEditorDecorationType(p)}})}}e.TextEditorDecorationType=k,k._Keys=new y.IdGenerator("TextEditorDecorationType");class _{constructor(l,E){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=E.undoStopBefore,this._undoStopAfter=E.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,E){this._throwIfFinalized();let h=null;if(l instanceof P.Position)h=new P.Range(l,l);else if(l instanceof P.Range)h=l;else throw new Error("Unrecognized location");this._pushEdit(h,E,!1)}insert(l,E){this._throwIfFinalized(),this._pushEdit(new P.Range(l,l),E,!0)}delete(l){this._throwIfFinalized();let E=null;if(l instanceof P.Range)E=l;else throw new Error("Unrecognized location");this._pushEdit(E,null,!0)}_pushEdit(l,E,h){const p=this._document.validateRange(l);this._collectedEdits.push({range:p,text:E,forceMoveMarkers:h})}setEndOfLine(l){if(this._throwIfFinalized(),l!==P.EndOfLine.LF&&l!==P.EndOfLine.CRLF)throw(0,i.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=_;class I{constructor(l,E,h,p){this._proxy=l,this._id=E,this._accept(h),this._logService=p;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(A){v._setTabSize(A)},get insertSpaces(){return v._insertSpaces},set insertSpaces(A){v._setInsertSpaces(A)},get cursorStyle(){return v._cursorStyle},set cursorStyle(A){v._setCursorStyle(A)},get lineNumbers(){return v._lineNumbers},set lineNumbers(A){v._setLineNumbers(A)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const E=Math.floor(l);return E>0?E:null}if(typeof l=="string"){const E=parseInt(l,10);return isNaN(E)?null:E>0?E:null}return null}_setTabSize(l){const E=this._validateTabSize(l);if(E!==null){if(typeof E=="number"){if(this._tabSize===E)return;this._tabSize=E}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:E}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const E=this._validateInsertSpaces(l);if(typeof E=="boolean"){if(this._insertSpaces===E)return;this._insertSpaces=E}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:E}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(l)})))}assign(l){const E={};let h=!1;if(typeof l.tabSize!="undefined"){const p=this._validateTabSize(l.tabSize);p==="auto"?(h=!0,E.tabSize=p):typeof p=="number"&&this._tabSize!==p&&(this._tabSize=p,h=!0,E.tabSize=p)}if(typeof l.insertSpaces!="undefined"){const p=this._validateInsertSpaces(l.insertSpaces);p==="auto"?(h=!0,E.insertSpaces=p):this._insertSpaces!==p&&(this._insertSpaces=p,h=!0,E.insertSpaces=p)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,h=!0,E.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,h=!0,E.lineNumbers=C.TextEditorLineNumbersStyle.from(l.lineNumbers)),h&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,E))}_warnOnError(l,E){E.catch(h=>{this._logService.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this._logService.warn(h)})}}e.ExtHostTextEditorOptions=I;class L{constructor(l,E,h,p,v,A,w,s){this.id=l,this._proxy=E,this._logService=h,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new I(this._proxy,this.id,A,h),this._visibleRanges=w,this._viewColumn=s;const o=this;this.value=Object.freeze({get document(){return p.getValue()},set document(g){throw(0,i.readonly)("document")},get selection(){return o._selections&&o._selections[0]},set selection(g){if(!(g instanceof P.Selection))throw(0,i.illegalArgument)("selection");o._selections=[g],o._trySetSelection()},get selections(){return o._selections},set selections(g){if(!Array.isArray(g)||g.some(c=>!(c instanceof P.Selection)))throw(0,i.illegalArgument)("selections");o._selections=g,o._trySetSelection()},get visibleRanges(){return o._visibleRanges},set visibleRanges(g){throw(0,i.readonly)("visibleRanges")},get options(){return o._options.value},set options(g){o._disposed||o._options.assign(g)},get viewColumn(){return o._viewColumn},set viewColumn(g){throw(0,i.readonly)("viewColumn")},edit(g,c={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const S=new _(p.getValue(),c);return g(S),o._applyEdit(S)},insertSnippet(g,c,S={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!c||Array.isArray(c)&&c.length===0)r=o._selections.map(t=>C.Range.from(t));else if(c instanceof P.Position){const{lineNumber:t,column:n}=C.Position.from(c);r=[{startLineNumber:t,startColumn:n,endLineNumber:t,endColumn:n}]}else if(c instanceof P.Range)r=[C.Range.from(c)];else{r=[];for(const t of c)if(t instanceof P.Range)r.push(C.Range.from(t));else{const{lineNumber:n,column:u}=C.Position.from(t);r.push({startLineNumber:n,startColumn:u,endLineNumber:n,endColumn:u})}}return E.$tryInsertSnippet(l,g.value,r,S)},setDecorations(g,c){const S=c.length===0;S&&!o._hasDecorationsForKey.has(g.key)||(S?o._hasDecorationsForKey.delete(g.key):o._hasDecorationsForKey.add(g.key),o._runOnProxy(()=>{if(C.isDecorationOptionsArr(c))return E.$trySetDecorations(l,g.key,C.fromRangeOrRangeWithMessage(c));{const r=new Array(4*c.length);for(let t=0,n=c.length;t<n;t++){const u=c[t];r[4*t]=u.start.line+1,r[4*t+1]=u.start.character+1,r[4*t+2]=u.end.line+1,r[4*t+3]=u.end.character+1}return E.$trySetDecorationsFast(l,g.key,r)}}))},revealRange(g,c){o._runOnProxy(()=>E.$tryRevealRange(l,C.Range.from(g),c||P.TextEditorRevealType.Default))},show(g){E.$tryShowEditor(l,C.ViewColumn.from(g))},hide(){E.$tryHideEditor(l)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,m.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,m.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,m.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,m.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const E=l.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const h=E.edits.map(v=>v.range);h.sort((v,A)=>v.end.line===A.end.line?v.end.character===A.end.character?v.start.line===A.start.line?v.start.character-A.start.character:v.start.line-A.start.line:v.end.character-A.end.character:v.end.line-A.end.line);for(let v=0,A=h.length-1;v<A;v++){const w=h[v].end;if(h[v+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=E.edits.map(v=>({range:C.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,p,{setEndOfLine:typeof E.setEndOfLine=="number"?C.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this._logService.warn(E),null))}}e.ExtHostTextEditor=L}),define(we[220],be([0,1,167,23,2,3,6,18,7,13,16,17,21,204]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(A,w){if((0,I.isString)(A))return{label:A};if(A&&typeof A=="object"&&typeof A.label=="string"){let s;return Array.isArray(A.highlights)&&(s=A.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),s=s.length?s:void 0),{label:A.label,highlights:s}}}class p{constructor(w,s,o){this._proxy=w,this.commands=s,this.logService=o,this.treeViews=new Map;function g(c){return c&&c.$treeViewId&&c.$treeItemHandle}s.registerArgumentProcessor({processArgument:c=>g(c)?this.convertArgument(c):Array.isArray(c)&&c.length>0?c.map(S=>g(S)?this.convertArgument(S):S):c})}registerTreeDataProvider(w,s,o){const g=this.createTreeView(w,{treeDataProvider:s},o);return{dispose:()=>g.dispose()}}createTreeView(w,s,o){if(!s||!s.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const g=s.dragAndDropController?.supportedMimeTypes,c=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!s.showCollapseAll,canSelectMany:!!s.canSelectMany,dragAndDropMimeTypes:g}),S=this.createExtHostTreeView(w,s,o);return{get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get message(){return S.message},set message(r){S.message=r},get title(){return S.title},set title(r){S.title=r},get description(){return S.description},set description(r){S.description=r},reveal:(r,t)=>S.reveal(r,t),dispose:async()=>{await c,this.treeViews.delete(w),S.dispose()}}}$getChildren(w,s){const o=this.treeViews.get(w);return o?o.getChildren(s):Promise.reject(new Error((0,m.localize)(0,null,w)))}async $onDrop(w,s,o,g,c){const S=this.treeViews.get(w);if(!S)return Promise.reject(new Error((0,m.localize)(1,null,w)));const r=E.TreeDataTransferConverter.toITreeDataTransfer(s);if(g===w&&c){const t=await S.onWillDrop(c);t&&t.forEach((n,u)=>{n&&r.set(u,n)})}return S.onDrop(r,o)}async $hasResolve(w){const s=this.treeViews.get(w);if(!s)throw new Error((0,m.localize)(2,null,w));return s.hasResolve}$resolve(w,s,o){const g=this.treeViews.get(w);if(!g)throw new Error((0,m.localize)(3,null,w));return g.resolveTreeItem(s,o)}$setExpanded(w,s,o){const g=this.treeViews.get(w);if(!g)throw new Error((0,m.localize)(4,null,w));g.setExpanded(s,o)}$setSelection(w,s){const o=this.treeViews.get(w);if(!o)throw new Error((0,m.localize)(5,null,w));o.setSelection(s)}$setVisible(w,s){const o=this.treeViews.get(w);if(!o)throw new Error((0,m.localize)(6,null,w));o.setVisible(s)}createExtHostTreeView(w,s,o){const g=new v(w,s,this._proxy,this.commands.converter,this.logService,o);return this.treeViews.set(w,g),g}convertArgument(w){const s=this.treeViews.get(w.$treeViewId);return s?s.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=p;class v extends P.Disposable{constructor(w,s,o,g,c,S){super();if(this.viewId=w,this.proxy=o,this.commands=g,this.logService=c,this.extension=S,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new l.CancellationTokenSource,S.contributes&&S.contributes.views)for(const n in S.contributes.views)for(const u of S.contributes.views[n])u.id===w&&(this._title=u.name);this.dataProvider=s.treeDataProvider,this.dndController=s.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(n=>this._onDidChangeData.fire({message:!1,element:n}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(n=>this._onDidChangeData.fire({message:!1,element:n})));let r,t;this._register(C.Event.debounce(this._onDidChangeData.event,(n,u)=>(n||(n={message:!1,elements:[]}),u.element!==!1&&(r||(r=new Promise(a=>t=a),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(u.element)?n.elements.push(...u.element):n.elements.push(u.element)),u.message&&(n.message=!0),n),200,!0)(({message:n,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const a=t;return r=null,this.refresh(u).then(()=>a())})),n&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!(0,I.isUndefinedOrNull)(w))}async getChildren(w){const s=w?this.getExtensionElement(w):void 0;if(w&&!s)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);let o=this.getChildrenNodes(w);return o||(o=await this.fetchChildrenNodes(s)),o?o.map(g=>g.item):void 0}getExtensionElement(w){return this.elements.get(w)}reveal(w,s){s=s||{select:!0,focus:!1};const o=(0,I.isUndefinedOrNull)(s.select)?!0:s.select,g=(0,I.isUndefinedOrNull)(s.focus)?!1:s.focus,c=(0,I.isUndefinedOrNull)(s.expand)?!1:s.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(S=>this.resolveTreeNode(w,S[S.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:S.map(t=>t.item)},{select:o,focus:g,expand:c})),S=>this.logService.error(S)):this.proxy.$reveal(this.viewId,void 0,{select:o,focus:g,expand:c})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,s){const o=this.getExtensionElement(w);o&&(s?this._onDidExpandElement.fire(Object.freeze({element:o})):this._onDidCollapseElement.fire(Object.freeze({element:o})))}setSelection(w){(0,L.equals)(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(w){const s=[];for(const o of w){const g=this.getExtensionElement(o);g&&s.push(g)}if(!(!this.dndController?.onWillDrop||s.length===0))return this.dndController.onWillDrop(s)}async onDrop(w,s){const o=this.getExtensionElement(s);if(!!o)return(0,k.asPromise)(()=>this.dndController?.onDrop(w,o))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,s){if(!this.dataProvider.resolveTreeItem)return;const o=this.elements.get(w);if(o){const g=this.nodes.get(o);if(g){const c=await this.dataProvider.resolveTreeItem(g.extensionItem,o,s)??g.extensionItem;return g.item.tooltip=this.getTooltip(c.tooltip),g.item.command=this.getCommand(g.disposableStore,c.command),g.item}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(s=>s?this.resolveUnknownParentChain(s).then(o=>this.resolveTreeNode(s,o[o.length-1]).then(g=>(o.push(g),o))):Promise.resolve([]))}resolveParent(w){const s=this.nodes.get(w);return s?Promise.resolve(s.parent?this.elements.get(s.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,s){const o=this.nodes.get(w);return o?Promise.resolve(o):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(g=>this.createHandle(w,g,s,!0)).then(g=>this.getChildren(s?s.item.handle:void 0).then(()=>{const c=this.getExtensionElement(g);if(c){const S=this.nodes.get(c);if(S)return Promise.resolve(S)}throw new Error(`Cannot resolve tree item for element ${g}`)}))}getChildrenNodes(w){if(w){let s;if(typeof w=="string"){const o=this.getExtensionElement(w);s=o?this.nodes.get(o):void 0}else s=w;return s&&s.children||void 0}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const s=new l.CancellationTokenSource(this._refreshCancellationSource.token);try{const o=w?this.nodes.get(w):void 0,g=await this.dataProvider.getChildren(w);if(s.token.isCancellationRequested)return;const c=await Promise.all((0,L.coalesce)(g||[]).map(async S=>{const r=await this.dataProvider.getTreeItem(S);return r&&!s.token.isCancellationRequested?this.createAndRegisterTreeNode(S,r,o):null}));return s.token.isCancellationRequested?void 0:(0,L.coalesce)(c)}finally{s.dispose()}}refresh(w){if(w.some(o=>!o))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new l.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const o=this.getHandlesToRefresh(w);if(o.length)return this.refreshHandles(o)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const s=new Set,o=w.map(c=>this.nodes.get(c));for(const c of o)if(c&&!s.has(c.item.handle)){let S=c;for(;S&&S.parent&&o.findIndex(r=>S&&S.parent&&r&&r.item.handle===S.parent.item.handle)===-1;){const r=this.elements.get(S.parent.item.handle);S=r?this.nodes.get(r):void 0}S&&!S.parent&&s.add(c.item.handle)}const g=[];return s.forEach(c=>{const S=this.elements.get(c);if(S){const r=this.nodes.get(S);r&&(!r.parent||!s.has(r.parent.item.handle))&&g.push(c)}}),g}refreshHandles(w){const s={};return Promise.all(w.map(o=>this.refreshNode(o).then(g=>{g&&(s[o]=g.item)}))).then(()=>Object.keys(s).length?this.proxy.$refresh(this.viewId,s):void 0)}refreshNode(w){const s=this.getExtensionElement(w);if(s){const o=this.nodes.get(s);if(o)return this.clearChildren(s),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(g=>{if(g){const c=this.createTreeNode(s,g,o.parent);return this.updateNodeCache(s,c,o,o.parent),o.dispose(),c}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,s,o){const g=this.createTreeNode(w,s,o);if(s.id&&this.elements.has(g.item.handle))throw new Error((0,m.localize)(7,null,s.id));return this.addNodeToCache(w,g),this.addNodeToParentCache(g,o),g}getTooltip(w){return _.MarkdownString.isMarkdownString(w)?T.MarkdownString.from(w):w}getCommand(w,s){return s?this.commands.toInternal(s,w):void 0}createTreeNode(w,s,o){const g=new P.DisposableStore,c=this.createHandle(w,s,o),S=this.getLightIconPath(s);return{item:{handle:c,parentHandle:o?o.item.handle:void 0,label:h(s.label,this.extension),description:s.description,resourceUri:s.resourceUri,tooltip:this.getTooltip(s.tooltip),command:this.getCommand(g,s.command),contextValue:s.contextValue,icon:S,iconDark:this.getDarkIconPath(s)||S,themeIcon:this.getThemeIcon(s),collapsibleState:(0,I.isUndefinedOrNull)(s.collapsibleState)?_.TreeItemCollapsibleState.None:s.collapsibleState,accessibilityInformation:s.accessibilityInformation},extensionItem:s,parent:o,children:void 0,disposableStore:g,dispose(){g.dispose()}}}getThemeIcon(w){return w.iconPath instanceof _.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:s,label:o,resourceUri:g},c,S){if(s)return`${v.ID_HANDLE_PREFIX}/${s}`;const r=h(o,this.extension),t=c?c.item.handle:v.LABEL_HANDLE_PREFIX;let n=r?r.label:g?(0,i.basename)(g):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const u=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,a=this.getChildrenNodes(c)||[];let f,b=0;do{if(f=`${t}/${b}:${n}`,S||!this.elements.has(f)||u===f)break;b++}while(b<=a.length);return f}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof _.ThemeIcon))return typeof w.iconPath=="string"||y.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof _.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return y.URI.isUri(w)?w:y.URI.file(w)}addNodeToCache(w,s){this.elements.set(s.item.handle,w),this.nodes.set(w,s)}updateNodeCache(w,s,o,g){this.elements.delete(s.item.handle),this.nodes.delete(w),s.item.handle!==o.item.handle&&this.elements.delete(o.item.handle),this.addNodeToCache(w,s);const c=this.getChildrenNodes(g)||[],S=c.filter(r=>r.item.handle===o.item.handle)[0];S&&c.splice(c.indexOf(S),1,s)}addNodeToParentCache(w,s){s?(s.children||(s.children=[]),s.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const s=this.nodes.get(w);if(s){if(s.children)for(const o of s.children){const g=this.elements.get(o.item.handle);g&&this.clear(g)}s.children=void 0}}else this.clearAll()}clear(w){const s=this.nodes.get(w);if(s){if(s.children)for(const o of s.children){const g=this.elements.get(o.item.handle);g&&this.clear(g)}this.nodes.delete(w),this.elements.delete(s.item.handle),s.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(we[221],be([0,1,18,3,6,13,63,17,126,89]),function(Y,e,m,i,y,C,P,k,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class L extends y.Disposable{constructor(l){super();this.controllerId=l,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new i.Emitter),this.root=new P.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(l){this._resolveHandler=l;for(const E of this.tree.values())this.updateExpandability(E)}collectDiff(){const l=this.diff;return this.diff=[],l}pushDiff(l){const E=this.diff[this.diff.length-1];if(E&&l[0]===1){if(E[0]===1&&E[1].extId===l[1].extId){(0,_.applyTestItemUpdate)(E[1],l[1]);return}if(E[0]===0&&E[1].item.extId===l[1].extId){(0,_.applyTestItemUpdate)(E[1],l[1]);return}}this.diff.push(l),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(l,E){const h=this.tree.get(l);if(!!h){if((h.expandLevels===void 0||E>h.expandLevels)&&(h.expandLevels=E),h.expand===1){const p=this.resolveChildren(h);return p.isOpen()?this.expandChildren(h,E-1):p.wait().then(()=>this.expandChildren(h,E-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.expandChildren(h,E-1)):this.expandChildren(h,E-1)}}dispose(){for(const l of this.tree.values())(0,P.getPrivateApiFor)(l.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(l,E){switch(E.op){case 2:this.pushDiff([4,l.fullId.toString()]);break;case 1:this.removeItem(I.TestId.joinToString(l.fullId,E.id));break;case 0:this.upsertItem(E.item,l);break;case 4:for(const h of E.ops)this.onTestItemEvent(l,h);break;case 3:{const{key:h,value:p,previous:v}=E,A=l.fullId.toString();switch(h){case"canResolveChildren":this.updateExpandability(l);break;case"tags":this.diffTagRefs(p,v,A);break;case"range":this.pushDiff([1,{extId:A,item:{range:k.Range.from(p)}}]);break;case"error":this.pushDiff([1,{extId:A,item:{error:k.MarkdownString.fromStrict(p)||null}}]);break;default:this.pushDiff([1,{extId:A,item:{[h]:p??null}}]);break}break}default:(0,C.assertNever)(E)}}upsertItem(l,E){if(!(l instanceof P.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${l.id} did not`);const h=I.TestId.fromExtHostTestItem(l,this.root.id,E?.actual),p=(0,P.getPrivateApiFor)(l);p.parent&&p.parent!==E?.actual&&p.parent.children.delete(l.id);let v=this.tree.get(h.toString());if(!v){v={fullId:h,actual:l,parent:E?h.parentId:null,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},l.tags.forEach(this.incrementTagRefs,this),this.tree.set(v.fullId.toString(),v),this.setItemParent(l,E),this.pushDiff([0,{parent:v.parent&&v.parent.toString(),controllerId:this.controllerId,expand:v.expand,item:k.TestItem.from(l)}]),this.connectItemAndChildren(l,v,E);return}if(v.actual===l){this.connectItem(l,v,E);return}const A=v.actual.children,w=v.actual,s=(0,P.diffTestItems)(w,l);(0,P.getPrivateApiFor)(w).listener=void 0,v.actual=l,v.expand=0;for(const[o,g]of s)this.onTestItemEvent(v,{op:3,key:o,value:g,previous:w[o]});this.connectItemAndChildren(l,v,E);for(const o of A)l.children.get(o.id)||this.removeItem(I.TestId.joinToString(h,o.id))}diffTagRefs(l,E,h){const p=new Set(E.map(v=>v.id));for(const v of l)p.delete(v.id)||this.incrementTagRefs(v);this.pushDiff([1,{extId:h,item:{tags:l.map(v=>k.TestTag.namespace(this.controllerId,v.id))}}]),p.forEach(this.decrementTagRefs,this)}incrementTagRefs(l){const E=this.tags.get(l.id);E?E.refCount++:(this.tags.set(l.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,l.id),ctrlLabel:this.root.label}]))}decrementTagRefs(l){const E=this.tags.get(l);E&&!--E.refCount&&(this.tags.delete(l),this.pushDiff([6,k.TestTag.namespace(this.controllerId,l)]))}setItemParent(l,E){(0,P.getPrivateApiFor)(l).parent=E&&E.actual!==this.root?E.actual:void 0}connectItem(l,E,h){this.setItemParent(l,h);const p=(0,P.getPrivateApiFor)(l);p.parent=h?.actual,p.listener=v=>this.onTestItemEvent(E,v),this.updateExpandability(E)}connectItemAndChildren(l,E,h){this.connectItem(l,E,h);for(const p of l.children)this.upsertItem(p,E)}updateExpandability(l){let E;this._resolveHandler?l.resolveBarrier?E=l.resolveBarrier.isOpen()?3:2:E=l.actual.canResolveChildren?1:0:E=0,E!==l.expand&&(l.expand=E,this.pushDiff([1,{extId:l.fullId.toString(),expand:E}]),E===1&&l.expandLevels!==void 0&&this.resolveChildren(l))}expandChildren(l,E){if(E<0)return;const h=[];for(const p of l.actual.children){const v=this.expand(I.TestId.joinToString(l.fullId,p.id),E);(0,m.isThenable)(v)&&h.push(v)}if(h.length)return Promise.all(h).then(()=>{})}resolveChildren(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this._resolveHandler){const v=new m.Barrier;return v.open(),v}l.expand=2,this.pushExpandStateUpdate(l);const E=l.resolveBarrier=new m.Barrier,h=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),l.actual!==this.root&&(l.actual.error=v.stack||v.message||String(v))};let p;try{p=this._resolveHandler(l.actual===this.root?void 0:l.actual)}catch(v){h(v)}return(0,m.isThenable)(p)?p.catch(h).then(()=>{E.open(),this.updateExpandability(l)}):(E.open(),this.updateExpandability(l)),l.resolveBarrier}pushExpandStateUpdate(l){this.pushDiff([1,{extId:l.fullId.toString(),expand:l.expand}])}removeItem(l){const E=this.tree.get(l);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff([2,l]);const h=[E];for(;h.length;){const p=h.pop();if(!!p){(0,P.getPrivateApiFor)(p.actual).listener=void 0;for(const v of p.actual.tags)this.decrementTagRefs(v.id);this.tree.delete(p.fullId.toString());for(const v of p.actual.children)h.push(this.tree.get(I.TestId.joinToString(p.fullId,v.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.diffOpEmitter.fire(l)}}e.SingleUseTestCollection=L}),define(we[222],be([0,1,4,182]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(i.IEnvironmentService)}),define(we[223],be([0,1,27,3,9]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(L){this.removedDueToLooping=L}}e.DeltaExtensionsResult=C;class P{constructor(L){this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=L,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const L of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(L.identifier))){console.error("Extension `"+L.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(L.identifier),L),this._extensionsArr.push(L),Array.isArray(L.activationEvents))for(let T of L.activationEvents)T==="onUri"&&(T=`onUri:${m.ExtensionIdentifier.toKey(L.identifier)}`),this._activationMap.has(T)||this._activationMap.set(T,[]),this._activationMap.get(T).push(L)}}keepOnly(L){const T=new Set;L.forEach(l=>T.add(m.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>T.has(m.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(L,T){L.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(L));const l=P._findLoopingExtensions(this._extensionDescriptions);if(T=T.concat(l.map(E=>E.identifier)),T.length>0){const E=new Set;T.forEach(h=>E.add(m.ExtensionIdentifier.toKey(h))),this._extensionDescriptions=this._extensionDescriptions.filter(h=>!E.has(m.ExtensionIdentifier.toKey(h.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(l)}static _findLoopingExtensions(L){const T=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,A){this.addNode(v),this.addNode(A),this._arcs.has(v)?this._arcs.get(v).push(A):this._arcs.set(v,[A])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,A){const w=T.getArcs(v);for(let s=0;s<w.length;s++)if(!A.has(w[s]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let v of L){const A=m.ExtensionIdentifier.toKey(v.identifier);if(l.set(A,v),v.extensionDependencies)for(let w of v.extensionDependencies){const s=m.ExtensionIdentifier.toKey(w);T.addArc(A,s)}}let E=new Set;T.getNodes().filter(v=>T.getArcs(v).length===0).forEach(v=>E.add(v));let h=T.getNodes().filter(v=>!E.has(v)),p;do{p=!1;for(let v=0;v<h.length;v++){const A=h[v];T.hasOnlyGoodArcs(A,E)&&(h.splice(v,1),v--,E.add(A),p=!0)}}while(p);return h.map(v=>l.get(v))}containsActivationEvent(L){return this._activationMap.has(L)}containsExtension(L){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(L))}getExtensionDescriptionsForActivationEvent(L){const T=this._activationMap.get(L);return T?T.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(L){const T=this._extensionsMap.get(m.ExtensionIdentifier.toKey(L));return T||void 0}}e.ExtensionDescriptionRegistry=P;var k;(function(I){I[I.Builtin=0]="Builtin",I[I.User=1]="User",I[I.Dev=2]="Dev"})(k||(k={}));function _(I,L){const T=I.isBuiltin?0:I.isUnderDevelopment?2:1,l=L.isBuiltin?0:L.isUnderDevelopment?2:1;if(T!==l)return T-l;const E=y.posix.basename(I.extensionLocation.path),h=y.posix.basename(L.extensionLocation.path);return E<h?-1:E>h?1:0}}),define(we[224],be([0,1,22]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var i;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(i=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var y;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(y=e.MessageType||(e.MessageType={}));function C(k){const _=m.VSBuffer.alloc(1);switch(k){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=C;function P(k,_){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=P}),define(we[29],be([0,1,3,2,4,27,193]),function(Y,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:i.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");var k;(function(o){o[o.None=0]="None",o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function _(o){switch(o){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=_;class I{constructor(g){this.dependency=g}}e.MissingExtensionDependency=I;var L;(function(o){o[o.LocalProcess=0]="LocalProcess",o[o.LocalWebWorker=1]="LocalWebWorker",o[o.Remote=2]="Remote"})(L=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(o){switch(o){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=T;function l(o,g){return o.enabledApiProposals?o.enabledApiProposals.includes(g):!1}e.isProposedApiEnabled=l;function E(o,g){if(!l(o,g))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${g}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${g}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.checkProposedApiEnabled=E;class h{constructor(g,c,S,r){this.codeLoadingTime=g,this.activateCallTime=c,this.activateResolvedTime=S,this.activationReason=r}}e.ActivationTimes=h;class p{constructor(g,c){this.description=g,this.value=c}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost";var v;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(v=e.ActivationKind||(e.ActivationKind={}));function A(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,P.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation}}e.toExtension=A;function w(o,g){return{identifier:new C.ExtensionIdentifier(o.identifier.id),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!g,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid}}e.toExtensionDescription=w;class s{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(g){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(g){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(g,c){return Promise.resolve()}_onWillActivateExtension(g){}_onDidActivateExtension(g,c,S,r,t){}_onDidActivateExtensionError(g,c){}_onExtensionRuntimeError(g,c){}_onExtensionHostExit(g){}}e.NullExtensionService=s}),define(we[225],be([0,1,15,27,29,11]),function(Y,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const P=Promise.resolve(void 0);class k{constructor(p,v,A,w){this.startup=p,this.codeLoadingTime=v,this.activateCallTime=A,this.activateResolvedTime=w}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class _{constructor(p){this._startup=p,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(p,v){return p===-1||v===-1?-1:v-p}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=_;class I{constructor(p,v,A,w,s,o){this.activationFailed=p,this.activationFailedError=v,this.activationTimes=A,this.module=w,this.exports=s,this.subscriptions=o}}e.ActivatedExtension=I;class L extends I{constructor(p){super(!1,null,p,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=L;class T extends I{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=T;class l extends I{constructor(p){super(!0,p,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=l;let E=class{constructor(p,v,A,w,s){this._logService=s,this._isDisposed=!1,this._registry=p,this._resolvedExtensionsSet=new Set,v.forEach(o=>this._resolvedExtensionsSet.add(i.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,A.forEach(o=>this._hostExtensionsMap.set(i.ExtensionIdentifier.toKey(o),o)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(p){const v=i.ExtensionIdentifier.toKey(p);return this._activatedExtensions.has(v)}getActivatedExtension(p){const v=i.ExtensionIdentifier.toKey(p),A=this._activatedExtensions.get(v);if(!A)throw new Error("Extension `"+p.value+"` is not known or not activated");return A}activateByEvent(p,v){if(this._alreadyActivatedEvents[p])return P;const A=this._registry.getExtensionDescriptionsForActivationEvent(p);return this._activateExtensions(A.map(w=>({id:w.identifier,reason:{startup:v,extensionId:w.identifier,activationEvent:p}}))).then(()=>{this._alreadyActivatedEvents[p]=!0})}activateById(p,v){const A=this._registry.getExtensionDescription(p);if(!A)throw new Error("Extension `"+p+"` is not known");return this._activateExtensions([{id:A.identifier,reason:v}])}_handleActivateRequest(p,v,A){if(this._hostExtensionsMap.has(i.ExtensionIdentifier.toKey(p.id))){v[i.ExtensionIdentifier.toKey(p.id)]=p;return}const w=this._registry.getExtensionDescription(p.id);if(!w){const g=new Error(`Cannot activate unknown extension '${p.id.value}'`);this._host.onExtensionActivationError(p.id,g,new y.MissingExtensionDependency(p.id.value)),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(p.id),new l(g));return}const s=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let o=!0;for(let g=0,c=s.length;g<c;g++){const S=s[g];if(this._resolvedExtensionsSet.has(i.ExtensionIdentifier.toKey(S)))continue;const r=this._activatedExtensions.get(i.ExtensionIdentifier.toKey(S));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const a=w.displayName||w.identifier.value,f=this._registry.getExtensionDescription(S),b=f&&f.displayName||S,d=new Error(`Cannot activate the '${a}' extension because its dependency '${b}' failed to activate`);d.detail=r.activationFailedError,this._host.onExtensionActivationError(w.identifier,d,null),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(w.identifier),new l(d));return}if(this._hostExtensionsMap.has(i.ExtensionIdentifier.toKey(S))){o=!1,v[i.ExtensionIdentifier.toKey(S)]={id:this._hostExtensionsMap.get(i.ExtensionIdentifier.toKey(S)),reason:p.reason};continue}const t=this._registry.getExtensionDescription(S);if(t){if(!t.main&&!t.browser)continue;o=!1,v[i.ExtensionIdentifier.toKey(S)]={id:t.identifier,reason:p.reason};continue}const n=w.displayName||w.identifier.value,u=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${S}'`);this._host.onExtensionActivationError(w.identifier,u,new y.MissingExtensionDependency(S)),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(w.identifier),new l(u));return}o?v[i.ExtensionIdentifier.toKey(w.identifier)]=p:A.push(p)}_activateExtensions(p){if(p.length===0||(p=p.filter(s=>!this._activatedExtensions.has(i.ExtensionIdentifier.toKey(s.id))),p.length===0))return Promise.resolve(void 0);const v=Object.create(null),A=[];for(let s=0,o=p.length;s<o;s++)this._handleActivateRequest(p[s],v,A);for(let s=0,o=A.length;s<o;s++){const g=i.ExtensionIdentifier.toKey(A[s].id);v[g]&&delete v[g]}const w=Object.keys(v).map(s=>v[s]);return A.length===0?Promise.all(w.map(s=>this._activateExtension(s.id,s.reason))).then(s=>{}):this._activateExtensions(w).then(s=>this._activateExtensions(A))}_activateExtension(p,v){const A=i.ExtensionIdentifier.toKey(p);if(this._activatedExtensions.has(A))return Promise.resolve(void 0);const w=this._activatingExtensions.get(A);if(w)return w;const s=this._host.actualActivateExtension(p,v).then(void 0,o=>{const g=new Error;return o&&o.name&&(g.name=o.name),o&&o.message?g.message=`Activating extension '${p.value}' failed: ${o.message}.`:g.message=`Activating extension '${p.value}' failed: ${o}.`,o&&o.stack&&(g.stack=o.stack),this._isDisposed&&m.isPromiseCanceledError(o)?new l(o):(this._host.onExtensionActivationError(p,g,null),this._logService.error(`Activating extension ${p.value} failed due to an error:`),this._logService.error(o),new l(o))}).then(o=>{this._activatedExtensions.set(A,o),this._activatingExtensions.delete(A)});return this._activatingExtensions.set(A,s),s}};E=je([ze(4,C.ILogService)],E),e.ExtensionsActivator=E}),define(we[226],be([0,1,11,26,29]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends m.LogService{constructor(k,_){super(k.createLogger(_.logFile,{name:y.ExtensionHostLogFileName}))}};C=je([ze(0,m.ILoggerService),ze(1,i.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(we[227],be([0,1,15]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class i{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,P)=>{this._actualOk=C,this._actualErr=P,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,m.onUnexpectedError)(C))}then(C,P){return this._ensureActual().then(C,P)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=i}),define(we[53],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(I,L){this._proxyIdentifierBrand=void 0,this.isMain=I,this.sid=L,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const i=[];function y(_){const I=new m(!0,_);return i[I.nid]=I,I}e.createMainContextProxyIdentifier=y;function C(_){const I=new m(!1,_);return i[I.nid]=I,I}e.createExtHostContextProxyIdentifier=C;function P(_){return i[_].sid}e.getStringIdentifierForProxy=P;class k{constructor(I){this.value=I}}e.SerializableObjectWithBuffers=k}),define(we[5],be([0,1,59,2,53]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var P;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(P=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var L;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(L=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var T;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(T=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(s){s.name="$ident";function o(c,S){return Object.defineProperty(c,s.name,{value:S,enumerable:!0}),c}s.mixin=o;function g(c){return c[s.name]}s.of=g})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class E{static mixin(o){return o._id=E._n++,o}}e.IdObject=E,E._n=0;var h;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.command="m",s.kindModifier="n"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(s){s[s.File=1]="File",s[s.Text=2]="Text",s[s.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function A(s){if(s&&s.edits)for(const o of s.edits)typeof o.resource=="object"?o.resource=i.URI.revive(o.resource):(o.newUri=i.URI.revive(o.newUri),o.oldUri=i.URI.revive(o.oldUri)),o.metadata&&o.metadata.iconPath&&(o.metadata=(0,m.revive)(o.metadata));return s}e.reviveWorkspaceEditDto=A;var w;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,y.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,y.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,y.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,y.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,y.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,y.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,y.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,y.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,y.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,y.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,y.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,y.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,y.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,y.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,y.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,y.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,y.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,y.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(we[90],be([0,1,5,3,4]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(k){this._onDidChangePassword=new i.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,_){return this._proxy.$getPassword(k,_)}store(k,_,I){return this._proxy.$setPassword(k,_,I)}delete(k,_){return this._proxy.$deletePassword(k,_)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")}),define(we[65],be([0,1,4,11,5,14]),function(Y,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let P=class{constructor(_,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(y.MainContext.MainThreadTelemetry)}report(_,I,L){const T=this.getUsageKey(_,I);this._reportedUsages.has(T)||(this._reportedUsages.add(T),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:_}))}getUsageKey(_,I){return`${_}-${I.identifier.value}`}};P=je([ze(0,C.IExtHostRpcService),ze(1,i.ILogService)],P),e.ExtHostApiDeprecationService=P,e.NullApiDeprecationService=Object.freeze(new class{report(k,_,I){}})}),define(we[228],be([0,1,3,5,7,27]),function(Y,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class P{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(i.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,I,L,T={}){const l=C.ExtensionIdentifier.toKey(_.identifier),E=this._inFlightRequests.get(l)||[],h=[...L].sort().join(" ");let p=E.find(v=>v.scopes===h);if(p)return p.result;{const v=this._getSession(_,l,I,L,T);p={scopes:h,result:v},E.push(p),this._inFlightRequests.set(l,E);try{await v}finally{const A=E.findIndex(w=>w.scopes===h);A>-1&&(E.splice(A),this._inFlightRequests.set(l,E))}return v}}async _getSession(_,I,L,T,l={}){await this._proxy.$ensureProvider(L);const E=_.displayName||_.name;return this._proxy.$getSession(L,T,I,E,l)}async removeSession(_,I){const L=this._authenticationProviders.get(_);return L?L.provider.removeSession(I):this._proxy.$removeSession(_,I)}registerAuthenticationProvider(_,I,L,T){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:I,provider:L,options:T??{supportsMultipleAccounts:!1}}),this._providers.find(E=>E.id===_)||this._providers.push({id:_,label:I});const l=L.onDidChangeSessions(E=>{this._proxy.$sendDidChangeSessions(_,{added:E.added??[],changed:E.changed??[],removed:E.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,I,T?.supportsMultipleAccounts??!1),new y.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(_);const E=this._providers.findIndex(h=>h.id===_);E>-1&&this._providers.splice(E),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,I){const L=this._authenticationProviders.get(_);if(L)return Promise.resolve(L.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,I){const L=this._authenticationProviders.get(_);if(L)return Promise.resolve(L.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,I){const L=this._authenticationProviders.get(_);if(L)return Promise.resolve(L.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,I){return this._onDidChangeSessions.fire({provider:{id:_,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=P}),define(we[229],be([0,1,5,14,17]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(k,_){this._extHostDocumentsAndEditors=_,this._proxy=k.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const _=y.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};C=je([ze(0,i.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(we[230],be([0,1,5]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class i{constructor(C){const P=C.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return P.$readText()},writeText(k){return P.$writeText(k)}})}}e.ExtHostClipboard=i}),define(we[38],be([0,1,13,7,17,25,5,16,11,59,41,49,2,6,4,14,63,22,53,50]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v,A,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(n,u){this._commands=new Map,this._apiCommands=new Map,this._proxy=n.getProxy(P.MainContext.MainThreadCommands),this._logService=u,this.converter=new g(this,a=>{const f=this._apiCommands.get(a);return f?.result===S.Void?f:void 0},u),this._argumentProcessors=[{processArgument(a){return(0,I.revive)(a)}},{processArgument(a){return(0,C.cloneAndChange)(a,function(f){if(L.Range.isIRange(f))return y.Range.to(f);if(T.Position.isIPosition(f))return y.Position.to(f);if(L.Range.isIRange(f.range)&&l.URI.isUri(f.uri))return y.location.to(f);if(f instanceof A.VSBuffer)return f.buffer.buffer;if(!Array.isArray(f))return f})}}]}registerArgumentProcessor(n){this._argumentProcessors.push(n)}registerApiCommand(n){const u=this.registerCommand(!1,n.id,async(...a)=>{const f=n.args.map((d,D)=>{if(!d.validate(a[D]))throw new Error(`Invalid argument '${d.name}' when running '${n.id}', received: ${a[D]}`);return d.convert(a[D])}),b=await this.executeCommand(n.internalId,...f);return n.result.convert(b,a,this.converter)},void 0,{description:n.description,args:n.args,returns:n.result.description});return this._apiCommands.set(n.id,n),new i.Disposable(()=>{u.dispose(),this._apiCommands.delete(n.id)})}registerCommand(n,u,a,f,b,d){if(this._logService.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this._commands.has(u))throw new Error(`command '${u}' already exists`);return this._commands.set(u,{callback:a,thisArg:f,description:b,extension:d}),n&&this._proxy.$registerCommand(u),new i.Disposable(()=>{this._commands.delete(u)&&n&&this._proxy.$unregisterCommand(u)})}executeCommand(n,...u){return this._logService.trace("ExtHostCommands#executeCommand",n),this._doExecuteCommand(n,u,!0)}async _doExecuteCommand(n,u,a){if(this._commands.has(n))return this._executeContributedCommand(n,u,!1);{let f=!1;const b=(0,C.cloneAndChange)(u,function(d){if(d instanceof i.Position)return y.Position.from(d);if(d instanceof i.Range)return y.Range.from(d);if(d instanceof i.Location)return y.location.from(d);if(i.NotebookRange.isNotebookRange(d))return y.NotebookRange.from(d);if(d instanceof ArrayBuffer)return f=!0,A.VSBuffer.wrap(new Uint8Array(d));if(d instanceof Uint8Array)return f=!0,A.VSBuffer.wrap(d);if(!Array.isArray(d))return d});try{const d=await this._proxy.$executeCommand(n,f?new w.SerializableObjectWithBuffers(b):b,a);return(0,I.revive)(d)}catch(d){if(d instanceof Error&&d.message==="$executeCommand:retry")return this._doExecuteCommand(n,u,!1);throw d}}}async _executeContributedCommand(n,u,a){const f=this._commands.get(n);if(!f)throw new Error("Unknown command");let{callback:b,thisArg:d,description:D}=f;if(D)for(let R=0;R<D.args.length;R++)try{(0,m.validateConstraint)(u[R],D.args[R].constraint)}catch{throw new Error(`Running the contributed command: '${n}' failed. Illegal argument '${D.args[R].name}' - ${D.args[R].description}`)}try{return await b.apply(d,u)}catch(R){if(n===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...u);N&&(n=N.command)}throw this._logService.error(R,n,f.extension?.identifier),a?new class extends Error{constructor(){super((0,s.toErrorMessage)(R));this.id=n,this.source=f.extension?.displayName??f.extension?.name}}:R}}$executeContributedCommand(n,...u){return this._logService.trace("ExtHostCommands#$executeContributedCommand",n),this._commands.has(n)?(u=u.map(a=>this._argumentProcessors.reduce((f,b)=>b.processArgument(f),a)),this._executeContributedCommand(n,u,!0)):Promise.reject(new Error(`Contributed command '${n}' does not exist.`))}getCommands(n=!1){return this._logService.trace("ExtHostCommands#getCommands",n),this._proxy.$getCommands().then(u=>(n&&(u=u.filter(a=>a[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const n=Object.create(null);for(let[u,a]of this._commands){let{description:f}=a;f&&(n[u]=f)}return Promise.resolve(n)}};o=je([ze(0,p.IExtHostRpcService),ze(1,_.ILogService)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class g{constructor(n,u,a){this._commands=n,this._lookupApiCommand=u,this._logService=a,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(n,u){if(!n)return;const a={$ident:void 0,id:n.command,title:n.title,tooltip:n.tooltip};if(!n.command)return a;const f=this._lookupApiCommand(n.command);if(f)a.id=f.internalId,a.arguments=f.args.map((b,d)=>b.convert(n.arguments&&n.arguments[d]));else if((0,k.isNonEmptyArray)(n.arguments)){const b=++this._cachIdPool;this._cache.set(b,n),u.add((0,E.toDisposable)(()=>{this._cache.delete(b),this._logService.trace("CommandsConverter#DISPOSE",b)})),a.$ident=b,a.id=this.delegatingCommandId,a.arguments=[b],this._logService.trace("CommandsConverter#CREATE",n.command,b)}return a}fromInternal(n){const u=P.ObjectIdentifier.of(n);return typeof u=="number"?this._cache.get(u):{command:n.id,title:n.title,arguments:n.arguments}}getActualCommand(...n){return this._cache.get(n[0])}_executeConvertedCommand(...n){const u=this.getActualCommand(...n);return this._logService.trace("CommandsConverter#EXECUTE",n[0],u?u.command:"MISSING"),u?this._commands.executeCommand(u.command,...u.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=g;class c{constructor(n,u,a,f){this.name=n,this.description=u,this.validate=a,this.convert=f}optional(){return new c(this.name,`(optional) ${this.description}`,n=>n==null||this.validate(n),n=>n===void 0?void 0:n===null?null:this.convert(n))}with(n,u){return new c(n??this.name,u??this.description,this.validate,this.convert)}}e.ApiCommandArgument=c,c.Uri=new c("uri","Uri of a text document",t=>l.URI.isUri(t),t=>t),c.Position=new c("position","A position in a text document",t=>i.Position.isPosition(t),y.Position.from),c.Range=new c("range","A range in a text document",t=>i.Range.isRange(t),y.Range.from),c.Selection=new c("selection","A selection in a text document",t=>i.Selection.isSelection(t),y.Selection.from),c.Number=new c("number","",t=>typeof t=="number",t=>t),c.String=new c("string","",t=>typeof t=="string",t=>t),c.CallHierarchyItem=new c("item","A call hierarchy item",t=>t instanceof i.CallHierarchyItem,y.CallHierarchyItem.from),c.TypeHierarchyItem=new c("item","A type hierarchy item",t=>t instanceof i.TypeHierarchyItem,y.TypeHierarchyItem.from),c.TestItem=new c("testItem","A VS Code TestItem",t=>t instanceof v.TestItemImpl,y.TestItem.from);class S{constructor(n,u){this.description=n,this.convert=u}}e.ApiCommandResult=S,S.Void=new S("no result",t=>t);class r{constructor(n,u,a,f,b){this.id=n,this.internalId=u,this.description=a,this.args=f,this.result=b}}e.ApiCommand=r}),define(we[231],be([0,1,17,7,84,38,16,110]),function(Y,e,m,i,y,C,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",L(m.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,E)=>{if((0,P.isFalsyOrEmpty)(l))return;class h extends i.SymbolInformation{static to(v){const A=new h(v.name,m.SymbolKind.to(v.kind),v.containerName||"",new i.Location(E[0],m.Range.to(v.range)));return A.detail=v.detail,A.range=A.location.range,A.selectionRange=m.Range.to(v.selectionRange),A.children=v.children?v.children.map(h.to):[],A}}return l.map(h.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new C.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(m.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",L(m.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",L(m.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(E=>i.Position.isPosition(E)),l=>l.map(m.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(E=>{let h;for(const p of E.reverse())h=new i.SelectionRange(m.Range.to(p),h);return h}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(m.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",l=>{if(!!l)return{range:m.Range.to(l.range),placeholder:l.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return m.WorkspaceEdit.to(l)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(m.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new i.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const E=(0,k.decodeSemanticTokensDto)(l);if(E.type==="full")return new i.SemanticTokens(E.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new i.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const E=(0,k.decodeSemanticTokensDto)(l);if(E.type==="full")return new i.SemanticTokens(E.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,E,h)=>{if(!l)return new i.CompletionList([]);const p=l.suggestions.map(v=>m.CompletionItem.to(v,h));return new i.CompletionList(p,l.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return m.SignatureHelp.to(l)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,E,h)=>L(p=>new i.CodeLens(m.Range.to(p.range),p.command&&h.fromInternal(p.command)))(l))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>i.Range.isRange(l),l=>i.Selection.isSelection(l)?m.Selection.from(l):m.Range.from(l)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,E,h)=>L(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(p.command)}else{const v=new i.CodeAction(p.title,p.kind?new i.CodeActionKind(p.kind):void 0);return p.edit&&(v.edit=m.WorkspaceEdit.to(p.edit)),p.command&&(v.command=h.fromInternal(p.command)),v.isPreferred=p.isPreferred,v}})(l))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(E=>new i.ColorInformation(m.Range.to(E.range),m.Color.to(E.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",l=>l instanceof i.Color,m.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:m.Range.from(l.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(m.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(m.InlayHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",L(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(E=>m.NotebookExclusiveDocumentPattern.to(E))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(m.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class I{static register(E){_.forEach(E.registerApiCommand,E)}}e.ExtHostApiCommands=I;function L(l){return E=>{if(Array.isArray(E))return E.map(l)}}function T(l){if(!Array.isArray(l))return;const E=[];for(const h of l)y.isLocationLink(h)?E.push(m.DefinitionLink.to(h)):E.push(m.location.to(h));return E}}),define(we[232],be([0,1,18,57,3,6,2,84,27,17,7,5]),function(Y,e,m,i,y,C,P,k,_,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function l(E,h,p){const v=E.getProxy(T.MainContext.MainThreadComments);class A{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const n=this._commentControllers.get(t.handle);return n||t}else if(t&&t.$mid===7){const n=this._commentControllers.get(t.commentControlHandle);if(!n)return t;const u=n.getCommentThread(t.commentThreadHandle);return u||t}else if(t&&t.$mid===8){const n=this._commentControllers.get(t.thread.commentControlHandle);if(!n)return t;const u=n.getCommentThread(t.thread.commentThreadHandle);return u?{thread:u,text:t.text}:t}else if(t&&t.$mid===9){const n=this._commentControllers.get(t.thread.commentControlHandle);if(!n)return t;const u=n.getCommentThread(t.thread.commentThreadHandle);if(!u)return t;let a=t.commentUniqueId,f=u.getCommentByUniqueId(a);return f||t}else if(t&&t.$mid===10){const n=this._commentControllers.get(t.thread.commentControlHandle);if(!n)return t;const u=n.getCommentThread(t.thread.commentThreadHandle);if(!u)return t;let a=t.text,f=t.commentUniqueId,b=u.getCommentByUniqueId(f);return b?(b.body=a,b):t}return t}})}createCommentController(t,n,u){const a=A.handlePool++,f=new s(t,a,n,u);this._commentControllers.set(f.handle,f);const b=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(t.identifier))||[];return b.push(f),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(t.identifier),b),f.value}$createCommentThreadTemplate(t,n,u){const a=this._commentControllers.get(t);!a||a.$createCommentThreadTemplate(n,u)}async $updateCommentThreadTemplate(t,n,u){const a=this._commentControllers.get(t);!a||a.$updateCommentThreadTemplate(n,u)}$deleteCommentThread(t,n){const u=this._commentControllers.get(t);u&&u.$deleteCommentThread(n)}$provideCommentingRanges(t,n,u){const a=this._commentControllers.get(t);if(!a||!a.commentingRangeProvider)return Promise.resolve(void 0);const f=p.getDocument(P.URI.revive(n));return(0,m.asPromise)(()=>a.commentingRangeProvider.provideCommentingRanges(f,u)).then(b=>b?b.map(d=>I.Range.from(d)):void 0)}$toggleReaction(t,n,u,a,f){const b=this._commentControllers.get(t);return!b||!b.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const d=b.getCommentThread(n);if(d){const D=d.getCommentByUniqueId(a.uniqueIdInThread);if(b!==void 0&&D&&b.reactionHandler)return b.reactionHandler(D,c(f))}return Promise.resolve(void 0)})}dispose(){}}A.handlePool=0;class w{constructor(t,n,u,a,f,b,d){this._commentControllerHandle=n,this._id=u,this._uri=a,this._range=f,this._comments=b,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new y.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),v.$createCommentThread(n,this.handle,this._id,this._uri,I.Range.from(this._range),d),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=b,this._localDisposables.push({dispose:()=>{v.$deleteCommentThread(n,this.handle)}});const D=this;this.value={get uri(){return D.uri},get range(){return D.range},set range(R){D.range=R},get comments(){return D.comments},set comments(R){D.comments=R},get collapsibleState(){return D.collapsibleState},set collapsibleState(R){D.collapsibleState=R},get canReply(){return D.canReply},set canReply(R){D.canReply=R},get contextValue(){return D.contextValue},set contextValue(R){D.contextValue=R},get label(){return D.label},set label(R){D.label=R},dispose:()=>{D.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const t=u=>Object.prototype.hasOwnProperty.call(this.modifications,u),n={};t("range")&&(n.range=I.Range.from(this._range)),t("label")&&(n.label=this.label),t("contextValue")&&(n.contextValue=this.contextValue??null),t("comments")&&(n.comments=this._comments.map(u=>o(this,u,this._commentsMap))),t("collapsibleState")&&(n.collapseState=S(this._collapseState)),t("canReply")&&(n.canReply=this.canReply),this.modifications={},v.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,n)}getCommentByUniqueId(t){for(let n of this._commentsMap){let u=n[0],a=n[1];if(t===a)return u}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}w._handlePool=0,je([(0,i.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class s{constructor(t,n,u,a){this._extension=t,this._handle=n,this._id=u,this._label=a,this._threads=new Map,v.$registerCommentController(this.handle,u,a);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(b){f.options=b},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(b){f.commentingRangeProvider=b},get reactionHandler(){return f.reactionHandler},set reactionHandler(b){f.reactionHandler=b},createCommentThread(b,d,D){return f.createCommentThread(b,d,D).value},dispose:()=>{f.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{v.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,v.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,v.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,v.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,n,u,a){if(typeof t=="string"){const f=new w(this.id,this.handle,t,n,u,a,this._extension.identifier);return this._threads.set(f.handle,f),f}else{const f=new w(this.id,this.handle,void 0,t,n,u,this._extension.identifier);return this._threads.set(f.handle,f),f}}$createCommentThreadTemplate(t,n){const u=new w(this.id,this.handle,void 0,P.URI.revive(t),I.Range.to(n),[],this._extension.identifier);return u.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(u.handle,u),u}$updateCommentThreadTemplate(t,n){let u=this._threads.get(t);u&&(u.range=I.Range.to(n))}$deleteCommentThread(t){let n=this._threads.get(t);n&&n.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function o(r,t,n){let u=n.get(t);u||(u=++r.commentHandle,n.set(t,u));const a=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:u,body:I.MarkdownString.from(t.body),userName:t.author.name,userIconPath:a,label:t.label,commentReactions:t.reactions?t.reactions.map(f=>g(f)):void 0}}function g(r){return{label:r.label,iconPath:r.iconPath?I.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function c(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?P.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function S(r){if(r!==void 0)switch(r){case L.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new A}e.createExtHostComments=l}),define(we[130],be([0,1,2,5,7,4,14,11,16,8,9]),function(Y,e,m,i,y,C,P,k,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let T=class bi{constructor(E,h){this._logService=h,this._provider=new Map,this._proxy=E.getProxy(i.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,h){const p=bi._handlePool++;this._provider.set(p,{provider:E,extensionId:h}),this._proxy.$registerDecorationProvider(p,h.value);const v=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(A=>{if(!A){this._proxy.$onDidChange(p,null);return}let w=(0,_.asArray)(A);if(w.length<=bi._maxEventSize){this._proxy.$onDidChange(p,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",h.value,w.length);const s=w.map(c=>({uri:c,rank:(0,I.count)(c.path,"/")})),o=(0,_.groupBy)(s,(c,S)=>c.rank-S.rank||(0,I.compare)(c.uri.path,S.uri.path));let g=[];e:for(let c of o){let S;for(let r of c){let t=(0,L.dirname)(r.uri.path);if(S!==t&&(S=t,g.push(r.uri)>=bi._maxEventSize))break e}}this._proxy.$onDidChange(p,g)});return new y.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(p),this._provider.delete(p)})}async $provideDecorations(E,h,p){if(!this._provider.has(E))return Object.create(null);const v=Object.create(null),{provider:A,extensionId:w}=this._provider.get(E);return await Promise.all(h.map(async s=>{try{const{uri:o,id:g}=s,c=await Promise.resolve(A.provideFileDecoration(m.URI.revive(o),p));if(!c)return;try{y.FileDecoration.validate(c),v[g]=[c.propagate,c.tooltip,c.badge,c.color]}catch(S){this._logService.warn(`INVALID decoration from extension '${w.value}': ${S}`)}}catch(o){this._logService.error(o)}})),v}};T._handlePool=0,T._maxEventSize=250,T=je([ze(0,P.IExtHostRpcService),ze(1,k.ILogService)],T),e.ExtHostDecorations=T,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},xe=this&&this.__classPrivateFieldGet||function(Y,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(Y):i?i.value:e.get(Y)};define(we[233],be([0,1,162,116,2,5,7,17,3,11,24,44]),function(Y,e,m,i,y,C,P,k,_,I,L,T){"use strict";var l,E,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class p{constructor(w,s,o,g,c,S){this._name=w,this._owner=s,this._maxDiagnosticsPerFile=o,l.set(this,void 0),E.set(this,void 0),h.set(this,void 0),this._isDisposed=!1,nt(this,h,new L.ResourceMap(r=>g.getComparisonKey(r)),"f"),nt(this,l,c,"f"),nt(this,E,S,"f")}dispose(){this._isDisposed||(xe(this,E,"f").fire([...xe(this,h,"f").keys()]),xe(this,l,"f")&&xe(this,l,"f").$clear(this._owner),xe(this,h,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(w,s){if(!w){this.clear();return}this._checkDisposed();let o=[];if(y.URI.isUri(w)){if(!s){this.delete(w);return}xe(this,h,"f").set(w,s.slice()),o=[w]}else if(Array.isArray(w)){o=[];let c;w=[...w].sort(p._compareIndexedTuplesByUri);for(const S of w){const[r,t]=S;if((!c||r.toString()!==c.toString())&&(c&&xe(this,h,"f").get(c).length===0&&xe(this,h,"f").delete(c),c=r,o.push(r),xe(this,h,"f").set(r,[])),t){const n=xe(this,h,"f").get(r);n&&n.push(...t)}else{const n=xe(this,h,"f").get(r);n&&(n.length=0)}}}if(xe(this,E,"f").fire(o),!xe(this,l,"f"))return;const g=[];for(let c of o){let S=[];const r=xe(this,h,"f").get(c);if(r)if(r.length>this._maxDiagnosticsPerFile){S=[];const t=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(let u of r)if(u.severity===t[n]&&S.push(k.Diagnostic.from(u))===this._maxDiagnosticsPerFile)break e;S.push({severity:i.MarkerSeverity.Info,message:(0,m.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:S[S.length-1].startLineNumber,startColumn:S[S.length-1].startColumn,endLineNumber:S[S.length-1].endLineNumber,endColumn:S[S.length-1].endColumn})}else S=r.map(t=>k.Diagnostic.from(t));g.push([c,S])}xe(this,l,"f").$changeMany(this._owner,g)}delete(w){this._checkDisposed(),xe(this,E,"f").fire([w]),xe(this,h,"f").delete(w),xe(this,l,"f")&&xe(this,l,"f").$changeMany(this._owner,[[w,void 0]])}clear(){this._checkDisposed(),xe(this,E,"f").fire([...xe(this,h,"f").keys()]),xe(this,h,"f").clear(),xe(this,l,"f")&&xe(this,l,"f").$clear(this._owner)}forEach(w,s){this._checkDisposed();for(let o of xe(this,h,"f").keys())w.apply(s,[o,this.get(o),this])}get(w){this._checkDisposed();const s=xe(this,h,"f").get(w);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(w){return this._checkDisposed(),Array.isArray(xe(this,h,"f").get(w))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(w,s){return w[0].toString()<s[0].toString()?-1:w[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=p,l=new WeakMap,E=new WeakMap,h=new WeakMap;let v=class ri{constructor(w,s,o){this._logService=s,this._fileSystemInfoService=o,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,ri._mapper),this._proxy=w.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(w){const s=new L.ResourceMap;for(const o of w)s.set(o,o);return{uris:Object.freeze(Array.from(s.values()))}}createDiagnosticCollection(w,s){const{_collections:o,_proxy:g,_onDidChangeDiagnostics:c,_logService:S,_fileSystemInfoService:r}=this,t=new class{$changeMany(a,f){g.$changeMany(a,f),S.trace("[DiagnosticCollection] change many (extension, owner, uris)",w.value,a,f.length===0?"CLEARING":f)}$clear(a){g.$clear(a),S.trace("[DiagnosticCollection] remove all (extension, owner)",w.value,a)}dispose(){g.dispose()}};let n;if(!s)s="_generated_diagnostic_collection_name_#"+ri._idPool++,n=s;else if(!o.has(s))n=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do n=s+ri._idPool++;while(o.has(n))}return new class extends p{constructor(){super(s,n,ri._maxDiagnosticsPerFile,r.extUri,t,c);o.set(n,this)}dispose(){super.dispose(),o.delete(n)}}}getDiagnostics(w){if(w)return this._getDiagnostics(w);{const s=new Map,o=[];for(const g of this._collections.values())g.forEach((c,S)=>{let r=s.get(c.toString());typeof r=="undefined"&&(r=o.length,s.set(c.toString(),r),o.push([c,[]])),o[r][1]=o[r][1].concat(...S)});return o}}_getDiagnostics(w){let s=[];for(let o of this._collections.values())o.has(w)&&(s=s.concat(o.get(w)));return s}$acceptMarkersChange(w){if(!this._mirrorCollection){const s="_generated_mirror",o=new p(s,s,ri._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(s,o),this._mirrorCollection=o}for(const[s,o]of w)this._mirrorCollection.set(y.URI.revive(s),o.map(k.Diagnostic.to))}};v._idPool=0,v._maxDiagnosticsPerFile=1e3,v=je([ze(1,I.ILogService),ze(2,T.IExtHostFileSystemInfo)],v),e.ExtHostDiagnostics=v}),define(we[234],be([0,1,2,5]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(P){this._proxy=P.getProxy(i.MainContext.MainThreadDialogs)}showOpenDialog(P){return this._proxy.$showOpenDialog(P).then(k=>k?k.map(_=>m.URI.revive(_)):void 0)}showSaveDialog(P){return this._proxy.$showSaveDialog(P).then(k=>k?m.URI.revive(k):void 0)}}e.ExtHostDialogs=y}),define(we[235],be([0,1,15,2,7,5,10,21,8]),function(Y,e,m,i,y,C,P,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(T,l,E){this._documentsAndEditors=l,this._logService=E,this._documentContentProviders=new Map,this._proxy=T.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(T,l){if(Object.keys(P.Schemas).indexOf(T)>=0)throw new Error(`scheme '${T}' already registered`);const E=I._handlePool++;this._documentContentProviders.set(E,l),this._proxy.$registerTextContentProvider(E,T);let h;return typeof l.onDidChange=="function"&&(h=l.onDidChange(p=>{if(p.scheme!==T){this._logService.warn(`Provider for scheme '${T}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(p)&&this.$provideTextDocumentContent(E,p).then(v=>{if(!v&&typeof v!="string")return;const A=this._documentsAndEditors.getDocument(p);if(!A)return;const w=(0,_.splitLines)(v);if(!A.equalLines(w))return this._proxy.$onVirtualDocumentChange(p,v)},m.onUnexpectedError)})),new y.Disposable(()=>{this._documentContentProviders.delete(E)&&this._proxy.$unregisterTextContentProvider(E),h&&(h.dispose(),h=void 0)})}$provideTextDocumentContent(T,l){const E=this._documentContentProviders.get(T);return E?Promise.resolve(E.provideTextDocumentContent(i.URI.revive(l),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=I,I._handlePool=0}),define(we[236],be([0,1,3,6,2,5,122,17,13,25,7]),function(Y,e,m,i,y,C,P,k,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(E,h){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new i.DisposableStore,this._documentLoader=new Map,this._proxy=E.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(p=>{for(const v of p)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(p=>{for(const v of p)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(E){if(!E)return;const h=this._documentsAndEditors.getDocument(E);if(h)return h}getDocument(E){const h=this.getDocumentData(E);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return h.document}ensureDocumentData(E){const h=this._documentsAndEditors.getDocument(E);if(h)return Promise.resolve(h);let p=this._documentLoader.get(E.toString());return p||(p=this._proxy.$tryOpenDocument(E).then(v=>{this._documentLoader.delete(E.toString());const A=y.URI.revive(v);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(A))},v=>(this._documentLoader.delete(E.toString()),Promise.reject(v))),this._documentLoader.set(E.toString(),p)),p}createDocumentData(E){return this._proxy.$tryCreateDocument(E).then(h=>y.URI.revive(h))}$acceptModelModeChanged(E,h){const p=y.URI.revive(E),v=this._documentsAndEditors.getDocument(p);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(h),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(E){const h=y.URI.revive(E),p=this._documentsAndEditors.getDocument(h);if(!p)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this._onDidSaveDocument.fire(p.document)}$acceptDirtyStateChanged(E,h){const p=y.URI.revive(E),v=this._documentsAndEditors.getDocument(p);if(!v)throw new Error("unknown document");v._acceptIsDirty(h),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,h,p){const v=y.URI.revive(E),A=this._documentsAndEditors.getDocument(v);if(!A)throw new Error("unknown document");A._acceptIsDirty(p),A.onEvents(h);let w;h.isUndoing?w=L.TextDocumentChangeReason.Undo:h.isRedoing&&(w=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,I.deepFreeze)({document:A.document,contentChanges:h.changes.map(s=>({range:k.Range.to(s.range),rangeOffset:s.rangeOffset,rangeLength:s.rangeLength,text:s.text})),reason:w}))}setWordDefinitionFor(E,h){(0,P.setWordDefinitionFor)(E,h)}}e.ExtHostDocuments=T}),define(we[45],be([0,1,56,3,6,2,4,5,122,14,129,17,11,24,10,77,140]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class A{constructor(o){this.value=o,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(o,g){this._extHostRpc=o,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new E.ResourceMap,this._onDidAddDocuments=new i.Emitter,this._onDidRemoveDocuments=new i.Emitter,this._onDidChangeVisibleTextEditors=new i.Emitter,this._onDidChangeActiveTextEditor=new i.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const g=[],c=[],S=[];if(o.removedDocuments)for(const r of o.removedDocuments){const t=C.URI.revive(r),n=this._documents.get(t);n?.unref()&&(this._documents.delete(t),g.push(n.value))}if(o.addedDocuments)for(const r of o.addedDocuments){const t=C.URI.revive(r.uri);let n=this._documents.get(t);if(n&&t.scheme!==h.Schemas.vscodeNotebookCell&&t.scheme!==h.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);n||(n=new A(new _.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),t,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(t,n),c.push(n.value)),n.ref()}if(o.removedEditors)for(const r of o.removedEditors){const t=this._editors.get(r);this._editors.delete(r),t&&S.push(t)}if(o.addedEditors)for(const r of o.addedEditors){const t=C.URI.revive(r.documentUri);m.ok(this._documents.has(t),`document '${t}' does not exist`),m.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const n=this._documents.get(t).value,u=new L.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>n.document),r.selections.map(T.Selection.to),r.options,r.visibleRanges.map(a=>T.Range.to(a)),typeof r.editorPosition=="number"?T.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,u)}o.newActiveEditor!==void 0&&(m.ok(o.newActiveEditor===null||this._editors.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this._activeEditorId=o.newActiveEditor),(0,y.dispose)(g),(0,y.dispose)(S),o.removedDocuments&&this._onDidRemoveDocuments.fire(g),o.addedDocuments&&this._onDidAddDocuments.fire(c),(o.removedEditors||o.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),o.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(o){return this._documents.get(o)?.value}allDocuments(){return p.Iterable.map(this._documents.values(),o=>o.value)}getEditor(o){return this._editors.get(o)}activeEditor(o){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return o?g:g?.value}allEditors(){return[...this._editors.values()]}};w=je([ze(0,I.IExtHostRpcService),ze(1,l.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,P.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[54],be([0,1,17,5,2,3,4,14,18]),function(Y,e,m,i,y,C,P,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,P.createDecorator)("IExtHostEditorTabs");let I=class{constructor(T){this._onDidChangeTabs=new C.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new C.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=T.getProxy(i.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(T){let l=-1;this._tabs=T.map((h,p)=>(h.isActive&&(l=p),Object.freeze({label:h.label,viewColumn:m.ViewColumn.to(h.viewColumn),index:p,resource:y.URI.revive(h.resource),additionalResourcesAndViewIds:h.additionalResourcesAndViewIds.map(({resource:v,viewId:A})=>({resource:y.URI.revive(v),viewId:A})),viewId:h.editorId,isActive:h.isActive,move:async(v,A)=>{this._proxy.$moveTab(h,v,m.ViewColumn.from(A)),await(0,_.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(h),await(0,_.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((h,p)=>h.viewColumn===p.viewColumn?h.index-p.index:h.viewColumn-p.viewColumn);const E=this._activeTab;this._activeTab=l===-1?void 0:this._tabs[l],this._activeTab!==E&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};I=je([ze(0,k.IExtHostRpcService)],I),e.ExtHostEditorTabs=I}),define(we[237],be([0,1,2,5,6,7,17,147,8,22,29]),function(Y,e,m,i,y,C,P,k,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const p=this._schemes.indexOf(h);p>=0&&(this._schemes.splice(p,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),p=[];let v,A,w=14,s=14;for(const o of h){let g=v?(0,_.commonPrefixLength)(v,o):0;for(g===0?A=1:A=s;g<o.length;g++)g+1===o.length?(w=s,s=9):s+=1,p.push([A,o.toUpperCase().charCodeAt(g),s]),p.push([A,o.toLowerCase().charCodeAt(g),s]),A=s;v=o,s=w}p.push([9,58,10]),p.push([10,47,12]),this._stateMachine=new k.StateMachine(p)}}provideDocumentLinks(h){this._initStateMachine();const p=[],v=k.LinkComputer.computeLinks({getLineContent(A){return h.lineAt(A-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const A of v){const w=P.DocumentLink.to(A);w.target&&p.push(w)}return p}}class l{constructor(h,p){this._extHostLanguageFeatures=p,this._linkProvider=new T,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(i.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,p,v,A={}){if(this._registeredSchemes.has(p))throw new Error(`a provider for the scheme '${p}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const w=this._handlePool++;this._linkProvider.add(p),this._registeredSchemes.add(p),this._fsProvider.set(w,v);let s=2;A.isCaseSensitive&&(s+=1024),A.isReadonly&&(s+=2048),typeof v.copy=="function"&&(s+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&((0,L.checkProposedApiEnabled)(h,"fsChunks"),s+=4),this._proxy.$registerFileSystemProvider(w,p,s).catch(g=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${p}`),console.error(g)});const o=v.onDidChangeFile(g=>{const c=[];for(const S of g){let{uri:r,type:t}=S;if(r.scheme!==p)continue;let n;switch(t){case C.FileChangeType.Changed:n=0;break;case C.FileChangeType.Created:n=1;break;case C.FileChangeType.Deleted:n=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:r,type:n})}this._proxy.$onFileSystemChange(w,c)});return(0,y.toDisposable)(()=>{o.dispose(),this._linkProvider.delete(p),this._registeredSchemes.delete(p),this._fsProvider.delete(w),this._proxy.$unregisterProvider(w)})}static _asIStat(h){const{type:p,ctime:v,mtime:A,size:w,permissions:s}=h;return{type:p,ctime:v,mtime:A,size:w,permissions:s}}$stat(h,p){return Promise.resolve(this._getFsProvider(h).stat(m.URI.revive(p))).then(v=>l._asIStat(v))}$readdir(h,p){return Promise.resolve(this._getFsProvider(h).readDirectory(m.URI.revive(p)))}$readFile(h,p){return Promise.resolve(this._getFsProvider(h).readFile(m.URI.revive(p))).then(v=>I.VSBuffer.wrap(v))}$writeFile(h,p,v,A){return Promise.resolve(this._getFsProvider(h).writeFile(m.URI.revive(p),v.buffer,A))}$delete(h,p,v){return Promise.resolve(this._getFsProvider(h).delete(m.URI.revive(p),v))}$rename(h,p,v,A){return Promise.resolve(this._getFsProvider(h).rename(m.URI.revive(p),m.URI.revive(v),A))}$copy(h,p,v,A){const w=this._getFsProvider(h);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(m.URI.revive(p),m.URI.revive(v),A))}$mkdir(h,p){return Promise.resolve(this._getFsProvider(h).createDirectory(m.URI.revive(p)))}$watch(h,p,v,A){const w=this._getFsProvider(h).watch(m.URI.revive(v),A);this._watches.set(p,w)}$unwatch(h,p){const v=this._watches.get(p);v&&(v.dispose(),this._watches.delete(p))}$open(h,p,v){const A=this._getFsProvider(h);if(!A.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(A.open(m.URI.revive(p),v))}$close(h,p){const v=this._getFsProvider(h);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(p))}$read(h,p,v,A){const w=this._getFsProvider(h);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const s=I.VSBuffer.alloc(A);return Promise.resolve(w.read(p,v,s.buffer,0,A)).then(o=>s.slice(0,o))}$write(h,p,v,A){const w=this._getFsProvider(h);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(p,v,A.buffer,0,A.byteLength))}_getFsProvider(h){const p=this._fsProvider.get(h);if(!p){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return p}}e.ExtHostFileSystem=l}),define(we[66],be([0,1,5,42,7,22,4,14,44,6]),function(Y,e,m,i,y,C,P,k,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class zt{constructor(l,E){this._fileSystemProvider=new Map,this._proxy=l.getProxy(m.MainContext.MainThreadFileSystem);const h=this;this.value=Object.freeze({async stat(p){try{const v=h._fileSystemProvider.get(p.scheme);if(!v)return await h._proxy.$stat(p);await h._proxy.$ensureActivation(p.scheme);const A=await v.stat(p);return{type:A.type,ctime:A.ctime,mtime:A.mtime,size:A.size,permissions:A.permissions}}catch(v){zt._handleError(v)}},async readDirectory(p){try{const v=h._fileSystemProvider.get(p.scheme);return v?(await h._proxy.$ensureActivation(p.scheme),(await v.readDirectory(p)).slice()):await h._proxy.$readdir(p)}catch(v){return zt._handleError(v)}},async createDirectory(p){try{return await h._proxy.$mkdir(p)}catch(v){return zt._handleError(v)}},async readFile(p){try{const v=h._fileSystemProvider.get(p.scheme);return v?(await h._proxy.$ensureActivation(p.scheme),(await v.readFile(p)).slice()):(await h._proxy.$readFile(p)).buffer}catch(v){return zt._handleError(v)}},async writeFile(p,v){try{return await h._proxy.$writeFile(p,C.VSBuffer.wrap(v))}catch(A){return zt._handleError(A)}},async delete(p,v){try{const A=h._fileSystemProvider.get(p.scheme);return A?(await h._proxy.$ensureActivation(p.scheme),await A.delete(p,{recursive:!1,...v})):await h._proxy.$delete(p,{recursive:!1,useTrash:!1,...v})}catch(A){return zt._handleError(A)}},async rename(p,v,A){try{return await h._proxy.$rename(p,v,{overwrite:!1,...A})}catch(w){return zt._handleError(w)}},async copy(p,v,A){try{return await h._proxy.$copy(p,v,{overwrite:!1,...A})}catch(w){return zt._handleError(w)}},isWritableFileSystem(p){const v=E.getCapabilities(p);if(typeof v=="number")return!(v&2048)}})}static _handleError(l){if(l instanceof y.FileSystemError)throw l;if(!(l instanceof Error))throw new y.FileSystemError(String(l));if(l.name==="ENOPRO")throw y.FileSystemError.Unavailable(l.message);switch(l.name){case i.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(l.message);case i.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(l.message);case i.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(l.message);case i.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(l.message);case i.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(l.message);case i.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(l.message);default:throw new y.FileSystemError(l.message,l.name)}}addFileSystemProvider(l,E){return this._fileSystemProvider.set(l,E),(0,I.toDisposable)(()=>this._fileSystemProvider.delete(l))}};L=je([ze(0,k.IExtHostRpcService),ze(1,_.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,P.createDecorator)("IExtHostConsumerFileSystem")}),define(we[238],be([0,1,2,38]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(P,k,_,I){this._extHostNotebooks=k,this._textDocumentsAndEditors=_,this._commands=I;const L=new i.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new i.ApiCommandArgument("showOptions","Show Options",T=>!0,T=>T),new i.ApiCommandArgument("resource","Interactive resource Uri",T=>!0,T=>T),new i.ApiCommandArgument("controllerId","Notebook controller Id",T=>!0,T=>T),new i.ApiCommandArgument("title","Interactive editor title",T=>!0,T=>T)],new i.ApiCommandResult("Notebook and input URI",T=>{if(T.notebookEditorId!==void 0){const l=this._extHostNotebooks.getEditorById(T.notebookEditorId);return{notebookUri:m.URI.revive(T.notebookUri),inputUri:m.URI.revive(T.inputUri),notebookEditor:l.apiEditor}}return{notebookUri:m.URI.revive(T.notebookUri),inputUri:m.URI.revive(T.inputUri)}}));this._commands.registerApiCommand(L)}$willAddInteractiveDocument(P,k,_,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:_,uri:P,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(P,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[P]})}}e.ExtHostInteractive=y}),define(we[239],be([0,1,6,5]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(P){this._handlePool=0,this._proxy=P.getProxy(i.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(P){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,P),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=y}),define(we[240],be([0,1,2,25,17,7,5,8,41,16,13,144,6,110,76,87,46,15,3]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(q,J){this._documents=q,this._provider=J}async provideDocumentSymbols(q,J){const re=this._documents.getDocument(q),he=await this._provider.provideDocumentSymbols(re,J);if(!(0,I.isFalsyOrEmpty)(he))return he[0]instanceof C.DocumentSymbol?he.map(y.DocumentSymbol.from):s._asDocumentSymbolTree(he)}static _asDocumentSymbolTree(q){q=q.slice(0).sort((he,ee)=>{let ae=he.location.range.start.compareTo(ee.location.range.start);return ae===0&&(ae=ee.location.range.end.compareTo(he.location.range.end)),ae});const J=[],re=[];for(const he of q){const ee={name:he.name||"!!MISSING: name!!",kind:y.SymbolKind.from(he.kind),tags:he.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:he.containerName,range:y.Range.from(he.location.range),selectionRange:y.Range.from(he.location.range),children:[]};for(;;){if(re.length===0){re.push(ee),J.push(ee);break}const ae=re[re.length-1];if(_.Range.containsRange(ae.range,ee.range)&&!_.Range.equalsRange(ae.range,ee.range)){ae.children&&ae.children.push(ee),re.push(ee);break}re.pop()}}return J}}class o{constructor(q,J,re){this._documents=q,this._commands=J,this._provider=re,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(q,J){const re=this._documents.getDocument(q),he=await this._provider.provideCodeLenses(re,J);if(!he||J.isCancellationRequested)return;const ee=this._cache.add(he),ae=new l.DisposableStore;this._disposables.set(ee,ae);const Se={cacheId:ee,lenses:[]};for(let Ue=0;Ue<he.length;Ue++)Se.lenses.push({cacheId:[ee,Ue],range:y.Range.from(he[Ue].range),command:this._commands.toInternal(he[Ue].command,ae)});return Se}async resolveCodeLens(q,J){const re=q.cacheId&&this._cache.get(...q.cacheId);if(!re)return;let he;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?he=re:he=await this._provider.resolveCodeLens(re,J),he||(he=re),J.isCancellationRequested)return;const ee=q.cacheId&&this._disposables.get(q.cacheId[0]);if(!!ee)return q.command=this._commands.toInternal(he.command??o._badCmd,ee),q}releaseCodeLenses(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function g(Oe){return Array.isArray(Oe)?Oe.map(y.DefinitionLink.from):Oe?[y.DefinitionLink.from(Oe)]:[]}class c{constructor(q,J){this._documents=q,this._provider=J}async provideDefinition(q,J,re){const he=this._documents.getDocument(q),ee=y.Position.to(J),ae=await this._provider.provideDefinition(he,ee,re);return g(ae)}}class S{constructor(q,J){this._documents=q,this._provider=J}async provideDeclaration(q,J,re){const he=this._documents.getDocument(q),ee=y.Position.to(J),ae=await this._provider.provideDeclaration(he,ee,re);return g(ae)}}class r{constructor(q,J){this._documents=q,this._provider=J}async provideImplementation(q,J,re){const he=this._documents.getDocument(q),ee=y.Position.to(J),ae=await this._provider.provideImplementation(he,ee,re);return g(ae)}}class t{constructor(q,J){this._documents=q,this._provider=J}async provideTypeDefinition(q,J,re){const he=this._documents.getDocument(q),ee=y.Position.to(J),ae=await this._provider.provideTypeDefinition(he,ee,re);return g(ae)}}class n{constructor(q,J){this._documents=q,this._provider=J}async provideHover(q,J,re){const he=this._documents.getDocument(q),ee=y.Position.to(J),ae=await this._provider.provideHover(he,ee,re);if(!(!ae||(0,I.isFalsyOrEmpty)(ae.contents)))return ae.range||(ae.range=he.getWordRangeAtPosition(ee)),ae.range||(ae.range=new C.Range(ee,ee)),y.Hover.from(ae)}}class u{constructor(q,J){this._documents=q,this._provider=J}async provideEvaluatableExpression(q,J,re){const he=this._documents.getDocument(q),ee=y.Position.to(J),ae=await this._provider.provideEvaluatableExpression(he,ee,re);if(ae)return y.EvaluatableExpression.from(ae)}}class a{constructor(q,J){this._documents=q,this._provider=J}async provideInlineValues(q,J,re,he){const ee=this._documents.getDocument(q),ae=await this._provider.provideInlineValues(ee,y.Range.to(J),y.InlineValueContext.to(re),he);if(Array.isArray(ae))return ae.map(Se=>y.InlineValue.from(Se))}}class f{constructor(q,J){this._documents=q,this._provider=J}async provideDocumentHighlights(q,J,re){const he=this._documents.getDocument(q),ee=y.Position.to(J),ae=await this._provider.provideDocumentHighlights(he,ee,re);if(Array.isArray(ae))return ae.map(y.DocumentHighlight.from)}}class b{constructor(q,J){this._documents=q,this._provider=J}async provideLinkedEditingRanges(q,J,re){const he=this._documents.getDocument(q),ee=y.Position.to(J),ae=await this._provider.provideLinkedEditingRanges(he,ee,re);if(ae&&Array.isArray(ae.ranges))return{ranges:(0,I.coalesce)(ae.ranges.map(y.Range.from)),wordPattern:ae.wordPattern}}}class d{constructor(q,J){this._documents=q,this._provider=J}async provideReferences(q,J,re,he){const ee=this._documents.getDocument(q),ae=y.Position.to(J),Se=await this._provider.provideReferences(ee,ae,re,he);if(Array.isArray(Se))return Se.map(y.location.from)}}class D{constructor(q,J,re,he,ee,ae,Se){this._documents=q,this._commands=J,this._diagnostics=re,this._provider=he,this._logService=ee,this._extension=ae,this._apiDeprecation=Se,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(q,J,re,he){const ee=this._documents.getDocument(q),ae=T.Selection.isISelection(J)?y.Selection.to(J):y.Range.to(J),Se=[];for(const ot of this._diagnostics.getDiagnostics(q))if(ae.intersection(ot.range)&&Se.push(ot)>D._maxCodeActionsPerFile)break;const Ue={diagnostics:Se,only:re.only?new C.CodeActionKind(re.only):void 0,triggerKind:y.CodeActionTriggerKind.to(re.trigger)},Ve=await this._provider.provideCodeActions(ee,ae,Ue,he);if(!(0,I.isNonEmptyArray)(Ve)||he.isCancellationRequested)return;const Ge=this._cache.add(Ve),Je=new l.DisposableStore;this._disposables.set(Ge,Je);const tt=[];for(let ot=0;ot<Ve.length;ot++){const et=Ve[ot];!et||(D._isCommand(et)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:et.title,command:this._commands.toInternal(et,Je)})):(Ue.only&&(et.kind?Ue.only.contains(et.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[Ge,ot],title:et.title,command:et.command&&this._commands.toInternal(et.command,Je),diagnostics:et.diagnostics&&et.diagnostics.map(y.Diagnostic.from),edit:et.edit&&y.WorkspaceEdit.from(et.edit),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,disabled:et.disabled?.reason})))}return{cacheId:Ge,actions:tt}}async resolveCodeAction(q,J){const[re,he]=q,ee=this._cache.get(re,he);if(!ee||D._isCommand(ee)||!this._provider.resolveCodeAction)return;const ae=await this._provider.resolveCodeAction(ee,J)??ee;return ae?.edit?y.WorkspaceEdit.from(ae.edit):void 0}releaseCodeActions(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}static _isCommand(q){return typeof q.command=="string"&&typeof q.title=="string"}}D._maxCodeActionsPerFile=1e3;class R{constructor(q,J){this._documents=q,this._provider=J}async provideDocumentFormattingEdits(q,J,re){const he=this._documents.getDocument(q),ee=await this._provider.provideDocumentFormattingEdits(he,J,re);if(Array.isArray(ee))return ee.map(y.TextEdit.from)}}class N{constructor(q,J){this._documents=q,this._provider=J}async provideDocumentRangeFormattingEdits(q,J,re,he){const ee=this._documents.getDocument(q),ae=y.Range.to(J),Se=await this._provider.provideDocumentRangeFormattingEdits(ee,ae,re,he);if(Array.isArray(Se))return Se.map(y.TextEdit.from)}}class B{constructor(q,J){this._documents=q,this._provider=J,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,J,re,he,ee){const ae=this._documents.getDocument(q),Se=y.Position.to(J),Ue=await this._provider.provideOnTypeFormattingEdits(ae,Se,re,he,ee);if(Array.isArray(Ue))return Ue.map(y.TextEdit.from)}}class F{constructor(q,J){this._provider=q,this._logService=J,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(q,J){const re=P.IdObject.mixin({symbols:[]}),he=await this._provider.provideWorkspaceSymbols(q,J);if((0,I.isNonEmptyArray)(he))for(const ee of he){if(!ee)continue;if(!ee.name){this._logService.warn("INVALID SymbolInformation, lacks name",ee);continue}const ae=P.IdObject.mixin(y.WorkspaceSymbol.from(ee));this._symbolCache.set(ae._id,ee),re.symbols.push(ae)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(q,J){if(typeof this._provider.resolveWorkspaceSymbol!="function")return q;const re=this._symbolCache.get(q._id);if(re){const he=await this._provider.resolveWorkspaceSymbol(re,J);return he&&(0,i.mixin)(q,y.WorkspaceSymbol.from(he),!0)}}releaseWorkspaceSymbols(q){const J=this._resultCache.get(q);if(J){for(let[re,he]=J;re<=he;re++)this._symbolCache.delete(re);this._resultCache.delete(q)}}}class O{constructor(q,J,re){this._documents=q,this._provider=J,this._logService=re}static supportsResolving(q){return typeof q.prepareRename=="function"}async provideRenameEdits(q,J,re,he){const ee=this._documents.getDocument(q),ae=y.Position.to(J);try{const Se=await this._provider.provideRenameEdits(ee,ae,re,he);return Se?y.WorkspaceEdit.from(Se):void 0}catch(Se){const Ue=O._asMessage(Se);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(Se)}}async resolveRenameLocation(q,J,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const he=this._documents.getDocument(q),ee=y.Position.to(J);try{const ae=await this._provider.prepareRename(he,ee,re);let Se,Ue;if(C.Range.isRange(ae)?(Se=ae,Ue=he.getText(ae)):(0,L.isObject)(ae)&&(Se=ae.range,Ue=ae.placeholder),!Se||!Ue)return;if(Se.start.line>ee.line||Se.end.line<ee.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(Se),text:Ue}}catch(ae){const Se=O._asMessage(ae);return Se?{rejectReason:Se,range:void 0,text:void 0}:Promise.reject(ae)}}static _asMessage(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class z{constructor(q,J){this.resultId=q,this.tokens=J}}class W{constructor(q,J){this._documents=q,this._provider=J,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(q,J,re){const he=this._documents.getDocument(q),ee=J!==0?this._previousResults.get(J):null;let ae=typeof ee?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(he,ee.resultId,re):await this._provider.provideDocumentSemanticTokens(he,re);return ee&&this._previousResults.delete(J),ae?(ae=W._fixProvidedSemanticTokens(ae),this._send(W._convertToEdits(ee,ae),ae)):null}async releaseDocumentSemanticColoring(q){this._previousResults.delete(q)}static _fixProvidedSemanticTokens(q){return W._isSemanticTokens(q)?W._isCorrectSemanticTokens(q)?q:new C.SemanticTokens(new Uint32Array(q.data),q.resultId):W._isSemanticTokensEdits(q)?W._isCorrectSemanticTokensEdits(q)?q:new C.SemanticTokensEdits(q.edits.map(J=>new C.SemanticTokensEdit(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),q.resultId):q}static _isSemanticTokens(q){return q&&!!q.data}static _isCorrectSemanticTokens(q){return q.data instanceof Uint32Array}static _isSemanticTokensEdits(q){return q&&Array.isArray(q.edits)}static _isCorrectSemanticTokensEdits(q){for(const J of q.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(q,J){if(!W._isSemanticTokens(J)||!q||!q.tokens)return J;const re=q.tokens,he=re.length,ee=J.data,ae=ee.length;let Se=0;const Ue=Math.min(he,ae);for(;Se<Ue&&re[Se]===ee[Se];)Se++;if(Se===he&&Se===ae)return new C.SemanticTokensEdits([],J.resultId);let Ve=0;const Ge=Ue-Se;for(;Ve<Ge&&re[he-Ve-1]===ee[ae-Ve-1];)Ve++;return new C.SemanticTokensEdits([{start:Se,deleteCount:he-Se-Ve,data:ee.subarray(Se,ae-Ve)}],J.resultId)}_send(q,J){if(W._isSemanticTokens(q)){const re=this._nextResultId++;return this._previousResults.set(re,new z(q.resultId,q.data)),(0,E.encodeSemanticTokensDto)({id:re,type:"full",data:q.data})}if(W._isSemanticTokensEdits(q)){const re=this._nextResultId++;return W._isSemanticTokens(J)?this._previousResults.set(re,new z(J.resultId,J.data)):this._previousResults.set(re,new z(q.resultId)),(0,E.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(q.edits||[]).map(he=>({start:he.start,deleteCount:he.deleteCount,data:he.data}))})}return null}}e.DocumentSemanticTokensAdapter=W;class M{constructor(q,J){this._documents=q,this._provider=J}async provideDocumentRangeSemanticTokens(q,J,re){const he=this._documents.getDocument(q),ee=await this._provider.provideDocumentRangeSemanticTokens(he,y.Range.to(J),re);return ee?this._send(ee):null}_send(q){return(0,E.encodeSemanticTokensDto)({id:0,type:"full",data:q.data})}}e.DocumentRangeSemanticTokensAdapter=M;class x{constructor(q,J,re,he,ee){this._documents=q,this._commands=J,this._provider=re,this._apiDeprecation=he,this._extension=ee,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}async provideCompletionItems(q,J,re,he){const ee=this._documents.getDocument(q),ae=y.Position.to(J),Se=ee.getWordRangeAtPosition(ae)||new C.Range(ae,ae),Ue=Se.with({end:ae}),Ve=new v.StopWatch(!0),Ge=await this._provider.provideCompletionItems(ee,ae,he,y.CompletionContext.to(re));if(!Ge||he.isCancellationRequested)return;const Je=Array.isArray(Ge)?new C.CompletionList(Ge):Ge,tt=x.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),ot=new l.DisposableStore;this._disposables.set(tt,ot);const et=[],it={x:tt,b:et,a:{replace:y.Range.from(Se),insert:y.Range.from(Ue)},c:Je.isIncomplete||void 0,d:Ve.elapsed()};for(let ct=0;ct<Je.items.length;ct++){const pt=Je.items[ct],Pt=this._convertCompletionItem(pt,[tt,ct],Ue,Se);et.push(Pt)}return it}async resolveCompletionItem(q,J){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...q);if(!re)return;const he=await this._provider.resolveCompletionItem(re,J);if(!!he)return this._convertCompletionItem(he,q)}releaseCompletionItems(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}_convertCompletionItem(q,J,re,he){const ee=this._disposables.get(J[0]);if(!ee)throw Error("DisposableStore is missing...");const ae={x:J,a:q.label,b:q.kind!==void 0?y.CompletionItemKind.from(q.kind):void 0,n:q.tags&&q.tags.map(y.CompletionItemTag.from),c:q.detail,d:typeof q.documentation=="undefined"?void 0:y.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters,l:q.additionalTextEdits&&q.additionalTextEdits.map(y.TextEdit.from),m:this._commands.toInternal(q.command,ee)};q.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=q.textEdit.newText):typeof q.insertText=="string"?ae.h=q.insertText:q.insertText instanceof C.SnippetString&&(ae.h=q.insertText.value,ae.i|=4);let Se;return q.textEdit?Se=q.textEdit.range:q.range&&(Se=q.range),C.Range.isRange(Se)?ae.j=y.Range.from(Se):Se&&(!re?.isEqual(Se.inserting)||!he?.isEqual(Se.replacing))&&(ae.j={insert:y.Range.from(Se.inserting),replace:y.Range.from(Se.replacing)}),ae}}class V{constructor(q,J,re){this._documents=q,this._provider=J,this._commands=re,this._cache=new p.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(q,J,re,he){const ee=this._documents.getDocument(q),ae=y.Position.to(J),Se=await this._provider.provideInlineCompletionItems(ee,ae,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:y.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text,isSnippetText:re.selectedSuggestionInfo.isSnippetText,completionKind:y.CompletionItemKind.to(re.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:re.triggerKind},he);if(!Se||he.isCancellationRequested)return;const Ue=(0,L.isArray)(Se)?{items:Se}:Se,Ve=this._cache.add(Ue.items);let Ge;return{pid:Ve,items:Ue.items.map((Je,tt)=>{let ot;return Je.command&&(Ge||(Ge=new l.DisposableStore,this._disposables.set(Ve,Ge)),ot=this._commands.toInternal(Je.command,Ge)),{text:Je.text,range:Je.range?y.Range.from(Je.range):void 0,command:ot,idx:tt}})}}disposeCompletions(q){this._cache.delete(q);const J=this._disposables.get(q);J&&J.clear(),this._disposables.delete(q)}handleDidShowCompletionItem(q,J){const re=this._cache.get(q,J);re&&U.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class U{constructor(){this._onDidShowCompletionItemEmitter=new w.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(q){let J=U.map.get(q);return J||(J=new U,U.map.set(q,J)),J}fireOnDidShowCompletionItem(q){this._onDidShowCompletionItemEmitter.fire(q)}}e.InlineCompletionController=U,U.map=new WeakMap;class H{constructor(q,J){this._documents=q,this._provider=J,this._cache=new p.Cache("SignatureHelp")}async provideSignatureHelp(q,J,re,he){const ee=this._documents.getDocument(q),ae=y.Position.to(J),Se=this.reviveContext(re),Ue=await this._provider.provideSignatureHelp(ee,ae,he,Se);if(Ue){const Ve=this._cache.add([Ue]);return{...y.SignatureHelp.from(Ue),id:Ve}}}reviveContext(q){let J;if(q.activeSignatureHelp){const re=y.SignatureHelp.to(q.activeSignatureHelp),he=this._cache.get(q.activeSignatureHelp.id,0);he?(J=he,J.activeSignature=re.activeSignature,J.activeParameter=re.activeParameter):J=re}return{...q,activeSignatureHelp:J}}releaseSignatureHelp(q){this._cache.delete(q)}}class X{constructor(q,J){this._documents=q,this._provider=J}async provideInlayHints(q,J,re){const he=this._documents.getDocument(q),ee=await this._provider.provideInlayHints(he,y.Range.to(J),re);return ee?{hints:ee.map(y.InlayHint.from)}:void 0}}class se{constructor(q,J){this._documents=q,this._provider=J,this._cache=new p.Cache("DocumentLink")}async provideLinks(q,J){const re=this._documents.getDocument(q),he=await this._provider.provideDocumentLinks(re,J);if(!(!Array.isArray(he)||he.length===0)&&!J.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:he.filter(se._validateLink).map(y.DocumentLink.from)};{const ee=this._cache.add(he),ae={links:[],id:ee};for(let Se=0;Se<he.length;Se++){if(!se._validateLink(he[Se]))continue;const Ue=y.DocumentLink.from(he[Se]);Ue.cacheId=[ee,Se],ae.links.push(Ue)}return ae}}}static _validateLink(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,J){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...q);if(!re)return;const he=await this._provider.resolveDocumentLink(re,J);if(!(!he||!se._validateLink(he)))return y.DocumentLink.from(he)}releaseLinks(q){this._cache.delete(q)}}class K{constructor(q,J){this._documents=q,this._provider=J}async provideColors(q,J){const re=this._documents.getDocument(q),he=await this._provider.provideDocumentColors(re,J);return Array.isArray(he)?he.map(ae=>({color:y.Color.from(ae.color),range:y.Range.from(ae.range)})):[]}async provideColorPresentations(q,J,re){const he=this._documents.getDocument(q),ee=y.Range.to(J.range),ae=y.Color.to(J.color),Se=await this._provider.provideColorPresentations(ae,{document:he,range:ee},re);if(!!Array.isArray(Se))return Se.map(y.ColorPresentation.from)}}class j{constructor(q,J){this._documents=q,this._provider=J}async provideFoldingRanges(q,J,re){const he=this._documents.getDocument(q),ee=await this._provider.provideFoldingRanges(he,J,re);if(!!Array.isArray(ee))return ee.map(y.FoldingRange.from)}}class ie{constructor(q,J,re){this._documents=q,this._provider=J,this._logService=re}async provideSelectionRanges(q,J,re){const he=this._documents.getDocument(q),ee=J.map(y.Position.to),ae=await this._provider.provideSelectionRanges(he,ee,re);if(!(0,I.isNonEmptyArray)(ae))return[];if(ae.length!==ee.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Se=[];for(let Ue=0;Ue<ee.length;Ue++){const Ve=[];Se.push(Ve);let Ge=ee[Ue],Je=ae[Ue];for(;;){if(!Je.range.contains(Ge))throw new Error("INVALID selection range, must contain the previous range");if(Ve.push(y.SelectionRange.from(Je)),!Je.parent)break;Ge=Je.range,Je=Je.parent}}return Se}}class ce{constructor(q,J){this._documents=q,this._provider=J,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(q,J,re){const he=this._documents.getDocument(q),ee=y.Position.to(J),ae=await this._provider.prepareCallHierarchy(he,ee,re);if(!ae)return;const Se=this._idPool.nextId();return this._cache.set(Se,new Map),Array.isArray(ae)?ae.map(Ue=>this._cacheAndConvertItem(Se,Ue)):[this._cacheAndConvertItem(Se,ae)]}async provideCallsTo(q,J,re){const he=this._itemFromCache(q,J);if(!he)throw new Error("missing call hierarchy item");const ee=await this._provider.provideCallHierarchyIncomingCalls(he,re);if(!!ee)return ee.map(ae=>({from:this._cacheAndConvertItem(q,ae.from),fromRanges:ae.fromRanges.map(Se=>y.Range.from(Se))}))}async provideCallsFrom(q,J,re){const he=this._itemFromCache(q,J);if(!he)throw new Error("missing call hierarchy item");const ee=await this._provider.provideCallHierarchyOutgoingCalls(he,re);if(!!ee)return ee.map(ae=>({to:this._cacheAndConvertItem(q,ae.to),fromRanges:ae.fromRanges.map(Se=>y.Range.from(Se))}))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,J){const re=this._cache.get(q),he=y.CallHierarchyItem.from(J,q,re.size.toString(36));return re.set(he._itemId,J),he}_itemFromCache(q,J){return this._cache.get(q)?.get(J)}}class ge{constructor(q,J){this._documents=q,this._provider=J,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(q,J,re){const he=this._documents.getDocument(q),ee=y.Position.to(J),ae=await this._provider.prepareTypeHierarchy(he,ee,re);if(!ae)return;const Se=this._idPool.nextId();return this._cache.set(Se,new Map),Array.isArray(ae)?ae.map(Ue=>this._cacheAndConvertItem(Se,Ue)):[this._cacheAndConvertItem(Se,ae)]}async provideSupertypes(q,J,re){const he=this._itemFromCache(q,J);if(!he)throw new Error("missing type hierarchy item");const ee=await this._provider.provideTypeHierarchySupertypes(he,re);if(!!ee)return ee.map(ae=>this._cacheAndConvertItem(q,ae))}async provideSubtypes(q,J,re){const he=this._itemFromCache(q,J);if(!he)throw new Error("missing type hierarchy item");const ee=await this._provider.provideTypeHierarchySubtypes(he,re);if(!!ee)return ee.map(ae=>this._cacheAndConvertItem(q,ae))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,J){const re=this._cache.get(q),he=y.TypeHierarchyItem.from(J,q,re.size.toString(36));return re.set(he._itemId,J),he}_itemFromCache(q,J){return this._cache.get(q)?.get(J)}}class ke{constructor(q,J){this.adapter=q,this.extension=J}}class Le{constructor(q,J,re,he,ee,ae,Se){this._adapter=new Map,this._uriTransformer=J,this._proxy=q.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=he,this._diagnostics=ee,this._logService=ae,this._apiDeprecation=Se}_transformDocumentSelector(q){return y.DocumentSelector.from(q,this._uriTransformer)}_createDisposable(q){return new C.Disposable(()=>{this._adapter.delete(q),this._proxy.$unregister(q)})}_nextHandle(){return Le._handlePool++}_withAdapter(q,J,re,he,ee=!1){const ae=this._adapter.get(q);if(!ae)return Promise.resolve(he);if(ae.adapter instanceof J){let Se;ae.extension&&(Se=Date.now(),this._logService.trace(`[${ae.extension.identifier.value}] INVOKE provider '${J.name}'`));const Ue=re(ae.adapter,ae.extension),Ve=ae.extension;return Ve&&Promise.resolve(Ue).then(()=>this._logService.trace(`[${Ve.identifier.value}] provider DONE after ${Date.now()-Se}ms`),Ge=>{ee&&Ge instanceof A.CancellationError||(this._logService.error(`[${Ve.identifier.value}] provider FAILED`),this._logService.error(Ge))}),Ue}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(q,J){const re=this._nextHandle();return this._adapter.set(re,new ke(q,J)),re}static _extLabel(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,J,re,he){const ee=this._addNewAdapter(new s(this._documents,re),q),ae=he&&he.label||Le._extLabel(q);return this._proxy.$registerDocumentSymbolProvider(ee,this._transformDocumentSelector(J),ae),this._createDisposable(ee)}$provideDocumentSymbols(q,J,re){return this._withAdapter(q,s,he=>he.provideDocumentSymbols(m.URI.revive(J),re),void 0)}registerCodeLensProvider(q,J,re){const he=this._nextHandle(),ee=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(he,new ke(new o(this._documents,this._commands.converter,re),q)),this._proxy.$registerCodeLensSupport(he,this._transformDocumentSelector(J),ee);let ae=this._createDisposable(he);if(ee!==void 0){const Se=re.onDidChangeCodeLenses(Ue=>this._proxy.$emitCodeLensEvent(ee));ae=C.Disposable.from(ae,Se)}return ae}$provideCodeLenses(q,J,re){return this._withAdapter(q,o,he=>he.provideCodeLenses(m.URI.revive(J),re),void 0)}$resolveCodeLens(q,J,re){return this._withAdapter(q,o,he=>he.resolveCodeLens(J,re),void 0)}$releaseCodeLenses(q,J){this._withAdapter(q,o,re=>Promise.resolve(re.releaseCodeLenses(J)),void 0)}registerDefinitionProvider(q,J,re){const he=this._addNewAdapter(new c(this._documents,re),q);return this._proxy.$registerDefinitionSupport(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideDefinition(q,J,re,he){return this._withAdapter(q,c,ee=>ee.provideDefinition(m.URI.revive(J),re,he),[])}registerDeclarationProvider(q,J,re){const he=this._addNewAdapter(new S(this._documents,re),q);return this._proxy.$registerDeclarationSupport(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideDeclaration(q,J,re,he){return this._withAdapter(q,S,ee=>ee.provideDeclaration(m.URI.revive(J),re,he),[])}registerImplementationProvider(q,J,re){const he=this._addNewAdapter(new r(this._documents,re),q);return this._proxy.$registerImplementationSupport(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideImplementation(q,J,re,he){return this._withAdapter(q,r,ee=>ee.provideImplementation(m.URI.revive(J),re,he),[])}registerTypeDefinitionProvider(q,J,re){const he=this._addNewAdapter(new t(this._documents,re),q);return this._proxy.$registerTypeDefinitionSupport(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideTypeDefinition(q,J,re,he){return this._withAdapter(q,t,ee=>ee.provideTypeDefinition(m.URI.revive(J),re,he),[])}registerHoverProvider(q,J,re,he){const ee=this._addNewAdapter(new n(this._documents,re),q);return this._proxy.$registerHoverProvider(ee,this._transformDocumentSelector(J)),this._createDisposable(ee)}$provideHover(q,J,re,he){return this._withAdapter(q,n,ee=>ee.provideHover(m.URI.revive(J),re,he),void 0)}registerEvaluatableExpressionProvider(q,J,re,he){const ee=this._addNewAdapter(new u(this._documents,re),q);return this._proxy.$registerEvaluatableExpressionProvider(ee,this._transformDocumentSelector(J)),this._createDisposable(ee)}$provideEvaluatableExpression(q,J,re,he){return this._withAdapter(q,u,ee=>ee.provideEvaluatableExpression(m.URI.revive(J),re,he),void 0)}registerInlineValuesProvider(q,J,re,he){const ee=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new a(this._documents,re),q);this._proxy.$registerInlineValuesProvider(ae,this._transformDocumentSelector(J),ee);let Se=this._createDisposable(ae);if(ee!==void 0){const Ue=re.onDidChangeInlineValues(Ve=>this._proxy.$emitInlineValuesEvent(ee));Se=C.Disposable.from(Se,Ue)}return Se}$provideInlineValues(q,J,re,he,ee){return this._withAdapter(q,a,ae=>ae.provideInlineValues(m.URI.revive(J),re,he,ee),void 0)}registerDocumentHighlightProvider(q,J,re){const he=this._addNewAdapter(new f(this._documents,re),q);return this._proxy.$registerDocumentHighlightProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideDocumentHighlights(q,J,re,he){return this._withAdapter(q,f,ee=>ee.provideDocumentHighlights(m.URI.revive(J),re,he),void 0)}registerLinkedEditingRangeProvider(q,J,re){const he=this._addNewAdapter(new b(this._documents,re),q);return this._proxy.$registerLinkedEditingRangeProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideLinkedEditingRanges(q,J,re,he){return this._withAdapter(q,b,async ee=>{const ae=await ee.provideLinkedEditingRanges(m.URI.revive(J),re,he);if(ae)return{ranges:ae.ranges,wordPattern:ae.wordPattern?Le._serializeRegExp(ae.wordPattern):void 0}},void 0)}registerReferenceProvider(q,J,re){const he=this._addNewAdapter(new d(this._documents,re),q);return this._proxy.$registerReferenceSupport(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideReferences(q,J,re,he,ee){return this._withAdapter(q,d,ae=>ae.provideReferences(m.URI.revive(J),re,he,ee),void 0)}registerCodeActionProvider(q,J,re,he){const ee=new l.DisposableStore,ae=this._addNewAdapter(new D(this._documents,this._commands.converter,this._diagnostics,re,this._logService,q,this._apiDeprecation),q);return this._proxy.$registerQuickFixSupport(ae,this._transformDocumentSelector(J),{providedKinds:he?.providedCodeActionKinds?.map(Se=>Se.value),documentation:he?.documentation?.map(Se=>({kind:Se.kind.value,command:this._commands.converter.toInternal(Se.command,ee)}))},Le._extLabel(q),Boolean(re.resolveCodeAction)),ee.add(this._createDisposable(ae)),ee}$provideCodeActions(q,J,re,he,ee){return this._withAdapter(q,D,ae=>ae.provideCodeActions(m.URI.revive(J),re,he,ee),void 0)}$resolveCodeAction(q,J,re){return this._withAdapter(q,D,he=>he.resolveCodeAction(J,re),void 0)}$releaseCodeActions(q,J){this._withAdapter(q,D,re=>Promise.resolve(re.releaseCodeActions(J)),void 0)}registerDocumentFormattingEditProvider(q,J,re){const he=this._addNewAdapter(new R(this._documents,re),q);return this._proxy.$registerDocumentFormattingSupport(he,this._transformDocumentSelector(J),q.identifier,q.displayName||q.name),this._createDisposable(he)}$provideDocumentFormattingEdits(q,J,re,he){return this._withAdapter(q,R,ee=>ee.provideDocumentFormattingEdits(m.URI.revive(J),re,he),void 0)}registerDocumentRangeFormattingEditProvider(q,J,re){const he=this._addNewAdapter(new N(this._documents,re),q);return this._proxy.$registerRangeFormattingSupport(he,this._transformDocumentSelector(J),q.identifier,q.displayName||q.name),this._createDisposable(he)}$provideDocumentRangeFormattingEdits(q,J,re,he,ee){return this._withAdapter(q,N,ae=>ae.provideDocumentRangeFormattingEdits(m.URI.revive(J),re,he,ee),void 0)}registerOnTypeFormattingEditProvider(q,J,re,he){const ee=this._addNewAdapter(new B(this._documents,re),q);return this._proxy.$registerOnTypeFormattingSupport(ee,this._transformDocumentSelector(J),he,q.identifier),this._createDisposable(ee)}$provideOnTypeFormattingEdits(q,J,re,he,ee,ae){return this._withAdapter(q,B,Se=>Se.provideOnTypeFormattingEdits(m.URI.revive(J),re,he,ee,ae),void 0)}registerWorkspaceSymbolProvider(q,J){const re=this._addNewAdapter(new F(J,this._logService),q);return this._proxy.$registerNavigateTypeSupport(re,typeof J.resolveWorkspaceSymbol=="function"),this._createDisposable(re)}$provideWorkspaceSymbols(q,J,re){return this._withAdapter(q,F,he=>he.provideWorkspaceSymbols(J,re),{symbols:[]})}$resolveWorkspaceSymbol(q,J,re){return this._withAdapter(q,F,he=>he.resolveWorkspaceSymbol(J,re),void 0)}$releaseWorkspaceSymbols(q,J){this._withAdapter(q,F,re=>re.releaseWorkspaceSymbols(J),void 0)}registerRenameProvider(q,J,re){const he=this._addNewAdapter(new O(this._documents,re,this._logService),q);return this._proxy.$registerRenameSupport(he,this._transformDocumentSelector(J),O.supportsResolving(re)),this._createDisposable(he)}$provideRenameEdits(q,J,re,he,ee){return this._withAdapter(q,O,ae=>ae.provideRenameEdits(m.URI.revive(J),re,he,ee),void 0)}$resolveRenameLocation(q,J,re,he){return this._withAdapter(q,O,ee=>ee.resolveRenameLocation(m.URI.revive(J),re,he),void 0)}registerDocumentSemanticTokensProvider(q,J,re,he){const ee=this._nextHandle(),ae=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(ee,new ke(new W(this._documents,re),q)),this._proxy.$registerDocumentSemanticTokensProvider(ee,this._transformDocumentSelector(J),he,ae);let Se=this._createDisposable(ee);if(ae){const Ue=re.onDidChangeSemanticTokens(Ve=>this._proxy.$emitDocumentSemanticTokensEvent(ae));Se=C.Disposable.from(Se,Ue)}return Se}$provideDocumentSemanticTokens(q,J,re,he){return this._withAdapter(q,W,ee=>ee.provideDocumentSemanticTokens(m.URI.revive(J),re,he),null,!0)}$releaseDocumentSemanticTokens(q,J){this._withAdapter(q,W,re=>re.releaseDocumentSemanticColoring(J),void 0)}registerDocumentRangeSemanticTokensProvider(q,J,re,he){const ee=this._addNewAdapter(new M(this._documents,re),q);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ee,this._transformDocumentSelector(J),he),this._createDisposable(ee)}$provideDocumentRangeSemanticTokens(q,J,re,he){return this._withAdapter(q,M,ee=>ee.provideDocumentRangeSemanticTokens(m.URI.revive(J),re,he),null,!0)}registerCompletionItemProvider(q,J,re,he){const ee=this._addNewAdapter(new x(this._documents,this._commands.converter,re,this._apiDeprecation,q),q);return this._proxy.$registerSuggestSupport(ee,this._transformDocumentSelector(J),he,x.supportsResolving(re),`${q.identifier.value}(${he.join("")})`),this._createDisposable(ee)}$provideCompletionItems(q,J,re,he,ee){return this._withAdapter(q,x,ae=>ae.provideCompletionItems(m.URI.revive(J),re,he,ee),void 0)}$resolveCompletionItem(q,J,re){return this._withAdapter(q,x,he=>he.resolveCompletionItem(J,re),void 0)}$releaseCompletionItems(q,J){this._withAdapter(q,x,re=>re.releaseCompletionItems(J),void 0)}registerInlineCompletionsProvider(q,J,re){const he=this._addNewAdapter(new V(this._documents,re,this._commands.converter),q);return this._proxy.$registerInlineCompletionsSupport(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideInlineCompletions(q,J,re,he,ee){return this._withAdapter(q,V,ae=>ae.provideInlineCompletions(m.URI.revive(J),re,he,ee),void 0)}$handleInlineCompletionDidShow(q,J,re){this._withAdapter(q,V,async he=>{he.handleDidShowCompletionItem(J,re)},void 0)}$freeInlineCompletionsList(q,J){this._withAdapter(q,V,async re=>{re.disposeCompletions(J)},void 0)}registerSignatureHelpProvider(q,J,re,he){const ee=Array.isArray(he)?{triggerCharacters:he,retriggerCharacters:[]}:he,ae=this._addNewAdapter(new H(this._documents,re),q);return this._proxy.$registerSignatureHelpProvider(ae,this._transformDocumentSelector(J),ee),this._createDisposable(ae)}$provideSignatureHelp(q,J,re,he,ee){return this._withAdapter(q,H,ae=>ae.provideSignatureHelp(m.URI.revive(J),re,he,ee),void 0)}$releaseSignatureHelp(q,J){this._withAdapter(q,H,re=>re.releaseSignatureHelp(J),void 0)}registerInlayHintsProvider(q,J,re){const he=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ee=this._addNewAdapter(new X(this._documents,re),q);this._proxy.$registerInlayHintsProvider(ee,this._transformDocumentSelector(J),he);let ae=this._createDisposable(ee);if(he!==void 0){const Se=re.onDidChangeInlayHints(Ue=>this._proxy.$emitInlayHintsEvent(he));ae=C.Disposable.from(ae,Se)}return ae}$provideInlayHints(q,J,re,he){return this._withAdapter(q,X,ee=>ee.provideInlayHints(m.URI.revive(J),re,he),void 0)}registerDocumentLinkProvider(q,J,re){const he=this._addNewAdapter(new se(this._documents,re),q);return this._proxy.$registerDocumentLinkProvider(he,this._transformDocumentSelector(J),typeof re.resolveDocumentLink=="function"),this._createDisposable(he)}$provideDocumentLinks(q,J,re){return this._withAdapter(q,se,he=>he.provideLinks(m.URI.revive(J),re),void 0)}$resolveDocumentLink(q,J,re){return this._withAdapter(q,se,he=>he.resolveLink(J,re),void 0)}$releaseDocumentLinks(q,J){this._withAdapter(q,se,re=>re.releaseLinks(J),void 0)}registerColorProvider(q,J,re){const he=this._addNewAdapter(new K(this._documents,re),q);return this._proxy.$registerDocumentColorProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideDocumentColors(q,J,re){return this._withAdapter(q,K,he=>he.provideColors(m.URI.revive(J),re),[])}$provideColorPresentations(q,J,re,he){return this._withAdapter(q,K,ee=>ee.provideColorPresentations(m.URI.revive(J),re,he),void 0)}registerFoldingRangeProvider(q,J,re){const he=this._nextHandle(),ee=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(he,new ke(new j(this._documents,re),q)),this._proxy.$registerFoldingRangeProvider(he,this._transformDocumentSelector(J),ee);let ae=this._createDisposable(he);if(ee!==void 0){const Se=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ee));ae=C.Disposable.from(ae,Se)}return ae}$provideFoldingRanges(q,J,re,he){return this._withAdapter(q,j,ee=>ee.provideFoldingRanges(m.URI.revive(J),re,he),void 0)}registerSelectionRangeProvider(q,J,re){const he=this._addNewAdapter(new ie(this._documents,re,this._logService),q);return this._proxy.$registerSelectionRangeProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideSelectionRanges(q,J,re,he){return this._withAdapter(q,ie,ee=>ee.provideSelectionRanges(m.URI.revive(J),re,he),[])}registerCallHierarchyProvider(q,J,re){const he=this._addNewAdapter(new ce(this._documents,re),q);return this._proxy.$registerCallHierarchyProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$prepareCallHierarchy(q,J,re,he){return this._withAdapter(q,ce,ee=>Promise.resolve(ee.prepareSession(m.URI.revive(J),re,he)),void 0)}$provideCallHierarchyIncomingCalls(q,J,re,he){return this._withAdapter(q,ce,ee=>ee.provideCallsTo(J,re,he),void 0)}$provideCallHierarchyOutgoingCalls(q,J,re,he){return this._withAdapter(q,ce,ee=>ee.provideCallsFrom(J,re,he),void 0)}$releaseCallHierarchy(q,J){this._withAdapter(q,ce,re=>Promise.resolve(re.releaseSession(J)),void 0)}registerTypeHierarchyProvider(q,J,re){const he=this._addNewAdapter(new ge(this._documents,re),q);return this._proxy.$registerTypeHierarchyProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$prepareTypeHierarchy(q,J,re,he){return this._withAdapter(q,ge,ee=>Promise.resolve(ee.prepareSession(m.URI.revive(J),re,he)),void 0)}$provideTypeHierarchySupertypes(q,J,re,he){return this._withAdapter(q,ge,ee=>ee.provideSupertypes(J,re,he),void 0)}$provideTypeHierarchySubtypes(q,J,re,he){return this._withAdapter(q,ge,ee=>ee.provideSubtypes(J,re,he),void 0)}$releaseTypeHierarchy(q,J){this._withAdapter(q,ge,re=>Promise.resolve(re.releaseSession(J)),void 0)}static _serializeRegExp(q){return{pattern:q.source,flags:(0,k.regExpFlags)(q)}}static _serializeIndentationRule(q){return{decreaseIndentPattern:Le._serializeRegExp(q.decreaseIndentPattern),increaseIndentPattern:Le._serializeRegExp(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Le._serializeRegExp(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Le._serializeRegExp(q.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(q){return{beforeText:Le._serializeRegExp(q.beforeText),afterText:q.afterText?Le._serializeRegExp(q.afterText):void 0,previousLineText:q.previousLineText?Le._serializeRegExp(q.previousLineText):void 0,action:q.action}}static _serializeOnEnterRules(q){return q.map(Le._serializeOnEnterRule)}setLanguageConfiguration(q,J,re){let{wordPattern:he}=re;if(he&&(0,k.regExpLeadsToEndlessLoop)(he))throw new Error(`Invalid language configuration: wordPattern '${he}' is not allowed to match the empty string.`);he?this._documents.setWordDefinitionFor(J,he):this._documents.setWordDefinitionFor(J,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const ee=this._nextHandle(),ae={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?Le._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?Le._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?Le._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ee,J,ae),this._createDisposable(ee)}$setWordDefinitions(q){for(const J of q)this._documents.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.ExtHostLanguageFeatures=Le,Le._handlePool=0}),define(we[241],be([0,1,5,17,7,48,18,6]),function(Y,e,m,i,y,C,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(L,T,l,E){this._documents=T,this._commands=l,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(m.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,T){await this._proxy.$changeLanguage(L,T);const l=this._documents.getDocumentData(L);if(!l)throw new Error(`document '${L.toString}' NOT found`);return l.document}async tokenAtPosition(L,T){const l=L.version,E=i.Position.from(T),h=await this._proxy.$tokensAtPosition(L.uri,E),p={type:y.StandardTokenType.Other,range:L.getWordRangeAtPosition(T)??new y.Range(T.line,T.character,T.line,T.character)};if(!h)return p;const v={range:i.Range.to(h.range),type:i.TokenType.to(h.type)};return!v.range.contains(T)||l!==L.version?p:v}createLanguageStatusItem(L,T,l){const E=this._handlePool++,h=this._proxy,p=this._ids,v=`${L.identifier.value}/${T}`;if(p.has(v))throw new Error(`LanguageStatusItem with id '${T}' ALREADY exists`);p.add(v);const A={selector:l,id:T,name:L.displayName??L.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let w,s=new k.DisposableStore;const o=()=>{w?.dispose(),w=(0,P.disposableTimeout)(()=>{s.clear(),this._proxy.$setLanguageStatus(E,{id:v,name:A.name??L.displayName??L.name,source:L.displayName??L.name,selector:i.DocumentSelector.from(A.selector,this._uriTransformer),label:A.text,detail:A.detail??"",severity:A.severity===y.LanguageStatusSeverity.Error?C.default.Error:A.severity===y.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info,command:A.command&&this._commands.toInternal(A.command,s),accessibilityInfo:A.accessibilityInformation,busy:A.busy})},0)},g={dispose(){s.dispose(),w?.dispose(),h.$removeLanguageStatus(E),p.delete(v)},get id(){return A.id},get name(){return A.name},set name(c){A.name=c,o()},get selector(){return A.selector},set selector(c){A.selector=c,o()},get text(){return A.text},set text(c){A.text=c,o()},get detail(){return A.detail},set detail(c){A.detail=c,o()},get severity(){return A.severity},set severity(c){A.severity=c,o()},get accessibilityInformation(){return A.accessibilityInformation},set accessibilityInformation(c){A.accessibilityInformation=c,o()},get command(){return A.command},set command(c){A.command=c,o()},get busy(){return A.busy},set busy(c){A.busy=c,o()}};return o(),g}}e.ExtHostLanguages=_}),define(we[131],be([0,1,11,5,26,14,3]),function(Y,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends m.AbstractLoggerService{constructor(L,T){const l=new P.Emitter;super(T.logLevel,l.event);this._proxy=L.getProxy(i.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(l)}$setLevel(L){this._onDidChangeLogLevel.fire(L)}doCreateLogger(L,T,l){return new _(this._proxy,L,T,l)}};k=je([ze(0,C.IExtHostRpcService),ze(1,y.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class _ extends m.AbstractMessageLogger{constructor(L,T,l,E){super(E?.always);this.proxy=L,this.file=T,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(l),this.proxy.$createLogger(T,E).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(L,T){const l=[[L,T]];this.isLoggerCreated?this.doLog(l):this.buffer.push(...l)}doLog(L){this.proxy.$log(this.file,L)}}}),define(we[242],be([0,1,5,11,29]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(k){return k&&k.title}let P=class{constructor(_,I){this._logService=I,this._proxy=_.getProxy(m.MainContext.MainThreadMessageService)}showMessage(_,I,L,T,l){const E={extension:_};let h;typeof T=="string"||C(T)?h=[T,...l]:(E.modal=T?.modal,E.useCustom=T?.useCustom,E.detail=T?.detail,h=l),E.useCustom&&(0,y.checkProposedApiEnabled)(_,"resolvers");const p=[];for(let v=0;v<h.length;v++){const A=h[v];if(typeof A=="string")p.push({title:A,handle:v,isCloseAffordance:!1});else if(typeof A=="object"){let{title:w,isCloseAffordance:s}=A;p.push({title:w,isCloseAffordance:!!s,handle:v})}else this._logService.warn("Invalid message item:",A)}return this._proxy.$showMessage(I,L,E,p).then(v=>{if(typeof v=="number")return h[v]})}};P=je([ze(1,i.ILogService)],P),e.ExtHostMessageService=P}),define(we[243],be([0,1,22,3,47,6,24,8,13,2,87,5,17,7,53,218,128]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class A{constructor(s,o,g,c,S){this._textDocumentsAndEditors=g,this._textDocuments=c,this._extensionStoragePaths=S,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new P.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new i.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new i.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new i.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new i.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new i.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new i.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new i.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new i.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new L.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(T.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(T.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(T.MainContext.MainThreadNotebookEditors),this._commandsConverter=o.converter,o.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const t=r.notebookEditor?.notebookUri,n=r.cell.handle,a=this._documents.get(t)?.getCell(n);if(a)return a.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){const o=this._editors.get(s);if(!o)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);return o}getIdByEditor(s){for(const[o,g]of this._editors)if(g.apiEditor===s)return o}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(s,o){const g=this._documents.get(s);if(!g&&!o)throw new Error(`NO notebook document for '${s}'`);return g}_getProviderData(s){const o=this._notebookContentProviders.get(s);if(!o)throw new Error(`NO provider for '${s}'`);return o}registerNotebookContentProvider(s,o,g,c,S){if((0,k.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(o))throw new Error(`Notebook provider for '${o}' already registered`);this._notebookContentProviders.set(o,{extension:s,provider:g});let r;return g.onDidChangeNotebookContentOptions&&(r=g.onDidChangeNotebookContentOptions(()=>{const t=l.NotebookDocumentContentOptions.from(g.options);this._notebookProxy.$updateNotebookProviderOptions(o,t)})),this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation},o,l.NotebookDocumentContentOptions.from(c),A._convertNotebookRegistrationData(s,S)),new E.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(o),this._notebookProxy.$unregisterNotebookProvider(o)})}static _convertNotebookRegistrationData(s,o){if(!o)return;const g=o.filenamePattern.map(c=>l.NotebookExclusiveDocumentPattern.from(c)).filter(c=>c!==void 0);if(o.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:o.displayName,filenamePattern:g,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,o,g){const c=A._notebookStatusBarItemProviderHandlePool++,S=typeof g.onDidChangeCellStatusBarItems=="function"?A._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(c,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(c,S,o);let r;return S!==void 0&&(r=g.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(S))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(c),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(c,S),r&&r.dispose()})}async createNotebookDocument(s){const o=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:s.viewType,content:s.content&&l.NotebookData.from(s.content)});return I.URI.revive(o)}async openNotebookDocument(s){const o=this._documents.get(s);if(o)return o.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(s),c=this._documents.get(I.URI.revive(g));return(0,_.assertIsDefined)(c?.apiNotebook)}async showNotebookDocument(s,o){I.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let g;typeof o=="object"?g={position:l.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(l.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:g={preserveFocus:!1};const c=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.notebookType,g),S=c&&this._editors.get(c)?.apiEditor;if(S)return S;throw c?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,o,g,c){const S=this._notebookStatusBarItemProviders.get(s),r=I.URI.revive(o),t=this._documents.get(r);if(!t||!S)return;const n=t.getCellFromIndex(g);if(!n)return;const u=await S.provideCellStatusBarItems(n.apiCell,c);if(!u)return;const a=new C.DisposableStore,f=this._statusBarCache.add([a]),d=(Array.isArray(u)?u:[u]).map(D=>l.NotebookStatusBarItem.from(D,this._commandsConverter,a));return{cacheId:f,items:d}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,o,g,c,S){if((0,k.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,g),this._notebookProxy.$registerNotebookSerializer(r,{id:s.identifier,location:s.extensionLocation},o,l.NotebookDocumentContentOptions.from(c),A._convertNotebookRegistrationData(s,S)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(s,o,g){const c=this._notebookSerializer.get(s);if(!c)throw new Error("NO serializer found");const S=await c.deserializeNotebook(o.buffer,g);return new h.SerializableObjectWithBuffers(l.NotebookData.from(S))}async $notebookToData(s,o,g){const c=this._notebookSerializer.get(s);if(!c)throw new Error("NO serializer found");const S=await c.serializeNotebook(l.NotebookData.to(o.value),g);return m.VSBuffer.wrap(S)}async $openNotebook(s,o,g,c,S){const{provider:r}=this._getProviderData(s),t=await r.openNotebook(I.URI.revive(o),{backupId:g,untitledDocumentData:c?.buffer},S);return new h.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(l.NotebookCellData.from)})}async $saveNotebook(s,o,g){const c=this.getNotebookDocument(I.URI.revive(o)),{provider:S}=this._getProviderData(s);return await S.saveNotebook(c.apiNotebook,g),!0}async $saveNotebookAs(s,o,g,c){const S=this.getNotebookDocument(I.URI.revive(o)),{provider:r}=this._getProviderData(s);return await r.saveNotebookAs(I.URI.revive(g),S.apiNotebook,c),!0}async $backupNotebook(s,o,g){const c=this.getNotebookDocument(I.URI.revive(o)),S=this._getProviderData(s),r=this._extensionStoragePaths.workspaceValue(S.extension)??this._extensionStoragePaths.globalValue(S.extension),t=String((0,y.hash)([c.uri.toString(),this._backupIdPool++])),n=I.URI.joinPath(r,t),u=await S.provider.backupNotebook(c.apiNotebook,{destination:n},g);return c.updateBackup(u),u.id}_createExtHostEditor(s,o,g){if(this._editors.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const c=new v.ExtHostNotebookEditor(o,this._notebookEditorsProxy,s,g.visibleRanges.map(l.NotebookRange.to),g.selections.map(l.NotebookRange.to),typeof g.viewColumn=="number"?l.ViewColumn.to(g.viewColumn):void 0);this._editors.set(o,c)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const g of s.value.removedDocuments){const c=I.URI.revive(g),S=this._documents.get(c);S&&(S.dispose(),this._documents.delete(c),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:S.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(S.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===c.toString()&&this._editors.delete(r.id)}if(s.value.addedDocuments){const g=[];for(const c of s.value.addedDocuments){const S=I.URI.revive(c.uri);if(this._documents.has(S))throw new Error(`adding EXISTING notebook ${S} `);const r=this,t=new p.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(n){r._onDidChangeNotebookCells.fire(n)},emitCellOutputsChange(n){r._onDidChangeCellOutputs.fire(n)},emitCellMetadataChange(n){r._onDidChangeCellMetadata.fire(n)},emitCellExecutionStateChange(n){r._onDidChangeCellExecutionState.fire(n)}},S,c);g.push(...c.cells.map(n=>p.ExtHostCell.asModelAddData(t.apiNotebook,n))),this._documents.get(S)?.dispose(),this._documents.set(S,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(s.value.addedEditors)for(const g of s.value.addedEditors){if(this._editors.has(g.id))return;const c=I.URI.revive(g.documentUri),S=this._documents.get(c);S&&this._createExtHostEditor(S,g.id,g)}const o=[];if(s.value.removedEditors)for(const g of s.value.removedEditors){const c=this._editors.get(g);c&&(this._editors.delete(g),this._activeNotebookEditor?.id===c.id&&(this._activeNotebookEditor=void 0),o.push(c))}if(s.value.visibleEditors){this._visibleNotebookEditors=s.value.visibleEditors.map(c=>this._editors.get(c)).filter(c=>!!c);const g=new Set;this._visibleNotebookEditors.forEach(c=>g.add(c.id));for(const c of this._editors.values()){const S=g.has(c.id);c._acceptVisibility(S)}this._visibleNotebookEditors=[...this._editors.values()].map(c=>c).filter(c=>c.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this._activeNotebookEditor=void 0:s.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=A,A._notebookStatusBarItemProviderHandlePool=0}),define(we[244],be([0,1,3,76,11,5,14,17]),function(Y,e,m,i,y,C,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(T,l){const E=_._Keys.nextId();T.$registerNotebookEditorDecorationType(E,k.NotebookDecorationRenderOptions.from(l)),this.value={key:E,dispose(){T.$removeNotebookEditorDecorationType(E)}}}}_._Keys=new i.IdGenerator("NotebookEditorDecorationType");let I=class{constructor(T,l,E){this._logService=T,this._extHostRpc=l,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(T){return new _(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),T).value}$acceptEditorPropertiesChanged(T,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,l);const E=this._notebooksAndEditors.getEditorById(T);l.visibleRanges&&E._acceptVisibleRanges(l.visibleRanges.ranges.map(k.NotebookRange.to)),l.selections&&E._acceptSelections(l.selections.selections.map(k.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const l in T)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(k.ViewColumn.to(T[l]))}};I=je([ze(0,y.ILogService),ze(1,P.IExtHostRpcService)],I),e.ExtHostNotebookEditors=I}),define(we[245],be([0,1,16,18,21,3,6,24,2,27,11,5,38,17,7,88,210,29,53]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let s=class{constructor(r,t,n,u,a){this._initData=t,this._extHostNotebook=n,this._commands=u,this._logService=a,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(T.MainContext.MainThreadNotebookKernels);const f=new l.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.ApiCommandArgument("options","Select kernel options",b=>!0,b=>{if(b&&"notebookEditor"in b&&"id"in b){const d=this._extHostNotebook.getIdByEditor(b.notebookEditor);return{id:b.id,extension:b.extension,notebookEditorId:d}}else if(b&&"notebookEditor"in b){const d=this._extHostNotebook.getIdByEditor(b.notebookEditor);if(d===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${b.notebookEditor.document.uri.toString()}`);return{notebookEditorId:d}}return b})],l.ApiCommandResult.Void);this._commands.registerApiCommand(f)}createNotebookController(r,t,n,u,a,f){for(let H of this._kernelData.values())if(H.controller.id===t&&I.ExtensionIdentifier.equals(r.identifier,H.extensionId))throw new Error(`notebook controller with id '${t}' ALREADY exist`);const b=this._handlePool++,d=this;this._logService.trace(`NotebookController[${b}], CREATED by ${r.identifier.value}, ${t}`);const D=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${r.identifier}'`);let R=!1;const N=new P.DisposableStore,B=new C.Emitter,F=new C.Emitter,O={id:`${r.identifier.value}/${t}`,notebookType:n,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:u||r.identifier.value,preloads:f?f.map(E.NotebookRendererScript.from):[]};let z=a??D,W;this._proxy.$addKernel(b,O).catch(H=>{console.log(H),R=!0});let M=0;const x=()=>{if(R)return;const H=++M;Promise.resolve().then(()=>{H===M&&this._proxy.$updateKernel(b,O)})},V=new k.ResourceMap,U={get id(){return t},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return O.label},set label(H){O.label=H??r.displayName??r.name,x()},get detail(){return O.detail??""},set detail(H){O.detail=H,x()},get description(){return O.description??""},set description(H){O.description=H,x()},get kind(){return(0,A.checkProposedApiEnabled)(r,"notebookControllerKind"),O.kind??""},set kind(H){(0,A.checkProposedApiEnabled)(r,"notebookControllerKind"),O.kind=H,x()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(H){O.supportedLanguages=H,x()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(H){O.supportsExecutionOrder=H,x()},get rendererScripts(){return O.preloads?O.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(H){z=H??D},get interruptHandler(){return W},set interruptHandler(H){W=H,O.supportsInterrupt=Boolean(H),x()},createNotebookCellExecution(H){if(R)throw new Error("notebook controller is DISPOSED");if(!V.has(H.notebook.uri))throw d._logService.trace(`NotebookController[${b}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(X=>X.toString())),new Error(`notebook controller is NOT associated to notebook: ${H.notebook.uri.toString()}`);return d._createNotebookCellExecution(H)},dispose:()=>{R||(this._logService.trace(`NotebookController[${b}], DISPOSED`),R=!0,this._kernelData.delete(b),N.dispose(),B.dispose(),F.dispose(),this._proxy.$removeKernel(b))},updateNotebookAffinity(H,X){d._proxy.$updateNotebookPriority(b,H.uri,X)},onDidReceiveMessage:F.event,postMessage(H,X){return(0,A.checkProposedApiEnabled)(r,"notebookMessaging"),d._proxy.$postMessage(b,X&&d._extHostNotebook.getIdByEditor(X),H)},asWebviewUri(H){return(0,A.checkProposedApiEnabled)(r,"notebookMessaging"),(0,p.asWebviewUri)(H,d._initData.remote)}};return this._kernelData.set(b,{extensionId:r.identifier,controller:U,onDidReceiveMessage:F,onDidChangeSelection:B,associatedNotebooks:V}),U}$acceptNotebookAssociation(r,t,n){const u=this._kernelData.get(r);if(u){const a=this._extHostNotebook.getNotebookDocument(_.URI.revive(t));n?u.associatedNotebooks.set(a.uri,!0):u.associatedNotebooks.delete(a.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,a.uri.toString(),n),u.onDidChangeSelection.fire({selected:n,notebook:a.apiNotebook})}}async $executeCells(r,t,n){const u=this._kernelData.get(r);if(!u)return;const a=this._extHostNotebook.getNotebookDocument(_.URI.revive(t)),f=[];for(let b of n){const d=a.getCell(b);d&&f.push(d.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,a.uri.toString(),f.length),await u.controller.executeHandler.call(u.controller,f,a.apiNotebook,u.controller)}catch(b){this._logService.error(`NotebookController[${r}] execute cells FAILED`,b),console.error(b)}}async $cancelCells(r,t,n){const u=this._kernelData.get(r);if(!u)return;const a=this._extHostNotebook.getNotebookDocument(_.URI.revive(t));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,a.apiNotebook);else for(let f of n){const b=a.getCell(f);b&&this._activeExecutions.get(b.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,t,n){const u=this._kernelData.get(r);if(!u)return;const a=this._extHostNotebook.getEditorById(t);u.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:n}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!n)throw new Error("invalid cell");if(this._activeExecutions.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const u=new g(n.notebook,n,this._proxy);this._activeExecutions.set(n.uri,u);const a=u.onDidChangeState(()=>{u.state===o.Resolved&&(u.dispose(),a.dispose(),this._activeExecutions.delete(n.uri))});return u.asApiObject()}};s=je([ze(4,L.ILogService)],s),e.ExtHostNotebookKernels=s;var o;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(o||(o={}));class g extends P.Disposable{constructor(r,t,n){super();this._document=r,this._cell=t,this._proxy=n,this._handle=g.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new y.CancellationTokenSource),this._collector=new c(10,u=>this.update(u)),this._executionOrder=t.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const t=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new w.SerializableObjectWithBuffers(t))}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let t=this._cell;if(r&&(t=this._document.getCellFromApiCell(r)),!t)throw new Error("INVALID cell");return t.handle}validateAndConvertOutputs(r){return r.map(t=>{const n=h.NotebookCellOutput.ensureUniqueMimeTypes(t.items,!0);return n===t.items?E.NotebookCellOutput.from(t):E.NotebookCellOutput.from({items:n,id:t.id,metadata:t.metadata})})}async updateOutputs(r,t,n){const u=this.cellIndexToHandle(t),a=this.validateAndConvertOutputs((0,m.asArray)(r));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:u,append:n,outputs:a})}async updateOutputItems(r,t,n){return r=h.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(r),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(E.NotebookCellOutputItem.from),outputId:t.id,append:n})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(n){r._executionOrder=n,r.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(n){if(r._state===o.Resolved||r._state===o.Started)throw new Error("Cannot call start again");r._state=o.Started,r._onDidChangeState.fire(),r.update({editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:n})},end(n,u){if(r._state===o.Resolved)throw new Error("Cannot call resolve twice");r._state=o.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:v.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:u,lastRunSuccess:n}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(n){return r.verifyStateForOutput(),r.updateOutputs([],n,!1)},appendOutput(n,u){return r.verifyStateForOutput(),r.updateOutputs(n,u,!0)},replaceOutput(n,u){return r.verifyStateForOutput(),r.updateOutputs(n,u,!1)},appendOutputItems(n,u){return r.verifyStateForOutput(),r.updateOutputItems(n,u,!0)},replaceOutputItems(n,u){return r.verifyStateForOutput(),r.updateOutputItems(n,u,!1)}})}}g.HANDLE=0;class c{constructor(r,t){this.delay=r,this.callback=t,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new i.DeferredPromise,this.startedTimer=Date.now(),(0,i.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const t=this.batch;return this.batch=[],this.callback(t).finally(()=>r.complete())}}}),define(we[246],be([0,1,3,5,128,29]),function(Y,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(_,I){this._extHostNotebook=I,this._rendererMessageEmitters=new Map,this.proxy=_.getProxy(i.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(_,I,L){const T=this._extHostNotebook.getEditorById(_);this._rendererMessageEmitters.get(I)?.fire({editor:T.apiEditor,message:L})}createRendererMessaging(_,I){if(!_.contributes?.notebookRenderer?.some(E=>E.id===I))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${I})`);const L=(0,C.isProposedApiEnabled)(_,"notebookEditor"),T=new WeakMap;return{onDidReceiveMessage:(E,h,p)=>{const v=L?E:A=>{const w={};T.set(w,A.editor),E({editor:w,message:A.message})};return this.getOrCreateEmitterFor(I).event(v,h,p)},postMessage:(E,h)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(E)&&([E,h]=[h,E]);const p=L?h:T.get(h),v=p&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(p);return this.proxy.$postMessage(v?.id,I,E)}}}getOrCreateEmitterFor(_){let I=this._rendererMessageEmitters.get(_);return I||(I=new m.Emitter({onLastListenerRemove:()=>{I?.dispose(),this._rendererMessageEmitters.delete(_)}}),this._rendererMessageEmitters.set(_,I),I)}}e.ExtHostNotebookRenderers=P}),define(we[132],be([0,1,5,6,4,14,11,211,66,26,44,151,22]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class E extends i.Disposable{constructor(v,A,w,s){super();this.id=v,this.name=A,this.logger=w,this.proxy=s,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(v){this.append(v+`
`)}append(v){this.write(v),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const v=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,v)}replace(v){const A=this.offset;this.write(v),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,A),this.visible&&this.logger.flush()}show(v,A){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof v=="boolean"?v:A))}hide(){this.proxy.$close(this.id)}write(v){this.offset+=l.VSBuffer.fromString(v).byteLength,this.logger.info(v)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=E;let h=class{constructor(v,A,w,s,o){this.extHostFileSystem=w,this.extHostFileSystemInfo=s,this.loggerService=o,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=v.getProxy(m.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(A.logsLocation,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.visibleChannelId=v;for(const[A,w]of this.channels)w.visible=A===this.visibleChannelId}createOutputChannel(v,A){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const w=this.doCreateOutputChannel(v,A);return w.then(s=>{this.channels.set(s.id,s),s.visible=s.id===this.visibleChannelId}),this.createExtHostOutputChannel(v,w)}async doCreateOutputChannel(v,A){const w=await this.createOutputDirectory(),s=this.extHostFileSystemInfo.extUri.joinPath(w,`${this.namePool++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.loggerService.createLogger(s,{always:!0,donotRotate:!0,donotUseFormatters:!0}),g=await this.proxy.$register(v,!1,s,A.identifier.value);return new E(g,v,o,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(v,A){let w=!1;const s=()=>{if(w)throw new Error("Channel has been closed")};return{get name(){return v},append(o){s(),A.then(g=>g.append(o))},appendLine(o){s(),A.then(g=>g.appendLine(o))},clear(){s(),A.then(o=>o.clear())},replace(o){s(),A.then(g=>g.replace(o))},show(o,g){s(),A.then(c=>c.show(o,g))},hide(){s(),A.then(o=>o.hide())},dispose(){w=!0,A.then(o=>o.dispose())}}}};h=je([ze(0,C.IExtHostRpcService),ze(1,I.IExtHostInitDataService),ze(2,_.IExtHostConsumerFileSystem),ze(3,L.IExtHostFileSystemInfo),ze(4,P.ILoggerService)],h),e.ExtHostOutputService=h,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(we[247],be([0,1,18,21,3,6,5,2,7,15,16,48,86,29]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(p,v,A){const w=p.getProxy(P.MainContext.MainThreadQuickOpen);class s{constructor(a,f){this._sessions=new Map,this._instances=0,this._workspace=a,this._commands=f}showQuickPick(a,f,b=i.CancellationToken.None){this._onDidSelectItem=void 0;const d=Promise.resolve(a),D=++this._instances,R=w.$show(D,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},b),N={},B=R.then(()=>N);return Promise.race([B,d]).then(F=>{if(F!==N)return d.then(O=>{const z=[];for(let W=0;W<O.length;W++){const M=O[W];typeof M=="string"?z.push({label:M,handle:W}):M.kind===_.QuickPickItemKind.Separator?z.push({type:"separator",label:M.label}):z.push({label:M.label,description:M.description,detail:M.detail,picked:M.picked,alwaysShow:M.alwaysShow,handle:W})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=W=>{f.onDidSelectItem(O[W])}),w.$setItems(D,z),R.then(W=>{if(typeof W=="number")return O[W];if(Array.isArray(W))return W.map(M=>O[M])})})}).then(void 0,F=>{if(!(0,I.isPromiseCanceledError)(F))return w.$setError(D,F),Promise.reject(F)})}$onItemSelected(a){this._onDidSelectItem&&this._onDidSelectItem(a)}showInput(a,f=i.CancellationToken.None){return this._validateInput=a?a.validateInput:void 0,w.$input(a,typeof this._validateInput=="function",f).then(void 0,b=>{if(!(0,I.isPromiseCanceledError)(b))return Promise.reject(b)})}$validateInput(a){return this._validateInput?(0,m.asPromise)(()=>this._validateInput(a)):Promise.resolve(void 0)}async showWorkspaceFolderPick(a,f=i.CancellationToken.None){const b=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!b)return;const d=await this._workspace.getWorkspaceFolders2();if(!!d)return d.find(D=>D.uri.toString()===b.uri.toString())}createQuickPick(a){const f=new t(a,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(a){const f=new n(a,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}$onDidChangeValue(a,f){const b=this._sessions.get(a);b&&b._fireDidChangeValue(f)}$onDidAccept(a){const f=this._sessions.get(a);f&&f._fireDidAccept()}$onDidChangeActive(a,f){const b=this._sessions.get(a);b instanceof t&&b._fireDidChangeActive(f)}$onDidChangeSelection(a,f){const b=this._sessions.get(a);b instanceof t&&b._fireDidChangeSelection(f)}$onDidTriggerButton(a,f){const b=this._sessions.get(a);b&&b._fireDidTriggerButton(f)}$onDidTriggerItemButton(a,f,b){const d=this._sessions.get(a);d instanceof t&&d._fireDidTriggerItemButton(f,b)}$onDidHide(a){const f=this._sessions.get(a);f&&f._fireDidHide()}}class o{constructor(a,f){this._extensionId=a,this._onDidDispose=f,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new y.Emitter,this._onDidChangeValueEmitter=new y.Emitter,this._onDidTriggerButtonEmitter=new y.Emitter,this._onDidHideEmitter=new y.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(a){this._title=a,this.update({title:a})}get step(){return this._steps}set step(a){this._steps=a,this.update({step:a})}get totalSteps(){return this._totalSteps}set totalSteps(a){this._totalSteps=a,this.update({totalSteps:a})}get enabled(){return this._enabled}set enabled(a){this._enabled=a,this.update({enabled:a})}get busy(){return this._busy}set busy(a){this._busy=a,this.update({busy:a})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(a){this._ignoreFocusOut=a,this.update({ignoreFocusOut:a})}get value(){return this._value}set value(a){this._value=a,this.update({value:a})}get placeholder(){return this._placeholder}set placeholder(a){this._placeholder=a,this.update({placeholder:a})}get buttons(){return this._buttons}set buttons(a){this._buttons=a.slice(),this._handlesToButtons.clear(),a.forEach((f,b)=>{const d=f===_.QuickInputButtons.Back?-1:b;this._handlesToButtons.set(d,f)}),this.update({buttons:a.map((f,b)=>({...r(f),tooltip:f.tooltip,handle:f===_.QuickInputButtons.Back?-1:b}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(a){this._value=a,this._onDidChangeValueEmitter.fire(a)}_fireDidTriggerButton(a){const f=this._handlesToButtons.get(a);f&&this._onDidTriggerButtonEmitter.fire(f)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),w.$dispose(this._id))}update(a){if(!this._disposed){for(const f of Object.keys(a)){const b=a[f];this._pendingUpdate[f]=b===void 0?null:b}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){w.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function g(u){if(u instanceof _.ThemeIcon)return{id:u.id};const a=S(u),f=c(u);return{dark:typeof a=="string"?k.URI.file(a):a,light:typeof f=="string"?k.URI.file(f):f}}function c(u){return typeof u=="object"&&"light"in u?u.light:u}function S(u){return typeof u=="object"&&"dark"in u?u.dark:u}function r(u){const a=g(u.iconPath);let f,b;return"id"in a?b=l.ThemeIcon.asClassName(a):f=a,{iconPath:f,iconClass:b}}class t extends o{constructor(a,f){super(a.identifier,f);this.extension=a,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new y.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new y.Emitter,this._onDidTriggerItemButtonEmitter=new y.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(a){a.some(b=>b.kind!==void 0)&&(0,E.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=a.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),a.forEach((b,d)=>{this._handlesToItems.set(d,b),this._itemsToHandles.set(b,d)});const f=[];for(let b=0;b<a.length;b++){const d=a[b];d.kind===_.QuickPickItemKind.Separator?f.push({type:"separator",label:d.label}):f.push({handle:b,label:d.label,description:d.description,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,buttons:d.buttons?.map((D,R)=>({...r(D),tooltip:D.tooltip,handle:R}))})}this.update({items:f})}get canSelectMany(){return this._canSelectMany}set canSelectMany(a){this._canSelectMany=a,this.update({canSelectMany:a})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(a){this._matchOnDescription=a,this.update({matchOnDescription:a})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(a){this._matchOnDetail=a,this.update({matchOnDetail:a})}get sortByLabel(){return this._sortByLabel}set sortByLabel(a){this._sortByLabel=a,this.update({sortByLabel:a})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(a){this._keepScrollPosition=a,this.update({keepScrollPosition:a})}get activeItems(){return this._activeItems}set activeItems(a){this._activeItems=a.filter(f=>this._itemsToHandles.has(f)),this.update({activeItems:this._activeItems.map(f=>this._itemsToHandles.get(f))})}get selectedItems(){return this._selectedItems}set selectedItems(a){this._selectedItems=a.filter(f=>this._itemsToHandles.has(f)),this.update({selectedItems:this._selectedItems.map(f=>this._itemsToHandles.get(f))})}_fireDidChangeActive(a){const f=(0,L.coalesce)(a.map(b=>this._handlesToItems.get(b)));this._activeItems=f,this._onDidChangeActiveEmitter.fire(f)}_fireDidChangeSelection(a){const f=(0,L.coalesce)(a.map(b=>this._handlesToItems.get(b)));this._selectedItems=f,this._onDidChangeSelectionEmitter.fire(f)}_fireDidTriggerItemButton(a,f){const b=this._handlesToItems.get(a);if(!b||!b.buttons||!b.buttons.length)return;const d=b.buttons[f];d&&this._onDidTriggerItemButtonEmitter.fire({button:d,item:b})}}class n extends o{constructor(a,f){super(a,f);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(a){this._password=a,this.update({password:a})}get prompt(){return this._prompt}set prompt(a){this._prompt=a,this.update({prompt:a})}get validationMessage(){return this._validationMessage}set validationMessage(a){this._validationMessage=a,this.update({validationMessage:a,severity:a?T.default.Error:T.default.Ignore})}}return new s(v,A)}e.createExtHostQuickOpen=h}),define(we[248],be([0,1,2,3,57,6,18,5,16,99,11,27,86,17,29]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function p(u){if(u)return typeof u.iconPath=="string"?m.URI.file(u.iconPath):m.URI.isUri(u.iconPath)||l.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function v(u,a){if(!u.iconPath&&!a.iconPath)return 0;if(u.iconPath){if(!a.iconPath)return 1}else return-1;const f=typeof u.iconPath=="string"?u.iconPath:m.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,b=typeof a.iconPath=="string"?a.iconPath:m.URI.isUri(a.iconPath)?a.iconPath.fsPath:a.iconPath.id;return(0,I.comparePaths)(f,b)}function A(u,a){let f=0;if(u.strikeThrough!==a.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==a.faded)return u.faded?1:-1;if(u.tooltip!==a.tooltip)return(u.tooltip||"").localeCompare(a.tooltip||"");if(f=v(u,a),f!==0)return f;if(u.light&&a.light)f=v(u.light,a.light);else{if(u.light)return 1;if(a.light)return-1}if(f!==0)return f;if(u.dark&&a.dark)f=v(u.dark,a.dark);else{if(u.dark)return 1;if(a.dark)return-1}return f}function w(u,a){if(u.command!==a.command)return u.command<a.command?-1:1;if(u.title!==a.title)return u.title<a.title?-1:1;if(u.tooltip!==a.tooltip){if(u.tooltip!==void 0&&a.tooltip!==void 0)return u.tooltip<a.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(a.tooltip!==void 0)return-1}if(u.arguments===a.arguments)return 0;if(u.arguments)if(a.arguments){if(u.arguments.length!==a.arguments.length)return u.arguments.length-a.arguments.length}else return 1;else return-1;for(let f=0;f<u.arguments.length;f++){const b=u.arguments[f],d=a.arguments[f];if(b!==d)return b<d?-1:1}return 0}function s(u,a){let f=(0,I.comparePaths)(u.resourceUri.fsPath,a.resourceUri.fsPath,!0);if(f!==0)return f;if(u.command&&a.command)f=w(u.command,a.command);else{if(u.command)return 1;if(a.command)return-1}if(f!==0)return f;if(u.decorations&&a.decorations)f=A(u.decorations,a.decorations);else{if(u.decorations)return 1;if(a.decorations)return-1}return f}function o(u,a){for(let f=0;f<u.length;f++)if(u[f]!==a[f])return!1;return!0}function g(u,a){return u.command===a.command&&u.title===a.title&&u.tooltip===a.tooltip&&(u.arguments&&a.arguments?o(u.arguments,a.arguments):u.arguments===a.arguments)}function c(u,a){return(0,_.equals)(u,a,g)}class S{constructor(a,f,b){this._extension=a,this._proxy=f,this._sourceControlHandle=b,this._value="",this._onDidChange=new i.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(a){a=a??"",this._proxy.$setInputBoxValue(this._sourceControlHandle,a),this.updateValue(a)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(a){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,a),this._placeholder=a}get validateInput(){return(0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(a){if((0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),a&&typeof a!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=a,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!a)}get visible(){return this._visible}set visible(a){a=!!a,this._visible!==a&&(this._visible=a,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,a))}showValidationMessage(a,f){(0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,a,f)}$onInputBoxValueChange(a){this.updateValue(a)}updateValue(a){this._value=a,this._onDidChange.fire(a)}}e.ExtHostSCMInputBox=S;class r{constructor(a,f,b,d,D){this._proxy=a,this._commands=f,this._sourceControlHandle=b,this._id=d,this._label=D,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new i.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(a){this._label=a,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,a)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(a){this._hideWhenEmpty=a,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(a){this._resourceStates=[...a],this._onDidUpdateResourceStates.fire()}getResourceState(a){return this._resourceStatesMap.get(a)}$executeResourceCommand(a,f){const b=this._resourceStatesCommandsMap.get(a);return b?(0,P.asPromise)(()=>this._commands.executeCommand(b.command,...b.arguments||[],f)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const a=[...this._resourceStates].sort(s),b=(0,_.sortedDiff)(this._resourceSnapshot,a,s).map(R=>{const N=R.toInsert.map(B=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,B);const O=B.resourceUri;let z;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const j=new C.DisposableStore;z=this._commands.converter.toInternal(B.command,j),this._resourceStatesDisposablesMap.set(F,j)}else this._resourceStatesCommandsMap.set(F,B.command);const W=p(B.decorations),M=B.decorations&&p(B.decorations.light)||W,x=B.decorations&&p(B.decorations.dark)||W,V=[M,x],U=B.decorations&&B.decorations.tooltip||"",H=B.decorations&&!!B.decorations.strikeThrough,X=B.decorations&&!!B.decorations.faded,se=B.contextValue||"";return{rawResource:[F,O,V,U,H,X,se,z],handle:F}});return{start:R.start,deleteCount:R.deleteCount,toInsert:N}}),d=b.map(({start:R,deleteCount:N,toInsert:B})=>[R,N,B.map(F=>F.rawResource)]),D=b.reverse();for(const{start:R,deleteCount:N,toInsert:B}of D){const F=B.map(z=>z.handle),O=this._handlesSnapshot.splice(R,N,...F);for(const z of O)this._resourceStatesMap.delete(z),this._resourceStatesCommandsMap.delete(z),this._resourceStatesDisposablesMap.get(z)?.dispose(),this._resourceStatesDisposablesMap.delete(z)}return this._resourceSnapshot=a,d}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class t{constructor(a,f,b,d,D,R){this._extension=a,this._proxy=f,this._commands=b,this._id=d,this._label=D,this._rootUri=R,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new C.MutableDisposable,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new i.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new S(a,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,d,D,R)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(a){this._count!==a&&(this._count=a,this._proxy.$updateSourceControl(this.handle,{count:a}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(a){this._quickDiffProvider=a,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!a})}get commitTemplate(){return this._commitTemplate}set commitTemplate(a){a!==this._commitTemplate&&(this._commitTemplate=a,this._proxy.$updateSourceControl(this.handle,{commitTemplate:a}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(a){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=a;const f=this._commands.converter.toInternal(a,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:f})}get actionButton(){return(0,h.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(a){(0,h.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new C.DisposableStore,this._actionButton=a;const f=a!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:f??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(a){if(this._statusBarCommands&&a&&c(this._statusBarCommands,a))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=a;const f=(a||[]).map(b=>this._commands.converter.toInternal(b,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:f})}get selected(){return this._selected}createResourceGroup(a,f){const b=new r(this._proxy,this._commands,this.handle,a,f),d=i.Event.once(b.onDidDispose)(()=>this.createdResourceGroups.delete(b));return this.createdResourceGroups.set(b,d),this.eventuallyAddResourceGroups(),b}eventuallyAddResourceGroups(){const a=[],f=[];for(const[b,d]of this.createdResourceGroups){d.dispose();const D=b.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(b),this.eventuallyUpdateResourceStates()});i.Event.once(b.onDidDispose)(()=>{this.updatedResourceGroups.delete(b),D.dispose(),this._groups.delete(b.handle),this._proxy.$unregisterGroup(this.handle,b.handle)}),a.push([b.handle,b.id,b.label,b.features]);const R=b._takeResourceStateSnapshot();R.length>0&&f.push([b.handle,R]),this._groups.set(b.handle,b)}this._proxy.$registerGroups(this.handle,a,f),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const a=[];this.updatedResourceGroups.forEach(f=>{const b=f._takeResourceStateSnapshot();b.length!==0&&a.push([f.handle,b])}),a.length>0&&this._proxy.$spliceResourceStates(this.handle,a),this.updatedResourceGroups.clear()}getResourceGroup(a){return this._groups.get(a)}setSelectionState(a){this._selected=a,this._onDidChangeSelection.fire(a)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(a=>a.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}t._handlePool=0,je([(0,y.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),je([(0,y.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let n=class Hi{constructor(a,f,b){this._commands=f,this.logService=b,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new i.Emitter,this._proxy=a.getProxy(k.MainContext.MainThreadSCM),this._telemetry=a.getProxy(k.MainContext.MainThreadTelemetry),f.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===3){const D=this._sourceControls.get(d.sourceControlHandle);if(!D)return d;const R=D.getResourceGroup(d.groupHandle);return R?R.getResourceState(d.handle):d}else if(d&&d.$mid===4){const D=this._sourceControls.get(d.sourceControlHandle);return D?D.getResourceGroup(d.groupHandle):d}else if(d&&d.$mid===5){const D=this._sourceControls.get(d.handle);return D||d}return d}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(a,f,b,d){this.logService.trace("ExtHostSCM#createSourceControl",a.identifier.value,f,b,d),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:a.identifier.value});const D=Hi._handlePool++,R=new t(a,this._proxy,this._commands,f,b,d);this._sourceControls.set(D,R);const N=this._sourceControlsByExtension.get(T.ExtensionIdentifier.toKey(a.identifier))||[];return N.push(R),this._sourceControlsByExtension.set(T.ExtensionIdentifier.toKey(a.identifier),N),R}getLastInputBox(a){this.logService.trace("ExtHostSCM#getLastInputBox",a.identifier.value);const f=this._sourceControlsByExtension.get(T.ExtensionIdentifier.toKey(a.identifier)),b=f&&f[f.length-1];return b&&b.inputBox}$provideOriginalResource(a,f,b){const d=m.URI.revive(f);this.logService.trace("ExtHostSCM#$provideOriginalResource",a,d.toString());const D=this._sourceControls.get(a);return!D||!D.quickDiffProvider||!D.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,P.asPromise)(()=>D.quickDiffProvider.provideOriginalResource(d,b)).then(R=>R||null)}$onInputBoxValueChange(a,f){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",a);const b=this._sourceControls.get(a);return b&&b.inputBox.$onInputBoxValueChange(f),Promise.resolve(void 0)}$executeResourceCommand(a,f,b,d){this.logService.trace("ExtHostSCM#$executeResourceCommand",a,f,b);const D=this._sourceControls.get(a);if(!D)return Promise.resolve(void 0);const R=D.getResourceGroup(f);return R?R.$executeResourceCommand(b,d):Promise.resolve(void 0)}$validateInput(a,f,b){this.logService.trace("ExtHostSCM#$validateInput",a);const d=this._sourceControls.get(a);return!d||!d.inputBox.validateInput?Promise.resolve(void 0):(0,P.asPromise)(()=>d.inputBox.validateInput(f,b)).then(D=>{if(!D)return Promise.resolve(void 0);const R=E.MarkdownString.fromStrict(D.message);return R?Promise.resolve([R,D.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(a){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",a),a!==void 0&&this._sourceControls.get(a)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=a,Promise.resolve(void 0)}};n._handlePool=0,n=je([ze(2,L.ILogService)],n),e.ExtHostSCM=n});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},xe=this&&this.__classPrivateFieldGet||function(Y,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(Y):i?i.value:e.get(Y)};define(we[249],be([0,1,7,5,165,6,17,13]),function(Y,e,m,i,y,C,P,k){"use strict";var _,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(h,p,v,A,w=m.StatusBarAlignment.Left,s){_.set(this,void 0),I.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,nt(this,_,h,"f"),nt(this,I,p,"f"),this._entryId=L.ID_GEN++,this._extension=v,this._id=A,this._alignment=w,this._priority=this.validatePriority(s)}validatePriority(h){if(!!(0,k.isNumber)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!L.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:xe(this,I,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:xe(this,I,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,xe(this,_,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let p;this._name?p=this._name:p=(0,y.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const A=this._tooltip?P.MarkdownString.fromStrict(this._tooltip):void 0;xe(this,_,"f").$setEntry(this._entryId,h,p,this._text,A,this._command?.internal,v,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=L,_=new WeakMap,I=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new m.ThemeColor("statusBarItem.warningForeground")]]);class T{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,y.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const p={message:h};return this._messages.unshift(p),this._update(),new m.Disposable(()=>{const v=this._messages.indexOf(p);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class l{constructor(h,p){this._proxy=h.getProxy(i.MainContext.MainThreadStatusBar),this._commands=p,this._statusMessage=new T(this)}createStatusBarEntry(h,p,v,A){return new L(this._proxy,this._commands,h,p,v,A)}setStatusBarMessage(h,p){const v=this._statusMessage.setMessage(h);let A;return typeof p=="number"?A=setTimeout(()=>v.dispose(),p):typeof p!="undefined"&&p.then(()=>v.dispose(),()=>v.dispose()),new m.Disposable(()=>{v.dispose(),clearTimeout(A)})}}e.ExtHostStatusBar=l}),define(we[91],be([0,1,5,3,4]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(k){this._onDidChangeStorage=new i.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,_){this._proxy.$registerExtensionStorageKeysToSync(k,_)}getValue(k,_,I){return this._proxy.$getValue(k,_).then(L=>L||I)}setValue(k,_,I){return this._proxy.$setValue(k,_,I)}$acceptValue(k,_,I){this._onDidChangeStorage.fire({shared:k,key:_,value:I})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(we[67],be([0,1,4,26,11,66,2]),function(Y,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let k=class{constructor(I,L,T){this._logService=L,this._extHostFileSystem=T,this._workspace=I.workspace??void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(I){return P.URI.joinPath(this._environment.workspaceStorageHome,I)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const I=this._workspace.id,L=await this._getWorkspaceStorageURI(I);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(P.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:P.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(T){this._logService.error("[ExtHostStorage]",T);return}}workspaceValue(I){if(this._value)return P.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return P.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=je([ze(0,i.IExtHostInitDataService),ze(1,y.ILogService),ze(2,C.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(we[34],be([0,1,3,5,4,2,14,6,7,166,15,213,21,33,195,86,13,18]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class w{constructor(u,a,f,b){this._proxy=u,this._id=a,this._creationOptions=f,this._name=b,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(D=>this._pidPromiseComplete=D);const d=this;this.value={get name(){return d._name||""},get processId(){return d._pidPromise},get creationOptions(){return d._creationOptions},get exitStatus(){return d._exitStatus},get state(){return d._state},sendText(D,R=!0){d._checkDisposed(),d._proxy.$sendText(d._id,D,R)},show(D){d._checkDisposed(),d._proxy.$show(d._id,D)},hide(){d._checkDisposed(),d._proxy.$hide(d._id)},dispose(){d._disposed||(d._disposed=!0,d._proxy.$dispose(d._id))},get dimensions(){if(!(d._cols===void 0||d._rows===void 0))return{columns:d._cols,rows:d._rows}}}}async create(u,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:u.name,shellPath:(0,v.withNullAsUndefined)(u.shellPath),shellArgs:(0,v.withNullAsUndefined)(u.shellArgs),cwd:(0,v.withNullAsUndefined)(u.cwd),env:(0,v.withNullAsUndefined)(u.env),icon:(0,v.withNullAsUndefined)(r(u.iconPath)),color:p.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:(0,v.withNullAsUndefined)(u.message),strictEnv:(0,v.withNullAsUndefined)(u.strictEnv),hideFromUser:(0,v.withNullAsUndefined)(u.hideFromUser),isFeatureTerminal:(0,v.withNullAsUndefined)(a?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,v.withNullAsUndefined)(a?.useShellEnvironment),location:a?.location||this._serializeParentTerminal(u.location,a?.resolvedExtHostIdentifier),disablePersistence:(0,v.withNullAsUndefined)(u.disablePersistence)})}async createExtensionTerminal(u,a,f,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:f,color:p.ThemeColor.isThemeColor(b)?b.id:void 0,location:this._serializeParentTerminal(u,a),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(u,a){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&a?{parentTerminal:a}:"viewColumn"in u?{viewColumn:u.viewColumn,preserveFocus:u.preserveFocus}:void 0:u}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(u){this._name=u}setExitCode(u){this._exitStatus=Object.freeze({code:u})}setDimensions(u,a){return u===this._cols&&a===this._rows||u===0||a===0?!1:(this._cols=u,this._rows=a,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(u){this._pidPromiseComplete?(this._pidPromiseComplete(u),this._pidPromiseComplete=void 0):this._pidPromise.then(a=>{a!==u&&(this._pidPromise=Promise.resolve(u))})}}e.ExtHostTerminal=w;class s{constructor(u){this._pty=u,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new m.Emitter,this._onDidChangeProperty=new m.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,a){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${a}`)}async start(){}shutdown(){this._pty.close()}input(u){this._pty.handleInput?.(u)}resize(u,a){this._pty.setDimensions?.({columns:u,rows:a})}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(u){this._pty.onDidWrite(a=>this._onProcessData.fire(a)),this._pty.onDidClose?.((a=void 0)=>{this._onProcessExit.fire(a===void 0?void 0:a)}),this._pty.onDidOverrideDimensions?.(a=>{a&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:a.columns,rows:a.rows}})}),this._pty.onDidChangeName?.(a=>{this._onDidChangeProperty.fire({type:"title",value:a})}),this._pty.open(u||void 0),u&&this._pty.setDimensions?.(u),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=s;let o=1,g=class extends k.Disposable{constructor(u,a){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new m.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new m.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new m.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new m.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=a.getProxy(i.MainContext.MainThreadTerminalService),this._bufferer=new h.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(u),this._register({dispose:()=>{for(const[f,b]of this._terminalProcesses)b.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(u=>u.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(u,a){const f=new w(this._proxy,(0,E.generateUuid)(),u,u.name),b=new s(u.pty);return f.createExtensionTerminal(u.location,this._serializeParentTerminal(u,a).resolvedExtHostIdentifier,r(u.iconPath),t(u.color)).then(d=>{const D=this._setupExtHostProcessListeners(d,b);this._terminalProcessDisposables[d]=D}),this._terminals.push(f),f.value}_serializeParentTerminal(u,a){if(a=a||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const f=u.location.parentTerminal;if(f){const b=this._terminals.find(d=>d.value===f);b&&(a.resolvedExtHostIdentifier=b._id)}}else u.location&&typeof u.location!="object"?a.location=u.location:a.location&&typeof a.location=="object"&&"splitActiveTerminal"in a.location&&(a.location={splitActiveTerminal:!0});return a}attachPtyToTerminal(u,a){if(!this._getTerminalById(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const b=new s(a),d=this._setupExtHostProcessListeners(u,b);this._terminalProcessDisposables[u]=d}async $acceptActiveTerminalChanged(u){const a=this._activeTerminal;if(u===null){this._activeTerminal=void 0,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const f=this._getTerminalById(u);f&&(this._activeTerminal=f,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(u,a){const f=this._getTerminalById(u);f&&this._onDidWriteTerminalData.fire({terminal:f.value,data:a})}async $acceptTerminalDimensions(u,a,f){const b=this._getTerminalById(u);b&&b.setDimensions(a,f)&&this._onDidChangeTerminalDimensions.fire({terminal:b.value,dimensions:b.value.dimensions})}async $acceptTerminalMaximumDimensions(u,a,f){this._terminalProcesses.get(u)?.resize(a,f)}async $acceptTerminalTitleChange(u,a){const f=this._getTerminalById(u);f&&(f.name=a)}async $acceptTerminalClosed(u,a){const f=this._getTerminalObjectIndexById(this._terminals,u);if(f!==null){const b=this._terminals.splice(f,1)[0];b.setExitCode(a),this._onDidCloseTerminal.fire(b.value)}}$acceptTerminalOpened(u,a,f,b){if(a){const R=this._getTerminalObjectIndexById(this._terminals,a);if(R!==null){this._terminals[R]._id=u,this._onDidOpenTerminal.fire(this.terminals[R]),this._terminals[R].isOpen=!0;return}}const d={name:b.name,shellPath:b.executable,shellArgs:b.args,cwd:typeof b.cwd=="string"?b.cwd:C.URI.revive(b.cwd),env:b.env,hideFromUser:b.hideFromUser},D=new w(this._proxy,u,d,f);this._terminals.push(D),this._onDidOpenTerminal.fire(D.value),D.isOpen=!0}async $acceptTerminalProcessId(u,a){const f=this._getTerminalById(u);f&&f._setProcessId(a)}async $startExtensionTerminal(u,a){const f=this._getTerminalById(u);if(!f)return{message:(0,I.localize)(0,null,u)};f.isOpen||await new Promise(d=>{const D=this.onDidOpenTerminal(async R=>{R===f.value&&(D.dispose(),d())})});const b=this._terminalProcesses.get(u);b?b.startSendingEvents(a):this._extensionTerminalAwaitingStart[u]={initialDimensions:a}}_setupExtHostProcessListeners(u,a){const f=new k.DisposableStore;f.add(a.onProcessReady(d=>this._proxy.$sendProcessReady(u,d.pid,d.cwd))),f.add(a.onDidChangeProperty(d=>this._proxy.$sendProcessProperty(u,d))),this._bufferer.startBuffering(u,a.onProcessData),f.add(a.onProcessExit(d=>this._onProcessExit(u,d))),this._terminalProcesses.set(u,a);const b=this._extensionTerminalAwaitingStart[u];return b&&a instanceof s&&(a.startSendingEvents(b.initialDimensions),delete this._extensionTerminalAwaitingStart[u]),f}$acceptProcessAckDataEvent(u,a){this._terminalProcesses.get(u)?.acknowledgeDataEvent(a)}$acceptProcessInput(u,a){this._terminalProcesses.get(u)?.input(a)}$acceptTerminalInteraction(u){const a=this._getTerminalById(u);a?.setInteractedWith()&&this._onDidChangeTerminalState.fire(a.value)}$acceptProcessResize(u,a,f){try{this._terminalProcesses.get(u)?.resize(a,f)}catch(b){if(b.code!=="EPIPE"&&b.code!=="ERR_IPC_CHANNEL_CLOSED")throw b}}$acceptProcessShutdown(u,a){this._terminalProcesses.get(u)?.shutdown(a)}$acceptProcessRequestInitialCwd(u){this._terminalProcesses.get(u)?.getInitialCwd().then(a=>this._proxy.$sendProcessProperty(u,{type:"initialCwd",value:a}))}$acceptProcessRequestCwd(u){this._terminalProcesses.get(u)?.getCwd().then(a=>this._proxy.$sendProcessProperty(u,{type:"cwd",value:a}))}$acceptProcessRequestLatency(u){return u}registerLinkProvider(u){return this._linkProviders.add(u),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(u),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(u,a,f){if(this._profileProviders.has(a))throw new Error(`Terminal profile provider "${a}" already registered`);return this._profileProviders.set(a,f),this._proxy.$registerProfileProvider(a,u.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(a),this._proxy.$unregisterProfileProvider(a)})}async $createContributedProfileTerminal(u,a){const f=new l.CancellationTokenSource().token;let b=await this._profileProviders.get(u)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(b&&!("options"in b)&&(b={options:b}),!b||!("options"in b))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in b.options){this.createExtensionTerminal(b.options,a);return}this.createTerminalFromOptions(b.options,a)}}async $provideLinks(u,a){const f=this._getTerminalById(u);if(!f)return[];this._terminalLinkCache.delete(u);const b=this._terminalLinkCancellationSource.get(u);b&&b.dispose(!0);const d=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(u,d);const D=[],R={terminal:f.value,line:a},N=[];for(const O of this._linkProviders)N.push(A.Promises.withAsyncBody(async z=>{d.token.onCancellationRequested(()=>z({provider:O,links:[]}));const W=await O.provideTerminalLinks(R,d.token)||[];d.token.isCancellationRequested||z({provider:O,links:W})}));const B=await Promise.all(N);if(d.token.isCancellationRequested)return[];const F=new Map;for(const O of B)O&&O.links.length>0&&D.push(...O.links.map(z=>{const W={id:o++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return F.set(W.id,{provider:O.provider,link:z}),W}));return this._terminalLinkCache.set(u,F),D}$activateLink(u,a){const f=this._terminalLinkCache.get(u)?.get(a);!f||f.provider.handleTerminalLink(f.link)}_onProcessExit(u,a){this._bufferer.stopBuffering(u),this._terminalProcesses.delete(u),delete this._extensionTerminalAwaitingStart[u];const f=this._terminalProcessDisposables[u];f&&(f.dispose(),delete this._terminalProcessDisposables[u]),this._proxy.$sendProcessExit(u,a)}_getTerminalById(u){return this._getTerminalObjectById(this._terminals,u)}_getTerminalObjectById(u,a){const f=this._getTerminalObjectIndexById(u,a);return f!==null?u[f]:null}_getTerminalObjectIndexById(u,a){let f=null;return u.some((b,d)=>b._id===a?(f=d,!0):!1),f}getEnvironmentVariableCollection(u){let a=this._environmentVariableCollections.get(u.identifier.value);return a||(a=new c,this._setEnvironmentVariableCollection(u.identifier.value,a)),a}_syncEnvironmentVariableCollection(u,a){const f=(0,T.serializeEnvironmentVariableCollection)(a.map);this._proxy.$setEnvironmentVariableCollection(u,a.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(u){u.forEach(a=>{const f=a[0],b=new c(a[1]);this._setEnvironmentVariableCollection(f,b)})}$acceptDefaultProfile(u,a){this._defaultProfile=u,this._defaultAutomationProfile=a}_setEnvironmentVariableCollection(u,a){this._environmentVariableCollections.set(u,a),a.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(u,a)})}};g=je([ze(1,P.IExtHostRpcService)],g),e.BaseExtHostTerminalService=g;class c{constructor(u){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(u)}get persistent(){return this._persistent}set persistent(u){this._persistent=u,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(u,a){this._setIfDiffers(u,{value:a,type:_.EnvironmentVariableMutatorType.Replace})}append(u,a){this._setIfDiffers(u,{value:a,type:_.EnvironmentVariableMutatorType.Append})}prepend(u,a){this._setIfDiffers(u,{value:a,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(u,a){const f=this.map.get(u);(!f||f.value!==a.value||f.type!==a.type)&&(this.map.set(u,a),this._onDidChangeCollection.fire())}get(u){return this.map.get(u)}forEach(u,a){this.map.forEach((f,b)=>u.call(a,b,f,this))}delete(u){this.map.delete(u),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=c;let S=class extends g{constructor(u){super(!1,u)}createTerminal(u,a,f){throw new L.NotSupportedError}createTerminalFromOptions(u,a){throw new L.NotSupportedError}};S=je([ze(0,P.IExtHostRpcService)],S),e.WorkerExtHostTerminalService=S;function r(n){if(!(!n||typeof n=="string"))return"id"in n?{id:n.id,color:n.color}:n}function t(n){return p.ThemeColor.isThemeColor(n)?n:void 0}});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},xe=this&&this.__classPrivateFieldGet||function(Y,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(Y):i?i.value:e.get(Y)};define(we[250],be([0,1,16,22,21,3,75,47,6,25,13,33,5,14,63,17,7,221,126,89]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v,A,w,s){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let g=class{constructor(R,N){this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(l.MainContext.MainThreadTesting),this.observer=new f(this.proxy),this.runTracker=new S(this.proxy),N.registerArgumentProcessor({processArgument:B=>B?.$mid===13?p.TestItem.toItemFromContext(B):B})}createTestController(R,N){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const B=new _.DisposableStore,F=B.add(new A.SingleUseTestCollection(R));F.root.label=N;const O=new Map,z=this.proxy,W={items:F.root.children,get label(){return N},set label(x){N=x,F.root.label=x,z.$updateControllerLabel(R,N)},get id(){return R},createRunProfile:(x,V,U,H,X)=>{let se=(0,k.hash)(x);for(;O.has(se);)se++;const K=new b(this.proxy,R,se,x,V,U,H,X);return O.set(se,K),K},createTestItem(x,V,U){return new h.TestItemImpl(R,x,V,U)},createTestRun:(x,V,U=!0)=>this.runTracker.createTestRun(R,F,x,V,U),set resolveHandler(x){F.resolveHandler=x},get resolveHandler(){return F.resolveHandler},dispose:()=>{B.dispose()}};W.createRunConfiguration=W.createRunProfile,z.$registerTestController(R,N),B.add((0,_.toDisposable)(()=>z.$unregisterTestController(R)));const M={controller:W,collection:F,profiles:O};return this.controllers.set(R,M),B.add((0,_.toDisposable)(()=>this.controllers.delete(R))),B.add(F.onDidGenerateDiff(x=>z.$publishDiff(R,x))),W}createTestObserver(){return this.observer.checkout()}async runTests(R,N=y.CancellationToken.None){const B=r(R);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(B.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map(O=>O.id)??[F.collection.root.id],profileGroup:d[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:R.exclude?.map(O=>O.id)},N)}$provideFileCoverage(R,N,B){return(0,m.mapFind)(this.runTracker.trackers,O=>O.id===R?O.getCoverage(N):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(R,N,B,F){return(0,m.mapFind)(this.runTracker.trackers,z=>z.id===R?z.getCoverage(N):void 0)?.resolveFileCoverage(B,F)??Promise.resolve([])}$configureRunProfile(R,N){this.controllers.get(R)?.profiles.get(N)?.configureHandler?.()}$publishTestResults(R){this.results=Object.freeze(R.map(N=>(0,I.deepFreeze)(p.TestResults.to(N))).concat(this.results).sort((N,B)=>B.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,N){const B=this.controllers.get(s.TestId.fromString(R).controllerId)?.collection;B&&(await B.expand(R,N<0?1/0:N),B.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,N){const B=this.controllers.get(R.controllerId);if(!B)return;const{collection:F,profiles:O}=B,z=O.get(R.profileId);if(!z)return;const W=R.testIds.map(U=>F.tree.get(U)).filter(L.isDefined),M=R.excludeExtIds.map(U=>B.collection.tree.get(U)).filter(L.isDefined).filter(U=>W.some(H=>H.fullId.compare(U.fullId)===2));if(!W.length)return;const x=new v.TestRunRequest(W.some(U=>U.actual instanceof h.TestItemRootImpl)?void 0:W.map(U=>U.actual),M.map(U=>U.actual),z),V=this.runTracker.prepareForMainThreadTestRun(x,t.fromInternal(R,B.collection),N);try{await z.runHandler(x,N)}finally{V.isRunning&&!N.isCancellationRequested&&await C.Event.toPromise(V.onEnd),V.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};g=je([ze(0,E.IExtHostRpcService)],g),e.ExtHostTesting=g;class c extends _.Disposable{constructor(R,N,B){super();this.dto=R,this.proxy=N,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new C.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(B)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const N=this.dto.id,B=this.dto.controllerId,F=(0,T.generateUuid)(),O=new n(this.proxy,N,F),z=V=>(U,...H)=>{if(M){console.warn(`Setting the state of test "${U.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(U)||(this.ensureTestIsKnown(U),V(U,...H))},W=(V,U)=>{const H=U instanceof Array?U.map(p.TestMessage.from):[p.TestMessage.from(U)];if(V.uri&&V.range){const X={range:p.Range.from(V.range),uri:V.uri};for(const se of H)se.location=se.location||X}this.proxy.$appendTestMessagesInRun(N,F,s.TestId.fromExtHostTestItem(V,B).toString(),H)};let M=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return O.coverageProvider},set coverageProvider(V){O.coverageProvider=V},enqueued:z(V=>{this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(V,B).toString(),1)}),skipped:z(V=>{this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(V,B).toString(),5)}),started:z(V=>{this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(V,B).toString(),2)}),errored:z((V,U,H)=>{W(V,U),this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(V,B).toString(),6,H)}),failed:z((V,U,H)=>{W(V,U),this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(V,B).toString(),4,H)}),passed:z((V,U)=>{this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(V,this.dto.controllerId).toString(),3,U)}),appendOutput:(V,U,H)=>{M||(H&&(this.dto.isIncluded(H)?this.ensureTestIsKnown(H):H=void 0),this.proxy.$appendOutputToRun(N,F,i.VSBuffer.fromString(V),U&&p.location.from(U),H&&s.TestId.fromExtHostTestItem(H,B).toString()))},end:()=>{M||(M=!0,this.proxy.$finishedTestRunTask(N,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:x,coverage:O}),this.proxy.$startedTestRunTask(N,{id:F,name:R,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof h.TestItemImpl))throw new h.InvalidTestItemError(R.id);if(this.sharedTestIds.has(s.TestId.fromExtHostTestItem(R,this.dto.controllerId).toString()))return;const N=[],B=this.dto.colllection.root;for(;;){const F=p.TestItem.from(R);if(N.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),R===B))break;R=R.parent||B}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,N)}}class S{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,N,B){return this.getTracker(R,N,B)}cancelRunById(R){for(const N of this.tracked.values())if(N.id===R){N.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,N,B,F,O){const z=this.tracked.get(B);if(z)return z.createRun(F);const W=t.fromPublic(R,N,B,O),M=r(B);this.proxy.$startedExtensionTestRun({controllerId:R,profile:M&&{group:d[M.kind],id:M.profileId},exclude:B.exclude?.map(V=>V.id)??[],id:W.id,include:B.include?.map(V=>V.id)??[N.root.id],persist:O});const x=this.getTracker(B,W);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(W.id)),x.createRun(F)}getTracker(R,N,B){const F=new c(N,this.proxy,B);return this.tracked.set(R,F),F.onEnd(()=>this.tracked.delete(R)),F}}e.TestRunCoordinator=S;const r=D=>{if(!!D.profile){if(!(D.profile instanceof b))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return D.profile}};class t{constructor(R,N,B,F,O,z){this.controllerId=R,this.id=N,this.isPersisted=O,this.colllection=z,this.includePrefix=B.map(W=>W+"\0"),this.excludePrefix=F.map(W=>W+"\0")}static fromPublic(R,N,B,F){return new t(R,(0,T.generateUuid)(),B.include?.map(O=>s.TestId.fromExtHostTestItem(O,R).toString())??[R],B.exclude?.map(O=>s.TestId.fromExtHostTestItem(O,R).toString())??[],F,N)}static fromInternal(R,N){return new t(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,N)}isIncluded(R){const N=s.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const B of this.excludePrefix)if(N===B||N.startsWith(B))return!1;for(const B of this.includePrefix)if(N===B||N.startsWith(B))return!0;return!1}}e.TestRunDto=t;class n{constructor(R,N,B){this.proxy=R,this.runId=N,this.taskId=B}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(p.TestCoverage.fromFile)??[]}catch(N){throw this.fileCoverage=void 0,N}}async resolveFileCoverage(R,N){const B=await this.fileCoverage;let F=B?.[R];return!this._coverageProvider||!B||!F?[]:(F.detailedCoverage||(F=B[R]=await this._coverageProvider.resolveFileCoverage?.(F,N)??F),F.detailedCoverage?.map(p.TestCoverage.fromDetailed)??[])}}class u extends w.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,p.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:N,removed:B}=this;return{get added(){return[...R].map(F=>F.revived)},get updated(){return[...N].map(F=>F.revived)},get removed(){return[...B].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class a extends w.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,N){return{...R,revived:p.TestItem.toPlain(R.item),depth:N?N.depth+1:0,children:new Set}}createChangeCollector(){return new u(this.changeEmitter)}}e.MirroredTestCollection=a;class f{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(N=>N.revived)},dispose:(0,P.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new a;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class b{constructor(R,N,B,F,O,z,W=!1,M=void 0){this.controllerId=N,this.profileId=B,this._label=F,this.kind=O,this.runHandler=z,this._isDefault=W,this._tag=M,o.set(this,void 0),nt(this,o,R,"f");const x=d[O];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${O}`);xe(this,o,"f").$publishTestRunProfile({profileId:B,controllerId:N,tag:M?p.TestTag.namespace(this.controllerId,M.id):null,label:F,group:x,isDefault:W,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,xe(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,xe(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,xe(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?p.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,xe(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){xe(this,o,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=b,o=new WeakMap;const d={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(we[251],be([0,1,3,16,5,129,17,7]),function(Y,e,m,i,y,C,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(L,T){this._extHostDocumentsAndEditors=T,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(y.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const T=this._extHostDocumentsAndEditors.allEditors();return L?T:T.map(l=>l.value)}async showTextDocument(L,T,l){let E;typeof T=="number"?E={position:P.ViewColumn.from(T),preserveFocus:l}:typeof T=="object"?E={position:P.ViewColumn.from(T.viewColumn),preserveFocus:T.preserveFocus,selection:typeof T.selection=="object"?P.Range.from(T.selection):void 0,pinned:typeof T.preview=="boolean"?!T.preview:void 0}:E={preserveFocus:!1};const h=await this._proxy.$tryShowTextDocument(L.uri,E),p=h&&this._extHostDocumentsAndEditors.getEditor(h);if(p)return p.value;throw h?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,T){return new C.TextEditorDecorationType(this._proxy,L,T).value}$acceptEditorPropertiesChanged(L,T){const l=this._extHostDocumentsAndEditors.getEditor(L);if(!l)throw new Error("unknown text editor");if(T.options&&l._acceptOptions(T.options),T.selections){const E=T.selections.selections.map(P.Selection.to);l._acceptSelections(E)}if(T.visibleRanges){const E=i.coalesce(T.visibleRanges.map(P.Range.to));l._acceptVisibleRanges(E)}if(T.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...T.options,lineNumbers:P.TextEditorLineNumbersStyle.to(T.options.lineNumbers)}}),T.selections){const E=k.TextEditorSelectionChangeKind.fromValue(T.selections.source),h=T.selections.selections.map(P.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:h,kind:E})}if(T.visibleRanges){const E=i.coalesce(T.visibleRanges.map(P.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:E})}}$acceptEditorPositionData(L){for(const T in L){const l=this._extHostDocumentsAndEditors.getEditor(T);if(!l)throw new Error("Unknown text editor");const E=P.ViewColumn.to(L[T]);l.value.viewColumn!==E&&(l._acceptViewColumn(E),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:E}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=_}),define(we[252],be([0,1,2,4,5,6,7]),function(Y,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,i.createDecorator)("IExtHostTimeline");class k{constructor(L,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=L.getProxy(y.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const E=l.uri===void 0?void 0:m.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(_(E))?.get(l.handle)}return l}})}async $getTimeline(L,T,l,E,h){return this._providers.get(L)?.provideTimeline(m.URI.revive(T),l,E,h)}registerTimelineProvider(L,T,l,E){const h=new C.DisposableStore,p=this.convertTimelineItem(T.id,E,h).bind(this);let v;T.onDidChange&&(v=T.onDidChange(w=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...w,id:T.id}),this));const A=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:L,onDidChange:void 0,async provideTimeline(w,s,o,g){g?.resetCache&&(h.clear(),A.get(T.id)?.clear());const c=await T.provideTimeline(w,s,o);if(c==null)return;const S=p(w,g);return{...c,source:T.id,items:c.items.map(S)}},dispose(){for(const w of A.values())w.get(T.id)?.clear();v?.dispose(),h.dispose()}})}convertTimelineItem(L,T,l){return(E,h)=>{let p;if(h?.cacheResults){let v=this._itemsBySourceAndUriMap.get(L);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(L,v));const A=_(E);p=v.get(A),p===void 0&&(p=new Map,v.set(A,p))}return v=>{const{iconPath:A,...w}=v,s=`${L}|${v.id??v.timestamp}`;p?.set(s,v);let o,g,c;return v.iconPath&&(A instanceof P.ThemeIcon?c={id:A.id,color:A.color}:m.URI.isUri(A)?(o=A,g=A):{light:o,dark:g}=A),{...w,id:w.id??void 0,handle:s,source:L,command:v.command?T.toInternal(v.command,l):void 0,icon:o,iconDark:g,themeIcon:c,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(L){if(this._providers.get(L.id))throw new Error(`Timeline Provider ${L.id} already exists.`);return this._proxy.$registerTimelineProvider({id:L.id,label:L.label,scheme:L.scheme}),this._providers.set(L.id,L),(0,C.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(L.id)?.clear();this._providers.delete(L.id),this._proxy.$unregisterTimelineProvider(L.id),L.dispose()})}}e.ExtHostTimeline=k;function _(I){return I?.toString()}}),define(we[253],be([0,1,6,10,2,5]),function(Y,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class P{constructor(_){this._openers=new Map,this._proxy=_.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,I,L,T){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const l=T.schemes.find(E=>!P.supportedSchemes.has(E));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,L),this._proxy.$registerUriOpener(I,T.schemes,_,T.label),(0,m.toDisposable)(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(_,I,L){const T=this._openers.get(_);if(!T)throw new Error(`Unknown opener with id: ${_}`);const l=y.URI.revive(I);return T.canOpenExternalUri(l,L)}async $openUri(_,I,L){const T=this._openers.get(_);if(!T)throw new Error(`Unknown opener id: '${_}'`);return T.openExternalUri(y.URI.revive(I.resolvedUri),{sourceUri:y.URI.revive(I.sourceUri)},L)}}e.ExtHostUriOpeners=P,P.supportedSchemes=new Set([i.Schemas.http,i.Schemas.https])}),define(we[254],be([0,1,5,2,6,15,27]),function(Y,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(I,L){if(this.handles.has(P.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const T=k.HandlePool++;return this.handles.add(P.ExtensionIdentifier.toKey(I)),this.handlers.set(T,L),this._proxy.$registerUriHandler(T,I),(0,y.toDisposable)(()=>{this.handles.delete(P.ExtensionIdentifier.toKey(I)),this.handlers.delete(T),this._proxy.$unregisterUriHandler(T)})}$handleExternalUri(I,L){const T=this.handlers.get(I);if(!T)return Promise.resolve(void 0);try{T.handleUri(i.URI.revive(L))}catch(l){(0,C.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(I){return i.URI.revive(await this._proxy.$createAppUri(I))}}e.ExtHostUrls=k,k.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},xe=this&&this.__classPrivateFieldGet||function(Y,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(Y):i?i.value:e.get(Y)};define(we[68],be([0,1,3,10,2,178,203,88,5]),function(Y,e,m,i,y,C,P,k,_){"use strict";var I,L,T,l,E,h,p,v,A,w,s,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class g{constructor(f,b,d,D,R,N,B){I.set(this,void 0),L.set(this,void 0),T.set(this,void 0),l.set(this,void 0),E.set(this,void 0),h.set(this,void 0),p.set(this,""),v.set(this,void 0),A.set(this,!1),w.set(this,!1),s.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new m.Emitter),this._onDidDispose=xe(this,o,"f").event,nt(this,I,f,"f"),nt(this,L,b,"f"),nt(this,v,d,"f"),nt(this,l,D,"f"),nt(this,E,R,"f"),nt(this,h,N,"f"),nt(this,s,c(N),"f"),nt(this,T,B,"f")}dispose(){nt(this,A,!0,"f"),xe(this,o,"f").fire(),xe(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return nt(this,w,!0,"f"),(0,k.asWebviewUri)(f,xe(this,l,"f").remote)}get cspSource(){const f=xe(this,h,"f").extensionLocation;if(f.scheme===i.Schemas.https||f.scheme===i.Schemas.http){let b=f.toString();return b.endsWith("/")||(b+="/"),b+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),xe(this,p,"f")}set html(f){this.assertNotDisposed(),xe(this,p,"f")!==f&&(nt(this,p,f,"f"),!xe(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(nt(this,w,!0,"f"),xe(this,T,"f").report("Webview vscode-resource: uris",xe(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),xe(this,L,"f").$setHtml(xe(this,I,"f"),f))}get options(){return this.assertNotDisposed(),xe(this,v,"f")}set options(f){this.assertNotDisposed(),xe(this,L,"f").$setOptions(xe(this,I,"f"),t(xe(this,h,"f"),xe(this,E,"f"),f)),nt(this,v,f,"f")}async postMessage(f){if(xe(this,A,"f"))return!1;const b=(0,P.serializeWebviewMessage)(f,{serializeBuffersForPostMessage:xe(this,s,"f")});return xe(this,L,"f").$postMessage(xe(this,I,"f"),b.message,...b.buffers)}assertNotDisposed(){if(xe(this,A,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,I=new WeakMap,L=new WeakMap,T=new WeakMap,l=new WeakMap,E=new WeakMap,h=new WeakMap,p=new WeakMap,v=new WeakMap,A=new WeakMap,w=new WeakMap,s=new WeakMap,o=new WeakMap;function c(a){try{const f=(0,C.normalizeVersion)((0,C.parseVersion)(a.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=c;class S{constructor(f,b,d,D,R){this.initData=b,this.workspace=d,this._logService=D,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=f.getProxy(_.MainContext.MainThreadWebviews)}$onMessage(f,b,d){const D=this.getWebview(f);if(D){const{message:R}=(0,P.deserializeWebviewMessage)(b,d.value);D._onMessageEmitter.fire(R)}}$onMissingCsp(f,b){this._logService.warn(`${b} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,b,d){const D=new g(f,this._webviewProxy,n(b),this.initData,this.workspace,d,this._deprecationService);return this._webviews.set(f,D),D._onDidDispose(()=>{this._webviews.delete(f)}),D}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=S;function r(a){return{id:a.identifier,location:a.extensionLocation}}e.toExtensionData=r;function t(a,f,b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots||u(a,f)}}e.serializeWebviewOptions=t;function n(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(f=>y.URI.from(f))}}e.reviveOptions=n;function u(a,f){return[...(f?.getWorkspaceFolders()||[]).map(b=>b.uri),a.extensionLocation]}}),define(we[255],be([0,1,21,47,6,10,23,2,17,68,87,5,7]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(c,S){this.document=c,this._storagePath=S,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(c){return this._edits.add([c])}async undo(c,S){await this.getEdit(c).undo(),S||this.disposeBackup()}async redo(c,S){await this.getEdit(c).redo(),S||this.disposeBackup()}disposeEdits(c){for(const S of c)this._edits.delete(S)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const c=o(this.document.uri)+this._backupCounter++;return(0,P.joinPath)(this._storagePath,c)}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(c){const S=this._edits.get(c,0);if(!S)throw new Error("No edit found");return S}}class h{constructor(){this._documents=new Map}get(c,S){return this._documents.get(this.key(c,S))}add(c,S,r){const t=this.key(c,S.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${c} resource:${S.uri}`);const n=new E(S,r);return this._documents.set(t,n),n}delete(c,S){const r=this.key(c,S.uri);this._documents.delete(r)}key(c,S){return`${c}@@@${S}`}}var p;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(p||(p={}));class v{constructor(){this._providers=new Map}addTextProvider(c,S,r){return this.add(0,c,S,r)}addCustomProvider(c,S,r){return this.add(1,c,S,r)}get(c){return this._providers.get(c)}add(c,S,r,t){if(this._providers.has(S))throw new Error(`Provider for viewType:${S} already registered`);return this._providers.set(S,{type:c,extension:r,provider:t}),new l.Disposable(()=>this._providers.delete(S))}}class A{constructor(c,S,r,t,n){this._extHostDocuments=S,this._extensionStoragePaths=r,this._extHostWebview=t,this._extHostWebviewPanels=n,this._editorProviders=new v,this._documents=new h,this._proxy=c.getProxy(T.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(c,S,r,t){const n=new y.DisposableStore;return w(r)?(n.add(this._editorProviders.addTextProvider(S,c,r)),this._proxy.$registerTextEditorProvider((0,I.toExtensionData)(c),S,t.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(c))):(n.add(this._editorProviders.addCustomProvider(S,c,r)),this.supportEditing(r)&&n.add(r.onDidChangeCustomDocument(u=>{const a=this.getCustomDocumentEntry(S,u.document.uri);if(s(u)){const f=a.addEdit(u);this._proxy.$onDidEdit(u.document.uri,S,f,u.label)}else this._proxy.$onContentChange(u.document.uri,S)})),this._proxy.$registerCustomEditorProvider((0,I.toExtensionData)(c),S,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(c))),l.Disposable.from(n,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(S)}))}async $createCustomDocument(c,S,r,t,n){const u=this._editorProviders.get(S);if(!u)throw new Error(`No provider found for '${S}'`);if(u.type!==1)throw new Error(`Invalid provide type for '${S}'`);const a=k.URI.revive(c),f=await u.provider.openCustomDocument(a,{backupId:r,untitledDocumentData:t?.buffer},n);let b;return this.supportEditing(u.provider)&&this._extensionStoragePaths&&(b=this._extensionStoragePaths.workspaceValue(u.extension)??this._extensionStoragePaths.globalValue(u.extension)),this._documents.add(S,f,b),{editable:this.supportEditing(u.provider)}}async $disposeCustomDocument(c,S){const r=this._editorProviders.get(S);if(!r)throw new Error(`No provider found for '${S}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${S}'`);const t=k.URI.revive(c),{document:n}=this.getCustomDocumentEntry(S,t);this._documents.delete(S,n),n.dispose()}async $resolveWebviewEditor(c,S,r,t,n,u){const a=this._editorProviders.get(r);if(!a)throw new Error(`No provider found for '${r}'`);const f=_.ViewColumn.to(n),b=this._extHostWebview.createNewWebview(S,t.webviewOptions,a.extension),d=this._extHostWebviewPanels.createNewWebviewPanel(S,r,t.title,f,t.panelOptions,b),D=k.URI.revive(c);switch(a.type){case 1:{const{document:R}=this.getCustomDocumentEntry(r,D);return a.provider.resolveCustomEditor(R,d,u)}case 0:{const R=this._extHostDocuments.getDocument(D);return a.provider.resolveCustomTextEditor(R,d,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(c,S,r){this.getCustomDocumentEntry(S,c).disposeEdits(r)}async $onMoveCustomEditor(c,S,r){const t=this._editorProviders.get(r);if(!t)throw new Error(`No provider found for '${r}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const n=this._extHostWebviewPanels.getWebviewPanel(c);if(!n)throw new Error("No webview found");const u=k.URI.revive(S),a=this._extHostDocuments.getDocument(u);await t.provider.moveCustomTextEditor(a,n,m.CancellationToken.None)}async $undo(c,S,r,t){return this.getCustomDocumentEntry(S,c).undo(r,t)}async $redo(c,S,r,t){return this.getCustomDocumentEntry(S,c).redo(r,t)}async $revert(c,S,r){const t=this.getCustomDocumentEntry(S,c);await this.getCustomEditorProvider(S).revertCustomDocument(t.document,r),t.disposeBackup()}async $onSave(c,S,r){const t=this.getCustomDocumentEntry(S,c);await this.getCustomEditorProvider(S).saveCustomDocument(t.document,r),t.disposeBackup()}async $onSaveAs(c,S,r,t){const n=this.getCustomDocumentEntry(S,c);return this.getCustomEditorProvider(S).saveCustomDocumentAs(n.document,k.URI.revive(r),t)}async $backup(c,S,r){const t=this.getCustomDocumentEntry(S,c),u=await this.getCustomEditorProvider(S).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},r);return t.updateBackup(u),u.id}getCustomDocumentEntry(c,S){const r=this._documents.get(c,k.URI.revive(S));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(c){const r=this._editorProviders.get(c)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(c){return!!c.onDidChangeCustomDocument}}e.ExtHostCustomEditors=A;function w(g){return typeof g.resolveCustomTextEditor=="function"}function s(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function o(g){const c=g.scheme===C.Schemas.file||g.scheme===C.Schemas.untitled?g.fsPath:g.toString();return(0,i.hash)(c)+""}});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},xe=this&&this.__classPrivateFieldGet||function(Y,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(Y):i?i.value:e.get(Y)};define(we[256],be([0,1,3,6,2,33,17,68,5,7]),function(Y,e,m,i,y,C,P,k,_,I){"use strict";var L,T,l,E,h,p,v,A,w,s,o,g,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class S extends i.Disposable{constructor(u,a,f,b,d,D,R){super();L.set(this,void 0),T.set(this,void 0),l.set(this,void 0),E.set(this,void 0),h.set(this,void 0),p.set(this,void 0),v.set(this,void 0),A.set(this,void 0),w.set(this,!0),s.set(this,!0),o.set(this,!1),g.set(this,this._register(new m.Emitter)),this.onDidDispose=xe(this,g,"f").event,c.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=xe(this,c,"f").event,nt(this,L,u,"f"),nt(this,T,a,"f"),nt(this,l,f,"f"),nt(this,h,D,"f"),nt(this,A,d,"f"),nt(this,p,b,"f"),nt(this,E,R,"f")}dispose(){xe(this,o,"f")||(nt(this,o,!0,"f"),xe(this,g,"f").fire(),xe(this,T,"f").$disposeWebview(xe(this,L,"f")),xe(this,E,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),xe(this,E,"f")}get viewType(){return this.assertNotDisposed(),xe(this,l,"f")}get title(){return this.assertNotDisposed(),xe(this,p,"f")}set title(u){this.assertNotDisposed(),xe(this,p,"f")!==u&&(nt(this,p,u,"f"),xe(this,T,"f").$setTitle(xe(this,L,"f"),u))}get iconPath(){return this.assertNotDisposed(),xe(this,v,"f")}set iconPath(u){this.assertNotDisposed(),xe(this,v,"f")!==u&&(nt(this,v,u,"f"),xe(this,T,"f").$setIconPath(xe(this,L,"f"),y.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return xe(this,h,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof xe(this,A,"f")=="number"&&xe(this,A,"f")<0))return xe(this,A,"f")}get active(){return this.assertNotDisposed(),xe(this,s,"f")}get visible(){return this.assertNotDisposed(),xe(this,w,"f")}_updateViewState(u){xe(this,o,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(nt(this,s,u.active,"f"),nt(this,w,u.visible,"f"),nt(this,A,u.viewColumn,"f"),xe(this,c,"f").fire({webviewPanel:this}))}reveal(u,a){this.assertNotDisposed(),xe(this,T,"f").$reveal(xe(this,L,"f"),{viewColumn:u?P.ViewColumn.from(u):void 0,preserveFocus:!!a})}assertNotDisposed(){if(xe(this,o,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,T=new WeakMap,l=new WeakMap,E=new WeakMap,h=new WeakMap,p=new WeakMap,v=new WeakMap,A=new WeakMap,w=new WeakMap,s=new WeakMap,o=new WeakMap,g=new WeakMap,c=new WeakMap;class r{constructor(u,a,f){this.webviews=a,this.workspace=f,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=u.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(u,a,f,b,d={}){const D=typeof b=="object"?b.viewColumn:b,R={viewColumn:P.ViewColumn.from(D),preserveFocus:typeof b=="object"&&!!b.preserveFocus},N=(0,k.shouldSerializeBuffersForPostMessage)(u),B=r.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(u),B,a,{title:f,panelOptions:t(d),webviewOptions:(0,k.serializeWebviewOptions)(u,this.workspace,d),serializeBuffersForPostMessage:N},R);const F=this.webviews.createNewWebview(B,d,u);return this.createNewWebviewPanel(B,a,f,D,d,F)}$onDidChangeWebviewPanelViewStates(u){const a=Object.keys(u);a.sort((f,b)=>{const d=u[f],D=u[b];return d.active?1:D.active?-1:+d.visible-+D.visible});for(const f of a){const b=this.getWebviewPanel(f);if(!b)continue;const d=u[f];b._updateViewState({active:d.active,visible:d.visible,viewColumn:P.ViewColumn.to(d.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this._webviewPanels.delete(u),this.webviews.deleteWebview(u)}registerWebviewPanelSerializer(u,a,f){if(this._serializers.has(a))throw new Error(`Serializer for '${a}' already registered`);return this._serializers.set(a,{serializer:f,extension:u}),this._proxy.$registerSerializer(a,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(u)}),new I.Disposable(()=>{this._serializers.delete(a),this._proxy.$unregisterSerializer(a)})}async $deserializeWebviewPanel(u,a,f,b){const d=this._serializers.get(a);if(!d)throw new Error(`No serializer found for '${a}'`);const{serializer:D,extension:R}=d,N=this.webviews.createNewWebview(u,f.webviewOptions,R),B=this.createNewWebviewPanel(u,a,f.title,b,f.panelOptions,N);await D.deserializeWebviewPanel(B,f.state)}createNewWebviewPanel(u,a,f,b,d,D){const R=new S(u,this._proxy,a,f,b,d,D);return this._webviewPanels.set(u,R),R}getWebviewPanel(u){return this._webviewPanels.get(u)}}e.ExtHostWebviewPanels=r;function t(n){return{enableFindWidget:n.enableFindWidget,retainContextWhenHidden:n.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},xe=this&&this.__classPrivateFieldGet||function(Y,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(Y):i?i.value:e.get(Y)};define(we[257],be([0,1,3,6,68,5,7]),function(Y,e,m,i,y,C,P){"use strict";var k,_,I,L,T,l,E,h,p,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class A extends i.Disposable{constructor(o,g,c,S,r,t){super();k.set(this,void 0),_.set(this,void 0),I.set(this,void 0),L.set(this,void 0),T.set(this,!1),l.set(this,void 0),E.set(this,void 0),h.set(this,void 0),p.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=xe(this,p,"f").event,v.set(this,this._register(new m.Emitter)),this.onDidDispose=xe(this,v,"f").event,nt(this,I,c,"f"),nt(this,E,S,"f"),nt(this,k,o,"f"),nt(this,_,g,"f"),nt(this,L,r,"f"),nt(this,l,t,"f")}dispose(){xe(this,T,"f")||(nt(this,T,!0,"f"),xe(this,v,"f").fire(),xe(this,L,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),xe(this,E,"f")}set title(o){this.assertNotDisposed(),xe(this,E,"f")!==o&&(nt(this,E,o,"f"),xe(this,_,"f").$setWebviewViewTitle(xe(this,k,"f"),o))}get description(){return this.assertNotDisposed(),xe(this,h,"f")}set description(o){this.assertNotDisposed(),xe(this,h,"f")!==o&&(nt(this,h,o,"f"),xe(this,_,"f").$setWebviewViewDescription(xe(this,k,"f"),o))}get visible(){return xe(this,l,"f")}get webview(){return xe(this,L,"f")}get viewType(){return xe(this,I,"f")}_setVisible(o){o===xe(this,l,"f")||xe(this,T,"f")||(nt(this,l,o,"f"),xe(this,p,"f").fire())}show(o){this.assertNotDisposed(),xe(this,_,"f").$show(xe(this,k,"f"),!!o)}assertNotDisposed(){if(xe(this,T,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,_=new WeakMap,I=new WeakMap,L=new WeakMap,T=new WeakMap,l=new WeakMap,E=new WeakMap,h=new WeakMap,p=new WeakMap,v=new WeakMap;class w{constructor(o,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=o.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(o,g,c,S){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:c,extension:o}),this._proxy.$registerWebviewViewProvider((0,y.toExtensionData)(o),g,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new P.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(o,g,c,S,r){const t=this._viewProviders.get(g);if(!t)throw new Error(`No view provider found for '${g}'`);const{provider:n,extension:u}=t,a=this._extHostWebview.createNewWebview(o,{},u),f=new A(o,this._proxy,g,c,a,!0);this._webviewViews.set(o,f),await n.resolveWebviewView(f,{state:S},r)}async $onDidChangeWebviewViewVisibility(o,g){this.getWebviewView(o)._setVisible(g)}async $disposeWebviewView(o){const g=this.getWebviewView(o);this._webviewViews.delete(o),g.dispose(),this._extHostWebview.deleteWebview(o)}getWebviewView(o){const g=this._webviewViews.get(o);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=w}),define(we[133],be([0,1,3,5,2,10,8,4,14]),function(Y,e,m,i,y,C,P,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class zi{constructor(T){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=zi.InitialState,this._proxy=T.getProxy(i.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(T){T!==this._state.focused&&(this._state={...this._state,focused:T},this._onDidChangeWindowState.fire(this._state))}openUri(T,l){let E;if(typeof T=="string"){E=T;try{T=y.URI.parse(T)}catch{return Promise.reject(`Invalid uri - '${T}'`)}}return(0,P.isFalsyOrWhitespace)(T.scheme)?Promise.reject("Invalid scheme - cannot be empty"):T.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${T.scheme}'`):this._proxy.$openUri(T,E,l)}async asExternalUri(T,l){if((0,P.isFalsyOrWhitespace)(T.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this._proxy.$asExternalUri(T,l);return y.URI.from(E)}};I.InitialState={focused:!0},I=je([ze(0,_.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(we[258],be([0,1,9,81,33,38,6,5,2,14]),function(Y,e,m,i,y,C,P,k,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends P.Disposable{constructor(l,E){super();const h=l.getProxy(k.MainContext.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async p=>{const v=_.URI.file((0,m.join)((0,i.tmpdir)(),(0,y.generateUuid)()));return await h.$download(p,v),v})}};L=je([ze(0,I.IExtHostRpcService),ze(1,C.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(we[259],be([0,1,131,10,187,33]),function(Y,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class P extends m.ExtHostLoggerService{doCreateLogger(_,I,L){return _.scheme===i.Schemas.file?new y.SpdLogLogger(L?.name||(0,C.generateUuid)(),_.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,I):super.doCreateLogger(_,I,L)}}e.ExtHostLoggerService=P}),define(we[260],be([0,1,60,9,2,67,6,10,18,28]),function(Y,e,m,i,y,C,P,k,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(c){const S=await super._getWorkspaceStorageURI(c);if(S.scheme!==k.Schemas.file)return S;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${S.fsPath}.`),S;const r=S.fsPath;let t=0;do{let n;t===0?n=r:n=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${t}`:`${r}-${t}`,await T(n);const u=i.join(n,"vscode.lock"),a=await p(this._logService,u,!1);if(a)return this._workspaceStorageLock=a,process.on("exit",()=>{a.dispose()}),y.URI.file(n);t++}while(t<10);return S}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function T(g){try{await I.Promises.stat(g);return}catch{}try{await I.Promises.mkdir(g,{recursive:!0})}catch{}}const l=1e3,E=10*60*1e3;class h extends P.Disposable{constructor(c,S){super();this.logService=c,this.filename=S,this._timer=this._register(new _.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await v(c,S);(!r||r.pid!==process.pid)&&(c.info(`Lock '${S}': The lock was lost unexpectedly.`),this._timer.cancel());try{await I.Promises.utimes(S,new Date,new Date)}catch(t){c.error(t),c.info(`Lock '${S}': Could not update mtime.`)}},l)}dispose(){super.dispose();try{m.unlinkSync(this.filename)}catch{}}async setWillRelease(c){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${c} ms.`);try{const S={pid:process.pid,willReleaseAt:Date.now()+c};await I.Promises.writeFile(this.filename,JSON.stringify(S),{flag:"w"})}catch(S){this.logService.error(S)}}}async function p(g,c,S){try{const t={pid:process.pid,willReleaseAt:0};await I.Promises.writeFile(c,JSON.stringify(t),{flag:"wx"})}catch(t){g.error(t)}const r=await v(g,c);return!r||r.pid!==process.pid?S?(g.info(`Lock '${c}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${c}': Could not acquire lock, checking if the file is stale.`),s(g,c)):(g.info(`Lock '${c}': Lock acquired.`),new h(g,c))}async function v(g,c){let S;try{S=await I.Promises.readFile(c)}catch(r){return g.error(r),null}try{return JSON.parse(String(S))}catch(r){return g.error(r),null}}async function A(g,c){let S;try{S=await I.Promises.stat(c)}catch(r){return g.error(r),0}return S.mtime.getTime()}function w(g){try{return process.kill(g,0),!0}catch{return!1}}async function s(g,c){const S=await v(g,c);if(!S)return g.info(`Lock '${c}': Could not read pid of lock holder.`),o(g,c);if(S.willReleaseAt){let a=S.willReleaseAt-Date.now();if(a<5e3){for(a>0?g.info(`Lock '${c}': The lockfile is scheduled to be released in ${a} ms.`):g.info(`Lock '${c}': The lockfile is scheduled to have been released.`);a>0;){if(await(0,_.timeout)(Math.min(100,a)),await A(g,c)===0)return o(g,c);a=S.willReleaseAt-Date.now()}return o(g,c)}}if(!w(S.pid))return g.info(`Lock '${c}': The pid ${S.pid} appears to be gone.`),o(g,c);const r=await A(g,c),t=Date.now()-r;if(t<=E)return g.info(`Lock '${c}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;g.info(`Lock '${c}': The lock looks stale, waiting for 2s.`),await(0,_.timeout)(2e3);const n=await A(g,c),u=Date.now()-n;return u<=E?(g.info(`Lock '${c}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(g.info(`Lock '${c}': The lock looks stale even after waiting for 2s.`),o(g,c))}async function o(g,c){g.info(`Lock '${c}': Deleting a stale lock.`);try{await I.Promises.unlink(c)}catch{}return p(g,c,!0)}}),define(we[261],be([0,1,33,14,34]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends y.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,_,I){return this.createTerminalFromOptions({name:k,shellPath:_,shellArgs:I})}createTerminalFromOptions(k,_){const I=new y.ExtHostTerminal(this._proxy,(0,m.generateUuid)(),k,k.name);return this._terminals.push(I),I.create(k,this._serializeParentTerminal(k,_)),I.value}};C=je([ze(0,i.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(we[262],be([0,1,5,14,170,6,26,2,37,23,28,7,12,52,3,120,78,11]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class w{constructor(f,b,d){this.remoteAddress=f,this.localAddress=b,this._dispose=d,this._onDispose=new h.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function s(a){const f=a.trim().split(`
`),b=[];return f.forEach(D=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(D);R&&R.length>=3&&b.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),b.reduce((D,R)=>(D[R.socket]=R,D),{})}e.getSockets=s;function o(...a){const f=[].concat(...a.map(c));return[...new Map(f.filter(b=>b.st==="0A").map(b=>{const d=b.local_address.split(":");return{socket:parseInt(b.inode,10),ip:g(d[0]),port:parseInt(d[1],16)}}).map(b=>[b.ip+":"+b.port,b])).values()]}e.loadListeningPorts=o;function g(a){let f="";if(a.length===8)for(let b=a.length-2;b>=0;b-=2)f+=parseInt(a.substr(b,2),16),b!==0&&(f+=".");else for(let b=a.length-4;b>=0;b-=4)f+=parseInt(a.substr(b,4),16).toString(16),b!==0&&(f+=":");return f}e.parseIpAddress=g;function c(a){const f=a.trim().split(`
`),b=f.shift().trim().split(/\s+/).filter(D=>D!=="rx_queue"&&D!=="tm->when");return f.map(D=>D.trim().split(/\s+/).reduce((R,N,B)=>(R[b[B]||B]=N,R),{}))}e.loadConnectionTable=c;function S(a){return!!a.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||a.indexOf("out/vs/server/main.js")!==-1||a.indexOf("_productName=VSCode")!==-1}function r(a){const f=a.trim().split(`
`),b=[];return f.forEach(d=>{const D=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(d);D&&D.length>=4&&b.push({pid:parseInt(D[1],10),ppid:parseInt(D[2]),cmd:D[3]})}),b}e.getRootProcesses=r;async function t(a,f,b){const d=b.reduce((R,N)=>(R[N.pid]=N,R),{}),D=[];return a.forEach(({socket:R,ip:N,port:B})=>{const F=f[R]?f[R].pid:void 0,O=F?d[F]?.cmd:void 0;F&&O&&!S(O)&&D.push({host:N,port:B,detail:O,pid:F})}),D}e.findPorts=t;function n(a,f,b){const d=new Map,D=r(f);for(const R of a){const N=b.get(R.port);if(N){d.set(R.port,N);continue}const B=D.find(F=>F.cmd.includes(`${R.port}`));if(B){let F=B,O;do O=D.find(z=>z.ppid===F.pid),O&&(F=O);while(O);d.set(R.port,{host:R.ip,port:R.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else d.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return d}e.tryFindRootPorts=n;let u=class extends C.Disposable{constructor(f,b,d){super();this.logService=d,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new h.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=f.getProxy(m.MainContext.MainThreadTunnelService),l.isLinux&&b.remote.isRemote&&b.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(f,b){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${f.identifier.value} called openTunnel API for ${b.remoteAddress.host}:${b.remoteAddress.port}.`);const d=await this._proxy.$openTunnel(b,f.displayName);if(d){const D=new w(d.remoteAddress,d.localAddress,()=>this._proxy.$closeTunnel(d.remoteAddress));return this._register(D),D}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(f){return Math.max(f*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(f,b){const d=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(d,{selector:f,provider:b}),this._proxy.$registerPortsAttributesProvider(f,d),new T.Disposable(()=>{this._portAttributesProviders.delete(d),this._proxy.$unregisterPortsAttributesProvider(d)})}async $providePortAttributes(f,b,d,D,R){const N=[];for(const F of f){const O=this._portAttributesProviders.get(F);if(!O)return[];N.push(...await Promise.all(b.map(async z=>O.provider.providePortAttributes(z,d,D,R))))}const B=N.filter(F=>!!F);return B.length>0?B.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(f){if(f&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=f;let b=new v.MovingAverage,d;for(;this._candidateFindingEnabled;){const D=new Date().getTime(),R=(await this.findCandidatePorts()).filter(B=>(0,p.isLocalhost)(B.host)||(0,p.isAllInterfaces)(B.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(B=>B.port).join(", ")}`);const N=new Date().getTime()-D;b.update(N),(!d||JSON.stringify(d)!==JSON.stringify(R))&&(d=R,await this._proxy.$onFoundNewCandidates(d)),await new Promise(B=>setTimeout(()=>B(),this.calculateDelay(b.value)))}}async setTunnelExtensionFunctions(f){if(f){if(f.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(f.candidatePortSource),f.showCandidatePort&&(this._showCandidatePort=f.showCandidatePort,this._proxy.$setCandidateFilter()),f.tunnelFactory){this._forwardPortProvider=f.tunnelFactory;let b=f.tunnelFeatures?.privacyOptions??[];f.tunnelFeatures?.public&&b.length===0&&(b=[{id:"private",label:y.localize(0,null),themeIcon:"lock"},{id:"public",label:y.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!f.tunnelFeatures?.elevation,public:!!f.tunnelFeatures?.public,privacyOptions:b})}}else this._forwardPortProvider=void 0;return(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(f,b){if(this._extensionTunnels.has(f.host)){const d=this._extensionTunnels.get(f.host);d.has(f.port)&&(b&&d.get(f.port).disposeListener.dispose(),await d.get(f.port).tunnel.dispose(),d.delete(f.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(f,b){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const d=this._forwardPortProvider(f,b);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),d!==void 0){const D=await d;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(f.remoteAddress.host)||this._extensionTunnels.set(f.remoteAddress.host,new Map);const R=this._register(D.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(D.remoteAddress))));return this._extensionTunnels.get(f.remoteAddress.host).set(f.remoteAddress.port,{tunnel:D,disposeListener:R}),E.TunnelDto.fromApiTunnel(D)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(f){const b=await Promise.all(f.map(D=>this._showCandidatePort(D.host,D.port,D.detail??""))),d=f.filter((D,R)=>b[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${f.map(D=>D.port).join(", ")} to ${d.map(D=>D.port).join(", ")}`),d}async findCandidatePorts(){let f="",b="";try{f=await L.Promises.readFile("/proc/net/tcp","utf8"),b=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const d=o(f,b),D=await new Promise(M=>{(0,_.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(x,V,U)=>{M(V)})}),R=s(D),N=await L.Promises.readdir("/proc"),B=[];for(let M of N)try{const x=Number(M),V=I.joinPath(k.URI.file("/proc"),M);if((await L.Promises.stat(V.fsPath)).isDirectory()&&!isNaN(x)){const H=await L.Promises.readlink(I.joinPath(V,"cwd").fsPath),X=await L.Promises.readFile(I.joinPath(V,"cmdline").fsPath,"utf8");B.push({pid:x,cwd:H,cmd:X})}}catch{}const F=[],O=d.filter(M=>{const x=R[M.socket];return x||F.push(M),x}),z=t(O,R,B);let W;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const M=await new Promise(x=>{(0,_.exec)("ps -F -A -l | grep root",(V,U,H)=>{x(U)})});this._foundRootPorts=n(F,M,this._foundRootPorts),W=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${W.join(", ")}`)}return z.then(M=>W?M.concat(W):M)}};u=je([ze(0,i.IExtHostRpcService),ze(1,P.IExtHostInitDataService),ze(2,A.ILogService)],u),e.ExtHostTunnelService=u}),define(we[263],be([0,1,18,22,21,15,3,6,102,227,53]),function(Y,e,m,i,y,C,P,k,_,I,L){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function l(d,D){try{return JSON.stringify(d,D)}catch{return"null"}}const E="$$ref$$",h={[E]:-1};class p{constructor(D,R){this.jsonString=D,this.referencedBuffers=R}}function v(d,D=null,R=!1){const N=[];return{jsonString:(R?l:JSON.stringify)(d,(F,O)=>{if(typeof O=="undefined")return h;if(typeof O=="object"){if(O instanceof i.VSBuffer){const z=N.push(O)-1;return{[E]:z}}if(D)return D(F,O)}return O}),referencedBuffers:N}}e.stringifyJsonWithBufferRefs=v;function A(d,D,R){return JSON.parse(d,(N,B)=>{if(B){const F=B[E];if(typeof F=="number")return D[F];if(R&&B.$mid===1)return R.transformIncoming(B)}return B})}e.parseJsonAndRestoreBufferRefs=A;function w(d,D){return JSON.stringify(d,D)}function s(d){return d?(D,R)=>R&&R.$mid===1?d.transformOutgoing(R):R:null}var o;(function(d){d[d.LocalSide=0]="LocalSide",d[d.OtherSide=1]="OtherSide"})(o=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(d){d[d.Responsive=0]="Responsive",d[d.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const c=()=>{},S=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class t extends k.Disposable{constructor(D,R=null,N=null){super();this[T]=!0,this._onDidChangeResponsiveState=this._register(new P.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=D,this._logger=R,this._uriTransformer=N,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let B=0,F=L.ProxyIdentifier.count;B<F;B++)this._locals[B]=null,this._proxies[B]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(B=>this._receiveOneMessage(B))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(D=>{this._pendingRPCReplies[D].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(D){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(D){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(D){this._responsiveState!==D&&(this._responsiveState=D,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(D){return this._uriTransformer?(0,_.transformIncomingURIs)(D,this._uriTransformer):D}getProxy(D){const{nid:R,sid:N}=D;return this._proxies[R]||(this._proxies[R]=this._createProxy(R,N)),this._proxies[R]}_createProxy(D,R){let N={get:(B,F)=>(typeof F=="string"&&!B[F]&&F.charCodeAt(0)===36&&(B[F]=(...O)=>this._remoteCall(D,F,O)),F===r?R:B[F])};return new Proxy(Object.create(null),N)}set(D,R){return this._locals[D.nid]=R,R}assertRegistered(D){for(let R=0,N=D.length;R<N;R++){const B=D[R];if(!this._locals[B.nid])throw new Error(`Missing actor ${B.sid} (isMain: ${B.isMain})`)}}_receiveOneMessage(D){if(this._isDisposed)return;const R=D.byteLength,N=n.read(D,0),B=N.readUInt8(),F=N.readUInt32();switch(B){case 1:case 2:{let{rpcId:O,method:z,args:W}=a.deserializeRequestJSONArgs(N);this._uriTransformer&&(W=(0,_.transformIncomingURIs)(W,this._uriTransformer)),this._receiveRequest(R,F,O,z,W,B===2);break}case 3:case 4:{let{rpcId:O,method:z,args:W}=a.deserializeRequestMixedArgs(N);this._uriTransformer&&(W=(0,_.transformIncomingURIs)(W,this._uriTransformer)),this._receiveRequest(R,F,O,z,W,B===4);break}case 5:{this._logger&&this._logger.logIncoming(R,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(R,F);break}case 7:{this._receiveReply(R,F,void 0);break}case 9:{let O=a.deserializeReplyOKJSON(N);this._uriTransformer&&(O=(0,_.transformIncomingURIs)(O,this._uriTransformer)),this._receiveReply(R,F,O);break}case 10:{const O=a.deserializeReplyOKJSONWithBuffers(N,this._uriTransformer);this._receiveReply(R,F,O);break}case 8:{let O=a.deserializeReplyOKVSBuffer(N);this._receiveReply(R,F,O);break}case 11:{let O=a.deserializeReplyErrError(N);this._uriTransformer&&(O=(0,_.transformIncomingURIs)(O,this._uriTransformer)),this._receiveReplyErr(R,F,O);break}case 12:{this._receiveReplyErr(R,F,void 0);break}default:console.error("received unexpected message"),console.error(D)}}_receiveRequest(D,R,N,B,F,O){this._logger&&this._logger.logIncoming(D,R,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(N)}.${B}(`,F);const z=String(R);let W,M;if(O){const V=new y.CancellationTokenSource;F.push(V.token),W=this._invokeHandler(N,B,F),M=()=>V.cancel()}else W=this._invokeHandler(N,B,F),M=c;this._cancelInvokedHandlers[z]=M;const x=a.serializeAcknowledged(R);this._logger&&this._logger.logOutgoing(x.byteLength,R,1,"ack"),this._protocol.send(x),W.then(V=>{delete this._cancelInvokedHandlers[z];const U=a.serializeReplyOK(R,V,this._uriReplacer);this._logger&&this._logger.logOutgoing(U.byteLength,R,1,"reply:",V),this._protocol.send(U)},V=>{delete this._cancelInvokedHandlers[z];const U=a.serializeReplyErr(R,V);this._logger&&this._logger.logOutgoing(U.byteLength,R,1,"replyErr:",V),this._protocol.send(U)})}_receiveCancel(D,R){this._logger&&this._logger.logIncoming(D,R,1,"receiveCancel");const N=String(R);this._cancelInvokedHandlers[N]&&this._cancelInvokedHandlers[N]()}_receiveReply(D,R,N){this._logger&&this._logger.logIncoming(D,R,0,"receiveReply:",N);const B=String(R);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const F=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B],F.resolveOk(N)}_receiveReplyErr(D,R,N){this._logger&&this._logger.logIncoming(D,R,0,"receiveReplyErr:",N);const B=String(R);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const F=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B];let O;N&&(N.$isError?(O=new Error,O.name=N.name,O.message=N.message,O.stack=N.stack):O=N),F.resolveErr(O)}_invokeHandler(D,R,N){try{return Promise.resolve(this._doInvokeHandler(D,R,N))}catch(B){return Promise.reject(B)}}_doInvokeHandler(D,R,N){const B=this._locals[D];if(!B)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(D));let F=B[R];if(typeof F!="function")throw new Error("Unknown method "+R+" on actor "+(0,L.getStringIdentifierForProxy)(D));return F.apply(B,N)}_remoteCall(D,R,N){if(this._isDisposed)return Promise.reject(C.canceled());let B=null;if(N.length>0&&y.CancellationToken.isCancellationToken(N[N.length-1])&&(B=N.pop()),B&&B.isCancellationRequested)return Promise.reject(C.canceled());const F=a.serializeRequestArguments(N,this._uriReplacer),O=++this._lastMessageId,z=String(O),W=new I.LazyPromise;B&&B.onCancellationRequested(()=>{const x=a.serializeCancel(O);this._logger&&this._logger.logOutgoing(x.byteLength,O,0,"cancel"),this._protocol.send(a.serializeCancel(O))}),this._pendingRPCReplies[z]=W,this._onWillSendRequest(O);const M=a.serializeRequest(O,D,R,F,!!B);return this._logger&&this._logger.logOutgoing(M.byteLength,O,0,`request: ${(0,L.getStringIdentifierForProxy)(D)}.${R}(`,N),this._protocol.send(M),W}}e.RPCProtocol=t,T=S,t.UNRESPONSIVE_TIME=3*1e3;class n{constructor(D,R){this._buff=D,this._offset=R}static alloc(D,R,N){let B=new n(i.VSBuffer.alloc(N+1+4),0);return B.writeUInt8(D),B.writeUInt32(R),B}static read(D,R){return new n(D,R)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(D){this._buff.writeUInt8(D,this._offset),this._offset+=1}readUInt8(){const D=this._buff.readUInt8(this._offset);return this._offset+=1,D}writeUInt32(D){this._buff.writeUInt32BE(D,this._offset),this._offset+=4}readUInt32(){const D=this._buff.readUInt32BE(this._offset);return this._offset+=4,D}static sizeShortString(D){return 1+D.byteLength}writeShortString(D){this._buff.writeUInt8(D.byteLength,this._offset),this._offset+=1,this._buff.set(D,this._offset),this._offset+=D.byteLength}readShortString(){const D=this._buff.readUInt8(this._offset);this._offset+=1;const N=this._buff.slice(this._offset,this._offset+D).toString();return this._offset+=D,N}static sizeLongString(D){return 4+D.byteLength}writeLongString(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}readLongString(){const D=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+D).toString();return this._offset+=D,N}writeBuffer(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}static sizeVSBuffer(D){return 4+D.byteLength}writeVSBuffer(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}readVSBuffer(){const D=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+D);return this._offset+=D,R}static sizeMixedArray(D){let R=0;R+=1;for(let N=0,B=D.length;N<B;N++){const F=D[N];switch(R+=1,F.type){case 1:R+=this.sizeLongString(F.value);break;case 2:R+=this.sizeVSBuffer(F.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(F.value);for(let O=0;O<F.buffers.length;++O)R+=this.sizeVSBuffer(F.buffers[O]);break;case 4:break}}return R}writeMixedArray(D){this._buff.writeUInt8(D.length,this._offset),this._offset+=1;for(let R=0,N=D.length;R<N;R++){const B=D[R];switch(B.type){case 1:this.writeUInt8(1),this.writeLongString(B.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(B.value);break;case 3:this.writeUInt8(3),this.writeUInt32(B.buffers.length),this.writeLongString(B.value);for(let F=0;F<B.buffers.length;++F)this.writeBuffer(B.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const D=this._buff.readUInt8(this._offset);this._offset+=1;let R=new Array(D);for(let N=0;N<D;N++)switch(this.readUInt8()){case 1:R[N]=this.readLongString();break;case 2:R[N]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),O=this.readLongString(),z=[];for(let W=0;W<F;++W)z.push(this.readVSBuffer());R[N]=new L.SerializableObjectWithBuffers(A(O,z,null));break}case 4:R[N]=void 0;break}return R}}n.sizeUInt32=4;var u;(function(d){d[d.Simple=0]="Simple",d[d.Mixed=1]="Mixed"})(u||(u={}));class a{static _useMixedArgSerialization(D){for(let R=0,N=D.length;R<N;R++)if(D[R]instanceof i.VSBuffer||D[R]instanceof L.SerializableObjectWithBuffers||typeof D[R]=="undefined")return!0;return!1}static serializeRequestArguments(D,R){if(this._useMixedArgSerialization(D)){const N=[];for(let B=0,F=D.length;B<F;B++){const O=D[B];if(O instanceof i.VSBuffer)N[B]={type:2,value:O};else if(typeof O=="undefined")N[B]={type:4};else if(O instanceof L.SerializableObjectWithBuffers){const{jsonString:z,referencedBuffers:W}=v(O.value,R);N[B]={type:3,value:i.VSBuffer.fromString(z),buffers:W}}else N[B]={type:1,value:i.VSBuffer.fromString(w(O,R))}}return{type:1,args:N}}return{type:0,args:w(D,R)}}static serializeRequest(D,R,N,B,F){switch(B.type){case 0:return this._requestJSONArgs(D,R,N,B.args,F);case 1:return this._requestMixedArgs(D,R,N,B.args,F)}}static _requestJSONArgs(D,R,N,B,F){const O=i.VSBuffer.fromString(N),z=i.VSBuffer.fromString(B);let W=0;W+=n.sizeUInt8(),W+=n.sizeShortString(O),W+=n.sizeLongString(z);let M=n.alloc(F?2:1,D,W);return M.writeUInt8(R),M.writeShortString(O),M.writeLongString(z),M.buffer}static deserializeRequestJSONArgs(D){const R=D.readUInt8(),N=D.readShortString(),B=D.readLongString();return{rpcId:R,method:N,args:JSON.parse(B)}}static _requestMixedArgs(D,R,N,B,F){const O=i.VSBuffer.fromString(N);let z=0;z+=n.sizeUInt8(),z+=n.sizeShortString(O),z+=n.sizeMixedArray(B);let W=n.alloc(F?4:3,D,z);return W.writeUInt8(R),W.writeShortString(O),W.writeMixedArray(B),W.buffer}static deserializeRequestMixedArgs(D){const R=D.readUInt8(),N=D.readShortString(),B=D.readMixedArray(),F=new Array(B.length);for(let O=0,z=B.length;O<z;O++){const W=B[O];typeof W=="string"?F[O]=JSON.parse(W):F[O]=W}return{rpcId:R,method:N,args:F}}static serializeAcknowledged(D){return n.alloc(5,D,0).buffer}static serializeCancel(D){return n.alloc(6,D,0).buffer}static serializeReplyOK(D,R,N){if(typeof R=="undefined")return this._serializeReplyOKEmpty(D);if(R instanceof i.VSBuffer)return this._serializeReplyOKVSBuffer(D,R);if(R instanceof L.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:F}=v(R.value,N,!0);return this._serializeReplyOKJSONWithBuffers(D,B,F)}else return this._serializeReplyOKJSON(D,l(R,N))}static _serializeReplyOKEmpty(D){return n.alloc(7,D,0).buffer}static _serializeReplyOKVSBuffer(D,R){let N=0;N+=n.sizeVSBuffer(R);let B=n.alloc(8,D,N);return B.writeVSBuffer(R),B.buffer}static deserializeReplyOKVSBuffer(D){return D.readVSBuffer()}static _serializeReplyOKJSON(D,R){const N=i.VSBuffer.fromString(R);let B=0;B+=n.sizeLongString(N);let F=n.alloc(9,D,B);return F.writeLongString(N),F.buffer}static _serializeReplyOKJSONWithBuffers(D,R,N){const B=i.VSBuffer.fromString(R);let F=0;F+=n.sizeUInt32,F+=n.sizeLongString(B);for(const z of N)F+=n.sizeVSBuffer(z);let O=n.alloc(10,D,F);O.writeUInt32(N.length),O.writeLongString(B);for(const z of N)O.writeBuffer(z);return O.buffer}static deserializeReplyOKJSON(D){const R=D.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(D,R){const N=D.readUInt32(),B=D.readLongString(),F=[];for(let O=0;O<N;++O)F.push(D.readVSBuffer());return new L.SerializableObjectWithBuffers(A(B,F,R))}static serializeReplyErr(D,R){return R?this._serializeReplyErrEror(D,R):this._serializeReplyErrEmpty(D)}static _serializeReplyErrEror(D,R){const N=i.VSBuffer.fromString(l(C.transformErrorForSerialization(R),null));let B=0;B+=n.sizeLongString(N);let F=n.alloc(11,D,B);return F.writeLongString(N),F.buffer}static deserializeReplyErrError(D){const R=D.readLongString();return JSON.parse(R)}static _serializeReplyErrEmpty(D){return n.alloc(12,D,0).buffer}}var f;(function(d){d[d.RequestJSONArgs=1]="RequestJSONArgs",d[d.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",d[d.RequestMixedArgs=3]="RequestMixedArgs",d[d.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",d[d.Acknowledged=5]="Acknowledged",d[d.Cancel=6]="Cancel",d[d.ReplyOKEmpty=7]="ReplyOKEmpty",d[d.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",d[d.ReplyOKJSON=9]="ReplyOKJSON",d[d.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",d[d.ReplyErrError=11]="ReplyErrError",d[d.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var b;(function(d){d[d.String=1]="String",d[d.VSBuffer=2]="VSBuffer",d[d.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",d[d.Undefined=4]="Undefined"})(b||(b={}))}),define(we[264],be([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService")}),define(we[265],be([0,1,10,9,12,2,4,62,43,222,264]),function(Y,e,m,i,y,C,P,k,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,P.createDecorator)("pathService");let T=class Vi{constructor(E,h,p,v){this.localUserHome=E,this.remoteAgentService=h,this.environmentService=p,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||y.OS)(),this.resolveUserHome=(async()=>{const A=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=A?.userHome||E})()}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(E,h){if(E.remoteAuthority)return m.Schemas.vscodeRemote;const p=(0,k.getVirtualWorkspaceScheme)(h.getWorkspace());if(p)return p;const v=h.getWorkspace().folders[0];if(v)return v.uri.scheme;const A=h.getWorkspace().configuration;return A?A.scheme:m.Schemas.file}async userHome(E){return E?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(E=>E===1?i.win32:i.posix)}async fileURI(E){let h="";if(await this.resolveOS===1&&(E=E.replace(/\\/g,"/")),E[0]==="/"&&E[1]==="/"){const v=E.indexOf("/",2);v===-1?(h=E.substring(2),E="/"):(h=E.substring(2,v),E=E.substring(v)||"/")}return C.URI.from({scheme:m.Schemas.file,authority:h,path:E,query:"",fragment:""})}};T=je([ze(1,L.IRemoteAgentService),ze(2,I.IWorkbenchEnvironmentService),ze(3,_.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(we[69],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(P,k){this.line=P,this.character=k}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,k){return new m(0,0)}with(P){return new m(0,0)}}e.Position=m;class i{constructor(P,k,_,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(P,k),this.end=new m(_,I)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new i(0,0,0,0)}with(P){return new i(0,0,0,0)}}e.Range=i;var y;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[32],be([0,1,16,31,25,30,8,4,9,15,69,13]),function(Y,e,m,i,y,C,P,k,_,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const l="\u27EA ",E=" characters skipped \u27EB",h=(l.length+E.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var p;(function(x){x[x.file=0]="file",x[x.text=1]="text"})(p=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(x){x[x.File=1]="File",x[x.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function A(x){return!!x.preview}e.resultIsMatch=A;function w(x){return!!x.resource}e.isFileMatch=w;function s(x){return!!x.message}e.isProgressMessage=s;var o;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(o=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(V){this.resource=V,this.results=[]}}e.FileMatch=g;class c{constructor(V,U,H){this.ranges=U;const X=Array.isArray(U)?U:[U];if(H&&H.matchLines===1&&S(X)){V=(0,P.getNLines)(V,H.matchLines);let se="",K=0,j=0;const ie=Math.floor(H.charsPerLine/5),ce=[];for(const ge of X){const ke=Math.max(ge.startColumn-ie,0),Le=ge.startColumn+H.charsPerLine;if(ke>j+ie+h){const Oe=l+(ke-j)+E;se+=Oe+V.slice(ke,Le),K+=ke-(j+Oe.length)}else se+=V.slice(j,Le);ce.push(new t(0,ge.startColumn-K,ge.endColumn-K)),j=Le}this.preview={text:se,matches:Array.isArray(this.ranges)?ce:ce[0]}}else{const se=Array.isArray(U)?U[0].startLineNumber:U.startLineNumber;this.preview={text:V,matches:(0,m.mapArrayOrNot)(U,K=>new r(K.startLineNumber-se,K.startColumn,K.endLineNumber-se,K.endColumn))}}}}e.TextSearchMatch=c;function S(x){const V=x[0].startLineNumber;for(const U of x)if(U.startLineNumber!==V||U.endLineNumber!==V)return!1;return!0}class r{constructor(V,U,H,X){this.startLineNumber=V,this.startColumn=U,this.endLineNumber=H,this.endColumn=X}}e.SearchRange=r;class t extends r{constructor(V,U,H){super(V,U,V,H)}}e.OneLineRange=t;var n;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function u(x,V=!0){const U=x&&x.files&&x.files.exclude,H=V&&x&&x.search&&x.search.exclude;if(!U&&!H)return;if(!U||!H)return U||H;let X=Object.create(null);return X=y.mixin(X,y.deepClone(U)),X=y.mixin(X,y.deepClone(H),!0),X}e.getExcludes=u;function a(x,V){return x.excludePattern&&i.match(x.excludePattern,V)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&i.match(x.includePattern,V)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(U=>{const H=U.folder.fsPath;if(C.isEqualOrParent(V,H)){const X=_.relative(H,V);return!U.includePattern||!!i.match(U.includePattern,X)}else return!1}):!1:!0}e.pathIncludedInQuery=a;var f;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class b extends Error{constructor(V,U){super(V);this.code=U}}e.SearchError=b;function d(x){const V=x.message;if((0,I.isPromiseCanceledError)(x))return new b(V,f.canceled);try{const U=JSON.parse(V);return new b(U.message,U.code)}catch{return new b(V,f.other)}}e.deserializeSearchError=d;function D(x){const V={message:x.message,code:x.code};return new Error(JSON.stringify(V))}e.serializeSearchError=D;function R(x){return x.type==="error"?!0:x.type==="success"}e.isSerializedSearchComplete=R;function N(x){return x.type==="success"}e.isSerializedSearchSuccess=N;function B(x){return!!x.path}e.isSerializedFileMatch=B;function F(x,V){const U=x.searchPath?x.searchPath:x.relativePath;return(0,P.fuzzyContains)(U,V)}e.isFilePatternMatch=F;class O{constructor(V){this.path=V,this.results=[]}addMatch(V){this.results.push(V)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function z(x,V){const U={...x||{},...V||{}};return Object.keys(U).filter(H=>{const X=U[H];return typeof X=="boolean"&&X})}e.resolvePatternsForProvider=z;class W{constructor(V,U){this._parsedIncludeExpression=null,this._excludeExpression={...V.excludePattern||{},...U.excludePattern||{}},this._parsedExcludeExpression=i.parse(this._excludeExpression);let H=V.includePattern;U.includePattern&&(H?H={...H,...U.includePattern}:H=U.includePattern),H&&(this._parsedIncludeExpression=i.parse(H))}matchesExcludesSync(V,U,H){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,U,H))}includedInQuerySync(V,U,H){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,U,H)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(V,U,H))}includedInQuery(V,U,H){const X=this._parsedExcludeExpression(V,U,H),se=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(V,U,H):!0;return(0,T.isPromise)(X)?X.then(K=>K?!1:se()):se()}hasSiblingExcludeClauses(){return M(this._excludeExpression)}}e.QueryGlobTester=W;function M(x){for(const V in x)if(typeof x[V]!="boolean")return!0;return!1}}),define(we[35],be([0,1,16,18,21,3,24,10,78,23,8,13,2,168,4,11,188,43,44,26,14,7,32,5]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v,A,w,s,o,g,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(D,R,N){return new I.ExtUri(B=>a(B,N)).isEqual(D,R)}function t(D,R,N){return r(D.uri,R.uri,N)?0:(0,L.compare)(D.uri.toString(),R.uri.toString())}function n(D,R,N){return D.index!==R.index?D.index<R.index?-1:1:r(D.uri,R.uri,N)?(0,L.compare)(D.name,R.name):(0,L.compare)(D.uri.toString(),R.uri.toString())}function u(D,R,N,B){const F=D.slice(0).sort((z,W)=>N(z,W,B)),O=R.slice(0).sort((z,W)=>N(z,W,B));return(0,m.delta)(F,O,(z,W)=>N(z,W,B))}function a(D,R){const N=R.getCapabilities(D.scheme);return!(N&&N&1024)}class f extends A.Workspace{constructor(R,N,B,F,O,z,W){super(R,B.map(M=>new A.WorkspaceFolder(M)),F,O,W);this._name=N,this._isUntitled=z,this._workspaceFolders=[],this._structure=P.TernarySearchTree.forUris(W),B.forEach(M=>{this._workspaceFolders.push(M),this._structure.set(M.uri,M)})}static toExtHostWorkspace(R,N,B,F){if(!R)return{workspace:null,added:[],removed:[]};const{id:O,name:z,folders:W,configuration:M,transient:x,isUntitled:V}=R,U=[],H=N;N?W.forEach((j,ie)=>{const ce=l.URI.revive(j.uri),ge=f._findFolder(B||N,ce,F);ge?(ge.name=j.name,ge.index=j.index,U.push(ge)):U.push({uri:ce,name:j.name,index:ie})}):U.push(...W.map(({uri:j,name:ie,index:ce})=>({uri:l.URI.revive(j),name:ie,index:ce}))),U.sort((j,ie)=>j.index<ie.index?-1:1);const X=new f(O,z,U,!!x,M?l.URI.revive(M):null,!!V,j=>a(j,F)),{added:se,removed:K}=u(H?H.workspaceFolders:[],X.workspaceFolders,t,F);return{workspace:X,added:se,removed:K}}static _findFolder(R,N,B){for(let F=0;F<R.folders.length;F++){const O=R.workspaceFolders[F];if(r(O.uri,N,B))return O}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,N){return N&&this._structure.get(R)&&(R=(0,I.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let b=class{constructor(R,N,B,F){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=F,this._extHostFileSystemInfo=B,this._requestIdProvider=new _.Counter,this._barrier=new i.Barrier,this._proxy=R.getProxy(S.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(S.MainContext.MainThreadMessageService);const O=N.workspace;this._confirmedWorkspace=O?new f(O.id,O.name,[],!!O.transient,O.configuration?l.URI.revive(O.configuration):null,!!O.isUntitled,z=>a(z,B)):void 0}$initializeWorkspace(R,N){this._trusted=N,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:k.Schemas.untitled,path:(0,I.basename)((0,I.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,N,B,...F){const O=[];if(Array.isArray(F)&&F.forEach(V=>{l.URI.isUri(V.uri)&&!O.some(U=>r(U.uri,V.uri,this._extHostFileSystemInfo))&&O.push({uri:V.uri,name:V.name||(0,I.basenameOrAuthority)(V.uri)})}),this._unconfirmedWorkspace||[N,B].some(V=>typeof V!="number"||V<0)||B===0&&O.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(N+B>z.length)return!1;const W=z.slice(0);W.splice(N,B,...O.map(V=>({uri:V.uri,name:V.name||(0,I.basenameOrAuthority)(V.uri),index:void 0})));for(let V=0;V<W.length;V++){const U=W[V];if(W.some((H,X)=>X!==V&&r(U.uri,H.uri,this._extHostFileSystemInfo)))return!1}W.forEach((V,U)=>V.index=U);const{added:M,removed:x}=u(z,W,n,this._extHostFileSystemInfo);if(M.length===0&&x.length===0)return!1;if(this._proxy){const V=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(V,N,B,O).then(void 0,U=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(v.Severity.Error,(0,E.localize)(0,null,V,U.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(W),!0}getWorkspaceFolder(R,N){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,N)}async getWorkspaceFolder2(R,N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,N)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,N){let B,F="";if(typeof R=="string"?(B=l.URI.file(R),F=R):typeof R!="undefined"&&(B=R,F=R.fsPath),!B)return F;const O=this.getWorkspaceFolder(B,!0);if(!O)return F;typeof N=="undefined"&&this._actualWorkspace&&(N=this._actualWorkspace.folders.length>1);let z=(0,I.relativePath)(O.uri,B);return N&&O.name&&(z=`${O.name}/${z}`),z}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=f.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:N,added:B,removed:F}=f.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=N||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:B,removed:F}))}findFiles(R,N,B,F,O=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let z;if(N===null?z=!1:N&&(typeof N=="string"?z=N:z=N.pattern),O&&O.isCancellationRequested)return Promise.resolve([]);const{includePattern:W,folder:M}=d(R);return this._proxy.$startFileSearch((0,T.withUndefinedAsNull)(W),(0,T.withUndefinedAsNull)(M),(0,T.withUndefinedAsNull)(z),(0,T.withUndefinedAsNull)(B),O).then(x=>Array.isArray(x)?x.map(V=>l.URI.revive(V)):[])}async findTextInFiles(R,N,B,F,O=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),W=typeof N.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:M,folder:x}=d(N.include),V=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,U={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:W,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:M,excludePattern:V},H=!1;if(this._activeSearchCallbacks[z]=X=>{if(H)return;const se=l.URI.revive(X.resource);X.results.forEach(K=>{(0,c.resultIsMatch)(K)?B({uri:se,preview:{text:K.preview.text,matches:(0,m.mapArrayOrNot)(K.preview.matches,j=>new g.Range(j.startLineNumber,j.startColumn,j.endLineNumber,j.endColumn))},ranges:(0,m.mapArrayOrNot)(K.ranges,j=>new g.Range(j.startLineNumber,j.startColumn,j.endLineNumber,j.endColumn))}):B({uri:se,text:K.text,lineNumber:K.lineNumber})})},O.isCancellationRequested)return{};try{const X=await this._proxy.$startTextSearch(R,(0,T.withUndefinedAsNull)(x),U,z,O);return delete this._activeSearchCallbacks[z],X||{}}catch(X){throw delete this._activeSearchCallbacks[z],X}}$handleTextSearchResult(R,N){this._activeSearchCallbacks[N]&&this._activeSearchCallbacks[N](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};b=je([ze(0,o.IExtHostRpcService),ze(1,s.IExtHostInitDataService),ze(2,w.IExtHostFileSystemInfo),ze(3,p.ILogService)],b),e.ExtHostWorkspace=b,e.IExtHostWorkspace=(0,h.createDecorator)("IExtHostWorkspace");function d(D){let R,N;return D&&(typeof D=="string"?R=D:(R=D.pattern,N=D.baseFolder||l.URI.file(D.base))),{includePattern:R,folder:N}}}),define(we[36],be([0,1,25,3,35,5,7,192,118,13,18,4,14,11,2]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function p(S,r){if(r){const t=r.split(".");let n=S;for(let u=0;n&&u<t.length;u++)n=n[t[u]];return n}}function v(S){return S instanceof h.URI}function A(S){return S&&S.uri instanceof h.URI&&S.languageId&&typeof S.languageId=="string"}function w(S){return S&&!S.uri&&S.languageId&&typeof S.languageId=="string"}function s(S){return S&&S.uri instanceof h.URI&&(!S.name||typeof S.name=="string")&&(!S.index||typeof S.index=="number")}function o(S){if(v(S))return{resource:S};if(A(S))return{resource:S.uri,overrideIdentifier:S.languageId};if(w(S))return{overrideIdentifier:S.languageId};if(s(S))return{resource:S.uri};if(S===null)return{resource:null}}let g=class{constructor(r,t,n){this._proxy=r.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=n,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new c(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,t){this.getConfigProvider().then(n=>n.$acceptConfigurationChanged(r,t))}};g=je([ze(0,l.IExtHostRpcService),ze(1,y.IExtHostWorkspace),ze(2,E.ILogService)],g),e.ExtHostConfiguration=g;class c{constructor(r,t,n,u){this._onDidChangeConfiguration=new i.Emitter,this._proxy=r,this._logService=u,this._extHostWorkspace=t,this._configuration=k.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,t){const n={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,n))}getConfiguration(r,t,n){const u=o(t)||{},a=this._toReadonlyValue(r?p(this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,u,n?.identifier);function f(d){if(d==null)return null;if(typeof d=="boolean")return d?1:4;switch(d){case P.ConfigurationTarget.Global:return 1;case P.ConfigurationTarget.Workspace:return 4;case P.ConfigurationTarget.WorkspaceFolder:return 5}}const b={has(d){return typeof p(a,d)!="undefined"},get:(d,D)=>{this._validateConfigurationAccess(r?`${r}.${d}`:d,u,n?.identifier);let R=p(a,d);if(typeof R=="undefined")R=D;else{let N;const B=(F,O)=>{let z;const W=()=>{N=N||(0,m.deepClone)(a),z=z||p(N,O)};return(0,I.isObject)(F)?new Proxy(F,{get:(M,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return W(),()=>z;if(N)return z=z||p(N,O),z[x];const V=M[x];return typeof x=="string"?B(V,`${O}.${x}`):V},set:(M,x,V)=>(W(),z&&(z[x]=V),!0),deleteProperty:(M,x)=>(W(),z&&delete z[x],!0),defineProperty:(M,x,V)=>(W(),z&&Object.defineProperty(z,x,V),!0)}):F};R=B(R,d)}return R},update:(d,D,R,N)=>{d=r?`${r}.${d}`:d;const B=f(R);return D!==void 0?this._proxy.$updateConfigurationOption(B,d,D,u,N):this._proxy.$removeConfigurationOption(B,d,u,N)},inspect:d=>{d=r?`${r}.${d}`:d;const D=(0,m.deepClone)(this._configuration.inspect(d,u,this._extHostWorkspace.workspace));if(D)return{key:d,defaultValue:D.default?.value,globalValue:D.user?.value,workspaceValue:D.workspace?.value,workspaceFolderValue:D.workspaceFolder?.value,defaultLanguageValue:D.default?.override,globalLanguageValue:D.user?.override,workspaceLanguageValue:D.workspace?.override,workspaceFolderLanguageValue:D.workspaceFolder?.override,languageIds:D.overrideIdentifiers}}};return typeof a=="object"&&(0,m.mixin)(b,a,!1),Object.freeze(b)}_toReadonlyValue(r){const t=n=>(0,I.isObject)(n)?new Proxy(n,{get:(u,a)=>t(u[a]),set:(u,a,f)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(a)}' of object`)},deleteProperty:(u,a)=>{throw new Error(`TypeError: Cannot delete read only property '${String(a)}' of object`)},defineProperty:(u,a)=>{throw new Error(`TypeError: Cannot define property '${String(a)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):n;return t(r)}_validateConfigurationAccess(r,t,n){const u=_.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),a=n?`[${n.value}] `:"";if(u===4){typeof t?.resource=="undefined"&&this._logService.warn(`${a}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){t?.resource&&this._logService.warn(`${a}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,t){const n=new k.ConfigurationChangeEvent(r,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(u,a)=>n.affectsConfiguration(u,o(a))})}_toMap(r){return r.reduce((t,n)=>(t.set(n[0],n[1]),t),new Map)}}e.ExtHostConfigProvider=c,e.IExtHostConfiguration=(0,T.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},xe=this&&this.__classPrivateFieldGet||function(Y,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(Y):i?i.value:e.get(Y)};define(we[70],be([0,1,2,18,3,5,7,35,45,36,21,34,14,26,4,10,12,11,65,212,15]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v,A,w,s,o){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var c;(function(O){function z(M){if(M!=null)return M}O.from=z;function W(M){if(M!=null)return M}O.to=W})(c=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var S;(function(O){function z(M){if(M!=null)return M}O.from=z;function W(M){if(M!=null)return M}O.to=W})(S=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(O){function z(M){if(M!=null)return M}O.from=z;function W(M){if(M!=null)return M}O.to=W})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function(O){function z(x){if(x){const V=x;return V&&!!V.process}else return!1}O.is=z;function W(x){if(x==null)return;const V={process:x.process,args:x.args};return x.options&&(V.options=r.from(x.options)),V}O.from=W;function M(x){if(x!=null)return new P.ProcessExecution(x.process,x.args,x.options)}O.to=M})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var n;(function(O){function z(M){if(M!=null)return M}O.from=z;function W(M){if(M!=null)return M}O.to=W})(n=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var u;(function(O){function z(x){if(x){const V=x;return V&&(!!V.commandLine||!!V.command)}else return!1}O.is=z;function W(x){if(x==null)return;const V={};return x.commandLine!==void 0?V.commandLine=x.commandLine:(V.command=x.command,V.args=x.args),x.options&&(V.options=n.from(x.options)),V}O.from=W;function M(x){if(!(x==null||x.command===void 0&&x.commandLine===void 0))return x.commandLine?new P.ShellExecution(x.commandLine,x.options):new P.ShellExecution(x.command,x.args?x.args:[],x.options)}O.to=M})(u=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var a;(function(O){function z(x){if(x){let V=x;return V&&V.customExecution==="customExecution"}else return!1}O.is=z;function W(x){return{customExecution:"customExecution"}}O.from=W;function M(x,V){return V.get(x)}O.to=M})(a=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var f;(function(O){function z(W,M){let x;return W.scope!==void 0&&typeof W.scope!="number"?x=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===P.TaskScope.Workspace&&M&&M.workspaceFile?x=M.workspaceFile:x=s.USER_TASKS_GROUP_KEY),{id:W._id,workspaceFolder:x}}O.from=z})(f=e.TaskHandleDTO||(e.TaskHandleDTO={}));var b;(function(O){function z(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}O.from=z})(b=e.TaskGroupDTO||(e.TaskGroupDTO={}));var d;(function(O){function z(x,V){if(x==null)return[];const U=[];for(let H of x){const X=W(H,V);X&&U.push(X)}return U}O.fromMany=z;function W(x,V){if(x==null)return;let U;x.execution instanceof P.ProcessExecution?U=t.from(x.execution):x.execution instanceof P.ShellExecution?U=u.from(x.execution):x.execution&&x.execution instanceof P.CustomExecution&&(U=a.from(x.execution));const H=c.from(x.definition);let X;return x.scope?typeof x.scope=="number"?X=x.scope:X=x.scope.uri:X=P.TaskScope.Workspace,!H||!X?void 0:{_id:x._id,definition:H,name:x.name,source:{extensionId:V.identifier.value,label:x.source,scope:X},execution:U,isBackground:x.isBackground,group:b.from(x.group),presentationOptions:S.from(x.presentationOptions),problemMatchers:x.problemMatchers,hasDefinedMatchers:x.hasDefinedMatchers,runOptions:x.runOptions?x.runOptions:{reevaluateOnRerun:!0},detail:x.detail}}O.from=W;async function M(x,V,U){if(x==null)return;let H;t.is(x.execution)?H=t.to(x.execution):u.is(x.execution)?H=u.to(x.execution):a.is(x.execution)&&(H=a.to(x._id,U));const X=c.to(x.definition);let se;if(x.source&&(x.source.scope!==void 0?typeof x.source.scope=="number"?se=x.source.scope:se=await V.resolveWorkspaceFolder(m.URI.revive(x.source.scope)):se=P.TaskScope.Workspace),!X||!se)return;const K=new P.Task(X,se,x.name,x.source.label,H,x.problemMatchers);return x.isBackground!==void 0&&(K.isBackground=x.isBackground),x.group!==void 0&&(K.group=P.TaskGroup.from(x.group._id),K.group&&x.group.isDefault&&(K.group=new P.TaskGroup(K.group.id,K.group.label),x.group.isDefault&&(K.group.isDefault=x.group.isDefault))),x.presentationOptions&&(K.presentationOptions=S.to(x.presentationOptions)),x._id&&(K._id=x._id),x.detail&&(K.detail=x.detail),K}O.to=M})(d=e.TaskDTO||(e.TaskDTO={}));var D;(function(O){function z(M){return M}O.from=z;function W(M){if(!!M)return Object.assign(Object.create(null),M)}O.to=W})(D=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(z,W,M){this._id=W,this._task=M,g.set(this,void 0),nt(this,g,z,"f")}get task(){return this._task}terminate(){xe(this,g,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}g=new WeakMap;var N;(function(O){function z(W){return{id:W._id,task:void 0}}O.from=z})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let B=class{constructor(z,W,M,x,V,U,H,X){this._onDidExecuteTask=new y.Emitter,this._onDidTerminateTask=new y.Emitter,this._onDidTaskProcessStarted=new y.Emitter,this._onDidTaskProcessEnded=new y.Emitter,this._proxy=z.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=M,this._editorService=x,this._configurationService=V,this._terminalService=U,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=H,this._deprecationService=X,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,W,M){if(!M)return new P.Disposable(()=>{});const x=this.nextHandle();return this._handlers.set(x,{type:W,provider:M,extension:z}),this._proxy.$registerTaskProvider(x,W),new P.Disposable(()=>{this._handlers.delete(x),this._proxy.$unregisterTaskProvider(x)})}registerTaskSystem(z,W){this._proxy.$registerTaskSystem(z,W)}fetchTasks(z){return this._proxy.$fetchTasks(D.from(z)).then(async W=>{const M=[];for(let x of W){const V=await d.to(x,this._workspaceProvider,this._providedCustomExecutions2);V&&M.push(V)}return M})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(W=>z.push(W)),z}terminateTask(z){if(!(z instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,W,M){const x=this._providedCustomExecutions2.get(z.id);x&&(this._activeCustomExecutions2.set(z.id,x),this._terminalService.attachPtyToTerminal(W,await x.callback(M))),this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const W=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:W})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const W=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:W,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const W=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:W,exitCode:z.exitCode})}$provideTasks(z,W){const M=this._handlers.get(z);if(!M)return Promise.reject(new Error("no handler found"));const x=[],V=(0,i.asPromise)(()=>M.provider.provideTasks(L.CancellationToken.None)).then(U=>this.provideTasksInternal(W,x,M,U));return new Promise(U=>{V.then(H=>{Promise.all(x).then(()=>{U(H)})})})}async $resolveTask(z,W){const M=this._handlers.get(z);if(!M)return Promise.reject(new Error("no handler found"));if(W.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${M.type}].`);const x=await d.to(W,this._workspaceProvider,this._providedCustomExecutions2);if(!x)throw new Error("Unexpected: Task cannot be resolved.");const V=await M.provider.resolveTask(x,L.CancellationToken.None);if(!V)return;this.checkDeprecation(V,M);const U=d.from(V,M.extension);if(!U)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==x.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return a.is(U.execution)&&await this.addCustomExecution(U,V,!0),await this.resolveTaskInternal(U)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,W,M){const x=await this._proxy.$createTaskId(z);!M&&!this._providedCustomExecutions2.has(x)&&(this._notProvidedCustomExecutions.add(x),this._activeCustomExecutions2.set(x,W.execution)),this._providedCustomExecutions2.set(x,W.execution)}async getTaskExecution(z,W){if(typeof z=="string"){const V=this._taskExecutionPromises.get(z);if(!V)throw new Error("Unexpected: The specified task is missing an execution");return V}let M=this._taskExecutionPromises.get(z.id);if(M)return M;const x=new Promise((V,U)=>{function H(X,se,K){K?V(new R(X,se.id,K)):U("Unexpected: Task does not exist.")}W?H(this,z,W):d.to(z.task,this._workspaceProvider,this._providedCustomExecutions2).then(X=>H(this,z,X))});return this._taskExecutionPromises.set(z.id,x),x.then(V=>(this._taskExecutions.set(z.id,V),V),V=>Promise.reject(V))}checkDeprecation(z,W){z._deprecated&&this._deprecationService.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let M=this._notProvidedCustomExecutions.values(),x=M.next();for(;!x.done;)!this._activeCustomExecutions2.has(x.value)&&this._lastStartedTask!==x.value&&(this._providedCustomExecutions2.delete(x.value),this._notProvidedCustomExecutions.delete(x.value)),x=M.next()}};B=je([ze(0,l.IExtHostRpcService),ze(1,E.IExtHostInitDataService),ze(2,k.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,I.IExtHostConfiguration),ze(5,T.IExtHostTerminalService),ze(6,A.ILogService),ze(7,w.IExtHostApiDeprecationService)],B),e.ExtHostTaskBase=B;let F=class extends B{constructor(z,W,M,x,V,U,H,X){super(z,W,M,x,V,U,H,X);this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(z,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const M=d.from(W,z);if(M===void 0)throw new Error("Task is not valid");if(a.is(M.execution))await this.addCustomExecution(M,W,!1);else throw new o.NotSupportedError;const x=await this.getTaskExecution(await this._proxy.$getTaskExecution(M),W);return this._proxy.$executeTask(M).catch(V=>{throw new Error(V)}),x}provideTasksInternal(z,W,M,x){const V=[];if(x)for(let U of x){this.checkDeprecation(U,M),(!U.definition||!z[U.definition.type])&&this._logService.warn(`The task [${U.source}, ${U.name}] uses an undefined task type. The task will be ignored in the future.`);const H=d.from(U,M.extension);H&&a.is(H.execution)?(V.push(H),W.push(this.addCustomExecution(H,U,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:V,extension:M.extension}}async resolveTaskInternal(z){if(a.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,W,M){}};F=je([ze(0,l.IExtHostRpcService),ze(1,E.IExtHostInitDataService),ze(2,k.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,I.IExtHostConfiguration),ze(5,T.IExtHostTerminalService),ze(6,A.ILogService),ze(7,w.IExtHostApiDeprecationService)],F),e.WorkerExtHostTask=F,e.IExtHostTask=(0,h.createDecorator)("IExtHostTask")}),define(we[266],be([0,1,16,74,31,80,24,10,9,23,8,13,2,145,174,115,43,127,265,32]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v,A,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let o=class{constructor(f,b,d,D){this.configurationService=f,this.workspaceContextService=b,this.editorGroupsService=d,this.pathService=D}text(f,b,d={}){f=this.getContentPattern(f,d);const D=this.configurationService.getValue(),R=b&&b.some(B=>!this.configurationService.getValue({resource:B}).search.useRipgrep);return{...this.commonQuery(b?.map(v.toWorkspaceFolder),d),type:2,contentPattern:f,previewOptions:d.previewOptions,maxFileSize:d.maxFileSize,usePCRE2:D.search.usePCRE2||R||!1,beforeContext:d.beforeContext,afterContext:d.afterContext,userDisabledExcludesAndIgnoreFiles:d.disregardExcludeSettings&&d.disregardIgnoreFiles}}getContentPattern(f,b){const d=this.configurationService.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const D={...f,wordSeparators:d.editor.wordSeparators};return this.isCaseSensitive(f,b)&&(D.isCaseSensitive=!0),this.isMultiline(f)&&(D.isMultiline=!0),D}file(f,b={}){return{...this.commonQuery(f,b),type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey}}handleIncludeExclude(f,b){return f?(f=Array.isArray(f)?f.map(t):t(f),b?this.parseSearchPaths(f):{pattern:c(...Array.isArray(f)?f:[f])}):{}}commonQuery(f=[],b={}){const d=this.handleIncludeExclude(b.includePattern,b.expandPatterns),D=this.handleIncludeExclude(b.excludePattern,b.expandPatterns),R=f.length>1,N=(d.searchPaths&&d.searchPaths.length?d.searchPaths.map(O=>this.getFolderQueryForSearchPath(O,b,D)):f.map(O=>this.getFolderQueryForRoot(O,b,D,R))).filter(O=>!!O),B={_reason:b._reason,folderQueries:N,usingSearchPaths:!!(d.searchPaths&&d.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:D.pattern,includePattern:d.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const z=m.coalesce(m.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(x=>x.resource)))).filter(M=>(0,s.pathIncludedInQuery)(B,M.fsPath)),W=this.commonQueryFromFileList(z);return{...B,...W}}const F=b.extraFileResources&&b.extraFileResources.filter(O=>(0,s.pathIncludedInQuery)(B,O.fsPath));return B.extraFileResources=F&&F.length?F:void 0,B}commonQueryFromFileList(f){const b=[],d=new P.ResourceMap,D={};let R=!1;return f.forEach(N=>{if(N.scheme===k.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(N)){const F=this.workspaceContextService.getWorkspaceFolder(N)?.uri??N.with({path:_.dirname(N.fsPath)});let O=d.get(F);O||(R=!0,O={folder:F,includePattern:{}},b.push(O),d.set(F,O));const z=_.relative(F.fsPath,N.fsPath);(0,T.assertIsDefined)(O.includePattern)[z.replace(/\\/g,"/")]=!0}else N.fsPath&&(R=!0,D[N.fsPath]=!0)}),{folderQueries:b,includePattern:D,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(f,b){if(b.isSmartCase){if(f.isRegExp){if(L.containsUppercaseCharacter(f.pattern,!0))return!0}else if(L.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}isMultiline(f){return f.isMultiline||f.isRegExp&&(0,E.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const b=W=>_.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),D=(Array.isArray(f)?f:S(f)).map(W=>{const M=this.pathService.resolvedUserHome;return M?(0,C.untildify)(W,M.scheme===k.Schemas.file?M.fsPath:M.path):W}),R=i.groupBy(D,W=>b(W)?"searchPaths":"exprSegments"),N=(R.exprSegments||[]).map(W=>L.rtrim(W,"/")).map(W=>L.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),r(W))),B={},F=this.expandSearchPathPatterns(R.searchPaths||[]);F&&F.length&&(B.searchPaths=F);const O=m.flatten(N),z=c(...O);return z&&(B.pattern=z),B}getExcludesForFolder(f,b){return b.disregardExcludeSettings?void 0:(0,s.getExcludes)(f,!b.disregardSearchExcludeSettings)}expandSearchPathPatterns(f){if(!f||!f.length)return[];const b=m.flatten(f.map(D=>{let{pathPortion:R,globPortion:N}=g(D);N&&(N=n(N));const B=this.expandOneSearchPath(R);return m.flatten(B.map(F=>this.resolveOneSearchPathPattern(F,N)))})),d=new Map;return b.forEach(D=>{const R=D.searchPath.toString(),N=d.get(R);N?D.pattern&&(N.pattern=N.pattern||{},N.pattern[D.pattern]=!0):d.set(R,{searchPath:D.searchPath,pattern:D.pattern?c(D.pattern):void 0})}),Array.from(d.values())}expandOneSearchPath(f){if(_.isAbsolute(f)){const b=this.workspaceContextService.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==k.Schemas.file?[{searchPath:b[0].uri.with({path:f})}]:[{searchPath:l.URI.file(_.normalize(f))}]}if(this.workspaceContextService.getWorkbenchState()===2){const b=this.workspaceContextService.getWorkspace().folders[0].uri;if(f=t(f),f.startsWith("../")||f===".."){const D=_.posix.resolve(b.path,f);return[{searchPath:b.with({path:D})}]}const d=n(f);return[{searchPath:b,pattern:d}]}else{if(f==="./"||f===".\\")return[];{const b=f.replace(/^\.[\/\\]/,""),D=this.workspaceContextService.getWorkspace().folders.map(R=>{const N=b.match(new RegExp(`^${L.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return N?{match:N,folder:R}:null}).filter(T.isDefined);if(D.length)return D.map(R=>{const N=R.match[1];return{searchPath:R.folder.uri,pattern:N&&n(N)}});{const R=f.match(/\.[\/\\](.+)[\/\\]?/),N=R?R[1]:f,B=h.localize(0,null,N);throw new Error(B)}}}}resolveOneSearchPathPattern(f,b){const d=f.pattern&&b?`${f.pattern}/${b}`:f.pattern||b,D=[{searchPath:f.searchPath,pattern:d}];return d&&!d.endsWith("**")&&D.push({searchPath:f.searchPath,pattern:d+"/**"}),D}getFolderQueryForSearchPath(f,b,d){const D=this.getFolderQueryForRoot((0,v.toWorkspaceFolder)(f.searchPath),b,d,!1);return D?{...D,includePattern:f.pattern}:null}getFolderQueryForRoot(f,b,d,D){let R;const N=l.URI.isUri(f)?f:f.uri;if(d.searchPaths){const W=d.searchPaths.filter(M=>(0,I.isEqual)(M.searchPath,N))[0];if(W&&!W.pattern)return null;W&&(R=W.pattern)}const B=this.configurationService.getValue({resource:N}),O={...this.getExcludesForFolder(B,b)||{},...R||{}},z=l.URI.isUri(f)?(0,I.basename)(f):f.name;return{folder:N,folderName:D?z:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!B.search.followSymlinks}}};o=je([ze(0,p.IConfigurationService),ze(1,v.IWorkspaceContextService),ze(2,A.IEditorGroupsService),ze(3,w.IPathService)],o),e.QueryBuilder=o;function g(a){const f=a.match(/[\*\{\}\(\)\[\]\?]/);if(f){const b=f.index,d=a.substr(0,b).match(/[/|\\][^/\\]*$/);if(d){let D=a.substr(0,d.index);return D.match(/[/\\]/)||(D+="/"),{pathPortion:D,globPortion:a.substr((d.index||0)+1)}}}return{pathPortion:a}}function c(...a){return a.length?a.reduce((f,b)=>(f[b]=!0,f),Object.create(null)):void 0}function S(a){return y.splitGlobAware(a,",").map(f=>f.trim()).filter(f=>!!f.length)}function r(a){return[`**/${a}/**`,`**/${a}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function t(a){return a.replace(/\\/g,"/")}function n(a){return t(a).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(a,f){a=m.distinct(a,D=>D.toString());const b=[],d=f.getWorkspace();return a&&a.forEach(D=>{let R;if(f.getWorkbenchState()===2)R=(0,I.relativePath)(d.folders[0].uri,D),R&&R!=="."&&(R="./"+R);else{const N=f.getWorkspaceFolder(D);if(N){const B=N.name;if(d.folders.filter(O=>O.name===B).length===1){const O=(0,I.relativePath)(N.uri,D);O===""?R=`./${N.name}`:R=`./${N.name}/${O}`}else R=D.fsPath}}R&&b.push(R)}),b}e.resolveResourcesForSearchIncludes=u}),define(we[267],be([0,1,23,2,21,15,4,266,32,43]),function(Y,e,m,i,y,C,P,k,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function T(p,v){const A=v.activationEvents;if(!A)return Promise.resolve(void 0);const w=[],s=[];for(const t of A)if(/^workspaceContains:/.test(t)){const n=t.substr("workspaceContains:".length);n.indexOf("*")>=0||n.indexOf("?")>=0||p.forceUsingSearch?s.push(n):w.push(n)}if(w.length===0&&s.length===0)return Promise.resolve(void 0);let o;const g=new Promise((t,n)=>{o=t}),c=t=>o({activationEvent:t}),S=Promise.all(w.map(t=>l(p,t,c))).then(()=>{}),r=E(p,v.identifier,s,c);return Promise.all([S,r]).then(()=>{o(void 0)}),g}e.checkActivateWorkspaceContainsExtension=T;async function l(p,v,A){for(const w of p.folders)if(await p.exists(m.joinPath(i.URI.revive(w),v))){A(`workspaceContains:${v}`);return}}async function E(p,v,A,w){if(A.length===0)return Promise.resolve(void 0);const s=new y.CancellationTokenSource,o=p.checkExists(p.folders,A,s.token),g=setTimeout(async()=>{s.cancel(),p.logService.info(`Not activating extension '${v.value}': Timed out while searching for 'workspaceContains' pattern ${A.join(",")}`)},L);let c=!1;try{c=await o}catch(S){C.isPromiseCanceledError(S)||C.onUnexpectedError(S)}s.dispose(),clearTimeout(g),c&&w(`workspaceContains:${A.join(",")}`)}function h(p,v,A,w){const s=p.get(P.IInstantiationService),o=p.get(_.ISearchService),c=s.createInstance(k.QueryBuilder).file(v.map(S=>(0,I.toWorkspaceFolder)(i.URI.revive(S))),{_reason:"checkExists",includePattern:A,exists:!0});return o.fileSearch(c,w).then(S=>!!S.limitHit,S=>C.isPromiseCanceledError(S)?!1:Promise.reject(S))}e.checkGlobFileExists=h});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},xe=this&&this.__classPrivateFieldGet||function(Y,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(Y):i?i.value:e.get(Y)};define(we[39],be([0,1,163,9,71,23,18,6,24,2,11,5,36,225,91,35,29,223,15,27,22,198,7,119,4,26,67,14,85,52,34,3,267,90,200,10]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v,A,w,s,o,g,c,S,r,t,n,u,a,f,b,d,D,R,N,B){"use strict";var F,O,z;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let W=class ji extends k.Disposable{constructor(U,H,X,se,K,j,ie,ce,ge,ke){super();this._onDidChangeRemoteConnectionData=this._register(new d.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=H,this._extHostContext=X,this._initData=ie,this._extHostWorkspace=se,this._extHostConfiguration=K,this._logService=j,this._extHostTunnelService=ge,this._extHostTerminalService=ke,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(T.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(T.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(T.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new P.Barrier,this._readyToStartExtensionHost=new P.Barrier,this._readyToRunExtensions=new P.Barrier,this._eagerExtensionsActivated=new P.Barrier,this._registry=new A.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new h.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=ce,this._instaService=U.createChild(new a.ServiceCollection([h.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const Le=new Set;this._initData.hostExtensions.forEach(Oe=>Le.add(s.ExtensionIdentifier.toKey(Oe))),this._activator=this._register(new E.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Oe,q,J)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Oe,w.transformErrorForSerialization(q),J)},actualActivateExtension:async(Oe,q)=>{if(Le.has(s.ExtensionIdentifier.toKey(Oe)))return await this._mainThreadExtensionsProxy.$activateExtension(Oe,q),new E.HostExtension;const J=this._registry.getExtensionDescription(Oe);return this._activateExtension(J,q)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),y.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(U){w.onUnexpectedError(U)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let U=[];try{U=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch{}await Promise.all(U)}isActivated(U){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(U):!1}_activateByEvent(U,H){return this._activator.activateByEvent(U,H)}_activateById(U,H){return this._activator.activateById(U,H)}activateByIdWithErrors(U,H){return this._activateById(U,H).then(()=>{const X=this._activator.getActivatedExtension(U);if(X.activationFailed)return Promise.reject(X.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(U=>this._registry)}getExtensionExports(U){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(U).exports:null}async _realPathExtensionUri(U){if(U.scheme!==B.Schemas.file)return U;const H=await this._hostUtils.realpath(U.fsPath);return I.URI.file(H)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const U=_.TernarySearchTree.forUris(H=>C.extUriBiasedIgnorePathCase.ignorePathCasing(H));for(const H of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(H)){const X=await this._realPathExtensionUri(H.extensionLocation);U.set(X,H)}return U})()),this._extensionPathIndex}_deactivate(U){let H=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(U))return H;const X=this._activator.getActivatedExtension(U);if(!X)return H;try{typeof X.module.deactivate=="function"&&(H=Promise.resolve(X.module.deactivate()).then(void 0,se=>(this._logService.error(se),Promise.resolve(void 0))))}catch(se){this._logService.error(`An error occurred when deactivating the extension '${U.value}':`),this._logService.error(se)}try{(0,k.dispose)(X.subscriptions)}catch(se){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this._logService.error(se)}return H}async _activateExtension(U,H){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(U.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(U.identifier),this._doActivateExtension(U,H).then(X=>{const se=X.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(U.identifier,se.codeLoadingTime,se.activateCallTime,se.activateResolvedTime,H),this._logExtensionActivationTimes(U,H,"success",se),X},X=>{throw this._logExtensionActivationTimes(U,H,"failure"),X})}_logExtensionActivationTimes(U,H,X,se){const K=M(U,H);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...K,...se||{},outcome:X})}_doActivateExtension(U,H){const X=M(U,H);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",X);const se=this._getEntryPoint(U);if(!se)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${H.startup}, activationEvent: '${H.activationEvent}'${U.identifier.value!==H.extensionId.value?`, root cause: ${H.extensionId.value}`:""}`),this._logService.flush();const K=new E.ExtensionActivationTimesBuilder(H.startup);return Promise.all([this._loadCommonJSModule(U.identifier,(0,C.joinPath)(U.extensionLocation,se),K),this._loadExtensionContext(U)]).then(j=>(y.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),ji._callActivate(this._logService,U.identifier,j[0],j[1],K))).then(j=>(y.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),j))}_loadExtensionContext(U){const H=new g.ExtensionGlobalMemento(U,this._storage),X=new g.ExtensionMemento(U.identifier.value,!1,this._storage),se=new N.ExtensionSecrets(U,this._secretState),K=U.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?c.ExtensionMode.Test:c.ExtensionMode.Development:c.ExtensionMode.Production,j=this._initData.remote.isRemote?c.ExtensionKind.Workspace:c.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([H.whenReady,X.whenReady,this._storagePath.whenReady]).then(()=>{const ie=this;let ce;return Object.freeze({globalState:H,workspaceState:X,secrets:se,subscriptions:[],get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(ge){return i.join(U.extensionLocation.fsPath,ge)},get storagePath(){return ie._storagePath.workspaceValue(U)?.fsPath},get globalStoragePath(){return ie._storagePath.globalValue(U).fsPath},get logPath(){return i.join(ie._initData.logsLocation.fsPath,U.identifier.value)},get logUri(){return I.URI.joinPath(ie._initData.logsLocation,U.identifier.value)},get storageUri(){return ie._storagePath.workspaceValue(U)},get globalStorageUri(){return ie._storagePath.globalValue(U)},get extensionMode(){return K},get extension(){return ce===void 0&&(ce=new x(ie,U.identifier,U,j)),ce},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(U,"extensionRuntime"),ie.extensionRuntime},get environmentVariableCollection(){return ie._extHostTerminalService.getEnvironmentVariableCollection(U)}})})}static _callActivate(U,H,X,se,K){return X=X||{activate:void 0,deactivate:void 0},this._callActivateOptional(U,H,X,se,K).then(j=>new E.ActivatedExtension(!1,null,K.build(),X,j,se.subscriptions))}static _callActivateOptional(U,H,X,se,K){if(typeof X.activate=="function")try{K.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${H.value}`);const j=typeof global=="object"?global:self,ie=X.activate.apply(j,[se]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(ie).then(ce=>(K.activateResolveStop(),ce))}catch(j){return Promise.reject(j)}else return Promise.resolve(X)}_activateOneStartupFinished(U,H){this._activateById(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:H}).then(void 0,X=>{this._logService.error(X)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(y.getMarks());for(const U of this._registry.getAllExtensionDescriptions())if(U.activationEvents)for(const H of U.activationEvents)H==="onStartupFinished"&&this._activateOneStartupFinished(U,H)}_handleEagerExtensions(){const U=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._register(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const H=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],X=this._handleWorkspaceContainsEagerExtensions(H),se=Promise.all([U,X]).then(()=>{});return Promise.race([se,(0,P.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),se}_handleWorkspaceContainsEagerExtensions(U){return U.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(H=>this._handleWorkspaceContainsEagerExtension(U,H))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(U,H){if(this.isActivated(H.identifier))return;const X=!this._initData.remote.isRemote&&!!this._initData.remote.authority,se={logService:this._logService,folders:U.map(j=>j.uri),forceUsingSearch:X,exists:j=>this._hostUtils.exists(j.fsPath),checkExists:(j,ie,ce)=>this._mainThreadWorkspaceProxy.$checkExists(j,ie,ce)},K=await(0,D.checkActivateWorkspaceContainsExtension)(se,H);if(!!K)return this._activateById(H.identifier,{startup:!0,extensionId:H.identifier,activationEvent:K.activationEvent}).then(void 0,j=>this._logService.error(j))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(U){throw console.error(U),U}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:H}=this._initData.environment;if(!U||!H)throw new Error(m.localize(0,null));const X=await this._loadCommonJSModule(null,H,new E.ExtensionActivationTimesBuilder(!1));if(!X||typeof X.run!="function")throw new Error(m.localize(1,null,H.toString()));return new Promise((se,K)=>{const j=(ge,ke)=>{ge?K(ge):se(typeof ke=="number"&&ke>0?1:0)},ie=(0,C.originalFSPath)(H),ce=X.run(ie,j);ce&&ce.then&&ce.then(()=>{se(0)}).catch(ge=>{K(ge.toString())})})}async $extensionTestsExit(U){this._logService.info(`Extension host terminating: test runner requested exit with code ${U}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${U}`),this._logService.flush(),this._hostUtils.exit(U)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,H){return this._resolvers[U]=H,(0,k.toDisposable)(()=>{delete this._resolvers[U]})}async _activateAndGetResolver(U){const H=U.indexOf("+");if(H===-1)throw new Error("Not an authority that can be resolved!");const X=U.substr(0,H);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${X}`,!1),{authorityPrefix:X,resolver:this._resolvers[X]}}async $resolveAuthority(U,H){const{authorityPrefix:X,resolver:se}=await this._activateAndGetResolver(U);if(!se)return{type:"error",error:{code:S.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${X}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(se)),y.mark(`code/extHost/willResolveAuthority/${X}`);const K=await se.resolve(U,{resolveAttempt:H});y.mark(`code/extHost/didResolveAuthorityOK/${X}`);const j={authority:U,host:K.host,port:K.port,connectionToken:K.connectionToken},ie={extensionHostEnv:K.extensionHostEnv,isTrusted:K.isTrusted,authenticationSession:K.authenticationSessionForInitializingExtensions?{id:K.authenticationSessionForInitializingExtensions.id,providerId:K.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:j,options:ie,tunnelInformation:{environmentTunnels:K.environmentTunnels}}}}catch(K){if(y.mark(`code/extHost/didResolveAuthorityError/${X}`),K instanceof c.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K}}async $getCanonicalURI(U,H){const{authorityPrefix:X,resolver:se}=await this._activateAndGetResolver(U);if(!se)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${X}`);const K=I.URI.revive(H);if(typeof se.getCanonicalURI=="undefined")return K;const j=await(0,P.asPromise)(()=>se.getCanonicalURI(K));return j||K}$startExtensionHost(U){return this._registry.keepOnly(U),this._startExtensionHost()}$activateByEvent(U,H){return H===1?this._activateByEvent(U,!1):this._readyToRunExtensions.wait().then(X=>this._activateByEvent(U,!1))}async $activate(U,H){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(U)?(await this._activateById(U,H),!0):!1}async $deltaExtensions(U,H){U.forEach(se=>se.extensionLocation=I.URI.revive(se.extensionLocation));const X=await this.getExtensionPathIndex();return await Promise.all(H.map(async se=>{const K=this._registry.getExtensionDescription(se);K&&X.delete(await this._realPathExtensionUri(K.extensionLocation))})),await Promise.all(U.map(async se=>{const K=await this._realPathExtensionUri(se.extensionLocation);X.set(K,se)})),this._registry.deltaExtensions(U,H),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){let H=o.VSBuffer.alloc(U),X=Math.random()%256;for(let se=0;se<U;se++)H.writeUInt8(X,se);return H}async $updateRemoteConnectionData(U){this._remoteConnectionData=U,this._onDidChangeRemoteConnectionData.fire()}};W=je([ze(0,r.IInstantiationService),ze(1,e.IHostUtils),ze(2,u.IExtHostRpcService),ze(3,p.IExtHostWorkspace),ze(4,l.IExtHostConfiguration),ze(5,L.ILogService),ze(6,t.IExtHostInitDataService),ze(7,n.IExtensionStoragePaths),ze(8,f.IExtHostTunnelService),ze(9,b.IExtHostTerminalService)],W),e.AbstractExtHostExtensionService=W;function M(V,U){return{id:V.identifier.value,name:V.name,extensionVersion:V.version,publisherDisplayName:V.publisher,activationEvents:V.activationEvents?V.activationEvents.join(","):null,isBuiltin:V.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class x{constructor(U,H,X,se){F.set(this,void 0),O.set(this,void 0),z.set(this,void 0),nt(this,F,U,"f"),nt(this,O,H,"f"),nt(this,z,X.identifier,"f"),this.id=X.identifier.value,this.extensionUri=X.extensionLocation,this.extensionPath=i.normalize((0,C.originalFSPath)(X.extensionLocation)),this.packageJSON=X,this.extensionKind=se}get isActive(){return xe(this,F,"f").isActivated(xe(this,z,"f"))}get exports(){if(this.packageJSON.api!=="none")return xe(this,F,"f").getExtensionExports(xe(this,z,"f"))}activate(){return xe(this,F,"f").activateByIdWithErrors(xe(this,z,"f"),{startup:!1,extensionId:xe(this,O,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=x,F=new WeakMap,O=new WeakMap,z=new WeakMap}),define(we[55],be([0,1,9,2,3,18,5,7,123,35,39,45,214,36,207,14,4,13,40,54]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v,A,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let o=class{constructor(a,f,b,d,D,R){this._workspaceService=f,this._extensionService=b,this._editorsService=d,this._configurationService=D,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new y.Emitter,this._onDidTerminateDebugSession=new y.Emitter,this._onDidChangeActiveDebugSession=new y.Emitter,this._onDidReceiveDebugSessionCustomEvent=new y.Emitter,this._debugServiceProxy=a.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new y.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new c(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(N=>{N.onDidChange(B=>{this.registerAllDebugTypes(N)}),this.registerAllDebugTypes(N)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(a,f){const b=a;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let d=`debug:${encodeURIComponent(b.path||"")}`,D="?";return f&&(d+=`${D}session=${encodeURIComponent(f.id)}`,D="&"),d+=`${D}ref=${b.sourceReference}`,i.URI.parse(d)}else{if(b.path)return i.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(a){const f=[];for(const b of a.getAllExtensionDescriptions())if(b.contributes){const d=b.contributes.debuggers;if(d&&d.length>0)for(const D of d)(0,h.isDebuggerMainContribution)(D)&&f.push(D.type)}this._debugServiceProxy.$registerDebugTypes(f)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const a=[];return this._breakpoints.forEach(f=>a.push(f)),a}addBreakpoints(a){this.startBreakpoints();const f=a.filter(D=>{const R=D.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,D),!0)});this.fireBreakpointChanges(f,[],[]);const b=[],d=new Map;for(const D of f)if(D instanceof k.SourceBreakpoint){let R=d.get(D.location.uri.toString());R||(R={type:"sourceMulti",uri:D.location.uri,lines:[]},d.set(D.location.uri.toString(),R),b.push(R)),R.lines.push({id:D.id,enabled:D.enabled,condition:D.condition,hitCondition:D.hitCondition,logMessage:D.logMessage,line:D.location.range.start.line,character:D.location.range.start.character})}else D instanceof k.FunctionBreakpoint&&b.push({type:"function",id:D.id,enabled:D.enabled,hitCondition:D.hitCondition,logMessage:D.logMessage,condition:D.condition,functionName:D.functionName});return this._debugServiceProxy.$registerBreakpoints(b)}removeBreakpoints(a){this.startBreakpoints();const f=a.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],f,[]);const b=f.filter(R=>R instanceof k.SourceBreakpoint).map(R=>R.id),d=f.filter(R=>R instanceof k.FunctionBreakpoint).map(R=>R.id),D=f.filter(R=>R instanceof k.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(b,d,D)}startDebugging(a,f,b){return this._debugServiceProxy.$startDebugging(a?a.uri:void 0,f,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,debugUI:b.debugUI,suppressSaveBeforeStart:b.suppressSaveBeforeStart})}stopDebugging(a){return this._debugServiceProxy.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,f,b){if(!f)return new k.Disposable(()=>{});const d=this._configProviderHandleCounter++;return this._configProviders.push({type:a,handle:d,provider:f}),this._debugServiceProxy.$registerDebugConfigurationProvider(a,b,!!f.provideDebugConfigurations,!!f.resolveDebugConfiguration,!!f.resolveDebugConfigurationWithSubstitutedVariables,d),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(D=>D.provider!==f),this._debugServiceProxy.$unregisterDebugConfigurationProvider(d)})}registerDebugAdapterDescriptorFactory(a,f,b){if(!b)return new k.Disposable(()=>{});if(!this.definesDebugType(a,f))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${f}' debugger.`);if(this.getAdapterDescriptorFactoryByType(f))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const d=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:f,handle:d,factory:b}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(f,d),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(D=>D.factory!==b),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(d)})}registerDebugAdapterTrackerFactory(a,f){if(!f)return new k.Disposable(()=>{});const b=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:a,handle:b,factory:f}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(d=>d.factory!==f)})}async $runInTerminal(a,f){return Promise.resolve(void 0)}async $substituteVariables(a,f){if(!this._variableResolver){const[D,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(D||[],this._editorsService,R)}let b;const d=await this.getFolder(a);return d&&(b={uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(b,f)}createDebugAdapter(a,f){if(a.type==="implementation")return new t(a.implementation)}createSignService(){}async $startDASession(a,f){const b=this,d=await this.getSession(f);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(d.type),d).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}' (extension might have failed to activate)`);const R=this.convertToDto(D),N=this.createDebugAdapter(R,d);if(!N)throw new Error(`Couldn't create a debug adapter for type '${d.type}'.`);const B=N;return this._debugAdapters.set(a,B),this.getDebugAdapterTrackers(d).then(F=>(F&&this._debugAdaptersTrackers.set(a,F),B.onMessage(async O=>{if(O.type==="request"&&O.command==="handshake"){const z=O,W={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(z.arguments.value);W.body={signature:M},B.sendResponse(W)}else throw new Error("no signer")}catch(M){W.success=!1,W.message=M.message,B.sendResponse(W)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(O),O=(0,h.convertToVSCPaths)(O,!0),b._debugServiceProxy.$acceptDAMessage(a,O)}),B.onError(O=>{F&&F.onError&&F.onError(O),this._debugServiceProxy.$acceptDAError(a,O.name,O.message,O.stack)}),B.onExit(O=>{F&&F.onExit&&F.onExit((0,A.withNullAsUndefined)(O),void 0),this._debugServiceProxy.$acceptDAExit(a,(0,A.withNullAsUndefined)(O),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),B.startSession()))})}$sendDAMessage(a,f){f=(0,h.convertToDAPaths)(f,!1);const b=this._debugAdaptersTrackers.get(a);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(f);const d=this._debugAdapters.get(a);d&&d.sendMessage(f)}$stopDASession(a){const f=this._debugAdaptersTrackers.get(a);this._debugAdaptersTrackers.delete(a),f&&f.onWillStopSession&&f.onWillStopSession();const b=this._debugAdapters.get(a);return this._debugAdapters.delete(a),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const f=[],b=[],d=[];if(a.added)for(const D of a.added){const R=D.id;if(R&&!this._breakpoints.has(R)){let N;if(D.type==="function")N=new k.FunctionBreakpoint(D.functionName,D.enabled,D.condition,D.hitCondition,D.logMessage);else if(D.type==="data")N=new k.DataBreakpoint(D.label,D.dataId,D.canPersist,D.enabled,D.hitCondition,D.condition,D.logMessage);else{const B=i.URI.revive(D.uri);N=new k.SourceBreakpoint(new k.Location(B,new k.Position(D.line,D.character)),D.enabled,D.condition,D.hitCondition,D.logMessage)}N._id=R,this._breakpoints.set(R,N),f.push(N)}}if(a.removed)for(const D of a.removed){const R=this._breakpoints.get(D);R&&(this._breakpoints.delete(D),b.push(R))}if(a.changed){for(const D of a.changed)if(D.id){const R=this._breakpoints.get(D.id);if(R){if(R instanceof k.FunctionBreakpoint&&D.type==="function"){const N=R;N.enabled=D.enabled,N.condition=D.condition,N.hitCondition=D.hitCondition,N.logMessage=D.logMessage,N.functionName=D.functionName}else if(R instanceof k.SourceBreakpoint&&D.type==="source"){const N=R;N.enabled=D.enabled,N.condition=D.condition,N.hitCondition=D.hitCondition,N.logMessage=D.logMessage,N.location=new k.Location(i.URI.revive(D.uri),new k.Position(D.line,D.character))}d.push(R)}}}this.fireBreakpointChanges(f,b,d)}$provideDebugConfigurations(a,f,b){return(0,C.asPromise)(async()=>{const d=this.getConfigProviderByHandle(a);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const D=await this.getFolder(f);return d.provideDebugConfigurations(D,b)}).then(d=>{if(!d)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return d})}$resolveDebugConfiguration(a,f,b,d){return(0,C.asPromise)(async()=>{const D=this.getConfigProviderByHandle(a);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(f);return D.resolveDebugConfiguration(R,b,d)})}$resolveDebugConfigurationWithSubstitutedVariables(a,f,b,d){return(0,C.asPromise)(async()=>{const D=this.getConfigProviderByHandle(a);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(f);return D.resolveDebugConfigurationWithSubstitutedVariables(R,b,d)})}async $provideDebugAdapter(a,f){const b=this.getAdapterDescriptorFactoryByHandle(a);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const d=await this.getSession(f);return this.getAdapterDescriptor(b,d).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}'`);return this.convertToDto(D)})}async $acceptDebugSessionStarted(a){const f=await this.getSession(a);this._onDidStartDebugSession.fire(f)}async $acceptDebugSessionTerminated(a){const f=await this.getSession(a);f&&(this._onDidTerminateDebugSession.fire(f),this._debugSessions.delete(f.id))}async $acceptDebugSessionActiveChanged(a){this._activeDebugSession=a?await this.getSession(a):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(a,f){const b=await this.getSession(a);b&&b._acceptNameChanged(f)}async $acceptDebugSessionCustomEvent(a,f){const d={session:await this.getSession(a),event:f.event,body:f.body};this._onDidReceiveDebugSessionCustomEvent.fire(d)}convertToDto(a){if(a instanceof k.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof k.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(a){const f=this._adapterFactories.filter(b=>b.type===a);if(f.length>0)return f[0].factory}getAdapterDescriptorFactoryByHandle(a){const f=this._adapterFactories.filter(b=>b.handle===a);if(f.length>0)return f[0].factory}getConfigProviderByHandle(a){const f=this._configProviders.filter(b=>b.handle===a);if(f.length>0)return f[0].provider}definesDebugType(a,f){if(a.contributes){const b=a.contributes.debuggers;if(b&&b.length>0){for(const d of b)if(d.label&&d.type&&d.type===f)return!0}}return!1}getDebugAdapterTrackers(a){const b=a.configuration.type,d=this._trackerFactories.filter(D=>D.type===b||D.type==="*").map(D=>(0,C.asPromise)(()=>D.factory.createDebugAdapterTracker(a)).then(R=>R,R=>null));return Promise.race([Promise.all(d).then(D=>{const R=D.filter(N=>!!N);if(R.length>0)return new r(R)}),new Promise((D,R)=>{const N=setTimeout(()=>{clearTimeout(N),R(new Error("timeout"))},1e3)})]).catch(D=>{})}async getAdapterDescriptor(a,f){const b=f.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new k.DebugAdapterServer(b));if(a){const D=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>a.createDebugAdapterDescriptor(f,this.daExecutableFromPackage(f,D))).then(R=>{if(R)return R})}const d=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(f,d))}daExecutableFromPackage(a,f){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(a,f,b){(a.length>0||f.length>0||b.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:a,removed:f,changed:b}))}async getSession(a){if(a)if(typeof a=="string"){const f=this._debugSessions.get(a);if(f)return f}else{let f=this._debugSessions.get(a.id);if(!f){const b=await this.getFolder(a.folderUri),d=a.parent?this._debugSessions.get(a.parent):void 0;f=new g(this._debugServiceProxy,a.id,a.type,a.name,b,a.configuration,d),this._debugSessions.set(f.id,f),this._debugServiceProxy.$sessionCached(f.id)}return f}throw new Error("cannot find session")}getFolder(a){if(a){const f=i.URI.revive(a);return this._workspaceService.resolveWorkspaceFolder(f)}return Promise.resolve(void 0)}};o=je([ze(0,p.IExtHostRpcService),ze(1,I.IExtHostWorkspace),ze(2,L.IExtHostExtensionService),ze(3,T.IExtHostDocumentsAndEditors),ze(4,E.IExtHostConfiguration),ze(5,s.IExtHostEditorTabs)],o),e.ExtHostDebugServiceBase=o;class g{constructor(a,f,b,d,D,R,N){this._debugServiceProxy=a,this._id=f,this._type=b,this._name=d,this._workspaceFolder=D,this._configuration=R,this._parentSession=N}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(a){this._name=a,this._debugServiceProxy.$setDebugSessionName(this._id,a)}get parentSession(){return this._parentSession}_acceptNameChanged(a){this._name=a}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(a,f){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,a,f)}getDebugProtocolBreakpoint(a){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,a.id)}}e.ExtHostDebugSession=g;class c{constructor(a){this.value=Object.freeze({append(f){a.$appendDebugConsole(f)},appendLine(f){this.append(f+`
`)}})}}e.ExtHostDebugConsole=c;class S extends l.AbstractVariableResolverService{constructor(a,f,b,d,D){function R(){if(f){const N=f.activeEditor();if(N)return N.document.uri;const B=d.tabs.filter(F=>F.isActive);if(B.length>0){const F=B[0].resource;return F&&(F.primary||F.secondary)?F.primary??F.secondary:B[0].resource}}}super({getFolderUri:N=>{const B=a.filter(F=>F.name===N);if(B&&B.length>0)return B[0].uri},getWorkspaceFolderCount:()=>a.length,getConfigurationValue:(N,B)=>b.getConfiguration(void 0,N).get(B),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{const N=R();if(N)return m.normalize(N.fsPath)},getWorkspaceFolderPathForFile:()=>{if(D){const N=R();if(N){const B=D.getWorkspaceFolder(N);if(B)return m.normalize(B.uri.fsPath)}}},getSelectedText:()=>{if(f){const N=f.activeEditor();if(N&&!N.selection.isEmpty)return N.document.getText(N.selection)}},getLineNumber:()=>{if(f){const N=f.activeEditor();if(N)return String(N.selection.end.line+1)}}},void 0,Promise.resolve(w.env))}}e.ExtHostVariableResolverService=S;class r{constructor(a){this.trackers=a}onWillStartSession(){this.trackers.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.trackers.forEach(f=>f.onWillReceiveMessage?f.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.trackers.forEach(f=>f.onDidSendMessage?f.onDidSendMessage(a):void 0)}onWillStopSession(){this.trackers.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.trackers.forEach(f=>f.onError?f.onError(a):void 0)}onExit(a,f){this.trackers.forEach(b=>b.onExit?b.onExit(a,f):void 0)}}class t extends _.AbstractDebugAdapter{constructor(a){super();this.implementation=a,a.onDidSendMessage(f=>{this.acceptMessage(f)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.implementation.handleMessage(a)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let n=class extends o{constructor(a,f,b,d,D,R){super(a,f,b,d,D,R)}createVariableResolver(a,f,b){return new S(a,f,b,this._editorTabs)}};n=je([ze(0,p.IExtHostRpcService),ze(1,I.IExtHostWorkspace),ze(2,L.IExtHostExtensionService),ze(3,T.IExtHostDocumentsAndEditors),ze(4,E.IExtHostConfiguration),ze(5,s.IExtHostEditorTabs)],n),e.WorkerExtHostDebugService=n}),define(we[268],be([0,1,71,2,5,36,29,27,14,26,4,39,40,11]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(s,o,g,c,S,r,t){this._apiFactory=s,this._extensionRegistry=o,this._instaService=g,this._extHostConfiguration=c,this._extHostExtensionService=S,this._initData=r,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const s=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new p(this._apiFactory,o,this._extensionRegistry,s,this._logService)),this.register(this._instaService.createInstance(v,o)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(A,o,this._initData.environment.appUriScheme))}register(s){if(Array.isArray(s.nodeModuleName))for(let o of s.nodeModuleName)this._factories.set(o,s);else this._factories.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this._alternatives.push(o=>s.alternativeModuleName(o))}};h=je([ze(2,L.IInstantiationService),ze(3,C.IExtHostConfiguration),ze(4,T.IExtHostExtensionService),ze(5,I.IExtHostInitDataService),ze(6,E.ILogService)],h),e.RequireInterceptor=h;class p{constructor(s,o,g,c,S){this._apiFactory=s,this._extensionPaths=o,this._extensionRegistry=g,this._configProvider=c,this._logService=S,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(s,o){const g=this._extensionPaths.findSubstr(o);if(g){let c=this._extApiImpl.get(k.ExtensionIdentifier.toKey(g.identifier));return c||(c=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(g.identifier),c)),c}if(!this._defaultApiImpl){let c="";this._extensionPaths.forEach((S,r)=>c+=`	${r} -> ${S.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${c}`),this._defaultApiImpl=this._apiFactory(P.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(s,o,g){this._extensionPaths=s,this.nodeModuleName="keytar",this._mainThreadTelemetry=o.getProxy(y.MainContext.MainThreadTelemetry);const{environment:c}=g,S=o.getProxy(y.MainContext.MainThreadKeytar);if(c.appRoot){let r=c.appRoot.fsPath;l.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,t)=>S.$getPassword(r,t),setPassword:(r,t,n)=>S.$setPassword(r,t,n),deletePassword:(r,t)=>S.$deletePassword(r,t),findPassword:r=>S.$findPassword(r),findCredentials(r){return S.$findCredentials(r)}}}load(s,o){const g=this._extensionPaths.findSubstr(o);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:g?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(s){const o=s.length;if(o<=7||!this.alternativeNames)return;const g=o-7;if((s.charAt(g)==="/"||s.charAt(g)==="\\")&&s.endsWith("keytar")&&(s=s.replace(/\\/g,"/"),this.alternativeNames.has(s)))return"keytar"}};v=je([ze(1,_.IExtHostRpcService),ze(2,I.IExtHostInitDataService)],v);let A=class{constructor(s,o,g){this._extensionPaths=s,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(y.MainContext.MainThreadTelemetry);const c=g.getProxy(y.MainContext.MainThreadWindow);this._impl=(S,r)=>{const t=i.URI.parse(S);return r?this.callOriginal(S,r):t.scheme==="http"||t.scheme==="https"?c.$openUri(t,S,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?c.$openUri(t,S,{}):this.callOriginal(S,r)}}load(s,o,g){const c=this._extensionPaths.findSubstr(o);return c&&(this._extensionId=c.identifier.value,this.sendShimmingTelemetry()),this._original=g(s),this._impl}callOriginal(s,o){return this.sendNoForwardTelemetry(),this._original(s,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};A=je([ze(2,_.IExtHostRpcService)],A)}),define(we[269],be([0,1,169,12,7,208,35,39,45,36,34,14,55,194,18,209,54]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let A=class extends l.ExtHostDebugServiceBase{constructor(o,g,c,S,r,t,n){super(o,g,c,S,r,n);this._terminalService=t,this._integratedTerminalInstances=new w}createDebugAdapter(o,g){switch(o.type){case"server":return new C.SocketDebugAdapter(o);case"pipeServer":return new C.NamedPipeDebugAdapter(o);case"executable":return new C.ExecutableDebugAdapter(o,g.type)}return super.createDebugAdapter(o,g)}daExecutableFromPackage(o,g){const c=C.ExecutableDebugAdapter.platformAdapterExecutable(g.getAllExtensionDescriptions(),o.type);if(c)return new y.DebugAdapterExecutable(c.command,c.args,c.options)}createSignService(){return new E.SignService}async $runInTerminal(o,g){if(o.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(R=>{this._integratedTerminalInstances.onTerminalClosed(R)}));const c=await this._configurationService.getConfigProvider(),S=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),t=o.title||m.localize(0,null),n=JSON.stringify({shell:S,shellArgs:r});let u=await this._integratedTerminalInstances.checkout(n,t),a,f=!1;if(u)a=o.cwd;else{const R={shellPath:S,shellArgs:r,cwd:o.cwd,name:t,iconPath:new y.ThemeIcon("debug")};f=!0,u=this._terminalService.createTerminalFromOptions(R,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(u,n)}u.show(!0);const b=await u.processId;f?await new Promise(R=>setTimeout(R,1e3)):c.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0||S.indexOf("cmd.exe")>=0?u.sendText("cls"):S.indexOf("bash")>=0?u.sendText("clear"):i.isWindows?u.sendText("cls"):u.sendText("clear"));const d=(0,p.prepareCommand)(S,o.args,a,o.env);u.sendText(d);const D=this.onDidTerminateDebugSession(R=>{R.id===g&&(this._integratedTerminalInstances.free(u),D.dispose())});return b}else if(o.kind==="external")return(0,p.runInExternalTerminal)(o,await this._configurationService.getConfigProvider());return super.$runInTerminal(o,g)}createVariableResolver(o,g,c){return new l.ExtHostVariableResolverService(o,g,c,this._editorTabs,this._workspaceService)}};A=je([ze(0,T.IExtHostRpcService),ze(1,P.IExtHostWorkspace),ze(2,k.IExtHostExtensionService),ze(3,_.IExtHostDocumentsAndEditors),ze(4,I.IExtHostConfiguration),ze(5,L.IExtHostTerminalService),ze(6,v.IExtHostEditorTabs)],A),e.ExtHostDebugService=A;class w{constructor(){this._terminalInstances=new Map}async checkout(o,g){const S=[...this._terminalInstances.entries()].map(([r,t])=>(0,h.createCancelablePromise)(async n=>{if(r.name!==g||t.lastUsedAt!==-1&&await(0,p.hasChildProcesses)(await r.processId))return null;const u=Date.now();return t.lastUsedAt+w.minUseDelay>u||n.isCancellationRequested||t.config!==o?null:(t.lastUsedAt=u,r)}));return await(0,h.firstParallel)(S,r=>!!r)}insert(o,g){this._terminalInstances.set(o,{lastUsedAt:Date.now(),config:g})}free(o){const g=this._terminalInstances.get(o);g&&(g.lastUsedAt=-1)}onTerminalClosed(o){this._terminalInstances.delete(o)}}w.minUseDelay=1e3}),define(we[270],be([0,1,9,2,112,35,55,45,36,43,34,14,26,70,10,11,65,54,23,81]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v,A,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let o=class extends E.ExtHostTaskBase{constructor(c,S,r,t,n,u,a,f,b){super(c,S,r,t,n,u,a,f);this.workspaceService=r,this.editorTabs=b,S.remote.isRemote&&S.remote.authority?this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:S.remote.authority,platform:process.platform}):this.registerTaskSystem(h.Schemas.file,{scheme:h.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(c,S){const r=S;if(!S.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const t=E.TaskHandleDTO.from(r,this.workspaceService),n=await this._proxy.$getTaskExecution(t);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const u=await this.getTaskExecution(n,S);return this._proxy.$executeTask(t).catch(()=>{}),u}else{const t=E.TaskDTO.from(S,c);if(t===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,S,!1);const n=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),S);return this._proxy.$executeTask(t).catch(()=>{}),n}}provideTasksInternal(c,S,r,t){const n=[];if(t)for(let u of t){this.checkDeprecation(u,r),(!u.definition||!c[u.definition.type])&&this._logService.warn(`The task [${u.source}, ${u.name}] uses an undefined task type. The task will be ignored in the future.`);const a=E.TaskDTO.from(u,r.extension);a&&(n.push(a),E.CustomExecutionDTO.is(a.execution)&&S.push(this.addCustomExecution(a,u,!0)))}return{tasks:n,extension:r.extension}}async resolveTaskInternal(c){return c}async getVariableResolver(c){if(this._variableResolver===void 0){const S=await this._configurationService.getConfigProvider();this._variableResolver=new P.ExtHostVariableResolverService(c,this._editorService,S,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(c){let S=c&&c.length>0?c[0]:void 0;if(!S){const r=i.URI.file((0,s.homedir)());S=new I.WorkspaceFolder({uri:r,name:w.basename(r),index:0})}return{uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(c,S){const r=i.URI.revive(c),t={process:void 0,variables:Object.create(null)},n=await this._workspaceProvider.resolveWorkspaceFolder(r),u=await this._workspaceProvider.getWorkspaceFolders2()??[],a=await this.getVariableResolver(u),f=n?{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(u);for(let b of S.variables)t.variables[b]=await a.resolveAsync(f,b);if(S.process!==void 0){let b;if(S.process.path!==void 0){b=S.process.path.split(m.delimiter);for(let d=0;d<b.length;d++)b[d]=await a.resolveAsync(f,b[d])}t.process=await y.win32.findExecutable(await a.resolveAsync(f,S.process.name),S.process.cwd!==void 0?await a.resolveAsync(f,S.process.cwd):void 0,b)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(c,S,r){return y.win32.findExecutable(c,S,r)}};o=je([ze(0,T.IExtHostRpcService),ze(1,l.IExtHostInitDataService),ze(2,C.IExtHostWorkspace),ze(3,k.IExtHostDocumentsAndEditors),ze(4,_.IExtHostConfiguration),ze(5,L.IExtHostTerminalService),ze(6,p.ILogService),ze(7,v.IExtHostApiDeprecationService),ze(8,A.IExtHostEditorTabs)],o),e.ExtHostTask=o}),define(we[271],be([0,1,18,15,71,6,2,5,263,11,83,85,26,186,14,64,39,34]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(o,g,c,S){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=c,this._rpcProtocol=new _.RPCProtocol(o,null,S),g=w._transform(g,this._rpcProtocol);const r=new T.ServiceCollection(...(0,L.getSingletonServiceDescriptors)());r.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...g}),r.set(h.IExtHostRpcService,new h.ExtHostRpcService(this._rpcProtocol)),r.set(p.IURITransformerService,new p.URITransformerService(S)),r.set(v.IHostUtils,c);const t=new E.InstantiationService(r,!0);this._disposables.add(t.invokeFunction(f=>f.get(A.IExtHostTerminalService))),this._disposables.add(t.invokeFunction(f=>f.get(v.IExtHostExtensionService))),this._logService=t.invokeFunction(f=>f.get(I.ILogService)),y.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",g),this._extensionService=t.invokeFunction(f=>f.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const n=new WeakMap;this._extensionService.getExtensionPathIndex().then(f=>{Error.prepareStackTrace=(b,d)=>{let D="",R,N;for(const B of d)D+=`
	at ${B.toString()}`,N=B.getFileName(),!R&&N&&(R=f.findSubstr(P.URI.file(N)));return n.set(b,R),`${b.name||"Error"}: ${b.message||""}${D}`}});const u=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),a=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(f=>{const b=i.transformErrorForSerialization(f),d=n.get(f);d?u.$onExtensionRuntimeError(d.identifier,b):a.$onUnexpectedError(b)})}terminate(o){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${o}`),this._logService.flush(),this._disposables.dispose(),i.setUnexpectedErrorHandler(c=>{this._logService.error(c)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();Promise.race([(0,m.timeout)(5e3),g]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(o,g){o.extensions.forEach(S=>S.extensionLocation=P.URI.revive(g.transformIncomingURIs(S.extensionLocation))),o.environment.appRoot=P.URI.revive(g.transformIncomingURIs(o.environment.appRoot));const c=o.environment.extensionDevelopmentLocationURI;return c&&(o.environment.extensionDevelopmentLocationURI=c.map(S=>P.URI.revive(g.transformIncomingURIs(S)))),o.environment.extensionTestsLocationURI=P.URI.revive(g.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=P.URI.revive(g.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=P.URI.revive(g.transformIncomingURIs(o.environment.workspaceStorageHome)),o.logsLocation=P.URI.revive(g.transformIncomingURIs(o.logsLocation)),o.logFile=P.URI.revive(g.transformIncomingURIs(o.logFile)),o.workspace=g.transformIncomingURIs(o.workspace),o}}e.ExtensionHostMain=w}),define(we[272],be([0,1,9,21,50,31,23,46,32]),function(Y,e,m,i,y,C,P,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(l,E,h){this.config=l,this.provider=E,this.sessionToken=h,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&C.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&C.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const E=this.config.folderQueries||[];return new Promise((h,p)=>{const v=A=>{this.resultCount++,l(A)};if(this.isCanceled)return h({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(A=>{const w=A.toString(),s=m.basename(w);this.globalExcludePattern&&this.globalExcludePattern(w,s)||this.matchFile(v,{base:A,basename:s})}),Promise.all(E.map(A=>this.searchInFolder(A,v))).then(A=>{h({limitHit:this.isLimitHit,stats:A[0]||void 0})},A=>{p(new Error((0,y.toErrorMessage)(A)))})})}async searchInFolder(l,E){const h=new i.CancellationTokenSource,p=this.getSearchOptionsForFolder(l),v=this.initDirectoryTree(),A=new _.QueryGlobTester(this.config,l),w=!A.hasSiblingExcludeClauses();let s;try{this.activeCancellationTokens.add(h),s=k.StopWatch.create();const o=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},p,h.token),g=s.elapsed(),c=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(o&&o.forEach(S=>{const r=m.posix.relative(l.folder.path,S.path);if(w){const t=m.basename(S.path);this.matchFile(E,{base:l.folder,relativePath:r,basename:t});return}this.addDirectoryEntries(v,l.folder,r,E)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,A,E),{providerTime:g,postProcessTime:c.elapsed()})}finally{h.dispose(),this.activeCancellationTokens.delete(h)}}getSearchOptionsForFolder(l){const E=(0,_.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),h=(0,_.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:h,includes:E,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},E,h,p){if(h===this.filePattern){const A=m.basename(this.filePattern);this.matchFile(p,{base:E,relativePath:this.filePattern,basename:A})}function v(A){const w=m.basename(A),s=m.dirname(A);let o=l[s];o||(o=l[s]=[],v(s)),o.push({base:E,relativePath:A,basename:w})}v(h)}matchDirectoryTree({rootEntries:l,pathToEntries:E},h,p){const v=this,A=this.filePattern;function w(s){const o=C.hasSiblingFn(()=>s.map(g=>g.basename));for(let g=0,c=s.length;g<c;g++){const S=s[g],{relativePath:r,basename:t}=S;if(h.matchesExcludesSync(r,t,A!==t?o:void 0))continue;const n=E[r];if(n)w(n);else{if(r===A)continue;v.matchFile(p,S)}if(v.isLimitHit)break}}w(l)}matchFile(l,E){(!this.includePattern||E.relativePath&&this.includePattern(E.relativePath,E.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(E))}}class L{constructor(){this.sessions=new Map}fileSearch(l,E,h,p){const v=this.getSessionTokenSource(l.cacheKey),A=new I(l,E,v&&v.token);let w=0;const s=o=>{w+=o.length,h(o.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(A,L.BATCH_SIZE,s,p).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:o.stats}}))}clearCache(l){const E=this.getSessionTokenSource(l);E&&E.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new i.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:P.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,E,h,p){p.onCancellationRequested(()=>{l.cancel()});const v=w=>{w&&(A.push(w),E>0&&A.length>=E&&(h(A),A=[]))};let A=[];return l.search(v).then(w=>(A.length&&h(A),w),w=>(A.length&&h(A),Promise.reject(w)))}}e.FileSearchManager=L,L.BATCH_SIZE=512}),define(we[134],be([0,1,16,21,50,31,10,9,23,13,2,32]),function(Y,e,m,i,y,C,P,k,_,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(s,o,g,c){this.query=s,this.provider=o,this.fileUtils=g,this.processType=c,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(s,o){const g=this.query.folderQueries||[],c=new i.CancellationTokenSource;return o.onCancellationRequested(()=>c.cancel()),new Promise((S,r)=>{this.collector=new h(s);let t=!1;const n=(u,a)=>{if(!t&&!this.isLimitHit){const f=this.resultSize(u);v(u)&&typeof this.query.maxResults=="number"&&this.resultCount+f>this.query.maxResults&&(this.isLimitHit=!0,t=!0,c.cancel(),u=this.trimResultToSize(u,this.query.maxResults-this.resultCount));const b=this.resultSize(u);this.resultCount+=b,(b>0||!v(u))&&this.collector.add(u,a)}};Promise.all(g.map((u,a)=>this.searchInFolder(u,f=>n(f,a),c.token))).then(u=>{c.dispose(),this.collector.flush();const a=u.some(f=>!!f&&!!f.limitHit);S({limitHit:this.isLimitHit||a,messages:(0,m.flatten)(u.map(f=>f?.message?(0,I.isArray)(f.message)?f.message:[f.message]:[])),stats:{type:this.processType}})},u=>{c.dispose();const a=(0,y.toErrorMessage)(u);r(new Error(a))})})}resultSize(s){return v(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}trimResultToSize(s,o){const g=Array.isArray(s.ranges)?s.ranges:[s.ranges],c=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:g.slice(0,o),preview:{matches:c.slice(0,o),text:s.preview.text},uri:s.uri}}async searchInFolder(s,o,g){const c=new T.QueryGlobTester(this.query,s),S=[],r={report:u=>{if(!this.validateProviderResult(u))return;const a=s.folder.scheme===P.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(_.dirname(u.uri))):void 0,f=_.relativePath(s.folder,u.uri);if(f){const b=c.includedInQuery(f,k.basename(f),a);(0,I.isPromise)(b)?S.push(b.then(d=>{d&&o(u)})):b&&o(u)}}},t=this.getSearchOptionsForFolder(s),n=await this.provider.provideTextSearchResults(E(this.query.contentPattern),t,r,g);return S.length&&await Promise.all(S),n}validateProviderResult(s){if(v(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(s){const o=(0,T.resolvePatternsForProvider)(this.query.includePattern,s.includePattern),g=(0,T.resolvePatternsForProvider)(this.query.excludePattern,s.excludePattern),c={folder:L.URI.from(s.folder),excludes:g,includes:o,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.fileUtils.toCanonicalName(s.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return c.usePCRE2=this.query.usePCRE2,c}}e.TextSearchManager=l;function E(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class h{constructor(s){this._onResult=s,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new A(512,o=>this.sendItems(o))}add(s,o){this._currentFileMatch&&(this._currentFolderIdx!==o||!_.isEqual(this._currentUri,s.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=o,this._currentFileMatch={resource:s.uri,results:[]}),this._currentFileMatch.results.push(p(s))}pushToCollector(){const s=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,s)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(s){this._onResult(s)}}e.TextSearchResultsCollector=h;function p(w){return v(w)?{preview:{matches:(0,m.mapArrayOrNot)(w.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:w.preview.text},ranges:(0,m.mapArrayOrNot)(w.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function v(w){return!!w.preview}e.extensionResultIsMatch=v;class A{constructor(s,o){this.maxBatchSize=s,this.cb=o,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(s,o){!s||this.addItemToBatch(s,o)}addItems(s,o){!s||this.addItemsToBatch(s,o)}addItemToBatch(s,o){this.batch.push(s),this.batchSize+=o,this.onUpdate()}addItemsToBatch(s,o){this.batch=this.batch.concat(s),this.batchSize+=o,this.onUpdate()}onUpdate(){this.totalNumberCompleted<A.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},A.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=A,A.TIMEOUT=4e3,A.START_BATCH_AFTER_COUNT=50}),define(we[72],be([0,1,6,5,4,272,14,64,11,2,134]),function(Y,e,m,i,y,C,P,k,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let T=class{constructor(p,v,A){this.extHostRpc=p,this._uriTransformer=v,this._logService=A,this._proxy=this.extHostRpc.getProxy(i.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}registerTextSearchProvider(p,v){if(this._textSearchUsedSchemes.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this._textSearchUsedSchemes.add(p);const A=this._handlePool++;return this._textSearchProvider.set(A,v),this._proxy.$registerTextSearchProvider(A,this._transformScheme(p)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(p),this._textSearchProvider.delete(A),this._proxy.$unregisterProvider(A)})}registerFileSearchProvider(p,v){if(this._fileSearchUsedSchemes.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this._fileSearchUsedSchemes.add(p);const A=this._handlePool++;return this._fileSearchProvider.set(A,v),this._proxy.$registerFileSearchProvider(A,this._transformScheme(p)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(p),this._fileSearchProvider.delete(A),this._proxy.$unregisterProvider(A)})}$provideFileSearchResults(p,v,A,w){const s=l(A),o=this._fileSearchProvider.get(p);if(o)return this._fileSearchManager.fileSearch(s,o,g=>{this._proxy.$handleFileMatch(p,v,g.map(c=>c.resource))},w);throw new Error("unknown provider: "+p)}$clearCache(p){return this._fileSearchManager.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,v,A,w){const s=this._textSearchProvider.get(p);if(!s||!s.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const o=l(A);return this.createTextSearchManager(o,s).search(c=>this._proxy.$handleTextMatch(p,v,c),w)}$enableExtensionHostSearch(){}createTextSearchManager(p,v){return new L.TextSearchManager(p,v,{readdir:A=>Promise.resolve([]),toCanonicalName:A=>A},"textSearchProvider")}};T=je([ze(0,P.IExtHostRpcService),ze(1,k.IURITransformerService),ze(2,_.ILogService)],T),e.ExtHostSearch=T;function l(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(E),extraFileResources:h.extraFileResources&&h.extraFileResources.map(p=>I.URI.revive(p))}}e.reviveQuery=l;function E(h){return{...h,folder:I.URI.revive(h.folder)}}}),define(we[273],be([0,1,21,15,3,48,2,113,108,146,82,42,5,231,230,38,232,36,233,234,235,216,236,45,39,237,217,240,241,242,132,219,247,248,249,91,34,251,220,17,7,254,68,133,35,74,205,239,62,130,70,55,72,11,64,14,26,243,202,52,65,228,252,201,67,66,257,255,256,229,44,250,253,90,54,121,245,69,246,10,189,244,199,238,6,29]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v,A,w,s,o,g,c,S,r,t,n,u,a,f,b,d,D,R,N,B,F,O,z,W,M,x,V,U,H,X,se,K,j,ie,ce,ge,ke,Le,Oe,q,J,re,he,ee,ae,Se,Ue,Ve,Ge,Je,tt,ot,et,it,ct,pt,Pt,We,Rt,Z,ne,ve,te,_e,Me,Be,Xe,Ae,Pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function de(fe){const Ee=fe.get(J.IExtHostInitDataService),Ce=fe.get(ct.IExtHostFileSystemInfo),Ne=fe.get(Je.IExtHostConsumerFileSystem),Ke=fe.get(r.IExtHostExtensionService),He=fe.get(H.IExtHostWorkspace),Qe=fe.get(Z.IExtHostTelemetry),st=fe.get(A.IExtHostConfiguration),at=fe.get(Oe.IURITransformerService),me=fe.get(q.IExtHostRpcService),De=fe.get(B.IExtHostStorage),ue=fe.get(Ge.IExtensionStoragePaths),Q=fe.get(Le.ILoggerService),Ie=fe.get(Le.ILogService),Fe=fe.get(ee.IExtHostTunnelService),Ze=fe.get(ae.IExtHostApiDeprecationService),qe=fe.get(U.IExtHostWindow),dt=fe.get(We.IExtHostSecretState),wt=fe.get(Rt.IExtHostEditorTabs);me.set(l.ExtHostContext.ExtHostFileSystemInfo,Ce),me.set(l.ExtHostContext.ExtHostLogLevelServiceShape,Q),me.set(l.ExtHostContext.ExtHostWorkspace,He),me.set(l.ExtHostContext.ExtHostConfiguration,st),me.set(l.ExtHostContext.ExtHostExtensionService,Ke),me.set(l.ExtHostContext.ExtHostStorage,De),me.set(l.ExtHostContext.ExtHostTunnelService,Fe),me.set(l.ExtHostContext.ExtHostWindow,qe),me.set(l.ExtHostContext.ExtHostSecretState,dt),me.set(l.ExtHostContext.ExtHostTelemetry,Qe),me.set(l.ExtHostContext.ExtHostEditorTabs,wt);const yt=me.set(l.ExtHostContext.ExtHostDecorations,fe.get(ie.IExtHostDecorations)),bt=me.set(l.ExtHostContext.ExtHostDocumentsAndEditors,fe.get(S.IExtHostDocumentsAndEditors)),ft=me.set(l.ExtHostContext.ExtHostCommands,fe.get(p.IExtHostCommands)),vt=me.set(l.ExtHostContext.ExtHostTerminalService,fe.get(F.IExtHostTerminalService)),_t=me.set(l.ExtHostContext.ExtHostDebugService,fe.get(ge.IExtHostDebugService)),Ot=me.set(l.ExtHostContext.ExtHostSearch,fe.get(ke.IExtHostSearch)),It=me.set(l.ExtHostContext.ExtHostTask,fe.get(ce.IExtHostTask)),Tt=me.set(l.ExtHostContext.ExtHostOutputService,fe.get(b.IExtHostOutputService)),Lt=me.set(l.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(me)),St=me.set(l.ExtHostContext.ExtHostDocuments,new c.ExtHostDocuments(me,bt)),Mt=me.set(l.ExtHostContext.ExtHostDocumentContentProviders,new o.ExtHostDocumentContentProvider(me,bt,Ie)),Nt=me.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new g.ExtHostDocumentSaveParticipant(Ie,St,me.getProxy(l.MainContext.MainThreadBulkEdits))),Et=me.set(l.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(me,ft,bt,St,ue)),Wt=me.set(l.ExtHostContext.ExtHostNotebookDocuments,new Xe.ExtHostNotebookDocuments(Ie,Et)),jt=me.set(l.ExtHostContext.ExtHostNotebookEditors,new Be.ExtHostNotebookEditors(Ie,me,Et)),si=me.set(l.ExtHostContext.ExtHostNotebookKernels,new ne.ExtHostNotebookKernels(me,Ee,Et,ft,Ie)),oi=me.set(l.ExtHostContext.ExtHostNotebookRenderers,new te.ExtHostNotebookRenderers(me,Et)),At=me.set(l.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(me,bt)),Xt=me.set(l.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(me.getProxy(l.MainContext.MainThreadTreeViews),ft,Ie)),ai=me.set(l.ExtHostContext.ExtHostEditorInsets,new se.ExtHostEditorInsets(me.getProxy(l.MainContext.MainThreadEditorInsets),At,Ee)),Yt=me.set(l.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(me,Ie,Ce)),Vt=me.set(l.ExtHostContext.ExtHostLanguages,new a.ExtHostLanguages(me,St,ft.converter,at)),gt=me.set(l.ExtHostContext.ExtHostLanguageFeatures,new u.ExtHostLanguageFeatures(me,at,St,ft,Yt,Ie,Ze)),ci=me.set(l.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(me,gt)),Ut=me.set(l.ExtHostContext.ExtHostFileSystemEventService,new n.ExtHostFileSystemEventService(me,Ie,bt)),qt=me.set(l.ExtHostContext.ExtHostQuickOpen,(0,D.createExtHostQuickOpen)(me,He,ft)),Jt=me.set(l.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(me,ft,Ie)),li=me.set(l.ExtHostContext.ExtHostComments,(0,v.createExtHostComments)(me,ft,St)),fi=me.set(l.ExtHostContext.ExtHostProgress,new d.ExtHostProgress(me.getProxy(l.MainContext.MainThreadProgress))),Ei=me.set(l.ExtHostContext.ExtHosLabelService,new K.ExtHostLabelService(me)),mi=me.set(l.ExtHostContext.ExtHostTheming,new he.ExtHostTheming(me)),Zt=me.set(l.ExtHostContext.ExtHostAuthentication,new Se.ExtHostAuthentication(me)),Si=me.set(l.ExtHostContext.ExtHostTimeline,new Ue.ExtHostTimeline(me,ft)),Gt=me.set(l.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(me,{remote:Ee.remote},He,Ie,Ze)),Kt=me.set(l.ExtHostContext.ExtHostWebviewPanels,new et.ExtHostWebviewPanels(me,Gt,He)),_i=me.set(l.ExtHostContext.ExtHostCustomEditors,new ot.ExtHostCustomEditors(me,St,ue,Gt,Kt)),Ci=me.set(l.ExtHostContext.ExtHostWebviewViews,new tt.ExtHostWebviewViews(me,Gt)),Qt=me.set(l.ExtHostContext.ExtHostTesting,new pt.ExtHostTesting(me,ft)),yi=me.set(l.ExtHostContext.ExtHostUriOpeners,new Pt.ExtHostUriOpeners(me));me.set(l.ExtHostContext.ExtHostInteractive,new Ae.ExtHostInteractive(me,Et,bt,ft));const ei=(0,X.values)(l.ExtHostContext);me.assertRegistered(ei);const Di=new it.ExtHostBulkEdits(me,bt),ki=new h.ExtHostClipboard(me),ui=new f.ExtHostMessageService(me,Ie),ti=new s.ExtHostDialogs(me),gi=new N.ExtHostStatusBar(me,ft.converter);return E.ExtHostApiCommands.register(ft),function($e,Bt,pi){const mt=function(){let oe=!$e.isUnderDevelopment;function pe(){oe||(Ie.info(`Extension '${$e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),oe=!0)}return function Re(ut){if(Array.isArray(ut))ut.forEach(Re);else if(typeof ut=="string")pe();else{const Ct=ut;typeof Ct.scheme=="undefined"&&pe(),typeof Ct.exclusive=="boolean"&&(0,ye.checkProposedApiEnabled)($e,"documentFiltersExclusive")}return ut}}(),ii={getSession(oe,pe,Re){return Zt.getSession($e,oe,pe,Re)},async hasSession(oe,pe){return(0,ye.checkProposedApiEnabled)($e,"authSession"),!!await Zt.getSession($e,oe,pe,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(oe,pe,Re,ut){return Zt.registerAuthenticationProvider(oe,pe,Re,ut)}},Ii={registerCommand(oe,pe,Re){return ft.registerCommand(!0,oe,pe,Re,void 0,$e)},registerTextEditorCommand(oe,pe,Re){return ft.registerCommand(!0,oe,(...ut)=>{const Ct=At.getActiveTextEditor();if(!Ct){Ie.warn("Cannot execute "+oe+" because there is no active text editor.");return}return Ct.edit(Dt=>{pe.apply(Re,[Ct,Dt,...ut])}).then(Dt=>{Dt||Ie.warn("Edits from command "+oe+" were not applied.")},Dt=>{Ie.warn("An error occurred while running command "+oe,Dt)})},void 0,void 0,$e)},registerDiffInformationCommand:(oe,pe,Re)=>((0,ye.checkProposedApiEnabled)($e,"diffCommand"),ft.registerCommand(!0,oe,async(...ut)=>{const Ct=bt.activeEditor(!0);if(!Ct){Ie.warn("Cannot execute "+oe+" because there is no active text editor.");return}const Dt=await At.getDiffInformation(Ct.id);pe.apply(Re,[Dt,...ut])},void 0,void 0,$e)),executeCommand(oe,...pe){return ft.executeCommand(oe,...pe)},getCommands(oe=!1){return ft.getCommands(oe)}},vi={get machineId(){return Ee.telemetryInfo.machineId},get sessionId(){return Ee.telemetryInfo.sessionId},get language(){return Ee.environment.appLanguage},get appName(){return Ee.environment.appName},get appRoot(){return Ee.environment.appRoot?.fsPath??""},get appHost(){return Ee.environment.appHost},get uriScheme(){return Ee.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return Qe.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Qe.onDidChangeTelemetryEnabled},get isNewAppInstall(){const oe=Date.now()-new Date(Ee.telemetryInfo.firstSessionDate).getTime();return isNaN(oe)?!1:oe<1e3*60*60*24},openExternal(oe,pe){return qe.openUri(oe,{allowTunneling:!!Ee.remote.authority,allowContributedOpeners:pe?.allowContributedOpeners})},async asExternalUri(oe){if(oe.scheme===Ee.environment.appUriScheme)return Lt.createAppUri(oe);try{return await qe.asExternalUri(oe,{allowTunneling:!!Ee.remote.authority})}catch(pe){if((0,Me.matchesScheme)(oe,_e.Schemas.http)||(0,Me.matchesScheme)(oe,_e.Schemas.https))return oe;throw pe}},get remoteName(){return(0,j.getRemoteName)(Ee.remote.authority)},get remoteAuthority(){return(0,ye.checkProposedApiEnabled)($e,"resolvers"),Ee.remote.authority},get uiKind(){return Ee.uiKind}};Ee.environment.extensionTestsLocationURI||Object.freeze(vi);const wi=Ee.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,Pi={createTestController(oe,pe){return Qt.createTestController(oe,pe)},createTestObserver(){return(0,ye.checkProposedApiEnabled)($e,"testObserver"),Qt.createTestObserver()},runTests(oe){return(0,ye.checkProposedApiEnabled)($e,"testObserver"),Qt.runTests(oe)},get onDidChangeTestResults(){return(0,ye.checkProposedApiEnabled)($e,"testObserver"),Qt.onResultsChanged},get testResults(){return(0,ye.checkProposedApiEnabled)($e,"testObserver"),Qt.results}},Ti={getExtension(oe){const pe=Bt.getExtensionDescription(oe);if(pe)return new r.Extension(Ke,$e.identifier,pe,wi)},get all(){return Bt.getAllExtensionDescriptions().map(oe=>new r.Extension(Ke,$e.identifier,oe,wi))},get onDidChange(){return Bt.onDidChange}},Ai={createDiagnosticCollection(oe){return Yt.createDiagnosticCollection($e.identifier,oe)},get onDidChangeDiagnostics(){return Yt.onDidChangeDiagnostics},getDiagnostics:oe=>Yt.getDiagnostics(oe),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(oe,pe){return Vt.changeLanguage(oe.uri,pe)},match(oe,pe){return(0,L.score)(W.LanguageSelector.from(oe),pe.uri,pe.languageId,!0)},registerCodeActionsProvider(oe,pe,Re){return gt.registerCodeActionProvider($e,mt(oe),pe,Re)},registerCodeLensProvider(oe,pe){return gt.registerCodeLensProvider($e,mt(oe),pe)},registerDefinitionProvider(oe,pe){return gt.registerDefinitionProvider($e,mt(oe),pe)},registerDeclarationProvider(oe,pe){return gt.registerDeclarationProvider($e,mt(oe),pe)},registerImplementationProvider(oe,pe){return gt.registerImplementationProvider($e,mt(oe),pe)},registerTypeDefinitionProvider(oe,pe){return gt.registerTypeDefinitionProvider($e,mt(oe),pe)},registerHoverProvider(oe,pe){return gt.registerHoverProvider($e,mt(oe),pe,$e.identifier)},registerEvaluatableExpressionProvider(oe,pe){return gt.registerEvaluatableExpressionProvider($e,mt(oe),pe,$e.identifier)},registerInlineValuesProvider(oe,pe){return gt.registerInlineValuesProvider($e,mt(oe),pe,$e.identifier)},registerDocumentHighlightProvider(oe,pe){return gt.registerDocumentHighlightProvider($e,mt(oe),pe)},registerLinkedEditingRangeProvider(oe,pe){return gt.registerLinkedEditingRangeProvider($e,mt(oe),pe)},registerReferenceProvider(oe,pe){return gt.registerReferenceProvider($e,mt(oe),pe)},registerRenameProvider(oe,pe){return gt.registerRenameProvider($e,mt(oe),pe)},registerDocumentSymbolProvider(oe,pe,Re){return gt.registerDocumentSymbolProvider($e,mt(oe),pe,Re)},registerWorkspaceSymbolProvider(oe){return gt.registerWorkspaceSymbolProvider($e,oe)},registerDocumentFormattingEditProvider(oe,pe){return gt.registerDocumentFormattingEditProvider($e,mt(oe),pe)},registerDocumentRangeFormattingEditProvider(oe,pe){return gt.registerDocumentRangeFormattingEditProvider($e,mt(oe),pe)},registerOnTypeFormattingEditProvider(oe,pe,Re,...ut){return gt.registerOnTypeFormattingEditProvider($e,mt(oe),pe,[Re].concat(ut))},registerDocumentSemanticTokensProvider(oe,pe,Re){return gt.registerDocumentSemanticTokensProvider($e,mt(oe),pe,Re)},registerDocumentRangeSemanticTokensProvider(oe,pe,Re){return gt.registerDocumentRangeSemanticTokensProvider($e,mt(oe),pe,Re)},registerSignatureHelpProvider(oe,pe,Re,...ut){return typeof Re=="object"?gt.registerSignatureHelpProvider($e,mt(oe),pe,Re):gt.registerSignatureHelpProvider($e,mt(oe),pe,typeof Re=="undefined"?[]:[Re,...ut])},registerCompletionItemProvider(oe,pe,...Re){return gt.registerCompletionItemProvider($e,mt(oe),pe,Re)},registerInlineCompletionItemProvider(oe,pe){return(0,ye.checkProposedApiEnabled)($e,"inlineCompletions"),gt.registerInlineCompletionsProvider($e,mt(oe),pe)},registerDocumentLinkProvider(oe,pe){return gt.registerDocumentLinkProvider($e,mt(oe),pe)},registerColorProvider(oe,pe){return gt.registerColorProvider($e,mt(oe),pe)},registerFoldingRangeProvider(oe,pe){return gt.registerFoldingRangeProvider($e,mt(oe),pe)},registerSelectionRangeProvider(oe,pe){return gt.registerSelectionRangeProvider($e,oe,pe)},registerCallHierarchyProvider(oe,pe){return gt.registerCallHierarchyProvider($e,oe,pe)},registerTypeHierarchyProvider(oe,pe){return gt.registerTypeHierarchyProvider($e,oe,pe)},setLanguageConfiguration:(oe,pe)=>gt.setLanguageConfiguration($e,oe,pe),getTokenInformationAtPosition(oe,pe){return(0,ye.checkProposedApiEnabled)($e,"tokenInformation"),Vt.tokenAtPosition(oe,pe)},registerInlayHintsProvider(oe,pe){return(0,ye.checkProposedApiEnabled)($e,"inlayHints"),gt.registerInlayHintsProvider($e,oe,pe)},createLanguageStatusItem(oe,pe){return(0,ye.checkProposedApiEnabled)($e,"languageStatus"),Vt.createLanguageStatusItem($e,oe,pe)}},Ri={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(oe,pe,Re){const ut=await(P.URI.isUri(oe)?Promise.resolve(ni.openTextDocument(oe)):Promise.resolve(oe));return At.showTextDocument(ut,pe,Re)},createTextEditorDecorationType(oe){return At.createTextEditorDecorationType($e,oe)},onDidChangeActiveTextEditor(oe,pe,Re){return At.onDidChangeActiveTextEditor(oe,pe,Re)},onDidChangeVisibleTextEditors(oe,pe,Re){return At.onDidChangeVisibleTextEditors(oe,pe,Re)},onDidChangeTextEditorSelection(oe,pe,Re){return At.onDidChangeTextEditorSelection(oe,pe,Re)},onDidChangeTextEditorOptions(oe,pe,Re){return At.onDidChangeTextEditorOptions(oe,pe,Re)},onDidChangeTextEditorVisibleRanges(oe,pe,Re){return At.onDidChangeTextEditorVisibleRanges(oe,pe,Re)},onDidChangeTextEditorViewColumn(oe,pe,Re){return At.onDidChangeTextEditorViewColumn(oe,pe,Re)},onDidCloseTerminal(oe,pe,Re){return vt.onDidCloseTerminal(oe,pe,Re)},onDidOpenTerminal(oe,pe,Re){return vt.onDidOpenTerminal(oe,pe,Re)},onDidChangeActiveTerminal(oe,pe,Re){return vt.onDidChangeActiveTerminal(oe,pe,Re)},onDidChangeTerminalDimensions(oe,pe,Re){return(0,ye.checkProposedApiEnabled)($e,"terminalDimensions"),vt.onDidChangeTerminalDimensions(oe,pe,Re)},onDidChangeTerminalState(oe,pe,Re){return vt.onDidChangeTerminalState(oe,pe,Re)},onDidWriteTerminalData(oe,pe,Re){return(0,ye.checkProposedApiEnabled)($e,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(oe,pe,Re)},get state(){return qe.state},onDidChangeWindowState(oe,pe,Re){return qe.onDidChangeWindowState(oe,pe,Re)},showInformationMessage(oe,...pe){return ui.showMessage($e,C.default.Info,oe,pe[0],pe.slice(1))},showWarningMessage(oe,...pe){return ui.showMessage($e,C.default.Warning,oe,pe[0],pe.slice(1))},showErrorMessage(oe,...pe){return ui.showMessage($e,C.default.Error,oe,pe[0],pe.slice(1))},showQuickPick(oe,pe,Re){return Array.isArray(oe)&&oe.some(ut=>ut.kind!==void 0)&&(0,ye.checkProposedApiEnabled)($e,"quickPickSeparators"),qt.showQuickPick(oe,pe,Re)},showWorkspaceFolderPick(oe){return qt.showWorkspaceFolderPick(oe)},showInputBox(oe,pe){return qt.showInput(oe,pe)},showOpenDialog(oe){return ti.showOpenDialog(oe)},showSaveDialog(oe){return ti.showSaveDialog(oe)},createStatusBarItem(oe,pe,Re){let ut,Ct,Dt;return typeof oe=="string"?(ut=oe,Ct=pe,Dt=Re):(Ct=oe,Dt=pe),gi.createStatusBarEntry($e,ut,Ct,Dt)},setStatusBarMessage(oe,pe){return gi.setStatusBarMessage(oe,pe)},withScmProgress(oe){return Ze.report("window.withScmProgress",$e,"Use 'withProgress' instead."),fi.withProgress($e,{location:M.ProgressLocation.SourceControl},(pe,Re)=>oe({report(ut){}}))},withProgress(oe,pe){return fi.withProgress($e,oe,pe)},createOutputChannel(oe){return Tt.createOutputChannel(oe,$e)},createWebviewPanel(oe,pe,Re,ut){return Kt.createWebviewPanel($e,oe,pe,Re,ut)},createWebviewTextEditorInset(oe,pe,Re,ut){return(0,ye.checkProposedApiEnabled)($e,"editorInsets"),ai.createWebviewEditorInset(oe,pe,Re,ut,$e)},createTerminal(oe,pe,Re){return typeof oe=="object"?"pty"in oe?vt.createExtensionTerminal(oe):vt.createTerminalFromOptions(oe):vt.createTerminal(oe,pe,Re)},registerTerminalLinkProvider(oe){return vt.registerLinkProvider(oe)},registerTerminalProfileProvider(oe,pe){return vt.registerProfileProvider($e,oe,pe)},registerTreeDataProvider(oe,pe){return Xt.registerTreeDataProvider(oe,pe,$e)},createTreeView(oe,pe){return Xt.createTreeView(oe,pe,$e)},registerWebviewPanelSerializer:(oe,pe)=>Kt.registerWebviewPanelSerializer($e,oe,pe),registerCustomEditorProvider:(oe,pe,Re={})=>_i.registerCustomEditorProvider($e,oe,pe,Re),registerFileDecorationProvider(oe){return yt.registerFileDecorationProvider(oe,$e.identifier)},registerUriHandler(oe){return Lt.registerUriHandler($e.identifier,oe)},createQuickPick(){return qt.createQuickPick($e)},createInputBox(){return qt.createInputBox($e.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(oe,pe,Re){return mi.onDidChangeActiveColorTheme(oe,pe,Re)},registerWebviewViewProvider(oe,pe,Re){return Ci.registerWebviewViewProvider($e,oe,pe,Re?.webviewOptions)},get activeNotebookEditor(){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(oe,pe,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.onDidChangeActiveNotebookEditor(oe,pe,Re)},get visibleNotebookEditors(){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(oe,pe,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),jt.onDidChangeNotebookEditorSelection(oe,pe,Re)},onDidChangeNotebookEditorVisibleRanges(oe,pe,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),jt.onDidChangeNotebookEditorVisibleRanges(oe,pe,Re)},showNotebookDocument(oe,pe){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.showNotebookDocument(oe,pe)},registerExternalUriOpener(oe,pe,Re){return(0,ye.checkProposedApiEnabled)($e,"externalUriOpener"),yi.registerExternalUriOpener($e.identifier,oe,pe,Re)},get tabs(){return(0,ye.checkProposedApiEnabled)($e,"tabs"),wt.tabs},get activeTab(){return(0,ye.checkProposedApiEnabled)($e,"tabs"),wt.activeTab},get onDidChangeTabs(){return(0,ye.checkProposedApiEnabled)($e,"tabs"),wt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ye.checkProposedApiEnabled)($e,"tabs"),wt.onDidChangeActiveTab},getInlineCompletionItemController(oe){return(0,ye.checkProposedApiEnabled)($e,"inlineCompletions"),u.InlineCompletionController.get(oe)}},ni={get rootPath(){return Ze.report("workspace.rootPath",$e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),He.getPath()},set rootPath(oe){throw i.readonly()},getWorkspaceFolder(oe){return He.getWorkspaceFolder(oe)},get workspaceFolders(){return He.getWorkspaceFolders()},get name(){return He.name},set name(oe){throw i.readonly()},get workspaceFile(){return He.workspaceFile},set workspaceFile(oe){throw i.readonly()},updateWorkspaceFolders:(oe,pe,...Re)=>He.updateWorkspaceFolders($e,oe,pe||0,...Re),onDidChangeWorkspaceFolders:function(oe,pe,Re){return He.onDidChangeWorkspace(oe,pe,Re)},asRelativePath:(oe,pe)=>He.getRelativePath(oe,pe),findFiles:(oe,pe,Re,ut)=>He.findFiles(W.GlobPattern.from(oe),W.GlobPattern.from(pe),Re,$e.identifier,ut),findTextInFiles:(oe,pe,Re,ut)=>{(0,ye.checkProposedApiEnabled)($e,"findTextInFiles");let Ct,Dt;return typeof pe=="object"?(Ct=pe,Dt=Re):(Ct={},Dt=pe,ut=Re),He.findTextInFiles(oe,Ct||{},Dt,$e.identifier,ut)},saveAll:oe=>He.saveAll(oe),applyEdit(oe){return Di.applyWorkspaceEdit(oe)},createFileSystemWatcher:(oe,pe,Re,ut)=>Ut.createFileSystemWatcher(W.GlobPattern.from(oe),pe,Re,ut),get textDocuments(){return St.getAllDocumentData().map(oe=>oe.document)},set textDocuments(oe){throw i.readonly()},openTextDocument(oe){let pe;const Re=oe;if(typeof oe=="string")pe=Promise.resolve(P.URI.file(oe));else if(P.URI.isUri(oe))pe=Promise.resolve(oe);else if(!Re||typeof Re=="object")pe=St.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return pe.then(ut=>St.ensureDocumentData(ut).then(Ct=>Ct.document))},onDidOpenTextDocument:(oe,pe,Re)=>St.onDidAddDocument(oe,pe,Re),onDidCloseTextDocument:(oe,pe,Re)=>St.onDidRemoveDocument(oe,pe,Re),onDidChangeTextDocument:(oe,pe,Re)=>St.onDidChangeDocument(oe,pe,Re),onDidSaveTextDocument:(oe,pe,Re)=>St.onDidSaveDocument(oe,pe,Re),onWillSaveTextDocument:(oe,pe,Re)=>Nt.getOnWillSaveTextDocumentEvent($e)(oe,pe,Re),get notebookDocuments(){return Et.notebookDocuments.map(oe=>oe.apiNotebook)},async openNotebookDocument(oe,pe){let Re;if(P.URI.isUri(oe))Re=oe,await Et.openNotebookDocument(oe);else if(typeof oe=="string")Re=P.URI.revive(await Et.createNotebookDocument({viewType:oe,content:pe}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Re).apiNotebook},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(oe,pe,Re,ut){return Et.registerNotebookSerializer($e,oe,pe,Re,(0,ye.isProposedApiEnabled)($e,"notebookLiveShare")?ut:void 0)},registerNotebookContentProvider:(oe,pe,Re,ut)=>((0,ye.checkProposedApiEnabled)($e,"notebookContentProvider"),Et.registerNotebookContentProvider($e,oe,pe,Re,(0,ye.isProposedApiEnabled)($e,"notebookLiveShare")?ut:void 0)),onDidChangeConfiguration:(oe,pe,Re)=>pi.onDidChangeConfiguration(oe,pe,Re),getConfiguration(oe,pe){return pe=arguments.length===1?void 0:pe,pi.getConfiguration(oe,pe,$e)},registerTextDocumentContentProvider(oe,pe){return Mt.registerTextDocumentContentProvider(oe,pe)},registerTaskProvider:(oe,pe)=>(Ze.report("window.registerTaskProvider",$e,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider($e,oe,pe)),registerFileSystemProvider(oe,pe,Re){return(0,Pe.combinedDisposable)(ci.registerFileSystemProvider($e,oe,pe,Re),Ne.addFileSystemProvider(oe,pe))},get fs(){return Ne.value},registerFileSearchProvider:(oe,pe)=>((0,ye.checkProposedApiEnabled)($e,"fileSearchProvider"),Ot.registerFileSearchProvider(oe,pe)),registerTextSearchProvider:(oe,pe)=>((0,ye.checkProposedApiEnabled)($e,"textSearchProvider"),Ot.registerTextSearchProvider(oe,pe)),registerRemoteAuthorityResolver:(oe,pe)=>((0,ye.checkProposedApiEnabled)($e,"resolvers"),Ke.registerRemoteAuthorityResolver(oe,pe)),registerResourceLabelFormatter:oe=>((0,ye.checkProposedApiEnabled)($e,"resolvers"),Ei.$registerResourceLabelFormatter(oe)),onDidCreateFiles:(oe,pe,Re)=>Ut.onDidCreateFile(oe,pe,Re),onDidDeleteFiles:(oe,pe,Re)=>Ut.onDidDeleteFile(oe,pe,Re),onDidRenameFiles:(oe,pe,Re)=>Ut.onDidRenameFile(oe,pe,Re),onWillCreateFiles:(oe,pe,Re)=>Ut.getOnWillCreateFileEvent($e)(oe,pe,Re),onWillDeleteFiles:(oe,pe,Re)=>Ut.getOnWillDeleteFileEvent($e)(oe,pe,Re),onWillRenameFiles:(oe,pe,Re)=>Ut.getOnWillRenameFileEvent($e)(oe,pe,Re),openTunnel:oe=>((0,ye.checkProposedApiEnabled)($e,"resolvers"),Fe.openTunnel($e,oe).then(pe=>{if(!pe)throw new Error("cannot open tunnel");return pe})),get tunnels(){return(0,ye.checkProposedApiEnabled)($e,"resolvers"),Fe.getTunnels()},onDidChangeTunnels:(oe,pe,Re)=>((0,ye.checkProposedApiEnabled)($e,"resolvers"),Fe.onDidChangeTunnels(oe,pe,Re)),registerPortAttributesProvider:(oe,pe)=>((0,ye.checkProposedApiEnabled)($e,"portsAttributes"),Fe.registerPortsAttributesProvider(oe,pe)),registerTimelineProvider:(oe,pe)=>((0,ye.checkProposedApiEnabled)($e,"timeline"),Si.registerTimelineProvider(oe,pe,$e.identifier,ft.converter)),get isTrusted(){return He.trusted},requestWorkspaceTrust:oe=>((0,ye.checkProposedApiEnabled)($e,"workspaceTrust"),He.requestWorkspaceTrust(oe)),onDidGrantWorkspaceTrust:(oe,pe,Re)=>He.onDidGrantWorkspaceTrust(oe,pe,Re)},Li={get inputBox(){return Ze.report("scm.inputBox",$e,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox($e)},createSourceControl(oe,pe,Re){return Jt.createSourceControl($e,oe,pe,Re)}},Fi={createCommentController(oe,pe){return li.createCommentController($e,oe,pe)}},Mi={get activeDebugSession(){return _t.activeDebugSession},get activeDebugConsole(){return _t.activeDebugConsole},get breakpoints(){return _t.breakpoints},onDidStartDebugSession(oe,pe,Re){return _t.onDidStartDebugSession(oe,pe,Re)},onDidTerminateDebugSession(oe,pe,Re){return _t.onDidTerminateDebugSession(oe,pe,Re)},onDidChangeActiveDebugSession(oe,pe,Re){return _t.onDidChangeActiveDebugSession(oe,pe,Re)},onDidReceiveDebugSessionCustomEvent(oe,pe,Re){return _t.onDidReceiveDebugSessionCustomEvent(oe,pe,Re)},onDidChangeBreakpoints(oe,pe,Re){return _t.onDidChangeBreakpoints(oe,pe,Re)},registerDebugConfigurationProvider(oe,pe,Re){return _t.registerDebugConfigurationProvider(oe,pe,Re||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(oe,pe){return _t.registerDebugAdapterDescriptorFactory($e,oe,pe)},registerDebugAdapterTrackerFactory(oe,pe){return _t.registerDebugAdapterTrackerFactory(oe,pe)},startDebugging(oe,pe,Re){return!Re||typeof Re=="object"&&"configuration"in Re?_t.startDebugging(oe,pe,{parentSession:Re}):_t.startDebugging(oe,pe,Re||{})},stopDebugging(oe){return _t.stopDebugging(oe)},addBreakpoints(oe){return _t.addBreakpoints(oe)},removeBreakpoints(oe){return _t.removeBreakpoints(oe)},asDebugSourceUri(oe,pe){return _t.asDebugSourceUri(oe,pe)}},Oi={registerTaskProvider:(oe,pe)=>It.registerTaskProvider($e,oe,pe),fetchTasks:oe=>It.fetchTasks(oe),executeTask:oe=>It.executeTask($e,oe),get taskExecutions(){return It.taskExecutions},onDidStartTask:(oe,pe,Re)=>It.onDidStartTask(oe,pe,Re),onDidEndTask:(oe,pe,Re)=>It.onDidEndTask(oe,pe,Re),onDidStartTaskProcess:(oe,pe,Re)=>It.onDidStartTaskProcess(oe,pe,Re),onDidEndTaskProcess:(oe,pe,Re)=>It.onDidEndTaskProcess(oe,pe,Re)},Ni={createNotebookController(oe,pe,Re,ut,Ct){return si.createNotebookController($e,oe,pe,Re,ut,(0,ye.isProposedApiEnabled)($e,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(oe,pe)=>Et.registerNotebookCellStatusBarItemProvider($e,oe,pe),get onDidSaveNotebookDocument(){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Wt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(oe){return(0,ye.checkProposedApiEnabled)($e,"notebookEditorDecorationType"),jt.createNotebookEditorDecorationType(oe)},createRendererMessaging(oe){return oi.createRendererMessaging($e,oe)},onDidChangeNotebookDocumentMetadata(oe,pe,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Wt.onDidChangeNotebookDocumentMetadata(oe,pe,Re)},onDidChangeNotebookCells(oe,pe,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.onDidChangeNotebookCells(oe,pe,Re)},onDidChangeNotebookCellExecutionState(oe,pe,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookCellExecutionState"),Et.onDidChangeNotebookCellExecutionState(oe,pe,Re)},onDidChangeCellOutputs(oe,pe,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.onDidChangeCellOutputs(oe,pe,Re)},onDidChangeCellMetadata(oe,pe,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.onDidChangeCellMetadata(oe,pe,Re)},createConcatTextDocument(oe,pe){return(0,ye.checkProposedApiEnabled)($e,"notebookConcatTextDocument"),new Ve.ExtHostNotebookConcatDocument(Et,St,oe,pe)}};return{version:Ee.version,authentication:ii,commands:Ii,comments:Fi,debug:Mi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Li,tasks:Oi,tests:Pi,window:Ri,workspace:ni,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:i.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:M.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:T.FileType,FilePermission:T.FilePermission,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,InlineCompletionItem:M.InlineSuggestion,InlineCompletionList:M.InlineSuggestions,Hover:M.Hover,IndentAction:I.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TerminalLink:M.TerminalLink,TerminalLocation:M.TerminalLocation,TerminalProfile:M.TerminalProfile,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,TextDocumentChangeReason:M.TextDocumentChangeReason,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,TypeHierarchyItem:M.TypeHierarchyItem,UIKind:l.UIKind,Uri:P.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlayHint:M.InlayHint,InlayHintKind:M.InlayHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookRendererScript:M.NotebookRendererScript,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,NotebookControllerAffinity:M.NotebookControllerAffinity,PortAttributes:M.PortAttributes,LinkedEditingRanges:M.LinkedEditingRanges,TestResultState:M.TestResultState,TestRunRequest:M.TestRunRequest,TestMessage:M.TestMessage,TestTag:M.TestTag,TestRunProfileKind:M.TestRunProfileKind,TextSearchCompleteMessageType:ve.TextSearchCompleteMessageType,TreeDataTransfer:M.TreeDataTransfer,TreeDataTransferItem:M.TreeDataTransferItem,CoveredCount:M.CoveredCount,FileCoverage:M.FileCoverage,StatementCoverage:M.StatementCoverage,BranchCoverage:M.BranchCoverage,FunctionCoverage:M.FunctionCoverage,WorkspaceTrustState:M.WorkspaceTrustState,LanguageStatusSeverity:M.LanguageStatusSeverity,QuickPickItemKind:M.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=de}),define(we[274],be([0,1,83,132,35,130,36,38,45,34,70,55,72,91,52,65,133,66,44,90,121,54,131,11,226]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v,A,w,s,o,g,c,S,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(S.ILoggerService,c.ExtHostLoggerService),(0,m.registerSingleton)(S.ILogService,r.ExtHostLogService),(0,m.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),(0,m.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,m.registerSingleton)(P.IExtHostConfiguration,P.ExtHostConfiguration),(0,m.registerSingleton)(A.IExtHostConsumerFileSystem,A.ExtHostConsumerFileSystem),(0,m.registerSingleton)(T.IExtHostDebugService,T.WorkerExtHostDebugService),(0,m.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,m.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,m.registerSingleton)(w.IExtHostFileSystemInfo,w.ExtHostFileSystemInfo),(0,m.registerSingleton)(i.IExtHostOutputService,i.ExtHostOutputService),(0,m.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,m.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage),(0,m.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask),(0,m.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService),(0,m.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService),(0,m.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,m.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace),(0,m.registerSingleton)(s.IExtHostSecretState,s.ExtHostSecretState),(0,m.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry),(0,m.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs)}),define(we[92],be([0,1,16,11,32,69]),function(Y,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function P(T){return T.startsWith("**")||T.startsWith("/")?T:`/${T}`}e.anchorGlob=P;function k(T,l,E,h){const p=(0,m.mapArrayOrNot)(E,_),v=new y.TextSearchMatch(l,p,h),A=v.preview.matches;return{ranges:(0,m.mapArrayOrNot)(p,I),uri:T,preview:{text:v.preview.text,matches:(0,m.mapArrayOrNot)(A,I)}}}e.createTextSearchResult=k;function _(T){return new y.SearchRange(T.start.line,T.start.character,T.end.line,T.end.character)}function I(T){return new C.Range(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn)}let L=class{constructor(l,E){this.prefix=l,this.logService=E}appendLine(l){this.logService.debug(`${this.prefix}#search`,l)}};L=je([ze(1,i.ILogService)],L),e.OutputChannel=L}),define(we[275],be([0,1,95,22]),function(Y,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function y(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(t=>t===r)}e.isUTFEncoding=y,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,P=512,k=512*8,_=512*128;var I;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(t,n){super(t);this.decodeStreamErrorKind=n}}e.DecodeStreamError=L;class T{constructor(t){this.iconvLiteDecoder=t}static async create(t){let n;if(t!==e.UTF8)n=(await new Promise((a,f)=>{Y(["iconv-lite-umd"],a,f)})).getDecoder(p(t));else{const u=new TextDecoder;n={write(a){return u.decode(a,{stream:!0})},end(){return u.decode()}}}return new T(n)}write(t){return this.iconvLiteDecoder.write(t)}end(){return this.iconvLiteDecoder.end()}}function l(r,t){const n=t.minBytesRequiredForDetection??t.guessEncoding?k:P;return new Promise((u,a)=>{const f=(0,m.newWriteableStream)(B=>B.join("")),b=[];let d=0,D,R;const N=async()=>{try{const B=await S({buffer:i.VSBuffer.concat(b),bytesRead:d},t.guessEncoding);if(B.seemsBinary&&t.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);B.encoding=await t.overwriteEncoding(B.encoding),D=await T.create(B.encoding);const F=D.write(i.VSBuffer.concat(b).buffer);f.write(F),b.length=0,d=0,u({stream:f,detected:B})}catch(B){R?.dispose(),f.destroy(),a(B)}};R=(0,m.listenStream)(r,{onData:async B=>{D?f.write(D.write(B.buffer)):(b.push(B),d+=B.byteLength,d>=n&&(r.pause(),await N(),setTimeout(()=>r.resume())))},onError:B=>f.error(B),onEnd:async()=>{D||await N(),f.end(D?.end())}})})}e.toDecodeStream=l;async function E(r,t,n){const a=(await new Promise((d,D)=>{Y(["iconv-lite-umd"],d,D)})).getEncoder(p(t),n);let f=!1,b=!1;return{read(){if(b)return null;const d=r.read();if(typeof d!="string"){if(b=!0,!f&&n?.addBOM)switch(t){case e.UTF8:case e.UTF8_with_bom:return i.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const D=a.end();return D&&D.length>0?(f=!0,i.VSBuffer.wrap(D)):null}return f=!0,i.VSBuffer.wrap(a.write(d))}}}e.toEncodeReadable=E;async function h(r){return(await new Promise((n,u)=>{Y(["iconv-lite-umd"],n,u)})).encodingExists(p(r))}e.encodingExists=h;function p(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=p;function v(r,t){if(!r||t<e.UTF16be_BOM.length)return null;const n=r.readUInt8(0),u=r.readUInt8(1);if(n===e.UTF16be_BOM[0]&&u===e.UTF16be_BOM[1])return e.UTF16be;if(n===e.UTF16le_BOM[0]&&u===e.UTF16le_BOM[1])return e.UTF16le;if(t<e.UTF8_BOM.length)return null;const a=r.readUInt8(2);return n===e.UTF8_BOM[0]&&u===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=v;const A=["ascii","utf-16","utf-32"];async function w(r){const t=await new Promise((b,d)=>{Y(["jschardet"],b,d)}),n=r.slice(0,_),u=g(n.buffer),a=t.detect(u);if(!a||!a.encoding)return null;const f=a.encoding.toLowerCase();return 0<=A.indexOf(f)?null:o(a.encoding)}const s={ibm866:"cp866",big5:"cp950"};function o(r){const t=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return s[t]||t}function g(r){let t="";for(let n=0;n<r.length;n++)t+=String.fromCharCode(r[n]);return t}function c(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const t=r.match(/windows(\d+)/);return t?"windows-"+t[1]:r}}}e.toCanonicalName=c;function S({buffer:r,bytesRead:t},n){let u=v(r,t),a=!1;if(u!==e.UTF16be&&u!==e.UTF16le&&r){let f=!0,b=!0,d=!1;for(let D=0;D<t&&D<C;D++){const R=D%2==1,N=r.readUInt8(D)===0;if(N&&(d=!0),f&&(R&&!N||!R&&N)&&(f=!1),b&&(R&&N||!R&&!N)&&(b=!1),N&&!f&&!b)break}d&&(f?u=e.UTF16le:b?u=e.UTF16be:a=!0)}return n&&!a&&!u&&r?w(r.slice(0,t)).then(f=>({seemsBinary:!1,encoding:f})):{seemsBinary:a,encoding:u}}e.detectEncodingFromBuffer=S,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(we[135],be([0,1,275,28,134]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends y.TextSearchManager{constructor(k,_,I=i,L="searchProcess"){super(k,_,{readdir:T=>I.Promises.readdir(T.fsPath),toCanonicalName:T=>(0,m.toCanonicalName)(T)},L)}}e.NativeTextSearchManager=C}),define(we[276],be([0,1,277,291,292,2,293]),function(Y,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(T,l,E,h,p,v){const A=v.environment.useHostProxy,w=typeof A=="boolean"?A:!v.remote.isRemote,s=(0,P.createProxyResolver)({resolveProxy:g=>T.resolveProxy(g),getHttpProxySetting:()=>l.getConfiguration("http").get("proxy"),log:(g,c,...S)=>{switch(g){case P.LogLevel.Trace:h.trace(c,...S);break;case P.LogLevel.Debug:h.debug(c,...S);break;case P.LogLevel.Info:h.info(c,...S);break;case P.LogLevel.Warning:h.warn(c,...S);break;case P.LogLevel.Error:h.error(c,...S);break;case P.LogLevel.Critical:h.critical(c,...S);break;case P.LogLevel.Off:break;default:r(g,c,S);break}function r(t,n,...u){h.error("Unknown log level",t),h.error(n,...u)}},getLogLevel:()=>h.getLevel(),proxyResolveTelemetry:g=>{p.$publicLog2("resolveProxy",g)},useHostProxy:w,env:process.env}),o=_(l,s);return L(E,o)}e.connectProxyResolver=k;function _(T,l){const E={config:T.getConfiguration("http").get("proxySupport")||"off"};T.onDidChangeConfiguration(p=>{E.config=T.getConfiguration("http").get("proxySupport")||"off"});const h={config:!!T.getConfiguration("http").get("systemCertificates")};return T.onDidChangeConfiguration(p=>{h.config=!!T.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},m,(0,P.createHttpPatch)(m,l,{config:"off"},h,!0)),on:Object.assign({},m,(0,P.createHttpPatch)(m,l,{config:"on"},h,!0)),override:Object.assign({},m,(0,P.createHttpPatch)(m,l,{config:"override"},h,!0)),onRequest:Object.assign({},m,(0,P.createHttpPatch)(m,l,E,h,!0)),default:Object.assign(m,(0,P.createHttpPatch)(m,l,E,h,!1))},https:{off:Object.assign({},i,(0,P.createHttpPatch)(i,l,{config:"off"},h,!0)),on:Object.assign({},i,(0,P.createHttpPatch)(i,l,{config:"on"},h,!0)),override:Object.assign({},i,(0,P.createHttpPatch)(i,l,{config:"override"},h,!0)),onRequest:Object.assign({},i,(0,P.createHttpPatch)(i,l,E,h,!0)),default:Object.assign(i,(0,P.createHttpPatch)(i,l,E,h,!1))},tls:Object.assign(y,(0,P.createTlsPatch)(y))}}const I=new Map;function L(T,l){return T.getExtensionPathIndex().then(E=>{const h=Y.__$__nodeRequire("module"),p=h._load;h._load=function(A,w,s){if(A==="tls")return l.tls;if(A!=="http"&&A!=="https")return p.apply(this,arguments);const o=l[A],g=E.findSubstr(C.URI.file(w.filename));let c=I.get(g);if(c||I.set(g,c={}),!c[A]){let S=o.default;c[A]={...S}}return c[A]}})}}),define(we[278],be([0,1,37,9,79,30,12,8,92,279]),function(Y,e,m,i,y,C,P,k,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const L=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function T(s,o,g,c){const S=l(s,o,g,c),r=o.folder.fsPath;return{cmd:m.spawn(L,S.args,{cwd:r}),rgDiskPath:L,siblingClauses:S.siblingClauses,rgArgs:S,cwd:r}}e.spawnRipgrepCmd=T;function l(s,o,g,c){const S=["--files","--hidden","--case-sensitive"];h([o],g,!1).forEach(t=>{const n=(0,_.anchorGlob)(t);if(S.push("-g",n),P.isMacintosh){const u=(0,y.normalizeNFD)(n);u!==n&&S.push("-g",u)}});const r=E([o],c,void 0,!1);return r.globArgs.forEach(t=>{const n=`!${(0,_.anchorGlob)(t)}`;if(S.push("-g",n),P.isMacintosh){const u=(0,y.normalizeNFD)(n);u!==n&&S.push("-g",u)}}),o.disregardIgnoreFiles!==!1?S.push("--no-ignore"):S.push("--no-ignore-parent"),o.ignoreSymlinks||S.push("--follow"),s.exists&&S.push("--quiet"),S.push("--no-config"),o.disregardGlobalIgnoreFiles&&S.push("--no-ignore-global"),{args:S,siblingClauses:r.siblingClauses}}function E(s,o,g,c=!0){const S=[];let r={};return s.forEach(t=>{const n=Object.assign({},t.excludePattern||{},o||{}),u=p(n,c?t.folder.fsPath:void 0,g);S.push(...u.globArgs),u.siblingClauses&&(r=Object.assign(r,u.siblingClauses))}),{globArgs:S,siblingClauses:r}}e.foldersToRgExcludeGlobs=E;function h(s,o,g=!0){const c=[];return s.forEach(S=>{const r=Object.assign({},o||{},S.includePattern||{}),t=p(r,g?S.folder.fsPath:void 0);c.push(...t.globArgs)}),c}e.foldersToIncludeGlobs=h;function p(s,o,g){const c=[],S={};return Object.keys(s).forEach(r=>{if(g&&g.has(r)||!r)return;const t=s[r];r=A(o?v(o,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof t=="boolean"&&t?(r.startsWith("\\\\")&&(r+="**"),c.push(w(r))):t&&t.when&&(S[r]=t)}),{globArgs:c,siblingClauses:S}}function v(s,o){return i.isAbsolute(o)?o:i.join(s,o)}e.getAbsoluteGlob=v;function A(s){return s=k.rtrim(s,"\\"),k.rtrim(s,"/")}function w(s){return C.getRoot(s).toLowerCase()==="c:/"?s.replace(/^c:[/\\]/i,"/"):s}e.fixDriveC=w}),define(we[280],be([0,1,37,60,9,103,16,50,31,79,30,12,46,8,13,28,32,278,100]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const s=new Set;process.on("exit",()=>{s.forEach(r=>r())});class o{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&_.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,w.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&_.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(n=>{const u=Object.assign({},n.excludePattern||{},this.config.excludePattern||{}),a=n.folder.fsPath;t.folderQueries.map(f=>f.folder.fsPath).filter(f=>f!==a).forEach(f=>{(0,L.isEqualOrParent)(f,a)&&(u[y.relative(a,f)]=!0)}),this.folderExcludePatterns.set(a,new c(u,a))})}cancel(){this.isCanceled=!0,s.forEach(t=>t())}walk(t,n,u,a,f){if(this.fileWalkSW=l.StopWatch.create(!1),this.isCanceled)return f(null,this.isLimitHit);n.forEach(b=>{const d=y.basename(b.fsPath);this.globalExcludePattern&&this.globalExcludePattern(b.fsPath,d)||this.matchFile(u,{relativePath:b.fsPath,searchPath:void 0})}),this.cmdSW=l.StopWatch.create(!1),this.parallel(t,(b,d)=>{this.call(this.cmdTraversal,this,b,u,a,D=>{if(D){const R=(0,k.toErrorMessage)(D);console.error(R),this.errors.push(R),d(D,void 0)}else d(null,void 0)})},(b,d)=>{this.fileWalkSW.stop();const D=b?P.coalesce(b)[0]:null;f(D,this.isLimitHit)})}parallel(t,n,u){const a=new Array(t.length),f=new Array(t.length);let b=!1,d=0;if(t.length===0)return u(null,[]);t.forEach((D,R)=>{n(D,(N,B)=>{if(N?(b=!0,a[R]=null,f[R]=N):(a[R]=B,f[R]=null),++d===t.length)return u(b?f:null,a)})})}call(t,n,...u){try{t.apply(n,u)}catch(a){u[u.length-1](a)}}cmdTraversal(t,n,u,a){const f=t.folder.fsPath,b=T.isMacintosh;let d;const D=()=>d&&d.kill();s.add(D);let R=M=>{s.delete(D),R=()=>{},a(M)},N="";const B=this.initDirectoryTree();let F;const O=(0,A.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression);d=O.cmd,F=!Object.keys(O.siblingClauses).length;const z=O.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let W=`${O.rgDiskPath} ${z}
 - cwd: ${O.cwd}`;O.rgArgs.siblingClauses&&(W+=`
 - Sibling clauses: ${JSON.stringify(O.rgArgs.siblingClauses)}`),u({message:W}),this.cmdResultCount=0,this.collectStdout(d,"utf8",u,(M,x,V)=>{if(M){R(M);return}if(this.isLimitHit){R();return}const H=(N+(b?I.normalizeNFC(x||""):x)).split(`
`);if(V){const X=H.length;H[X-1]=H[X-1].trim(),H[X-1]||H.pop()}else N=H.pop()||"";if(H.length&&H[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=H.length,F){for(const X of H)if(this.matchFile(n,{base:f,relativePath:X,searchPath:this.getSearchPath(t,X)}),this.isLimitHit){D();break}(V||this.isLimitHit)&&R();return}this.addDirectoryEntries(t,B,f,H,n),V&&(this.matchDirectoryTree(B,f,n),R())})}spawnFindCmd(t){const n=this.folderExcludePatterns.get(t.folder.fsPath),u=n.getBasenameTerms(),a=n.getPathTerms(),f=["-L","."];if(u.length||a.length){f.push("-not","(","(");for(const b of u)f.push("-name",b),f.push("-o");for(const b of a)f.push("-path",b),f.push("-o");f.pop(),f.push(")","-prune",")")}return f.push("-type","f"),m.spawn("find",f,{cwd:t.folder.fsPath})}readStdout(t,n,u){let a="";this.collectStdout(t,n,()=>{},(f,b,d)=>{if(f){u(f);return}a+=b,d&&u(null,a)})}collectStdout(t,n,u,a){let f=(D,R,N)=>{(D||N)&&(f=()=>{},this.cmdSW&&this.cmdSW.stop()),a(D,R,N)},b=!1;t.stdout?(this.forwardData(t.stdout,n,f),t.stdout.once("data",()=>b=!0)):u({message:"stdout is null"});let d;t.stderr?d=this.collectData(t.stderr):u({message:"stderr is null"}),t.on("error",D=>{f(D)}),t.on("close",D=>{let R;!b&&(R=this.decodeData(d,n))&&S(R)?f(new Error(`command failed with error code ${D}: ${this.decodeData(d,n)}`)):(this.exists&&D===0&&(this.isLimitHit=!0),f(null,"",!0))})}forwardData(t,n,u){const a=new C.StringDecoder(n);return t.on("data",f=>{u(null,a.write(f))}),a}collectData(t){const n=[];return t.on("data",u=>{n.push(u)}),n}decodeData(t,n){const u=new C.StringDecoder(n);return t.map(a=>u.write(a)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:n},u,a,f){a.indexOf(this.filePattern)!==-1&&this.matchFile(f,{base:u,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const b=d=>{const D=y.basename(d),R=y.dirname(d);let N=n[R];N||(N=n[R]=[],b(R)),N.push({base:u,relativePath:d,basename:D,searchPath:this.getSearchPath(t,d)})};a.forEach(b)}matchDirectoryTree({rootEntries:t,pathToEntries:n},u,a){const f=this,b=this.folderExcludePatterns.get(u),d=this.filePattern;function D(R){f.directoriesWalked++;const N=_.hasSiblingFn(()=>R.map(B=>B.basename));for(let B=0,F=R.length;B<F;B++){const O=R[B],{relativePath:z,basename:W}=O;if(b.test(z,W,d!==W?N:void 0))continue;const M=n[z];if(M)D(M);else{if(f.filesWalked++,z===d)continue;f.matchFile(a,O)}if(f.isLimitHit)break}}D(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,n,u,a,f){const b=t.folder,d=_.hasSiblingFn(()=>u);this.parallel(u,(D,R)=>{if(this.isCanceled||this.isLimitHit)return R(null);const N=n?[n,D].join(y.sep):D;if(this.folderExcludePatterns.get(t.folder.fsPath).test(N,D,this.config.filePattern!==D?d:void 0))return R(null);const B=[b.fsPath,N].join(y.sep);i.lstat(B,(F,O)=>{if(F||this.isCanceled||this.isLimitHit)return R(null);this.statLinkIfNeeded(B,O,(z,W)=>z||this.isCanceled||this.isLimitHit?R(null):W.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(B,O,(M,x)=>M||this.isCanceled||this.isLimitHit||(x=x||"",this.walkedPaths[x])?R(null):(this.walkedPaths[x]=!0,p.Promises.readdir(B).then(V=>{if(this.isCanceled||this.isLimitHit)return R(null);this.doWalk(t,N,V,a,U=>R(U||null))},V=>{R(null)})))):(this.filesWalked++,N===this.filePattern||this.maxFilesize&&h.isNumber(W.size)&&W.size>this.maxFilesize||this.matchFile(a,{base:b.fsPath,relativePath:N,searchPath:this.getSearchPath(t,N)}),R(null,void 0)))})},D=>{const R=D&&P.coalesce(D);return f(R&&R.length>0?R[0]:void 0)})}matchFile(t,n){this.isFileMatch(n)&&(!this.includePattern||this.includePattern(n.relativePath,y.basename(n.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(n))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,v.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,n,u){return n.isSymbolicLink()?i.stat(t,u):u(null,n)}realPathIfNeeded(t,n,u){return n.isSymbolicLink()?i.realpath(t,(a,f)=>a?u(a):u(null,f)):u(null,t)}getSearchPath(t,n){return t.folderName?y.join(t.folderName,n):n}}e.FileWalker=o;class g{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new o(t)}search(t,n,u){this.walker.walk(this.folderQueries,this.extraFiles,t,n,(a,f)=>{u(a,{limitHit:f,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class c{constructor(t,n){this.expression=t,this.root=n,this.init(t)}init(t){let n,u;Object.keys(t).filter(a=>t[a]).forEach(a=>{y.isAbsolute(a)?(n=n||_.getEmptyExpression(),n[a]=t[a]):(u=u||_.getEmptyExpression(),u[a]=t[a])}),this.absoluteParsedExpr=n&&_.parse(n,{trimForExclusions:!0}),this.relativeParsedExpr=u&&_.parse(u,{trimForExclusions:!0})}test(t,n,u){return this.relativeParsedExpr&&this.relativeParsedExpr(t,n,u)||this.absoluteParsedExpr&&this.absoluteParsedExpr(y.join(this.root,t),n,u)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(..._.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(..._.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(..._.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(..._.getPathTerms(this.relativeParsedExpr)),t}}function S(r){const t=r.trim().split(`
`),n=t[0].trim();if(n.startsWith("Error parsing regex"))return n;if(n.startsWith("regex parse error"))return E.uppercaseFirstLetter(t[t.length-1].trim());if(n.startsWith("error parsing glob")||n.startsWith("unsupported encoding"))return n.charAt(0).toUpperCase()+n.substr(1);if(n==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(n.startsWith("Literal "))return n}e.rgErrorMsgForDisplay=S}),define(we[136],be([0,1,37,294,103,16,74,31,9,8,2,32,69,295,279,92]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const v=h.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class A{constructor(b){this.outputChannel=b}provideTextSearchResults(b,d,D,R){return this.outputChannel.appendLine(`provideTextSearchResults ${b.pattern}, ${JSON.stringify({...d,folder:d.folder.toString()})}`),new Promise((N,B)=>{R.onCancellationRequested(()=>U());const F=S(b,d),O=d.folder.fsPath,z=F.map(j=>j.match(/^-/)?j:`'${j}'`).join(" ");this.outputChannel.appendLine(`${v} ${z}
 - cwd: ${O}`);let W=m.spawn(v,F,{cwd:O});W.on("error",j=>{console.error(j),this.outputChannel.appendLine("Error: "+(j&&j.message)),B((0,T.serializeSearchError)(new T.SearchError(j&&j.message,T.SearchErrorCode.rgProcessError)))});let M=!1;const x=new o(d.maxResults,O,d.previewOptions);x.on("result",j=>{M=!0,X="",D.report(j)});let V=!1;const U=()=>{V=!0,W&&W.kill(),x&&x.cancel()};let H=!1;x.on("hitLimit",()=>{H=!0,U()});let X="";W.stdout.on("data",j=>{x.handleData(j),M||(X+=j)});let se=!1;W.stdout.once("data",()=>se=!0);let K="";W.stderr.on("data",j=>{const ie=j.toString();this.outputChannel.appendLine(ie),K+=ie}),W.on("close",()=>{if(this.outputChannel.appendLine(se?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(M?"Got result from parser":"No result from parser"),X&&this.outputChannel.appendLine(`Got data without result: ${X}`),this.outputChannel.appendLine(""),V)N({limitHit:H});else{x.flush(),W=null;let j;K&&!se&&(j=w(K))?B((0,T.serializeSearchError)(new T.SearchError(j.message,j.code))):N({limitHit:H})}})})}}e.RipgrepTextSearchEngine=A;function w(f){const b=f.split(`
`),d=b[0].trim();if(b.some(R=>R.startsWith("regex parse error")))return new T.SearchError(s(b),T.SearchErrorCode.regexParseError);const D=d.match(/grep config error: unknown encoding: (.*)/);if(D)return new T.SearchError(`Unknown encoding: ${D[1]}`,T.SearchErrorCode.unknownEncoding);if(d.startsWith("error parsing glob"))return new T.SearchError(d.charAt(0).toUpperCase()+d.substr(1),T.SearchErrorCode.globParseError);if(d.startsWith("the literal"))return new T.SearchError(d.charAt(0).toUpperCase()+d.substr(1),T.SearchErrorCode.invalidLiteral);if(d.startsWith("PCRE2: error compiling pattern"))return new T.SearchError(d,T.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=w;function s(f){const b=["Regex parse error"],d=f.filter(D=>D.startsWith("PCRE2:"));if(d.length>=1){const D=d[0].replace("PCRE2:","");if(D.indexOf(":")!==-1&&D.split(":").length>=2){const R=D.split(":")[1];b.push(":"+R)}}return b.join("")}e.buildRegexParseError=s;class o extends i.EventEmitter{constructor(b,d,D){super();this.maxResults=b,this.rootFolder=d,this.previewOptions=D,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new y.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(b,d){return super.on(b,d),this}handleData(b){if(this.isDone)return;const d=typeof b=="string"?b:this.stringDecoder.write(b);this.handleDecodedData(d)}handleDecodedData(b){let d=b.indexOf(`
`);const D=this.remainder+b;if(d>=0)d+=this.remainder.length;else{this.remainder=D;return}let R=0;for(;d>=0;)this.handleLine(D.substring(R,d).trim()),R=d+1,d=D.indexOf(`
`,R);this.remainder=D.substring(R)}handleLine(b){if(this.isDone||!b)return;let d;try{d=JSON.parse(b)}catch{throw new Error(`malformed line from rg: ${b}`)}if(d.type==="match"){const D=g(d.data.path),R=L.URI.file(_.join(this.rootFolder,D)),N=this.createTextSearchMatch(d.data,R);this.onResult(N),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(d.type==="context"){const D=g(d.data.path),R=L.URI.file(_.join(this.rootFolder,D));this.createTextSearchContext(d.data,R).forEach(B=>this.onResult(B))}}createTextSearchMatch(b,d){const D=b.line_number-1,R=g(b.lines),N=Buffer.from(R);let B=0,F=0,O=D;b.submatches.length===0&&b.submatches.push(R.length?{start:0,end:1,match:{text:R[0]}}:{start:0,end:0,match:{text:""}});const z=(0,C.coalesce)(b.submatches.map((W,M)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const x=g(W.match),V=N.slice(B,W.start).toString().length,U=F+V,H=c(x),X=O,se=H.numLines+X,K=H.numLines>0?H.lastLineLength:H.lastLineLength+U;return B=W.end,F=K,O=se,new l.Range(X,U,se,K)}));return(0,p.createTextSearchResult)(d,R,z,this.previewOptions)}createTextSearchContext(b,d){const D=g(b.lines),R=b.line_number;return D.replace(/\r?\n$/,"").split(`
`).map((N,B)=>({text:N,uri:d,lineNumber:R+B}))}onResult(b){this.emit("result",b)}}e.RipgrepParser=o;function g(f){return f.bytes?Buffer.from(f.bytes,"base64").toString():f.text}function c(f){const b=/\n/g;let d=0,D=-1,R;for(;R=b.exec(f);)d++,D=R.index;const N=D>=0?f.length-D-1:f.length;return{numLines:d,lastLineLength:N}}function S(f,b){const d=["--hidden"];d.push(f.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:D,otherIncludes:R}=(0,P.groupBy)(b.includes,B=>B.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(R&&R.length){const B=new Set;R.forEach(F=>{B.add(F)}),d.push("-g","!*"),B.forEach(F=>{r(F).map(p.anchorGlob).forEach(O=>{d.push("-g",O)})})}D&&D.length&&D.forEach(B=>{d.push("-g",B)}),b.excludes.map(p.anchorGlob).forEach(B=>d.push("-g",`!${B}`)),b.maxFileSize&&d.push("--max-filesize",b.maxFileSize+""),b.useIgnoreFiles?d.push("--no-ignore-parent"):d.push("--no-ignore"),b.followSymlinks&&d.push("--follow"),b.encoding&&b.encoding!=="utf8"&&d.push("--encoding",b.encoding),f.pattern==="--"&&(f.isRegExp=!0,f.pattern="\\-\\-"),f.isMultiline&&!f.isRegExp&&(f.pattern=(0,I.escapeRegExpCharacters)(f.pattern),f.isRegExp=!0),b.usePCRE2&&d.push("--pcre2"),d.push("--crlf"),f.isRegExp&&(f.pattern=t(f.pattern),d.push("--auto-hybrid-regex"));let N;if(f.isWordMatch){const F=(0,I.createRegExp)(f.pattern,!!f.isRegExp,{wholeWord:f.isWordMatch}).source.replace(/\\\//g,"/");d.push("--regexp",F)}else if(f.isRegExp){let B=u(f.pattern);B=a(B),d.push("--regexp",B)}else N=f.pattern,d.push("--fixed-strings");return d.push("--no-config"),b.useGlobalIgnoreFiles||d.push("--no-ignore-global"),d.push("--json"),f.isMultiline&&d.push("--multiline"),b.beforeContext&&d.push("--before-context",b.beforeContext+""),b.afterContext&&d.push("--after-context",b.afterContext+""),d.push("--"),N&&d.push(N),d.push("."),d}function r(f){const b=(0,k.splitGlobAware)(f,"/");return b.map((d,D)=>b.slice(0,D+1).join("/"))}e.spreadGlobComponents=r;function t(f){const b=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;f.match(b);)f=f.replace(b,"$1\\x{$2}");const d=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;f.match(d);)f=f.replace(d,"$1\\x{$2}");return f}e.unicodeEscapesToPCRE2=t;const n=f=>f.type==="Assertion"&&f.kind==="lookbehind";function u(f){let b;try{b=new E.RegExpParser().parsePattern(f)}catch{return f}let d="",D=0;const R=(F,O,z)=>{d+=f.slice(D,F)+z,D=O},N=[];return new E.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const O=N[0];if(!O)R(F.start,F.end,"\\r?\\n");else if(!N.some(n))if(O.type==="CharacterClass")if(O.negate){const z=f.slice(O.start+2,F.start)+f.slice(F.end,O.end-1);if(O.parent?.type==="Quantifier"){const W=O.parent;R(W.start,W.end,(z?`[^${z}]`:".")+(W.greedy?"+":"*"))}else R(O.start,O.end,"(?!\\r?\\n"+(z?`|[${z}]`:"")+")")}else{const z=f.slice(O.start+1,F.start)+f.slice(F.end,O.end-1);R(O.start,O.end,z===""?"\\r?\\n":`(?:[${z}]|\\r?\\n)`)}else O.type==="Quantifier"&&R(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){N.unshift(F)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(F){N.unshift(F)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(F){N.unshift(F)},onCharacterClassLeave(){N.shift()},onAssertionEnter(F){n(F)&&N.push(F)},onAssertionLeave(F){N[0]===F&&N.shift()}}).visit(b),d+=f.slice(D),d}e.fixRegexNewline=u;function a(f){return f.replace(/\n/g,"\\r?\\n")}e.fixNewline=a}),define(we[281],be([0,1,21,136,117,10]),function(Y,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class P{constructor(I){this.outputChannel=I,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(I,L,T,l){const E=new i.RipgrepTextSearchEngine(this.outputChannel);if(L.folder.scheme===C.Schemas.userData){const h={...L,folder:L.folder.with({scheme:C.Schemas.file})},p=new y.Progress(v=>T.report({...v,uri:v.uri.with({scheme:L.folder.scheme})}));return this.withToken(l,v=>E.provideTextSearchResults(I,h,p,v))}else return this.withToken(l,h=>E.provideTextSearchResults(I,L,T,h))}async withToken(I,L){const T=k(I);this.inProgress.add(T);const l=await L(T.token);return this.inProgress.delete(T),l}dispose(){this.inProgress.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=P;function k(_){const I=new m.CancellationTokenSource;return _.onCancellationRequested(()=>I.cancel()),I}}),define(we[282],be([0,1,28,136,135]),function(Y,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(_){this.query=_}search(_,I,L){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const T={appendLine(E){L({message:E})}},l=new y.NativeTextSearchManager(this.query,new i.RipgrepTextSearchEngine(T),m);return new Promise((E,h)=>l.search(p=>{I(p.map(P))},_).then(p=>E({limitHit:p.limitHit,type:"success",stats:p.stats}),h))}}e.TextSearchEngineAdapter=C;function P(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((_,I)=>{if(I.ranges){const L=I;return _+(Array.isArray(L.ranges)?L.ranges.length:1)}else return _+1},0)}}}),define(we[283],be([0,1,16,18,15,3,100,9,46,2,42,32,280,282]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class h{constructor(o="searchProcess"){this.processType=o,this.caches=Object.create(null)}fileSearch(o){let g;const c=A(o),S=new C.Emitter({onFirstListenerDidAdd:()=>{g=(0,i.createCancelablePromise)(r=>this.doFileSearchWithEngine(l.Engine,c,t=>S.fire(t),r)),g.then(r=>S.fire(r),r=>S.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return S.event}textSearch(o){let g;const c=A(o),S=new C.Emitter({onFirstListenerDidAdd:()=>{g=(0,i.createCancelablePromise)(r=>this.ripgrepTextSearch(c,t=>S.fire(t),r)),g.then(r=>S.fire(r),r=>S.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return S.event}ripgrepTextSearch(o,g,c){return o.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new E.TextSearchEngineAdapter(o).search(c,g,g)}doFileSearch(o,g,c){return this.doFileSearchWithEngine(l.Engine,o,g,c)}doFileSearchWithEngine(o,g,c,S,r=h.BATCH_SIZE){let t=0;const n=a=>{Array.isArray(a)?(t+=a.length,c(a.map(f=>this.rawMatchToSearchItem(f)))):a.relativePath?(t++,c(this.rawMatchToSearchItem(a))):c(a)};if(g.sortByScore){let a=this.trySortedSearchFromCache(g,n,S);if(!a){const f=g.maxResults?Object.assign({},g,{maxResults:null}):g,b=new o(f);a=this.doSortedSearch(b,g,c,n,S)}return new Promise((f,b)=>{a.then(([d,D])=>{const R=D.map(N=>this.rawMatchToSearchItem(N));this.sendProgress(R,c,r),f(d)},b)})}const u=new o(g);return this.doSearch(u,n,r,S).then(a=>({limitHit:a.limitHit,type:"success",stats:{detailStats:a.stats,type:this.processType,fromCache:!1,resultCount:t,sortingTime:void 0}}))}rawMatchToSearchItem(o){return{path:o.base?(0,k.join)(o.base,o.relativePath):o.relativePath}}doSortedSearch(o,g,c,S,r){const t=new C.Emitter;let n=(0,i.createCancelablePromise)(a=>{let f=[];const b=d=>{Array.isArray(d)?f=d:(S(d),t.fire(d))};return this.doSearch(o,b,-1,a).then(d=>[d,f])}),u;if(g.cacheKey){u=this.getOrCreateCache(g.cacheKey);const a={promise:n,event:t.event,resolved:!1};u.resultsToSearchCache[g.filePattern||""]=a,n.then(()=>{a.resolved=!0},f=>{delete u.resultsToSearchCache[g.filePattern||""]}),n=this.preventCancellation(n)}return n.then(([a,f])=>{const b=u?u.scorerCache:Object.create(null),d=(typeof g.maxResults!="number"||g.maxResults>0)&&_.StopWatch.create(!1);return this.sortResults(g,f,b,r).then(D=>{const R=d?d.elapsed():-1;return[{type:"success",stats:{detailStats:a.stats,sortingTime:R,fromCache:!1,type:this.processType,workspaceFolderCount:g.folderQueries.length,resultCount:D.length},messages:a.messages,limitHit:a.limitHit||typeof g.maxResults=="number"&&f.length>g.maxResults},D]})})}getOrCreateCache(o){const g=this.caches[o];return g||(this.caches[o]=new p)}trySortedSearchFromCache(o,g,c){const S=o.cacheKey&&this.caches[o.cacheKey];if(!S)return;const r=this.getResultsFromCache(S,o.filePattern||"",g,c);if(r)return r.then(([t,n,u])=>{const a=_.StopWatch.create(!1);return this.sortResults(o,n,S.scorerCache,c).then(f=>{const b=a.elapsed(),d={fromCache:!0,detailStats:u,type:this.processType,resultCount:n.length,sortingTime:b};return[{type:"success",limitHit:t.limitHit||typeof o.maxResults=="number"&&n.length>o.maxResults,stats:d},f]})})}sortResults(o,g,c,S){const r=(0,P.prepareQuery)(o.filePattern||""),t=(u,a)=>(0,P.compareItemsByFuzzyScore)(u,a,r,!0,v,c),n=typeof o.maxResults=="number"?o.maxResults:Number.MAX_VALUE;return m.topAsync(g,t,n,1e4,S)}sendProgress(o,g,c){if(c&&c>0)for(let S=0;S<o.length;S+=c)g(o.slice(S,S+c));else g(o)}getResultsFromCache(o,g,c,S){const r=_.StopWatch.create(!1),t=g.indexOf(k.sep)>=0;let n;for(const b in o.resultsToSearchCache)if(g.startsWith(b)){if(t&&b.indexOf(k.sep)<0&&b!=="")continue;const d=o.resultsToSearchCache[b];n={promise:this.preventCancellation(d.promise),event:d.event,resolved:d.resolved};break}if(!n)return null;const u=r.elapsed(),a=_.StopWatch.create(!1),f=n.event(c);return S&&S.onCancellationRequested(()=>{f.dispose()}),n.promise.then(([b,d])=>{if(S&&S.isCancellationRequested)throw(0,y.canceled)();const D=[],R=(0,P.prepareQuery)(g).normalizedLowercase;for(const N of d)!(0,T.isFilePatternMatch)(N,R)||D.push(N);return[b,D,{cacheWasResolved:n.resolved,cacheLookupTime:u,cacheFilterTime:a.elapsed(),cacheEntryCount:d.length}]})}doSearch(o,g,c,S){return new Promise((r,t)=>{let n=[];S&&S.onCancellationRequested(()=>o.cancel()),o.search(u=>{u&&(c?(n.push(u),c>0&&n.length>=c&&(g(n),n=[])):g(u))},u=>{g(u)},(u,a)=>{n.length&&g(n),u?t(u):r(a)})})}clearCache(o){return delete this.caches[o],Promise.resolve(void 0)}preventCancellation(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,c){return o.then(g,c)}catch(g){return this.then(void 0,g)}finally(g){return o.finally(g)}}}}e.SearchService=h,h.BATCH_SIZE=512;class p{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const v=new class{getItemLabel(s){return(0,k.basename)(s.relativePath)}getItemDescription(s){return(0,k.dirname)(s.relativePath)}getItemPath(s){return s.relativePath}};function A(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(w),extraFileResources:s.extraFileResources&&s.extraFileResources.map(o=>I.URI.revive(o))}}function w(s){return{...s,folder:I.URI.revive(s.folder)}}}),define(we[284],be([0,1,6,10,2,28,11,26,14,72,64,32,283,281,92,135]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let v=class extends I.ExtHostSearch{constructor(w,s,o,g){super(w,o,g);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const c=new h.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(i.Schemas.userData,new E.RipgrepSearchProvider(c)),s.remote.isRemote&&s.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const w=new h.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(i.Schemas.file,new E.RipgrepSearchProvider(w)),this.registerInternalFileSearchProvider(i.Schemas.file,new l.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(w,s){const o=this._handlePool++;return this._internalFileSearchProvider=s,this._internalFileSearchHandle=o,this._proxy.$registerFileSearchProvider(o,this._transformScheme(w)),(0,m.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(w,s,o,g){const c=(0,I.reviveQuery)(o);return w===this._internalFileSearchHandle?this.doInternalFileSearch(w,s,c,g):super.$provideFileSearchResults(w,s,o,g)}doInternalFileSearch(w,s,o,g){const c=S=>{if((0,T.isSerializedFileMatch)(S)&&(S=[S]),Array.isArray(S)){this._proxy.$handleFileMatch(w,s,S.map(r=>y.URI.file(r.path)));return}S.message&&this._logService.debug("ExtHostSearch",S.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(o,c,g)}$clearCache(w){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(w),super.$clearCache(w)}createTextSearchManager(w,s){return new p.NativeTextSearchManager(w,s,void 0,"textSearchProvider")}};v=je([ze(0,_.IExtHostRpcService),ze(1,k.IExtHostInitDataService),ze(2,L.IURITransformerService),ze(3,P.ILogService)],v),e.NativeExtHostSearch=v}),define(we[137],be([0,1,296,124,81,22,15,3,6,9,12,33,105,106,297]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{constructor(d,D=""){this.debugLabel=D,this.socket=d,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=R=>{if(this.traceSocketEvent("error",{code:R?.code,message:R?.message}),R){if(R.code==="EPIPE")return;(0,P.onUnexpectedError)(R)}},this.socket.on("error",this._errorListener)}traceSocketEvent(d,D){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,d,D)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(d){const D=R=>{this.traceSocketEvent("read",R),d(C.VSBuffer.wrap(R))};return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(d){const D=R=>{this.traceSocketEvent("close",{hadError:R}),d({type:0,hadError:R,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(d){const D=()=>{this.traceSocketEvent("nodeEndReceived"),d()};return this.socket.on("end",D),{dispose:()=>this.socket.off("end",D)}}write(d){if(!this.socket.destroyed)try{this.traceSocketEvent("write",d),this.socket.write(d.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,P.onUnexpectedError)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,P.onUnexpectedError)(D)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((d,D)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),d();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),this.traceSocketEvent("nodeDrainEnd"),d()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=p;var v;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var A;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(A||(A={}));class w extends _.Disposable{constructor(d,D,R,N){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=d,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:D,inflateBytesLength:R?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new s(this,D,R,N,this._onData,(B,F)=>this._write(B,F))),this._register(this._flowManager.onError(B=>{console.error(B),(0,P.onUnexpectedError)(B),this._onClose.fire({type:0,hadError:!0,error:B})})),this._incomingData=new E.ChunkStream,this._register(this.socket.onData(B=>this._acceptChunk(B))),this._register(this.socket.onClose(B=>this._onClose.fire(B)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(d,D){this.socket.traceSocketEvent(d,D)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this._onData.event(d)}onClose(d){return this._onClose.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){this._flowManager.writeMessage(d)}_write(d,D){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",d);let R=2;d.byteLength<126?R+=0:d.byteLength<2**16?R+=2:R+=8;const N=C.VSBuffer.alloc(R);if(D?N.writeUInt8(194,0):N.writeUInt8(130,0),d.byteLength<126)N.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){N.writeUInt8(126,1);let B=1;N.writeUInt8(d.byteLength>>>8&255,++B),N.writeUInt8(d.byteLength>>>0&255,++B)}else{N.writeUInt8(127,1);let B=1;N.writeUInt8(0,++B),N.writeUInt8(0,++B),N.writeUInt8(0,++B),N.writeUInt8(0,++B),N.writeUInt8(d.byteLength>>>24&255,++B),N.writeUInt8(d.byteLength>>>16&255,++B),N.writeUInt8(d.byteLength>>>8&255,++B),N.writeUInt8(d.byteLength>>>0&255,++B)}this.socket.write(C.VSBuffer.concat([N,d]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(d){if(d.byteLength!==0){for(this._incomingData.acceptChunk(d);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const D=this._incomingData.peek(this._state.readLen),R=D.readUInt8(0),N=(R&128)>>>7,B=(R&64)>>>6,F=D.readUInt8(1),O=(F&128)>>>7,z=F&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(z===126?2:0)+(z===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(B)),this._state.firstFrameOfMessage=Boolean(N),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const D=this._incomingData.read(this._state.readLen),R=D.readUInt8(1),N=(R&128)>>>7;let B=R&127,F=1;B===126?B=D.readUInt8(++F)*2**8+D.readUInt8(++F):B===127&&(B=D.readUInt8(++F)*0+D.readUInt8(++F)*0+D.readUInt8(++F)*0+D.readUInt8(++F)*0+D.readUInt8(++F)*2**24+D.readUInt8(++F)*2**16+D.readUInt8(++F)*2**8+D.readUInt8(++F));let O=0;N&&(O=D.readUInt8(++F)*2**24+D.readUInt8(++F)*2**16+D.readUInt8(++F)*2**8+D.readUInt8(++F)),this._state.state=3,this._state.readLen=B,this._state.mask=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const D=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",D),c(D,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",D),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(D,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class s extends _.Disposable{constructor(d,D,R,N,B,F){super();this._tracer=d,this._onData=B,this._writeFn=F,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,D?(this._zlibInflateStream=this._register(new o(this._tracer,N,R,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(O=>this._onError.fire(O))),this._register(this._zlibDeflateStream.onError(O=>this._onError.fire(O)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}writeMessage(d){this._writeQueue.push(d),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const d=this._writeQueue.shift();if(this._zlibDeflateStream){const D=await this._deflateMessage(this._zlibDeflateStream,d);this._writeFn(D,!0)}else this._writeFn(d,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(d,D){return new Promise((R,N)=>{d.write(D),d.flush(B=>R(B))})}acceptFrame(d,D,R){this._readQueue.push({data:d,isCompressed:D,isLastFrameOfMessage:R}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const d=this._readQueue.shift();if(this._zlibInflateStream&&d.isCompressed){const D=await this._inflateFrame(this._zlibInflateStream,d.data,d.isLastFrameOfMessage);this._onData.fire(D)}else this._onData.fire(d.data)}this._isProcessingReadQueue=!1}}_inflateFrame(d,D,R){return new Promise((N,B)=>{d.write(D),R&&d.write(C.VSBuffer.fromByteArray([0,0,255,255])),d.flush(F=>N(F))})}}class o extends _.Disposable{constructor(d,D,R,N){super();this._tracer=d,this._recordInflateBytes=D,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=h.createInflateRaw(N),this._zlibInflate.on("error",B=>{this._tracer.traceSocketEvent("zlibInflateError",{message:B?.message,code:B?.code}),this._onError.fire(B)}),this._zlibInflate.on("data",B=>{this._tracer.traceSocketEvent("zlibInflateData",B),this._pendingInflateData.push(C.VSBuffer.wrap(B))}),R&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",R.buffer),this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}write(d){this._recordInflateBytes&&this._recordedInflateBytes.push(d.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",d),this._zlibInflate.write(d.buffer)}flush(d){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const D=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,d(D)})}}class g extends _.Disposable{constructor(d,D){super();this._tracer=d,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",R=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:R?.message,code:R?.code}),this._onError.fire(R)}),this._zlibDeflate.on("data",R=>{this._tracer.traceSocketEvent("zlibDeflateData",R),this._pendingDeflateData.push(C.VSBuffer.wrap(R))})}write(d){this._tracer.traceSocketEvent("zlibDeflateWrite",d.buffer),this._zlibDeflate.write(d.buffer)}flush(d){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let D=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,D=D.slice(0,D.byteLength-4),d(D)})}}function c(b,d){if(d===0)return;let D=b.byteLength>>>2;for(let z=0;z<D;z++){const W=b.readUInt32BE(z*4);b.writeUInt32BE(W^d,z*4)}let R=D*4,N=b.byteLength-R;const B=d>>>24&255,F=d>>>16&255,O=d>>>8&255;N>=1&&b.writeUInt8(b.readUInt8(R)^B,R),N>=2&&b.writeUInt8(b.readUInt8(R+1)^F,R+1),N>=3&&b.writeUInt8(b.readUInt8(R+2)^O,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const S={[2]:107,[1]:103};function r(){const b=(0,T.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;let d;return e.XDG_RUNTIME_DIR?d=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${b}.sock`):d=(0,I.join)((0,y.tmpdir)(),`vscode-ipc-${b}.sock`),n(d),d}e.createRandomIPCHandle=r;function t(b,d,D){const R=(0,m.createHash)("md5").update(b).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${D}-${d}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${D}-${d}.sock`):N=(0,I.join)(b,`${D}-${d}.sock`),n(N),N}e.createStaticIPCHandle=t;function n(b){const d=S[L.platform];typeof d=="number"&&b.length>=d&&console.warn(`WARNING: IPC handle "${b}" is longer than ${d} chars, try a shorter --user-data-dir`)}class u extends l.IPCServer{constructor(d){super(u.toClientConnectionEvent(d));this.server=d}static toClientConnectionEvent(d){const D=k.Event.fromNodeEventEmitter(d,"connection");return k.Event.map(D,R=>({protocol:new E.Protocol(new p(R,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=u;function a(b){return new Promise((d,D)=>{const R=(0,i.createServer)();R.on("error",D),R.listen(b,()=>{R.removeListener("error",D),d(new u(R))})})}e.serve=a;function f(b,d){return new Promise((D,R)=>{const N=(0,i.createConnection)(b,()=>{N.removeListener("error",R),D(E.Client.fromSocket(new p(N,`ipc-client${d}`),d))});N.once("error",R)})}e.connect=f}),define(we[285],be([0,1,137,277,60,38,2,197,11]),function(Y,e,m,i,y,C,P,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(l,E,h){this._commands=l,this.logService=E,this._ipcHandlePath=h,this._server=i.createServer((p,v)=>this.onRequest(p,v)),this.setup().catch(p=>(E.error(p),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",l=>this.logService.error(l))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(l,E){const h=[];l.setEncoding("utf8"),l.on("data",p=>h.push(p)),l.on("end",()=>{const p=JSON.parse(h.join(""));switch(p.type){case"open":this.open(p,E);break;case"openExternal":this.openExternal(p,E);break;case"status":this.getStatus(p,E);break;case"extensionManagement":this.manageExtensions(p,E).catch(this.logService.error);break;default:E.writeHead(404),E.write(`Unknown message type: ${p.type}`,v=>{v&&this.logService.error(v)}),E.end();break}})}open(l,E){const{fileURIs:h,folderURIs:p,forceNewWindow:v,diffMode:A,addMode:w,forceReuseWindow:s,gotoLineMode:o,waitMarkerFilePath:g,remoteAuthority:c}=l,S=[];if(Array.isArray(p))for(const u of p)try{S.push({folderUri:P.URI.parse(u)})}catch{}if(Array.isArray(h))for(const u of h)try{(0,k.hasWorkspaceFileExtension)(u)?S.push({workspaceUri:P.URI.parse(u)}):S.push({fileUri:P.URI.parse(u)})}catch{}const r=g?P.URI.file(g):void 0,n={forceNewWindow:v,diffMode:A,addMode:w,gotoLineMode:o,forceReuseWindow:s,preferNewWindow:!s&&!r&&!w,waitMarkerFileURI:r,remoteAuthority:c};this._commands.executeCommand("_remoteCLI.windowOpen",S,n),E.writeHead(200),E.end()}async openExternal(l,E){for(const h of l.uris){const p=P.URI.parse(h),v=p.scheme==="file"?p:h;await this._commands.executeCommand("_remoteCLI.openExternal",v)}E.writeHead(200),E.end()}async manageExtensions(l,E){try{const h=A=>A?.map(w=>/\.vsix$/i.test(w)?P.URI.parse(w):w),p={list:l.list,install:h(l.install),uninstall:h(l.uninstall),force:l.force},v=await this._commands.executeCommand("_remoteCLI.manageExtensions",p);E.writeHead(200),E.write(v)}catch(h){E.writeHead(500),E.write(String(h),p=>{p&&this.logService.error(p)})}E.end()}async getStatus(l,E){try{const h=await this._commands.executeCommand("_remoteCLI.getSystemStatus");E.writeHead(200),E.write(h),E.end()}catch(h){E.writeHead(500),E.write(String(h),p=>{p&&this.logService.error(p)}),E.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&y.existsSync(this._ipcHandlePath)&&y.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=I;let L=class extends I{constructor(l,E){super(l,E,(0,m.createRandomIPCHandle)())}};L=je([ze(0,C.IExtHostCommands),ze(1,_.ILogService)],L),e.CLIServer=L}),define(we[286],be([0,1,71,273,268,5,276,39,258,2,10,7,285,104]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class h extends y.RequireInterceptor{_installInterceptor(){const A=this,w=Y.__$__nodeRequire("module"),s=w._load;w._load=function(g,c,S){for(let r of A._alternatives){let t=r(g);if(t){g=t;break}}return A._factories.has(g)?A._factories.get(g).load(g,I.URI.file((0,E.realpathSync)(c.filename)),r=>s.apply(this,[r,c,S])):s.apply(this,arguments)}}}class p extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const A=this._instaService.invokeFunction(i.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(_.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const c=this._instaService.createInstance(l.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}await this._instaService.createInstance(h,A,this._registry).install(),m.mark("code/extHost/didInitAPI");const s=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,s,this,this._logService,this._mainThreadTelemetryProxy,this._initData),m.mark("code/extHost/didInitProxyResolver");const o=process.send,g=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...c)=>c.length===0||!c[0]||c[0].type!=="__$console"?o.apply(process,c):(g.$logExtensionHostMessage(c[0]),!1)}_getEntryPoint(A){return A.main}_loadCommonJSModule(A,w,s){if(w.scheme!==L.Schemas.file)throw new Error(`Cannot load URI: '${w}', must be of file-scheme`);let o=null;s.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${w.toString(!0)}`),this._logService.flush();try{A&&m.mark(`code/extHost/willLoadExtensionCode/${A.value}`),o=Y.__$__nodeRequire(w.fsPath)}catch(g){return Promise.reject(g)}finally{A&&m.mark(`code/extHost/didLoadExtensionCode/${A.value}`),s.codeLoadingStop()}return Promise.resolve(o)}async $setRemoteEnvironment(A){if(!!this._initData.remote.isRemote)for(const w in A){const s=A[w];s===null?delete process.env[w]:process.env[w]=s}}}e.ExtHostExtensionService=p}),define(we[287],be([0,1,83,261,270,269,284,286,262,55,39,72,70,34,52,67,260,259,11]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(L.IExtHostExtensionService,k.ExtHostExtensionService),(0,m.registerSingleton)(w.ILoggerService,A.ExtHostLoggerService),(0,m.registerSingleton)(p.IExtensionStoragePaths,v.ExtensionStoragePaths),(0,m.registerSingleton)(I.IExtHostDebugService,C.ExtHostDebugService),(0,m.registerSingleton)(T.IExtHostSearch,P.NativeExtHostSearch),(0,m.registerSingleton)(l.IExtHostTask,y.ExtHostTask),(0,m.registerSingleton)(E.IExtHostTerminalService,i.ExtHostTerminalService),(0,m.registerSingleton)(h.IExtHostTunnelService,_.ExtHostTunnelService)}),define(we[288],be([0,1,124,298,71,15,106,137,190,224,271,22,102,28,104,18,113,274,287]),function(Y,e,m,i,y,C,P,k,_,I,L,T,l,E,h,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let n=0;n<process.execArgv.length;n++)process.execArgv[n]==="--inspect-port=0"&&(process.execArgv.splice(n,1),n--)}();const A=i(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const t=Y.__$__nodeRequire("module"),n=t._load;t._load=function(u){if(u==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return n.apply(this,arguments)}})();const w=process.exit.bind(process);function s(t){process.exit=function(n){if(t)w(n);else{const u=new Error("An extension called process.exit() and this was prevented.");console.warn(u.stack)}},process.crash=function(){const n=new Error("An extension called process.crash() and this was prevented.");console.warn(n.stack)}}let o=function(t){w()};function g(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((t,n)=>{let u=null,a=setTimeout(()=>{o("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const f=108e5,b=3e5,d=new p.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (1)"),f),D=new p.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (2)"),b);process.on("message",(N,B)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const F=T.VSBuffer.wrap(Buffer.from(N.initialDataChunk,"base64"));let O;if(N.skipWebSocketFrames)O=new k.NodeSocket(B,"extHost-socket");else{const z=T.VSBuffer.wrap(Buffer.from(N.inflateBytes,"base64"));O=new k.WebSocketNodeSocket(new k.NodeSocket(B,"extHost-socket"),N.permessageDeflate,z,!1)}u?(d.cancel(),D.cancel(),u.beginAcceptReconnection(O,F),u.endAcceptReconnection(),u.sendResume()):(clearTimeout(a),u=new P.PersistentProtocol(O,F),u.sendResume(),u.onDidDispose(()=>o("renderer disconnected")),t(u),u.onSocketClose(()=>{d.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(D.isScheduled())return;d.isScheduled()&&D.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const t=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((n,u)=>{const a=m.createConnection(t,()=>{a.removeListener("error",u),n(new P.PersistentProtocol(new k.NodeSocket(a,"extHost-renderer")))});a.once("error",u),a.on("close",()=>{o("renderer closed the socket")})})}}async function c(){const t=await g();return new class{constructor(){this._onMessage=new P.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,t.onMessage(n=>{(0,I.isMessageOfType)(n,2)?(this._terminating=!0,o("received terminate message from renderer")):this._onMessage.fire(n)})}send(n){this._terminating||t.send(n)}drain(){return t.drain()}}}function S(t){return new Promise(n=>{const u=t.onMessage(a=>{u.dispose();const f=JSON.parse(a.toString()),b=f.commit,d=_.default.commit;b&&d&&b!==d&&w(55);let D=0;setInterval(function(){try{process.kill(f.parentPid,0),D=0}catch(N){N&&N.code==="EPERM"?(D++,D>=3&&o(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):o(`parent process ${f.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let R;try{R=Y.__$__nodeRequire("native-watchdog"),R.start(f.parentPid)}catch(N){(0,C.onUnexpectedError)(N)}t.send((0,I.createMessageOfType)(0)),n({protocol:t,initData:f})});t.send((0,I.createMessageOfType)(1))})}async function r(){const t=[];process.on("unhandledRejection",(D,R)=>{t.push(R),setTimeout(()=>{const N=t.indexOf(R);N>=0&&R.catch(B=>{t.splice(N,1),(0,C.isPromiseCanceledError)(B)||(console.warn(`rejected promise not handled within 1 second: ${B}`),B&&B.stack&&console.warn(`stack trace: ${B.stack}`),D&&(0,C.onUnexpectedError)(D))})},1e3)}),process.on("rejectionHandled",D=>{const R=t.indexOf(D);R>=0&&t.splice(R,1)}),process.on("uncaughtException",function(D){(0,C.onUnexpectedError)(D)}),y.mark("code/extHost/willConnectToRenderer");const n=await c();y.mark("code/extHost/didConnectToRenderer");const u=await S(n);y.mark("code/extHost/didWaitForInitData");const{initData:a}=u;s(!!a.environment.extensionTestsLocationURI),a.environment.useHostProxy=A.useHostProxy!==void 0?A.useHostProxy!=="false":void 0,a.environment.skipWorkspaceStorageLock=(0,v.boolean)(A.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(R){w(R)}exists(R){return E.Promises.exists(R)}realpath(R){return(0,h.realpath)(R)}};let b=null;if(a.remote.authority&&A.uriTransformerPath)try{const R=Y.__$__nodeRequire(A.uriTransformerPath)(a.remote.authority);b=new l.URITransformer(R)}catch(D){console.error(D)}const d=new L.ExtensionHostMain(u.protocol,a,f,b);o=D=>d.terminate(D)}e.startExtensionHostProcess=r}),define(we[299],be([0,1,288]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.startExtensionHostProcess)().catch(i=>console.log(i))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/807bf598bea406dcb272a9fced54697986e87768/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
