/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["require","exports","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/network","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/codicons","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/editor/common/core/range","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/services/extensions/worker/extensionHostWorker"],ye=function(ne){for(var e=[],a=0,t=ne.length;a<t;a++)e[a]=Ee[ne[a]];return e};define(Ee[41],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function a(t,w){if(!t)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=a}),define(Ee[51],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function a(k){return k?k.replace(/\$\((.*?)\)/g,(P,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=a;class t{constructor(P,C,R){this.id=P,this.definition=C,this.description=R,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function w(k,P){const C=["codicon","codicon-"+k];return P&&C.push("codicon-modifier-"+P),C}e.getClassNamesArray=w;var T;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function C(_){if(_ instanceof t)return["codicon","codicon-"+_.id];const n=P.exec(_.id);if(!n)return C(t.error);let[,m,r]=n;const g=["codicon","codicon-"+m];return r&&g.push("codicon-modifier-"+r.substr(1)),g}k.asClassNameArray=C;function R(_){return C(_).join(" ")}k.asClassName=R;function F(_){return"."+C(_).join(".")}k.asCSSSelector=F})(T=e.CSSIcon||(e.CSSIcon={}))}),define(Ee[74],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const a=Object.prototype.hasOwnProperty;function t(F){const _=[];for(let n in F)a.call(F,n)&&_.push(F[n]);return _}e.values=t;function w(F,_){for(let n in F)if(a.call(F,n)&&_({key:n,value:F[n]},function(){delete F[n]})===!1)return}e.forEach=w;function T(F,_){const n=Object.create(null);for(const m of F){const r=_(m);let g=n[r];g||(g=n[r]=[]),g.push(m)}return n}e.groupBy=T;function k(F){const _=Object.create(null);return F&&F.forEach((n,m)=>{_[m]=n}),_}e.fromMap=k;function P(F,_){const n=[],m=[];for(let r of F)_.has(r)||n.push(r);for(let r of _)F.has(r)||m.push(r);return{removed:n,added:m}}e.diffSets=P;function C(F,_){const n=[],m=[];for(let[r,g]of F)_.has(r)||n.push(g);for(let[r,g]of _)F.has(r)||m.push(g);return{removed:n,added:m}}e.diffMaps=C;class R{constructor(){this.map=new Map}add(_,n){let m=this.map.get(_);m||(m=new Set,this.map.set(_,m)),m.add(n)}delete(_,n){const m=this.map.get(_);!m||(m.delete(n),m.size===0&&this.map.delete(_))}forEach(_,n){const m=this.map.get(_);!m||m.forEach(n)}}e.SetMap=R}),define(Ee[52],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function a(k){return(P,C,R)=>{let F=null,_=null;if(typeof R.value=="function"?(F="value",_=R.value):typeof R.get=="function"&&(F="get",_=R.get),!_)throw new Error("not supported");R[F]=k(_,C)}}e.createDecorator=a;function t(k,P,C){let R=null,F=null;if(typeof C.value=="function"?(R="value",F=C.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(R="get",F=C.get),!F)throw new Error("not supported");const _=`$memoize$${P}`;C[R]=function(...n){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,n)}),this[_]}}e.memoize=t;function w(k,P,C){return a((R,F)=>{const _=`$debounce$${F}`,n=`$debounce$result$${F}`;return function(...m){this[n]||(this[n]=C?C():void 0),clearTimeout(this[_]),P&&(this[n]=P(this[n],...m),m=[this[n]]),this[_]=setTimeout(()=>{R.apply(this,m),this[n]=C?C():void 0},k)}})}e.debounce=w;function T(k,P,C){return a((R,F)=>{const _=`$throttle$timer$${F}`,n=`$throttle$result$${F}`,m=`$throttle$lastRun$${F}`,r=`$throttle$pending$${F}`;return function(...g){if(this[n]||(this[n]=C?C():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),P&&(this[n]=P(this[n],...g)),this[r])return;const d=this[m]+k;d<=Date.now()?(this[m]=Date.now(),R.apply(this,[this[n]]),this[n]=C?C():void 0):(this[r]=!0,this[_]=setTimeout(()=>{this[r]=!1,this[m]=Date.now(),R.apply(this,[this[n]]),this[n]=C?C():void 0},d-Date.now()))}})}e.throttle=T}),define(Ee[53],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(w){this._prefix=w,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(Ee[100],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(l){l[l.None=0]="None",l[l.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=2]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",l[l.InvalidUnicode=4]="InvalidUnicode",l[l.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",l[l.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var t;(function(l){l[l.OpenBraceToken=1]="OpenBraceToken",l[l.CloseBraceToken=2]="CloseBraceToken",l[l.OpenBracketToken=3]="OpenBracketToken",l[l.CloseBracketToken=4]="CloseBracketToken",l[l.CommaToken=5]="CommaToken",l[l.ColonToken=6]="ColonToken",l[l.NullKeyword=7]="NullKeyword",l[l.TrueKeyword=8]="TrueKeyword",l[l.FalseKeyword=9]="FalseKeyword",l[l.StringLiteral=10]="StringLiteral",l[l.NumericLiteral=11]="NumericLiteral",l[l.LineCommentTrivia=12]="LineCommentTrivia",l[l.BlockCommentTrivia=13]="BlockCommentTrivia",l[l.LineBreakTrivia=14]="LineBreakTrivia",l[l.Trivia=15]="Trivia",l[l.Unknown=16]="Unknown",l[l.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(l){l[l.InvalidSymbol=1]="InvalidSymbol",l[l.InvalidNumberFormat=2]="InvalidNumberFormat",l[l.PropertyNameExpected=3]="PropertyNameExpected",l[l.ValueExpected=4]="ValueExpected",l[l.ColonExpected=5]="ColonExpected",l[l.CommaExpected=6]="CommaExpected",l[l.CloseBraceExpected=7]="CloseBraceExpected",l[l.CloseBracketExpected=8]="CloseBracketExpected",l[l.EndOfFileExpected=9]="EndOfFileExpected",l[l.InvalidCommentToken=10]="InvalidCommentToken",l[l.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=12]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",l[l.InvalidUnicode=14]="InvalidUnicode",l[l.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",l[l.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(l){l.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function k(l,M=!1){let o=0,i=l.length,h="",u=0,s=16,b=0;function y(L){let z=0,N=0;for(;z<L;){const $=l.charCodeAt(o);if($>=48&&$<=57)N=N*16+$-48;else if($>=65&&$<=70)N=N*16+$-65+10;else if($>=97&&$<=102)N=N*16+$-97+10;else break;o++,z++}return z<L&&(N=-1),N}function c(L){o=L,h="",u=0,s=16,b=0}function S(){const L=o;if(l.charCodeAt(o)===48)o++;else for(o++;o<l.length&&R(l.charCodeAt(o));)o++;if(o<l.length&&l.charCodeAt(o)===46)if(o++,o<l.length&&R(l.charCodeAt(o)))for(o++;o<l.length&&R(l.charCodeAt(o));)o++;else return b=3,l.substring(L,o);let z=o;if(o<l.length&&(l.charCodeAt(o)===69||l.charCodeAt(o)===101))if(o++,(o<l.length&&l.charCodeAt(o)===43||l.charCodeAt(o)===45)&&o++,o<l.length&&R(l.charCodeAt(o))){for(o++;o<l.length&&R(l.charCodeAt(o));)o++;z=o}else b=3;return l.substring(L,z)}function A(){let L="",z=o;for(;;){if(o>=i){L+=l.substring(z,o),b=2;break}const N=l.charCodeAt(o);if(N===34){L+=l.substring(z,o),o++;break}if(N===92){if(L+=l.substring(z,o),o++,o>=i){b=2;break}switch(l.charCodeAt(o++)){case 34:L+='"';break;case 92:L+="\\";break;case 47:L+="/";break;case 98:L+="\b";break;case 102:L+="\f";break;case 110:L+=`
`;break;case 114:L+="\r";break;case 116:L+="	";break;case 117:{const j=y(4);j>=0?L+=String.fromCharCode(j):b=4;break}default:b=5}z=o;continue}if(N>=0&&N<=31)if(C(N)){L+=l.substring(z,o),b=2;break}else b=6;o++}return L}function U(){if(h="",b=0,u=o,o>=i)return u=i,s=17;let L=l.charCodeAt(o);if(P(L)){do o++,h+=String.fromCharCode(L),L=l.charCodeAt(o);while(P(L));return s=15}if(C(L))return o++,h+=String.fromCharCode(L),L===13&&l.charCodeAt(o)===10&&(o++,h+=`
`),s=14;switch(L){case 123:return o++,s=1;case 125:return o++,s=2;case 91:return o++,s=3;case 93:return o++,s=4;case 58:return o++,s=6;case 44:return o++,s=5;case 34:return o++,h=A(),s=10;case 47:{const z=o-1;if(l.charCodeAt(o+1)===47){for(o+=2;o<i&&!C(l.charCodeAt(o));)o++;return h=l.substring(z,o),s=12}if(l.charCodeAt(o+1)===42){o+=2;const N=i-1;let $=!1;for(;o<N;){if(l.charCodeAt(o)===42&&l.charCodeAt(o+1)===47){o+=2,$=!0;break}o++}return $||(o++,b=1),h=l.substring(z,o),s=13}return h+=String.fromCharCode(L),o++,s=16}case 45:if(h+=String.fromCharCode(L),o++,o===i||!R(l.charCodeAt(o)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=S(),s=11;default:for(;o<i&&H(L);)o++,L=l.charCodeAt(o);if(u!==o){switch(h=l.substring(u,o),h){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return h+=String.fromCharCode(L),o++,s=16}}function H(L){if(P(L)||C(L))return!1;switch(L){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function E(){let L;do L=U();while(L>=12&&L<=15);return L}return{setPosition:c,getPosition:()=>o,scan:M?E:U,getToken:()=>s,getTokenValue:()=>h,getTokenOffset:()=>u,getTokenLength:()=>o-u,getTokenError:()=>b}}e.createScanner=k;function P(l){return l===32||l===9||l===11||l===12||l===160||l===5760||l>=8192&&l<=8203||l===8239||l===8287||l===12288||l===65279}function C(l){return l===10||l===13||l===8232||l===8233}function R(l){return l>=48&&l<=57}var F;(function(l){l[l.nullCharacter=0]="nullCharacter",l[l.maxAsciiCharacter=127]="maxAsciiCharacter",l[l.lineFeed=10]="lineFeed",l[l.carriageReturn=13]="carriageReturn",l[l.lineSeparator=8232]="lineSeparator",l[l.paragraphSeparator=8233]="paragraphSeparator",l[l.nextLine=133]="nextLine",l[l.space=32]="space",l[l.nonBreakingSpace=160]="nonBreakingSpace",l[l.enQuad=8192]="enQuad",l[l.emQuad=8193]="emQuad",l[l.enSpace=8194]="enSpace",l[l.emSpace=8195]="emSpace",l[l.threePerEmSpace=8196]="threePerEmSpace",l[l.fourPerEmSpace=8197]="fourPerEmSpace",l[l.sixPerEmSpace=8198]="sixPerEmSpace",l[l.figureSpace=8199]="figureSpace",l[l.punctuationSpace=8200]="punctuationSpace",l[l.thinSpace=8201]="thinSpace",l[l.hairSpace=8202]="hairSpace",l[l.zeroWidthSpace=8203]="zeroWidthSpace",l[l.narrowNoBreakSpace=8239]="narrowNoBreakSpace",l[l.ideographicSpace=12288]="ideographicSpace",l[l.mathematicalSpace=8287]="mathematicalSpace",l[l.ogham=5760]="ogham",l[l._=95]="_",l[l.$=36]="$",l[l._0=48]="_0",l[l._1=49]="_1",l[l._2=50]="_2",l[l._3=51]="_3",l[l._4=52]="_4",l[l._5=53]="_5",l[l._6=54]="_6",l[l._7=55]="_7",l[l._8=56]="_8",l[l._9=57]="_9",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.ampersand=38]="ampersand",l[l.asterisk=42]="asterisk",l[l.at=64]="at",l[l.backslash=92]="backslash",l[l.bar=124]="bar",l[l.caret=94]="caret",l[l.closeBrace=125]="closeBrace",l[l.closeBracket=93]="closeBracket",l[l.closeParen=41]="closeParen",l[l.colon=58]="colon",l[l.comma=44]="comma",l[l.dot=46]="dot",l[l.doubleQuote=34]="doubleQuote",l[l.equals=61]="equals",l[l.exclamation=33]="exclamation",l[l.greaterThan=62]="greaterThan",l[l.lessThan=60]="lessThan",l[l.minus=45]="minus",l[l.openBrace=123]="openBrace",l[l.openBracket=91]="openBracket",l[l.openParen=40]="openParen",l[l.percent=37]="percent",l[l.plus=43]="plus",l[l.question=63]="question",l[l.semicolon=59]="semicolon",l[l.singleQuote=39]="singleQuote",l[l.slash=47]="slash",l[l.tilde=126]="tilde",l[l.backspace=8]="backspace",l[l.formFeed=12]="formFeed",l[l.byteOrderMark=65279]="byteOrderMark",l[l.tab=9]="tab",l[l.verticalTab=11]="verticalTab"})(F||(F={}));function _(l,M){const o=[],i=new Object;let h;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function b(y,c,S,A){u.value=y,u.offset=c,u.length=S,u.type=A,u.colonOffset=void 0,h=u}try{f(l,{onObjectBegin:(y,c)=>{if(M<=y)throw i;h=void 0,s=M>y,o.push("")},onObjectProperty:(y,c,S)=>{if(M<c||(b(y,c,S,"property"),o[o.length-1]=y,M<=c+S))throw i},onObjectEnd:(y,c)=>{if(M<=y)throw i;h=void 0,o.pop()},onArrayBegin:(y,c)=>{if(M<=y)throw i;h=void 0,o.push(0)},onArrayEnd:(y,c)=>{if(M<=y)throw i;h=void 0,o.pop()},onLiteralValue:(y,c,S)=>{if(M<c||(b(y,c,S,I(y)),M<=c+S))throw i},onSeparator:(y,c,S)=>{if(M<=c)throw i;if(y===":"&&h&&h.type==="property")h.colonOffset=c,s=!1,h=void 0;else if(y===","){const A=o[o.length-1];typeof A=="number"?o[o.length-1]=A+1:(s=!0,o[o.length-1]=""),h=void 0}}})}catch(y){if(y!==i)throw y}return{path:o,previousNode:h,isAtPropertyKey:s,matches:y=>{let c=0;for(let S=0;c<y.length&&S<o.length;S++)if(y[c]===o[S]||y[c]==="*")c++;else if(y[c]!=="**")return!1;return c===y.length}}}e.getLocation=_;function n(l,M=[],o=T.DEFAULT){let i=null,h=[];const u=[];function s(y){Array.isArray(h)?h.push(y):i!==null&&(h[i]=y)}return f(l,{onObjectBegin:()=>{const y={};s(y),u.push(h),h=y,i=null},onObjectProperty:y=>{i=y},onObjectEnd:()=>{h=u.pop()},onArrayBegin:()=>{const y=[];s(y),u.push(h),h=y,i=null},onArrayEnd:()=>{h=u.pop()},onLiteralValue:s,onError:(y,c,S)=>{M.push({error:y,offset:c,length:S})}},o),h[0]}e.parse=n;function m(l,M=[],o=T.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(y){i.type==="property"&&(i.length=y-i.offset,i=i.parent)}function u(y){return i.children.push(y),y}f(l,{onObjectBegin:y=>{i=u({type:"object",offset:y,length:-1,parent:i,children:[]})},onObjectProperty:(y,c,S)=>{i=u({type:"property",offset:c,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:y,offset:c,length:S,parent:i})},onObjectEnd:(y,c)=>{i.length=y+c-i.offset,i=i.parent,h(y+c)},onArrayBegin:(y,c)=>{i=u({type:"array",offset:y,length:-1,parent:i,children:[]})},onArrayEnd:(y,c)=>{i.length=y+c-i.offset,i=i.parent,h(y+c)},onLiteralValue:(y,c,S)=>{u({type:I(y),offset:c,length:S,parent:i,value:y}),h(c+S)},onSeparator:(y,c,S)=>{i.type==="property"&&(y===":"?i.colonOffset=c:y===","&&h(c))},onError:(y,c,S)=>{M.push({error:y,offset:c,length:S})}},o);const b=i.children[0];return b&&delete b.parent,b}e.parseTree=m;function r(l,M){if(!l)return;let o=l;for(let i of M)if(typeof i=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let h=!1;for(const u of o.children)if(Array.isArray(u.children)&&u.children[0].value===i){o=u.children[1],h=!0;break}if(!h)return}else{const h=i;if(o.type!=="array"||h<0||!Array.isArray(o.children)||h>=o.children.length)return;o=o.children[h]}return o}e.findNodeAtLocation=r;function g(l){if(!l.parent||!l.parent.children)return[];const M=g(l.parent);if(l.parent.type==="property"){const o=l.parent.children[0].value;M.push(o)}else if(l.parent.type==="array"){const o=l.parent.children.indexOf(l);o!==-1&&M.push(o)}return M}e.getNodePath=g;function d(l){switch(l.type){case"array":return l.children.map(d);case"object":{const M=Object.create(null);for(let o of l.children){const i=o.children[1];i&&(M[o.children[0].value]=d(i))}return M}case"null":case"string":case"number":case"boolean":return l.value;default:return}}e.getNodeValue=d;function D(l,M,o=!1){return M>=l.offset&&M<l.offset+l.length||o&&M===l.offset+l.length}e.contains=D;function v(l,M,o=!1){if(D(l,M,o)){const i=l.children;if(Array.isArray(i))for(let h=0;h<i.length&&i[h].offset<=M;h++){const u=v(i[h],M,o);if(u)return u}return l}}e.findNodeAtOffset=v;function f(l,M,o=T.DEFAULT){const i=k(l,!1);function h(ae){return ae?()=>ae(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(ae){return ae?le=>ae(le,i.getTokenOffset(),i.getTokenLength()):()=>!0}const s=h(M.onObjectBegin),b=u(M.onObjectProperty),y=h(M.onObjectEnd),c=h(M.onArrayBegin),S=h(M.onArrayEnd),A=u(M.onLiteralValue),U=u(M.onSeparator),H=h(M.onComment),E=u(M.onError),L=o&&o.disallowComments,z=o&&o.allowTrailingComma;function N(){for(;;){const ae=i.scan();switch(i.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:L||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(ae){case 12:case 13:L?$(10):H();break;case 16:$(1);break;case 15:case 14:break;default:return ae}}}function $(ae,le=[],Se=[]){if(E(ae),le.length+Se.length>0){let Ce=i.getToken();for(;Ce!==17;){if(le.indexOf(Ce)!==-1){N();break}else if(Se.indexOf(Ce)!==-1)break;Ce=N()}}}function j(ae){const le=i.getTokenValue();return ae?A(le):b(le),N(),!0}function ue(){switch(i.getToken()){case 11:{let ae=0;try{ae=JSON.parse(i.getTokenValue()),typeof ae!="number"&&($(2),ae=0)}catch{$(2)}A(ae);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return N(),!0}function K(){return i.getToken()!==10?($(3,[],[2,5]),!1):(j(!1),i.getToken()===6?(U(":"),N(),we()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function ie(){s(),N();let ae=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ae||$(4,[],[]),U(","),N(),i.getToken()===2&&z)break}else ae&&$(6,[],[]);K()||$(4,[],[2,5]),ae=!0}return y(),i.getToken()!==2?$(7,[2],[]):N(),!0}function pe(){c(),N();let ae=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ae||$(4,[],[]),U(","),N(),i.getToken()===4&&z)break}else ae&&$(6,[],[]);we()||$(4,[],[4,5]),ae=!0}return S(),i.getToken()!==4?$(8,[4],[]):N(),!0}function we(){switch(i.getToken()){case 3:return pe();case 1:return ie();case 10:return j(!0);default:return ue()}}return N(),i.getToken()===17?o.allowEmptyContent?!0:($(4,[],[]),!1):we()?(i.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=f;function p(l,M){let o=k(l),i=[],h,u=0,s;do switch(s=o.getPosition(),h=o.scan(),h){case 12:case 13:case 17:u!==s&&i.push(l.substring(u,s)),M!==void 0&&i.push(o.getTokenValue().replace(/[^\r\n]/g,M)),u=o.getPosition();break}while(h!==17);return i.join("")}e.stripComments=p;function I(l){switch(typeof l){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(l){if(Array.isArray(l))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=I}),define(Ee[101],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class a{constructor(w){this.executor=w,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(w){this._error=w}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(w){return new a(()=>w(this.getValue()))}}e.Lazy=a}),function(ne,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ne=typeof globalThis!="undefined"?globalThis:ne||self,ne.marked=e())}(this,function(){"use strict";function ne(Te,De){for(var ve=0;ve<De.length;ve++){var re=De[ve];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(Te,re.key,re)}}function e(Te,De,ve){return De&&ne(Te.prototype,De),ve&&ne(Te,ve),Te}function a(Te,De){if(!!Te){if(typeof Te=="string")return t(Te,De);var ve=Object.prototype.toString.call(Te).slice(8,-1);if(ve==="Object"&&Te.constructor&&(ve=Te.constructor.name),ve==="Map"||ve==="Set")return Array.from(Te);if(ve==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ve))return t(Te,De)}}function t(Te,De){(De==null||De>Te.length)&&(De=Te.length);for(var ve=0,re=new Array(De);ve<De;ve++)re[ve]=Te[ve];return re}function w(Te,De){var ve=typeof Symbol!="undefined"&&Te[Symbol.iterator]||Te["@@iterator"];if(ve)return(ve=ve.call(Te)).next.bind(ve);if(Array.isArray(Te)||(ve=a(Te))||De&&Te&&typeof Te.length=="number"){ve&&(Te=ve);var re=0;return function(){return re>=Te.length?{done:!0}:{done:!1,value:Te[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var T={exports:{}};function k(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function P(Te){T.exports.defaults=Te}T.exports={defaults:k(),getDefaults:k,changeDefaults:P};var C=/[&<>"']/,R=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(De){return n[De]};function r(Te,De){if(De){if(C.test(Te))return Te.replace(R,m)}else if(F.test(Te))return Te.replace(_,m);return Te}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(Te){return Te.replace(g,function(De,ve){return ve=ve.toLowerCase(),ve==="colon"?":":ve.charAt(0)==="#"?ve.charAt(1)==="x"?String.fromCharCode(parseInt(ve.substring(2),16)):String.fromCharCode(+ve.substring(1)):""})}var D=/(^|[^\[])\^/g;function v(Te,De){Te=Te.source||Te,De=De||"";var ve={replace:function(oe,he){return he=he.source||he,he=he.replace(D,"$1"),Te=Te.replace(oe,he),ve},getRegex:function(){return new RegExp(Te,De)}};return ve}var f=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function I(Te,De,ve){if(Te){var re;try{re=decodeURIComponent(d(ve)).replace(f,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}De&&!p.test(ve)&&(ve=h(De,ve));try{ve=encodeURI(ve).replace(/%25/g,"%")}catch{return null}return ve}var l={},M=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(Te,De){l[" "+Te]||(M.test(Te)?l[" "+Te]=Te+"/":l[" "+Te]=y(Te,"/",!0)),Te=l[" "+Te];var ve=Te.indexOf(":")===-1;return De.substring(0,2)==="//"?ve?De:Te.replace(o,"$1")+De:De.charAt(0)==="/"?ve?De:Te.replace(i,"$1")+De:Te+De}var u={exec:function(){}};function s(Te){for(var De=1,ve,re;De<arguments.length;De++){ve=arguments[De];for(re in ve)Object.prototype.hasOwnProperty.call(ve,re)&&(Te[re]=ve[re])}return Te}function b(Te,De){var ve=Te.replace(/\|/g,function(he,me,Pe){for(var We=!1,Le=me;--Le>=0&&Pe[Le]==="\\";)We=!We;return We?"|":" |"}),re=ve.split(/ \|/),oe=0;if(re[0].trim()||re.shift(),re[re.length-1].trim()||re.pop(),re.length>De)re.splice(De);else for(;re.length<De;)re.push("");for(;oe<re.length;oe++)re[oe]=re[oe].trim().replace(/\\\|/g,"|");return re}function y(Te,De,ve){var re=Te.length;if(re===0)return"";for(var oe=0;oe<re;){var he=Te.charAt(re-oe-1);if(he===De&&!ve)oe++;else if(he!==De&&ve)oe++;else break}return Te.substr(0,re-oe)}function c(Te,De){if(Te.indexOf(De[1])===-1)return-1;for(var ve=Te.length,re=0,oe=0;oe<ve;oe++)if(Te[oe]==="\\")oe++;else if(Te[oe]===De[0])re++;else if(Te[oe]===De[1]&&(re--,re<0))return oe;return-1}function S(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(Te,De){if(De<1)return"";for(var ve="";De>1;)De&1&&(ve+=Te),De>>=1,Te+=Te;return ve+Te}var U={escape:r,unescape:d,edit:v,cleanUrl:I,resolveUrl:h,noopTest:u,merge:s,splitCells:b,rtrim:y,findClosingBracket:c,checkSanitizeDeprecation:S,repeatString:A},H=T.exports.defaults,E=U.rtrim,L=U.splitCells,z=U.escape,N=U.findClosingBracket;function $(Te,De,ve,re){var oe=De.href,he=De.title?z(De.title):null,me=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){re.state.inLink=!0;var Pe={type:"link",raw:ve,href:oe,title:he,text:me,tokens:re.inlineTokens(me,[])};return re.state.inLink=!1,Pe}else return{type:"image",raw:ve,href:oe,title:he,text:z(me)}}function j(Te,De){var ve=Te.match(/^(\s+)(?:```)/);if(ve===null)return De;var re=ve[1];return De.split(`
`).map(function(oe){var he=oe.match(/^\s+/);if(he===null)return oe;var me=he[0];return me.length>=re.length?oe.slice(re.length):oe}).join(`
`)}var ue=function(){function Te(ve){this.options=ve||H}var De=Te.prototype;return De.space=function(re){var oe=this.rules.block.newline.exec(re);if(oe)return oe[0].length>1?{type:"space",raw:oe[0]}:{raw:`
`}},De.code=function(re){var oe=this.rules.block.code.exec(re);if(oe){var he=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?he:E(he,`
`)}}},De.fences=function(re){var oe=this.rules.block.fences.exec(re);if(oe){var he=oe[0],me=j(he,oe[3]||"");return{type:"code",raw:he,lang:oe[2]?oe[2].trim():oe[2],text:me}}},De.heading=function(re){var oe=this.rules.block.heading.exec(re);if(oe){var he=oe[2].trim();if(/#$/.test(he)){var me=E(he,"#");(this.options.pedantic||!me||/ $/.test(me))&&(he=me.trim())}var Pe={type:"heading",raw:oe[0],depth:oe[1].length,text:he,tokens:[]};return this.lexer.inline(Pe.text,Pe.tokens),Pe}},De.hr=function(re){var oe=this.rules.block.hr.exec(re);if(oe)return{type:"hr",raw:oe[0]}},De.blockquote=function(re){var oe=this.rules.block.blockquote.exec(re);if(oe){var he=oe[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:oe[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},De.list=function(re){var oe=this.rules.block.list.exec(re);if(oe){var he,me,Pe,We,Le,Ke,it,rt,te,ge,Z=oe[1].trim(),W=Z.length>1,be={type:"list",raw:"",ordered:W,start:W?+Z.slice(0,-1):"",loose:!1,items:[]};Z=W?"\\d{1,9}\\"+Z.slice(-1):"\\"+Z,this.options.pedantic&&(Z=W?Z:"[*+-]");for(var Ie=new RegExp("^( {0,3}"+Z+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");re&&!(this.rules.block.hr.test(re)||!(oe=Ie.exec(re)));){te=oe[2].split(`
`),this.options.pedantic?(We=2,ge=te[0].trimLeft()):(We=oe[2].search(/[^ ]/),We=oe[1].length+(We>4?1:We),ge=te[0].slice(We-oe[1].length)),Ke=!1,he=oe[0],!te[0]&&/^ *$/.test(te[1])&&(he=oe[1]+te.slice(0,2).join(`
`)+`
`,be.loose=!0,te=[]);var Qe=new RegExp("^ {0,"+Math.min(3,We-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Le=1;Le<te.length;Le++){if(rt=te[Le],this.options.pedantic&&(rt=rt.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Qe.test(rt)){he=oe[1]+te.slice(0,Le).join(`
`)+`
`;break}if(!Ke){rt.trim()||(Ke=!0),rt.search(/[^ ]/)>=We?ge+=`
`+rt.slice(We):ge+=`
`+rt;continue}if(rt.search(/[^ ]/)>=We||!rt.trim()){ge+=`
`+rt.slice(We);continue}else{he=oe[1]+te.slice(0,Le).join(`
`)+`
`;break}}be.loose||(it?be.loose=!0:/\n *\n *$/.test(he)&&(it=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(ge),me&&(Pe=me[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),be.items.push({type:"list_item",raw:he,task:!!me,checked:Pe,loose:!1,text:ge}),be.raw+=he,re=re.slice(he.length)}be.items[be.items.length-1].raw=he.trimRight(),be.items[be.items.length-1].text=ge.trimRight(),be.raw=be.raw.trimRight();var Ue=be.items.length;for(Le=0;Le<Ue;Le++)this.lexer.state.top=!1,be.items[Le].tokens=this.lexer.blockTokens(be.items[Le].text,[]),be.items[Le].tokens.some(function(ut){return ut.type==="space"})&&(be.loose=!0,be.items[Le].loose=!0);return be}},De.html=function(re){var oe=this.rules.block.html.exec(re);if(oe){var he={type:"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:oe[0]};return this.options.sanitize&&(he.type="paragraph",he.text=this.options.sanitizer?this.options.sanitizer(oe[0]):z(oe[0]),he.tokens=[],this.lexer.inline(he.text,he.tokens)),he}},De.def=function(re){var oe=this.rules.block.def.exec(re);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var he=oe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:oe[0],href:oe[2],title:oe[3]}}},De.table=function(re){var oe=this.rules.block.table.exec(re);if(oe){var he={type:"table",header:L(oe[1]).map(function(it){return{text:it}}),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:oe[3]?oe[3].replace(/\n$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=oe[0];var me=he.align.length,Pe,We,Le,Ke;for(Pe=0;Pe<me;Pe++)/^ *-+: *$/.test(he.align[Pe])?he.align[Pe]="right":/^ *:-+: *$/.test(he.align[Pe])?he.align[Pe]="center":/^ *:-+ *$/.test(he.align[Pe])?he.align[Pe]="left":he.align[Pe]=null;for(me=he.rows.length,Pe=0;Pe<me;Pe++)he.rows[Pe]=L(he.rows[Pe],he.header.length).map(function(it){return{text:it}});for(me=he.header.length,We=0;We<me;We++)he.header[We].tokens=[],this.lexer.inlineTokens(he.header[We].text,he.header[We].tokens);for(me=he.rows.length,We=0;We<me;We++)for(Ke=he.rows[We],Le=0;Le<Ke.length;Le++)Ke[Le].tokens=[],this.lexer.inlineTokens(Ke[Le].text,Ke[Le].tokens);return he}}},De.lheading=function(re){var oe=this.rules.block.lheading.exec(re);if(oe){var he={type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1],tokens:[]};return this.lexer.inline(he.text,he.tokens),he}},De.paragraph=function(re){var oe=this.rules.block.paragraph.exec(re);if(oe){var he={type:"paragraph",raw:oe[0],text:oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1],tokens:[]};return this.lexer.inline(he.text,he.tokens),he}},De.text=function(re){var oe=this.rules.block.text.exec(re);if(oe){var he={type:"text",raw:oe[0],text:oe[0],tokens:[]};return this.lexer.inline(he.text,he.tokens),he}},De.escape=function(re){var oe=this.rules.inline.escape.exec(re);if(oe)return{type:"escape",raw:oe[0],text:z(oe[1])}},De.tag=function(re){var oe=this.rules.inline.tag.exec(re);if(oe)return!this.lexer.state.inLink&&/^<a /i.test(oe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(oe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):z(oe[0]):oe[0]}},De.link=function(re){var oe=this.rules.inline.link.exec(re);if(oe){var he=oe[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var me=E(he.slice(0,-1),"\\");if((he.length-me.length)%2==0)return}else{var Pe=N(oe[2],"()");if(Pe>-1){var We=oe[0].indexOf("!")===0?5:4,Le=We+oe[1].length+Pe;oe[2]=oe[2].substring(0,Pe),oe[0]=oe[0].substring(0,Le).trim(),oe[3]=""}}var Ke=oe[2],it="";if(this.options.pedantic){var rt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ke);rt&&(Ke=rt[1],it=rt[3])}else it=oe[3]?oe[3].slice(1,-1):"";return Ke=Ke.trim(),/^</.test(Ke)&&(this.options.pedantic&&!/>$/.test(he)?Ke=Ke.slice(1):Ke=Ke.slice(1,-1)),$(oe,{href:Ke&&Ke.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},oe[0],this.lexer)}},De.reflink=function(re,oe){var he;if((he=this.rules.inline.reflink.exec(re))||(he=this.rules.inline.nolink.exec(re))){var me=(he[2]||he[1]).replace(/\s+/g," ");if(me=oe[me.toLowerCase()],!me||!me.href){var Pe=he[0].charAt(0);return{type:"text",raw:Pe,text:Pe}}return $(he,me,he[0],this.lexer)}},De.emStrong=function(re,oe,he){he===void 0&&(he="");var me=this.rules.inline.emStrong.lDelim.exec(re);if(!!me&&!(me[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Pe=me[1]||me[2]||"";if(!Pe||Pe&&(he===""||this.rules.inline.punctuation.exec(he))){var We=me[0].length-1,Le,Ke,it=We,rt=0,te=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(te.lastIndex=0,oe=oe.slice(-1*re.length+We);(me=te.exec(oe))!=null;)if(Le=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Le){if(Ke=Le.length,me[3]||me[4]){it+=Ke;continue}else if((me[5]||me[6])&&We%3&&!((We+Ke)%3)){rt+=Ke;continue}if(it-=Ke,!(it>0)){if(Ke=Math.min(Ke,Ke+it+rt),Math.min(We,Ke)%2){var ge=re.slice(1,We+me.index+Ke);return{type:"em",raw:re.slice(0,We+me.index+Ke+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}var Z=re.slice(2,We+me.index+Ke-1);return{type:"strong",raw:re.slice(0,We+me.index+Ke+1),text:Z,tokens:this.lexer.inlineTokens(Z,[])}}}}}},De.codespan=function(re){var oe=this.rules.inline.code.exec(re);if(oe){var he=oe[2].replace(/\n/g," "),me=/[^ ]/.test(he),Pe=/^ /.test(he)&&/ $/.test(he);return me&&Pe&&(he=he.substring(1,he.length-1)),he=z(he,!0),{type:"codespan",raw:oe[0],text:he}}},De.br=function(re){var oe=this.rules.inline.br.exec(re);if(oe)return{type:"br",raw:oe[0]}},De.del=function(re){var oe=this.rules.inline.del.exec(re);if(oe)return{type:"del",raw:oe[0],text:oe[2],tokens:this.lexer.inlineTokens(oe[2],[])}},De.autolink=function(re,oe){var he=this.rules.inline.autolink.exec(re);if(he){var me,Pe;return he[2]==="@"?(me=z(this.options.mangle?oe(he[1]):he[1]),Pe="mailto:"+me):(me=z(he[1]),Pe=me),{type:"link",raw:he[0],text:me,href:Pe,tokens:[{type:"text",raw:me,text:me}]}}},De.url=function(re,oe){var he;if(he=this.rules.inline.url.exec(re)){var me,Pe;if(he[2]==="@")me=z(this.options.mangle?oe(he[0]):he[0]),Pe="mailto:"+me;else{var We;do We=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(We!==he[0]);me=z(he[0]),he[1]==="www."?Pe="http://"+me:Pe=me}return{type:"link",raw:he[0],text:me,href:Pe,tokens:[{type:"text",raw:me,text:me}]}}},De.inlineText=function(re,oe){var he=this.rules.inline.text.exec(re);if(he){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):z(he[0]):he[0]:me=z(this.options.smartypants?oe(he[0]):he[0]),{type:"text",raw:he[0],text:me}}},Te}(),K=U.noopTest,ie=U.edit,pe=U.merge,we={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:K,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};we._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,we._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,we.def=ie(we.def).replace("label",we._label).replace("title",we._title).getRegex(),we.bullet=/(?:[*+-]|\d{1,9}[.)])/,we.listItemStart=ie(/^( *)(bull) */).replace("bull",we.bullet).getRegex(),we.list=ie(we.list).replace(/bull/g,we.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+we.def.source+")").getRegex(),we._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",we._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,we.html=ie(we.html,"i").replace("comment",we._comment).replace("tag",we._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),we.paragraph=ie(we._paragraph).replace("hr",we.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",we._tag).getRegex(),we.blockquote=ie(we.blockquote).replace("paragraph",we.paragraph).getRegex(),we.normal=pe({},we),we.gfm=pe({},we.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),we.gfm.table=ie(we.gfm.table).replace("hr",we.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",we._tag).getRegex(),we.pedantic=pe({},we.normal,{html:ie(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",we._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:K,paragraph:ie(we.normal._paragraph).replace("hr",we.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",we.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ae={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:K,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:K,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ae._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ae.punctuation=ie(ae.punctuation).replace(/punctuation/g,ae._punctuation).getRegex(),ae.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ae.escapedEmSt=/\\\*|\\_/g,ae._comment=ie(we._comment).replace("(?:-->|$)","-->").getRegex(),ae.emStrong.lDelim=ie(ae.emStrong.lDelim).replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimAst=ie(ae.emStrong.rDelimAst,"g").replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimUnd=ie(ae.emStrong.rDelimUnd,"g").replace(/punct/g,ae._punctuation).getRegex(),ae._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ae._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ae._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ae.autolink=ie(ae.autolink).replace("scheme",ae._scheme).replace("email",ae._email).getRegex(),ae._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ae.tag=ie(ae.tag).replace("comment",ae._comment).replace("attribute",ae._attribute).getRegex(),ae._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ae._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ae._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ae.link=ie(ae.link).replace("label",ae._label).replace("href",ae._href).replace("title",ae._title).getRegex(),ae.reflink=ie(ae.reflink).replace("label",ae._label).getRegex(),ae.reflinkSearch=ie(ae.reflinkSearch,"g").replace("reflink",ae.reflink).replace("nolink",ae.nolink).getRegex(),ae.normal=pe({},ae),ae.pedantic=pe({},ae.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:ie(/^!?\[(label)\]\((.*?)\)/).replace("label",ae._label).getRegex(),reflink:ie(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ae._label).getRegex()}),ae.gfm=pe({},ae.normal,{escape:ie(ae.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ae.gfm.url=ie(ae.gfm.url,"i").replace("email",ae.gfm._extended_email).getRegex(),ae.breaks=pe({},ae.gfm,{br:ie(ae.br).replace("{2,}","*").getRegex(),text:ie(ae.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var le={block:we,inline:ae},Se=ue,Ce=T.exports.defaults,Fe=le.block,$e=le.inline,Ve=U.repeatString;function je(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(Te){var De="",ve,re,oe=Te.length;for(ve=0;ve<oe;ve++)re=Te.charCodeAt(ve),Math.random()>.5&&(re="x"+re.toString(16)),De+="&#"+re+";";return De}var G=function(){function Te(ve){this.tokens=[],this.tokens.links=Object.create(null),this.options=ve||Ce,this.options.tokenizer=this.options.tokenizer||new Se,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:Fe.normal,inline:$e.normal};this.options.pedantic?(re.block=Fe.pedantic,re.inline=$e.pedantic):this.options.gfm&&(re.block=Fe.gfm,this.options.breaks?re.inline=$e.breaks:re.inline=$e.gfm),this.tokenizer.rules=re}Te.lex=function(re,oe){var he=new Te(oe);return he.lex(re)},Te.lexInline=function(re,oe){var he=new Te(oe);return he.inlineTokens(re)};var De=Te.prototype;return De.lex=function(re){re=re.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(re,this.tokens);for(var oe;oe=this.inlineQueue.shift();)this.inlineTokens(oe.src,oe.tokens);return this.tokens},De.blockTokens=function(re,oe){var he=this;oe===void 0&&(oe=[]),this.options.pedantic&&(re=re.replace(/^ +$/gm,""));for(var me,Pe,We,Le;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(me=it.call({lexer:he},re,oe))?(re=re.substring(me.raw.length),oe.push(me),!0):!1}))){if(me=this.tokenizer.space(re)){re=re.substring(me.raw.length),me.type&&oe.push(me);continue}if(me=this.tokenizer.code(re)){re=re.substring(me.raw.length),Pe=oe[oe.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+me.raw,Pe.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):oe.push(me);continue}if(me=this.tokenizer.fences(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.heading(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.hr(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.blockquote(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.list(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.html(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.def(re)){re=re.substring(me.raw.length),Pe=oe[oe.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+me.raw,Pe.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.lheading(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(We=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=1/0,rt=re.slice(1),te=void 0;he.options.extensions.startBlock.forEach(function(ge){te=ge.call({lexer:this},rt),typeof te=="number"&&te>=0&&(it=Math.min(it,te))}),it<1/0&&it>=0&&(We=re.substring(0,it+1))}(),this.state.top&&(me=this.tokenizer.paragraph(We))){Pe=oe[oe.length-1],Le&&Pe.type==="paragraph"?(Pe.raw+=`
`+me.raw,Pe.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):oe.push(me),Le=We.length!==re.length,re=re.substring(me.raw.length);continue}if(me=this.tokenizer.text(re)){re=re.substring(me.raw.length),Pe=oe[oe.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+me.raw,Pe.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):oe.push(me);continue}if(re){var Ke="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(Ke);break}else throw new Error(Ke)}}return this.state.top=!0,oe},De.inline=function(re,oe){this.inlineQueue.push({src:re,tokens:oe})},De.inlineTokens=function(re,oe){var he=this;oe===void 0&&(oe=[]);var me,Pe,We,Le=re,Ke,it,rt;if(this.tokens.links){var te=Object.keys(this.tokens.links);if(te.length>0)for(;(Ke=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)te.includes(Ke[0].slice(Ke[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,Ke.index)+"["+Ve("a",Ke[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ke=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,Ke.index)+"["+Ve("a",Ke[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ke=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,Ke.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(it||(rt=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Z){return(me=Z.call({lexer:he},re,oe))?(re=re.substring(me.raw.length),oe.push(me),!0):!1}))){if(me=this.tokenizer.escape(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.tag(re)){re=re.substring(me.raw.length),Pe=oe[oe.length-1],Pe&&me.type==="text"&&Pe.type==="text"?(Pe.raw+=me.raw,Pe.text+=me.text):oe.push(me);continue}if(me=this.tokenizer.link(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(me.raw.length),Pe=oe[oe.length-1],Pe&&me.type==="text"&&Pe.type==="text"?(Pe.raw+=me.raw,Pe.text+=me.text):oe.push(me);continue}if(me=this.tokenizer.emStrong(re,Le,rt)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.codespan(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.br(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.del(re)){re=re.substring(me.raw.length),oe.push(me);continue}if(me=this.tokenizer.autolink(re,B)){re=re.substring(me.raw.length),oe.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(re,B))){re=re.substring(me.raw.length),oe.push(me);continue}if(We=re,this.options.extensions&&this.options.extensions.startInline&&function(){var Z=1/0,W=re.slice(1),be=void 0;he.options.extensions.startInline.forEach(function(Ie){be=Ie.call({lexer:this},W),typeof be=="number"&&be>=0&&(Z=Math.min(Z,be))}),Z<1/0&&Z>=0&&(We=re.substring(0,Z+1))}(),me=this.tokenizer.inlineText(We,je)){re=re.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(rt=me.raw.slice(-1)),it=!0,Pe=oe[oe.length-1],Pe&&Pe.type==="text"?(Pe.raw+=me.raw,Pe.text+=me.text):oe.push(me);continue}if(re){var ge="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return oe},e(Te,null,[{key:"rules",get:function(){return{block:Fe,inline:$e}}}]),Te}(),X=T.exports.defaults,se=U.cleanUrl,q=U.escape,ee=function(){function Te(ve){this.options=ve||X}var De=Te.prototype;return De.code=function(re,oe,he){var me=(oe||"").match(/\S*/)[0];if(this.options.highlight){var Pe=this.options.highlight(re,me);Pe!=null&&Pe!==re&&(he=!0,re=Pe)}return re=re.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+q(me,!0)+'">'+(he?re:q(re,!0))+`</code></pre>
`:"<pre><code>"+(he?re:q(re,!0))+`</code></pre>
`},De.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},De.html=function(re){return re},De.heading=function(re,oe,he,me){return this.options.headerIds?"<h"+oe+' id="'+this.options.headerPrefix+me.slug(he)+'">'+re+"</h"+oe+`>
`:"<h"+oe+">"+re+"</h"+oe+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(re,oe,he){var me=oe?"ol":"ul",Pe=oe&&he!==1?' start="'+he+'"':"";return"<"+me+Pe+`>
`+re+"</"+me+`>
`},De.listitem=function(re){return"<li>"+re+`</li>
`},De.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(re){return"<p>"+re+`</p>
`},De.table=function(re,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+oe+`</table>
`},De.tablerow=function(re){return`<tr>
`+re+`</tr>
`},De.tablecell=function(re,oe){var he=oe.header?"th":"td",me=oe.align?"<"+he+' align="'+oe.align+'">':"<"+he+">";return me+re+"</"+he+`>
`},De.strong=function(re){return"<strong>"+re+"</strong>"},De.em=function(re){return"<em>"+re+"</em>"},De.codespan=function(re){return"<code>"+re+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(re){return"<del>"+re+"</del>"},De.link=function(re,oe,he){if(re=se(this.options.sanitize,this.options.baseUrl,re),re===null)return he;var me='<a href="'+q(re)+'"';return oe&&(me+=' title="'+oe+'"'),me+=">"+he+"</a>",me},De.image=function(re,oe,he){if(re=se(this.options.sanitize,this.options.baseUrl,re),re===null)return he;var me='<img src="'+re+'" alt="'+he+'"';return oe&&(me+=' title="'+oe+'"'),me+=this.options.xhtml?"/>":">",me},De.text=function(re){return re},Te}(),fe=function(){function Te(){}var De=Te.prototype;return De.strong=function(re){return re},De.em=function(re){return re},De.codespan=function(re){return re},De.del=function(re){return re},De.html=function(re){return re},De.text=function(re){return re},De.link=function(re,oe,he){return""+he},De.image=function(re,oe,he){return""+he},De.br=function(){return""},Te}(),Ae=function(){function Te(){this.seen={}}var De=Te.prototype;return De.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(re,oe){var he=re,me=0;if(this.seen.hasOwnProperty(he)){me=this.seen[re];do me++,he=re+"-"+me;while(this.seen.hasOwnProperty(he))}return oe||(this.seen[re]=me,this.seen[he]=0),he},De.slug=function(re,oe){oe===void 0&&(oe={});var he=this.serialize(re);return this.getNextSafeSlug(he,oe.dryrun)},Te}(),xe=ee,ze=fe,Xe=Ae,et=T.exports.defaults,st=U.unescape,Je=function(){function Te(ve){this.options=ve||et,this.options.renderer=this.options.renderer||new xe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ze,this.slugger=new Xe}Te.parse=function(re,oe){var he=new Te(oe);return he.parse(re)},Te.parseInline=function(re,oe){var he=new Te(oe);return he.parseInline(re)};var De=Te.prototype;return De.parse=function(re,oe){oe===void 0&&(oe=!0);var he="",me,Pe,We,Le,Ke,it,rt,te,ge,Z,W,be,Ie,Qe,Ue,ut,vt,St,bt,ht=re.length;for(me=0;me<ht;me++){if(Z=re[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Z.type]&&(bt=this.options.extensions.renderers[Z.type].call({parser:this},Z),bt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Z.type))){he+=bt||"";continue}switch(Z.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(Z.tokens),Z.depth,st(this.parseInline(Z.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(Z.text,Z.lang,Z.escaped);continue}case"table":{for(te="",rt="",Le=Z.header.length,Pe=0;Pe<Le;Pe++)rt+=this.renderer.tablecell(this.parseInline(Z.header[Pe].tokens),{header:!0,align:Z.align[Pe]});for(te+=this.renderer.tablerow(rt),ge="",Le=Z.rows.length,Pe=0;Pe<Le;Pe++){for(it=Z.rows[Pe],rt="",Ke=it.length,We=0;We<Ke;We++)rt+=this.renderer.tablecell(this.parseInline(it[We].tokens),{header:!1,align:Z.align[We]});ge+=this.renderer.tablerow(rt)}he+=this.renderer.table(te,ge);continue}case"blockquote":{ge=this.parse(Z.tokens),he+=this.renderer.blockquote(ge);continue}case"list":{for(W=Z.ordered,be=Z.start,Ie=Z.loose,Le=Z.items.length,ge="",Pe=0;Pe<Le;Pe++)Ue=Z.items[Pe],ut=Ue.checked,vt=Ue.task,Qe="",Ue.task&&(St=this.renderer.checkbox(ut),Ie?Ue.tokens.length>0&&Ue.tokens[0].type==="paragraph"?(Ue.tokens[0].text=St+" "+Ue.tokens[0].text,Ue.tokens[0].tokens&&Ue.tokens[0].tokens.length>0&&Ue.tokens[0].tokens[0].type==="text"&&(Ue.tokens[0].tokens[0].text=St+" "+Ue.tokens[0].tokens[0].text)):Ue.tokens.unshift({type:"text",text:St}):Qe+=St),Qe+=this.parse(Ue.tokens,Ie),ge+=this.renderer.listitem(Qe,vt,ut);he+=this.renderer.list(ge,W,be);continue}case"html":{he+=this.renderer.html(Z.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(Z.tokens));continue}case"text":{for(ge=Z.tokens?this.parseInline(Z.tokens):Z.text;me+1<ht&&re[me+1].type==="text";)Z=re[++me],ge+=`
`+(Z.tokens?this.parseInline(Z.tokens):Z.text);he+=oe?this.renderer.paragraph(ge):ge;continue}default:{var gt='Token with "'+Z.type+'" type was not found.';if(this.options.silent){console.error(gt);return}else throw new Error(gt)}}}return he},De.parseInline=function(re,oe){oe=oe||this.renderer;var he="",me,Pe,We,Le=re.length;for(me=0;me<Le;me++){if(Pe=re[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(We=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),We!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Pe.type))){he+=We||"";continue}switch(Pe.type){case"escape":{he+=oe.text(Pe.text);break}case"html":{he+=oe.html(Pe.text);break}case"link":{he+=oe.link(Pe.href,Pe.title,this.parseInline(Pe.tokens,oe));break}case"image":{he+=oe.image(Pe.href,Pe.title,Pe.text);break}case"strong":{he+=oe.strong(this.parseInline(Pe.tokens,oe));break}case"em":{he+=oe.em(this.parseInline(Pe.tokens,oe));break}case"codespan":{he+=oe.codespan(Pe.text);break}case"br":{he+=oe.br();break}case"del":{he+=oe.del(this.parseInline(Pe.tokens,oe));break}case"text":{he+=oe.text(Pe.text);break}default:{var Ke='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(Ke);return}else throw new Error(Ke)}}}return he},Te}(),nt=G,lt=Je,pt=ue,Ft=ee,Oe=fe,Mt=Ae,V=U.merge,Q=U.checkSanitizeDeprecation,de=U.escape,Ne=T.exports.getDefaults,qe=T.exports.changeDefaults,ot=T.exports.defaults;function Ye(Te,De,ve){if(typeof Te=="undefined"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof De=="function"&&(ve=De,De=null),De=V({},Ye.defaults,De||{}),Q(De),ve){var re=De.highlight,oe;try{oe=nt.lex(Te,De)}catch(We){return ve(We)}var he=function(Le){var Ke;if(!Le)try{De.walkTokens&&Ye.walkTokens(oe,De.walkTokens),Ke=lt.parse(oe,De)}catch(it){Le=it}return De.highlight=re,Le?ve(Le):ve(null,Ke)};if(!re||re.length<3||(delete De.highlight,!oe.length))return he();var me=0;Ye.walkTokens(oe,function(We){We.type==="code"&&(me++,setTimeout(function(){re(We.text,We.lang,function(Le,Ke){if(Le)return he(Le);Ke!=null&&Ke!==We.text&&(We.text=Ke,We.escaped=!0),me--,me===0&&he()})},0))}),me===0&&he();return}try{var Pe=nt.lex(Te,De);return De.walkTokens&&Ye.walkTokens(Pe,De.walkTokens),lt.parse(Pe,De)}catch(We){if(We.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+de(We.message+"",!0)+"</pre>";throw We}}Ye.options=Ye.setOptions=function(Te){return V(Ye.defaults,Te),qe(Ye.defaults),Ye},Ye.getDefaults=Ne,Ye.defaults=ot,Ye.use=function(){for(var Te=this,De=arguments.length,ve=new Array(De),re=0;re<De;re++)ve[re]=arguments[re];var oe=V.apply(void 0,[{}].concat(ve)),he=Ye.defaults.extensions||{renderers:{},childTokens:{}},me;ve.forEach(function(Pe){if(Pe.extensions&&(me=!0,Pe.extensions.forEach(function(Le){if(!Le.name)throw new Error("extension name required");if(Le.renderer){var Ke=he.renderers?he.renderers[Le.name]:null;Ke?he.renderers[Le.name]=function(){for(var it=arguments.length,rt=new Array(it),te=0;te<it;te++)rt[te]=arguments[te];var ge=Le.renderer.apply(this,rt);return ge===!1&&(ge=Ke.apply(this,rt)),ge}:he.renderers[Le.name]=Le.renderer}if(Le.tokenizer){if(!Le.level||Le.level!=="block"&&Le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Le.level]?he[Le.level].unshift(Le.tokenizer):he[Le.level]=[Le.tokenizer],Le.start&&(Le.level==="block"?he.startBlock?he.startBlock.push(Le.start):he.startBlock=[Le.start]:Le.level==="inline"&&(he.startInline?he.startInline.push(Le.start):he.startInline=[Le.start]))}Le.childTokens&&(he.childTokens[Le.name]=Le.childTokens)})),Pe.renderer&&function(){var Le=Ye.defaults.renderer||new Ft,Ke=function(te){var ge=Le[te];Le[te]=function(){for(var Z=arguments.length,W=new Array(Z),be=0;be<Z;be++)W[be]=arguments[be];var Ie=Pe.renderer[te].apply(Le,W);return Ie===!1&&(Ie=ge.apply(Le,W)),Ie}};for(var it in Pe.renderer)Ke(it);oe.renderer=Le}(),Pe.tokenizer&&function(){var Le=Ye.defaults.tokenizer||new pt,Ke=function(te){var ge=Le[te];Le[te]=function(){for(var Z=arguments.length,W=new Array(Z),be=0;be<Z;be++)W[be]=arguments[be];var Ie=Pe.tokenizer[te].apply(Le,W);return Ie===!1&&(Ie=ge.apply(Le,W)),Ie}};for(var it in Pe.tokenizer)Ke(it);oe.tokenizer=Le}(),Pe.walkTokens){var We=Ye.defaults.walkTokens;oe.walkTokens=function(Le){Pe.walkTokens.call(Te,Le),We&&We(Le)}}me&&(oe.extensions=he),Ye.setOptions(oe)})},Ye.walkTokens=function(Te,De){for(var ve=function(){var me=oe.value;switch(De(me),me.type){case"table":{for(var Pe=w(me.header),We;!(We=Pe()).done;){var Le=We.value;Ye.walkTokens(Le.tokens,De)}for(var Ke=w(me.rows),it;!(it=Ke()).done;)for(var rt=it.value,te=w(rt),ge;!(ge=te()).done;){var Z=ge.value;Ye.walkTokens(Z.tokens,De)}break}case"list":{Ye.walkTokens(me.items,De);break}default:Ye.defaults.extensions&&Ye.defaults.extensions.childTokens&&Ye.defaults.extensions.childTokens[me.type]?Ye.defaults.extensions.childTokens[me.type].forEach(function(W){Ye.walkTokens(me[W],De)}):me.tokens&&Ye.walkTokens(me.tokens,De)}},re=w(Te),oe;!(oe=re()).done;)ve()},Ye.parseInline=function(Te,De){if(typeof Te=="undefined"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");De=V({},Ye.defaults,De||{}),Q(De);try{var ve=nt.lexInline(Te,De);return De.walkTokens&&Ye.walkTokens(ve,De.walkTokens),lt.parseInline(ve,De)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+de(re.message+"",!0)+"</pre>";throw re}},Ye.Parser=lt,Ye.parser=lt.parse,Ye.Renderer=Ft,Ye.TextRenderer=Oe,Ye.Lexer=nt,Ye.lexer=nt.lex,Ye.Tokenizer=pt,Ye.Slugger=Mt,Ye.parse=Ye;var yt=Ye;return yt}),define(Ee[75],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(k,P,C){return Math.min(Math.max(k,P),C)}e.clamp=a;function t(k,P){return(P+k%P)%P}e.rot=t;class w{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=w;class T{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T}),function(){function ne(w){const T=[];typeof w=="number"&&T.push("code/timeOrigin",w);function k(C){T.push(C,Date.now())}function P(){const C=[];for(let R=0;R<T.length;R+=2)C.push({name:T[R],startTime:T[R+1]});return C}return{mark:k,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const k of performance.getEntriesByType("mark"))T.push({name:k.name,startTime:Math.round(w+k.startTime)});return T}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function a(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=a(t))}(),define(Ee[102],ye([0,1,15,6]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function w(f){const p=f;return p?[p.on,p.pause,p.resume,p.destroy].every(I=>typeof I=="function"):!1}e.isReadableStream=w;function T(f){const p=f;return p?w(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=T;function k(f,p){return new P(f,p)}e.newWriteableStream=k;class P{constructor(p,I){this.reducer=p,this.options=I,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(I=>this.pendingWritePromises.push(I))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(I=>I(p))}emitError(p){this.listeners.error.length===0?(0,a.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(I=>I(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,I){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(I),this.resume();break;case"end":this.listeners.end.push(I),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(I),this.state.flowing&&this.flowErrors();break}}removeListener(p,I){if(this.state.destroyed)return;let l;switch(p){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const M=l.indexOf(I);M>=0&&l.splice(M,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const I=[...this.pendingWritePromises];this.pendingWritePromises.length=0,I.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(f,p){const I=[];let l;for(;(l=f.read())!==null;)I.push(l);return p(I)}e.consumeReadable=C;function R(f,p,I){const l=[];let M;for(;(M=f.read())!==null&&l.length<I;)l.push(M);return M===null&&l.length>0?p(l):{read:()=>{if(l.length>0)return l.shift();if(typeof M!="undefined"){const o=M;return M=void 0,o}return f.read()}}}e.peekReadable=R;function F(f,p){return new Promise((I,l)=>{const M=[];_(f,{onData:o=>{p&&M.push(o)},onError:o=>{p?l(o):I(void 0)},onEnd:()=>{I(p?p(M):void 0)}})})}e.consumeStream=F;function _(f,p){let I=!1;return f.on("error",l=>{I||p.onError(l)}),f.on("end",()=>{I||p.onEnd()}),f.on("data",l=>{I||p.onData(l)}),(0,t.toDisposable)(()=>I=!0)}e.listenStream=_;function n(f,p){return new Promise((I,l)=>{const M=new t.DisposableStore,o=[],i=s=>{if(o.push(s),o.length>p)return M.dispose(),f.pause(),I({stream:f,buffer:o,ended:!1})},h=s=>l(s),u=()=>I({stream:f,buffer:o,ended:!0});M.add((0,t.toDisposable)(()=>f.removeListener("error",h))),f.on("error",h),M.add((0,t.toDisposable)(()=>f.removeListener("end",u))),f.on("end",u),M.add((0,t.toDisposable)(()=>f.removeListener("data",i))),f.on("data",i)})}e.peekStream=n;function m(f,p){const I=k(p);return I.end(f),I}e.toStream=m;function r(){const f=k(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=r;function g(f){let p=!1;return{read:()=>p?null:(p=!0,f)}}e.toReadable=g;function d(f,p,I){const l=k(I);return _(f,{onData:M=>l.write(p.data(M)),onError:M=>l.error(p.error?p.error(M):M),onEnd:()=>l.end()}),l}e.transform=d;function D(f,p,I){let l=!1;return{read:()=>{const M=p.read();return l?M:(l=!0,M!==null?I([f,M]):f)}}}e.prefixedReadable=D;function v(f,p,I){let l=!1;const M=k(I);return _(p,{onData:o=>l?M.write(o):(l=!0,M.write(I([f,o]))),onError:o=>M.error(o),onEnd:()=>{l||(l=!0,M.write(f)),M.end()}}),M}e.prefixedStream=v}),define(Ee[22],ye([0,1,102]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let w,T;class k{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return t?new k(Buffer.allocUnsafe(i)):new k(new Uint8Array(i))}static wrap(i){return t&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new k(i)}static fromString(i,h){return!(h?.dontUseNodeBuffer||!1)&&t?new k(Buffer.from(i)):(w||(w=new TextEncoder),new k(w.encode(i)))}static fromByteArray(i){const h=k.alloc(i.length);for(let u=0,s=i.length;u<s;u++)h.buffer[u]=i[u];return h}static concat(i,h){if(typeof h=="undefined"){h=0;for(let b=0,y=i.length;b<y;b++)h+=i[b].byteLength}const u=k.alloc(h);let s=0;for(let b=0,y=i.length;b<y;b++){const c=i[b];u.set(c,s),s+=c.byteLength}return u}clone(){const i=k.alloc(this.byteLength);return i.set(this),i}toString(){return t?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(i,h){return new k(this.buffer.subarray(i,h))}set(i,h){if(i instanceof k)this.buffer.set(i.buffer,h);else if(i instanceof Uint8Array)this.buffer.set(i,h);else if(i instanceof ArrayBuffer)this.buffer.set(new Uint8Array(i),h);else if(ArrayBuffer.isView(i))this.buffer.set(new Uint8Array(i.buffer,i.byteOffset,i.byteLength),h);else throw new Error("Unkown argument 'array'")}readUInt32BE(i){return R(this.buffer,i)}writeUInt32BE(i,h){F(this.buffer,i,h)}readUInt32LE(i){return _(this.buffer,i)}writeUInt32LE(i,h){n(this.buffer,i,h)}readUInt8(i){return m(this.buffer,i)}writeUInt8(i,h){r(this.buffer,i,h)}}e.VSBuffer=k;function P(o,i){return o[i+0]<<0>>>0|o[i+1]<<8>>>0}e.readUInt16LE=P;function C(o,i,h){o[h+0]=i&255,i=i>>>8,o[h+1]=i&255}e.writeUInt16LE=C;function R(o,i){return o[i]*2**24+o[i+1]*2**16+o[i+2]*2**8+o[i+3]}e.readUInt32BE=R;function F(o,i,h){o[h+3]=i,i=i>>>8,o[h+2]=i,i=i>>>8,o[h+1]=i,i=i>>>8,o[h]=i}e.writeUInt32BE=F;function _(o,i){return o[i+0]<<0>>>0|o[i+1]<<8>>>0|o[i+2]<<16>>>0|o[i+3]<<24>>>0}e.readUInt32LE=_;function n(o,i,h){o[h+0]=i&255,i=i>>>8,o[h+1]=i&255,i=i>>>8,o[h+2]=i&255,i=i>>>8,o[h+3]=i&255}e.writeUInt32LE=n;function m(o,i){return o[i]}e.readUInt8=m;function r(o,i,h){o[h]=i}e.writeUInt8=r;function g(o){return a.consumeReadable(o,i=>k.concat(i))}e.readableToBuffer=g;function d(o){return a.toReadable(o)}e.bufferToReadable=d;function D(o){return a.consumeStream(o,i=>k.concat(i))}e.streamToBuffer=D;async function v(o){return o.ended?k.concat(o.buffer):k.concat([...o.buffer,await D(o.stream)])}e.bufferedStreamToBuffer=v;function f(o){return a.toStream(o,i=>k.concat(i))}e.bufferToStream=f;function p(o){return a.transform(o,{data:i=>typeof i=="string"?k.fromString(i):k.wrap(i)},i=>k.concat(i))}e.streamToBufferReadableStream=p;function I(o){return a.newWriteableStream(i=>k.concat(i),o)}e.newWriteableBufferStream=I;function l(o,i){return a.prefixedReadable(o,i,h=>k.concat(h))}e.prefixedBufferReadable=l;function M(o,i){return a.prefixedStream(o,i,h=>k.concat(h))}e.prefixedBufferStream=M});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(ne,a):w?w.value=a:e.set(ne,a),a},Re=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Ee[21],ye([0,1,16,9]),function(ne,e,a,t){"use strict";var w,T,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(o,i,h){let u=o.get(i);return u===void 0&&(u=h,o.set(i,u)),u}e.getOrSet=P;function C(o){const i=[];return o.forEach((h,u)=>{i.push(`${u} => ${h}`)}),`Map(${o.size}) {${i.join(", ")}}`}e.mapToString=C;function R(o){const i=[];return o.forEach(h=>{i.push(h)}),`Set(${o.size}) {${i.join(", ")}}`}e.setToString=R;class F{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const h=i.charCodeAt(0),u=this._value.charCodeAt(this._pos);return h-u}value(){return this._value[this._pos]}}e.StringIterator=F;class _{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class n{constructor(i=!0,h=!0){this._splitOnBackslash=i,this._caseSensitive=h}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let h=i.length-1;h>=0;h--,this._valueLen--){const u=this._value.charCodeAt(h);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const h=this._value.charCodeAt(this._to);if(h===47||this._splitOnBackslash&&h===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=n;var m;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(m||(m={}));class r{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=r;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(d||(d={}));class D{constructor(i){this._iter=i}static forUris(i=()=>!1){return new D(new r(i))}static forPaths(){return new D(new n)}static forStrings(){return new D(new F)}static forConfigKeys(){return new D(new _)}clear(){this._root=void 0}fill(i,h){if(h){const u=h.slice(0);(0,a.shuffle)(u);for(let s of u)this.set(s,i)}else{const u=i.slice(0);(0,a.shuffle)(u);for(let s of u)this.set(s[0],s[1])}}set(i,h){const u=this._iter.reset(i);let s;this._root||(this._root=new g,this._root.segment=u.value());const b=[];for(s=this._root;;){const c=u.cmp(s.segment);if(c>0)s.left||(s.left=new g,s.left.segment=u.value()),b.push([-1,s]),s=s.left;else if(c<0)s.right||(s.right=new g,s.right.segment=u.value()),b.push([1,s]),s=s.right;else if(u.hasNext())u.next(),s.mid||(s.mid=new g,s.mid.segment=u.value()),b.push([0,s]),s=s.mid;else break}const y=s.value;s.value=h,s.key=i;for(let c=b.length-1;c>=0;c--){const S=b[c][1];S.updateHeight();const A=S.balanceFactor();if(A<-1||A>1){const U=b[c][0],H=b[c+1][0];if(U===1&&H===1)b[c][1]=S.rotateLeft();else if(U===-1&&H===-1)b[c][1]=S.rotateRight();else if(U===1&&H===-1)S.right=b[c+1][1]=b[c+1][1].rotateRight(),b[c][1]=S.rotateLeft();else if(U===-1&&H===1)S.left=b[c+1][1]=b[c+1][1].rotateLeft(),b[c][1]=S.rotateRight();else throw new Error;if(c>0)switch(b[c-1][0]){case-1:b[c-1][1].left=b[c][1];break;case 1:b[c-1][1].right=b[c][1];break;case 0:b[c-1][1].mid=b[c][1];break}else this._root=b[0][1]}}return y}get(i){return this._getNode(i)?.value}_getNode(i){const h=this._iter.reset(i);let u=this._root;for(;u;){const s=h.cmp(u.segment);if(s>0)u=u.left;else if(s<0)u=u.right;else if(h.hasNext())h.next(),u=u.mid;else break}return u}has(i){const h=this._getNode(i);return!(h?.value===void 0&&h?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,h){const u=this._iter.reset(i),s=[];let b=this._root;for(;b;){const y=u.cmp(b.segment);if(y>0)s.push([-1,b]),b=b.left;else if(y<0)s.push([1,b]),b=b.right;else if(u.hasNext())u.next(),s.push([0,b]),b=b.mid;else break}if(!!b){if(h?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const y=this._min(b.right),{key:c,value:S,segment:A}=y;this._delete(y.key,!1),b.key=c,b.value=S,b.segment=A}else{const y=b.left??b.right;if(s.length>0){const[c,S]=s[s.length-1];switch(c){case-1:S.left=y;break;case 0:S.mid=y;break;case 1:S.right=y;break}}else this._root=y}for(let y=s.length-1;y>=0;y--){const c=s[y][1];c.updateHeight();const S=c.balanceFactor();if(S>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),s[y][1]=c.rotateLeft()):S<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),s[y][1]=c.rotateRight()),y>0)switch(s[y-1][0]){case-1:s[y-1][1].left=s[y][1];break;case 1:s[y-1][1].right=s[y][1];break;case 0:s[y-1][1].mid=s[y][1];break}else this._root=s[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const h=this._iter.reset(i);let u=this._root,s;for(;u;){const b=h.cmp(u.segment);if(b>0)u=u.left;else if(b<0)u=u.right;else if(h.hasNext())h.next(),s=u.value||s,u=u.mid;else break}return u&&u.value||s}findSuperstr(i){const h=this._iter.reset(i);let u=this._root;for(;u;){const s=h.cmp(u.segment);if(s>0)u=u.left;else if(s<0)u=u.right;else if(h.hasNext())h.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(i){for(const[h,u]of this)i(u,h)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=h=>{if(!h)return!0;const u=h.balanceFactor();return u<-1||u>1?!1:i(h.left)&&i(h.right)};return i(this._root)}}e.TernarySearchTree=D;class v{constructor(i,h){this.uri=i,this.value=h}}class f{constructor(i,h){this[w]="ResourceMap",i instanceof f?(this.map=new Map(i.map),this.toKey=h??f.defaultToKey):(this.map=new Map,this.toKey=i??f.defaultToKey)}set(i,h){return this.map.set(this.toKey(i),new v(i,h)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,h){typeof h!="undefined"&&(i=i.bind(h));for(let[u,s]of this.map)i(s.value,s.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=f,f.defaultToKey=o=>o.toString();var p;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class I{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,h=0){const u=this._map.get(i);if(!!u)return h!==0&&this.touch(u,h),u.value}set(i,h,u=0){let s=this._map.get(i);if(s)s.value=h,u!==0&&this.touch(s,u);else{switch(s={key:i,value:h,next:void 0,previous:void 0},u){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(i,s),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const h=this._map.get(i);if(!!h)return this._map.delete(i),this.removeItem(h),this._size--,h.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,h){const u=this._state;let s=this._head;for(;s;){if(h?i.bind(h)(s.value,s.key,this):i(s.value,s.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const i=this,h=this._state;let u=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:u.key,done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return s}values(){const i=this,h=this._state;let u=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:u.value,done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return s}entries(){const i=this,h=this._state;let u=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:[u.key,u.value],done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return s}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let h=this._head,u=this.size;for(;h&&u>i;)this._map.delete(h.key),h=h.next,u--;this._head=h,this._size=u,h&&(h.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const h=i.next,u=i.previous;if(!h||!u)throw new Error("Invalid list");h.previous=u,u.next=h}i.next=void 0,i.previous=void 0,this._state++}touch(i,h){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(i===this._head)return;const u=i.next,s=i.previous;i===this._tail?(s.next=void 0,this._tail=s):(u.previous=s,s.next=u),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(h===2){if(i===this._tail)return;const u=i.next,s=i.previous;i===this._head?(u.previous=void 0,this._head=u):(u.previous=s,s.next=u),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((h,u)=>{i.push([u,h])}),i}fromJSON(i){this.clear();for(const[h,u]of i)this.set(h,u)}}e.LinkedMap=I;class l extends I{constructor(i,h=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,h),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,h=2){return super.get(i,h)}peek(i){return super.get(i,0)}set(i,h){return super.set(i,h,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class M{constructor(i){k.set(this,void 0),Ze(this,k,i,"f")}get size(){return Re(this,k,"f").size}forEach(i,h){Re(this,k,"f").forEach(i,h)}get(i){return Re(this,k,"f").get(i)}has(i){return Re(this,k,"f").has(i)}entries(){return Re(this,k,"f").entries()}keys(){return Re(this,k,"f").keys()}values(){return Re(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Re(this,k,"f").entries()}}e.ReadonlyMapView=M}),define(Ee[103],ye([0,1,21,9]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function w(...q){return function(ee,fe){for(let Ae=0,xe=q.length;Ae<xe;Ae++){const ze=q[Ae](ee,fe);if(ze)return ze}return null}}e.or=w,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(q,ee,fe){if(!fe||fe.length<ee.length)return null;let Ae;return q?Ae=t.startsWithIgnoreCase(fe,ee):Ae=fe.indexOf(ee)===0,Ae?ee.length>0?[{start:0,end:ee.length}]:[]:null}function k(q,ee){const fe=ee.toLowerCase().indexOf(q.toLowerCase());return fe===-1?null:[{start:fe,end:fe+q.length}]}e.matchesContiguousSubString=k;function P(q,ee){return C(q.toLowerCase(),ee.toLowerCase(),0,0)}e.matchesSubString=P;function C(q,ee,fe,Ae){if(fe===q.length)return[];if(Ae===ee.length)return null;if(q[fe]===ee[Ae]){let xe=null;return(xe=C(q,ee,fe+1,Ae+1))?D({start:Ae,end:Ae+1},xe):null}return C(q,ee,fe,Ae+1)}function R(q){return 97<=q&&q<=122}function F(q){return 65<=q&&q<=90}e.isUpper=F;function _(q){return 48<=q&&q<=57}function n(q){return q===32||q===9||q===10||q===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(q=>m.add(q.charCodeAt(0)));function r(q){return n(q)||m.has(q)}function g(q,ee){return q===ee||r(q)&&r(ee)}function d(q){return R(q)||F(q)||_(q)}function D(q,ee){return ee.length===0?ee=[q]:q.end===ee[0].start?ee[0].start=q.start:ee.unshift(q),ee}function v(q,ee){for(let fe=ee;fe<q.length;fe++){const Ae=q.charCodeAt(fe);if(F(Ae)||_(Ae)||fe>0&&!d(q.charCodeAt(fe-1)))return fe}return q.length}function f(q,ee,fe,Ae){if(fe===q.length)return[];if(Ae===ee.length)return null;if(q[fe]!==ee[Ae].toLowerCase())return null;{let xe=null,ze=Ae+1;for(xe=f(q,ee,fe+1,Ae+1);!xe&&(ze=v(ee,ze))<ee.length;)xe=f(q,ee,fe+1,ze),ze++;return xe===null?null:D({start:Ae,end:Ae+1},xe)}}function p(q){let ee=0,fe=0,Ae=0,xe=0,ze=0;for(let nt=0;nt<q.length;nt++)ze=q.charCodeAt(nt),F(ze)&&ee++,R(ze)&&fe++,d(ze)&&Ae++,_(ze)&&xe++;const Xe=ee/q.length,et=fe/q.length,st=Ae/q.length,Je=xe/q.length;return{upperPercent:Xe,lowerPercent:et,alphaPercent:st,numericPercent:Je}}function I(q){const{upperPercent:ee,lowerPercent:fe}=q;return fe===0&&ee>.6}function l(q){const{upperPercent:ee,lowerPercent:fe,alphaPercent:Ae,numericPercent:xe}=q;return fe>.2&&ee<.8&&Ae>.6&&xe<.2}function M(q){let ee=0,fe=0,Ae=0,xe=0;for(let ze=0;ze<q.length;ze++)Ae=q.charCodeAt(ze),F(Ae)&&ee++,R(Ae)&&fe++,n(Ae)&&xe++;return(ee===0||fe===0)&&xe===0?q.length<=30:ee<=5}function o(q,ee){if(!ee||(ee=ee.trim(),ee.length===0)||!M(q)||ee.length>60)return null;const fe=p(ee);if(!l(fe)){if(!I(fe))return null;ee=ee.toLowerCase()}let Ae=null,xe=0;for(q=q.toLowerCase();xe<ee.length&&(Ae=f(q,ee,0,xe))===null;)xe=v(ee,xe+1);return Ae}e.matchesCamelCase=o;function i(q,ee,fe=!1){if(!ee||ee.length===0)return null;let Ae=null,xe=0;for(q=q.toLowerCase(),ee=ee.toLowerCase();xe<ee.length&&(Ae=h(q,ee,0,xe,fe))===null;)xe=u(ee,xe+1);return Ae}e.matchesWords=i;function h(q,ee,fe,Ae,xe){if(fe===q.length)return[];if(Ae===ee.length)return null;if(g(q.charCodeAt(fe),ee.charCodeAt(Ae))){let ze=null,Xe=Ae+1;if(ze=h(q,ee,fe+1,Ae+1,xe),!xe)for(;!ze&&(Xe=u(ee,Xe))<ee.length;)ze=h(q,ee,fe+1,Xe,xe),Xe++;return ze===null?null:D({start:Ae,end:Ae+1},ze)}else return null}function u(q,ee){for(let fe=ee;fe<q.length;fe++)if(r(q.charCodeAt(fe))||fe>0&&r(q.charCodeAt(fe-1)))return fe;return q.length}const s=w(e.matchesPrefix,o,k),b=w(e.matchesPrefix,o,P),y=new a.LRUCache(1e4);function c(q,ee,fe=!1){if(typeof q!="string"||typeof ee!="string")return null;let Ae=y.get(q);Ae||(Ae=new RegExp(t.convertSimple2RegExpPattern(q),"i"),y.set(q,Ae));const xe=Ae.exec(ee);return xe?[{start:xe.index,end:xe.index+xe[0].length}]:fe?b(q,ee):s(q,ee)}e.matchesFuzzy=c;function S(q,ee){const fe=$e(q,q.toLowerCase(),0,ee,ee.toLowerCase(),0,!0);return fe?U(fe):null}e.matchesFuzzy2=S;function A(q,ee,fe,Ae,xe,ze){const Xe=Math.min(13,q.length);for(;fe<Xe;fe++){const et=$e(q,ee,fe,Ae,xe,ze,!1);if(et)return et}return[0,ze]}e.anyScore=A;function U(q){if(typeof q=="undefined")return[];const ee=[],fe=q[1];for(let Ae=q.length-1;Ae>1;Ae--){const xe=q[Ae]+fe,ze=ee[ee.length-1];ze&&ze.end===xe?ze.end=xe+1:ee.push({start:xe,end:xe+1})}return ee}e.createMatches=U;const H=128;function E(){const q=[],ee=[];for(let fe=0;fe<=H;fe++)ee[fe]=0;for(let fe=0;fe<=H;fe++)q.push(ee.slice(0));return q}function L(q){const ee=[];for(let fe=0;fe<=q;fe++)ee[fe]=0;return ee}const z=L(2*H),N=L(2*H),$=E(),j=E(),ue=E(),K=!1;function ie(q,ee,fe,Ae,xe){function ze(et,st,Je=" "){for(;et.length<st;)et=Je+et;return et}let Xe=` |   |${Ae.split("").map(et=>ze(et,3)).join("|")}
`;for(let et=0;et<=fe;et++)et===0?Xe+=" |":Xe+=`${ee[et-1]}|`,Xe+=q[et].slice(0,xe+1).map(st=>ze(st.toString(),3)).join("|")+`
`;return Xe}function pe(q,ee,fe,Ae){q=q.substr(ee),fe=fe.substr(Ae),console.log(ie(j,q,q.length,fe,fe.length)),console.log(ie(ue,q,q.length,fe,fe.length)),console.log(ie($,q,q.length,fe,fe.length))}function we(q,ee){if(ee<0||ee>=q.length)return!1;const fe=q.codePointAt(ee);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(fe)}}function ae(q,ee){if(ee<0||ee>=q.length)return!1;switch(q.charCodeAt(ee)){case 32:case 9:return!0;default:return!1}}function le(q,ee,fe){return ee[q]!==fe[q]}function Se(q,ee,fe,Ae,xe,ze,Xe=!1){for(;ee<fe&&xe<ze;)q[ee]===Ae[xe]&&(Xe&&(z[ee]=xe),ee+=1),xe+=1;return ee===fe}e.isPatternInWord=Se;var Ce;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var Fe;(function(q){q.Default=[-100,0];function ee(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}q.isDefault=ee})(Fe=e.FuzzyScore||(e.FuzzyScore={}));function $e(q,ee,fe,Ae,xe,ze,Xe){const et=q.length>H?H:q.length,st=Ae.length>H?H:Ae.length;if(fe>=et||ze>=st||et-fe>st-ze||!Se(ee,fe,et,xe,ze,st,!0))return;Ve(et,st,fe,ze,ee,xe);let Je=1,nt=1,lt=fe,pt=ze;const Ft=[!1];for(Je=1,lt=fe;lt<et;Je++,lt++){const de=z[lt],Ne=N[lt],qe=lt+1<et?N[lt+1]:st;for(nt=de-ze+1,pt=de;pt<qe;nt++,pt++){let ot=Number.MIN_SAFE_INTEGER,Ye=!1;pt<=Ne&&(ot=je(q,ee,lt,fe,Ae,xe,pt,st,ze,$[Je-1][nt-1]===0,Ft));let yt=0;ot!==Number.MAX_SAFE_INTEGER&&(Ye=!0,yt=ot+j[Je-1][nt-1]);const Te=pt>de,De=Te?j[Je][nt-1]+($[Je][nt-1]>0?-5:0):0,ve=pt>de+1&&$[Je][nt-1]>0,re=ve?j[Je][nt-2]+($[Je][nt-2]>0?-5:0):0;if(ve&&(!Te||re>=De)&&(!Ye||re>=yt))j[Je][nt]=re,ue[Je][nt]=3,$[Je][nt]=0;else if(Te&&(!Ye||De>=yt))j[Je][nt]=De,ue[Je][nt]=2,$[Je][nt]=0;else if(Ye)j[Je][nt]=yt,ue[Je][nt]=1,$[Je][nt]=$[Je-1][nt-1]+1;else throw new Error("not possible")}}if(K&&pe(q,fe,Ae,ze),!Ft[0]&&!Xe)return;Je--,nt--;const Oe=[j[Je][nt],ze];let Mt=0,V=0;for(;Je>=1;){let de=nt;do{const Ne=ue[Je][de];if(Ne===3)de=de-2;else if(Ne===2)de=de-1;else break}while(de>=1);Mt>1&&ee[fe+Je-1]===xe[ze+nt-1]&&!le(de+ze-1,Ae,xe)&&Mt+1>$[Je][de]&&(de=nt),de===nt?Mt++:Mt=1,V||(V=de),Je--,nt=de-1,Oe.push(nt)}st===et&&(Oe[0]+=2);const Q=V-et;return Oe[0]-=Q,Oe}e.fuzzyScore=$e;function Ve(q,ee,fe,Ae,xe,ze){let Xe=q-1,et=ee-1;for(;Xe>=fe&&et>=Ae;)xe[Xe]===ze[et]&&(N[Xe]=et,Xe--),et--}function je(q,ee,fe,Ae,xe,ze,Xe,et,st,Je,nt){if(ee[fe]!==ze[Xe])return Number.MIN_SAFE_INTEGER;let lt=1,pt=!1;return Xe===fe-Ae?lt=q[fe]===xe[Xe]?7:5:le(Xe,xe,ze)&&(Xe===0||!le(Xe-1,xe,ze))?(lt=q[fe]===xe[Xe]?7:5,pt=!0):we(ze,Xe)&&(Xe===0||!we(ze,Xe-1))?lt=5:(we(ze,Xe-1)||ae(ze,Xe-1))&&(lt=5,pt=!0),lt>1&&fe===Ae&&(nt[0]=!0),pt||(pt=le(Xe,xe,ze)||we(ze,Xe-1)||ae(ze,Xe-1)),fe===Ae?Xe>st&&(lt-=pt?3:5):Je?lt+=pt?2:0:lt+=pt?0:1,Xe+1===et&&(lt-=pt?3:5),lt}function B(q,ee,fe,Ae,xe,ze,Xe){return X(q,ee,fe,Ae,xe,ze,!0,Xe)}e.fuzzyScoreGracefulAggressive=B;function G(q,ee,fe,Ae,xe,ze,Xe){return X(q,ee,fe,Ae,xe,ze,!1,Xe)}e.fuzzyScoreGraceful=G;function X(q,ee,fe,Ae,xe,ze,Xe,et){let st=$e(q,ee,fe,Ae,xe,ze,et);if(st&&!Xe)return st;if(q.length>=3){const Je=Math.min(7,q.length-1);for(let nt=fe+1;nt<Je;nt++){const lt=se(q,nt);if(lt){const pt=$e(lt,lt.toLowerCase(),fe,Ae,xe,ze,et);pt&&(pt[0]-=3,(!st||pt[0]>st[0])&&(st=pt))}}}return st}function se(q,ee){if(ee+1>=q.length)return;const fe=q[ee],Ae=q[ee+1];if(fe!==Ae)return q.slice(0,ee)+Ae+fe+q.slice(ee+2)}}),define(Ee[104],ye([0,1,51,103,9]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(a.CSSIcon.iconNameCharacter),P=new RegExp(`(\\\\)?${T.source}`,"g");function C(d){return d.replace(P,(D,v)=>v?D:`\\${D}`)}e.escapeIcons=C;const R=new RegExp(`\\\\${T.source}`,"g");function F(d){return d.replace(R,D=>`\\${D}`)}e.markdownEscapeEscapedIcons=F;const _=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function n(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(_,(D,v,f,p)=>f?D:v||p||"")}e.stripIcons=n;function m(d){const D=d.indexOf(e.iconStartMarker);return D===-1?{text:d}:r(d,D)}e.parseLabelWithIcons=m;function r(d,D){const v=[];let f="";function p(s){if(s){f+=s;for(const b of s)v.push(M)}}let I=-1,l="",M=0,o,i,h=D;const u=d.length;for(p(d.substr(0,D));h<u;)o=d[h],i=d[h+1],o===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(I=h,p(l),l=e.iconStartMarker,h++):o===")"&&I!==-1?(M+=h-I+1,I=-1,l=""):I!==-1?k.test(o)?l+=o:(p(l),I=-1,l=""):p(o),h++;return p(l),{text:f,iconOffsets:v}}function g(d,D,v=!1){const{text:f,iconOffsets:p}=D;if(!p||p.length===0)return(0,t.matchesFuzzy)(d,f,v);const I=(0,w.ltrim)(f," "),l=f.length-I.length,M=(0,t.matchesFuzzy)(d,I,v);if(M)for(const o of M){const i=p[o.start+l]+l;o.start+=i,o.end+=i}return M}e.matchesFuzzyIconAware=g}),define(Ee[76],ye([0,1,15,104]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var w;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(w=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class T{constructor(m="",r=!1){if(this.value=m,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(m,r=0){return this.value+=R(this.supportThemeIcons?(0,t.escapeIcons)(m):m).replace(/([ \t]+)/g,(g,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,r){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=r,this.value+="\n```\n",this}}e.MarkdownString=T;function k(n){return P(n)?!n.value:Array.isArray(n)?n.every(k):!0}e.isEmptyMarkdownString=k;function P(n){return n instanceof T?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=P;function C(n,m){return n===m?!0:!n||!m?!1:n.value===m.value&&n.isTrusted===m.isTrusted&&n.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=C;function R(n){return n.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=R;function F(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=F;function _(n){const m=[],r=n.split("|").map(d=>d.trim());n=r[0];const g=r[1];if(g){const d=/height=(\d+)/.exec(g),D=/width=(\d+)/.exec(g),v=d?d[1]:"",f=D?D[1]:"",p=isFinite(parseInt(f)),I=isFinite(parseInt(v));p&&m.push(`width="${f}"`),I&&m.push(`height="${v}"`)}return{href:n,dimensions:m}}e.parseHrefAndDimensions=_}),define(Ee[34],ye([0,1,9]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(t||(t={})),function(w){const T="error",k="warning",P="warn",C="info",R="ignore";function F(n){return n?a.equalsIgnoreCase(T,n)?w.Error:a.equalsIgnoreCase(k,n)||a.equalsIgnoreCase(P,n)?w.Warning:a.equalsIgnoreCase(C,n)?w.Info:w.Ignore:w.Ignore}w.fromValue=F;function _(n){switch(n){case w.Error:return T;case w.Warning:return k;case w.Info:return C;default:return R}}w.toString=_}(t||(t={})),e.default=t}),define(Ee[42],ye([0,1,17,23,9,11]),function(ne,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(h){return h===47||h===92}e.isPathSeparator=k;function P(h){return h.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=P;function C(h){return h.indexOf("/")===-1&&(h=P(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.toPosixPath=C;function R(h,u=a.posix.sep){if(!h)return"";const s=h.length,b=h.charCodeAt(0);if(k(b)){if(k(h.charCodeAt(1))&&!k(h.charCodeAt(2))){let c=3;const S=c;for(;c<s&&!k(h.charCodeAt(c));c++);if(S!==c&&!k(h.charCodeAt(c+1))){for(c+=1;c<s;c++)if(k(h.charCodeAt(c)))return h.slice(0,c+1).replace(/[\\/]/g,u)}}return u}else if(D(b)&&h.charCodeAt(1)===58)return k(h.charCodeAt(2))?h.slice(0,2)+u:h.slice(0,2);let y=h.indexOf("://");if(y!==-1){for(y+=3;y<s;y++)if(k(h.charCodeAt(y)))return h.slice(0,y+1)}return""}e.getRoot=R;function F(h){if(!t.isWindows||!h||h.length<5)return!1;let u=h.charCodeAt(0);if(u!==92||(u=h.charCodeAt(1),u!==92))return!1;let s=2;const b=s;for(;s<h.length&&(u=h.charCodeAt(s),u!==92);s++);return!(b===s||(u=h.charCodeAt(s+1),isNaN(u)||u===92))}e.isUNC=F;const _=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(h,u=t.isWindows){const s=u?_:n;return!(!h||h.length===0||/^\s+$/.test(h)||(s.lastIndex=0,s.test(h))||u&&m.test(h)||h==="."||h===".."||u&&h[h.length-1]==="."||u&&h.length!==h.trim().length||h.length>255)}e.isValidBasename=r;function g(h,u,s){const b=h===u;return!s||b?b:!h||!u?!1:(0,w.equalsIgnoreCase)(h,u)}e.isEqual=g;function d(h,u,s,b=a.sep){if(h===u)return!0;if(!h||!u||u.length>h.length)return!1;if(s){if(!(0,w.startsWithIgnoreCase)(h,u))return!1;if(u.length===h.length)return!0;let c=u.length;return u.charAt(u.length-1)===b&&c--,h.charAt(c)===b}return u.charAt(u.length-1)!==b&&(u+=b),h.indexOf(u)===0}e.isEqualOrParent=d;function D(h){return h>=65&&h<=90||h>=97&&h<=122}e.isWindowsDriveLetter=D;function v(h,u){return t.isWindows&&h.endsWith(":")&&(h+=a.sep),(0,a.isAbsolute)(h)||(h=(0,a.join)(u,h)),h=(0,a.normalize)(h),t.isWindows?(h=(0,w.rtrim)(h,a.sep),h.endsWith(":")&&(h+=a.sep)):(h=(0,w.rtrim)(h,a.sep),h||(h=a.sep)),h}e.sanitizeFilePath=v;function f(h){const u=(0,a.normalize)(h);return t.isWindows?h.length>3?!1:p(u)&&(h.length===2||u.charCodeAt(2)===92):u===a.posix.sep}e.isRootOrDriveLetter=f;function p(h,u){return(u!==void 0?u:t.isWindows)?D(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function I(h){return p(h)?h[0]:void 0}e.getDriveLetter=I;function l(h,u,s){return u.length>h.length?-1:h===u?0:(s&&(h=h.toLowerCase(),u=u.toLowerCase()),h.indexOf(u))}e.indexOfPath=l;function M(h){const u=h.split(":");let s,b,y;if(u.forEach(c=>{const S=Number(c);(0,T.isNumber)(S)?b===void 0?b=S:y===void 0&&(y=S):s=s?[s,c].join(":"):c}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:b!==void 0?b:void 0,column:y!==void 0?y:b!==void 0?1:void 0}}e.parseLineAndColumnAware=M;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(h,u,s=8){let b="";for(let c=0;c<s;c++)b+=o.charAt(Math.floor(Math.random()*o.length));let y;return u?y=`${u}-${b}`:y=b,h?(0,a.join)(h,y):y}e.randomPath=i}),define(Ee[54],ye([0,1,22,9,2]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(F){return JSON.stringify(F,C)}e.stringify=T;function k(F){let _=JSON.parse(F);return _=R(_),_}e.parse=k;var P;(function(F){F[F.Uri=1]="Uri",F[F.Regexp=2]="Regexp",F[F.ScmResource=3]="ScmResource",F[F.ScmResourceGroup=4]="ScmResourceGroup",F[F.ScmProvider=5]="ScmProvider",F[F.CommentController=6]="CommentController",F[F.CommentThread=7]="CommentThread",F[F.CommentThreadReply=8]="CommentThreadReply",F[F.CommentNode=9]="CommentNode",F[F.CommentThreadNode=10]="CommentThreadNode",F[F.TimelineActionContext=11]="TimelineActionContext",F[F.NotebookCellActionContext=12]="NotebookCellActionContext",F[F.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function C(F,_){return _ instanceof RegExp?{$mid:2,source:_.source,flags:(0,t.regExpFlags)(_)}:_}function R(F,_=0){if(!F||_>200)return F;if(typeof F=="object"){switch(F.$mid){case 1:return w.URI.revive(F);case 2:return new RegExp(F.source,F.flags)}if(F instanceof a.VSBuffer||F instanceof Uint8Array)return F;if(Array.isArray(F))for(let n=0;n<F.length;++n)F[n]=R(F[n],_+1);else for(const n in F)Object.hasOwnProperty.call(F,n)&&(F[n]=R(F[n],_+1))}return F}e.revive=R}),define(Ee[10],ye([0,1,23,2]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var w;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(w=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,R,F){this._hosts[C]=R,this._ports[C]=F}setConnectionToken(C,R){this._connectionTokens[C]=R}rewrite(C){if(this._delegate)return this._delegate(C);const R=C.authority;let F=this._hosts[R];F&&F.indexOf(":")!==-1&&(F=`[${F}]`);const _=this._ports[R],n=this._connectionTokens[R];let m=`path=${encodeURIComponent(C.path)}`;return typeof n=="string"&&(m+=`&tkn=${encodeURIComponent(n)}`),t.URI.from({scheme:a.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${F}:${_}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new T;class k{asBrowserUri(C,R){const F=this.toUri(C,R);return F.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(F):F.scheme===w.file&&(a.isNative||typeof a.globals.importScripts=="function"&&a.globals.origin===`${w.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?F.with({scheme:w.vscodeFileResource,authority:F.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):F}asFileUri(C,R){const F=this.toUri(C,R);return F.scheme===w.vscodeFileResource?F.with({scheme:w.file,authority:F.authority!==k.FALLBACK_AUTHORITY?F.authority:null,query:null,fragment:null}):F}toUri(C,R){return t.URI.isUri(C)?C:t.URI.parse(R.toUrl(C))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(Ee[24],ye([0,1,42,10,17,23,9,2]),function(ne,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(m){return(0,P.uriToFsPath)(m,!0)}e.originalFSPath=C;class R{constructor(r){this._ignorePathCasing=r}compare(r,g,d=!1){return r===g?0:(0,k.compare)(this.getComparisonKey(r,d),this.getComparisonKey(g,d))}isEqual(r,g,d=!1){return r===g?!0:!r||!g?!1:this.getComparisonKey(r,d)===this.getComparisonKey(g,d)}getComparisonKey(r,g=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,g,d=!1){if(r.scheme===g.scheme){if(r.scheme===t.Schemas.file)return a.isEqualOrParent(C(r),C(g),this._ignorePathCasing(r))&&r.query===g.query&&(d||r.fragment===g.fragment);if((0,e.isEqualAuthority)(r.authority,g.authority))return a.isEqualOrParent(r.path,g.path,this._ignorePathCasing(r),"/")&&r.query===g.query&&(d||r.fragment===g.fragment)}return!1}joinPath(r,...g){return P.URI.joinPath(r,...g)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return w.posix.basename(r.path)}extname(r){return w.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let g;return r.scheme===t.Schemas.file?g=P.URI.file(w.dirname(C(r))).path:(g=w.posix.dirname(r.path),r.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),g="/")),r.with({path:g})}normalizePath(r){if(!r.path.length)return r;let g;return r.scheme===t.Schemas.file?g=P.URI.file(w.normalize(C(r))).path:g=w.posix.normalize(r.path),r.with({path:g})}relativePath(r,g){if(r.scheme!==g.scheme||!(0,e.isEqualAuthority)(r.authority,g.authority))return;if(r.scheme===t.Schemas.file){const v=w.relative(C(r),C(g));return T.isWindows?a.toSlashes(v):v}let d=r.path||"/",D=g.path||"/";if(this._ignorePathCasing(r)){let v=0;for(const f=Math.min(d.length,D.length);v<f&&!(d.charCodeAt(v)!==D.charCodeAt(v)&&d.charAt(v).toLowerCase()!==D.charAt(v).toLowerCase());v++);d=D.substr(0,v)+d.substr(v)}return w.posix.relative(d,D)}resolvePath(r,g){if(r.scheme===t.Schemas.file){const d=P.URI.file(w.resolve(C(r),g));return r.with({authority:d.authority,path:d.path})}return g=a.toPosixPath(g),r.with({path:w.posix.resolve(r.path,g)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,g){return r===g||r!==void 0&&g!==void 0&&(0,k.equalsIgnoreCase)(r,g)}hasTrailingPathSeparator(r,g=w.sep){if(r.scheme===t.Schemas.file){const d=C(r);return d.length>a.getRoot(d).length&&d[d.length-1]===g}else{const d=r.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,g=w.sep){return(0,e.hasTrailingPathSeparator)(r,g)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,g=w.sep){let d=!1;if(r.scheme===t.Schemas.file){const D=C(r);d=D!==void 0&&D.length===a.getRoot(D).length&&D[D.length-1]===g}else{g="/";const D=r.path;d=D.length===1&&D.charCodeAt(D.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(r,g)?r.with({path:r.path+"/"}):r}}e.ExtUri=R,e.extUri=new R(()=>!1),e.extUriBiasedIgnorePathCase=new R(m=>m.scheme===t.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new R(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function F(m,r){const g=[];for(let d=0;d<m.length;d++){const D=r(m[d]);m.some((v,f)=>f===d?!1:(0,e.isEqualOrParent)(D,r(v)))||g.push(m[d])}return g}e.distinctParents=F;var _;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function r(g){const d=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(f=>{const[p,I]=f.split(":");p&&I&&d.set(p,I)});const v=g.path.substring(0,g.path.indexOf(";"));return v&&d.set(m.META_DATA_MIME,v),d}m.parseMetaData=r})(_=e.DataUri||(e.DataUri={}));function n(m,r,g){if(r){let d=m.path;return d&&d[0]!==w.posix.sep&&(d=w.posix.sep+d),m.with({scheme:g,authority:r,path:d})}return m.with({scheme:g})}e.toLocalResource=n}),define(Ee[14],ye([0,1,20,15,4,6,24,23]),function(ne,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(ae){return!!ae&&typeof ae.then=="function"}e.isThenable=C;function R(ae){const le=new a.CancellationTokenSource,Se=ae(le.token),Ce=new Promise((Fe,$e)=>{const Ve=le.token.onCancellationRequested(()=>{Ve.dispose(),le.dispose(),$e((0,t.canceled)())});Promise.resolve(Se).then(je=>{Ve.dispose(),le.dispose(),Fe(je)},je=>{Ve.dispose(),le.dispose(),$e(je)})});return new class{cancel(){le.cancel()}then(Fe,$e){return Ce.then(Fe,$e)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Ce.finally(Fe)}}}e.createCancelablePromise=R;function F(ae,le,Se){return Promise.race([ae,new Promise(Ce=>le.onCancellationRequested(()=>Ce(Se)))])}e.raceCancellation=F;async function _(ae){let le=-1;const Se=ae.map((Fe,$e)=>Fe.then(Ve=>(le=$e,Ve))),Ce=await Promise.race(Se);return ae.forEach((Fe,$e)=>{$e!==le&&Fe.cancel()}),Ce}e.raceCancellablePromises=_;function n(ae,le,Se){let Ce;const Fe=setTimeout(()=>{Ce?.(void 0),Se?.()},le);return Promise.race([ae.finally(()=>clearTimeout(Fe)),new Promise($e=>Ce=$e)])}e.raceTimeout=n;function m(ae){return new Promise((le,Se)=>{const Ce=ae();C(Ce)?Ce.then(le,Se):le(Ce)})}e.asPromise=m;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(le){if(this.activePromise){if(this.queuedPromiseFactory=le,!this.queuedPromise){const Se=()=>{this.queuedPromise=null;const Ce=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Ce};this.queuedPromise=new Promise(Ce=>{this.activePromise.then(Se,Se).then(Ce)})}return new Promise((Se,Ce)=>{this.queuedPromise.then(Se,Ce)})}return this.activePromise=le(),new Promise((Se,Ce)=>{this.activePromise.then(Fe=>{this.activePromise=null,Se(Fe)},Fe=>{this.activePromise=null,Ce(Fe)})})}}e.Throttler=r;class g{constructor(){this.current=Promise.resolve(null)}queue(le){return this.current=this.current.then(()=>le(),()=>le())}}e.Sequencer=g;class d{constructor(){this.promiseMap=new Map}queue(le,Se){const Fe=(this.promiseMap.get(le)??Promise.resolve()).catch(()=>{}).then(Se).finally(()=>{this.promiseMap.get(le)===Fe&&this.promiseMap.delete(le)});return this.promiseMap.set(le,Fe),Fe}}e.SequencerByKey=d;const D=(ae,le)=>{let Se=!0;const Ce=setTimeout(()=>{Se=!1,le()},ae);return{isTriggered:()=>Se,dispose:()=>{clearTimeout(Ce),Se=!1}}},v=ae=>{let le=!0;return queueMicrotask(()=>{le&&(le=!1,ae())}),{isTriggered:()=>le,dispose:()=>{le=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(le){this.defaultDelay=le,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(le,Se=this.defaultDelay){this.task=le,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,$e)=>{this.doResolve=Fe,this.doReject=$e}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Ce=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=Se===e.MicrotaskDelay?v(Ce):D(Se,Ce),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,t.canceled)()),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class p{constructor(le){this.delayer=new f(le),this.throttler=new r}trigger(le,Se){return this.delayer.trigger(()=>this.throttler.queue(le),Se)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=p;class I{constructor(){this._isOpen=!1,this._promise=new Promise((le,Se)=>{this._completePromise=le})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=I;class l extends I{constructor(le){super();this._timeout=setTimeout(()=>this.open(),le)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function M(ae,le){return le?new Promise((Se,Ce)=>{const Fe=setTimeout(()=>{$e.dispose(),Se()},ae),$e=le.onCancellationRequested(()=>{clearTimeout(Fe),$e.dispose(),Ce((0,t.canceled)())})}):R(Se=>M(ae,Se))}e.timeout=M;function o(ae,le=0){const Se=setTimeout(ae,le);return(0,T.toDisposable)(()=>clearTimeout(Se))}e.disposableTimeout=o;function i(ae){const le=[];let Se=0;const Ce=ae.length;function Fe(){return Se<Ce?ae[Se++]():null}function $e(Ve){Ve!=null&&le.push(Ve);const je=Fe();return je?je.then($e):Promise.resolve(le)}return Promise.resolve(null).then($e)}e.sequence=i;function h(ae,le=Ce=>!!Ce,Se=null){let Ce=0;const Fe=ae.length,$e=()=>{if(Ce>=Fe)return Promise.resolve(Se);const Ve=ae[Ce++];return Promise.resolve(Ve()).then(B=>le(B)?Promise.resolve(B):$e())};return $e()}e.first=h;function u(ae,le=Ce=>!!Ce,Se=null){if(ae.length===0)return Promise.resolve(Se);let Ce=ae.length;const Fe=()=>{Ce=-1;for(const $e of ae)$e.cancel?.()};return new Promise(($e,Ve)=>{for(const je of ae)je.then(B=>{--Ce>=0&&le(B)?(Fe(),$e(B)):Ce===0&&$e(Se)}).catch(B=>{--Ce>=0&&(Fe(),Ve(B))})})}e.firstParallel=u;class s{constructor(le){this._size=0,this.maxDegreeOfParalellism=le,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new w.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(le){return this._size++,new Promise((Se,Ce)=>{this.outstandingPromises.push({factory:le,c:Se,e:Ce}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const le=this.outstandingPromises.shift();this.runningPromises++;const Se=le.factory();Se.then(le.c,le.e),Se.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class b extends s{constructor(){super(1)}}e.Queue=b;class y{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const le=new j;return this.drainers.add(le),le.p}isDrained(){for(const[,le]of this.queues)if(le.size>0)return!1;return!0}queueFor(le,Se=k.extUri){const Ce=Se.getComparisonKey(le);let Fe=this.queues.get(Ce);return Fe||(Fe=new b,w.Event.once(Fe.onFinished)(()=>{Fe?.dispose(),this.queues.delete(Ce),this.onDidQueueFinish()}),this.queues.set(Ce,Fe)),Fe}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const le of this.drainers)le.complete();this.drainers.clear()}dispose(){for(const[,le]of this.queues)le.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=y;class c{constructor(le,Se){this._token=-1,typeof le=="function"&&typeof Se=="number"&&this.setIfNotSet(le,Se)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(le,Se){this.cancel(),this._token=setTimeout(()=>{this._token=-1,le()},Se)}setIfNotSet(le,Se){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,le()},Se))}}e.TimeoutTimer=c;class S{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(le,Se){this.cancel(),this._token=setInterval(()=>{le()},Se)}}e.IntervalTimer=S;class A{constructor(le,Se){this.timeoutToken=-1,this.runner=le,this.timeout=Se,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(le=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,le)}get delay(){return this.timeout}set delay(le){this.timeout=le}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=A;class U{constructor(le,Se){Se%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Se}ms is not a multiple of 1000ms.`),this.runner=le,this.timeout=Se,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(le=this.timeout){le%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(le/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=U;class H extends A{constructor(le,Se){super(le,Se);this.units=[]}work(le){this.units.push(le),this.isScheduled()||this.schedule()}doRun(){const le=this.units;this.units=[],this.runner&&this.runner(le)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=H;class E extends T.Disposable{constructor(le,Se,Ce,Fe){super();this.maxWorkChunkSize=le,this.maxPendingWork=Se,this.throttleDelay=Ce,this.handler=Fe,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(le){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+le.length>this.maxPendingWork)return!1}else if(this.pending+le.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...le),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new A(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=E,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ae=>{(0,P.setTimeout0)(()=>{if(le)return;const Se=Date.now()+15;ae(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Se-Date.now())}}))});let le=!1;return{dispose(){le||(le=!0)}}}:e.runWhenIdle=(ae,le)=>{const Se=requestIdleCallback(ae,typeof le=="number"?{timeout:le}:void 0);let Ce=!1;return{dispose(){Ce||(Ce=!0,cancelIdleCallback(Se))}}}}();class L{constructor(le){this._didRun=!1,this._executor=()=>{try{this._value=le()}catch(Se){this._error=Se}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=L;async function z(ae,le,Se){let Ce;for(let Fe=0;Fe<Se;Fe++)try{return await ae()}catch($e){Ce=$e,await M(le)}throw Ce}e.retry=z;class N{hasPending(le){return this._pending?typeof le=="number"?this._pending.taskId===le:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(le,Se,Ce){return this._pending={taskId:le,cancel:()=>Ce?.(),promise:Se},Se.then(()=>this.donePending(le),()=>this.donePending(le)),Se}donePending(le){this._pending&&le===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const le=this._next;this._next=void 0,le.run().then(le.promiseResolve,le.promiseReject)}}setNext(le){if(this._next)this._next.run=le;else{let Se,Ce;const Fe=new Promise(($e,Ve)=>{Se=$e,Ce=Ve});this._next={run:le,promise:Fe,promiseResolve:Se,promiseReject:Ce}}return this._next.promise}}e.TaskSequentializer=N;class ${constructor(le,Se=()=>Date.now()){this.interval=le,this.nowFn=Se,this.lastIncrementTime=0,this.value=0}increment(){const le=this.nowFn();return le-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=le,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class j{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((le,Se)=>{this.completeCallback=le,this.errorCallback=Se})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(le){return new Promise(Se=>{this.completeCallback(le),this.resolved=!0,Se()})}error(le){return new Promise(Se=>{this.errorCallback(le),this.rejected=!0,Se()})}cancel(){new Promise(le=>{this.errorCallback((0,t.canceled)()),this.rejected=!0,le()})}}e.DeferredPromise=j;var ue;(function(ae){async function le(Ce){let Fe;const $e=await Promise.all(Ce.map(Ve=>Ve.then(je=>je,je=>{Fe||(Fe=je)})));if(typeof Fe!="undefined")throw Fe;return $e}ae.settled=le;function Se(Ce){return new Promise(async(Fe,$e)=>{try{await Ce(Fe,$e)}catch(Ve){$e(Ve)}})}ae.withAsyncBody=Se})(ue=e.Promises||(e.Promises={}));var K;(function(ae){ae[ae.Initial=0]="Initial",ae[ae.DoneOK=1]="DoneOK",ae[ae.DoneError=2]="DoneError"})(K||(K={}));class ie{constructor(le){this._state=0,this._results=[],this._error=null,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const Se={emitOne:Ce=>this.emitOne(Ce),emitMany:Ce=>this.emitMany(Ce),reject:Ce=>this.reject(Ce)};try{await Promise.resolve(le(Se)),this.resolve()}catch(Ce){this.reject(Ce)}finally{Se.emitOne=void 0,Se.emitMany=void 0,Se.reject=void 0}})}static fromArray(le){return new ie(Se=>{Se.emitMany(le)})}static fromPromise(le){return new ie(async Se=>{Se.emitMany(await le)})}static fromPromises(le){return new ie(async Se=>{await Promise.all(le.map(async Ce=>Se.emitOne(await Ce)))})}static merge(le){return new ie(async Se=>{await Promise.all(le.map(async Ce=>{for await(const Fe of Ce)Se.emitOne(Fe)}))})}[Symbol.asyncIterator](){let le=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(le<this._results.length)return{done:!1,value:this._results[le++]};if(this._state===1)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(le,Se){return new ie(async Ce=>{for await(const Fe of le)Ce.emitOne(Se(Fe))})}map(le){return ie.map(this,le)}static filter(le,Se){return new ie(async Ce=>{for await(const Fe of le)Se(Fe)&&Ce.emitOne(Fe)})}filter(le){return ie.filter(this,le)}static coalesce(le){return ie.filter(le,Se=>!!Se)}coalesce(){return ie.coalesce(this)}static async toPromise(le){const Se=[];for await(const Ce of le)Se.push(Ce);return Se}toPromise(){return ie.toPromise(this)}emitOne(le){this._state===0&&(this._results.push(le),this._onStateChanged.fire())}emitMany(le){this._state===0&&(this._results=this._results.concat(le),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(le){this._state===0&&(this._state=2,this._error=le,this._onStateChanged.fire())}}e.AsyncIterableObject=ie,ie.EMPTY=ie.fromArray([]);class pe extends ie{constructor(le,Se){super(Se);this._source=le}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=pe;function we(ae){const le=new a.CancellationTokenSource,Se=ae(le.token);return new pe(le,async Ce=>{const Fe=le.token.onCancellationRequested(()=>{Fe.dispose(),le.dispose(),Ce.reject((0,t.canceled)())});try{for await(const $e of Se){if(le.token.isCancellationRequested)return;Ce.emitOne($e)}Fe.dispose(),le.dispose()}catch($e){Fe.dispose(),le.dispose(),Ce.reject($e)}})}e.createCancelableAsyncIterable=we}),define(Ee[105],ye([0,1,14,17]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const w=new a.IdleValue(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),T=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(y,c,S=!1){const A=y||"",U=c||"",H=w.value.collator.compare(A,U);return w.value.collatorIsNumeric&&H===0&&A!==U?A<U?-1:1:H}e.compareFileNames=P;function C(y,c){const S=T.value.collator;return y=y||"",c=c||"",I(S,y,c)}e.compareFileNamesDefault=C;function R(y,c){const S=T.value.collator;return y=y||"",c=c||"",i(y,c)||I(S,y,c)}e.compareFileNamesUpper=R;function F(y,c){const S=T.value.collator;return y=y||"",c=c||"",o(y,c)||I(S,y,c)}e.compareFileNamesLower=F;function _(y,c){return y=y||"",c=c||"",y===c?0:y<c?-1:1}e.compareFileNamesUnicode=_;function n(y,c,S=!1){S||(y=y&&y.toLowerCase(),c=c&&c.toLowerCase());const[A,U]=f(y),[H,E]=f(c);return A!==H?A<H?-1:1:U===E?0:U<E?-1:1}e.noIntlCompareFileNames=n;function m(y,c){const[S,A]=f(y),[U,H]=f(c);let E=w.value.collator.compare(A,H);if(E===0){if(w.value.collatorIsNumeric&&A!==H)return A<H?-1:1;if(E=w.value.collator.compare(S,U),w.value.collatorIsNumeric&&E===0&&S!==U)return S<U?-1:1}return E}e.compareFileExtensions=m;function r(y,c){y=y||"",c=c||"";const S=p(y),A=p(c),U=T.value.collator,H=k.value.collator;return I(H,S,A)||I(U,y,c)}e.compareFileExtensionsDefault=r;function g(y,c){y=y||"",c=c||"";const S=p(y),A=p(c),U=T.value.collator,H=k.value.collator;return I(H,S,A)||i(y,c)||I(U,y,c)}e.compareFileExtensionsUpper=g;function d(y,c){y=y||"",c=c||"";const S=p(y),A=p(c),U=T.value.collator,H=k.value.collator;return I(H,S,A)||o(y,c)||I(U,y,c)}e.compareFileExtensionsLower=d;function D(y,c){y=y||"",c=c||"";const S=p(y).toLowerCase(),A=p(c).toLowerCase();return S!==A?S<A?-1:1:y!==c?y<c?-1:1:0}e.compareFileExtensionsUnicode=D;const v=/^(.*?)(\.([^.]*))?$/;function f(y,c=!1){const S=y?v.exec(y):[];let A=[S&&S[1]||"",S&&S[3]||""];return c&&(!A[0]&&A[1]||A[0]&&A[0].charAt(0)===".")&&(A=[A[0]+"."+A[1],""]),A}function p(y){const c=y?v.exec(y):[];return c&&c[1]&&c[1].charAt(0)!=="."&&c[3]||""}function I(y,c,S){let A=y.compare(c,S);return A!==0?A:c.length!==S.length?c.length<S.length?-1:1:0}function l(y){const c=y.charAt(0);return c.toLocaleUpperCase()!==c}function M(y){const c=y.charAt(0);return c.toLocaleLowerCase()!==c}function o(y,c){return l(y)&&M(c)?-1:M(y)&&l(c)?1:0}function i(y,c){return M(y)&&l(c)?-1:l(y)&&M(c)?1:0}function h(y,c,S=!1){return S||(y=y&&y.toLowerCase(),c=c&&c.toLowerCase()),y===c?0:y<c?-1:1}function u(y,c,S=!1){const A=y.split(t.sep),U=c.split(t.sep),H=A.length-1,E=U.length-1;let L,z;for(let N=0;;N++){if(L=H===N,z=E===N,L&&z)return P(A[N],U[N],S);if(L)return-1;if(z)return 1;const $=h(A[N],U[N],S);if($!==0)return $}}e.comparePaths=u;function s(y,c,S){const A=y.toLowerCase(),U=c.toLowerCase(),H=b(y,c,S);if(H)return H;const E=A.endsWith(S),L=U.endsWith(S);if(E!==L)return E?-1:1;const z=P(A,U);return z!==0?z:A.localeCompare(U)}e.compareAnything=s;function b(y,c,S){const A=y.toLowerCase(),U=c.toLowerCase(),H=A.startsWith(S),E=U.startsWith(S);if(H!==E)return H?-1:1;if(H&&E){if(A.length<U.length)return-1;if(A.length>U.length)return 1}return 0}e.compareByPrefix=b}),define(Ee[29],ye([0,1,14,42,21,17,9]),function(ne,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const C="**",R="/",F="[/\\\\]",_="[^/\\\\]",n=/\//g;function m(K){switch(K){case 0:return"";case 1:return`${_}*?`;default:return`(?:${F}|${_}+${F}|${F}${_}+)*?`}}function r(K,ie){if(!K)return[];const pe=[];let we=!1,ae=!1,le="";for(const Se of K){switch(Se){case ie:if(!we&&!ae){pe.push(le),le="";continue}break;case"{":we=!0;break;case"}":we=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}le+=Se}return le&&pe.push(le),pe}e.splitGlobAware=r;function g(K){if(!K)return"";let ie="";const pe=r(K,R);if(pe.every(we=>we===C))ie=".*";else{let we=!1;pe.forEach((ae,le)=>{if(ae===C){we||(ie+=m(2),we=!0);return}let Se=!1,Ce="",Fe=!1,$e="";for(const Ve of ae){if(Ve!=="}"&&Se){Ce+=Ve;continue}if(Fe&&(Ve!=="]"||!$e)){let je;Ve==="-"?je=Ve:(Ve==="^"||Ve==="!")&&!$e?je="^":Ve===R?je="":je=k.escapeRegExpCharacters(Ve),$e+=je;continue}switch(Ve){case"{":Se=!0;continue;case"[":Fe=!0;continue;case"}":{ie+=`(?:${r(Ce,",").map(G=>g(G)).join("|")})`,Se=!1,Ce="";break}case"]":ie+="["+$e+"]",Fe=!1,$e="";break;case"?":ie+=_;continue;case"*":ie+=m(1);continue;default:ie+=k.escapeRegExpCharacters(Ve)}}le<pe.length-1&&(pe[le+1]!==C||le+2<pe.length)&&(ie+=F),we=!1})}return ie}const d=/^\*\*\/\*\.[\w\.-]+$/,D=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,I=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new w.LRUCache(1e4),M=function(){return!1},o=function(){return null};function i(K,ie){if(!K)return o;let pe;typeof K!="string"?pe=K.pattern:pe=K,pe=pe.trim();const we=`${pe}_${!!ie.trimForExclusions}`;let ae=l.get(we);if(ae)return h(ae,K);let le;if(d.test(pe)){const Se=pe.substr(4);ae=function(Ce,Fe){return typeof Ce=="string"&&Ce.endsWith(Se)?pe:null}}else(le=D.exec(u(pe,ie)))?ae=s(le[1],pe):(ie.trimForExclusions?f:v).test(pe)?ae=b(pe,ie):(le=p.exec(u(pe,ie)))?ae=y(le[1].substr(1),pe,!0):(le=I.exec(u(pe,ie)))?ae=y(le[1],pe,!1):ae=c(pe);return l.set(we,ae),h(ae,K)}function h(K,ie){return typeof ie=="string"?K:function(pe,we){return t.isEqualOrParent(pe,ie.base)?K(T.relative(ie.base,pe),we):null}}function u(K,ie){return ie.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function s(K,ie){const pe=`/${K}`,we=`\\${K}`,ae=function(Se,Ce){return typeof Se!="string"?null:Ce?Ce===K?ie:null:Se===K||Se.endsWith(pe)||Se.endsWith(we)?ie:null},le=[K];return ae.basenames=le,ae.patterns=[ie],ae.allBasenames=le,ae}function b(K,ie){const pe=ue(K.slice(1,-1).split(",").map(Ce=>i(Ce,ie)).filter(Ce=>Ce!==o),K),we=pe.length;if(!we)return o;if(we===1)return pe[0];const ae=function(Ce,Fe){for(let $e=0,Ve=pe.length;$e<Ve;$e++)if(pe[$e](Ce,Fe))return K;return null},le=pe.find(Ce=>!!Ce.allBasenames);le&&(ae.allBasenames=le.allBasenames);const Se=pe.reduce((Ce,Fe)=>Fe.allPaths?Ce.concat(Fe.allPaths):Ce,[]);return Se.length&&(ae.allPaths=Se),ae}function y(K,ie,pe){const we=T.sep===T.posix.sep,ae=we?K:K.replace(n,T.sep),le=T.sep+ae,Se=T.posix.sep+K,Ce=pe?function(Fe,$e){return typeof Fe=="string"&&(Fe===ae||Fe.endsWith(le)||!we&&(Fe===K||Fe.endsWith(Se)))?ie:null}:function(Fe,$e){return typeof Fe=="string"&&(Fe===ae||!we&&Fe===K)?ie:null};return Ce.allPaths=[(pe?"*/":"./")+K],Ce}function c(K){try{const ie=new RegExp(`^${g(K)}$`);return function(pe){return ie.lastIndex=0,typeof pe=="string"&&ie.test(pe)?K:null}}catch{return o}}function S(K,ie,pe){return!K||typeof ie!="string"?!1:A(K)(ie,void 0,pe)}e.match=S;function A(K,ie={}){if(!K)return M;if(typeof K=="string"||L(K)){const pe=i(K,ie);if(pe===o)return M;const we=function(ae,le){return!!pe(ae,le)};return pe.allBasenames&&(we.allBasenames=pe.allBasenames),pe.allPaths&&(we.allPaths=pe.allPaths),we}return $(K,ie)}e.parse=A;function U(K){if(!K)return;let ie;return pe=>(ie||(ie=(K()||Promise.resolve([])).then(we=>we?E(we):{})),ie.then(we=>!!we[pe]))}e.hasSiblingPromiseFn=U;function H(K){if(!K)return;let ie;return pe=>{if(!ie){const we=K();ie=we?E(we):{}}return!!ie[pe]}}e.hasSiblingFn=H;function E(K){const ie={};for(const pe of K)ie[pe]=!0;return ie}function L(K){const ie=K;return ie&&typeof ie.base=="string"&&typeof ie.pattern=="string"}e.isRelativePattern=L;function z(K){return K.allBasenames||[]}e.getBasenameTerms=z;function N(K){return K.allPaths||[]}e.getPathTerms=N;function $(K,ie){const pe=ue(Object.getOwnPropertyNames(K).map(Ce=>j(Ce,K[Ce],ie)).filter(Ce=>Ce!==o)),we=pe.length;if(!we)return o;if(!pe.some(Ce=>!!Ce.requiresSiblings)){if(we===1)return pe[0];const Ce=function(Ve,je){for(let B=0,G=pe.length;B<G;B++){const X=pe[B](Ve,je);if(X)return X}return null},Fe=pe.find(Ve=>!!Ve.allBasenames);Fe&&(Ce.allBasenames=Fe.allBasenames);const $e=pe.reduce((Ve,je)=>je.allPaths?Ve.concat(je.allPaths):Ve,[]);return $e.length&&(Ce.allPaths=$e),Ce}const ae=function(Ce,Fe,$e){let Ve;for(let je=0,B=pe.length;je<B;je++){const G=pe[je];G.requiresSiblings&&$e&&(Fe||(Fe=T.basename(Ce)),Ve||(Ve=Fe.substr(0,Fe.length-T.extname(Ce).length)));const X=G(Ce,Fe,Ve,$e);if(X)return X}return null},le=pe.find(Ce=>!!Ce.allBasenames);le&&(ae.allBasenames=le.allBasenames);const Se=pe.reduce((Ce,Fe)=>Fe.allPaths?Ce.concat(Fe.allPaths):Ce,[]);return Se.length&&(ae.allPaths=Se),ae}function j(K,ie,pe){if(ie===!1)return o;const we=i(K,pe);if(we===o)return o;if(typeof ie=="boolean")return we;if(ie){const ae=ie.when;if(typeof ae=="string"){const le=(Se,Ce,Fe,$e)=>{if(!$e||!we(Se,Ce))return null;const Ve=ae.replace("$(basename)",Fe),je=$e(Ve);return(0,a.isThenable)(je)?je.then(B=>B?K:null):je?K:null};return le.requiresSiblings=!0,le}}return we}function ue(K,ie){const pe=K.filter(Ce=>!!Ce.basenames);if(pe.length<2)return K;const we=pe.reduce((Ce,Fe)=>{const $e=Fe.basenames;return $e?Ce.concat($e):Ce},[]);let ae;if(ie){ae=[];for(let Ce=0,Fe=we.length;Ce<Fe;Ce++)ae.push(ie)}else ae=pe.reduce((Ce,Fe)=>{const $e=Fe.patterns;return $e?Ce.concat($e):Ce},[]);const le=function(Ce,Fe){if(typeof Ce!="string")return null;if(!Fe){let Ve;for(Ve=Ce.length;Ve>0;Ve--){const je=Ce.charCodeAt(Ve-1);if(je===47||je===92)break}Fe=Ce.substr(Ve)}const $e=we.indexOf(Fe);return $e!==-1?ae[$e]:null};le.basenames=we,le.patterns=ae,le.allBasenames=we;const Se=K.filter(Ce=>!Ce.basenames);return Se.push(le),Se}}),define(Ee[77],ye([0,1,42,10,17,23,24,9,2]),function(ne,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function R(i,h,u){if(typeof i=="string"&&(i=C.URI.file(i)),u){const b=u.getWorkspaceFolder(i);if(b){const y=u.getWorkspace().folders.length>1;let c;if((0,k.isEqual)(b.uri,i)?c="":c=(0,k.relativePath)(b.uri,i),y){const S=b.name?b.name:(0,k.basename)(b.uri);c=c?S+" \u2022 "+c:S}return c}}if(i.scheme!==t.Schemas.file&&i.scheme!==t.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,a.hasDriveLetter)(i.fsPath))return(0,w.normalize)(_(i.fsPath));let s=(0,w.normalize)(i.fsPath);return!T.isWindows&&h?.userHome&&(s=m(s,h.userHome.fsPath)),s}e.getPathLabel=R;function F(i){if(!i)return;typeof i=="string"&&(i=C.URI.file(i));const h=(0,k.basename)(i)||(i.scheme===t.Schemas.file?i.fsPath:i.path);return T.isWindows&&(0,a.isRootOrDriveLetter)(h)?_(h):h}e.getBaseLabel=F;function _(i,h){return(0,a.hasDriveLetter)(i,h)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=_;let n=Object.create(null);function m(i,h){if(T.isWindows||!i||!h)return i;let u=n.original===h?n.normalized:void 0;return u||(u=`${(0,P.rtrim)(h,w.posix.sep)}${w.posix.sep}`,n={original:h,normalized:u}),(T.isLinux?i.startsWith(u):(0,P.startsWithIgnoreCase)(i,u))&&(i=`~/${i.substr(u.length)}`),i}e.tildify=m;function r(i,h){return i.replace(/^~($|\/|\\)/,`${h}$1`)}e.untildify=r;const g="\u2026",d="\\\\",D="~";function v(i,h=w.sep){const u=new Array(i.length);let s=!1;for(let b=0;b<i.length;b++){let y=i[b];if(y===""){u[b]=`.${h}`;continue}if(!y){u[b]=y;continue}s=!0;let c="";y.indexOf(d)===0?(c=y.substr(0,y.indexOf(d)+d.length),y=y.substr(y.indexOf(d)+d.length)):y.indexOf(h)===0?(c=y.substr(0,y.indexOf(h)+h.length),y=y.substr(y.indexOf(h)+h.length)):y.indexOf(D)===0&&(c=y.substr(0,y.indexOf(D)+D.length),y=y.substr(y.indexOf(D)+D.length));const S=y.split(h);for(let A=1;s&&A<=S.length;A++)for(let U=S.length-A;s&&U>=0;U--){s=!1;let H=S.slice(U,U+A).join(h);for(let E=0;!s&&E<i.length;E++)if(E!==b&&i[E]&&i[E].indexOf(H)>-1){const L=U+A===S.length,z=U>0&&i[E].indexOf(h)>-1?h+H:H,N=i[E].endsWith(z);s=!L||N}if(!s){let E="";(S[0].endsWith(":")||c!=="")&&(U===1&&(U=0,A++,H=S[0]+h+H),U>0&&(E=S[0]+h),E=c+E),U>0&&(E=E+g+h),E=E+H,U+A<S.length&&(E=E+h+g),u[b]=E}}s&&(u[b]=y)}return u}e.shorten=v;var f;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function p(i,h=Object.create(null)){const u=[];let s=!1,b="";for(const y of i)if(y==="$"||s&&y==="{")b&&u.push({value:b,type:f.TEXT}),b="",s=!0;else if(y==="}"&&s){const c=h[b];if(typeof c=="string")c.length&&u.push({value:c,type:f.VARIABLE});else if(c){const S=u[u.length-1];(!S||S.type!==f.SEPARATOR)&&u.push({value:c.label,type:f.SEPARATOR})}b="",s=!1}else b+=y;return b&&!s&&u.push({value:b,type:f.TEXT}),u.filter((y,c)=>{if(y.type===f.SEPARATOR){const S=u[c-1],A=u[c+1];return[S,A].every(U=>U&&(U.type===f.VARIABLE||U.type===f.TEXT)&&U.value.length>0)}return!0}).map(y=>y.value).join("")}e.template=p;function I(i,h){return T.isMacintosh||h?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=I;function l(i,h){return T.isMacintosh||h?i.replace(/\(&&\w\)|&&/g,""):T.isWindows?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function M(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=M;function o(i){const h=i.indexOf("/")!==-1?w.posix:w.win32,u=h.basename(i),s=h.dirname(i);return u.length?{name:u,parentPath:s}:{name:s,parentPath:""}}e.splitName=o}),define(Ee[78],ye([0,1,29,10,17,24,9]),function(ne,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown",i.latex="text/latex"})(P=e.Mimes||(e.Mimes={}));let C=[],R=[],F=[];function _(i,h=!1){const u=n(i);C.push(u),u.userConfigured?F.push(u):R.push(u),h&&!u.userConfigured&&C.forEach(s=>{s.mime===u.mime||s.userConfigured||(u.extension&&s.extension===u.extension&&console.warn(`Overwriting extension <<${u.extension}>> to now point to mime <<${u.mime}>>`),u.filename&&s.filename===u.filename&&console.warn(`Overwriting filename <<${u.filename}>> to now point to mime <<${u.mime}>>`),u.filepattern&&s.filepattern===u.filepattern&&console.warn(`Overwriting filepattern <<${u.filepattern}>> to now point to mime <<${u.mime}>>`),u.firstline&&s.firstline===u.firstline&&console.warn(`Overwriting firstline <<${u.firstline}>> to now point to mime <<${u.mime}>>`))})}e.registerTextMime=_;function n(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,a.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(w.posix.sep)>=0:!1}}function m(i){i?(C=C.filter(h=>!h.userConfigured),F=[]):(C=[],R=[],F=[])}e.clearTextMimes=m;function r(i,h){let u;if(i)switch(i.scheme){case t.Schemas.file:u=i.fsPath;break;case t.Schemas.data:{u=T.DataUri.parseMetaData(i).get(T.DataUri.META_DATA_LABEL);break}default:u=i.path}if(!u)return[P.unknown];u=u.toLowerCase();const s=(0,w.basename)(u),b=g(u,s,F);if(b)return[b,P.text];const y=g(u,s,R);if(y)return[y,P.text];if(h){const c=d(h);if(c)return[c,P.text]}return[P.unknown]}e.guessMimeTypes=r;function g(i,h,u){let s=null,b=null,y=null;for(let c=u.length-1;c>=0;c--){const S=u[c];if(h===S.filenameLowercase){s=S;break}if(S.filepattern&&(!b||S.filepattern.length>b.filepattern.length)){const A=S.filepatternOnPath?i:h;S.filepatternLowercase?.(A)&&(b=S)}S.extension&&(!y||S.extension.length>y.extension.length)&&h.endsWith(S.extensionLowercase)&&(y=S)}return s?s.mime:b?b.mime:y?y.mime:null}function d(i){if((0,k.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let h=C.length-1;h>=0;h--){const u=C[h];if(!u.firstline)continue;const s=i.match(u.firstline);if(s&&s.length>0)return u.mime}return null}function D(i){return i?typeof i=="string"?i===P.binary||i===P.text||i===P.unknown:i.length===1&&D(i[0]):!0}e.isUnspecific=D;const v={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function p(i){const h=(0,w.extname)(i),u=v[h.toLowerCase()];return u!==void 0?u:I(i)}e.getMediaOrTextMime=p;function I(i){const h=(0,w.extname)(i);return f[h.toLowerCase()]}e.getMediaMime=I;function l(i){for(const h in f)if(f[h]===i)return h}e.getExtensionForMimeType=l;const M=/^(.+)\/(.+?)(;.+)?$/;function o(i,h){const u=M.exec(i);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:h?void 0:i}e.normalizeMimeType=o}),define(Ee[106],ye([0,1,2]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(F){return F.toJSON()}class w{constructor(_){this._uriTransformer=_}transformIncoming(_){const n=this._uriTransformer.transformIncoming(_);return n===_?_:t(a.URI.from(n))}transformOutgoing(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:t(a.URI.from(n))}transformOutgoingURI(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:a.URI.from(n)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(F){return F}transformOutgoing(F){return F}transformOutgoingURI(F){return F}transformOutgoingScheme(F){return F}};function T(F,_,n){if(!F||n>200)return null;if(typeof F=="object"){if(F instanceof a.URI)return _.transformOutgoing(F);for(let m in F)if(Object.hasOwnProperty.call(F,m)){const r=T(F[m],_,n+1);r!==null&&(F[m]=r)}}return null}function k(F,_){const n=T(F,_,0);return n===null?F:n}e.transformOutgoingURIs=k;function P(F,_,n,m){if(!F||m>200)return null;if(typeof F=="object"){if(F.$mid===1)return n?a.URI.revive(_.transformIncoming(F)):_.transformIncoming(F);for(let r in F)if(Object.hasOwnProperty.call(F,r)){const g=P(F[r],_,n,m+1);g!==null&&(F[r]=g)}}return null}function C(F,_){const n=P(F,_,!1,0);return n===null?F:n}e.transformIncomingURIs=C;function R(F,_){const n=P(F,_,!0,0);return n===null?F:n}e.transformAndReviveIncomingURIs=R}),define(Ee[35],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(C){return a.test(C)}e.isUUID=t;const w=new Uint8Array(16),T=[];for(let C=0;C<256;C++)T.push(C.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(C){for(let R=0;R<C.length;R++)C[R]=Math.floor(Math.random()*256);return C};function P(){k(w),w[6]=w[6]&15|64,w[8]=w[8]&63|128;let C=0,R="";return R+=T[w[C++]],R+=T[w[C++]],R+=T[w[C++]],R+=T[w[C++]],R+="-",R+=T[w[C++]],R+=T[w[C++]],R+="-",R+=T[w[C++]],R+=T[w[C++]],R+="-",R+=T[w[C++]],R+=T[w[C++]],R+="-",R+=T[w[C++]],R+=T[w[C++]],R+=T[w[C++]],R+=T[w[C++]],R+=T[w[C++]],R+=T[w[C++]],R}e.generateUuid=P}),define(Ee[107],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(k){k[k.None=0]="None",k[k.Indent=1]="Indent",k[k.IndentOutdent=2]="IndentOutdent",k[k.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class t{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(P.notIn))for(let C=0,R=P.notIn.length;C<R;C++)switch(P.notIn[C]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(P,C){if(P.getTokenCount()===0)return!0;const R=P.findTokenIndexAtOffset(C-2),F=P.getStandardTokenType(R);return this.isOK(F)}_findNeutralCharacterInRange(P,C){for(let R=P;R<=C;R++){const F=String.fromCharCode(R);if(!this.open.includes(F)&&!this.close.includes(F))return F}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class w{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of P)T(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),T(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),T(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),T(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&T(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=w;function T(k,P,C){k.has(P)?k.get(P).push(C):k.set(P,[C])}}),define(Ee[55],ye([0,1,29,17]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function w(T,k,P,C){if(Array.isArray(T)){let R=0;for(const F of T){const _=w(F,k,P,C);if(_===10)return _;_>R&&(R=_)}return R}else{if(typeof T=="string")return C?T==="*"?5:T===P?10:0:0;if(T){const{language:R,pattern:F,scheme:_,hasAccessToAllModels:n}=T;if(!C&&!n)return 0;let m=0;if(_)if(_===k.scheme)m=10;else if(_==="*")m=5;else return 0;if(R)if(R===P)m=10;else if(R==="*")m=Math.max(m,5);else return 0;if(F){let r;if(typeof F=="string"?r=F:r={...F,base:(0,t.normalize)(F.base)},r===k.fsPath||(0,a.match)(r,k.fsPath))m=10;else return 0}return m}else return 0}}e.score=w}),define(Ee[108],ye([0,1,4,6]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class w{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new a.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,P){return this._map.set(k,P),this.fire([k]),(0,t.toDisposable)(()=>{this._map.get(k)===P&&(this._map.delete(k),this.fire([k]))})}registerPromise(k,P){let C=null,R=!1;return this._promises.set(k,P.then(F=>{this._promises.delete(k),!(R||!F)&&(C=this.register(k,F))})),(0,t.toDisposable)(()=>{R=!0,C&&C.dispose()})}getPromise(k){const P=this.get(k);if(P)return Promise.resolve(P);const C=this._promises.get(k);return C?C.then(R=>this.get(k)):null}get(k){return this._map.get(k)||null}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=w}),define(Ee[79],ye([0,1,22,23]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var w;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(w||(w={}));function T(_){for(let n=0,m=_.length;n<m;n+=4){const r=_[n+0],g=_[n+1],d=_[n+2],D=_[n+3];_[n+0]=D,_[n+1]=d,_[n+2]=g,_[n+3]=r}}function k(_){const n=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return t.isLittleEndian()||T(n),a.VSBuffer.wrap(n)}function P(_){const n=_.buffer;if(t.isLittleEndian()||T(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const m=new Uint8Array(n.byteLength);return m.set(n),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function C(_){const n=new Uint32Array(R(_));let m=0;if(n[m++]=_.id,_.type==="full")n[m++]=1,n[m++]=_.data.length,n.set(_.data,m),m+=_.data.length;else{n[m++]=2,n[m++]=_.deltas.length;for(const r of _.deltas)n[m++]=r.start,n[m++]=r.deleteCount,r.data?(n[m++]=r.data.length,n.set(r.data,m),m+=r.data.length):n[m++]=0}return k(n)}e.encodeSemanticTokensDto=C;function R(_){let n=0;if(n+=1+1,_.type==="full")n+=1+_.data.length;else{n+=1,n+=(1+1+1)*_.deltas.length;for(const m of _.deltas)m.data&&(n+=m.data.length)}return n}function F(_){const n=P(_);let m=0;const r=n[m++];if(n[m++]===1){const v=n[m++],f=n.subarray(m,m+v);return m+=v,{id:r,type:"full",data:f}}const d=n[m++];let D=[];for(let v=0;v<d;v++){const f=n[m++],p=n[m++],I=n[m++];let l;I>0&&(l=n.subarray(m,m+I),m+=I),D[v]={start:f,deleteCount:p,data:l}}return{id:r,type:"delta",deltas:D}}e.decodeSemanticTokensDto=F}),define(Ee[109],ye([18,19]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(Ee[110],ye([0,1,109]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,w=t*60,T=w*24,k=T*7,P=T*30,C=T*365;function R(_,n){typeof _!="number"&&(_=_.getTime());const m=Math.round((new Date().getTime()-_)/1e3);if(m<-30)return(0,a.localize)(0,null,R(new Date().getTime()+m*1e3,!1));if(m<30)return(0,a.localize)(1,null);let r;return m<t?(r=m,n?r===1?(0,a.localize)(2,null,r):(0,a.localize)(3,null,r):r===1?(0,a.localize)(4,null,r):(0,a.localize)(5,null,r)):m<w?(r=Math.floor(m/t),n?r===1?(0,a.localize)(6,null,r):(0,a.localize)(7,null,r):r===1?(0,a.localize)(8,null,r):(0,a.localize)(9,null,r)):m<T?(r=Math.floor(m/w),n?r===1?(0,a.localize)(10,null,r):(0,a.localize)(11,null,r):r===1?(0,a.localize)(12,null,r):(0,a.localize)(13,null,r)):m<k?(r=Math.floor(m/T),n?r===1?(0,a.localize)(14,null,r):(0,a.localize)(15,null,r):r===1?(0,a.localize)(16,null,r):(0,a.localize)(17,null,r)):m<P?(r=Math.floor(m/k),n?r===1?(0,a.localize)(18,null,r):(0,a.localize)(19,null,r):r===1?(0,a.localize)(20,null,r):(0,a.localize)(21,null,r)):m<C?(r=Math.floor(m/P),n?r===1?(0,a.localize)(22,null,r):(0,a.localize)(23,null,r):r===1?(0,a.localize)(24,null,r):(0,a.localize)(25,null,r)):(r=Math.floor(m/C),n?r===1?(0,a.localize)(26,null,r):(0,a.localize)(27,null,r):r===1?(0,a.localize)(28,null,r):(0,a.localize)(29,null,r))}e.fromNow=R;function F(_){return _.getFullYear()+"-"+String(_.getMonth()+1).padStart(2,"0")+"-"+String(_.getDate()).padStart(2,"0")+"T"+String(_.getHours()).padStart(2,"0")+":"+String(_.getMinutes()).padStart(2,"0")+":"+String(_.getSeconds()).padStart(2,"0")+"."+(_.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=F}),define(Ee[111],ye([18,19]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(Ee[43],ye([0,1,16,11,111]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(R,F){return F&&(R.stack||R.stacktrace)?w.localize(0,null,P(R),k(R.stack)||k(R.stacktrace)):P(R)}function k(R){return Array.isArray(R)?R.join(`
`):R}function P(R){return typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?w.localize(1,null,R.message):R.message||w.localize(2,null)}function C(R=null,F=!1){if(!R)return w.localize(3,null);if(Array.isArray(R)){const _=a.coalesce(R),n=C(_[0],F);return _.length>1?w.localize(4,null,n,_.length):n}if(t.isString(R))return R;if(R.detail){const _=R.detail;if(_.error)return T(_.error,F);if(_.exception)return T(_.exception,F)}return R.stack?T(R,F):R.message?R.message:w.localize(5,null)}e.toErrorMessage=C}),define(Ee[112],ye([18,19]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(Ee[113],ye([0,1,112,23,114,16,26]),function(ne,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var P;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(P=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=C;class R{constructor(){this._values=[]}_read(Q){return this._values[Q]}get(Q){return this._values[Q]}_write(Q,de){this._values[Q]=de}}e.ValidatedEditorOptions=R;class F{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=F;class _{constructor(Q,de,Ne,qe){this.id=Q,this.name=de,this.defaultValue=Ne,this.schema=qe}applyUpdate(Q,de){return m(Q,de)}compute(Q,de,Ne){return Ne}}class n{constructor(Q,de){this.newValue=Q,this.didChange=de}}e.ApplyUpdateResult=n;function m(V,Q){if(typeof V!="object"||typeof Q!="object"||!V||!Q)return new n(Q,V!==Q);if(Array.isArray(V)||Array.isArray(Q)){const Ne=Array.isArray(V)&&Array.isArray(Q)&&T.equals(V,Q);return new n(Q,Ne)}let de=!1;for(let Ne in Q)if(Q.hasOwnProperty(Ne)){const qe=m(V[Ne],Q[Ne]);qe.didChange&&(V[Ne]=qe.newValue,de=!0)}return new n(V,de)}class r{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,de){return m(Q,de)}validate(Q){return this.defaultValue}}class g{constructor(Q,de,Ne,qe){this.id=Q,this.name=de,this.defaultValue=Ne,this.schema=qe}applyUpdate(Q,de){return m(Q,de)}validate(Q){return typeof Q=="undefined"?this.defaultValue:Q}compute(Q,de,Ne){return Ne}}function d(V,Q){return typeof V=="undefined"?Q:V==="false"?!1:Boolean(V)}e.boolean=d;class D extends g{constructor(Q,de,Ne,qe=void 0){typeof qe!="undefined"&&(qe.type="boolean",qe.default=Ne);super(Q,de,Ne,qe)}validate(Q){return d(Q,this.defaultValue)}}function v(V,Q,de,Ne){if(typeof V=="undefined")return Q;let qe=parseInt(V,10);return isNaN(qe)?Q:(qe=Math.max(de,qe),qe=Math.min(Ne,qe),qe|0)}e.clampedInt=v;class f extends g{constructor(Q,de,Ne,qe,ot,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="integer",Ye.default=Ne,Ye.minimum=qe,Ye.maximum=ot);super(Q,de,Ne,Ye);this.minimum=qe,this.maximum=ot}static clampedInt(Q,de,Ne,qe){return v(Q,de,Ne,qe)}validate(Q){return f.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class p extends g{constructor(Q,de,Ne,qe,ot){typeof ot!="undefined"&&(ot.type="number",ot.default=Ne);super(Q,de,Ne,ot);this.validationFn=qe}static clamp(Q,de,Ne){return Q<de?de:Q>Ne?Ne:Q}static float(Q,de){if(typeof Q=="number")return Q;if(typeof Q=="undefined")return de;const Ne=parseFloat(Q);return isNaN(Ne)?de:Ne}validate(Q){return this.validationFn(p.float(Q,this.defaultValue))}}class I extends g{static string(Q,de){return typeof Q!="string"?de:Q}constructor(Q,de,Ne,qe=void 0){typeof qe!="undefined"&&(qe.type="string",qe.default=Ne);super(Q,de,Ne,qe)}validate(Q){return I.string(Q,this.defaultValue)}}function l(V,Q,de){return typeof V!="string"||de.indexOf(V)===-1?Q:V}e.stringSet=l;class M extends g{constructor(Q,de,Ne,qe,ot=void 0){typeof ot!="undefined"&&(ot.type="string",ot.enum=qe,ot.default=Ne);super(Q,de,Ne,ot);this._allowedValues=qe}validate(Q){return l(Q,this.defaultValue,this._allowedValues)}}class o extends _{constructor(Q,de,Ne,qe,ot,Ye,yt=void 0){typeof yt!="undefined"&&(yt.type="string",yt.enum=ot,yt.default=qe);super(Q,de,Ne,yt);this._allowedValues=ot,this._convert=Ye}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function i(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends _{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",description:a.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,de,Ne){return Ne===0?Q.accessibilitySupport:Ne}}class u extends _{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:a.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{insertSpace:d(de.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(de.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function b(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(y=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function c(V){switch(V){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=c;function S(V){switch(V){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class A extends r{constructor(){super(127)}compute(Q,de,Ne){const qe=["monaco-editor"];return de.get(33)&&qe.push(de.get(33)),Q.extraEditorClassName&&qe.push(Q.extraEditorClassName),de.get(65)==="default"?qe.push("mouse-default"):de.get(65)==="copy"&&qe.push("mouse-copy"),de.get(99)&&qe.push("showUnused"),de.get(125)&&qe.push("showDeprecated"),qe.join(" ")}}class U extends D{constructor(){super(32,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(Q,de,Ne){return Ne&&Q.emptySelectionClipboard}}class H extends _{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:a.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:a.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{cursorMoveOnType:d(de.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":l(de.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":l(de.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(de.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(de.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(de.loop,this.defaultValue.loop)}}}class E extends _{constructor(){super(44,"fontLigatures",E.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(Q){return typeof Q=="undefined"?this.defaultValue:typeof Q=="string"?Q==="false"?E.OFF:Q==="true"?E.ON:Q:Boolean(Q)?E.ON:E.OFF}}e.EditorFontLigatures=E,E.OFF='"liga" off, "calt" off',E.ON='"liga" on, "calt" on';class L extends r{constructor(){super(43)}compute(Q,de,Ne){return Q.fontInfo}}class z extends g{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(22,null)})}validate(Q){let de=p.float(Q,this.defaultValue);return de===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(de,6,100)}compute(Q,de,Ne){return Q.fontInfo.fontSize}}class N extends _{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:N.MINIMUM_VALUE,maximum:N.MAXIMUM_VALUE,errorMessage:a.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:N.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(f.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,N.MINIMUM_VALUE,N.MAXIMUM_VALUE))}}N.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],N.MINIMUM_VALUE=1,N.MAXIMUM_VALUE=1e3;class $ extends _{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},de={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[a.localize(25,null),a.localize(26,null),a.localize(27,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(29,null),...de},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(30,null),...de},"editor.gotoLocation.multipleDeclarations":{description:a.localize(31,null),...de},"editor.gotoLocation.multipleImplementations":{description:a.localize(32,null),...de},"editor.gotoLocation.multipleReferences":{description:a.localize(33,null),...de},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ne,description:a.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ne,description:a.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ne,description:a.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ne,description:a.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ne,description:a.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{multiple:l(de.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:de.multipleDefinitions??l(de.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:de.multipleTypeDefinitions??l(de.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:de.multipleDeclarations??l(de.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:de.multipleImplementations??l(de.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:de.multipleReferences??l(de.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:I.string(de.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:I.string(de.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:I.string(de.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:I.string(de.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:I.string(de.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class j extends _{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:a.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,description:a.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:a.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:a.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{enabled:d(de.enabled,this.defaultValue.enabled),delay:f.clampedInt(de.delay,this.defaultValue.delay,0,1e4),sticky:d(de.sticky,this.defaultValue.sticky),above:d(de.above,this.defaultValue.above)}}}var ue;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(ue=e.RenderMinimap||(e.RenderMinimap={}));class K extends r{constructor(){super(130)}compute(Q,de,Ne){return K.computeLayout(de,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const de=Q.height/Q.lineHeight,Ne=Q.scrollBeyondLastLine?de-1:0,qe=(Q.viewLineCount+Ne)/(Q.pixelRatio*Q.height),ot=Math.floor(Q.viewLineCount/qe);return{typicalViewportLineCount:de,extraLinesBeyondLastLine:Ne,desiredRatio:qe,minimapLineCount:ot}}static _computeMinimapLayout(Q,de){const Ne=Q.outerWidth,qe=Q.outerHeight,ot=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:qe};const Ye=de.stableMinimapLayoutInput,yt=Ye&&Q.outerHeight===Ye.outerHeight&&Q.lineHeight===Ye.lineHeight&&Q.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Ye.pixelRatio&&Q.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&Q.minimap.enabled===Ye.minimap.enabled&&Q.minimap.side===Ye.minimap.side&&Q.minimap.size===Ye.minimap.size&&Q.minimap.showSlider===Ye.minimap.showSlider&&Q.minimap.renderCharacters===Ye.minimap.renderCharacters&&Q.minimap.maxColumn===Ye.minimap.maxColumn&&Q.minimap.scale===Ye.minimap.scale&&Q.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&Q.isViewportWrapping===Ye.isViewportWrapping,Te=Q.lineHeight,De=Q.typicalHalfwidthCharacterWidth,ve=Q.scrollBeyondLastLine,re=Q.minimap.renderCharacters;let oe=ot>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const he=Q.minimap.maxColumn,me=Q.minimap.size,Pe=Q.minimap.side,We=Q.verticalScrollbarWidth,Le=Q.viewLineCount,Ke=Q.remainingWidth,it=Q.isViewportWrapping,rt=re?2:3;let te=Math.floor(ot*qe);const ge=te/ot;let Z=!1,W=!1,be=rt*oe,Ie=oe/ot,Qe=1;if(me==="fill"||me==="fit"){const{typicalViewportLineCount:gt,extraLinesBeyondLastLine:_t,desiredRatio:Lt,minimapLineCount:It}=K.computeContainedMinimapLineCount({viewLineCount:Le,scrollBeyondLastLine:ve,height:qe,lineHeight:Te,pixelRatio:ot});if(Le/It>1)Z=!0,W=!0,oe=1,be=1,Ie=oe/ot;else{let At=!1,Et=oe+1;if(me==="fit"){const Ot=Math.ceil((Le+_t)*be);it&&yt&&Ke<=de.stableFitRemainingWidth?(At=!0,Et=de.stableFitMaxMinimapScale):At=Ot>te}if(me==="fill"||At){Z=!0;const Ot=oe;be=Math.min(Te*ot,Math.max(1,Math.floor(1/Lt))),it&&yt&&Ke<=de.stableFitRemainingWidth&&(Et=de.stableFitMaxMinimapScale),oe=Math.min(Et,Math.max(1,Math.floor(be/rt))),oe>Ot&&(Qe=Math.min(2,oe/Ot)),Ie=oe/ot/Qe,te=Math.ceil(Math.max(gt,Le+_t)*be),it?(de.stableMinimapLayoutInput=Q,de.stableFitRemainingWidth=Ke,de.stableFitMaxMinimapScale=oe):(de.stableMinimapLayoutInput=null,de.stableFitRemainingWidth=0)}}}const Ue=Math.floor(he*Ie),ut=Math.min(Ue,Math.max(0,Math.floor((Ke-We-2)*Ie/(De+Ie)))+e.MINIMAP_GUTTER_WIDTH);let vt=Math.floor(ot*ut);const St=vt/ot;vt=Math.floor(vt*Qe);const bt=re?1:2,ht=Pe==="left"?0:Ne-ut-We;return{renderMinimap:bt,minimapLeft:ht,minimapWidth:ut,minimapHeightIsEditorHeight:Z,minimapIsSampling:W,minimapScale:oe,minimapLineHeight:be,minimapCanvasInnerWidth:vt,minimapCanvasInnerHeight:te,minimapCanvasOuterWidth:St,minimapCanvasOuterHeight:ge}}static computeLayout(Q,de){const Ne=de.outerWidth|0,qe=de.outerHeight|0,ot=de.lineHeight|0,Ye=de.lineNumbersDigitCount|0,yt=de.typicalHalfwidthCharacterWidth,Te=de.maxDigitWidth,De=de.pixelRatio,ve=de.viewLineCount,re=Q.get(122),oe=re==="inherit"?Q.get(121):re,he=oe==="inherit"?Q.get(117):oe,me=Q.get(120),Pe=Q.get(2),We=de.isDominatedByLongLines,Le=Q.get(49),Ke=Q.get(59).renderType!==0,it=Q.get(60),rt=Q.get(93),te=Q.get(64),ge=Q.get(91),Z=ge.verticalScrollbarSize,W=ge.verticalHasArrows,be=ge.arrowSize,Ie=ge.horizontalScrollbarSize,Qe=Q.get(57),Ue=Q.get(37);let ut;if(typeof Qe=="string"&&/^\d+(\.\d+)?ch$/.test(Qe)){const $t=parseFloat(Qe.substr(0,Qe.length-2));ut=f.clampedInt($t*yt,0,0,1e3)}else ut=f.clampedInt(Qe,0,0,1e3);Ue&&(ut+=16);let vt=0;if(Ke){const $t=Math.max(Ye,it);vt=Math.round($t*Te)}let St=0;Le&&(St=ot);let bt=0,ht=bt+St,gt=ht+vt,_t=gt+ut;const Lt=Ne-St-vt-ut;let It=!1,Pt=!1,At=-1;Pe!==2&&(oe==="inherit"&&We?(It=!0,Pt=!0):he==="on"||he==="bounded"?Pt=!0:he==="wordWrapColumn"&&(At=me));const Et=K._computeMinimapLayout({outerWidth:Ne,outerHeight:qe,lineHeight:ot,typicalHalfwidthCharacterWidth:yt,pixelRatio:De,scrollBeyondLastLine:rt,minimap:te,verticalScrollbarWidth:Z,viewLineCount:ve,remainingWidth:Lt,isViewportWrapping:Pt},de.memory||new F);Et.renderMinimap!==0&&Et.minimapLeft===0&&(bt+=Et.minimapWidth,ht+=Et.minimapWidth,gt+=Et.minimapWidth,_t+=Et.minimapWidth);const Ot=Lt-Et.minimapWidth,Nt=Math.max(1,Math.floor((Ot-Z-2)/yt)),wt=W?be:0;return Pt&&(At=Math.max(1,Nt),he==="bounded"&&(At=Math.min(At,me))),{width:Ne,height:qe,glyphMarginLeft:bt,glyphMarginWidth:St,lineNumbersLeft:ht,lineNumbersWidth:vt,decorationsLeft:gt,decorationsWidth:ut,contentLeft:_t,contentWidth:Ot,minimap:Et,viewportColumn:Nt,isWordWrapMinified:It,isViewportWrapping:Pt,wrappingColumn:At,verticalScrollbarWidth:Z,horizontalScrollbarHeight:Ie,overviewRuler:{top:wt,width:Z,height:qe-2*wt,right:0}}}}e.EditorLayoutInfoComputer=K;class ie extends _{constructor(){const Q={enabled:!0};super(56,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:a.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:d(Q.enabled,this.defaultValue.enabled)}}}class pe extends _{constructor(){const Q={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"boolean",default:Q.enabled,description:a.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:a.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:a.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{enabled:d(de.enabled,this.defaultValue.enabled),fontSize:f.clampedInt(de.fontSize,this.defaultValue.fontSize,0,100),fontFamily:I.string(de.fontFamily,this.defaultValue.fontFamily)}}}class we extends p{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>p.clamp(Q,0,150),{markdownDescription:a.localize(47,null)})}compute(Q,de,Ne){return Q.fontInfo.lineHeight}}class ae extends _{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:a.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(49,null),a.localize(50,null),a.localize(51,null)],default:Q.size,description:a.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:a.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:a.localize(54,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:a.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:a.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{enabled:d(de.enabled,this.defaultValue.enabled),size:l(de.size,this.defaultValue.size,["proportional","fill","fit"]),side:l(de.side,this.defaultValue.side,["right","left"]),showSlider:l(de.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(de.renderCharacters,this.defaultValue.renderCharacters),scale:f.clampedInt(de.scale,1,1,3),maxColumn:f.clampedInt(de.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le(V){return V==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Se extends _{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{top:f.clampedInt(de.top,0,0,1e3),bottom:f.clampedInt(de.bottom,0,0,1e3)}}}class Ce extends _{constructor(){const Q={enabled:!0,cycle:!1};super(75,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:a.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:a.localize(61,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{enabled:d(de.enabled,this.defaultValue.enabled),cycle:d(de.cycle,this.defaultValue.cycle)}}}class Fe extends r{constructor(){super(128)}compute(Q,de,Ne){return Q.pixelRatio}}class $e extends _{constructor(){const Q={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",Q,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Q.strings,description:a.localize(62,null)},comments:{type:"boolean",default:Q.comments,description:a.localize(63,null)},other:{type:"boolean",default:Q.other,description:a.localize(64,null)}}}],default:Q,description:a.localize(65,null)});this.defaultValue=Q}validate(Q){if(typeof Q=="boolean")return Q;if(Q&&typeof Q=="object"){const de=Q,Ne={other:d(de.other,this.defaultValue.other),comments:d(de.comments,this.defaultValue.comments),strings:d(de.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var Ve;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Ve=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class je extends _{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(66,null),a.localize(67,null),a.localize(68,null),a.localize(69,null)],default:"on",description:a.localize(70,null)})}validate(Q){let de=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof Q!="undefined"&&(typeof Q=="function"?(de=4,Ne=Q):Q==="interval"?de=3:Q==="relative"?de=2:Q==="on"?de=1:de=0),{renderType:de,renderFn:Ne}}}function B(V){const Q=V.get(86);return Q==="editable"?V.get(80):Q!=="on"}e.filterValidationDecorations=B;class G extends _{constructor(){const Q=[],de={type:"number",description:a.localize(71,null)};super(90,"rulers",Q,{type:"array",items:{anyOf:[de,{type:["object"],properties:{column:de,color:{type:"string",description:a.localize(72,null),format:"color-hex"}}}]},default:Q,description:a.localize(73,null)})}validate(Q){if(Array.isArray(Q)){let de=[];for(let Ne of Q)if(typeof Ne=="number")de.push({column:f.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const qe=Ne;de.push({column:f.clampedInt(qe.column,0,0,1e4),color:qe.color})}return de.sort((Ne,qe)=>Ne.column-qe.column),de}return this.defaultValue}}function X(V,Q){if(typeof V!="string")return Q;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class se extends _{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(74,null),a.localize(75,null),a.localize(76,null)],default:"auto",description:a.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(78,null),a.localize(79,null),a.localize(80,null)],default:"auto",description:a.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:a.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:a.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:a.localize(84,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q,Ne=f.clampedInt(de.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),qe=f.clampedInt(de.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:f.clampedInt(de.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:X(de.vertical,this.defaultValue.vertical),horizontal:X(de.horizontal,this.defaultValue.horizontal),useShadows:d(de.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(de.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(de.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(de.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(de.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:f.clampedInt(de.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:qe,verticalSliderSize:f.clampedInt(de.verticalSliderSize,qe,0,1e3),scrollByPage:d(de.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings"};class q extends _{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{}};super(112,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:a.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:a.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:a.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:a.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:a.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:a.localize(90,null),additionalProperties:{type:"boolean"}}})}applyUpdate(Q,de){let Ne=!1;de.allowedCharacters&&(k.equals(Q.allowedCharacters,de.allowedCharacters)||(Q={...Q,allowedCharacters:de.allowedCharacters},Ne=!0));const qe=super.applyUpdate(Q,de);return Ne?new n(qe.newValue,!0):qe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{nonBasicASCII:xe(de.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(de.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(de.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:xe(de.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:xe(de.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateAllowedCharacters(Q.allowedCharacters,this.defaultValue.allowedCharacters)}}validateAllowedCharacters(Q,de){if(typeof Q!="object"||!Q)return de;const Ne={};for(const[qe,ot]of Object.entries(Q))ot===!0&&(Ne[qe]=!0);return Ne}}class ee extends _{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:a.localize(91,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{enabled:d(de.enabled,this.defaultValue.enabled),mode:l(de.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class fe extends _{constructor(){const Q={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,description:a.localize(92,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:d(Q.enabled,this.defaultValue.enabled)}}}class Ae extends _{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(93,null),a.localize(94,null),a.localize(95,null)],default:Q.bracketPairs,description:a.localize(96,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(97,null),a.localize(98,null),a.localize(99,null)],default:Q.bracketPairsHorizontal,description:a.localize(100,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:a.localize(101,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:a.localize(102,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Q.highlightActiveIndentation,description:a.localize(103,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{bracketPairs:xe(de.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:xe(de.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(de.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(de.indentation,this.defaultValue.indentation),highlightActiveIndentation:d(de.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function xe(V,Q,de){const Ne=de.indexOf(V);return Ne===-1?Q:de[Ne]}class ze extends _{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(104,null),a.localize(105,null)],default:Q.insertMode,description:a.localize(106,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:a.localize(107,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:a.localize(108,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:a.localize(109,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:a.localize(110,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:a.localize(111,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:a.localize(112,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:a.localize(113,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:a.localize(114,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(115,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(116,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(117,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(118,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(119,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(120,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(121,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(122,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(123,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(124,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(125,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(126,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(127,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(128,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(129,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(130,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(131,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(132,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(133,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(134,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(135,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(136,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(137,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(138,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(139,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(140,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(141,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(142,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(143,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(144,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(145,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{insertMode:l(de.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(de.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(de.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(de.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(de.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(de.showIcons,this.defaultValue.showIcons),showStatusBar:d(de.showStatusBar,this.defaultValue.showStatusBar),preview:d(de.preview,this.defaultValue.preview),previewMode:l(de.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(de.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(de.showMethods,this.defaultValue.showMethods),showFunctions:d(de.showFunctions,this.defaultValue.showFunctions),showConstructors:d(de.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(de.showDeprecated,this.defaultValue.showDeprecated),showFields:d(de.showFields,this.defaultValue.showFields),showVariables:d(de.showVariables,this.defaultValue.showVariables),showClasses:d(de.showClasses,this.defaultValue.showClasses),showStructs:d(de.showStructs,this.defaultValue.showStructs),showInterfaces:d(de.showInterfaces,this.defaultValue.showInterfaces),showModules:d(de.showModules,this.defaultValue.showModules),showProperties:d(de.showProperties,this.defaultValue.showProperties),showEvents:d(de.showEvents,this.defaultValue.showEvents),showOperators:d(de.showOperators,this.defaultValue.showOperators),showUnits:d(de.showUnits,this.defaultValue.showUnits),showValues:d(de.showValues,this.defaultValue.showValues),showConstants:d(de.showConstants,this.defaultValue.showConstants),showEnums:d(de.showEnums,this.defaultValue.showEnums),showEnumMembers:d(de.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(de.showKeywords,this.defaultValue.showKeywords),showWords:d(de.showWords,this.defaultValue.showWords),showColors:d(de.showColors,this.defaultValue.showColors),showFiles:d(de.showFiles,this.defaultValue.showFiles),showReferences:d(de.showReferences,this.defaultValue.showReferences),showFolders:d(de.showFolders,this.defaultValue.showFolders),showTypeParameters:d(de.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(de.showSnippets,this.defaultValue.showSnippets),showUsers:d(de.showUsers,this.defaultValue.showUsers),showIssues:d(de.showIssues,this.defaultValue.showIssues)}}}class Xe extends _{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(146,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class et extends r{constructor(){super(129)}compute(Q,de,Ne){return de.get(80)?!0:Q.tabFocusMode}}var st;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(st=e.WrappingIndent||(e.WrappingIndent={}));function Je(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class nt extends r{constructor(){super(131)}compute(Q,de,Ne){const qe=de.get(130);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:qe.isWordWrapMinified,isViewportWrapping:qe.isViewportWrapping,wrappingColumn:qe.wrappingColumn}}}const lt="Consolas, 'Courier New', monospace",pt="Menlo, Monaco, 'Courier New', monospace",Ft="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?pt:t.isLinux?Ft:lt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Oe(V){return e.editorOptionsRegistry[V.id]=V,V}var Mt;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.bracketPairColorization=12]="bracketPairColorization",V[V.guides=13]="guides",V[V.codeLens=14]="codeLens",V[V.codeLensFontFamily=15]="codeLensFontFamily",V[V.codeLensFontSize=16]="codeLensFontSize",V[V.colorDecorators=17]="colorDecorators",V[V.columnSelection=18]="columnSelection",V[V.comments=19]="comments",V[V.contextmenu=20]="contextmenu",V[V.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",V[V.cursorBlinking=22]="cursorBlinking",V[V.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",V[V.cursorStyle=24]="cursorStyle",V[V.cursorSurroundingLines=25]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",V[V.cursorWidth=27]="cursorWidth",V[V.disableLayerHinting=28]="disableLayerHinting",V[V.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",V[V.domReadOnly=30]="domReadOnly",V[V.dragAndDrop=31]="dragAndDrop",V[V.emptySelectionClipboard=32]="emptySelectionClipboard",V[V.extraEditorClassName=33]="extraEditorClassName",V[V.fastScrollSensitivity=34]="fastScrollSensitivity",V[V.find=35]="find",V[V.fixedOverflowWidgets=36]="fixedOverflowWidgets",V[V.folding=37]="folding",V[V.foldingStrategy=38]="foldingStrategy",V[V.foldingHighlight=39]="foldingHighlight",V[V.foldingImportsByDefault=40]="foldingImportsByDefault",V[V.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=42]="fontFamily",V[V.fontInfo=43]="fontInfo",V[V.fontLigatures=44]="fontLigatures",V[V.fontSize=45]="fontSize",V[V.fontWeight=46]="fontWeight",V[V.formatOnPaste=47]="formatOnPaste",V[V.formatOnType=48]="formatOnType",V[V.glyphMargin=49]="glyphMargin",V[V.gotoLocation=50]="gotoLocation",V[V.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",V[V.hover=52]="hover",V[V.inDiffEditor=53]="inDiffEditor",V[V.inlineSuggest=54]="inlineSuggest",V[V.letterSpacing=55]="letterSpacing",V[V.lightbulb=56]="lightbulb",V[V.lineDecorationsWidth=57]="lineDecorationsWidth",V[V.lineHeight=58]="lineHeight",V[V.lineNumbers=59]="lineNumbers",V[V.lineNumbersMinChars=60]="lineNumbersMinChars",V[V.linkedEditing=61]="linkedEditing",V[V.links=62]="links",V[V.matchBrackets=63]="matchBrackets",V[V.minimap=64]="minimap",V[V.mouseStyle=65]="mouseStyle",V[V.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=67]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",V[V.multiCursorModifier=69]="multiCursorModifier",V[V.multiCursorPaste=70]="multiCursorPaste",V[V.occurrencesHighlight=71]="occurrencesHighlight",V[V.overviewRulerBorder=72]="overviewRulerBorder",V[V.overviewRulerLanes=73]="overviewRulerLanes",V[V.padding=74]="padding",V[V.parameterHints=75]="parameterHints",V[V.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",V[V.quickSuggestions=78]="quickSuggestions",V[V.quickSuggestionsDelay=79]="quickSuggestionsDelay",V[V.readOnly=80]="readOnly",V[V.renameOnType=81]="renameOnType",V[V.renderControlCharacters=82]="renderControlCharacters",V[V.renderFinalNewline=83]="renderFinalNewline",V[V.renderLineHighlight=84]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=86]="renderValidationDecorations",V[V.renderWhitespace=87]="renderWhitespace",V[V.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",V[V.roundedSelection=89]="roundedSelection",V[V.rulers=90]="rulers",V[V.scrollbar=91]="scrollbar",V[V.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=93]="scrollBeyondLastLine",V[V.scrollPredominantAxis=94]="scrollPredominantAxis",V[V.selectionClipboard=95]="selectionClipboard",V[V.selectionHighlight=96]="selectionHighlight",V[V.selectOnLineNumbers=97]="selectOnLineNumbers",V[V.showFoldingControls=98]="showFoldingControls",V[V.showUnused=99]="showUnused",V[V.snippetSuggestions=100]="snippetSuggestions",V[V.smartSelect=101]="smartSelect",V[V.smoothScrolling=102]="smoothScrolling",V[V.stickyTabStops=103]="stickyTabStops",V[V.stopRenderingLineAfter=104]="stopRenderingLineAfter",V[V.suggest=105]="suggest",V[V.suggestFontSize=106]="suggestFontSize",V[V.suggestLineHeight=107]="suggestLineHeight",V[V.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",V[V.suggestSelection=109]="suggestSelection",V[V.tabCompletion=110]="tabCompletion",V[V.tabIndex=111]="tabIndex",V[V.unicodeHighlighting=112]="unicodeHighlighting",V[V.unusualLineTerminators=113]="unusualLineTerminators",V[V.useShadowDOM=114]="useShadowDOM",V[V.useTabStops=115]="useTabStops",V[V.wordSeparators=116]="wordSeparators",V[V.wordWrap=117]="wordWrap",V[V.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=120]="wordWrapColumn",V[V.wordWrapOverride1=121]="wordWrapOverride1",V[V.wordWrapOverride2=122]="wordWrapOverride2",V[V.wrappingIndent=123]="wrappingIndent",V[V.wrappingStrategy=124]="wrappingStrategy",V[V.showDeprecated=125]="showDeprecated",V[V.inlayHints=126]="inlayHints",V[V.editorClassName=127]="editorClassName",V[V.pixelRatio=128]="pixelRatio",V[V.tabFocusMode=129]="tabFocusMode",V[V.layoutInfo=130]="layoutInfo",V[V.wrappingInfo=131]="wrappingInfo"})(Mt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Oe(new D(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(147,null)})),acceptSuggestionOnEnter:Oe(new M(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(148,null),""],markdownDescription:a.localize(149,null)})),accessibilitySupport:Oe(new h),accessibilityPageSize:Oe(new f(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(150,null)})),ariaLabel:Oe(new I(4,"ariaLabel",a.localize(151,null))),autoClosingBrackets:Oe(new M(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(152,null),a.localize(153,null),""],description:a.localize(154,null)})),autoClosingDelete:Oe(new M(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(155,null),""],description:a.localize(156,null)})),autoClosingOvertype:Oe(new M(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(157,null),""],description:a.localize(158,null)})),autoClosingQuotes:Oe(new M(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(159,null),a.localize(160,null),""],description:a.localize(161,null)})),autoIndent:Oe(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[a.localize(162,null),a.localize(163,null),a.localize(164,null),a.localize(165,null),a.localize(166,null)],description:a.localize(167,null)})),automaticLayout:Oe(new D(10,"automaticLayout",!1)),autoSurround:Oe(new M(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(168,null),a.localize(169,null),a.localize(170,null),""],description:a.localize(171,null)})),bracketPairColorization:Oe(new fe),bracketPairGuides:Oe(new Ae),stickyTabStops:Oe(new D(103,"stickyTabStops",!1,{description:a.localize(172,null)})),codeLens:Oe(new D(14,"codeLens",!0,{description:a.localize(173,null)})),codeLensFontFamily:Oe(new I(15,"codeLensFontFamily","",{description:a.localize(174,null)})),codeLensFontSize:Oe(new f(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(175,null)})),colorDecorators:Oe(new D(17,"colorDecorators",!0,{description:a.localize(176,null)})),columnSelection:Oe(new D(18,"columnSelection",!1,{description:a.localize(177,null)})),comments:Oe(new u),contextmenu:Oe(new D(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Oe(new D(21,"copyWithSyntaxHighlighting",!0,{description:a.localize(178,null)})),cursorBlinking:Oe(new o(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],b,{description:a.localize(179,null)})),cursorSmoothCaretAnimation:Oe(new D(23,"cursorSmoothCaretAnimation",!1,{description:a.localize(180,null)})),cursorStyle:Oe(new o(24,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],S,{description:a.localize(181,null)})),cursorSurroundingLines:Oe(new f(25,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(182,null)})),cursorSurroundingLinesStyle:Oe(new M(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(183,null),a.localize(184,null)],description:a.localize(185,null)})),cursorWidth:Oe(new f(27,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(186,null)})),disableLayerHinting:Oe(new D(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Oe(new D(29,"disableMonospaceOptimizations",!1)),domReadOnly:Oe(new D(30,"domReadOnly",!1)),dragAndDrop:Oe(new D(31,"dragAndDrop",!0,{description:a.localize(187,null)})),emptySelectionClipboard:Oe(new U),extraEditorClassName:Oe(new I(33,"extraEditorClassName","")),fastScrollSensitivity:Oe(new p(34,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:a.localize(188,null)})),find:Oe(new H),fixedOverflowWidgets:Oe(new D(36,"fixedOverflowWidgets",!1)),folding:Oe(new D(37,"folding",!0,{description:a.localize(189,null)})),foldingStrategy:Oe(new M(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(190,null),a.localize(191,null)],description:a.localize(192,null)})),foldingHighlight:Oe(new D(39,"foldingHighlight",!0,{description:a.localize(193,null)})),foldingImportsByDefault:Oe(new D(40,"foldingImportsByDefault",!1,{description:a.localize(194,null)})),unfoldOnClickAfterEndOfLine:Oe(new D(41,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(195,null)})),fontFamily:Oe(new I(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(196,null)})),fontInfo:Oe(new L),fontLigatures2:Oe(new E),fontSize:Oe(new z),fontWeight:Oe(new N),formatOnPaste:Oe(new D(47,"formatOnPaste",!1,{description:a.localize(197,null)})),formatOnType:Oe(new D(48,"formatOnType",!1,{description:a.localize(198,null)})),glyphMargin:Oe(new D(49,"glyphMargin",!0,{description:a.localize(199,null)})),gotoLocation:Oe(new $),hideCursorInOverviewRuler:Oe(new D(51,"hideCursorInOverviewRuler",!1,{description:a.localize(200,null)})),hover:Oe(new j),inDiffEditor:Oe(new D(53,"inDiffEditor",!1)),letterSpacing:Oe(new p(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>p.clamp(V,-5,20),{description:a.localize(201,null)})),lightbulb:Oe(new ie),lineDecorationsWidth:Oe(new g(57,"lineDecorationsWidth",10)),lineHeight:Oe(new we),lineNumbers:Oe(new je),lineNumbersMinChars:Oe(new f(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Oe(new D(61,"linkedEditing",!1,{description:a.localize(202,null)})),links:Oe(new D(62,"links",!0,{description:a.localize(203,null)})),matchBrackets:Oe(new M(63,"matchBrackets","always",["always","near","never"],{description:a.localize(204,null)})),minimap:Oe(new ae),mouseStyle:Oe(new M(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Oe(new p(66,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:a.localize(205,null)})),mouseWheelZoom:Oe(new D(67,"mouseWheelZoom",!1,{markdownDescription:a.localize(206,null)})),multiCursorMergeOverlapping:Oe(new D(68,"multiCursorMergeOverlapping",!0,{description:a.localize(207,null)})),multiCursorModifier:Oe(new o(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[a.localize(208,null),a.localize(209,null)],markdownDescription:a.localize(210,null)})),multiCursorPaste:Oe(new M(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(211,null),a.localize(212,null)],markdownDescription:a.localize(213,null)})),occurrencesHighlight:Oe(new D(71,"occurrencesHighlight",!0,{description:a.localize(214,null)})),overviewRulerBorder:Oe(new D(72,"overviewRulerBorder",!0,{description:a.localize(215,null)})),overviewRulerLanes:Oe(new f(73,"overviewRulerLanes",3,0,3)),padding:Oe(new Se),parameterHints:Oe(new Ce),peekWidgetDefaultFocus:Oe(new M(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(216,null),a.localize(217,null)],description:a.localize(218,null)})),definitionLinkOpensInPeek:Oe(new D(77,"definitionLinkOpensInPeek",!1,{description:a.localize(219,null)})),quickSuggestions:Oe(new $e),quickSuggestionsDelay:Oe(new f(79,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(220,null)})),readOnly:Oe(new D(80,"readOnly",!1)),renameOnType:Oe(new D(81,"renameOnType",!1,{description:a.localize(221,null),markdownDeprecationMessage:a.localize(222,null)})),renderControlCharacters:Oe(new D(82,"renderControlCharacters",!0,{description:a.localize(223,null),restricted:!0})),renderFinalNewline:Oe(new D(83,"renderFinalNewline",!0,{description:a.localize(224,null)})),renderLineHighlight:Oe(new M(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(225,null)],description:a.localize(226,null)})),renderLineHighlightOnlyWhenFocus:Oe(new D(85,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(227,null)})),renderValidationDecorations:Oe(new M(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Oe(new M(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(228,null),a.localize(229,null),a.localize(230,null),""],description:a.localize(231,null)})),revealHorizontalRightPadding:Oe(new f(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Oe(new D(89,"roundedSelection",!0,{description:a.localize(232,null)})),rulers:Oe(new G),scrollbar:Oe(new se),scrollBeyondLastColumn:Oe(new f(92,"scrollBeyondLastColumn",5,0,1073741824,{description:a.localize(233,null)})),scrollBeyondLastLine:Oe(new D(93,"scrollBeyondLastLine",!0,{description:a.localize(234,null)})),scrollPredominantAxis:Oe(new D(94,"scrollPredominantAxis",!0,{description:a.localize(235,null)})),selectionClipboard:Oe(new D(95,"selectionClipboard",!0,{description:a.localize(236,null),included:t.isLinux})),selectionHighlight:Oe(new D(96,"selectionHighlight",!0,{description:a.localize(237,null)})),selectOnLineNumbers:Oe(new D(97,"selectOnLineNumbers",!0)),showFoldingControls:Oe(new M(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[a.localize(238,null),a.localize(239,null)],description:a.localize(240,null)})),showUnused:Oe(new D(99,"showUnused",!0,{description:a.localize(241,null)})),showDeprecated:Oe(new D(125,"showDeprecated",!0,{description:a.localize(242,null)})),inlayHints:Oe(new pe),snippetSuggestions:Oe(new M(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(243,null),a.localize(244,null),a.localize(245,null),a.localize(246,null)],description:a.localize(247,null)})),smartSelect:Oe(new Xe),smoothScrolling:Oe(new D(102,"smoothScrolling",!1,{description:a.localize(248,null)})),stopRenderingLineAfter:Oe(new f(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Oe(new ze),inlineSuggest:Oe(new ee),suggestFontSize:Oe(new f(106,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(249,null)})),suggestLineHeight:Oe(new f(107,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(250,null)})),suggestOnTriggerCharacters:Oe(new D(108,"suggestOnTriggerCharacters",!0,{description:a.localize(251,null)})),suggestSelection:Oe(new M(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(252,null),a.localize(253,null),a.localize(254,null)],description:a.localize(255,null)})),tabCompletion:Oe(new M(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(256,null),a.localize(257,null),a.localize(258,null)],description:a.localize(259,null)})),tabIndex:Oe(new f(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:Oe(new q),unusualLineTerminators:Oe(new M(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(260,null),a.localize(261,null),a.localize(262,null)],description:a.localize(263,null)})),useShadowDOM:Oe(new D(114,"useShadowDOM",!0)),useTabStops:Oe(new D(115,"useTabStops",!0,{description:a.localize(264,null)})),wordSeparators:Oe(new I(116,"wordSeparators",w.USUAL_WORD_SEPARATORS,{description:a.localize(265,null)})),wordWrap:Oe(new M(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(266,null),a.localize(267,null),a.localize(268,null),a.localize(269,null)],description:a.localize(270,null)})),wordWrapBreakAfterCharacters:Oe(new I(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Oe(new I(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Oe(new f(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(271,null)})),wordWrapOverride1:Oe(new M(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Oe(new M(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Oe(new o(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Je,{enumDescriptions:[a.localize(272,null),a.localize(273,null),a.localize(274,null),a.localize(275,null)],description:a.localize(276,null)})),wrappingStrategy:Oe(new M(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[a.localize(277,null),a.localize(278,null)],description:a.localize(279,null)})),editorClassName:Oe(new A),pixelRatio:Oe(new Fe),tabFocusMode:Oe(new et),layoutInfo:Oe(new K),wrappingInfo:Oe(new nt)}}),define(Ee[115],ye([18,19]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[116],ye([18,19]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[117],ye([18,19]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(Ee[118],ye([18,19]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(Ee[119],ye([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[120],ye([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[121],ye([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(Ee[122],ye([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[123],ye([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[124],ye([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[125],ye([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[126],ye([18,19]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(Ee[127],ye([18,19]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[128],ye([18,19]),function(ne,e){return ne.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(Ee[129],ye([18,19]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Ee[130],ye([18,19]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[131],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var a;(function(k){k[k.ACTIVATE=1]="ACTIVATE",k[k.RESTORE=2]="RESTORE",k[k.PRESERVE=3]="PRESERVE"})(a=e.EditorActivation||(e.EditorActivation={}));var t;(function(k){k[k.PICK=0]="PICK",k[k.DISABLED=1]="DISABLED",k[k.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var w;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(w=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(Ee[132],ye([0,1,116]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function T(n){return n=n.trim(),n==="*"||t.test(n)}e.isValidVersionStr=T;function k(n){if(!T(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=n.match(t);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=k;function P(n){if(!n)return null;let m=n.majorBase,r=n.majorMustEqual,g=n.minorBase,d=n.minorMustEqual,D=n.patchBase,v=n.patchMustEqual;n.hasCaret&&(m===0||(d=!1),v=!1);let f=0;if(n.preRelease){const p=w.exec(n.preRelease);if(p){const[,I,l,M]=p;f=Date.UTC(Number(I),Number(l)-1,Number(M))}}return{majorBase:m,majorMustEqual:r,minorBase:g,minorMustEqual:d,patchBase:D,patchMustEqual:v,isMinimum:n.hasGreaterEquals,notBefore:f}}e.normalizeVersion=P;function C(n,m,r){let g;typeof n=="string"?g=P(k(n)):g=n;let d;m instanceof Date?d=m.getTime():typeof m=="string"&&(d=new Date(m).getTime());let D;if(typeof r=="string"?D=P(k(r)):D=r,!g||!D)return!1;let v=g.majorBase,f=g.minorBase,p=g.patchBase,I=D.majorBase,l=D.minorBase,M=D.patchBase,o=D.notBefore,i=D.majorMustEqual,h=D.minorMustEqual,u=D.patchMustEqual;return D.isMinimum?v>I?!0:v<I?!1:f>l?!0:f<l||d&&d<o?!1:p>=M:(v===1&&I===0&&(!i||!h||!u)&&(I=1,l=0,M=0,i=!0,h=!1,u=!1),v<I?!1:v>I?!i:f<l?!1:f>l?!h:p<M?!1:p>M?!u:!(d&&d<o))}e.isValidVersion=C;function R(n,m,r,g){return r.isBuiltin||typeof r.main=="undefined"?!0:_(n,m,r.engines.vscode,g)}e.isValidExtensionVersion=R;function F(n,m,r){return n==="*"||_(m,r,n)}e.isEngineValid=F;function _(n,m,r,g=[]){let d=P(k(r));if(!d)return g.push(a.localize(0,null,r)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return g.push(a.localize(1,null,r)),!1}else if(!d.majorMustEqual)return g.push(a.localize(2,null,r)),!1;return C(n,m,d)?!0:(g.push(a.localize(3,null,n,r)),!1)}}),define(Ee[80],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(w,T=[],k=!1){this.ctor=w,this.staticArguments=T,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=a}),define(Ee[56],ye([0,1,80]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function w(k,P,C){P instanceof a.SyncDescriptor||(P=new a.SyncDescriptor(P,[],C)),t.push([k,P])}e.registerSingleton=w;function T(){return t}e.getSingletonServiceDescriptors=T}),define(Ee[133],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=a;class t{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let k of this._nodes.values())k.outgoing.size===0&&T.push(k);return T}insertEdge(T,k){const P=this.lookupOrInsertNode(T),C=this.lookupOrInsertNode(k);P.outgoing.set(this._hashFn(k),C),C.incoming.set(this._hashFn(T),P)}removeNode(T){const k=this._hashFn(T);this._nodes.delete(k);for(let P of this._nodes.values())P.outgoing.delete(k),P.incoming.delete(k)}lookupOrInsertNode(T){const k=this._hashFn(T);let P=this._nodes.get(k);return P||(P=new a(T),this._nodes.set(k,P)),P}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[k,P]of this._nodes)T.push(`${k}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,k]of this._nodes){const P=new Set([T]),C=this._findCycle(k,P);if(C)return C}}_findCycle(T,k){for(let[P,C]of T.outgoing){if(k.has(P))return[...k,P].join(" -> ");k.add(P);const R=this._findCycle(C,k);if(R)return R;k.delete(P)}}}e.Graph=t}),define(Ee[3],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function P(C){return C[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=P})(a=e._util||(e._util={})),e.IInstantiationService=w("instantiationService");function t(k,P,C,R){P[a.DI_TARGET]===P?P[a.DI_DEPENDENCIES].push({id:k,index:C,optional:R}):(P[a.DI_DEPENDENCIES]=[{id:k,index:C,optional:R}],P[a.DI_TARGET]=P)}function w(k){if(a.serviceIds.has(k))return a.serviceIds.get(k);const P=function(C,R,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,C,F,!1)};return P.toString=()=>k,a.serviceIds.set(k,P),P}e.createDecorator=w;function T(k){return k}e.refineServiceDecorator=T}),define(Ee[134],ye([0,1,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,a.createDecorator)("modelService");function t(w){return!w.isTooLargeForSyncing()&&!w.isForSimpleWidget}e.shouldSynchronizeModel=t}),define(Ee[135],ye([0,1,4,57,6,21,75,55,134]),function(ne,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function R(g){return typeof g=="string"?!1:Array.isArray(g)?g.every(R):!!g.exclusive}class F{constructor(){this._clock=0,this._entries=[],this._onDidChange=new a.Emitter}get onDidChange(){return this._onDidChange.event}register(d,D){let v={selector:d,provider:D,_score:-1,_time:this._clock++};return this._entries.push(v),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,w.toDisposable)(()=>{if(v){let f=this._entries.indexOf(v);f>=0&&(this._entries.splice(f,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),v=void 0)}})}has(d){return this.all(d).length>0}all(d){if(!d)return[];this._updateScores(d);const D=[];for(let v of this._entries)v._score>0&&D.push(v.provider);return D}ordered(d){const D=[];return this._orderedForEach(d,v=>D.push(v.provider)),D}orderedGroups(d){const D=[];let v,f;return this._orderedForEach(d,p=>{v&&f===p._score?v.push(p.provider):(f=p._score,v=[p.provider],D.push(v))}),D}_orderedForEach(d,D){if(!!d){this._updateScores(d);for(const v of this._entries)v._score>0&&D(v)}}_updateScores(d){let D={uri:d.uri.toString(),language:d.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===D.language&&this._lastCandidate.uri===D.uri)){this._lastCandidate=D;for(let v of this._entries)if(v._score=(0,P.score)(v.selector,d.uri,d.getLanguageId(),(0,C.shouldSynchronizeModel)(d)),R(v.selector)&&v._score>0){for(let f of this._entries)f._score=0;v._score=1e3;break}this._entries.sort(F._compareByScoreAndTime)}}static _compareByScoreAndTime(d,D){return d._score<D._score?1:d._score>D._score?-1:d._time<D._time?1:d._time>D._time?-1:0}}e.LanguageFeatureRegistry=F;const _=new WeakMap;let n=0;function m(g){let d=_.get(g);return d===void 0&&(d=++n,_.set(g,d)),d}class r{constructor(d,D,v=Number.MAX_SAFE_INTEGER){this._registry=d,this.min=D,this.max=v,this._cache=new T.LRUCache(50,.7)}_key(d){return d.id+this._registry.all(d).reduce((D,v)=>(0,t.doHash)(m(v),D),0)}_clamp(d){return d===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(d*1.3)))}get(d){const D=this._key(d),v=this._cache.get(D);return this._clamp(v?.value)}update(d,D){const v=this._key(d);let f=this._cache.get(v);return f||(f=new k.MovingAverage,this._cache.set(v,f)),f.update(D),this.get(d)}}e.LanguageFeatureRequestDelays=r}),define(Ee[58],ye([0,1,2,59,135,108,51]),function(ne,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(c){c[c.Null=0]="Null",c[c.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));var C;(function(c){c[c.NotSet=-1]="NotSet",c[c.None=0]="None",c[c.Italic=1]="Italic",c[c.Bold=2]="Bold",c[c.Underline=4]="Underline",c[c.Strikethrough=8]="Strikethrough"})(C=e.FontStyle||(e.FontStyle={}));var R;(function(c){c[c.None=0]="None",c[c.DefaultForeground=1]="DefaultForeground",c[c.DefaultBackground=2]="DefaultBackground"})(R=e.ColorId||(e.ColorId={}));var F;(function(c){c[c.Other=0]="Other",c[c.Comment=1]="Comment",c[c.String=2]="String",c[c.RegEx=3]="RegEx"})(F=e.StandardTokenType||(e.StandardTokenType={}));var _;(function(c){c[c.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",c[c.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",c[c.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",c[c.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",c[c.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",c[c.ITALIC_MASK=1024]="ITALIC_MASK",c[c.BOLD_MASK=2048]="BOLD_MASK",c[c.UNDERLINE_MASK=4096]="UNDERLINE_MASK",c[c.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",c[c.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",c[c.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",c[c.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",c[c.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",c[c.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",c[c.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",c[c.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",c[c.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",c[c.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",c[c.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(_=e.MetadataConsts||(e.MetadataConsts={}));class n{static getLanguageId(S){return(S&255)>>>0}static getTokenType(S){return(S&768)>>>8}static getFontStyle(S){return(S&15360)>>>10}static getForeground(S){return(S&8372224)>>>14}static getBackground(S){return(S&4286578688)>>>23}static getClassNameFromMetadata(S){let A=this.getForeground(S),U="mtk"+A,H=this.getFontStyle(S);return H&1&&(U+=" mtki"),H&2&&(U+=" mtkb"),H&4&&(U+=" mtku"),U}static getInlineStyleFromMetadata(S,A){const U=this.getForeground(S),H=this.getFontStyle(S);let E=`color: ${A[U]};`;return H&1&&(E+="font-style: italic;"),H&2&&(E+="font-weight: bold;"),H&4&&(E+="text-decoration: underline;"),E}}e.TokenMetadata=n;var m;(function(c){c[c.Method=0]="Method",c[c.Function=1]="Function",c[c.Constructor=2]="Constructor",c[c.Field=3]="Field",c[c.Variable=4]="Variable",c[c.Class=5]="Class",c[c.Struct=6]="Struct",c[c.Interface=7]="Interface",c[c.Module=8]="Module",c[c.Property=9]="Property",c[c.Event=10]="Event",c[c.Operator=11]="Operator",c[c.Unit=12]="Unit",c[c.Value=13]="Value",c[c.Constant=14]="Constant",c[c.Enum=15]="Enum",c[c.EnumMember=16]="EnumMember",c[c.Keyword=17]="Keyword",c[c.Text=18]="Text",c[c.Color=19]="Color",c[c.File=20]="File",c[c.Reference=21]="Reference",c[c.Customcolor=22]="Customcolor",c[c.Folder=23]="Folder",c[c.TypeParameter=24]="TypeParameter",c[c.User=25]="User",c[c.Issue=26]="Issue",c[c.Snippet=27]="Snippet"})(m=e.CompletionItemKind||(e.CompletionItemKind={}));var r;(function(c){const S=new Map;S.set(0,k.Codicon.symbolMethod),S.set(1,k.Codicon.symbolFunction),S.set(2,k.Codicon.symbolConstructor),S.set(3,k.Codicon.symbolField),S.set(4,k.Codicon.symbolVariable),S.set(5,k.Codicon.symbolClass),S.set(6,k.Codicon.symbolStruct),S.set(7,k.Codicon.symbolInterface),S.set(8,k.Codicon.symbolModule),S.set(9,k.Codicon.symbolProperty),S.set(10,k.Codicon.symbolEvent),S.set(11,k.Codicon.symbolOperator),S.set(12,k.Codicon.symbolUnit),S.set(13,k.Codicon.symbolValue),S.set(15,k.Codicon.symbolEnum),S.set(14,k.Codicon.symbolConstant),S.set(15,k.Codicon.symbolEnum),S.set(16,k.Codicon.symbolEnumMember),S.set(17,k.Codicon.symbolKeyword),S.set(27,k.Codicon.symbolSnippet),S.set(18,k.Codicon.symbolText),S.set(19,k.Codicon.symbolColor),S.set(20,k.Codicon.symbolFile),S.set(21,k.Codicon.symbolReference),S.set(22,k.Codicon.symbolCustomColor),S.set(23,k.Codicon.symbolFolder),S.set(24,k.Codicon.symbolTypeParameter),S.set(25,k.Codicon.account),S.set(26,k.Codicon.issues);function A(E){let L=S.get(E);return L||(console.info("No codicon found for CompletionItemKind "+E),L=k.Codicon.symbolProperty),L}c.toIcon=A;const U=new Map;U.set("method",0),U.set("function",1),U.set("constructor",2),U.set("field",3),U.set("variable",4),U.set("class",5),U.set("struct",6),U.set("interface",7),U.set("module",8),U.set("property",9),U.set("event",10),U.set("operator",11),U.set("unit",12),U.set("value",13),U.set("constant",14),U.set("enum",15),U.set("enum-member",16),U.set("enumMember",16),U.set("keyword",17),U.set("snippet",27),U.set("text",18),U.set("color",19),U.set("file",20),U.set("reference",21),U.set("customcolor",22),U.set("folder",23),U.set("type-parameter",24),U.set("typeParameter",24),U.set("account",25),U.set("issue",26);function H(E,L){let z=U.get(E);return typeof z=="undefined"&&!L&&(z=9),z}c.fromString=H})(r=e.CompletionItemKinds||(e.CompletionItemKinds={}));var g;(function(c){c[c.Deprecated=1]="Deprecated"})(g=e.CompletionItemTag||(e.CompletionItemTag={}));var d;(function(c){c[c.KeepWhitespace=1]="KeepWhitespace",c[c.InsertAsSnippet=4]="InsertAsSnippet"})(d=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var D;(function(c){c[c.Invoke=0]="Invoke",c[c.TriggerCharacter=1]="TriggerCharacter",c[c.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(D=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var v;(function(c){c[c.Automatic=0]="Automatic",c[c.Explicit=1]="Explicit"})(v=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var f;(function(c){c[c.Invoke=1]="Invoke",c[c.Auto=2]="Auto"})(f=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(c){c[c.Invoke=1]="Invoke",c[c.TriggerCharacter=2]="TriggerCharacter",c[c.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var I;(function(c){c[c.Text=0]="Text",c[c.Read=1]="Read",c[c.Write=2]="Write"})(I=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function l(c){return c&&a.URI.isUri(c.uri)&&t.Range.isIRange(c.range)&&(t.Range.isIRange(c.originSelectionRange)||t.Range.isIRange(c.targetSelectionRange))}e.isLocationLink=l;var M;(function(c){c[c.File=0]="File",c[c.Module=1]="Module",c[c.Namespace=2]="Namespace",c[c.Package=3]="Package",c[c.Class=4]="Class",c[c.Method=5]="Method",c[c.Property=6]="Property",c[c.Field=7]="Field",c[c.Constructor=8]="Constructor",c[c.Enum=9]="Enum",c[c.Interface=10]="Interface",c[c.Function=11]="Function",c[c.Variable=12]="Variable",c[c.Constant=13]="Constant",c[c.String=14]="String",c[c.Number=15]="Number",c[c.Boolean=16]="Boolean",c[c.Array=17]="Array",c[c.Object=18]="Object",c[c.Key=19]="Key",c[c.Null=20]="Null",c[c.EnumMember=21]="EnumMember",c[c.Struct=22]="Struct",c[c.Event=23]="Event",c[c.Operator=24]="Operator",c[c.TypeParameter=25]="TypeParameter"})(M=e.SymbolKind||(e.SymbolKind={}));var o;(function(c){c[c.Deprecated=1]="Deprecated"})(o=e.SymbolTag||(e.SymbolTag={}));var i;(function(c){const S=new Map;S.set(0,k.Codicon.symbolFile),S.set(1,k.Codicon.symbolModule),S.set(2,k.Codicon.symbolNamespace),S.set(3,k.Codicon.symbolPackage),S.set(4,k.Codicon.symbolClass),S.set(5,k.Codicon.symbolMethod),S.set(6,k.Codicon.symbolProperty),S.set(7,k.Codicon.symbolField),S.set(8,k.Codicon.symbolConstructor),S.set(9,k.Codicon.symbolEnum),S.set(10,k.Codicon.symbolInterface),S.set(11,k.Codicon.symbolFunction),S.set(12,k.Codicon.symbolVariable),S.set(13,k.Codicon.symbolConstant),S.set(14,k.Codicon.symbolString),S.set(15,k.Codicon.symbolNumber),S.set(16,k.Codicon.symbolBoolean),S.set(17,k.Codicon.symbolArray),S.set(18,k.Codicon.symbolObject),S.set(19,k.Codicon.symbolKey),S.set(20,k.Codicon.symbolNull),S.set(21,k.Codicon.symbolEnumMember),S.set(22,k.Codicon.symbolStruct),S.set(23,k.Codicon.symbolEvent),S.set(24,k.Codicon.symbolOperator),S.set(25,k.Codicon.symbolTypeParameter);function A(U){let H=S.get(U);return H||(console.info("No codicon found for SymbolKind "+U),H=k.Codicon.symbolProperty),H}c.toIcon=A})(i=e.SymbolKinds||(e.SymbolKinds={}));class h{constructor(S){this.value=S}}e.FoldingRangeKind=h,h.Comment=new h("comment"),h.Imports=new h("imports"),h.Region=new h("region");var u;(function(c){c[c.Collapsed=0]="Collapsed",c[c.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var s;(function(c){c[c.Editing=0]="Editing",c[c.Preview=1]="Preview"})(s=e.CommentMode||(e.CommentMode={}));var b;(function(c){c[c.Other=0]="Other",c[c.Type=1]="Type",c[c.Parameter=2]="Parameter"})(b=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new w.LanguageFeatureRegistry,e.RenameProviderRegistry=new w.LanguageFeatureRegistry,e.CompletionProviderRegistry=new w.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new w.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new w.LanguageFeatureRegistry,e.HoverProviderRegistry=new w.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new w.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new w.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new w.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new w.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new w.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new w.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new w.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new w.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new w.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.LinkProviderRegistry=new w.LanguageFeatureRegistry,e.ColorProviderRegistry=new w.LanguageFeatureRegistry,e.SelectionRangeRegistry=new w.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new w.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var y;(function(c){c[c.None=0]="None",c[c.Option=1]="Option",c[c.Default=2]="Default",c[c.Preferred=3]="Preferred"})(y=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ee[81],ye([0,1,11,2,3]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,w.createDecorator)("configurationService");function T(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationOverrides=T;function k(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||a.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=k;var P;(function(d){d[d.USER=1]="USER",d[d.USER_LOCAL=2]="USER_LOCAL",d[d.USER_REMOTE=3]="USER_REMOTE",d[d.WORKSPACE=4]="WORKSPACE",d[d.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",d[d.DEFAULT=6]="DEFAULT",d[d.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(d){switch(d){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function R(d,D){const v=Object.create(null);for(let f in d)F(v,f,d[f],D);return v}e.toValuesTree=R;function F(d,D,v,f){const p=D.split("."),I=p.pop();let l=d;for(let M=0;M<p.length;M++){let o=p[M],i=l[o];switch(typeof i){case"undefined":i=l[o]=Object.create(null);break;case"object":break;default:f(`Ignoring ${D} as ${p.slice(0,M+1).join(".")} is ${JSON.stringify(i)}`);return}l=i}if(typeof l=="object"&&l!==null)try{l[I]=v}catch{f(`Ignoring ${D} as ${p.join(".")} is ${JSON.stringify(l)}`)}else f(`Ignoring ${D} as ${p.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=F;function _(d,D){const v=D.split(".");n(d,v)}e.removeFromValueTree=_;function n(d,D){const v=D.shift();if(D.length===0){delete d[v];return}if(Object.keys(d).indexOf(v)!==-1){const f=d[v];typeof f=="object"&&!Array.isArray(f)&&(n(f,D),Object.keys(f).length===0&&delete d[v])}}function m(d,D,v){function f(l,M){let o=l;for(const i of M){if(typeof o!="object"||o===null)return;o=o[i]}return o}const p=D.split("."),I=f(d,p);return typeof I=="undefined"?v:I}e.getConfigurationValue=m;function r(d,D,v){Object.keys(D).forEach(f=>{f!=="__proto__"&&(f in d?a.isObject(d[f])&&a.isObject(D[f])?r(d[f],D[f],v):v&&(d[f]=D[f]):d[f]=D[f])})}e.merge=r;function g(d,D,v){const f=d.inspect(D),p=d.inspect(v);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:f.defaultValue}e.getMigratedSettingValue=g}),define(Ee[44],ye([0,1,23,9,3]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=a.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",a.isMacintosh),k.set("isLinux",a.isLinux),k.set("isWindows",a.isWindows),k.set("isWeb",a.isWeb),k.set("isMacNative",a.isMacintosh&&!a.isWeb),k.set("isEdge",T.indexOf("Edg/")>=0),k.set("isFirefox",T.indexOf("Firefox")>=0),k.set("isChrome",T.indexOf("Chrome")>=0),k.set("isSafari",T.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var C;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class R{static false(){return n.INSTANCE}static true(){return m.INSTANCE}static has(E){return r.create(E)}static equals(E,L){return g.create(E,L)}static notEquals(E,L){return v.create(E,L)}static regex(E,L){return i.create(E,L)}static in(E,L){return d.create(E,L)}static not(E){return f.create(E)}static and(...E){return s.create(E,null)}static or(...E){return b.create(E,null,!0)}static greater(E,L){return I.create(E,L)}static greaterEquals(E,L){return l.create(E,L)}static smaller(E,L){return M.create(E,L)}static smallerEquals(E,L){return o.create(E,L)}static deserialize(E,L=!1){if(!!E)return this._deserializeOrExpression(E,L)}static _deserializeOrExpression(E,L){let z=E.split("||");return b.create(z.map(N=>this._deserializeAndExpression(N,L)),null,!0)}static _deserializeAndExpression(E,L){let z=E.split("&&");return s.create(z.map(N=>this._deserializeOne(N,L)),null)}static _deserializeOne(E,L){if(E=E.trim(),E.indexOf("!=")>=0){let z=E.split("!=");return v.create(z[0].trim(),this._deserializeValue(z[1],L))}if(E.indexOf("==")>=0){let z=E.split("==");return g.create(z[0].trim(),this._deserializeValue(z[1],L))}if(E.indexOf("=~")>=0){let z=E.split("=~");return i.create(z[0].trim(),this._deserializeRegexValue(z[1],L))}if(E.indexOf(" in ")>=0){let z=E.split(" in ");return d.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(E)){const z=E.split(">=");return l.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(E)){const z=E.split(">");return I.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(E)){const z=E.split("<=");return o.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(E)){const z=E.split("<");return M.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(E)?f.create(E.substr(1).trim()):r.create(E)}static _deserializeValue(E,L){if(E=E.trim(),E==="true")return!0;if(E==="false")return!1;let z=/^'([^']*)'$/.exec(E);return z?z[1].trim():E}static _deserializeRegexValue(E,L){if((0,t.isFalsyOrWhitespace)(E)){if(L)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=E.indexOf("/"),N=E.lastIndexOf("/");if(z===N||z<0){if(L)throw new Error(`bad regexp-value '${E}', missing /-enclosure`);return console.warn(`bad regexp-value '${E}', missing /-enclosure`),null}let $=E.slice(z+1,N),j=E[N+1]==="i"?"i":"";try{return new RegExp($,j)}catch(ue){if(L)throw new Error(`bad regexp-value '${E}', parse error: ${ue}`);return console.warn(`bad regexp-value '${E}', parse error: ${ue}`),null}}}e.ContextKeyExpr=R;function F(H,E){const L=H?H.substituteConstants():void 0,z=E?E.substituteConstants():void 0;return!L&&!z?!0:!L||!z?!1:L.equals(z)}e.expressionsAreEqualWithConstantSubstitution=F;function _(H,E){return H.cmp(E)}class n{constructor(){this.type=0}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class m{constructor(){this.type=1}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class r{constructor(E,L){this.key=E,this.negated=L,this.type=2}static create(E,L=null){const z=k.get(E);return typeof z=="boolean"?z?m.INSTANCE:n.INSTANCE:new r(E,L)}cmp(E){return E.type!==this.type?this.type-E.type:c(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=k.get(this.key);return typeof E=="boolean"?E?m.INSTANCE:n.INSTANCE:this}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=r;class g{constructor(E,L,z){this.key=E,this.value=L,this.negated=z,this.type=4}static create(E,L,z=null){if(typeof L=="boolean")return L?r.create(E,z):f.create(E,z);const N=k.get(E);return typeof N=="boolean"?L===(N?"true":"false")?m.INSTANCE:n.INSTANCE:new g(E,L,z)}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=k.get(this.key);if(typeof E=="boolean"){const L=E?"true":"false";return this.value===L?m.INSTANCE:n.INSTANCE}return this}evaluate(E){return E.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(E){return E.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=g;class d{constructor(E,L){this.key=E,this.valueKey=L,this.type=10,this.negated=null}static create(E,L){return new d(E,L)}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.valueKey,E.key,E.valueKey)}equals(E){return E.type===this.type?this.key===E.key&&this.valueKey===E.valueKey:!1}substituteConstants(){return this}evaluate(E){const L=E.getValue(this.valueKey),z=E.getValue(this.key);return Array.isArray(L)?L.indexOf(z)>=0:typeof z=="string"&&typeof L=="object"&&L!==null?P.call(L,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(E){return E.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=D.create(this)),this.negated}}e.ContextKeyInExpr=d;class D{constructor(E){this._actual=E,this.type=11}static create(E){return new D(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new D(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotInExpr=D;class v{constructor(E,L,z){this.key=E,this.value=L,this.negated=z,this.type=5}static create(E,L,z=null){if(typeof L=="boolean")return L?f.create(E,z):r.create(E,z);const N=k.get(E);return typeof N=="boolean"?L===(N?"true":"false")?n.INSTANCE:m.INSTANCE:new v(E,L,z)}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=k.get(this.key);if(typeof E=="boolean"){const L=E?"true":"false";return this.value===L?n.INSTANCE:m.INSTANCE}return this}evaluate(E){return E.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(E){return E.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=v;class f{constructor(E,L){this.key=E,this.negated=L,this.type=3}static create(E,L=null){const z=k.get(E);return typeof z=="boolean"?z?n.INSTANCE:m.INSTANCE:new f(E,L)}cmp(E){return E.type!==this.type?this.type-E.type:c(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=k.get(this.key);return typeof E=="boolean"?E?n.INSTANCE:m.INSTANCE:this}evaluate(E){return!E.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(E){return E.mapNot(this.key)}negate(){return this.negated||(this.negated=r.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=f;function p(H,E){if(typeof H=="string"){const L=parseFloat(H);isNaN(L)||(H=L)}return typeof H=="string"||typeof H=="number"?E(H):n.INSTANCE}class I{constructor(E,L,z){this.key=E,this.value=L,this.negated=z,this.type=12}static create(E,L,z=null){return p(L,N=>new I(E,N,z))}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=I;class l{constructor(E,L,z){this.key=E,this.value=L,this.negated=z,this.type=13}static create(E,L,z=null){return p(L,N=>new l(E,N,z))}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class M{constructor(E,L,z){this.key=E,this.value=L,this.negated=z,this.type=14}static create(E,L,z=null){return p(L,N=>new M(E,N,z))}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=M;class o{constructor(E,L,z){this.key=E,this.value=L,this.negated=z,this.type=15}static create(E,L,z=null){return p(L,N=>new o(E,N,z))}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=o;class i{constructor(E,L){this.key=E,this.regexp=L,this.type=7,this.negated=null}static create(E,L){return new i(E,L)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.key<E.key)return-1;if(this.key>E.key)return 1;const L=this.regexp?this.regexp.source:"",z=E.regexp?E.regexp.source:"";return L<z?-1:L>z?1:0}equals(E){if(E.type===this.type){const L=this.regexp?this.regexp.source:"",z=E.regexp?E.regexp.source:"";return this.key===E.key&&L===z}return!1}substituteConstants(){return this}evaluate(E){let L=E.getValue(this.key);return this.regexp?this.regexp.test(L):!1}serialize(){const E=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${E}`}keys(){return[this.key]}map(E){return E.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=h.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class h{constructor(E){this._actual=E,this.type=8}static create(E){return new h(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new h(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=h;function u(H){let E=null;for(let L=0,z=H.length;L<z;L++){const N=H[L].substituteConstants();if(H[L]!==N&&E===null){E=[];for(let $=0;$<L;$++)E[$]=H[$]}E!==null&&(E[L]=N)}return E===null?H:E}class s{constructor(E,L){this.expr=E,this.negated=L,this.type=6}static create(E,L){return s._normalizeArr(E,L)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let L=0,z=this.expr.length;L<z;L++){const N=_(this.expr[L],E.expr[L]);if(N!==0)return N}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let L=0,z=this.expr.length;L<z;L++)if(!this.expr[L].equals(E.expr[L]))return!1;return!0}return!1}substituteConstants(){const E=u(this.expr);return E===this.expr?this:s.create(E,this.negated)}evaluate(E){for(let L=0,z=this.expr.length;L<z;L++)if(!this.expr[L].evaluate(E))return!1;return!0}static _normalizeArr(E,L){const z=[];let N=!1;for(const $ of E)if(!!$){if($.type===1){N=!0;continue}if($.type===0)return n.INSTANCE;if($.type===6){z.push(...$.expr);continue}z.push($)}if(z.length===0&&N)return m.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(_);for(let $=1;$<z.length;$++)z[$-1].equals(z[$])&&(z.splice($,1),$--);if(z.length===1)return z[0];for(;z.length>1;){const $=z[z.length-1];if($.type!==9)break;z.pop();const j=z.pop(),ue=z.length===0,K=b.create($.expr.map(ie=>s.create([ie,j],null)),null,ue);K&&(z.push(K),z.sort(_))}return z.length===1?z[0]:new s(z,L)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(let L of this.expr)E.push(...L.keys());return E}map(E){return new s(this.expr.map(L=>L.map(E)),null)}negate(){if(!this.negated){const E=[];for(let L of this.expr)E.push(L.negate());this.negated=b.create(E,this,!0)}return this.negated}}class b{constructor(E,L){this.expr=E,this.negated=L,this.type=9}static create(E,L,z){return b._normalizeArr(E,L,z)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let L=0,z=this.expr.length;L<z;L++){const N=_(this.expr[L],E.expr[L]);if(N!==0)return N}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let L=0,z=this.expr.length;L<z;L++)if(!this.expr[L].equals(E.expr[L]))return!1;return!0}return!1}substituteConstants(){const E=u(this.expr);return E===this.expr?this:b.create(E,this.negated,!1)}evaluate(E){for(let L=0,z=this.expr.length;L<z;L++)if(this.expr[L].evaluate(E))return!0;return!1}static _normalizeArr(E,L,z){let N=[],$=!1;if(E){for(let j=0,ue=E.length;j<ue;j++){const K=E[j];if(!!K){if(K.type===0){$=!0;continue}if(K.type===1)return m.INSTANCE;if(K.type===9){N=N.concat(K.expr);continue}N.push(K)}}if(N.length===0&&$)return n.INSTANCE;N.sort(_)}if(N.length!==0){if(N.length===1)return N[0];for(let j=1;j<N.length;j++)N[j-1].equals(N[j])&&(N.splice(j,1),j--);if(N.length===1)return N[0];if(z){for(let j=0;j<N.length;j++)for(let ue=j+1;ue<N.length;ue++)A(N[j],N[ue])&&(N.splice(ue,1),ue--);if(N.length===1)return N[0]}return new b(N,L)}}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(let L of this.expr)E.push(...L.keys());return E}map(E){return new b(this.expr.map(L=>L.map(E)),null)}negate(){if(!this.negated){let E=[];for(let L of this.expr)E.push(L.negate());for(;E.length>1;){const L=E.shift(),z=E.shift(),N=[];for(const j of U(L))for(const ue of U(z))N.push(s.create([j,ue],null));const $=E.length===0;E.unshift(b.create(N,null,$))}this.negated=E[0]}return this.negated}}class y extends r{constructor(E,L,z){super(E,null);this._defaultValue=L,typeof z=="object"?y._info.push({...z,key:E}):z!==!0&&y._info.push({key:E,description:z,type:L!=null?typeof L:void 0})}static all(){return y._info.values()}bindTo(E){return E.createKey(this.key,this._defaultValue)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(E){return g.create(this.key,E)}notEqualsTo(E){return v.create(this.key,E)}}e.RawContextKey=y,y._info=[],e.IContextKeyService=(0,w.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function c(H,E){return H<E?-1:H>E?1:0}function S(H,E,L,z){return H<L?-1:H>L?1:E<z?-1:E>z?1:0}function A(H,E){if(E.type===6&&H.type!==9&&H.type!==6){for(const N of E.expr)if(H.equals(N))return!0}const L=H.negate(),z=U(L).concat(U(E));z.sort(_);for(let N=0;N<z.length;N++){const j=z[N].negate();for(let ue=N+1;ue<z.length;ue++){const K=z[ue];if(j.equals(K))return!0}}return!1}e.implies=A;function U(H){return H.type===9?H.expr:[H]}}),define(Ee[136],ye([0,1,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(Ee[45],ye([0,1,21,17,9,11,2,117,3]),function(ne,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function R(N){return N.create===!0}e.isFileOpenForWriteOptions=R;var F;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(F=e.FileType||(e.FileType={}));var _;(function(N){N[N.Readonly=1]="Readonly"})(_=e.FilePermission||(e.FilePermission={}));var n;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock",N[N.FileAtomicRead=16384]="FileAtomicRead"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=m;function r(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=r;function g(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function d(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=d;function D(N){return m(N)?!!(N.capabilities&16384):!1}e.hasFileAtomicReadCapability=D;var v;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor($,j){super($);this.code=j}}e.FileSystemProviderError=f;function p(N,$){const j=new f(N.toString(),$);return l(j,$),j}e.createFileSystemProviderError=p;function I(N){return N||p((0,P.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=I;function l(N,$){return N.name=$?`${$} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=l;function M(N){if(!N)return v.Unknown;if(N instanceof f)return N.code;const $=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!$)return v.Unknown;switch($[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=M;function o(N){if(N instanceof y)return N.fileOperationResult;switch(M(N)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var i;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class h{constructor($,j,ue){this.resource=$,this.operation=j,this.target=ue}isOperation($){return this.operation===$}}e.FileOperationEvent=h;var u;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class s{constructor($,j){this.added=void 0,this.updated=void 0,this.deleted=void 0;const ue=new Map;for(const K of $){const ie=ue.get(K.type);ie?ie.push([K.resource,K]):ue.set(K.type,[[K.resource,K]])}for(const[K,ie]of ue)switch(K){case 1:this.added=a.TernarySearchTree.forUris(()=>j),this.added.fill(ie);break;case 0:this.updated=a.TernarySearchTree.forUris(()=>j),this.updated.fill(ie);break;case 2:this.deleted=a.TernarySearchTree.forUris(()=>j),this.deleted.fill(ie);break}}contains($,...j){return this.doContains($,{includeChildren:!1},...j)}affects($,...j){return this.doContains($,{includeChildren:!0},...j)}doContains($,j,...ue){if(!$)return!1;const K=ue.length>0;return!!((!K||ue.includes(1))&&(this.added?.get($)||j.includeChildren&&this.added?.findSuperstr($))||(!K||ue.includes(0))&&(this.updated?.get($)||j.includeChildren&&this.updated?.findSuperstr($))||(!K||ue.includes(2))&&(this.deleted?.findSubstr($)||j.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=s;function b(N,$,j){return!N||!$||N===$||$.length>N.length?!1:($.charAt($.length-1)!==t.sep&&($+=t.sep),j?(0,w.startsWithIgnoreCase)(N,$):N.indexOf($)===0)}e.isParent=b;class y extends Error{constructor($,j,ue){super($);this.fileOperationResult=j,this.options=ue}}e.FileOperationError=y;class c extends y{constructor($,j,ue){super($,2,ue);this.stat=j}}e.NotModifiedSinceFileOperationError=c;var S;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(S=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=U;async function H(N,$){if(!$.hasProvider(k.URI.from({scheme:N.scheme})))return new Promise(j=>{const ue=$.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===N.scheme&&K.added&&(ue.dispose(),j())})})}e.whenProviderRegistered=H,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class E{static formatSize($){return(0,T.isNumber)($)||($=0),$<E.KB?(0,P.localize)(1,null,$.toFixed(0)):$<E.MB?(0,P.localize)(2,null,($/E.KB).toFixed(2)):$<E.GB?(0,P.localize)(3,null,($/E.MB).toFixed(2)):$<E.TB?(0,P.localize)(4,null,($/E.GB).toFixed(2)):(0,P.localize)(5,null,($/E.TB).toFixed(2))}}e.ByteSize=E,E.KB=1024,E.MB=E.KB*E.KB,E.GB=E.MB*E.KB,E.TB=E.GB*E.KB;var L;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(L=e.Arch||(e.Arch={}));function z(N){return{maxFileSize:N===0?300*E.MB:16*E.GB,maxHeapSize:N===0?700*E.MB:2*700*E.MB}}e.getPlatformLimits=z}),define(Ee[60],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...w){this._entries=new Map;for(let[T,k]of w)this.set(T,k)}set(w,T){const k=this._entries.get(w);return this._entries.set(w,T),k}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=a}),define(Ee[137],ye([0,1,14,15,80,133,3,60]),function(ne,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class R extends Error{constructor(r){super("cyclic dependency between services");this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class F{constructor(r=new P.ServiceCollection,g=!1,d){this._activeInstantiations=new Set,this._services=r,this._strict=g,this._parent=d,this._services.set(k.IInstantiationService,this)}createChild(r){return new F(r,this._strict,this)}invokeFunction(r,...g){let d=n.traceInvocation(r),D=!1;try{return r({get:f=>{if(D)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(f,d);if(!p)throw new Error(`[invokeFunction] unknown service '${f}'`);return p}},...g)}finally{D=!0,d.stop()}}createInstance(r,...g){let d,D;return r instanceof w.SyncDescriptor?(d=n.traceCreation(r.ctor),D=this._createInstance(r.ctor,r.staticArguments.concat(g),d)):(d=n.traceCreation(r),D=this._createInstance(r,g,d)),d.stop(),D}_createInstance(r,g=[],d){let D=k._util.getServiceDependencies(r).sort((p,I)=>p.index-I.index),v=[];for(const p of D){let I=this._getOrCreateServiceInstance(p.id,d);if(!I&&this._strict&&!p.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${p.id}.`);v.push(I)}let f=D.length>0?D[0].index:g.length;if(g.length!==f){console.warn(`[createInstance] First service dependency of ${r.name} at position ${f+1} conflicts with ${g.length} static arguments`);let p=f-g.length;p>0?g=g.concat(new Array(p)):g=g.slice(0,f)}return new r(...[...g,...v])}_setServiceInstance(r,g){if(this._services.get(r)instanceof w.SyncDescriptor)this._services.set(r,g);else if(this._parent)this._parent._setServiceInstance(r,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let g=this._services.get(r);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):g}_getOrCreateServiceInstance(r,g){let d=this._getServiceInstanceOrDescriptor(r);return d instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,d,g.branch(r,!0)):(g.branch(r,!1),d)}_safeCreateAndCacheServiceInstance(r,g,d){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,g,d)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,g,d){const D=new T.Graph(p=>p.id.toString());let v=0;const f=[{id:r,desc:g,_trace:d}];for(;f.length;){const p=f.pop();if(D.lookupOrInsertNode(p),v++>1e3)throw new R(D);for(let I of k._util.getServiceDependencies(p.desc.ctor)){let l=this._getServiceInstanceOrDescriptor(I.id);if(!l&&!I.optional&&console.warn(`[createInstance] ${r} depends on ${I.id} which is NOT registered.`),l instanceof w.SyncDescriptor){const M={id:I.id,desc:l,_trace:p._trace.branch(I.id,!0)};D.insertEdge(p,M),f.push(M)}}}for(;;){const p=D.roots();if(p.length===0){if(!D.isEmpty())throw new R(D);break}for(const{data:I}of p){if(this._getServiceInstanceOrDescriptor(I.id)instanceof w.SyncDescriptor){const M=this._createServiceInstanceWithOwner(I.id,I.desc.ctor,I.desc.staticArguments,I.desc.supportsDelayedInstantiation,I._trace);this._setServiceInstance(I.id,M)}D.removeNode(I)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,g,d=[],D,v){if(this._services.get(r)instanceof w.SyncDescriptor)return this._createServiceInstance(g,d,D,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,g,d,D,v);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(r,g=[],d,D){if(d){const v=new a.IdleValue(()=>this._createInstance(r,g,D));return new Proxy(Object.create(null),{get(f,p){if(p in f)return f[p];let I=v.value,l=I[p];return typeof l!="function"||(l=l.bind(I),f[p]=l),l},set(f,p,I){return v.value[p]=I,!0}})}else return this._createInstance(r,g,D)}}e.InstantiationService=F;var _;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(_||(_={}));class n{constructor(r,g){this.type=r,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return C?new n(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(r){return C?new n(0,r.name):n._None}branch(r,g){let d=new n(2,r.toString());return this._dep.push([r,g,d]),d}stop(){let r=Date.now()-this._start;n._totals+=r;let g=!1;function d(v,f){let p=[],I=new Array(v+1).join("	");for(const[l,M,o]of f._dep)if(M&&o){g=!0,p.push(`${I}CREATES -> ${l}`);let i=d(v+1,o);i&&p.push(i)}else p.push(`${I}uses -> ${l}`);return p.join(`
`)}let D=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(r>2||g)&&console.log(D.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(Ee[12],ye([0,1,43,4,6,23,3]),function(ne,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function P(){return new Date().toISOString()}var C;(function(M){M[M.Trace=0]="Trace",M[M.Debug=1]="Debug",M[M.Info=2]="Info",M[M.Warning=3]="Warning",M[M.Error=4]="Error",M[M.Critical=5]="Critical",M[M.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function R(M,o,i){switch(o){case C.Trace:M.trace(i);break;case C.Debug:M.debug(i);break;case C.Info:M.info(i);break;case C.Warning:M.warn(i);break;case C.Error:M.error(i);break;case C.Critical:M.critical(i);break;default:throw new Error("Invalid log level")}}e.log=R;function F(M){let o="";for(let i=0;i<M.length;i++){let h=M[i];if(typeof h=="object")try{h=JSON.stringify(h)}catch{}o+=(i>0?" ":"")+h}return o}e.format=F;class _ extends w.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=_;class n extends _{constructor(o){super();this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...i){this.checkLogLevel(C.Trace)&&this.log(C.Trace,F([o,...i]))}debug(o,...i){this.checkLogLevel(C.Debug)&&this.log(C.Debug,F([o,...i]))}info(o,...i){this.checkLogLevel(C.Info)&&this.log(C.Info,F([o,...i]))}warn(o,...i){this.checkLogLevel(C.Warning)&&this.log(C.Warning,F([o,...i]))}error(o,...i){if(this.checkLogLevel(C.Error))if(o instanceof Error){const h=Array.prototype.slice.call(arguments);h[0]=o.stack,this.log(C.Error,F(h))}else this.log(C.Error,F([o,...i]))}critical(o,...i){this.checkLogLevel(C.Critical)&&this.log(C.Critical,F([o,...i]))}flush(){}}e.AbstractMessageLogger=n;class m extends _{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o),this.useColors=!T.isWindows}trace(o,...i){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,o,...i):console.log(`[main ${P()}]`,o,...i))}debug(o,...i){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,o,...i):console.log(`[main ${P()}]`,o,...i))}info(o,...i){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,o,...i):console.log(`[main ${P()}]`,o,...i))}warn(o,...i){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,o,...i):console.warn(`[main ${P()}]`,o,...i))}error(o,...i){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,o,...i):console.error(`[main ${P()}]`,o,...i))}critical(o,...i){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,o,...i):console.error(`[main ${P()}]`,o,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class r extends _{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o)}trace(o,...i){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",o,...i)}debug(o,...i){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...i)}info(o,...i){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",o,...i)}warn(o,...i){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",o,...i)}error(o,...i){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",o,...i)}critical(o,...i){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...i)}dispose(){}flush(){}}e.ConsoleLogger=r;class g extends _{constructor(o,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=o,this.setLevel(i)}trace(o,...i){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(o),...i])}debug(o,...i){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(o),...i])}info(o,...i){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(o),...i])}warn(o,...i){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(o),...i])}error(o,...i){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(o),...i])}critical(o,...i){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(o),...i])}extractMessage(o){return typeof o=="string"?o:(0,a.toErrorMessage)(o,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class d extends _{constructor(o){super();this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const i of this.logServices)i.setLevel(o);super.setLevel(o)}trace(o,...i){for(const h of this.logServices)h.trace(o,...i)}debug(o,...i){for(const h of this.logServices)h.debug(o,...i)}info(o,...i){for(const h of this.logServices)h.info(o,...i)}warn(o,...i){for(const h of this.logServices)h.warn(o,...i)}error(o,...i){for(const h of this.logServices)h.error(o,...i)}critical(o,...i){for(const h of this.logServices)h.critical(o,...i)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=d;class D extends w.Disposable{constructor(o){super();this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...i){this.logger.trace(o,...i)}debug(o,...i){this.logger.debug(o,...i)}info(o,...i){this.logger.info(o,...i)}warn(o,...i){this.logger.warn(o,...i)}error(o,...i){this.logger.error(o,...i)}critical(o,...i){this.logger.critical(o,...i)}flush(){this.logger.flush()}}e.LogService=D;class v extends w.Disposable{constructor(o,i){super();this.logLevel=o,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(h=>{this.logLevel=h,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(h))}))}getLogger(o){return this.loggers.get(o.toString())}createLogger(o,i){let h=this.loggers.get(o.toString());return h||(h=this.doCreateLogger(o,i?.always?C.Trace:this.logLevel,i),this.loggers.set(o.toString(),h),i?.always||this.logLevelChangeableLoggers.push(h)),h}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(o=>o.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class f{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(o){}getLevel(){return C.Info}trace(o,...i){}debug(o,...i){}info(o,...i){}warn(o,...i){}error(o,...i){}critical(o,...i){}dispose(){}flush(){}}e.NullLogService=f;function p(M){if(M.verbose)return C.Trace;if(typeof M.logLevel=="string"){const o=I(M.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function I(M){switch(M){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=I;function l(M){switch(M){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=l}),define(Ee[82],ye([0,1,34,118,3]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var k;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function R(r,g){return g-r}C.compare=R;const F=Object.create(null);F[C.Error]=(0,t.localize)(0,null),F[C.Warning]=(0,t.localize)(1,null),F[C.Info]=(0,t.localize)(2,null);function _(r){return F[r]||""}C.toString=_;function n(r){switch(r){case a.default.Error:return C.Error;case a.default.Warning:return C.Warning;case a.default.Info:return C.Info;case a.default.Ignore:return C.Hint}}C.fromSeverity=n;function m(r){switch(r){case C.Error:return a.default.Error;case C.Warning:return a.default.Warning;case C.Info:return a.default.Info;case C.Hint:return a.default.Ignore}}C.toSeverity=m}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(C){const R="";function F(n){return _(n,!0)}C.makeKey=F;function _(n,m){let r=[R];return n.source?r.push(n.source.replace("\xA6","\\\xA6")):r.push(R),n.code?typeof n.code=="string"?r.push(n.code.replace("\xA6","\\\xA6")):r.push(n.code.value.replace("\xA6","\\\xA6")):r.push(R),n.severity!==void 0&&n.severity!==null?r.push(k.toString(n.severity)):r.push(R),n.message&&m?r.push(n.message.replace("\xA6","\\\xA6")):r.push(R),n.startLineNumber!==void 0&&n.startLineNumber!==null?r.push(n.startLineNumber.toString()):r.push(R),n.startColumn!==void 0&&n.startColumn!==null?r.push(n.startColumn.toString()):r.push(R),n.endLineNumber!==void 0&&n.endLineNumber!==null?r.push(n.endLineNumber.toString()):r.push(R),n.endColumn!==void 0&&n.endColumn!==null?r.push(n.endColumn.toString()):r.push(R),r.push(R),r.join("\xA6")}C.makeKeyOptionalMessage=_})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(Ee[138],ye([0,1,4,34,3]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,w.createDecorator)("notificationService");var T;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new C,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(F){}updateMessage(F){}updateActions(F){}close(){}}e.NoOpNotification=P;class C{infinite(){}done(){}total(F){}worked(F){}}e.NoOpProgress=C}),define(Ee[139],ye([0,1,6,9,2,3]),function(ne,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return a.Disposable.None},registerValidator(){return a.Disposable.None},registerExternalUriResolver(){return a.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return a.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function k(C,R){return w.URI.isUri(C)?(0,t.equalsIgnoreCase)(C.scheme,R):(0,t.startsWithIgnoreCase)(C,R+":")}e.matchesScheme=k;function P(C,...R){return R.some(F=>k(C,F))}e.matchesSomeScheme=P});var Be=this&&this.__decorate||function(ne,e,a,t){var w=arguments.length,T=w<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,a):t,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(ne,e,a,t);else for(var P=ne.length-1;P>=0;P--)(k=ne[P])&&(T=(w<3?k(T):w>3?k(e,a,T):k(e,a))||T);return w>3&&T&&Object.defineProperty(e,a,T),T},He=this&&this.__param||function(ne,e){return function(a,t){e(a,t,ne)}};define(Ee[140],ye([0,1,14,20,6,3]),function(ne,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,T.createDecorator)("progressService");var k;(function(F){F[F.Explorer=1]="Explorer",F[F.Scm=3]="Scm",F[F.Extensions=5]="Extensions",F[F.Window=10]="Window",F[F.Notification=15]="Notification",F[F.Dialog=20]="Dialog"})(k=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(_){this.callback=_}get value(){return this._value}report(_){this._value=_,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let C=class extends w.Disposable{constructor(_,n){super();this.deferred=new a.DeferredPromise,n.withProgress(_,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,w.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};C=Be([He(1,e.IProgressService)],C),e.UnmanagedProgress=C;class R extends w.Disposable{constructor(_){super();this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new w.DisposableStore)}start(_){this.stop();const n=++this.currentOperationId,m=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,w.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,w.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,w.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:m.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=R,e.IEditorProgressService=(0,T.createDecorator)("editorProgressService")}),define(Ee[36],ye([0,1,41,11]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(k,P){a.ok(t.isString(k)),a.ok(t.isObject(P)),a.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,P)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new w}),define(Ee[141],ye([0,1,4,36]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class T{constructor(){this._onDidChangeSchema=new a.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,R){this.schemasById[w(C)]=R,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new T;t.Registry.add(e.Extensions.JSONContribution,k)}),define(Ee[83],ye([0,1,16,4,11,115,141,36]),function(ne,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const F=P.Registry.as(k.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(I,l=!0){this.registerConfigurations([I],l)}registerConfigurations(I,l=!0){const M=this.doRegisterConfigurations(I,l);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:M})}deregisterConfigurations(I){const l=this.doDeregisterConfigurations(I);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:I,remove:l}){const M=[];M.push(...this.doDeregisterConfigurations(l)),M.push(...this.doRegisterConfigurations(I,!1)),F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,a.distinct)(M)})}registerDefaultConfigurations(I){const l=[],M=[];for(const{overrides:o,source:i}of I)for(const h in o)if(l.push(h),e.OVERRIDE_PROPERTY_REGEX.test(h)){const u={...this.configurationDefaultsOverrides.get(h)?.value||{},...o[h]};this.configurationDefaultsOverrides.set(h,{source:i,value:u});const s={type:"object",default:u,description:T.localize(1,null,h),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:u,source:w.isString(i)?void 0:i};M.push(...r(h)),this.configurationProperties[h]=s,this.defaultLanguageConfigurationOverridesNode.properties[h]=s}else{this.configurationDefaultsOverrides.set(h,{value:o[h],source:i});const u=this.configurationProperties[h];u&&(this.updatePropertyDefaultValue(h,u),this.updateSchema(h,u))}this.registerOverrideIdentifiers(M),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}deregisterDefaultConfigurations(I){const l=[];for(const{overrides:M,source:o}of I)for(const i in M){const h=this.configurationDefaultsOverrides.get(i),u=w.isString(o)?o:o?.id,s=w.isString(h?.source)?h?.source:h?.source?.id;if(u===s)if(l.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const b=this.configurationProperties[i];b&&(this.updatePropertyDefaultValue(i,b),this.updateSchema(i,b))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...I){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(I){for(const l of I)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(I,l){const M=[];return I.forEach(o=>{M.push(...this.validateAndRegisterProperties(o,l,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),M}doDeregisterConfigurations(I){const l=[],M=o=>{if(o.properties)for(const i in o.properties)l.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,o.properties[i]);o.allOf&&o.allOf.forEach(i=>M(i))};for(const o of I){M(o);const i=this.configurationContributors.indexOf(o);i!==-1&&this.configurationContributors.splice(i,1)}return l}validateAndRegisterProperties(I,l=!0,M,o,i=3){i=w.isUndefinedOrNull(I.scope)?i:I.scope;let h=[],u=I.properties;if(u)for(let b in u){if(l&&v(b)){delete u[b];continue}const y=u[b];if(y.source=M,y.defaultDefaultValue=u[b].default,this.updatePropertyDefaultValue(b,y),e.OVERRIDE_PROPERTY_REGEX.test(b)?y.scope=void 0:(y.scope=w.isUndefinedOrNull(y.scope)?i:y.scope,y.restricted=w.isUndefinedOrNull(y.restricted)?!!o?.includes(b):y.restricted),u[b].hasOwnProperty("included")&&!u[b].included){this.excludedConfigurationProperties[b]=u[b],delete u[b];continue}else this.configurationProperties[b]=u[b];!u[b].deprecationMessage&&u[b].markdownDeprecationMessage&&(u[b].deprecationMessage=u[b].markdownDeprecationMessage),h.push(b)}let s=I.allOf;if(s)for(let b of s)h.push(...this.validateAndRegisterProperties(b,l,M,o,i));return h}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(I){const l=M=>{let o=M.properties;if(o)for(const h in o)this.updateSchema(h,o[h]);let i=M.allOf;i&&i.forEach(l)};l(I)}updateSchema(I,l){switch(e.allSettings.properties[I]=l,l.scope){case 1:e.applicationSettings.properties[I]=l;break;case 2:e.machineSettings.properties[I]=l;break;case 6:e.machineOverridableSettings.properties[I]=l;break;case 3:e.windowSettings.properties[I]=l;break;case 4:e.resourceSettings.properties[I]=l;break;case 5:e.resourceSettings.properties[I]=l,this.resourceLanguageSettingsSchema.properties[I]=l;break}}removeFromSchema(I,l){switch(delete e.allSettings.properties[I],l.scope){case 1:delete e.applicationSettings.properties[I];break;case 2:delete e.machineSettings.properties[I];break;case 6:delete e.machineOverridableSettings.properties[I];break;case 3:delete e.windowSettings.properties[I];break;case 4:case 5:delete e.resourceSettings.properties[I],delete this.resourceLanguageSettingsSchema.properties[I];break}}updateOverridePropertyPatternKey(){for(const I of this.overrideIdentifiers.values()){const l=`[${I}]`,M={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,M),e.allSettings.properties[l]=M,e.applicationSettings.properties[l]=M,e.machineSettings.properties[l]=M,e.machineOverridableSettings.properties[l]=M,e.windowSettings.properties[l]=M,e.resourceSettings.properties[l]=M}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const I={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=I,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=I,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=I,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=I,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=I,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=I,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(I,l){const M=this.configurationDefaultsOverrides.get(I);let o=M?.value,i=M?.source;w.isUndefined(o)&&(o=l.defaultDefaultValue,i=void 0),w.isUndefined(o)&&(o=d(l.type)),l.default=o,l.defaultValueSource=i}}const n="\\[([^\\]]+)\\]",m=new RegExp(n,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${n})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function r(p){const I=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let l=m.exec(p);for(;l?.length;){const M=l[1].trim();M&&I.push(M),l=m.exec(p)}}return(0,a.distinct)(I)}e.overrideIdentifiersFromKey=r;function g(p){return p.reduce((I,l)=>`${I}[${l}]`,"")}e.keyFromOverrideIdentifiers=g;function d(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const D=new _;P.Registry.add(e.Extensions.Configuration,D);function v(p){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?T.localize(7,null,p):D.getConfigurationProperties()[p]!==void 0?T.localize(8,null,p):null:T.localize(6,null)}e.validateProperty=v;function f(){const p=[],I=D.getConfigurationProperties();for(const l of Object.keys(I))p.push([l,I[l].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=f}),define(Ee[142],ye([0,1,16,4,100,6,21,26,11,2,81,83,36]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(o={},i=[],h=[]){this._contents=o,this._keys=i,this._overrides=h,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(o){return o?(0,F.getConfigurationValue)(this.contents,o):this.contents}getOverrideValue(o,i){const h=this.getContentsForOverrideIdentifer(i);return h?o?(0,F.getConfigurationValue)(h,o):h:void 0}getKeysForOverrideIdentifier(o){const i=[];for(const h of this.overrides)h.identifiers.includes(o)&&i.push(...h.keys);return a.distinct(i)}getAllOverrideIdentifiers(){const o=[];for(const i of this.overrides)o.push(...i.identifiers);return a.distinct(o)}override(o){let i=this.overrideConfigurations.get(o);return i||(i=this.createOverrideConfigurationModel(o),this.overrideConfigurations.set(o,i)),i}merge(...o){const i=P.deepClone(this.contents),h=P.deepClone(this.overrides),u=[...this.keys];for(const s of o){this.mergeContents(i,s.contents);for(const b of s.overrides){const[y]=h.filter(c=>a.equals(c.identifiers,b.identifiers));y?(this.mergeContents(y.contents,b.contents),y.keys.push(...b.keys),y.keys=a.distinct(y.keys)):h.push(P.deepClone(b))}for(const b of s.keys)u.indexOf(b)===-1&&u.push(b)}return new m(i,u,h)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(o){const i=this.getContentsForOverrideIdentifer(o);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let h={};for(const u of a.distinct([...Object.keys(this.contents),...Object.keys(i)])){let s=this.contents[u],b=i[u];b&&(typeof s=="object"&&typeof b=="object"?(s=P.deepClone(s),this.mergeContents(s,b)):s=b),h[u]=s}return new m(h,this.keys,this.overrides)}mergeContents(o,i){for(const h of Object.keys(i)){if(h in o&&C.isObject(o[h])&&C.isObject(i[h])){this.mergeContents(o[h],i[h]);continue}o[h]=P.deepClone(i[h])}}checkAndFreeze(o){return this.isFrozen&&!Object.isFrozen(o)?P.deepFreeze(o):o}getContentsForOverrideIdentifer(o){let i=null,h=null;const u=s=>{s&&(h?this.mergeContents(h,s):h=P.deepClone(s))};for(const s of this.overrides)a.equals(s.identifiers,[o])?i=s.contents:s.identifiers.includes(o)&&u(s.contents);return u(i),h}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(o,i){this.addKey(o),(0,F.addToValueTree)(this.contents,o,i,h=>{throw new Error(h)})}removeValue(o){this.removeKey(o)&&(0,F.removeFromValueTree)(this.contents,o)}addKey(o){let i=this.keys.length;for(let h=0;h<i;h++)o.indexOf(this.keys[h])===0&&(i=h);this.keys.splice(i,1,o)}removeKey(o){let i=this.keys.indexOf(o);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=m;class r extends m{constructor(o={}){const i=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(i),u=Object.create(null),s=[];for(const b in i){const y=o[b],c=y!==void 0?y:i[b].default;(0,F.addToValueTree)(u,b,c,S=>console.error(`Conflict in default settings: ${S}`))}for(const b of Object.keys(u))_.OVERRIDE_PROPERTY_REGEX.test(b)&&s.push({identifiers:(0,_.overrideIdentifiersFromKey)(b),keys:Object.keys(u[b]),contents:(0,F.toValuesTree)(u[b],y=>console.error(`Conflict in default settings file: ${y}`))});super(u,h,s)}}e.DefaultConfigurationModel=r;class g{constructor(o){this._name=o,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(o,i){if(!C.isUndefinedOrNull(o)){const h=this.doParseContent(o);this.parseRaw(h,i)}}reparse(o){this._raw&&this.parseRaw(this._raw,o)}parseRaw(o,i){this._raw=o;const{contents:h,keys:u,overrides:s,restricted:b}=this.doParseRaw(o,i);this._configurationModel=new m(h,u,s),this._restrictedConfigurations=b||[]}doParseContent(o){let i={},h=null,u=[],s=[],b=[];function y(S){Array.isArray(u)?u.push(S):h!==null&&(u[h]=S)}let c={onObjectBegin:()=>{let S={};y(S),s.push(u),u=S,h=null},onObjectProperty:S=>{h=S},onObjectEnd:()=>{u=s.pop()},onArrayBegin:()=>{let S=[];y(S),s.push(u),u=S,h=null},onArrayEnd:()=>{u=s.pop()},onLiteralValue:y,onError:(S,A,U)=>{b.push({error:S,offset:A,length:U})}};if(o)try{w.visit(o,c),i=u[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return i}doParseRaw(o,i){const h=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),u=this.filter(o,h,!0,i);o=u.raw;const s=(0,F.toValuesTree)(o,c=>console.error(`Conflict in settings file ${this._name}: ${c}`)),b=Object.keys(o),y=this.toOverrides(o,c=>console.error(`Conflict in settings file ${this._name}: ${c}`));return{contents:s,keys:b,overrides:y,restricted:u.restricted}}filter(o,i,h,u){if(!u?.scopes&&!u?.skipRestricted)return{raw:o,restricted:[]};const s={},b=[];for(let y in o)if(_.OVERRIDE_PROPERTY_REGEX.test(y)&&h){const c=this.filter(o[y],i,!1,u);s[y]=c.raw,b.push(...c.restricted)}else{const c=i[y],S=c?typeof c.scope!="undefined"?c.scope:3:void 0;c?.restricted&&b.push(y),(S===void 0||u.scopes===void 0||u.scopes.includes(S))&&(u.skipRestricted&&c?.restricted||(s[y]=o[y]))}return{raw:s,restricted:b}}toOverrides(o,i){const h=[];for(const u of Object.keys(o))if(_.OVERRIDE_PROPERTY_REGEX.test(u)){const s={};for(const b in o[u])s[b]=o[u][b];h.push({identifiers:(0,_.overrideIdentifiersFromKey)(u),keys:Object.keys(s),contents:(0,F.toValuesTree)(s,i)})}return h}}e.ConfigurationModelParser=g;class d extends T.Disposable{constructor(o,i,h,u){super();this.userSettingsResource=o,this.scopes=i,this.fileService=u,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(h.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const o=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(o.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class D{constructor(o,i,h=new m,u=new m,s=new k.ResourceMap,b=new m,y=new k.ResourceMap,c=!0){this._defaultConfiguration=o,this._localUserConfiguration=i,this._remoteUserConfiguration=h,this._workspaceConfiguration=u,this._folderConfigurations=s,this._memoryConfiguration=b,this._memoryConfigurationByResource=y,this._freeze=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(o,i,h){return this.getConsolidateConfigurationModel(i,h).getValue(o)}updateValue(o,i,h={}){let u;h.resource?(u=this._memoryConfigurationByResource.get(h.resource),u||(u=new m,this._memoryConfigurationByResource.set(h.resource,u))):u=this._memoryConfiguration,i===void 0?u.removeValue(o):u.setValue(o,i),h.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(o,i,h){const u=this.getConsolidateConfigurationModel(i,h),s=this.getFolderConfigurationModelForResource(i.resource,h),b=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,y=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this._defaultConfiguration.freeze().getValue(o),c=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this.userConfiguration.freeze().getValue(o),S=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this.localUserConfiguration.freeze().getValue(o),A=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this.remoteUserConfiguration.freeze().getValue(o),U=h?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this._workspaceConfiguration.freeze().getValue(o):void 0,H=s?i.overrideIdentifier?s.freeze().override(i.overrideIdentifier).getValue(o):s.freeze().getValue(o):void 0,E=i.overrideIdentifier?b.override(i.overrideIdentifier).getValue(o):b.getValue(o),L=u.getValue(o),z=a.distinct(a.flatten(u.overrides.map(N=>N.identifiers))).filter(N=>u.getOverrideValue(o,N)!==void 0);return{defaultValue:y,userValue:c,userLocalValue:S,userRemoteValue:A,workspaceValue:U,workspaceFolderValue:H,memoryValue:E,value:L,default:y!==void 0?{value:this._defaultConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,user:c!==void 0?{value:this.userConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,userLocal:S!==void 0?{value:this.localUserConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,workspaceFolder:H!==void 0?{value:s?.freeze().getValue(o),override:i.overrideIdentifier?s?.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,memory:E!==void 0?{value:b.getValue(o),override:i.overrideIdentifier?b.getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(o){const i=this.getFolderConfigurationModelForResource(void 0,o);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(o){this._defaultConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(o){this._localUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(o){this._remoteUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(o){this._workspaceConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(o,i){this._folderConfigurations.set(o,i),this._foldersConsolidatedConfigurations.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this._foldersConsolidatedConfigurations.delete(o)}compareAndUpdateDefaultConfiguration(o,i){const h=[];if(!i){const{added:u,updated:s,removed:b}=I(this._defaultConfiguration,o);i=[...u,...s,...b]}for(const u of i)for(const s of(0,_.overrideIdentifiersFromKey)(u)){const b=this._defaultConfiguration.getKeysForOverrideIdentifier(s),y=o.getKeysForOverrideIdentifier(s),c=[...y.filter(S=>b.indexOf(S)===-1),...b.filter(S=>y.indexOf(S)===-1),...b.filter(S=>!P.equals(this._defaultConfiguration.override(s).getValue(S),o.override(s).getValue(S)))];h.push([s,c])}return this.updateDefaultConfiguration(o),{keys:i,overrides:h}}compareAndUpdateLocalUserConfiguration(o){const{added:i,updated:h,removed:u,overrides:s}=I(this.localUserConfiguration,o),b=[...i,...h,...u];return b.length&&this.updateLocalUserConfiguration(o),{keys:b,overrides:s}}compareAndUpdateRemoteUserConfiguration(o){const{added:i,updated:h,removed:u,overrides:s}=I(this.remoteUserConfiguration,o);let b=[...i,...h,...u];return b.length&&this.updateRemoteUserConfiguration(o),{keys:b,overrides:s}}compareAndUpdateWorkspaceConfiguration(o){const{added:i,updated:h,removed:u,overrides:s}=I(this.workspaceConfiguration,o);let b=[...i,...h,...u];return b.length&&this.updateWorkspaceConfiguration(o),{keys:b,overrides:s}}compareAndUpdateFolderConfiguration(o,i){const h=this.folderConfigurations.get(o),{added:u,updated:s,removed:b,overrides:y}=I(h,i);let c=[...u,...s,...b];return(c.length||!h)&&this.updateFolderConfiguration(o,i),{keys:c,overrides:y}}compareAndDeleteFolderConfiguration(o){const i=this.folderConfigurations.get(o);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:h,updated:u,removed:s,overrides:b}=I(i,void 0);return{keys:[...h,...u,...s],overrides:b}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(o,i){let h=this.getConsolidatedConfigurationModelForResource(o,i);return o.overrideIdentifier?h.override(o.overrideIdentifier):h}getConsolidatedConfigurationModelForResource({resource:o},i){let h=this.getWorkspaceConsolidatedConfiguration();if(i&&o){const u=i.getFolder(o);u&&(h=this.getFolderConsolidatedConfiguration(u.uri)||h);const s=this._memoryConfigurationByResource.get(o);s&&(h=h.merge(s))}return h}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(o){let i=this._foldersConsolidatedConfigurations.get(o);if(!i){const h=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(o);u?(i=h.merge(u),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(o,i)):i=h}return i}getFolderConfigurationModelForResource(o,i){if(i&&o){const h=i.getFolder(o);if(h)return this._folderConfigurations.get(h.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((o,i)=>{const{contents:h,overrides:u,keys:s}=this._folderConfigurations.get(i);return o.push([i,{contents:h,overrides:u,keys:s}]),o},[])}}allKeys(){const o=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>o.add(i)),this.userConfiguration.freeze().keys.forEach(i=>o.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>o.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(h=>o.add(h))),[...o.values()]}allOverrideIdentifiers(){const o=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(h=>o.add(h))),[...o.values()]}getAllKeysForOverrideIdentifier(o){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(o).forEach(h=>i.add(h)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(h=>i.add(h)),this._workspaceConfiguration.getKeysForOverrideIdentifier(o).forEach(h=>i.add(h)),this._folderConfigurations.forEach(h=>h.getKeysForOverrideIdentifier(o).forEach(u=>i.add(u))),[...i.values()]}static parse(o){const i=this.parseConfigurationModel(o.defaults),h=this.parseConfigurationModel(o.user),u=this.parseConfigurationModel(o.workspace),s=o.folders.reduce((b,y)=>(b.set(R.URI.revive(y[0]),this.parseConfigurationModel(y[1])),b),new k.ResourceMap);return new D(i,h,new m,u,s,new m,new k.ResourceMap,!1)}static parseConfigurationModel(o){return new m(o.contents,o.keys,o.overrides).freeze()}}e.Configuration=D;function v(...M){if(M.length===0)return{keys:[],overrides:[]};if(M.length===1)return M[0];const o=new Set,i=new Map;for(const u of M)u.keys.forEach(s=>o.add(s)),u.overrides.forEach(([s,b])=>{const y=(0,k.getOrSet)(i,s,new Set);b.forEach(c=>y.add(c))});const h=[];return i.forEach((u,s)=>h.push([s,[...u.values()]])),{keys:[...o.values()],overrides:h}}e.mergeChanges=v;class f{constructor(o,i,h,u){this.change=o,this.previous=i,this.currentConfiguraiton=h,this.currentWorkspace=u,this._previousConfiguration=void 0;const s=new Set;o.keys.forEach(y=>s.add(y)),o.overrides.forEach(([,y])=>y.forEach(c=>s.add(c))),this.affectedKeys=[...s.values()];const b=new m;this.affectedKeys.forEach(y=>b.setValue(y,{})),this.affectedKeysTree=b.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=D.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(o,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,o)){if(i){const h=this.previousConfiguration?this.previousConfiguration.getValue(o,i,this.previous?.workspace):void 0,u=this.currentConfiguraiton.getValue(o,i,this.currentWorkspace);return!P.equals(h,u)}return!0}return!1}doesAffectedKeysTreeContains(o,i){let h=(0,F.toValuesTree)({[i]:!0},()=>{}),u;for(;typeof h=="object"&&(u=Object.keys(h)[0]);){if(o=o[u],!o)return!1;h=h[u]}return!0}}e.ConfigurationChangeEvent=f;class p extends f{constructor(o,i,h,u){super({keys:o.allKeys(),overrides:[]},void 0,o,i);this.source=h,this.sourceConfig=u}}e.AllKeysConfigurationChangeEvent=p;function I(M,o){const{added:i,removed:h,updated:u}=l(o,M),s=[],b=M?.getAllOverrideIdentifiers()||[],y=o?.getAllOverrideIdentifiers()||[];if(o){const c=y.filter(S=>!b.includes(S));for(const S of c)s.push([S,o.getKeysForOverrideIdentifier(S)])}if(M){const c=b.filter(S=>!y.includes(S));for(const S of c)s.push([S,M.getKeysForOverrideIdentifier(S)])}if(o&&M){for(const c of b)if(y.includes(c)){const S=l({contents:M.getOverrideValue(void 0,c)||{},keys:M.getKeysForOverrideIdentifier(c)},{contents:o.getOverrideValue(void 0,c)||{},keys:o.getKeysForOverrideIdentifier(c)});s.push([c,[...S.added,...S.removed,...S.updated]])}}return{added:i,removed:h,updated:u,overrides:s}}function l(M,o){const i=M?o?M.keys.filter(s=>o.keys.indexOf(s)===-1):[...M.keys]:[],h=o?M?o.keys.filter(s=>M.keys.indexOf(s)===-1):[...o.keys]:[],u=[];if(M&&o){for(const s of o.keys)if(M.keys.indexOf(s)!==-1){const b=(0,F.getConfigurationValue)(o.contents,s),y=(0,F.getConfigurationValue)(M.contents,s);P.equals(b,y)||u.push(s)}}return{added:i,removed:h,updated:u}}}),define(Ee[84],ye([0,1,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,a.createDecorator)("remoteAuthorityResolverService");var t;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class w extends Error{constructor(k,P=t.Unknown,C){super(k);this._message=k,this._code=P,this._detail=C,this.isHandled=P===t.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype)}static isTemporarilyNotAvailable(k){return k instanceof w&&k._code===t.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof w&&k._code===t.NoResolverFound}static isHandled(k){return k instanceof w&&k.isHandled}}e.RemoteAuthorityResolverError=w}),define(Ee[61],ye([0,1,10]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function t(R){return R.scheme===a.Schemas.vscodeRemote?R.authority:void 0}e.getRemoteAuthority=t;function w(R){if(!R)return;const F=R.indexOf("+");return F<0?R:R.substr(0,F)}e.getRemoteName=w;function T(R){return R.scheme!==a.Schemas.file&&R.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=T;function k(R){if(R.folders.length)return R.folders.every(F=>T(F.uri))?R.folders[0].uri:void 0;if(R.configuration&&T(R.configuration))return R.configuration}e.getVirtualWorkspaceLocation=k;function P(R){return k(R)?.scheme}e.getVirtualWorkspaceScheme=P;function C(R){return k(R)!==void 0}e.isVirtualWorkspace=C}),define(Ee[25],ye([0,1,9,3,61]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=T;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class C{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,r){if(typeof m=="undefined"||m===null)return typeof r=="undefined"||r===null;if(typeof r=="undefined"||r===null)return!1;if(typeof m=="string"||typeof r=="string"){let g=typeof m=="string"?m:m.value,d=typeof r=="string"?r:r.value;return a.equalsIgnoreCase(g,d)}return m._lower===r._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=C;function R(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function F(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=F;function _(n,m){if(m){const r=`onResolveRemoteAuthority:${(0,w.getRemoteName)(m)}`;return n.activationEvents?.indexOf(r)!==-1}return!1}e.isResolverExtension=_,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ee[143],ye([0,1,9,25]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function w(r,g){return r.uuid&&g.uuid?r.uuid===g.uuid:r.id===g.id?!0:(0,a.compareIgnoreCase)(r.id,g.id)===0}e.areSameExtensions=w;class T{constructor(g,d){this.version=d,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof T?w(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=T;function k(r,g){return`${r}.${g}`}e.getExtensionId=k;function P(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function C(r,g){return P(k(r,g))}e.getGalleryExtensionId=C;function R(r,g){const d=[],D=v=>{for(const f of d)if(f.some(p=>w(g(p),g(v))))return f;return null};for(const v of r){const f=D(v);f?f.push(v):d.push([v])}return d}e.groupByExtension=R;function F(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=F;function _(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function n(r){const g=new Set;if(r.malicious)for(const d of r.malicious)g.add(d.id);return g}e.getMaliciousExtensionsSet=n;function m(r,g){const d=[],D=g.manifest.extensionDependencies?.slice(0)??[];for(;D.length;){const v=D.shift();if(v&&d.every(f=>!w(f.identifier,{id:v}))){const f=r.filter(p=>w(p.identifier,{id:v}));f.length===1&&(d.push(f[0]),D.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}e.getExtensionDependencies=m}),define(Ee[144],ye([0,1,4,23,3,12]),function(ne,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,w.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,w.createDecorator)("sharedTunnelsService");var k;(function(r){r.Http="http",r.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function R(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=R,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function F(r){return e.LOCALHOST_ADDRESSES.indexOf(r)>=0}e.isLocalhost=F,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function _(r){return e.ALL_INTERFACES_ADDRESSES.indexOf(r)>=0}e.isAllInterfaces=_;function n(r,g){return g?g!==1&&r<1024:!t.isWindows&&r<1024}e.isPortPrivileged=n;let m=class{constructor(g){this.logService=g,this._onTunnelOpened=new a.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new a.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new a.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(g,d){return this._tunnelProvider=g,g?(this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],d=Array.from(this._tunnels.values());for(let D of d){const v=Array.from(D.values());for(let f of v){const p=await f.value;p&&g.push(p)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:d}of g.values())await d.then(D=>D?.dispose());g.clear()}this._tunnels.clear()}openTunnel(g,d,D,v,f=!1,p=P.Private,I){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${D} on local port ${v}.`),!g)return;d||(d="localhost");const l=this.retainOrCreateTunnel(g,d,D,v,f,p,I);return l?l.then(M=>{if(!M){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,D);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(M);return(M.tunnelRemoteHost!==d||M.tunnelRemotePort!==D)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const d=this._tunnels.get(g.tunnelRemoteHost);if(d){const D=d.get(g.tunnelRemotePort);D&&(D.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,D))}}}}async tryDisposeTunnel(g,d,D){if(D.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${d}.`);const v=D.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(d),v}}async closeTunnel(g,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${d} `);const D=this._tunnels.get(g);if(D&&D.has(d)){const v=D.get(d);v.refcount=0,await this.tryDisposeTunnel(g,d,v)}}addTunnelToMap(g,d,D){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(d,{refcount:1,value:D})}async removeEmptyTunnelFromMap(g,d){const D=this._tunnels.get(g);D&&(await D.get(d)||D.delete(d),D.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,d){let D=[g];F(g)?(D.push(...e.LOCALHOST_ADDRESSES),D.push(...e.ALL_INTERFACES_ADDRESSES)):_(g)&&D.push(...e.ALL_INTERFACES_ADDRESSES);const v=D.map(f=>this._tunnels.get(f));for(const f of v){const p=f?.get(d);if(p)return p}}canTunnel(g){return!!R(g)}createWithProvider(g,d,D,v,f,p,I){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${D} on local port ${v}.`);const M={elevationRequired:f?n(v===void 0?D:v):!1},o={remoteAddress:{host:d,port:D},localAddressPort:v,privacy:p,public:p!==P.Private,protocol:I},i=g.forwardPort(o,M);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(d,D,i),i}};m=Be([He(0,T.ILogService)],m),e.AbstractTunnelService=m}),define(Ee[145],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(w){this._callback=w,this._terminalBufferMap=new Map}dispose(){for(const w of this._terminalBufferMap.values())w.dispose()}startBuffering(w,T,k=5){let P;return P=T(C=>{const R=typeof C=="string"?C:C.data;let F=this._terminalBufferMap.get(w);if(F){F.data.push(R);return}const _=setTimeout(()=>this.flushBuffer(w),k);F={data:[R],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(w),P.dispose()}},this._terminalBufferMap.set(w,F)}),P}stopBuffering(w){const T=this._terminalBufferMap.get(w);T&&T.dispose()}flushBuffer(w){const T=this._terminalBufferMap.get(w);T&&(this._terminalBufferMap.delete(w),this._callback(w,T.data.join("")))}}e.TerminalDataBufferer=a}),define(Ee[146],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var a;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(a=e.ColorScheme||(e.ColorScheme={}))}),define(Ee[62],ye([0,1,51,4,6,3,36,146]),function(ne,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var C;(function(d){function D(v){return v&&typeof v=="object"&&typeof v.id=="string"}d.isThemeColor=D})(C=e.ThemeColor||(e.ThemeColor={}));function R(d){return{id:d}}e.themeColorFromId=R;var F;(function(d){function D(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||C.isThemeColor(i.color))}d.isThemeIcon=D;const v=new RegExp(`^\\$\\((${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?)\\)$`);function f(i){const h=v.exec(i);if(!h)return;let[,u]=h;return{id:u}}d.fromString=f;function p(i){return{id:i}}d.fromId=p;function I(i,h){let u=i.id;const s=u.lastIndexOf("~");return s!==-1&&(u=u.substring(0,s)),h&&(u=`${u}~${h}`),{id:u}}d.modify=I;function l(i){const h=i.id.lastIndexOf("~");if(h!==-1)return i.id.substring(h+1)}d.getModifier=l;function M(i,h){return i.id===h.id&&i.color?.id===h.color?.id}d.isEqual=M;function o(i,h){return{id:i.id,color:h?R(h):void 0}}d.asThemeIcon=o,d.asClassNameArray=a.CSSIcon.asClassNameArray,d.asClassName=a.CSSIcon.asClassName,d.asCSSSelector=a.CSSIcon.asCSSSelector})(F=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=a.Codicon.file,e.FolderThemeIcon=a.Codicon.folder;function _(d){switch(d){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=_,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(D){return this.themingParticipants.push(D),this.onThemingParticipantAddedEmitter.fire(D),(0,w.toDisposable)(()=>{const v=this.themingParticipants.indexOf(D);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new n;k.Registry.add(e.Extensions.ThemingContribution,m);function r(d){return m.onColorThemeChange(d)}e.registerThemingParticipant=r;class g extends w.Disposable{constructor(D){super();this.themeService=D,this.theme=D.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(D){this.theme=D,this.updateStyles()}updateStyles(){}getColor(D,v){let f=this.theme.getColor(D);return f&&v&&(f=v(f,this.theme)),f?f.toString():null}}e.Themable=g}),define(Ee[46],ye([0,1,21,24,2,3]),function(ne,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var k;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function P(n){const m=n;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=P;function C(n){const m=n;return!!(m&&typeof m=="object"&&w.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=C;class R{constructor(m,r,g,d,D){this._id=m,this._transient=g,this._configuration=d,this._ignorePathCasing=D,this._foldersMap=a.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(m){this._id=m.id,this._configuration=m.configuration,this._transient=m.transient,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=a.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=R;class F{constructor(m,r){this.raw=r,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,t.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=F;function _(n){return new F({uri:n,index:0,name:(0,t.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=_}),define(Ee[63],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(w){this.id=w,this._data=new Map,this._idPool=1}add(w){const T=this._idPool++;return this._data.set(T,w),this.logDebugInfo(),T}get(w,T){return this._data.has(w)?this._data.get(w)[T]:void 0}delete(w){this._data.delete(w),this.logDebugInfo()}logDebugInfo(){!a.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=a,a.enableDebugLogging=!1}),define(Ee[30],ye([0,1,10,24,3]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(a.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(P=>{const C=this._providerInfo.get(P.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(P,C){C===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,C)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,w.createDecorator)("IExtHostFileSystemInfo")}),define(Ee[28],ye([0,1,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(Ee[147],ye([0,1,14]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(k,P,C){this._deferredPromises=new Map,this._id=k,this._shared=P,this._storage=C,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(R=>(this._value=R,this)),this._storageListener=this._storage.onDidChangeStorage(R=>{R.shared===this._shared&&R.key===this._id&&(this._value=R.value)}),this._scheduler=new a.RunOnceScheduler(()=>{const R=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const F of R.values())F.complete()}catch(F){for(const _ of R.values())_.error(F)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,k])=>k!==void 0).map(([k])=>k)}get whenReady(){return this._init}get(k,P){let C=this._value[k];return typeof C=="undefined"&&(C=P),C}update(k,P){this._value[k]=P;let C=this._deferredPromises.get(k);if(C!==void 0)return C.p;const R=new a.DeferredPromise;return this._deferredPromises.set(k,R),this._scheduler.isScheduled()||this._scheduler.schedule(),R.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class w extends t{constructor(k,P){super(k.identifier.value,!0,P);this._extension=k}setKeysForSync(k){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},k)}}e.ExtensionGlobalMemento=w}),define(Ee[148],ye([0,1,4,2,12]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let T=class{constructor(P,C){this._logService=P,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new a.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new a.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(P,C,R){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P)).acceptModelChanged(C.value,R)}$acceptDirtyStateChanged(P,C){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P)).acceptDirty(C)}$acceptModelSaved(P){const C=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(P,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",P.path,C);const R=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P));R.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:R.apiNotebook})}};T=Be([He(0,w.ILogService)],T),e.ExtHostNotebookDocuments=T}),define(Ee[13],ye([0,1,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class t{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=t});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(ne,a):w?w.value=a:e.set(ne,a),a},Re=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Ee[149],ye([0,1,25,4]),function(ne,e,a,t){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(P,C){w.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=a.ExtensionIdentifier.toKey(P.identifier),Ze(this,w,C,"f"),Re(this,w,"f").onDidChangePassword(R=>{R.extensionId===this._id&&this._onDidChange.fire({key:R.key})})}get(P){return Re(this,w,"f").get(this._id,P)}store(P,C){return Re(this,w,"f").store(this._id,P,C)}delete(P){return Re(this,w,"f").delete(this._id,P)}}e.ExtensionSecrets=T,w=new WeakMap}),define(Ee[85],ye([0,1,3,4]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class w{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(k){this._enabled=k}$onDidChangeTelemetryEnabled(k){this._enabled=k,this._onDidChangeTelemetryEnabled.fire(k)}}e.ExtHostTelemetry=w,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(Ee[47],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var a;(function(v){v[v.Upsert=0]="Upsert",v[v.RemoveChild=1]="RemoveChild",v[v.Invalidated=2]="Invalidated",v[v.SetProp=3]="SetProp",v[v.Bulk=4]="Bulk"})(a=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,w=(v,f)=>{const p={controllerId:f};return t.set(v,p),p};e.createPrivateApiFor=w;const T=v=>t.get(v);e.getPrivateApiFor=T;const k=(v,f,p,I)=>{let l=p;return{enumerable:!0,configurable:!1,get(){return l},set(M){if(!I(l,M)){const o=l;l=M,v.listener?.({op:3,key:f,value:M,previous:o})}}}},P=(v,f)=>v===f,C={range:(v,f)=>v===f?!0:!v||!f?!1:v.isEqual(f),label:P,description:P,busy:P,error:P,canResolveChildren:P,tags:(v,f)=>!(v.length!==f.length||v.some(p=>!f.find(I=>p.id===I.id)))},R=Object.keys(C),F=(v,f)=>({range:k(v,"range",void 0,C.range),label:k(v,"label",f,C.label),description:k(v,"description",void 0,C.description),canResolveChildren:k(v,"canResolveChildren",!1,C.canResolveChildren),busy:k(v,"busy",!1,C.busy),error:k(v,"error",void 0,C.error),tags:k(v,"tags",[],C.tags)}),_=(v,f)=>{const p=new Map;for(const I of R)C[I](v[I],f[I])||p.set(I,f[I]);return p};e.diffTestItems=_;class n extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.DuplicateTestItemError=n;class m extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class r extends Error{constructor(f,p,I){super(`TestItem with ID "${f}" is from controller "${p}" and cannot be added as a child of an item from controller "${I}".`)}}e.MixedTestItemController=r;const g=v=>{const f=(0,e.getPrivateApiFor)(v);let p=new Map;return{get size(){return p.size},forEach(I,l){for(const M of p.values())I.call(l,M,this)},replace(I){const l=new Map,M=new Set(p.keys()),o={op:4,ops:[]};for(const i of I){if(!(i instanceof d))throw new m(i.id);const h=(0,e.getPrivateApiFor)(i).controllerId;if(h!==f.controllerId)throw new r(i.id,h,f.controllerId);if(l.has(i.id))throw new n(i.id);l.set(i.id,i),M.delete(i.id),o.ops.push({op:0,item:i})}for(const i of M.keys())o.ops.push({op:1,id:i});f.listener?.(o),p=l},add(I){if(!(I instanceof d))throw new m(I.id);p.set(I.id,I),f.listener?.({op:0,item:I})},delete(I){p.delete(I)&&f.listener?.({op:1,id:I})},get(I){return p.get(I)},toJSON(){return Array.from(p.values())},[Symbol.iterator](){return p.values()}}};class d{constructor(f,p,I,l){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const M=(0,e.createPrivateApiFor)(this,f);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return M.parent instanceof D?void 0:M.parent}},children:{value:g(this),enumerable:!0,writable:!1},...F(M,I)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=d;class D extends d{constructor(f,p){super(f,f,p,void 0)}}e.TestItemRootImpl=D}),define(Ee[64],ye([0,1,3,144,4,13]),function(ne,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var k;(function(C){function R(_){return{remoteAddress:_.remoteAddress,localAddress:_.localAddress,public:!!_.public,privacy:_.privacy??(_.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:_.protocol}}C.fromApiTunnel=R;function F(_){return{remoteAddress:{host:_.tunnelRemoteHost,port:_.tunnelRemotePort},localAddress:_.localAddress,public:_.privacy!==t.TunnelPrivacyId.ConstantPrivate&&_.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:_.privacy,protocol:_.protocol}}C.fromServiceTunnel=F})(k=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let P=class{constructor(R){this.onDidChangeTunnels=new w.Emitter().event}async $applyCandidateFilter(R){return R}async openTunnel(R,F){}async getTunnels(){return[]}async setTunnelExtensionFunctions(R){return{dispose:()=>{}}}registerPortsAttributesProvider(R,F){return{dispose:()=>{}}}async $providePortAttributes(R,F,_,n,m){return[]}async $forwardPort(R,F){}async $closeTunnel(R){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=Be([He(0,T.IExtHostRpcService)],P),e.ExtHostTunnelService=P});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(ne,a):w?w.value=a:e.set(ne,a),a},Re=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Ee[7],ye([0,1,16,15,76,21,78,9,11,2,35,45,84]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n){"use strict";var m,r,g,d,D,v,f,p,I,l,M,o,i,h,u,s,b,y,c,S;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(x){function O(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(O,x),Object.setPrototypeOf(O.prototype,x.prototype),O}let U=D=class{constructor(O){m.set(this,void 0),Ze(this,m,O,"f")}static from(...O){let J=O;return new D(function(){if(J){for(const _e of J)_e&&typeof _e.dispose=="function"&&_e.dispose();J=void 0}})}dispose(){typeof Re(this,m,"f")=="function"&&(Re(this,m,"f").call(this),Ze(this,m,void 0,"f"))}};m=new WeakMap,U=D=Be([A],U),e.Disposable=U;let H=v=class{constructor(O,J){if(O<0)throw(0,t.illegalArgument)("line must be non-negative");if(J<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=O,this._character=J}static Min(...O){if(O.length===0)throw new TypeError;let J=O[0];for(let _e=1;_e<O.length;_e++){const Ge=O[_e];Ge.isBefore(J)&&(J=Ge)}return J}static Max(...O){if(O.length===0)throw new TypeError;let J=O[0];for(let _e=1;_e<O.length;_e++){const Ge=O[_e];Ge.isAfter(J)&&(J=Ge)}return J}static isPosition(O){if(!O)return!1;if(O instanceof v)return!0;let{line:J,character:_e}=O;return typeof J=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,J=0){if(O===null||J===null)throw(0,t.illegalArgument)();let _e;return typeof O=="undefined"?_e=0:typeof O=="number"?_e=O:(_e=typeof O.lineDelta=="number"?O.lineDelta:0,J=typeof O.characterDelta=="number"?O.characterDelta:0),_e===0&&J===0?this:new v(this.line+_e,this.character+J)}with(O,J=this.character){if(O===null||J===null)throw(0,t.illegalArgument)();let _e;return typeof O=="undefined"?_e=this.line:typeof O=="number"?_e=O:(_e=typeof O.line=="number"?O.line:this.line,J=typeof O.character=="number"?O.character:this.character),_e===this.line&&J===this.character?this:new v(_e,J)}toJSON(){return{line:this.line,character:this.character}}};H=v=Be([A],H),e.Position=H;let E=f=class{constructor(O,J,_e,Ge){let tt,at;if(typeof O=="number"&&typeof J=="number"&&typeof _e=="number"&&typeof Ge=="number"?(tt=new H(O,J),at=new H(_e,Ge)):O instanceof H&&J instanceof H&&(tt=O,at=J),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this._start=tt,this._end=at):(this._start=at,this._end=tt)}static isRange(O){return O instanceof f?!0:O?H.isPosition(O.start)&&H.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof f?this.contains(O._start)&&this.contains(O._end):O instanceof H?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const J=H.Max(O.start,this._start),_e=H.Min(O.end,this._end);if(!J.isAfter(_e))return new f(J,_e)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const J=H.Min(O.start,this._start),_e=H.Max(O.end,this.end);return new f(J,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,J=this.end){if(O===null||J===null)throw(0,t.illegalArgument)();let _e;return O?H.isPosition(O)?_e=O:(_e=O.start||this.start,J=O.end||this.end):_e=this.start,_e.isEqual(this._start)&&J.isEqual(this.end)?this:new f(_e,J)}toJSON(){return[this.start,this.end]}};E=f=Be([A],E),e.Range=E;let L=p=class extends E{constructor(O,J,_e,Ge){let tt,at;if(typeof O=="number"&&typeof J=="number"&&typeof _e=="number"&&typeof Ge=="number"?(tt=new H(O,J),at=new H(_e,Ge)):O instanceof H&&J instanceof H&&(tt=O,at=J),!tt||!at)throw new Error("Invalid arguments");super(tt,at);this._anchor=tt,this._active=at}static isSelection(O){return O instanceof p?!0:O?E.isRange(O)&&H.isPosition(O.anchor)&&H.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};L=p=Be([A],L),e.Selection=L;class z{constructor(O,J,_e){if(typeof O!="string"||O.length===0)throw(0,t.illegalArgument)("host");if(typeof J!="number"||J===0||Math.round(J)!==J)throw(0,t.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,t.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(J),this.connectionToken=_e}}e.ResolvedAuthority=z;class N extends Error{constructor(O,J=n.RemoteAuthorityResolverErrorCode.Unknown,_e){super(O);this._message=O,this._code=J,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,N.prototype)}static NotAvailable(O,J){return new N(O,n.RemoteAuthorityResolverErrorCode.NotAvailable,J)}static TemporarilyNotAvailable(O){return new N(O,n.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=N;var $;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})($=e.EndOfLine||(e.EndOfLine={}));var j;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(j=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ue=I=class{constructor(O,J){this._range=O,this._newText=J}static isTextEdit(O){return O instanceof I?!0:O?E.isRange(O)&&typeof O.newText=="string":!1}static replace(O,J){return new I(O,J)}static insert(O,J){return I.replace(new E(O,O),J)}static delete(O){return I.replace(O,"")}static setEndOfLine(O){const J=new I(new E(new H(0,0),new H(0,0)),"");return J.newEol=O,J}get range(){return this._range}set range(O){if(O&&!E.isRange(O))throw(0,t.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,t.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,t.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ue=I=Be([A],ue),e.TextEdit=ue;var K;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace"})(K=e.FileEditType||(e.FileEditType={}));let ie=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,J,_e,Ge){this._edits.push({_type:1,from:O,to:J,options:_e,metadata:Ge})}createFile(O,J,_e){this._edits.push({_type:1,from:void 0,to:O,options:J,metadata:_e})}deleteFile(O,J,_e){this._edits.push({_type:1,from:O,to:void 0,options:J,metadata:_e})}replaceNotebookMetadata(O,J,_e){this._edits.push({_type:3,metadata:_e,uri:O,edit:{editType:5,metadata:J},notebookMetadata:J})}replaceNotebookCells(O,J,_e,Ge,tt){let at,dt,kt=[],Rt;if(Me.isNotebookRange(J)&&Ut.isNotebookCellDataArray(_e)&&!Ut.isNotebookCellDataArray(Ge)?(at=J.start,dt=J.end,kt=_e,Rt=Ge):typeof J=="number"&&typeof _e=="number"&&Ut.isNotebookCellDataArray(Ge)&&(at=J,dt=_e,kt=Ge,Rt=tt),at===void 0||dt===void 0)throw new Error("Invalid arguments");(at!==dt||kt.length>0)&&this._edits.push({_type:5,uri:O,index:at,count:dt-at,cells:kt,metadata:Rt})}replaceNotebookCellMetadata(O,J,_e,Ge){this._edits.push({_type:3,metadata:Ge,uri:O,edit:{editType:8,index:J,metadata:_e}})}replace(O,J,_e,Ge){this._edits.push({_type:2,uri:O,edit:new ue(J,_e),metadata:Ge})}insert(O,J,_e,Ge){this.replace(O,new E(J,J),_e,Ge)}delete(O,J,_e){this.replace(O,J,"",_e)}has(O){return this._edits.some(J=>J._type===2&&J.uri.toString()===O.toString())}set(O,J){if(J)for(const _e of J)_e&&this._edits.push({_type:2,uri:O,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const Ge=this._edits[_e];Ge._type===2&&Ge.uri.toString()===O.toString()&&(this._edits[_e]=void 0)}(0,a.coalesceInPlace)(this._edits)}}get(O){const J=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===O.toString()&&J.push(_e.edit);return J}entries(){const O=new T.ResourceMap;for(let J of this._edits)if(J._type===2){let _e=O.get(J.uri);_e||(_e=[J.uri,[]],O.set(J.uri,_e)),_e[1].push(J.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ie=Be([A],ie),e.WorkspaceEdit=ie;let pe=l=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof l?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=l._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,J=this._tabstop++){if(typeof O=="function"){const _e=new l;_e._tabstop=this._tabstop,O(_e),this._tabstop=_e._tabstop,O=_e.value}else O=l._escape(O);return this.value+="${",this.value+=J,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,J=this._tabstop++){const _e=O.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=J,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(O,J){if(typeof J=="function"){const _e=new l;_e._tabstop=this._tabstop,J(_e),this._tabstop=_e._tabstop,J=_e.value}else typeof J=="string"&&(J=J.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,J&&(this.value+=":",this.value+=J),this.value+="}",this}};pe=l=Be([A],pe),e.SnippetString=pe;var we;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(we=e.DiagnosticTag||(e.DiagnosticTag={}));var ae;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(ae=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let le=M=class{constructor(O,J){if(this.uri=O,J)if(J instanceof E)this.range=J;else if(J instanceof H)this.range=new E(J,J);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof M?!0:O?E.isRange(O.range)&&R.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};le=M=Be([A],le),e.Location=le;let Se=class{constructor(O,J){this.location=O,this.message=J}static is(O){return O?typeof O.message=="string"&&O.location&&E.isRange(O.location.range)&&R.URI.isUri(O.location.uri):!1}static isEqual(O,J){return O===J?!0:!O||!J?!1:O.message===J.message&&O.location.range.isEqual(J.location.range)&&O.location.uri.toString()===J.location.uri.toString()}};Se=Be([A],Se),e.DiagnosticRelatedInformation=Se;let Ce=class{constructor(O,J,_e=ae.Error){if(!E.isRange(O))throw new TypeError("range must be set");if(!J)throw new TypeError("message must be set");this.range=O,this.message=J,this.severity=_e}toJSON(){return{severity:ae[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,J){return O===J?!0:!O||!J?!1:O.message===J.message&&O.severity===J.severity&&O.code===J.code&&O.severity===J.severity&&O.source===J.source&&O.range.isEqual(J.range)&&(0,a.equals)(O.tags,J.tags)&&(0,a.equals)(O.relatedInformation,J.relatedInformation,Se.isEqual)}};Ce=Be([A],Ce),e.Diagnostic=Ce;let Fe=class{constructor(O,J){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=J}};Fe=Be([A],Fe),e.Hover=Fe;var $e;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})($e=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ve=class{constructor(O,J=$e.Text){this.range=O,this.kind=J}toJSON(){return{range:this.range,kind:$e[this.kind]}}};Ve=Be([A],Ve),e.DocumentHighlight=Ve;var je;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(je=e.SymbolKind||(e.SymbolKind={}));var B;(function(x){x[x.Deprecated=1]="Deprecated"})(B=e.SymbolTag||(e.SymbolTag={}));let G=o=class{constructor(O,J,_e,Ge,tt){this.name=O,this.kind=J,this.containerName=tt,typeof _e=="string"&&(this.containerName=_e),Ge instanceof le?this.location=Ge:_e instanceof E&&(this.location=new le(Ge,_e)),o.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:je[this.kind],location:this.location,containerName:this.containerName}}};G=o=Be([A],G),e.SymbolInformation=G;let X=i=class{constructor(O,J,_e,Ge,tt){this.name=O,this.detail=J,this.kind=_e,this.range=Ge,this.selectionRange=tt,this.children=[],i.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(i.validate)}};X=i=Be([A],X),e.DocumentSymbol=X;var se;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(se=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let q=class{constructor(O,J){this.title=O,this.kind=J}};q=Be([A],q),e.CodeAction=q;let ee=h=class{constructor(O){this.value=O}append(O){return new h(this.value?this.value+h.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+h.sep)}};ee.sep=".",ee=h=Be([A],ee),e.CodeActionKind=ee,ee.Empty=new ee(""),ee.QuickFix=ee.Empty.append("quickfix"),ee.Refactor=ee.Empty.append("refactor"),ee.RefactorExtract=ee.Refactor.append("extract"),ee.RefactorInline=ee.Refactor.append("inline"),ee.RefactorRewrite=ee.Refactor.append("rewrite"),ee.Source=ee.Empty.append("source"),ee.SourceOrganizeImports=ee.Source.append("organizeImports"),ee.SourceFixAll=ee.Source.append("fixAll");let fe=class{constructor(O,J){if(this.range=O,this.parent=J,J&&!J.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};fe=Be([A],fe),e.SelectionRange=fe;class Ae{constructor(O,J,_e,Ge,tt,at){this.kind=O,this.name=J,this.detail=_e,this.uri=Ge,this.range=tt,this.selectionRange=at}}e.CallHierarchyItem=Ae;class xe{constructor(O,J){this.fromRanges=J,this.from=O}}e.CallHierarchyIncomingCall=xe;class ze{constructor(O,J){this.fromRanges=J,this.to=O}}e.CallHierarchyOutgoingCall=ze;var Xe;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(O,J){this.range=O,this.command=J}get isResolved(){return!!this.command}};et=Be([A],et),e.CodeLens=et;let st=u=class{constructor(O,J=!1){r.set(this,void 0),Ze(this,r,new w.MarkdownString(O,{supportThemeIcons:J}),"f")}static isMarkdownString(O){return O instanceof u?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Re(this,r,"f").value}set value(O){Re(this,r,"f").value=O}get isTrusted(){return Re(this,r,"f").isTrusted}set isTrusted(O){Re(this,r,"f").isTrusted=O}get supportThemeIcons(){return Re(this,r,"f").supportThemeIcons}set supportThemeIcons(O){Re(this,r,"f").supportThemeIcons=O}get supportHtml(){return Re(this,r,"f").supportHtml}set supportHtml(O){Re(this,r,"f").supportHtml=O}appendText(O){return Re(this,r,"f").appendText(O),this}appendMarkdown(O){return Re(this,r,"f").appendMarkdown(O),this}appendCodeblock(O,J){return Re(this,r,"f").appendCodeblock(J??"",O),this}};r=new WeakMap,st=u=Be([A],st),e.MarkdownString=st;let Je=class{constructor(O,J){this.label=O,this.documentation=J}};Je=Be([A],Je),e.ParameterInformation=Je;let nt=class{constructor(O,J){this.label=O,this.documentation=J,this.parameters=[]}};nt=Be([A],nt),e.SignatureInformation=nt;let lt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};lt=Be([A],lt),e.SignatureHelp=lt;var pt;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(pt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ft;(function(x){x[x.Other=0]="Other",x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(Ft=e.InlayHintKind||(e.InlayHintKind={}));let Oe=class{constructor(O,J,_e){this.text=O,this.position=J,this.kind=_e}};Oe=Be([A],Oe),e.InlayHint=Oe;var Mt;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Mt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var V;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(V=e.CompletionItemKind||(e.CompletionItemKind={}));var Q;(function(x){x[x.Deprecated=1]="Deprecated"})(Q=e.CompletionItemTag||(e.CompletionItemTag={}));let de=class{constructor(O,J){this.label=O,this.kind=J}toJSON(){return{label:this.label,kind:this.kind&&V[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};de=Be([A],de),e.CompletionItem=de;let Ne=class{constructor(O=[],J=!1){this.items=O,this.isIncomplete=J}};Ne=Be([A],Ne),e.CompletionList=Ne;let qe=class{constructor(O,J,_e){this.text=O,this.range=J,this.command=_e}};qe=Be([A],qe),e.InlineSuggestion=qe;let ot=class{constructor(O){this.items=O}};ot=Be([A],ot),e.InlineSuggestions=ot;var Ye;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Ye=e.ViewColumn||(e.ViewColumn={}));var yt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(yt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Te;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(Te=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var De;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(De=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ve;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var re;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(re=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var oe;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(oe=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var he;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(he=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function O(J){switch(J){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=O}(re=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let me=class{constructor(O,J){if(J&&!R.URI.isUri(J))throw(0,t.illegalArgument)("target");if(!E.isRange(O)||O.isEmpty)throw(0,t.illegalArgument)("range");this.range=O,this.target=J}};me=Be([A],me),e.DocumentLink=me;let Pe=class{constructor(O,J,_e,Ge){this.red=O,this.green=J,this.blue=_e,this.alpha=Ge}};Pe=Be([A],Pe),e.Color=Pe;let We=class{constructor(O,J){if(J&&!(J instanceof Pe))throw(0,t.illegalArgument)("color");if(!E.isRange(O)||O.isEmpty)throw(0,t.illegalArgument)("range");this.range=O,this.color=J}};We=Be([A],We),e.ColorInformation=We;let Le=class{constructor(O){if(!O||typeof O!="string")throw(0,t.illegalArgument)("label");this.label=O}};Le=Be([A],Le),e.ColorPresentation=Le;var Ke;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Ke=e.ColorFormat||(e.ColorFormat={}));var it;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class rt{constructor(O,J,_e){if(this.startIndex=O,this.length=J,this.tooltip=_e,typeof O!="number"||O<0)throw(0,t.illegalArgument)("startIndex");if(typeof J!="number"||J<1)throw(0,t.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=rt;var te;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(te=e.TerminalLocation||(e.TerminalLocation={}));class ge{constructor(O){this.options=O,typeof O!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=ge;var Z;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(Z=e.TaskRevealKind||(e.TaskRevealKind={}));var W;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(W=e.TaskPanelKind||(e.TaskPanelKind={}));let be=s=class{constructor(O,J){if(this.label=J,typeof O!="string"||typeof J!="string")throw(0,t.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};be.Clean=new s("clean","Clean"),be.Build=new s("build","Build"),be.Rebuild=new s("rebuild","Rebuild"),be.Test=new s("test","Test"),be=s=Be([A],be),e.TaskGroup=be;function Ie(x){let O="";for(let J=0;J<x.length;J++)O+=x[J].replace(/,/g,",,")+",";return O}let Qe=class{constructor(O,J,_e){if(typeof O!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=O,J!==void 0&&(Array.isArray(J)?(this._args=J,this._options=_e):this._options=J)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,t.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let J of this._args)O.push(J);return Ie(O)}};Qe=Be([A],Qe),e.ProcessExecution=Qe;let Ue=class{constructor(O,J,_e){if(this._args=[],Array.isArray(J)){if(!O)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,t.illegalArgument)("command");this._command=O,this._args=J,this._options=_e}else{if(typeof O!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=O,this._options=J}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,t.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let J of this._args)O.push(typeof J=="string"?J:J.value);return Ie(O)}};Ue=Be([A],Ue),e.ShellExecution=Ue;var ut;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(ut=e.ShellQuoting||(e.ShellQuoting={}));var vt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(vt=e.TaskScope||(e.TaskScope={}));class St{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,F.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=St;let bt=b=class{constructor(O,J,_e,Ge,tt,at){this.__deprecated=!1,this._definition=this.definition=O;let dt;typeof J=="string"?(this._name=this.name=J,this._source=this.source=_e,this.execution=Ge,dt=tt,this.__deprecated=!0):J===vt.Global||J===vt.Workspace?(this.target=J,this._name=this.name=_e,this._source=this.source=Ge,this.execution=tt,dt=at):(this.target=J,this._name=this.name=_e,this._source=this.source=Ge,this.execution=tt,dt=at),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Qe?this._definition={type:b.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ue?this._definition={type:b.ShellType,id:this._execution.computeId()}:this._execution instanceof St?this._definition={type:b.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:b.EmptyType,id:(0,F.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const J=this._definition.type;(b.EmptyType===J||b.ProcessType===J||b.ShellType===J||b.ExtensionCallbackType===J)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=b=Be([A],bt),e.Task=bt;var ht;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(ht=e.ProgressLocation||(e.ProgressLocation={}));let gt=class{constructor(O,J=_t.None){this.collapsibleState=J,R.URI.isUri(O)?this.resourceUri=O:this.label=O}};gt=Be([A],gt),e.TreeItem=gt;var _t;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Lt=class{constructor(O){this._value=O}async asString(){return JSON.stringify(this._value)}};Lt=Be([A],Lt),e.TreeDataTransferItem=Lt;let It=class{constructor(){this._items=new Map}get(O){return this._items.get(O)}set(O,J){this._items.set(O,J)}forEach(O){this._items.forEach(O)}};It=Be([A],It),e.TreeDataTransfer=It;let Pt=class{constructor(O,J){this.id=O,this.color=J}};Pt=Be([A],Pt),e.ThemeIcon=Pt,Pt.File=new Pt("file"),Pt.Folder=new Pt("folder");let At=class{constructor(O){this.id=O}};At=Be([A],At),e.ThemeColor=At;var Et;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(Et=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ot=class{constructor(O,J){if(typeof O!="string"&&(!O||!R.URI.isUri(O)&&!R.URI.isUri(O.uri)))throw(0,t.illegalArgument)("base");if(typeof J!="string")throw(0,t.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=R.URI.file(O),this.base=O):R.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=J}};Ot=Be([A],Ot),e.RelativePattern=Ot;let Nt=class{constructor(O,J,_e,Ge){this.enabled=typeof O=="boolean"?O:!0,typeof J=="string"&&(this.condition=J),typeof _e=="string"&&(this.hitCondition=_e),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,F.generateUuid)()),this._id}};Nt=Be([A],Nt),e.Breakpoint=Nt;let wt=class extends Nt{constructor(O,J,_e,Ge,tt){super(J,_e,Ge,tt);if(O===null)throw(0,t.illegalArgument)("location");this.location=O}};wt=Be([A],wt),e.SourceBreakpoint=wt;let $t=class extends Nt{constructor(O,J,_e,Ge,tt){super(J,_e,Ge,tt);this.functionName=O}};$t=Be([A],$t),e.FunctionBreakpoint=$t;let jt=class extends Nt{constructor(O,J,_e,Ge,tt,at,dt){super(Ge,tt,at,dt);if(!J)throw(0,t.illegalArgument)("dataId");this.label=O,this.dataId=J,this.canPersist=_e}};jt=Be([A],jt),e.DataBreakpoint=jt;let oi=class{constructor(O,J,_e){this.command=O,this.args=J||[],this.options=_e}};oi=Be([A],oi),e.DebugAdapterExecutable=oi;let si=class{constructor(O,J){this.port=O,this.host=J}};si=Be([A],si),e.DebugAdapterServer=si;let Tt=class{constructor(O){this.path=O}};Tt=Be([A],Tt),e.DebugAdapterNamedPipeServer=Tt;let Yt=class{constructor(O){this.implementation=O}};Yt=Be([A],Yt),e.DebugAdapterInlineImplementation=Yt;let ai=class{constructor(O,J){this.range=O,this.expression=J}};ai=Be([A],ai),e.EvaluatableExpression=ai;var Xt;(function(x){x[x.Automatic=0]="Automatic",x[x.Explicit=1]="Explicit"})(Xt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Vt=class{constructor(O,J){this.range=O,this.text=J}};Vt=Be([A],Vt),e.InlineValueText=Vt;let mt=class{constructor(O,J,_e=!0){this.range=O,this.variableName=J,this.caseSensitiveLookup=_e}};mt=Be([A],mt),e.InlineValueVariableLookup=mt;let li=class{constructor(O,J){this.range=O,this.expression=J}};li=Be([A],li),e.InlineValueEvaluatableExpression=li;let xt=class{constructor(O,J){this.frameId=O,this.stoppedLocation=J}};xt=Be([A],xt),e.InlineValueContext=xt;var qt;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(qt=e.FileChangeType||(e.FileChangeType={}));let Jt=y=class extends Error{constructor(O,J=_.FileSystemProviderErrorCode.Unknown,_e){super(R.URI.isUri(O)?O.toString(!0):O);this.code=_e?.name??"Unknown",(0,_.markAsFileSystemProviderError)(this,J),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,y.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(O){return new y(O,_.FileSystemProviderErrorCode.FileExists,y.FileExists)}static FileNotFound(O){return new y(O,_.FileSystemProviderErrorCode.FileNotFound,y.FileNotFound)}static FileNotADirectory(O){return new y(O,_.FileSystemProviderErrorCode.FileNotADirectory,y.FileNotADirectory)}static FileIsADirectory(O){return new y(O,_.FileSystemProviderErrorCode.FileIsADirectory,y.FileIsADirectory)}static NoPermissions(O){return new y(O,_.FileSystemProviderErrorCode.NoPermissions,y.NoPermissions)}static Unavailable(O){return new y(O,_.FileSystemProviderErrorCode.Unavailable,y.Unavailable)}};Jt=y=Be([A],Jt),e.FileSystemError=Jt;let ci=class{constructor(O,J,_e){this.start=O,this.end=J,this.kind=_e}};ci=Be([A],ci),e.FoldingRange=ci;var fi;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class Zt{constructor(O,J=[]){this.tokenTypes=O,this.tokenModifiers=J}}e.SemanticTokensLegend=Zt;function yi(x){return typeof x=="undefined"||(0,C.isStringArray)(x)}class Kt{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let J=0,_e=O.tokenTypes.length;J<_e;J++)this._tokenTypeStrToInt.set(O.tokenTypes[J],J);for(let J=0,_e=O.tokenModifiers.length;J<_e;J++)this._tokenModifierStrToInt.set(O.tokenModifiers[J],J)}}push(O,J,_e,Ge,tt){if(typeof O=="number"&&typeof J=="number"&&typeof _e=="number"&&typeof Ge=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(O,J,_e,Ge,tt);if(E.isRange(O)&&typeof J=="string"&&yi(_e))return this._push(O,J,_e);throw(0,t.illegalArgument)()}_push(O,J,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(J))throw new Error("`tokenType` is not in the provided legend");const Ge=O.start.line,tt=O.start.character,at=O.end.character-O.start.character,dt=this._tokenTypeStrToInt.get(J);let kt=0;if(_e)for(const Rt of _e){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Bt=this._tokenModifierStrToInt.get(Rt);kt|=1<<Bt>>>0}this._pushEncoded(Ge,tt,at,dt,kt)}_pushEncoded(O,J,_e,Ge,tt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&J<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const kt=this._data.length/5|0;let Rt=0,Bt=0;for(let Ht=0;Ht<kt;Ht++){let zt=this._data[5*Ht],di=this._data[5*Ht+1];zt===0?(zt=Rt,di+=Bt):zt+=Rt,this._data[5*Ht]=zt,this._data[5*Ht+1]=di,Rt=zt,Bt=di}}let at=O,dt=J;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=tt,this._prevLine=O,this._prevChar=J}static _sortAndDeltaEncode(O){let J=[];const _e=O.length/5|0;for(let dt=0;dt<_e;dt++)J[dt]=dt;J.sort((dt,kt)=>{const Rt=O[5*dt],Bt=O[5*kt];if(Rt===Bt){const Ht=O[5*dt+1],zt=O[5*kt+1];return Ht-zt}return Rt-Bt});const Ge=new Uint32Array(O.length);let tt=0,at=0;for(let dt=0;dt<_e;dt++){const kt=5*J[dt],Rt=O[kt+0],Bt=O[kt+1],Ht=O[kt+2],zt=O[kt+3],di=O[kt+4],Hi=Rt-tt,Yi=Hi===0?Bt-at:Bt,hi=5*dt;Ge[hi+0]=Hi,Ge[hi+1]=Yi,Ge[hi+2]=Ht,Ge[hi+3]=zt,Ge[hi+4]=di,tt=Rt,at=Bt}return Ge}build(O){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),O):new Gt(Kt._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=Kt;class Gt{constructor(O,J){this.resultId=J,this.data=O}}e.SemanticTokens=Gt;class _i{constructor(O,J,_e){this.start=O,this.deleteCount=J,this.data=_e}}e.SemanticTokensEdit=_i;class Ci{constructor(O,J){this.resultId=J,this.edits=O}}e.SemanticTokensEdits=Ci;var Qt;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Qt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Si;(function(x){x[x.Initial=1]="Initial",x[x.Dynamic=2]="Dynamic"})(Si=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new Pt("arrow-left")},ei=Be([A],ei),e.QuickInputButtons=ei;var Di;(function(x){x[x.Default=1]="Default",x[x.Separator=2]="Separator"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor(O,J,_e){this.badge=O,this.tooltip=J,this.color=_e}static validate(O){if(O.badge){let J=(0,P.nextCharLength)(O.badge,0);if(J<O.badge.length&&(J+=(0,P.nextCharLength)(O.badge,J)),O.badge.length>J)throw new Error("The 'badge'-property must be undefined or a short character")}if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ti=class{constructor(O){this.kind=O}};ti=Be([A],ti),e.ColorTheme=ti;var gi;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Me{constructor(O,J){if(O<0)throw(0,t.illegalArgument)("start must be positive");if(J<0)throw(0,t.illegalArgument)("end must be positive");O<=J?(this._start=O,this._end=J):(this._start=J,this._end=O)}static isNotebookRange(O){return O instanceof Me?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let J=this._start,_e=this._end;return O.start!==void 0&&(J=O.start),O.end!==void 0&&(_e=O.end),J===this._start&&_e===this._end?this:new Me(J,_e)}}e.NotebookRange=Me;class Ut{constructor(O,J,_e,Ge,tt,at,dt){this.kind=O,this.value=J,this.languageId=_e,this.mime=Ge,this.outputs=tt??[],this.metadata=at,this.executionSummary=dt,Ut.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(J=>Ut.isNotebookCellData(J))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Ut;class pi{constructor(O){this.cells=O}}e.NotebookData=pi;class ft{constructor(O,J){this.data=O,this.mime=J;const _e=(0,k.normalizeMimeType)(J,!0);if(!_e)throw new Error(`INVALID mime type: ${J}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(O){return O instanceof ft?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const J={name:O.name,message:O.message,stack:O.stack};return ft.json(J,"application/vnd.code.notebook.error")}static stdout(O){return ft.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return ft.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,J="application/octet-stream"){return new ft(O,J)}static text(O,J=k.Mimes.text){const _e=Re(ft,g,"f",d).encode(String(O));return new ft(_e,J)}static json(O,J="application/json"){const _e=JSON.stringify(O,void 0,"	");return ft.text(_e,J)}}e.NotebookCellOutputItem=ft,g=ft,d={value:new TextEncoder};class ii{constructor(O,J,_e){this.items=ii.ensureUniqueMimeTypes(O,!0),typeof J=="string"?(this.id=J,this.metadata=_e):(this.id=(0,F.generateUuid)(),this.metadata=J??_e)}static isNotebookCellOutput(O){return O instanceof ii?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,C.isArray)(O.items)}static ensureUniqueMimeTypes(O,J=!1){const _e=new Set,Ge=new Set;for(let tt=0;tt<O.length;tt++){const at=O[tt],dt=(0,k.normalizeMimeType)(at.mime);if(!_e.has(dt)){_e.add(dt);continue}Ge.add(tt),J&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?O:O.filter((tt,at)=>!Ge.has(at))}}e.NotebookCellOutput=ii;var Ii;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var bi;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(bi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor(O,J){this.text=O,this.alignment=J}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor(O,J=[]){this.uri=O,this.provides=(0,a.asArray)(J)}}e.NotebookRendererScript=Ri;let ni=class{constructor(O,J){this.label=O,this.timestamp=J}};ni=Be([A],ni),e.TimelineItem=ni;var Fi;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(Fi=e.ExtensionMode||(e.ExtensionMode={}));var Mi;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(Mi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Oi;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(Oi=e.StandardTokenType||(e.StandardTokenType={}));class Li{constructor(O,J){this.ranges=O,this.wordPattern=J}}e.LinkedEditingRanges=Li;class Ni{constructor(O,J){this._port=O,this._autoForwardAction=J}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var Y;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(Y=e.TestResultState||(e.TestResultState={}));var ce;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(ce=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ke=class{constructor(O=void 0,J=void 0,_e=void 0){this.include=O,this.exclude=J,this.profile=_e}};ke=Be([A],ke),e.TestRunRequest=ke;let ct=c=class{constructor(O){this.message=O}static diff(O,J,_e){const Ge=new c(O);return Ge.expectedOutput=J,Ge.actualOutput=_e,Ge}};ct=c=Be([A],ct),e.TestMessage=ct;let Ct=class{constructor(O){this.id=O}};Ct=Be([A],Ct),e.TestTag=Ct;let Dt=class{constructor(O,J){this.covered=O,this.total=J}};Dt=Be([A],Dt),e.CoveredCount=Dt;let xi=S=class{constructor(O,J,_e,Ge){this.uri=O,this.statementCoverage=J,this.branchCoverage=_e,this.functionCoverage=Ge}static fromDetails(O,J){const _e=new Dt(0,0),Ge=new Dt(0,0),tt=new Dt(0,0);for(const dt of J)if("branches"in dt){_e.total+=1,_e.covered+=dt.executionCount>0?1:0;for(const kt of dt.branches)Ge.total+=1,Ge.covered+=kt.executionCount>0?1:0}else tt.total+=1,tt.covered+=dt.executionCount>0?1:0;const at=new S(O,_e,Ge.total>0?Ge:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=J,at}};xi=S=Be([A],xi),e.FileCoverage=xi;let Ui=class{constructor(O,J,_e=[]){this.executionCount=O,this.location=J,this.branches=_e}};Ui=Be([A],Ui),e.StatementCoverage=Ui;let Bi=class{constructor(O,J){this.executionCount=O,this.location=J}};Bi=Be([A],Bi),e.BranchCoverage=Bi;let $i=class{constructor(O,J){this.executionCount=O,this.location=J}};$i=Be([A],$i),e.FunctionCoverage=$i;var qi;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ki;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(Ki=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Gi;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(Gi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(O,J,_e,Ge,tt,at){this.kind=O,this.name=J,this.detail=_e,this.uri=Ge,this.range=tt,this.selectionRange=at}}e.TypeHierarchyItem=Qi}),define(Ee[86],ye([0,1,41,10,9,223,114,7,16]),function(ne,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const R=new Map;function F(r,g){g?R.set(r,g):R.delete(r)}e.setWordDefinitionFor=F;function _(r){return R.get(r)}e.getWordDefinitionFor=_;class n extends T.MirrorTextModel{constructor(g,d,D,v,f,p,I,l){super(d,D,v,f);this._proxy=g,this._languageId=p,this._isDirty=I,this._notebook=l,this._isDisposed=!1}dispose(){(0,a.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(g){return(0,C.equals)(this._lines,g)}get document(){if(!this._document){const g=this;this._document={get uri(){return g._uri},get fileName(){return g._uri.fsPath},get isUntitled(){return g._uri.scheme===t.Schemas.untitled},get languageId(){return g._languageId},get version(){return g._versionId},get isClosed(){return g._isDisposed},get isDirty(){return g._isDirty},get notebook(){return g._notebook},save(){return g._save()},getText(d){return d?g._getTextInRange(d):g.getText()},get eol(){return g._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return g._lines.length},lineAt(d){return g._lineAt(d)},offsetAt(d){return g._offsetAt(d)},positionAt(d){return g._positionAt(d)},validateRange(d){return g._validateRange(d)},validatePosition(d){return g._validatePosition(d)},getWordRangeAtPosition(d,D){return g._getWordRangeAtPosition(d,D)}}}return Object.freeze(this._document)}_acceptLanguageId(g){(0,a.ok)(!this._isDisposed),this._languageId=g}_acceptIsDirty(g){(0,a.ok)(!this._isDisposed),this._isDirty=g}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(g){const d=this._validateRange(g);if(d.isEmpty)return"";if(d.isSingleLine)return this._lines[d.start.line].substring(d.start.character,d.end.character);const D=this._eol,v=d.start.line,f=d.end.line,p=[];p.push(this._lines[v].substring(d.start.character));for(let I=v+1;I<f;I++)p.push(this._lines[I]);return p.push(this._lines[f].substring(0,d.end.character)),p.join(D)}_lineAt(g){let d;if(g instanceof P.Position?d=g.line:typeof g=="number"&&(d=g),typeof d!="number"||d<0||d>=this._lines.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new m(d,this._lines[d],d===this._lines.length-1)}_offsetAt(g){return g=this._validatePosition(g),this._ensureLineStarts(),this._lineStarts.getPrefixSum(g.line-1)+g.character}_positionAt(g){g=Math.floor(g),g=Math.max(0,g),this._ensureLineStarts();const d=this._lineStarts.getIndexOf(g),D=this._lines[d.index].length;return new P.Position(d.index,Math.min(d.remainder,D))}_validateRange(g){if(!(g instanceof P.Range))throw new Error("Invalid argument");const d=this._validatePosition(g.start),D=this._validatePosition(g.end);return d===g.start&&D===g.end?g:new P.Range(d.line,d.character,D.line,D.character)}_validatePosition(g){if(!(g instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return g.with(0,0);let{line:d,character:D}=g,v=!1;if(d<0)d=0,D=0,v=!0;else if(d>=this._lines.length)d=this._lines.length-1,D=this._lines[d].length,v=!0;else{const f=this._lines[d].length;D<0?(D=0,v=!0):D>f&&(D=f,v=!0)}return v?new P.Position(d,D):g}_getWordRangeAtPosition(g,d){const D=this._validatePosition(g);if(!d)d=_(this._languageId);else if((0,w.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const v=(0,k.getWordAtText)(D.character+1,(0,k.ensureValidWordDefinition)(d),this._lines[D.line],0);if(v)return new P.Range(D.line,v.startColumn-1,D.line,v.endColumn-1)}}e.ExtHostDocumentData=n;class m{constructor(g,d,D){this._line=g,this._text=d,this._isLastLine=D}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(Ee[150],ye([0,1,7,4,224,6,55,21,2,35]),function(ne,e,a,t,w,T,k,P,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class F{constructor(n,m,r,g){this._notebook=r,this._selector=g,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,R.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(D=>{const v=this._cellUris.get(D.document.uri);v!==void 0&&(this._cellLengths.setValue(v,this._cells[v].document.getText().length+1),this._cellLines.setValue(v,this._cells[v].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const d=D=>{D===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(D=>d(D.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const n=[],m=[];for(const r of this._notebook.getCells())r.kind===a.NotebookCellKind.Code&&(!this._selector||(0,k.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),n.push(r.document.getText().length+1),m.push(r.document.lineCount));this._cellLengths=new w.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new w.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(n){if(!n){let v="";for(const f of this._cells)v+=f.document.getText()+`
`;return v=v.slice(0,-1),v}if(n.isEmpty)return"";const m=this.locationAt(n.start),r=this.locationAt(n.end),g=this._cellUris.get(m.uri),d=this._cellUris.get(r.uri);if(g===void 0||d===void 0)return"";if(g===d)return this._cells[g].document.getText(new a.Range(m.range.start,r.range.end));const D=[this._cells[g].document.getText(new a.Range(m.range.start,new a.Position(this._cells[g].document.lineCount,0)))];for(let v=g+1;v<d;v++)D.push(this._cells[v].document.getText());return D.push(this._cells[d].document.getText(new a.Range(new a.Position(0,0),r.range.end))),D.join(`
`)}offsetAt(n){const m=this._cellLines.getIndexOf(n.line),r=this._cellLengths.getPrefixSum(m.index-1),g=this._cells[m.index].document.offsetAt(n.with(m.remainder));return r+g}positionAt(n){if(typeof n=="number"){const r=this._cellLengths.getIndexOf(n),g=this._cellLines.getPrefixSum(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(g)}const m=this._cellUris.get(n.uri);if(m!==void 0){const r=this._cellLines.getPrefixSum(m-1);return new a.Position(r+n.range.start.line,n.range.start.character)}return new a.Position(0,0)}locationAt(n){a.Range.isRange(n)||(n=new a.Range(n,n));const m=this._cellLines.getIndexOf(n.start.line);let r=m;n.isEmpty||(r=this._cellLines.getIndexOf(n.end.line));const g=new a.Position(m.remainder,n.start.character),d=new a.Position(r.remainder,n.end.character),D=new a.Range(g,d),v=this._cells[m.index];return new a.Location(v.document.uri,v.document.validateRange(D))}contains(n){return this._cellUris.has(n)}validateRange(n){const m=this.validatePosition(n.start),r=this.validatePosition(n.end);return n.with(m,r)}validatePosition(n){const m=this._cellLines.getIndexOf(n.line),r=new a.Position(m.remainder,n.character),g=this._cells[m.index].document.validatePosition(r),d=this._cellLines.getPrefixSum(m.index-1);return new a.Position(d+g.line,g.character)}}e.ExtHostNotebookConcatDocument=F}),define(Ee[151],ye([0,1,7,13,4]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(P){this._actual=new a.ColorTheme(a.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new w.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let C=P==="light"?a.ColorThemeKind.Light:P==="dark"?a.ColorThemeKind.Dark:a.ColorThemeKind.HighContrast;this._actual=new a.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Be([He(0,t.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(Ee[65],ye([0,1,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class t{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=t}),define(Ee[152],ye([0,1,22]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(C){let R=this.buffers.indexOf(C);return R<0&&(R=this.buffers.length,this.buffers.push(C)),R}}function w(P,C){if(C.serializeBuffersForPostMessage){const R=new t,F=(m,r)=>{if(r instanceof ArrayBuffer){const g=R.add(r);return{$$vscode_array_buffer_reference$$:!0,index:g}}else if(ArrayBuffer.isView(r)){const g=T(r);if(g){const d=R.add(r.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:g,byteLength:r.byteLength,byteOffset:r.byteOffset}}}}return r},_=JSON.stringify(P,F),n=R.buffers.map(m=>{const r=new Uint8Array(m);return a.VSBuffer.wrap(r)});return{message:_,buffers:n}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=w;function T(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function k(P,C){const R=C.map(n=>{const m=new ArrayBuffer(n.byteLength);return new Uint8Array(m).set(n.buffer),m}),F=C.length?(n,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const r=m,{index:g}=r,d=R[g];if(r.view)switch(r.view.type){case 1:return new Int8Array(d,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return m}:void 0;return{message:JSON.parse(P,F),arrayBuffers:R}}e.deserializeWebviewMessage=k}),define(Ee[153],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var a;(function(t){function w(k){const P=new Map;return k.types.forEach((C,R)=>{P.set(C,{asString:async()=>k.items[R].asString})}),P}t.toITreeDataTransfer=w;async function T(k){const P={types:[],items:[]},C=Array.from(k.entries());for(const R of C)P.types.push(R[0]),P.items.push({asString:await R[1].asString()});return P}t.toTreeDataTransferDTO=T})(a=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(Ee[66],ye([0,1,10,2]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function w(P,C){return P.scheme===a.Schemas.http||P.scheme===a.Schemas.https?P:(C&&C.authority&&C.isRemote&&P.scheme===a.Schemas.file&&(P=t.URI.from({scheme:a.Schemas.vscodeRemote,authority:C.authority,path:P.path})),t.URI.from({scheme:a.Schemas.https,authority:`${P.scheme}+${T(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=w;function T(P){return P.replace(/./g,C=>{const R=C.charCodeAt(0);return R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57?C:"-"+R.toString(16).padStart(4,"0")})}function k(P){return P.replace(/-([0-9a-f]{4})/g,(C,R)=>String.fromCharCode(parseInt(R,16)))}e.decodeAuthority=k}),define(Ee[154],ye([0,1,4,6,66]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(P,C,R){this._proxy=P,this._editors=C,this._initData=R,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const F=C.getVisibleTextEditors();for(const _ of this._insets.values())F.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,C,R,F,_){let n;for(const f of this._editors.getVisibleTextEditors(!0))if(f.value===P){n=f;break}if(!n)throw new Error("not a visible editor");const m=this,r=this._handlePool++,g=new a.Emitter,d=new a.Emitter,D=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(f){return(0,w.asWebviewUri)(f,m._initData.remote)}get cspSource(){return w.webviewGenericCspSource}set options(f){this._options=f,m._proxy.$setOptions(r,f)}get options(){return this._options}set html(f){this._html=f,m._proxy.$setHtml(r,f)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(f){return m._proxy.$postMessage(r,f)}},v=new class{constructor(){this.editor=P,this.line=C,this.height=R,this.webview=D,this.onDidDispose=d.event}dispose(){m._insets.has(r)&&(m._insets.delete(r),m._proxy.$disposeEditorInset(r),d.fire(),d.dispose(),g.dispose())}};return this._proxy.$createEditorInset(r,n.id,n.value.document.uri,C+1,R,F||{},_.identifier,_.extensionLocation),this._insets.set(r,{editor:P,inset:v,onDidReceiveMessage:g}),v}$onDidDispose(P){const C=this._insets.get(P);C&&C.inset.dispose()}$onDidReceiveMessage(P,C){const R=this._insets.get(P);R&&R.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=T}),define(Ee[155],ye([0,1,126,11,2,6,3,44,36,45,16,10]),function(ne,e,a,t,w,T,k,P,C,R,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.ActiveEditorDirtyContext=new P.RawContextKey("activeEditorIsDirty",!1,(0,a.localize)(2,null)),e.ActiveEditorPinnedContext=new P.RawContextKey("activeEditorIsNotPreview",!1,(0,a.localize)(3,null)),e.ActiveEditorStickyContext=new P.RawContextKey("activeEditorIsPinned",!1,(0,a.localize)(4,null)),e.ActiveEditorReadonlyContext=new P.RawContextKey("activeEditorIsReadonly",!1,(0,a.localize)(5,null)),e.ActiveEditorCanRevertContext=new P.RawContextKey("activeEditorCanRevert",!1,(0,a.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new P.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new P.RawContextKey("activeEditor",null,{type:"string",description:(0,a.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new P.RawContextKey("activeEditorAvailableEditorIds","",(0,a.localize)(8,null)),e.TextCompareEditorVisibleContext=new P.RawContextKey("textCompareEditorVisible",!1,(0,a.localize)(9,null)),e.TextCompareEditorActiveContext=new P.RawContextKey("textCompareEditorActive",!1,(0,a.localize)(10,null)),e.SideBySideEditorActiveContext=new P.RawContextKey("sideBySideEditorActive",!1,(0,a.localize)(11,null)),e.EditorGroupEditorsCountContext=new P.RawContextKey("groupEditorsCount",0,(0,a.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new P.RawContextKey("activeEditorGroupEmpty",!1,(0,a.localize)(13,null)),e.ActiveEditorGroupIndexContext=new P.RawContextKey("activeEditorGroupIndex",0,(0,a.localize)(14,null)),e.ActiveEditorGroupLastContext=new P.RawContextKey("activeEditorGroupLast",!1,(0,a.localize)(15,null)),e.ActiveEditorGroupLockedContext=new P.RawContextKey("activeEditorGroupLocked",!1,(0,a.localize)(16,null)),e.MultipleEditorGroupsContext=new P.RawContextKey("multipleEditorGroups",!1,(0,a.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new P.RawContextKey("editorIsOpen",!1,(0,a.localize)(18,null)),e.InEditorZenModeContext=new P.RawContextKey("inZenMode",!1,(0,a.localize)(19,null)),e.IsCenteredLayoutContext=new P.RawContextKey("isCenteredLayout",!1,(0,a.localize)(20,null)),e.SplitEditorsVertically=new P.RawContextKey("splitEditorsVertically",!1,(0,a.localize)(21,null)),e.EditorAreaVisibleContext=new P.RawContextKey("editorAreaVisible",!0,(0,a.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function n(E,L,z){for(const N of z.visibleEditorPanes)if(N.group.id===L&&E.matches(N.input))return N.getViewState()}e.findViewStateForEditor=n;function m(E){if(I(E))return!1;const L=E;return w.URI.isUri(L?.resource)}e.isResourceEditorInput=m;function r(E){if(I(E))return!1;const L=E;return L?.original!==void 0&&L.modified!==void 0}e.isResourceDiffEditorInput=r;function g(E){if(I(E)||r(E))return!1;const L=E;return L?.primary!==void 0&&L.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function d(E){if(I(E))return!1;const L=E;return L?L.resource===void 0||L.resource.scheme===_.Schemas.untitled||L.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=d;var D;(function(E){E[E.SHORT=0]="SHORT",E[E.MEDIUM=1]="MEDIUM",E[E.LONG=2]="LONG"})(D=e.Verbosity||(e.Verbosity={}));var v;(function(E){E[E.EXPLICIT=1]="EXPLICIT",E[E.AUTO=2]="AUTO",E[E.FOCUS_CHANGE=3]="FOCUS_CHANGE",E[E.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(v=e.SaveReason||(e.SaveReason={}));var f;(function(E){E[E.None=0]="None",E[E.Readonly=2]="Readonly",E[E.Untitled=4]="Untitled",E[E.Singleton=8]="Singleton",E[E.RequiresTrust=16]="RequiresTrust",E[E.CanSplitInGroup=32]="CanSplitInGroup",E[E.ForceDescription=64]="ForceDescription"})(f=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class p extends T.Disposable{}e.AbstractEditorInput=p;function I(E){return E instanceof p}e.isEditorInput=I;function l(E){const L=E;return w.URI.isUri(L?.preferredResource)}function M(E){const L=E;return I(L?.primary)&&I(L?.secondary)}e.isSideBySideEditorInput=M;function o(E){const L=E;return I(L?.modified)&&I(L?.original)}e.isDiffEditorInput=o;function i(E){return I(E?.editor)}e.isEditorInputWithOptions=i;function h(E){const L=E;return i(E)&&L?.group!==void 0}e.isEditorInputWithOptionsAndGroup=h;function u(E){const L=E;return typeof L?.groupId=="number"&&I(L.editor)}e.isEditorIdentifier=u;var s;(function(E){E[E.UNKNOWN=0]="UNKNOWN",E[E.REPLACE=1]="REPLACE",E[E.MOVE=2]="MOVE",E[E.UNPIN=3]="UNPIN"})(s=e.EditorCloseContext||(e.EditorCloseContext={}));var b;(function(E){E[E.GROUP_ACTIVE=0]="GROUP_ACTIVE",E[E.GROUP_INDEX=1]="GROUP_INDEX",E[E.GROUP_LOCKED=2]="GROUP_LOCKED",E[E.EDITOR_OPEN=3]="EDITOR_OPEN",E[E.EDITOR_CLOSE=4]="EDITOR_CLOSE",E[E.EDITOR_MOVE=5]="EDITOR_MOVE",E[E.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",E[E.EDITOR_LABEL=7]="EDITOR_LABEL",E[E.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",E[E.EDITOR_PIN=9]="EDITOR_PIN",E[E.EDITOR_STICKY=10]="EDITOR_STICKY",E[E.EDITOR_DIRTY=11]="EDITOR_DIRTY",E[E.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(b=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var y;(function(E){E[E.PRIMARY=1]="PRIMARY",E[E.SECONDARY=2]="SECONDARY",E[E.BOTH=3]="BOTH",E[E.ANY=4]="ANY"})(y=e.SideBySideEditor||(e.SideBySideEditor={}));class c{getOriginalUri(L,z){if(!L)return;if(z?.supportSideBySide){const{primary:$,secondary:j}=this.getSideEditors(L);if($&&j){if(z?.supportSideBySide===y.BOTH)return{primary:this.getOriginalUri($,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(j,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===y.ANY)return this.getOriginalUri($,{filterByScheme:z.filterByScheme})??this.getOriginalUri(j,{filterByScheme:z.filterByScheme});L=z.supportSideBySide===y.PRIMARY?$:j}}if(r(L)||g(L))return;const N=l(L)?L.preferredResource:L.resource;return!N||!z||!z.filterByScheme?N:this.filterUri(N,z.filterByScheme)}getSideEditors(L){return M(L)||g(L)?{primary:L.primary,secondary:L.secondary}:o(L)||r(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,z){if(!L)return;if(z?.supportSideBySide){const{primary:$,secondary:j}=this.getSideEditors(L);if($&&j){if(z?.supportSideBySide===y.BOTH)return{primary:this.getCanonicalUri($,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(j,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===y.ANY)return this.getCanonicalUri($,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(j,{filterByScheme:z.filterByScheme});L=z.supportSideBySide===y.PRIMARY?$:j}}if(r(L)||g(L))return;const N=L.resource;return!N||!z||!z.filterByScheme?N:this.filterUri(N,z.filterByScheme)}filterUri(L,z){if(Array.isArray(z)){if(z.some(N=>L.scheme===N))return L}else if(z===L.scheme)return L}}e.EditorResourceAccessor=new c;var S;(function(E){E[E.LEFT=0]="LEFT",E[E.RIGHT=1]="RIGHT"})(S=e.CloseDirection||(e.CloseDirection={}));class A{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(L){const z=this.instantiationService=L.get(k.IInstantiationService);for(const[N,$]of this.editorSerializerConstructors)this.createEditorSerializer(N,$,z);this.editorSerializerConstructors.clear()}createEditorSerializer(L,z,N){const $=N.createInstance(z);this.editorSerializerInstances.set(L,$)}registerFileEditorFactory(L){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=L}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(L,z){if(this.editorSerializerConstructors.has(L)||this.editorSerializerInstances.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.instantiationService?this.createEditorSerializer(L,z,this.instantiationService):this.editorSerializerConstructors.set(L,z),(0,T.toDisposable)(()=>{this.editorSerializerConstructors.delete(L),this.editorSerializerInstances.delete(L)})}getEditorSerializer(L){return this.editorSerializerInstances.get(typeof L=="string"?L:L.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new A);async function U(E,L){if(!E||!E.length)return[];const z=await Promise.all(E.map(async N=>{const $=w.URI.revive(N.fileUri);if(!$||!await L.canHandleResource($))return;let ue=N.exists,K=N.type;if(typeof ue!="boolean"||typeof K!="number")try{K=(await L.resolve($)).isDirectory?R.FileType.Directory:R.FileType.Unknown,ue=!0}catch{ue=!1}if(!ue&&N.openOnlyIfExists||K===R.FileType.Directory)return;const ie={selection:ue?N.selection:void 0,pinned:!0,override:N.editorOverrideId};let pe;return ue?pe={resource:$,options:ie}:pe={resource:$,options:ie,forceUntitled:!0},pe}));return(0,F.coalesce)(z)}e.pathsToEditors=U;var H;(function(E){E[E.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",E[E.SEQUENTIAL=1]="SEQUENTIAL"})(H=e.EditorsOrder||(e.EditorsOrder={}))}),define(Ee[156],ye([0,1,4,14,127]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new a.Emitter,this._onExit=new a.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,C,R,F){const _={command:P};if(C&&Object.keys(C).length>0&&(_.arguments=C),this.internalSend("request",_),typeof F=="number"){const n=setTimeout(()=>{clearTimeout(n);const m=this.pendingRequests.get(_.seq);if(m){this.pendingRequests.delete(_.seq);const r={type:"response",seq:0,request_seq:_.seq,success:!1,command:P,message:(0,w.localize)(0,null,F,P)};m(r)}},F)}return R&&this.pendingRequests.set(_.seq,R),_.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,C){return P.type!=="event"||C.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,t.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":{const C=P,R=this.pendingRequests.get(C.request_seq);R&&(this.pendingRequests.delete(C.request_seq),R(C));break}}}}internalSend(P,C){C.type=P,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((C,R)=>P.set(R,C)),await(0,t.timeout)(500),P.forEach((C,R)=>{C({type:"response",seq:0,request_seq:R,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(R)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(Ee[157],ye([0,1,9,2,17,26,10]),function(ne,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function C(o,i,h){return o.replace(P,function(u,s){return i&&s.length>0&&s[0]!=="_"?u:h&&h.hasOwnProperty(s)?h[s]:u})}e.formatPII=C;function R(o){const i={};for(const h of Object.keys(o))h.startsWith("!")||(i[h]=o[h]);return i}e.filterExceptionsFromTelemetry=R;function F(o){return o.configuration.request==="attach"&&!_(o)&&(!o.parentSession||F(o.parentSession))}e.isSessionAttach=F;function _(o){let i=o.configuration.type;if(!!i)return i==="vslsShare"&&(i=o.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(i,"extensionhost")||(0,a.equalsIgnoreCase)(i,"pwa-extensionhost")?o:o.parentSession?_(o.parentSession):void 0}e.getExtensionHostDebugSession=_;function n(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=n;function m(o,i,h){let u,s=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,y=null;for(;y=b.exec(o);){let c=y.index+1,S=c+y[0].length;if(c<=i&&S>=h){u=y[0],s=c;break}}if(u){let c=/\w+/g,S=null;for(;(S=c.exec(u))&&!(S.index+1+s+S[0].length>=h););S&&(u=u.substring(0,c.lastIndex))}return u?{start:s,end:s+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(o){return!!(o&&o.match(r))}e.isUri=g;function d(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(g(o.path))return t.URI.parse(o.path);if((0,w.isAbsolute)(o.path))return t.URI.file(o.path)}return o.path}function D(o){if(typeof o.path=="object"){const i=t.URI.revive(o.path);if(i)return i.scheme===k.Schemas.file?i.fsPath:i.toString()}return o.path}function v(o,i){const h=i?d:D,u=(0,T.deepClone)(o);return p(u,(s,b)=>{s&&b&&(b.path=h(b))}),u}e.convertToDAPaths=v;function f(o,i){const h=i?d:D,u=(0,T.deepClone)(o);return p(u,(s,b)=>{!s&&b&&(b.path=h(b))}),u}e.convertToVSCPaths=f;function p(o,i){switch(o.type){case"event":{const h=o;switch(h.event){case"output":i(!1,h.body.source);break;case"loadedSource":i(!1,h.body.source);break;case"breakpoint":i(!1,h.body.breakpoint.source);break;default:break}break}case"request":{const h=o;switch(h.command){case"setBreakpoints":i(!0,h.arguments.source);break;case"breakpointLocations":i(!0,h.arguments.source);break;case"source":i(!0,h.arguments.source);break;case"gotoTargets":i(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(u=>i(!1,u));break;default:break}break}case"response":{const h=o;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(u=>i(!1,u.source));break;case"loadedSources":h.body.sources.forEach(u=>i(!1,u));break;case"scopes":h.body.scopes.forEach(u=>i(!1,u.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(u=>i(!1,u.source));break;case"setBreakpoints":h.body.breakpoints.forEach(u=>i(!1,u.source));break;default:break}break}}}function I(o){return o.filter(i=>!i.presentation?.hidden).sort((i,h)=>i.presentation?h.presentation?i.presentation.group?h.presentation.group?i.presentation.group!==h.presentation.group?i.presentation.group.localeCompare(h.presentation.group):l(i.presentation.order,h.presentation.order):-1:h.presentation.group?1:l(i.presentation.order,h.presentation.order):-1:h.presentation?1:0)}e.getVisibleAndSorted=I;function l(o,i){return typeof o!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:o-i}async function M(o,i){const h=o.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(h!=="none"&&(await i.saveAll(),h==="allEditorsInActiveGroup")){const u=i.activeEditorPane;u&&await i.save({editor:u.input,groupId:u.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=M}),define(Ee[87],ye([0,1,29,158,78,10,17,23,44]),function(ne,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var R;(function(c){c[c.Markup=1]="Markup",c[c.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",w.Mimes.latex,w.Mimes.markdown,"image/png","image/jpeg",w.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[w.Mimes.latex,w.Mimes.markdown,"application/json",w.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var F;(function(c){c[c.Running=1]="Running",c[c.Idle=2]="Idle"})(F=e.NotebookRunState||(e.NotebookRunState={}));var _;(function(c){c[c.Pending=2]="Pending",c[c.Executing=3]="Executing"})(_=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var n;(function(c){c[c.WithHardKernelDependency=0]="WithHardKernelDependency",c[c.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",c[c.Pure=2]="Pure",c[c.Never=3]="Never"})(n=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(c){c.Always="always",c.Never="never",c.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var r;(function(c){c[c.ModelChange=1]="ModelChange",c[c.Move=2]="Move",c[c.ChangeLanguage=5]="ChangeLanguage",c[c.Initialize=6]="Initialize",c[c.ChangeCellMetadata=7]="ChangeCellMetadata",c[c.Output=8]="Output",c[c.OutputItem=9]="OutputItem",c[c.ChangeCellContent=10]="ChangeCellContent",c[c.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",c[c.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",c[c.ChangeCellMime=13]="ChangeCellMime",c[c.Unknown=100]="Unknown"})(r=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(c){c[c.Handle=0]="Handle",c[c.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(c){c[c.Replace=1]="Replace",c[c.Output=2]="Output",c[c.Metadata=3]="Metadata",c[c.CellLanguage=4]="CellLanguage",c[c.DocumentMetadata=5]="DocumentMetadata",c[c.Move=6]="Move",c[c.OutputItems=7]="OutputItems",c[c.PartialMetadata=8]="PartialMetadata",c[c.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var D;(function(c){c.scheme=T.Schemas.vscodeNotebookCell;const S=/^ch(\d{7,})/;function A(N,$){return N.with({scheme:c.scheme,fragment:`ch${$.toString().padStart(7,"0")}${N.scheme!==T.Schemas.file?N.scheme:""}`})}c.generate=A;function U(N){if(N.scheme!==c.scheme)return;const $=S.exec(N.fragment);return $?{handle:Number($[1]),notebook:N.with({scheme:N.fragment.substr($[0].length)||T.Schemas.file,fragment:null})}:void 0}c.parse=U;function H(N,$,j){return N.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`ch${$.toString().padStart(7,"0")},${j??""},${N.scheme!==T.Schemas.file?N.scheme:""}`})}c.generateCellOutputUri=H;function E(N){if(N.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const $=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(N.fragment);if(!$)return;const j=Number($[1]),ue=$[2]&&$[2]!==""?$[2]:void 0,K=$[3];return{handle:j,outputId:ue,notebook:N.with({scheme:K||T.Schemas.file,fragment:null})}}c.parseCellOutputUri=E;function L(N,$,j){return N.with({scheme:j,fragment:`ch${$.toString().padStart(7,"0")}${N.scheme!==T.Schemas.file?N.scheme:""}`})}c.generateCellUri=L;function z(N,$){if(N.scheme!==$)return;const j=S.exec(N.fragment);return j?{handle:Number(j[1]),notebook:N.with({scheme:N.fragment.substr(j[0].length)||T.Schemas.file,fragment:null})}:void 0}c.parseCellUri=z})(D=e.CellUri||(e.CellUri={}));const v=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[w.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[w.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function f(c){return v.get(c)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=f;function p(c){return v.get(c)?.supportedByCore??!1}e.mimeTypeSupportedByCore=p;function I(c){return v.get(c)?.mergeable??!1}e.mimeTypeIsMergeable=I;const l=c=>P.isWindows?c.replace(/\//g,"\\"):c;class M{constructor(S=[],A=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=A,this.order=[...new Set(S)].map(U=>({pattern:U,matches:a.parse(l(U))}))}sort(S){const A=new Map(t.Iterable.map(S,H=>[H,l(H)]));let U=[];for(const{matches:H}of this.order)for(const[E,L]of A)if(H(L)){U.push(E),A.delete(E);break}return A.size&&(U=U.concat([...A.keys()].sort((H,E)=>this.defaultOrder.indexOf(H)-this.defaultOrder.indexOf(E)))),U}prioritize(S,A){const U=this.findIndex(S);if(U===-1){this.order.unshift({pattern:S,matches:a.parse(l(S))});return}const H=new Set(A.map(L=>this.findIndex(L,U)));H.delete(-1);const E=Array.from(H).sort();this.order.splice(U+1,0,...E.map(L=>this.order[L]));for(let L=E.length-1;L>=0;L--)this.order.splice(E[L],1)}toArray(){return this.order.map(S=>S.pattern)}findIndex(S,A=this.order.length){const U=l(S);for(let H=0;H<A;H++)if(this.order[H].matches(U))return H;return-1}}e.MimeTypeDisplayOrder=M;function o(c,S,A,U=(H,E)=>H===E){const H=[];function E(N,$,j){if($===0&&j.length===0)return;const ue=H[H.length-1];ue&&ue.start+ue.deleteCount===N?(ue.deleteCount+=$,ue.toInsert.push(...j)):H.push({start:N,deleteCount:$,toInsert:j})}let L=0,z=0;for(;;){if(L===c.length){E(L,0,S.slice(z));break}if(z===S.length){E(L,c.length-L,[]);break}const N=c[L],$=S[z];if(U(N,$)){L+=1,z+=1;continue}A($)?(E(L,1,[]),L+=1):(E(L,0,[$]),z+=1)}return H}e.diff=o,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(c){c.default="default",c.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function h(c){const S=c;return!!((typeof S.include=="string"||a.isRelativePattern(S.include))&&(typeof S.exclude=="string"||a.isRelativePattern(S.exclude)))}e.isDocumentExcludePattern=h;function u(c,S,A){if(Array.isArray(c.viewType)&&c.viewType.indexOf(S)>=0||c.viewType===S)return!0;if(c.filenamePattern){let U=h(c.filenamePattern)?c.filenamePattern.include:c.filenamePattern,H=h(c.filenamePattern)?c.filenamePattern.exclude:void 0;if(a.match(U,(0,k.basename)(A.fsPath).toLowerCase()))return!(H&&a.match(H,(0,k.basename)(A.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=u;class s{constructor(S){this.textModel=S}getElements(){const S=new Int32Array(this.textModel.cells.length);for(let A=0;A<this.textModel.cells.length;A++)S[A]=this.textModel.cells[A].getHashValue();return S}}e.CellSequence=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var b;(function(c){c[c.Left=1]="Left",c[c.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class y{static create(S){return`${y._prefix}${S}`}static parse(S){if(S.startsWith(y._prefix))return S.substr(y._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=y,y._prefix="notebook/"}),define(Ee[159],ye([0,1,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(w){w[w.Output=1]="Output",w[w.OutputItems=2]="OutputItems",w[w.ExecutionState=3]="ExecutionState",w[w.Complete=4]="Complete"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(Ee[160],ye([0,1,3,44]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,a.createDecorator)(e.OUTPUT_SERVICE_ID);var w;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(w=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(Ee[161],ye([0,1,129,3,44]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new w.RawContextKey("customExecutionSupported",!0,a.localize(0,null)),e.ShellExecutionSupportedContext=new w.RawContextKey("shellExecutionSupported",!1,a.localize(1,null)),e.ProcessExecutionSupportedContext=new w.RawContextKey("processExecutionSupported",!1,a.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Ee[162],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(w){return[...w.entries()]}e.serializeEnvironmentVariableCollection=a;function t(w){return new Map(w)}e.deserializeEnvironmentVariableCollection=t}),define(Ee[88],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var a;(function(_){_[_.Unset=0]="Unset",_[_.Queued=1]="Queued",_[_.Running=2]="Running",_[_.Passed=3]="Passed",_[_.Failed=4]="Failed",_[_.Skipped=5]="Skipped",_[_.Errored=6]="Errored"})(a=e.TestResultState||(e.TestResultState={}));var t;(function(_){_[_.Run=2]="Run",_[_.Debug=4]="Debug",_[_.Coverage=8]="Coverage",_[_.HasNonDefaultProfile=16]="HasNonDefaultProfile",_[_.HasConfigurable=32]="HasConfigurable"})(t=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var w;(function(_){_[_.Error=0]="Error",_[_.Info=1]="Info"})(w=e.TestMessageType||(e.TestMessageType={}));var T;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(T=e.TestItemExpandState||(e.TestItemExpandState={}));const k=(_,n)=>{n.expand!==void 0&&(_.expand=n.expand),n.item!==void 0&&(_.item=_.item?Object.assign(_.item,n.item):n.item)};e.applyTestItemUpdate=k;var P;(function(_){_[_.Function=0]="Function",_[_.Statement=1]="Statement"})(P=e.DetailType||(e.DetailType={}));var C;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire",_[_.AddTag=5]="AddTag",_[_.RemoveTag=6]="RemoveTag"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));class R{add(n){}update(n){}remove(n,m){}complete(){}}e.IncrementalChangeCollector=R;class F{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const m=this.createChangeCollector();for(const r of n)switch(r[0]){case 0:{const g=r[1];if(g.parent){if(this.items.has(g.parent)){const d=this.items.get(g.parent);d.children.add(g.item.extId);const D=this.createItem(g,d);this.items.set(g.item.extId,D),m.add(D)}}else{const d=this.createItem(g);this.roots.add(d),this.items.set(g.item.extId,d),m.add(d)}g.expand===2&&this.busyControllerCount++;break}case 1:{const g=r[1],d=this.items.get(g.extId);if(!d)break;g.expand!==void 0&&(d.expand===2&&this.busyControllerCount--,g.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(d,g),m.update(d);break}case 2:{const g=this.items.get(r[1]);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g);const d=[[r[1]]];for(;d.length;)for(const D of d.pop()){const v=this.items.get(D);v&&(d.push(v.children),this.items.delete(D),m.remove(v,v!==g),v.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(r[1]);break;case 3:this.updatePendingRoots(r[1]);break;case 5:this._tags.set(r[1].id,r[1]);break;case 6:this._tags.delete(r[1]);break}m.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new R}}e.AbstractIncrementalTestCollection=F}),define(Ee[67],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(T){T.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class w{constructor(k,P=k.length){if(this.path=k,this.viewEnd=P,k.length===0||P<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(k,P,C=k.parent){if(k.id===P)return new w([P]);let R=[k.id];for(let F=C;F&&F.id!==P;F=F.parent)R.push(F.id);return R.push(P),new w(R.reverse())}static isRoot(k){return!k.includes("\0")}static fromString(k){return new w(k.split("\0"))}static join(k,P){return new w([...k.path,P])}static joinToString(k,P){return k.toString()+"\0"+P}static compare(k,P){return k===P?0:P.startsWith(k+"\0")?2:k.startsWith(P+"\0")?3:1}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let k=1;k<=this.viewEnd;k++)yield new w(this.path,k)}compare(k){if(typeof k=="string")return w.compare(this.toString(),k);for(let P=0;P<k.viewEnd&&P<this.viewEnd;P++)if(k.path[P]!==this.path[P])return 1;return k.viewEnd>this.viewEnd?2:k.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let k=1;k<this.viewEnd;k++)this.stringifed+="\0",this.stringifed+=this.path[k]}return this.stringifed}}e.TestId=w}),define(Ee[163],ye([0,1,17,89,11,26,23,77,130]),function(ne,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(_,n,m){this._contributedVariables=new Map,this._context=_,this._labelService=n,m&&(this._envVariablesPromise=m.then(r=>this.prepareEnv(r)))}prepareEnv(_){if(k.isWindows){const n=Object.create(null);return Object.keys(_).forEach(m=>{n[m.toLowerCase()]=_[m]}),n}return _}resolveWithEnvironment(_,n,m){return this.recursiveResolve(this.prepareEnv(_),n?n.uri:void 0,m)}async resolveAsync(_,n){return this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,n)}async resolveAnyBase(_,n,m,r){const g=T.deepClone(n);return k.isWindows&&g.windows?Object.keys(g.windows).forEach(d=>g[d]=g.windows[d]):k.isMacintosh&&g.osx?Object.keys(g.osx).forEach(d=>g[d]=g.osx[d]):k.isLinux&&g.linux&&Object.keys(g.linux).forEach(d=>g[d]=g.linux[d]),delete g.windows,delete g.osx,delete g.linux,this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,g,m,r)}async resolveAnyAsync(_,n,m){return this.resolveAnyBase(_,n,m)}async resolveAnyMap(_,n,m){const r=new Map;return{newConfig:await this.resolveAnyBase(_,n,m,r),resolvedVariables:r}}resolveWithInteractionReplace(_,n,m,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,n,m,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,n){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,n)}recursiveResolve(_,n,m,r,g){if(w.isString(m))return this.resolveString(_,n,m,r,g);if(w.isArray(m))return m.map(d=>this.recursiveResolve(_,n,d,r,g));if(w.isObject(m)){let d=Object.create(null);return Object.keys(m).forEach(D=>{const v=this.resolveString(_,n,D,r,g);d[v]=this.recursiveResolve(_,n,m[D],r,g)}),d}return m}resolveString(_,n,m,r,g){return m.replace(R.VARIABLE_REGEXP,(D,v)=>{if(v.includes(R.VARIABLE_LHS))return D;let f=this.evaluateSingleVariable(_,D,v,n,r);return g&&g.set(v,f),f!==D&&w.isString(f)&&f.match(R.VARIABLE_REGEXP)&&(f=this.resolveString(_,n,f,r,g)),f})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}evaluateSingleVariable(_,n,m,r,g){let d;const D=m.split(":");D.length>1&&(m=D[0],d=D[1]);const v=()=>{const I=this._context.getFilePath();if(I)return I;throw new Error((0,C.localize)(0,null,n))},f=()=>{const I=v();if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return l}throw new Error((0,C.localize)(1,null,n,a.basename(I)))},p=()=>{if(d){const I=this._context.getFolderUri(d);if(I)return I;throw new Error((0,C.localize)(2,null,n,d))}if(r)return r;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,n)):new Error((0,C.localize)(4,null,n))};switch(m){case"env":if(d){if(_){const I=_[k.isWindows?d.toLowerCase():d];if(w.isString(I))return I}return""}throw new Error((0,C.localize)(5,null,n));case"config":if(d){const I=this._context.getConfigurationValue(r,d);if(w.isUndefinedOrNull(I))throw new Error((0,C.localize)(6,null,n,d));if(w.isObject(I))throw new Error((0,C.localize)(7,null,n,d));return I}throw new Error((0,C.localize)(8,null,n));case"command":return this.resolveFromMap(n,d,g,"command");case"input":return this.resolveFromMap(n,d,g,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(p()));case"cwd":return r||d?(0,P.normalizeDriveLetter)(this.fsPath(p())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return a.basename(this.fsPath(p()));case"lineNumber":{const I=this._context.getLineNumber();if(I)return I;throw new Error((0,C.localize)(9,null,n))}case"selectedText":{const I=this._context.getSelectedText();if(I)return I;throw new Error((0,C.localize)(10,null,n))}case"file":return v();case"fileWorkspaceFolder":return f();case"relativeFile":return r||d?a.relative(this.fsPath(p()),v()):v();case"relativeFileDirname":{const I=a.dirname(v());if(r||d){const l=a.relative(this.fsPath(p()),I);return l.length===0?".":l}return I}case"fileDirname":return a.dirname(v());case"fileExtname":return a.extname(v());case"fileBasename":return a.basename(v());case"fileBasenameNoExtension":{const I=a.basename(v());return I.slice(0,I.length-a.extname(I).length)}case"fileDirnameBasename":return a.basename(a.dirname(v()));case"execPath":{const I=this._context.getExecPath();return I||n}case"execInstallFolder":{const I=this._context.getAppRoot();return I||n}case"pathSeparator":return a.sep;default:try{const I=d?`${m}:${d}`:m;return this.resolveFromMap(n,I,g,void 0)}catch{return n}}}}resolveFromMap(_,n,m,r){if(n&&m){const g=r===void 0?m[n]:m[r+":"+n];if(typeof g=="string")return g;throw new Error((0,C.localize)(11,null,_))}return _}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[90],ye([0,1,3,155]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var w;(function(r){r[r.UP=0]="UP",r[r.DOWN=1]="DOWN",r[r.LEFT=2]="LEFT",r[r.RIGHT=3]="RIGHT"})(w=e.GroupDirection||(e.GroupDirection={}));var T;(function(r){r[r.HORIZONTAL=0]="HORIZONTAL",r[r.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(r){r[r.FIRST=0]="FIRST",r[r.LAST=1]="LAST",r[r.NEXT=2]="NEXT",r[r.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var P;(function(r){r[r.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",r[r.EVEN=1]="EVEN",r[r.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(r){r[r.COPY_EDITORS=0]="COPY_EDITORS",r[r.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function R(r){const g=r;return(0,t.isEditorInput)(g?.editor)&&(0,t.isEditorInput)(g?.replacement)}e.isEditorReplacement=R;var F;(function(r){r[r.CREATION_TIME=0]="CREATION_TIME",r[r.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",r[r.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F=e.GroupsOrder||(e.GroupsOrder={}));var _;(function(r){r[r.NEW_EDITOR=1]="NEW_EDITOR",r[r.MOVE_EDITOR=2]="MOVE_EDITOR",r[r.COPY_EDITOR=3]="COPY_EDITOR"})(_=e.OpenEditorContext||(e.OpenEditorContext={}));function n(r){const g=r;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=n;function m(r){return r.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=m}),define(Ee[164],ye([0,1,3,90]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function w(T){const k=T;return typeof T=="number"||(0,t.isEditorGroup)(k)}e.isPreferredGroup=w}),define(Ee[8],ye([0,1,16,22,76,225,54,26,11,2,59,58,131,82,47,87,67,164,7]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m,r,g,d,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var f;(function(te){function ge(W){const{selectionStartLineNumber:be,selectionStartColumn:Ie,positionLineNumber:Qe,positionColumn:Ue}=W,ut=new v.Position(be-1,Ie-1),vt=new v.Position(Qe-1,Ue-1);return new v.Selection(ut,vt)}te.to=ge;function Z(W){const{anchor:be,active:Ie}=W;return{selectionStartLineNumber:be.line+1,selectionStartColumn:be.character+1,positionLineNumber:Ie.line+1,positionColumn:Ie.character+1}}te.from=Z})(f=e.Selection||(e.Selection={}));var p;(function(te){function ge(W){if(!W)return;const{start:be,end:Ie}=W;return{startLineNumber:be.line+1,startColumn:be.character+1,endLineNumber:Ie.line+1,endColumn:Ie.character+1}}te.from=ge;function Z(W){if(!W)return;const{startLineNumber:be,startColumn:Ie,endLineNumber:Qe,endColumn:Ue}=W;return new v.Range(be-1,Ie-1,Qe-1,Ue-1)}te.to=Z})(p=e.Range||(e.Range={}));var I;(function(te){function ge(Z){switch(Z){case 1:return v.StandardTokenType.Comment;case 0:return v.StandardTokenType.Other;case 3:return v.StandardTokenType.RegEx;case 2:return v.StandardTokenType.String}}te.to=ge})(I=e.TokenType||(e.TokenType={}));var l;(function(te){function ge(W){return new v.Position(W.lineNumber-1,W.column-1)}te.to=ge;function Z(W){return{lineNumber:W.line+1,column:W.character+1}}te.from=Z})(l=e.Position||(e.Position={}));var M;(function(te){function ge(be,Ie){return(0,a.coalesce)((0,a.asArray)(be).map(Qe=>Z(Qe,Ie)))}te.from=ge;function Z(be,Ie){if(typeof be=="string")return{$serialized:!0,language:be};if(be)return{$serialized:!0,language:be.language,scheme:W(be.scheme,Ie),pattern:typeof be.pattern=="undefined"?void 0:V.from(be.pattern),exclusive:be.exclusive}}function W(be,Ie){return Ie&&typeof be=="string"?Ie.transformOutgoingScheme(be):be}})(M=e.DocumentSelector||(e.DocumentSelector={}));var o;(function(te){function ge(W){switch(W){case v.DiagnosticTag.Unnecessary:return 1;case v.DiagnosticTag.Deprecated:return 2}}te.from=ge;function Z(W){switch(W){case 1:return v.DiagnosticTag.Unnecessary;case 2:return v.DiagnosticTag.Deprecated;default:return}}te.to=Z})(o=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(te){function ge(W){let be;return W.code&&((0,C.isString)(W.code)||(0,C.isNumber)(W.code)?be=String(W.code):be={value:String(W.code.value),target:W.code.target}),{...p.from(W.range),message:W.message,source:W.source,code:be,severity:u.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(h.from),tags:Array.isArray(W.tags)?(0,a.coalesce)(W.tags.map(o.from)):void 0}}te.from=ge;function Z(W){const be=new v.Diagnostic(p.to(W),W.message,u.to(W.severity));return be.source=W.source,be.code=(0,C.isString)(W.code)?W.code:W.code?.value,be.relatedInformation=W.relatedInformation&&W.relatedInformation.map(h.to),be.tags=W.tags&&(0,a.coalesce)(W.tags.map(o.to)),be}te.to=Z})(i=e.Diagnostic||(e.Diagnostic={}));var h;(function(te){function ge(W){return{...p.from(W.location.range),message:W.message,resource:W.location.uri}}te.from=ge;function Z(W){return new v.DiagnosticRelatedInformation(new v.Location(W.resource,p.to(W)),W.message)}te.to=Z})(h=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var u;(function(te){function ge(W){switch(W){case v.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}te.from=ge;function Z(W){switch(W){case m.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}te.to=Z})(u=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(te){function ge(W){return typeof W=="number"&&W>=v.ViewColumn.One?W-1:W===v.ViewColumn.Beside?D.SIDE_GROUP:D.ACTIVE_GROUP}te.from=ge;function Z(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}te.to=Z})(s=e.ViewColumn||(e.ViewColumn={}));function b(te){return typeof te.range!="undefined"}function y(te){return te.length===0?!0:!!b(te[0])}e.isDecorationOptionsArr=y;var c;(function(te){function ge(Ue){return Ue.map(te.from)}te.fromMany=ge;function Z(Ue){return Ue&&typeof Ue=="object"&&typeof Ue.language=="string"&&typeof Ue.value=="string"}function W(Ue){let ut;if(Z(Ue)){const{language:ht,value:gt}=Ue;ut={value:"```"+ht+`
`+gt+"\n```\n"}}else v.MarkdownString.isMarkdownString(Ue)?ut={value:Ue.value,isTrusted:Ue.isTrusted,supportThemeIcons:Ue.supportThemeIcons,supportHtml:Ue.supportHtml}:typeof Ue=="string"?ut={value:Ue}:ut={value:""};const vt=Object.create(null);ut.uris=vt;const St=ht=>{try{let gt=R.URI.parse(ht,!0);gt=gt.with({query:be(gt.query,vt)}),vt[ht]=gt}catch{}return""},bt=new T.Renderer;return bt.link=St,bt.image=ht=>St(w.parseHrefAndDimensions(ht).href),T(ut.value,{renderer:bt}),ut}te.from=W;function be(Ue,ut){if(!Ue)return Ue;let vt;try{vt=(0,k.parse)(Ue)}catch{}if(!vt)return Ue;let St=!1;return vt=(0,P.cloneAndChange)(vt,bt=>{if(R.URI.isUri(bt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ht]=bt,St=!0,ht}else return}),St?JSON.stringify(vt):Ue}function Ie(Ue){const ut=new v.MarkdownString(Ue.value,Ue.supportThemeIcons);return ut.isTrusted=Ue.isTrusted,ut.supportHtml=Ue.supportHtml,ut}te.to=Ie;function Qe(Ue){if(!!Ue)return typeof Ue=="string"?Ue:te.from(Ue)}te.fromStrict=Qe})(c=e.MarkdownString||(e.MarkdownString={}));function S(te){return y(te)?te.map(ge=>({range:p.from(ge.range),hoverMessage:Array.isArray(ge.hoverMessage)?c.fromMany(ge.hoverMessage):ge.hoverMessage?c.from(ge.hoverMessage):void 0,renderOptions:ge.renderOptions})):te.map(ge=>({range:p.from(ge)}))}e.fromRangeOrRangeWithMessage=S;function A(te){return typeof te=="undefined"?te:typeof te=="string"?R.URI.file(te):te}e.pathOrURIToURI=A;var U;(function(te){function ge(Z){return typeof Z=="undefined"?Z:{contentText:Z.contentText,contentIconPath:Z.contentIconPath?A(Z.contentIconPath):void 0,border:Z.border,borderColor:Z.borderColor,fontStyle:Z.fontStyle,fontWeight:Z.fontWeight,textDecoration:Z.textDecoration,color:Z.color,backgroundColor:Z.backgroundColor,margin:Z.margin,width:Z.width,height:Z.height}}te.from=ge})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var H;(function(te){function ge(Z){return typeof Z=="undefined"?Z:{backgroundColor:Z.backgroundColor,outline:Z.outline,outlineColor:Z.outlineColor,outlineStyle:Z.outlineStyle,outlineWidth:Z.outlineWidth,border:Z.border,borderColor:Z.borderColor,borderRadius:Z.borderRadius,borderSpacing:Z.borderSpacing,borderStyle:Z.borderStyle,borderWidth:Z.borderWidth,fontStyle:Z.fontStyle,fontWeight:Z.fontWeight,textDecoration:Z.textDecoration,cursor:Z.cursor,color:Z.color,opacity:Z.opacity,letterSpacing:Z.letterSpacing,gutterIconPath:Z.gutterIconPath?A(Z.gutterIconPath):void 0,gutterIconSize:Z.gutterIconSize,overviewRulerColor:Z.overviewRulerColor,before:Z.before?U.from(Z.before):void 0,after:Z.after?U.from(Z.after):void 0}}te.from=ge})(H=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var E;(function(te){function ge(Z){if(typeof Z=="undefined")return Z;switch(Z){case v.DecorationRangeBehavior.OpenOpen:return 0;case v.DecorationRangeBehavior.ClosedClosed:return 1;case v.DecorationRangeBehavior.OpenClosed:return 2;case v.DecorationRangeBehavior.ClosedOpen:return 3}}te.from=ge})(E=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(te){function ge(Z){return{isWholeLine:Z.isWholeLine,rangeBehavior:Z.rangeBehavior?E.from(Z.rangeBehavior):void 0,overviewRulerLane:Z.overviewRulerLane,light:Z.light?H.from(Z.light):void 0,dark:Z.dark?H.from(Z.dark):void 0,backgroundColor:Z.backgroundColor,outline:Z.outline,outlineColor:Z.outlineColor,outlineStyle:Z.outlineStyle,outlineWidth:Z.outlineWidth,border:Z.border,borderColor:Z.borderColor,borderRadius:Z.borderRadius,borderSpacing:Z.borderSpacing,borderStyle:Z.borderStyle,borderWidth:Z.borderWidth,fontStyle:Z.fontStyle,fontWeight:Z.fontWeight,textDecoration:Z.textDecoration,cursor:Z.cursor,color:Z.color,opacity:Z.opacity,letterSpacing:Z.letterSpacing,gutterIconPath:Z.gutterIconPath?A(Z.gutterIconPath):void 0,gutterIconSize:Z.gutterIconSize,overviewRulerColor:Z.overviewRulerColor,before:Z.before?U.from(Z.before):void 0,after:Z.after?U.from(Z.after):void 0}}te.from=ge})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(te){function ge(W){return{text:W.newText,eol:W.newEol&&lt.from(W.newEol),range:p.from(W.range)}}te.from=ge;function Z(W){const be=new v.TextEdit(p.to(W.range),W.text);return be.newEol=typeof W.eol=="undefined"?void 0:lt.to(W.eol),be}te.to=Z})(z=e.TextEdit||(e.TextEdit={}));var N;(function(te){function ge(W,be,Ie){const Qe={edits:[]};if(W instanceof v.WorkspaceEdit)for(let Ue of W._allEntries())if(Ue._type===1)Qe.edits.push({_type:1,oldUri:Ue.from,newUri:Ue.to,options:Ue.options,metadata:Ue.metadata});else if(Ue._type===2){const ut=be?.getDocument(Ue.uri);Qe.edits.push({_type:2,resource:Ue.uri,edit:z.from(Ue.edit),modelVersionId:ut?.version,metadata:Ue.metadata})}else Ue._type===3?Qe.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,edit:Ue.edit,notebookMetadata:Ue.notebookMetadata,notebookVersionId:Ie?.getNotebookDocument(Ue.uri,!0)?.apiNotebook.version}):Ue._type===5&&Qe.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,notebookVersionId:Ie?.getNotebookDocument(Ue.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ue.index,count:Ue.count,cells:Ue.cells.map(Ye.from)}});return Qe}te.from=ge;function Z(W){const be=new v.WorkspaceEdit;for(const Ie of W.edits)Ie.edit?be.replace(R.URI.revive(Ie.resource),p.to(Ie.edit.range),Ie.edit.text):be.renameFile(R.URI.revive(Ie.oldUri),R.URI.revive(Ie.newUri),Ie.options);return be}te.to=Z})(N=e.WorkspaceEdit||(e.WorkspaceEdit={}));var $;(function(te){const ge=Object.create(null);ge[v.SymbolKind.File]=0,ge[v.SymbolKind.Module]=1,ge[v.SymbolKind.Namespace]=2,ge[v.SymbolKind.Package]=3,ge[v.SymbolKind.Class]=4,ge[v.SymbolKind.Method]=5,ge[v.SymbolKind.Property]=6,ge[v.SymbolKind.Field]=7,ge[v.SymbolKind.Constructor]=8,ge[v.SymbolKind.Enum]=9,ge[v.SymbolKind.Interface]=10,ge[v.SymbolKind.Function]=11,ge[v.SymbolKind.Variable]=12,ge[v.SymbolKind.Constant]=13,ge[v.SymbolKind.String]=14,ge[v.SymbolKind.Number]=15,ge[v.SymbolKind.Boolean]=16,ge[v.SymbolKind.Array]=17,ge[v.SymbolKind.Object]=18,ge[v.SymbolKind.Key]=19,ge[v.SymbolKind.Null]=20,ge[v.SymbolKind.EnumMember]=21,ge[v.SymbolKind.Struct]=22,ge[v.SymbolKind.Event]=23,ge[v.SymbolKind.Operator]=24,ge[v.SymbolKind.TypeParameter]=25;function Z(be){return typeof ge[be]=="number"?ge[be]:6}te.from=Z;function W(be){for(const Ie in ge)if(ge[Ie]===be)return Number(Ie);return v.SymbolKind.Property}te.to=W})($=e.SymbolKind||(e.SymbolKind={}));var j;(function(te){function ge(W){switch(W){case v.SymbolTag.Deprecated:return 1}}te.from=ge;function Z(W){switch(W){case 1:return v.SymbolTag.Deprecated}}te.to=Z})(j=e.SymbolTag||(e.SymbolTag={}));var ue;(function(te){function ge(W){return{name:W.name,kind:$.from(W.kind),tags:W.tags&&W.tags.map(j.from),containerName:W.containerName,location:ae.from(W.location)}}te.from=ge;function Z(W){const be=new v.SymbolInformation(W.name,$.to(W.kind),W.containerName,ae.to(W.location));return be.tags=W.tags&&W.tags.map(j.to),be}te.to=Z})(ue=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var K;(function(te){function ge(W){const be={name:W.name||"!!MISSING: name!!",detail:W.detail,range:p.from(W.range),selectionRange:p.from(W.selectionRange),kind:$.from(W.kind),tags:W.tags?.map(j.from)??[]};return W.children&&(be.children=W.children.map(ge)),be}te.from=ge;function Z(W){const be=new v.DocumentSymbol(W.name,W.detail,$.to(W.kind),p.to(W.range),p.to(W.selectionRange));return(0,a.isNonEmptyArray)(W.tags)&&(be.tags=W.tags.map(j.to)),W.children&&(be.children=W.children.map(Z)),be}te.to=Z})(K=e.DocumentSymbol||(e.DocumentSymbol={}));var ie;(function(te){function ge(W){const be=new v.CallHierarchyItem($.to(W.kind),W.name,W.detail||"",R.URI.revive(W.uri),p.to(W.range),p.to(W.selectionRange));return be._sessionId=W._sessionId,be._itemId=W._itemId,be}te.to=ge;function Z(W,be,Ie){if(be=be??W._sessionId,Ie=Ie??W._itemId,be===void 0||Ie===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:Ie,name:W.name,detail:W.detail,kind:$.from(W.kind),uri:W.uri,range:p.from(W.range),selectionRange:p.from(W.selectionRange),tags:W.tags?.map(j.from)}}te.from=Z})(ie=e.CallHierarchyItem||(e.CallHierarchyItem={}));var pe;(function(te){function ge(Z){return new v.CallHierarchyIncomingCall(ie.to(Z.from),Z.fromRanges.map(W=>p.to(W)))}te.to=ge})(pe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var we;(function(te){function ge(Z){return new v.CallHierarchyOutgoingCall(ie.to(Z.to),Z.fromRanges.map(W=>p.to(W)))}te.to=ge})(we=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ae;(function(te){function ge(W){return{range:W.range&&p.from(W.range),uri:W.uri}}te.from=ge;function Z(W){return new v.Location(R.URI.revive(W.uri),p.to(W.range))}te.to=Z})(ae=e.location||(e.location={}));var le;(function(te){function ge(W){const be=W,Ie=W;return{originSelectionRange:be.originSelectionRange?p.from(be.originSelectionRange):void 0,uri:be.targetUri?be.targetUri:Ie.uri,range:p.from(be.targetRange?be.targetRange:Ie.range),targetSelectionRange:be.targetSelectionRange?p.from(be.targetSelectionRange):void 0}}te.from=ge;function Z(W){return{targetUri:R.URI.revive(W.uri),targetRange:p.to(W.range),targetSelectionRange:W.targetSelectionRange?p.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?p.to(W.originSelectionRange):void 0}}te.to=Z})(le=e.DefinitionLink||(e.DefinitionLink={}));var Se;(function(te){function ge(W){return{range:p.from(W.range),contents:c.fromMany(W.contents)}}te.from=ge;function Z(W){return new v.Hover(W.contents.map(c.to),p.to(W.range))}te.to=Z})(Se=e.Hover||(e.Hover={}));var Ce;(function(te){function ge(W){return{range:p.from(W.range),expression:W.expression}}te.from=ge;function Z(W){return new v.EvaluatableExpression(p.to(W.range),W.expression)}te.to=Z})(Ce=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Fe;(function(te){function ge(W){if(W instanceof v.InlineValueText)return{type:"text",range:p.from(W.range),text:W.text};if(W instanceof v.InlineValueVariableLookup)return{type:"variable",range:p.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof v.InlineValueEvaluatableExpression)return{type:"expression",range:p.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}te.from=ge;function Z(W){switch(W.type){case"text":return{range:p.to(W.range),text:W.text};case"variable":return{range:p.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:p.to(W.range),expression:W.expression}}}te.to=Z})(Fe=e.InlineValue||(e.InlineValue={}));var $e;(function(te){function ge(W){return{frameId:W.frameId,stoppedLocation:p.from(W.stoppedLocation)}}te.from=ge;function Z(W){return new v.InlineValueContext(W.frameId,p.to(W.stoppedLocation))}te.to=Z})($e=e.InlineValueContext||(e.InlineValueContext={}));var Ve;(function(te){function ge(W){return{range:p.from(W.range),kind:W.kind}}te.from=ge;function Z(W){return new v.DocumentHighlight(p.to(W.range),W.kind)}te.to=Z})(Ve=e.DocumentHighlight||(e.DocumentHighlight={}));var je;(function(te){function ge(Z){switch(Z){case 1:return v.CompletionTriggerKind.TriggerCharacter;case 2:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return v.CompletionTriggerKind.Invoke}}te.to=ge})(je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var B;(function(te){function ge(Z){return{triggerKind:je.to(Z.triggerKind),triggerCharacter:Z.triggerCharacter}}te.to=ge})(B=e.CompletionContext||(e.CompletionContext={}));var G;(function(te){function ge(W){switch(W){case v.CompletionItemTag.Deprecated:return 1}}te.from=ge;function Z(W){switch(W){case 1:return v.CompletionItemTag.Deprecated}}te.to=Z})(G=e.CompletionItemTag||(e.CompletionItemTag={}));var X;(function(te){const ge=new Map([[v.CompletionItemKind.Method,0],[v.CompletionItemKind.Function,1],[v.CompletionItemKind.Constructor,2],[v.CompletionItemKind.Field,3],[v.CompletionItemKind.Variable,4],[v.CompletionItemKind.Class,5],[v.CompletionItemKind.Interface,7],[v.CompletionItemKind.Struct,6],[v.CompletionItemKind.Module,8],[v.CompletionItemKind.Property,9],[v.CompletionItemKind.Unit,12],[v.CompletionItemKind.Value,13],[v.CompletionItemKind.Constant,14],[v.CompletionItemKind.Enum,15],[v.CompletionItemKind.EnumMember,16],[v.CompletionItemKind.Keyword,17],[v.CompletionItemKind.Snippet,27],[v.CompletionItemKind.Text,18],[v.CompletionItemKind.Color,19],[v.CompletionItemKind.File,20],[v.CompletionItemKind.Reference,21],[v.CompletionItemKind.Folder,23],[v.CompletionItemKind.Event,10],[v.CompletionItemKind.Operator,11],[v.CompletionItemKind.TypeParameter,24],[v.CompletionItemKind.Issue,26],[v.CompletionItemKind.User,25]]);function Z(Ie){return ge.get(Ie)??9}te.from=Z;const W=new Map([[0,v.CompletionItemKind.Method],[1,v.CompletionItemKind.Function],[2,v.CompletionItemKind.Constructor],[3,v.CompletionItemKind.Field],[4,v.CompletionItemKind.Variable],[5,v.CompletionItemKind.Class],[7,v.CompletionItemKind.Interface],[6,v.CompletionItemKind.Struct],[8,v.CompletionItemKind.Module],[9,v.CompletionItemKind.Property],[12,v.CompletionItemKind.Unit],[13,v.CompletionItemKind.Value],[14,v.CompletionItemKind.Constant],[15,v.CompletionItemKind.Enum],[16,v.CompletionItemKind.EnumMember],[17,v.CompletionItemKind.Keyword],[27,v.CompletionItemKind.Snippet],[18,v.CompletionItemKind.Text],[19,v.CompletionItemKind.Color],[20,v.CompletionItemKind.File],[21,v.CompletionItemKind.Reference],[23,v.CompletionItemKind.Folder],[10,v.CompletionItemKind.Event],[11,v.CompletionItemKind.Operator],[24,v.CompletionItemKind.TypeParameter],[25,v.CompletionItemKind.User],[26,v.CompletionItemKind.Issue]]);function be(Ie){return W.get(Ie)??v.CompletionItemKind.Property}te.to=be})(X=e.CompletionItemKind||(e.CompletionItemKind={}));var se;(function(te){function ge(Z,W){const be=new v.CompletionItem(Z.label);return be.insertText=Z.insertText,be.kind=X.to(Z.kind),be.tags=Z.tags?.map(G.to),be.detail=Z.detail,be.documentation=w.isMarkdownString(Z.documentation)?c.to(Z.documentation):Z.documentation,be.sortText=Z.sortText,be.filterText=Z.filterText,be.preselect=Z.preselect,be.commitCharacters=Z.commitCharacters,F.Range.isIRange(Z.range)?be.range=p.to(Z.range):typeof Z.range=="object"&&(be.range={inserting:p.to(Z.range.insert),replacing:p.to(Z.range.replace)}),be.keepWhitespace=typeof Z.insertTextRules=="undefined"?!1:Boolean(Z.insertTextRules&1),typeof Z.insertTextRules!="undefined"&&Z.insertTextRules&4?be.insertText=new v.SnippetString(Z.insertText):(be.insertText=Z.insertText,be.textEdit=be.range instanceof v.Range?new v.TextEdit(be.range,be.insertText):void 0),Z.additionalTextEdits&&Z.additionalTextEdits.length>0&&(be.additionalTextEdits=Z.additionalTextEdits.map(Ie=>z.to(Ie))),be.command=W&&Z.command?W.fromInternal(Z.command):void 0,be}te.to=ge})(se=e.CompletionItem||(e.CompletionItem={}));var q;(function(te){function ge(W){return{label:W.label,documentation:W.documentation?c.fromStrict(W.documentation):void 0}}te.from=ge;function Z(W){return{label:W.label,documentation:w.isMarkdownString(W.documentation)?c.to(W.documentation):W.documentation}}te.to=Z})(q=e.ParameterInformation||(e.ParameterInformation={}));var ee;(function(te){function ge(W){return{label:W.label,documentation:W.documentation?c.fromStrict(W.documentation):void 0,parameters:Array.isArray(W.parameters)?W.parameters.map(q.from):[],activeParameter:W.activeParameter}}te.from=ge;function Z(W){return{label:W.label,documentation:w.isMarkdownString(W.documentation)?c.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(q.to):[],activeParameter:W.activeParameter}}te.to=Z})(ee=e.SignatureInformation||(e.SignatureInformation={}));var fe;(function(te){function ge(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(ee.from):[]}}te.from=ge;function Z(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(ee.to):[]}}te.to=Z})(fe=e.SignatureHelp||(e.SignatureHelp={}));var Ae;(function(te){function ge(W){return{text:W.text,position:l.from(W.position),kind:xe.from(W.kind??v.InlayHintKind.Other),whitespaceBefore:W.whitespaceBefore,whitespaceAfter:W.whitespaceAfter}}te.from=ge;function Z(W){const be=new v.InlayHint(W.text,l.to(W.position),xe.to(W.kind));return be.whitespaceAfter=W.whitespaceAfter,be.whitespaceBefore=W.whitespaceBefore,be}te.to=Z})(Ae=e.InlayHint||(e.InlayHint={}));var xe;(function(te){function ge(W){return W}te.from=ge;function Z(W){return W}te.to=Z})(xe=e.InlayHintKind||(e.InlayHintKind={}));var ze;(function(te){function ge(W){return{range:p.from(W.range),url:W.target,tooltip:W.tooltip}}te.from=ge;function Z(W){let be;if(W.url)try{be=typeof W.url=="string"?R.URI.parse(W.url,!0):R.URI.revive(W.url)}catch{}return new v.DocumentLink(p.to(W.range),be)}te.to=Z})(ze=e.DocumentLink||(e.DocumentLink={}));var Xe;(function(te){function ge(W){const be=new v.ColorPresentation(W.label);return W.textEdit&&(be.textEdit=z.to(W.textEdit)),W.additionalTextEdits&&(be.additionalTextEdits=W.additionalTextEdits.map(Ie=>z.to(Ie))),be}te.to=ge;function Z(W){return{label:W.label,textEdit:W.textEdit?z.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(be=>z.from(be)):void 0}}te.from=Z})(Xe=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(te){function ge(W){return new v.Color(W[0],W[1],W[2],W[3])}te.to=ge;function Z(W){return[W.red,W.green,W.blue,W.alpha]}te.from=Z})(et=e.Color||(e.Color={}));var st;(function(te){function ge(W){return{range:p.from(W.range)}}te.from=ge;function Z(W){return new v.SelectionRange(p.to(W.range))}te.to=Z})(st=e.SelectionRange||(e.SelectionRange={}));var Je;(function(te){function ge(Z){switch(Z){case 2:return v.TextDocumentSaveReason.AfterDelay;case 1:return v.TextDocumentSaveReason.Manual;case 3:case 4:return v.TextDocumentSaveReason.FocusOut}}te.to=ge})(Je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(te){function ge(W){switch(W){case v.TextEditorLineNumbersStyle.Off:return 0;case v.TextEditorLineNumbersStyle.Relative:return 2;case v.TextEditorLineNumbersStyle.On:default:return 1}}te.from=ge;function Z(W){switch(W){case 0:return v.TextEditorLineNumbersStyle.Off;case 2:return v.TextEditorLineNumbersStyle.Relative;case 1:default:return v.TextEditorLineNumbersStyle.On}}te.to=Z})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var lt;(function(te){function ge(W){if(W===v.EndOfLine.CRLF)return 1;if(W===v.EndOfLine.LF)return 0}te.from=ge;function Z(W){if(W===1)return v.EndOfLine.CRLF;if(W===0)return v.EndOfLine.LF}te.to=Z})(lt=e.EndOfLine||(e.EndOfLine={}));var pt;(function(te){function ge(Z){if(typeof Z=="object")return Z.viewId;switch(Z){case v.ProgressLocation.SourceControl:return 3;case v.ProgressLocation.Window:return 10;case v.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}te.from=ge})(pt=e.ProgressLocation||(e.ProgressLocation={}));var Ft;(function(te){function ge(Z){const W={start:Z.start+1,end:Z.end+1};return Z.kind&&(W.kind=Oe.from(Z.kind)),W}te.from=ge})(Ft=e.FoldingRange||(e.FoldingRange={}));var Oe;(function(te){function ge(Z){if(Z)switch(Z){case v.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case v.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case v.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}te.from=ge})(Oe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Mt;(function(te){function ge(Z){if(Z)return{pinned:typeof Z.preview=="boolean"?!Z.preview:void 0,inactive:Z.background,preserveFocus:Z.preserveFocus,selection:typeof Z.selection=="object"?p.from(Z.selection):void 0,override:typeof Z.override=="boolean"?n.EditorResolution.DISABLED:void 0}}te.from=ge})(Mt=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var V;(function(te){function ge(W){return W instanceof v.RelativePattern||typeof W=="string"?W:Z(W)?new v.RelativePattern(W.base,W.pattern):W}te.from=ge;function Z(W){const be=W;return be&&typeof be.base=="string"&&typeof be.pattern=="string"}})(V=e.GlobPattern||(e.GlobPattern={}));var Q;(function(te){function ge(Z){if(Z){if(Array.isArray(Z))return Z.map(ge);if(typeof Z=="string")return Z;{const W=Z;return{language:W.language,scheme:W.scheme,pattern:typeof W.pattern=="undefined"?void 0:V.from(W.pattern),exclusive:W.exclusive}}}else return}te.from=ge})(Q=e.LanguageSelector||(e.LanguageSelector={}));var de;(function(te){function ge(W){return{start:W.start,end:W.end}}te.from=ge;function Z(W){return new v.NotebookRange(W.start,W.end)}te.to=Z})(de=e.NotebookRange||(e.NotebookRange={}));var Ne;(function(te){function ge(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}te.to=ge;function Z(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}te.from=Z})(Ne=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var qe;(function(te){function ge(W){switch(W){case v.NotebookCellKind.Markup:return g.CellKind.Markup;case v.NotebookCellKind.Code:default:return g.CellKind.Code}}te.from=ge;function Z(W){switch(W){case g.CellKind.Markup:return v.NotebookCellKind.Markup;case g.CellKind.Code:default:return v.NotebookCellKind.Code}}te.to=Z})(qe=e.NotebookCellKind||(e.NotebookCellKind={}));var ot;(function(te){function ge(W){const be={metadata:W.metadata??Object.create(null),cells:[]};for(let Ie of W.cells)v.NotebookCellData.validate(Ie),be.cells.push(Ye.from(Ie));return be}te.from=ge;function Z(W){const be=new v.NotebookData(W.cells.map(Ye.to));return(0,C.isEmptyObject)(W.metadata)||(be.metadata=W.metadata),be}te.to=Z})(ot=e.NotebookData||(e.NotebookData={}));var Ye;(function(te){function ge(W){return{cellKind:qe.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:Ne.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(Te.from):[]}}te.from=ge;function Z(W){return new v.NotebookCellData(qe.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(Te.to):void 0,W.metadata,W.internalMetadata?Ne.to(W.internalMetadata):void 0)}te.to=Z})(Ye=e.NotebookCellData||(e.NotebookCellData={}));var yt;(function(te){function ge(W){return{mime:W.mime,valueBytes:t.VSBuffer.wrap(W.data)}}te.from=ge;function Z(W){return new v.NotebookCellOutputItem(W.valueBytes.buffer,W.mime)}te.to=Z})(yt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Te;(function(te){function ge(W){return{outputId:W.id,items:W.items.map(yt.from),metadata:W.metadata}}te.from=ge;function Z(W){const be=W.items.map(yt.to);return new v.NotebookCellOutput(be,W.outputId,W.metadata)}te.to=Z})(Te=e.NotebookCellOutput||(e.NotebookCellOutput={}));var De;(function(te){function ge(Ie){if(Ie!=null){if(Ie instanceof v.RelativePattern||typeof Ie=="string")return Ie;if(be(Ie))return new v.RelativePattern(Ie.base,Ie.pattern);if(W(Ie))return{include:V.from(Ie.include)||void 0,exclude:V.from(Ie.exclude)||void 0}}}te.from=ge;function Z(Ie){return typeof Ie=="string"?Ie:be(Ie)?{base:Ie.base,pattern:Ie.pattern}:{include:Ie.include,exclude:Ie.exclude}}te.to=Z;function W(Ie){const Qe=Ie,Ue=V.from(Qe.include);if(!(Ue&&Ue instanceof v.RelativePattern||typeof Ue=="string"))return!1;const ut=V.from(Qe.exclude);return!!(ut&&ut instanceof v.RelativePattern||typeof ut=="string")}function be(Ie){const Qe=Ie;return Qe&&typeof Qe.base=="string"&&typeof Qe.pattern=="string"}})(De=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ve;(function(te){function ge(Z){return{backgroundColor:Z.backgroundColor,borderColor:Z.borderColor,top:Z.top?U.from(Z.top):void 0}}te.from=ge})(ve=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var re;(function(te){function ge(Z,W,be){const Ie=typeof Z.command=="string"?{title:"",command:Z.command}:Z.command;return{alignment:Z.alignment===v.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(Ie,be),text:Z.text,tooltip:Z.tooltip,accessibilityInformation:Z.accessibilityInformation,priority:Z.priority}}te.from=ge})(re=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var oe;(function(te){function ge(Z){return{transientOutputs:Z?.transientOutputs??!1,transientCellMetadata:Z?.transientCellMetadata??{},transientDocumentMetadata:Z?.transientDocumentMetadata??{}}}te.from=ge})(oe=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var he;(function(te){function ge(W){return{uri:W.uri,provides:W.provides}}te.from=ge;function Z(W){return new v.NotebookRendererScript(R.URI.revive(W.uri),W.provides)}te.to=Z})(he=e.NotebookRendererScript||(e.NotebookRendererScript={}));var me;(function(te){function ge(W){return{message:c.fromStrict(W.message)||"",type:0,expected:W.expectedOutput,actual:W.actualOutput,location:W.location?ae.from(W.location):void 0}}te.from=ge;function Z(W){const be=new v.TestMessage(typeof W.message=="string"?W.message:c.to(W.message));return be.actualOutput=W.actual,be.expectedOutput=W.expected,be.location=W.location?ae.to(W.location):void 0,be}te.to=Z})(me=e.TestMessage||(e.TestMessage={}));var Pe;(function(te){let ge;(function(Z){Z.Delimiter="\0"})(ge||(ge={})),te.namespace=(Z,W)=>Z+"\0"+W,te.denamespace=Z=>{const W=Z.indexOf("\0");return{ctrlId:Z.slice(0,W),tagId:Z.slice(W+1)}}})(Pe=e.TestTag||(e.TestTag={}));var We;(function(te){function ge(Ie){const Qe=(0,r.getPrivateApiFor)(Ie).controllerId;return{extId:d.TestId.fromExtHostTestItem(Ie,Qe).toString(),label:Ie.label,uri:Ie.uri,tags:Ie.tags.map(Ue=>Pe.namespace(Qe,Ue.id)),range:p.from(Ie.range)||null,description:Ie.description||null,error:Ie.error&&c.fromStrict(Ie.error)||null}}te.from=ge;function Z(Ie){return{parent:void 0,error:void 0,id:d.TestId.fromString(Ie.extId).localId,label:Ie.label,uri:R.URI.revive(Ie.uri),tags:(Ie.tags||[]).map(Qe=>{const{tagId:Ue}=Pe.denamespace(Qe);return new v.TestTag(Ue)}),range:p.to(Ie.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ie.description||void 0}}te.toPlain=Z;function W(Ie){const Qe=d.TestId.fromString(Ie.extId),Ue=new r.TestItemImpl(Qe.controllerId,Qe.localId,Ie.label,R.URI.revive(Ie.uri));return Ue.range=p.to(Ie.range||void 0),Ue.description=Ie.description||void 0,Ue}function be(Ie){let Qe;for(const Ue of Ie.tests){const ut=W(Ue.item);(0,r.getPrivateApiFor)(ut).parent=Qe,Qe=ut}return Qe}te.toItemFromContext=be})(We=e.TestItem||(e.TestItem={})),function(te){function ge(W){return{id:W.id}}te.from=ge;function Z(W){return new v.TestTag(W.id)}te.to=Z}(Pe=e.TestTag||(e.TestTag={}));var Le;(function(te){const ge=(W,be)=>{const Ie={...We.toPlain(W.item),parent:void 0,taskStates:W.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(Ue=>Ue.type===0).map(me.to)})),children:W.children.map(Qe=>be.get(Qe)).filter(C.isDefined).map(Qe=>ge(Qe,be))};for(const Qe of Ie.children)Qe.parent=Ie;return Ie};function Z(W){const be=[],Ie=new Map;for(const Qe of W.items)Ie.set(Qe.item.extId,Qe),W.request.targets.some(Ue=>Ue.controllerId===Qe.controllerId&&Ue.testIds.includes(Qe.item.extId))&&be.push(Qe);return{completedAt:W.completedAt,results:be.map(Qe=>ge(Qe,Ie))}}te.to=Z})(Le=e.TestResults||(e.TestResults={}));var Ke;(function(te){function ge(Ie){return{covered:Ie.covered,total:Ie.covered}}function Z(Ie){return"line"in Ie?l.from(Ie):p.from(Ie)}function W(Ie){return"branches"in Ie?{count:Ie.executionCount,location:Z(Ie.location),type:1,branches:Ie.branches.length?Ie.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&Z(Qe.location)})):void 0}:{type:0,count:Ie.executionCount,location:Z(Ie.location)}}te.fromDetailed=W;function be(Ie){return{uri:Ie.uri,statement:ge(Ie.statementCoverage),branch:Ie.branchCoverage&&ge(Ie.branchCoverage),function:Ie.functionCoverage&&ge(Ie.functionCoverage),details:Ie.detailedCoverage?.map(W)}}te.fromFile=be})(Ke=e.TestCoverage||(e.TestCoverage={}));var it;(function(te){function ge(Z){switch(Z){case 1:return v.CodeActionTriggerKind.Invoke;case 2:return v.CodeActionTriggerKind.Automatic}}te.to=ge})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var rt;(function(te){function ge(W){const be=new v.TypeHierarchyItem($.to(W.kind),W.name,W.detail||"",R.URI.revive(W.uri),p.to(W.range),p.to(W.selectionRange));return be._sessionId=W._sessionId,be._itemId=W._itemId,be}te.to=ge;function Z(W,be,Ie){if(be=be??W._sessionId,Ie=Ie??W._itemId,be===void 0||Ie===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:Ie,kind:$.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:p.from(W.range),selectionRange:p.from(W.selectionRange),tags:W.tags?.map(j.from)}}te.from=Z})(rt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(Ee[165],ye([0,1,2,15,7,8,226]),function(ne,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(R,F,_,n={timeout:1500,errors:3}){this._logService=R,this._documents=F,this._mainThreadBulkEdits=_,this._thresholds=n,this._callbacks=new k.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(R){return(F,_,n)=>{const r={dispose:this._callbacks.push([F,_,R])};return Array.isArray(n)&&n.push(r),r}}async $participateInSave(R,F){const _=a.URI.revive(R);let n=!1;const m=setTimeout(()=>n=!0,this._thresholds.timeout),r=[];try{for(let g of[...this._callbacks]){if(n)break;const d=this._documents.getDocument(_),D=await this._deliverEventAsyncAndBlameBadListeners(g,{document:d,reason:T.TextDocumentSaveReason.to(F)});r.push(D)}}finally{clearTimeout(m)}return r}_deliverEventAsyncAndBlameBadListeners([R,F,_],n){const m=this._badListeners.get(R);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,R,F,n).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const g=this._badListeners.get(R);this._badListeners.set(R,g?g+1:1),typeof g=="number"&&g>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(R,F,_,n){const m=[],r=Date.now(),{document:g,reason:d}=n,{version:D}=g,v=Object.freeze({document:g,reason:d,waitUntil(f){if(Object.isFrozen(m))throw(0,t.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(f))}});try{F.apply(_,[v])}catch(f){return Promise.reject(f)}return Object.freeze(m),new Promise((f,p)=>{const I=setTimeout(()=>p(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(l=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(I),f(l)}).catch(l=>{clearTimeout(I),p(l)})}).then(f=>{const p={edits:[]};for(const I of f)if(Array.isArray(I)&&I.every(l=>l instanceof w.TextEdit))for(const{newText:l,newEol:M,range:o}of I)p.edits.push({_type:2,resource:g.uri,edit:{range:o&&T.Range.from(o),text:l,eol:M&&T.EndOfLine.from(M)}});if(p.edits.length!==0)return D===g.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(p):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(Ee[166],ye([0,1,4,29,2,8,7]),function(ne,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class P{constructor(F,_,n,m,r){this._onDidCreate=new a.Emitter,this._onDidChange=new a.Emitter,this._onDidDelete=new a.Emitter,this._config=0,n&&(this._config+=1),m&&(this._config+=2),r&&(this._config+=4);const g=(0,t.parse)(_),d=F(D=>{if(!n)for(let v of D.created){const f=w.URI.revive(v);g(f.fsPath)&&this._onDidCreate.fire(f)}if(!m)for(let v of D.changed){const f=w.URI.revive(v);g(f.fsPath)&&this._onDidChange.fire(f)}if(!r)for(let v of D.deleted){const f=w.URI.revive(v);g(f.fsPath)&&this._onDidDelete.fire(f)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,d)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(F,_,n){this._logService=_,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new a.Emitter,this._onDidRenameFile=new a.Emitter,this._onDidCreateFile=new a.Emitter,this._onDidDeleteFile=new a.Emitter,this._onWillRenameFile=new a.AsyncEmitter,this._onWillCreateFile=new a.AsyncEmitter,this._onWillDeleteFile=new a.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(F,_,n,m){return new P(this._onFileSystemEvent.event,F,_,n,m)}$onFileEvent(F){this._onFileSystemEvent.fire(F)}$onDidRunFileOperation(F,_){switch(F){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(n=>({oldUri:w.URI.revive(n.source),newUri:w.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(n=>w.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(n=>w.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(F){return this._createWillExecuteEvent(F,this._onWillRenameFile)}getOnWillCreateFileEvent(F){return this._createWillExecuteEvent(F,this._onWillCreateFile)}getOnWillDeleteFileEvent(F){return this._createWillExecuteEvent(F,this._onWillDeleteFile)}_createWillExecuteEvent(F,_){return(n,m,r)=>{const g=function(D){n.call(m,D)};return g.extension=F,_.event(g,void 0,r)}}async $onWillRunFileOperation(F,_,n,m){switch(F){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(r=>({oldUri:w.URI.revive(r.source),newUri:w.URI.revive(r.target)}))},n,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(r=>w.URI.revive(r.target))},n,m);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(r=>w.URI.revive(r.target))},n,m)}}async _fireWillEvent(F,_,n,m){const r=new Set,g=[];if(await F.fireAsync(_,m,async(D,v)=>{const f=Date.now(),p=await Promise.resolve(D);p instanceof k.WorkspaceEdit&&(g.push(p),r.add(v.extension.displayName??v.extension.identifier.value)),Date.now()-f>n&&this._logService.warn("SLOW file-participant",v.extension.identifier)}),m.isCancellationRequested||g.length===0)return;const d={edits:[]};for(let D of g){let{edits:v}=T.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);d.edits=d.edits.concat(v)}return{edit:d,extensionNames:Array.from(r)}}}e.ExtHostFileSystemEventService=C}),define(Ee[167],ye([0,1,10,26,2,8,7,87]),function(ne,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class C{constructor(n,m,r,g){this.start=n,this.deletedCount=m,this.deletedItems=r,this.items=g}static asApiEvents(n){return n.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(r=>r.apiCell)}))}}class R{constructor(n,m,r){this.notebook=n,this._extHostDocument=m,this._cellData=r,this.handle=r.handle,this.uri=w.URI.revive(r.uri),this.cellKind=r.cellKind,this._outputs=r.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=r.internalMetadata??{},this._metadata=Object.freeze(r.metadata??{}),this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(r.internalMetadata??{}))}static asModelAddData(n,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return n._mime},set mime(r){n._mime=r},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(T.NotebookCellOutput.to)}setOutputItems(n,m,r){const g=r.map(T.NotebookCellOutputItem.to),d=this._outputs.find(D=>D.id===n);d&&(m||(d.items.length=0),d.items.push(...g))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=R;class F{constructor(n,m,r,g,d,D){this._proxy=n,this._textDocumentsAndEditors=m,this._textDocuments=r,this._emitter=g,this.uri=d,this.handle=F._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=D.viewType,this._metadata=Object.freeze(D.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,D.cells]],!0),this._versionId=D.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===a.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(m){return m=n._validateIndex(m),n._cells[m].apiCell},getCells(m){return(m?n._getCells(m):n._cells).map(g=>g.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,m){this._versionId=n.versionId,this._isDirty=m;for(const r of n.rawEvents)r.kind===P.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(r.changes,!1):r.kind===P.NotebookCellsChangeType.Move?this._moveCell(r.index,r.newIdx):r.kind===P.NotebookCellsChangeType.Output?this._setCellOutputs(r.index,r.outputs):r.kind===P.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(r.index,r.outputId,r.append,r.outputItems):r.kind===P.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(r.index,r.language):r.kind===P.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(r.index,r.mime):r.kind===P.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(r.index,r.metadata):r.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(r.index,r.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let m=n.start|0,r=n.end|0;return m<0&&(m=0),r>this._cells.length&&(r=this._cells.length),n.with({start:m,end:r})}_getCells(n){n=this._validateRange(n);const m=[];for(let r=n.start;r<n.end;r++)m.push(this._cells[r]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,m){if(this._disposed)return;const r=[],g=[],d=[];n.reverse().forEach(D=>{const f=D[2].map(l=>{const M=new R(this,this._textDocumentsAndEditors,l);return m||g.push(R.asModelAddData(this.apiNotebook,l)),M}),p=new C(D[0],D[1],[],f),I=this._cells.splice(D[0],D[1],...f);for(const l of I)d.push(l.uri),p.deletedItems.push(l.apiCell);r.push(p)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:d}),m||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(r)}))}_moveCell(n,m){const r=this._cells.splice(n,1);this._cells.splice(m,0,...r);const g=[new C(n,1,r.map(d=>d.apiCell),[]),new C(m,0,[],r)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(g)}))}_setCellOutputs(n,m){const r=this._cells[n];r.setOutputs(m),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[r.apiCell]}))}_setCellOutputItems(n,m,r,g){const d=this._cells[n];d.setOutputItems(m,r,g),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[d.apiCell]}))}_changeCellLanguage(n,m){const r=this._cells[n];r.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(r.uri,m)}_changeCellMime(n,m){const r=this._cells[n];r.apiCell.mime=m}_changeCellMetadata(n,m){const r=this._cells[n],g=r.apiCell.metadata;r.setMetadata(m);const d=r.apiCell.metadata;(0,t.equals)(g,d)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:r.apiCell}))}_changeCellInternalMetadata(n,m){const r=this._cells[n],g=r.internalMetadata;if(r.setInternalMetadata(m),g.runState!==m.runState){const d=m.runState??k.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,t.deepFreeze)({document:this.apiNotebook,cell:r.apiCell,state:d}))}}getCellFromApiCell(n){return this._cells.find(m=>m.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(m=>m.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=F,F._handlePool=0}),define(Ee[91],ye([0,1,7,8,15]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,R){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:R})}replaceCells(C,R,F){this._throwIfFinalized(),!(C===R&&F.length===0)&&this._collectedEdits.push({editType:1,index:C,count:R-C,cells:F.map(t.NotebookCellData.from)})}}class k{constructor(C,R,F,_,n,m){this.id=C,this._proxy=R,this.notebookData=F,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=_,this._viewColumn=m}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(R){if(!Array.isArray(R)||!R.every(a.NotebookRange.isNotebookRange))throw(0,w.illegalArgument)("selections");C._selections=R,C._trySetSelections(R)},get visibleRanges(){return C._visibleRanges},revealRange(R,F){C._proxy.$tryRevealRange(C.id,t.NotebookRange.from(R),F??a.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(R){const F=new T(this.document.version);return R(F),C._applyEdit(F.finalize())},setDecorations(R,F){return C.setDecorations(R,F)}},k.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(t.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const R=[];let F=-1;for(let _=0;_<C.cellEdits.length;_++){if(F<0){R.push(C.cellEdits[_]),F++;continue}const m=R[F],r=C.cellEdits[_];if(m.editType===1&&r.editType===1&&m.index===r.index){m.cells.push(...C.cellEdits[_].cells),m.count+=C.cellEdits[_].count;continue}R.push(C.cellEdits[_]),F++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,R)}setDecorations(C,R){if(!(R.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return R.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(R),C.key)}}e.ExtHostNotebookEditor=k,k.apiEditorsToExtHost=new WeakMap}),define(Ee[168],ye([0,1,8,140,121,20,52,15]),function(ne,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(n){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=n}async withProgress(n,m,r){const g=this._handles++,{title:d,location:D,cancellable:v}=m,f={label:(0,w.localize)(0,null,n.displayName||n.name),id:n.identifier.value};return this._proxy.$startProgress(g,{location:a.ProgressLocation.from(D),title:d,source:f,cancellable:v},n).catch(P.onUnexpectedExternalError),this._withProgress(g,r,!!v)}_withProgress(n,m,r){let g;r&&(g=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(n,g));const d=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),g&&g.dispose()};let D;try{D=m(new F(this._proxy,n),r&&g?g.token:T.CancellationToken.None)}catch(v){throw d(n),v}return D.then(v=>d(n),v=>d(n)),D}$acceptProgressCanceled(n){const m=this._mapHandleToCancellationSource.get(n);m&&(m.cancel(),this._mapHandleToCancellationSource.delete(n))}}e.ExtHostProgress=C;function R(_,n){return _.message=n.message,typeof n.increment=="number"&&(typeof _.increment=="number"?_.increment+=n.increment:_.increment=n.increment),_}class F extends t.Progress{constructor(n,m){super(r=>this.throttledReport(r));this._proxy=n,this._handle=m}throttledReport(n){this._proxy.$progressReport(this._handle,n)}}Be([(0,k.throttle)(100,(_,n)=>R(_,n),()=>Object.create(null))],F.prototype,"throttledReport",null)}),define(Ee[92],ye([0,1,41,15,53,8,7]),function(ne,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(n,m,r){const g=P._Keys.nextId();n.$registerTextEditorDecorationType(m.identifier,g,T.DecorationRenderOptions.from(r)),this.value=Object.freeze({key:g,dispose(){n.$removeTextEditorDecorationType(g)}})}}e.TextEditorDecorationType=P,P._Keys=new w.IdGenerator("TextEditorDecorationType");class C{constructor(n,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,m){this._throwIfFinalized();let r=null;if(n instanceof k.Position)r=new k.Range(n,n);else if(n instanceof k.Range)r=n;else throw new Error("Unrecognized location");this._pushEdit(r,m,!1)}insert(n,m){this._throwIfFinalized(),this._pushEdit(new k.Range(n,n),m,!0)}delete(n){this._throwIfFinalized();let m=null;if(n instanceof k.Range)m=n;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(n,m,r){const g=this._document.validateRange(n);this._collectedEdits.push({range:g,text:m,forceMoveMarkers:r})}setEndOfLine(n){if(this._throwIfFinalized(),n!==k.EndOfLine.LF&&n!==k.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=C;class R{constructor(n,m,r,g){this._proxy=n,this._id=m,this._accept(r),this._logService=g;const d=this;this.value={get tabSize(){return d._tabSize},set tabSize(D){d._setTabSize(D)},get insertSpaces(){return d._insertSpaces},set insertSpaces(D){d._setInsertSpaces(D)},get cursorStyle(){return d._cursorStyle},set cursorStyle(D){d._setCursorStyle(D)},get lineNumbers(){return d._lineNumbers},set lineNumbers(D){d._setLineNumbers(D)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const m=Math.floor(n);return m>0?m:null}if(typeof n=="string"){const m=parseInt(n,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(n){const m=this._validateTabSize(n);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const m=this._validateInsertSpaces(n);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(n)})))}assign(n){const m={};let r=!1;if(typeof n.tabSize!="undefined"){const g=this._validateTabSize(n.tabSize);g==="auto"?(r=!0,m.tabSize=g):typeof g=="number"&&this._tabSize!==g&&(this._tabSize=g,r=!0,m.tabSize=g)}if(typeof n.insertSpaces!="undefined"){const g=this._validateInsertSpaces(n.insertSpaces);g==="auto"?(r=!0,m.insertSpaces=g):this._insertSpaces!==g&&(this._insertSpaces=g,r=!0,m.insertSpaces=g)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,r=!0,m.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,r=!0,m.lineNumbers=T.TextEditorLineNumbersStyle.from(n.lineNumbers)),r&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,m))}_warnOnError(n,m){m.catch(r=>{this._logService.warn(`ExtHostTextEditorOptions '${n}' failed:'`),this._logService.warn(r)})}}e.ExtHostTextEditorOptions=R;class F{constructor(n,m,r,g,d,D,v,f){this.id=n,this._proxy=m,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._options=new R(this._proxy,this.id,D,r),this._visibleRanges=v,this._viewColumn=f;const p=this;this.value=Object.freeze({get document(){return g.getValue()},set document(I){throw(0,t.readonly)("document")},get selection(){return p._selections&&p._selections[0]},set selection(I){if(!(I instanceof k.Selection))throw(0,t.illegalArgument)("selection");p._selections=[I],p._trySetSelection()},get selections(){return p._selections},set selections(I){if(!Array.isArray(I)||I.some(l=>!(l instanceof k.Selection)))throw(0,t.illegalArgument)("selections");p._selections=I,p._trySetSelection()},get visibleRanges(){return p._visibleRanges},set visibleRanges(I){throw(0,t.readonly)("visibleRanges")},get options(){return p._options.value},set options(I){p._disposed||p._options.assign(I)},get viewColumn(){return p._viewColumn},set viewColumn(I){throw(0,t.readonly)("viewColumn")},edit(I,l={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const M=new C(g.getValue(),l);return I(M),p._applyEdit(M)},insertSnippet(I,l,M={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!l||Array.isArray(l)&&l.length===0)o=p._selections.map(i=>T.Range.from(i));else if(l instanceof k.Position){const{lineNumber:i,column:h}=T.Position.from(l);o=[{startLineNumber:i,startColumn:h,endLineNumber:i,endColumn:h}]}else if(l instanceof k.Range)o=[T.Range.from(l)];else{o=[];for(const i of l)if(i instanceof k.Range)o.push(T.Range.from(i));else{const{lineNumber:h,column:u}=T.Position.from(i);o.push({startLineNumber:h,startColumn:u,endLineNumber:h,endColumn:u})}}return m.$tryInsertSnippet(n,I.value,o,M)},setDecorations(I,l){const M=l.length===0;M&&!p._hasDecorationsForKey.has(I.key)||(M?p._hasDecorationsForKey.delete(I.key):p._hasDecorationsForKey.add(I.key),p._runOnProxy(()=>{if(T.isDecorationOptionsArr(l))return m.$trySetDecorations(n,I.key,T.fromRangeOrRangeWithMessage(l));{const o=new Array(4*l.length);for(let i=0,h=l.length;i<h;i++){const u=l[i];o[4*i]=u.start.line+1,o[4*i+1]=u.start.character+1,o[4*i+2]=u.end.line+1,o[4*i+3]=u.end.character+1}return m.$trySetDecorationsFast(n,I.key,o)}}))},revealRange(I,l){p._runOnProxy(()=>m.$tryRevealRange(n,T.Range.from(I),l||k.TextEditorRevealType.Default))},show(I){m.$tryShowEditor(n,T.ViewColumn.from(I))},hide(){m.$tryHideEditor(n)}})}dispose(){(0,a.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,a.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,a.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,a.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,a.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const m=n.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const r=m.edits.map(d=>d.range);r.sort((d,D)=>d.end.line===D.end.line?d.end.character===D.end.character?d.start.line===D.start.line?d.start.character-D.start.character:d.start.line-D.start.line:d.end.character-D.end.character:d.end.line-D.end.line);for(let d=0,D=r.length-1;d<D;d++){const v=r[d].end;if(r[d+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=m.edits.map(d=>({range:T.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,g,{setEndOfLine:typeof m.setEndOfLine=="number"?T.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=F}),define(Ee[169],ye([0,1,124,24,2,4,6,14,7,11,16,8,20,153]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function r(D,v){if((0,R.isString)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let f;return Array.isArray(D.highlights)&&(f=D.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),f=f.length?f:void 0),{label:D.label,highlights:f}}}class g{constructor(v,f,p){this._proxy=v,this.commands=f,this.logService=p,this.treeViews=new Map;function I(l){return l&&l.$treeViewId&&l.$treeItemHandle}f.registerArgumentProcessor({processArgument:l=>I(l)?this.convertArgument(l):Array.isArray(l)&&l.length>0?l.map(M=>I(M)?this.convertArgument(M):M):l})}registerTreeDataProvider(v,f,p){const I=this.createTreeView(v,{treeDataProvider:f},p);return{dispose:()=>I.dispose()}}createTreeView(v,f,p){if(!f||!f.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const I=f.dragAndDropController?.supportedMimeTypes,l=this._proxy.$registerTreeViewDataProvider(v,{showCollapseAll:!!f.showCollapseAll,canSelectMany:!!f.canSelectMany,dragAndDropMimeTypes:I}),M=this.createExtHostTreeView(v,f,p);return{get onDidCollapseElement(){return M.onDidCollapseElement},get onDidExpandElement(){return M.onDidExpandElement},get selection(){return M.selectedElements},get onDidChangeSelection(){return M.onDidChangeSelection},get visible(){return M.visible},get onDidChangeVisibility(){return M.onDidChangeVisibility},get message(){return M.message},set message(o){M.message=o},get title(){return M.title},set title(o){M.title=o},get description(){return M.description},set description(o){M.description=o},reveal:(o,i)=>M.reveal(o,i),dispose:async()=>{await l,this.treeViews.delete(v),M.dispose()}}}$getChildren(v,f){const p=this.treeViews.get(v);return p?p.getChildren(f):Promise.reject(new Error((0,a.localize)(0,null,v)))}async $onDrop(v,f,p,I,l){const M=this.treeViews.get(v);if(!M)return Promise.reject(new Error((0,a.localize)(1,null,v)));const o=m.TreeDataTransferConverter.toITreeDataTransfer(f);if(I===v&&l){const i=await M.onWillDrop(l);i&&i.forEach((h,u)=>{h&&o.set(u,h)})}return M.onDrop(o,p)}async $hasResolve(v){const f=this.treeViews.get(v);if(!f)throw new Error((0,a.localize)(2,null,v));return f.hasResolve}$resolve(v,f,p){const I=this.treeViews.get(v);if(!I)throw new Error((0,a.localize)(3,null,v));return I.resolveTreeItem(f,p)}$setExpanded(v,f,p){const I=this.treeViews.get(v);if(!I)throw new Error((0,a.localize)(4,null,v));I.setExpanded(f,p)}$setSelection(v,f){const p=this.treeViews.get(v);if(!p)throw new Error((0,a.localize)(5,null,v));p.setSelection(f)}$setVisible(v,f){const p=this.treeViews.get(v);if(!p)throw new Error((0,a.localize)(6,null,v));p.setVisible(f)}createExtHostTreeView(v,f,p){const I=new d(v,f,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(v,I),I}convertArgument(v){const f=this.treeViews.get(v.$treeViewId);return f?f.getExtensionElement(v.$treeItemHandle):null}}e.ExtHostTreeViews=g;class d extends k.Disposable{constructor(v,f,p,I,l,M){super();if(this.viewId=v,this.proxy=p,this.commands=I,this.logService=l,this.extension=M,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new n.CancellationTokenSource,M.contributes&&M.contributes.views)for(const h in M.contributes.views)for(const u of M.contributes.views[h])u.id===v&&(this._title=u.name);this.dataProvider=f.treeDataProvider,this.dndController=f.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(h=>this._onDidChangeData.fire({message:!1,element:h}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(h=>this._onDidChangeData.fire({message:!1,element:h})));let o,i;this._register(T.Event.debounce(this._onDidChangeData.event,(h,u)=>(h||(h={message:!1,elements:[]}),u.element!==!1&&(o||(o=new Promise(s=>i=s),this.refreshPromise=this.refreshPromise.then(()=>o)),Array.isArray(u.element)?h.elements.push(...u.element):h.elements.push(u.element)),u.message&&(h.message=!0),h),200,!0)(({message:h,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const s=i;return o=null,this.refresh(u).then(()=>s())})),h&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(v=>this.getExtensionElement(v)).filter(v=>!(0,R.isUndefinedOrNull)(v))}async getChildren(v){const f=v?this.getExtensionElement(v):void 0;if(v&&!f)return this.logService.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let p=this.getChildrenNodes(v);return p||(p=await this.fetchChildrenNodes(f)),p?p.map(I=>I.item):void 0}getExtensionElement(v){return this.elements.get(v)}reveal(v,f){f=f||{select:!0,focus:!1};const p=(0,R.isUndefinedOrNull)(f.select)?!0:f.select,I=(0,R.isUndefinedOrNull)(f.focus)?!1:f.focus,l=(0,R.isUndefinedOrNull)(f.expand)?!1:f.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.refreshPromise.then(()=>this.resolveUnknownParentChain(v)).then(M=>this.resolveTreeNode(v,M[M.length-1]).then(o=>this.proxy.$reveal(this.viewId,{item:o.item,parentChain:M.map(i=>i.item)},{select:p,focus:I,expand:l})),M=>this.logService.error(M)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:I,expand:l})}get message(){return this._message}set message(v){this._message=v,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(v){this._title=v,this.proxy.$setTitle(this.viewId,v,this._description)}get description(){return this._description}set description(v){this._description=v,this.proxy.$setTitle(this.viewId,this._title,v)}setExpanded(v,f){const p=this.getExtensionElement(v);p&&(f?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(v){(0,F.equals)(this._selectedHandles,v)||(this._selectedHandles=v,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(v){v!==this._visible&&(this._visible=v,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(v){const f=[];for(const p of v){const I=this.getExtensionElement(p);I&&f.push(I)}if(!(!this.dndController?.onWillDrop||f.length===0))return this.dndController.onWillDrop(f)}async onDrop(v,f){const p=this.getExtensionElement(f);if(!!p)return(0,P.asPromise)(()=>this.dndController?.onDrop(v,p))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(v,f){if(!this.dataProvider.resolveTreeItem)return;const p=this.elements.get(v);if(p){const I=this.nodes.get(p);if(I){const l=await this.dataProvider.resolveTreeItem(I.extensionItem,p,f)??I.extensionItem;return I.item.tooltip=this.getTooltip(l.tooltip),I.item.command=this.getCommand(I.disposableStore,l.command),I.item}}}resolveUnknownParentChain(v){return this.resolveParent(v).then(f=>f?this.resolveUnknownParentChain(f).then(p=>this.resolveTreeNode(f,p[p.length-1]).then(I=>(p.push(I),p))):Promise.resolve([]))}resolveParent(v){const f=this.nodes.get(v);return f?Promise.resolve(f.parent?this.elements.get(f.parent.item.handle):void 0):(0,P.asPromise)(()=>this.dataProvider.getParent(v))}resolveTreeNode(v,f){const p=this.nodes.get(v);return p?Promise.resolve(p):(0,P.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(I=>this.createHandle(v,I,f,!0)).then(I=>this.getChildren(f?f.item.handle:void 0).then(()=>{const l=this.getExtensionElement(I);if(l){const M=this.nodes.get(l);if(M)return Promise.resolve(M)}throw new Error(`Cannot resolve tree item for element ${I}`)}))}getChildrenNodes(v){if(v){let f;if(typeof v=="string"){const p=this.getExtensionElement(v);f=p?this.nodes.get(p):void 0}else f=v;return f&&f.children||void 0}return this.roots}async fetchChildrenNodes(v){this.clearChildren(v);const f=new n.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=v?this.nodes.get(v):void 0,I=await this.dataProvider.getChildren(v);if(f.token.isCancellationRequested)return;const l=await Promise.all((0,F.coalesce)(I||[]).map(async M=>{const o=await this.dataProvider.getTreeItem(M);return o&&!f.token.isCancellationRequested?this.createAndRegisterTreeNode(M,o,p):null}));return f.token.isCancellationRequested?void 0:(0,F.coalesce)(l)}finally{f.dispose()}}refresh(v){if(v.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new n.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(v);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(v){const f=new Set,p=v.map(l=>this.nodes.get(l));for(const l of p)if(l&&!f.has(l.item.handle)){let M=l;for(;M&&M.parent&&p.findIndex(o=>M&&M.parent&&o&&o.item.handle===M.parent.item.handle)===-1;){const o=this.elements.get(M.parent.item.handle);M=o?this.nodes.get(o):void 0}M&&!M.parent&&f.add(l.item.handle)}const I=[];return f.forEach(l=>{const M=this.elements.get(l);if(M){const o=this.nodes.get(M);o&&(!o.parent||!f.has(o.parent.item.handle))&&I.push(l)}}),I}refreshHandles(v){const f={};return Promise.all(v.map(p=>this.refreshNode(p).then(I=>{I&&(f[p]=I.item)}))).then(()=>Object.keys(f).length?this.proxy.$refresh(this.viewId,f):void 0)}refreshNode(v){const f=this.getExtensionElement(v);if(f){const p=this.nodes.get(f);if(p)return this.clearChildren(f),(0,P.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(I=>{if(I){const l=this.createTreeNode(f,I,p.parent);return this.updateNodeCache(f,l,p,p.parent),p.dispose(),l}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(v,f,p){const I=this.createTreeNode(v,f,p);if(f.id&&this.elements.has(I.item.handle))throw new Error((0,a.localize)(7,null,f.id));return this.addNodeToCache(v,I),this.addNodeToParentCache(I,p),I}getTooltip(v){return C.MarkdownString.isMarkdownString(v)?_.MarkdownString.from(v):v}getCommand(v,f){return f?this.commands.toInternal(f,v):void 0}createTreeNode(v,f,p){const I=new k.DisposableStore,l=this.createHandle(v,f,p),M=this.getLightIconPath(f);return{item:{handle:l,parentHandle:p?p.item.handle:void 0,label:r(f.label,this.extension),description:f.description,resourceUri:f.resourceUri,tooltip:this.getTooltip(f.tooltip),command:this.getCommand(I,f.command),contextValue:f.contextValue,icon:M,iconDark:this.getDarkIconPath(f)||M,themeIcon:this.getThemeIcon(f),collapsibleState:(0,R.isUndefinedOrNull)(f.collapsibleState)?C.TreeItemCollapsibleState.None:f.collapsibleState,accessibilityInformation:f.accessibilityInformation},extensionItem:f,parent:p,children:void 0,disposableStore:I,dispose(){I.dispose()}}}getThemeIcon(v){return v.iconPath instanceof C.ThemeIcon?v.iconPath:void 0}createHandle(v,{id:f,label:p,resourceUri:I},l,M){if(f)return`${d.ID_HANDLE_PREFIX}/${f}`;const o=r(p,this.extension),i=l?l.item.handle:d.LABEL_HANDLE_PREFIX;let h=o?o.label:I?(0,t.basename)(I):"";h=h.indexOf("/")!==-1?h.replace("/","//"):h;const u=this.nodes.has(v)?this.nodes.get(v).item.handle:void 0,s=this.getChildrenNodes(l)||[];let b,y=0;do{if(b=`${i}/${y}:${h}`,M||!this.elements.has(b)||u===b)break;y++}while(y<=s.length);return b}getLightIconPath(v){if(v.iconPath&&!(v.iconPath instanceof C.ThemeIcon))return typeof v.iconPath=="string"||w.URI.isUri(v.iconPath)?this.getIconPath(v.iconPath):this.getIconPath(v.iconPath.light)}getDarkIconPath(v){if(v.iconPath&&!(v.iconPath instanceof C.ThemeIcon)&&v.iconPath.dark)return this.getIconPath(v.iconPath.dark)}getIconPath(v){return w.URI.isUri(v)?v:w.URI.file(v)}addNodeToCache(v,f){this.elements.set(f.item.handle,v),this.nodes.set(v,f)}updateNodeCache(v,f,p,I){this.elements.delete(f.item.handle),this.nodes.delete(v),f.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(v,f);const l=this.getChildrenNodes(I)||[],M=l.filter(o=>o.item.handle===p.item.handle)[0];M&&l.splice(l.indexOf(M),1,f)}addNodeToParentCache(v,f){f?(f.children||(f.children=[]),f.children.push(v)):(this.roots||(this.roots=[]),this.roots.push(v))}clearChildren(v){if(v){const f=this.nodes.get(v);if(f){if(f.children)for(const p of f.children){const I=this.elements.get(p.item.handle);I&&this.clear(I)}f.children=void 0}}else this.clearAll()}clear(v){const f=this.nodes.get(v);if(f){if(f.children)for(const p of f.children){const I=this.elements.get(p.item.handle);I&&this.clear(I)}this.nodes.delete(v),this.elements.delete(f.item.handle),f.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(v=>v.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}d.LABEL_HANDLE_PREFIX="0",d.ID_HANDLE_PREFIX="1"}),define(Ee[170],ye([0,1,14,4,6,11,47,8,88,67]),function(ne,e,a,t,w,T,k,P,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class F extends w.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new k.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const m=this.diff[this.diff.length-1];if(m&&n[0]===1){if(m[0]===1&&m[1].extId===n[1].extId){(0,C.applyTestItemUpdate)(m[1],n[1]);return}if(m[0]===0&&m[1].item.extId===n[1].extId){(0,C.applyTestItemUpdate)(m[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,m){const r=this.tree.get(n);if(!!r){if((r.expandLevels===void 0||m>r.expandLevels)&&(r.expandLevels=m),r.expand===1){const g=this.resolveChildren(r);return g.isOpen()?this.expandChildren(r,m-1):g.wait().then(()=>this.expandChildren(r,m-1))}else if(r.expand===3)return r.resolveBarrier?.isOpen()===!1?r.resolveBarrier.wait().then(()=>this.expandChildren(r,m-1)):this.expandChildren(r,m-1)}}dispose(){for(const n of this.tree.values())(0,k.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,m){switch(m.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(R.TestId.joinToString(n.fullId,m.id));break;case 0:this.upsertItem(m.item,n);break;case 4:for(const r of m.ops)this.onTestItemEvent(n,r);break;case 3:{const{key:r,value:g,previous:d}=m,D=n.fullId.toString();switch(r){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(g,d,D);break;case"range":this.pushDiff([1,{extId:D,item:{range:P.Range.from(g)}}]);break;case"error":this.pushDiff([1,{extId:D,item:{error:P.MarkdownString.fromStrict(g)||null}}]);break;default:this.pushDiff([1,{extId:D,item:{[r]:g??null}}]);break}break}default:(0,T.assertNever)(m)}}upsertItem(n,m){if(!(n instanceof k.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const r=R.TestId.fromExtHostTestItem(n,this.root.id,m?.actual),g=(0,k.getPrivateApiFor)(n);g.parent&&g.parent!==m?.actual&&g.parent.children.delete(n.id);let d=this.tree.get(r.toString());if(!d){d={fullId:r,actual:n,parent:m?r.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(d.fullId.toString(),d),this.setItemParent(n,m),this.pushDiff([0,{parent:d.parent&&d.parent.toString(),controllerId:this.controllerId,expand:d.expand,item:P.TestItem.from(n)}]),this.connectItemAndChildren(n,d,m);return}if(d.actual===n){this.connectItem(n,d,m);return}const D=d.actual.children,v=d.actual,f=(0,k.diffTestItems)(v,n);(0,k.getPrivateApiFor)(v).listener=void 0,d.actual=n,d.expand=0;for(const[p,I]of f)this.onTestItemEvent(d,{op:3,key:p,value:I,previous:v[p]});this.connectItemAndChildren(n,d,m);for(const p of D)n.children.get(p.id)||this.removeItem(R.TestId.joinToString(r,p.id))}diffTagRefs(n,m,r){const g=new Set(m.map(d=>d.id));for(const d of n)g.delete(d.id)||this.incrementTagRefs(d);this.pushDiff([1,{extId:r,item:{tags:n.map(d=>P.TestTag.namespace(this.controllerId,d.id))}}]),g.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const m=this.tags.get(n.id);m?m.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:P.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const m=this.tags.get(n);m&&!--m.refCount&&(this.tags.delete(n),this.pushDiff([6,P.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,m){(0,k.getPrivateApiFor)(n).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(n,m,r){this.setItemParent(n,r);const g=(0,k.getPrivateApiFor)(n);g.parent=r?.actual,g.listener=d=>this.onTestItemEvent(m,d),this.updateExpandability(m)}connectItemAndChildren(n,m,r){this.connectItem(n,m,r);for(const g of n.children)this.upsertItem(g,m)}updateExpandability(n){let m;this._resolveHandler?n.resolveBarrier?m=n.resolveBarrier.isOpen()?3:2:m=n.actual.canResolveChildren?1:0:m=0,m!==n.expand&&(n.expand=m,this.pushDiff([1,{extId:n.fullId.toString(),expand:m}]),m===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,m){if(m<0)return;const r=[];for(const g of n.actual.children){const d=this.expand(R.TestId.joinToString(n.fullId,g.id),m);(0,a.isThenable)(d)&&r.push(d)}if(r.length)return Promise.all(r).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const d=new a.Barrier;return d.open(),d}n.expand=2,this.pushExpandStateUpdate(n);const m=n.resolveBarrier=new a.Barrier,r=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=d.stack||d.message||String(d))};let g;try{g=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(d){r(d)}return(0,a.isThenable)(g)?g.catch(r).then(()=>{m.open(),this.updateExpandability(n)}):(m.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const m=this.tree.get(n);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const r=[m];for(;r.length;){const g=r.pop();if(!!g){(0,k.getPrivateApiFor)(g.actual).listener=void 0;for(const d of g.actual.tags)this.decrementTagRefs(d.id);this.tree.delete(g.fullId.toString());for(const d of g.actual.children)r.push(this.tree.get(R.TestId.joinToString(g.fullId,d.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=F}),define(Ee[171],ye([0,1,3,136]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(t.IEnvironmentService)}),define(Ee[172],ye([0,1,25,4,17]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(F){this.removedDueToLooping=F}}e.DeltaExtensionsResult=T;class k{constructor(F){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=F,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const F of this._extensionDescriptions){if(this._extensionsMap.has(a.ExtensionIdentifier.toKey(F.identifier))){console.error("Extension `"+F.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(a.ExtensionIdentifier.toKey(F.identifier),F),this._extensionsArr.push(F),Array.isArray(F.activationEvents))for(let _ of F.activationEvents)_==="onUri"&&(_=`onUri:${a.ExtensionIdentifier.toKey(F.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(F)}}keepOnly(F){const _=new Set;F.forEach(n=>_.add(a.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>_.has(a.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(F,_){F.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(F));const n=k._findLoopingExtensions(this._extensionDescriptions);if(_=_.concat(n.map(m=>m.identifier)),_.length>0){const m=new Set;_.forEach(r=>m.add(a.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!m.has(a.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(n)}static _findLoopingExtensions(F){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(d){this._nodesSet.has(d)||(this._nodesSet.add(d),this._nodesArr.push(d))}addArc(d,D){this.addNode(d),this.addNode(D),this._arcs.has(d)?this._arcs.get(d).push(D):this._arcs.set(d,[D])}getArcs(d){return this._arcs.has(d)?this._arcs.get(d):[]}hasOnlyGoodArcs(d,D){const v=_.getArcs(d);for(let f=0;f<v.length;f++)if(!D.has(v[f]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let d of F){const D=a.ExtensionIdentifier.toKey(d.identifier);if(n.set(D,d),d.extensionDependencies)for(let v of d.extensionDependencies){const f=a.ExtensionIdentifier.toKey(v);_.addArc(D,f)}}let m=new Set;_.getNodes().filter(d=>_.getArcs(d).length===0).forEach(d=>m.add(d));let r=_.getNodes().filter(d=>!m.has(d)),g;do{g=!1;for(let d=0;d<r.length;d++){const D=r[d];_.hasOnlyGoodArcs(D,m)&&(r.splice(d,1),d--,m.add(D),g=!0)}}while(g);return r.map(d=>n.get(d))}containsActivationEvent(F){return this._activationMap.has(F)}containsExtension(F){return this._extensionsMap.has(a.ExtensionIdentifier.toKey(F))}getExtensionDescriptionsForActivationEvent(F){const _=this._activationMap.get(F);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(F){const _=this._extensionsMap.get(a.ExtensionIdentifier.toKey(F));return _||void 0}}e.ExtensionDescriptionRegistry=k;var P;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(P||(P={}));function C(R,F){const _=R.isBuiltin?0:R.isUnderDevelopment?2:1,n=F.isBuiltin?0:F.isUnderDevelopment?2:1;if(_!==n)return _-n;const m=w.posix.basename(R.extensionLocation.path),r=w.posix.basename(F.extensionLocation.path);return m<r?-1:m>r?1:0}}),define(Ee[173],ye([0,1,22]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var t;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(t=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var w;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(w=e.MessageType||(e.MessageType={}));function T(P){const C=a.VSBuffer.alloc(1);switch(P){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.createMessageOfType=T;function k(P,C){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.isMessageOfType=k}),define(Ee[27],ye([0,1,4,2,3,25,143]),function(ne,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,w.createDecorator)("extensionService");var P;(function(p){p[p.None=0]="None",p[p.LocalProcess=1]="LocalProcess",p[p.LocalWebWorker=2]="LocalWebWorker",p[p.Remote=3]="Remote"})(P=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(p){switch(p){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class R{constructor(I){this.dependency=I}}e.MissingExtensionDependency=R;var F;(function(p){p[p.LocalProcess=0]="LocalProcess",p[p.LocalWebWorker=1]="LocalWebWorker",p[p.Remote=2]="Remote"})(F=e.ExtensionHostKind||(e.ExtensionHostKind={}));function _(p){switch(p){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=_;function n(p,I){return p.enabledApiProposals?p.enabledApiProposals.includes(I):!1}e.isProposedApiEnabled=n;function m(p,I){if(!n(p,I))throw new Error(`Extension '${p.identifier.value}' CANNOT use API proposal: ${I}.
Its package.json#enabledApiProposals-property declares: ${p.enabledApiProposals?.join(", ")??"[]"} but NOT ${I}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${p.identifier.value}`)}e.checkProposedApiEnabled=m;class r{constructor(I,l,M,o){this.codeLoadingTime=I,this.activateCallTime=l,this.activateResolvedTime=M,this.activationReason=o}}e.ActivationTimes=r;class g{constructor(I,l){this.description=I,this.value=l}}e.ExtensionPointContribution=g,e.ExtensionHostLogFileName="exthost";var d;(function(p){p[p.Normal=0]="Normal",p[p.Immediate=1]="Immediate"})(d=e.ActivationKind||(e.ActivationKind={}));function D(p){return{type:p.isBuiltin?0:1,isBuiltin:p.isBuiltin||p.isUserBuiltin,identifier:{id:(0,k.getGalleryExtensionId)(p.publisher,p.name),uuid:p.uuid},manifest:p,location:p.extensionLocation}}e.toExtension=D;function v(p,I){return{identifier:new T.ExtensionIdentifier(p.identifier.id),isBuiltin:p.type===0,isUserBuiltin:p.type===1&&p.isBuiltin,isUnderDevelopment:!!I,extensionLocation:p.location,...p.manifest,uuid:p.identifier.uuid}}e.toExtensionDescription=v;class f{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None}activateByEvent(I){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(I){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(I){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(I){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(I,l){return Promise.resolve()}_onWillActivateExtension(I){}_onDidActivateExtension(I,l,M,o,i){}_onDidActivateExtensionError(I,l){}_onExtensionRuntimeError(I,l){}_onExtensionHostExit(I){}}e.NullExtensionService=f}),define(Ee[174],ye([0,1,15,25,27,12]),function(ne,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const k=Promise.resolve(void 0);class P{constructor(g,d,D,v){this.startup=g,this.codeLoadingTime=d,this.activateCallTime=D,this.activateResolvedTime=v}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class C{constructor(g){this._startup=g,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(g,d){return g===-1||d===-1?-1:d-g}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class R{constructor(g,d,D,v,f,p){this.activationFailed=g,this.activationFailedError=d,this.activationTimes=D,this.module=v,this.exports=f,this.subscriptions=p}}e.ActivatedExtension=R;class F extends R{constructor(g){super(!1,null,g,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=F;class _ extends R{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=_;class n extends R{constructor(g){super(!0,g,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=n;let m=class{constructor(g,d,D,v,f){this._logService=f,this._isDisposed=!1,this._registry=g,this._resolvedExtensionsSet=new Set,d.forEach(p=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(p))),this._hostExtensionsMap=new Map,D.forEach(p=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(p),p)),this._host=v,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(g){const d=t.ExtensionIdentifier.toKey(g);return this._activatedExtensions.has(d)}getActivatedExtension(g){const d=t.ExtensionIdentifier.toKey(g),D=this._activatedExtensions.get(d);if(!D)throw new Error("Extension `"+g.value+"` is not known or not activated");return D}activateByEvent(g,d){if(this._alreadyActivatedEvents[g])return k;const D=this._registry.getExtensionDescriptionsForActivationEvent(g);return this._activateExtensions(D.map(v=>({id:v.identifier,reason:{startup:d,extensionId:v.identifier,activationEvent:g}}))).then(()=>{this._alreadyActivatedEvents[g]=!0})}activateById(g,d){const D=this._registry.getExtensionDescription(g);if(!D)throw new Error("Extension `"+g+"` is not known");return this._activateExtensions([{id:D.identifier,reason:d}])}_handleActivateRequest(g,d,D){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(g.id))){d[t.ExtensionIdentifier.toKey(g.id)]=g;return}const v=this._registry.getExtensionDescription(g.id);if(!v){const I=new Error(`Cannot activate unknown extension '${g.id.value}'`);this._host.onExtensionActivationError(g.id,I,new w.MissingExtensionDependency(g.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(g.id),new n(I));return}const f=typeof v.extensionDependencies=="undefined"?[]:v.extensionDependencies;let p=!0;for(let I=0,l=f.length;I<l;I++){const M=f[I];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(M)))continue;const o=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(M));if(o&&!o.activationFailed)continue;if(o&&o.activationFailed){const s=v.displayName||v.identifier.value,b=this._registry.getExtensionDescription(M),y=b&&b.displayName||M,c=new Error(`Cannot activate the '${s}' extension because its dependency '${y}' failed to activate`);c.detail=o.activationFailedError,this._host.onExtensionActivationError(v.identifier,c,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(v.identifier),new n(c));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(M))){p=!1,d[t.ExtensionIdentifier.toKey(M)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(M)),reason:g.reason};continue}const i=this._registry.getExtensionDescription(M);if(i){if(!i.main&&!i.browser)continue;p=!1,d[t.ExtensionIdentifier.toKey(M)]={id:i.identifier,reason:g.reason};continue}const h=v.displayName||v.identifier.value,u=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${M}'`);this._host.onExtensionActivationError(v.identifier,u,new w.MissingExtensionDependency(M)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(v.identifier),new n(u));return}p?d[t.ExtensionIdentifier.toKey(v.identifier)]=g:D.push(g)}_activateExtensions(g){if(g.length===0||(g=g.filter(f=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(f.id))),g.length===0))return Promise.resolve(void 0);const d=Object.create(null),D=[];for(let f=0,p=g.length;f<p;f++)this._handleActivateRequest(g[f],d,D);for(let f=0,p=D.length;f<p;f++){const I=t.ExtensionIdentifier.toKey(D[f].id);d[I]&&delete d[I]}const v=Object.keys(d).map(f=>d[f]);return D.length===0?Promise.all(v.map(f=>this._activateExtension(f.id,f.reason))).then(f=>{}):this._activateExtensions(v).then(f=>this._activateExtensions(D))}_activateExtension(g,d){const D=t.ExtensionIdentifier.toKey(g);if(this._activatedExtensions.has(D))return Promise.resolve(void 0);const v=this._activatingExtensions.get(D);if(v)return v;const f=this._host.actualActivateExtension(g,d).then(void 0,p=>{const I=new Error;return p&&p.name&&(I.name=p.name),p&&p.message?I.message=`Activating extension '${g.value}' failed: ${p.message}.`:I.message=`Activating extension '${g.value}' failed: ${p}.`,p&&p.stack&&(I.stack=p.stack),this._isDisposed&&a.isPromiseCanceledError(p)?new n(p):(this._host.onExtensionActivationError(g,I,null),this._logService.error(`Activating extension ${g.value} failed due to an error:`),this._logService.error(p),new n(p))}).then(p=>{this._activatedExtensions.set(D,p),this._activatingExtensions.delete(D)});return this._activatingExtensions.set(D,f),f}};m=Be([He(4,T.ILogService)],m),e.ExtensionsActivator=m}),define(Ee[175],ye([0,1,12,28,27]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends a.LogService{constructor(P,C){super(P.createLogger(C.logFile,{name:w.ExtensionHostLogFileName}))}};T=Be([He(0,a.ILoggerService),He(1,t.IExtHostInitDataService)],T),e.ExtHostLogService=T}),define(Ee[176],ye([0,1,15]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,k)=>{this._actualOk=T,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,a.onUnexpectedError)(T))}then(T,k){return this._ensureActual().then(T,k)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=t}),define(Ee[37],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(R,F){this._proxyIdentifierBrand=void 0,this.isMain=R,this.sid=F,this.nid=++a.count}}e.ProxyIdentifier=a,a.count=0;const t=[];function w(C){const R=new a(!0,C);return t[R.nid]=R,R}e.createMainContextProxyIdentifier=w;function T(C){const R=new a(!1,C);return t[R.nid]=R,R}e.createExtHostContextProxyIdentifier=T;function k(C){return t[C].sid}e.getStringIdentifierForProxy=k;class P{constructor(R){this.value=R}}e.SerializableObjectWithBuffers=P}),define(Ee[5],ye([0,1,54,2,37]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(f){f[f.Desktop=1]="Desktop",f[f.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var k;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var C;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(C=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var R;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(R=e.CellOutputKind||(e.CellOutputKind={}));var F;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(F=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(_=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(f){f.name="$ident";function p(l,M){return Object.defineProperty(l,f.name,{value:M,enumerable:!0}),l}f.mixin=p;function I(l){return l[f.name]}f.of=I})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(p){return p._id=m._n++,p}}e.IdObject=m,m._n=0;var r;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.command="m",f.kindModifier="n"})(r=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var d;(function(f){f[f.File=1]="File",f[f.Text=2]="Text",f[f.Cell=3]="Cell"})(d=e.WorkspaceEditType||(e.WorkspaceEditType={}));function D(f){if(f&&f.edits)for(const p of f.edits)typeof p.resource=="object"?p.resource=t.URI.revive(p.resource):(p.newUri=t.URI.revive(p.newUri),p.oldUri=t.URI.revive(p.oldUri)),p.metadata&&p.metadata.iconPath&&(p.metadata=(0,a.revive)(p.metadata));return f}e.reviveWorkspaceEditDto=D;var v;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,w.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,w.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,w.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,w.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,w.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,w.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,w.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,w.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,w.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,w.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,w.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,w.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,w.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(Ee[68],ye([0,1,5,4,3]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(P){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,C){return this._proxy.$getPassword(P,C)}store(P,C,R){return this._proxy.$setPassword(P,C,R)}delete(P,C){return this._proxy.$deletePassword(P,C)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,w.createDecorator)("IExtHostSecretState")}),define(Ee[69],ye([0,1,3,12,5,13]),function(ne,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let k=class{constructor(C,R){this._extHostLogService=R,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(w.MainContext.MainThreadTelemetry)}report(C,R,F){const _=this.getUsageKey(C,R);this._reportedUsages.has(_)||(this._reportedUsages.add(_),R.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${F}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:R.identifier.value,apiId:C}))}getUsageKey(C,R){return`${C}-${R.identifier.value}`}};k=Be([He(0,T.IExtHostRpcService),He(1,t.ILogService)],k),e.ExtHostApiDeprecationService=k,e.NullApiDeprecationService=Object.freeze(new class{report(P,C,R){}})}),define(Ee[177],ye([0,1,4,5,7,25]),function(ne,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class k{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new a.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,R,F,_={}){const n=T.ExtensionIdentifier.toKey(C.identifier),m=this._inFlightRequests.get(n)||[],r=[...F].sort().join(" ");let g=m.find(d=>d.scopes===r);if(g)return g.result;{const d=this._getSession(C,n,R,F,_);g={scopes:r,result:d},m.push(g),this._inFlightRequests.set(n,m);try{await d}finally{const D=m.findIndex(v=>v.scopes===r);D>-1&&(m.splice(D),this._inFlightRequests.set(n,m))}return d}}async _getSession(C,R,F,_,n={}){await this._proxy.$ensureProvider(F);const m=C.displayName||C.name;return this._proxy.$getSession(F,_,R,m,n)}async removeSession(C,R){const F=this._authenticationProviders.get(C);return F?F.provider.removeSession(R):this._proxy.$removeSession(C,R)}registerAuthenticationProvider(C,R,F,_){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:R,provider:F,options:_??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===C)||this._providers.push({id:C,label:R});const n=F.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(C,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,R,_?.supportsMultipleAccounts??!1),new w.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(C);const m=this._providers.findIndex(r=>r.id===C);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,R){const F=this._authenticationProviders.get(C);if(F)return Promise.resolve(F.provider.createSession(R));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,R){const F=this._authenticationProviders.get(C);if(F)return Promise.resolve(F.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,R){const F=this._authenticationProviders.get(C);if(F)return Promise.resolve(F.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,R){return this._onDidChangeSessions.fire({provider:{id:C,label:R}}),Promise.resolve()}}e.ExtHostAuthentication=k}),define(Ee[178],ye([0,1,5,13,8]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(P,C){this._extHostDocumentsAndEditors=C,this._proxy=P.getProxy(a.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const C=w.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(C)}};T=Be([He(0,t.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(Ee[179],ye([0,1,5]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(T){const k=T.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(P){return k.$writeText(P)}})}}e.ExtHostClipboard=t}),define(Ee[38],ye([0,1,11,7,8,26,5,16,12,54,59,227,2,6,3,13,47,22,37,43]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m,r,g,d,D,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let p=class{constructor(h,u){this._commands=new Map,this._apiCommands=new Map,this._proxy=h.getProxy(k.MainContext.MainThreadCommands),this._logService=u,this.converter=new I(this,s=>{const b=this._apiCommands.get(s);return b?.result===M.Void?b:void 0},u),this._argumentProcessors=[{processArgument(s){return(0,R.revive)(s)}},{processArgument(s){return(0,T.cloneAndChange)(s,function(b){if(F.Range.isIRange(b))return w.Range.to(b);if(_.Position.isIPosition(b))return w.Position.to(b);if(F.Range.isIRange(b.range)&&n.URI.isUri(b.uri))return w.location.to(b);if(b instanceof D.VSBuffer)return b.buffer.buffer;if(!Array.isArray(b))return b})}}]}registerArgumentProcessor(h){this._argumentProcessors.push(h)}registerApiCommand(h){const u=this.registerCommand(!1,h.id,async(...s)=>{const b=h.args.map((c,S)=>{if(!c.validate(s[S]))throw new Error(`Invalid argument '${c.name}' when running '${h.id}', received: ${s[S]}`);return c.convert(s[S])}),y=await this.executeCommand(h.internalId,...b);return h.result.convert(y,s,this.converter)},void 0,{description:h.description,args:h.args,returns:h.result.description});return this._apiCommands.set(h.id,h),new t.Disposable(()=>{u.dispose(),this._apiCommands.delete(h.id)})}registerCommand(h,u,s,b,y,c){if(this._logService.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this._commands.has(u))throw new Error(`command '${u}' already exists`);return this._commands.set(u,{callback:s,thisArg:b,description:y,extension:c}),h&&this._proxy.$registerCommand(u),new t.Disposable(()=>{this._commands.delete(u)&&h&&this._proxy.$unregisterCommand(u)})}executeCommand(h,...u){return this._logService.trace("ExtHostCommands#executeCommand",h),this._doExecuteCommand(h,u,!0)}async _doExecuteCommand(h,u,s){if(this._commands.has(h))return this._executeContributedCommand(h,u,!1);{let b=!1;const y=(0,T.cloneAndChange)(u,function(c){if(c instanceof t.Position)return w.Position.from(c);if(c instanceof t.Range)return w.Range.from(c);if(c instanceof t.Location)return w.location.from(c);if(t.NotebookRange.isNotebookRange(c))return w.NotebookRange.from(c);if(c instanceof ArrayBuffer)return b=!0,D.VSBuffer.wrap(new Uint8Array(c));if(c instanceof Uint8Array)return b=!0,D.VSBuffer.wrap(c);if(!Array.isArray(c))return c});try{const c=await this._proxy.$executeCommand(h,b?new v.SerializableObjectWithBuffers(y):y,s);return(0,R.revive)(c)}catch(c){if(c instanceof Error&&c.message==="$executeCommand:retry")return this._doExecuteCommand(h,u,!1);throw c}}}async _executeContributedCommand(h,u,s){const b=this._commands.get(h);if(!b)throw new Error("Unknown command");let{callback:y,thisArg:c,description:S}=b;if(S)for(let A=0;A<S.args.length;A++)try{(0,a.validateConstraint)(u[A],S.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${h}' failed. Illegal argument '${S.args[A].name}' - ${S.args[A].description}`)}try{return await y.apply(c,u)}catch(A){if(h===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...u);U&&(h=U.command)}throw this._logService.error(A,h,b.extension?.identifier),s?new class extends Error{constructor(){super((0,f.toErrorMessage)(A));this.id=h,this.source=b.extension?.displayName??b.extension?.name}}:A}}$executeContributedCommand(h,...u){return this._logService.trace("ExtHostCommands#$executeContributedCommand",h),this._commands.has(h)?(u=u.map(s=>this._argumentProcessors.reduce((b,y)=>y.processArgument(b),s)),this._executeContributedCommand(h,u,!0)):Promise.reject(new Error(`Contributed command '${h}' does not exist.`))}getCommands(h=!1){return this._logService.trace("ExtHostCommands#getCommands",h),this._proxy.$getCommands().then(u=>(h&&(u=u.filter(s=>s[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const h=Object.create(null);for(let[u,s]of this._commands){let{description:b}=s;b&&(h[u]=b)}return Promise.resolve(h)}};p=Be([He(0,g.IExtHostRpcService),He(1,C.ILogService)],p),e.ExtHostCommands=p,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class I{constructor(h,u,s){this._commands=h,this._lookupApiCommand=u,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(h,u){if(!h)return;const s={$ident:void 0,id:h.command,title:h.title,tooltip:h.tooltip};if(!h.command)return s;const b=this._lookupApiCommand(h.command);if(b)s.id=b.internalId,s.arguments=b.args.map((y,c)=>y.convert(h.arguments&&h.arguments[c]));else if((0,P.isNonEmptyArray)(h.arguments)){const y=++this._cachIdPool;this._cache.set(y,h),u.add((0,m.toDisposable)(()=>{this._cache.delete(y),this._logService.trace("CommandsConverter#DISPOSE",y)})),s.$ident=y,s.id=this.delegatingCommandId,s.arguments=[y],this._logService.trace("CommandsConverter#CREATE",h.command,y)}return s}fromInternal(h){const u=k.ObjectIdentifier.of(h);return typeof u=="number"?this._cache.get(u):{command:h.id,title:h.title,arguments:h.arguments}}getActualCommand(...h){return this._cache.get(h[0])}_executeConvertedCommand(...h){const u=this.getActualCommand(...h);return this._logService.trace("CommandsConverter#EXECUTE",h[0],u?u.command:"MISSING"),u?this._commands.executeCommand(u.command,...u.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=I;class l{constructor(h,u,s,b){this.name=h,this.description=u,this.validate=s,this.convert=b}optional(){return new l(this.name,`(optional) ${this.description}`,h=>h==null||this.validate(h),h=>h===void 0?void 0:h===null?null:this.convert(h))}with(h,u){return new l(h??this.name,u??this.description,this.validate,this.convert)}}e.ApiCommandArgument=l,l.Uri=new l("uri","Uri of a text document",i=>n.URI.isUri(i),i=>i),l.Position=new l("position","A position in a text document",i=>t.Position.isPosition(i),w.Position.from),l.Range=new l("range","A range in a text document",i=>t.Range.isRange(i),w.Range.from),l.Selection=new l("selection","A selection in a text document",i=>t.Selection.isSelection(i),w.Selection.from),l.Number=new l("number","",i=>typeof i=="number",i=>i),l.String=new l("string","",i=>typeof i=="string",i=>i),l.CallHierarchyItem=new l("item","A call hierarchy item",i=>i instanceof t.CallHierarchyItem,w.CallHierarchyItem.from),l.TypeHierarchyItem=new l("item","A type hierarchy item",i=>i instanceof t.TypeHierarchyItem,w.TypeHierarchyItem.from),l.TestItem=new l("testItem","A VS Code TestItem",i=>i instanceof d.TestItemImpl,w.TestItem.from);class M{constructor(h,u){this.description=h,this.convert=u}}e.ApiCommandResult=M,M.Void=new M("no result",i=>i);class o{constructor(h,u,s,b,y){this.id=h,this.internalId=u,this.description=s,this.args=b,this.result=y}}e.ApiCommand=o}),define(Ee[180],ye([0,1,8,7,58,38,16,79]),function(ne,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new T.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",F(a.DocumentHighlight.to))),new T.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,m)=>{if((0,k.isFalsyOrEmpty)(n))return;class r extends t.SymbolInformation{static to(d){const D=new r(d.name,a.SymbolKind.to(d.kind),d.containerName||"",new t.Location(m[0],a.Range.to(d.range)));return D.detail=d.detail,D.range=D.location.range,D.selectionRange=a.Range.to(d.selectionRange),D.children=d.children?d.children.map(r.to):[],D}}return n.map(r.to)})),new T.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(a.TextEdit.to))),new T.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range,new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(a.TextEdit.to))),new T.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,new T.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(a.TextEdit.to))),new T.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location-instances.",F(a.location.to))),new T.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Hover-instances.",F(a.Hover.to))),new T.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(m=>t.Position.isPosition(m)),n=>n.map(a.Position.from))],new T.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(m=>{let r;for(const g of m.reverse())r=new t.SelectionRange(a.Range.to(g),r);return r}))),new T.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[T.ApiCommandArgument.String.with("query","Search string")],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(a.WorkspaceSymbol.to))),new T.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(a.CallHierarchyItem.to))),new T.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(a.CallHierarchyIncomingCall.to))),new T.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(a.CallHierarchyOutgoingCall.to))),new T.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:a.Range.to(n.range),placeholder:n.text}})),new T.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("newName","The new symbol name")],new T.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return a.WorkspaceEdit.to(n)}})),new T.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new T.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(a.DocumentLink.to))),new T.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new t.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const m=(0,P.decodeSemanticTokensDto)(n);if(m.type==="full")return new t.SemanticTokens(m.data,void 0)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range.optional()],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new t.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const m=(0,P.decodeSemanticTokensDto)(n);if(m.type==="full")return new t.SemanticTokens(m.data,void 0)})),new T.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new T.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,m,r)=>{if(!n)return new t.CompletionList([]);const g=n.suggestions.map(d=>a.CompletionItem.to(d,r));return new t.CompletionList(g,n.incomplete)})),new T.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new T.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return a.SignatureHelp.to(n)})),new T.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new T.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,m,r)=>F(g=>new t.CodeLens(a.Range.to(g.range),g.command&&r.fromInternal(g.command)))(n))),new T.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>t.Range.isRange(n),n=>t.Selection.isSelection(n)?a.Selection.from(n):a.Range.from(n)),T.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new T.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,m,r)=>F(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(g.command)}else{const d=new t.CodeAction(g.title,g.kind?new t.CodeActionKind(g.kind):void 0);return g.edit&&(d.edit=a.WorkspaceEdit.to(g.edit)),g.command&&(d.command=r.fromInternal(g.command)),d.isPreferred=g.isPreferred,d}})(n))),new T.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(m=>new t.ColorInformation(a.Range.to(m.range),a.Color.to(m.color))):[])),new T.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new T.ApiCommandArgument("color","The color to show and insert",n=>n instanceof t.Color,a.Color.from),new T.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:a.Range.from(n.range)}))],new T.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(a.ColorPresentation.to):[])),new T.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(a.InlayHint.to))),new T.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new T.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",F(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(m=>a.NotebookExclusiveDocumentPattern.to(m))})))),new T.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(a.InlineValue.to))),new T.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional(),T.ApiCommandArgument.String.with("label","").optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[T.ApiCommandArgument.Uri.with("resource","Resource to open"),T.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[T.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),T.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),T.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)]).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(a.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(a.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(a.TypeHierarchyItem.to))),new T.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[T.ApiCommandArgument.TestItem],T.ApiCommandResult.Void)];class R{static register(m){C.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=R;function F(n){return m=>{if(Array.isArray(m))return m.map(n)}}function _(n){if(!Array.isArray(n))return;const m=[];for(const r of n)w.isLocationLink(r)?m.push(a.DefinitionLink.to(r)):m.push(a.location.to(r));return m}}),define(Ee[181],ye([0,1,14,52,4,6,2,58,25,8,7,5]),function(ne,e,a,t,w,T,k,P,C,R,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(m,r,g){const d=m.getProxy(_.MainContext.MainThreadComments);class D{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,r.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const h=this._commentControllers.get(i.handle);return h||i}else if(i&&i.$mid===7){const h=this._commentControllers.get(i.commentControlHandle);if(!h)return i;const u=h.getCommentThread(i.commentThreadHandle);return u||i}else if(i&&i.$mid===8){const h=this._commentControllers.get(i.thread.commentControlHandle);if(!h)return i;const u=h.getCommentThread(i.thread.commentThreadHandle);return u?{thread:u,text:i.text}:i}else if(i&&i.$mid===9){const h=this._commentControllers.get(i.thread.commentControlHandle);if(!h)return i;const u=h.getCommentThread(i.thread.commentThreadHandle);if(!u)return i;let s=i.commentUniqueId,b=u.getCommentByUniqueId(s);return b||i}else if(i&&i.$mid===10){const h=this._commentControllers.get(i.thread.commentControlHandle);if(!h)return i;const u=h.getCommentThread(i.thread.commentThreadHandle);if(!u)return i;let s=i.text,b=i.commentUniqueId,y=u.getCommentByUniqueId(b);return y?(y.body=s,y):i}return i}})}createCommentController(i,h,u){const s=D.handlePool++,b=new f(i,s,h,u);this._commentControllers.set(b.handle,b);const y=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(i.identifier))||[];return y.push(b),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(i.identifier),y),b.value}$createCommentThreadTemplate(i,h,u){const s=this._commentControllers.get(i);!s||s.$createCommentThreadTemplate(h,u)}async $updateCommentThreadTemplate(i,h,u){const s=this._commentControllers.get(i);!s||s.$updateCommentThreadTemplate(h,u)}$deleteCommentThread(i,h){const u=this._commentControllers.get(i);u&&u.$deleteCommentThread(h)}$provideCommentingRanges(i,h,u){const s=this._commentControllers.get(i);if(!s||!s.commentingRangeProvider)return Promise.resolve(void 0);const b=g.getDocument(k.URI.revive(h));return(0,a.asPromise)(()=>s.commentingRangeProvider.provideCommentingRanges(b,u)).then(y=>y?y.map(c=>R.Range.from(c)):void 0)}$toggleReaction(i,h,u,s,b){const y=this._commentControllers.get(i);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const c=y.getCommentThread(h);if(c){const S=c.getCommentByUniqueId(s.uniqueIdInThread);if(y!==void 0&&S&&y.reactionHandler)return y.reactionHandler(S,l(b))}return Promise.resolve(void 0)})}dispose(){}}D.handlePool=0;class v{constructor(i,h,u,s,b,y,c){this._commentControllerHandle=h,this._id=u,this._uri=s,this._range=b,this._comments=y,this.handle=v._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new w.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),d.$createCommentThread(h,this.handle,this._id,this._uri,R.Range.from(this._range),c),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this._localDisposables.push({dispose:()=>{d.$deleteCommentThread(h,this.handle)}});const S=this;this.value={get uri(){return S.uri},get range(){return S.range},set range(A){S.range=A},get comments(){return S.comments},set comments(A){S.comments=A},get collapsibleState(){return S.collapsibleState},set collapsibleState(A){S.collapsibleState=A},get canReply(){return S.canReply},set canReply(A){S.canReply=A},get contextValue(){return S.contextValue},set contextValue(A){S.contextValue=A},get label(){return S.label},set label(A){S.label=A},dispose:()=>{S.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const i=u=>Object.prototype.hasOwnProperty.call(this.modifications,u),h={};i("range")&&(h.range=R.Range.from(this._range)),i("label")&&(h.label=this.label),i("contextValue")&&(h.contextValue=this.contextValue??null),i("comments")&&(h.comments=this._comments.map(u=>p(this,u,this._commentsMap))),i("collapsibleState")&&(h.collapseState=M(this._collapseState)),i("canReply")&&(h.canReply=this.canReply),this.modifications={},d.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,h)}getCommentByUniqueId(i){for(let h of this._commentsMap){let u=h[0],s=h[1];if(i===s)return u}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}v._handlePool=0,Be([(0,t.debounce)(100)],v.prototype,"eventuallyUpdateCommentThread",null);class f{constructor(i,h,u,s){this._extension=i,this._handle=h,this._id=u,this._label=s,this._threads=new Map,d.$registerCommentController(this.handle,u,s);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(y){b.options=y},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(y){b.commentingRangeProvider=y},get reactionHandler(){return b.reactionHandler},set reactionHandler(y){b.reactionHandler=y},createCommentThread(y,c,S){return b.createCommentThread(y,c,S).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,d.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,h,u,s){if(typeof i=="string"){const b=new v(this.id,this.handle,i,h,u,s,this._extension.identifier);return this._threads.set(b.handle,b),b}else{const b=new v(this.id,this.handle,void 0,i,h,u,this._extension.identifier);return this._threads.set(b.handle,b),b}}$createCommentThreadTemplate(i,h){const u=new v(this.id,this.handle,void 0,k.URI.revive(i),R.Range.to(h),[],this._extension.identifier);return u.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(u.handle,u),u}$updateCommentThreadTemplate(i,h){let u=this._threads.get(i);u&&(u.range=R.Range.to(h))}$deleteCommentThread(i){let h=this._threads.get(i);h&&h.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function p(o,i,h){let u=h.get(i);u||(u=++o.commentHandle,h.set(i,u));const s=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:u,body:R.MarkdownString.from(i.body),userName:i.author.name,userIconPath:s,label:i.label,commentReactions:i.reactions?i.reactions.map(b=>I(b)):void 0}}function I(o){return{label:o.label,iconPath:o.iconPath?R.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function l(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?k.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function M(o){if(o!==void 0)switch(o){case F.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}return new D}e.createExtHostComments=n}),define(Ee[93],ye([0,1,2,5,7,3,13,12,16,9,17]),function(ne,e,a,t,w,T,k,P,C,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class wi{constructor(m,r){this._logService=r,this._provider=new Map,this._proxy=m.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,r){const g=wi._handlePool++;this._provider.set(g,{provider:m,extensionId:r}),this._proxy.$registerDecorationProvider(g,r.value);const d=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(D=>{if(!D){this._proxy.$onDidChange(g,null);return}let v=(0,C.asArray)(D);if(v.length<=wi._maxEventSize){this._proxy.$onDidChange(g,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,v.length);const f=v.map(l=>({uri:l,rank:(0,R.count)(l.path,"/")})),p=(0,C.groupBy)(f,(l,M)=>l.rank-M.rank||(0,R.compare)(l.uri.path,M.uri.path));let I=[];e:for(let l of p){let M;for(let o of l){let i=(0,F.dirname)(o.uri.path);if(M!==i&&(M=i,I.push(o.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(g,I)});return new w.Disposable(()=>{d?.dispose(),this._proxy.$unregisterDecorationProvider(g),this._provider.delete(g)})}async $provideDecorations(m,r,g){if(!this._provider.has(m))return Object.create(null);const d=Object.create(null),{provider:D,extensionId:v}=this._provider.get(m);return await Promise.all(r.map(async f=>{try{const{uri:p,id:I}=f,l=await Promise.resolve(D.provideFileDecoration(a.URI.revive(p),g));if(!l)return;try{w.FileDecoration.validate(l),d[I]=[l.propagate,l.tooltip,l.badge,l.color]}catch(M){this._logService.warn(`INVALID decoration from extension '${v.value}': ${M}`)}}catch(p){this._logService.error(p)}})),d}};_._handlePool=0,_._maxEventSize=250,_=Be([He(0,k.IExtHostRpcService),He(1,P.ILogService)],_),e.ExtHostDecorations=_,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(ne,a):w?w.value=a:e.set(ne,a),a},Re=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Ee[182],ye([0,1,119,82,2,5,7,8,4,12,21,30]),function(ne,e,a,t,w,T,k,P,C,R,F,_){"use strict";var n,m,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class g{constructor(v,f,p,I,l,M){this._name=v,this._owner=f,this._maxDiagnosticsPerFile=p,n.set(this,void 0),m.set(this,void 0),r.set(this,void 0),this._isDisposed=!1,Ze(this,r,new F.ResourceMap(o=>I.getComparisonKey(o)),"f"),Ze(this,n,l,"f"),Ze(this,m,M,"f")}dispose(){this._isDisposed||(Re(this,m,"f").fire([...Re(this,r,"f").keys()]),Re(this,n,"f")&&Re(this,n,"f").$clear(this._owner),Re(this,r,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,f){if(!v){this.clear();return}this._checkDisposed();let p=[];if(w.URI.isUri(v)){if(!f){this.delete(v);return}Re(this,r,"f").set(v,f.slice()),p=[v]}else if(Array.isArray(v)){p=[];let l;v=[...v].sort(g._compareIndexedTuplesByUri);for(const M of v){const[o,i]=M;if((!l||o.toString()!==l.toString())&&(l&&Re(this,r,"f").get(l).length===0&&Re(this,r,"f").delete(l),l=o,p.push(o),Re(this,r,"f").set(o,[])),i){const h=Re(this,r,"f").get(o);h&&h.push(...i)}else{const h=Re(this,r,"f").get(o);h&&(h.length=0)}}}if(Re(this,m,"f").fire(p),!Re(this,n,"f"))return;const I=[];for(let l of p){let M=[];const o=Re(this,r,"f").get(l);if(o)if(o.length>this._maxDiagnosticsPerFile){M=[];const i=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(let u of o)if(u.severity===i[h]&&M.push(P.Diagnostic.from(u))===this._maxDiagnosticsPerFile)break e;M.push({severity:t.MarkerSeverity.Info,message:(0,a.localize)(0,null,o.length-this._maxDiagnosticsPerFile),startLineNumber:M[M.length-1].startLineNumber,startColumn:M[M.length-1].startColumn,endLineNumber:M[M.length-1].endLineNumber,endColumn:M[M.length-1].endColumn})}else M=o.map(i=>P.Diagnostic.from(i));I.push([l,M])}Re(this,n,"f").$changeMany(this._owner,I)}delete(v){this._checkDisposed(),Re(this,m,"f").fire([v]),Re(this,r,"f").delete(v),Re(this,n,"f")&&Re(this,n,"f").$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Re(this,m,"f").fire([...Re(this,r,"f").keys()]),Re(this,r,"f").clear(),Re(this,n,"f")&&Re(this,n,"f").$clear(this._owner)}forEach(v,f){this._checkDisposed();for(let p of Re(this,r,"f").keys())v.apply(f,[p,this.get(p),this])}get(v){this._checkDisposed();const f=Re(this,r,"f").get(v);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Re(this,r,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,f){return v[0].toString()<f[0].toString()?-1:v[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=g,n=new WeakMap,m=new WeakMap,r=new WeakMap;let d=class ri{constructor(v,f,p){this._logService=f,this._fileSystemInfoService=p,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:I=>I.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,ri._mapper),this._proxy=v.getProxy(T.MainContext.MainThreadDiagnostics)}static _mapper(v){const f=new F.ResourceMap;for(const p of v)f.set(p,p);return{uris:Object.freeze(Array.from(f.values()))}}createDiagnosticCollection(v,f){const{_collections:p,_proxy:I,_onDidChangeDiagnostics:l,_logService:M,_fileSystemInfoService:o}=this,i=new class{$changeMany(s,b){I.$changeMany(s,b),M.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,s,b.length===0?"CLEARING":b)}$clear(s){I.$clear(s),M.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,s)}dispose(){I.dispose()}};let h;if(!f)f="_generated_diagnostic_collection_name_#"+ri._idPool++,h=f;else if(!p.has(f))h=f;else{this._logService.warn(`DiagnosticCollection with name '${f}' does already exist.`);do h=f+ri._idPool++;while(p.has(h))}return new class extends g{constructor(){super(f,h,ri._maxDiagnosticsPerFile,o.extUri,i,l);p.set(h,this)}dispose(){super.dispose(),p.delete(h)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const f=new Map,p=[];for(const I of this._collections.values())I.forEach((l,M)=>{let o=f.get(l.toString());typeof o=="undefined"&&(o=p.length,f.set(l.toString(),o),p.push([l,[]])),p[o][1]=p[o][1].concat(...M)});return p}}_getDiagnostics(v){let f=[];for(let p of this._collections.values())p.has(v)&&(f=f.concat(p.get(v)));return f}$acceptMarkersChange(v){if(!this._mirrorCollection){const f="_generated_mirror",p=new g(f,f,ri._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(f,p),this._mirrorCollection=p}for(const[f,p]of v)this._mirrorCollection.set(w.URI.revive(f),p.map(P.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=Be([He(1,R.ILogService),He(2,_.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(Ee[183],ye([0,1,2,5]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class w{constructor(k){this._proxy=k.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(k){return this._proxy.$showOpenDialog(k).then(P=>P?P.map(C=>a.URI.revive(C)):void 0)}showSaveDialog(k){return this._proxy.$showSaveDialog(k).then(P=>P?a.URI.revive(P):void 0)}}e.ExtHostDialogs=w}),define(Ee[184],ye([0,1,15,2,7,5,10,20,9]),function(ne,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class R{constructor(_,n,m){this._documentsAndEditors=n,this._logService=m,this._documentContentProviders=new Map,this._proxy=_.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,n){if(Object.keys(k.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const m=R._handlePool++;this._documentContentProviders.set(m,n),this._proxy.$registerTextContentProvider(m,_);let r;return typeof n.onDidChange=="function"&&(r=n.onDidChange(g=>{if(g.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(g)&&this.$provideTextDocumentContent(m,g).then(d=>{if(!d&&typeof d!="string")return;const D=this._documentsAndEditors.getDocument(g);if(!D)return;const v=(0,C.splitLines)(d);if(!D.equalLines(v))return this._proxy.$onVirtualDocumentChange(g,d)},a.onUnexpectedError)})),new w.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(_,n){const m=this._documentContentProviders.get(_);return m?Promise.resolve(m.provideTextDocumentContent(t.URI.revive(n),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=R,R._handlePool=0}),define(Ee[185],ye([0,1,4,6,2,5,86,8,11,26,7]),function(ne,e,a,t,w,T,k,P,C,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class _{constructor(m,r){this._onDidAddDocument=new a.Emitter,this._onDidRemoveDocument=new a.Emitter,this._onDidChangeDocument=new a.Emitter,this._onDidSaveDocument=new a.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=r,this._documentsAndEditors.onDidRemoveDocuments(g=>{for(const d of g)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(g=>{for(const d of g)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const r=this._documentsAndEditors.getDocument(m);if(r)return r}getDocument(m){const r=this.getDocumentData(m);if(!r?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return r.document}ensureDocumentData(m){const r=this._documentsAndEditors.getDocument(m);if(r)return Promise.resolve(r);let g=this._documentLoader.get(m.toString());return g||(g=this._proxy.$tryOpenDocument(m).then(d=>{this._documentLoader.delete(m.toString());const D=w.URI.revive(d);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(D))},d=>(this._documentLoader.delete(m.toString()),Promise.reject(d))),this._documentLoader.set(m.toString(),g)),g}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(r=>w.URI.revive(r))}$acceptModelModeChanged(m,r){const g=w.URI.revive(m),d=this._documentsAndEditors.getDocument(g);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(r),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(m){const r=w.URI.revive(m),g=this._documentsAndEditors.getDocument(r);if(!g)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(g.document)}$acceptDirtyStateChanged(m,r){const g=w.URI.revive(m),d=this._documentsAndEditors.getDocument(g);if(!d)throw new Error("unknown document");d._acceptIsDirty(r),this._onDidChangeDocument.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,r,g){const d=w.URI.revive(m),D=this._documentsAndEditors.getDocument(d);if(!D)throw new Error("unknown document");D._acceptIsDirty(g),D.onEvents(r);let v;r.isUndoing?v=F.TextDocumentChangeReason.Undo:r.isRedoing&&(v=F.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,R.deepFreeze)({document:D.document,contentChanges:r.changes.map(f=>({range:P.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text})),reason:v}))}setWordDefinitionFor(m,r){(0,k.setWordDefinitionFor)(m,r)}}e.ExtHostDocuments=_}),define(Ee[48],ye([0,1,41,4,6,2,3,5,86,13,92,8,12,21,10,158,101]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m,r,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class D{constructor(p){this.value=p,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let v=class{constructor(p,I){this._extHostRpc=p,this._logService=I,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(p){this.acceptDocumentsAndEditorsDelta(p)}acceptDocumentsAndEditorsDelta(p){const I=[],l=[],M=[];if(p.removedDocuments)for(const o of p.removedDocuments){const i=T.URI.revive(o),h=this._documents.get(i);h?.unref()&&(this._documents.delete(i),I.push(h.value))}if(p.addedDocuments)for(const o of p.addedDocuments){const i=T.URI.revive(o.uri);let h=this._documents.get(i);if(h&&i.scheme!==r.Schemas.vscodeNotebookCell&&i.scheme!==r.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);h||(h=new D(new C.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),i,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this._documents.set(i,h),l.push(h.value)),h.ref()}if(p.removedEditors)for(const o of p.removedEditors){const i=this._editors.get(o);this._editors.delete(o),i&&M.push(i)}if(p.addedEditors)for(const o of p.addedEditors){const i=T.URI.revive(o.documentUri);a.ok(this._documents.has(i),`document '${i}' does not exist`),a.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const h=this._documents.get(i).value,u=new F.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new d.Lazy(()=>h.document),o.selections.map(_.Selection.to),o.options,o.visibleRanges.map(s=>_.Range.to(s)),typeof o.editorPosition=="number"?_.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,u)}p.newActiveEditor!==void 0&&(a.ok(p.newActiveEditor===null||this._editors.has(p.newActiveEditor),`active editor '${p.newActiveEditor}' does not exist`),this._activeEditorId=p.newActiveEditor),(0,w.dispose)(I),(0,w.dispose)(M),p.removedDocuments&&this._onDidRemoveDocuments.fire(I),p.addedDocuments&&this._onDidAddDocuments.fire(l),(p.removedEditors||p.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),p.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(p){return this._documents.get(p)?.value}allDocuments(){return g.Iterable.map(this._documents.values(),p=>p.value)}getEditor(p){return this._editors.get(p)}activeEditor(p){if(!this._activeEditorId)return;const I=this._editors.get(this._activeEditorId);return p?I:I?.value}allEditors(){return[...this._editors.values()]}};v=Be([He(0,R.IExtHostRpcService),He(1,n.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,k.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ee[70],ye([0,1,8,5,2,4,3,13,14]),function(ne,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,k.createDecorator)("IExtHostEditorTabs");let R=class{constructor(_){this._onDidChangeTabs=new T.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new T.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=_.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(_){let n=-1;this._tabs=_.map((r,g)=>(r.isActive&&(n=g),Object.freeze({label:r.label,viewColumn:a.ViewColumn.to(r.viewColumn),index:g,resource:w.URI.revive(r.resource),additionalResourcesAndViewIds:r.additionalResourcesAndViewIds.map(({resource:d,viewId:D})=>({resource:w.URI.revive(d),viewId:D})),viewId:r.editorId,isActive:r.isActive,move:async(d,D)=>{this._proxy.$moveTab(r,d,a.ViewColumn.from(D)),await(0,C.raceTimeout)(T.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(r),await(0,C.raceTimeout)(T.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((r,g)=>r.viewColumn===g.viewColumn?r.index-g.index:r.viewColumn-g.viewColumn);const m=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==m&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};R=Be([He(0,P.IExtHostRpcService)],R),e.ExtHostEditorTabs=R}),define(Ee[186],ye([0,1,2,5,6,7,8,228,9,22,27]),function(ne,e,a,t,w,T,k,P,C,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class _{constructor(){this._schemes=[]}add(r){this._stateMachine=void 0,this._schemes.push(r)}delete(r){const g=this._schemes.indexOf(r);g>=0&&(this._schemes.splice(g,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const r=this._schemes.sort(),g=[];let d,D,v=14,f=14;for(const p of r){let I=d?(0,C.commonPrefixLength)(d,p):0;for(I===0?D=1:D=f;I<p.length;I++)I+1===p.length?(v=f,f=9):f+=1,g.push([D,p.toUpperCase().charCodeAt(I),f]),g.push([D,p.toLowerCase().charCodeAt(I),f]),D=f;d=p,f=v}g.push([9,58,10]),g.push([10,47,12]),this._stateMachine=new P.StateMachine(g)}}provideDocumentLinks(r){this._initStateMachine();const g=[],d=P.LinkComputer.computeLinks({getLineContent(D){return r.lineAt(D-1).text},getLineCount(){return r.lineCount}},this._stateMachine);for(const D of d){const v=k.DocumentLink.to(D);v.target&&g.push(v)}return g}}class n{constructor(r,g){this._extHostLanguageFeatures=g,this._linkProvider=new _,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=r.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(r,g,d,D={}){if(this._registeredSchemes.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const v=this._handlePool++;this._linkProvider.add(g),this._registeredSchemes.add(g),this._fsProvider.set(v,d);let f=2;D.isCaseSensitive&&(f+=1024),D.isReadonly&&(f+=2048),typeof d.copy=="function"&&(f+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,F.checkProposedApiEnabled)(r,"fsChunks"),f+=4),this._proxy.$registerFileSystemProvider(v,g,f).catch(I=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${g}`),console.error(I)});const p=d.onDidChangeFile(I=>{const l=[];for(const M of I){let{uri:o,type:i}=M;if(o.scheme!==g)continue;let h;switch(i){case T.FileChangeType.Changed:h=0;break;case T.FileChangeType.Created:h=1;break;case T.FileChangeType.Deleted:h=2;break;default:throw new Error("Unknown FileChangeType")}l.push({resource:o,type:h})}this._proxy.$onFileSystemChange(v,l)});return(0,w.toDisposable)(()=>{p.dispose(),this._linkProvider.delete(g),this._registeredSchemes.delete(g),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(r){const{type:g,ctime:d,mtime:D,size:v,permissions:f}=r;return{type:g,ctime:d,mtime:D,size:v,permissions:f}}$stat(r,g){return Promise.resolve(this._getFsProvider(r).stat(a.URI.revive(g))).then(d=>n._asIStat(d))}$readdir(r,g){return Promise.resolve(this._getFsProvider(r).readDirectory(a.URI.revive(g)))}$readFile(r,g){return Promise.resolve(this._getFsProvider(r).readFile(a.URI.revive(g))).then(d=>R.VSBuffer.wrap(d))}$writeFile(r,g,d,D){return Promise.resolve(this._getFsProvider(r).writeFile(a.URI.revive(g),d.buffer,D))}$delete(r,g,d){return Promise.resolve(this._getFsProvider(r).delete(a.URI.revive(g),d))}$rename(r,g,d,D){return Promise.resolve(this._getFsProvider(r).rename(a.URI.revive(g),a.URI.revive(d),D))}$copy(r,g,d,D){const v=this._getFsProvider(r);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(a.URI.revive(g),a.URI.revive(d),D))}$mkdir(r,g){return Promise.resolve(this._getFsProvider(r).createDirectory(a.URI.revive(g)))}$watch(r,g,d,D){const v=this._getFsProvider(r).watch(a.URI.revive(d),D);this._watches.set(g,v)}$unwatch(r,g){const d=this._watches.get(g);d&&(d.dispose(),this._watches.delete(g))}$open(r,g,d){const D=this._getFsProvider(r);if(!D.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(D.open(a.URI.revive(g),d))}$close(r,g){const d=this._getFsProvider(r);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(g))}$read(r,g,d,D){const v=this._getFsProvider(r);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const f=R.VSBuffer.alloc(D);return Promise.resolve(v.read(g,d,f.buffer,0,D)).then(p=>f.slice(0,p))}$write(r,g,d,D){const v=this._getFsProvider(r);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(g,d,D.buffer,0,D.byteLength))}_getFsProvider(r){const g=this._fsProvider.get(r);if(!g){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return g}}e.ExtHostFileSystem=n}),define(Ee[49],ye([0,1,5,45,7,22,3,13,30,6]),function(ne,e,a,t,w,T,k,P,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let F=class Wt{constructor(n,m){this._fileSystemProvider=new Map,this._proxy=n.getProxy(a.MainContext.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(g){try{const d=r._fileSystemProvider.get(g.scheme);if(!d)return await r._proxy.$stat(g);await r._proxy.$ensureActivation(g.scheme);const D=await d.stat(g);return{type:D.type,ctime:D.ctime,mtime:D.mtime,size:D.size,permissions:D.permissions}}catch(d){Wt._handleError(d)}},async readDirectory(g){try{const d=r._fileSystemProvider.get(g.scheme);return d?(await r._proxy.$ensureActivation(g.scheme),(await d.readDirectory(g)).slice()):await r._proxy.$readdir(g)}catch(d){return Wt._handleError(d)}},async createDirectory(g){try{return await r._proxy.$mkdir(g)}catch(d){return Wt._handleError(d)}},async readFile(g){try{const d=r._fileSystemProvider.get(g.scheme);return d?(await r._proxy.$ensureActivation(g.scheme),(await d.readFile(g)).slice()):(await r._proxy.$readFile(g)).buffer}catch(d){return Wt._handleError(d)}},async writeFile(g,d){try{return await r._proxy.$writeFile(g,T.VSBuffer.wrap(d))}catch(D){return Wt._handleError(D)}},async delete(g,d){try{const D=r._fileSystemProvider.get(g.scheme);return D?(await r._proxy.$ensureActivation(g.scheme),await D.delete(g,{recursive:!1,...d})):await r._proxy.$delete(g,{recursive:!1,useTrash:!1,...d})}catch(D){return Wt._handleError(D)}},async rename(g,d,D){try{return await r._proxy.$rename(g,d,{overwrite:!1,...D})}catch(v){return Wt._handleError(v)}},async copy(g,d,D){try{return await r._proxy.$copy(g,d,{overwrite:!1,...D})}catch(v){return Wt._handleError(v)}},isWritableFileSystem(g){const d=m.getCapabilities(g);if(typeof d=="number")return!(d&2048)}})}static _handleError(n){if(n instanceof w.FileSystemError)throw n;if(!(n instanceof Error))throw new w.FileSystemError(String(n));if(n.name==="ENOPRO")throw w.FileSystemError.Unavailable(n.message);switch(n.name){case t.FileSystemProviderErrorCode.FileExists:throw w.FileSystemError.FileExists(n.message);case t.FileSystemProviderErrorCode.FileNotFound:throw w.FileSystemError.FileNotFound(n.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw w.FileSystemError.FileNotADirectory(n.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw w.FileSystemError.FileIsADirectory(n.message);case t.FileSystemProviderErrorCode.NoPermissions:throw w.FileSystemError.NoPermissions(n.message);case t.FileSystemProviderErrorCode.Unavailable:throw w.FileSystemError.Unavailable(n.message);default:throw new w.FileSystemError(n.message,n.name)}}addFileSystemProvider(n,m){return this._fileSystemProvider.set(n,m),(0,R.toDisposable)(()=>this._fileSystemProvider.delete(n))}};F=Be([He(0,P.IExtHostRpcService),He(1,C.IExtHostFileSystemInfo)],F),e.ExtHostConsumerFileSystem=F,e.IExtHostConsumerFileSystem=(0,k.createDecorator)("IExtHostConsumerFileSystem")}),define(Ee[187],ye([0,1,2,38]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class w{constructor(k,P,C,R){this._extHostNotebooks=P,this._textDocumentsAndEditors=C,this._commands=R;const F=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new t.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new t.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new t.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new t.ApiCommandResult("Notebook and input URI",_=>{if(_.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(_.notebookEditorId);return{notebookUri:a.URI.revive(_.notebookUri),inputUri:a.URI.revive(_.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:a.URI.revive(_.notebookUri),inputUri:a.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(F)}$willAddInteractiveDocument(k,P,C,R){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:C,uri:k,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(a.URI.revive(R))?.apiNotebook}]})}$willRemoveInteractiveDocument(k,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[k]})}}e.ExtHostInteractive=w}),define(Ee[188],ye([0,1,6,5]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class w{constructor(k){this._handlePool=0,this._proxy=k.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,k),(0,a.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=w}),define(Ee[189],ye([0,1,2,26,8,7,5,9,59,16,11,229,6,79,53,63,190,15,4]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m,r,g,d,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class f{constructor(B,G){this._documents=B,this._provider=G}async provideDocumentSymbols(B,G){const X=this._documents.getDocument(B),se=await this._provider.provideDocumentSymbols(X,G);if(!(0,R.isFalsyOrEmpty)(se))return se[0]instanceof T.DocumentSymbol?se.map(w.DocumentSymbol.from):f._asDocumentSymbolTree(se)}static _asDocumentSymbolTree(B){B=B.slice(0).sort((se,q)=>{let ee=se.location.range.start.compareTo(q.location.range.start);return ee===0&&(ee=q.location.range.end.compareTo(se.location.range.end)),ee});const G=[],X=[];for(const se of B){const q={name:se.name||"!!MISSING: name!!",kind:w.SymbolKind.from(se.kind),tags:se.tags?.map(w.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:w.Range.from(se.location.range),selectionRange:w.Range.from(se.location.range),children:[]};for(;;){if(X.length===0){X.push(q),G.push(q);break}const ee=X[X.length-1];if(C.Range.containsRange(ee.range,q.range)&&!C.Range.equalsRange(ee.range,q.range)){ee.children&&ee.children.push(q),X.push(q);break}X.pop()}}return G}}class p{constructor(B,G,X){this._documents=B,this._commands=G,this._provider=X,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(B,G){const X=this._documents.getDocument(B),se=await this._provider.provideCodeLenses(X,G);if(!se||G.isCancellationRequested)return;const q=this._cache.add(se),ee=new n.DisposableStore;this._disposables.set(q,ee);const fe={cacheId:q,lenses:[]};for(let Ae=0;Ae<se.length;Ae++)fe.lenses.push({cacheId:[q,Ae],range:w.Range.from(se[Ae].range),command:this._commands.toInternal(se[Ae].command,ee)});return fe}async resolveCodeLens(B,G){const X=B.cacheId&&this._cache.get(...B.cacheId);if(!X)return;let se;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?se=X:se=await this._provider.resolveCodeLens(X,G),se||(se=X),G.isCancellationRequested)return;const q=B.cacheId&&this._disposables.get(B.cacheId[0]);if(!!q)return B.command=this._commands.toInternal(se.command??p._badCmd,q),B}releaseCodeLenses(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}}p._badCmd={command:"missing",title:"!!MISSING: command!!"};function I(je){return Array.isArray(je)?je.map(w.DefinitionLink.from):je?[w.DefinitionLink.from(je)]:[]}class l{constructor(B,G){this._documents=B,this._provider=G}async provideDefinition(B,G,X){const se=this._documents.getDocument(B),q=w.Position.to(G),ee=await this._provider.provideDefinition(se,q,X);return I(ee)}}class M{constructor(B,G){this._documents=B,this._provider=G}async provideDeclaration(B,G,X){const se=this._documents.getDocument(B),q=w.Position.to(G),ee=await this._provider.provideDeclaration(se,q,X);return I(ee)}}class o{constructor(B,G){this._documents=B,this._provider=G}async provideImplementation(B,G,X){const se=this._documents.getDocument(B),q=w.Position.to(G),ee=await this._provider.provideImplementation(se,q,X);return I(ee)}}class i{constructor(B,G){this._documents=B,this._provider=G}async provideTypeDefinition(B,G,X){const se=this._documents.getDocument(B),q=w.Position.to(G),ee=await this._provider.provideTypeDefinition(se,q,X);return I(ee)}}class h{constructor(B,G){this._documents=B,this._provider=G}async provideHover(B,G,X){const se=this._documents.getDocument(B),q=w.Position.to(G),ee=await this._provider.provideHover(se,q,X);if(!(!ee||(0,R.isFalsyOrEmpty)(ee.contents)))return ee.range||(ee.range=se.getWordRangeAtPosition(q)),ee.range||(ee.range=new T.Range(q,q)),w.Hover.from(ee)}}class u{constructor(B,G){this._documents=B,this._provider=G}async provideEvaluatableExpression(B,G,X){const se=this._documents.getDocument(B),q=w.Position.to(G),ee=await this._provider.provideEvaluatableExpression(se,q,X);if(ee)return w.EvaluatableExpression.from(ee)}}class s{constructor(B,G){this._documents=B,this._provider=G}async provideInlineValues(B,G,X,se){const q=this._documents.getDocument(B),ee=await this._provider.provideInlineValues(q,w.Range.to(G),w.InlineValueContext.to(X),se);if(Array.isArray(ee))return ee.map(fe=>w.InlineValue.from(fe))}}class b{constructor(B,G){this._documents=B,this._provider=G}async provideDocumentHighlights(B,G,X){const se=this._documents.getDocument(B),q=w.Position.to(G),ee=await this._provider.provideDocumentHighlights(se,q,X);if(Array.isArray(ee))return ee.map(w.DocumentHighlight.from)}}class y{constructor(B,G){this._documents=B,this._provider=G}async provideLinkedEditingRanges(B,G,X){const se=this._documents.getDocument(B),q=w.Position.to(G),ee=await this._provider.provideLinkedEditingRanges(se,q,X);if(ee&&Array.isArray(ee.ranges))return{ranges:(0,R.coalesce)(ee.ranges.map(w.Range.from)),wordPattern:ee.wordPattern}}}class c{constructor(B,G){this._documents=B,this._provider=G}async provideReferences(B,G,X,se){const q=this._documents.getDocument(B),ee=w.Position.to(G),fe=await this._provider.provideReferences(q,ee,X,se);if(Array.isArray(fe))return fe.map(w.location.from)}}class S{constructor(B,G,X,se,q,ee,fe){this._documents=B,this._commands=G,this._diagnostics=X,this._provider=se,this._logService=q,this._extension=ee,this._apiDeprecation=fe,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(B,G,X,se){const q=this._documents.getDocument(B),ee=_.Selection.isISelection(G)?w.Selection.to(G):w.Range.to(G),fe=[];for(const st of this._diagnostics.getDiagnostics(B))if(ee.intersection(st.range)&&fe.push(st)>S._maxCodeActionsPerFile)break;const Ae={diagnostics:fe,only:X.only?new T.CodeActionKind(X.only):void 0,triggerKind:w.CodeActionTriggerKind.to(X.trigger)},xe=await this._provider.provideCodeActions(q,ee,Ae,se);if(!(0,R.isNonEmptyArray)(xe)||se.isCancellationRequested)return;const ze=this._cache.add(xe),Xe=new n.DisposableStore;this._disposables.set(ze,Xe);const et=[];for(let st=0;st<xe.length;st++){const Je=xe[st];!Je||(S._isCommand(Je)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:Je.title,command:this._commands.toInternal(Je,Xe)})):(Ae.only&&(Je.kind?Ae.only.contains(Je.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action is of kind '${Je.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[ze,st],title:Je.title,command:Je.command&&this._commands.toInternal(Je.command,Xe),diagnostics:Je.diagnostics&&Je.diagnostics.map(w.Diagnostic.from),edit:Je.edit&&w.WorkspaceEdit.from(Je.edit),kind:Je.kind&&Je.kind.value,isPreferred:Je.isPreferred,disabled:Je.disabled?.reason})))}return{cacheId:ze,actions:et}}async resolveCodeAction(B,G){const[X,se]=B,q=this._cache.get(X,se);if(!q||S._isCommand(q)||!this._provider.resolveCodeAction)return;const ee=await this._provider.resolveCodeAction(q,G)??q;return ee?.edit?w.WorkspaceEdit.from(ee.edit):void 0}releaseCodeActions(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}static _isCommand(B){return typeof B.command=="string"&&typeof B.title=="string"}}S._maxCodeActionsPerFile=1e3;class A{constructor(B,G){this._documents=B,this._provider=G}async provideDocumentFormattingEdits(B,G,X){const se=this._documents.getDocument(B),q=await this._provider.provideDocumentFormattingEdits(se,G,X);if(Array.isArray(q))return q.map(w.TextEdit.from)}}class U{constructor(B,G){this._documents=B,this._provider=G}async provideDocumentRangeFormattingEdits(B,G,X,se){const q=this._documents.getDocument(B),ee=w.Range.to(G),fe=await this._provider.provideDocumentRangeFormattingEdits(q,ee,X,se);if(Array.isArray(fe))return fe.map(w.TextEdit.from)}}class H{constructor(B,G){this._documents=B,this._provider=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,G,X,se,q){const ee=this._documents.getDocument(B),fe=w.Position.to(G),Ae=await this._provider.provideOnTypeFormattingEdits(ee,fe,X,se,q);if(Array.isArray(Ae))return Ae.map(w.TextEdit.from)}}class E{constructor(B,G){this._provider=B,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(B,G){const X=k.IdObject.mixin({symbols:[]}),se=await this._provider.provideWorkspaceSymbols(B,G);if((0,R.isNonEmptyArray)(se))for(const q of se){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const ee=k.IdObject.mixin(w.WorkspaceSymbol.from(q));this._symbolCache.set(ee._id,q),X.symbols.push(ee)}return X.symbols.length>0&&this._resultCache.set(X._id,[X.symbols[0]._id,X.symbols[X.symbols.length-1]._id]),X}async resolveWorkspaceSymbol(B,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return B;const X=this._symbolCache.get(B._id);if(X){const se=await this._provider.resolveWorkspaceSymbol(X,G);return se&&(0,t.mixin)(B,w.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(B){const G=this._resultCache.get(B);if(G){for(let[X,se]=G;X<=se;X++)this._symbolCache.delete(X);this._resultCache.delete(B)}}}class L{constructor(B,G,X){this._documents=B,this._provider=G,this._logService=X}static supportsResolving(B){return typeof B.prepareRename=="function"}async provideRenameEdits(B,G,X,se){const q=this._documents.getDocument(B),ee=w.Position.to(G);try{const fe=await this._provider.provideRenameEdits(q,ee,X,se);return fe?w.WorkspaceEdit.from(fe):void 0}catch(fe){const Ae=L._asMessage(fe);return Ae?{rejectReason:Ae,edits:void 0}:Promise.reject(fe)}}async resolveRenameLocation(B,G,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument(B),q=w.Position.to(G);try{const ee=await this._provider.prepareRename(se,q,X);let fe,Ae;if(T.Range.isRange(ee)?(fe=ee,Ae=se.getText(ee)):(0,F.isObject)(ee)&&(fe=ee.range,Ae=ee.placeholder),!fe||!Ae)return;if(fe.start.line>q.line||fe.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:w.Range.from(fe),text:Ae}}catch(ee){const fe=L._asMessage(ee);return fe?{rejectReason:fe,range:void 0,text:void 0}:Promise.reject(ee)}}static _asMessage(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class z{constructor(B,G){this.resultId=B,this.tokens=G}}class N{constructor(B,G){this._documents=B,this._provider=G,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(B,G,X){const se=this._documents.getDocument(B),q=G!==0?this._previousResults.get(G):null;let ee=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(se,q.resultId,X):await this._provider.provideDocumentSemanticTokens(se,X);return q&&this._previousResults.delete(G),ee?(ee=N._fixProvidedSemanticTokens(ee),this._send(N._convertToEdits(q,ee),ee)):null}async releaseDocumentSemanticColoring(B){this._previousResults.delete(B)}static _fixProvidedSemanticTokens(B){return N._isSemanticTokens(B)?N._isCorrectSemanticTokens(B)?B:new T.SemanticTokens(new Uint32Array(B.data),B.resultId):N._isSemanticTokensEdits(B)?N._isCorrectSemanticTokensEdits(B)?B:new T.SemanticTokensEdits(B.edits.map(G=>new T.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),B.resultId):B}static _isSemanticTokens(B){return B&&!!B.data}static _isCorrectSemanticTokens(B){return B.data instanceof Uint32Array}static _isSemanticTokensEdits(B){return B&&Array.isArray(B.edits)}static _isCorrectSemanticTokensEdits(B){for(const G of B.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(B,G){if(!N._isSemanticTokens(G)||!B||!B.tokens)return G;const X=B.tokens,se=X.length,q=G.data,ee=q.length;let fe=0;const Ae=Math.min(se,ee);for(;fe<Ae&&X[fe]===q[fe];)fe++;if(fe===se&&fe===ee)return new T.SemanticTokensEdits([],G.resultId);let xe=0;const ze=Ae-fe;for(;xe<ze&&X[se-xe-1]===q[ee-xe-1];)xe++;return new T.SemanticTokensEdits([{start:fe,deleteCount:se-fe-xe,data:q.subarray(fe,ee-xe)}],G.resultId)}_send(B,G){if(N._isSemanticTokens(B)){const X=this._nextResultId++;return this._previousResults.set(X,new z(B.resultId,B.data)),(0,m.encodeSemanticTokensDto)({id:X,type:"full",data:B.data})}if(N._isSemanticTokensEdits(B)){const X=this._nextResultId++;return N._isSemanticTokens(G)?this._previousResults.set(X,new z(G.resultId,G.data)):this._previousResults.set(X,new z(B.resultId)),(0,m.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(B.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=N;class ${constructor(B,G){this._documents=B,this._provider=G}async provideDocumentRangeSemanticTokens(B,G,X){const se=this._documents.getDocument(B),q=await this._provider.provideDocumentRangeSemanticTokens(se,w.Range.to(G),X);return q?this._send(q):null}_send(B){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:B.data})}}e.DocumentRangeSemanticTokensAdapter=$;class j{constructor(B,G,X,se,q){this._documents=B,this._commands=G,this._provider=X,this._apiDeprecation=se,this._extension=q,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}async provideCompletionItems(B,G,X,se){const q=this._documents.getDocument(B),ee=w.Position.to(G),fe=q.getWordRangeAtPosition(ee)||new T.Range(ee,ee),Ae=fe.with({end:ee}),xe=new d.StopWatch(!0),ze=await this._provider.provideCompletionItems(q,ee,se,w.CompletionContext.to(X));if(!ze||se.isCancellationRequested)return;const Xe=Array.isArray(ze)?new T.CompletionList(ze):ze,et=j.supportsResolving(this._provider)?this._cache.add(Xe.items):this._cache.add([]),st=new n.DisposableStore;this._disposables.set(et,st);const Je=[],nt={x:et,b:Je,a:{replace:w.Range.from(fe),insert:w.Range.from(Ae)},c:Xe.isIncomplete||void 0,d:xe.elapsed()};for(let lt=0;lt<Xe.items.length;lt++){const pt=Xe.items[lt],Ft=this._convertCompletionItem(pt,[et,lt],Ae,fe);Je.push(Ft)}return nt}async resolveCompletionItem(B,G){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...B);if(!X)return;const se=await this._provider.resolveCompletionItem(X,G);if(!!se)return this._convertCompletionItem(se,B)}releaseCompletionItems(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_convertCompletionItem(B,G,X,se){const q=this._disposables.get(G[0]);if(!q)throw Error("DisposableStore is missing...");const ee={x:G,a:B.label,b:B.kind!==void 0?w.CompletionItemKind.from(B.kind):void 0,n:B.tags&&B.tags.map(w.CompletionItemTag.from),c:B.detail,d:typeof B.documentation=="undefined"?void 0:w.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters,l:B.additionalTextEdits&&B.additionalTextEdits.map(w.TextEdit.from),m:this._commands.toInternal(B.command,q)};B.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ee.h=B.textEdit.newText):typeof B.insertText=="string"?ee.h=B.insertText:B.insertText instanceof T.SnippetString&&(ee.h=B.insertText.value,ee.i|=4);let fe;return B.textEdit?fe=B.textEdit.range:B.range&&(fe=B.range),T.Range.isRange(fe)?ee.j=w.Range.from(fe):fe&&(!X?.isEqual(fe.inserting)||!se?.isEqual(fe.replacing))&&(ee.j={insert:w.Range.from(fe.inserting),replace:w.Range.from(fe.replacing)}),ee}}class ue{constructor(B,G,X){this._documents=B,this._provider=G,this._commands=X,this._cache=new g.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(B,G,X,se){const q=this._documents.getDocument(B),ee=w.Position.to(G),fe=await this._provider.provideInlineCompletionItems(q,ee,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:w.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text,isSnippetText:X.selectedSuggestionInfo.isSnippetText,completionKind:w.CompletionItemKind.to(X.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:X.triggerKind},se);if(!fe||se.isCancellationRequested)return;const Ae=(0,F.isArray)(fe)?{items:fe}:fe,xe=this._cache.add(Ae.items);let ze;return{pid:xe,items:Ae.items.map((Xe,et)=>{let st;return Xe.command&&(ze||(ze=new n.DisposableStore,this._disposables.set(xe,ze)),st=this._commands.toInternal(Xe.command,ze)),{text:Xe.text,range:Xe.range?w.Range.from(Xe.range):void 0,command:st,idx:et}})}}disposeCompletions(B){this._cache.delete(B);const G=this._disposables.get(B);G&&G.clear(),this._disposables.delete(B)}handleDidShowCompletionItem(B,G){const X=this._cache.get(B,G);X&&K.get(this._provider).fireOnDidShowCompletionItem({completionItem:X})}}class K{constructor(){this._onDidShowCompletionItemEmitter=new v.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(B){let G=K.map.get(B);return G||(G=new K,K.map.set(B,G)),G}fireOnDidShowCompletionItem(B){this._onDidShowCompletionItemEmitter.fire(B)}}e.InlineCompletionController=K,K.map=new WeakMap;class ie{constructor(B,G){this._documents=B,this._provider=G,this._cache=new g.Cache("SignatureHelp")}async provideSignatureHelp(B,G,X,se){const q=this._documents.getDocument(B),ee=w.Position.to(G),fe=this.reviveContext(X),Ae=await this._provider.provideSignatureHelp(q,ee,se,fe);if(Ae){const xe=this._cache.add([Ae]);return{...w.SignatureHelp.from(Ae),id:xe}}}reviveContext(B){let G;if(B.activeSignatureHelp){const X=w.SignatureHelp.to(B.activeSignatureHelp),se=this._cache.get(B.activeSignatureHelp.id,0);se?(G=se,G.activeSignature=X.activeSignature,G.activeParameter=X.activeParameter):G=X}return{...B,activeSignatureHelp:G}}releaseSignatureHelp(B){this._cache.delete(B)}}class pe{constructor(B,G){this._documents=B,this._provider=G}async provideInlayHints(B,G,X){const se=this._documents.getDocument(B),q=await this._provider.provideInlayHints(se,w.Range.to(G),X);return q?{hints:q.map(w.InlayHint.from)}:void 0}}class we{constructor(B,G){this._documents=B,this._provider=G,this._cache=new g.Cache("DocumentLink")}async provideLinks(B,G){const X=this._documents.getDocument(B),se=await this._provider.provideDocumentLinks(X,G);if(!(!Array.isArray(se)||se.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.filter(we._validateLink).map(w.DocumentLink.from)};{const q=this._cache.add(se),ee={links:[],id:q};for(let fe=0;fe<se.length;fe++){if(!we._validateLink(se[fe]))continue;const Ae=w.DocumentLink.from(se[fe]);Ae.cacheId=[q,fe],ee.links.push(Ae)}return ee}}}static _validateLink(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,G){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...B);if(!X)return;const se=await this._provider.resolveDocumentLink(X,G);if(!(!se||!we._validateLink(se)))return w.DocumentLink.from(se)}releaseLinks(B){this._cache.delete(B)}}class ae{constructor(B,G){this._documents=B,this._provider=G}async provideColors(B,G){const X=this._documents.getDocument(B),se=await this._provider.provideDocumentColors(X,G);return Array.isArray(se)?se.map(ee=>({color:w.Color.from(ee.color),range:w.Range.from(ee.range)})):[]}async provideColorPresentations(B,G,X){const se=this._documents.getDocument(B),q=w.Range.to(G.range),ee=w.Color.to(G.color),fe=await this._provider.provideColorPresentations(ee,{document:se,range:q},X);if(!!Array.isArray(fe))return fe.map(w.ColorPresentation.from)}}class le{constructor(B,G){this._documents=B,this._provider=G}async provideFoldingRanges(B,G,X){const se=this._documents.getDocument(B),q=await this._provider.provideFoldingRanges(se,G,X);if(!!Array.isArray(q))return q.map(w.FoldingRange.from)}}class Se{constructor(B,G,X){this._documents=B,this._provider=G,this._logService=X}async provideSelectionRanges(B,G,X){const se=this._documents.getDocument(B),q=G.map(w.Position.to),ee=await this._provider.provideSelectionRanges(se,q,X);if(!(0,R.isNonEmptyArray)(ee))return[];if(ee.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const fe=[];for(let Ae=0;Ae<q.length;Ae++){const xe=[];fe.push(xe);let ze=q[Ae],Xe=ee[Ae];for(;;){if(!Xe.range.contains(ze))throw new Error("INVALID selection range, must contain the previous range");if(xe.push(w.SelectionRange.from(Xe)),!Xe.parent)break;ze=Xe.range,Xe=Xe.parent}}return fe}}class Ce{constructor(B,G){this._documents=B,this._provider=G,this._idPool=new r.IdGenerator(""),this._cache=new Map}async prepareSession(B,G,X){const se=this._documents.getDocument(B),q=w.Position.to(G),ee=await this._provider.prepareCallHierarchy(se,q,X);if(!ee)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(ee)?ee.map(Ae=>this._cacheAndConvertItem(fe,Ae)):[this._cacheAndConvertItem(fe,ee)]}async provideCallsTo(B,G,X){const se=this._itemFromCache(B,G);if(!se)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(se,X);if(!!q)return q.map(ee=>({from:this._cacheAndConvertItem(B,ee.from),fromRanges:ee.fromRanges.map(fe=>w.Range.from(fe))}))}async provideCallsFrom(B,G,X){const se=this._itemFromCache(B,G);if(!se)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(se,X);if(!!q)return q.map(ee=>({to:this._cacheAndConvertItem(B,ee.to),fromRanges:ee.fromRanges.map(fe=>w.Range.from(fe))}))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,G){const X=this._cache.get(B),se=w.CallHierarchyItem.from(G,B,X.size.toString(36));return X.set(se._itemId,G),se}_itemFromCache(B,G){return this._cache.get(B)?.get(G)}}class Fe{constructor(B,G){this._documents=B,this._provider=G,this._idPool=new r.IdGenerator(""),this._cache=new Map}async prepareSession(B,G,X){const se=this._documents.getDocument(B),q=w.Position.to(G),ee=await this._provider.prepareTypeHierarchy(se,q,X);if(!ee)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(ee)?ee.map(Ae=>this._cacheAndConvertItem(fe,Ae)):[this._cacheAndConvertItem(fe,ee)]}async provideSupertypes(B,G,X){const se=this._itemFromCache(B,G);if(!se)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(se,X);if(!!q)return q.map(ee=>this._cacheAndConvertItem(B,ee))}async provideSubtypes(B,G,X){const se=this._itemFromCache(B,G);if(!se)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(se,X);if(!!q)return q.map(ee=>this._cacheAndConvertItem(B,ee))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,G){const X=this._cache.get(B),se=w.TypeHierarchyItem.from(G,B,X.size.toString(36));return X.set(se._itemId,G),se}_itemFromCache(B,G){return this._cache.get(B)?.get(G)}}class $e{constructor(B,G){this.adapter=B,this.extension=G}}class Ve{constructor(B,G,X,se,q,ee,fe){this._adapter=new Map,this._uriTransformer=G,this._proxy=B.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=X,this._commands=se,this._diagnostics=q,this._logService=ee,this._apiDeprecation=fe}_transformDocumentSelector(B){return w.DocumentSelector.from(B,this._uriTransformer)}_createDisposable(B){return new T.Disposable(()=>{this._adapter.delete(B),this._proxy.$unregister(B)})}_nextHandle(){return Ve._handlePool++}_withAdapter(B,G,X,se,q=!1){const ee=this._adapter.get(B);if(!ee)return Promise.resolve(se);if(ee.adapter instanceof G){let fe;ee.extension&&(fe=Date.now(),this._logService.trace(`[${ee.extension.identifier.value}] INVOKE provider '${G.name}'`));const Ae=X(ee.adapter,ee.extension),xe=ee.extension;return xe&&Promise.resolve(Ae).then(()=>this._logService.trace(`[${xe.identifier.value}] provider DONE after ${Date.now()-fe}ms`),ze=>{q&&ze instanceof D.CancellationError||(this._logService.error(`[${xe.identifier.value}] provider FAILED`),this._logService.error(ze))}),Ae}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(B,G){const X=this._nextHandle();return this._adapter.set(X,new $e(B,G)),X}static _extLabel(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,G,X,se){const q=this._addNewAdapter(new f(this._documents,X),B),ee=se&&se.label||Ve._extLabel(B);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(G),ee),this._createDisposable(q)}$provideDocumentSymbols(B,G,X){return this._withAdapter(B,f,se=>se.provideDocumentSymbols(a.URI.revive(G),X),void 0)}registerCodeLensProvider(B,G,X){const se=this._nextHandle(),q=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new $e(new p(this._documents,this._commands.converter,X),B)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(G),q);let ee=this._createDisposable(se);if(q!==void 0){const fe=X.onDidChangeCodeLenses(Ae=>this._proxy.$emitCodeLensEvent(q));ee=T.Disposable.from(ee,fe)}return ee}$provideCodeLenses(B,G,X){return this._withAdapter(B,p,se=>se.provideCodeLenses(a.URI.revive(G),X),void 0)}$resolveCodeLens(B,G,X){return this._withAdapter(B,p,se=>se.resolveCodeLens(G,X),void 0)}$releaseCodeLenses(B,G){this._withAdapter(B,p,X=>Promise.resolve(X.releaseCodeLenses(G)),void 0)}registerDefinitionProvider(B,G,X){const se=this._addNewAdapter(new l(this._documents,X),B);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDefinition(B,G,X,se){return this._withAdapter(B,l,q=>q.provideDefinition(a.URI.revive(G),X,se),[])}registerDeclarationProvider(B,G,X){const se=this._addNewAdapter(new M(this._documents,X),B);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDeclaration(B,G,X,se){return this._withAdapter(B,M,q=>q.provideDeclaration(a.URI.revive(G),X,se),[])}registerImplementationProvider(B,G,X){const se=this._addNewAdapter(new o(this._documents,X),B);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideImplementation(B,G,X,se){return this._withAdapter(B,o,q=>q.provideImplementation(a.URI.revive(G),X,se),[])}registerTypeDefinitionProvider(B,G,X){const se=this._addNewAdapter(new i(this._documents,X),B);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideTypeDefinition(B,G,X,se){return this._withAdapter(B,i,q=>q.provideTypeDefinition(a.URI.revive(G),X,se),[])}registerHoverProvider(B,G,X,se){const q=this._addNewAdapter(new h(this._documents,X),B);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(G)),this._createDisposable(q)}$provideHover(B,G,X,se){return this._withAdapter(B,h,q=>q.provideHover(a.URI.revive(G),X,se),void 0)}registerEvaluatableExpressionProvider(B,G,X,se){const q=this._addNewAdapter(new u(this._documents,X),B);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(G)),this._createDisposable(q)}$provideEvaluatableExpression(B,G,X,se){return this._withAdapter(B,u,q=>q.provideEvaluatableExpression(a.URI.revive(G),X,se),void 0)}registerInlineValuesProvider(B,G,X,se){const q=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ee=this._addNewAdapter(new s(this._documents,X),B);this._proxy.$registerInlineValuesProvider(ee,this._transformDocumentSelector(G),q);let fe=this._createDisposable(ee);if(q!==void 0){const Ae=X.onDidChangeInlineValues(xe=>this._proxy.$emitInlineValuesEvent(q));fe=T.Disposable.from(fe,Ae)}return fe}$provideInlineValues(B,G,X,se,q){return this._withAdapter(B,s,ee=>ee.provideInlineValues(a.URI.revive(G),X,se,q),void 0)}registerDocumentHighlightProvider(B,G,X){const se=this._addNewAdapter(new b(this._documents,X),B);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDocumentHighlights(B,G,X,se){return this._withAdapter(B,b,q=>q.provideDocumentHighlights(a.URI.revive(G),X,se),void 0)}registerLinkedEditingRangeProvider(B,G,X){const se=this._addNewAdapter(new y(this._documents,X),B);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideLinkedEditingRanges(B,G,X,se){return this._withAdapter(B,y,async q=>{const ee=await q.provideLinkedEditingRanges(a.URI.revive(G),X,se);if(ee)return{ranges:ee.ranges,wordPattern:ee.wordPattern?Ve._serializeRegExp(ee.wordPattern):void 0}},void 0)}registerReferenceProvider(B,G,X){const se=this._addNewAdapter(new c(this._documents,X),B);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideReferences(B,G,X,se,q){return this._withAdapter(B,c,ee=>ee.provideReferences(a.URI.revive(G),X,se,q),void 0)}registerCodeActionProvider(B,G,X,se){const q=new n.DisposableStore,ee=this._addNewAdapter(new S(this._documents,this._commands.converter,this._diagnostics,X,this._logService,B,this._apiDeprecation),B);return this._proxy.$registerQuickFixSupport(ee,this._transformDocumentSelector(G),{providedKinds:se?.providedCodeActionKinds?.map(fe=>fe.value),documentation:se?.documentation?.map(fe=>({kind:fe.kind.value,command:this._commands.converter.toInternal(fe.command,q)}))},Ve._extLabel(B),Boolean(X.resolveCodeAction)),q.add(this._createDisposable(ee)),q}$provideCodeActions(B,G,X,se,q){return this._withAdapter(B,S,ee=>ee.provideCodeActions(a.URI.revive(G),X,se,q),void 0)}$resolveCodeAction(B,G,X){return this._withAdapter(B,S,se=>se.resolveCodeAction(G,X),void 0)}$releaseCodeActions(B,G){this._withAdapter(B,S,X=>Promise.resolve(X.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider(B,G,X){const se=this._addNewAdapter(new A(this._documents,X),B);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(G),B.identifier,B.displayName||B.name),this._createDisposable(se)}$provideDocumentFormattingEdits(B,G,X,se){return this._withAdapter(B,A,q=>q.provideDocumentFormattingEdits(a.URI.revive(G),X,se),void 0)}registerDocumentRangeFormattingEditProvider(B,G,X){const se=this._addNewAdapter(new U(this._documents,X),B);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(G),B.identifier,B.displayName||B.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(B,G,X,se,q){return this._withAdapter(B,U,ee=>ee.provideDocumentRangeFormattingEdits(a.URI.revive(G),X,se,q),void 0)}registerOnTypeFormattingEditProvider(B,G,X,se){const q=this._addNewAdapter(new H(this._documents,X),B);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(G),se,B.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits(B,G,X,se,q,ee){return this._withAdapter(B,H,fe=>fe.provideOnTypeFormattingEdits(a.URI.revive(G),X,se,q,ee),void 0)}registerWorkspaceSymbolProvider(B,G){const X=this._addNewAdapter(new E(G,this._logService),B);return this._proxy.$registerNavigateTypeSupport(X,typeof G.resolveWorkspaceSymbol=="function"),this._createDisposable(X)}$provideWorkspaceSymbols(B,G,X){return this._withAdapter(B,E,se=>se.provideWorkspaceSymbols(G,X),{symbols:[]})}$resolveWorkspaceSymbol(B,G,X){return this._withAdapter(B,E,se=>se.resolveWorkspaceSymbol(G,X),void 0)}$releaseWorkspaceSymbols(B,G){this._withAdapter(B,E,X=>X.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider(B,G,X){const se=this._addNewAdapter(new L(this._documents,X,this._logService),B);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(G),L.supportsResolving(X)),this._createDisposable(se)}$provideRenameEdits(B,G,X,se,q){return this._withAdapter(B,L,ee=>ee.provideRenameEdits(a.URI.revive(G),X,se,q),void 0)}$resolveRenameLocation(B,G,X,se){return this._withAdapter(B,L,q=>q.resolveRenameLocation(a.URI.revive(G),X,se),void 0)}registerDocumentSemanticTokensProvider(B,G,X,se){const q=this._nextHandle(),ee=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new $e(new N(this._documents,X),B)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(G),se,ee);let fe=this._createDisposable(q);if(ee){const Ae=X.onDidChangeSemanticTokens(xe=>this._proxy.$emitDocumentSemanticTokensEvent(ee));fe=T.Disposable.from(fe,Ae)}return fe}$provideDocumentSemanticTokens(B,G,X,se){return this._withAdapter(B,N,q=>q.provideDocumentSemanticTokens(a.URI.revive(G),X,se),null,!0)}$releaseDocumentSemanticTokens(B,G){this._withAdapter(B,N,X=>X.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider(B,G,X,se){const q=this._addNewAdapter(new $(this._documents,X),B);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(G),se),this._createDisposable(q)}$provideDocumentRangeSemanticTokens(B,G,X,se){return this._withAdapter(B,$,q=>q.provideDocumentRangeSemanticTokens(a.URI.revive(G),X,se),null,!0)}registerCompletionItemProvider(B,G,X,se){const q=this._addNewAdapter(new j(this._documents,this._commands.converter,X,this._apiDeprecation,B),B);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(G),se,j.supportsResolving(X),`${B.identifier.value}(${se.join("")})`),this._createDisposable(q)}$provideCompletionItems(B,G,X,se,q){return this._withAdapter(B,j,ee=>ee.provideCompletionItems(a.URI.revive(G),X,se,q),void 0)}$resolveCompletionItem(B,G,X){return this._withAdapter(B,j,se=>se.resolveCompletionItem(G,X),void 0)}$releaseCompletionItems(B,G){this._withAdapter(B,j,X=>X.releaseCompletionItems(G),void 0)}registerInlineCompletionsProvider(B,G,X){const se=this._addNewAdapter(new ue(this._documents,X,this._commands.converter),B);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideInlineCompletions(B,G,X,se,q){return this._withAdapter(B,ue,ee=>ee.provideInlineCompletions(a.URI.revive(G),X,se,q),void 0)}$handleInlineCompletionDidShow(B,G,X){this._withAdapter(B,ue,async se=>{se.handleDidShowCompletionItem(G,X)},void 0)}$freeInlineCompletionsList(B,G){this._withAdapter(B,ue,async X=>{X.disposeCompletions(G)},void 0)}registerSignatureHelpProvider(B,G,X,se){const q=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,ee=this._addNewAdapter(new ie(this._documents,X),B);return this._proxy.$registerSignatureHelpProvider(ee,this._transformDocumentSelector(G),q),this._createDisposable(ee)}$provideSignatureHelp(B,G,X,se,q){return this._withAdapter(B,ie,ee=>ee.provideSignatureHelp(a.URI.revive(G),X,se,q),void 0)}$releaseSignatureHelp(B,G){this._withAdapter(B,ie,X=>X.releaseSignatureHelp(G),void 0)}registerInlayHintsProvider(B,G,X){const se=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new pe(this._documents,X),B);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(G),se);let ee=this._createDisposable(q);if(se!==void 0){const fe=X.onDidChangeInlayHints(Ae=>this._proxy.$emitInlayHintsEvent(se));ee=T.Disposable.from(ee,fe)}return ee}$provideInlayHints(B,G,X,se){return this._withAdapter(B,pe,q=>q.provideInlayHints(a.URI.revive(G),X,se),void 0)}registerDocumentLinkProvider(B,G,X){const se=this._addNewAdapter(new we(this._documents,X),B);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(G),typeof X.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks(B,G,X){return this._withAdapter(B,we,se=>se.provideLinks(a.URI.revive(G),X),void 0)}$resolveDocumentLink(B,G,X){return this._withAdapter(B,we,se=>se.resolveLink(G,X),void 0)}$releaseDocumentLinks(B,G){this._withAdapter(B,we,X=>X.releaseLinks(G),void 0)}registerColorProvider(B,G,X){const se=this._addNewAdapter(new ae(this._documents,X),B);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDocumentColors(B,G,X){return this._withAdapter(B,ae,se=>se.provideColors(a.URI.revive(G),X),[])}$provideColorPresentations(B,G,X,se){return this._withAdapter(B,ae,q=>q.provideColorPresentations(a.URI.revive(G),X,se),void 0)}registerFoldingRangeProvider(B,G,X){const se=this._nextHandle(),q=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new $e(new le(this._documents,X),B)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(G),q);let ee=this._createDisposable(se);if(q!==void 0){const fe=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));ee=T.Disposable.from(ee,fe)}return ee}$provideFoldingRanges(B,G,X,se){return this._withAdapter(B,le,q=>q.provideFoldingRanges(a.URI.revive(G),X,se),void 0)}registerSelectionRangeProvider(B,G,X){const se=this._addNewAdapter(new Se(this._documents,X,this._logService),B);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideSelectionRanges(B,G,X,se){return this._withAdapter(B,Se,q=>q.provideSelectionRanges(a.URI.revive(G),X,se),[])}registerCallHierarchyProvider(B,G,X){const se=this._addNewAdapter(new Ce(this._documents,X),B);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$prepareCallHierarchy(B,G,X,se){return this._withAdapter(B,Ce,q=>Promise.resolve(q.prepareSession(a.URI.revive(G),X,se)),void 0)}$provideCallHierarchyIncomingCalls(B,G,X,se){return this._withAdapter(B,Ce,q=>q.provideCallsTo(G,X,se),void 0)}$provideCallHierarchyOutgoingCalls(B,G,X,se){return this._withAdapter(B,Ce,q=>q.provideCallsFrom(G,X,se),void 0)}$releaseCallHierarchy(B,G){this._withAdapter(B,Ce,X=>Promise.resolve(X.releaseSession(G)),void 0)}registerTypeHierarchyProvider(B,G,X){const se=this._addNewAdapter(new Fe(this._documents,X),B);return this._proxy.$registerTypeHierarchyProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$prepareTypeHierarchy(B,G,X,se){return this._withAdapter(B,Fe,q=>Promise.resolve(q.prepareSession(a.URI.revive(G),X,se)),void 0)}$provideTypeHierarchySupertypes(B,G,X,se){return this._withAdapter(B,Fe,q=>q.provideSupertypes(G,X,se),void 0)}$provideTypeHierarchySubtypes(B,G,X,se){return this._withAdapter(B,Fe,q=>q.provideSubtypes(G,X,se),void 0)}$releaseTypeHierarchy(B,G){this._withAdapter(B,Fe,X=>Promise.resolve(X.releaseSession(G)),void 0)}static _serializeRegExp(B){return{pattern:B.source,flags:(0,P.regExpFlags)(B)}}static _serializeIndentationRule(B){return{decreaseIndentPattern:Ve._serializeRegExp(B.decreaseIndentPattern),increaseIndentPattern:Ve._serializeRegExp(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?Ve._serializeRegExp(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?Ve._serializeRegExp(B.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(B){return{beforeText:Ve._serializeRegExp(B.beforeText),afterText:B.afterText?Ve._serializeRegExp(B.afterText):void 0,previousLineText:B.previousLineText?Ve._serializeRegExp(B.previousLineText):void 0,action:B.action}}static _serializeOnEnterRules(B){return B.map(Ve._serializeOnEnterRule)}setLanguageConfiguration(B,G,X){let{wordPattern:se}=X;if(se&&(0,P.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(G,se):this._documents.setWordDefinitionFor(G,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const q=this._nextHandle(),ee={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?Ve._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?Ve._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?Ve._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,G,ee),this._createDisposable(q)}$setWordDefinitions(B){for(const G of B)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=Ve,Ve._handlePool=0}),define(Ee[191],ye([0,1,5,8,7,34,14,6]),function(ne,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(F,_,n,m){this._documents=_,this._commands=n,this._uriTransformer=m,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=F.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(F){this._languageIds=F}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(F,_){await this._proxy.$changeLanguage(F,_);const n=this._documents.getDocumentData(F);if(!n)throw new Error(`document '${F.toString}' NOT found`);return n.document}async tokenAtPosition(F,_){const n=F.version,m=t.Position.from(_),r=await this._proxy.$tokensAtPosition(F.uri,m),g={type:w.StandardTokenType.Other,range:F.getWordRangeAtPosition(_)??new w.Range(_.line,_.character,_.line,_.character)};if(!r)return g;const d={range:t.Range.to(r.range),type:t.TokenType.to(r.type)};return!d.range.contains(_)||n!==F.version?g:d}createLanguageStatusItem(F,_,n){const m=this._handlePool++,r=this._proxy,g=this._ids,d=`${F.identifier.value}/${_}`;if(g.has(d))throw new Error(`LanguageStatusItem with id '${_}' ALREADY exists`);g.add(d);const D={selector:n,id:_,name:F.displayName??F.name,severity:w.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v,f=new P.DisposableStore;const p=()=>{v?.dispose(),v=(0,k.disposableTimeout)(()=>{f.clear(),this._proxy.$setLanguageStatus(m,{id:d,name:D.name??F.displayName??F.name,source:F.displayName??F.name,selector:t.DocumentSelector.from(D.selector,this._uriTransformer),label:D.text,detail:D.detail??"",severity:D.severity===w.LanguageStatusSeverity.Error?T.default.Error:D.severity===w.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:D.command&&this._commands.toInternal(D.command,f),accessibilityInfo:D.accessibilityInformation,busy:D.busy})},0)},I={dispose(){f.dispose(),v?.dispose(),r.$removeLanguageStatus(m),g.delete(d)},get id(){return D.id},get name(){return D.name},set name(l){D.name=l,p()},get selector(){return D.selector},set selector(l){D.selector=l,p()},get text(){return D.text},set text(l){D.text=l,p()},get detail(){return D.detail},set detail(l){D.detail=l,p()},get severity(){return D.severity},set severity(l){D.severity=l,p()},get accessibilityInformation(){return D.accessibilityInformation},set accessibilityInformation(l){D.accessibilityInformation=l,p()},get command(){return D.command},set command(l){D.command=l,p()},get busy(){return D.busy},set busy(l){D.busy=l,p()}};return p(),I}}e.ExtHostLanguages=C}),define(Ee[192],ye([0,1,12,5,28,13,4]),function(ne,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let P=class extends a.AbstractLoggerService{constructor(F,_){const n=new k.Emitter;super(_.logLevel,n.event);this._proxy=F.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(n)}$setLevel(F){this._onDidChangeLogLevel.fire(F)}doCreateLogger(F,_,n){return new C(this._proxy,F,_,n)}};P=Be([He(0,T.IExtHostRpcService),He(1,w.IExtHostInitDataService)],P),e.ExtHostLoggerService=P;class C extends a.AbstractMessageLogger{constructor(F,_,n,m){super(m?.always);this.proxy=F,this.file=_,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(n),this.proxy.$createLogger(_,m).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(F,_){const n=[[F,_]];this.isLoggerCreated?this.doLog(n):this.buffer.push(...n)}doLog(F){this.proxy.$log(this.file,F)}}}),define(Ee[193],ye([0,1,5,12,27]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(P){return P&&P.title}let k=class{constructor(C,R){this._logService=R,this._proxy=C.getProxy(a.MainContext.MainThreadMessageService)}showMessage(C,R,F,_,n){const m={extension:C};let r;typeof _=="string"||T(_)?r=[_,...n]:(m.modal=_?.modal,m.useCustom=_?.useCustom,m.detail=_?.detail,r=n),m.useCustom&&(0,w.checkProposedApiEnabled)(C,"resolvers");const g=[];for(let d=0;d<r.length;d++){const D=r[d];if(typeof D=="string")g.push({title:D,handle:d,isCloseAffordance:!1});else if(typeof D=="object"){let{title:v,isCloseAffordance:f}=D;g.push({title:v,isCloseAffordance:!!f,handle:d})}else this._logService.warn("Invalid message item:",D)}return this._proxy.$showMessage(R,F,m,g).then(d=>{if(typeof d=="number")return r[d]})}};k=Be([He(1,t.ILogService)],k),e.ExtHostMessageService=k}),define(Ee[194],ye([0,1,22,4,57,6,21,9,11,2,63,5,8,7,37,167,91]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m,r,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class D{constructor(f,p,I,l,M){this._textDocumentsAndEditors=I,this._textDocuments=l,this._extensionStoragePaths=M,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new t.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new F.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=f.getProxy(_.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=f.getProxy(_.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=f.getProxy(_.MainContext.MainThreadNotebookEditors),this._commandsConverter=p.converter,p.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===12){const i=o.notebookEditor?.notebookUri,h=o.cell.handle,s=this._documents.get(i)?.getCell(h);if(s)return s.apiCell}return o}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(f=>f.apiEditor)}getEditorById(f){const p=this._editors.get(f);if(!p)throw new Error(`unknown text editor: ${f}. known editors: ${[...this._editors.keys()]} `);return p}getIdByEditor(f){for(const[p,I]of this._editors)if(I.apiEditor===f)return p}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(f,p){const I=this._documents.get(f);if(!I&&!p)throw new Error(`NO notebook document for '${f}'`);return I}_getProviderData(f){const p=this._notebookContentProviders.get(f);if(!p)throw new Error(`NO provider for '${f}'`);return p}registerNotebookContentProvider(f,p,I,l,M){if((0,P.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(p))throw new Error(`Notebook provider for '${p}' already registered`);this._notebookContentProviders.set(p,{extension:f,provider:I});let o;return I.onDidChangeNotebookContentOptions&&(o=I.onDidChangeNotebookContentOptions(()=>{const i=n.NotebookDocumentContentOptions.from(I.options);this._notebookProxy.$updateNotebookProviderOptions(p,i)})),this._notebookProxy.$registerNotebookProvider({id:f.identifier,location:f.extensionLocation},p,n.NotebookDocumentContentOptions.from(l),D._convertNotebookRegistrationData(f,M)),new m.Disposable(()=>{o?.dispose(),this._notebookContentProviders.delete(p),this._notebookProxy.$unregisterNotebookProvider(p)})}static _convertNotebookRegistrationData(f,p){if(!p)return;const I=p.filenamePattern.map(l=>n.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(p.filenamePattern&&!I){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:p.displayName,filenamePattern:I,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,p,I){const l=D._notebookStatusBarItemProviderHandlePool++,M=typeof I.onDidChangeCellStatusBarItems=="function"?D._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(l,I),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(l,M,p);let o;return M!==void 0&&(o=I.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(M))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(l),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(l,M),o&&o.dispose()})}async createNotebookDocument(f){const p=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:f.viewType,content:f.content&&n.NotebookData.from(f.content)});return R.URI.revive(p)}async openNotebookDocument(f){const p=this._documents.get(f);if(p)return p.apiNotebook;const I=await this._notebookDocumentsProxy.$tryOpenNotebook(f),l=this._documents.get(R.URI.revive(I));return(0,C.assertIsDefined)(l?.apiNotebook)}async showNotebookDocument(f,p){R.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let I;typeof p=="object"?I={position:n.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(n.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:I={preserveFocus:!1};const l=await this._notebookEditorsProxy.$tryShowNotebookDocument(f.uri,f.notebookType,I),M=l&&this._editors.get(l)?.apiEditor;if(M)return M;throw l?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,p,I,l){const M=this._notebookStatusBarItemProviders.get(f),o=R.URI.revive(p),i=this._documents.get(o);if(!i||!M)return;const h=i.getCellFromIndex(I);if(!h)return;const u=await M.provideCellStatusBarItems(h.apiCell,l);if(!u)return;const s=new T.DisposableStore,b=this._statusBarCache.add([s]),c=(Array.isArray(u)?u:[u]).map(S=>n.NotebookStatusBarItem.from(S,this._commandsConverter,s));return{cacheId:b,items:c}}$releaseNotebookCellStatusBarItems(f){this._statusBarCache.delete(f)}registerNotebookSerializer(f,p,I,l,M){if((0,P.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,I),this._notebookProxy.$registerNotebookSerializer(o,{id:f.identifier,location:f.extensionLocation},p,n.NotebookDocumentContentOptions.from(l),D._convertNotebookRegistrationData(f,M)),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(f,p,I){const l=this._notebookSerializer.get(f);if(!l)throw new Error("NO serializer found");const M=await l.deserializeNotebook(p.buffer,I);return new r.SerializableObjectWithBuffers(n.NotebookData.from(M))}async $notebookToData(f,p,I){const l=this._notebookSerializer.get(f);if(!l)throw new Error("NO serializer found");const M=await l.serializeNotebook(n.NotebookData.to(p.value),I);return a.VSBuffer.wrap(M)}async $openNotebook(f,p,I,l,M){const{provider:o}=this._getProviderData(f),i=await o.openNotebook(R.URI.revive(p),{backupId:I,untitledDocumentData:l?.buffer},M);return new r.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(n.NotebookCellData.from)})}async $saveNotebook(f,p,I){const l=this.getNotebookDocument(R.URI.revive(p)),{provider:M}=this._getProviderData(f);return await M.saveNotebook(l.apiNotebook,I),!0}async $saveNotebookAs(f,p,I,l){const M=this.getNotebookDocument(R.URI.revive(p)),{provider:o}=this._getProviderData(f);return await o.saveNotebookAs(R.URI.revive(I),M.apiNotebook,l),!0}async $backupNotebook(f,p,I){const l=this.getNotebookDocument(R.URI.revive(p)),M=this._getProviderData(f),o=this._extensionStoragePaths.workspaceValue(M.extension)??this._extensionStoragePaths.globalValue(M.extension),i=String((0,w.hash)([l.uri.toString(),this._backupIdPool++])),h=R.URI.joinPath(o,i),u=await M.provider.backupNotebook(l.apiNotebook,{destination:h},I);return l.updateBackup(u),u.id}_createExtHostEditor(f,p,I){if(this._editors.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const l=new d.ExtHostNotebookEditor(p,this._notebookEditorsProxy,f,I.visibleRanges.map(n.NotebookRange.to),I.selections.map(n.NotebookRange.to),typeof I.viewColumn=="number"?n.ViewColumn.to(I.viewColumn):void 0);this._editors.set(p,l)}$acceptDocumentAndEditorsDelta(f){if(f.value.removedDocuments)for(const I of f.value.removedDocuments){const l=R.URI.revive(I),M=this._documents.get(l);M&&(M.dispose(),this._documents.delete(l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:M.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(M.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===l.toString()&&this._editors.delete(o.id)}if(f.value.addedDocuments){const I=[];for(const l of f.value.addedDocuments){const M=R.URI.revive(l.uri);if(this._documents.has(M))throw new Error(`adding EXISTING notebook ${M} `);const o=this,i=new g.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(h){o._onDidChangeNotebookCells.fire(h)},emitCellOutputsChange(h){o._onDidChangeCellOutputs.fire(h)},emitCellMetadataChange(h){o._onDidChangeCellMetadata.fire(h)},emitCellExecutionStateChange(h){o._onDidChangeCellExecutionState.fire(h)}},M,l);I.push(...l.cells.map(h=>g.ExtHostCell.asModelAddData(i.apiNotebook,h))),this._documents.get(M)?.dispose(),this._documents.set(M,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:I}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(f.value.addedEditors)for(const I of f.value.addedEditors){if(this._editors.has(I.id))return;const l=R.URI.revive(I.documentUri),M=this._documents.get(l);M&&this._createExtHostEditor(M,I.id,I)}const p=[];if(f.value.removedEditors)for(const I of f.value.removedEditors){const l=this._editors.get(I);l&&(this._editors.delete(I),this._activeNotebookEditor?.id===l.id&&(this._activeNotebookEditor=void 0),p.push(l))}if(f.value.visibleEditors){this._visibleNotebookEditors=f.value.visibleEditors.map(l=>this._editors.get(l)).filter(l=>!!l);const I=new Set;this._visibleNotebookEditors.forEach(l=>I.add(l.id));for(const l of this._editors.values()){const M=I.has(l.id);l._acceptVisibility(M)}this._visibleNotebookEditors=[...this._editors.values()].map(l=>l).filter(l=>l.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}f.value.newActiveEditor===null?this._activeNotebookEditor=void 0:f.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(f.value.newActiveEditor)),f.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=D,D._notebookStatusBarItemProviderHandlePool=0}),define(Ee[195],ye([0,1,4,53,12,5,13,8]),function(ne,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(_,n){const m=C._Keys.nextId();_.$registerNotebookEditorDecorationType(m,P.NotebookDecorationRenderOptions.from(n)),this.value={key:m,dispose(){_.$removeNotebookEditorDecorationType(m)}}}}C._Keys=new t.IdGenerator("NotebookEditorDecorationType");let R=class{constructor(_,n,m){this._logService=_,this._extHostRpc=n,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new a.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new a.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(_){return new C(this._extHostRpc.getProxy(T.MainContext.MainThreadNotebookEditors),_).value}$acceptEditorPropertiesChanged(_,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,n);const m=this._notebooksAndEditors.getEditorById(_);n.visibleRanges&&m._acceptVisibleRanges(n.visibleRanges.ranges.map(P.NotebookRange.to)),n.selections&&m._acceptSelections(n.selections.selections.map(P.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const n in _)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(P.ViewColumn.to(_[n]))}};R=Be([He(0,w.ILogService),He(1,k.IExtHostRpcService)],R),e.ExtHostNotebookEditors=R}),define(Ee[196],ye([0,1,16,14,20,4,6,21,2,25,12,5,38,8,7,66,159,27,37]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m,r,g,d,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let f=class{constructor(o,i,h,u,s){this._initData=i,this._extHostNotebook=h,this._commands=u,this._logService=s,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=o.getProxy(_.MainContext.MainThreadNotebookKernels);const b=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",y=>!0,y=>{if(y&&"notebookEditor"in y&&"id"in y){const c=this._extHostNotebook.getIdByEditor(y.notebookEditor);return{id:y.id,extension:y.extension,notebookEditorId:c}}else if(y&&"notebookEditor"in y){const c=this._extHostNotebook.getIdByEditor(y.notebookEditor);if(c===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${y.notebookEditor.document.uri.toString()}`);return{notebookEditorId:c}}return y})],n.ApiCommandResult.Void);this._commands.registerApiCommand(b)}createNotebookController(o,i,h,u,s,b){for(let ie of this._kernelData.values())if(ie.controller.id===i&&R.ExtensionIdentifier.equals(o.identifier,ie.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const y=this._handlePool++,c=this;this._logService.trace(`NotebookController[${y}], CREATED by ${o.identifier.value}, ${i}`);const S=()=>console.warn(`NO execute handler from notebook controller '${L.id}' of extension: '${o.identifier}'`);let A=!1;const U=new k.DisposableStore,H=new T.Emitter,E=new T.Emitter,L={id:`${o.identifier.value}/${i}`,notebookType:h,extensionId:o.identifier,extensionLocation:o.extensionLocation,label:u||o.identifier.value,preloads:b?b.map(m.NotebookRendererScript.from):[]};let z=s??S,N;this._proxy.$addKernel(y,L).catch(ie=>{console.log(ie),A=!0});let $=0;const j=()=>{if(A)return;const ie=++$;Promise.resolve().then(()=>{ie===$&&this._proxy.$updateKernel(y,L)})},ue=new P.ResourceMap,K={get id(){return i},get notebookType(){return L.notebookType},onDidChangeSelectedNotebooks:H.event,get label(){return L.label},set label(ie){L.label=ie??o.displayName??o.name,j()},get detail(){return L.detail??""},set detail(ie){L.detail=ie,j()},get description(){return L.description??""},set description(ie){L.description=ie,j()},get kind(){return(0,D.checkProposedApiEnabled)(o,"notebookControllerKind"),L.kind??""},set kind(ie){(0,D.checkProposedApiEnabled)(o,"notebookControllerKind"),L.kind=ie,j()},get supportedLanguages(){return L.supportedLanguages},set supportedLanguages(ie){L.supportedLanguages=ie,j()},get supportsExecutionOrder(){return L.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){L.supportsExecutionOrder=ie,j()},get rendererScripts(){return L.preloads?L.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(ie){z=ie??S},get interruptHandler(){return N},set interruptHandler(ie){N=ie,L.supportsInterrupt=Boolean(ie),j()},createNotebookCellExecution(ie){if(A)throw new Error("notebook controller is DISPOSED");if(!ue.has(ie.notebook.uri))throw c._logService.trace(`NotebookController[${y}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(pe=>pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return c._createNotebookCellExecution(ie)},dispose:()=>{A||(this._logService.trace(`NotebookController[${y}], DISPOSED`),A=!0,this._kernelData.delete(y),U.dispose(),H.dispose(),E.dispose(),this._proxy.$removeKernel(y))},updateNotebookAffinity(ie,pe){c._proxy.$updateNotebookPriority(y,ie.uri,pe)},onDidReceiveMessage:E.event,postMessage(ie,pe){return(0,D.checkProposedApiEnabled)(o,"notebookMessaging"),c._proxy.$postMessage(y,pe&&c._extHostNotebook.getIdByEditor(pe),ie)},asWebviewUri(ie){return(0,D.checkProposedApiEnabled)(o,"notebookMessaging"),(0,g.asWebviewUri)(ie,c._initData.remote)}};return this._kernelData.set(y,{extensionId:o.identifier,controller:K,onDidReceiveMessage:E,onDidChangeSelection:H,associatedNotebooks:ue}),K}$acceptNotebookAssociation(o,i,h){const u=this._kernelData.get(o);if(u){const s=this._extHostNotebook.getNotebookDocument(C.URI.revive(i));h?u.associatedNotebooks.set(s.uri,!0):u.associatedNotebooks.delete(s.uri),this._logService.trace(`NotebookController[${o}] ASSOCIATE notebook`,s.uri.toString(),h),u.onDidChangeSelection.fire({selected:h,notebook:s.apiNotebook})}}async $executeCells(o,i,h){const u=this._kernelData.get(o);if(!u)return;const s=this._extHostNotebook.getNotebookDocument(C.URI.revive(i)),b=[];for(let y of h){const c=s.getCell(y);c&&b.push(c.apiCell)}try{this._logService.trace(`NotebookController[${o}] EXECUTE cells`,s.uri.toString(),b.length),await u.controller.executeHandler.call(u.controller,b,s.apiNotebook,u.controller)}catch(y){this._logService.error(`NotebookController[${o}] execute cells FAILED`,y),console.error(y)}}async $cancelCells(o,i,h){const u=this._kernelData.get(o);if(!u)return;const s=this._extHostNotebook.getNotebookDocument(C.URI.revive(i));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,s.apiNotebook);else for(let b of h){const y=s.getCell(b);y&&this._activeExecutions.get(y.uri)?.cancel()}}$acceptKernelMessageFromRenderer(o,i,h){const u=this._kernelData.get(o);if(!u)return;const s=this._extHostNotebook.getEditorById(i);u.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:h}))}_createNotebookCellExecution(o){if(o.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const h=this._extHostNotebook.getNotebookDocument(o.notebook.uri).getCellFromApiCell(o);if(!h)throw new Error("invalid cell");if(this._activeExecutions.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const u=new I(h.notebook,h,this._proxy);this._activeExecutions.set(h.uri,u);const s=u.onDidChangeState(()=>{u.state===p.Resolved&&(u.dispose(),s.dispose(),this._activeExecutions.delete(h.uri))});return u.asApiObject()}};f=Be([He(4,F.ILogService)],f),e.ExtHostNotebookKernels=f;var p;(function(M){M[M.Init=0]="Init",M[M.Started=1]="Started",M[M.Resolved=2]="Resolved"})(p||(p={}));class I extends k.Disposable{constructor(o,i,h){super();this._document=o,this._cell=i,this._proxy=h,this._handle=I.HANDLE++,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=p.Init,this._tokenSource=this._register(new w.CancellationTokenSource),this._collector=new l(10,u=>this.update(u)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(o){await this._collector.addItem(o)}async update(o){const i=Array.isArray(o)?o:[o];return this._proxy.$updateExecutions(new v.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===p.Init)throw new Error("Must call start before modifying cell output");if(this._state===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(o){let i=this._cell;if(o&&(i=this._document.getCellFromApiCell(o)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(o){return o.map(i=>{const h=r.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return h===i.items?m.NotebookCellOutput.from(i):m.NotebookCellOutput.from({items:h,id:i.id,metadata:i.metadata})})}async updateOutputs(o,i,h){const u=this.cellIndexToHandle(i),s=this.validateAndConvertOutputs((0,a.asArray)(o));return this.updateSoon({editType:d.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:u,append:h,outputs:s})}async updateOutputItems(o,i,h){return o=r.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(o),!0),this.updateSoon({editType:d.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:o.map(m.NotebookCellOutputItem.from),outputId:i.id,append:h})}asApiObject(){const o=this;return Object.freeze({get token(){return o._tokenSource.token},get cell(){return o._cell.apiCell},get executionOrder(){return o._executionOrder},set executionOrder(h){o._executionOrder=h,o.update([{editType:d.CellExecutionUpdateType.ExecutionState,executionHandle:o._handle,executionOrder:o._executionOrder}])},start(h){if(o._state===p.Resolved||o._state===p.Started)throw new Error("Cannot call start again");o._state=p.Started,o._onDidChangeState.fire(),o.update({editType:d.CellExecutionUpdateType.ExecutionState,executionHandle:o._handle,runStartTime:h})},end(h,u){if(o._state===p.Resolved)throw new Error("Cannot call resolve twice");o._state=p.Resolved,o._onDidChangeState.fire(),o.updateSoon({editType:d.CellExecutionUpdateType.Complete,executionHandle:o._handle,runEndTime:u,lastRunSuccess:h}),o._collector.flush(),o._proxy.$removeExecution(o._handle)},clearOutput(h){return o.verifyStateForOutput(),o.updateOutputs([],h,!1)},appendOutput(h,u){return o.verifyStateForOutput(),o.updateOutputs(h,u,!0)},replaceOutput(h,u){return o.verifyStateForOutput(),o.updateOutputs(h,u,!1)},appendOutputItems(h,u){return o.verifyStateForOutput(),o.updateOutputItems(h,u,!0)},replaceOutputItems(h,u){return o.verifyStateForOutput(),o.updateOutputItems(h,u,!1)}})}}I.HANDLE=0;class l{constructor(o,i){this.delay=o,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(o){return this.batch.push(o),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const o=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>o.complete())}}}),define(Ee[197],ye([0,1,4,5,91,27]),function(ne,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class k{constructor(C,R){this._extHostNotebook=R,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,R,F){const _=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(R)?.fire({editor:_.apiEditor,message:F})}createRendererMessaging(C,R){if(!C.contributes?.notebookRenderer?.some(m=>m.id===R))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${R})`);const F=(0,T.isProposedApiEnabled)(C,"notebookEditor"),_=new WeakMap;return{onDidReceiveMessage:(m,r,g)=>{const d=F?m:D=>{const v={};_.set(v,D.editor),m({editor:v,message:D.message})};return this.getOrCreateEmitterFor(R).event(d,r,g)},postMessage:(m,r)=>{w.ExtHostNotebookEditor.apiEditorsToExtHost.has(m)&&([m,r]=[r,m]);const g=F?r:_.get(r),d=g&&w.ExtHostNotebookEditor.apiEditorsToExtHost.get(g);return this.proxy.$postMessage(d?.id,R,m)}}}getOrCreateEmitterFor(C){let R=this._rendererMessageEmitters.get(C);return R||(R=new a.Emitter({onLastListenerRemove:()=>{R?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,R),R)}}e.ExtHostNotebookRenderers=k}),define(Ee[94],ye([0,1,5,6,3,13,12,160,49,28,30,110,22]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class m extends t.Disposable{constructor(d,D,v,f){super();this.id=d,this.name=D,this.logger=v,this.proxy=f,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(d){this.append(d+`
`)}append(d){this.write(d),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}clear(){const d=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,d)}replace(d){const D=this.offset;this.write(d),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,D),this.visible&&this.logger.flush()}show(d,D){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof d=="boolean"?d:D))}hide(){this.proxy.$close(this.id)}write(d){this.offset+=n.VSBuffer.fromString(d).byteLength,this.logger.info(d)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=m;let r=class{constructor(d,D,v,f,p){this.extHostFileSystem=v,this.extHostFileSystemInfo=f,this.loggerService=p,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=d.getProxy(a.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(D.logsLocation,`output_logging_${(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(d){this.visibleChannelId=d;for(const[D,v]of this.channels)v.visible=D===this.visibleChannelId}createOutputChannel(d,D){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");const v=this.doCreateOutputChannel(d,D);return v.then(f=>{this.channels.set(f.id,f),f.visible=f.id===this.visibleChannelId}),this.createExtHostOutputChannel(d,v)}async doCreateOutputChannel(d,D){const v=await this.createOutputDirectory(),f=this.extHostFileSystemInfo.extUri.joinPath(v,`${this.namePool++}-${d.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),p=this.loggerService.createLogger(f,{always:!0,donotRotate:!0,donotUseFormatters:!0}),I=await this.proxy.$register(d,!1,f,D.identifier.value);return new m(I,d,p,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(d,D){let v=!1;const f=()=>{if(v)throw new Error("Channel has been closed")};return{get name(){return d},append(p){f(),D.then(I=>I.append(p))},appendLine(p){f(),D.then(I=>I.appendLine(p))},clear(){f(),D.then(p=>p.clear())},replace(p){f(),D.then(I=>I.replace(p))},show(p,I){f(),D.then(l=>l.show(p,I))},hide(){f(),D.then(p=>p.hide())},dispose(){v=!0,D.then(p=>p.dispose())}}}};r=Be([He(0,T.IExtHostRpcService),He(1,R.IExtHostInitDataService),He(2,C.IExtHostConsumerFileSystem),He(3,F.IExtHostFileSystemInfo),He(4,k.ILoggerService)],r),e.ExtHostOutputService=r,e.IExtHostOutputService=(0,w.createDecorator)("IExtHostOutputService")}),define(Ee[198],ye([0,1,14,20,4,6,5,2,7,15,16,34,62,27]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function r(g,d,D){const v=g.getProxy(k.MainContext.MainThreadQuickOpen);class f{constructor(s,b){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=b}showQuickPick(s,b,y=t.CancellationToken.None){this._onDidSelectItem=void 0;const c=Promise.resolve(s),S=++this._instances,A=v.$show(S,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},y),U={},H=A.then(()=>U);return Promise.race([H,c]).then(E=>{if(E!==U)return c.then(L=>{const z=[];for(let N=0;N<L.length;N++){const $=L[N];typeof $=="string"?z.push({label:$,handle:N}):$.kind===C.QuickPickItemKind.Separator?z.push({type:"separator",label:$.label}):z.push({label:$.label,description:$.description,detail:$.detail,picked:$.picked,alwaysShow:$.alwaysShow,handle:N})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=N=>{b.onDidSelectItem(L[N])}),v.$setItems(S,z),A.then(N=>{if(typeof N=="number")return L[N];if(Array.isArray(N))return N.map($=>L[$])})})}).then(void 0,E=>{if(!(0,R.isPromiseCanceledError)(E))return v.$setError(S,E),Promise.reject(E)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,b=t.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,v.$input(s,typeof this._validateInput=="function",b).then(void 0,y=>{if(!(0,R.isPromiseCanceledError)(y))return Promise.reject(y)})}$validateInput(s){return this._validateInput?(0,a.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,b=t.CancellationToken.None){const y=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!y)return;const c=await this._workspace.getWorkspaceFolders2();if(!!c)return c.find(S=>S.uri.toString()===y.uri.toString())}createQuickPick(s){const b=new i(s,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(s){const b=new h(s,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}$onDidChangeValue(s,b){const y=this._sessions.get(s);y&&y._fireDidChangeValue(b)}$onDidAccept(s){const b=this._sessions.get(s);b&&b._fireDidAccept()}$onDidChangeActive(s,b){const y=this._sessions.get(s);y instanceof i&&y._fireDidChangeActive(b)}$onDidChangeSelection(s,b){const y=this._sessions.get(s);y instanceof i&&y._fireDidChangeSelection(b)}$onDidTriggerButton(s,b){const y=this._sessions.get(s);y&&y._fireDidTriggerButton(b)}$onDidTriggerItemButton(s,b,y){const c=this._sessions.get(s);c instanceof i&&c._fireDidTriggerItemButton(b,y)}$onDidHide(s){const b=this._sessions.get(s);b&&b._fireDidHide()}}class p{constructor(s,b){this._extensionId=s,this._onDidDispose=b,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new w.Emitter,this._onDidChangeValueEmitter=new w.Emitter,this._onDidTriggerButtonEmitter=new w.Emitter,this._onDidHideEmitter=new w.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((b,y)=>{const c=b===C.QuickInputButtons.Back?-1:y;this._handlesToButtons.set(c,b)}),this.update({buttons:s.map((b,y)=>({...o(b),tooltip:b.tooltip,handle:b===C.QuickInputButtons.Back?-1:y}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const b=this._handlesToButtons.get(s);b&&this._onDidTriggerButtonEmitter.fire(b)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),v.$dispose(this._id))}update(s){if(!this._disposed){for(const b of Object.keys(s)){const y=s[b];this._pendingUpdate[b]=y===void 0?null:y}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){v.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}p._nextId=1;function I(u){if(u instanceof C.ThemeIcon)return{id:u.id};const s=M(u),b=l(u);return{dark:typeof s=="string"?P.URI.file(s):s,light:typeof b=="string"?P.URI.file(b):b}}function l(u){return typeof u=="object"&&"light"in u?u.light:u}function M(u){return typeof u=="object"&&"dark"in u?u.dark:u}function o(u){const s=I(u.iconPath);let b,y;return"id"in s?y=n.ThemeIcon.asClassName(s):b=s,{iconPath:b,iconClass:y}}class i extends p{constructor(s,b){super(s.identifier,b);this.extension=s,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new w.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new w.Emitter,this._onDidTriggerItemButtonEmitter=new w.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){s.some(y=>y.kind!==void 0)&&(0,m.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((y,c)=>{this._handlesToItems.set(c,y),this._itemsToHandles.set(y,c)});const b=[];for(let y=0;y<s.length;y++){const c=s[y];c.kind===C.QuickPickItemKind.Separator?b.push({type:"separator",label:c.label}):b.push({handle:y,label:c.label,description:c.description,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow,buttons:c.buttons?.map((S,A)=>({...o(S),tooltip:S.tooltip,handle:A}))})}this.update({items:b})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(b=>this._itemsToHandles.has(b)),this.update({activeItems:this._activeItems.map(b=>this._itemsToHandles.get(b))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(b=>this._itemsToHandles.has(b)),this.update({selectedItems:this._selectedItems.map(b=>this._itemsToHandles.get(b))})}_fireDidChangeActive(s){const b=(0,F.coalesce)(s.map(y=>this._handlesToItems.get(y)));this._activeItems=b,this._onDidChangeActiveEmitter.fire(b)}_fireDidChangeSelection(s){const b=(0,F.coalesce)(s.map(y=>this._handlesToItems.get(y)));this._selectedItems=b,this._onDidChangeSelectionEmitter.fire(b)}_fireDidTriggerItemButton(s,b){const y=this._handlesToItems.get(s);if(!y||!y.buttons||!y.buttons.length)return;const c=y.buttons[b];c&&this._onDidTriggerItemButtonEmitter.fire({button:c,item:y})}}class h extends p{constructor(s,b){super(s,b);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?_.default.Error:_.default.Ignore})}}return new f(d,D)}e.createExtHostQuickOpen=r}),define(Ee[199],ye([0,1,2,4,52,6,14,5,16,105,12,25,62,8,27]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(u){if(u)return typeof u.iconPath=="string"?a.URI.file(u.iconPath):a.URI.isUri(u.iconPath)||n.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function d(u,s){if(!u.iconPath&&!s.iconPath)return 0;if(u.iconPath){if(!s.iconPath)return 1}else return-1;const b=typeof u.iconPath=="string"?u.iconPath:a.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,y=typeof s.iconPath=="string"?s.iconPath:a.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id;return(0,R.comparePaths)(b,y)}function D(u,s){let b=0;if(u.strikeThrough!==s.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==s.faded)return u.faded?1:-1;if(u.tooltip!==s.tooltip)return(u.tooltip||"").localeCompare(s.tooltip||"");if(b=d(u,s),b!==0)return b;if(u.light&&s.light)b=d(u.light,s.light);else{if(u.light)return 1;if(s.light)return-1}if(b!==0)return b;if(u.dark&&s.dark)b=d(u.dark,s.dark);else{if(u.dark)return 1;if(s.dark)return-1}return b}function v(u,s){if(u.command!==s.command)return u.command<s.command?-1:1;if(u.title!==s.title)return u.title<s.title?-1:1;if(u.tooltip!==s.tooltip){if(u.tooltip!==void 0&&s.tooltip!==void 0)return u.tooltip<s.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(u.arguments===s.arguments)return 0;if(u.arguments)if(s.arguments){if(u.arguments.length!==s.arguments.length)return u.arguments.length-s.arguments.length}else return 1;else return-1;for(let b=0;b<u.arguments.length;b++){const y=u.arguments[b],c=s.arguments[b];if(y!==c)return y<c?-1:1}return 0}function f(u,s){let b=(0,R.comparePaths)(u.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(b!==0)return b;if(u.command&&s.command)b=v(u.command,s.command);else{if(u.command)return 1;if(s.command)return-1}if(b!==0)return b;if(u.decorations&&s.decorations)b=D(u.decorations,s.decorations);else{if(u.decorations)return 1;if(s.decorations)return-1}return b}function p(u,s){for(let b=0;b<u.length;b++)if(u[b]!==s[b])return!1;return!0}function I(u,s){return u.command===s.command&&u.title===s.title&&u.tooltip===s.tooltip&&(u.arguments&&s.arguments?p(u.arguments,s.arguments):u.arguments===s.arguments)}function l(u,s){return(0,C.equals)(u,s,I)}class M{constructor(s,b,y){this._extension=s,this._proxy=b,this._sourceControlHandle=y,this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(s){s=s??"",this._proxy.$setInputBoxValue(this._sourceControlHandle,s),this.updateValue(s)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(s){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,s),this._placeholder=s}get validateInput(){return(0,r.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(s){if((0,r.checkProposedApiEnabled)(this._extension,"scmValidation"),s&&typeof s!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=s,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!s)}get visible(){return this._visible}set visible(s){s=!!s,this._visible!==s&&(this._visible=s,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,s))}showValidationMessage(s,b){(0,r.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,s,b)}$onInputBoxValueChange(s){this.updateValue(s)}updateValue(s){this._value=s,this._onDidChange.fire(s)}}e.ExtHostSCMInputBox=M;class o{constructor(s,b,y,c,S){this._proxy=s,this._commands=b,this._sourceControlHandle=y,this._id=c,this._label=S,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=o._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(s){this._label=s,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,s)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(s){this._hideWhenEmpty=s,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(s){this._resourceStates=[...s],this._onDidUpdateResourceStates.fire()}getResourceState(s){return this._resourceStatesMap.get(s)}$executeResourceCommand(s,b){const y=this._resourceStatesCommandsMap.get(s);return y?(0,k.asPromise)(()=>this._commands.executeCommand(y.command,...y.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const s=[...this._resourceStates].sort(f),y=(0,C.sortedDiff)(this._resourceSnapshot,s,f).map(A=>{const U=A.toInsert.map(H=>{const E=this._resourceHandlePool++;this._resourceStatesMap.set(E,H);const L=H.resourceUri;let z;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"){const le=new T.DisposableStore;z=this._commands.converter.toInternal(H.command,le),this._resourceStatesDisposablesMap.set(E,le)}else this._resourceStatesCommandsMap.set(E,H.command);const N=g(H.decorations),$=H.decorations&&g(H.decorations.light)||N,j=H.decorations&&g(H.decorations.dark)||N,ue=[$,j],K=H.decorations&&H.decorations.tooltip||"",ie=H.decorations&&!!H.decorations.strikeThrough,pe=H.decorations&&!!H.decorations.faded,we=H.contextValue||"";return{rawResource:[E,L,ue,K,ie,pe,we,z],handle:E}});return{start:A.start,deleteCount:A.deleteCount,toInsert:U}}),c=y.map(({start:A,deleteCount:U,toInsert:H})=>[A,U,H.map(E=>E.rawResource)]),S=y.reverse();for(const{start:A,deleteCount:U,toInsert:H}of S){const E=H.map(z=>z.handle),L=this._handlesSnapshot.splice(A,U,...E);for(const z of L)this._resourceStatesMap.delete(z),this._resourceStatesCommandsMap.delete(z),this._resourceStatesDisposablesMap.get(z)?.dispose(),this._resourceStatesDisposablesMap.delete(z)}return this._resourceSnapshot=s,c}dispose(){this._disposed=!0,this._onDidDispose.fire()}}o._handlePool=0;class i{constructor(s,b,y,c,S,A){this._extension=s,this._proxy=b,this._commands=y,this._id=c,this._label=S,this._rootUri=A,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new T.MutableDisposable,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new M(s,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,c,S,A)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(s){this._count!==s&&(this._count=s,this._proxy.$updateSourceControl(this.handle,{count:s}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(s){this._quickDiffProvider=s,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!s})}get commitTemplate(){return this._commitTemplate}set commitTemplate(s){s!==this._commitTemplate&&(this._commitTemplate=s,this._proxy.$updateSourceControl(this.handle,{commitTemplate:s}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(s){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=s;const b=this._commands.converter.toInternal(s,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:b})}get actionButton(){return(0,r.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(s){(0,r.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new T.DisposableStore,this._actionButton=s;const b=s!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:b??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(s){if(this._statusBarCommands&&s&&l(this._statusBarCommands,s))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=s;const b=(s||[]).map(y=>this._commands.converter.toInternal(y,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(s,b){const y=new o(this._proxy,this._commands,this.handle,s,b),c=t.Event.once(y.onDidDispose)(()=>this.createdResourceGroups.delete(y));return this.createdResourceGroups.set(y,c),this.eventuallyAddResourceGroups(),y}eventuallyAddResourceGroups(){const s=[],b=[];for(const[y,c]of this.createdResourceGroups){c.dispose();const S=y.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(y),this.eventuallyUpdateResourceStates()});t.Event.once(y.onDidDispose)(()=>{this.updatedResourceGroups.delete(y),S.dispose(),this._groups.delete(y.handle),this._proxy.$unregisterGroup(this.handle,y.handle)}),s.push([y.handle,y.id,y.label,y.features]);const A=y._takeResourceStateSnapshot();A.length>0&&b.push([y.handle,A]),this._groups.set(y.handle,y)}this._proxy.$registerGroups(this.handle,s,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const s=[];this.updatedResourceGroups.forEach(b=>{const y=b._takeResourceStateSnapshot();y.length!==0&&s.push([b.handle,y])}),s.length>0&&this._proxy.$spliceResourceStates(this.handle,s),this.updatedResourceGroups.clear()}getResourceGroup(s){return this._groups.get(s)}setSelectionState(s){this._selected=s,this._onDidChangeSelection.fire(s)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(s=>s.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Be([(0,w.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),Be([(0,w.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let h=class zi{constructor(s,b,y){this._commands=b,this.logService=y,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=s.getProxy(P.MainContext.MainThreadSCM),this._telemetry=s.getProxy(P.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===3){const S=this._sourceControls.get(c.sourceControlHandle);if(!S)return c;const A=S.getResourceGroup(c.groupHandle);return A?A.getResourceState(c.handle):c}else if(c&&c.$mid===4){const S=this._sourceControls.get(c.sourceControlHandle);return S?S.getResourceGroup(c.groupHandle):c}else if(c&&c.$mid===5){const S=this._sourceControls.get(c.handle);return S||c}return c}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(s,b,y,c){this.logService.trace("ExtHostSCM#createSourceControl",s.identifier.value,b,y,c),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const S=zi._handlePool++,A=new i(s,this._proxy,this._commands,b,y,c);this._sourceControls.set(S,A);const U=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(s.identifier))||[];return U.push(A),this._sourceControlsByExtension.set(_.ExtensionIdentifier.toKey(s.identifier),U),A}getLastInputBox(s){this.logService.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const b=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(s.identifier)),y=b&&b[b.length-1];return y&&y.inputBox}$provideOriginalResource(s,b,y){const c=a.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",s,c.toString());const S=this._sourceControls.get(s);return!S||!S.quickDiffProvider||!S.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,k.asPromise)(()=>S.quickDiffProvider.provideOriginalResource(c,y)).then(A=>A||null)}$onInputBoxValueChange(s,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",s);const y=this._sourceControls.get(s);return y&&y.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(s,b,y,c){this.logService.trace("ExtHostSCM#$executeResourceCommand",s,b,y);const S=this._sourceControls.get(s);if(!S)return Promise.resolve(void 0);const A=S.getResourceGroup(b);return A?A.$executeResourceCommand(y,c):Promise.resolve(void 0)}$validateInput(s,b,y){this.logService.trace("ExtHostSCM#$validateInput",s);const c=this._sourceControls.get(s);return!c||!c.inputBox.validateInput?Promise.resolve(void 0):(0,k.asPromise)(()=>c.inputBox.validateInput(b,y)).then(S=>{if(!S)return Promise.resolve(void 0);const A=m.MarkdownString.fromStrict(S.message);return A?Promise.resolve([A,S.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(s){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&this._sourceControls.get(s)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=s,Promise.resolve(void 0)}};h._handlePool=0,h=Be([He(2,F.ILogService)],h),e.ExtHostSCM=h});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(ne,a):w?w.value=a:e.set(ne,a),a},Re=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Ee[200],ye([0,1,7,5,122,6,8,11]),function(ne,e,a,t,w,T,k,P){"use strict";var C,R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class F{constructor(r,g,d,D,v=a.StatusBarAlignment.Left,f){C.set(this,void 0),R.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,Ze(this,C,r,"f"),Ze(this,R,g,"f"),this._entryId=F.ID_GEN++,this._extension=d,this._id=D,this._alignment=v,this._priority=this.validatePriority(f)}validatePriority(r){if(!!(0,P.isNumber)(r))return r===Number.POSITIVE_INFINITY?Number.MAX_VALUE:r===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:r}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(r){this._text=r,this.update()}set name(r){this._name=r,this.update()}set tooltip(r){this._tooltip=r,this.update()}set color(r){this._color=r,this.update()}set backgroundColor(r){r&&!F.ALLOWED_BACKGROUND_COLORS.has(r.id)&&(r=void 0),this._backgroundColor=r,this.update()}set command(r){this._command?.fromApi!==r&&(this._internalCommandRegistration.clear(),typeof r=="string"?this._command={fromApi:r,internal:Re(this,R,"f").toInternal({title:"",command:r},this._internalCommandRegistration)}:r?this._command={fromApi:r,internal:Re(this,R,"f").toInternal(r,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(r){this._accessibilityInformation=r,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Re(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let r;this._extension?this._id?r=`${this._extension.identifier.value}.${this._id}`:r=this._extension.identifier.value:r=this._id;let g;this._name?g=this._name:g=(0,w.localize)(0,null,this._extension.displayName||this._extension.name);let d=this._color;this._backgroundColor&&(d=F.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const D=this._tooltip?k.MarkdownString.fromStrict(this._tooltip):void 0;Re(this,C,"f").$setEntry(this._entryId,r,g,this._text,D,this._command?.internal,d,this._backgroundColor,this._alignment===a.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=F,C=new WeakMap,R=new WeakMap,F.ID_GEN=0,F.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]);class _{constructor(r){this._messages=[],this._item=r.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,w.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(r){const g={message:r};return this._messages.unshift(g),this._update(),new a.Disposable(()=>{const d=this._messages.indexOf(g);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(r,g){this._proxy=r.getProxy(t.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new _(this)}createStatusBarEntry(r,g,d,D){return new F(this._proxy,this._commands,r,g,d,D)}setStatusBarMessage(r,g){const d=this._statusMessage.setMessage(r);let D;return typeof g=="number"?D=setTimeout(()=>d.dispose(),g):typeof g!="undefined"&&g.then(()=>d.dispose(),()=>d.dispose()),new a.Disposable(()=>{d.dispose(),clearTimeout(D)})}}e.ExtHostStatusBar=n}),define(Ee[71],ye([0,1,5,4,3]),function(ne,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(P){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,C){this._proxy.$registerExtensionStorageKeysToSync(P,C)}getValue(P,C,R){return this._proxy.$getValue(P,C).then(F=>F||R)}setValue(P,C,R){return this._proxy.$setValue(P,C,R)}$acceptValue(P,C,R){this._onDidChangeStorage.fire({shared:P,key:C,value:R})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,w.createDecorator)("IExtHostStorage")}),define(Ee[72],ye([0,1,3,28,12,49,2]),function(ne,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let P=class{constructor(R,F,_){this._logService=F,this._extHostFileSystem=_,this._workspace=R.workspace??void 0,this._environment=R.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(R){return k.URI.joinPath(this._environment.workspaceStorageHome,R)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const R=this._workspace.id,F=await this._getWorkspaceStorageURI(R);try{return await this._extHostFileSystem.value.stat(F),this._logService.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",F),await this._extHostFileSystem.value.createDirectory(F),await this._extHostFileSystem.value.writeFile(k.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:k.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),F}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(R){if(this._value)return k.URI.joinPath(this._value,R.identifier.value)}globalValue(R){return k.URI.joinPath(this._environment.globalStorageHome,R.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=Be([He(0,t.IExtHostInitDataService),He(1,w.ILogService),He(2,T.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(Ee[39],ye([0,1,4,5,3,2,13,6,7,123,15,162,20,35,145,62,11,14]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m,r,g,d,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,w.createDecorator)("IExtHostTerminalService");class v{constructor(u,s,b,y){this._proxy=u,this._id=s,this._creationOptions=b,this._name=y,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(S=>this._pidPromiseComplete=S);const c=this;this.value={get name(){return c._name||""},get processId(){return c._pidPromise},get creationOptions(){return c._creationOptions},get exitStatus(){return c._exitStatus},get state(){return c._state},sendText(S,A=!0){c._checkDisposed(),c._proxy.$sendText(c._id,S,A)},show(S){c._checkDisposed(),c._proxy.$show(c._id,S)},hide(){c._checkDisposed(),c._proxy.$hide(c._id)},dispose(){c._disposed||(c._disposed=!0,c._proxy.$dispose(c._id))},get dimensions(){if(!(c._cols===void 0||c._rows===void 0))return{columns:c._cols,rows:c._rows}}}}async create(u,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:u.name,shellPath:(0,d.withNullAsUndefined)(u.shellPath),shellArgs:(0,d.withNullAsUndefined)(u.shellArgs),cwd:(0,d.withNullAsUndefined)(u.cwd),env:(0,d.withNullAsUndefined)(u.env),icon:(0,d.withNullAsUndefined)(o(u.iconPath)),color:g.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:(0,d.withNullAsUndefined)(u.message),strictEnv:(0,d.withNullAsUndefined)(u.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(u.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this._serializeParentTerminal(u.location,s?.resolvedExtHostIdentifier),disablePersistence:(0,d.withNullAsUndefined)(u.disablePersistence)})}async createExtensionTerminal(u,s,b,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:b,color:g.ThemeColor.isThemeColor(y)?y.id:void 0,location:this._serializeParentTerminal(u,s),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(u,s){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in u?{viewColumn:u.viewColumn,preserveFocus:u.preserveFocus}:void 0:u}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(u){this._name=u}setExitCode(u){this._exitStatus=Object.freeze({code:u})}setDimensions(u,s){return u===this._cols&&s===this._rows||u===0||s===0?!1:(this._cols=u,this._rows=s,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(u){this._pidPromiseComplete?(this._pidPromiseComplete(u),this._pidPromiseComplete=void 0):this._pidPromise.then(s=>{s!==u&&(this._pidPromise=Promise.resolve(u))})}}e.ExtHostTerminal=v;class f{constructor(u){this._pty=u,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new a.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new a.Emitter,this._onDidChangeProperty=new a.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new a.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${s}`)}async start(){}shutdown(){this._pty.close()}input(u){this._pty.handleInput?.(u)}resize(u,s){this._pty.setDimensions?.({columns:u,rows:s})}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(u){this._pty.onDidWrite(s=>this._onProcessData.fire(s)),this._pty.onDidClose?.((s=void 0)=>{this._onProcessExit.fire(s===void 0?void 0:s)}),this._pty.onDidOverrideDimensions?.(s=>{s&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this._pty.onDidChangeName?.(s=>{this._onDidChangeProperty.fire({type:"title",value:s})}),this._pty.open(u||void 0),u&&this._pty.setDimensions?.(u),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=f;let p=1,I=class extends P.Disposable{constructor(u,s){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new a.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new a.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new a.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new a.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new a.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=s.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new a.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(u),this._register({dispose:()=>{for(const[b,y]of this._terminalProcesses)y.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(u=>u.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(u,s){const b=new v(this._proxy,(0,m.generateUuid)(),u,u.name),y=new f(u.pty);return b.createExtensionTerminal(u.location,this._serializeParentTerminal(u,s).resolvedExtHostIdentifier,o(u.iconPath),i(u.color)).then(c=>{const S=this._setupExtHostProcessListeners(c,y);this._terminalProcessDisposables[c]=S}),this._terminals.push(b),b.value}_serializeParentTerminal(u,s){if(s=s||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const b=u.location.parentTerminal;if(b){const y=this._terminals.find(c=>c.value===b);y&&(s.resolvedExtHostIdentifier=y._id)}}else u.location&&typeof u.location!="object"?s.location=u.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(u,s){if(!this._getTerminalById(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const y=new f(s),c=this._setupExtHostProcessListeners(u,y);this._terminalProcessDisposables[u]=c}async $acceptActiveTerminalChanged(u){const s=this._activeTerminal;if(u===null){this._activeTerminal=void 0,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const b=this._getTerminalById(u);b&&(this._activeTerminal=b,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(u,s){const b=this._getTerminalById(u);b&&this._onDidWriteTerminalData.fire({terminal:b.value,data:s})}async $acceptTerminalDimensions(u,s,b){const y=this._getTerminalById(u);y&&y.setDimensions(s,b)&&this._onDidChangeTerminalDimensions.fire({terminal:y.value,dimensions:y.value.dimensions})}async $acceptTerminalMaximumDimensions(u,s,b){this._terminalProcesses.get(u)?.resize(s,b)}async $acceptTerminalTitleChange(u,s){const b=this._getTerminalById(u);b&&(b.name=s)}async $acceptTerminalClosed(u,s){const b=this._getTerminalObjectIndexById(this._terminals,u);if(b!==null){const y=this._terminals.splice(b,1)[0];y.setExitCode(s),this._onDidCloseTerminal.fire(y.value)}}$acceptTerminalOpened(u,s,b,y){if(s){const A=this._getTerminalObjectIndexById(this._terminals,s);if(A!==null){this._terminals[A]._id=u,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const c={name:y.name,shellPath:y.executable,shellArgs:y.args,cwd:typeof y.cwd=="string"?y.cwd:T.URI.revive(y.cwd),env:y.env,hideFromUser:y.hideFromUser},S=new v(this._proxy,u,c,b);this._terminals.push(S),this._onDidOpenTerminal.fire(S.value),S.isOpen=!0}async $acceptTerminalProcessId(u,s){const b=this._getTerminalById(u);b&&b._setProcessId(s)}async $startExtensionTerminal(u,s){const b=this._getTerminalById(u);if(!b)return{message:(0,R.localize)(0,null,u)};b.isOpen||await new Promise(c=>{const S=this.onDidOpenTerminal(async A=>{A===b.value&&(S.dispose(),c())})});const y=this._terminalProcesses.get(u);y?y.startSendingEvents(s):this._extensionTerminalAwaitingStart[u]={initialDimensions:s}}_setupExtHostProcessListeners(u,s){const b=new P.DisposableStore;b.add(s.onProcessReady(c=>this._proxy.$sendProcessReady(u,c.pid,c.cwd))),b.add(s.onDidChangeProperty(c=>this._proxy.$sendProcessProperty(u,c))),this._bufferer.startBuffering(u,s.onProcessData),b.add(s.onProcessExit(c=>this._onProcessExit(u,c))),this._terminalProcesses.set(u,s);const y=this._extensionTerminalAwaitingStart[u];return y&&s instanceof f&&(s.startSendingEvents(y.initialDimensions),delete this._extensionTerminalAwaitingStart[u]),b}$acceptProcessAckDataEvent(u,s){this._terminalProcesses.get(u)?.acknowledgeDataEvent(s)}$acceptProcessInput(u,s){this._terminalProcesses.get(u)?.input(s)}$acceptTerminalInteraction(u){const s=this._getTerminalById(u);s?.setInteractedWith()&&this._onDidChangeTerminalState.fire(s.value)}$acceptProcessResize(u,s,b){try{this._terminalProcesses.get(u)?.resize(s,b)}catch(y){if(y.code!=="EPIPE"&&y.code!=="ERR_IPC_CHANNEL_CLOSED")throw y}}$acceptProcessShutdown(u,s){this._terminalProcesses.get(u)?.shutdown(s)}$acceptProcessRequestInitialCwd(u){this._terminalProcesses.get(u)?.getInitialCwd().then(s=>this._proxy.$sendProcessProperty(u,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(u){this._terminalProcesses.get(u)?.getCwd().then(s=>this._proxy.$sendProcessProperty(u,{type:"cwd",value:s}))}$acceptProcessRequestLatency(u){return u}registerLinkProvider(u){return this._linkProviders.add(u),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(u),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(u,s,b){if(this._profileProviders.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this._profileProviders.set(s,b),this._proxy.$registerProfileProvider(s,u.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(s),this._proxy.$unregisterProfileProvider(s)})}async $createContributedProfileTerminal(u,s){const b=new n.CancellationTokenSource().token;let y=await this._profileProviders.get(u)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(y&&!("options"in y)&&(y={options:y}),!y||!("options"in y))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in y.options){this.createExtensionTerminal(y.options,s);return}this.createTerminalFromOptions(y.options,s)}}async $provideLinks(u,s){const b=this._getTerminalById(u);if(!b)return[];this._terminalLinkCache.delete(u);const y=this._terminalLinkCancellationSource.get(u);y&&y.dispose(!0);const c=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(u,c);const S=[],A={terminal:b.value,line:s},U=[];for(const L of this._linkProviders)U.push(D.Promises.withAsyncBody(async z=>{c.token.onCancellationRequested(()=>z({provider:L,links:[]}));const N=await L.provideTerminalLinks(A,c.token)||[];c.token.isCancellationRequested||z({provider:L,links:N})}));const H=await Promise.all(U);if(c.token.isCancellationRequested)return[];const E=new Map;for(const L of H)L&&L.links.length>0&&S.push(...L.links.map(z=>{const N={id:p++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return E.set(N.id,{provider:L.provider,link:z}),N}));return this._terminalLinkCache.set(u,E),S}$activateLink(u,s){const b=this._terminalLinkCache.get(u)?.get(s);!b||b.provider.handleTerminalLink(b.link)}_onProcessExit(u,s){this._bufferer.stopBuffering(u),this._terminalProcesses.delete(u),delete this._extensionTerminalAwaitingStart[u];const b=this._terminalProcessDisposables[u];b&&(b.dispose(),delete this._terminalProcessDisposables[u]),this._proxy.$sendProcessExit(u,s)}_getTerminalById(u){return this._getTerminalObjectById(this._terminals,u)}_getTerminalObjectById(u,s){const b=this._getTerminalObjectIndexById(u,s);return b!==null?u[b]:null}_getTerminalObjectIndexById(u,s){let b=null;return u.some((y,c)=>y._id===s?(b=c,!0):!1),b}getEnvironmentVariableCollection(u){let s=this._environmentVariableCollections.get(u.identifier.value);return s||(s=new l,this._setEnvironmentVariableCollection(u.identifier.value,s)),s}_syncEnvironmentVariableCollection(u,s){const b=(0,_.serializeEnvironmentVariableCollection)(s.map);this._proxy.$setEnvironmentVariableCollection(u,s.persistent,b.length===0?void 0:b)}$initEnvironmentVariableCollections(u){u.forEach(s=>{const b=s[0],y=new l(s[1]);this._setEnvironmentVariableCollection(b,y)})}$acceptDefaultProfile(u,s){this._defaultProfile=u,this._defaultAutomationProfile=s}_setEnvironmentVariableCollection(u,s){this._environmentVariableCollections.set(u,s),s.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(u,s)})}};I=Be([He(1,k.IExtHostRpcService)],I),e.BaseExtHostTerminalService=I;class l{constructor(u){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new a.Emitter,this.map=new Map(u)}get persistent(){return this._persistent}set persistent(u){this._persistent=u,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(u,s){this._setIfDiffers(u,{value:s,type:C.EnvironmentVariableMutatorType.Replace})}append(u,s){this._setIfDiffers(u,{value:s,type:C.EnvironmentVariableMutatorType.Append})}prepend(u,s){this._setIfDiffers(u,{value:s,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(u,s){const b=this.map.get(u);(!b||b.value!==s.value||b.type!==s.type)&&(this.map.set(u,s),this._onDidChangeCollection.fire())}get(u){return this.map.get(u)}forEach(u,s){this.map.forEach((b,y)=>u.call(s,y,b,this))}delete(u){this.map.delete(u),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=l;let M=class extends I{constructor(u){super(!1,u)}createTerminal(u,s,b){throw new F.NotSupportedError}createTerminalFromOptions(u,s){throw new F.NotSupportedError}};M=Be([He(0,k.IExtHostRpcService)],M),e.WorkerExtHostTerminalService=M;function o(h){if(!(!h||typeof h=="string"))return"id"in h?{id:h.id,color:h.color}:h}function i(h){return g.ThemeColor.isThemeColor(h)?h:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(ne,a):w?w.value=a:e.set(ne,a),a},Re=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Ee[201],ye([0,1,16,22,20,4,230,57,6,26,11,35,5,13,47,8,7,170,88,67]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m,r,g,d,D,v,f){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let I=class{constructor(A,U){this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=A.getProxy(n.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new M(this.proxy),U.registerArgumentProcessor({processArgument:H=>H?.$mid===13?g.TestItem.toItemFromContext(H):H})}createTestController(A,U){if(this.controllers.has(A))throw new Error(`Attempt to insert a duplicate controller with ID "${A}"`);const H=new C.DisposableStore,E=H.add(new D.SingleUseTestCollection(A));E.root.label=U;const L=new Map,z=this.proxy,N={items:E.root.children,get label(){return U},set label(j){U=j,E.root.label=j,z.$updateControllerLabel(A,U)},get id(){return A},createRunProfile:(j,ue,K,ie,pe)=>{let we=(0,P.hash)(j);for(;L.has(we);)we++;const ae=new y(this.proxy,A,we,j,ue,K,ie,pe);return L.set(we,ae),ae},createTestItem(j,ue,K){return new r.TestItemImpl(A,j,ue,K)},createTestRun:(j,ue,K=!0)=>this.runTracker.createTestRun(A,E,j,ue,K),set resolveHandler(j){E.resolveHandler=j},get resolveHandler(){return E.resolveHandler},dispose:()=>{H.dispose()}};N.createRunConfiguration=N.createRunProfile,z.$registerTestController(A,U),H.add((0,C.toDisposable)(()=>z.$unregisterTestController(A)));const $={controller:N,collection:E,profiles:L};return this.controllers.set(A,$),H.add((0,C.toDisposable)(()=>this.controllers.delete(A))),H.add(E.onDidGenerateDiff(j=>z.$publishDiff(A,j))),N}createTestObserver(){return this.observer.checkout()}async runTests(A,U=w.CancellationToken.None){const H=o(A);if(!H)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const E=this.controllers.get(H.controllerId);if(!E)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:A.include?.map(L=>L.id)??[E.collection.root.id],profileGroup:c[H.kind],profileId:H.profileId,controllerId:H.controllerId}],exclude:A.exclude?.map(L=>L.id)},U)}$provideFileCoverage(A,U,H){return(0,a.mapFind)(this.runTracker.trackers,L=>L.id===A?L.getCoverage(U):void 0)?.provideFileCoverage(H)??Promise.resolve([])}$resolveFileCoverage(A,U,H,E){return(0,a.mapFind)(this.runTracker.trackers,z=>z.id===A?z.getCoverage(U):void 0)?.resolveFileCoverage(H,E)??Promise.resolve([])}$configureRunProfile(A,U){this.controllers.get(A)?.profiles.get(U)?.configureHandler?.()}$publishTestResults(A){this.results=Object.freeze(A.map(U=>(0,R.deepFreeze)(g.TestResults.to(U))).concat(this.results).sort((U,H)=>H.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(A,U){const H=this.controllers.get(f.TestId.fromString(A).controllerId)?.collection;H&&(await H.expand(A,U<0?1/0:U),H.flushDiff())}$acceptDiff(A){this.observer.applyDiff(A)}async $runControllerTests(A,U){const H=this.controllers.get(A.controllerId);if(!H)return;const{collection:E,profiles:L}=H,z=L.get(A.profileId);if(!z)return;const N=A.testIds.map(K=>E.tree.get(K)).filter(F.isDefined),$=A.excludeExtIds.map(K=>H.collection.tree.get(K)).filter(F.isDefined).filter(K=>N.some(ie=>ie.fullId.compare(K.fullId)===2));if(!N.length)return;const j=new d.TestRunRequest(N.some(K=>K.actual instanceof r.TestItemRootImpl)?void 0:N.map(K=>K.actual),$.map(K=>K.actual),z),ue=this.runTracker.prepareForMainThreadTestRun(j,i.fromInternal(A,H.collection),U);try{await z.runHandler(j,U)}finally{ue.isRunning&&!U.isCancellationRequested&&await T.Event.toPromise(ue.onEnd),ue.dispose()}}$cancelExtensionTestRun(A){A===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(A)}};I=Be([He(0,m.IExtHostRpcService)],I),e.ExtHostTesting=I;class l extends C.Disposable{constructor(A,U,H){super();this.dto=A,this.proxy=U,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new w.CancellationTokenSource(H)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:E}of this.tasks.values())E.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(A){return this.tasks.get(A)?.coverage}createRun(A){const U=this.dto.id,H=this.dto.controllerId,E=(0,_.generateUuid)(),L=new h(this.proxy,U,E),z=ue=>(K,...ie)=>{if($){console.warn(`Setting the state of test "${K.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(K)||(this.ensureTestIsKnown(K),ue(K,...ie))},N=(ue,K)=>{const ie=K instanceof Array?K.map(g.TestMessage.from):[g.TestMessage.from(K)];if(ue.uri&&ue.range){const pe={range:g.Range.from(ue.range),uri:ue.uri};for(const we of ie)we.location=we.location||pe}this.proxy.$appendTestMessagesInRun(U,E,f.TestId.fromExtHostTestItem(ue,H).toString(),ie)};let $=!1;const j={isPersisted:this.dto.isPersisted,token:this.cts.token,name:A,get coverageProvider(){return L.coverageProvider},set coverageProvider(ue){L.coverageProvider=ue},enqueued:z(ue=>{this.proxy.$updateTestStateInRun(U,E,f.TestId.fromExtHostTestItem(ue,H).toString(),1)}),skipped:z(ue=>{this.proxy.$updateTestStateInRun(U,E,f.TestId.fromExtHostTestItem(ue,H).toString(),5)}),started:z(ue=>{this.proxy.$updateTestStateInRun(U,E,f.TestId.fromExtHostTestItem(ue,H).toString(),2)}),errored:z((ue,K,ie)=>{N(ue,K),this.proxy.$updateTestStateInRun(U,E,f.TestId.fromExtHostTestItem(ue,H).toString(),6,ie)}),failed:z((ue,K,ie)=>{N(ue,K),this.proxy.$updateTestStateInRun(U,E,f.TestId.fromExtHostTestItem(ue,H).toString(),4,ie)}),passed:z((ue,K)=>{this.proxy.$updateTestStateInRun(U,E,f.TestId.fromExtHostTestItem(ue,this.dto.controllerId).toString(),3,K)}),appendOutput:(ue,K,ie)=>{$||(ie&&(this.dto.isIncluded(ie)?this.ensureTestIsKnown(ie):ie=void 0),this.proxy.$appendOutputToRun(U,E,t.VSBuffer.fromString(ue),K&&g.location.from(K),ie&&f.TestId.fromExtHostTestItem(ie,H).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(U,E),this.tasks.delete(E),this.isRunning||this.dispose())}};return this.tasks.set(E,{run:j,coverage:L}),this.proxy.$startedTestRunTask(U,{id:E,name:A,running:!0}),j}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(A){if(!(A instanceof r.TestItemImpl))throw new r.InvalidTestItemError(A.id);if(this.sharedTestIds.has(f.TestId.fromExtHostTestItem(A,this.dto.controllerId).toString()))return;const U=[],H=this.dto.colllection.root;for(;;){const E=g.TestItem.from(A);if(U.unshift(E),this.sharedTestIds.has(E.extId)||(this.sharedTestIds.add(E.extId),A===H))break;A=A.parent||H}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,U)}}class M{constructor(A){this.proxy=A,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(A,U,H){return this.getTracker(A,U,H)}cancelRunById(A){for(const U of this.tracked.values())if(U.id===A){U.dispose();return}}cancelAllRuns(){for(const A of this.tracked.values())A.dispose()}createTestRun(A,U,H,E,L){const z=this.tracked.get(H);if(z)return z.createRun(E);const N=i.fromPublic(A,U,H,L),$=o(H);this.proxy.$startedExtensionTestRun({controllerId:A,profile:$&&{group:c[$.kind],id:$.profileId},exclude:H.exclude?.map(ue=>ue.id)??[],id:N.id,include:H.include?.map(ue=>ue.id)??[U.root.id],persist:L});const j=this.getTracker(H,N);return j.onEnd(()=>this.proxy.$finishedExtensionTestRun(N.id)),j.createRun(E)}getTracker(A,U,H){const E=new l(U,this.proxy,H);return this.tracked.set(A,E),E.onEnd(()=>this.tracked.delete(A)),E}}e.TestRunCoordinator=M;const o=S=>{if(!!S.profile){if(!(S.profile instanceof y))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return S.profile}};class i{constructor(A,U,H,E,L,z){this.controllerId=A,this.id=U,this.isPersisted=L,this.colllection=z,this.includePrefix=H.map(N=>N+"\0"),this.excludePrefix=E.map(N=>N+"\0")}static fromPublic(A,U,H,E){return new i(A,(0,_.generateUuid)(),H.include?.map(L=>f.TestId.fromExtHostTestItem(L,A).toString())??[A],H.exclude?.map(L=>f.TestId.fromExtHostTestItem(L,A).toString())??[],E,U)}static fromInternal(A,U){return new i(A.controllerId,A.runId,A.testIds,A.excludeExtIds,!0,U)}isIncluded(A){const U=f.TestId.fromExtHostTestItem(A,this.controllerId).toString()+"\0";for(const H of this.excludePrefix)if(U===H||U.startsWith(H))return!1;for(const H of this.includePrefix)if(U===H||U.startsWith(H))return!0;return!1}}e.TestRunDto=i;class h{constructor(A,U,H){this.proxy=A,this.runId=U,this.taskId=H}set coverageProvider(A){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!A||(this._coverageProvider=A,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(A){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(A))());try{return(await this.fileCoverage)?.map(g.TestCoverage.fromFile)??[]}catch(U){throw this.fileCoverage=void 0,U}}async resolveFileCoverage(A,U){const H=await this.fileCoverage;let E=H?.[A];return!this._coverageProvider||!H||!E?[]:(E.detailedCoverage||(E=H[A]=await this._coverageProvider.resolveFileCoverage?.(E,U)??E),E.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class u extends v.IncrementalChangeCollector{constructor(A){super();this.emitter=A,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,g.TestItem.toPlain(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.item.extId);return}this.removed.add(A)}getChangeEvent(){const{added:A,updated:U,removed:H}=this;return{get added(){return[...A].map(E=>E.revived)},get updated(){return[...U].map(E=>E.revived)},get removed(){return[...H].map(E=>E.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class s extends v.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){return this.items.get(A.id)}createItem(A,U){return{...A,revived:g.TestItem.toPlain(A.item),depth:U?U.depth+1:0,children:new Set}}createChangeCollector(){return new u(this.changeEmitter)}}e.MirroredTestCollection=s;class b{constructor(A){this.proxy=A}checkout(){this.current||(this.current=this.createObserverData());const A=this.current;return A.observers++,{onDidChangeTest:A.tests.onDidChangeTests,get tests(){return[...A.tests.rootTests].map(U=>U.revived)},dispose:(0,k.once)(()=>{--A.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(A){return this.current?.tests.getMirroredTestDataByReference(A)}applyDiff(A){this.current?.tests.apply(A)}createObserverData(){const A=new s;return this.proxy.$subscribeToDiffs(),{observers:0,tests:A}}}class y{constructor(A,U,H,E,L,z,N=!1,$=void 0){this.controllerId=U,this.profileId=H,this._label=E,this.kind=L,this.runHandler=z,this._isDefault=N,this._tag=$,p.set(this,void 0),Ze(this,p,A,"f");const j=c[L];if(typeof j!="number")throw new Error(`Unknown TestRunProfile.group ${L}`);Re(this,p,"f").$publishTestRunProfile({profileId:H,controllerId:U,tag:$?g.TestTag.namespace(this.controllerId,$.id):null,label:E,group:j,isDefault:N,hasConfigurationHandler:!1})}get label(){return this._label}set label(A){A!==this._label&&(this._label=A,Re(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:A}))}get isDefault(){return this._isDefault}set isDefault(A){A!==this._isDefault&&(this._isDefault=A,Re(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:A}))}get tag(){return this._tag}set tag(A){A?.id!==this._tag?.id&&(this._tag=A,Re(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:A?g.TestTag.namespace(this.controllerId,A.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(A){A!==this._configureHandler&&(this._configureHandler=A,Re(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!A}))}dispose(){Re(this,p,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=y,p=new WeakMap;const c={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(Ee[202],ye([0,1,4,16,5,92,8,7]),function(ne,e,a,t,w,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(F,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new a.Emitter,this._onDidChangeTextEditorOptions=new a.Emitter,this._onDidChangeTextEditorVisibleRanges=new a.Emitter,this._onDidChangeTextEditorViewColumn=new a.Emitter,this._onDidChangeActiveTextEditor=new a.Emitter,this._onDidChangeVisibleTextEditors=new a.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=F.getProxy(w.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(F){const _=this._extHostDocumentsAndEditors.allEditors();return F?_:_.map(n=>n.value)}async showTextDocument(F,_,n){let m;typeof _=="number"?m={position:k.ViewColumn.from(_),preserveFocus:n}:typeof _=="object"?m={position:k.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?k.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:m={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(F.uri,m),g=r&&this._extHostDocumentsAndEditors.getEditor(r);if(g)return g.value;throw r?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,_){return new T.TextEditorDecorationType(this._proxy,F,_).value}$acceptEditorPropertiesChanged(F,_){const n=this._extHostDocumentsAndEditors.getEditor(F);if(!n)throw new Error("unknown text editor");if(_.options&&n._acceptOptions(_.options),_.selections){const m=_.selections.selections.map(k.Selection.to);n._acceptSelections(m)}if(_.visibleRanges){const m=t.coalesce(_.visibleRanges.map(k.Range.to));n._acceptVisibleRanges(m)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{..._.options,lineNumbers:k.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const m=P.TextEditorSelectionChangeKind.fromValue(_.selections.source),r=_.selections.selections.map(k.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:r,kind:m})}if(_.visibleRanges){const m=t.coalesce(_.visibleRanges.map(k.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:m})}}$acceptEditorPositionData(F){for(const _ in F){const n=this._extHostDocumentsAndEditors.getEditor(_);if(!n)throw new Error("Unknown text editor");const m=k.ViewColumn.to(F[_]);n.value.viewColumn!==m&&(n._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:m}))}}getDiffInformation(F){return Promise.resolve(this._proxy.$getDiffInformation(F))}}e.ExtHostEditors=C}),define(Ee[203],ye([0,1,2,3,5,6,7]),function(ne,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class P{constructor(F,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=F.getProxy(w.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const m=n.uri===void 0?void 0:a.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(C(m))?.get(n.handle)}return n}})}async $getTimeline(F,_,n,m,r){return this._providers.get(F)?.provideTimeline(a.URI.revive(_),n,m,r)}registerTimelineProvider(F,_,n,m){const r=new T.DisposableStore,g=this.convertTimelineItem(_.id,m,r).bind(this);let d;_.onDidChange&&(d=_.onDidChange(v=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:_.id}),this));const D=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:F,onDidChange:void 0,async provideTimeline(v,f,p,I){I?.resetCache&&(r.clear(),D.get(_.id)?.clear());const l=await _.provideTimeline(v,f,p);if(l==null)return;const M=g(v,I);return{...l,source:_.id,items:l.items.map(M)}},dispose(){for(const v of D.values())v.get(_.id)?.clear();d?.dispose(),r.dispose()}})}convertTimelineItem(F,_,n){return(m,r)=>{let g;if(r?.cacheResults){let d=this._itemsBySourceAndUriMap.get(F);d===void 0&&(d=new Map,this._itemsBySourceAndUriMap.set(F,d));const D=C(m);g=d.get(D),g===void 0&&(g=new Map,d.set(D,g))}return d=>{const{iconPath:D,...v}=d,f=`${F}|${d.id??d.timestamp}`;g?.set(f,d);let p,I,l;return d.iconPath&&(D instanceof k.ThemeIcon?l={id:D.id,color:D.color}:a.URI.isUri(D)?(p=D,I=D):{light:p,dark:I}=D),{...v,id:v.id??void 0,handle:f,source:F,command:d.command?_.toInternal(d.command,n):void 0,icon:p,iconDark:I,themeIcon:l,accessibilityInformation:d.accessibilityInformation}}}}registerTimelineProviderCore(F){if(this._providers.get(F.id))throw new Error(`Timeline Provider ${F.id} already exists.`);return this._proxy.$registerTimelineProvider({id:F.id,label:F.label,scheme:F.scheme}),this._providers.set(F.id,F),(0,T.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(F.id)?.clear();this._providers.delete(F.id),this._proxy.$unregisterTimelineProvider(F.id),F.dispose()})}}e.ExtHostTimeline=P;function C(R){return R?.toString()}}),define(Ee[204],ye([0,1,6,10,2,5]),function(ne,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{constructor(C){this._openers=new Map,this._proxy=C.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,R,F,_){if(this._openers.has(R))throw new Error(`Opener with id '${R}' already registered`);const n=_.schemes.find(m=>!k.supportedSchemes.has(m));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(R,F),this._proxy.$registerUriOpener(R,_.schemes,C,_.label),(0,a.toDisposable)(()=>{this._openers.delete(R),this._proxy.$unregisterUriOpener(R)})}async $canOpenUri(C,R,F){const _=this._openers.get(C);if(!_)throw new Error(`Unknown opener with id: ${C}`);const n=w.URI.revive(R);return _.canOpenExternalUri(n,F)}async $openUri(C,R,F){const _=this._openers.get(C);if(!_)throw new Error(`Unknown opener id: '${C}'`);return _.openExternalUri(w.URI.revive(R.resolvedUri),{sourceUri:w.URI.revive(R.sourceUri)},F)}}e.ExtHostUriOpeners=k,k.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(Ee[205],ye([0,1,5,2,6,15,25]),function(ne,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(R){this.handles=new Set,this.handlers=new Map,this._proxy=R.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(R,F){if(this.handles.has(k.ExtensionIdentifier.toKey(R)))throw new Error(`Protocol handler already registered for extension ${R}`);const _=P.HandlePool++;return this.handles.add(k.ExtensionIdentifier.toKey(R)),this.handlers.set(_,F),this._proxy.$registerUriHandler(_,R),(0,w.toDisposable)(()=>{this.handles.delete(k.ExtensionIdentifier.toKey(R)),this.handlers.delete(_),this._proxy.$unregisterUriHandler(_)})}$handleExternalUri(R,F){const _=this.handlers.get(R);if(!_)return Promise.resolve(void 0);try{_.handleUri(t.URI.revive(F))}catch(n){(0,T.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(R){return t.URI.revive(await this._proxy.$createAppUri(R))}}e.ExtHostUrls=P,P.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(ne,a):w?w.value=a:e.set(ne,a),a},Re=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Ee[50],ye([0,1,4,10,2,132,152,66,5]),function(ne,e,a,t,w,T,k,P,C){"use strict";var R,F,_,n,m,r,g,d,D,v,f,p;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class I{constructor(b,y,c,S,A,U,H){R.set(this,void 0),F.set(this,void 0),_.set(this,void 0),n.set(this,void 0),m.set(this,void 0),r.set(this,void 0),g.set(this,""),d.set(this,void 0),D.set(this,!1),v.set(this,!1),f.set(this,!1),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,p.set(this,new a.Emitter),this._onDidDispose=Re(this,p,"f").event,Ze(this,R,b,"f"),Ze(this,F,y,"f"),Ze(this,d,c,"f"),Ze(this,n,S,"f"),Ze(this,m,A,"f"),Ze(this,r,U,"f"),Ze(this,f,l(U),"f"),Ze(this,_,H,"f")}dispose(){Ze(this,D,!0,"f"),Re(this,p,"f").fire(),Re(this,p,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return Ze(this,v,!0,"f"),(0,P.asWebviewUri)(b,Re(this,n,"f").remote)}get cspSource(){const b=Re(this,r,"f").extensionLocation;if(b.scheme===t.Schemas.https||b.scheme===t.Schemas.http){let y=b.toString();return y.endsWith("/")||(y+="/"),y+" "+P.webviewGenericCspSource}return P.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Re(this,g,"f")}set html(b){this.assertNotDisposed(),Re(this,g,"f")!==b&&(Ze(this,g,b,"f"),!Re(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(Ze(this,v,!0,"f"),Re(this,_,"f").report("Webview vscode-resource: uris",Re(this,r,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Re(this,F,"f").$setHtml(Re(this,R,"f"),b))}get options(){return this.assertNotDisposed(),Re(this,d,"f")}set options(b){this.assertNotDisposed(),Re(this,F,"f").$setOptions(Re(this,R,"f"),i(Re(this,r,"f"),Re(this,m,"f"),b)),Ze(this,d,b,"f")}async postMessage(b){if(Re(this,D,"f"))return!1;const y=(0,k.serializeWebviewMessage)(b,{serializeBuffersForPostMessage:Re(this,f,"f")});return Re(this,F,"f").$postMessage(Re(this,R,"f"),y.message,...y.buffers)}assertNotDisposed(){if(Re(this,D,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=I,R=new WeakMap,F=new WeakMap,_=new WeakMap,n=new WeakMap,m=new WeakMap,r=new WeakMap,g=new WeakMap,d=new WeakMap,D=new WeakMap,v=new WeakMap,f=new WeakMap,p=new WeakMap;function l(s){try{const b=(0,T.normalizeVersion)((0,T.parseVersion)(s.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=l;class M{constructor(b,y,c,S,A){this.initData=y,this.workspace=c,this._logService=S,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=b.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(b,y,c){const S=this.getWebview(b);if(S){const{message:A}=(0,k.deserializeWebviewMessage)(y,c.value);S._onMessageEmitter.fire(A)}}$onMissingCsp(b,y){this._logService.warn(`${y} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,y,c){const S=new I(b,this._webviewProxy,h(y),this.initData,this.workspace,c,this._deprecationService);return this._webviews.set(b,S),S._onDidDispose(()=>{this._webviews.delete(b)}),S}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=M;function o(s){return{id:s.identifier,location:s.extensionLocation}}e.toExtensionData=o;function i(s,b,y){return{enableCommandUris:y.enableCommandUris,enableScripts:y.enableScripts,enableForms:y.enableForms,portMapping:y.portMapping,localResourceRoots:y.localResourceRoots||u(s,b)}}e.serializeWebviewOptions=i;function h(s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots?.map(b=>w.URI.from(b))}}e.reviveOptions=h;function u(s,b){return[...(b?.getWorkspaceFolders()||[]).map(y=>y.uri),s.extensionLocation]}}),define(Ee[206],ye([0,1,20,57,6,10,24,2,8,50,63,5,7]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(l,M){this.document=l,this._storagePath=M,this._backupCounter=1,this._edits=new F.Cache("custom documents")}addEdit(l){return this._edits.add([l])}async undo(l,M){await this.getEdit(l).undo(),M||this.disposeBackup()}async redo(l,M){await this.getEdit(l).redo(),M||this.disposeBackup()}disposeEdits(l){for(const M of l)this._edits.delete(M)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const l=p(this.document.uri)+this._backupCounter++;return(0,k.joinPath)(this._storagePath,l)}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(l){const M=this._edits.get(l,0);if(!M)throw new Error("No edit found");return M}}class r{constructor(){this._documents=new Map}get(l,M){return this._documents.get(this.key(l,M))}add(l,M,o){const i=this.key(l,M.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${l} resource:${M.uri}`);const h=new m(M,o);return this._documents.set(i,h),h}delete(l,M){const o=this.key(l,M.uri);this._documents.delete(o)}key(l,M){return`${l}@@@${M}`}}var g;(function(I){I[I.Text=0]="Text",I[I.Custom=1]="Custom"})(g||(g={}));class d{constructor(){this._providers=new Map}addTextProvider(l,M,o){return this.add(0,l,M,o)}addCustomProvider(l,M,o){return this.add(1,l,M,o)}get(l){return this._providers.get(l)}add(l,M,o,i){if(this._providers.has(M))throw new Error(`Provider for viewType:${M} already registered`);return this._providers.set(M,{type:l,extension:o,provider:i}),new n.Disposable(()=>this._providers.delete(M))}}class D{constructor(l,M,o,i,h){this._extHostDocuments=M,this._extensionStoragePaths=o,this._extHostWebview=i,this._extHostWebviewPanels=h,this._editorProviders=new d,this._documents=new r,this._proxy=l.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(l,M,o,i){const h=new w.DisposableStore;return v(o)?(h.add(this._editorProviders.addTextProvider(M,l,o)),this._proxy.$registerTextEditorProvider((0,R.toExtensionData)(l),M,i.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,R.shouldSerializeBuffersForPostMessage)(l))):(h.add(this._editorProviders.addCustomProvider(M,l,o)),this.supportEditing(o)&&h.add(o.onDidChangeCustomDocument(u=>{const s=this.getCustomDocumentEntry(M,u.document.uri);if(f(u)){const b=s.addEdit(u);this._proxy.$onDidEdit(u.document.uri,M,b,u.label)}else this._proxy.$onContentChange(u.document.uri,M)})),this._proxy.$registerCustomEditorProvider((0,R.toExtensionData)(l),M,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,R.shouldSerializeBuffersForPostMessage)(l))),n.Disposable.from(h,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(M)}))}async $createCustomDocument(l,M,o,i,h){const u=this._editorProviders.get(M);if(!u)throw new Error(`No provider found for '${M}'`);if(u.type!==1)throw new Error(`Invalid provide type for '${M}'`);const s=P.URI.revive(l),b=await u.provider.openCustomDocument(s,{backupId:o,untitledDocumentData:i?.buffer},h);let y;return this.supportEditing(u.provider)&&this._extensionStoragePaths&&(y=this._extensionStoragePaths.workspaceValue(u.extension)??this._extensionStoragePaths.globalValue(u.extension)),this._documents.add(M,b,y),{editable:this.supportEditing(u.provider)}}async $disposeCustomDocument(l,M){const o=this._editorProviders.get(M);if(!o)throw new Error(`No provider found for '${M}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${M}'`);const i=P.URI.revive(l),{document:h}=this.getCustomDocumentEntry(M,i);this._documents.delete(M,h),h.dispose()}async $resolveWebviewEditor(l,M,o,i,h,u){const s=this._editorProviders.get(o);if(!s)throw new Error(`No provider found for '${o}'`);const b=C.ViewColumn.to(h),y=this._extHostWebview.createNewWebview(M,i.webviewOptions,s.extension),c=this._extHostWebviewPanels.createNewWebviewPanel(M,o,i.title,b,i.panelOptions,y),S=P.URI.revive(l);switch(s.type){case 1:{const{document:A}=this.getCustomDocumentEntry(o,S);return s.provider.resolveCustomEditor(A,c,u)}case 0:{const A=this._extHostDocuments.getDocument(S);return s.provider.resolveCustomTextEditor(A,c,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,M,o){this.getCustomDocumentEntry(M,l).disposeEdits(o)}async $onMoveCustomEditor(l,M,o){const i=this._editorProviders.get(o);if(!i)throw new Error(`No provider found for '${o}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const h=this._extHostWebviewPanels.getWebviewPanel(l);if(!h)throw new Error("No webview found");const u=P.URI.revive(M),s=this._extHostDocuments.getDocument(u);await i.provider.moveCustomTextEditor(s,h,a.CancellationToken.None)}async $undo(l,M,o,i){return this.getCustomDocumentEntry(M,l).undo(o,i)}async $redo(l,M,o,i){return this.getCustomDocumentEntry(M,l).redo(o,i)}async $revert(l,M,o){const i=this.getCustomDocumentEntry(M,l);await this.getCustomEditorProvider(M).revertCustomDocument(i.document,o),i.disposeBackup()}async $onSave(l,M,o){const i=this.getCustomDocumentEntry(M,l);await this.getCustomEditorProvider(M).saveCustomDocument(i.document,o),i.disposeBackup()}async $onSaveAs(l,M,o,i){const h=this.getCustomDocumentEntry(M,l);return this.getCustomEditorProvider(M).saveCustomDocumentAs(h.document,P.URI.revive(o),i)}async $backup(l,M,o){const i=this.getCustomDocumentEntry(M,l),u=await this.getCustomEditorProvider(M).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},o);return i.updateBackup(u),u.id}getCustomDocumentEntry(l,M){const o=this._documents.get(l,P.URI.revive(M));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(l){const o=this._editorProviders.get(l)?.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(l){return!!l.onDidChangeCustomDocument}}e.ExtHostCustomEditors=D;function v(I){return typeof I.resolveCustomTextEditor=="function"}function f(I){return typeof I.undo=="function"&&typeof I.redo=="function"}function p(I){const l=I.scheme===T.Schemas.file||I.scheme===T.Schemas.untitled?I.fsPath:I.toString();return(0,t.hash)(l)+""}});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(ne,a):w?w.value=a:e.set(ne,a),a},Re=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Ee[207],ye([0,1,4,6,2,35,8,50,5,7]),function(ne,e,a,t,w,T,k,P,C,R){"use strict";var F,_,n,m,r,g,d,D,v,f,p,I,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class M extends t.Disposable{constructor(u,s,b,y,c,S,A){super();F.set(this,void 0),_.set(this,void 0),n.set(this,void 0),m.set(this,void 0),r.set(this,void 0),g.set(this,void 0),d.set(this,void 0),D.set(this,void 0),v.set(this,!0),f.set(this,!0),p.set(this,!1),I.set(this,this._register(new a.Emitter)),this.onDidDispose=Re(this,I,"f").event,l.set(this,this._register(new a.Emitter)),this.onDidChangeViewState=Re(this,l,"f").event,Ze(this,F,u,"f"),Ze(this,_,s,"f"),Ze(this,n,b,"f"),Ze(this,r,S,"f"),Ze(this,D,c,"f"),Ze(this,g,y,"f"),Ze(this,m,A,"f")}dispose(){Re(this,p,"f")||(Ze(this,p,!0,"f"),Re(this,I,"f").fire(),Re(this,_,"f").$disposeWebview(Re(this,F,"f")),Re(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Re(this,m,"f")}get viewType(){return this.assertNotDisposed(),Re(this,n,"f")}get title(){return this.assertNotDisposed(),Re(this,g,"f")}set title(u){this.assertNotDisposed(),Re(this,g,"f")!==u&&(Ze(this,g,u,"f"),Re(this,_,"f").$setTitle(Re(this,F,"f"),u))}get iconPath(){return this.assertNotDisposed(),Re(this,d,"f")}set iconPath(u){this.assertNotDisposed(),Re(this,d,"f")!==u&&(Ze(this,d,u,"f"),Re(this,_,"f").$setIconPath(Re(this,F,"f"),w.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Re(this,r,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Re(this,D,"f")=="number"&&Re(this,D,"f")<0))return Re(this,D,"f")}get active(){return this.assertNotDisposed(),Re(this,f,"f")}get visible(){return this.assertNotDisposed(),Re(this,v,"f")}_updateViewState(u){Re(this,p,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(Ze(this,f,u.active,"f"),Ze(this,v,u.visible,"f"),Ze(this,D,u.viewColumn,"f"),Re(this,l,"f").fire({webviewPanel:this}))}reveal(u,s){this.assertNotDisposed(),Re(this,_,"f").$reveal(Re(this,F,"f"),{viewColumn:u?k.ViewColumn.from(u):void 0,preserveFocus:!!s})}assertNotDisposed(){if(Re(this,p,"f"))throw new Error("Webview is disposed")}}F=new WeakMap,_=new WeakMap,n=new WeakMap,m=new WeakMap,r=new WeakMap,g=new WeakMap,d=new WeakMap,D=new WeakMap,v=new WeakMap,f=new WeakMap,p=new WeakMap,I=new WeakMap,l=new WeakMap;class o{constructor(u,s,b){this.webviews=s,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=u.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(u,s,b,y,c={}){const S=typeof y=="object"?y.viewColumn:y,A={viewColumn:k.ViewColumn.from(S),preserveFocus:typeof y=="object"&&!!y.preserveFocus},U=(0,P.shouldSerializeBuffersForPostMessage)(u),H=o.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(u),H,s,{title:b,panelOptions:i(c),webviewOptions:(0,P.serializeWebviewOptions)(u,this.workspace,c),serializeBuffersForPostMessage:U},A);const E=this.webviews.createNewWebview(H,c,u);return this.createNewWebviewPanel(H,s,b,S,c,E)}$onDidChangeWebviewPanelViewStates(u){const s=Object.keys(u);s.sort((b,y)=>{const c=u[b],S=u[y];return c.active?1:S.active?-1:+c.visible-+S.visible});for(const b of s){const y=this.getWebviewPanel(b);if(!y)continue;const c=u[b];y._updateViewState({active:c.active,visible:c.visible,viewColumn:k.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this._webviewPanels.delete(u),this.webviews.deleteWebview(u)}registerWebviewPanelSerializer(u,s,b){if(this._serializers.has(s))throw new Error(`Serializer for '${s}' already registered`);return this._serializers.set(s,{serializer:b,extension:u}),this._proxy.$registerSerializer(s,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(u)}),new R.Disposable(()=>{this._serializers.delete(s),this._proxy.$unregisterSerializer(s)})}async $deserializeWebviewPanel(u,s,b,y){const c=this._serializers.get(s);if(!c)throw new Error(`No serializer found for '${s}'`);const{serializer:S,extension:A}=c,U=this.webviews.createNewWebview(u,b.webviewOptions,A),H=this.createNewWebviewPanel(u,s,b.title,y,b.panelOptions,U);await S.deserializeWebviewPanel(H,b.state)}createNewWebviewPanel(u,s,b,y,c,S){const A=new M(u,this._proxy,s,b,y,c,S);return this._webviewPanels.set(u,A),A}getWebviewPanel(u){return this._webviewPanels.get(u)}}e.ExtHostWebviewPanels=o;function i(h){return{enableFindWidget:h.enableFindWidget,retainContextWhenHidden:h.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(ne,a):w?w.value=a:e.set(ne,a),a},Re=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Ee[208],ye([0,1,4,6,50,5,7]),function(ne,e,a,t,w,T,k){"use strict";var P,C,R,F,_,n,m,r,g,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class D extends t.Disposable{constructor(p,I,l,M,o,i){super();P.set(this,void 0),C.set(this,void 0),R.set(this,void 0),F.set(this,void 0),_.set(this,!1),n.set(this,void 0),m.set(this,void 0),r.set(this,void 0),g.set(this,this._register(new a.Emitter)),this.onDidChangeVisibility=Re(this,g,"f").event,d.set(this,this._register(new a.Emitter)),this.onDidDispose=Re(this,d,"f").event,Ze(this,R,l,"f"),Ze(this,m,M,"f"),Ze(this,P,p,"f"),Ze(this,C,I,"f"),Ze(this,F,o,"f"),Ze(this,n,i,"f")}dispose(){Re(this,_,"f")||(Ze(this,_,!0,"f"),Re(this,d,"f").fire(),Re(this,F,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Re(this,m,"f")}set title(p){this.assertNotDisposed(),Re(this,m,"f")!==p&&(Ze(this,m,p,"f"),Re(this,C,"f").$setWebviewViewTitle(Re(this,P,"f"),p))}get description(){return this.assertNotDisposed(),Re(this,r,"f")}set description(p){this.assertNotDisposed(),Re(this,r,"f")!==p&&(Ze(this,r,p,"f"),Re(this,C,"f").$setWebviewViewDescription(Re(this,P,"f"),p))}get visible(){return Re(this,n,"f")}get webview(){return Re(this,F,"f")}get viewType(){return Re(this,R,"f")}_setVisible(p){p===Re(this,n,"f")||Re(this,_,"f")||(Ze(this,n,p,"f"),Re(this,g,"f").fire())}show(p){this.assertNotDisposed(),Re(this,C,"f").$show(Re(this,P,"f"),!!p)}assertNotDisposed(){if(Re(this,_,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,C=new WeakMap,R=new WeakMap,F=new WeakMap,_=new WeakMap,n=new WeakMap,m=new WeakMap,r=new WeakMap,g=new WeakMap,d=new WeakMap;class v{constructor(p,I){this._extHostWebview=I,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=p.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(p,I,l,M){if(this._viewProviders.has(I))throw new Error(`View provider for '${I}' already registered`);return this._viewProviders.set(I,{provider:l,extension:p}),this._proxy.$registerWebviewViewProvider((0,w.toExtensionData)(p),I,{retainContextWhenHidden:M?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new k.Disposable(()=>{this._viewProviders.delete(I),this._proxy.$unregisterWebviewViewProvider(I)})}async $resolveWebviewView(p,I,l,M,o){const i=this._viewProviders.get(I);if(!i)throw new Error(`No view provider found for '${I}'`);const{provider:h,extension:u}=i,s=this._extHostWebview.createNewWebview(p,{},u),b=new D(p,this._proxy,I,l,s,!0);this._webviewViews.set(p,b),await h.resolveWebviewView(b,{state:M},o)}async $onDidChangeWebviewViewVisibility(p,I){this.getWebviewView(p)._setVisible(I)}async $disposeWebviewView(p){const I=this.getWebviewView(p);this._webviewViews.delete(p),I.dispose(),this._extHostWebview.deleteWebview(p)}getWebviewView(p){const I=this._webviewViews.get(p);if(!I)throw new Error("No webview found");return I}}e.ExtHostWebviewViews=v}),define(Ee[95],ye([0,1,4,5,2,10,9,3,13]),function(ne,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let R=class Wi{constructor(_){this._onDidChangeWindowState=new a.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Wi.InitialState,this._proxy=_.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(_){_!==this._state.focused&&(this._state={...this._state,focused:_},this._onDidChangeWindowState.fire(this._state))}openUri(_,n){let m;if(typeof _=="string"){m=_;try{_=w.URI.parse(_)}catch{return Promise.reject(`Invalid uri - '${_}'`)}}return(0,k.isFalsyOrWhitespace)(_.scheme)?Promise.reject("Invalid scheme - cannot be empty"):_.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${_.scheme}'`):this._proxy.$openUri(_,m,n)}async asExternalUri(_,n){if((0,k.isFalsyOrWhitespace)(_.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(_,n);return w.URI.from(m)}};R.InitialState={focused:!0},R=Be([He(0,C.IExtHostRpcService)],R),e.ExtHostWindow=R,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(Ee[209],ye([0,1,14,22,20,15,4,6,106,176,37]),function(ne,e,a,t,w,T,k,P,C,R,F){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(c,S){try{return JSON.stringify(c,S)}catch{return"null"}}const m="$$ref$$",r={[m]:-1};class g{constructor(S,A){this.jsonString=S,this.referencedBuffers=A}}function d(c,S=null,A=!1){const U=[];return{jsonString:(A?n:JSON.stringify)(c,(E,L)=>{if(typeof L=="undefined")return r;if(typeof L=="object"){if(L instanceof t.VSBuffer){const z=U.push(L)-1;return{[m]:z}}if(S)return S(E,L)}return L}),referencedBuffers:U}}e.stringifyJsonWithBufferRefs=d;function D(c,S,A){return JSON.parse(c,(U,H)=>{if(H){const E=H[m];if(typeof E=="number")return S[E];if(A&&H.$mid===1)return A.transformIncoming(H)}return H})}e.parseJsonAndRestoreBufferRefs=D;function v(c,S){return JSON.stringify(c,S)}function f(c){return c?(S,A)=>A&&A.$mid===1?c.transformOutgoing(A):A:null}var p;(function(c){c[c.LocalSide=0]="LocalSide",c[c.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));var I;(function(c){c[c.Responsive=0]="Responsive",c[c.Unresponsive=1]="Unresponsive"})(I=e.ResponsiveState||(e.ResponsiveState={}));const l=()=>{},M=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class i extends P.Disposable{constructor(S,A=null,U=null){super();this[_]=!0,this._onDidChangeResponsiveState=this._register(new k.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=S,this._logger=A,this._uriTransformer=U,this._uriReplacer=f(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let H=0,E=F.ProxyIdentifier.count;H<E;H++)this._locals[H]=null,this._proxies[H]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new a.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(H=>this._receiveOneMessage(H))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(S=>{this._pendingRPCReplies[S].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(S){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(S){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(S){this._responsiveState!==S&&(this._responsiveState=S,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(S){return this._uriTransformer?(0,C.transformIncomingURIs)(S,this._uriTransformer):S}getProxy(S){const{nid:A,sid:U}=S;return this._proxies[A]||(this._proxies[A]=this._createProxy(A,U)),this._proxies[A]}_createProxy(S,A){let U={get:(H,E)=>(typeof E=="string"&&!H[E]&&E.charCodeAt(0)===36&&(H[E]=(...L)=>this._remoteCall(S,E,L)),E===o?A:H[E])};return new Proxy(Object.create(null),U)}set(S,A){return this._locals[S.nid]=A,A}assertRegistered(S){for(let A=0,U=S.length;A<U;A++){const H=S[A];if(!this._locals[H.nid])throw new Error(`Missing actor ${H.sid} (isMain: ${H.isMain})`)}}_receiveOneMessage(S){if(this._isDisposed)return;const A=S.byteLength,U=h.read(S,0),H=U.readUInt8(),E=U.readUInt32();switch(H){case 1:case 2:{let{rpcId:L,method:z,args:N}=s.deserializeRequestJSONArgs(U);this._uriTransformer&&(N=(0,C.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(A,E,L,z,N,H===2);break}case 3:case 4:{let{rpcId:L,method:z,args:N}=s.deserializeRequestMixedArgs(U);this._uriTransformer&&(N=(0,C.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(A,E,L,z,N,H===4);break}case 5:{this._logger&&this._logger.logIncoming(A,E,0,"ack"),this._onDidReceiveAcknowledge(E);break}case 6:{this._receiveCancel(A,E);break}case 7:{this._receiveReply(A,E,void 0);break}case 9:{let L=s.deserializeReplyOKJSON(U);this._uriTransformer&&(L=(0,C.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReply(A,E,L);break}case 10:{const L=s.deserializeReplyOKJSONWithBuffers(U,this._uriTransformer);this._receiveReply(A,E,L);break}case 8:{let L=s.deserializeReplyOKVSBuffer(U);this._receiveReply(A,E,L);break}case 11:{let L=s.deserializeReplyErrError(U);this._uriTransformer&&(L=(0,C.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReplyErr(A,E,L);break}case 12:{this._receiveReplyErr(A,E,void 0);break}default:console.error("received unexpected message"),console.error(S)}}_receiveRequest(S,A,U,H,E,L){this._logger&&this._logger.logIncoming(S,A,1,`receiveRequest ${(0,F.getStringIdentifierForProxy)(U)}.${H}(`,E);const z=String(A);let N,$;if(L){const ue=new w.CancellationTokenSource;E.push(ue.token),N=this._invokeHandler(U,H,E),$=()=>ue.cancel()}else N=this._invokeHandler(U,H,E),$=l;this._cancelInvokedHandlers[z]=$;const j=s.serializeAcknowledged(A);this._logger&&this._logger.logOutgoing(j.byteLength,A,1,"ack"),this._protocol.send(j),N.then(ue=>{delete this._cancelInvokedHandlers[z];const K=s.serializeReplyOK(A,ue,this._uriReplacer);this._logger&&this._logger.logOutgoing(K.byteLength,A,1,"reply:",ue),this._protocol.send(K)},ue=>{delete this._cancelInvokedHandlers[z];const K=s.serializeReplyErr(A,ue);this._logger&&this._logger.logOutgoing(K.byteLength,A,1,"replyErr:",ue),this._protocol.send(K)})}_receiveCancel(S,A){this._logger&&this._logger.logIncoming(S,A,1,"receiveCancel");const U=String(A);this._cancelInvokedHandlers[U]&&this._cancelInvokedHandlers[U]()}_receiveReply(S,A,U){this._logger&&this._logger.logIncoming(S,A,0,"receiveReply:",U);const H=String(A);if(!this._pendingRPCReplies.hasOwnProperty(H))return;const E=this._pendingRPCReplies[H];delete this._pendingRPCReplies[H],E.resolveOk(U)}_receiveReplyErr(S,A,U){this._logger&&this._logger.logIncoming(S,A,0,"receiveReplyErr:",U);const H=String(A);if(!this._pendingRPCReplies.hasOwnProperty(H))return;const E=this._pendingRPCReplies[H];delete this._pendingRPCReplies[H];let L;U&&(U.$isError?(L=new Error,L.name=U.name,L.message=U.message,L.stack=U.stack):L=U),E.resolveErr(L)}_invokeHandler(S,A,U){try{return Promise.resolve(this._doInvokeHandler(S,A,U))}catch(H){return Promise.reject(H)}}_doInvokeHandler(S,A,U){const H=this._locals[S];if(!H)throw new Error("Unknown actor "+(0,F.getStringIdentifierForProxy)(S));let E=H[A];if(typeof E!="function")throw new Error("Unknown method "+A+" on actor "+(0,F.getStringIdentifierForProxy)(S));return E.apply(H,U)}_remoteCall(S,A,U){if(this._isDisposed)return Promise.reject(T.canceled());let H=null;if(U.length>0&&w.CancellationToken.isCancellationToken(U[U.length-1])&&(H=U.pop()),H&&H.isCancellationRequested)return Promise.reject(T.canceled());const E=s.serializeRequestArguments(U,this._uriReplacer),L=++this._lastMessageId,z=String(L),N=new R.LazyPromise;H&&H.onCancellationRequested(()=>{const j=s.serializeCancel(L);this._logger&&this._logger.logOutgoing(j.byteLength,L,0,"cancel"),this._protocol.send(s.serializeCancel(L))}),this._pendingRPCReplies[z]=N,this._onWillSendRequest(L);const $=s.serializeRequest(L,S,A,E,!!H);return this._logger&&this._logger.logOutgoing($.byteLength,L,0,`request: ${(0,F.getStringIdentifierForProxy)(S)}.${A}(`,U),this._protocol.send($),N}}e.RPCProtocol=i,_=M,i.UNRESPONSIVE_TIME=3*1e3;class h{constructor(S,A){this._buff=S,this._offset=A}static alloc(S,A,U){let H=new h(t.VSBuffer.alloc(U+1+4),0);return H.writeUInt8(S),H.writeUInt32(A),H}static read(S,A){return new h(S,A)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(S){this._buff.writeUInt8(S,this._offset),this._offset+=1}readUInt8(){const S=this._buff.readUInt8(this._offset);return this._offset+=1,S}writeUInt32(S){this._buff.writeUInt32BE(S,this._offset),this._offset+=4}readUInt32(){const S=this._buff.readUInt32BE(this._offset);return this._offset+=4,S}static sizeShortString(S){return 1+S.byteLength}writeShortString(S){this._buff.writeUInt8(S.byteLength,this._offset),this._offset+=1,this._buff.set(S,this._offset),this._offset+=S.byteLength}readShortString(){const S=this._buff.readUInt8(this._offset);this._offset+=1;const U=this._buff.slice(this._offset,this._offset+S).toString();return this._offset+=S,U}static sizeLongString(S){return 4+S.byteLength}writeLongString(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}readLongString(){const S=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+S).toString();return this._offset+=S,U}writeBuffer(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}static sizeVSBuffer(S){return 4+S.byteLength}writeVSBuffer(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}readVSBuffer(){const S=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+S);return this._offset+=S,A}static sizeMixedArray(S){let A=0;A+=1;for(let U=0,H=S.length;U<H;U++){const E=S[U];switch(A+=1,E.type){case 1:A+=this.sizeLongString(E.value);break;case 2:A+=this.sizeVSBuffer(E.value);break;case 3:A+=this.sizeUInt32,A+=this.sizeLongString(E.value);for(let L=0;L<E.buffers.length;++L)A+=this.sizeVSBuffer(E.buffers[L]);break;case 4:break}}return A}writeMixedArray(S){this._buff.writeUInt8(S.length,this._offset),this._offset+=1;for(let A=0,U=S.length;A<U;A++){const H=S[A];switch(H.type){case 1:this.writeUInt8(1),this.writeLongString(H.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(H.value);break;case 3:this.writeUInt8(3),this.writeUInt32(H.buffers.length),this.writeLongString(H.value);for(let E=0;E<H.buffers.length;++E)this.writeBuffer(H.buffers[E]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const S=this._buff.readUInt8(this._offset);this._offset+=1;let A=new Array(S);for(let U=0;U<S;U++)switch(this.readUInt8()){case 1:A[U]=this.readLongString();break;case 2:A[U]=this.readVSBuffer();break;case 3:{const E=this.readUInt32(),L=this.readLongString(),z=[];for(let N=0;N<E;++N)z.push(this.readVSBuffer());A[U]=new F.SerializableObjectWithBuffers(D(L,z,null));break}case 4:A[U]=void 0;break}return A}}h.sizeUInt32=4;var u;(function(c){c[c.Simple=0]="Simple",c[c.Mixed=1]="Mixed"})(u||(u={}));class s{static _useMixedArgSerialization(S){for(let A=0,U=S.length;A<U;A++)if(S[A]instanceof t.VSBuffer||S[A]instanceof F.SerializableObjectWithBuffers||typeof S[A]=="undefined")return!0;return!1}static serializeRequestArguments(S,A){if(this._useMixedArgSerialization(S)){const U=[];for(let H=0,E=S.length;H<E;H++){const L=S[H];if(L instanceof t.VSBuffer)U[H]={type:2,value:L};else if(typeof L=="undefined")U[H]={type:4};else if(L instanceof F.SerializableObjectWithBuffers){const{jsonString:z,referencedBuffers:N}=d(L.value,A);U[H]={type:3,value:t.VSBuffer.fromString(z),buffers:N}}else U[H]={type:1,value:t.VSBuffer.fromString(v(L,A))}}return{type:1,args:U}}return{type:0,args:v(S,A)}}static serializeRequest(S,A,U,H,E){switch(H.type){case 0:return this._requestJSONArgs(S,A,U,H.args,E);case 1:return this._requestMixedArgs(S,A,U,H.args,E)}}static _requestJSONArgs(S,A,U,H,E){const L=t.VSBuffer.fromString(U),z=t.VSBuffer.fromString(H);let N=0;N+=h.sizeUInt8(),N+=h.sizeShortString(L),N+=h.sizeLongString(z);let $=h.alloc(E?2:1,S,N);return $.writeUInt8(A),$.writeShortString(L),$.writeLongString(z),$.buffer}static deserializeRequestJSONArgs(S){const A=S.readUInt8(),U=S.readShortString(),H=S.readLongString();return{rpcId:A,method:U,args:JSON.parse(H)}}static _requestMixedArgs(S,A,U,H,E){const L=t.VSBuffer.fromString(U);let z=0;z+=h.sizeUInt8(),z+=h.sizeShortString(L),z+=h.sizeMixedArray(H);let N=h.alloc(E?4:3,S,z);return N.writeUInt8(A),N.writeShortString(L),N.writeMixedArray(H),N.buffer}static deserializeRequestMixedArgs(S){const A=S.readUInt8(),U=S.readShortString(),H=S.readMixedArray(),E=new Array(H.length);for(let L=0,z=H.length;L<z;L++){const N=H[L];typeof N=="string"?E[L]=JSON.parse(N):E[L]=N}return{rpcId:A,method:U,args:E}}static serializeAcknowledged(S){return h.alloc(5,S,0).buffer}static serializeCancel(S){return h.alloc(6,S,0).buffer}static serializeReplyOK(S,A,U){if(typeof A=="undefined")return this._serializeReplyOKEmpty(S);if(A instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(S,A);if(A instanceof F.SerializableObjectWithBuffers){const{jsonString:H,referencedBuffers:E}=d(A.value,U,!0);return this._serializeReplyOKJSONWithBuffers(S,H,E)}else return this._serializeReplyOKJSON(S,n(A,U))}static _serializeReplyOKEmpty(S){return h.alloc(7,S,0).buffer}static _serializeReplyOKVSBuffer(S,A){let U=0;U+=h.sizeVSBuffer(A);let H=h.alloc(8,S,U);return H.writeVSBuffer(A),H.buffer}static deserializeReplyOKVSBuffer(S){return S.readVSBuffer()}static _serializeReplyOKJSON(S,A){const U=t.VSBuffer.fromString(A);let H=0;H+=h.sizeLongString(U);let E=h.alloc(9,S,H);return E.writeLongString(U),E.buffer}static _serializeReplyOKJSONWithBuffers(S,A,U){const H=t.VSBuffer.fromString(A);let E=0;E+=h.sizeUInt32,E+=h.sizeLongString(H);for(const z of U)E+=h.sizeVSBuffer(z);let L=h.alloc(10,S,E);L.writeUInt32(U.length),L.writeLongString(H);for(const z of U)L.writeBuffer(z);return L.buffer}static deserializeReplyOKJSON(S){const A=S.readLongString();return JSON.parse(A)}static deserializeReplyOKJSONWithBuffers(S,A){const U=S.readUInt32(),H=S.readLongString(),E=[];for(let L=0;L<U;++L)E.push(S.readVSBuffer());return new F.SerializableObjectWithBuffers(D(H,E,A))}static serializeReplyErr(S,A){return A?this._serializeReplyErrEror(S,A):this._serializeReplyErrEmpty(S)}static _serializeReplyErrEror(S,A){const U=t.VSBuffer.fromString(n(T.transformErrorForSerialization(A),null));let H=0;H+=h.sizeLongString(U);let E=h.alloc(11,S,H);return E.writeLongString(U),E.buffer}static deserializeReplyErrError(S){const A=S.readLongString();return JSON.parse(A)}static _serializeReplyErrEmpty(S){return h.alloc(12,S,0).buffer}}var b;(function(c){c[c.RequestJSONArgs=1]="RequestJSONArgs",c[c.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",c[c.RequestMixedArgs=3]="RequestMixedArgs",c[c.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",c[c.Acknowledged=5]="Acknowledged",c[c.Cancel=6]="Cancel",c[c.ReplyOKEmpty=7]="ReplyOKEmpty",c[c.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",c[c.ReplyOKJSON=9]="ReplyOKJSON",c[c.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",c[c.ReplyErrError=11]="ReplyErrError",c[c.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var y;(function(c){c[c.String=1]="String",c[c.VSBuffer=2]="VSBuffer",c[c.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",c[c.Undefined=4]="Undefined"})(y||(y={}))}),define(Ee[210],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const a=function(T){const k=P=>{self.removeEventListener("message",k);const C=P.data;Object.defineProperties(self,{postMessage:{value(R,F){C.postMessage(R,F)}},onmessage:{get(){return C.onmessage},set(R){C.onmessage=R}}}),C.addEventListener("message",R=>{self.dispatchEvent(new MessageEvent("message",{data:R.data}))}),C.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",k)}.toString();class t extends EventTarget{constructor(T,k,P){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const C=`((${a})('${k}'))`,R=new Blob([C],{type:"application/javascript"}),F=URL.createObjectURL(R),_=new MessageChannel,n=F,m={type:"_newWorker",id:n,port:_.port2,url:F,options:P};T(m,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:n};_.port1.postMessage(r),URL.revokeObjectURL(F),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(r){_.port1.onmessage=r}},onmessageerror:{get(){return _.port1.onmessageerror},set(r){_.port1.onmessageerror=r}}}),_.port1.addEventListener("messageerror",r=>{const g=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(g)}),_.port1.addEventListener("message",r=>{const g=new MessageEvent("message",{data:r.data});this.dispatchEvent(g)}),_.port1.start()}}e.NestedWorker=t}),define(Ee[211],ye([0,1,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(Ee[212],ye([0,1,10,17,23,2,3,61,46,171,211]),function(ne,e,a,t,w,T,k,P,C,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,k.createDecorator)("pathService");let _=class Vi{constructor(m,r,g,d){this.localUserHome=m,this.remoteAgentService=r,this.environmentService=g,this.contextService=d,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||w.OS)(),this.resolveUserHome=(async()=>{const D=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=D?.userHome||m})()}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,r){if(m.remoteAuthority)return a.Schemas.vscodeRemote;const g=(0,P.getVirtualWorkspaceScheme)(r.getWorkspace());if(g)return g;const d=r.getWorkspace().folders[0];if(d)return d.uri.scheme;const D=r.getWorkspace().configuration;return D?D.scheme:a.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?t.win32:t.posix)}async fileURI(m){let r="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const d=m.indexOf("/",2);d===-1?(r=m.substring(2),m="/"):(r=m.substring(2,d),m=m.substring(d)||"/")}return T.URI.from({scheme:a.Schemas.file,authority:r,path:m,query:"",fragment:""})}};_=Be([He(1,F.IRemoteAgentService),He(2,R.IWorkbenchEnvironmentService),He(3,C.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(Ee[96],ye([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(k,P){this.line=k,this.character=P}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,P){return new a(0,0)}with(k){return new a(0,0)}}e.Position=a;class t{constructor(k,P,C,R){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(k,P),this.end=new a(C,R)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new t(0,0,0,0)}with(k){return new t(0,0,0,0)}}e.Range=t;var w;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(w=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ee[40],ye([0,1,16,29,26,42,9,3,17,15,96,11]),function(ne,e,a,t,w,T,k,P,C,R,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",m=" characters skipped \u27EB",r=(n.length+m.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var g;(function(j){j[j.file=0]="file",j[j.text=1]="text"})(g=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(j){j[j.File=1]="File",j[j.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function D(j){return!!j.preview}e.resultIsMatch=D;function v(j){return!!j.resource}e.isFileMatch=v;function f(j){return!!j.message}e.isProgressMessage=f;var p;(function(j){j[j.Normal=0]="Normal",j[j.NewSearchStarted=1]="NewSearchStarted"})(p=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class I{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=I;class l{constructor(ue,K,ie){this.ranges=K;const pe=Array.isArray(K)?K:[K];if(ie&&ie.matchLines===1&&M(pe)){ue=(0,k.getNLines)(ue,ie.matchLines);let we="",ae=0,le=0;const Se=Math.floor(ie.charsPerLine/5),Ce=[];for(const Fe of pe){const $e=Math.max(Fe.startColumn-Se,0),Ve=Fe.startColumn+ie.charsPerLine;if($e>le+Se+r){const je=n+($e-le)+m;we+=je+ue.slice($e,Ve),ae+=$e-(le+je.length)}else we+=ue.slice(le,Ve);Ce.push(new i(0,Fe.startColumn-ae,Fe.endColumn-ae)),le=Ve}this.preview={text:we,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const we=Array.isArray(K)?K[0].startLineNumber:K.startLineNumber;this.preview={text:ue,matches:(0,a.mapArrayOrNot)(K,ae=>new o(ae.startLineNumber-we,ae.startColumn,ae.endLineNumber-we,ae.endColumn))}}}}e.TextSearchMatch=l;function M(j){const ue=j[0].startLineNumber;for(const K of j)if(K.startLineNumber!==ue||K.endLineNumber!==ue)return!1;return!0}class o{constructor(ue,K,ie,pe){this.startLineNumber=ue,this.startColumn=K,this.endLineNumber=ie,this.endColumn=pe}}e.SearchRange=o;class i extends o{constructor(ue,K,ie){super(ue,K,ue,ie)}}e.OneLineRange=i;var h;(function(j){j.Default="default",j.FileNames="fileNames",j.Type="type",j.Modified="modified",j.CountDescending="countDescending",j.CountAscending="countAscending"})(h=e.SearchSortOrder||(e.SearchSortOrder={}));function u(j,ue=!0){const K=j&&j.files&&j.files.exclude,ie=ue&&j&&j.search&&j.search.exclude;if(!K&&!ie)return;if(!K||!ie)return K||ie;let pe=Object.create(null);return pe=w.mixin(pe,w.deepClone(K)),pe=w.mixin(pe,w.deepClone(ie),!0),pe}e.getExcludes=u;function s(j,ue){return j.excludePattern&&t.match(j.excludePattern,ue)?!1:j.includePattern||j.usingSearchPaths?j.includePattern&&t.match(j.includePattern,ue)?!0:j.usingSearchPaths?!!j.folderQueries&&j.folderQueries.some(K=>{const ie=K.folder.fsPath;if(T.isEqualOrParent(ue,ie)){const pe=C.relative(ie,ue);return!K.includePattern||!!t.match(K.includePattern,pe)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var b;(function(j){j[j.unknownEncoding=1]="unknownEncoding",j[j.regexParseError=2]="regexParseError",j[j.globParseError=3]="globParseError",j[j.invalidLiteral=4]="invalidLiteral",j[j.rgProcessError=5]="rgProcessError",j[j.other=6]="other",j[j.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class y extends Error{constructor(ue,K){super(ue);this.code=K}}e.SearchError=y;function c(j){const ue=j.message;if((0,R.isPromiseCanceledError)(j))return new y(ue,b.canceled);try{const K=JSON.parse(ue);return new y(K.message,K.code)}catch{return new y(ue,b.other)}}e.deserializeSearchError=c;function S(j){const ue={message:j.message,code:j.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=S;function A(j){return j.type==="error"?!0:j.type==="success"}e.isSerializedSearchComplete=A;function U(j){return j.type==="success"}e.isSerializedSearchSuccess=U;function H(j){return!!j.path}e.isSerializedFileMatch=H;function E(j,ue){const K=j.searchPath?j.searchPath:j.relativePath;return(0,k.fuzzyContains)(K,ue)}e.isFilePatternMatch=E;class L{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=L;function z(j,ue){const K={...j||{},...ue||{}};return Object.keys(K).filter(ie=>{const pe=K[ie];return typeof pe=="boolean"&&pe})}e.resolvePatternsForProvider=z;class N{constructor(ue,K){this._parsedIncludeExpression=null,this._excludeExpression={...ue.excludePattern||{},...K.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let ie=ue.includePattern;K.includePattern&&(ie?ie={...ie,...K.includePattern}:ie=K.includePattern),ie&&(this._parsedIncludeExpression=t.parse(ie))}matchesExcludesSync(ue,K,ie){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,K,ie))}includedInQuerySync(ue,K,ie){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,K,ie)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ue,K,ie))}includedInQuery(ue,K,ie){const pe=this._parsedExcludeExpression(ue,K,ie),we=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ue,K,ie):!0;return(0,_.isPromise)(pe)?pe.then(ae=>ae?!1:we()):we()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=N;function $(j){for(const ue in j)if(typeof j[ue]!="boolean")return!0;return!1}}),define(Ee[31],ye([0,1,16,14,20,4,21,10,75,24,9,11,2,125,3,12,138,46,30,28,13,7,40,5]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m,r,g,d,D,v,f,p,I,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(S,A,U){return new R.ExtUri(H=>s(H,U)).isEqual(S,A)}function i(S,A,U){return o(S.uri,A.uri,U)?0:(0,F.compare)(S.uri.toString(),A.uri.toString())}function h(S,A,U){return S.index!==A.index?S.index<A.index?-1:1:o(S.uri,A.uri,U)?(0,F.compare)(S.name,A.name):(0,F.compare)(S.uri.toString(),A.uri.toString())}function u(S,A,U,H){const E=S.slice(0).sort((z,N)=>U(z,N,H)),L=A.slice(0).sort((z,N)=>U(z,N,H));return(0,a.delta)(E,L,(z,N)=>U(z,N,H))}function s(S,A){const U=A.getCapabilities(S.scheme);return!(U&&U&1024)}class b extends D.Workspace{constructor(A,U,H,E,L,z,N){super(A,H.map($=>new D.WorkspaceFolder($)),E,L,N);this._name=U,this._isUntitled=z,this._workspaceFolders=[],this._structure=k.TernarySearchTree.forUris(N),H.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}static toExtHostWorkspace(A,U,H,E){if(!A)return{workspace:null,added:[],removed:[]};const{id:L,name:z,folders:N,configuration:$,transient:j,isUntitled:ue}=A,K=[],ie=U;U?N.forEach((le,Se)=>{const Ce=n.URI.revive(le.uri),Fe=b._findFolder(H||U,Ce,E);Fe?(Fe.name=le.name,Fe.index=le.index,K.push(Fe)):K.push({uri:Ce,name:le.name,index:Se})}):K.push(...N.map(({uri:le,name:Se,index:Ce})=>({uri:n.URI.revive(le),name:Se,index:Ce}))),K.sort((le,Se)=>le.index<Se.index?-1:1);const pe=new b(L,z,K,!!j,$?n.URI.revive($):null,!!ue,le=>s(le,E)),{added:we,removed:ae}=u(ie?ie.workspaceFolders:[],pe.workspaceFolders,i,E);return{workspace:pe,added:we,removed:ae}}static _findFolder(A,U,H){for(let E=0;E<A.folders.length;E++){const L=A.workspaceFolders[E];if(o(L.uri,U,H))return L}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(A,U){return U&&this._structure.get(A)&&(A=(0,R.dirname)(A)),this._structure.findSubstr(A)}resolveWorkspaceFolder(A){return this._structure.get(A)}}let y=class{constructor(A,U,H,E){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=E,this._extHostFileSystemInfo=H,this._requestIdProvider=new C.Counter,this._barrier=new t.Barrier,this._proxy=A.getProxy(M.MainContext.MainThreadWorkspace),this._messageService=A.getProxy(M.MainContext.MainThreadMessageService);const L=U.workspace;this._confirmedWorkspace=L?new b(L.id,L.name,[],!!L.transient,L.configuration?n.URI.revive(L.configuration):null,!!L.isUntitled,z=>s(z,H)):void 0}$initializeWorkspace(A,U){this._trusted=U,this.$acceptWorkspaceData(A),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:P.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(A,U,H,...E){const L=[];if(Array.isArray(E)&&E.forEach(ue=>{n.URI.isUri(ue.uri)&&!L.some(K=>o(K.uri,ue.uri,this._extHostFileSystemInfo))&&L.push({uri:ue.uri,name:ue.name||(0,R.basenameOrAuthority)(ue.uri)})}),this._unconfirmedWorkspace||[U,H].some(ue=>typeof ue!="number"||ue<0)||H===0&&L.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+H>z.length)return!1;const N=z.slice(0);N.splice(U,H,...L.map(ue=>({uri:ue.uri,name:ue.name||(0,R.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<N.length;ue++){const K=N[ue];if(N.some((ie,pe)=>pe!==ue&&o(K.uri,ie.uri,this._extHostFileSystemInfo)))return!1}N.forEach((ue,K)=>ue.index=K);const{added:$,removed:j}=u(z,N,h,this._extHostFileSystemInfo);if($.length===0&&j.length===0)return!1;if(this._proxy){const ue=A.displayName||A.name;this._proxy.$updateWorkspaceFolders(ue,U,H,L).then(void 0,K=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(d.Severity.Error,(0,m.localize)(0,null,ue,K.toString()),{extension:A},[])})}return this.trySetWorkspaceFolders(N),!0}getWorkspaceFolder(A,U){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,U)}async getWorkspaceFolder2(A,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,U)}async resolveWorkspaceFolder(A){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(A)}getPath(){if(!this._actualWorkspace)return;const{folders:A}=this._actualWorkspace;if(A.length!==0)return A[0].uri.fsPath}getRelativePath(A,U){let H,E="";if(typeof A=="string"?(H=n.URI.file(A),E=A):typeof A!="undefined"&&(H=A,E=A.fsPath),!H)return E;const L=this.getWorkspaceFolder(H,!0);if(!L)return E;typeof U=="undefined"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let z=(0,R.relativePath)(L.uri,H);return U&&L.name&&(z=`${L.name}/${z}`),z}trySetWorkspaceFolders(A){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:A,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(A){const{workspace:U,added:H,removed:E}=b.toExtHostWorkspace(A,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:H,removed:E}))}findFiles(A,U,H,E,L=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${E.value}, entryPoint: findFiles`);let z;if(U===null?z=!1:U&&(typeof U=="string"?z=U:z=U.pattern),L&&L.isCancellationRequested)return Promise.resolve([]);const{includePattern:N,folder:$}=c(A);return this._proxy.$startFileSearch((0,_.withUndefinedAsNull)(N),(0,_.withUndefinedAsNull)($),(0,_.withUndefinedAsNull)(z),(0,_.withUndefinedAsNull)(H),L).then(j=>Array.isArray(j)?j.map(ue=>n.URI.revive(ue)):[])}async findTextInFiles(A,U,H,E,L=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${E.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),N=typeof U.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:$,folder:j}=c(U.include),ue=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,K={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:N,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:$,excludePattern:ue},ie=!1;if(this._activeSearchCallbacks[z]=pe=>{if(ie)return;const we=n.URI.revive(pe.resource);pe.results.forEach(ae=>{(0,l.resultIsMatch)(ae)?H({uri:we,preview:{text:ae.preview.text,matches:(0,a.mapArrayOrNot)(ae.preview.matches,le=>new I.Range(le.startLineNumber,le.startColumn,le.endLineNumber,le.endColumn))},ranges:(0,a.mapArrayOrNot)(ae.ranges,le=>new I.Range(le.startLineNumber,le.startColumn,le.endLineNumber,le.endColumn))}):H({uri:we,text:ae.text,lineNumber:ae.lineNumber})})},L.isCancellationRequested)return{};try{const pe=await this._proxy.$startTextSearch(A,(0,_.withUndefinedAsNull)(j),K,z,L);return delete this._activeSearchCallbacks[z],pe||{}}catch(pe){throw delete this._activeSearchCallbacks[z],pe}}$handleTextSearchResult(A,U){this._activeSearchCallbacks[U]&&this._activeSearchCallbacks[U](A)}saveAll(A){return this._proxy.$saveAll(A)}resolveProxy(A){return this._proxy.$resolveProxy(A)}get trusted(){return this._trusted}requestWorkspaceTrust(A){return this._proxy.$requestWorkspaceTrust(A)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};y=Be([He(0,p.IExtHostRpcService),He(1,f.IExtHostInitDataService),He(2,v.IExtHostFileSystemInfo),He(3,g.ILogService)],y),e.ExtHostWorkspace=y,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function c(S){let A,U;return S&&(typeof S=="string"?A=S:(A=S.pattern,U=S.baseFolder||n.URI.file(S.base))),{includePattern:A,folder:U}}}),define(Ee[32],ye([0,1,26,4,31,5,7,142,83,11,14,3,13,12,2]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function g(M,o){if(o){const i=o.split(".");let h=M;for(let u=0;h&&u<i.length;u++)h=h[i[u]];return h}}function d(M){return M instanceof r.URI}function D(M){return M&&M.uri instanceof r.URI&&M.languageId&&typeof M.languageId=="string"}function v(M){return M&&!M.uri&&M.languageId&&typeof M.languageId=="string"}function f(M){return M&&M.uri instanceof r.URI&&(!M.name||typeof M.name=="string")&&(!M.index||typeof M.index=="number")}function p(M){if(d(M))return{resource:M};if(D(M))return{resource:M.uri,overrideIdentifier:M.languageId};if(v(M))return{overrideIdentifier:M.languageId};if(f(M))return{resource:M.uri};if(M===null)return{resource:null}}let I=class{constructor(o,i,h){this._proxy=o.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=h,this._barrier=new F.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new l(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,i){this.getConfigProvider().then(h=>h.$acceptConfigurationChanged(o,i))}};I=Be([He(0,n.IExtHostRpcService),He(1,w.IExtHostWorkspace),He(2,m.ILogService)],I),e.ExtHostConfiguration=I;class l{constructor(o,i,h,u){this._onDidChangeConfiguration=new t.Emitter,this._proxy=o,this._logService=u,this._extHostWorkspace=i,this._configuration=P.Configuration.parse(h),this._configurationScopes=this._toMap(h.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,i){const h={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,h))}getConfiguration(o,i,h){const u=p(i)||{},s=this._toReadonlyValue(o?g(this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,u,h?.identifier);function b(c){if(c==null)return null;if(typeof c=="boolean")return c?1:4;switch(c){case k.ConfigurationTarget.Global:return 1;case k.ConfigurationTarget.Workspace:return 4;case k.ConfigurationTarget.WorkspaceFolder:return 5}}const y={has(c){return typeof g(s,c)!="undefined"},get:(c,S)=>{this._validateConfigurationAccess(o?`${o}.${c}`:c,u,h?.identifier);let A=g(s,c);if(typeof A=="undefined")A=S;else{let U;const H=(E,L)=>{let z;const N=()=>{U=U||(0,a.deepClone)(s),z=z||g(U,L)};return(0,R.isObject)(E)?new Proxy(E,{get:($,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return N(),()=>z;if(U)return z=z||g(U,L),z[j];const ue=$[j];return typeof j=="string"?H(ue,`${L}.${j}`):ue},set:($,j,ue)=>(N(),z&&(z[j]=ue),!0),deleteProperty:($,j)=>(N(),z&&delete z[j],!0),defineProperty:($,j,ue)=>(N(),z&&Object.defineProperty(z,j,ue),!0)}):E};A=H(A,c)}return A},update:(c,S,A,U)=>{c=o?`${o}.${c}`:c;const H=b(A);return S!==void 0?this._proxy.$updateConfigurationOption(H,c,S,u,U):this._proxy.$removeConfigurationOption(H,c,u,U)},inspect:c=>{c=o?`${o}.${c}`:c;const S=(0,a.deepClone)(this._configuration.inspect(c,u,this._extHostWorkspace.workspace));if(S)return{key:c,defaultValue:S.default?.value,globalValue:S.user?.value,workspaceValue:S.workspace?.value,workspaceFolderValue:S.workspaceFolder?.value,defaultLanguageValue:S.default?.override,globalLanguageValue:S.user?.override,workspaceLanguageValue:S.workspace?.override,workspaceFolderLanguageValue:S.workspaceFolder?.override,languageIds:S.overrideIdentifiers}}};return typeof s=="object"&&(0,a.mixin)(y,s,!1),Object.freeze(y)}_toReadonlyValue(o){const i=h=>(0,R.isObject)(h)?new Proxy(h,{get:(u,s)=>i(u[s]),set:(u,s,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(s)}' of object`)},deleteProperty:(u,s)=>{throw new Error(`TypeError: Cannot delete read only property '${String(s)}' of object`)},defineProperty:(u,s)=>{throw new Error(`TypeError: Cannot define property '${String(s)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):h;return i(o)}_validateConfigurationAccess(o,i,h){const u=C.OVERRIDE_PROPERTY_REGEX.test(o)?4:this._configurationScopes.get(o),s=h?`[${h.value}] `:"";if(u===4){typeof i?.resource=="undefined"&&this._logService.warn(`${s}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){i?.resource&&this._logService.warn(`${s}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,i){const h=new P.ConfigurationChangeEvent(o,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(u,s)=>h.affectsConfiguration(u,p(s))})}_toMap(o){return o.reduce((i,h)=>(i.set(h[0],h[1]),i),new Map)}}e.ExtHostConfigProvider=l,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(ne,a):w?w.value=a:e.set(ne,a),a},Re=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Ee[97],ye([0,1,2,14,4,5,7,31,48,32,20,39,13,28,3,10,23,12,69,161,15]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m,r,g,d,D,v,f,p){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var l;(function(L){function z($){if($!=null)return $}L.from=z;function N($){if($!=null)return $}L.to=N})(l=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var M;(function(L){function z($){if($!=null)return $}L.from=z;function N($){if($!=null)return $}L.to=N})(M=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(L){function z($){if($!=null)return $}L.from=z;function N($){if($!=null)return $}L.to=N})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(L){function z(j){if(j){const ue=j;return ue&&!!ue.process}else return!1}L.is=z;function N(j){if(j==null)return;const ue={process:j.process,args:j.args};return j.options&&(ue.options=o.from(j.options)),ue}L.from=N;function $(j){if(j!=null)return new k.ProcessExecution(j.process,j.args,j.options)}L.to=$})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var h;(function(L){function z($){if($!=null)return $}L.from=z;function N($){if($!=null)return $}L.to=N})(h=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var u;(function(L){function z(j){if(j){const ue=j;return ue&&(!!ue.commandLine||!!ue.command)}else return!1}L.is=z;function N(j){if(j==null)return;const ue={};return j.commandLine!==void 0?ue.commandLine=j.commandLine:(ue.command=j.command,ue.args=j.args),j.options&&(ue.options=h.from(j.options)),ue}L.from=N;function $(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new k.ShellExecution(j.commandLine,j.options):new k.ShellExecution(j.command,j.args?j.args:[],j.options)}L.to=$})(u=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var s;(function(L){function z(j){if(j){let ue=j;return ue&&ue.customExecution==="customExecution"}else return!1}L.is=z;function N(j){return{customExecution:"customExecution"}}L.from=N;function $(j,ue){return ue.get(j)}L.to=$})(s=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(L){function z(N,$){let j;return N.scope!==void 0&&typeof N.scope!="number"?j=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===k.TaskScope.Workspace&&$&&$.workspaceFile?j=$.workspaceFile:j=f.USER_TASKS_GROUP_KEY),{id:N._id,workspaceFolder:j}}L.from=z})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var y;(function(L){function z(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}L.from=z})(y=e.TaskGroupDTO||(e.TaskGroupDTO={}));var c;(function(L){function z(j,ue){if(j==null)return[];const K=[];for(let ie of j){const pe=N(ie,ue);pe&&K.push(pe)}return K}L.fromMany=z;function N(j,ue){if(j==null)return;let K;j.execution instanceof k.ProcessExecution?K=i.from(j.execution):j.execution instanceof k.ShellExecution?K=u.from(j.execution):j.execution&&j.execution instanceof k.CustomExecution&&(K=s.from(j.execution));const ie=l.from(j.definition);let pe;return j.scope?typeof j.scope=="number"?pe=j.scope:pe=j.scope.uri:pe=k.TaskScope.Workspace,!ie||!pe?void 0:{_id:j._id,definition:ie,name:j.name,source:{extensionId:ue.identifier.value,label:j.source,scope:pe},execution:K,isBackground:j.isBackground,group:y.from(j.group),presentationOptions:M.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}L.from=N;async function $(j,ue,K){if(j==null)return;let ie;i.is(j.execution)?ie=i.to(j.execution):u.is(j.execution)?ie=u.to(j.execution):s.is(j.execution)&&(ie=s.to(j._id,K));const pe=l.to(j.definition);let we;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?we=j.source.scope:we=await ue.resolveWorkspaceFolder(a.URI.revive(j.source.scope)):we=k.TaskScope.Workspace),!pe||!we)return;const ae=new k.Task(pe,we,j.name,j.source.label,ie,j.problemMatchers);return j.isBackground!==void 0&&(ae.isBackground=j.isBackground),j.group!==void 0&&(ae.group=k.TaskGroup.from(j.group._id),ae.group&&j.group.isDefault&&(ae.group=new k.TaskGroup(ae.group.id,ae.group.label),j.group.isDefault&&(ae.group.isDefault=j.group.isDefault))),j.presentationOptions&&(ae.presentationOptions=M.to(j.presentationOptions)),j._id&&(ae._id=j._id),j.detail&&(ae.detail=j.detail),ae}L.to=$})(c=e.TaskDTO||(e.TaskDTO={}));var S;(function(L){function z($){return $}L.from=z;function N($){if(!!$)return Object.assign(Object.create(null),$)}L.to=N})(S=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(z,N,$){this._id=N,this._task=$,I.set(this,void 0),Ze(this,I,z,"f")}get task(){return this._task}terminate(){Re(this,I,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}I=new WeakMap;var U;(function(L){function z(N){return{id:N._id,task:void 0}}L.from=z})(U=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let H=class{constructor(z,N,$,j,ue,K,ie,pe){this._onDidExecuteTask=new w.Emitter,this._onDidTerminateTask=new w.Emitter,this._onDidTaskProcessStarted=new w.Emitter,this._onDidTaskProcessEnded=new w.Emitter,this._proxy=z.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=j,this._configurationService=ue,this._terminalService=K,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ie,this._deprecationService=pe,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,N,$){if(!$)return new k.Disposable(()=>{});const j=this.nextHandle();return this._handlers.set(j,{type:N,provider:$,extension:z}),this._proxy.$registerTaskProvider(j,N),new k.Disposable(()=>{this._handlers.delete(j),this._proxy.$unregisterTaskProvider(j)})}registerTaskSystem(z,N){this._proxy.$registerTaskSystem(z,N)}fetchTasks(z){return this._proxy.$fetchTasks(S.from(z)).then(async N=>{const $=[];for(let j of N){const ue=await c.to(j,this._workspaceProvider,this._providedCustomExecutions2);ue&&$.push(ue)}return $})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(N=>z.push(N)),z}terminateTask(z){if(!(z instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,N,$){const j=this._providedCustomExecutions2.get(z.id);j&&(this._activeCustomExecutions2.set(z.id,j),this._terminalService.attachPtyToTerminal(N,await j.callback($))),this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const N=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:N})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const N=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:N,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const N=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:N,exitCode:z.exitCode})}$provideTasks(z,N){const $=this._handlers.get(z);if(!$)return Promise.reject(new Error("no handler found"));const j=[],ue=(0,t.asPromise)(()=>$.provider.provideTasks(F.CancellationToken.None)).then(K=>this.provideTasksInternal(N,j,$,K));return new Promise(K=>{ue.then(ie=>{Promise.all(j).then(()=>{K(ie)})})})}async $resolveTask(z,N){const $=this._handlers.get(z);if(!$)return Promise.reject(new Error("no handler found"));if(N.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${$.type}].`);const j=await c.to(N,this._workspaceProvider,this._providedCustomExecutions2);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const ue=await $.provider.resolveTask(j,F.CancellationToken.None);if(!ue)return;this.checkDeprecation(ue,$);const K=c.from(ue,$.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(ue.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return s.is(K.execution)&&await this.addCustomExecution(K,ue,!0),await this.resolveTaskInternal(K)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,N,$){const j=await this._proxy.$createTaskId(z);!$&&!this._providedCustomExecutions2.has(j)&&(this._notProvidedCustomExecutions.add(j),this._activeCustomExecutions2.set(j,N.execution)),this._providedCustomExecutions2.set(j,N.execution)}async getTaskExecution(z,N){if(typeof z=="string"){const ue=this._taskExecutionPromises.get(z);if(!ue)throw new Error("Unexpected: The specified task is missing an execution");return ue}let $=this._taskExecutionPromises.get(z.id);if($)return $;const j=new Promise((ue,K)=>{function ie(pe,we,ae){ae?ue(new A(pe,we.id,ae)):K("Unexpected: Task does not exist.")}N?ie(this,z,N):c.to(z.task,this._workspaceProvider,this._providedCustomExecutions2).then(pe=>ie(this,z,pe))});return this._taskExecutionPromises.set(z.id,j),j.then(ue=>(this._taskExecutions.set(z.id,ue),ue),ue=>Promise.reject(ue))}checkDeprecation(z,N){z._deprecated&&this._deprecationService.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let $=this._notProvidedCustomExecutions.values(),j=$.next();for(;!j.done;)!this._activeCustomExecutions2.has(j.value)&&this._lastStartedTask!==j.value&&(this._providedCustomExecutions2.delete(j.value),this._notProvidedCustomExecutions.delete(j.value)),j=$.next()}};H=Be([He(0,n.IExtHostRpcService),He(1,m.IExtHostInitDataService),He(2,P.IExtHostWorkspace),He(3,C.IExtHostDocumentsAndEditors),He(4,R.IExtHostConfiguration),He(5,_.IExtHostTerminalService),He(6,D.ILogService),He(7,v.IExtHostApiDeprecationService)],H),e.ExtHostTaskBase=H;let E=class extends H{constructor(z,N,$,j,ue,K,ie,pe){super(z,N,$,j,ue,K,ie,pe);this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(z,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const $=c.from(N,z);if($===void 0)throw new Error("Task is not valid");if(s.is($.execution))await this.addCustomExecution($,N,!1);else throw new p.NotSupportedError;const j=await this.getTaskExecution(await this._proxy.$getTaskExecution($),N);return this._proxy.$executeTask($).catch(ue=>{throw new Error(ue)}),j}provideTasksInternal(z,N,$,j){const ue=[];if(j)for(let K of j){this.checkDeprecation(K,$),(!K.definition||!z[K.definition.type])&&this._logService.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const ie=c.from(K,$.extension);ie&&s.is(ie.execution)?(ue.push(ie),N.push(this.addCustomExecution(ie,K,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ue,extension:$.extension}}async resolveTaskInternal(z){if(s.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,N,$){}};E=Be([He(0,n.IExtHostRpcService),He(1,m.IExtHostInitDataService),He(2,P.IExtHostWorkspace),He(3,C.IExtHostDocumentsAndEditors),He(4,R.IExtHostConfiguration),He(5,_.IExtHostTerminalService),He(6,D.ILogService),He(7,v.IExtHostApiDeprecationService)],E),e.WorkerExtHostTask=E,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")}),define(Ee[213],ye([0,1,16,74,29,77,21,10,17,24,9,11,2,231,128,81,46,90,212,40]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m,r,g,d,D,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(b,y,c,S){this.configurationService=b,this.workspaceContextService=y,this.editorGroupsService=c,this.pathService=S}text(b,y,c={}){b=this.getContentPattern(b,c);const S=this.configurationService.getValue(),A=y&&y.some(H=>!this.configurationService.getValue({resource:H}).search.useRipgrep);return{...this.commonQuery(y?.map(d.toWorkspaceFolder),c),type:2,contentPattern:b,previewOptions:c.previewOptions,maxFileSize:c.maxFileSize,usePCRE2:S.search.usePCRE2||A||!1,beforeContext:c.beforeContext,afterContext:c.afterContext,userDisabledExcludesAndIgnoreFiles:c.disregardExcludeSettings&&c.disregardIgnoreFiles}}getContentPattern(b,y){const c=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const S={...b,wordSeparators:c.editor.wordSeparators};return this.isCaseSensitive(b,y)&&(S.isCaseSensitive=!0),this.isMultiline(b)&&(S.isMultiline=!0),S}file(b,y={}){return{...this.commonQuery(b,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}handleIncludeExclude(b,y){return b?(b=Array.isArray(b)?b.map(i):i(b),y?this.parseSearchPaths(b):{pattern:l(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],y={}){const c=this.handleIncludeExclude(y.includePattern,y.expandPatterns),S=this.handleIncludeExclude(y.excludePattern,y.expandPatterns),A=b.length>1,U=(c.searchPaths&&c.searchPaths.length?c.searchPaths.map(L=>this.getFolderQueryForSearchPath(L,y,S)):b.map(L=>this.getFolderQueryForRoot(L,y,S,A))).filter(L=>!!L),H={_reason:y._reason,folderQueries:U,usingSearchPaths:!!(c.searchPaths&&c.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:S.pattern,includePattern:c.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const z=a.coalesce(a.flatten(this.editorGroupsService.groups.map($=>$.editors.map(j=>j.resource)))).filter($=>(0,f.pathIncludedInQuery)(H,$.fsPath)),N=this.commonQueryFromFileList(z);return{...H,...N}}const E=y.extraFileResources&&y.extraFileResources.filter(L=>(0,f.pathIncludedInQuery)(H,L.fsPath));return H.extraFileResources=E&&E.length?E:void 0,H}commonQueryFromFileList(b){const y=[],c=new k.ResourceMap,S={};let A=!1;return b.forEach(U=>{if(U.scheme===P.Schemas.walkThrough)return;if((0,R.isAbsolutePath)(U)){const E=this.workspaceContextService.getWorkspaceFolder(U)?.uri??U.with({path:C.dirname(U.fsPath)});let L=c.get(E);L||(A=!0,L={folder:E,includePattern:{}},y.push(L),c.set(E,L));const z=C.relative(E.fsPath,U.fsPath);(0,_.assertIsDefined)(L.includePattern)[z.replace(/\\/g,"/")]=!0}else U.fsPath&&(A=!0,S[U.fsPath]=!0)}),{folderQueries:y,includePattern:S,usingSearchPaths:!0,excludePattern:A?void 0:{"**/*":!0}}}isCaseSensitive(b,y){if(y.isSmartCase){if(b.isRegExp){if(F.containsUppercaseCharacter(b.pattern,!0))return!0}else if(F.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,m.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const y=N=>C.isAbsolute(N)||/^\.\.?([\/\\]|$)/.test(N),S=(Array.isArray(b)?b:M(b)).map(N=>{const $=this.pathService.resolvedUserHome;return $?(0,T.untildify)(N,$.scheme===P.Schemas.file?$.fsPath:$.path):N}),A=t.groupBy(S,N=>y(N)?"searchPaths":"exprSegments"),U=(A.exprSegments||[]).map(N=>F.rtrim(N,"/")).map(N=>F.rtrim(N,"\\")).map(N=>(N[0]==="."&&(N="*"+N),o(N))),H={},E=this.expandSearchPathPatterns(A.searchPaths||[]);E&&E.length&&(H.searchPaths=E);const L=a.flatten(U),z=l(...L);return z&&(H.pattern=z),H}getExcludesForFolder(b,y){return y.disregardExcludeSettings?void 0:(0,f.getExcludes)(b,!y.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const y=a.flatten(b.map(S=>{let{pathPortion:A,globPortion:U}=I(S);U&&(U=h(U));const H=this.expandOneSearchPath(A);return a.flatten(H.map(E=>this.resolveOneSearchPathPattern(E,U)))})),c=new Map;return y.forEach(S=>{const A=S.searchPath.toString(),U=c.get(A);U?S.pattern&&(U.pattern=U.pattern||{},U.pattern[S.pattern]=!0):c.set(A,{searchPath:S.searchPath,pattern:S.pattern?l(S.pattern):void 0})}),Array.from(c.values())}expandOneSearchPath(b){if(C.isAbsolute(b)){const y=this.workspaceContextService.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==P.Schemas.file?[{searchPath:y[0].uri.with({path:b})}]:[{searchPath:n.URI.file(C.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const y=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=i(b),b.startsWith("../")||b===".."){const S=C.posix.resolve(y.path,b);return[{searchPath:y.with({path:S})}]}const c=h(b);return[{searchPath:y,pattern:c}]}else{if(b==="./"||b===".\\")return[];{const y=b.replace(/^\.[\/\\]/,""),S=this.workspaceContextService.getWorkspace().folders.map(A=>{const U=y.match(new RegExp(`^${F.escapeRegExpCharacters(A.name)}(?:/(.*)|$)`));return U?{match:U,folder:A}:null}).filter(_.isDefined);if(S.length)return S.map(A=>{const U=A.match[1];return{searchPath:A.folder.uri,pattern:U&&h(U)}});{const A=b.match(/\.[\/\\](.+)[\/\\]?/),U=A?A[1]:b,H=r.localize(0,null,U);throw new Error(H)}}}}resolveOneSearchPathPattern(b,y){const c=b.pattern&&y?`${b.pattern}/${y}`:b.pattern||y,S=[{searchPath:b.searchPath,pattern:c}];return c&&!c.endsWith("**")&&S.push({searchPath:b.searchPath,pattern:c+"/**"}),S}getFolderQueryForSearchPath(b,y,c){const S=this.getFolderQueryForRoot((0,d.toWorkspaceFolder)(b.searchPath),y,c,!1);return S?{...S,includePattern:b.pattern}:null}getFolderQueryForRoot(b,y,c,S){let A;const U=n.URI.isUri(b)?b:b.uri;if(c.searchPaths){const N=c.searchPaths.filter($=>(0,R.isEqual)($.searchPath,U))[0];if(N&&!N.pattern)return null;N&&(A=N.pattern)}const H=this.configurationService.getValue({resource:U}),L={...this.getExcludesForFolder(H,y)||{},...A||{}},z=n.URI.isUri(b)?(0,R.basename)(b):b.name;return{folder:U,folderName:S?z:void 0,excludePattern:Object.keys(L).length>0?L:void 0,fileEncoding:H.files&&H.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!H.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!H.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!H.search.followSymlinks}}};p=Be([He(0,g.IConfigurationService),He(1,d.IWorkspaceContextService),He(2,D.IEditorGroupsService),He(3,v.IPathService)],p),e.QueryBuilder=p;function I(s){const b=s.match(/[\*\{\}\(\)\[\]\?]/);if(b){const y=b.index,c=s.substr(0,y).match(/[/|\\][^/\\]*$/);if(c){let S=s.substr(0,c.index);return S.match(/[/\\]/)||(S+="/"),{pathPortion:S,globPortion:s.substr((c.index||0)+1)}}}return{pathPortion:s}}function l(...s){return s.length?s.reduce((b,y)=>(b[y]=!0,b),Object.create(null)):void 0}function M(s){return w.splitGlobAware(s,",").map(b=>b.trim()).filter(b=>!!b.length)}function o(s){return[`**/${s}/**`,`**/${s}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function i(s){return s.replace(/\\/g,"/")}function h(s){return i(s).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(s,b){s=a.distinct(s,S=>S.toString());const y=[],c=b.getWorkspace();return s&&s.forEach(S=>{let A;if(b.getWorkbenchState()===2)A=(0,R.relativePath)(c.folders[0].uri,S),A&&A!=="."&&(A="./"+A);else{const U=b.getWorkspaceFolder(S);if(U){const H=U.name;if(c.folders.filter(L=>L.name===H).length===1){const L=(0,R.relativePath)(U.uri,S);L===""?A=`./${U.name}`:A=`./${U.name}/${L}`}else A=S.fsPath}}A&&y.push(A)}),y}e.resolveResourcesForSearchIncludes=u}),define(Ee[214],ye([0,1,24,2,20,15,3,213,40,46]),function(ne,e,a,t,w,T,k,P,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const F=7e3;function _(g,d){const D=d.activationEvents;if(!D)return Promise.resolve(void 0);const v=[],f=[];for(const i of D)if(/^workspaceContains:/.test(i)){const h=i.substr("workspaceContains:".length);h.indexOf("*")>=0||h.indexOf("?")>=0||g.forceUsingSearch?f.push(h):v.push(h)}if(v.length===0&&f.length===0)return Promise.resolve(void 0);let p;const I=new Promise((i,h)=>{p=i}),l=i=>p({activationEvent:i}),M=Promise.all(v.map(i=>n(g,i,l))).then(()=>{}),o=m(g,d.identifier,f,l);return Promise.all([M,o]).then(()=>{p(void 0)}),I}e.checkActivateWorkspaceContainsExtension=_;async function n(g,d,D){for(const v of g.folders)if(await g.exists(a.joinPath(t.URI.revive(v),d))){D(`workspaceContains:${d}`);return}}async function m(g,d,D,v){if(D.length===0)return Promise.resolve(void 0);const f=new w.CancellationTokenSource,p=g.checkExists(g.folders,D,f.token),I=setTimeout(async()=>{f.cancel(),g.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${D.join(",")}`)},F);let l=!1;try{l=await p}catch(M){T.isPromiseCanceledError(M)||T.onUnexpectedError(M)}f.dispose(),clearTimeout(I),l&&v(`workspaceContains:${D.join(",")}`)}function r(g,d,D,v){const f=g.get(k.IInstantiationService),p=g.get(C.ISearchService),l=f.createInstance(P.QueryBuilder).file(d.map(M=>(0,R.toWorkspaceFolder)(t.URI.revive(M))),{_reason:"checkExists",includePattern:D,exists:!0});return p.fileSearch(l,v).then(M=>!!M.limitHit,M=>T.isPromiseCanceledError(M)?!1:Promise.reject(M))}e.checkGlobFileExists=r});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(ne,a):w?w.value=a:e.set(ne,a),a},Re=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Ee[33],ye([0,1,120,17,73,24,14,6,21,2,12,5,32,174,71,31,27,172,15,25,22,147,7,84,3,28,72,13,60,64,39,4,214,68,149,10]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m,r,g,d,D,v,f,p,I,l,M,o,i,h,u,s,b,y,c,S,A,U,H){"use strict";var E,L,z;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let N=class ji extends P.Disposable{constructor(K,ie,pe,we,ae,le,Se,Ce,Fe,$e){super();this._onDidChangeRemoteConnectionData=this._register(new c.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ie,this._extHostContext=pe,this._initData=Se,this._extHostWorkspace=we,this._extHostConfiguration=ae,this._logService=le,this._extHostTunnelService=Fe,this._extHostTerminalService=$e,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new k.Barrier,this._readyToStartExtensionHost=new k.Barrier,this._readyToRunExtensions=new k.Barrier,this._eagerExtensionsActivated=new k.Barrier,this._registry=new D.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new A.ExtHostSecretState(this._extHostContext),this._storagePath=Ce,this._instaService=K.createChild(new s.ServiceCollection([r.IExtHostStorage,this._storage],[A.IExtHostSecretState,this._secretState]));const Ve=new Set;this._initData.hostExtensions.forEach(je=>Ve.add(f.ExtensionIdentifier.toKey(je))),this._activator=this._register(new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(je,B,G)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(je,v.transformErrorForSerialization(B),G)},actualActivateExtension:async(je,B)=>{if(Ve.has(f.ExtensionIdentifier.toKey(je)))return await this._mainThreadExtensionsProxy.$activateExtension(je,B),new m.HostExtension;const G=this._registry.getExtensionDescription(je);return this._activateExtension(G,B)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),w.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(K){v.onUnexpectedError(K)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let K=[];try{K=this._registry.getAllExtensionDescriptions().map(ae=>ae.identifier).filter(ae=>this.isActivated(ae)).map(ae=>this._deactivate(ae))}catch{}await Promise.all(K)}isActivated(K){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(K):!1}_activateByEvent(K,ie){return this._activator.activateByEvent(K,ie)}_activateById(K,ie){return this._activator.activateById(K,ie)}activateByIdWithErrors(K,ie){return this._activateById(K,ie).then(()=>{const pe=this._activator.getActivatedExtension(K);if(pe.activationFailed)return Promise.reject(pe.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(K=>this._registry)}getExtensionExports(K){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(K).exports:null}async _realPathExtensionUri(K){if(K.scheme!==H.Schemas.file)return K;const ie=await this._hostUtils.realpath(K.fsPath);return R.URI.file(ie)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const K=C.TernarySearchTree.forUris(ie=>T.extUriBiasedIgnorePathCase.ignorePathCasing(ie));for(const ie of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ie)){const pe=await this._realPathExtensionUri(ie.extensionLocation);K.set(pe,ie)}return K})()),this._extensionPathIndex}_deactivate(K){let ie=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(K))return ie;const pe=this._activator.getActivatedExtension(K);if(!pe)return ie;try{typeof pe.module.deactivate=="function"&&(ie=Promise.resolve(pe.module.deactivate()).then(void 0,we=>(this._logService.error(we),Promise.resolve(void 0))))}catch(we){this._logService.error(`An error occurred when deactivating the extension '${K.value}':`),this._logService.error(we)}try{(0,P.dispose)(pe.subscriptions)}catch(we){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this._logService.error(we)}return ie}async _activateExtension(K,ie){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(K.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(K.identifier),this._doActivateExtension(K,ie).then(pe=>{const we=pe.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(K.identifier,we.codeLoadingTime,we.activateCallTime,we.activateResolvedTime,ie),this._logExtensionActivationTimes(K,ie,"success",we),pe},pe=>{throw this._logExtensionActivationTimes(K,ie,"failure"),pe})}_logExtensionActivationTimes(K,ie,pe,we){const ae=$(K,ie);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ae,...we||{},outcome:pe})}_doActivateExtension(K,ie){const pe=$(K,ie);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",pe);const we=this._getEntryPoint(K);if(!we)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${ie.startup}, activationEvent: '${ie.activationEvent}'${K.identifier.value!==ie.extensionId.value?`, root cause: ${ie.extensionId.value}`:""}`),this._logService.flush();const ae=new m.ExtensionActivationTimesBuilder(ie.startup);return Promise.all([this._loadCommonJSModule(K.identifier,(0,T.joinPath)(K.extensionLocation,we),ae),this._loadExtensionContext(K)]).then(le=>(w.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),ji._callActivate(this._logService,K.identifier,le[0],le[1],ae))).then(le=>(w.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),le))}_loadExtensionContext(K){const ie=new I.ExtensionGlobalMemento(K,this._storage),pe=new I.ExtensionMemento(K.identifier.value,!1,this._storage),we=new U.ExtensionSecrets(K,this._secretState),ae=K.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?l.ExtensionMode.Test:l.ExtensionMode.Development:l.ExtensionMode.Production,le=this._initData.remote.isRemote?l.ExtensionKind.Workspace:l.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([ie.whenReady,pe.whenReady,this._storagePath.whenReady]).then(()=>{const Se=this;let Ce;return Object.freeze({globalState:ie,workspaceState:pe,secrets:we,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(Fe){return t.join(K.extensionLocation.fsPath,Fe)},get storagePath(){return Se._storagePath.workspaceValue(K)?.fsPath},get globalStoragePath(){return Se._storagePath.globalValue(K).fsPath},get logPath(){return t.join(Se._initData.logsLocation.fsPath,K.identifier.value)},get logUri(){return R.URI.joinPath(Se._initData.logsLocation,K.identifier.value)},get storageUri(){return Se._storagePath.workspaceValue(K)},get globalStorageUri(){return Se._storagePath.globalValue(K)},get extensionMode(){return ae},get extension(){return Ce===void 0&&(Ce=new j(Se,K.identifier,K,le)),Ce},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(K,"extensionRuntime"),Se.extensionRuntime},get environmentVariableCollection(){return Se._extHostTerminalService.getEnvironmentVariableCollection(K)}})})}static _callActivate(K,ie,pe,we,ae){return pe=pe||{activate:void 0,deactivate:void 0},this._callActivateOptional(K,ie,pe,we,ae).then(le=>new m.ActivatedExtension(!1,null,ae.build(),pe,le,we.subscriptions))}static _callActivateOptional(K,ie,pe,we,ae){if(typeof pe.activate=="function")try{ae.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${ie.value}`);const le=typeof global=="object"?global:self,Se=pe.activate.apply(le,[we]);return ae.activateCallStop(),ae.activateResolveStart(),Promise.resolve(Se).then(Ce=>(ae.activateResolveStop(),Ce))}catch(le){return Promise.reject(le)}else return Promise.resolve(pe)}_activateOneStartupFinished(K,ie){this._activateById(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:ie}).then(void 0,pe=>{this._logService.error(pe)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(w.getMarks());for(const K of this._registry.getAllExtensionDescriptions())if(K.activationEvents)for(const ie of K.activationEvents)ie==="onStartupFinished"&&this._activateOneStartupFinished(K,ie)}_handleEagerExtensions(){const K=this._activateByEvent("*",!0).then(void 0,ae=>{this._logService.error(ae)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ae=>this._handleWorkspaceContainsEagerExtensions(ae.added)));const ie=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],pe=this._handleWorkspaceContainsEagerExtensions(ie),we=Promise.all([K,pe]).then(()=>{});return Promise.race([we,(0,k.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),we}_handleWorkspaceContainsEagerExtensions(K){return K.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ie=>this._handleWorkspaceContainsEagerExtension(K,ie))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(K,ie){if(this.isActivated(ie.identifier))return;const pe=!this._initData.remote.isRemote&&!!this._initData.remote.authority,we={logService:this._logService,folders:K.map(le=>le.uri),forceUsingSearch:pe,exists:le=>this._hostUtils.exists(le.fsPath),checkExists:(le,Se,Ce)=>this._mainThreadWorkspaceProxy.$checkExists(le,Se,Ce)},ae=await(0,S.checkActivateWorkspaceContainsExtension)(we,ie);if(!!ae)return this._activateById(ie.identifier,{startup:!0,extensionId:ie.identifier,activationEvent:ae.activationEvent}).then(void 0,le=>this._logService.error(le))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(K){throw console.error(K),K}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:ie}=this._initData.environment;if(!K||!ie)throw new Error(a.localize(0,null));const pe=await this._loadCommonJSModule(null,ie,new m.ExtensionActivationTimesBuilder(!1));if(!pe||typeof pe.run!="function")throw new Error(a.localize(1,null,ie.toString()));return new Promise((we,ae)=>{const le=(Fe,$e)=>{Fe?ae(Fe):we(typeof $e=="number"&&$e>0?1:0)},Se=(0,T.originalFSPath)(ie),Ce=pe.run(Se,le);Ce&&Ce.then&&Ce.then(()=>{we(0)}).catch(Fe=>{ae(Fe.toString())})})}async $extensionTestsExit(K){this._logService.info(`Extension host terminating: test runner requested exit with code ${K}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${K}`),this._logService.flush(),this._hostUtils.exit(K)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,ie){return this._resolvers[K]=ie,(0,P.toDisposable)(()=>{delete this._resolvers[K]})}async _activateAndGetResolver(K){const ie=K.indexOf("+");if(ie===-1)throw new Error("Not an authority that can be resolved!");const pe=K.substr(0,ie);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${pe}`,!1),{authorityPrefix:pe,resolver:this._resolvers[pe]}}async $resolveAuthority(K,ie){const{authorityPrefix:pe,resolver:we}=await this._activateAndGetResolver(K);if(!we)return{type:"error",error:{code:M.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${pe}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(we)),w.mark(`code/extHost/willResolveAuthority/${pe}`);const ae=await we.resolve(K,{resolveAttempt:ie});w.mark(`code/extHost/didResolveAuthorityOK/${pe}`);const le={authority:K,host:ae.host,port:ae.port,connectionToken:ae.connectionToken},Se={extensionHostEnv:ae.extensionHostEnv,isTrusted:ae.isTrusted,authenticationSession:ae.authenticationSessionForInitializingExtensions?{id:ae.authenticationSessionForInitializingExtensions.id,providerId:ae.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:le,options:Se,tunnelInformation:{environmentTunnels:ae.environmentTunnels}}}}catch(ae){if(w.mark(`code/extHost/didResolveAuthorityError/${pe}`),ae instanceof l.RemoteAuthorityResolverError)return{type:"error",error:{code:ae._code,message:ae._message,detail:ae._detail}};throw ae}}async $getCanonicalURI(K,ie){const{authorityPrefix:pe,resolver:we}=await this._activateAndGetResolver(K);if(!we)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${pe}`);const ae=R.URI.revive(ie);if(typeof we.getCanonicalURI=="undefined")return ae;const le=await(0,k.asPromise)(()=>we.getCanonicalURI(ae));return le||ae}$startExtensionHost(K){return this._registry.keepOnly(K),this._startExtensionHost()}$activateByEvent(K,ie){return ie===1?this._activateByEvent(K,!1):this._readyToRunExtensions.wait().then(pe=>this._activateByEvent(K,!1))}async $activate(K,ie){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(K)?(await this._activateById(K,ie),!0):!1}async $deltaExtensions(K,ie){K.forEach(we=>we.extensionLocation=R.URI.revive(we.extensionLocation));const pe=await this.getExtensionPathIndex();return await Promise.all(ie.map(async we=>{const ae=this._registry.getExtensionDescription(we);ae&&pe.delete(await this._realPathExtensionUri(ae.extensionLocation))})),await Promise.all(K.map(async we=>{const ae=await this._realPathExtensionUri(we.extensionLocation);pe.set(ae,we)})),this._registry.deltaExtensions(K,ie),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){let ie=p.VSBuffer.alloc(K),pe=Math.random()%256;for(let we=0;we<K;we++)ie.writeUInt8(pe,we);return ie}async $updateRemoteConnectionData(K){this._remoteConnectionData=K,this._onDidChangeRemoteConnectionData.fire()}};N=Be([He(0,o.IInstantiationService),He(1,e.IHostUtils),He(2,u.IExtHostRpcService),He(3,g.IExtHostWorkspace),He(4,n.IExtHostConfiguration),He(5,F.ILogService),He(6,i.IExtHostInitDataService),He(7,h.IExtensionStoragePaths),He(8,b.IExtHostTunnelService),He(9,y.IExtHostTerminalService)],N),e.AbstractExtHostExtensionService=N;function $(ue,K){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class j{constructor(K,ie,pe,we){E.set(this,void 0),L.set(this,void 0),z.set(this,void 0),Ze(this,E,K,"f"),Ze(this,L,ie,"f"),Ze(this,z,pe.identifier,"f"),this.id=pe.identifier.value,this.extensionUri=pe.extensionLocation,this.extensionPath=t.normalize((0,T.originalFSPath)(pe.extensionLocation)),this.packageJSON=pe,this.extensionKind=we}get isActive(){return Re(this,E,"f").isActivated(Re(this,z,"f"))}get exports(){if(this.packageJSON.api!=="none")return Re(this,E,"f").getExtensionExports(Re(this,z,"f"))}activate(){return Re(this,E,"f").activateByIdWithErrors(Re(this,z,"f"),{startup:!1,extensionId:Re(this,L,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=j,E=new WeakMap,L=new WeakMap,z=new WeakMap}),define(Ee[98],ye([0,1,17,2,4,14,5,7,156,31,33,48,163,32,157,13,3,11,89,70]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m,r,g,d,D,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,d.createDecorator)("IExtHostDebugService");let p=class{constructor(s,b,y,c,S,A){this._workspaceService=b,this._extensionService=y,this._editorsService=c,this._configurationService=S,this._editorTabs=A,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new w.Emitter,this._onDidTerminateDebugSession=new w.Emitter,this._onDidChangeActiveDebugSession=new w.Emitter,this._onDidReceiveDebugSessionCustomEvent=new w.Emitter,this._debugServiceProxy=s.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new w.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new l(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(U=>{U.onDidChange(H=>{this.registerAllDebugTypes(U)}),this.registerAllDebugTypes(U)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(s,b){const y=s;if(typeof y.sourceReference=="number"&&y.sourceReference>0){let c=`debug:${encodeURIComponent(y.path||"")}`,S="?";return b&&(c+=`${S}session=${encodeURIComponent(b.id)}`,S="&"),c+=`${S}ref=${y.sourceReference}`,t.URI.parse(c)}else{if(y.path)return t.URI.file(y.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const b=[];for(const y of s.getAllExtensionDescriptions())if(y.contributes){const c=y.contributes.debuggers;if(c&&c.length>0)for(const S of c)(0,r.isDebuggerMainContribution)(S)&&b.push(S.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const s=[];return this._breakpoints.forEach(b=>s.push(b)),s}addBreakpoints(s){this.startBreakpoints();const b=s.filter(S=>{const A=S.id;return this._breakpoints.has(A)?!1:(this._breakpoints.set(A,S),!0)});this.fireBreakpointChanges(b,[],[]);const y=[],c=new Map;for(const S of b)if(S instanceof P.SourceBreakpoint){let A=c.get(S.location.uri.toString());A||(A={type:"sourceMulti",uri:S.location.uri,lines:[]},c.set(S.location.uri.toString(),A),y.push(A)),A.lines.push({id:S.id,enabled:S.enabled,condition:S.condition,hitCondition:S.hitCondition,logMessage:S.logMessage,line:S.location.range.start.line,character:S.location.range.start.character})}else S instanceof P.FunctionBreakpoint&&y.push({type:"function",id:S.id,enabled:S.enabled,hitCondition:S.hitCondition,logMessage:S.logMessage,condition:S.condition,functionName:S.functionName});return this._debugServiceProxy.$registerBreakpoints(y)}removeBreakpoints(s){this.startBreakpoints();const b=s.filter(A=>this._breakpoints.delete(A.id));this.fireBreakpointChanges([],b,[]);const y=b.filter(A=>A instanceof P.SourceBreakpoint).map(A=>A.id),c=b.filter(A=>A instanceof P.FunctionBreakpoint).map(A=>A.id),S=b.filter(A=>A instanceof P.DataBreakpoint).map(A=>A.id);return this._debugServiceProxy.$unregisterBreakpoints(y,c,S)}startDebugging(s,b,y){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,b,{parentSessionID:y.parentSession?y.parentSession.id:void 0,lifecycleManagedByParent:y.lifecycleManagedByParent,repl:y.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:y.noDebug,compact:y.compact,debugUI:y.debugUI,suppressSaveBeforeStart:y.suppressSaveBeforeStart})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,b,y){if(!b)return new P.Disposable(()=>{});const c=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:c,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,y,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,c),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(S=>S.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(s,b,y){if(!y)return new P.Disposable(()=>{});if(!this.definesDebugType(s,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:c,factory:y}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,c),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(S=>S.factory!==y),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(s,b){if(!b)return new P.Disposable(()=>{});const y=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:y,factory:b}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(c=>c.factory!==b)})}async $runInTerminal(s,b){return Promise.resolve(void 0)}async $substituteVariables(s,b){if(!this._variableResolver){const[S,A]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(S||[],this._editorsService,A)}let y;const c=await this.getFolder(s);return c&&(y={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(y,b)}createDebugAdapter(s,b){if(s.type==="implementation")return new i(s.implementation)}createSignService(){}async $startDASession(s,b){const y=this,c=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(c.type),c).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const A=this.convertToDto(S),U=this.createDebugAdapter(A,c);if(!U)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const H=U;return this._debugAdapters.set(s,H),this.getDebugAdapterTrackers(c).then(E=>(E&&this._debugAdaptersTrackers.set(s,E),H.onMessage(async L=>{if(L.type==="request"&&L.command==="handshake"){const z=L,N={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(z.arguments.value);N.body={signature:$},H.sendResponse(N)}else throw new Error("no signer")}catch($){N.success=!1,N.message=$.message,H.sendResponse(N)}}else E&&E.onDidSendMessage&&E.onDidSendMessage(L),L=(0,r.convertToVSCPaths)(L,!0),y._debugServiceProxy.$acceptDAMessage(s,L)}),H.onError(L=>{E&&E.onError&&E.onError(L),this._debugServiceProxy.$acceptDAError(s,L.name,L.message,L.stack)}),H.onExit(L=>{E&&E.onExit&&E.onExit((0,D.withNullAsUndefined)(L),void 0),this._debugServiceProxy.$acceptDAExit(s,(0,D.withNullAsUndefined)(L),void 0)}),E&&E.onWillStartSession&&E.onWillStartSession(),H.startSession()))})}$sendDAMessage(s,b){b=(0,r.convertToDAPaths)(b,!1);const y=this._debugAdaptersTrackers.get(s);y&&y.onWillReceiveMessage&&y.onWillReceiveMessage(b);const c=this._debugAdapters.get(s);c&&c.sendMessage(b)}$stopDASession(s){const b=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),b&&b.onWillStopSession&&b.onWillStopSession();const y=this._debugAdapters.get(s);return this._debugAdapters.delete(s),y?y.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const b=[],y=[],c=[];if(s.added)for(const S of s.added){const A=S.id;if(A&&!this._breakpoints.has(A)){let U;if(S.type==="function")U=new P.FunctionBreakpoint(S.functionName,S.enabled,S.condition,S.hitCondition,S.logMessage);else if(S.type==="data")U=new P.DataBreakpoint(S.label,S.dataId,S.canPersist,S.enabled,S.hitCondition,S.condition,S.logMessage);else{const H=t.URI.revive(S.uri);U=new P.SourceBreakpoint(new P.Location(H,new P.Position(S.line,S.character)),S.enabled,S.condition,S.hitCondition,S.logMessage)}U._id=A,this._breakpoints.set(A,U),b.push(U)}}if(s.removed)for(const S of s.removed){const A=this._breakpoints.get(S);A&&(this._breakpoints.delete(S),y.push(A))}if(s.changed){for(const S of s.changed)if(S.id){const A=this._breakpoints.get(S.id);if(A){if(A instanceof P.FunctionBreakpoint&&S.type==="function"){const U=A;U.enabled=S.enabled,U.condition=S.condition,U.hitCondition=S.hitCondition,U.logMessage=S.logMessage,U.functionName=S.functionName}else if(A instanceof P.SourceBreakpoint&&S.type==="source"){const U=A;U.enabled=S.enabled,U.condition=S.condition,U.hitCondition=S.hitCondition,U.logMessage=S.logMessage,U.location=new P.Location(t.URI.revive(S.uri),new P.Position(S.line,S.character))}c.push(A)}}}this.fireBreakpointChanges(b,y,c)}$provideDebugConfigurations(s,b,y){return(0,T.asPromise)(async()=>{const c=this.getConfigProviderByHandle(s);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const S=await this.getFolder(b);return c.provideDebugConfigurations(S,y)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(s,b,y,c){return(0,T.asPromise)(async()=>{const S=this.getConfigProviderByHandle(s);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.getFolder(b);return S.resolveDebugConfiguration(A,y,c)})}$resolveDebugConfigurationWithSubstitutedVariables(s,b,y,c){return(0,T.asPromise)(async()=>{const S=this.getConfigProviderByHandle(s);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.getFolder(b);return S.resolveDebugConfigurationWithSubstitutedVariables(A,y,c)})}async $provideDebugAdapter(s,b){const y=this.getAdapterDescriptorFactoryByHandle(s);if(!y)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.getSession(b);return this.getAdapterDescriptor(y,c).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.convertToDto(S)})}async $acceptDebugSessionStarted(s){const b=await this.getSession(s);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(s){const b=await this.getSession(s);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,b){const y=await this.getSession(s);y&&y._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(s,b){const c={session:await this.getSession(s),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(c)}convertToDto(s){if(s instanceof P.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof P.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const b=this._adapterFactories.filter(y=>y.type===s);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(s){const b=this._adapterFactories.filter(y=>y.handle===s);if(b.length>0)return b[0].factory}getConfigProviderByHandle(s){const b=this._configProviders.filter(y=>y.handle===s);if(b.length>0)return b[0].provider}definesDebugType(s,b){if(s.contributes){const y=s.contributes.debuggers;if(y&&y.length>0){for(const c of y)if(c.label&&c.type&&c.type===b)return!0}}return!1}getDebugAdapterTrackers(s){const y=s.configuration.type,c=this._trackerFactories.filter(S=>S.type===y||S.type==="*").map(S=>(0,T.asPromise)(()=>S.factory.createDebugAdapterTracker(s)).then(A=>A,A=>null));return Promise.race([Promise.all(c).then(S=>{const A=S.filter(U=>!!U);if(A.length>0)return new o(A)}),new Promise((S,A)=>{const U=setTimeout(()=>{clearTimeout(U),A(new Error("timeout"))},1e3)})]).catch(S=>{})}async getAdapterDescriptor(s,b){const y=b.configuration.debugServer;if(typeof y=="number")return Promise.resolve(new P.DebugAdapterServer(y));if(s){const S=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>s.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,S))).then(A=>{if(A)return A})}const c=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,c))}daExecutableFromPackage(s,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(s,b,y){(s.length>0||b.length>0||y.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:b,changed:y}))}async getSession(s){if(s)if(typeof s=="string"){const b=this._debugSessions.get(s);if(b)return b}else{let b=this._debugSessions.get(s.id);if(!b){const y=await this.getFolder(s.folderUri),c=s.parent?this._debugSessions.get(s.parent):void 0;b=new I(this._debugServiceProxy,s.id,s.type,s.name,y,s.configuration,c),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(s){if(s){const b=t.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};p=Be([He(0,g.IExtHostRpcService),He(1,R.IExtHostWorkspace),He(2,F.IExtHostExtensionService),He(3,_.IExtHostDocumentsAndEditors),He(4,m.IExtHostConfiguration),He(5,f.IExtHostEditorTabs)],p),e.ExtHostDebugServiceBase=p;class I{constructor(s,b,y,c,S,A,U){this._debugServiceProxy=s,this._id=b,this._type=y,this._name=c,this._workspaceFolder=S,this._configuration=A,this._parentSession=U}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,b)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=I;class l{constructor(s){this.value=Object.freeze({append(b){s.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=l;class M extends n.AbstractVariableResolverService{constructor(s,b,y,c,S){function A(){if(b){const U=b.activeEditor();if(U)return U.document.uri;const H=c.tabs.filter(E=>E.isActive);if(H.length>0){const E=H[0].resource;return E&&(E.primary||E.secondary)?E.primary??E.secondary:H[0].resource}}}super({getFolderUri:U=>{const H=s.filter(E=>E.name===U);if(H&&H.length>0)return H[0].uri},getWorkspaceFolderCount:()=>s.length,getConfigurationValue:(U,H)=>y.getConfiguration(void 0,U).get(H),getAppRoot:()=>v.cwd(),getExecPath:()=>v.env.VSCODE_EXEC_PATH,getFilePath:()=>{const U=A();if(U)return a.normalize(U.fsPath)},getWorkspaceFolderPathForFile:()=>{if(S){const U=A();if(U){const H=S.getWorkspaceFolder(U);if(H)return a.normalize(H.uri.fsPath)}}},getSelectedText:()=>{if(b){const U=b.activeEditor();if(U&&!U.selection.isEmpty)return U.document.getText(U.selection)}},getLineNumber:()=>{if(b){const U=b.activeEditor();if(U)return String(U.selection.end.line+1)}}},void 0,Promise.resolve(v.env))}}e.ExtHostVariableResolverService=M;class o{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(b=>b.onError?b.onError(s):void 0)}onExit(s,b){this.trackers.forEach(y=>y.onExit?y.onExit(s,b):void 0)}}class i extends C.AbstractDebugAdapter{constructor(s){super();this.implementation=s,s.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let h=class extends p{constructor(s,b,y,c,S,A){super(s,b,y,c,S,A)}createVariableResolver(s,b,y){return new M(s,b,y,this._editorTabs)}};h=Be([He(0,g.IExtHostRpcService),He(1,R.IExtHostWorkspace),He(2,F.IExtHostExtensionService),He(3,_.IExtHostDocumentsAndEditors),He(4,m.IExtHostConfiguration),He(5,f.IExtHostEditorTabs)],h),e.WorkerExtHostDebugService=h}),define(Ee[215],ye([0,1,73,2,5,32,27,25,13,28,3,33,89,12]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(f,p,I,l,M,o,i){this._apiFactory=f,this._extensionRegistry=p,this._instaService=I,this._extHostConfiguration=l,this._extHostExtensionService=M,this._initData=o,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),a.mark("code/extHost/willWaitForConfig");const f=await this._extHostConfiguration.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const p=await this._extHostExtensionService.getExtensionPathIndex();this.register(new g(this._apiFactory,p,this._extensionRegistry,f,this._logService)),this.register(this._instaService.createInstance(d,p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(D,p,this._initData.environment.appUriScheme))}register(f){if(Array.isArray(f.nodeModuleName))for(let p of f.nodeModuleName)this._factories.set(p,f);else this._factories.set(f.nodeModuleName,f);typeof f.alternativeModuleName=="function"&&this._alternatives.push(p=>f.alternativeModuleName(p))}};r=Be([He(2,F.IInstantiationService),He(3,T.IExtHostConfiguration),He(4,_.IExtHostExtensionService),He(5,R.IExtHostInitDataService),He(6,m.ILogService)],r),e.RequireInterceptor=r;class g{constructor(f,p,I,l,M){this._apiFactory=f,this._extensionPaths=p,this._extensionRegistry=I,this._configProvider=l,this._logService=M,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(f,p){const I=this._extensionPaths.findSubstr(p);if(I){let l=this._extApiImpl.get(P.ExtensionIdentifier.toKey(I.identifier));return l||(l=this._apiFactory(I,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(I.identifier),l)),l}if(!this._defaultApiImpl){let l="";this._extensionPaths.forEach((M,o)=>l+=`	${o} -> ${M.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${p}. These are the extension path mappings: 
${l}`),this._defaultApiImpl=this._apiFactory(k.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let d=class{constructor(f,p,I){this._extensionPaths=f,this.nodeModuleName="keytar",this._mainThreadTelemetry=p.getProxy(w.MainContext.MainThreadTelemetry);const{environment:l}=I,M=p.getProxy(w.MainContext.MainThreadKeytar);if(l.appRoot){let o=l.appRoot.fsPath;n.platform==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${o}/node_modules.asar/keytar`),this.alternativeNames.add(`${o}/node_modules/keytar`)}this._impl={getPassword:(o,i)=>M.$getPassword(o,i),setPassword:(o,i,h)=>M.$setPassword(o,i,h),deletePassword:(o,i)=>M.$deletePassword(o,i),findPassword:o=>M.$findPassword(o),findCredentials(o){return M.$findCredentials(o)}}}load(f,p){const I=this._extensionPaths.findSubstr(p);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:I?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(f){const p=f.length;if(p<=7||!this.alternativeNames)return;const I=p-7;if((f.charAt(I)==="/"||f.charAt(I)==="\\")&&f.endsWith("keytar")&&(f=f.replace(/\\/g,"/"),this.alternativeNames.has(f)))return"keytar"}};d=Be([He(1,C.IExtHostRpcService),He(2,R.IExtHostInitDataService)],d);let D=class{constructor(f,p,I){this._extensionPaths=f,this._appUriScheme=p,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=I.getProxy(w.MainContext.MainThreadTelemetry);const l=I.getProxy(w.MainContext.MainThreadWindow);this._impl=(M,o)=>{const i=t.URI.parse(M);return o?this.callOriginal(M,o):i.scheme==="http"||i.scheme==="https"?l.$openUri(i,M,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?l.$openUri(i,M,{}):this.callOriginal(M,o)}}load(f,p,I){const l=this._extensionPaths.findSubstr(p);return l&&(this._extensionId=l.identifier.value,this.sendShimmingTelemetry()),this._original=I(f),this._impl}callOriginal(f,p){return this.sendNoForwardTelemetry(),this._original(f,p)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};D=Be([He(2,C.IExtHostRpcService)],D)}),define(Ee[216],ye([0,1,14,15,73,6,2,5,209,12,56,60,28,137,13,65,33,39]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m,r,g,d,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class v{constructor(p,I,l,M){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=l,this._rpcProtocol=new C.RPCProtocol(p,null,M),I=v._transform(I,this._rpcProtocol);const o=new _.ServiceCollection(...(0,F.getSingletonServiceDescriptors)());o.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...I}),o.set(r.IExtHostRpcService,new r.ExtHostRpcService(this._rpcProtocol)),o.set(g.IURITransformerService,new g.URITransformerService(M)),o.set(d.IHostUtils,l);const i=new m.InstantiationService(o,!0);this._disposables.add(i.invokeFunction(b=>b.get(D.IExtHostTerminalService))),this._disposables.add(i.invokeFunction(b=>b.get(d.IExtHostExtensionService))),this._logService=i.invokeFunction(b=>b.get(R.ILogService)),w.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",I),this._extensionService=i.invokeFunction(b=>b.get(d.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const h=new WeakMap;this._extensionService.getExtensionPathIndex().then(b=>{Error.prepareStackTrace=(y,c)=>{let S="",A,U;for(const H of c)S+=`
	at ${H.toString()}`,U=H.getFileName(),!A&&U&&(A=b.findSubstr(k.URI.file(U)));return h.set(y,A),`${y.name||"Error"}: ${y.message||""}${S}`}});const u=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),s=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(b=>{const y=t.transformErrorForSerialization(b),c=h.get(b);c?u.$onExtensionRuntimeError(c.identifier,y):s.$onUnexpectedError(y)})}terminate(p){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${p}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(l=>{this._logService.error(l)}),this._rpcProtocol.dispose();const I=this._extensionService.deactivateAll();Promise.race([(0,a.timeout)(5e3),I]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(p,I){p.extensions.forEach(M=>M.extensionLocation=k.URI.revive(I.transformIncomingURIs(M.extensionLocation))),p.environment.appRoot=k.URI.revive(I.transformIncomingURIs(p.environment.appRoot));const l=p.environment.extensionDevelopmentLocationURI;return l&&(p.environment.extensionDevelopmentLocationURI=l.map(M=>k.URI.revive(I.transformIncomingURIs(M)))),p.environment.extensionTestsLocationURI=k.URI.revive(I.transformIncomingURIs(p.environment.extensionTestsLocationURI)),p.environment.globalStorageHome=k.URI.revive(I.transformIncomingURIs(p.environment.globalStorageHome)),p.environment.workspaceStorageHome=k.URI.revive(I.transformIncomingURIs(p.environment.workspaceStorageHome)),p.logsLocation=k.URI.revive(I.transformIncomingURIs(p.logsLocation)),p.logFile=k.URI.revive(I.transformIncomingURIs(p.logFile)),p.workspace=I.transformIncomingURIs(p.workspace),p}}e.ExtensionHostMain=v}),define(Ee[217],ye([0,1,17,20,43,29,24,190,40]),function(ne,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class R{constructor(n,m,r){this.config=n,this.provider=m,this.sessionToken=r,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&T.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&T.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const m=this.config.folderQueries||[];return new Promise((r,g)=>{const d=D=>{this.resultCount++,n(D)};if(this.isCanceled)return r({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(D=>{const v=D.toString(),f=a.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,f)||this.matchFile(d,{base:D,basename:f})}),Promise.all(m.map(D=>this.searchInFolder(D,d))).then(D=>{r({limitHit:this.isLimitHit,stats:D[0]||void 0})},D=>{g(new Error((0,w.toErrorMessage)(D)))})})}async searchInFolder(n,m){const r=new t.CancellationTokenSource,g=this.getSearchOptionsForFolder(n),d=this.initDirectoryTree(),D=new C.QueryGlobTester(this.config,n),v=!D.hasSiblingExcludeClauses();let f;try{this.activeCancellationTokens.add(r),f=P.StopWatch.create();const p=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},g,r.token),I=f.elapsed(),l=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(p&&p.forEach(M=>{const o=a.posix.relative(n.folder.path,M.path);if(v){const i=a.basename(M.path);this.matchFile(m,{base:n.folder,relativePath:o,basename:i});return}this.addDirectoryEntries(d,n.folder,o,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,D,m),{providerTime:I,postProcessTime:l.elapsed()})}finally{r.dispose(),this.activeCancellationTokens.delete(r)}}getSearchOptionsForFolder(n){const m=(0,C.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),r=(0,C.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:r,includes:m,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},m,r,g){if(r===this.filePattern){const D=a.basename(this.filePattern);this.matchFile(g,{base:m,relativePath:this.filePattern,basename:D})}function d(D){const v=a.basename(D),f=a.dirname(D);let p=n[f];p||(p=n[f]=[],d(f)),p.push({base:m,relativePath:D,basename:v})}d(r)}matchDirectoryTree({rootEntries:n,pathToEntries:m},r,g){const d=this,D=this.filePattern;function v(f){const p=T.hasSiblingFn(()=>f.map(I=>I.basename));for(let I=0,l=f.length;I<l;I++){const M=f[I],{relativePath:o,basename:i}=M;if(r.matchesExcludesSync(o,i,D!==i?p:void 0))continue;const h=m[o];if(h)v(h);else{if(o===D)continue;d.matchFile(g,M)}if(d.isLimitHit)break}}v(n)}matchFile(n,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(m))}}class F{constructor(){this.sessions=new Map}fileSearch(n,m,r,g){const d=this.getSessionTokenSource(n.cacheKey),D=new R(n,m,d&&d.token);let v=0;const f=p=>{v+=p.length,r(p.map(I=>this.rawMatchToSearchItem(I)))};return this.doSearch(D,F.BATCH_SIZE,f,g).then(p=>({limitHit:p.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:p.stats}}))}clearCache(n){const m=this.getSessionTokenSource(n);m&&m.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new t.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:k.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,m,r,g){g.onCancellationRequested(()=>{n.cancel()});const d=v=>{v&&(D.push(v),m>0&&D.length>=m&&(r(D),D=[]))};let D=[];return n.search(d).then(v=>(D.length&&r(D),v),v=>(D.length&&r(D),Promise.reject(v)))}}e.FileSearchManager=F,F.BATCH_SIZE=512}),define(Ee[218],ye([0,1,16,20,43,29,10,17,24,11,2,40]),function(ne,e,a,t,w,T,k,P,C,R,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(f,p,I,l){this.query=f,this.provider=p,this.fileUtils=I,this.processType=l,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(f,p){const I=this.query.folderQueries||[],l=new t.CancellationTokenSource;return p.onCancellationRequested(()=>l.cancel()),new Promise((M,o)=>{this.collector=new r(f);let i=!1;const h=(u,s)=>{if(!i&&!this.isLimitHit){const b=this.resultSize(u);d(u)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,i=!0,l.cancel(),u=this.trimResultToSize(u,this.query.maxResults-this.resultCount));const y=this.resultSize(u);this.resultCount+=y,(y>0||!d(u))&&this.collector.add(u,s)}};Promise.all(I.map((u,s)=>this.searchInFolder(u,b=>h(b,s),l.token))).then(u=>{l.dispose(),this.collector.flush();const s=u.some(b=>!!b&&!!b.limitHit);M({limitHit:this.isLimitHit||s,messages:(0,a.flatten)(u.map(b=>b?.message?(0,R.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:this.processType}})},u=>{l.dispose();const s=(0,w.toErrorMessage)(u);o(new Error(s))})})}resultSize(f){return d(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}trimResultToSize(f,p){const I=Array.isArray(f.ranges)?f.ranges:[f.ranges],l=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:I.slice(0,p),preview:{matches:l.slice(0,p),text:f.preview.text},uri:f.uri}}async searchInFolder(f,p,I){const l=new _.QueryGlobTester(this.query,f),M=[],o={report:u=>{if(!this.validateProviderResult(u))return;const s=f.folder.scheme===k.Schemas.file?T.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(u.uri))):void 0,b=C.relativePath(f.folder,u.uri);if(b){const y=l.includedInQuery(b,P.basename(b),s);(0,R.isPromise)(y)?M.push(y.then(c=>{c&&p(u)})):y&&p(u)}}},i=this.getSearchOptionsForFolder(f),h=await this.provider.provideTextSearchResults(m(this.query.contentPattern),i,o,I);return M.length&&await Promise.all(M),h}validateProviderResult(f){if(d(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(f){const p=(0,_.resolvePatternsForProvider)(this.query.includePattern,f.includePattern),I=(0,_.resolvePatternsForProvider)(this.query.excludePattern,f.excludePattern),l={folder:F.URI.from(f.folder),excludes:I,includes:p,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.fileUtils.toCanonicalName(f.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return l.usePCRE2=this.query.usePCRE2,l}}e.TextSearchManager=n;function m(v){return{isCaseSensitive:v.isCaseSensitive||!1,isRegExp:v.isRegExp||!1,isWordMatch:v.isWordMatch||!1,isMultiline:v.isMultiline||!1,pattern:v.pattern}}class r{constructor(f){this._onResult=f,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new D(512,p=>this.sendItems(p))}add(f,p){this._currentFileMatch&&(this._currentFolderIdx!==p||!C.isEqual(this._currentUri,f.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=p,this._currentFileMatch={resource:f.uri,results:[]}),this._currentFileMatch.results.push(g(f))}pushToCollector(){const f=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,f)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(f){this._onResult(f)}}e.TextSearchResultsCollector=r;function g(v){return d(v)?{preview:{matches:(0,a.mapArrayOrNot)(v.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:v.preview.text},ranges:(0,a.mapArrayOrNot)(v.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:v.text,lineNumber:v.lineNumber}}function d(v){return!!v.preview}e.extensionResultIsMatch=d;class D{constructor(f,p){this.maxBatchSize=f,this.cb=p,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(f,p){!f||this.addItemToBatch(f,p)}addItems(f,p){!f||this.addItemsToBatch(f,p)}addItemToBatch(f,p){this.batch.push(f),this.batchSize+=p,this.onUpdate()}addItemsToBatch(f,p){this.batch=this.batch.concat(f),this.batchSize+=p,this.onUpdate()}onUpdate(){this.totalNumberCompleted<D.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},D.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=D,D.TIMEOUT=4e3,D.START_BATCH_AFTER_COUNT=50}),define(Ee[99],ye([0,1,6,5,3,217,13,65,12,2,218]),function(ne,e,a,t,w,T,k,P,C,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,w.createDecorator)("IExtHostSearch");let _=class{constructor(g,d,D){this.extHostRpc=g,this._uriTransformer=d,this._logService=D,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}registerTextSearchProvider(g,d){if(this._textSearchUsedSchemes.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this._textSearchUsedSchemes.add(g);const D=this._handlePool++;return this._textSearchProvider.set(D,d),this._proxy.$registerTextSearchProvider(D,this._transformScheme(g)),(0,a.toDisposable)(()=>{this._textSearchUsedSchemes.delete(g),this._textSearchProvider.delete(D),this._proxy.$unregisterProvider(D)})}registerFileSearchProvider(g,d){if(this._fileSearchUsedSchemes.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this._fileSearchUsedSchemes.add(g);const D=this._handlePool++;return this._fileSearchProvider.set(D,d),this._proxy.$registerFileSearchProvider(D,this._transformScheme(g)),(0,a.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(g),this._fileSearchProvider.delete(D),this._proxy.$unregisterProvider(D)})}$provideFileSearchResults(g,d,D,v){const f=n(D),p=this._fileSearchProvider.get(g);if(p)return this._fileSearchManager.fileSearch(f,p,I=>{this._proxy.$handleFileMatch(g,d,I.map(l=>l.resource))},v);throw new Error("unknown provider: "+g)}$clearCache(g){return this._fileSearchManager.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,d,D,v){const f=this._textSearchProvider.get(g);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const p=n(D);return this.createTextSearchManager(p,f).search(l=>this._proxy.$handleTextMatch(g,d,l),v)}$enableExtensionHostSearch(){}createTextSearchManager(g,d){return new F.TextSearchManager(g,d,{readdir:D=>Promise.resolve([]),toCanonicalName:D=>D},"textSearchProvider")}};_=Be([He(0,k.IExtHostRpcService),He(1,P.IURITransformerService),He(2,C.ILogService)],_),e.ExtHostSearch=_;function n(r){return{...r,folderQueries:r.folderQueries&&r.folderQueries.map(m),extraFileResources:r.extraFileResources&&r.extraFileResources.map(g=>R.URI.revive(g))}}e.reviveQuery=n;function m(r){return{...r,folder:R.URI.revive(r.folder)}}}),define(Ee[219],ye([0,1,20,15,4,34,2,113,232,107,55,45,5,180,179,38,181,32,182,183,184,165,185,48,33,186,166,189,191,193,94,168,198,199,200,71,39,202,169,8,7,205,50,95,31,74,154,188,61,93,97,98,99,12,65,13,28,194,151,64,69,177,203,150,72,49,208,206,207,178,30,201,204,68,70,85,196,96,197,10,139,195,148,187,6,27]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m,r,g,d,D,v,f,p,I,l,M,o,i,h,u,s,b,y,c,S,A,U,H,E,L,z,N,$,j,ue,K,ie,pe,we,ae,le,Se,Ce,Fe,$e,Ve,je,B,G,X,se,q,ee,fe,Ae,xe,ze,Xe,et,st,Je,nt,lt,pt,Ft,Oe,Mt,V,Q,de,Ne,qe,ot,Ye,yt,Te,De,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function re(oe){const he=oe.get(G.IExtHostInitDataService),me=oe.get(lt.IExtHostFileSystemInfo),Pe=oe.get(Xe.IExtHostConsumerFileSystem),We=oe.get(o.IExtHostExtensionService),Le=oe.get(ie.IExtHostWorkspace),Ke=oe.get(V.IExtHostTelemetry),it=oe.get(D.IExtHostConfiguration),rt=oe.get(je.IURITransformerService),te=oe.get(B.IExtHostRpcService),ge=oe.get(H.IExtHostStorage),Z=oe.get(ze.IExtensionStoragePaths),W=oe.get(Ve.ILoggerService),be=oe.get(Ve.ILogService),Ie=oe.get(q.IExtHostTunnelService),Qe=oe.get(ee.IExtHostApiDeprecationService),Ue=oe.get(K.IExtHostWindow),ut=oe.get(Oe.IExtHostSecretState),vt=oe.get(Mt.IExtHostEditorTabs);te.set(n.ExtHostContext.ExtHostFileSystemInfo,me),te.set(n.ExtHostContext.ExtHostLogLevelServiceShape,W),te.set(n.ExtHostContext.ExtHostWorkspace,Le),te.set(n.ExtHostContext.ExtHostConfiguration,it),te.set(n.ExtHostContext.ExtHostExtensionService,We),te.set(n.ExtHostContext.ExtHostStorage,ge),te.set(n.ExtHostContext.ExtHostTunnelService,Ie),te.set(n.ExtHostContext.ExtHostWindow,Ue),te.set(n.ExtHostContext.ExtHostSecretState,ut),te.set(n.ExtHostContext.ExtHostTelemetry,Ke),te.set(n.ExtHostContext.ExtHostEditorTabs,vt);const St=te.set(n.ExtHostContext.ExtHostDecorations,oe.get(Se.IExtHostDecorations)),bt=te.set(n.ExtHostContext.ExtHostDocumentsAndEditors,oe.get(M.IExtHostDocumentsAndEditors)),ht=te.set(n.ExtHostContext.ExtHostCommands,oe.get(g.IExtHostCommands)),gt=te.set(n.ExtHostContext.ExtHostTerminalService,oe.get(E.IExtHostTerminalService)),_t=te.set(n.ExtHostContext.ExtHostDebugService,oe.get(Fe.IExtHostDebugService)),Lt=te.set(n.ExtHostContext.ExtHostSearch,oe.get($e.IExtHostSearch)),It=te.set(n.ExtHostContext.ExtHostTask,oe.get(Ce.IExtHostTask)),Pt=te.set(n.ExtHostContext.ExtHostOutputService,oe.get(y.IExtHostOutputService)),At=te.set(n.ExtHostContext.ExtHostUrls,new j.ExtHostUrls(te)),Et=te.set(n.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments(te,bt)),Ot=te.set(n.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(te,bt,be)),Nt=te.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new I.ExtHostDocumentSaveParticipant(be,Et,te.getProxy(n.MainContext.MainThreadBulkEdits))),wt=te.set(n.ExtHostContext.ExtHostNotebook,new X.ExtHostNotebookController(te,ht,bt,Et,Z)),$t=te.set(n.ExtHostContext.ExtHostNotebookDocuments,new yt.ExtHostNotebookDocuments(be,wt)),jt=te.set(n.ExtHostContext.ExtHostNotebookEditors,new Ye.ExtHostNotebookEditors(be,te,wt)),oi=te.set(n.ExtHostContext.ExtHostNotebookKernels,new Q.ExtHostNotebookKernels(te,he,wt,ht,be)),si=te.set(n.ExtHostContext.ExtHostNotebookRenderers,new Ne.ExtHostNotebookRenderers(te,wt)),Tt=te.set(n.ExtHostContext.ExtHostEditors,new L.ExtHostEditors(te,bt)),Yt=te.set(n.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(te.getProxy(n.MainContext.MainThreadTreeViews),ht,be)),ai=te.set(n.ExtHostContext.ExtHostEditorInsets,new we.ExtHostEditorInsets(te.getProxy(n.MainContext.MainThreadEditorInsets),Tt,he)),Xt=te.set(n.ExtHostContext.ExtHostDiagnostics,new v.ExtHostDiagnostics(te,be,me)),Vt=te.set(n.ExtHostContext.ExtHostLanguages,new s.ExtHostLanguages(te,Et,ht.converter,rt)),mt=te.set(n.ExtHostContext.ExtHostLanguageFeatures,new u.ExtHostLanguageFeatures(te,rt,Et,ht,Xt,be,Qe)),li=te.set(n.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(te,mt)),xt=te.set(n.ExtHostContext.ExtHostFileSystemEventService,new h.ExtHostFileSystemEventService(te,be,bt)),qt=te.set(n.ExtHostContext.ExtHostQuickOpen,(0,S.createExtHostQuickOpen)(te,Le,ht)),Jt=te.set(n.ExtHostContext.ExtHostSCM,new A.ExtHostSCM(te,ht,be)),ci=te.set(n.ExtHostContext.ExtHostComments,(0,d.createExtHostComments)(te,ht,Et)),fi=te.set(n.ExtHostContext.ExtHostProgress,new c.ExtHostProgress(te.getProxy(n.MainContext.MainThreadProgress))),Ei=te.set(n.ExtHostContext.ExtHosLabelService,new ae.ExtHostLabelService(te)),mi=te.set(n.ExtHostContext.ExtHostTheming,new se.ExtHostTheming(te)),Zt=te.set(n.ExtHostContext.ExtHostAuthentication,new fe.ExtHostAuthentication(te)),yi=te.set(n.ExtHostContext.ExtHostTimeline,new Ae.ExtHostTimeline(te,ht)),Kt=te.set(n.ExtHostContext.ExtHostWebviews,new ue.ExtHostWebviews(te,{remote:he.remote},Le,be,Qe)),Gt=te.set(n.ExtHostContext.ExtHostWebviewPanels,new Je.ExtHostWebviewPanels(te,Kt,Le)),_i=te.set(n.ExtHostContext.ExtHostCustomEditors,new st.ExtHostCustomEditors(te,Et,Z,Kt,Gt)),Ci=te.set(n.ExtHostContext.ExtHostWebviewViews,new et.ExtHostWebviewViews(te,Kt)),Qt=te.set(n.ExtHostContext.ExtHostTesting,new pt.ExtHostTesting(te,ht)),Si=te.set(n.ExtHostContext.ExtHostUriOpeners,new Ft.ExtHostUriOpeners(te));te.set(n.ExtHostContext.ExtHostInteractive,new Te.ExtHostInteractive(te,wt,bt,ht));const ei=(0,pe.values)(n.ExtHostContext);te.assertRegistered(ei);const Di=new nt.ExtHostBulkEdits(te,bt),ki=new r.ExtHostClipboard(te),ui=new b.ExtHostMessageService(te,be),ti=new f.ExtHostDialogs(te),gi=new U.ExtHostStatusBar(te,ht.converter);return m.ExtHostApiCommands.register(ht),function(Me,Ut,pi){const ft=function(){let Y=!Me.isUnderDevelopment;function ce(){Y||(be.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function ke(ct){if(Array.isArray(ct))ct.forEach(ke);else if(typeof ct=="string")ce();else{const Ct=ct;typeof Ct.scheme=="undefined"&&ce(),typeof Ct.exclusive=="boolean"&&(0,ve.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return ct}}(),ii={getSession(Y,ce,ke){return Zt.getSession(Me,Y,ce,ke)},async hasSession(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"authSession"),!!await Zt.getSession(Me,Y,ce,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(Y,ce,ke,ct){return Zt.registerAuthenticationProvider(Y,ce,ke,ct)}},Ii={registerCommand(Y,ce,ke){return ht.registerCommand(!0,Y,ce,ke,void 0,Me)},registerTextEditorCommand(Y,ce,ke){return ht.registerCommand(!0,Y,(...ct)=>{const Ct=Tt.getActiveTextEditor();if(!Ct){be.warn("Cannot execute "+Y+" because there is no active text editor.");return}return Ct.edit(Dt=>{ce.apply(ke,[Ct,Dt,...ct])}).then(Dt=>{Dt||be.warn("Edits from command "+Y+" were not applied.")},Dt=>{be.warn("An error occurred while running command "+Y,Dt)})},void 0,void 0,Me)},registerDiffInformationCommand:(Y,ce,ke)=>((0,ve.checkProposedApiEnabled)(Me,"diffCommand"),ht.registerCommand(!0,Y,async(...ct)=>{const Ct=bt.activeEditor(!0);if(!Ct){be.warn("Cannot execute "+Y+" because there is no active text editor.");return}const Dt=await Tt.getDiffInformation(Ct.id);ce.apply(ke,[Dt,...ct])},void 0,void 0,Me)),executeCommand(Y,...ce){return ht.executeCommand(Y,...ce)},getCommands(Y=!1){return ht.getCommands(Y)}},vi={get machineId(){return he.telemetryInfo.machineId},get sessionId(){return he.telemetryInfo.sessionId},get language(){return he.environment.appLanguage},get appName(){return he.environment.appName},get appRoot(){return he.environment.appRoot?.fsPath??""},get appHost(){return he.environment.appHost},get uriScheme(){return he.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return gt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ke.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ke.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(he.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,ce){return Ue.openUri(Y,{allowTunneling:!!he.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(Y){if(Y.scheme===he.environment.appUriScheme)return At.createAppUri(Y);try{return await Ue.asExternalUri(Y,{allowTunneling:!!he.remote.authority})}catch(ce){if((0,ot.matchesScheme)(Y,qe.Schemas.http)||(0,ot.matchesScheme)(Y,qe.Schemas.https))return Y;throw ce}},get remoteName(){return(0,le.getRemoteName)(he.remote.authority)},get remoteAuthority(){return(0,ve.checkProposedApiEnabled)(Me,"resolvers"),he.remote.authority},get uiKind(){return he.uiKind}};he.environment.extensionTestsLocationURI||Object.freeze(vi);const bi=he.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,Pi={createTestController(Y,ce){return Qt.createTestController(Y,ce)},createTestObserver(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Qt.createTestObserver()},runTests(Y){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Qt.runTests(Y)},get onDidChangeTestResults(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Qt.onResultsChanged},get testResults(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Qt.results}},Ti={getExtension(Y){const ce=Ut.getExtensionDescription(Y);if(ce)return new o.Extension(We,Me.identifier,ce,bi)},get all(){return Ut.getAllExtensionDescriptions().map(Y=>new o.Extension(We,Me.identifier,Y,bi))},get onDidChange(){return Ut.onDidChange}},Ai={createDiagnosticCollection(Y){return Xt.createDiagnosticCollection(Me.identifier,Y)},get onDidChangeDiagnostics(){return Xt.onDidChangeDiagnostics},getDiagnostics:Y=>Xt.getDiagnostics(Y),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(Y,ce){return Vt.changeLanguage(Y.uri,ce)},match(Y,ce){return(0,F.score)(N.LanguageSelector.from(Y),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(Y,ce,ke){return mt.registerCodeActionProvider(Me,ft(Y),ce,ke)},registerCodeLensProvider(Y,ce){return mt.registerCodeLensProvider(Me,ft(Y),ce)},registerDefinitionProvider(Y,ce){return mt.registerDefinitionProvider(Me,ft(Y),ce)},registerDeclarationProvider(Y,ce){return mt.registerDeclarationProvider(Me,ft(Y),ce)},registerImplementationProvider(Y,ce){return mt.registerImplementationProvider(Me,ft(Y),ce)},registerTypeDefinitionProvider(Y,ce){return mt.registerTypeDefinitionProvider(Me,ft(Y),ce)},registerHoverProvider(Y,ce){return mt.registerHoverProvider(Me,ft(Y),ce,Me.identifier)},registerEvaluatableExpressionProvider(Y,ce){return mt.registerEvaluatableExpressionProvider(Me,ft(Y),ce,Me.identifier)},registerInlineValuesProvider(Y,ce){return mt.registerInlineValuesProvider(Me,ft(Y),ce,Me.identifier)},registerDocumentHighlightProvider(Y,ce){return mt.registerDocumentHighlightProvider(Me,ft(Y),ce)},registerLinkedEditingRangeProvider(Y,ce){return mt.registerLinkedEditingRangeProvider(Me,ft(Y),ce)},registerReferenceProvider(Y,ce){return mt.registerReferenceProvider(Me,ft(Y),ce)},registerRenameProvider(Y,ce){return mt.registerRenameProvider(Me,ft(Y),ce)},registerDocumentSymbolProvider(Y,ce,ke){return mt.registerDocumentSymbolProvider(Me,ft(Y),ce,ke)},registerWorkspaceSymbolProvider(Y){return mt.registerWorkspaceSymbolProvider(Me,Y)},registerDocumentFormattingEditProvider(Y,ce){return mt.registerDocumentFormattingEditProvider(Me,ft(Y),ce)},registerDocumentRangeFormattingEditProvider(Y,ce){return mt.registerDocumentRangeFormattingEditProvider(Me,ft(Y),ce)},registerOnTypeFormattingEditProvider(Y,ce,ke,...ct){return mt.registerOnTypeFormattingEditProvider(Me,ft(Y),ce,[ke].concat(ct))},registerDocumentSemanticTokensProvider(Y,ce,ke){return mt.registerDocumentSemanticTokensProvider(Me,ft(Y),ce,ke)},registerDocumentRangeSemanticTokensProvider(Y,ce,ke){return mt.registerDocumentRangeSemanticTokensProvider(Me,ft(Y),ce,ke)},registerSignatureHelpProvider(Y,ce,ke,...ct){return typeof ke=="object"?mt.registerSignatureHelpProvider(Me,ft(Y),ce,ke):mt.registerSignatureHelpProvider(Me,ft(Y),ce,typeof ke=="undefined"?[]:[ke,...ct])},registerCompletionItemProvider(Y,ce,...ke){return mt.registerCompletionItemProvider(Me,ft(Y),ce,ke)},registerInlineCompletionItemProvider(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"inlineCompletions"),mt.registerInlineCompletionsProvider(Me,ft(Y),ce)},registerDocumentLinkProvider(Y,ce){return mt.registerDocumentLinkProvider(Me,ft(Y),ce)},registerColorProvider(Y,ce){return mt.registerColorProvider(Me,ft(Y),ce)},registerFoldingRangeProvider(Y,ce){return mt.registerFoldingRangeProvider(Me,ft(Y),ce)},registerSelectionRangeProvider(Y,ce){return mt.registerSelectionRangeProvider(Me,Y,ce)},registerCallHierarchyProvider(Y,ce){return mt.registerCallHierarchyProvider(Me,Y,ce)},registerTypeHierarchyProvider(Y,ce){return mt.registerTypeHierarchyProvider(Me,Y,ce)},setLanguageConfiguration:(Y,ce)=>mt.setLanguageConfiguration(Me,Y,ce),getTokenInformationAtPosition(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"tokenInformation"),Vt.tokenAtPosition(Y,ce)},registerInlayHintsProvider(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"inlayHints"),mt.registerInlayHintsProvider(Me,Y,ce)},createLanguageStatusItem(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"languageStatus"),Vt.createLanguageStatusItem(Me,Y,ce)}},Ri={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(Y,ce,ke){const ct=await(k.URI.isUri(Y)?Promise.resolve(ni.openTextDocument(Y)):Promise.resolve(Y));return Tt.showTextDocument(ct,ce,ke)},createTextEditorDecorationType(Y){return Tt.createTextEditorDecorationType(Me,Y)},onDidChangeActiveTextEditor(Y,ce,ke){return Tt.onDidChangeActiveTextEditor(Y,ce,ke)},onDidChangeVisibleTextEditors(Y,ce,ke){return Tt.onDidChangeVisibleTextEditors(Y,ce,ke)},onDidChangeTextEditorSelection(Y,ce,ke){return Tt.onDidChangeTextEditorSelection(Y,ce,ke)},onDidChangeTextEditorOptions(Y,ce,ke){return Tt.onDidChangeTextEditorOptions(Y,ce,ke)},onDidChangeTextEditorVisibleRanges(Y,ce,ke){return Tt.onDidChangeTextEditorVisibleRanges(Y,ce,ke)},onDidChangeTextEditorViewColumn(Y,ce,ke){return Tt.onDidChangeTextEditorViewColumn(Y,ce,ke)},onDidCloseTerminal(Y,ce,ke){return gt.onDidCloseTerminal(Y,ce,ke)},onDidOpenTerminal(Y,ce,ke){return gt.onDidOpenTerminal(Y,ce,ke)},onDidChangeActiveTerminal(Y,ce,ke){return gt.onDidChangeActiveTerminal(Y,ce,ke)},onDidChangeTerminalDimensions(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"terminalDimensions"),gt.onDidChangeTerminalDimensions(Y,ce,ke)},onDidChangeTerminalState(Y,ce,ke){return gt.onDidChangeTerminalState(Y,ce,ke)},onDidWriteTerminalData(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(Y,ce,ke)},get state(){return Ue.state},onDidChangeWindowState(Y,ce,ke){return Ue.onDidChangeWindowState(Y,ce,ke)},showInformationMessage(Y,...ce){return ui.showMessage(Me,T.default.Info,Y,ce[0],ce.slice(1))},showWarningMessage(Y,...ce){return ui.showMessage(Me,T.default.Warning,Y,ce[0],ce.slice(1))},showErrorMessage(Y,...ce){return ui.showMessage(Me,T.default.Error,Y,ce[0],ce.slice(1))},showQuickPick(Y,ce,ke){return Array.isArray(Y)&&Y.some(ct=>ct.kind!==void 0)&&(0,ve.checkProposedApiEnabled)(Me,"quickPickSeparators"),qt.showQuickPick(Y,ce,ke)},showWorkspaceFolderPick(Y){return qt.showWorkspaceFolderPick(Y)},showInputBox(Y,ce){return qt.showInput(Y,ce)},showOpenDialog(Y){return ti.showOpenDialog(Y)},showSaveDialog(Y){return ti.showSaveDialog(Y)},createStatusBarItem(Y,ce,ke){let ct,Ct,Dt;return typeof Y=="string"?(ct=Y,Ct=ce,Dt=ke):(Ct=Y,Dt=ce),gi.createStatusBarEntry(Me,ct,Ct,Dt)},setStatusBarMessage(Y,ce){return gi.setStatusBarMessage(Y,ce)},withScmProgress(Y){return Qe.report("window.withScmProgress",Me,"Use 'withProgress' instead."),fi.withProgress(Me,{location:$.ProgressLocation.SourceControl},(ce,ke)=>Y({report(ct){}}))},withProgress(Y,ce){return fi.withProgress(Me,Y,ce)},createOutputChannel(Y){return Pt.createOutputChannel(Y,Me)},createWebviewPanel(Y,ce,ke,ct){return Gt.createWebviewPanel(Me,Y,ce,ke,ct)},createWebviewTextEditorInset(Y,ce,ke,ct){return(0,ve.checkProposedApiEnabled)(Me,"editorInsets"),ai.createWebviewEditorInset(Y,ce,ke,ct,Me)},createTerminal(Y,ce,ke){return typeof Y=="object"?"pty"in Y?gt.createExtensionTerminal(Y):gt.createTerminalFromOptions(Y):gt.createTerminal(Y,ce,ke)},registerTerminalLinkProvider(Y){return gt.registerLinkProvider(Y)},registerTerminalProfileProvider(Y,ce){return gt.registerProfileProvider(Me,Y,ce)},registerTreeDataProvider(Y,ce){return Yt.registerTreeDataProvider(Y,ce,Me)},createTreeView(Y,ce){return Yt.createTreeView(Y,ce,Me)},registerWebviewPanelSerializer:(Y,ce)=>Gt.registerWebviewPanelSerializer(Me,Y,ce),registerCustomEditorProvider:(Y,ce,ke={})=>_i.registerCustomEditorProvider(Me,Y,ce,ke),registerFileDecorationProvider(Y){return St.registerFileDecorationProvider(Y,Me.identifier)},registerUriHandler(Y){return At.registerUriHandler(Me.identifier,Y)},createQuickPick(){return qt.createQuickPick(Me)},createInputBox(){return qt.createInputBox(Me.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(Y,ce,ke){return mi.onDidChangeActiveColorTheme(Y,ce,ke)},registerWebviewViewProvider(Y,ce,ke){return Ci.registerWebviewViewProvider(Me,Y,ce,ke?.webviewOptions)},get activeNotebookEditor(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.onDidChangeActiveNotebookEditor(Y,ce,ke)},get visibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),jt.onDidChangeNotebookEditorSelection(Y,ce,ke)},onDidChangeNotebookEditorVisibleRanges(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),jt.onDidChangeNotebookEditorVisibleRanges(Y,ce,ke)},showNotebookDocument(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.showNotebookDocument(Y,ce)},registerExternalUriOpener(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"externalUriOpener"),Si.registerExternalUriOpener(Me.identifier,Y,ce,ke)},get tabs(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),vt.tabs},get activeTab(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),vt.activeTab},get onDidChangeTabs(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),vt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),vt.onDidChangeActiveTab},getInlineCompletionItemController(Y){return(0,ve.checkProposedApiEnabled)(Me,"inlineCompletions"),u.InlineCompletionController.get(Y)}},ni={get rootPath(){return Qe.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Le.getPath()},set rootPath(Y){throw t.readonly()},getWorkspaceFolder(Y){return Le.getWorkspaceFolder(Y)},get workspaceFolders(){return Le.getWorkspaceFolders()},get name(){return Le.name},set name(Y){throw t.readonly()},get workspaceFile(){return Le.workspaceFile},set workspaceFile(Y){throw t.readonly()},updateWorkspaceFolders:(Y,ce,...ke)=>Le.updateWorkspaceFolders(Me,Y,ce||0,...ke),onDidChangeWorkspaceFolders:function(Y,ce,ke){return Le.onDidChangeWorkspace(Y,ce,ke)},asRelativePath:(Y,ce)=>Le.getRelativePath(Y,ce),findFiles:(Y,ce,ke,ct)=>Le.findFiles(N.GlobPattern.from(Y),N.GlobPattern.from(ce),ke,Me.identifier,ct),findTextInFiles:(Y,ce,ke,ct)=>{(0,ve.checkProposedApiEnabled)(Me,"findTextInFiles");let Ct,Dt;return typeof ce=="object"?(Ct=ce,Dt=ke):(Ct={},Dt=ce,ct=ke),Le.findTextInFiles(Y,Ct||{},Dt,Me.identifier,ct)},saveAll:Y=>Le.saveAll(Y),applyEdit(Y){return Di.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,ce,ke,ct)=>xt.createFileSystemWatcher(N.GlobPattern.from(Y),ce,ke,ct),get textDocuments(){return Et.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw t.readonly()},openTextDocument(Y){let ce;const ke=Y;if(typeof Y=="string")ce=Promise.resolve(k.URI.file(Y));else if(k.URI.isUri(Y))ce=Promise.resolve(Y);else if(!ke||typeof ke=="object")ce=Et.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(ct=>Et.ensureDocumentData(ct).then(Ct=>Ct.document))},onDidOpenTextDocument:(Y,ce,ke)=>Et.onDidAddDocument(Y,ce,ke),onDidCloseTextDocument:(Y,ce,ke)=>Et.onDidRemoveDocument(Y,ce,ke),onDidChangeTextDocument:(Y,ce,ke)=>Et.onDidChangeDocument(Y,ce,ke),onDidSaveTextDocument:(Y,ce,ke)=>Et.onDidSaveDocument(Y,ce,ke),onWillSaveTextDocument:(Y,ce,ke)=>Nt.getOnWillSaveTextDocumentEvent(Me)(Y,ce,ke),get notebookDocuments(){return wt.notebookDocuments.map(Y=>Y.apiNotebook)},async openNotebookDocument(Y,ce){let ke;if(k.URI.isUri(Y))ke=Y,await wt.openNotebookDocument(Y);else if(typeof Y=="string")ke=k.URI.revive(await wt.createNotebookDocument({viewType:Y,content:ce}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(Y,ce,ke,ct){return wt.registerNotebookSerializer(Me,Y,ce,ke,(0,ve.isProposedApiEnabled)(Me,"notebookLiveShare")?ct:void 0)},registerNotebookContentProvider:(Y,ce,ke,ct)=>((0,ve.checkProposedApiEnabled)(Me,"notebookContentProvider"),wt.registerNotebookContentProvider(Me,Y,ce,ke,(0,ve.isProposedApiEnabled)(Me,"notebookLiveShare")?ct:void 0)),onDidChangeConfiguration:(Y,ce,ke)=>pi.onDidChangeConfiguration(Y,ce,ke),getConfiguration(Y,ce){return ce=arguments.length===1?void 0:ce,pi.getConfiguration(Y,ce,Me)},registerTextDocumentContentProvider(Y,ce){return Ot.registerTextDocumentContentProvider(Y,ce)},registerTaskProvider:(Y,ce)=>(Qe.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Me,Y,ce)),registerFileSystemProvider(Y,ce,ke){return(0,De.combinedDisposable)(li.registerFileSystemProvider(Me,Y,ce,ke),Pe.addFileSystemProvider(Y,ce))},get fs(){return Pe.value},registerFileSearchProvider:(Y,ce)=>((0,ve.checkProposedApiEnabled)(Me,"fileSearchProvider"),Lt.registerFileSearchProvider(Y,ce)),registerTextSearchProvider:(Y,ce)=>((0,ve.checkProposedApiEnabled)(Me,"textSearchProvider"),Lt.registerTextSearchProvider(Y,ce)),registerRemoteAuthorityResolver:(Y,ce)=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),We.registerRemoteAuthorityResolver(Y,ce)),registerResourceLabelFormatter:Y=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),Ei.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,ce,ke)=>xt.onDidCreateFile(Y,ce,ke),onDidDeleteFiles:(Y,ce,ke)=>xt.onDidDeleteFile(Y,ce,ke),onDidRenameFiles:(Y,ce,ke)=>xt.onDidRenameFile(Y,ce,ke),onWillCreateFiles:(Y,ce,ke)=>xt.getOnWillCreateFileEvent(Me)(Y,ce,ke),onWillDeleteFiles:(Y,ce,ke)=>xt.getOnWillDeleteFileEvent(Me)(Y,ce,ke),onWillRenameFiles:(Y,ce,ke)=>xt.getOnWillRenameFileEvent(Me)(Y,ce,ke),openTunnel:Y=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),Ie.openTunnel(Me,Y).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,ve.checkProposedApiEnabled)(Me,"resolvers"),Ie.getTunnels()},onDidChangeTunnels:(Y,ce,ke)=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),Ie.onDidChangeTunnels(Y,ce,ke)),registerPortAttributesProvider:(Y,ce)=>((0,ve.checkProposedApiEnabled)(Me,"portsAttributes"),Ie.registerPortsAttributesProvider(Y,ce)),registerTimelineProvider:(Y,ce)=>((0,ve.checkProposedApiEnabled)(Me,"timeline"),yi.registerTimelineProvider(Y,ce,Me.identifier,ht.converter)),get isTrusted(){return Le.trusted},requestWorkspaceTrust:Y=>((0,ve.checkProposedApiEnabled)(Me,"workspaceTrust"),Le.requestWorkspaceTrust(Y)),onDidGrantWorkspaceTrust:(Y,ce,ke)=>Le.onDidGrantWorkspaceTrust(Y,ce,ke)},Fi={get inputBox(){return Qe.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Me)},createSourceControl(Y,ce,ke){return Jt.createSourceControl(Me,Y,ce,ke)}},Mi={createCommentController(Y,ce){return ci.createCommentController(Me,Y,ce)}},Oi={get activeDebugSession(){return _t.activeDebugSession},get activeDebugConsole(){return _t.activeDebugConsole},get breakpoints(){return _t.breakpoints},onDidStartDebugSession(Y,ce,ke){return _t.onDidStartDebugSession(Y,ce,ke)},onDidTerminateDebugSession(Y,ce,ke){return _t.onDidTerminateDebugSession(Y,ce,ke)},onDidChangeActiveDebugSession(Y,ce,ke){return _t.onDidChangeActiveDebugSession(Y,ce,ke)},onDidReceiveDebugSessionCustomEvent(Y,ce,ke){return _t.onDidReceiveDebugSessionCustomEvent(Y,ce,ke)},onDidChangeBreakpoints(Y,ce,ke){return _t.onDidChangeBreakpoints(Y,ce,ke)},registerDebugConfigurationProvider(Y,ce,ke){return _t.registerDebugConfigurationProvider(Y,ce,ke||$.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,ce){return _t.registerDebugAdapterDescriptorFactory(Me,Y,ce)},registerDebugAdapterTrackerFactory(Y,ce){return _t.registerDebugAdapterTrackerFactory(Y,ce)},startDebugging(Y,ce,ke){return!ke||typeof ke=="object"&&"configuration"in ke?_t.startDebugging(Y,ce,{parentSession:ke}):_t.startDebugging(Y,ce,ke||{})},stopDebugging(Y){return _t.stopDebugging(Y)},addBreakpoints(Y){return _t.addBreakpoints(Y)},removeBreakpoints(Y){return _t.removeBreakpoints(Y)},asDebugSourceUri(Y,ce){return _t.asDebugSourceUri(Y,ce)}},Li={registerTaskProvider:(Y,ce)=>It.registerTaskProvider(Me,Y,ce),fetchTasks:Y=>It.fetchTasks(Y),executeTask:Y=>It.executeTask(Me,Y),get taskExecutions(){return It.taskExecutions},onDidStartTask:(Y,ce,ke)=>It.onDidStartTask(Y,ce,ke),onDidEndTask:(Y,ce,ke)=>It.onDidEndTask(Y,ce,ke),onDidStartTaskProcess:(Y,ce,ke)=>It.onDidStartTaskProcess(Y,ce,ke),onDidEndTaskProcess:(Y,ce,ke)=>It.onDidEndTaskProcess(Y,ce,ke)},Ni={createNotebookController(Y,ce,ke,ct,Ct){return oi.createNotebookController(Me,Y,ce,ke,ct,(0,ve.isProposedApiEnabled)(Me,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(Y,ce)=>wt.registerNotebookCellStatusBarItemProvider(Me,Y,ce),get onDidSaveNotebookDocument(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),$t.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Y){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditorDecorationType"),jt.createNotebookEditorDecorationType(Y)},createRendererMessaging(Y){return si.createRendererMessaging(Me,Y)},onDidChangeNotebookDocumentMetadata(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),$t.onDidChangeNotebookDocumentMetadata(Y,ce,ke)},onDidChangeNotebookCells(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.onDidChangeNotebookCells(Y,ce,ke)},onDidChangeNotebookCellExecutionState(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),wt.onDidChangeNotebookCellExecutionState(Y,ce,ke)},onDidChangeCellOutputs(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.onDidChangeCellOutputs(Y,ce,ke)},onDidChangeCellMetadata(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.onDidChangeCellMetadata(Y,ce,ke)},createConcatTextDocument(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"notebookConcatTextDocument"),new xe.ExtHostNotebookConcatDocument(wt,Et,Y,ce)}};return{version:he.version,authentication:ii,commands:Ii,comments:Mi,debug:Oi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Fi,tasks:Li,tests:Pi,window:Ri,workspace:ni,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:$.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,EventEmitter:w.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionList:$.InlineSuggestions,Hover:$.Hover,IndentAction:R.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:n.UIKind,Uri:k.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,InlayHint:$.InlayHint,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:de.TextSearchCompleteMessageType,TreeDataTransfer:$.TreeDataTransfer,TreeDataTransferItem:$.TreeDataTransferItem,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity,QuickPickItemKind:$.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=re}),define(Ee[220],ye([0,1,56,94,31,93,32,38,48,39,97,98,99,71,64,69,95,49,30,68,85,70,192,12,175]),function(ne,e,a,t,w,T,k,P,C,R,F,_,n,m,r,g,d,D,v,f,p,I,l,M,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(M.ILoggerService,l.ExtHostLoggerService),(0,a.registerSingleton)(M.ILogService,o.ExtHostLogService),(0,a.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,a.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,a.registerSingleton)(k.IExtHostConfiguration,k.ExtHostConfiguration),(0,a.registerSingleton)(D.IExtHostConsumerFileSystem,D.ExtHostConsumerFileSystem),(0,a.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService),(0,a.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,a.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,a.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo),(0,a.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,a.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,a.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,a.registerSingleton)(F.IExtHostTask,F.WorkerExtHostTask),(0,a.registerSingleton)(R.IExtHostTerminalService,R.WorkerExtHostTerminalService),(0,a.registerSingleton)(r.IExtHostTunnelService,r.ExtHostTunnelService),(0,a.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow),(0,a.registerSingleton)(w.IExtHostWorkspace,w.ExtHostWorkspace),(0,a.registerSingleton)(f.IExtHostSecretState,f.ExtHostSecretState),(0,a.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry),(0,a.registerSingleton)(I.IExtHostEditorTabs,I.ExtHostEditorTabs)}),define(Ee[221],ye([0,1,219,33,215,7,14,5,10]),function(ne,e,a,t,w,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class R extends w.RequireInterceptor{_installInterceptor(){}getModule(r,g){for(let d of this._alternatives){let D=d(r);if(D){r=D;break}}if(this._factories.has(r))return this._factories.get(r).load(r,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class F extends t.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const r=this._extHostContext.getProxy(P.MainContext.MainThreadConsole);n(r,this._initData.environment.isExtensionDevelopmentDebug);const g=this._instaService.invokeFunction(a.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(R,g,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(r){return r.browser}async _loadCommonJSModule(r,g,d){g=g.with({path:_(g.path,".js")}),r&&performance.mark(`code/extHost/willFetchExtensionCode/${r.value}`);const D=await fetch(C.FileAccess.asBrowserUri(g).toString(!0));if(r&&performance.mark(`code/extHost/didFetchExtensionCode/${r.value}`),D.status!==200)throw new Error(D.statusText);const v=await D.text(),f=`${g.toString(!0)}#vscode-extension`,p=`${v}
//# sourceURL=${f}`;let I;try{I=new Function("module","exports","require",p)}catch(i){throw console.error(r?`Loading code for extension ${r.value} failed: ${i.message}`:`Loading code failed: ${i.message}`),console.error(`${g.toString(!0)}${typeof i.line=="number"?` line ${i.line}`:""}${typeof i.column=="number"?` column ${i.column}`:""}`),console.error(i),i}const l={},M={exports:l},o=i=>{const h=this._fakeModules.getModule(i,g);if(h===void 0)throw new Error(`Cannot load module '${i}'`);return h};try{return d.codeLoadingStart(),r&&performance.mark(`code/extHost/willLoadExtensionCode/${r.value}`),I(M,l,o),M.exports!==l?M.exports:l}finally{r&&performance.mark(`code/extHost/didLoadExtensionCode/${r.value}`),d.codeLoadingStop()}}async $setRemoteEnvironment(r){}async _waitForDebuggerAttachment(r=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+r;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,k.timeout)(10)}}e.ExtHostExtensionService=F;function _(m,r){return m.endsWith(r)?m:m+r}function n(m,r){g("info","log"),g("log","log"),g("warn","warn"),g("error","error");function g(v,f){const p=console[v];console[v]=function(){m.$logExtensionHostMessage({type:"__$console",severity:f,arguments:D(arguments)}),r&&p.apply(console,arguments)}}const d=1e5;function D(v){const f=[],p=[];if(v.length)for(let I=0;I<v.length;I++){if(typeof v[I]=="undefined")v[I]="undefined";else if(v[I]instanceof Error){const l=v[I];l.stack?v[I]=l.stack:v[I]=l.toString()}p.push(v[I])}try{const I=JSON.stringify(p,function(l,M){if(M&&typeof M=="object"){if(f.indexOf(M)!==-1)return"[Circular]";f.push(M)}return M});return I.length>d?"Output omitted for a large object that exceeds the limits":I}catch(I){return`Output omitted for an object that cannot be inspected ('${I.toString()}')`}}}}),define(Ee[222],ye([0,1,56,33,72,221]),function(ne,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(t.IExtHostExtensionService,T.ExtHostExtensionService),(0,a.registerSingleton)(w.IExtensionStoragePaths,w.ExtensionStoragePaths)}),define(Ee[233],ye([0,1,22,4,173,216,210,17,73,10,2,220,222]),function(ne,e,a,t,w,T,k,P,C,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const m=fetch.bind(self);if(self.fetch=function(f,p){return f instanceof Request||/^file:/i.test(String(f))&&(f=R.FileAccess.asBrowserUri(F.URI.parse(String(f))).toString(!0)),m(f,p)},self.XMLHttpRequest=class extends XMLHttpRequest{open(f,p,I,l,M){return/^file:/i.test(p.toString())&&(p=R.FileAccess.asBrowserUri(F.URI.parse(p.toString())).toString(!0)),super.open(f,p,I??!0,l,M)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const f=self.Worker;Worker=function(p,I){/^file:/i.test(p.toString())&&(p=R.FileAccess.asBrowserUri(F.URI.parse(p.toString())).toString(!0));const M=`(${function(u){function s(c){return typeof c=="string"||c instanceof URL?String(c).replace(/^file:\/\//i,"vscode-file://vscode-app"):c}const b=fetch.bind(self);self.fetch=function(c,S){return c instanceof Request?b(c,S):b(s(c),S)},self.XMLHttpRequest=class extends XMLHttpRequest{open(c,S,A,U,H){return super.open(c,s(S),A??!0,U,H)}};const y=importScripts.bind(self);self.importScripts=(...c)=>{y(...c.map(s))},y(u)}.toString()}('${p}'))`;I=I||{},I.name=I.name||P.basename(p.toString());const o=new Blob([M],{type:"application/javascript"}),i=URL.createObjectURL(o);return new f(i,I)}}else self.Worker=class extends k.NestedWorker{constructor(f,p){super(n,f,{name:P.basename(f.toString()),...p})}};const r=new class{constructor(){this.pid=void 0}exit(f){_()}async exists(f){return!0}async realpath(f){return f}};class g{constructor(){const p=new MessageChannel,I=new t.Emitter;let l=!1;n(p.port2,[p.port2]),p.port1.onmessage=M=>{const{data:o}=M;if(!(o instanceof ArrayBuffer)){console.warn("UNKNOWN data received",o);return}const i=a.VSBuffer.wrap(new Uint8Array(o,0,o.byteLength));if((0,w.isMessageOfType)(i,2)){l=!0,D("received terminate message from renderer");return}I.fire(i)},this.protocol={onMessage:I.event,send:M=>{if(!l){const o=M.buffer.buffer.slice(M.buffer.byteOffset,M.buffer.byteOffset+M.buffer.byteLength);p.port1.postMessage(o,[o])}}}}}function d(f){return new Promise(p=>{const I=f.onMessage(l=>{I.dispose();const M=JSON.parse(l.toString());f.send((0,w.createMessageOfType)(0)),p({protocol:f,initData:M})});f.send((0,w.createMessageOfType)(1))})}let D=f=>_();function v(){const f=new g;C.mark("code/extHost/willConnectToRenderer"),d(f.protocol).then(p=>{C.mark("code/extHost/didWaitForInitData");const I=new T.ExtensionHostMain(p.protocol,p.initData,r,null);D=l=>I.terminate(l)})}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/807bf598bea406dcb272a9fced54697986e87768/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
